/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ne=function(J){for(var e=[],P=0,A=J.length;P<A;P++)e[P]=ie[J[P]];return e};define(ie[134],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function P(m,w,$){const d=A(m,w);if(d!==-1)return m[d]}e.$fb=P;function A(m,w,$=m.length-1){for(let d=$;d>=0;d--){const h=m[d];if(w(h))return d}return-1}e.$gb=A;function s(m,w){const $=R(m,w);return $===-1?void 0:m[$]}e.$hb=s;function R(m,w,$=0,d=m.length){let h=$,k=d;for(;h<k;){const c=Math.floor((h+k)/2);w(m[c])?h=c+1:k=c}return h-1}e.$ib=R;function C(m,w){const $=S(m,w);return $===m.length?void 0:m[$]}e.$jb=C;function S(m,w,$=0,d=m.length){let h=$,k=d;for(;h<k;){const c=Math.floor((h+k)/2);w(m[c])?k=c:h=c+1}return h}e.$kb=S;function u(m,w,$=0,d=m.length){const h=S(m,w,$,d);return h===m.length?-1:h}e.$lb=u;class a{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(a.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!w(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const $=R(this.e,w,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$mb=a;function g(m,w){if(m.length===0)return;let $=m[0];for(let d=1;d<m.length;d++){const h=m[d];w(h,$)>0&&($=h)}return $}e.$nb=g;function b(m,w){if(m.length===0)return;let $=m[0];for(let d=1;d<m.length;d++){const h=m[d];w(h,$)>=0&&($=h)}return $}e.$ob=b;function y(m,w){return g(m,($,d)=>-w($,d))}e.$pb=y;function f(m,w){if(m.length===0)return-1;let $=0;for(let d=1;d<m.length;d++){const h=m[d];w(h,m[$])>0&&($=d)}return $}e.$qb=f;function v(m,w){for(const $ of m){const d=w($);if(d!==void 0)return d}}e.$rb=v}),define(ie[135],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function P(C,S){const u=Object.create(null);for(const a of C){const g=S(a);let b=u[g];b||(b=u[g]=[]),b.push(a)}return u}e.$J=P;function A(C,S){const u=[],a=[];for(const g of C)S.has(g)||u.push(g);for(const g of S)C.has(g)||a.push(g);return{removed:u,added:a}}e.$K=A;function s(C,S){const u=[],a=[];for(const[g,b]of C)S.has(g)||u.push(b);for(const[g,b]of S)C.has(g)||a.push(b);return{removed:u,added:a}}e.$L=s;function R(C,S){const u=new Set;for(const a of S)C.has(a)&&u.add(a);return u}e.$M=R}),define(ie[136],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=e.$Zs=e.$Ys=void 0;function P(S,u){const a=Math.pow(10,u);return Math.round(S*a)/a}class A{constructor(u,a,g,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=P(Math.max(Math.min(1,b),0),3)}static equals(u,a){return u.r===a.r&&u.g===a.g&&u.b===a.b&&u.a===a.a}}e.$Ys=A;class s{constructor(u,a,g,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=P(Math.max(Math.min(1,a),0),3),this.l=P(Math.max(Math.min(1,g),0),3),this.a=P(Math.max(Math.min(1,b),0),3)}static equals(u,a){return u.h===a.h&&u.s===a.s&&u.l===a.l&&u.a===a.a}static fromRGBA(u){const a=u.r/255,g=u.g/255,b=u.b/255,y=u.a,f=Math.max(a,g,b),v=Math.min(a,g,b);let m=0,w=0;const $=(v+f)/2,d=f-v;if(d>0){switch(w=Math.min($<=.5?d/(2*$):d/(2-2*$),1),f){case a:m=(g-b)/d+(g<b?6:0);break;case g:m=(b-a)/d+2;break;case b:m=(a-g)/d+4;break}m*=60,m=Math.round(m)}return new s(m,w,$,y)}static i(u,a,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?u+(a-u)*6*g:g<1/2?a:g<2/3?u+(a-u)*(2/3-g)*6:u}static toRGBA(u){const a=u.h/360,{s:g,l:b,a:y}=u;let f,v,m;if(g===0)f=v=m=b;else{const w=b<.5?b*(1+g):b+g-b*g,$=2*b-w;f=s.i($,w,a+1/3),v=s.i($,w,a),m=s.i($,w,a-1/3)}return new A(Math.round(f*255),Math.round(v*255),Math.round(m*255),y)}}e.$Zs=s;class R{constructor(u,a,g,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=P(Math.max(Math.min(1,a),0),3),this.v=P(Math.max(Math.min(1,g),0),3),this.a=P(Math.max(Math.min(1,b),0),3)}static equals(u,a){return u.h===a.h&&u.s===a.s&&u.v===a.v&&u.a===a.a}static fromRGBA(u){const a=u.r/255,g=u.g/255,b=u.b/255,y=Math.max(a,g,b),f=Math.min(a,g,b),v=y-f,m=y===0?0:v/y;let w;return v===0?w=0:y===a?w=((g-b)/v%6+6)%6:y===g?w=(b-a)/v+2:w=(a-g)/v+4,new R(Math.round(w*60),m,y,u.a)}static toRGBA(u){const{h:a,s:g,v:b,a:y}=u,f=b*g,v=f*(1-Math.abs(a/60%2-1)),m=b-f;let[w,$,d]=[0,0,0];return a<60?(w=f,$=v):a<120?(w=v,$=f):a<180?($=f,d=v):a<240?($=v,d=f):a<300?(w=v,d=f):a<=360&&(w=f,d=v),w=Math.round((w+m)*255),$=Math.round(($+m)*255),d=Math.round((d+m)*255),new A(w,$,d,y)}}e.$1s=R;class C{static fromHex(u){return C.Format.CSS.parseHex(u)||C.red}static equals(u,a){return!u&&!a?!0:!u||!a?!1:u.equals(a)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof A)this.rgba=u;else if(u instanceof s)this.i=u,this.rgba=s.toRGBA(u);else if(u instanceof R)this.j=u,this.rgba=R.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&A.equals(this.rgba,u.rgba)&&s.equals(this.hsla,u.hsla)&&R.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=C.k(this.rgba.r),a=C.k(this.rgba.g),g=C.k(this.rgba.b),b=.2126*u+.7152*a+.0722*g;return P(b,4)}static k(u){const a=u/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(u){const a=this.getRelativeLuminance(),g=u.getRelativeLuminance();return a>g?(a+.05)/(g+.05):(g+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const a=this.getRelativeLuminance(),g=u.getRelativeLuminance();return a>g}isDarkerThan(u){const a=this.getRelativeLuminance(),g=u.getRelativeLuminance();return a<g}lighten(u){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:a,g,b,a:y}=this.rgba;return new C(new A(a,g,b,y*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const a=u.rgba,g=this.rgba.a,b=a.a,y=g+b*(1-g);if(y<1e-6)return C.transparent;const f=this.rgba.r*g/y+a.r*b*(1-g)/y,v=this.rgba.g*g/y+a.g*b*(1-g)/y,m=this.rgba.b*g/y+a.b*b*(1-g)/y;return new C(new A(f,v,m,y))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:a,g,b,a:y}=this.rgba;return new C(new A(u.rgba.r-y*(u.rgba.r-a),u.rgba.g-y*(u.rgba.g-g),u.rgba.b-y*(u.rgba.b-b),1))}flatten(...u){const a=u.reduceRight((g,b)=>C.o(b,g));return C.o(this,a)}static o(u,a){const g=1-u.rgba.a;return new C(new A(g*a.rgba.r+u.rgba.a*u.rgba.r,g*a.rgba.g+u.rgba.a*u.rgba.g,g*a.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(u,a,g){if(u.isLighterThan(a))return u;g=g||.5;const b=u.getRelativeLuminance(),y=a.getRelativeLuminance();return g=g*(y-b)/y,u.lighten(g)}static getDarkerColor(u,a,g){if(u.isDarkerThan(a))return u;g=g||.5;const b=u.getRelativeLuminance(),y=a.getRelativeLuminance();return g=g*(b-y)/b,u.darken(g)}static{this.white=new C(new A(255,255,255,1))}static{this.black=new C(new A(0,0,0,1))}static{this.red=new C(new A(255,0,0,1))}static{this.blue=new C(new A(0,0,255,1))}static{this.green=new C(new A(0,255,0,1))}static{this.cyan=new C(new A(0,255,255,1))}static{this.lightgrey=new C(new A(211,211,211,1))}static{this.transparent=new C(new A(0,0,0,0))}}e.$2s=C,function(S){let u;(function(a){let g;(function(b){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:S.Format.CSS.formatRGBA(i)}b.formatRGB=y;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}b.formatRGBA=f;function v(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(i)}b.formatHSL=v;function m(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}b.formatHSLA=m;function w(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function $(i){return`#${w(i.rgba.r)}${w(i.rgba.g)}${w(i.rgba.b)}`}b.formatHex=$;function d(i,o=!1){return o&&i.rgba.a===1?S.Format.CSS.formatHex(i):`#${w(i.rgba.r)}${w(i.rgba.g)}${w(i.rgba.b)}${w(Math.round(i.rgba.a*255))}`}b.formatHexA=d;function h(i){return i.isOpaque()?S.Format.CSS.formatHex(i):S.Format.CSS.formatRGBA(i)}b.format=h;function k(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const r=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),t=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),n=16*c(i.charCodeAt(5))+c(i.charCodeAt(6));return new S(new A(r,t,n,1))}if(o===9){const r=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),t=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),n=16*c(i.charCodeAt(5))+c(i.charCodeAt(6)),l=16*c(i.charCodeAt(7))+c(i.charCodeAt(8));return new S(new A(r,t,n,l/255))}if(o===4){const r=c(i.charCodeAt(1)),t=c(i.charCodeAt(2)),n=c(i.charCodeAt(3));return new S(new A(16*r+r,16*t+t,16*n+n))}if(o===5){const r=c(i.charCodeAt(1)),t=c(i.charCodeAt(2)),n=c(i.charCodeAt(3)),l=c(i.charCodeAt(4));return new S(new A(16*r+r,16*t+t,16*n+n,(16*l+l)/255))}return null}b.parseHex=k;function c(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=a.CSS||(a.CSS={}))})(u=S.Format||(S.Format={}))}(C||(e.$2s=C={}))}),define(ie[54],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function P(C){return(S,u,a)=>{let g=null,b=null;if(typeof a.value=="function"?(g="value",b=a.value):typeof a.get=="function"&&(g="get",b=a.get),!b)throw new Error("not supported");a[g]=C(b,u)}}function A(C,S,u){let a=null,g=null;if(typeof u.value=="function"?(a="value",g=u.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",g=u.get),!g)throw new Error("not supported");const b=`$memoize$${S}`;u[a]=function(...y){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,y)}),this[b]}}e.$ih=A;function s(C,S,u){return P((a,g)=>{const b=`$debounce$${g}`,y=`$debounce$result$${g}`;return function(...f){this[y]||(this[y]=u?u():void 0),clearTimeout(this[b]),S&&(this[y]=S(this[y],...f),f=[this[y]]),this[b]=setTimeout(()=>{a.apply(this,f),this[y]=u?u():void 0},C)}})}e.$jh=s;function R(C,S,u){return P((a,g)=>{const b=`$throttle$timer$${g}`,y=`$throttle$result$${g}`,f=`$throttle$lastRun$${g}`,v=`$throttle$pending$${g}`;return function(...m){if(this[y]||(this[y]=u?u():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),S&&(this[y]=S(this[y],...m)),this[v])return;const w=this[f]+C;w<=Date.now()?(this[f]=Date.now(),a.apply(this,[this[y]]),this[y]=u?u():void 0):(this[v]=!0,this[b]=setTimeout(()=>{this[v]=!1,this[f]=Date.now(),a.apply(this,[this[y]]),this[y]=u?u():void 0},w-Date.now()))}})}e.$kh=R}),define(ie[14],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class P{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?h.isErrorNoTelemetry(i)?new h(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=P,e.$X=new P;function A(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=A;function s(c){if(!c||typeof c!="object")return!1;const i=c;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function R(c){a(c)||e.$X.onUnexpectedError(c)}e.$1=R;function C(c){a(c)||e.$X.onUnexpectedExternalError(c)}e.$2=C;function S(c){if(c instanceof Error){const{name:i,message:o}=c,r=c.stacktrace||c.stack;return{$isError:!0,name:i,message:o,stack:r,noTelemetry:h.isErrorNoTelemetry(c)}}return c}e.$3=S;const u="Canceled";function a(c){return c instanceof g?!0:c instanceof Error&&c.name===u&&c.message===u}e.$4=a;class g extends Error{constructor(){super(u),this.name=this.message}}e.$5=g;function b(){const c=new Error(u);return c.name=c.message,c}e.$6=b;function y(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=y;function f(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=f;class v extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function m(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=m;class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=w;class $ extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=$;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class h extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof h)return i;const o=new h;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=h;class k extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}e.$cb=k}),define(ie[23],ne([0,1,14,134]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(F,B=0){return F[F.length-(1+B)]}e.$sb=s;function R(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$tb=R;function C(F,B,V=(ae,de)=>ae===de){if(F===B)return!0;if(!F||!B||F.length!==B.length)return!1;for(let ae=0,de=F.length;ae<de;ae++)if(!V(F[ae],B[ae]))return!1;return!0}e.$ub=C;function S(F,B){const V=F.length-1;B<V&&(F[B]=F[V]),F.pop()}e.$vb=S;function u(F,B,V){return a(F.length,ae=>V(F[ae],B))}e.$wb=u;function a(F,B){let V=0,ae=F-1;for(;V<=ae;){const de=(V+ae)/2|0,ue=B(de);if(ue<0)V=de+1;else if(ue>0)ae=de-1;else return de}return-(V+1)}e.$xb=a;function g(F,B,V){if(F=F|0,F>=B.length)throw new TypeError("invalid index");const ae=B[Math.floor(B.length*Math.random())],de=[],ue=[],he=[];for(const ve of B){const be=V(ve,ae);be<0?de.push(ve):be>0?ue.push(ve):he.push(ve)}return F<de.length?g(F,de,V):F<de.length+he.length?he[0]:g(F-(de.length+he.length),ue,V)}e.$yb=g;function b(F,B){const V=[];let ae;for(const de of F.slice(0).sort(B))!ae||B(ae[0],de)!==0?(ae=[de],V.push(ae)):ae.push(de);return V}e.$zb=b;function*y(F,B){let V,ae;for(const de of F)ae!==void 0&&B(ae,de)?V.push(de):(V&&(yield V),V=[de]),ae=de;V&&(yield V)}e.$Ab=y;function f(F,B){for(let V=0;V<=F.length;V++)B(V===0?void 0:F[V-1],V===F.length?void 0:F[V])}e.$Bb=f;function v(F,B){for(let V=0;V<F.length;V++)B(V===0?void 0:F[V-1],F[V],V+1===F.length?void 0:F[V+1])}e.$Cb=v;function m(F,B,V){const ae=[];function de(ve,be,ye){if(be===0&&ye.length===0)return;const Ie=ae[ae.length-1];Ie&&Ie.start+Ie.deleteCount===ve?(Ie.deleteCount+=be,Ie.toInsert.push(...ye)):ae.push({start:ve,deleteCount:be,toInsert:ye})}let ue=0,he=0;for(;;){if(ue===F.length){de(ue,0,B.slice(he));break}if(he===B.length){de(ue,F.length-ue,[]);break}const ve=F[ue],be=B[he],ye=V(ve,be);ye===0?(ue+=1,he+=1):ye<0?(de(ue,1,[]),ue+=1):ye>0&&(de(ue,0,[be]),he+=1)}return ae}e.$Db=m;function w(F,B,V){const ae=m(F,B,V),de=[],ue=[];for(const he of ae)de.push(...F.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:de,added:ue}}e.$Eb=w;function $(F,B,V){if(V===0)return[];const ae=F.slice(0,V).sort(B);return h(F,B,ae,V,F.length),ae}e.top=$;function d(F,B,V,ae,de){return V===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const ve=F.length,be=F.slice(0,V).sort(B);for(let ye=V,Ie=Math.min(V+ae,ve);ye<ve;ye=Ie,Ie=Math.min(Ie+ae,ve)){if(ye>V&&await new Promise(Te=>setTimeout(Te)),de&&de.isCancellationRequested)throw new P.$5;h(F,B,be,ye,Ie)}return be})().then(ue,he)})}e.$Gb=d;function h(F,B,V,ae,de){for(const ue=V.length;ae<de;ae++){const he=F[ae];if(B(he,V[ue-1])<0){V.pop();const ve=(0,A.$kb)(V,be=>B(he,be)<0);V.splice(ve,0,he)}}}function k(F){return F.filter(B=>!!B)}e.$Hb=k;function c(F){let B=0;for(let V=0;V<F.length;V++)F[V]&&(F[B]=F[V],B+=1);F.length=B}e.$Ib=c;function i(F,B,V){F.splice(V,0,F.splice(B,1)[0])}e.$Jb=i;function o(F){return!Array.isArray(F)||F.length===0}e.$Kb=o;function r(F){return Array.isArray(F)&&F.length>0}e.$Lb=r;function t(F,B=V=>V){const V=new Set;return F.filter(ae=>{const de=B(ae);return V.has(de)?!1:(V.add(de),!0)})}e.$Mb=t;function n(F){const B=new Set;return V=>{const ae=F(V);return B.has(ae)?!1:(B.add(ae),!0)}}e.$Nb=n;function l(F,B){return F.length>0?F[0]:B}e.$Ob=l;function p(F,B){return F.length>0?F[F.length-1]:B}e.$Pb=p;function O(F,B,V=(ae,de)=>ae===de){let ae=0;for(let de=0,ue=Math.min(F.length,B.length);de<ue&&V(F[de],B[de]);de++)ae++;return ae}e.$Qb=O;function D(F){return[].concat(...F)}e.$Rb=D;function E(F,B){let V=typeof B=="number"?F:0;typeof B=="number"?V=F:(V=0,B=F);const ae=[];if(V<=B)for(let de=V;de<B;de++)ae.push(de);else for(let de=V;de>B;de--)ae.push(de);return ae}e.$Sb=E;function I(F,B,V){return F.reduce((ae,de)=>(ae[B(de)]=V?V(de):de,ae),Object.create(null))}e.$Tb=I;function j(F,B){return F.push(B),()=>U(F,B)}e.$Ub=j;function U(F,B){const V=F.indexOf(B);if(V>-1)return F.splice(V,1),B}e.$Vb=U;function z(F,B,V){const ae=F.slice(0,B),de=F.slice(B);return ae.concat(V,de)}e.$Wb=z;function X(F,B){let V;if(typeof B=="number"){let ae=B;V=()=>{const de=Math.sin(ae++)*179426549;return de-Math.floor(de)}}else V=Math.random;for(let ae=F.length-1;ae>0;ae-=1){const de=Math.floor(V()*(ae+1)),ue=F[ae];F[ae]=F[de],F[de]=ue}}e.$Xb=X;function x(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.unshift(B))}e.$Yb=x;function oe(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.push(B))}e.$Zb=oe;function se(F,B){for(const V of B)F.push(V)}e.$1b=se;function ce(F,B){return Array.isArray(F)?F.map(B):B(F)}e.$2b=ce;function Y(F){return Array.isArray(F)?F:[F]}e.$3b=Y;function K(F){return F[Math.floor(Math.random()*F.length)]}e.$4b=K;function Q(F,B,V){const ae=W(F,B),de=F.length,ue=V.length;F.length=de+ue;for(let he=de-1;he>=ae;he--)F[he+ue]=F[he];for(let he=0;he<ue;he++)F[he+ae]=V[he]}e.$5b=Q;function q(F,B,V,ae){const de=W(F,B);let ue=F.splice(de,V);return ue===void 0&&(ue=[]),Q(F,de,ae),ue}e.$6b=q;function W(F,B){return B<0?Math.max(B+F.length,0):Math.min(B,F.length)}var G;(function(F){function B(ue){return ue<0}F.isLessThan=B;function V(ue){return ue<=0}F.isLessThanOrEqual=V;function ae(ue){return ue>0}F.isGreaterThan=ae;function de(ue){return ue===0}F.isNeitherLessOrGreaterThan=de,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function H(F,B){return(V,ae)=>B(F(V),F(ae))}e.$7b=H;function Z(...F){return(B,V)=>{for(const ae of F){const de=ae(B,V);if(!G.isNeitherLessOrGreaterThan(de))return de}return G.neitherLessOrGreaterThan}}e.$8b=Z;const re=(F,B)=>F-B;e.$9b=re;const L=(F,B)=>(0,e.$9b)(F?1:0,B?1:0);e.$0b=L;function M(F){return(B,V)=>-F(B,V)}e.$$b=M;class N{constructor(B){this.g=B,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(B){let V=this.c;for(;V<this.g.length&&B(this.g[V]);)V++;const ae=V===this.c?null:this.g.slice(this.c,V);return this.c=V,ae}takeFromEndWhile(B){let V=this.d;for(;V>=0&&B(this.g[V]);)V--;const ae=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,ae}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const B=this.g[this.c];return this.c++,B}removeLast(){const B=this.g[this.d];return this.d--,B}takeCount(B){const V=this.g.slice(this.c,this.c+B);return this.c+=B,V}}e.$_b=N;class T{static{this.empty=new T(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(V=>(B(V),!0))}toArray(){const B=[];return this.iterate(V=>(B.push(V),!0)),B}filter(B){return new T(V=>this.iterate(ae=>B(ae)?V(ae):!0))}map(B){return new T(V=>this.iterate(ae=>V(B(ae))))}some(B){let V=!1;return this.iterate(ae=>(V=B(ae),!V)),V}findFirst(B){let V;return this.iterate(ae=>B(ae)?(V=ae,!1):!0),V}findLast(B){let V;return this.iterate(ae=>(B(ae)&&(V=ae),!0)),V}findLastMaxBy(B){let V,ae=!0;return this.iterate(de=>((ae||G.isGreaterThan(B(de,V)))&&(ae=!1,V=de),!0)),V}}e.$ac=T}),define(ie[137],ne([0,1,14]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function A(u,a){if(!u)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=A;function s(u,a="Unreachable"){throw new Error(a)}e.$4c=s;function R(u){if(!u)throw new P.$cb("Assertion Failed")}e.$5c=R;function C(u){if(!u()){debugger;u(),(0,P.$1)(new P.$cb("Assertion Failed"))}}e.$6c=C;function S(u,a){let g=0;for(;g<u.length-1;){const b=u[g],y=u[g+1];if(!a(b,y))return!1;g++}return!0}e.$7c=S}),define(ie[84],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function P(A){const s=this;let R=!1,C;return function(){return R||(R=!0,C=A.apply(s,arguments)),C}}e.$db=P}),define(ie[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(A){function s(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}A.is=s;const R=Object.freeze([]);function C(){return R}A.empty=C;function*S(c){yield c}A.single=S;function u(c){return s(c)?c:S(c)}A.wrap=u;function a(c){return c||R}A.from=a;function*g(c){for(let i=c.length-1;i>=0;i--)yield c[i]}A.reverse=g;function b(c){return!c||c[Symbol.iterator]().next().done===!0}A.isEmpty=b;function y(c){return c[Symbol.iterator]().next().value}A.first=y;function f(c,i){for(const o of c)if(i(o))return!0;return!1}A.some=f;function v(c,i){for(const o of c)if(i(o))return o}A.find=v;function*m(c,i){for(const o of c)i(o)&&(yield o)}A.filter=m;function*w(c,i){let o=0;for(const r of c)yield i(r,o++)}A.map=w;function*$(...c){for(const i of c)for(const o of i)yield o}A.concat=$;function d(c,i,o){let r=o;for(const t of c)r=i(r,t);return r}A.reduce=d;function*h(c,i,o=c.length){for(i<0&&(i+=c.length),o<0?o+=c.length:o>c.length&&(o=c.length);i<o;i++)yield c[i]}A.slice=h;function k(c,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,c];const r=c[Symbol.iterator]();for(let t=0;t<i;t++){const n=r.next();if(n.done)return[o,A.empty()];o.push(n.value)}return[o,{[Symbol.iterator](){return r}}]}A.consume=k})(P||(e.Iterable=P={}))}),define(ie[44],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var s;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function C(i,o=!1){let r=0;const t=i.length;let n="",l=0,p=16,O=0;function D(x){let oe=0,se=0;for(;oe<x;){const ce=i.charCodeAt(r);if(ce>=48&&ce<=57)se=se*16+ce-48;else if(ce>=65&&ce<=70)se=se*16+ce-65+10;else if(ce>=97&&ce<=102)se=se*16+ce-97+10;else break;r++,oe++}return oe<x&&(se=-1),se}function E(x){r=x,n="",l=0,p=16,O=0}function I(){const x=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&a(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&a(i.charCodeAt(r)))for(r++;r<i.length&&a(i.charCodeAt(r));)r++;else return O=3,i.substring(x,r);let oe=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&a(i.charCodeAt(r))){for(r++;r<i.length&&a(i.charCodeAt(r));)r++;oe=r}else O=3;return i.substring(x,oe)}function j(){let x="",oe=r;for(;;){if(r>=t){x+=i.substring(oe,r),O=2;break}const se=i.charCodeAt(r);if(se===34){x+=i.substring(oe,r),r++;break}if(se===92){if(x+=i.substring(oe,r),r++,r>=t){O=2;break}switch(i.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const Y=D(4);Y>=0?x+=String.fromCharCode(Y):O=4;break}default:O=5}oe=r;continue}if(se>=0&&se<=31)if(u(se)){x+=i.substring(oe,r),O=2;break}else O=6;r++}return x}function U(){if(n="",O=0,l=r,r>=t)return l=t,p=17;let x=i.charCodeAt(r);if(S(x)){do r++,n+=String.fromCharCode(x),x=i.charCodeAt(r);while(S(x));return p=15}if(u(x))return r++,n+=String.fromCharCode(x),x===13&&i.charCodeAt(r)===10&&(r++,n+=`
`),p=14;switch(x){case 123:return r++,p=1;case 125:return r++,p=2;case 91:return r++,p=3;case 93:return r++,p=4;case 58:return r++,p=6;case 44:return r++,p=5;case 34:return r++,n=j(),p=10;case 47:{const oe=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<t&&!u(i.charCodeAt(r));)r++;return n=i.substring(oe,r),p=12}if(i.charCodeAt(r+1)===42){r+=2;const se=t-1;let ce=!1;for(;r<se;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,ce=!0;break}r++}return ce||(r++,O=1),n=i.substring(oe,r),p=13}return n+=String.fromCharCode(x),r++,p=16}case 45:if(n+=String.fromCharCode(x),r++,r===t||!a(i.charCodeAt(r)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=I(),p=11;default:for(;r<t&&z(x);)r++,x=i.charCodeAt(r);if(l!==r){switch(n=i.substring(l,r),n){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return n+=String.fromCharCode(x),r++,p=16}}function z(x){if(S(x)||u(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let x;do x=U();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>r,scan:o?X:U,getToken:()=>p,getTokenValue:()=>n,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>O}}e.$Vm=C;function S(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var g;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(g||(g={}));function b(i,o){const r=[],t=new Object;let n;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function O(D,E,I,j){l.value=D,l.offset=E,l.length=I,l.type=j,l.colonOffset=void 0,n=l}try{h(i,{onObjectBegin:(D,E)=>{if(o<=D)throw t;n=void 0,p=o>D,r.push("")},onObjectProperty:(D,E,I)=>{if(o<E||(O(D,E,I,"property"),r[r.length-1]=D,o<=E+I))throw t},onObjectEnd:(D,E)=>{if(o<=D)throw t;n=void 0,r.pop()},onArrayBegin:(D,E)=>{if(o<=D)throw t;n=void 0,r.push(0)},onArrayEnd:(D,E)=>{if(o<=D)throw t;n=void 0,r.pop()},onLiteralValue:(D,E,I)=>{if(o<E||(O(D,E,I,c(D)),o<=E+I))throw t},onSeparator:(D,E,I)=>{if(o<=E)throw t;if(D===":"&&n&&n.type==="property")n.colonOffset=E,p=!1,n=void 0;else if(D===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(p=!0,r[r.length-1]=""),n=void 0}}})}catch(D){if(D!==t)throw D}return{path:r,previousNode:n,isAtPropertyKey:p,matches:D=>{let E=0;for(let I=0;E<D.length&&I<r.length;I++)if(D[E]===r[I]||D[E]==="*")E++;else if(D[E]!=="**")return!1;return E===D.length}}}e.$Wm=b;function y(i,o=[],r=R.DEFAULT){let t=null,n=[];const l=[];function p(D){Array.isArray(n)?n.push(D):t!==null&&(n[t]=D)}return h(i,{onObjectBegin:()=>{const D={};p(D),l.push(n),n=D,t=null},onObjectProperty:D=>{t=D},onObjectEnd:()=>{n=l.pop()},onArrayBegin:()=>{const D=[];p(D),l.push(n),n=D,t=null},onArrayEnd:()=>{n=l.pop()},onLiteralValue:p,onError:(D,E,I)=>{o.push({error:D,offset:E,length:I})}},r),n[0]}e.$Xm=y;function f(i,o=[],r=R.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(D){t.type==="property"&&(t.length=D-t.offset,t=t.parent)}function l(D){return t.children.push(D),D}h(i,{onObjectBegin:D=>{t=l({type:"object",offset:D,length:-1,parent:t,children:[]})},onObjectProperty:(D,E,I)=>{t=l({type:"property",offset:E,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:D,offset:E,length:I,parent:t})},onObjectEnd:(D,E)=>{t.length=D+E-t.offset,t=t.parent,n(D+E)},onArrayBegin:(D,E)=>{t=l({type:"array",offset:D,length:-1,parent:t,children:[]})},onArrayEnd:(D,E)=>{t.length=D+E-t.offset,t=t.parent,n(D+E)},onLiteralValue:(D,E,I)=>{l({type:c(D),offset:E,length:I,parent:t,value:D}),n(E+I)},onSeparator:(D,E,I)=>{t.type==="property"&&(D===":"?t.colonOffset=E:D===","&&n(E))},onError:(D,E,I)=>{o.push({error:D,offset:E,length:I})}},r);const O=t.children[0];return O&&delete O.parent,O}e.$Ym=f;function v(i,o){if(!i)return;let r=i;for(const t of o)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===t){r=l.children[1],n=!0;break}if(!n)return}else{const n=t;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Zm=v;function m(i){if(!i.parent||!i.parent.children)return[];const o=m(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;o.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&o.push(r)}return o}e.$1m=m;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const o=Object.create(null);for(const r of i.children){const t=r.children[1];t&&(o[r.children[0].value]=w(t))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$2m=w;function $(i,o,r=!1){return o>=i.offset&&o<i.offset+i.length||r&&o===i.offset+i.length}e.$3m=$;function d(i,o,r=!1){if($(i,o,r)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=o;n++){const l=d(t[n],o,r);if(l)return l}return i}}e.$4m=d;function h(i,o,r=R.DEFAULT){const t=C(i,!1);function n(H){return H?()=>H(t.getTokenOffset(),t.getTokenLength()):()=>!0}function l(H){return H?Z=>H(Z,t.getTokenOffset(),t.getTokenLength()):()=>!0}const p=n(o.onObjectBegin),O=l(o.onObjectProperty),D=n(o.onObjectEnd),E=n(o.onArrayBegin),I=n(o.onArrayEnd),j=l(o.onLiteralValue),U=l(o.onSeparator),z=n(o.onComment),X=l(o.onError),x=r&&r.disallowComments,oe=r&&r.allowTrailingComma;function se(){for(;;){const H=t.scan();switch(t.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:x||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(H){case 12:case 13:x?ce(10):z();break;case 16:ce(1);break;case 15:case 14:break;default:return H}}}function ce(H,Z=[],re=[]){if(X(H),Z.length+re.length>0){let L=t.getToken();for(;L!==17;){if(Z.indexOf(L)!==-1){se();break}else if(re.indexOf(L)!==-1)break;L=se()}}}function Y(H){const Z=t.getTokenValue();return H?j(Z):O(Z),se(),!0}function K(){switch(t.getToken()){case 11:{let H=0;try{H=JSON.parse(t.getTokenValue()),typeof H!="number"&&(ce(2),H=0)}catch{ce(2)}j(H);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return se(),!0}function Q(){return t.getToken()!==10?(ce(3,[],[2,5]),!1):(Y(!1),t.getToken()===6?(U(":"),se(),G()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function q(){p(),se();let H=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(H||ce(4,[],[]),U(","),se(),t.getToken()===2&&oe)break}else H&&ce(6,[],[]);Q()||ce(4,[],[2,5]),H=!0}return D(),t.getToken()!==2?ce(7,[2],[]):se(),!0}function W(){E(),se();let H=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(H||ce(4,[],[]),U(","),se(),t.getToken()===4&&oe)break}else H&&ce(6,[],[]);G()||ce(4,[],[4,5]),H=!0}return I(),t.getToken()!==4?ce(8,[4],[]):se(),!0}function G(){switch(t.getToken()){case 3:return W();case 1:return q();case 10:return Y(!0);default:return K()}}return se(),t.getToken()===17?r.allowEmptyContent?!0:(ce(4,[],[]),!1):G()?(t.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.$5m=h;function k(i,o){const r=C(i),t=[];let n,l=0,p;do switch(p=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:l!==p&&t.push(i.substring(l,p)),o!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,o)),l=r.getPosition();break}while(n!==17);return t.join("")}e.$6m=k;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$7m=c}),define(ie[138],ne([0,1,44]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cT=e.$bT=e.$aT=e.$_S=void 0;function A(a,g,b){let y,f,v,m,w;if(g){for(m=g.offset,w=m+g.length,v=m;v>0&&!u(a,v-1);)v--;let p=w;for(;p<a.length&&!u(a,p);)p++;f=a.substring(v,p),y=C(f,b)}else f=a,y=0,v=0,m=0,w=a.length;const $=S(b,a);let d=!1,h=0,k;b.insertSpaces?k=R(" ",b.tabSize||4):k="	";const c=(0,P.$Vm)(f,!1);let i=!1;function o(){return $+R(k,y+h)}function r(){let p=c.scan();for(d=!1;p===15||p===14;)d=d||p===14,p=c.scan();return i=p===16||c.getTokenError()!==0,p}const t=[];function n(p,O,D){!i&&O<w&&D>m&&a.substring(O,D)!==p&&t.push({offset:O,length:D-O,content:p})}let l=r();if(l!==17){const p=c.getTokenOffset()+v,O=R(k,y);n(O,v,p)}for(;l!==17;){let p=c.getTokenOffset()+c.getTokenLength()+v,O=r(),D="";for(;!d&&(O===12||O===13);){const I=c.getTokenOffset()+v;n(" ",p,I),p=c.getTokenOffset()+c.getTokenLength()+v,D=O===12?o():"",O=r()}if(O===2)l!==1&&(h--,D=o());else if(O===4)l!==3&&(h--,D=o());else{switch(l){case 3:case 1:h++,D=o();break;case 5:case 12:D=o();break;case 13:d?D=o():D=" ";break;case 6:D=" ";break;case 10:if(O===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:O===12||O===13?D=" ":O!==5&&O!==17&&(i=!0);break;case 16:i=!0;break}d&&(O===12||O===13)&&(D=o())}const E=c.getTokenOffset()+v;n(D,p,E),l=O}return t}e.$_S=A;function s(a,g){const b=JSON.stringify(a,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?b.replace(/\r\n|\r|\n/g,g.eol):b}e.$aT=s;function R(a,g){let b="";for(let y=0;y<g;y++)b+=a;return b}function C(a,g){let b=0,y=0;const f=g.tabSize||4;for(;b<a.length;){const v=a.charAt(b);if(v===" ")y++;else if(v==="	")y+=f;else break;b++}return Math.floor(y/f)}function S(a,g){for(let b=0;b<g.length;b++){const y=g.charAt(b);if(y==="\r")return b+1<g.length&&g.charAt(b+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return a&&a.eol||`
`}e.$bT=S;function u(a,g){return`\r
`.indexOf(a.charAt(g))!==-1}e.$cT=u}),define(ie[139],ne([0,1,44,138]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hT=e.$gT=e.$fT=e.$eT=e.$dT=void 0;function s(a,g,b){return R(a,g,void 0,b)}e.$dT=s;function R(a,g,b,y,f){const v=g.slice(),m=[],w=(0,P.$Ym)(a,m);let $,d;for(;v.length>0&&(d=v.pop(),$=(0,P.$Zm)(w,v),$===void 0&&b!==void 0);)typeof d=="string"?b={[d]:b}:b=[b];if($)if($.type==="object"&&typeof d=="string"&&Array.isArray($.children)){const h=(0,P.$Zm)($,[d]);if(h!==void 0)if(b===void 0){if(!h.parent)throw new Error("Malformed AST");const k=$.children.indexOf(h.parent);let c,i=h.parent.offset+h.parent.length;if(k>0){const o=$.children[k-1];c=o.offset+o.length}else c=$.offset+1,$.children.length>1&&(i=$.children[1].offset);return C(a,{offset:c,length:i-c,content:""},y)}else return C(a,{offset:h.offset,length:h.length,content:JSON.stringify(b)},y);else{if(b===void 0)return[];const k=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,c=f?f($.children.map(o=>o.children[0].value)):$.children.length;let i;if(c>0){const o=$.children[c-1];i={offset:o.offset+o.length,length:0,content:","+k}}else $.children.length===0?i={offset:$.offset+1,length:0,content:k}:i={offset:$.offset+1,length:0,content:k+","};return C(a,i,y)}}else if($.type==="array"&&typeof d=="number"&&Array.isArray($.children))if(b!==void 0){const h=`${JSON.stringify(b)}`;let k;if($.children.length===0||d===0)k={offset:$.offset+1,length:0,content:$.children.length===0?h:h+","};else{const c=d===-1||d>$.children.length?$.children.length:d,i=$.children[c-1];k={offset:i.offset+i.length,length:0,content:","+h}}return C(a,k,y)}else{const h=d,k=$.children[h];let c;if($.children.length===1)c={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===h){const i=$.children[h-1],o=i.offset+i.length,r=$.offset+$.length;c={offset:o,length:r-2-o,content:""}}else c={offset:k.offset,length:$.children[h+1].offset-k.offset,content:""};return C(a,c,y)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${$.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return C(a,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(b)},y)}}e.$eT=R;function C(a,g,b){let y=S(a,g),f=g.offset,v=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;f>0&&!(0,A.$cT)(y,f-1);)f--;for(;v<y.length&&!(0,A.$cT)(y,v);)v++}const m=(0,A.$_S)(y,{offset:f,length:v-f},b);for(let $=m.length-1;$>=0;$--){const d=m[$];y=S(y,d),f=Math.min(f,d.offset),v=Math.max(v,d.offset+d.length),v+=d.content.length-d.length}const w=a.length-(y.length-v)-f;return[{offset:f,length:w,content:y.substring(f,v)}]}e.$fT=C;function S(a,g){return a.substring(0,g.offset)+g.content+a.substring(g.offset+g.length)}e.$gT=S;function u(a,g){const b=g.slice(0).sort((f,v)=>{const m=f.offset-v.offset;return m===0?f.length-v.length:m});let y=a.length;for(let f=b.length-1;f>=0;f--){const v=b[f];if(v.offset+v.length<=y)a=S(a,v);else throw new Error("Overlapping edit");y=v.offset}return a}e.$hT=u}),define(ie[71],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=P}),define(ie[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(R){this.element=R,this.next=P.Undefined,this.prev=P.Undefined}}class A{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let R=this.a;for(;R!==P.Undefined;){const C=R.next;R.prev=P.Undefined,R.next=P.Undefined,R=C}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,C){const S=new P(R);if(this.a===P.Undefined)this.a=S,this.b=S;else if(C){const a=this.b;this.b=S,S.prev=a,a.next=S}else{const a=this.a;this.a=S,S.next=a,a.prev=S}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==P.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==P.Undefined&&R.next!==P.Undefined){const C=R.prev;C.next=R.next,R.next.prev=C}else R.prev===P.Undefined&&R.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):R.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):R.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==P.Undefined;)yield R.element,R=R.next}}e.$2c=A}),define(ie[31],ne([0,1]),function(J,e){"use strict";var P,A,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function R(d,h,k){let c=d.get(h);return c===void 0&&(c=k,d.set(h,c)),c}e.$xc=R;function C(d){const h=[];return d.forEach((k,c)=>{h.push(`${c} => ${k}`)}),`Map(${d.size}) {${h.join(", ")}}`}e.$yc=C;function S(d){const h=[];return d.forEach(k=>{h.push(k)}),`Set(${d.size}) {${h.join(", ")}}`}e.$zc=S;class u{constructor(h,k){this.uri=h,this.value=k}}function a(d){return Array.isArray(d)}class g{static{this.a=h=>h.toString()}constructor(h,k){if(this[P]="ResourceMap",h instanceof g)this.b=new Map(h.b),this.c=k??g.a;else if(a(h)){this.b=new Map,this.c=k??g.a;for(const[c,i]of h)this.set(c,i)}else this.b=new Map,this.c=h??g.a}set(h,k){return this.b.set(this.c(h),new u(h,k)),this}get(h){return this.b.get(this.c(h))?.value}has(h){return this.b.has(this.c(h))}get size(){return this.b.size}clear(){this.b.clear()}delete(h){return this.b.delete(this.c(h))}forEach(h,k){typeof k<"u"&&(h=h.bind(k));for(const[c,i]of this.b)h(i.value,i.uri,this)}*values(){for(const h of this.b.values())yield h.value}*keys(){for(const h of this.b.values())yield h.uri}*entries(){for(const h of this.b.values())yield[h.uri,h.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.b)yield[h.uri,h.value]}}e.$Ac=g;class b{constructor(h,k){this[A]="ResourceSet",!h||typeof h=="function"?this.a=new g(h):(this.a=new g(k),h.forEach(this.add,this))}get size(){return this.a.size}add(h){return this.a.set(h,h),this}clear(){this.a.clear()}delete(h){return this.a.delete(h)}forEach(h,k){this.a.forEach((c,i)=>h.call(k,i,i,this))}has(h){return this.a.has(h)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=b;var y;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class f{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(h){return this.a.has(h)}get(h,k=0){const c=this.a.get(h);if(c)return k!==0&&this.j(c,k),c.value}set(h,k,c=0){let i=this.a.get(h);if(i)i.value=k,c!==0&&this.j(i,c);else{switch(i={key:h,value:k,next:void 0,previous:void 0},c){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(h,i),this.d++}return this}delete(h){return!!this.remove(h)}remove(h){const k=this.a.get(h);if(k)return this.a.delete(h),this.i(k),this.d--,k.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const h=this.b;return this.a.delete(h.key),this.i(h),this.d--,h.value}forEach(h,k){const c=this.e;let i=this.b;for(;i;){if(k?h.bind(k)(i.value,i.key,this):h(i.value,i.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const h=this,k=this.e;let c=this.b;const i={[Symbol.iterator](){return i},next(){if(h.e!==k)throw new Error("LinkedMap got modified during iteration.");if(c){const o={value:c.key,done:!1};return c=c.next,o}else return{value:void 0,done:!0}}};return i}values(){const h=this,k=this.e;let c=this.b;const i={[Symbol.iterator](){return i},next(){if(h.e!==k)throw new Error("LinkedMap got modified during iteration.");if(c){const o={value:c.value,done:!1};return c=c.next,o}else return{value:void 0,done:!0}}};return i}entries(){const h=this,k=this.e;let c=this.b;const i={[Symbol.iterator](){return i},next(){if(h.e!==k)throw new Error("LinkedMap got modified during iteration.");if(c){const o={value:[c.key,c.value],done:!1};return c=c.next,o}else return{value:void 0,done:!0}}};return i}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(h){if(h>=this.size)return;if(h===0){this.clear();return}let k=this.b,c=this.size;for(;k&&c>h;)this.a.delete(k.key),k=k.next,c--;this.b=k,this.d=c,k&&(k.previous=void 0),this.e++}g(h){if(!this.b&&!this.c)this.c=h;else if(this.b)h.next=this.b,this.b.previous=h;else throw new Error("Invalid list");this.b=h,this.e++}h(h){if(!this.b&&!this.c)this.b=h;else if(this.c)h.previous=this.c,this.c.next=h;else throw new Error("Invalid list");this.c=h,this.e++}i(h){if(h===this.b&&h===this.c)this.b=void 0,this.c=void 0;else if(h===this.b){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.b=h.next}else if(h===this.c){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.c=h.previous}else{const k=h.next,c=h.previous;if(!k||!c)throw new Error("Invalid list");k.previous=c,c.next=k}h.next=void 0,h.previous=void 0,this.e++}j(h,k){if(!this.b||!this.c)throw new Error("Invalid list");if(!(k!==1&&k!==2)){if(k===1){if(h===this.b)return;const c=h.next,i=h.previous;h===this.c?(i.next=void 0,this.c=i):(c.previous=i,i.next=c),h.previous=void 0,h.next=this.b,this.b.previous=h,this.b=h,this.e++}else if(k===2){if(h===this.c)return;const c=h.next,i=h.previous;h===this.b?(c.previous=void 0,this.b=c):(c.previous=i,i.next=c),h.next=void 0,h.previous=this.c,this.c.next=h,this.c=h,this.e++}}}toJSON(){const h=[];return this.forEach((k,c)=>{h.push([c,k])}),h}fromJSON(h){this.clear();for(const[k,c]of h)this.set(k,c)}}e.$Cc=f;class v extends f{constructor(h,k=1){super(),this.k=h,this.l=Math.min(Math.max(0,k),1)}get limit(){return this.k}set limit(h){this.k=h,this.m()}get ratio(){return this.l}set ratio(h){this.l=Math.min(Math.max(0,h),1),this.m()}get(h,k=2){return super.get(h,k)}peek(h){return super.get(h,0)}set(h,k){return super.set(h,k,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=v;class m{constructor(){this.a=new Map}add(h){return this.a.set(h,(this.a.get(h)||0)+1),this}delete(h){let k=this.a.get(h)||0;return k===0?!1:(k--,k===0?this.a.delete(h):this.a.set(h,k),!0)}has(h){return this.a.has(h)}}e.$Ec=m;class w{constructor(h){if(this.a=new Map,this.b=new Map,h)for(const[k,c]of h)this.set(k,c)}clear(){this.a.clear(),this.b.clear()}set(h,k){this.a.set(h,k),this.b.set(k,h)}get(h){return this.a.get(h)}getKey(h){return this.b.get(h)}delete(h){const k=this.a.get(h);return k===void 0?!1:(this.a.delete(h),this.b.delete(k),!0)}forEach(h,k){this.a.forEach((c,i)=>{h.call(k,c,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=w;class ${constructor(){this.a=new Map}add(h,k){let c=this.a.get(h);c||(c=new Set,this.a.set(h,c)),c.add(k)}delete(h,k){const c=this.a.get(h);c&&(c.delete(k),c.size===0&&this.a.delete(h))}forEach(h,k){const c=this.a.get(h);c&&c.forEach(k)}get(h){const k=this.a.get(h);return k||new Set}}e.$Gc=$}),define(ie[2],ne([0,1,23,135,31,84,70]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const S=!1;let u=null;class a{constructor(){this.b=new Map}static{this.a=0}c(I){let j=this.b.get(I);return j||(j={parent:null,source:null,isSingleton:!1,value:I,idx:a.a++},this.b.set(I,j)),j}trackDisposable(I){const j=this.c(I);j.source||(j.source=new Error().stack)}setParent(I,j){const U=this.c(I);U.parent=j}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,j){const U=j.get(I);if(U)return U;const z=I.parent?this.f(this.c(I.parent),j):I;return j.set(I,z),z}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,I).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(I=10,j){let U;if(j)U=j;else{const se=new Map,ce=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,se).isSingleton);if(ce.length===0)return;const Y=new Set(ce.map(K=>K.value));if(U=ce.filter(K=>!(K.parent&&Y.has(K.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function z(se){function ce(K,Q){for(;K.length>0&&Q.some(q=>typeof q=="string"?q===K[0]:K[0].match(q));)K.shift()}const Y=se.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return ce(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const X=new s.$Gc;for(const se of U){const ce=z(se);for(let Y=0;Y<=ce.length;Y++)X.add(ce.slice(0,Y).join(`
`),se)}U.sort((0,P.$7b)(se=>se.idx,P.$9b));let x="",oe=0;for(const se of U.slice(0,I)){oe++;const ce=z(se),Y=[];for(let K=0;K<ce.length;K++){let Q=ce[K];Q=`(shared with ${X.get(ce.slice(0,K+1).join(`
`)).size}/${U.length} leaks) at ${Q}`;const W=X.get(ce.slice(0,K).join(`
`)),G=(0,A.$J)([...W].map(H=>z(H)[K]),H=>H);delete G[ce[K]];for(const[H,Z]of Object.entries(G))Y.unshift(`    - stacktraces of ${Z.length} other leaks continue with ${H}`);Y.unshift(Q)}x+=`


==================== Leaking disposable ${oe}/${U.length}: ${se.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return U.length>I&&(x+=`


... and ${U.length-I} more leaking disposables

`),{leaks:U,details:x}}}e.$Hc=a;function g(E){u=E}if(e.$Ic=g,S){const E="__is_disposable_tracked__";g(new class{trackDisposable(I){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[E]||console.log(j)},3e3)}setParent(I,j){if(I&&I!==i.None)try{I[E]=!0}catch{}}markAsDisposed(I){if(I&&I!==i.None)try{I[E]=!0}catch{}}markAsSingleton(I){}})}function b(E){return u?.trackDisposable(E),E}e.$Jc=b;function y(E){u?.markAsDisposed(E)}e.$Kc=y;function f(E,I){u?.setParent(E,I)}function v(E,I){if(u)for(const j of E)u.setParent(j,I)}function m(E){return u?.markAsSingleton(E),E}e.$Lc=m;function w(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Mc=w;function $(E){if(C.Iterable.is(E)){const I=[];for(const j of E)if(j)try{j.dispose()}catch(U){I.push(U)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Nc=$;function d(E){for(const I of E)w(I)&&I.dispose();return[]}e.$Oc=d;function h(...E){const I=k(()=>$(E));return v(E,I),I}e.$Pc=h;function k(E){const I=b({dispose:(0,R.$db)(()=>{y(I),E()})});return I}e.$Qc=k;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return f(I,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),f(I,null))}}e.$Rc=c;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,b(this),f(this.q,this)}dispose(){y(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Sc=i;class o{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&f(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&f(I,null),I}}e.$Tc=o;class r{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=r;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(I){let j=I;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,y(this))},this}}e.$Vc=t;class n{constructor(){this.a=new Map}acquire(I,...j){let U=this.a.get(I);U||(U={counter:0,object:this.b(I,...j)},this.a.set(I,U));const{object:z}=U,X=(0,R.$db)(()=>{--U.counter===0&&(this.c(I,U.object),this.a.delete(I))});return U.counter++,{object:z,dispose:X}}}e.$Wc=n;class l{constructor(I){this.a=I}async acquire(I,...j){const U=this.a.acquire(I,...j);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(z){throw U.dispose(),z}}}e.$Xc=l;class p{constructor(I){this.object=I}dispose(){}}e.$Yc=p;function O(E){const I=new c;try{E(I)}finally{I.dispose()}}e.$Zc=O;class D{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,j,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(I)?.dispose(),this.a.set(I,j)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=D}),define(ie[85],ne([0,1,31]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$pl=void 0;const A=new P.$Dc(1e4);function s(a){return u(a,"NFC",A)}e.$pl=s;const R=new P.$Dc(1e4);function C(a){return u(a,"NFD",R)}e.$ql=C;const S=/[^\u0000-\u0080]/;function u(a,g,b){if(!a)return a;const y=b.get(a);if(y)return y;let f;return S.test(a)?f=a.normalize(g):f=a,b.set(a,f),f}e.$rl=function(){const a=/[\u0300-\u036f]/g;return function(g){return C(g).replace(a,"")}}()}),define(ie[140],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=e.rot=e.$Pl=void 0;function P(S,u,a){return Math.min(Math.max(S,u),a)}e.$Pl=P;function A(S,u){return(u+S%u)%u}e.rot=A;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Rl=s;class R{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Sl=R;class C{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Tl=C}),function(){function J(s){const R=[];typeof s=="number"&&R.push("code/timeOrigin",s);function C(u){R.push(u,Date.now())}function S(){const u=[];for(let a=0;a<R.length;a+=2)u.push({name:R[a],startTime:R[a+1]});return u}return{mark:C,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const C of performance.getEntriesByType("mark"))R.push({name:C.name,startTime:Math.round(s+C.startTime)});return R}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=P(A))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var A in P)(typeof exports=="object"?exports:J)[A]=P[A]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function P(A){if(e[A])return e[A].exports;var s=e[A]={i:A,l:!1,exports:{}};return J[A].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=J,P.c=e,P.d=function(A,s,R){P.o(A,s)||Object.defineProperty(A,s,{enumerable:!0,get:R})},P.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},P.t=function(A,s){if(1&s&&(A=P(A)),8&s||4&s&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(P.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&s&&typeof A!="string")for(var C in A)P.d(R,C,function(S){return A[S]}.bind(null,C));return R},P.n=function(A){var s=A&&A.__esModule?function(){return A.default}:function(){return A};return P.d(s,"a",s),s},P.o=function(A,s){return Object.prototype.hasOwnProperty.call(A,s)},P.p="",P(P.s=0)}([function(J,e,P){(function(A){var s;e=J.exports=re,s=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],u=e.src=[],a=0,g=a++;u[g]="0|[1-9]\\d*";var b=a++;u[b]="[0-9]+";var y=a++;u[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=a++;u[f]="("+u[g]+")\\.("+u[g]+")\\.("+u[g]+")";var v=a++;u[v]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var m=a++;u[m]="(?:"+u[g]+"|"+u[y]+")";var w=a++;u[w]="(?:"+u[b]+"|"+u[y]+")";var $=a++;u[$]="(?:-("+u[m]+"(?:\\."+u[m]+")*))";var d=a++;u[d]="(?:-?("+u[w]+"(?:\\."+u[w]+")*))";var h=a++;u[h]="[0-9A-Za-z-]+";var k=a++;u[k]="(?:\\+("+u[h]+"(?:\\."+u[h]+")*))";var c=a++,i="v?"+u[f]+u[$]+"?"+u[k]+"?";u[c]="^"+i+"$";var o="[v=\\s]*"+u[v]+u[d]+"?"+u[k]+"?",r=a++;u[r]="^"+o+"$";var t=a++;u[t]="((?:<|>)?=?)";var n=a++;u[n]=u[b]+"|x|X|\\*";var l=a++;u[l]=u[g]+"|x|X|\\*";var p=a++;u[p]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[$]+")?"+u[k]+"?)?)?";var O=a++;u[O]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[d]+")?"+u[k]+"?)?)?";var D=a++;u[D]="^"+u[t]+"\\s*"+u[p]+"$";var E=a++;u[E]="^"+u[t]+"\\s*"+u[O]+"$";var I=a++;u[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=a++;u[j]="(?:~>?)";var U=a++;u[U]="(\\s*)"+u[j]+"\\s+",S[U]=new RegExp(u[U],"g");var z=a++;u[z]="^"+u[j]+u[p]+"$";var X=a++;u[X]="^"+u[j]+u[O]+"$";var x=a++;u[x]="(?:\\^)";var oe=a++;u[oe]="(\\s*)"+u[x]+"\\s+",S[oe]=new RegExp(u[oe],"g");var se=a++;u[se]="^"+u[x]+u[p]+"$";var ce=a++;u[ce]="^"+u[x]+u[O]+"$";var Y=a++;u[Y]="^"+u[t]+"\\s*("+o+")$|^$";var K=a++;u[K]="^"+u[t]+"\\s*("+i+")$|^$";var Q=a++;u[Q]="(\\s*)"+u[t]+"\\s*("+o+"|"+u[p]+")",S[Q]=new RegExp(u[Q],"g");var q=a++;u[q]="^\\s*("+u[p]+")\\s+-\\s+("+u[p]+")\\s*$";var W=a++;u[W]="^\\s*("+u[O]+")\\s+-\\s+("+u[O]+")\\s*$";var G=a++;u[G]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)s(H,u[H]),S[H]||(S[H]=new RegExp(u[H]));function Z(_,le){if(_ instanceof re)return _;if(typeof _!="string"||_.length>R||!(le?S[r]:S[c]).test(_))return null;try{return new re(_,le)}catch{return null}}function re(_,le){if(_ instanceof re){if(_.loose===le)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof re))return new re(_,le);s("SemVer",_,le),this.loose=le;var ge=_.trim().match(le?S[r]:S[c]);if(!ge)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Ce=+Oe;if(Ce>=0&&Ce<C)return Ce}return Oe}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=Z,e.valid=function(_,le){var ge=Z(_,le);return ge?ge.version:null},e.clean=function(_,le){var ge=Z(_.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(_){return s("SemVer.compare",this.version,this.loose,_),_ instanceof re||(_=new re(_,this.loose)),this.compareMain(_)||this.comparePre(_)},re.prototype.compareMain=function(_){return _ instanceof re||(_=new re(_,this.loose)),M(this.major,_.major)||M(this.minor,_.minor)||M(this.patch,_.patch)},re.prototype.comparePre=function(_){if(_ instanceof re||(_=new re(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],Oe=_.prerelease[le];if(s("prerelease compare",le,ge,Oe),ge===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(ge===void 0)return-1;if(ge!==Oe)return M(ge,Oe)}while(++le)},re.prototype.inc=function(_,le){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,le,ge,Oe){typeof ge=="string"&&(Oe=ge,ge=void 0);try{return new re(_,ge).inc(le,Oe).version}catch{return null}},e.diff=function(_,le){if(B(_,le))return null;var ge=Z(_),Oe=Z(le);if(ge.prerelease.length||Oe.prerelease.length){for(var Ce in ge)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ge[Ce]!==Oe[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in ge)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ge[Ce]!==Oe[Ce])return Ce},e.compareIdentifiers=M;var L=/^[0-9]+$/;function M(_,le){var ge=L.test(_),Oe=L.test(le);return ge&&Oe&&(_=+_,le=+le),ge&&!Oe?-1:Oe&&!ge?1:_<le?-1:_>le?1:0}function N(_,le,ge){return new re(_,ge).compare(new re(le,ge))}function T(_,le,ge){return N(_,le,ge)>0}function F(_,le,ge){return N(_,le,ge)<0}function B(_,le,ge){return N(_,le,ge)===0}function V(_,le,ge){return N(_,le,ge)!==0}function ae(_,le,ge){return N(_,le,ge)>=0}function de(_,le,ge){return N(_,le,ge)<=0}function ue(_,le,ge,Oe){var Ce;switch(le){case"===":typeof _=="object"&&(_=_.version),typeof ge=="object"&&(ge=ge.version),Ce=_===ge;break;case"!==":typeof _=="object"&&(_=_.version),typeof ge=="object"&&(ge=ge.version),Ce=_!==ge;break;case"":case"=":case"==":Ce=B(_,ge,Oe);break;case"!=":Ce=V(_,ge,Oe);break;case">":Ce=T(_,ge,Oe);break;case">=":Ce=ae(_,ge,Oe);break;case"<":Ce=F(_,ge,Oe);break;case"<=":Ce=de(_,ge,Oe);break;default:throw new TypeError("Invalid operator: "+le)}return Ce}function he(_,le){if(_ instanceof he){if(_.loose===le)return _;_=_.value}if(!(this instanceof he))return new he(_,le);s("comparator",_,le),this.loose=le,this.parse(_),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(_,le){return M(le,_)},e.major=function(_,le){return new re(_,le).major},e.minor=function(_,le){return new re(_,le).minor},e.patch=function(_,le){return new re(_,le).patch},e.compare=N,e.compareLoose=function(_,le){return N(_,le,!0)},e.rcompare=function(_,le,ge){return N(le,_,ge)},e.sort=function(_,le){return _.sort(function(ge,Oe){return e.compare(ge,Oe,le)})},e.rsort=function(_,le){return _.sort(function(ge,Oe){return e.rcompare(ge,Oe,le)})},e.gt=T,e.lt=F,e.eq=B,e.neq=V,e.gte=ae,e.lte=de,e.cmp=ue,e.Comparator=he;var ve={};function be(_,le){if(_ instanceof be)return _.loose===le?_:new be(_.raw,le);if(_ instanceof he)return new be(_.value,le);if(!(this instanceof be))return new be(_,le);if(this.loose=le,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function ye(_){return!_||_.toLowerCase()==="x"||_==="*"}function Ie(_,le,ge,Oe,Ce,Le,Re,He,ze,ee,fe,$e,ke){return((le=ye(ge)?"":ye(Oe)?">="+ge+".0.0":ye(Ce)?">="+ge+"."+Oe+".0":">="+le)+" "+(He=ye(ze)?"":ye(ee)?"<"+(+ze+1)+".0.0":ye(fe)?"<"+ze+"."+(+ee+1)+".0":$e?"<="+ze+"."+ee+"."+fe+"-"+$e:"<="+He)).trim()}function Te(_,le){for(var ge=0;ge<_.length;ge++)if(!_[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<_.length;ge++)if(s(_[ge].semver),_[ge].semver!==ve&&_[ge].semver.prerelease.length>0){var Oe=_[ge].semver;if(Oe.major===le.major&&Oe.minor===le.minor&&Oe.patch===le.patch)return!0}return!1}return!0}function me(_,le,ge){try{le=new be(le,ge)}catch{return!1}return le.test(_)}function we(_,le,ge,Oe){var Ce,Le,Re,He,ze;switch(_=new re(_,Oe),le=new be(le,Oe),ge){case">":Ce=T,Le=de,Re=F,He=">",ze=">=";break;case"<":Ce=F,Le=ae,Re=T,He="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(_,le,Oe))return!1;for(var ee=0;ee<le.set.length;++ee){var fe=le.set[ee],$e=null,ke=null;if(fe.forEach(function(De){De.semver===ve&&(De=new he(">=0.0.0")),$e=$e||De,ke=ke||De,Ce(De.semver,$e.semver,Oe)?$e=De:Re(De.semver,ke.semver,Oe)&&(ke=De)}),$e.operator===He||$e.operator===ze||(!ke.operator||ke.operator===He)&&Le(_,ke.semver)||ke.operator===ze&&Re(_,ke.semver))return!1}return!0}he.prototype.parse=function(_){var le=this.loose?S[Y]:S[K],ge=_.match(le);if(!ge)throw new TypeError("Invalid comparator: "+_);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new re(ge[2],this.loose):this.semver=ve},he.prototype.toString=function(){return this.value},he.prototype.test=function(_){return s("Comparator.test",_,this.loose),this.semver===ve||(typeof _=="string"&&(_=new re(_,this.loose)),ue(_,this.operator,this.semver,this.loose))},he.prototype.intersects=function(_,le){if(!(_ instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(_.value,le),me(this.value,ge,le);if(_.operator==="")return ge=new be(this.value,le),me(_.semver,ge,le);var Oe=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Le=this.semver.version===_.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),He=ue(this.semver,"<",_.semver,le)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),ze=ue(this.semver,">",_.semver,le)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return Oe||Ce||Le&&Re||He||ze},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(_){var le=this.loose;_=_.trim(),s("range",_,le);var ge=le?S[W]:S[q];_=_.replace(ge,Ie),s("hyphen replace",_),_=_.replace(S[Q],"$1$2$3"),s("comparator trim",_,S[Q]),_=(_=(_=_.replace(S[U],"$1~")).replace(S[oe],"$1^")).split(/\s+/).join(" ");var Oe=le?S[Y]:S[K],Ce=_.split(" ").map(function(Le){return function(Re,He){return s("comp",Re),Re=function(ze,ee){return ze.trim().split(/\s+/).map(function(fe){return function($e,ke){s("caret",$e,ke);var De=ke?S[ce]:S[se];return $e.replace(De,function(Ne,je,Fe,Ve,Ge){var Qe;return s("caret",$e,Ne,je,Fe,Ve,Ge),ye(je)?Qe="":ye(Fe)?Qe=">="+je+".0.0 <"+(+je+1)+".0.0":ye(Ve)?Qe=je==="0"?">="+je+"."+Fe+".0 <"+je+"."+(+Fe+1)+".0":">="+je+"."+Fe+".0 <"+(+je+1)+".0.0":Ge?(s("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Qe=je==="0"?Fe==="0"?">="+je+"."+Fe+"."+Ve+Ge+" <"+je+"."+Fe+"."+(+Ve+1):">="+je+"."+Fe+"."+Ve+Ge+" <"+je+"."+(+Fe+1)+".0":">="+je+"."+Fe+"."+Ve+Ge+" <"+(+je+1)+".0.0"):(s("no pr"),Qe=je==="0"?Fe==="0"?">="+je+"."+Fe+"."+Ve+" <"+je+"."+Fe+"."+(+Ve+1):">="+je+"."+Fe+"."+Ve+" <"+je+"."+(+Fe+1)+".0":">="+je+"."+Fe+"."+Ve+" <"+(+je+1)+".0.0"),s("caret return",Qe),Qe})}(fe,ee)}).join(" ")}(Re,He),s("caret",Re),Re=function(ze,ee){return ze.trim().split(/\s+/).map(function(fe){return function($e,ke){var De=ke?S[X]:S[z];return $e.replace(De,function(Ne,je,Fe,Ve,Ge){var Qe;return s("tilde",$e,Ne,je,Fe,Ve,Ge),ye(je)?Qe="":ye(Fe)?Qe=">="+je+".0.0 <"+(+je+1)+".0.0":ye(Ve)?Qe=">="+je+"."+Fe+".0 <"+je+"."+(+Fe+1)+".0":Ge?(s("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Qe=">="+je+"."+Fe+"."+Ve+Ge+" <"+je+"."+(+Fe+1)+".0"):Qe=">="+je+"."+Fe+"."+Ve+" <"+je+"."+(+Fe+1)+".0",s("tilde return",Qe),Qe})}(fe,ee)}).join(" ")}(Re,He),s("tildes",Re),Re=function(ze,ee){return s("replaceXRanges",ze,ee),ze.split(/\s+/).map(function(fe){return function($e,ke){$e=$e.trim();var De=ke?S[E]:S[D];return $e.replace(De,function(Ne,je,Fe,Ve,Ge,Qe){s("xRange",$e,Ne,je,Fe,Ve,Ge,Qe);var Ze=ye(Fe),Xe=Ze||ye(Ve),it=Xe||ye(Ge);return je==="="&&it&&(je=""),Ze?Ne=je===">"||je==="<"?"<0.0.0":"*":je&&it?(Xe&&(Ve=0),it&&(Ge=0),je===">"?(je=">=",Xe?(Fe=+Fe+1,Ve=0,Ge=0):it&&(Ve=+Ve+1,Ge=0)):je==="<="&&(je="<",Xe?Fe=+Fe+1:Ve=+Ve+1),Ne=je+Fe+"."+Ve+"."+Ge):Xe?Ne=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":it&&(Ne=">="+Fe+"."+Ve+".0 <"+Fe+"."+(+Ve+1)+".0"),s("xRange return",Ne),Ne})}(fe,ee)}).join(" ")}(Re,He),s("xrange",Re),Re=function(ze,ee){return s("replaceStars",ze,ee),ze.trim().replace(S[G],"")}(Re,He),s("stars",Re),Re}(Le,le)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Le){return!!Le.match(Oe)})),Ce=Ce.map(function(Le){return new he(Le,le)})},be.prototype.intersects=function(_,le){if(!(_ instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Oe){return _.set.some(function(Ce){return Ce.every(function(Le){return Oe.intersects(Le,le)})})})})},e.toComparators=function(_,le){return new be(_,le).set.map(function(ge){return ge.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},be.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new re(_,this.loose));for(var le=0;le<this.set.length;le++)if(Te(this.set[le],_))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(_,le,ge){var Oe=null,Ce=null;try{var Le=new be(le,ge)}catch{return null}return _.forEach(function(Re){Le.test(Re)&&(Oe&&Ce.compare(Re)!==-1||(Ce=new re(Oe=Re,ge)))}),Oe},e.minSatisfying=function(_,le,ge){var Oe=null,Ce=null;try{var Le=new be(le,ge)}catch{return null}return _.forEach(function(Re){Le.test(Re)&&(Oe&&Ce.compare(Re)!==1||(Ce=new re(Oe=Re,ge)))}),Oe},e.validRange=function(_,le){try{return new be(_,le).range||"*"}catch{return null}},e.ltr=function(_,le,ge){return we(_,le,"<",ge)},e.gtr=function(_,le,ge){return we(_,le,">",ge)},e.outside=we,e.prerelease=function(_,le){var ge=Z(_,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(_,le,ge){return _=new be(_,ge),le=new be(le,ge),_.intersects(le)},e.coerce=function(_){if(_ instanceof re)return _;if(typeof _!="string")return null;var le=_.match(S[I]);return le==null?null:Z((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,P(1))},function(J,e){var P,A,s=J.exports={};function R(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function S(w){if(P===setTimeout)return setTimeout(w,0);if((P===R||!P)&&setTimeout)return P=setTimeout,setTimeout(w,0);try{return P(w,0)}catch{try{return P.call(null,w,0)}catch{return P.call(this,w,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:R}catch{P=R}try{A=typeof clearTimeout=="function"?clearTimeout:C}catch{A=C}})();var u,a=[],g=!1,b=-1;function y(){g&&u&&(g=!1,u.length?a=u.concat(a):b=-1,a.length&&f())}function f(){if(!g){var w=S(y);g=!0;for(var $=a.length;$;){for(u=a,a=[];++b<$;)u&&u[b].run();b=-1,$=a.length}u=null,g=!1,function(d){if(A===clearTimeout)return clearTimeout(d);if((A===C||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(d);try{A(d)}catch{try{return A.call(null,d)}catch{return A.call(this,d)}}}(w)}}function v(w,$){this.fun=w,this.array=$}function m(){}s.nextTick=function(w){var $=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)$[d-1]=arguments[d];a.push(new v(w,$)),a.length!==1||g||S(f)},v.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=m,s.addListener=m,s.once=m,s.off=m,s.removeListener=m,s.removeAllListeners=m,s.emit=m,s.prependListener=m,s.prependOnceListener=m,s.listeners=function(w){return[]},s.binding=function(w){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(w){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ie[141],ne([0,1]),function(J,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class A{constructor(S,u,a){this.level=S,this.key=u,this.value=a,this.forward=[]}}const s=void 0;class R{constructor(S,u=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new A(this.c,s,s)}get size(){return this.f}clear(){this.e=new A(this.c,s,s),this.f=0}has(S){return!!R.g(this,S,this.comparator)}get(S){return R.g(this,S,this.comparator)?.value}set(S,u){return R.h(this,S,u,this.comparator)&&(this.f+=1),this}delete(S){const u=R.k(this,S,this.comparator);return u&&(this.f-=1),u}forEach(S,u){let a=this.e.forward[0];for(;a;)S.call(u,a.value,a.key,this),a=a.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",u=this.e.forward[0];for(;u;)S+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return S}static g(S,u,a){let g=S.e;for(let b=S.d-1;b>=0;b--)for(;g.forward[b]&&a(g.forward[b].key,u)<0;)g=g.forward[b];if(g=g.forward[0],g&&a(g.key,u)===0)return g}static h(S,u,a,g){const b=[];let y=S.e;for(let f=S.d-1;f>=0;f--){for(;y.forward[f]&&g(y.forward[f].key,u)<0;)y=y.forward[f];b[f]=y}if(y=y.forward[0],y&&g(y.key,u)===0)return y.value=a,!1;{const f=R.j(S);if(f>S.d){for(let v=S.d;v<f;v++)b[v]=S.e;S.d=f}y=new A(f,u,a);for(let v=0;v<f;v++)y.forward[v]=b[v].forward[v],b[v].forward[v]=y;return!0}}static j(S,u=.5){let a=1;for(;Math.random()<u&&a<S.c;)a+=1;return a}static k(S,u,a){const g=[];let b=S.e;for(let y=S.d-1;y>=0;y--){for(;b.forward[y]&&a(b.forward[y].key,u)<0;)b=b.forward[y];g[y]=b}if(b=b.forward[0],!b||a(b.key,u)!==0)return!1;for(let y=0;y<S.d&&g[y].forward[y]===b;y++)g[y].forward[y]=b.forward[y];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$Cr=R}),define(ie[72],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(R){return new A(R)}constructor(R){this.c=P&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Kd=A}),define(ie[3],ne([0,1,14,84,2,101,72]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.Event=void 0;const S=!1,u=!1;var a;(function(D){D.None=()=>s.$Sc.None;function E(ue){if(u){const{onDidAddListener:he}=ue,ve=v.create();let be=0;ue.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),he?.()}}}function I(ue,he){return K(ue,()=>{},0,void 0,!0,void 0,he)}D.defer=I;function j(ue){return(he,ve=null,be)=>{let ye=!1,Ie;return Ie=ue(Te=>{if(!ye)return Ie?Ie.dispose():ye=!0,he.call(ve,Te)},null,be),ye&&Ie.dispose(),Ie}}D.once=j;function U(ue,he,ve){return ce((be,ye=null,Ie)=>ue(Te=>be.call(ye,he(Te)),null,Ie),ve)}D.map=U;function z(ue,he,ve){return ce((be,ye=null,Ie)=>ue(Te=>{he(Te),be.call(ye,Te)},null,Ie),ve)}D.forEach=z;function X(ue,he,ve){return ce((be,ye=null,Ie)=>ue(Te=>he(Te)&&be.call(ye,Te),null,Ie),ve)}D.filter=X;function x(ue){return ue}D.signal=x;function oe(...ue){return(he,ve=null,be)=>{const ye=(0,s.$Pc)(...ue.map(Ie=>Ie(Te=>he.call(ve,Te))));return Y(ye,be)}}D.any=oe;function se(ue,he,ve,be){let ye=ve;return U(ue,Ie=>(ye=he(ye,Ie),ye),be)}D.reduce=se;function ce(ue,he){let ve;const be={onWillAddFirstListener(){ve=ue(ye.fire,ye)},onDidRemoveLastListener(){ve?.dispose()}};he||E(be);const ye=new h(be);return he?.add(ye),ye.event}function Y(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function K(ue,he,ve=100,be=!1,ye=!1,Ie,Te){let me,we,_,le=0,ge;const Oe={leakWarningThreshold:Ie,onWillAddFirstListener(){me=ue(Le=>{le++,we=he(we,Le),be&&!_&&(Ce.fire(we),we=void 0),ge=()=>{const Re=we;we=void 0,_=void 0,(!be||le>1)&&Ce.fire(Re),le=0},typeof ve=="number"?(clearTimeout(_),_=setTimeout(ge,ve)):_===void 0&&(_=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,me.dispose()}};Te||E(Oe);const Ce=new h(Oe);return Te?.add(Ce),Ce.event}D.debounce=K;function Q(ue,he=0,ve){return D.debounce(ue,(be,ye)=>be?(be.push(ye),be):[ye],he,void 0,!0,void 0,ve)}D.accumulate=Q;function q(ue,he=(be,ye)=>be===ye,ve){let be=!0,ye;return X(ue,Ie=>{const Te=be||!he(Ie,ye);return be=!1,ye=Ie,Te},ve)}D.latch=q;function W(ue,he,ve){return[D.filter(ue,he,ve),D.filter(ue,be=>!he(be),ve)]}D.split=W;function G(ue,he=!1,ve=[],be){let ye=ve.slice(),Ie=ue(we=>{ye?ye.push(we):me.fire(we)});be&&be.add(Ie);const Te=()=>{ye?.forEach(we=>me.fire(we)),ye=null},me=new h({onWillAddFirstListener(){Ie||(Ie=ue(we=>me.fire(we)),be&&be.add(Ie))},onDidAddFirstListener(){ye&&(he?setTimeout(Te):Te())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return be&&be.add(me),me.event}D.buffer=G;function H(ue,he){return(be,ye,Ie)=>{const Te=he(new re);return ue(function(me){const we=Te.evaluate(me);we!==Z&&be.call(ye,we)},void 0,Ie)}}D.chain=H;const Z=Symbol("HaltChainable");class re{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push(ve=>(he(ve),ve)),this}filter(he){return this.f.push(ve=>he(ve)?ve:Z),this}reduce(he,ve){let be=ve;return this.f.push(ye=>(be=he(be,ye),be)),this}latch(he=(ve,be)=>ve===be){let ve=!0,be;return this.f.push(ye=>{const Ie=ve||!he(ye,be);return ve=!1,be=ye,Ie?ye:Z}),this}evaluate(he){for(const ve of this.f)if(he=ve(he),he===Z)break;return he}}function L(ue,he,ve=be=>be){const be=(...me)=>Te.fire(ve(...me)),ye=()=>ue.on(he,be),Ie=()=>ue.removeListener(he,be),Te=new h({onWillAddFirstListener:ye,onDidRemoveLastListener:Ie});return Te.event}D.fromNodeEventEmitter=L;function M(ue,he,ve=be=>be){const be=(...me)=>Te.fire(ve(...me)),ye=()=>ue.addEventListener(he,be),Ie=()=>ue.removeEventListener(he,be),Te=new h({onWillAddFirstListener:ye,onDidRemoveLastListener:Ie});return Te.event}D.fromDOMEventEmitter=M;function N(ue){return new Promise(he=>j(ue)(he))}D.toPromise=N;function T(ue){const he=new h;return ue.then(ve=>{he.fire(ve)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}D.fromPromise=T;function F(ue,he,ve){return he(ve),ue(be=>he(be))}D.runAndSubscribe=F;function B(ue,he){let ve=null;function be(Ie){ve?.dispose(),ve=new s.$Rc,he(Ie,ve)}be(void 0);const ye=ue(Ie=>be(Ie));return(0,s.$Qc)(()=>{ye.dispose(),ve?.dispose()})}D.runAndSubscribeWithStore=B;class V{constructor(he,ve){this._observable=he,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};ve||E(be),this.emitter=new h(be),ve&&ve.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,ve){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ae(ue,he){return new V(ue,he).emitter.event}D.fromObservable=ae;function de(ue){return he=>{let ve=0,be=!1;const ye={beginUpdate(){ve++},endUpdate(){ve--,ve===0&&(ue.reportChanges(),be&&(be=!1,he()))},handlePossibleChange(){},handleChange(){be=!0}};return ue.addObserver(ye),ue.reportChanges(),{dispose(){ue.removeObserver(ye)}}}}D.fromObservableLight=de})(a||(e.Event=a={}));class g{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${g.f++}`,g.all.add(this)}start(E){this.g=new C.$Kd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Md=g;let b=-1;function y(D){const E=b;return b=D,{dispose(){b=E}}}e.$Nd=y;class f{constructor(E,I=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=I,this.g=0}dispose(){this.f?.clear()}check(E,I){const j=this.threshold;if(j<=0||I<j)return;this.f||(this.f=new Map);const U=this.f.get(E.value)||0;if(this.f.set(E.value,U+1),this.g-=1,this.g<=0){this.g=j*.5;let z,X=0;for(const[x,oe]of this.f)(!z||X<oe)&&(z=x,X=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${X}):`),console.warn(z)}return()=>{const z=this.f.get(E.value)||0;this.f.set(E.value,z-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class w{constructor(E){this.value=E,this.id=m++}}const $=2,d=(D,E)=>{if(D instanceof w)E(D);else for(let I=0;I<D.length;I++){const j=D[I];j&&E(j)}};class h{constructor(E){this.w=0,this.f=E,this.g=b>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const E=this.t;queueMicrotask(()=>{d(E,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,I,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Sc.None;if(this.m)return s.$Sc.None;I&&(E=E.bind(I));const U=new w(E);let z,X;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(U.stack=v.create(),z=this.g.check(U.stack,this.w+1)),S&&(U.stack=X??v.create()),this.t?this.t instanceof w?(this.u??=new c,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.w++;const x=(0,s.$Qc)(()=>{z?.(),this.x(U)});return j instanceof s.$Rc?j.add(x):Array.isArray(j)&&j.push(x),x},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,j=I.indexOf(E);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[j]=void 0;const U=this.u.current===this;if(this.w*$<=I.length){let z=0;for(let X=0;X<I.length;X++)I[X]?I[z++]=I[X]:U&&(this.u.end--,z<this.u.i&&this.u.i--);I.length=z}}y(E,I){if(!E)return;const j=this.f?.onListenerError||P.$1;if(!j){E.value(I);return}try{E.value(I)}catch(U){j(U)}}z(E){const I=E.current.t;for(;E.i<E.end;)this.y(I[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,E);else{const I=this.u;I.enqueue(this,E,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Od=h;const k=()=>new c;e.$Pd=k;class c{constructor(){this.i=-1,this.end=0}enqueue(E,I,j){this.i=0,this.end=j,this.current=E,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends h{async fireAsync(E,I,j){if(this.t)for(this.h||(this.h=new R.$2c),d(this.t,U=>this.h.push([U.value,E]));this.h.size>0&&!I.isCancellationRequested;){const[U,z]=this.h.shift(),X=[],x={...z,token:I,waitUntil:oe=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");j&&(oe=j(oe,U)),X.push(oe)}};try{U(x)}catch(oe){(0,P.$1)(oe);continue}Object.freeze(X),await Promise.allSettled(X).then(oe=>{for(const se of oe)se.status==="rejected"&&(0,P.$1)(se.reason)})}}}e.$Qd=i;class o extends h{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new R.$2c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Rd=o;class r extends o{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$Sd=r;class t extends h{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$Td=t;class n{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const I={event:E,listener:null};this.h.push(I),this.g&&this.m(I);const j=()=>{this.g&&this.o(I);const U=this.h.indexOf(I);this.h.splice(U,1)};return(0,s.$Qc)((0,A.$db)(j))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(I=>this.f.fire(I))}o(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.f.dispose()}}e.$Ud=n;class l{constructor(E,I,j,U){this.f=new s.$Rc;const z=this.f.add(new n),X=this.f.add(new s.$1c);function x(oe){X.set(oe,z.add(U(oe)))}for(const oe of E)x(oe);this.f.add(I(oe=>{x(oe)})),this.f.add(j(oe=>{X.deleteAndDispose(oe)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Vd=l;class p{constructor(){this.f=[]}wrapEvent(E){return(I,j,U)=>E(z=>{const X=this.f[this.f.length-1];X?X.push(()=>I.call(j,z)):I.call(j,z)},void 0,U)}bufferEvents(E){const I=[];this.f.push(I);const j=E();return this.f.pop(),I.forEach(U=>U()),j}}e.$Wd=p;class O{constructor(){this.f=!1,this.g=a.None,this.h=s.$Sc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Xd=O}),define(ie[22],ne([0,1,3]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.CancellationToken=void 0;const A=Object.freeze(function(S,u){const a=setTimeout(S.bind(u),0);return{dispose(){clearTimeout(a)}}});var s;(function(S){function u(a){return a===S.None||a===S.Cancelled||a instanceof R?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}S.isCancellationToken=u,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(s||(e.CancellationToken=s={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new P.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=s.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=s.None}}e.$Yd=C}),define(ie[142],ne([0,1,22]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=void 0;class A{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$Yd,u=this.b(S.token);return this.a={promise:u,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$xe=A;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const u=JSON.stringify(S);return this.b!==u&&(this.b=u,this.a=this.c(S)),this.a}}e.$ye=s;class R{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const u=this.b(S);return this.a.set(S,u),u}}e.$ze=R}),define(ie[61],ne([0,1,14,2]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function s(k){const c=k;return c?typeof c.read=="function":!1}e.$Zd=s;function R(k){const c=k;return c?[c.on,c.pause,c.resume,c.destroy].every(i=>typeof i=="function"):!1}e.$1d=R;function C(k){const c=k;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$2d=C;function S(k,c){return new u(k,c)}e.$3d=S;class u{constructor(c,i){this.e=c,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(i=>i(c))}h(c){this.c.error.length===0?(0,P.$1)(c):this.c.error.slice(0).forEach(i=>i(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,i){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(c,i){if(this.a.destroyed)return;let o;switch(c){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(i);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(k,c){const i=[];let o;for(;(o=k.read())!==null;)i.push(o);return c(i)}e.$4d=a;function g(k,c,i){const o=[];let r;for(;(r=k.read())!==null&&o.length<i;)o.push(r);return r===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return k.read()}}}e.$5d=g;function b(k,c){return new Promise((i,o)=>{const r=[];y(k,{onData:t=>{c&&r.push(t)},onError:t=>{c?o(t):i(void 0)},onEnd:()=>{i(c?c(r):void 0)}})})}e.$6d=b;function y(k,c,i){k.on("error",o=>{i?.isCancellationRequested||c.onError(o)}),k.on("end",()=>{i?.isCancellationRequested||c.onEnd()}),k.on("data",o=>{i?.isCancellationRequested||c.onData(o)})}e.$7d=y;function f(k,c){return new Promise((i,o)=>{const r=new A.$Rc,t=[],n=O=>{if(t.push(O),t.length>c)return r.dispose(),k.pause(),i({stream:k,buffer:t,ended:!1})},l=O=>(r.dispose(),o(O)),p=()=>(r.dispose(),i({stream:k,buffer:t,ended:!0}));r.add((0,A.$Qc)(()=>k.removeListener("error",l))),k.on("error",l),r.add((0,A.$Qc)(()=>k.removeListener("end",p))),k.on("end",p),r.add((0,A.$Qc)(()=>k.removeListener("data",n))),k.on("data",n)})}e.$8d=f;function v(k,c){const i=S(c);return i.end(k),i}e.$9d=v;function m(){const k=S(()=>{throw new Error("not supported")});return k.end(),k}e.$0d=m;function w(k){let c=!1;return{read:()=>c?null:(c=!0,k)}}e.$$d=w;function $(k,c,i){const o=S(i);return y(k,{onData:r=>o.write(c.data(r)),onError:r=>o.error(c.error?c.error(r):r),onEnd:()=>o.end()}),o}e.$_d=$;function d(k,c,i){let o=!1;return{read:()=>{const r=c.read();return o?r:(o=!0,r!==null?i([k,r]):k)}}}e.$ae=d;function h(k,c,i){let o=!1;const r=S(i);return y(c,{onData:t=>o?r.write(t):(o=!0,r.write(i([k,t]))),onError:t=>r.error(t),onEnd:()=>{o||(o=!0,r.write(k)),r.end()}}),r}e.$be=h}),define(ie[17],ne([0,1,71,61]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const s=typeof Buffer<"u",R=new P.$V(()=>new Uint8Array(256));let C,S;class u{static alloc(I){return s?new u(Buffer.allocUnsafe(I)):new u(new Uint8Array(I))}static wrap(I){return s&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new u(I)}static fromString(I,j){return!(j?.dontUseNodeBuffer||!1)&&s?new u(Buffer.from(I)):(C||(C=new TextEncoder),new u(C.encode(I)))}static fromByteArray(I){const j=u.alloc(I.length);for(let U=0,z=I.length;U<z;U++)j.buffer[U]=I[U];return j}static concat(I,j){if(typeof j>"u"){j=0;for(let X=0,x=I.length;X<x;X++)j+=I[X].byteLength}const U=u.alloc(j);let z=0;for(let X=0,x=I.length;X<x;X++){const oe=I[X];U.set(oe,z),z+=oe.byteLength}return U}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=u.alloc(this.byteLength);return I.set(this),I}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(I,j){return new u(this.buffer.subarray(I,j))}set(I,j){if(I instanceof u)this.buffer.set(I.buffer,j);else if(I instanceof Uint8Array)this.buffer.set(I,j);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),j);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return y(this.buffer,I)}writeUInt32BE(I,j){f(this.buffer,I,j)}readUInt32LE(I){return v(this.buffer,I)}writeUInt32LE(I,j){m(this.buffer,I,j)}readUInt8(I){return w(this.buffer,I)}writeUInt8(I,j){$(this.buffer,I,j)}indexOf(I,j=0){return a(this.buffer,I instanceof u?I.buffer:I,j)}}e.$ce=u;function a(E,I,j=0){const U=I.byteLength,z=E.byteLength;if(U===0)return 0;if(U===1)return E.indexOf(I[0]);if(U>z-j)return-1;const X=R.value;X.fill(I.length);for(let ce=0;ce<I.length;ce++)X[I[ce]]=I.length-ce-1;let x=j+I.length-1,oe=x,se=-1;for(;x<z;)if(E[x]===I[oe]){if(oe===0){se=x;break}x--,oe--}else x+=Math.max(I.length-oe,X[E[x]]),oe=I.length-1;return se}e.$de=a;function g(E,I){return E[I+0]<<0>>>0|E[I+1]<<8>>>0}e.$ee=g;function b(E,I,j){E[j+0]=I&255,I=I>>>8,E[j+1]=I&255}e.$fe=b;function y(E,I){return E[I]*2**24+E[I+1]*2**16+E[I+2]*2**8+E[I+3]}e.$ge=y;function f(E,I,j){E[j+3]=I,I=I>>>8,E[j+2]=I,I=I>>>8,E[j+1]=I,I=I>>>8,E[j]=I}e.$he=f;function v(E,I){return E[I+0]<<0>>>0|E[I+1]<<8>>>0|E[I+2]<<16>>>0|E[I+3]<<24>>>0}e.$ie=v;function m(E,I,j){E[j+0]=I&255,I=I>>>8,E[j+1]=I&255,I=I>>>8,E[j+2]=I&255,I=I>>>8,E[j+3]=I&255}e.$je=m;function w(E,I){return E[I]}e.$ke=w;function $(E,I,j){E[j]=I}e.$le=$;function d(E){return A.$4d(E,I=>u.concat(I))}e.$me=d;function h(E){return A.$$d(E)}e.$ne=h;function k(E){return A.$6d(E,I=>u.concat(I))}e.$oe=k;async function c(E){return E.ended?u.concat(E.buffer):u.concat([...E.buffer,await k(E.stream)])}e.$pe=c;function i(E){return A.$9d(E,I=>u.concat(I))}e.$qe=i;function o(E){return A.$_d(E,{data:I=>typeof I=="string"?u.fromString(I):u.wrap(I)},I=>u.concat(I))}e.$re=o;function r(E){return A.$3d(I=>u.concat(I),E)}e.$se=r;function t(E,I){return A.$ae(E,I,j=>u.concat(j))}e.$te=t;function n(E,I){return A.$be(E,I,j=>u.concat(j))}e.$ue=n;function l(E){let I=0,j=0,U=0;const z=new Uint8Array(Math.floor(E.length/4*3)),X=oe=>{switch(j){case 3:z[U++]=I|oe,j=0;break;case 2:z[U++]=I|oe>>>2,I=oe<<6,j=3;break;case 1:z[U++]=I|oe>>>4,I=oe<<4,j=2;break;default:I=oe<<2,j=1}};for(let oe=0;oe<E.length;oe++){const se=E.charCodeAt(oe);if(se>=65&&se<=90)X(se-65);else if(se>=97&&se<=122)X(se-97+26);else if(se>=48&&se<=57)X(se-48+52);else if(se===43||se===45)X(62);else if(se===47||se===95)X(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${E[oe]}`)}}const x=U;for(;j>0;)X(0);return u.wrap(z).slice(0,x)}e.$ve=l;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:E},I=!0,j=!1){const U=j?O:p;let z="";const X=E.byteLength%3;let x=0;for(;x<E.byteLength-X;x+=3){const oe=E[x+0],se=E[x+1],ce=E[x+2];z+=U[oe>>>2],z+=U[(oe<<4|se>>>4)&63],z+=U[(se<<2|ce>>>6)&63],z+=U[ce&63]}if(X===1){const oe=E[x+0];z+=U[oe>>>2],z+=U[oe<<4&63],I&&(z+="==")}else if(X===2){const oe=E[x+0],se=E[x+1];z+=U[oe>>>2],z+=U[(oe<<4|se>>>4)&63],z+=U[se<<2&63],I&&(z+="=")}return z}e.$we=D}),define(ie[27],ne([0,1,142,71]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yf=e.$xf=e.$wf=e.$vf=e.GraphemeBreakType=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function s(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.$Ce=s;const R=/{(\d+)}/g;function C(ee,...fe){return fe.length===0?ee:ee.replace(R,function($e,ke){const De=parseInt(ke,10);return isNaN(De)||De<0||De>=fe.length?$e:fe[De]})}e.$De=C;const S=/{([^}]+)}/g;function u(ee,fe){return Object.keys(fe).length===0?ee:ee.replace(S,($e,ke)=>fe[ke]??$e)}e.$Ee=u;function a(ee){return ee.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Fe=a;function g(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ge=g;function b(ee,fe){let $e=0;const ke=fe.charCodeAt(0);for(let De=ee.length-1;De>=0;De--)ee.charCodeAt(De)===ke&&$e++;return $e}e.$He=b;function y(ee,fe,$e="\u2026"){return ee.length<=fe?ee:`${ee.substr(0,fe)}${$e}`}e.$Ie=y;function f(ee,fe=" "){const $e=v(ee,fe);return m($e,fe)}e.$Je=f;function v(ee,fe){if(!ee||!fe)return ee;const $e=fe.length;if($e===0||ee.length===0)return ee;let ke=0;for(;ee.indexOf(fe,ke)===ke;)ke=ke+$e;return ee.substring(ke)}e.$Ke=v;function m(ee,fe){if(!ee||!fe)return ee;const $e=fe.length,ke=ee.length;if($e===0||ke===0)return ee;let De=ke,Ne=-1;for(;Ne=ee.lastIndexOf(fe,De-1),!(Ne===-1||Ne+$e!==De);){if(Ne===0)return"";De=Ne}return ee.substring(0,De)}e.$Le=m;function w(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Me=w;function $(ee){return ee.replace(/\*/g,"")}e.$Ne=$;function d(ee,fe,$e={}){if(!ee)throw new Error("Cannot create regex from empty string");fe||(ee=g(ee)),$e.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let ke="";return $e.global&&(ke+="g"),$e.matchCase||(ke+="i"),$e.multiline&&(ke+="m"),$e.unicode&&(ke+="u"),new RegExp(ee,ke)}e.$Oe=d;function h(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.$Pe=h;function k(ee){return ee.split(/\r\n|\r|\n/)}e.$Qe=k;function c(ee){for(let fe=0,$e=ee.length;fe<$e;fe++){const ke=ee.charCodeAt(fe);if(ke!==32&&ke!==9)return fe}return-1}e.$Re=c;function i(ee,fe=0,$e=ee.length){for(let ke=fe;ke<$e;ke++){const De=ee.charCodeAt(ke);if(De!==32&&De!==9)return ee.substring(fe,ke)}return ee.substring(fe,$e)}e.$Se=i;function o(ee,fe=ee.length-1){for(let $e=fe;$e>=0;$e--){const ke=ee.charCodeAt($e);if(ke!==32&&ke!==9)return $e}return-1}e.$Te=o;function r(ee,fe,$e){const ke=[];let De=0;for(const Ne of ee.matchAll(fe)){if(ke.push(ee.slice(De,Ne.index)),Ne.index===void 0)throw new Error("match.index should be defined");De=Ne.index+Ne[0].length,ke.push($e(Ne[0],...Ne.slice(1),Ne.index,ee,Ne.groups))}return ke.push(ee.slice(De)),Promise.all(ke).then(Ne=>Ne.join(""))}e.$Ue=r;function t(ee,fe){return ee<fe?-1:ee>fe?1:0}e.$Ve=t;function n(ee,fe,$e=0,ke=ee.length,De=0,Ne=fe.length){for(;$e<ke&&De<Ne;$e++,De++){const Ve=ee.charCodeAt($e),Ge=fe.charCodeAt(De);if(Ve<Ge)return-1;if(Ve>Ge)return 1}const je=ke-$e,Fe=Ne-De;return je<Fe?-1:je>Fe?1:0}e.$We=n;function l(ee,fe){return p(ee,fe,0,ee.length,0,fe.length)}e.$Xe=l;function p(ee,fe,$e=0,ke=ee.length,De=0,Ne=fe.length){for(;$e<ke&&De<Ne;$e++,De++){let Ve=ee.charCodeAt($e),Ge=fe.charCodeAt(De);if(Ve===Ge)continue;if(Ve>=128||Ge>=128)return n(ee.toLowerCase(),fe.toLowerCase(),$e,ke,De,Ne);D(Ve)&&(Ve-=32),D(Ge)&&(Ge-=32);const Qe=Ve-Ge;if(Qe!==0)return Qe}const je=ke-$e,Fe=Ne-De;return je<Fe?-1:je>Fe?1:0}e.$Ye=p;function O(ee){return ee>=48&&ee<=57}e.$Ze=O;function D(ee){return ee>=97&&ee<=122}e.$1e=D;function E(ee){return ee>=65&&ee<=90}e.$2e=E;function I(ee,fe){return ee.length===fe.length&&p(ee,fe)===0}e.$3e=I;function j(ee,fe){const $e=fe.length;return fe.length>ee.length?!1:p(ee,fe,0,$e)===0}e.$4e=j;function U(ee,fe){const $e=Math.min(ee.length,fe.length);let ke;for(ke=0;ke<$e;ke++)if(ee.charCodeAt(ke)!==fe.charCodeAt(ke))return ke;return $e}e.$5e=U;function z(ee,fe){const $e=Math.min(ee.length,fe.length);let ke;const De=ee.length-1,Ne=fe.length-1;for(ke=0;ke<$e;ke++)if(ee.charCodeAt(De-ke)!==fe.charCodeAt(Ne-ke))return ke;return $e}e.$6e=z;function X(ee){return 55296<=ee&&ee<=56319}e.$7e=X;function x(ee){return 56320<=ee&&ee<=57343}e.$8e=x;function oe(ee,fe){return(ee-55296<<10)+(fe-56320)+65536}e.$9e=oe;function se(ee,fe,$e){const ke=ee.charCodeAt($e);if(X(ke)&&$e+1<fe){const De=ee.charCodeAt($e+1);if(x(De))return oe(ke,De)}return ke}e.$0e=se;function ce(ee,fe){const $e=ee.charCodeAt(fe-1);if(x($e)&&fe>1){const ke=ee.charCodeAt(fe-2);if(X(ke))return oe(ke,$e)}return $e}class Y{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ce(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=se(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$$e=Y;class K{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new Y(fe,$e)}nextGraphemeLength(){const fe=le.getInstance(),$e=this.c,ke=$e.offset;let De=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ne=$e.offset,je=fe.getGraphemeBreakType($e.nextCodePoint());if(we(De,je)){$e.setOffset(Ne);break}De=je}return $e.offset-ke}prevGraphemeLength(){const fe=le.getInstance(),$e=this.c,ke=$e.offset;let De=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ne=$e.offset,je=fe.getGraphemeBreakType($e.prevCodePoint());if(we(je,De)){$e.setOffset(Ne);break}De=je}return ke-$e.offset}eol(){return this.c.eol()}}e.$_e=K;function Q(ee,fe){return new K(ee,fe).nextGraphemeLength()}e.$af=Q;function q(ee,fe){return new K(ee,fe).prevGraphemeLength()}e.$bf=q;function W(ee,fe){fe>0&&x(ee.charCodeAt(fe))&&fe--;const $e=fe+Q(ee,fe);return[$e-q(ee,$e),$e]}e.$cf=W;function G(ee){const fe=new K(ee);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}e.$df=G;let H;function Z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function re(ee){return H||(H=Z()),H.test(ee)}e.$ef=re;const L=/^[\t\n\r\x20-\x7E]*$/;function M(ee){return L.test(ee)}e.$ff=M,e.$gf=/[\u2028\u2029]/;function N(ee){return e.$gf.test(ee)}e.$hf=N;function T(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.$if=T;function F(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.$jf=F;function B(ee,fe){if(ee.length<fe)return ee;const $e=/\b/g;let ke=0;for(;$e.test(ee)&&!(ee.length-$e.lastIndex<fe);)ke=$e.lastIndex,$e.lastIndex+=1;return ee.substring(ke).replace(/^\s/,"")}e.$kf=B;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ae=/\x1b\].*?\x07/g;function de(ee){return ee&&(ee=ee.replace(V,"").replace(ae,"")),ee}e.$lf=de,e.$mf=String.fromCharCode(65279);function ue(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.$nf=ue;function he(ee){return ue(ee)?ee.substr(1):ee}e.$of=he;function ve(ee,fe){if(!ee||!fe||ee.length<fe.length)return!1;const $e=fe.length,ke=ee.toLowerCase();let De=0,Ne=-1;for(;De<$e;){const je=ke.indexOf(fe[De],Ne+1);if(je<0)return!1;Ne=je,De++}return!0}e.$pf=ve;function be(ee,fe=!1){return ee?(fe&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.$qf=be;function ye(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.$rf=ye;function Ie(ee,fe=1){if(fe===0)return"";let $e=-1;do $e=ee.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?ee:(ee[$e-1]==="\r"&&$e--,ee.substr(0,$e))}e.$sf=Ie;function Te(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.$tf=Te;function me(ee){return le.getInstance().getGraphemeBreakType(ee)}e.$uf=me;function we(ee,fe){return ee===0?fe!==5&&fe!==7:ee===2&&fe===3?!1:ee===4||ee===2||ee===3||fe===4||fe===2||fe===3?!0:!(ee===8&&(fe===8||fe===9||fe===11||fe===12)||(ee===11||ee===9)&&(fe===9||fe===10)||(ee===12||ee===10)&&fe===10||fe===5||fe===13||fe===7||ee===1||ee===13&&fe===14||ee===6&&fe===6)}var _;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(_||(e.GraphemeBreakType=_={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=ge()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const $e=this.d,ke=$e.length/3;let De=1;for(;De<=ke;)if(fe<$e[3*De])De=2*De;else if(fe>$e[3*De+1])De=2*De+1;else return $e[3*De+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(ee,fe){if(ee===0)return 0;const $e=Ce(ee,fe);if($e!==void 0)return $e;const ke=new Y(fe,ee);return ke.prevCodePoint(),ke.offset}e.$vf=Oe;function Ce(ee,fe){const $e=new Y(fe,ee);let ke=$e.prevCodePoint();for(;Le(ke)||ke===65039||ke===8419;){if($e.offset===0)return;ke=$e.prevCodePoint()}if(!F(ke))return;let De=$e.offset;return De>0&&$e.prevCodePoint()===8205&&(De=$e.offset),De}function Le(ee){return 127995<=ee&&ee<=127999}var Re;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={})),e.$wf="\xA0";class He{static{this.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$ye(fe=>{function $e(Qe){const Ze=new Map;for(let Xe=0;Xe<Qe.length;Xe+=2)Ze.set(Qe[Xe],Qe[Xe+1]);return Ze}function ke(Qe,Ze){const Xe=new Map(Qe);for(const[it,nt]of Ze)Xe.set(it,nt);return Xe}function De(Qe,Ze){if(!Qe)return Ze;const Xe=new Map;for(const[it,nt]of Qe)Ze.has(it)&&Xe.set(it,nt);return Xe}const Ne=this.c.value;let je=fe.filter(Qe=>!Qe.startsWith("_")&&Qe in Ne);je.length===0&&(je=["_default"]);let Fe;for(const Qe of je){const Ze=$e(Ne[Qe]);Fe=De(Fe,Ze)}const Ve=$e(Ne._common),Ge=ke(Ve,Fe);return new He(Ge)})}static getInstance(fe){return He.d.get(Array.from(fe))}static{this.e=new A.$V(()=>Object.keys(He.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return He.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$xf=He;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(fe){return ze.e().has(fe)}static get codePoints(){return ze.e()}}e.$yf=ze}),define(ie[55],ne([0,1,27]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;function A($){return s($,0)}e.$Ei=A;function s($,d){switch(typeof $){case"object":return $===null?R(349,d):Array.isArray($)?u($,d):a($,d);case"string":return S($,d);case"boolean":return C($,d);case"number":return R($,d);case"undefined":return R(937,d);default:return R(617,d)}}e.$Fi=s;function R($,d){return(d<<5)-d+$|0}e.$Gi=R;function C($,d){return R($?433:863,d)}function S($,d){d=R(149417,d);for(let h=0,k=$.length;h<k;h++)d=R($.charCodeAt(h),d);return d}e.$Hi=S;function u($,d){return d=R(104579,d),$.reduce((h,k)=>s(k,h),d)}function a($,d){return d=R(181387,d),Object.keys($).sort().reduce((h,k)=>(h=S(k,h),s($[k],h)),d)}class g{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=s(d,this.g),this.g}}e.$Ii=g;var b;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function y($,d,h=32){const k=h-d,c=~((1<<k)-1);return($<<d|(c&$)>>>k)>>>0}function f($,d=0,h=$.byteLength,k=0){for(let c=0;c<h;c++)$[d+c]=k}function v($,d,h="0"){for(;$.length<d;)$=h+$;return $}function m($,d=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(h=>h.toString(16).padStart(2,"0")).join(""):v(($>>>0).toString(16),d/4)}e.$Ji=m;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const h=d.length;if(h===0)return;const k=this.p;let c=this.r,i=this.u,o,r;for(i!==0?(o=i,r=-1,i=0):(o=d.charCodeAt(0),r=0);;){let t=o;if(P.$7e(o))if(r+1<h){const n=d.charCodeAt(r+1);P.$8e(n)?(r++,t=P.$9e(o,n)):t=65533}else{i=o;break}else P.$8e(o)&&(t=65533);if(c=this.w(k,c,t),r++,r<h)o=d.charCodeAt(r);else break}this.r=c,this.u=i}w(d,h,k){return k<128?d[h++]=k:k<2048?(d[h++]=192|(k&1984)>>>6,d[h++]=128|(k&63)>>>0):k<65536?(d[h++]=224|(k&61440)>>>12,d[h++]=128|(k&4032)>>>6,d[h++]=128|(k&63)>>>0):(d[h++]=240|(k&1835008)>>>18,d[h++]=128|(k&258048)>>>12,d[h++]=128|(k&4032)>>>6,d[h++]=128|(k&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=w.g,h=this.q;for(let p=0;p<64;p+=4)d.setUint32(p,h.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)d.setUint32(p,y(d.getUint32(p-12,!1)^d.getUint32(p-32,!1)^d.getUint32(p-56,!1)^d.getUint32(p-64,!1),1),!1);let k=this.h,c=this.l,i=this.m,o=this.n,r=this.o,t,n,l;for(let p=0;p<80;p++)p<20?(t=c&i|~c&o,n=1518500249):p<40?(t=c^i^o,n=1859775393):p<60?(t=c&i|c&o|i&o,n=2400959708):(t=c^i^o,n=3395469782),l=y(k,5)+t+r+n+d.getUint32(p*4,!1)&4294967295,r=o,o=i,i=y(c,30),c=k,k=l;this.h=this.h+k&4294967295,this.l=this.l+c&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$Ki=w}),define(ie[73],ne([0,1,27]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(A||(A={})),function(s){const R="error",C="warning",S="warn",u="info",a="ignore";function g(y){return y?P.$3e(R,y)?s.Error:P.$3e(C,y)||P.$3e(S,y)?s.Warning:P.$3e(u,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=g;function b(y){switch(y){case s.Error:return R;case s.Warning:return C;case s.Info:return u;default:return a}}s.toString=b}(A||(A={})),e.default=A}),define(ie[143],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(ie[56],ne([0,1,23,27]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const v=f.charCodeAt(0),m=this.b.charCodeAt(this.c);return v-m}value(){return this.b[this.c]}}e.$Sh=s;class R{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,A.$We)(f,this.b,0,f.length,this.c,this.d):(0,A.$Ye)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Th=R;class C{constructor(f=!0,v=!0){this.f=f,this.g=v}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let v=f.length-1;v>=0;v--,this.c--){const m=this.b.charCodeAt(v);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,A.$We)(f,this.b,0,f.length,this.d,this.e):(0,A.$Ye)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Uh=C;var S;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(S||(S={}));class u{constructor(f,v){this.f=f,this.g=v,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,A.$Xe)(f,this.c.scheme);if(this.d[this.e]===2)return(0,A.$Xe)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,A.$Ve)(f,this.c.query);if(this.d[this.e]===5)return(0,A.$Ve)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Vh=u;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(g||(g={}));class b{static forUris(f=()=>!1,v=()=>!1){return new b(new u(f,v))}static forPaths(f=!1){return new b(new C(void 0,!f))}static forStrings(){return new b(new s)}static forConfigKeys(){return new b(new R)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,v){if(v){const m=v.slice(0);(0,P.$Xb)(m);for(const w of m)this.set(w,f)}else{const m=f.slice(0);(0,P.$Xb)(m);for(const w of m)this.set(w[0],w[1])}}set(f,v){const m=this.b.reset(f);let w;this.c||(this.c=new a,this.c.segment=m.value());const $=[];for(w=this.c;;){const h=m.cmp(w.segment);if(h>0)w.left||(w.left=new a,w.left.segment=m.value()),$.push([-1,w]),w=w.left;else if(h<0)w.right||(w.right=new a,w.right.segment=m.value()),$.push([1,w]),w=w.right;else if(m.hasNext())m.next(),w.mid||(w.mid=new a,w.mid.segment=m.value()),$.push([0,w]),w=w.mid;else break}const d=w.value;w.value=v,w.key=f;for(let h=$.length-1;h>=0;h--){const k=$[h][1];k.updateHeight();const c=k.balanceFactor();if(c<-1||c>1){const i=$[h][0],o=$[h+1][0];if(i===1&&o===1)$[h][1]=k.rotateLeft();else if(i===-1&&o===-1)$[h][1]=k.rotateRight();else if(i===1&&o===-1)k.right=$[h+1][1]=$[h+1][1].rotateRight(),$[h][1]=k.rotateLeft();else if(i===-1&&o===1)k.left=$[h+1][1]=$[h+1][1].rotateLeft(),$[h][1]=k.rotateRight();else throw new Error;if(h>0)switch($[h-1][0]){case-1:$[h-1][1].left=$[h][1];break;case 1:$[h-1][1].right=$[h][1];break;case 0:$[h-1][1].mid=$[h][1];break}else this.c=$[0][1]}}return d}get(f){return this.d(f)?.value}d(f){const v=this.b.reset(f);let m=this.c;for(;m;){const w=v.cmp(m.segment);if(w>0)m=m.left;else if(w<0)m=m.right;else if(v.hasNext())v.next(),m=m.mid;else break}return m}has(f){const v=this.d(f);return!(v?.value===void 0&&v?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,v){const m=this.b.reset(f),w=[];let $=this.c;for(;$;){const d=m.cmp($.segment);if(d>0)w.push([-1,$]),$=$.left;else if(d<0)w.push([1,$]),$=$.right;else if(m.hasNext())m.next(),w.push([0,$]),$=$.mid;else break}if($){if(v?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const d=this.f($.right);if(d.key){const{key:h,value:k,segment:c}=d;this.e(d.key,!1),$.key=h,$.value=k,$.segment=c}}else{const d=$.left??$.right;if(w.length>0){const[h,k]=w[w.length-1];switch(h){case-1:k.left=d;break;case 0:k.mid=d;break;case 1:k.right=d;break}}else this.c=d}for(let d=w.length-1;d>=0;d--){const h=w[d][1];h.updateHeight();const k=h.balanceFactor();if(k>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),w[d][1]=h.rotateLeft()):k<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),w[d][1]=h.rotateRight()),d>0)switch(w[d-1][0]){case-1:w[d-1][1].left=w[d][1];break;case 1:w[d-1][1].right=w[d][1];break;case 0:w[d-1][1].mid=w[d][1];break}else this.c=w[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const v=this.b.reset(f);let m=this.c,w;for(;m;){const $=v.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(v.hasNext())v.next(),w=m.value||w,m=m.mid;else break}return m&&m.value||w}findSuperstr(f){return this.g(f,!1)}g(f,v){const m=this.b.reset(f);let w=this.c;for(;w;){const $=m.cmp(w.segment);if($>0)w=w.left;else if($<0)w=w.right;else if(m.hasNext())m.next(),w=w.mid;else return w.mid?this.h(w.mid):v?w.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[v,m]of this)f(m,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const v=[];return this.j(f,v),v[Symbol.iterator]()}j(f,v){f&&(f.left&&this.j(f.left,v),f.value&&v.push([f.key,f.value]),f.mid&&this.j(f.mid,v),f.right&&this.j(f.right,v))}_isBalanced(){const f=v=>{if(!v)return!0;const m=v.balanceFactor();return m<-1||m>1?!1:f(v.left)&&f(v.right)};return f(this.c)}}e.$Wh=b}),define(ie[12],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=void 0;function P(c){return typeof c=="string"}e.$zf=P;function A(c){return Array.isArray(c)&&c.every(i=>P(i))}e.$Af=A;function s(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Bf=s;function R(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}e.$Cf=R;function C(c){return typeof c=="number"&&!isNaN(c)}e.$Df=C;function S(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Ef=S;function u(c){return c===!0||c===!1}e.$Ff=u;function a(c){return typeof c>"u"}e.$Gf=a;function g(c){return!b(c)}e.$Hf=g;function b(c){return a(c)||c===null}e.$If=b;function y(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$Jf=y;function f(c){if(b(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Kf=f;function v(...c){const i=[];for(let o=0;o<c.length;o++){const r=c[o];if(b(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(r)}return i}e.$Lf=v;const m=Object.prototype.hasOwnProperty;function w(c){if(!s(c))return!1;for(const i in c)if(m.call(c,i))return!1;return!0}e.$Mf=w;function $(c){return typeof c=="function"}e.$Nf=$;function d(...c){return c.length>0&&c.every($)}e.$Of=d;function h(c,i){const o=Math.min(c.length,i.length);for(let r=0;r<o;r++)k(c[r],i[r])}e.$Pf=h;function k(c,i){if(P(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if($(i)){try{if(c instanceof i)return}catch{}if(!b(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Qf=k}),define(ie[74],ne([0,1,12]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=void 0;const A=Object.create(null);function s(S,u){if((0,P.$zf)(u)){const a=A[u];if(a===void 0)throw new Error(`${S} references an unknown codicon: ${u}`);u=a}return A[S]=u,{id:S}}function R(){return A}e.$Tj=R;function C(){return Object.values(e.$Vj)}e.$Uj=C,e.$Vj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ie[37],ne([0,1,12]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=void 0;function A(k){if(!k||typeof k!="object"||k instanceof RegExp)return k;const c=Array.isArray(k)?[]:{};return Object.entries(k).forEach(([i,o])=>{c[i]=o&&typeof o=="object"?A(o):o}),c}e.$8m=A;function s(k){if(!k||typeof k!="object")return k;const c=[k];for(;c.length>0;){const i=c.shift();Object.freeze(i);for(const o in i)if(R.call(i,o)){const r=i[o];typeof r=="object"&&!Object.isFrozen(r)&&!(0,P.$Cf)(r)&&c.push(r)}}return k}e.$9m=s;const R=Object.prototype.hasOwnProperty;function C(k,c){return S(k,c,new Set)}e.$0m=C;function S(k,c,i){if((0,P.$If)(k))return k;const o=c(k);if(typeof o<"u")return o;if(Array.isArray(k)){const r=[];for(const t of k)r.push(S(t,c,i));return r}if((0,P.$Bf)(k)){if(i.has(k))throw new Error("Cannot clone recursive data-structure");i.add(k);const r={};for(const t in k)R.call(k,t)&&(r[t]=S(k[t],c,i));return i.delete(k),r}return k}function u(k,c,i=!0){return(0,P.$Bf)(k)?((0,P.$Bf)(c)&&Object.keys(c).forEach(o=>{o in k?i&&((0,P.$Bf)(k[o])&&(0,P.$Bf)(c[o])?u(k[o],c[o],i):k[o]=c[o]):k[o]=c[o]}),k):c}e.$$m=u;function a(k,c){if(k===c)return!0;if(k==null||c===null||c===void 0||typeof k!=typeof c||typeof k!="object"||Array.isArray(k)!==Array.isArray(c))return!1;let i,o;if(Array.isArray(k)){if(k.length!==c.length)return!1;for(i=0;i<k.length;i++)if(!a(k[i],c[i]))return!1}else{const r=[];for(o in k)r.push(o);r.sort();const t=[];for(o in c)t.push(o);if(t.sort(),!a(r,t))return!1;for(i=0;i<r.length;i++)if(!a(k[r[i]],c[r[i]]))return!1}return!0}e.$_m=a;function g(k){const c=new Set;return JSON.stringify(k,(i,o)=>{if((0,P.$Bf)(o)||Array.isArray(o)){if(c.has(o))return"[Circular]";c.add(o)}return o})}e.$an=g;function b(k,c){const i=Object.create(null);return!k||!c||Object.keys(c).forEach(r=>{const t=k[r],n=c[r];a(t,n)||(i[r]=n)}),i}e.$bn=b;function y(k,c){const i=c.toLowerCase(),o=Object.keys(k).find(r=>r.toLowerCase()===i);return o?k[o]:k[c]}e.$cn=y;function f(k,c){const i=Object.create(null);for(const[o,r]of Object.entries(k))c(o,r)&&(i[o]=r);return i}e.$dn=f;function v(k){let c=[];for(;Object.prototype!==k;)c=c.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return c}e.$en=v;function m(k){const c=[];for(const i of v(k))typeof k[i]=="function"&&c.push(i);return c}e.$fn=m;function w(k,c){const i=r=>function(){const t=Array.prototype.slice.call(arguments,0);return c(r,t)},o={};for(const r of k)o[r]=i(r);return o}e.$gn=w;function $(k,c,i){typeof c=="string"&&k[c]!==void 0&&typeof k[c]!="boolean"&&(k[c]=i)}e.$hn=$;function d(k,c,i){typeof c=="string"&&k[c]!==void 0&&typeof k[c]!="number"&&(k[c]=i)}e.$in=d;function h(k,c,i,o){if(typeof c!="string")return;const r=k[c];r!==void 0&&(typeof r!="string"||!i.includes(r))&&(k[c]=o)}e.$jn=h}),define(ie[102],ne([0,1,74]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Wj=e.ThemeColor=void 0;var A;(function(C){function S(u){return u&&typeof u=="object"&&typeof u.id=="string"}C.isThemeColor=S})(A||(e.ThemeColor=A={}));function s(C){return{id:C}}e.$Wj=s;var R;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function u(d){const h=S.exec(d.id);if(!h)return u(P.$Vj.error);const[,k,c]=h,i=["codicon","codicon-"+k];return c&&i.push("codicon-modifier-"+c.substring(1)),i}C.asClassNameArray=u;function a(d){return u(d).join(" ")}C.asClassName=a;function g(d){return"."+u(d).join(".")}C.asCSSSelector=g;function b(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||A.isThemeColor(d.color))}C.isThemeIcon=b;const y=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function f(d){const h=y.exec(d);if(!h)return;const[,k]=h;return{id:k}}C.fromString=f;function v(d){return{id:d}}C.fromId=v;function m(d,h){let k=d.id;const c=k.lastIndexOf("~");return c!==-1&&(k=k.substring(0,c)),h&&(k=`${k}~${h}`),{id:k}}C.modify=m;function w(d){const h=d.id.lastIndexOf("~");if(h!==-1)return d.id.substring(h+1)}C.getModifier=w;function $(d,h){return d.id===h.id&&d.color?.id===h.color?.id}C.isEqual=$})(R||(e.ThemeIcon=R={}))}),define(ie[32],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(s){return P.test(s)}e.$eg=A,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let u=0;u<S.length;u++)S[u]=Math.floor(Math.random()*256);return S};const R=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));return function(){s(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let u=0,a="";return a+=C[R[u++]],a+=C[R[u++]],a+=C[R[u++]],a+=C[R[u++]],a+="-",a+=C[R[u++]],a+=C[R[u++]],a+="-",a+=C[R[u++]],a+=C[R[u++]],a+="-",a+=C[R[u++]],a+=C[R[u++]],a+="-",a+=C[R[u++]],a+=C[R[u++]],a+=C[R[u++]],a+=C[R[u++]],a+=C[R[u++]],a+=C[R[u++]],a}}()}),define(ie[144],ne([0,1,86,45,84]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rT=void 0;async function R(C,S){if(await new Promise((g,b)=>{const y=A.createReadStream(C),f=P.createHash("sha1");y.pipe(f);const v=(0,s.$db)((m,w)=>{y.removeAllListeners(),f.removeAllListeners(),m?b(m):g(w)});y.once("error",v),y.once("end",v),f.once("error",v),f.once("data",m=>v(void 0,m.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$rT=R}),define(ie[145],ne([0,1,28]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(C){const S=C.replace(/\-/g,":").toLowerCase();return!A.has(S)}function R(){const C=(0,P.networkInterfaces)();for(const S in C){const u=C[S];if(u){for(const{mac:a}of u)if(s(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Rm=R}),define(ie[103],ne([0,1,87]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=e.$ig=e.$hg=void 0;function A(S,u,a,g=1){let b=!1;return new Promise(y=>{const f=setTimeout(()=>{if(!b)return b=!0,y(0)},a);s(S,u,g,v=>{if(!b)return b=!0,clearTimeout(f),y(v)})})}e.$hg=A;function s(S,u,a,g){if(u===0)return g(0);const b=new P.Socket;b.once("connect",()=>(C(b),s(S+a,u-1,a,g))),b.once("data",()=>{}),b.once("error",y=>(C(b),y.code!=="ECONNREFUSED"?s(S+a,u-1,a,g):g(S))),b.connect(S,"127.0.0.1")}e.$ig={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(S,u,a,g="127.0.0.1"){let b=!1,y,f=1;const v=P.createServer({pauseOnConnect:!0});function m(w,$){b||(b=!0,v.removeAllListeners(),v.close(),y&&clearTimeout(y),$(w))}return new Promise(w=>{y=setTimeout(()=>{m(0,w)},a),v.on("listening",()=>{m(S,w)}),v.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&f<u?(S++,f++,v.listen(S,g)):m(0,w)}),v.on("close",()=>{m(0,w)}),v.listen(S,g)})}e.$jg=R;function C(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(u){console.error(u)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function P(u){const a=new Set;if(Array.isArray(u))for(const g of u)typeof g=="string"&&a.add(g);return Array.from(a)}function A(){const u=e();return u?Array.from(u):[]}function s(u){if(process.platform!=="win32")return;const a=e();if(a)if(typeof u=="string")a.add(u.toLowerCase());else for(const g of P(u))s(g)}function R(u){if(typeof u!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const b of a){if(u.indexOf(b)!==0)continue;const f=u.indexOf("\\",b.length);if(f===-1)continue;const v=u.substring(b.length,f);if(v){g=v;break}}return g}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:s,getUNCHost:R,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ie[146],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vT=e.$uT=void 0,e.$uT="vscode:contextmenu",e.$vT="vscode:onCloseContextMenu"}),define(ie[147],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CT=void 0;class P{constructor(s,R){this.a=s,this.onMessage=R}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$CT=P}),define(ie[148],ne([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(ie[149],ne([0,1,148]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=void 0;const A=60,s=A*60,R=s*24,C=R*7,S=R*30,u=R*365;function a(b,y,f,v){typeof b!="number"&&(b=b.getTime());const m=Math.round((new Date().getTime()-b)/1e3);if(m<-30)return(0,P.localize)(0,null,a(new Date().getTime()+m*1e3,!1));if(!v&&m<30)return(0,P.localize)(1,null);let w;return m<A?(w=m,y?w===1?f?(0,P.localize)(2,null,w):(0,P.localize)(3,null,w):f?(0,P.localize)(4,null,w):(0,P.localize)(5,null,w):w===1?f?(0,P.localize)(6,null,w):(0,P.localize)(7,null,w):f?(0,P.localize)(8,null,w):(0,P.localize)(9,null,w)):m<s?(w=Math.floor(m/A),y?w===1?f?(0,P.localize)(10,null,w):(0,P.localize)(11,null,w):f?(0,P.localize)(12,null,w):(0,P.localize)(13,null,w):w===1?f?(0,P.localize)(14,null,w):(0,P.localize)(15,null,w):f?(0,P.localize)(16,null,w):(0,P.localize)(17,null,w)):m<R?(w=Math.floor(m/s),y?w===1?f?(0,P.localize)(18,null,w):(0,P.localize)(19,null,w):f?(0,P.localize)(20,null,w):(0,P.localize)(21,null,w):w===1?f?(0,P.localize)(22,null,w):(0,P.localize)(23,null,w):f?(0,P.localize)(24,null,w):(0,P.localize)(25,null,w)):m<C?(w=Math.floor(m/R),y?w===1?(0,P.localize)(26,null,w):(0,P.localize)(27,null,w):w===1?(0,P.localize)(28,null,w):(0,P.localize)(29,null,w)):m<S?(w=Math.floor(m/C),y?w===1?f?(0,P.localize)(30,null,w):(0,P.localize)(31,null,w):f?(0,P.localize)(32,null,w):(0,P.localize)(33,null,w):w===1?f?(0,P.localize)(34,null,w):(0,P.localize)(35,null,w):f?(0,P.localize)(36,null,w):(0,P.localize)(37,null,w)):m<u?(w=Math.floor(m/S),y?w===1?f?(0,P.localize)(38,null,w):(0,P.localize)(39,null,w):f?(0,P.localize)(40,null,w):(0,P.localize)(41,null,w):w===1?f?(0,P.localize)(42,null,w):(0,P.localize)(43,null,w):f?(0,P.localize)(44,null,w):(0,P.localize)(45,null,w)):(w=Math.floor(m/u),y?w===1?f?(0,P.localize)(46,null,w):(0,P.localize)(47,null,w):f?(0,P.localize)(48,null,w):(0,P.localize)(49,null,w):w===1?f?(0,P.localize)(50,null,w):(0,P.localize)(51,null,w):f?(0,P.localize)(52,null,w):(0,P.localize)(53,null,w))}e.$em=a;function g(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$fm=g}),define(ie[150],ne([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ie[49],ne([0,1,23,12,150]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=void 0;function R(b,y){return y&&(b.stack||b.stacktrace)?s.localize(0,null,S(b),C(b.stack)||C(b.stacktrace)):S(b)}function C(b){return Array.isArray(b)?b.join(`
`):b}function S(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?s.localize(1,null,b.message):b.message||s.localize(2,null)}function u(b=null,y=!1){if(!b)return s.localize(3,null);if(Array.isArray(b)){const f=P.$Hb(b),v=u(f[0],y);return f.length>1?s.localize(4,null,v,f.length):v}if(A.$zf(b))return b;if(b.detail){const f=b.detail;if(f.error)return R(f.error,y);if(f.exception)return R(f.exception,y)}return b.stack?R(b,y):b.message?b.message:s.localize(5,null)}e.$Bi=u;function a(b){const y=b;return y instanceof Error&&Array.isArray(y.actions)}e.$Ci=a;function g(b,y){let f;return typeof b=="string"?f=new Error(b):f=b,f.actions=y,f}e.$Di=g}),define(ie[151],ne([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ie[152],ne([0,1,151]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;function A(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$Ap=A}),define(ie[153],ne([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(ie[4],ne([0,1,153]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let A=!1,s=!1,R=!1,C=!1,S=!1,u=!1,a=!1,g=!1,b=!1,y=!1,f,v=e.$g,m=e.$g,w,$;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?d=e.$h.vscode.process:typeof process<"u"&&(d=process);const h=typeof d?.versions?.electron=="string",k=h&&d?.type==="renderer";if(typeof navigator=="object"&&!k)$=navigator.userAgent,A=$.indexOf("Windows")>=0,s=$.indexOf("Macintosh")>=0,g=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=$.indexOf("Linux")>=0,y=$?.indexOf("Mobi")>=0,u=!0,f=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,v=f,m=navigator.language;else if(typeof d=="object"){A=d.platform==="win32",s=d.platform==="darwin",R=d.platform==="linux",C=R&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,a=h,b=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,v=e.$g;const O=d.env.VSCODE_NLS_CONFIG;if(O)try{const D=JSON.parse(O),E=D.availableLanguages["*"];f=D.locale,m=D.osLocale,v=E||e.$g,w=D._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var c;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(c||(e.Platform=c={}));function i(O){switch(O){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=i;let o=0;s?o=1:A?o=3:R&&(o=2),e.$j=A,e.$k=s,e.$l=R,e.$m=C,e.$n=S,e.$o=a,e.$p=u,e.$q=u&&typeof e.$h.importScripts=="function",e.$r=g,e.$s=y,e.$t=b,e.$u=o,e.$v=$,e.$w=v;var r;(function(O){function D(){return e.$w}O.value=D;function E(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}O.isDefaultVariant=E;function I(){return e.$w==="en"}O.isDefault=I})(r||(e.Language=r={})),e.$x=f,e.$y=m,e.$z=w,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const O=[];e.$h.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let I=0,j=O.length;I<j;I++){const U=O[I];if(U.id===E.data.vscodeScheduleAsyncWork){O.splice(I,1),U.callback();return}}});let D=0;return E=>{const I=++D;O.push({id:I,callback:E}),e.$h.postMessage({vscodeScheduleAsyncWork:I},"*")}}return O=>setTimeout(O)})();var t;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=s||g?2:A?1:3;let n=!0,l=!1;function p(){if(!l){l=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,n=new Uint16Array(O.buffer)[0]===(2<<8)+1}return n}e.$D=p,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ie[35],ne([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let A;if(typeof P.$h.vscode<"u"&&typeof P.$h.vscode.process<"u"){const s=P.$h.vscode.process;A={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return P.$j?"win32":P.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$dc=A.platform,e.$ec=A.arch}),define(ie[9],ne([0,1,35]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const A=65,s=97,R=90,C=122,S=46,u=47,a=92,g=58,b=63;class y extends Error{constructor(o,r,t){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const l=o.indexOf(".")!==-1?"property":"argument";let p=`The "${o}" ${l} ${n} of type ${r}`;p+=`. Received type ${typeof t}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,o){if(i===null||typeof i!="object")throw new y(o,"Object",i)}function v(i,o){if(typeof i!="string")throw new y(o,"string",i)}const m=P.$dc==="win32";function w(i){return i===u||i===a}function $(i){return i===u}function d(i){return i>=A&&i<=R||i>=s&&i<=C}function h(i,o,r,t){let n="",l=0,p=-1,O=0,D=0;for(let E=0;E<=i.length;++E){if(E<i.length)D=i.charCodeAt(E);else{if(t(D))break;D=u}if(t(D)){if(!(p===E-1||O===1))if(O===2){if(n.length<2||l!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const I=n.lastIndexOf(r);I===-1?(n="",l=0):(n=n.slice(0,I),l=n.length-1-n.lastIndexOf(r)),p=E,O=0;continue}else if(n.length!==0){n="",l=0,p=E,O=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",l=2)}else n.length>0?n+=`${r}${i.slice(p+1,E)}`:n=i.slice(p+1,E),l=E-p-1;p=E,O=0}else D===S&&O!==-1?++O:O=-1}return n}function k(i,o){f(o,"pathObject");const r=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${t}`:`${r}${i}${t}`:t}e.$fc={resolve(...i){let o="",r="",t=!1;for(let n=i.length-1;n>=-1;n--){let l;if(n>=0){if(l=i[n],v(l,"path"),l.length===0)continue}else o.length===0?l=P.cwd():(l=P.env[`=${o}`]||P.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===a)&&(l=`${o}\\`));const p=l.length;let O=0,D="",E=!1;const I=l.charCodeAt(0);if(p===1)w(I)&&(O=1,E=!0);else if(w(I))if(E=!0,w(l.charCodeAt(1))){let j=2,U=j;for(;j<p&&!w(l.charCodeAt(j));)j++;if(j<p&&j!==U){const z=l.slice(U,j);for(U=j;j<p&&w(l.charCodeAt(j));)j++;if(j<p&&j!==U){for(U=j;j<p&&!w(l.charCodeAt(j));)j++;(j===p||j!==U)&&(D=`\\\\${z}\\${l.slice(U,j)}`,O=j)}}}else O=1;else d(I)&&l.charCodeAt(1)===g&&(D=l.slice(0,2),O=2,p>2&&w(l.charCodeAt(2))&&(E=!0,O=3));if(D.length>0)if(o.length>0){if(D.toLowerCase()!==o.toLowerCase())continue}else o=D;if(t){if(o.length>0)break}else if(r=`${l.slice(O)}\\${r}`,t=E,E&&o.length>0)break}return r=h(r,!t,"\\",w),t?`${o}\\${r}`:`${o}${r}`||"."},normalize(i){v(i,"path");const o=i.length;if(o===0)return".";let r=0,t,n=!1;const l=i.charCodeAt(0);if(o===1)return $(l)?"\\":i;if(w(l))if(n=!0,w(i.charCodeAt(1))){let O=2,D=O;for(;O<o&&!w(i.charCodeAt(O));)O++;if(O<o&&O!==D){const E=i.slice(D,O);for(D=O;O<o&&w(i.charCodeAt(O));)O++;if(O<o&&O!==D){for(D=O;O<o&&!w(i.charCodeAt(O));)O++;if(O===o)return`\\\\${E}\\${i.slice(D)}\\`;O!==D&&(t=`\\\\${E}\\${i.slice(D,O)}`,r=O)}}}else r=1;else d(l)&&i.charCodeAt(1)===g&&(t=i.slice(0,2),r=2,o>2&&w(i.charCodeAt(2))&&(n=!0,r=3));let p=r<o?h(i.slice(r),!n,"\\",w):"";return p.length===0&&!n&&(p="."),p.length>0&&w(i.charCodeAt(o-1))&&(p+="\\"),t===void 0?n?`\\${p}`:p:n?`${t}\\${p}`:`${t}${p}`},isAbsolute(i){v(i,"path");const o=i.length;if(o===0)return!1;const r=i.charCodeAt(0);return w(r)||o>2&&d(r)&&i.charCodeAt(1)===g&&w(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,r;for(let l=0;l<i.length;++l){const p=i[l];v(p,"path"),p.length>0&&(o===void 0?o=r=p:o+=`\\${p}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof r=="string"&&w(r.charCodeAt(0))){++n;const l=r.length;l>1&&w(r.charCodeAt(1))&&(++n,l>2&&(w(r.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&w(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$fc.normalize(o)},relative(i,o){if(v(i,"from"),v(o,"to"),i===o)return"";const r=e.$fc.resolve(i),t=e.$fc.resolve(o);if(r===t||(i=r.toLowerCase(),o=t.toLowerCase(),i===o))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===a;)n++;let l=i.length;for(;l-1>n&&i.charCodeAt(l-1)===a;)l--;const p=l-n;let O=0;for(;O<o.length&&o.charCodeAt(O)===a;)O++;let D=o.length;for(;D-1>O&&o.charCodeAt(D-1)===a;)D--;const E=D-O,I=p<E?p:E;let j=-1,U=0;for(;U<I;U++){const X=i.charCodeAt(n+U);if(X!==o.charCodeAt(O+U))break;X===a&&(j=U)}if(U!==I){if(j===-1)return t}else{if(E>I){if(o.charCodeAt(O+U)===a)return t.slice(O+U+1);if(U===2)return t.slice(O+U)}p>I&&(i.charCodeAt(n+U)===a?j=U:U===2&&(j=3)),j===-1&&(j=0)}let z="";for(U=n+j+1;U<=l;++U)(U===l||i.charCodeAt(U)===a)&&(z+=z.length===0?"..":"\\..");return O+=j,z.length>0?`${z}${t.slice(O,D)}`:(t.charCodeAt(O)===a&&++O,t.slice(O,D))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$fc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===a){if(o.charCodeAt(1)===a){const r=o.charCodeAt(2);if(r!==b&&r!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===g&&o.charCodeAt(2)===a)return`\\\\?\\${o}`;return i},dirname(i){v(i,"path");const o=i.length;if(o===0)return".";let r=-1,t=0;const n=i.charCodeAt(0);if(o===1)return w(n)?i:".";if(w(n)){if(r=t=1,w(i.charCodeAt(1))){let O=2,D=O;for(;O<o&&!w(i.charCodeAt(O));)O++;if(O<o&&O!==D){for(D=O;O<o&&w(i.charCodeAt(O));)O++;if(O<o&&O!==D){for(D=O;O<o&&!w(i.charCodeAt(O));)O++;if(O===o)return i;O!==D&&(r=t=O+1)}}}}else d(n)&&i.charCodeAt(1)===g&&(r=o>2&&w(i.charCodeAt(2))?3:2,t=r);let l=-1,p=!0;for(let O=o-1;O>=t;--O)if(w(i.charCodeAt(O))){if(!p){l=O;break}}else p=!1;if(l===-1){if(r===-1)return".";l=r}return i.slice(0,l)},basename(i,o){o!==void 0&&v(o,"ext"),v(i,"path");let r=0,t=-1,n=!0,l;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(r=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let p=o.length-1,O=-1;for(l=i.length-1;l>=r;--l){const D=i.charCodeAt(l);if(w(D)){if(!n){r=l+1;break}}else O===-1&&(n=!1,O=l+1),p>=0&&(D===o.charCodeAt(p)?--p===-1&&(t=l):(p=-1,t=O))}return r===t?t=O:t===-1&&(t=i.length),i.slice(r,t)}for(l=i.length-1;l>=r;--l)if(w(i.charCodeAt(l))){if(!n){r=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":i.slice(r,t)},extname(i){v(i,"path");let o=0,r=-1,t=0,n=-1,l=!0,p=0;i.length>=2&&i.charCodeAt(1)===g&&d(i.charCodeAt(0))&&(o=t=2);for(let O=i.length-1;O>=o;--O){const D=i.charCodeAt(O);if(w(D)){if(!l){t=O+1;break}continue}n===-1&&(l=!1,n=O+1),D===S?r===-1?r=O:p!==1&&(p=1):r!==-1&&(p=-1)}return r===-1||n===-1||p===0||p===1&&r===n-1&&r===t+1?"":i.slice(r,n)},format:k.bind(null,"\\"),parse(i){v(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.length;let t=0,n=i.charCodeAt(0);if(r===1)return w(n)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(w(n)){if(t=1,w(i.charCodeAt(1))){let j=2,U=j;for(;j<r&&!w(i.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&w(i.charCodeAt(j));)j++;if(j<r&&j!==U){for(U=j;j<r&&!w(i.charCodeAt(j));)j++;j===r?t=j:j!==U&&(t=j+1)}}}}else if(d(n)&&i.charCodeAt(1)===g){if(r<=2)return o.root=o.dir=i,o;if(t=2,w(i.charCodeAt(2))){if(r===3)return o.root=o.dir=i,o;t=3}}t>0&&(o.root=i.slice(0,t));let l=-1,p=t,O=-1,D=!0,E=i.length-1,I=0;for(;E>=t;--E){if(n=i.charCodeAt(E),w(n)){if(!D){p=E+1;break}continue}O===-1&&(D=!1,O=E+1),n===S?l===-1?l=E:I!==1&&(I=1):l!==-1&&(I=-1)}return O!==-1&&(l===-1||I===0||I===1&&l===O-1&&l===p+1?o.base=o.name=i.slice(p,O):(o.name=i.slice(p,l),o.base=i.slice(p,O),o.ext=i.slice(l,O))),p>0&&p!==t?o.dir=i.slice(0,p-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(m){const i=/\\/g;return()=>{const o=P.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>P.cwd()})();e.$gc={resolve(...i){let o="",r=!1;for(let t=i.length-1;t>=-1&&!r;t--){const n=t>=0?i[t]:c();v(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===u)}return o=h(o,!r,"/",$),r?`/${o}`:o.length>0?o:"."},normalize(i){if(v(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===u,r=i.charCodeAt(i.length-1)===u;return i=h(i,!o,"/",$),i.length===0?o?"/":r?"./":".":(r&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return v(i,"path"),i.length>0&&i.charCodeAt(0)===u},join(...i){if(i.length===0)return".";let o;for(let r=0;r<i.length;++r){const t=i[r];v(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.$gc.normalize(o)},relative(i,o){if(v(i,"from"),v(o,"to"),i===o||(i=e.$gc.resolve(i),o=e.$gc.resolve(o),i===o))return"";const r=1,t=i.length,n=t-r,l=1,p=o.length-l,O=n<p?n:p;let D=-1,E=0;for(;E<O;E++){const j=i.charCodeAt(r+E);if(j!==o.charCodeAt(l+E))break;j===u&&(D=E)}if(E===O)if(p>O){if(o.charCodeAt(l+E)===u)return o.slice(l+E+1);if(E===0)return o.slice(l+E)}else n>O&&(i.charCodeAt(r+E)===u?D=E:E===0&&(D=0));let I="";for(E=r+D+1;E<=t;++E)(E===t||i.charCodeAt(E)===u)&&(I+=I.length===0?"..":"/..");return`${I}${o.slice(l+D)}`},toNamespacedPath(i){return i},dirname(i){if(v(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===u;let r=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===u){if(!t){r=n;break}}else t=!1;return r===-1?o?"/":".":o&&r===1?"//":i.slice(0,r)},basename(i,o){o!==void 0&&v(o,"ext"),v(i,"path");let r=0,t=-1,n=!0,l;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let p=o.length-1,O=-1;for(l=i.length-1;l>=0;--l){const D=i.charCodeAt(l);if(D===u){if(!n){r=l+1;break}}else O===-1&&(n=!1,O=l+1),p>=0&&(D===o.charCodeAt(p)?--p===-1&&(t=l):(p=-1,t=O))}return r===t?t=O:t===-1&&(t=i.length),i.slice(r,t)}for(l=i.length-1;l>=0;--l)if(i.charCodeAt(l)===u){if(!n){r=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":i.slice(r,t)},extname(i){v(i,"path");let o=-1,r=0,t=-1,n=!0,l=0;for(let p=i.length-1;p>=0;--p){const O=i.charCodeAt(p);if(O===u){if(!n){r=p+1;break}continue}t===-1&&(n=!1,t=p+1),O===S?o===-1?o=p:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||t===-1||l===0||l===1&&o===t-1&&o===r+1?"":i.slice(o,t)},format:k.bind(null,"/"),parse(i){v(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.charCodeAt(0)===u;let t;r?(o.root="/",t=1):t=0;let n=-1,l=0,p=-1,O=!0,D=i.length-1,E=0;for(;D>=t;--D){const I=i.charCodeAt(D);if(I===u){if(!O){l=D+1;break}continue}p===-1&&(O=!1,p=D+1),I===S?n===-1?n=D:E!==1&&(E=1):n!==-1&&(E=-1)}if(p!==-1){const I=l===0&&r?1:l;n===-1||E===0||E===1&&n===p-1&&n===l+1?o.base=o.name=i.slice(I,p):(o.name=i.slice(I,n),o.base=i.slice(I,p),o.ext=i.slice(n,p))}return l>0?o.dir=i.slice(0,l-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=m?e.$fc.normalize:e.$gc.normalize,e.$ic=m?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=m?e.$fc.join:e.$gc.join,e.$kc=m?e.$fc.resolve:e.$gc.resolve,e.$lc=m?e.$fc.relative:e.$gc.relative,e.$mc=m?e.$fc.dirname:e.$gc.dirname,e.$nc=m?e.$fc.basename:e.$gc.basename,e.$oc=m?e.$fc.extname:e.$gc.extname,e.$pc=m?e.$fc.format:e.$gc.format,e.$qc=m?e.$fc.parse:e.$gc.parse,e.$rc=m?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=m?e.$fc.sep:e.$gc.sep,e.$tc=m?e.$fc.delimiter:e.$gc.delimiter}),define(ie[33],ne([0,1,9,4,27,12]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function C(l){return l===47||l===92}e.$Rf=C;function S(l){return l.replace(/[\\/]/g,P.$gc.sep)}e.$Sf=S;function u(l){return l.indexOf("/")===-1&&(l=S(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Tf=u;function a(l,p=P.$gc.sep){if(!l)return"";const O=l.length,D=l.charCodeAt(0);if(C(D)){if(C(l.charCodeAt(1))&&!C(l.charCodeAt(2))){let I=3;const j=I;for(;I<O&&!C(l.charCodeAt(I));I++);if(j!==I&&!C(l.charCodeAt(I+1))){for(I+=1;I<O;I++)if(C(l.charCodeAt(I)))return l.slice(0,I+1).replace(/[\\/]/g,p)}}return p}else if($(D)&&l.charCodeAt(1)===58)return C(l.charCodeAt(2))?l.slice(0,2)+p:l.slice(0,2);let E=l.indexOf("://");if(E!==-1){for(E+=3;E<O;E++)if(C(l.charCodeAt(E)))return l.slice(0,E+1)}return""}e.$Uf=a;function g(l){if(!A.$j||!l||l.length<5)return!1;let p=l.charCodeAt(0);if(p!==92||(p=l.charCodeAt(1),p!==92))return!1;let O=2;const D=O;for(;O<l.length&&(p=l.charCodeAt(O),p!==92);O++);return!(D===O||(p=l.charCodeAt(O+1),isNaN(p)||p===92))}e.$Vf=g;const b=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(l,p=A.$j){const O=p?b:y;return!(!l||l.length===0||/^\s+$/.test(l)||(O.lastIndex=0,O.test(l))||p&&f.test(l)||l==="."||l===".."||p&&l[l.length-1]==="."||p&&l.length!==l.trim().length||l.length>255)}e.$Wf=v;function m(l,p,O){const D=l===p;return!O||D?D:!l||!p?!1:(0,s.$3e)(l,p)}e.$Xf=m;function w(l,p,O,D=P.sep){if(l===p)return!0;if(!l||!p||p.length>l.length)return!1;if(O){if(!(0,s.$4e)(l,p))return!1;if(p.length===l.length)return!0;let I=p.length;return p.charAt(p.length-1)===D&&I--,l.charAt(I)===D}return p.charAt(p.length-1)!==D&&(p+=D),l.indexOf(p)===0}e.$Yf=w;function $(l){return l>=65&&l<=90||l>=97&&l<=122}e.$Zf=$;function d(l,p){return A.$j&&l.endsWith(":")&&(l+=P.sep),(0,P.$ic)(l)||(l=(0,P.$jc)(p,l)),l=(0,P.$hc)(l),A.$j?(l=(0,s.$Le)(l,P.sep),l.endsWith(":")&&(l+=P.sep)):(l=(0,s.$Le)(l,P.sep),l||(l=P.sep)),l}e.$1f=d;function h(l){const p=(0,P.$hc)(l);return A.$j?l.length>3?!1:k(p)&&(l.length===2||p.charCodeAt(2)===92):p===P.$gc.sep}e.$2f=h;function k(l,p=A.$j){return p?$(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$3f=k;function c(l,p=A.$j){return k(l,p)?l[0]:void 0}e.$4f=c;function i(l,p,O){return p.length>l.length?-1:l===p?0:(O&&(l=l.toLowerCase(),p=p.toLowerCase()),l.indexOf(p))}e.$5f=i;function o(l){const p=l.split(":");let O,D,E;for(const I of p){const j=Number(I);(0,R.$Df)(j)?D===void 0?D=j:E===void 0&&(E=j):O=O?[O,I].join(":"):I}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:D!==void 0?D:void 0,column:E!==void 0?E:D!==void 0?1:void 0}}e.$6f=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(l,p,O=8){let D="";for(let I=0;I<O;I++){let j;I===0&&A.$j&&!p&&(O===3||O===4)?j=t:j=r,D+=j.charAt(Math.floor(Math.random()*j.length))}let E;return p?E=`${p}-${D}`:E=D,l?(0,P.$jc)(l,E):E}e.$7f=n}),define(ie[75],ne([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.TerminateResponseCode=e.Source=void 0;var A;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(A||(e.Source=A={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function R(S,...u){const a=u.reduce((y,f)=>(y[f]=!0,y),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(y=>!a[y]).forEach(y=>{for(let f=0;f<g.length;f++)if(y.search(g[f])!==-1){delete S[y];break}})}e.$Al=R;function C(S){S&&(delete S.DEBUG,P.$k&&delete S.DYLD_LIBRARY_PATH,P.$l&&delete S.LD_PRELOAD)}e.$Bl=C}),define(ie[7],ne([0,1,9,4]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,R=/^\//,C=/^\/\//;function S(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!s.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!R.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(t,n){return!t&&!n?"file":t}function a(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const g="",b="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,l,p,O,D,E=!1){typeof n=="object"?(this.scheme=n.scheme||g,this.authority=n.authority||g,this.path=n.path||g,this.query=n.query||g,this.fragment=n.fragment||g):(this.scheme=u(n,E),this.authority=l||g,this.path=a(this.scheme,p||g),this.query=O||g,this.fragment=D||g,S(this,E))}get fsPath(){return k(this,!1)}with(n){if(!n)return this;let{scheme:l,authority:p,path:O,query:D,fragment:E}=n;return l===void 0?l=this.scheme:l===null&&(l=g),p===void 0?p=this.authority:p===null&&(p=g),O===void 0?O=this.path:O===null&&(O=g),D===void 0?D=this.query:D===null&&(D=g),E===void 0?E=this.fragment:E===null&&(E=g),l===this.scheme&&p===this.authority&&O===this.path&&D===this.query&&E===this.fragment?this:new w(l,p,O,D,E)}static parse(n,l=!1){const p=y.exec(n);return p?new w(p[2]||g,r(p[4]||g),r(p[5]||g),r(p[7]||g),r(p[9]||g),l):new w(g,g,g,g,g)}static file(n){let l=g;if(A.$j&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const p=n.indexOf(b,2);p===-1?(l=n.substring(2),n=b):(l=n.substring(2,p),n=n.substring(p)||b)}return new w("file",l,n,g,g)}static from(n,l){return new w(n.scheme,n.authority,n.path,n.query,n.fragment,l)}static joinPath(n,...l){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return A.$j&&n.scheme==="file"?p=f.file(P.$fc.join(k(n,!0),...l)).path:p=P.$gc.join(n.path,...l),n.with({path:p})}toString(n=!1){return c(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const l=new w(n);return l._formatted=n.external??null,l._fsPath=n._sep===m?n.fsPath??null:null,l}}else return n}}e.URI=f;function v(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$vc=v;const m=A.$j?1:void 0;class w extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(n=!1){return n?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(t,n,l){let p,O=-1;for(let D=0;D<t.length;D++){const E=t.charCodeAt(D);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||l&&E===91||l&&E===93||l&&E===58)O!==-1&&(p+=encodeURIComponent(t.substring(O,D)),O=-1),p!==void 0&&(p+=t.charAt(D));else{p===void 0&&(p=t.substr(0,D));const I=$[E];I!==void 0?(O!==-1&&(p+=encodeURIComponent(t.substring(O,D)),O=-1),p+=I):O===-1&&(O=D)}}return O!==-1&&(p+=encodeURIComponent(t.substring(O))),p!==void 0?p:t}function h(t){let n;for(let l=0;l<t.length;l++){const p=t.charCodeAt(l);p===35||p===63?(n===void 0&&(n=t.substr(0,l)),n+=$[p]):n!==void 0&&(n+=t[l])}return n!==void 0?n:t}function k(t,n){let l;return t.authority&&t.path.length>1&&t.scheme==="file"?l=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?l=t.path.substr(1):l=t.path[1].toLowerCase()+t.path.substr(2):l=t.path,A.$j&&(l=l.replace(/\//g,"\\")),l}e.$wc=k;function c(t,n){const l=n?h:d;let p="",{scheme:O,authority:D,path:E,query:I,fragment:j}=t;if(O&&(p+=O,p+=":"),(D||O==="file")&&(p+=b,p+=b),D){let U=D.indexOf("@");if(U!==-1){const z=D.substr(0,U);D=D.substr(U+1),U=z.lastIndexOf(":"),U===-1?p+=l(z,!1,!1):(p+=l(z.substr(0,U),!1,!1),p+=":",p+=l(z.substr(U+1),!1,!0)),p+="@"}D=D.toLowerCase(),U=D.lastIndexOf(":"),U===-1?p+=l(D,!1,!0):(p+=l(D.substr(0,U),!1,!0),p+=D.substr(U))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const U=E.charCodeAt(1);U>=65&&U<=90&&(E=`/${String.fromCharCode(U+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const U=E.charCodeAt(0);U>=65&&U<=90&&(E=`${String.fromCharCode(U+32)}:${E.substr(2)}`)}p+=l(E,!0,!1)}return I&&(p+="?",p+=l(I,!1,!1)),j&&(p+="#",p+=n?j:d(j,!1,!1)),p}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(o)?t.replace(o,n=>i(n)):t}}),define(ie[154],ne([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$4p=e.$3p=e.$2p=void 0;function A(a){const g=a;return g&&typeof g.type=="string"&&typeof g.severity=="string"}e.$2p=A;function s(a){const g=[];let b;try{const y=JSON.parse(a.arguments),f=y[y.length-1];f&&f.__$stack&&(y.pop(),b=f.__$stack),g.push(...y)}catch{g.push("Unable to log remote console arguments",a.arguments)}return{args:g,stack:b}}e.$3p=s;function R(a){if(typeof a!="string")return R(s(a).stack);const g=a;if(g){const b=C(g),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(y&&y.length===4)return{uri:P.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$4p=R;function C(a){if(!a)return a;const g=a.indexOf(`
`);return g===-1?a:a.substring(0,g)}function S(a,g){const{args:b,stack:y}=s(a),f=typeof b[0]=="string"&&b.length===1;let v=C(y);v&&(v=`(${v.trim()})`);let m=[];if(typeof b[0]=="string"?v&&f?m=[`%c[${g}] %c${b[0]} %c${v}`,u("blue"),u(""),u("grey")]:m=[`%c[${g}] %c${b[0]}`,u("blue"),u(""),...b.slice(1)]:m=[`%c[${g}]%`,u("blue"),...b],v&&!f&&m.push(v),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,m)}e.log=S;function u(a){return`color: ${a}`}}),define(ie[76],ne([0,1,17,7]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function s(u){return JSON.stringify(u,C)}e.$lh=s;function R(u){let a=JSON.parse(u);return a=S(a),a}e.$mh=R;function C(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function S(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return A.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof P.$ce||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let g=0;g<u.length;++g)u[g]=S(u[g],a+1);else for(const g in u)Object.hasOwnProperty.call(u,g)&&(u[g]=S(u[g],a+1))}return u}e.$nh=S}),define(ie[13],ne([0,1,14,4,7]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var R;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$8f="vscode-tkn",e.$9f="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g){this.f=`${g}/${R.vscodeRemoteResource}`}set(g,b,y){this.a[g]=b,this.b[g]=y}setConnectionToken(g,b){this.c[g]=b}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(w){return P.$1(w),g}const b=g.authority;let y=this.a[b];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const f=this.b[b],v=this.c[b];let m=`path=${encodeURIComponent(g.path)}`;return typeof v=="string"&&(m+=`&${e.$9f}=${encodeURIComponent(v)}`),s.URI.from({scheme:A.$p?this.d:R.vscodeRemoteResource,authority:`${y}:${f}`,path:this.f,query:m})}}e.$0f=new C,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class S{static{this.a=e.$cg}asBrowserUri(g){const b=this.b(g,J);return this.uriToBrowserUri(b)}uriToBrowserUri(g){return g.scheme===R.vscodeRemote?e.$0f.rewrite(g):g.scheme===R.file&&(A.$n||A.$q&&A.$h.origin===`${R.vscodeFileResource}://${S.a}`)?g.with({scheme:R.vscodeFileResource,authority:g.authority||S.a,query:null,fragment:null}):g}asFileUri(g){const b=this.b(g,J);return this.uriToFileUri(b)}uriToFileUri(g){return g.scheme===R.vscodeFileResource?g.with({scheme:R.file,authority:g.authority!==S.a?g.authority:null,query:null,fragment:null}):g}b(g,b){return s.URI.isUri(g)?g:s.URI.parse(b.toUrl(g))}}e.$dg=new S;var u;(function(a){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(g.get("3"));const b="vscode-coi";function y(v){let m;typeof v=="string"?m=new URL(v).searchParams:v instanceof URL?m=v.searchParams:s.URI.isUri(v)&&(m=new URL(v.toString(!0)).searchParams);const w=m?.get(b);if(w)return g.get(w)}a.getHeadersFromQuery=y;function f(v,m,w){if(!globalThis.crossOriginIsolated)return;const $=m&&w?"3":w?"2":"1";v instanceof URLSearchParams?v.set(b,$):v[b]=$}a.addSearchParam=f})(u||(e.COI=u={}))}),define(ie[19],ne([0,1,33,13,9,4,27,7]),function(J,e,P,A,s,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function u(f){return(0,S.$wc)(f,!0)}e.$kg=u;class a{constructor(v){this.a=v}compare(v,m,w=!1){return v===m?0:(0,C.$Ve)(this.getComparisonKey(v,w),this.getComparisonKey(m,w))}isEqual(v,m,w=!1){return v===m?!0:!v||!m?!1:this.getComparisonKey(v,w)===this.getComparisonKey(m,w)}getComparisonKey(v,m=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,m,w=!1){if(v.scheme===m.scheme){if(v.scheme===A.Schemas.file)return P.$Yf(u(v),u(m),this.a(v))&&v.query===m.query&&(w||v.fragment===m.fragment);if((0,e.$Bg)(v.authority,m.authority))return P.$Yf(v.path,m.path,this.a(v),"/")&&v.query===m.query&&(w||v.fragment===m.fragment)}return!1}joinPath(v,...m){return S.URI.joinPath(v,...m)}basenameOrAuthority(v){return(0,e.$tg)(v)||v.authority}basename(v){return s.$gc.basename(v.path)}extname(v){return s.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let m;return v.scheme===A.Schemas.file?m=S.URI.file(s.$mc(u(v))).path:(m=s.$gc.dirname(v.path),v.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),m="/")),v.with({path:m})}normalizePath(v){if(!v.path.length)return v;let m;return v.scheme===A.Schemas.file?m=S.URI.file(s.$hc(u(v))).path:m=s.$gc.normalize(v.path),v.with({path:m})}relativePath(v,m){if(v.scheme!==m.scheme||!(0,e.$Bg)(v.authority,m.authority))return;if(v.scheme===A.Schemas.file){const d=s.$lc(u(v),u(m));return R.$j?P.$Sf(d):d}let w=v.path||"/";const $=m.path||"/";if(this.a(v)){let d=0;for(const h=Math.min(w.length,$.length);d<h&&!(w.charCodeAt(d)!==$.charCodeAt(d)&&w.charAt(d).toLowerCase()!==$.charAt(d).toLowerCase());d++);w=$.substr(0,d)+w.substr(d)}return s.$gc.relative(w,$)}resolvePath(v,m){if(v.scheme===A.Schemas.file){const w=S.URI.file(s.$kc(u(v),m));return v.with({authority:w.authority,path:w.path})}return m=P.$Tf(m),v.with({path:s.$gc.resolve(v.path,m)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,m){return v===m||v!==void 0&&m!==void 0&&(0,C.$3e)(v,m)}hasTrailingPathSeparator(v,m=s.sep){if(v.scheme===A.Schemas.file){const w=u(v);return w.length>P.$Uf(w).length&&w[w.length-1]===m}else{const w=v.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,m=s.sep){return(0,e.$Cg)(v,m)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,m=s.sep){let w=!1;if(v.scheme===A.Schemas.file){const $=u(v);w=$!==void 0&&$.length===P.$Uf($).length&&$[$.length-1]===m}else{m="/";const $=v.path;w=$.length===1&&$.charCodeAt($.length-1)===47}return!w&&!(0,e.$Cg)(v,m)?v.with({path:v.path+"/"}):v}}e.$lg=a,e.$mg=new a(()=>!1),e.$ng=new a(f=>f.scheme===A.Schemas.file?!R.$l:!0),e.$og=new a(f=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function g(f,v){const m=[];for(let w=0;w<f.length;w++){const $=v(f[w]);f.some((d,h)=>h===w?!1:(0,e.$qg)($,v(d)))||m.push(f[w])}return m}e.$Fg=g;var b;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function v(m){const w=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(h=>{const[k,c]=h.split(":");k&&c&&w.set(k,c)});const d=m.path.substring(0,m.path.indexOf(";"));return d&&w.set(f.META_DATA_MIME,d),w}f.parseMetaData=v})(b||(e.DataUri=b={}));function y(f,v,m){if(v){let w=f.path;return w&&w[0]!==s.$gc.sep&&(w=s.$gc.sep+w),f.with({scheme:m,authority:v,path:w})}return f.with({scheme:m})}e.$Gg=y}),define(ie[8],ne([0,1,22,14,3,2,19,4,143]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.Promises=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function a(N){return!!N&&typeof N.then=="function"}e.$Hg=a;function g(N){const T=new P.$Yd,F=N(T.token),B=new Promise((V,ae)=>{const de=T.token.onCancellationRequested(()=>{de.dispose(),T.dispose(),ae(new A.$5)});Promise.resolve(F).then(ue=>{de.dispose(),T.dispose(),V(ue)},ue=>{de.dispose(),T.dispose(),ae(ue)})});return new class{cancel(){T.cancel()}then(V,ae){return B.then(V,ae)}catch(V){return this.then(void 0,V)}finally(V){return B.finally(V)}}}e.$Ig=g;function b(N,T,F){return new Promise((B,V)=>{const ae=T.onCancellationRequested(()=>{ae.dispose(),B(F)});N.then(B,V).finally(()=>ae.dispose())})}e.$Jg=b;function y(N,T){return new Promise((F,B)=>{const V=T.onCancellationRequested(()=>{V.dispose(),B(new A.$5)});N.then(F,B).finally(()=>V.dispose())})}e.$Kg=y;async function f(N){let T=-1;const F=N.map((B,V)=>B.then(ae=>(T=V,ae)));try{return await Promise.race(F)}finally{N.forEach((B,V)=>{V!==T&&B.cancel()})}}e.$Lg=f;function v(N,T,F){let B;const V=setTimeout(()=>{B?.(void 0),F?.()},T);return Promise.race([N.finally(()=>clearTimeout(V)),new Promise(ae=>B=ae)])}e.$Mg=v;function m(N){return new Promise((T,F)=>{const B=N();a(B)?B.then(T,F):T(B)})}e.$Ng=m;class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(T){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=T,!this.b){const F=()=>{if(this.b=null,this.f)return;const B=this.queue(this.d);return this.d=null,B};this.b=new Promise(B=>{this.a.then(F,F).then(B)})}return new Promise((F,B)=>{this.b.then(F,B)})}return this.a=T(),new Promise((F,B)=>{this.a.then(V=>{this.a=null,F(V)},V=>{this.a=null,B(V)})})}dispose(){this.f=!0}}e.$Og=w;class ${constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.$Pg=$;class d{constructor(){this.a=new Map}queue(T,F){const V=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(T)===V&&this.a.delete(T)});return this.a.set(T,V),V}}e.$Qg=d;const h=(N,T)=>{let F=!0;const B=setTimeout(()=>{F=!1,T()},N);return{isTriggered:()=>F,dispose:()=>{clearTimeout(B),F=!1}}},k=N=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,N())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class c{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,F=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((V,ae)=>{this.d=V,this.f=ae}).then(()=>{if(this.b=null,this.d=null,this.g){const V=this.g;return this.g=null,V()}}));const B=()=>{this.a=null,this.d?.(null)};return this.a=F===u.$Ld?k(B):h(F,B),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=c;class i{constructor(T){this.a=new c(T),this.b=new w}trigger(T,F){return this.a.trigger(()=>this.b.queue(T),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=i;class o{constructor(){this.a=!1,this.b=new Promise((T,F)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=o;class r extends o{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.$Ug=r;function t(N,T){return T?new Promise((F,B)=>{const V=setTimeout(()=>{ae.dispose(),F()},N),ae=T.onCancellationRequested(()=>{clearTimeout(V),ae.dispose(),B(new A.$5)})}):g(F=>t(N,F))}e.$Vg=t;function n(N,T=0,F){const B=setTimeout(()=>{N(),F&&V.dispose()},T),V=(0,R.$Qc)(()=>{clearTimeout(B),F?.deleteAndLeak(V)});return F?.add(V),V}e.$Wg=n;function l(N){const T=[];let F=0;const B=N.length;function V(){return F<B?N[F++]():null}function ae(de){de!=null&&T.push(de);const ue=V();return ue?ue.then(ae):Promise.resolve(T)}return Promise.resolve(null).then(ae)}e.$Xg=l;function p(N,T=B=>!!B,F=null){let B=0;const V=N.length,ae=()=>{if(B>=V)return Promise.resolve(F);const de=N[B++];return Promise.resolve(de()).then(he=>T(he)?Promise.resolve(he):ae())};return ae()}e.$Yg=p;function O(N,T=B=>!!B,F=null){if(N.length===0)return Promise.resolve(F);let B=N.length;const V=()=>{B=-1;for(const ae of N)ae.cancel?.()};return new Promise((ae,de)=>{for(const ue of N)ue.then(he=>{--B>=0&&T(he)?(V(),ae(he)):B===0&&ae(F)}).catch(he=>{--B>=0&&(V(),de(he))})})}e.$Zg=O;class D{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new s.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((F,B)=>{this.f.push({factory:T,c:F,e:B}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const F=T.factory();F.then(T.c,T.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=D;class E extends D{constructor(){super(1)}}e.$2g=E;class I{constructor(){this.a=new K,this.b=0}queue(T){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,T())):this.a.run(this.b++,T())}}e.$3g=I;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const T=new W;return this.b.add(T),T.p}g(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,F=C.$mg){const B=F.getComparisonKey(T);let V=this.a.get(B);if(!V){V=new E;const ae=this.f++,de=s.Event.once(V.onDrained)(()=>{V?.dispose(),this.a.delete(B),this.h(),this.d?.deleteAndDispose(ae),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$1c),this.d.set(ae,de),this.a.set(B,V)}return V}h(){this.g()&&this.j()}j(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=j;class U{constructor(T,F){this.a=-1,typeof T=="function"&&typeof F=="number"&&this.setIfNotSet(T,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},F)}setIfNotSet(T,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},F))}}e.$5g=U;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,F){this.cancel(),this.a=setInterval(()=>{T()},F)}}e.$6g=z;class X{constructor(T,F){this.b=-1,this.a=T,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=X;class x{constructor(T,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=T,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=x;class oe extends X{constructor(T,F){super(T,F),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.$9g=oe;class se extends R.$Sc{constructor(T,F){super(),this.g=T,this.h=F,this.a=[],this.b=this.B(new R.$Tc),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of T)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$$g=N=>{(0,S.$B)(()=>{if(T)return;const F=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.$$g=(N,T)=>{const F=requestIdleCallback(N,typeof T=="number"?{timeout:T}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(F))}}}}();class ce{constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$_g=ce;async function Y(N,T,F){let B;for(let V=0;V<F;V++)try{return await N()}catch(ae){B=ae,await t(T)}throw B}e.$ah=Y;class K{isRunning(T){return typeof T=="number"?this.a?.taskId===T:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(T,F,B){return this.a={taskId:T,cancel:()=>B?.(),promise:F},F.then(()=>this.d(T),()=>this.d(T)),F}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this.b)this.b.run=T;else{let F,B;const V=new Promise((ae,de)=>{F=ae,B=de});this.b={run:T,promise:V,promiseResolve:F,promiseReject:B}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$bh=K;class Q{constructor(T,F=()=>Date.now()){this.d=T,this.f=F,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.$ch=Q;var q;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(q||(q={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((T,F)=>{this.a=T,this.b=F})}complete(T){return new Promise(F=>{this.a(T),this.d={outcome:0,value:T},F()})}error(T){return new Promise(F=>{this.b(T),this.d={outcome:1,value:T},F()})}cancel(){return this.error(new A.$5)}}e.$dh=W;var G;(function(N){async function T(B){let V;const ae=await Promise.all(B.map(de=>de.then(ue=>ue,ue=>{V||(V=ue)})));if(typeof V<"u")throw V;return ae}N.settled=T;function F(B){return new Promise(async(V,ae)=>{try{await B(V,ae)}catch(de){ae(de)}})}N.withAsyncBody=F})(G||(e.Promises=G={}));var H;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(H||(H={}));class Z{static fromArray(T){return new Z(F=>{F.emitMany(T)})}static fromPromise(T){return new Z(async F=>{F.emitMany(await T)})}static fromPromises(T){return new Z(async F=>{await Promise.all(T.map(async B=>F.emitOne(await B)))})}static merge(T){return new Z(async F=>{await Promise.all(T.map(async B=>{for await(const V of B)F.emitOne(V)}))})}static{this.EMPTY=Z.fromArray([])}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new s.$Od,queueMicrotask(async()=>{const F={emitOne:B=>this.g(B),emitMany:B=>this.h(B),reject:B=>this.k(B)};try{await Promise.resolve(T(F)),this.j()}catch(B){this.k(B)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(T,F){return new Z(async B=>{for await(const V of T)B.emitOne(F(V))})}map(T){return Z.map(this,T)}static filter(T,F){return new Z(async B=>{for await(const V of T)F(V)&&B.emitOne(V)})}filter(T){return Z.filter(this,T)}static coalesce(T){return Z.filter(T,F=>!!F)}coalesce(){return Z.coalesce(this)}static async toPromise(T){const F=[];for await(const B of T)F.push(B);return F}toPromise(){return Z.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.$eh=Z;class re extends Z{constructor(T,F){super(F),this.l=T}cancel(){this.l.cancel()}}e.$fh=re;function L(N){const T=new P.$Yd,F=N(T.token);return new re(T,async B=>{const V=T.token.onCancellationRequested(()=>{V.dispose(),T.dispose(),B.reject(new A.$5)});try{for await(const ae of F){if(T.token.isCancellationRequested)return;B.emitOne(ae)}V.dispose(),T.dispose()}catch(ae){V.dispose(),T.dispose(),B.reject(ae)}})}e.$gh=L;class M{constructor(){this.a=new W,this.b=new Z(B=>{if(T){B.reject(T);return}return F&&B.emitMany(F),this.d=V=>B.reject(V),this.f=V=>B.emitOne(V),this.a.p});let T,F;this.f=B=>{F||(F=[]),F.push(B)},this.d=B=>{T||(T=B)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(T){this.d(T),this.a.complete()}emitOne(T){this.f(T)}}e.$hh=M}),define(ie[104],ne([0,1,23,8,33,31,9,4,27]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=void 0;function a(){return Object.create(null)}e.$sj=a,e.$tj="**",e.$uj="/";const g="[/\\\\]",b="[^/\\\\]",y=/\//g;function f(K,Q){switch(K){case 0:return"";case 1:return`${b}*?`;default:return`(?:${g}|${b}+${g}${Q?`|${g}${b}+`:""})*?`}}function v(K,Q){if(!K)return[];const q=[];let W=!1,G=!1,H="";for(const Z of K){switch(Z){case Q:if(!W&&!G){q.push(H),H="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":G=!0;break;case"]":G=!1;break}H+=Z}return H&&q.push(H),q}e.$vj=v;function m(K){if(!K)return"";let Q="";const q=v(K,e.$uj);if(q.every(W=>W===e.$tj))Q=".*";else{let W=!1;q.forEach((G,H)=>{if(G===e.$tj){if(W)return;Q+=f(2,H===q.length-1)}else{let Z=!1,re="",L=!1,M="";for(const N of G){if(N!=="}"&&Z){re+=N;continue}if(L&&(N!=="]"||!M)){let T;N==="-"?T=N:(N==="^"||N==="!")&&!M?T="^":N===e.$uj?T="":T=(0,u.$Ge)(N),M+=T;continue}switch(N){case"{":Z=!0;continue;case"[":L=!0;continue;case"}":{const F=`(?:${v(re,",").map(B=>m(B)).join("|")})`;Q+=F,Z=!1,re="";break}case"]":{Q+="["+M+"]",L=!1,M="";break}case"?":Q+=b;continue;case"*":Q+=f(1);continue;default:Q+=(0,u.$Ge)(N)}}H<q.length-1&&(q[H+1]!==e.$tj||H+2<q.length)&&(Q+=g)}W=G===e.$tj})}return Q}const w=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.$Dc(1e4),o=function(){return!1},r=function(){return null};function t(K,Q){if(!K)return r;let q;typeof K!="string"?q=K.pattern:q=K,q=q.trim();const W=`${q}_${!!Q.trimForExclusions}`;let G=i.get(W);if(G)return n(G,K);let H;return w.test(q)?G=p(q.substr(4),q):(H=$.exec(l(q,Q)))?G=O(H[1],q):(Q.trimForExclusions?h:d).test(q)?G=D(q,Q):(H=k.exec(l(q,Q)))?G=E(H[1].substr(1),q,!0):(H=c.exec(l(q,Q)))?G=E(H[1],q,!1):G=I(q),i.set(W,G),n(G,K)}function n(K,Q){if(typeof Q=="string")return K;const q=function(W,G){return(0,s.$Yf)(W,Q.base,!S.$l)?K((0,u.$Ke)(W.substr(Q.base.length),C.sep),G):null};return q.allBasenames=K.allBasenames,q.allPaths=K.allPaths,q.basenames=K.basenames,q.patterns=K.patterns,q}function l(K,Q){return Q.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function p(K,Q){return function(q,W){return typeof q=="string"&&q.endsWith(K)?Q:null}}function O(K,Q){const q=`/${K}`,W=`\\${K}`,G=function(Z,re){return typeof Z!="string"?null:re?re===K?Q:null:Z===K||Z.endsWith(q)||Z.endsWith(W)?Q:null},H=[K];return G.basenames=H,G.patterns=[Q],G.allBasenames=H,G}function D(K,Q){const q=ce(K.slice(1,-1).split(",").map(re=>t(re,Q)).filter(re=>re!==r),K),W=q.length;if(!W)return r;if(W===1)return q[0];const G=function(re,L){for(let M=0,N=q.length;M<N;M++)if(q[M](re,L))return K;return null},H=q.find(re=>!!re.allBasenames);H&&(G.allBasenames=H.allBasenames);const Z=q.reduce((re,L)=>L.allPaths?re.concat(L.allPaths):re,[]);return Z.length&&(G.allPaths=Z),G}function E(K,Q,q){const W=C.sep===C.$gc.sep,G=W?K:K.replace(y,C.sep),H=C.sep+G,Z=C.$gc.sep+K;let re;return q?re=function(L,M){return typeof L=="string"&&(L===G||L.endsWith(H)||!W&&(L===K||L.endsWith(Z)))?Q:null}:re=function(L,M){return typeof L=="string"&&(L===G||!W&&L===K)?Q:null},re.allPaths=[(q?"*/":"./")+K],re}function I(K){try{const Q=new RegExp(`^${m(K)}$`);return function(q){return Q.lastIndex=0,typeof q=="string"&&Q.test(q)?K:null}}catch{return r}}function j(K,Q,q){return!K||typeof Q!="string"?!1:U(K)(Q,void 0,q)}e.$wj=j;function U(K,Q={}){if(!K)return o;if(typeof K=="string"||z(K)){const q=t(K,Q);if(q===r)return o;const W=function(G,H){return!!q(G,H)};return q.allBasenames&&(W.allBasenames=q.allBasenames),q.allPaths&&(W.allPaths=q.allPaths),W}return oe(K,Q)}e.$xj=U;function z(K){const Q=K;return Q?typeof Q.base=="string"&&typeof Q.pattern=="string":!1}e.$yj=z;function X(K){return K.allBasenames||[]}e.$zj=X;function x(K){return K.allPaths||[]}e.$Aj=x;function oe(K,Q){const q=ce(Object.getOwnPropertyNames(K).map(re=>se(re,K[re],Q)).filter(re=>re!==r)),W=q.length;if(!W)return r;if(!q.some(re=>!!re.requiresSiblings)){if(W===1)return q[0];const re=function(N,T){let F;for(let B=0,V=q.length;B<V;B++){const ae=q[B](N,T);if(typeof ae=="string")return ae;(0,A.$Hg)(ae)&&(F||(F=[]),F.push(ae))}return F?(async()=>{for(const B of F){const V=await B;if(typeof V=="string")return V}return null})():null},L=q.find(N=>!!N.allBasenames);L&&(re.allBasenames=L.allBasenames);const M=q.reduce((N,T)=>T.allPaths?N.concat(T.allPaths):N,[]);return M.length&&(re.allPaths=M),re}const G=function(re,L,M){let N,T;for(let F=0,B=q.length;F<B;F++){const V=q[F];V.requiresSiblings&&M&&(L||(L=(0,C.$nc)(re)),N||(N=L.substr(0,L.length-(0,C.$oc)(re).length)));const ae=V(re,L,N,M);if(typeof ae=="string")return ae;(0,A.$Hg)(ae)&&(T||(T=[]),T.push(ae))}return T?(async()=>{for(const F of T){const B=await F;if(typeof B=="string")return B}return null})():null},H=q.find(re=>!!re.allBasenames);H&&(G.allBasenames=H.allBasenames);const Z=q.reduce((re,L)=>L.allPaths?re.concat(L.allPaths):re,[]);return Z.length&&(G.allPaths=Z),G}function se(K,Q,q){if(Q===!1)return r;const W=t(K,q);if(W===r)return r;if(typeof Q=="boolean")return W;if(Q){const G=Q.when;if(typeof G=="string"){const H=(Z,re,L,M)=>{if(!M||!W(Z,re))return null;const N=G.replace("$(basename)",()=>L),T=M(N);return(0,A.$Hg)(T)?T.then(F=>F?K:null):T?K:null};return H.requiresSiblings=!0,H}}return W}function ce(K,Q){const q=K.filter(re=>!!re.basenames);if(q.length<2)return K;const W=q.reduce((re,L)=>{const M=L.basenames;return M?re.concat(M):re},[]);let G;if(Q){G=[];for(let re=0,L=W.length;re<L;re++)G.push(Q)}else G=q.reduce((re,L)=>{const M=L.patterns;return M?re.concat(M):re},[]);const H=function(re,L){if(typeof re!="string")return null;if(!L){let N;for(N=re.length;N>0;N--){const T=re.charCodeAt(N-1);if(T===47||T===92)break}L=re.substr(N)}const M=W.indexOf(L);return M!==-1?G[M]:null};H.basenames=W,H.patterns=G,H.allBasenames=W;const Z=K.filter(re=>!re.basenames);return Z.push(H),Z}function Y(K,Q){return(0,P.$ub)(K,Q,(q,W)=>typeof q=="string"&&typeof W=="string"?q===W:typeof q!="string"&&typeof W!="string"?q.base===W.base&&q.pattern===W.pattern:!1)}e.$Bj=Y}),define(ie[46],ne([0,1,23,33,9,4,19,27]),function(J,e,P,A,s,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=void 0;function u(t,n){const{os:l,tildify:p,relative:O}=n;if(O){const I=a(t,O,l);if(typeof I=="string")return I}let D=t.fsPath;if(l===1&&!R.$j?D=D.replace(/\//g,"\\"):l!==1&&R.$j&&(D=D.replace(/\\/g,"/")),l!==1&&p?.userHome){const I=p.userHome.fsPath;let j;t.scheme!==p.userHome.scheme&&t.path.startsWith(s.$gc.sep)?j=p.userHome.with({path:t.path}).fsPath:j=t.fsPath,D=y(j,I,l)}return(l===1?s.$fc:s.$gc).normalize(g(D,l===1))}e.$vv=u;function a(t,n,l){const p=l===1?s.$fc:s.$gc,O=l===3?C.$mg:C.$og,D=n.getWorkspace(),E=(0,P.$Ob)(D.folders);if(!E)return;t.scheme!==E.uri.scheme&&t.path.startsWith(s.$gc.sep)&&(t=E.uri.with({path:t.path}));const I=n.getWorkspaceFolder(t);if(!I)return;let j;if(O.isEqual(I.uri,t)?j="":j=O.relativePath(I.uri,t)??"",j&&(j=p.normalize(j)),D.folders.length>1&&!n.noPrefix){const U=I.name?I.name:O.basenameOrAuthority(I.uri);j=j?`${U} \u2022 ${j}`:U}return j}function g(t,n=R.$j){return(0,A.$3f)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$wv=g;let b=Object.create(null);function y(t,n,l=R.OS){if(l===1||!t||!n)return t;let p=b.original===n?b.normalized:void 0;p||(p=n,R.$j&&(p=(0,A.$Sf)(p)),p=`${(0,S.$Le)(p,s.$gc.sep)}${s.$gc.sep}`,b={original:n,normalized:p});let O=t;return R.$j&&(O=(0,A.$Sf)(O)),(l===3?O.startsWith(p):(0,S.$4e)(O,p))?`~/${O.substr(p.length)}`:t}e.$xv=y;function f(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.$yv=f;const v="\u2026",m="\\\\",w="~";function $(t,n=s.sep){const l=new Array(t.length);let p=!1;for(let O=0;O<t.length;O++){const D=t[O];if(D===""){l[O]=`.${n}`;continue}if(!D){l[O]=D;continue}p=!0;let E="",I=D;I.indexOf(m)===0?(E=I.substr(0,I.indexOf(m)+m.length),I=I.substr(I.indexOf(m)+m.length)):I.indexOf(n)===0?(E=I.substr(0,I.indexOf(n)+n.length),I=I.substr(I.indexOf(n)+n.length)):I.indexOf(w)===0&&(E=I.substr(0,I.indexOf(w)+w.length),I=I.substr(I.indexOf(w)+w.length));const j=I.split(n);for(let U=1;p&&U<=j.length;U++)for(let z=j.length-U;p&&z>=0;z--){p=!1;let X=j.slice(z,z+U).join(n);for(let x=0;!p&&x<t.length;x++)if(x!==O&&t[x]&&t[x].indexOf(X)>-1){const oe=z+U===j.length,se=z>0&&t[x].indexOf(n)>-1?n+X:X,ce=t[x].endsWith(se);p=!oe||ce}if(!p){let x="";(j[0].endsWith(":")||E!=="")&&(z===1&&(z=0,U++,X=j[0]+n+X),z>0&&(x=j[0]+n),x=E+x),z>0&&(x=x+v+n),x=x+X,z+U<j.length&&(x=x+n+v),l[O]=x}}p&&(l[O]=D)}return l}e.$zv=$;var d;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function h(t,n=Object.create(null)){const l=[];let p=!1,O="";for(const D of t)if(D==="$"||p&&D==="{")O&&l.push({value:O,type:d.TEXT}),O="",p=!0;else if(D==="}"&&p){const E=n[O];if(typeof E=="string")E.length&&l.push({value:E,type:d.VARIABLE});else if(E){const I=l[l.length-1];(!I||I.type!==d.SEPARATOR)&&l.push({value:E.label,type:d.SEPARATOR})}O="",p=!1}else O+=D;return O&&!p&&l.push({value:O,type:d.TEXT}),l.filter((D,E)=>{if(D.type===d.SEPARATOR){const I=l[E-1],j=l[E+1];return[I,j].every(U=>U&&(U.type===d.VARIABLE||U.type===d.TEXT)&&U.value.length>0)}return!0}).map(D=>D.value).join("")}e.$Av=h;function k(t,n){return R.$k||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):t.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$Bv=k;function c(t,n){return R.$k||n?t.replace(/\(&&\w\)|&&/g,""):R.$j?t.replace(/&&|&/g,l=>l==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$Cv=c;function i(t){return t.replace(/&/g,"&&")}e.$Dv=i;function o(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const l=r(t.substring(0,n));return{name:l.name,parentPath:l.parentPath+t.substring(n)}}}return r(t)}e.$Ev=o;function r(t){const n=t.indexOf("/")!==-1?s.$gc:s.$fc,l=n.basename(t),p=n.dirname(t);return l.length?{name:l,parentPath:p}:{name:p,parentPath:""}}}),define(ie[155],ne([0,1,17,7]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0;function s(b){return b.toJSON()}class R{constructor(y){this.a=y}transformIncoming(y){const f=this.a.transformIncoming(y);return f===y?y:s(A.URI.from(f))}transformOutgoing(y){const f=this.a.transformOutgoing(y);return f===y?y:s(A.URI.from(f))}transformOutgoingURI(y){const f=this.a.transformOutgoing(y);return f===y?y:A.URI.from(f)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Mm=R,e.$Nm=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function C(b,y,f){if(!b||f>200)return null;if(typeof b=="object"){if(b instanceof A.URI)return y.transformOutgoing(b);for(const v in b)if(Object.hasOwnProperty.call(b,v)){const m=C(b[v],y,f+1);m!==null&&(b[v]=m)}}return null}function S(b,y){const f=C(b,y,0);return f===null?b:f}e.$Om=S;function u(b,y,f,v){if(!b||v>200)return null;if(typeof b=="object"){if(b.$mid===1)return f?A.URI.revive(y.transformIncoming(b)):y.transformIncoming(b);if(b instanceof P.$ce)return null;for(const m in b)if(Object.hasOwnProperty.call(b,m)){const w=u(b[m],y,f,v+1);w!==null&&(b[m]=w)}}return null}function a(b,y){const f=u(b,y,!1,0);return f===null?b:f}e.$Pm=a;function g(b,y){const f=u(b,y,!0,0);return f===null?b:f}e.$Qm=g}),define(ie[88],ne([0,1,28,56,32,145,4]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Sm=new class{c(y){return this.a||(this.a=A.$Wh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,f=0;const v=(0,P.networkInterfaces)();for(const m in v){const w=v[m];if(w)for(const{mac:$,internal:d}of w)d||(f+=1,this.c($.toUpperCase())&&(y+=1))}this.b=f>0?y/f:0}return this.b}};let S;async function u(y){return S||(S=(async()=>await a(y)||s.$fg())()),S}e.$Tm=u;async function a(y){try{const f=await new Promise((m,w)=>{J(["crypto"],m,w)}),v=(0,R.$Rm)();return f.createHash("sha256").update(v,"utf8").digest("hex")}catch(f){y(f);return}}const g="Software\\Microsoft\\SQMClient";async function b(y){if(C.$j){const f=await new Promise((v,m)=>{J(["@vscode/windows-registry"],v,m)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(v){return y(v),""}}return""}e.$Um=b}),define(ie[21],ne([0,1,45,28,156,8,33,85,9,4,19,7]),function(J,e,P,A,s,R,C,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function f(se,ce=y.UNLINK,Y){if((0,C.$2f)(se))throw new Error("rimraf - will refuse to recursively delete root");return ce===y.UNLINK?m(se):v(se,Y)}async function v(se,ce=(0,C.$7f)((0,A.tmpdir)())){try{try{await P.promises.rename(se,ce)}catch(Y){return Y.code==="ENOENT"?void 0:m(se)}m(ce).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function m(se){return(0,s.promisify)(P.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function w(se){if((0,C.$2f)(se))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function $(se,ce){return k(await(ce?d(se):(0,s.promisify)(P.readdir)(se)))}async function d(se){try{return await(0,s.promisify)(P.readdir)(se,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ce=[],Y=await $(se);for(const K of Y){let Q=!1,q=!1,W=!1;try{const G=await e.Promises.lstat((0,u.$jc)(se,K));Q=G.isFile(),q=G.isDirectory(),W=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ce.push({name:K,isFile:()=>Q,isDirectory:()=>q,isSymbolicLink:()=>W})}return ce}function h(se){return k(P.readdirSync(se))}e.readdirSync=h;function k(se){return se.map(ce=>typeof ce=="string"?a.$k?(0,S.$pl)(ce):ce:(ce.name=a.$k?(0,S.$pl)(ce.name):ce.name,ce))}async function c(se){const ce=await $(se),Y=[];for(const K of ce)await o.existsDirectory((0,u.$jc)(se,K))&&Y.push(K);return Y}function i(se,ce=1e3){return new Promise(Y=>{let K=!1;const Q=setInterval(()=>{K||(K=!0,P.access(se,q=>{K=!1,q&&(clearInterval(Q),Y(void 0))}))},ce)})}e.whenDeleted=i;var o;(function(se){async function ce(Q){let q;try{if(q=await e.Promises.lstat(Q),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(Q),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(a.$j&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Q)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw G}throw W}}se.stat=ce;async function Y(Q){try{const{stat:q,symbolicLink:W}=await se.stat(Q);return q.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=Y;async function K(Q){try{const{stat:q,symbolicLink:W}=await se.stat(Q);return q.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const r=new R.$4g;function t(se,ce,Y){return r.queueFor(b.URI.file(se),g.$ng).queue(()=>{const K=D(Y);return new Promise((Q,q)=>p(se,ce,K,W=>W?q(W):Q()))})}let n=!0;function l(se){n=se}e.configureFlushOnWrite=l;function p(se,ce,Y,K){if(!n)return P.writeFile(se,ce,{mode:Y.mode,flag:Y.flag},K);P.open(se,Y.flag,Y.mode,(Q,q)=>{if(Q)return K(Q);P.writeFile(q,ce,W=>{if(W)return P.close(q,()=>K(W));P.fdatasync(q,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),l(!1)),P.close(q,H=>K(H))))})})}function O(se,ce,Y){const K=D(Y);if(!n)return P.writeFileSync(se,ce,{mode:K.mode,flag:K.flag});const Q=P.openSync(se,K.flag,K.mode);try{P.writeFileSync(Q,ce);try{P.fdatasyncSync(Q)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),l(!1)}}finally{P.closeSync(Q)}}e.writeFileSync=O;function D(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function E(se,ce,Y=6e4){if(se!==ce)try{a.$j&&typeof Y=="number"?await I(se,ce,Date.now(),Y):await(0,s.promisify)(P.rename)(se,ce)}catch(K){if(se.toLowerCase()!==ce.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await j(se,ce,{preserveSymlinks:!1}),await f(se,y.MOVE);else throw K}}async function I(se,ce,Y,K,Q=0){try{return await(0,s.promisify)(P.rename)(se,ce)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-Y>=K)throw console.error(`[node.js fs] rename failed after ${Q} retries with error: ${q}`),q;if(Q===0){let W=!1;try{const{stat:G}=await o.stat(ce);G.isFile()||(W=!0)}catch{}if(W)throw q}return await(0,R.$Vg)(Math.min(100,Q*10)),I(se,ce,Y,K,Q+1)}}async function j(se,ce,Y){return z(se,ce,{root:{source:se,target:ce},options:Y,handledSourcePaths:new Set})}const U=511;async function z(se,ce,Y){if(Y.handledSourcePaths.has(se))return;Y.handledSourcePaths.add(se);const{stat:K,symbolicLink:Q}=await o.stat(se);if(Q){if(Y.options.preserveSymlinks)try{return await oe(se,ce,Y)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(Q.dangling)return}return K.isDirectory()?X(se,ce,K.mode&U,Y):x(se,ce,K.mode&U)}async function X(se,ce,Y,K){await e.Promises.mkdir(ce,{recursive:!0,mode:Y});const Q=await $(se);for(const q of Q)await z((0,u.$jc)(se,q),(0,u.$jc)(ce,q),K)}async function x(se,ce,Y){await e.Promises.copyFile(se,ce),await e.Promises.chmod(ce,Y)}async function oe(se,ce,Y){let K=await e.Promises.readlink(se);(0,C.$Yf)(K,Y.root.source,!a.$l)&&(K=(0,u.$jc)(Y.root.target,K.substr(Y.root.source.length+1))),await e.Promises.symlink(K,ce)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(se,ce,Y,K,Q)=>new Promise((q,W)=>{P.read(se,ce,Y,K,Q,(G,H,Z)=>G?W(G):q({bytesRead:H,buffer:Z}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(se,ce,Y,K,Q)=>new Promise((q,W)=>{P.write(se,ce,Y,K,Q,(G,H,Z)=>G?W(G):q({bytesWritten:H,buffer:Z}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return c}get writeFile(){return t}get rm(){return f}get rename(){return E}get copy(){return j}}}),define(ie[105],ne([0,1,45,9,4,27,21]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.$9p=void 0;function S(y){if(s.$l)return y;const f=(0,A.$mc)(y);if(y===f)return y;const v=((0,A.$nc)(y)||y).toLowerCase();try{const w=(0,C.readdirSync)(f).filter($=>$.toLowerCase()===v);if(w.length===1){const $=S(f);if($)return(0,A.$jc)($,w[0])}else if(w.length>1){const $=w.indexOf(v);if($>=0){const d=S(f);if(d)return(0,A.$jc)(d,w[$])}}}catch{}return null}e.$9p=S;async function u(y){if(s.$l)return y;const f=(0,A.$mc)(y);if(y===f)return y;const v=((0,A.$nc)(y)||y).toLowerCase();try{const w=(await C.Promises.readdir(f)).filter($=>$.toLowerCase()===v);if(w.length===1){const $=await u(f);if($)return(0,A.$jc)($,w[0])}else if(w.length>1){const $=w.indexOf(v);if($>=0){const d=await u(f);if(d)return(0,A.$jc)(d,w[$])}}}catch{}return null}e.$0p=u;async function a(y){try{return await C.Promises.realpath(y)}catch{const v=b(y);return await C.Promises.access(v,P.constants.R_OK),v}}e.$$p=a;function g(y){try{return P.realpathSync(y)}catch{const v=b(y);return P.accessSync(v,P.constants.R_OK),v}}e.$_p=g;function b(y){return(0,R.$Le)((0,A.$hc)(y),A.sep)}}),define(ie[106],ne([0,1,28,9,21]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0;const R=/^\d+$/,C=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var u;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class b{constructor(c,i,o){this.exePath=c,this.displayName=i,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:k=!1}={}){return k?a===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:k=!1,findPreview:c=!1}={}){const i=y({useAlternateBitness:k});if(!i)return null;const o=A.$jc(i,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,t=null;for(const p of await s.Promises.readdir(o)){let O=-1;if(c){const E=p.indexOf("-");if(E<0)continue;const I=p.substring(0,E);if(!R.test(I)||p.substring(E+1)!=="preview")continue;O=parseInt(I,10)}else{if(!R.test(p))continue;O=parseInt(p,10)}if(O<=r)continue;const D=A.$jc(o,p,"pwsh.exe");await s.SymlinkSupport.existsFile(D)&&(t=D,r=O)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",l=c?" Preview":"";return new b(t,`PowerShell${l}${n}`,!0)}async function v({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const c=A.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=k?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(c))if(i.test(r)){const t=A.$jc(c,r,"pwsh.exe");return new b(t,o)}return null}function m(){const k=A.$jc(P.homedir(),".dotnet","tools","pwsh.exe");return new b(k,".NET Core PowerShell Global Tool")}function w(){const k=A.$jc(process.env.windir,a===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(k,"Windows PowerShell",!0)}async function*$(){let k=await f();k&&(yield k),k=await f({useAlternateBitness:!0}),k&&(yield k),k=await v(),k&&(yield k),k=m(),k&&(yield k),k=await f({findPreview:!0}),k&&(yield k),k=await v({findPreview:!0}),k&&(yield k),k=await f({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=w(),k&&(yield k)}async function*d(){for await(const k of $())await k.exists()&&(yield k)}e.$yl=d;async function h(){for await(const k of d())return k;return null}e.$zl=h}),define(ie[89],ne([0,1,9,4,35,75,12,21]),function(J,e,P,A,s,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Dl=e.$Cl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function u(b=s.env){return b.comspec||"cmd.exe"}e.$Cl=u;function a(b){let y=[],f=!1;const v=function(m){if(f){y.push(m);return}(!b.send(m,$=>{if($&&console.error($),f=!1,y.length>0){const d=y.slice(0);y=[],d.forEach(h=>v(h))}})||A.$j)&&(f=!0)};return{send:v}}e.$Dl=a;var g;(function(b){async function y(f,v,m){if(P.$ic(f))return f;if(v===void 0&&(v=s.cwd()),P.$mc(f)!=="."||(m===void 0&&C.$zf(s.env.PATH)&&(m=s.env.PATH.split(P.$tc)),m===void 0||m.length===0))return P.$jc(v,f);async function $(d){if(await S.Promises.exists(d)){let h;try{h=await S.Promises.stat(d)}catch(k){k.message.startsWith("EACCES")&&(h=await S.Promises.lstat(d))}return h?!h.isDirectory():!1}return!1}for(const d of m){let h;if(P.$ic(d)?h=P.$jc(d,f):h=P.$jc(v,d,f),await $(h))return h;let k=h+".com";if(await $(k)||(k=h+".exe",await $(k)))return k}return P.$jc(v,f)}b.findExecutable=y})(g||(e.win32=g={}))}),define(ie[107],ne([0,1,47,13]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;function s(C){return new Promise((S,u)=>{let a;const g=new Map;function b(f,v,m,w,$){const d=g.get(v);if(f===C||d){const h={name:y(m),cmd:m,pid:f,ppid:v,load:w,mem:$};g.set(f,h),f===C&&(a=h),d&&(d.children||(d.children=[]),d.children.push(h),d.children.length>1&&(d.children=d.children.sort((k,c)=>k.pid-c.pid)))}}function y(f){const v=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,$=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(w.exec(f))return"electron-crash-reporter";if($.exec(f))return"winpty-agent";if(d.exec(f))return"conpty-agent";let k=h.exec(f);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?v.exec(f)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const c=/[a-zA-Z-]+\.js/g;let i="";do k=c.exec(f),k&&(i+=k+" ");while(k);return i&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${i})`:m.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,m)=>{J(["@vscode/windows-process-tree"],v,m)}).then(v=>{v.getProcessList(C,m=>{if(!m){u(new Error(`Root process ${C} not found`));return}v.getProcessCpuUsage(m,w=>{const $=new Map;w.forEach(d=>{const h=f(d.commandLine||"");$.set(d.pid,{name:y(h),cmd:h,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),a=$.get(C),a?($.forEach(d=>{const h=$.get(d.ppid);h&&(h.children||(h.children=[]),h.children.push(d))}),$.forEach(d=>{d.children&&(d.children=d.children.sort((h,k)=>h.pid-k.pid))}),S(a)):u(new Error(`Root process ${C} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let f=function(){let v=[a];const m=[];for(;v.length;){const $=v.shift();$&&(m.push($.pid),$.children&&(v=v.concat($.children)))}let w=JSON.stringify(A.$dg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+m.join(" "),(0,P.exec)(w,{},($,d,h)=>{if($||h)u($||new Error(h.toString()));else{const k=d.toString().split(`
`);for(let c=0;c<m.length;c++){const i=g.get(m[c]);i.load=parseFloat(k[c])}if(!a){u(new Error(`Root process ${C} not found`));return}S(a)}})};(0,P.exec)("which ps",{},(v,m,w)=>{if(v||w)if(process.platform!=="linux")u(v||new Error(w.toString()));else{const $=JSON.stringify(A.$dg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)($,{},(d,h,k)=>{d||k?u(d||new Error(k.toString())):(R(h,b),f())})}else{const $=m.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${$} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,k,c)=>{h||c&&!c.includes("screen size is bogus")?u(h||new Error(c.toString())):(R(k,b),process.platform==="linux"?f():a?S(a):u(new Error(`Root process ${C} not found`)))})}})}})}e.$Gr=s;function R(C,S){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=C.toString().split(`
`);for(const g of a){const b=u.exec(g.trim());b&&b.length===6&&S(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ie[108],ne([0,1,28,4,106,89]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0;async function C(b,y){return b===1?A.$j?g():R.$Cl(y):u(b,y)}e.$El=C;let S=null;function u(b,y){if(A.$l&&b===2||A.$k&&b===3)return"/bin/bash";if(!S){let f;if(A.$j)f="/bin/bash";else{if(f=y.SHELL,!f)try{f=(0,P.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}S=f}return S}let a=null;async function g(){return a||(a=(await(0,s.$zl)()).exePath),a}});var Ee=this&&this.__decorate||function(J,e,P,A){var s=arguments.length,R=s<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,P):A,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(J,e,P,A);else for(var S=J.length-1;S>=0;S--)(C=J[S])&&(R=(s<3?C(R):s>3?C(e,P,R):C(e,P))||R);return s>3&&R&&Object.defineProperty(e,P,R),R};define(ie[42],ne([0,1,23,8,17,22,54,14,3,2,76,27,12]),function(J,e,P,A,s,R,C,S,u,a,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.ProxyChannel=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.RequestInitiator=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;var f;(function(Q){Q[Q.Promise=100]="Promise",Q[Q.PromiseCancel=101]="PromiseCancel",Q[Q.EventListen=102]="EventListen",Q[Q.EventDispose=103]="EventDispose"})(f||(f={}));function v(Q){switch(Q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(Q){Q[Q.Initialize=200]="Initialize",Q[Q.PromiseSuccess=201]="PromiseSuccess",Q[Q.PromiseError=202]="PromiseError",Q[Q.PromiseErrorObj=203]="PromiseErrorObj",Q[Q.EventFire=204]="EventFire"})(m||(m={}));function w(Q){switch(Q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(Q){Q[Q.Uninitialized=0]="Uninitialized",Q[Q.Idle=1]="Idle"})($||($={}));function d(Q){let q=0;for(let W=0;;W+=7){const G=Q.read(1);if(q|=(G.buffer[0]&127)<<W,!(G.buffer[0]&128))return q}}const h=r(0);function k(Q,q){if(q===0){Q.write(h);return}let W=0;for(let H=q;H!==0;H=H>>>7)W++;const G=s.$ce.alloc(W);for(let H=0;q!==0;H++)G.buffer[H]=q&127,q=q>>>7,q>0&&(G.buffer[H]|=128);Q.write(G)}class c{constructor(q){this.b=q,this.a=0}read(q){const W=this.b.slice(this.a,this.a+q);return this.a+=W.byteLength,W}}e.$oh=c;class i{constructor(){this.a=[]}get buffer(){return s.$ce.concat(this.a)}write(q){this.a.push(q)}}e.$ph=i;var o;(function(Q){Q[Q.Undefined=0]="Undefined",Q[Q.String=1]="String",Q[Q.Buffer=2]="Buffer",Q[Q.VSBuffer=3]="VSBuffer",Q[Q.Array=4]="Array",Q[Q.Object=5]="Object",Q[Q.Int=6]="Int"})(o||(o={}));function r(Q){const q=s.$ce.alloc(1);return q.writeUInt8(Q,0),q}const t={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function l(Q,q){if(typeof q>"u")Q.write(t.Undefined);else if(typeof q=="string"){const W=s.$ce.fromString(q);Q.write(t.String),k(Q,W.byteLength),Q.write(W)}else if(n&&Buffer.isBuffer(q)){const W=s.$ce.wrap(q);Q.write(t.Buffer),k(Q,W.byteLength),Q.write(W)}else if(q instanceof s.$ce)Q.write(t.VSBuffer),k(Q,q.byteLength),Q.write(q);else if(Array.isArray(q)){Q.write(t.Array),k(Q,q.length);for(const W of q)l(Q,W)}else if(typeof q=="number"&&(q|0)===q)Q.write(t.Uint),k(Q,q);else{const W=s.$ce.fromString(JSON.stringify(q));Q.write(t.Object),k(Q,W.byteLength),Q.write(W)}}e.$qh=l;function p(Q){switch(Q.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return Q.read(d(Q)).toString();case o.Buffer:return Q.read(d(Q)).buffer;case o.VSBuffer:return Q.read(d(Q));case o.Array:{const W=d(Q),G=[];for(let H=0;H<W;H++)G.push(p(Q));return G}case o.Object:return JSON.parse(Q.read(d(Q)).toString());case o.Int:return d(Q)}}e.$rh=p;class O{constructor(q,W,G=null,H=1e3){this.h=q,this.j=W,this.k=G,this.l=H,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Z=>this.q(Z)),this.m({type:200})}registerChannel(q,W){this.b.set(q,W),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const W=this.o([q.type]);this.k?.logOutgoing(W,0,1,w(q.type));return}case 201:case 202:case 204:case 203:{const W=this.o([q.type,q.id],q.data);this.k?.logOutgoing(W,q.id,1,w(q.type),q.data);return}}}o(q,W=void 0){const G=new i;return l(G,q),l(G,W),this.p(G.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const W=new c(q),G=p(W),H=p(W),Z=G[0];switch(Z){case 100:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(Z)}: ${G[2]}.${G[3]}`,H),this.s({type:Z,id:G[1],channelName:G[2],name:G[3],arg:H});case 102:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(Z)}: ${G[2]}.${G[3]}`,H),this.t({type:Z,id:G[1],channelName:G[2],name:G[3],arg:H});case 101:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(Z)}`),this.u({type:Z,id:G[1]});case 103:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(Z)}`),this.u({type:Z,id:G[1]})}}s(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const G=new R.$Yd;let H;try{H=W.call(this.j,q.name,q.arg,G.token)}catch(L){H=Promise.reject(L)}const Z=q.id;H.then(L=>{this.m({id:Z,data:L,type:201})},L=>{L instanceof Error?this.m({id:Z,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.m({id:Z,data:L,type:203})}).finally(()=>{re.dispose(),this.d.delete(q.id)});const re=(0,a.$Qc)(()=>G.cancel());this.d.set(q.id,re)}t(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const G=q.id,Z=W.listen(this.j,q.name,q.arg)(re=>this.m({id:G,data:re,type:204}));this.d.set(q.id,Z)}u(q){const W=this.d.get(q.id);W&&(W.dispose(),this.d.delete(q.id))}v(q){let W=this.g.get(q.channelName);W||(W=[],this.g.set(q.channelName,W));const G=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:q,timeoutTimer:G})}w(q){const W=this.g.get(q);if(W){for(const G of W)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Nc)(this.d.values()),this.d.clear()}}e.$sh=O;var D;(function(Q){Q[Q.LocalSide=0]="LocalSide",Q[Q.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class E{constructor(q,W=null){this.l=q,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=W}getChannel(q){const W=this;return{call(G,H,Z){return W.a?Promise.reject(new S.$5):W.m(q,G,H,Z)},listen(G,H){return W.a?u.Event.None:W.o(q,G,H)}}}m(q,W,G,H=R.CancellationToken.None){const Z=this.g++,L={id:Z,type:100,channelName:q,name:W,arg:G};if(H.isCancellationRequested)return Promise.reject(new S.$5);let M;return new Promise((T,F)=>{if(H.isCancellationRequested)return F(new S.$5);const B=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(Z),T(he.data);break;case 202:{this.f.delete(Z);const ve=new Error(he.data.message);ve.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ve.name=he.data.name,F(ve);break}case 203:this.f.delete(Z),F(he.data);break}};this.f.set(Z,ue),this.p(L)};let V=null;this.b===$.Idle?B():(V=(0,A.$Ig)(ue=>this.u()),V.then(()=>{V=null,B()}));const ae=()=>{V?(V.cancel(),V=null):this.p({id:Z,type:101}),F(new S.$5)},de=H.onCancellationRequested(ae);M=(0,a.$Pc)((0,a.$Qc)(ae),de),this.d.add(M)}).finally(()=>{M.dispose(),this.d.delete(M)})}o(q,W,G){const H=this.g++,re={id:H,type:102,channelName:q,name:W,arg:G};let L=null;const M=new u.$Od({onWillAddFirstListener:()=>{L=(0,A.$Ig)(T=>this.u()),L.then(()=>{L=null,this.d.add(M),this.p(re)})},onDidRemoveLastListener:()=>{L?(L.cancel(),L=null):(this.d.delete(M),this.p({id:H,type:103}))}}),N=T=>M.fire(T.data);return this.f.set(H,N),M.event}p(q){switch(q.type){case 100:case 102:{const W=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(W,q.id,0,`${v(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const W=this.q([q.type,q.id]);this.j?.logOutgoing(W,q.id,0,v(q.type));return}}}q(q,W=void 0){const G=new i;return l(G,q),l(G,W),this.r(G.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const W=new c(q),G=p(W),H=p(W),Z=G[0];switch(Z){case 200:return this.j?.logIncoming(q.byteLength,0,0,w(Z)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,G[1],0,w(Z),H),this.t({type:G[0],id:G[1],data:H})}}t(q){if(q.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Nc)(this.d.values()),this.d.clear()}}e.$th=E,Ee([C.$ih],E.prototype,"onDidInitializePromise",null);class I{get connections(){const q=[];return this.f.forEach(W=>q.push(W)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new u.$Od,this.onDidAddConnection=this.g.event,this.h=new u.$Od,this.onDidRemoveConnection=this.h.event,this.j=new a.$Rc,this.j.add(q(({protocol:W,onDidClientDisconnect:G})=>{const H=u.Event.once(W.onMessage);this.j.add(H(Z=>{const re=new c(Z),L=p(re),M=new O(W,L),N=new E(W);this.a.forEach((F,B)=>M.registerChannel(B,F));const T={channelServer:M,channelClient:N,ctx:L};this.f.add(T),this.g.fire(T),this.j.add(G(()=>{M.dispose(),N.dispose(),this.f.delete(T),this.h.fire(T)}))}))}))}getChannel(q,W){const G=this;return{call(H,Z,re){let L;if((0,y.$Nf)(W)){const N=(0,P.$4b)(G.connections.filter(W));L=N?Promise.resolve(N):u.Event.toPromise(u.Event.filter(G.onDidAddConnection,W))}else L=W.routeCall(G,H,Z);const M=L.then(N=>N.channelClient.getChannel(q));return U(M).call(H,Z,re)},listen(H,Z){if((0,y.$Nf)(W))return G.k(q,W,H,Z);const re=W.routeEvent(G,H,Z).then(L=>L.channelClient.getChannel(q));return U(re).listen(H,Z)}}}k(q,W,G,H){const Z=this;let re;const L=new u.$Od({onWillAddFirstListener:()=>{re=new a.$Rc;const M=new u.$Ud,N=new Map,T=B=>{const ae=B.channelClient.getChannel(q).listen(G,H),de=M.add(ae);N.set(B,de)},F=B=>{const V=N.get(B);V&&(V.dispose(),N.delete(B))};Z.connections.filter(W).forEach(T),u.Event.filter(Z.onDidAddConnection,W)(T,void 0,re),Z.onDidRemoveConnection(F,void 0,re),M.event(L.fire,L,re),re.add(M)},onDidRemoveLastListener:()=>{re?.dispose(),re=void 0}});return L.event}registerChannel(q,W){this.a.set(q,W);for(const G of this.f)G.channelServer.registerChannel(q,W)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$uh=I;class j{constructor(q,W,G=null){const H=new i;l(H,W),q.send(H.buffer),this.a=new E(q,G),this.d=new O(q,W,G)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,W){this.d.registerChannel(q,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$vh=j;function U(Q){return{call(q,W,G){return Q.then(H=>H.call(q,W,G))},listen(q,W){const G=new u.$Xd;return Q.then(H=>G.input=H.listen(q,W)),G.event}}}e.$wh=U;function z(Q){let q=!1;return{call(W,G,H){return q?Q.call(W,G,H):(0,A.$Vg)(0).then(()=>q=!0).then(()=>Q.call(W,G,H))},listen(W,G){if(q)return Q.listen(W,G);const H=new u.$Xd;return(0,A.$Vg)(0).then(()=>q=!0).then(()=>H.input=Q.listen(W,G)),H.event}}}e.$xh=z;class X{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const W of q.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await u.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$yh=X;var x;(function(Q){function q(Z,re,L){const M=Z,N=L&&L.disableMarshalling,T=new Map;for(const F in M)G(F)&&T.set(F,u.Event.buffer(M[F],!0,void 0,re));return new class{listen(F,B,V){const ae=T.get(B);if(ae)return ae;if(H(B)){const de=M[B];if(typeof de=="function")return de.call(M,V)}throw new S.$bb(`Event not found: ${B}`)}call(F,B,V){const ae=M[B];if(typeof ae=="function"){if(!N&&Array.isArray(V))for(let ue=0;ue<V.length;ue++)V[ue]=(0,g.$nh)(V[ue]);let de=ae.apply(M,V);return de instanceof Promise||(de=Promise.resolve(de)),de}throw new S.$bb(`Method not found: ${B}`)}}}Q.fromService=q;function W(Z,re){const L=re&&re.disableMarshalling;return new Proxy({},{get(M,N){if(typeof N=="string")return re?.properties?.has(N)?re.properties.get(N):H(N)?function(T){return Z.listen(N,T)}:G(N)?Z.listen(N):async function(...T){let F;re&&!(0,y.$If)(re.context)?F=[re.context,...T]:F=T;const B=await Z.call(N,F);return L?B:(0,g.$nh)(B)};throw new S.$bb(`Property not found: ${String(N)}`)}})}Q.toService=W;function G(Z){return Z[0]==="o"&&Z[1]==="n"&&b.$2e(Z.charCodeAt(2))}function H(Z){return/^onDynamic/.test(Z)&&b.$2e(Z.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(Q){if(Array.isArray(Q))return Q;if(Q&&typeof Q=="object"&&typeof Q.toString=="function"){const q=Q.toString();if(q!=="[object Object]")return q}return Q}function ce(Q){return Array.isArray(Q)?Q.map(se):se(Q)}function Y(Q,q,W,G,H,Z,re){re=ce(re);const L=oe[H],M=L[G%L.length];let N=[`%c[${Q}]%c[${String(q).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(Z)?(N=N.concat(re),N.push(")")):N.push(re),console.log.apply(console,N)}class K{constructor(q,W){this.d=q,this.f=W,this.a=0,this.b=0}logOutgoing(q,W,G,H,Z){this.b+=q,Y(this.d,this.b,q,W,G,H,Z)}logIncoming(q,W,G,H,Z){this.a+=q,Y(this.f,this.a,q,W,G,H,Z)}}e.$zh=K}),define(ie[157],ne([0,1,17,3,42]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AT=e.$zT=void 0;class R{constructor(u){this.a=u,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",a=>P.$ce.wrap(a.data)),u.start()}send(u){this.a.postMessage(u.buffer)}disconnect(){this.a.close()}}e.$zT=R;class C extends s.$vh{constructor(u,a){const g=new R(u);super(g,a),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$AT=C}),define(ie[109],ne([0,1,17,3,2,42]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.ProtocolConstants=e.$Ah=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var S;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let l=0;function p(D,E){if(!n.has(D)){const I=String(++l);n.set(D,I)}return n.get(D)}function O(D,E,I,j){if(!t.enableDiagnostics)return;const U=p(D,E);if(j instanceof P.$ce||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const z=P.$ce.alloc(j.byteLength);z.set(j),t.records.push({timestamp:Date.now(),id:U,label:E,type:I,buff:z})}else t.records.push({timestamp:Date.now(),id:U,label:E,type:I,data:j})}t.traceSocketEvent=O})(S||(e.SocketDiagnostics=S={}));var u;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u||(e.SocketCloseEventType=u={}));let a=null;function g(){return a||(a=P.$ce.alloc(0)),a}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,l){if(n===0)return g();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const E=this.a[0];return l&&(this.a.shift(),this.b-=n),E}if(this.a[0].byteLength>n){const E=this.a[0].slice(0,n);return l&&(this.a[0]=this.a[0].slice(n),this.b-=n),E}const p=P.$ce.alloc(n);let O=0,D=0;for(;n>0;){const E=this.a[D];if(E.byteLength>n){const I=E.slice(0,n);p.set(I,O),O+=n,l&&(this.a[D]=E.slice(n),this.b-=n),n-=n}else p.set(E,O),O+=E.byteLength,l?(this.a.shift(),this.b-=E.byteLength):D++,n-=E.byteLength}return p}}e.$Ah=b;var y;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(y||(y={}));function f(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class m{constructor(n,l,p,O){this.type=n,this.id=l,this.ack=p,this.data=O,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends s.$Sc{constructor(n){super(),this.f=this.B(new A.$Od),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new b,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,O=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new m(p,O,D,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=P.$ce.alloc(13);l.writeUInt8(n.type,0),l.writeUInt32BE(n.id,1),l.writeUInt32BE(n.ack,5),l.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(l,n.data)}g(n,l){const p=this.f===0;return this.d.push(n,l),this.f+=n.byteLength+l.byteLength,p}h(){const n=P.$ce.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,l){this.g(n,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class d extends s.$Sc{constructor(n){super(),this.f=new A.$Od,this.onMessage=this.f.event,this.g=new A.$Od,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new $(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$Bh=d;class h extends R.$vh{static fromSocket(n,l){return new h(new d(n),l)}get onDidDispose(){return this.b.onDidDispose}constructor(n,l,p=null){super(n,l,p),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Ch=h;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Od({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Dh=k;class c{constructor(n){this.data=n,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let n=0,l=this.a;for(;l;)l=l.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let l=0,p=this.a;for(;p;)n[l++]=p.data,p=p.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const l=new c(n);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let l=0;l<o.a;l++)this.c[l]=n-1e3*l;setInterval(()=>{for(let l=o.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),l=(1+o.a)*1e3;let p=0;for(let O=0;O<o.a;O++)n-this.c[O]<=l&&p++;return 1-p/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Rc,this.o=n.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,g());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,g());this.p.write(n)}sendResume(){const n=new m(8,0,0,g());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,l){this.a=!0,this.r.dispose(),this.r=new s.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,g());this.p.write(n);const l=this.b.toArray();for(let p=0,O=l.length;p<O;p++)this.p.write(l[p]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const l=this.b.peek();if(l&&l.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new m(6,0,0,g())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let p=0,O=l.length;p<O;p++)this.p.write(l[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const l=++this.c;this.h=this.g;const p=new m(1,l,this.h,n);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(n){const l=new m(2,0,0,n);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),l=Date.now()-n.writtenTime,p=Date.now()-this.q.lastReadTime,O=Date.now()-this.n;if(l>=2e4&&p>=2e4&&O>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:p});return}const D=Math.max(2e4-l,2e4-p,2e4-O,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,g());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,g());this.p.write(n)}}e.$Eh=r}),define(ie[38],ne([0,1,15,14,13]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wT=void 0;class R{constructor(){this.a=new WeakMap}on(S,u){const a=(g,...b)=>{this.b(S,g)&&u(g,...b)};return this.a.set(u,a),P.ipcMain.on(S,a),this}once(S,u){return P.ipcMain.once(S,(a,...g)=>{this.b(S,a)&&u(a,...g)}),this}handle(S,u){return P.ipcMain.handle(S,(a,...g)=>this.b(S,a)?u(a,...g):Promise.reject(`Invalid channel '${S}' or sender for ipcMain.handle() usage.`)),this}removeHandler(S){return P.ipcMain.removeHandler(S),this}removeListener(S,u){const a=this.a.get(u);return a&&(P.ipcMain.removeListener(S,a),this.a.delete(u)),this}b(S,u){if(!S||!S.startsWith("vscode:"))return(0,A.$1)(`Refused to handle ipcMain event for channel '${S}' because the channel is unknown.`),!1;const a=u.senderFrame,g=a.url;if(!g||g==="about:blank")return!0;let b="unknown";try{b=new URL(g).host}catch{return(0,A.$1)(`Refused to handle ipcMain event for channel '${S}' because of a malformed URL '${g}'.`),!1}return b!==s.$cg?((0,A.$1)(`Refused to handle ipcMain event for channel '${S}' because of a bad origin of '${b}'.`),!1):a.parent!==null?((0,A.$1)(`Refused to handle ipcMain event for channel '${S}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.$wT=new R}),define(ie[158],ne([0,1,15,38,146]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xT=void 0;function R(){A.$wT.on(s.$uT,(S,u,a,g,b)=>{const y=C(S,g,a);y.popup({x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{y&&S.sender.send(s.$vT,u)}})})}e.$xT=R;function C(S,u,a){const g=new P.Menu;return a.forEach(b=>{let y;b.type==="separator"?y=new P.MenuItem({type:b.type}):Array.isArray(b.submenu)?y=new P.MenuItem({submenu:C(S,u,b.submenu),label:b.label}):y=new P.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(f,v,m)=>S.sender.send(u,b.id,m)}),g.append(y)}),g}}),define(ie[159],ne([0,1,38,17,3,2,42,147]),function(J,e,P,A,s,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DT=void 0;function u(g,b){const y=s.Event.fromNodeEventEmitter(P.$wT,b,(v,m)=>({event:v,message:m})),f=s.Event.filter(y,({event:v})=>v.sender.id===g);return s.Event.map(f,({message:v})=>v&&A.$ce.wrap(v))}class a extends C.$uh{static{this.b=new Map}static d(){const b=s.Event.fromNodeEventEmitter(P.$wT,"vscode:hello",({sender:y})=>y);return s.Event.map(b,y=>{const f=y.id;a.b.get(f)?.dispose();const m=new s.$Od;a.b.set(f,(0,R.$Qc)(()=>m.fire()));const w=u(f,"vscode:message"),$=s.Event.any(s.Event.signal(u(f,"vscode:disconnect")),m.event);return{protocol:new S.$CT(y,w),onDidClientDisconnect:$}})}constructor(){super(a.d())}}e.$DT=a}),define(ie[110],ne([0,1,38,3,32,157]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FT=e.$ET=void 0;class C extends R.$AT{constructor(a,g){super({addEventListener:(b,y)=>a.addListener(b,y),removeEventListener:(b,y)=>a.removeListener(b,y),postMessage:b=>a.postMessage(b),start:()=>a.start(),close:()=>a.close()},g)}}e.$ET=C;async function S(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,s.$fg)();u.webContents.send("vscode:createMessageChannel",a);const g=A.Event.fromNodeEventEmitter(P.$wT,"vscode:createMessageChannelResult",(y,f)=>({nonce:f,port:y.ports[0]})),{port:b}=await A.Event.toPromise(A.Event.once(A.Event.filter(g,y=>y.nonce===a)));return b}e.$FT=S}),define(ie[160],ne([0,1,47,8,17,22,154,14,3,2,37,89,75,42]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class v extends f.$sh{constructor($){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",d=>s.$ce.wrap(Buffer.from(d,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$6p=v;class m{constructor($,d){this.i=$,this.j=d,this.c=new Set,this.g=new Map,this.h=new u.$Od,this.onDidProcessExit=this.h.event;const h=d&&d.timeout?d.timeout:6e4;this.b=new A.$Rg(h),this.d=null,this.f=null}getChannel($){const d=this;return{call(h,k,c){return d.k($,h,k,c)},listen(h,k){return d.l($,h,k)}}}k($,d,h,k=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const c=this.n($),i=(0,A.$Ig)(t=>c.call(d,h,t)),o=k.onCancellationRequested(()=>i.cancel()),r=(0,a.$Qc)(()=>i.cancel());return this.c.add(r),i.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l($,d,h){if(!this.b)return u.Event.None;this.b.cancel();let k;const c=new u.$Od({onWillAddFirstListener:()=>{k=this.n($).listen(d,h)(c.fire,c),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,g.$8m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$Bl)(d.env),this.d=(0,P.fork)(this.i,$,d);const h=new u.$Od;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,C.$2p)(n)){(0,C.log)(n,`IPC Library: ${this.j.serverName}`);return}h.fire(s.$ce.wrap(Buffer.from(n,"base64")))});const c=this.j.useQueue?(0,b.$Dl)(this.d):this.d,i=n=>this.d&&this.d.connected&&c.send(n.buffer.toString("base64")),o=h.event,r={send:i,onMessage:o};this.f=new f.$th(r);const t=()=>this.o();process.once("exit",t),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,l)=>{process.removeListener("exit",t),this.c.forEach(p=>(0,a.$Nc)(p)),this.c.clear(),n!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:l})})}return this.f}n($){let d=this.g.get($);return d||(d=this.m.getChannel($),this.g.set($,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7p=m}),define(ie[111],ne([0,1,8,3,2,76,12]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.StorageState=e.$5o=e.StorageHint=void 0;var S;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function u(y){const f=y;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$5o=u;var a;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(a||(e.StorageState=a={}));class g extends s.$Sc{static{this.a=100}constructor(f,v=Object.create(null)){super(),this.r=f,this.s=v,this.b=this.B(new A.$Rd),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new P.$Sg(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((v,m)=>this.w(m,v)),f.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(f,v){if(this.c===a.Closed)return;let m=!1;(0,C.$If)(v)?m=this.f.delete(f):this.f.get(f)!==v&&(this.f.set(f,v),m=!0),m&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,v){const m=this.f.get(f);return(0,C.$If)(m)?v:m}getBoolean(f,v){const m=this.get(f);return(0,C.$If)(m)?v:m==="true"}getNumber(f,v){const m=this.get(f);return(0,C.$If)(m)?v:parseInt(m,10)}getObject(f,v){const m=this.get(f);return(0,C.$If)(m)?v:(0,R.$mh)(m)}async set(f,v,m=!1){if(this.c===a.Closed)return;if((0,C.$If)(v))return this.delete(f,m);const w=(0,C.$Bf)(v)||Array.isArray(v)?(0,R.$lh)(v):String(v);if(this.f.get(f)!==w)return this.f.set(f,w),this.j.set(f,w),this.h.delete(f),this.b.fire({key:f,external:m}),this.D()}async delete(f,v=!1){if(!(this.c===a.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:v}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$6o=g;class b{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((v,m)=>this.a.set(m,v)),f.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$7o=b}),define(ie[161],ne([0,1,8,3,31,9,21]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2T=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return A.Event.None}static{this.a=2e3}static{this.b=256}constructor(g,b=Object.create(null)){this.g=g,this.h=b,this.c=(0,R.$nc)(this.g),this.d=new u(this.h.logging),this.f=this.n(this.g)}async getItems(){const g=await this.f,b=new Map;return(await this.s(g,"SELECT * FROM ItemTable")).forEach(f=>b.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${b.size} rows`),b}async updateItems(g){const b=await this.f;return this.j(b,g)}j(g,b){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${b.insert?(0,s.$yc)(b.insert):"0"}), delete(${b.delete?(0,s.$zc)(b.delete):"0"})`),this.t(g,()=>{const y=b.insert,f=b.delete;if(y&&y.size>0){const v=[];v.push([]);let m=0;y.forEach((w,$)=>{let d=v[m];d.length>S.b&&(m++,d=[],v.push(d)),d.push($,w)}),v.forEach(w=>{this.u(g,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,$=>$.run(w),()=>{const $=[];let d=0;return y.forEach((h,k)=>{$.push(k),d+=h.length}),`Keys: ${$.join(", ")} Length: ${d}`})})}if(f&&f.size){const v=[];v.push([]);let m=0;f.forEach(w=>{let $=v[m];$.length>S.b&&(m++,$=[],v.push($)),$.push(w)}),v.forEach(w=>{this.u(g,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,$=>$.run(w),()=>{const $=[];return f.forEach(d=>{$.push(d)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const g=await this.f;return this.q(g,"VACUUM")}async close(g){this.d.trace(`[storage ${this.c}] close()`);const b=await this.f;return this.k(b,g)}k(g,b){return new Promise((y,f)=>{g.db.close(v=>(v&&this.o(g,`[storage ${this.c}] close(): ${v}`),this.g===S.IN_MEMORY_PATH?y():!g.isErroneous&&!g.isInMemory?this.l().then(y,m=>(this.d.error(`[storage ${this.c}] backup(): ${m}`),y())):typeof b=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(m=>{const w=()=>this.k(m,void 0);return this.j(m,{insert:b()}).then(()=>w(),$=>(w(),Promise.reject($)))})).then(y,f):f(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const g=this.m(this.g);return C.Promises.copy(this.g,g,{preserveSymlinks:!1})}m(g){return`${g}.backup`}async checkIntegrity(g){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${g})`);const b=await this.f,y=await this.r(b,g?"PRAGMA integrity_check":"PRAGMA quick_check"),f=g?y.integrity_check:y.quick_check;return b.isErroneous?`${f} (last error: ${b.lastError})`:b.isInMemory?`${f} (in-memory!)`:f}async n(g,b=!0){this.d.trace(`[storage ${this.c}] open(${g}, retryOnBusy: ${b})`);try{return await this.p(g)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&b)return await(0,P.$Vg)(S.a),this.n(g,!1);try{await C.Promises.unlink(g);try{await C.Promises.rename(this.m(g),g,!1)}catch{}return await this.p(g)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(S.IN_MEMORY_PATH)}}}o(g,b){g.isErroneous=!0,g.lastError=b,this.d.error(b)}p(g){return new Promise((b,y)=>{new Promise((f,v)=>{J(["@vscode/sqlite3"],f,v)}).then(f=>{const v={db:new(this.d.isTracing?f.verbose().Database:f.Database)(g,m=>m?v.db&&m.code!=="SQLITE_CANTOPEN"?v.db.close(()=>y(m)):y(m):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(v),w=>v.db.close(()=>y(w)))),isInMemory:g===S.IN_MEMORY_PATH};v.db.on("error",m=>this.o(v,`[storage ${this.c}] Error (event): ${m}`)),this.d.isTracing&&v.db.on("trace",m=>this.d.trace(`[storage ${this.c}] Trace (event): ${m}`))},y)})}q(g,b){return new Promise((y,f)=>{g.db.exec(b,v=>v?(this.o(g,`[storage ${this.c}] exec(): ${v}`),f(v)):y())})}r(g,b){return new Promise((y,f)=>{g.db.get(b,(v,m)=>v?(this.o(g,`[storage ${this.c}] get(): ${v}`),f(v)):y(m))})}s(g,b){return new Promise((y,f)=>{g.db.all(b,(v,m)=>v?(this.o(g,`[storage ${this.c}] all(): ${v}`),f(v)):y(m))})}t(g,b){return new Promise((y,f)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),b(),g.db.run("END TRANSACTION",v=>v?(this.o(g,`[storage ${this.c}] transaction(): ${v}`),f(v)):y())})})}u(g,b,y,f){const v=g.db.prepare(b),m=w=>{this.o(g,`[storage ${this.c}] prepare(): ${w} (${b}). Details: ${f()}`)};v.on("error",m),y(v),v.finalize(w=>{w&&m(w),v.removeListener("error",m)})}}e.$2T=S;class u{static{this.a="VSCODE_TRACE_STORAGE"}constructor(g){g&&typeof g.logTrace=="function"&&process.env[u.a]&&(this.b=g.logTrace),g&&typeof g.logError=="function"&&(this.c=g.logError)}get isTracing(){return!!this.b}trace(g){this.b?.(g)}error(g){this.c?.(g)}}}),define(ie[162],ne([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(ie[163],ne([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[164],ne([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[165],ne([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ie[166],ne([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(ie[167],ne([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ie[168],ne([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ie[169],ne([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ie[170],ne([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[171],ne([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[172],ne([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[173],ne([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[174],ne([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ie[175],ne([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ie[176],ne([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ie[177],ne([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ie[178],ne([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ie[179],ne([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[180],ne([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ie[181],ne([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(ie[182],ne([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ie[183],ne([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ie[184],ne([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ie[185],ne([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[186],ne([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ie[187],ne([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ie[188],ne([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(ie[189],ne([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[190],ne([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ie[191],ne([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ie[192],ne([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ie[193],ne([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ie[194],ne([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ie[195],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SU=e.$RU=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$RU=P;function A(s){return s&&s.hasOwnProperty("workspace")}e.$SU=A}),define(ie[196],ne([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T6b=e.$S6b=e.$R6b=void 0;function A(C){return typeof C?.backupFolder=="string"}e.$R6b=A;function s(C){let S=[];try{Array.isArray(C.workspaces)&&(S=C.workspaces.map(u=>({workspace:{id:u.id,configPath:P.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return S}e.$S6b=s;function R(C){let S=[];try{Array.isArray(C.folders)&&(S=C.folders.map(u=>({folderUri:P.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return S}e.$T6b=R}),define(ie[197],ne([0,1,14,165]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.TokenType=void 0;var s;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(s||(e.TokenType=s={}));function R(...a){switch(a.length){case 1:return(0,A.localize)(0,null,a[0]);case 2:return(0,A.localize)(1,null,a[0],a[1]);case 3:return(0,A.localize)(2,null,a[0],a[1],a[2]);default:return}}const C=(0,A.localize)(3,null),S=(0,A.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,P.$8)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(g){return this.c=g,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(g){return this.r()||this.c.charCodeAt(this.e)!==g?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(g){this.f.push({type:g,offset:this.d})}l(g){const b=this.d,y=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:y};this.g.push({offset:b,lexeme:y,additionalInfo:g}),this.f.push(f)}n(){this.m.lastIndex=this.d;const g=this.m.exec(this.c);if(g){this.e=this.d+g[0].length;const b=this.c.substring(this.d,this.e),y=u.b.get(b);y?this.k(y):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let g=this.e,b=!1,y=!1;for(;;){if(g>=this.c.length){this.e=g,this.l(S);return}const v=this.c.charCodeAt(g);if(b)b=!1;else if(v===47&&!y){g++;break}else v===91?y=!0:v===92?b=!0:v===93&&(y=!1);g++}for(;g<this.c.length&&u.a.has(this.c.charCodeAt(g));)g++;this.e=g;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Li=u}),define(ie[198],ne([0,1,3,2]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=e.$Qn=void 0;class s{constructor(){this.a=new P.$Od,this.b=new P.$Od,this.c=new P.$Od,this.d=new P.$Od}static{this.ChannelName="extensionhostdebugservice"}call(S,u,a){switch(u){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(S,u,a){switch(u){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Qn=s;class R extends A.$Sc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,u,a){this.b.call("attach",[S,u,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,u){this.b.call("terminate",[S,u])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,u){return this.b.call("openExtensionDevelopmentHostWindow",[S,u])}}e.$Rn=R}),define(ie[199],ne([0,1,149,54,13,9,35,19,7]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.$gm=void 0,e.$gm=/^([^.]+\..+):(.+)$/;class a{get appRoot(){return(0,R.$mc)(s.$dg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,R.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,S.$wg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$wg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,P.$fm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.$jc)(this.userDataPath,"logs",f)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$wg)(u.URI.file((0,R.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$wg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$wg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$wg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=C.env.VSCODE_PORTABLE;return f?u.URI.file((0,R.$jc)(f,"argv.json")):(0,S.$wg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,R.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,R.$kc)(f):(0,R.$hc)((0,R.$jc)(s.$dg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?u.URI.file((0,R.$kc)(f)):u.URI.file((0,R.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,R.$kc)(f);const v=C.env.VSCODE_EXTENSIONS;if(v)return v;const m=C.env.VSCODE_PORTABLE;return m?(0,R.$jc)(m,"extensions"):(0,S.$wg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(v=>/^[^:/?#]+?:\/\//.test(v)?u.URI.parse(v):u.URI.file((0,R.$hc)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?u.URI.parse(f):u.URI.file((0,R.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$gm.test(f))}get extensionLogLevel(){const f=[];for(const v of this.args.log||[]){const m=e.$gm.exec(v);m&&m[1]&&m[2]&&f.push([m[1],m[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,S.$wg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=C.env.VSCODE_PORTABLE;return f?u.URI.file((0,R.$jc)(f,"policy.json")):(0,S.$wg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,v,m){this.a=f,this.b=v,this.c=m,this.editSessionId=this.args.editSessionId}}e.$hm=a,Ee([A.$ih],a.prototype,"appRoot",null),Ee([A.$ih],a.prototype,"userHome",null),Ee([A.$ih],a.prototype,"userDataPath",null),Ee([A.$ih],a.prototype,"appSettingsHome",null),Ee([A.$ih],a.prototype,"tmpDir",null),Ee([A.$ih],a.prototype,"cacheHome",null),Ee([A.$ih],a.prototype,"stateResource",null),Ee([A.$ih],a.prototype,"userRoamingDataHome",null),Ee([A.$ih],a.prototype,"userDataSyncHome",null),Ee([A.$ih],a.prototype,"sync",null),Ee([A.$ih],a.prototype,"machineSettingsResource",null),Ee([A.$ih],a.prototype,"workspaceStorageHome",null),Ee([A.$ih],a.prototype,"localHistoryHome",null),Ee([A.$ih],a.prototype,"keyboardLayoutResource",null),Ee([A.$ih],a.prototype,"argvResource",null),Ee([A.$ih],a.prototype,"isExtensionDevelopment",null),Ee([A.$ih],a.prototype,"untitledWorkspacesHome",null),Ee([A.$ih],a.prototype,"builtinExtensionsPath",null),Ee([A.$ih],a.prototype,"extensionsPath",null),Ee([A.$ih],a.prototype,"extensionDevelopmentLocationURI",null),Ee([A.$ih],a.prototype,"extensionDevelopmentKind",null),Ee([A.$ih],a.prototype,"extensionTestsLocationURI",null),Ee([A.$ih],a.prototype,"debugExtensionHost",null),Ee([A.$ih],a.prototype,"logLevel",null),Ee([A.$ih],a.prototype,"extensionLogLevel",null),Ee([A.$ih],a.prototype,"serviceMachineIdResource",null),Ee([A.$ih],a.prototype,"disableTelemetry",null),Ee([A.$ih],a.prototype,"disableWorkspaceTrust",null),Ee([A.$ih],a.prototype,"useInMemorySecretStorage",null),Ee([A.$ih],a.prototype,"policyFile",null);function g(y,f){return b(y["inspect-extensions"],y["inspect-brk-extensions"],5870,f,y.debugId,y.extensionEnvironment)}e.$im=g;function b(y,f,v,m,w,$){const h=Number(f||y)||(m?null:v),k=h?!!f:!1;let c;if($)try{c=JSON.parse($)}catch{}return{port:h,break:k,debugId:w,env:c}}e.$jm=b}),define(ie[112],ne([0,1,309,4,168]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0;const R={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Fl=["tunnel","serve-web"],e.$Gl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(m,w,$=C){const d=m.find(l=>l.length>0&&l[0]!=="-"),h={},k=["_"],c=[],i={};let o;for(const l in w){const p=w[l];p.type==="subcommand"?l===d&&(o=p):(p.alias&&(h[l]=p.alias),p.type==="string"||p.type==="string[]"?(k.push(l),p.deprecates&&k.push(...p.deprecates)):p.type==="boolean"&&(c.push(l),p.deprecates&&c.push(...p.deprecates)),p.global&&(i[l]=p))}if(o&&d){const l=i;for(const E in o.options)l[E]=o.options[E];const p=m.filter(E=>E!==d),O=$.getSubcommandReporter?$.getSubcommandReporter(d):void 0,D=S(p,l,O);return{[d]:D,_:[]}}const r=P(m,{string:k,boolean:c,alias:h}),t={},n=r;t._=r._.map(l=>String(l)).filter(l=>l.length>0),delete n._;for(const l in w){const p=w[l];if(p.type==="subcommand")continue;p.alias&&delete n[p.alias];let O=n[l];if(p.deprecates)for(const D of p.deprecates)n.hasOwnProperty(D)&&(O||(O=n[D],O&&$.onDeprecatedOption(D,p.deprecationMessage||(0,s.localize)(37,null,l))),delete n[D]);if(typeof O<"u"){if(p.type==="string[]"){if(Array.isArray(O)||(O=[O]),!p.allowEmptyValue){const D=O.filter(E=>E.length>0);D.length!==O.length&&($.onEmptyValue(l),O=D.length>0?D:void 0)}}else p.type==="string"&&(Array.isArray(O)?(O=O.pop(),$.onMultipleValues(l,O)):!O&&!p.allowEmptyValue&&($.onEmptyValue(l),O=void 0));t[l]=O,p.deprecationMessage&&$.onDeprecatedOption(l,p.deprecationMessage)}delete n[l]}for(const l in n)$.onUnknownOption(l);return t}e.$Hl=S;function u(m,w){let $="";return w.args&&(Array.isArray(w.args)?$=` <${w.args.join("> <")}>`:$=` <${w.args}>`),w.alias?`-${w.alias} --${m}${$}`:`--${m}${$}`}function a(m,w){const $=[];for(const d in m){const h=m[d],k=u(d,h);$.push([k,h.description])}return g($,w)}e.$Il=a;function g(m,w){const d=m.reduce((c,i)=>Math.max(c,i[0].length),12)+2+1;if(w-d<25)return m.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const h=w-d-1,k=[];for(const c of m){const i=c[0],o=y(c[1],h),r=b(d-i.length-2);k.push("  "+i+r+o[0]);for(let t=1;t<o.length;t++)k.push(b(d)+o[t])}return k}function b(m){return" ".repeat(m)}function y(m,w){const $=[];for(;m.length;){const d=m.length<w?m.length:m.lastIndexOf(" ",w),h=m.slice(0,d).trim();m=m.slice(d),$.push(h)}return $}function f(m,w,$,d,h){const k=process.stdout.isTTY&&process.stdout.columns||80,c=h?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",i=[`${m} ${$}`];i.push(""),i.push(`${(0,s.localize)(39,null)}: ${w} [${(0,s.localize)(40,null)}]${c}`),i.push(""),h?.noPipe!==!0&&(A.$j?i.push((0,s.localize)(41,null,w)):i.push((0,s.localize)(42,null,w)),i.push(""));const o={},r=[];for(const t in d){const n=d[t];if(n.type==="subcommand")n.description&&r.push({command:t,description:n.description});else if(n.description&&n.cat){let l=o[n.cat];l||(o[n.cat]=l={}),l[t]=n}}for(const t in o){const n=t,l=o[n];l&&(i.push(R[n]),i.push(...a(l,k)),i.push(""))}return r.length&&(i.push((0,s.localize)(43,null)),i.push(...g(r.map(t=>[t.command,t.description]),k)),i.push("")),i.join(`
`)}e.$Jl=f;function v(m,w){return`${m||(0,s.localize)(44,null)}
${w||(0,s.localize)(45,null)}
${process.arch}`}e.$Kl=v}),define(ie[200],ne([0,1,87,198,112]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=void 0;class R extends A.$Qn{constructor(S){super(),this.f=S}call(S,u,a){return u==="openExtensionDevelopmentHostWindow"?this.g(a[0],a[1]):super.call(S,u,a)}async g(S,u){const a=(0,s.$Hl)(S,s.$Gl);a.debugRenderer=u;const g=a.extensionDevelopmentPath;if(!g)return{success:!1};const[b]=await this.f.openExtensionDevelopmentHostWindow(g,{context:5,cli:a,forceProfile:a.profile,forceTempProfile:a["profile-temp"]});if(!u)return{success:!0};const y=b.win;if(!y)return{success:!0};const f=y.webContents.debugger;let v=f.isAttached()?1/0:0;const m=(0,P.createServer)(w=>{v++===0&&f.attach();let $=!1;const d=c=>{$||w.write(JSON.stringify(c)+"\0")},h=(c,i,o,r)=>d({method:i,params:o,sessionId:r});y.on("close",()=>{f.removeListener("message",h),w.end(),$=!0}),f.addListener("message",h);let k=Buffer.alloc(0);w.on("data",c=>{k=Buffer.concat([k,c]);for(let i=k.indexOf(0);i!==-1;i=k.indexOf(0)){let o;try{const r=k.slice(0,i).toString("utf8");k=k.slice(i+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}f.sendCommand(o.method,o.params,o.sessionId).then(r=>d({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>d({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),w.on("error",c=>{console.error("error on cdp pipe:",c)}),w.on("close",()=>{$=!0,--v===0&&f.detach()})});return await new Promise(w=>m.listen(0,w)),y.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.$h7b=R}),define(ie[62],ne([0,1,310,169,112]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.$Ll=void 0;function R(b,y){const f=(h,k)=>{console.warn((0,A.localize)(0,null,h,k))},v=h=>{console.warn((0,A.localize)(1,null,h))},m=(h,k)=>{console.warn((0,A.localize)(2,null,h,k))},w=h=>({onUnknownOption:k=>{s.$Fl.includes(h)||console.warn((0,A.localize)(3,null,k,h))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:m,getSubcommandReporter:s.$Fl.includes(h)?w:void 0}),$={onUnknownOption:h=>{console.warn((0,A.localize)(4,null,h))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:m,getSubcommandReporter:w},d=(0,s.$Hl)(b,s.$Gl,y?$:void 0);return d.goto&&d._.forEach(h=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(h),(0,A.localize)(5,null))),d}function C(b){const y=b.findIndex(f=>!/^-/.test(f));if(y>-1)return[...b.slice(0,y),...b.slice(y+1)]}function S(b){let[,...y]=b;process.env.VSCODE_DEV&&(y=C(y)||[]);const f=!g(process.env);return R(y,f)}e.$Ll=S;function u(b){let[,,...y]=b;return process.env.VSCODE_DEV&&(y=C(y)||[]),R(y,!0)}e.$Ml=u;function a(b,...y){const f=b.indexOf("--");return f===-1?b.push(...y):b.splice(f,0,...y),b}e.$Nl=a;function g(b){return b.VSCODE_CLI==="1"}e.$Ol=g}),function(){"use strict";function J(e,P,A){function s(C,S){const u=R(C,S),a=[u];return e.isAbsolute(u)||a.unshift(A),e.resolve(...a)}function R(C,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,S);const g=C["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(b,"AppData","Roaming")}break;case"darwin":a=e.join(P.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,S)}return{getUserDataPath:s}}if(typeof define=="function")define(ie[201],ne([113,28,35]),function(e,P,A){return J(e,P,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=J(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[90],ne([0,1,28,199,201]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=e.$km=void 0;class R extends A.$hm{constructor(a,g){super(a,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(a,g.nameShort)},g)}}e.$km=R;function C(u,a){return(0,A.$jm)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}e.$lm=C;function S(u,a){return(0,A.$jm)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}e.$mm=S}),define(ie[202],ne([0,1,45,28,33]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z8b=void 0;function R(C){const S=(0,s.$7f)((0,A.tmpdir)());try{return(0,P.writeFileSync)(S,""),C&&console.log(`Marker file for --wait created: ${S}`),S}catch(u){C&&console.error(`Failed to create marker file for --wait: ${u}`);return}}e.$z8b=R}),define(ie[203],ne([0,1,12,171]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;function s(C,S,u,a){try{R(C,S,u,a)}catch(g){C.error(g?.message??g)}return S}e.$Bp=s;function R(C,S,u,a){const g=(b,y,f)=>{const v=b[y];if((0,P.$zf)(v)){const m=v,w=m.length;if(w>1&&m[0]==="%"&&m[w-1]==="%"){const $=m.substr(1,w-2);let d=u[$];d===void 0&&a&&(d=a[$]);const h=typeof d=="string"?d:d?.message,k=a?.[$],c=typeof k=="string"?k:k?.message;if(!h){c||C.warn(`[${S.name}]: ${(0,A.localize)(0,null,$)}`);return}if(f&&(y==="title"||y==="category")&&c&&c!==h){const i={value:h,original:c};b[y]=i}else b[y]=h}}else if((0,P.$Bf)(v))for(const m in v)v.hasOwnProperty(m)&&(m==="commands"?g(v,m,!0):g(v,m,f));else if(Array.isArray(v))for(let m=0;m<v.length;m++)g(v,m,f)};for(const b in S)S.hasOwnProperty(b)&&g(S,b)}}),define(ie[204],ne([0,1,19,73,173,205]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function u($){return $=$.trim(),$==="*"||C.test($)}e.$Po=u;function a($){if(!u($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=$.match(C);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.$Qo=a;function g($){if(!$)return null;const d=$.majorBase,h=$.majorMustEqual,k=$.minorBase;let c=$.minorMustEqual;const i=$.patchBase;let o=$.patchMustEqual;$.hasCaret&&(d===0||(c=!1),o=!1);let r=0;if($.preRelease){const t=S.exec($.preRelease);if(t){const[,n,l,p]=t;r=Date.UTC(Number(n),Number(l)-1,Number(p))}}return{majorBase:d,majorMustEqual:h,minorBase:k,minorMustEqual:c,patchBase:i,patchMustEqual:o,isMinimum:$.hasGreaterEquals,notBefore:r}}e.$Ro=g;function b($,d,h){let k;typeof $=="string"?k=g(a($)):k=$;let c;d instanceof Date?c=d.getTime():typeof d=="string"&&(c=new Date(d).getTime());let i;if(typeof h=="string"?i=g(a(h)):i=h,!k||!i)return!1;const o=k.majorBase,r=k.minorBase,t=k.patchBase;let n=i.majorBase,l=i.minorBase,p=i.patchBase;const O=i.notBefore;let D=i.majorMustEqual,E=i.minorMustEqual,I=i.patchMustEqual;return i.isMinimum?o>n?!0:o<n?!1:r>l?!0:r<l||c&&c<O?!1:t>=p:(o===1&&n===0&&(!D||!E||!I)&&(n=1,l=0,p=0,D=!0,E=!1,I=!1),o<n?!1:o>n?!D:r<l?!1:r>l?!E:t<p?!1:t>p?!I:!(c&&c<O))}e.$So=b;function y($,d,h,k,c){const i=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return i.push([A.default.Error,s.localize(0,null)]),i;if(typeof k.name!="string")return i.push([A.default.Error,s.localize(1,null,"name")]),i;if(typeof k.version!="string")return i.push([A.default.Error,s.localize(2,null,"version")]),i;if(!k.engines)return i.push([A.default.Error,s.localize(3,null,"engines")]),i;if(typeof k.engines.vscode!="string")return i.push([A.default.Error,s.localize(4,null,"engines.vscode")]),i;if(typeof k.extensionDependencies<"u"&&!w(k.extensionDependencies))return i.push([A.default.Error,s.localize(5,null,"extensionDependencies")]),i;if(typeof k.activationEvents<"u"){if(!w(k.activationEvents))return i.push([A.default.Error,s.localize(6,null,"activationEvents")]),i;if(typeof k.main>"u"&&typeof k.browser>"u")return i.push([A.default.Error,s.localize(7,null,"activationEvents","main","browser")]),i}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&i.push([A.default.Warning,s.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return i.push([A.default.Error,s.localize(9,null,"main")]),i;{const t=(0,P.$wg)(h,k.main);(0,P.$qg)(t,h)||i.push([A.default.Warning,s.localize(10,null,t.path,h.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return i.push([A.default.Error,s.localize(11,null,"browser")]),i;{const t=(0,P.$wg)(h,k.browser);(0,P.$qg)(t,h)||i.push([A.default.Warning,s.localize(12,null,t.path,h.path)])}}if(!R.valid(k.version))return i.push([A.default.Error,s.localize(13,null)]),i;const o=[];if(!f($,d,k,c,o))for(const t of o)i.push([A.default.Error,t]);return i}e.$To=y;function f($,d,h,k,c){return k||typeof h.main>"u"&&typeof h.browser>"u"?!0:m($,d,h.engines.vscode,c)}e.$Uo=f;function v($,d,h){return $==="*"||m(d,h,$)}e.$Vo=v;function m($,d,h,k=[]){const c=g(a(h));if(!c)return k.push(s.localize(14,null,h)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return k.push(s.localize(15,null,h)),!1}else if(!c.majorMustEqual)return k.push(s.localize(16,null,h)),!1;return b($,d,c)?!0:(k.push(s.localize(17,null,$,h)),!1)}function w($){if(!Array.isArray($))return!1;for(let d=0,h=$.length;d<h;d++)if(typeof $[d]!="string")return!1;return!0}}),define(ie[206],ne([0,1,17,32]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;async function s(R,C,S){let u=S&&S.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const g=(await C.readFile(R.serviceMachineIdResource)).value.toString();u=(0,A.$eg)(g)?g:null}catch{u=null}if(!u){u=(0,A.$fg)();try{await C.writeFile(R.serviceMachineIdResource,P.$ce.fromString(u))}catch{}}return S?.store("storage.serviceMachineId",u,-1,1),u}e.$dp=s}),define(ie[77],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class P{constructor(s,R=[],C=!1){this.ctor=s,this.staticArguments=R,this.supportsDelayedInstantiation=C}}e.$Nh=P}),define(ie[207],ne([0,1,77]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.InstantiationType=void 0;const A=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function R(S,u,a){u instanceof P.$Nh||(u=new P.$Nh(u,[],!!a)),A.push([S,u])}e.$Ar=R;function C(){return A}e.$Br=C}),define(ie[208],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class P{constructor(R,C){this.key=R,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$fq=P;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const C of this.a.values())C.outgoing.size===0&&R.push(C);return R}insertEdge(R,C){const S=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(C);S.outgoing.set(u.key,u),u.incoming.set(S.key,S)}removeNode(R){const C=this.b(R);this.a.delete(C);for(const S of this.a.values())S.outgoing.delete(C),S.incoming.delete(C)}lookupOrInsertNode(R){const C=this.b(R);let S=this.a.get(C);return S||(S=new P(C,R),this.a.set(C,S)),S}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[C,S]of this.a)R.push(`${C}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,C]of this.a){const S=new Set([R]),u=this.c(C,S);if(u)return u}}c(R,C){for(const[S,u]of R.outgoing){if(C.has(S))return[...C,S].join(" -> ");C.add(S);const a=this.c(u,C);if(a)return a;C.delete(S)}}}e.$gq=A}),define(ie[5],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e._util=void 0;var P;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(u){return u[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(P||(e._util=P={})),e.$Ph=s("instantiationService");function A(C,S,u){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:C,index:u}):(S[P.DI_DEPENDENCIES]=[{id:C,index:u}],S[P.DI_TARGET]=S)}function s(C){if(P.serviceIds.has(C))return P.serviceIds.get(C);const S=function(u,a,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(S,u,g)};return S.toString=()=>C,P.serviceIds.set(C,S),S}e.$Qh=s;function R(C){return C}e.$Rh=R}),define(ie[78],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=void 0,e.$a7b=(0,P.$Qh)("auxiliaryWindowsMainService")}),define(ie[63],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U6b=void 0,e.$U6b=(0,P.$Qh)("backupMainService")}),define(ie[18],ne([0,1,12,7,5]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.ConfigurationTarget=e.$mi=e.$li=e.$ki=void 0,e.$ki=(0,s.$Qh)("configurationService");function R($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof A.URI)}e.$li=R;function C($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof A.URI)}e.$mi=C;var S;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function u($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ni=u;function a($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}e.$oi=a;function g($,d){const h=Object.create(null);for(const k in $)b(h,k,$[k],d);return h}e.$pi=g;function b($,d,h,k){const c=d.split("."),i=c.pop();let o=$;for(let r=0;r<c.length;r++){const t=c[r];let n=o[t];switch(typeof n){case"undefined":n=o[t]=Object.create(null);break;case"object":break;default:k(`Ignoring ${d} as ${c.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[i]=h}catch{k(`Ignoring ${d} as ${c.join(".")} is ${JSON.stringify(o)}`)}else k(`Ignoring ${d} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.$qi=b;function y($,d){const h=d.split(".");f($,h)}e.$ri=y;function f($,d){const h=d.shift();if(d.length===0){delete $[h];return}if(Object.keys($).indexOf(h)!==-1){const k=$[h];typeof k=="object"&&!Array.isArray(k)&&(f(k,d),Object.keys(k).length===0&&delete $[h])}}function v($,d,h){function k(o,r){let t=o;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const c=d.split("."),i=k($,c);return typeof i>"u"?h:i}e.$si=v;function m($,d,h){Object.keys(d).forEach(k=>{k!=="__proto__"&&(k in $?P.$Bf($[k])&&P.$Bf(d[k])?m($[k],d[k],h):h&&($[k]=d[k]):$[k]=d[k])})}e.$ti=m;function w($){return $.replace(/[\[\]]/g,"")}e.$ui=w}),define(ie[114],ne([0,1,4,27,197,5,164,14]),function(J,e,P,A,s,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ContextKeyExprType=e.$Mi=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",P.$k),u.set("isLinux",P.$l),u.set("isWindows",P.$j),u.set("isWeb",P.$p),u.set("isMacNative",P.$k&&!P.$p),u.set("isEdge",P.$H),u.set("isFirefox",P.$F),u.set("isChrome",P.$E),u.set("isSafari",P.$G);function a(L,M){if(u.get(L)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(L,M)}e.$Mi=a;const g=Object.prototype.hasOwnProperty;var b;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const y={regexParsingWithErrorRecovery:!0},f=(0,C.localize)(0,null),v=(0,C.localize)(1,null),m=(0,C.localize)(2,null),w=(0,C.localize)(3,null),$=(0,C.localize)(4,null),d=(0,C.localize)(5,null),h=(0,C.localize)(6,null),k=(0,C.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=y){this.k=M,this.d=new s.$Li,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const T=this.D(),F=T.type===17?d:void 0;throw this.h.push({message:$,offset:T.offset,lexeme:s.$Li.getLexeme(T),additionalInfo:F}),c.c}return N}catch(N){if(N!==c.c)throw N;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(16);){const N=this.o();M.push(N)}return M.length===1?M[0]:i.or(...M)}o(){const M=[this.s()];for(;this.y(15);){const N=this.s();M.push(N)}return M.length===1?M[0]:i.and(...M)}s(){if(this.y(2)){const M=this.D();switch(M.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,w),N?.negate()}case 17:return this.z(),j.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const N=this.l();return this.A(1,w),N}case 17:{const N=M.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const B=F.lexeme,V=B.lastIndexOf("/"),ae=V===B.length-1?void 0:this.w(B.substring(V+1));let de;try{de=new RegExp(B.substring(1,V),ae)}catch{throw this.B("REGEX",F)}return se.create(N,de)}switch(F.type){case 10:case 19:{const B=[F.lexeme];this.z();let V=this.D(),ae=0;for(let be=0;be<F.lexeme.length;be++)F.lexeme.charCodeAt(be)===40?ae++:F.lexeme.charCodeAt(be)===41&&ae--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:ae++;break;case 1:ae--;break;case 10:case 18:for(let be=0;be<V.lexeme.length;be++)V.lexeme.charCodeAt(be)===40?ae++:F.lexeme.charCodeAt(be)===41&&ae--}if(ae<0)break;B.push(s.$Li.getLexeme(V)),this.z(),V=this.D()}const de=B.join(""),ue=de.lastIndexOf("/"),he=ue===de.length-1?void 0:this.w(de.substring(ue+1));let ve;try{ve=new RegExp(de.substring(1,ue),he)}catch{throw this.B("REGEX",F)}return i.regex(N,ve)}case 18:{const B=F.lexeme;this.z();let V=null;if(!(0,A.$Ce)(B)){const ae=B.indexOf("/"),de=B.lastIndexOf("/");if(ae!==de&&ae>=0){const ue=B.slice(ae+1,de),he=B[de+1]==="i"?"i":"";try{V=new RegExp(ue,he)}catch{throw this.B("REGEX",F)}}}if(V===null)throw this.B("REGEX",F);return se.create(N,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const F=this.u();return i.notIn(N,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return i.equals(N,F);switch(F){case"true":return i.has(N);case"false":return i.not(N);default:return i.equals(N,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return i.notEquals(N,F);switch(F){case"true":return i.not(N);case"false":return i.has(N);default:return i.notEquals(N,F)}}case 5:return this.z(),x.create(N,this.u());case 6:return this.z(),oe.create(N,this.u());case 7:return this.z(),z.create(N,this.u());case 8:return this.z(),X.create(N,this.u());case 13:return this.z(),i.in(N,this.u());default:return i.has(N)}}case 20:throw this.h.push({message:h,offset:M.offset,lexeme:"",additionalInfo:k}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case 17:case 18:return this.z(),M.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,N){if(this.C(M))return this.z();throw this.B(N,this.D())}B(M,N,T){const F=(0,C.localize)(8,null,M,s.$Li.getLexeme(N)),B=N.offset,V=s.$Li.getLexeme(N);return this.h.push({message:F,offset:B,lexeme:V,additionalInfo:T}),c.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ni=c;class i{static false(){return n.INSTANCE}static true(){return l.INSTANCE}static has(M){return p.create(M)}static equals(M,N){return O.create(M,N)}static notEquals(M,N){return I.create(M,N)}static regex(M,N){return se.create(M,N)}static in(M,N){return D.create(M,N)}static notIn(M,N){return E.create(M,N)}static not(M){return j.create(M)}static and(...M){return K.create(M,null,!0)}static or(...M){return Q.create(M,null,!0)}static greater(M,N){return z.create(M,N)}static greaterEquals(M,N){return X.create(M,N)}static smaller(M,N){return x.create(M,N)}static smallerEquals(M,N){return oe.create(M,N)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$Oi=i;function o(L){const M=new c({regexParsingWithErrorRecovery:!1});return L.map(N=>(M.parse(N),M.lexingErrors.length>0?M.lexingErrors.map(T=>({errorMessage:T.additionalInfo?(0,C.localize)(9,null,T.additionalInfo):(0,C.localize)(10,null),offset:T.offset,length:T.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(T=>({errorMessage:T.additionalInfo?`${T.message}. ${T.additionalInfo}`:T.message,offset:T.offset,length:T.lexeme.length})):[]))}e.$Pi=o;function r(L,M){const N=L?L.substituteConstants():void 0,T=M?M.substituteConstants():void 0;return!N&&!T?!0:!N||!T?!1:N.equals(T)}e.$Qi=r;function t(L,M){return L.cmp(M)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return l.INSTANCE}}e.$Ri=n;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return n.INSTANCE}}e.$Si=l;class p{static create(M,N=null){const T=u.get(M);return typeof T=="boolean"?T?l.INSTANCE:n.INSTANCE:new p(M,N)}constructor(M,N){this.key=M,this.c=N,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:W(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=u.get(this.key);return typeof M=="boolean"?M?l.INSTANCE:n.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Ti=p;class O{static create(M,N,T=null){if(typeof N=="boolean")return N?p.create(M,T):j.create(M,T);const F=u.get(M);return typeof F=="boolean"?N===(F?"true":"false")?l.INSTANCE:n.INSTANCE:new O(M,N,T)}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=u.get(this.c);if(typeof M=="boolean"){const N=M?"true":"false";return this.d===N?l.INSTANCE:n.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ui=O;class D{static create(M,N){return new D(M,N)}constructor(M,N){this.d=M,this.f=N,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:G(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const N=M.getValue(this.f),T=M.getValue(this.d);return Array.isArray(N)?N.includes(T):typeof T=="string"&&typeof N=="object"&&N!==null?g.call(N,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Vi=D;class E{static create(M,N){return new E(M,N)}constructor(M,N){this.d=M,this.f=N,this.type=11,this.c=D.create(M,N)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Wi=E;class I{static create(M,N,T=null){if(typeof N=="boolean")return N?j.create(M,T):p.create(M,T);const F=u.get(M);return typeof F=="boolean"?N===(F?"true":"false")?n.INSTANCE:l.INSTANCE:new I(M,N,T)}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=u.get(this.c);if(typeof M=="boolean"){const N=M?"true":"false";return this.d===N?n.INSTANCE:l.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Xi=I;class j{static create(M,N=null){const T=u.get(M);return typeof T=="boolean"?T?n.INSTANCE:l.INSTANCE:new j(M,N)}constructor(M,N){this.c=M,this.d=N,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:W(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=u.get(this.c);return typeof M=="boolean"?M?n.INSTANCE:l.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$Yi=j;function U(L,M){if(typeof L=="string"){const N=parseFloat(L);isNaN(N)||(L=N)}return typeof L=="string"||typeof L=="number"?M(L):n.INSTANCE}class z{static create(M,N,T=null){return U(N,F=>new z(M,F,T))}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$Zi=z;class X{static create(M,N,T=null){return U(N,F=>new X(M,F,T))}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$1i=X;class x{static create(M,N,T=null){return U(N,F=>new x(M,F,T))}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$2i=x;class oe{static create(M,N,T=null){return U(N,F=>new oe(M,F,T))}constructor(M,N,T){this.c=M,this.d=N,this.f=T,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$3i=oe;class se{static create(M,N){return new se(M,N)}constructor(M,N){this.d=M,this.f=N,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const N=this.f?this.f.source:"",T=M.f?M.f.source:"";return N<T?-1:N>T?1:0}equals(M){if(M.type===this.type){const N=this.f?this.f.source:"",T=M.f?M.f.source:"";return this.d===M.d&&N===T}return!1}substituteConstants(){return this}evaluate(M){const N=M.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$4i=se;class ce{static create(M){return new ce(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new ce(this.c.map(M))}negate(){return this.c}}e.$5i=ce;function Y(L){let M=null;for(let N=0,T=L.length;N<T;N++){const F=L[N].substituteConstants();if(L[N]!==F&&M===null){M=[];for(let B=0;B<N;B++)M[B]=L[B]}M!==null&&(M[N]=F)}return M===null?L:M}class K{static create(M,N,T){return K.d(M,N,T)}constructor(M,N){this.expr=M,this.c=N,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let N=0,T=this.expr.length;N<T;N++){const F=t(this.expr[N],M.expr[N]);if(F!==0)return F}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let N=0,T=this.expr.length;N<T;N++)if(!this.expr[N].equals(M.expr[N]))return!1;return!0}return!1}substituteConstants(){const M=Y(this.expr);return M===this.expr?this:K.create(M,this.c,!1)}evaluate(M){for(let N=0,T=this.expr.length;N<T;N++)if(!this.expr[N].evaluate(M))return!1;return!0}static d(M,N,T){const F=[];let B=!1;for(const V of M)if(V){if(V.type===1){B=!0;continue}if(V.type===0)return n.INSTANCE;if(V.type===6){F.push(...V.expr);continue}F.push(V)}if(F.length===0&&B)return l.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(t);for(let V=1;V<F.length;V++)F[V-1].equals(F[V])&&(F.splice(V,1),V--);if(F.length===1)return F[0];for(;F.length>1;){const V=F[F.length-1];if(V.type!==9)break;F.pop();const ae=F.pop(),de=F.length===0,ue=Q.create(V.expr.map(he=>K.create([he,ae],null,T)),null,de);ue&&(F.push(ue),F.sort(t))}if(F.length===1)return F[0];if(T){for(let V=0;V<F.length;V++)for(let ae=V+1;ae<F.length;ae++)if(F[V].negate().equals(F[ae]))return n.INSTANCE;if(F.length===1)return F[0]}return new K(F,N)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const N of this.expr)M.push(...N.keys());return M}map(M){return new K(this.expr.map(N=>N.map(M)),null)}negate(){if(!this.c){const M=[];for(const N of this.expr)M.push(N.negate());this.c=Q.create(M,this,!0)}return this.c}}e.$6i=K;class Q{static create(M,N,T){return Q.d(M,N,T)}constructor(M,N){this.expr=M,this.c=N,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let N=0,T=this.expr.length;N<T;N++){const F=t(this.expr[N],M.expr[N]);if(F!==0)return F}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let N=0,T=this.expr.length;N<T;N++)if(!this.expr[N].equals(M.expr[N]))return!1;return!0}return!1}substituteConstants(){const M=Y(this.expr);return M===this.expr?this:Q.create(M,this.c,!1)}evaluate(M){for(let N=0,T=this.expr.length;N<T;N++)if(this.expr[N].evaluate(M))return!0;return!1}static d(M,N,T){let F=[],B=!1;if(M){for(let V=0,ae=M.length;V<ae;V++){const de=M[V];if(de){if(de.type===0){B=!0;continue}if(de.type===1)return l.INSTANCE;if(de.type===9){F=F.concat(de.expr);continue}F.push(de)}}if(F.length===0&&B)return n.INSTANCE;F.sort(t)}if(F.length!==0){if(F.length===1)return F[0];for(let V=1;V<F.length;V++)F[V-1].equals(F[V])&&(F.splice(V,1),V--);if(F.length===1)return F[0];if(T){for(let V=0;V<F.length;V++)for(let ae=V+1;ae<F.length;ae++)if(F[V].negate().equals(F[ae]))return l.INSTANCE;if(F.length===1)return F[0]}return new Q(F,N)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const N of this.expr)M.push(...N.keys());return M}map(M){return new Q(this.expr.map(N=>N.map(M)),null)}negate(){if(!this.c){const M=[];for(const N of this.expr)M.push(N.negate());for(;M.length>1;){const N=M.shift(),T=M.shift(),F=[];for(const B of re(N))for(const V of re(T))F.push(K.create([B,V],null,!1));M.unshift(Q.create(F,null,!1))}this.c=Q.create(M,this,!0)}return this.c}}e.$7i=Q;class q extends p{static{this.d=[]}static all(){return q.d.values()}constructor(M,N,T){super(M,null),this.f=N,typeof T=="object"?q.d.push({...T,key:M}):T!==!0&&q.d.push({key:M,description:T,type:N!=null?typeof N:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return O.create(this.key,M)}notEqualsTo(M){return I.create(this.key,M)}}e.$8i=q,e.$9i=(0,R.$Qh)("contextKeyService");function W(L,M){return L<M?-1:L>M?1:0}function G(L,M,N,T){return L<N?-1:L>N?1:M<T?-1:M>T?1:0}function H(L,M){if(L.type===0||M.type===1)return!0;if(L.type===9)return M.type===9?Z(L.expr,M.expr):!1;if(M.type===9){for(const N of M.expr)if(H(L,N))return!0;return!1}if(L.type===6){if(M.type===6)return Z(M.expr,L.expr);for(const N of L.expr)if(H(N,M))return!0;return!1}return L.equals(M)}e.$0i=H;function Z(L,M){let N=0,T=0;for(;N<L.length&&T<M.length;){const F=L[N].cmp(M[T]);if(F<0)return!1;F===0&&N++,T++}return N===L.length}function re(L){return L.type===9?L.expr:[L]}}),define(ie[91],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.ID=void 0,e.ID="diagnosticsService",e.$rm=(0,P.$Qh)(e.ID);function A(R){return!!R.hostName&&!!R.errorMessage}e.$sm=A;class s{async getPerformanceInfo(C,S){return{}}async getSystemInfo(C,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,S){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$tm=s}),define(ie[115],ne([0,1,19,73,166,5,46,4,37]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.ConfirmResult=e.$Hv=e.$Gv=e.$Fv=void 0,e.$Fv=(0,R.$Qh)("dialogService");var a;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(a||(a={}));class g{a(w){return this.d(w,a.Confirmation)}b(w){return this.d(w,a.Prompt)}c(w){return this.d(w,a.Input)}d(w,$){const d=[];switch($){case a.Confirmation:{const h=w;h.primaryButton?d.push(h.primaryButton):d.push((0,s.localize)(0,null)),h.cancelButton?d.push(h.cancelButton):d.push((0,s.localize)(1,null));break}case a.Prompt:{const h=w;Array.isArray(h.buttons)&&h.buttons.length>0&&d.push(...h.buttons.map(k=>k.label)),h.cancelButton&&(h.cancelButton===!0?d.push((0,s.localize)(2,null)):typeof h.cancelButton=="string"?d.push(h.cancelButton):h.cancelButton.label?d.push(h.cancelButton.label):d.push((0,s.localize)(3,null))),d.length===0&&d.push((0,s.localize)(4,null));break}case a.Input:{const h=w;h.primaryButton?d.push(h.primaryButton):d.push((0,s.localize)(5,null)),h.cancelButton?d.push(h.cancelButton):d.push((0,s.localize)(6,null));break}}return d}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===A.default.Info?"info":w===A.default.Error?"error":w===A.default.Warning?"warning":"none"}f(w,$,d){const h=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&h.push(w.cancelButton);let k=h[$]?.run({checkboxChecked:d});return k instanceof Promise||(k=Promise.resolve(k)),{result:k,checkboxChecked:d}}}e.$Gv=g,e.$Hv=(0,R.$Qh)("fileDialogService");var b;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const y=10;function f(m){const w=[];return w.push(...m.slice(0,y).map($=>typeof $=="string"?$:(0,P.$tg)($))),m.length>y&&(m.length-y===1?w.push((0,s.localize)(7,null)):w.push((0,s.localize)(8,null,m.length-y))),w.push(""),w.join(`
`)}e.$Iv=f;function v(m,w){const $=(0,u.$8m)(m);let d=($.buttons??[]).map(i=>(0,C.$Cv)(i)),h=(m.buttons||[]).map((i,o)=>o),k=0,c=$.cancelId??d.length-1;if(d.length>1){const i=typeof c=="number"?d[c]:void 0;if(S.$l||S.$k){if(typeof i=="string"&&d.length>1&&c!==1){d.splice(c,1),d.splice(1,0,i);const o=h[c];h.splice(c,1),h.splice(1,0,o),c=1}S.$l&&d.length>1&&(d=d.reverse(),h=h.reverse(),k=d.length-1,typeof i=="string"&&(c=k-1))}else if(S.$j&&typeof i=="string"&&d.length>1&&c!==d.length-1){d.splice(c,1),d.push(i);const o=h[c];h.splice(c,1),h.push(o),c=d.length-1}}return $.buttons=d,$.defaultId=k,$.cancelId=c,$.noLink=!0,$.title=$.title||w.nameLong,{options:$,buttonIndeces:h}}e.$Jv=v}),define(ie[116],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gU=e.$fU=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$eU=e.$dU=void 0,e.$dU=(0,P.$Qh)("encryptionService"),e.$eU=(0,P.$Qh)("encryptionMainService");var A;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(A||(e.PasswordStoreCLIOption=A={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function R(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$fU=R;function C(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$gU=C}),define(ie[36],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=void 0,e.$Xh=(0,P.$Qh)("environmentService"),e.$Yh=(0,P.$Rh)(e.$Xh)}),define(ie[117],ne([0,1,170,5]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0,e.$2n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3n=new RegExp(e.$2n),e.$4n="__web_extension",e.$5n="skipWalkthrough",e.$6n="extensionsSync",e.$7n="dependecyOrPackExtensionInstall";function s($){switch($){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$8n=s;function R($){switch($){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$9n=R;function C($,d){switch($){case 3:return d==="x64"?"win32-x64":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$0n=C;function S($,d){return d==="web"&&!$.includes("web")}e.$$n=S;function u($,d,h){return S(d,h)?!1:$==="undefined"||$==="universal"?!0:$==="unknown"?!1:$===h}e.$_n=u;function a($){return $&&typeof $=="object"&&typeof $.id=="string"&&(!$.uuid||typeof $.uuid=="string")}e.$ao=a;var g;(function($){$[$.NoneOrRelevance=0]="NoneOrRelevance",$[$.LastUpdatedDate=1]="LastUpdatedDate",$[$.Title=2]="Title",$[$.PublisherName=3]="PublisherName",$[$.InstallCount=4]="InstallCount",$[$.PublishedDate=10]="PublishedDate",$[$.AverageRating=6]="AverageRating",$[$.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var b;(function($){$[$.Default=0]="Default",$[$.Ascending=1]="Ascending",$[$.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var y;(function($){$.Install="install",$.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var f;(function($){$[$.None=1]="None",$[$.Install=2]="Install",$[$.Update=3]="Update",$[$.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$bo=(0,A.$Qh)("extensionGalleryService");var v;(function($){$.Unsupported="Unsupported",$.Deprecated="Deprecated",$.Malicious="Malicious",$.Incompatible="Incompatible",$.IncompatibleTargetPlatform="IncompatibleTargetPlatform",$.ReleaseVersionNotFound="ReleaseVersionNotFound",$.Invalid="Invalid",$.Download="Download",$.Extract="Extract",$.Delete="Delete",$.Rename="Rename",$.CorruptZip="CorruptZip",$.IncompleteZip="IncompleteZip",$.Signature="Signature",$.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var m;(function($){$.UnknownError="UnknownError",$.PackageIsInvalidZip="PackageIsInvalidZip",$.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(m||(e.ExtensionSignaturetErrorCode=m={}));class w extends Error{constructor(d,h){super(d),this.code=h,this.name=h}}e.$co=w,e.$do=(0,A.$Qh)("extensionManagementService"),e.$eo="extensionsIdentifiers/disabled",e.$fo="extensionsIdentifiers/enabled",e.$go=(0,A.$Qh)("IGlobalExtensionEnablementService"),e.$ho=(0,A.$Qh)("IExtensionTipsService"),e.$io=(0,P.localize)(0,null),e.$jo={value:e.$io,original:"Extensions"},e.$ko={value:(0,P.localize)(1,null),original:"Preferences"}}),define(ie[209],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=e.$o7b=void 0,e.$o7b=(0,P.$Qh)("extensionHostStarter"),e.$p7b="extensionHostStarter"}),define(ie[210],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yYb=e.$xYb=void 0,e.$xYb=(0,P.$Qh)("externalTerminal"),e.$yYb="Terminal.app"}),define(ie[211],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=void 0,e.$r7b=(0,P.$Qh)("externalTerminal")}),define(ie[212],ne([0,1,47,13,9,4,75,21,89,174,210]),function(J,e,P,A,s,R,C,S,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=e.$t7b=e.$s7b=void 0;const b=a.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends y{static{this.b="cmd.exe"}openTerminal(k,c){return this.spawnTerminal(P,k,u.$Cl(),c)}spawnTerminal(k,c,i,o){const r=c.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const t=s.$nc(r,".exe").toLowerCase();if(t==="cmder")return k.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),t==="wt"&&n.push("-d ."),new Promise((l,p)=>{const O=w(process),D=k.spawn(i,n,{cwd:o,env:O});D.on("error",p),D.on("exit",()=>l())})}runInTerminal(k,c,i,o,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,l)=>{const p=`"${c} - ${b}"`,O=`""${i.join('" "')}" & pause"`,D=Object.assign({},w(process),o);Object.keys(D).filter(z=>D[z]===null).forEach(z=>delete D[z]);const E={cwd:c,env:D,windowsVerbatimArguments:!0};let I,j;s.$nc(t,".exe")==="wt"?(I=t,j=["-d",".",f.b,"/c",O]):(I=f.b,j=["/c","start",p,"/wait",t,"/c",O]),P.spawn(I,j,E).on("error",z=>{l($(z))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const k=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${k?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.$s7b=f;class v extends y{static{this.b="/usr/bin/osascript"}openTerminal(k,c){return this.spawnTerminal(P,k,c)}runInTerminal(k,c,i,o,r){const t=r.osxExec||g.$yYb;return new Promise((n,l)=>{if(t===g.$yYb||t==="iTerm.app"){const p=t===g.$yYb?"TerminalHelper":"iTermHelper",D=[A.$dg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`).fsPath,"-t",k||b,"-w",c];for(const j of i)D.push("-a"),D.push(j);if(o){const j=Object.assign({},w(process),o);for(const U in j){const z=j[U];z===null?(D.push("-u"),D.push(U)):(D.push("-e"),D.push(`${U}=${z}`))}}let E="";const I=P.spawn(v.b,D);I.on("error",j=>{l($(j))}),I.stderr.on("data",j=>{E+=j.toString()}),I.on("exit",j=>{if(j===0)n(void 0);else if(E){const U=E.split(`
`,1);l(new Error(U[0]))}else l(new Error(a.localize(1,null,p,j)))})}else l(new Error(a.localize(2,null,t)))})}spawnTerminal(k,c,i){const o=c.osxExec||g.$yYb;return new Promise((r,t)=>{const n=["-a",o];i&&n.push(i);const l=w(process),p=k.spawn("/usr/bin/open",n,{cwd:i,env:l});p.on("error",t),p.on("exit",()=>r())})}}e.$t7b=v;class m extends y{static{this.b=a.localize(3,null)}openTerminal(k,c){return this.spawnTerminal(P,k,c)}runInTerminal(k,c,i,o,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((n,l)=>{const p=[];t.then(O=>{O.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const D=`${d(i)}; echo; read -p "${m.b}" -n1;`;p.push(`''${D}''`);const E=Object.assign({},w(process),o);Object.keys(E).filter(z=>E[z]===null).forEach(z=>delete E[z]);const I={cwd:c,env:E};let j="";const U=P.spawn(O,p,I);U.on("error",z=>{l($(z))}),U.stderr.on("data",z=>{j+=z.toString()}),U.on("exit",z=>{if(z===0)n(void 0);else if(j){const X=j.split(`
`,1);l(new Error(X[0]))}else l(new Error(a.localize(4,null,O,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!R.$l)m.d=Promise.resolve("xterm");else{const k=await S.Promises.exists("/etc/debian_version");m.d=new Promise(c=>{k?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return m.d}spawnTerminal(k,c,i){const o=c.linuxExec?Promise.resolve(c.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{o.then(n=>{const l=w(process),p=k.spawn(n,[],{cwd:i,env:l});p.on("error",t),p.on("exit",()=>r())})})}}e.$u7b=m;function w(h){const k={...h.env};return(0,C.$Al)(k),k}function $(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(a.localize(5,null,h.path)):h}function d(h){let k="";for(const c of h)c.indexOf(" ")>=0?k+='"'+c+'"':k+=c,k+=" ";return k}}),define(ie[16],ne([0,1,56,9,27,12,7,176,5,4,13,71]),function(J,e,P,A,s,R,C,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileKind=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileOperationResult=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileChangeType=e.$rk=e.FileOperation=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderErrorCode=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderCapabilities=e.$bk=e.FilePermission=e.FileType=e.$ak=e.$_j=void 0,e.$_j=(0,u.$Qh)("fileService");function y(H){return H.create===!0}e.$ak=y;var f;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var v;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function m(H){const Z=H;return!!Z&&typeof Z.onDidChange=="function"}e.$bk=m;var w;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function $(H){return!!(H.capabilities&2)}e.$ck=$;function d(H){return!!(H.capabilities&8)}e.$dk=d;function h(H){return!!(H.capabilities&131072)}e.$ek=h;function k(H){return!!(H.capabilities&4)}e.$fk=k;function c(H){return!!(H.capabilities&16)}e.$gk=c;function i(H){return $(H)?!!(H.capabilities&16384):!1}e.$hk=i;function o(H){return $(H)?!!(H.capabilities&32768):!1}e.$ik=o;function r(H){return!!(H.capabilities&65536)}e.$jk=r;function t(H){return!!(H.capabilities&2048)}e.$kk=t;var n;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class l extends Error{static create(Z,re){const L=new l(Z.toString(),re);return D(L,re),L}constructor(Z,re){super(Z),this.code=re}}e.$lk=l;function p(H,Z){return l.create(H,Z)}e.$mk=p;function O(H){return H||p((0,S.localize)(0,null),n.Unknown)}e.$nk=O;function D(H,Z){return H.name=Z?`${Z} (FileSystemError)`:"FileSystemError",H}e.$ok=D;function E(H){if(!H)return n.Unknown;if(H instanceof l)return H.code;const Z=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!Z)return n.Unknown;switch(Z[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$pk=E;function I(H){if(H instanceof oe)return H.fileOperationResult;switch(E(H)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$qk=I;var j;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class U{constructor(Z,re,L){this.resource=Z,this.operation=re,this.target=L}isOperation(Z){return this.operation===Z}}e.$rk=U;var z;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class X{static{this.a=null}constructor(Z,re){this.c=re,this.b=void 0,this.d=new b.$V(()=>{const L=P.$Wh.forUris(()=>this.c);return L.fill(this.rawAdded.map(M=>[M,!0])),L}),this.f=new b.$V(()=>{const L=P.$Wh.forUris(()=>this.c);return L.fill(this.rawUpdated.map(M=>[M,!0])),L}),this.g=new b.$V(()=>{const L=P.$Wh.forUris(()=>this.c);return L.fill(this.rawDeleted.map(M=>[M,!0])),L}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const L of Z){switch(L.type){case 1:this.rawAdded.push(L.resource);break;case 0:this.rawUpdated.push(L.resource);break;case 2:this.rawDeleted.push(L.resource);break}this.b!==X.a&&(typeof L.cId=="number"?this.b===void 0?this.b=L.cId:this.b!==L.cId&&(this.b=X.a):this.b!==void 0&&(this.b=X.a))}}contains(Z,...re){return this.h(Z,{includeChildren:!1},...re)}affects(Z,...re){return this.h(Z,{includeChildren:!0},...re)}h(Z,re,...L){if(!Z)return!1;const M=L.length>0;return!!((!M||L.includes(1))&&(this.d.value.get(Z)||re.includeChildren&&this.d.value.findSuperstr(Z))||(!M||L.includes(0))&&(this.f.value.get(Z)||re.includeChildren&&this.f.value.findSuperstr(Z))||(!M||L.includes(2))&&(this.g.value.findSubstr(Z)||re.includeChildren&&this.g.value.findSuperstr(Z)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Z){return this.b===Z}hasCorrelation(){return typeof this.b=="number"}}e.$sk=X;function x(H,Z,re){return!H||!Z||H===Z||Z.length>H.length?!1:(Z.charAt(Z.length-1)!==A.sep&&(Z+=A.sep),re?(0,s.$4e)(H,Z):H.indexOf(Z)===0)}e.$tk=x;class oe extends Error{constructor(Z,re,L){super(Z),this.fileOperationResult=re,this.options=L}}e.$uk=oe;class se extends oe{constructor(Z,re,L,M){super(Z,re,M),this.fileOperationResult=re,this.size=L}}e.$vk=se;class ce extends oe{constructor(Z,re,L){super(Z,2,L),this.stat=re}}e.$wk=ce;var Y;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zk="files.associations",e.$Ak="files.exclude",e.$Bk="files.readonlyInclude",e.$Ck="files.readonlyExclude",e.$Dk="files.readonlyFromPermissions";var K;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$Ek="";function Q(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.$Fk=Q;async function q(H,Z){if(!Z.hasProvider(C.URI.from({scheme:H.scheme})))return new Promise(re=>{const L=Z.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===H.scheme&&M.added&&(L.dispose(),re())})})}e.$Gk=q;class W{static{this.KB=1024}static{this.MB=W.KB*W.KB}static{this.GB=W.MB*W.KB}static{this.TB=W.GB*W.KB}static formatSize(Z){return(0,R.$Df)(Z)||(Z=0),Z<W.KB?(0,S.localize)(1,null,Z.toFixed(0)):Z<W.MB?(0,S.localize)(2,null,(Z/W.KB).toFixed(2)):Z<W.GB?(0,S.localize)(3,null,(Z/W.MB).toFixed(2)):Z<W.TB?(0,S.localize)(4,null,(Z/W.GB).toFixed(2)):(0,S.localize)(5,null,(Z/W.TB).toFixed(2))}}e.$Hk=W;function G(H){const Z=typeof H=="string"||H?.scheme===g.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===g.Schemas.file?1024*W.MB:Z?10*W.MB:a.$p?50*W.MB:1024*W.MB}e.$Ik=G}),define(ie[118],ne([0,1,17,14,177,16]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;async function C(g,b,y,f,v,m){let w;try{await S(g,b,y,f,v,m)}catch($){w=$}finally{w&&v.errorTransformer&&(w=v.errorTransformer(w)),typeof w<"u"&&y.error(w),y.end()}}e.$Qp=C;async function S(g,b,y,f,v,m){u(m);const w=await g.open(b,{create:!1});try{u(m);let $=0,d=0,h=v&&typeof v.length=="number"?v.length:void 0,k=P.$ce.alloc(Math.min(v.bufferSize,typeof h=="number"?h:v.bufferSize)),c=v&&typeof v.position=="number"?v.position:0,i=0;do d=await g.read(w,c,k.buffer,i,k.byteLength-i),c+=d,i+=d,$+=d,typeof h=="number"&&(h-=d),i===k.byteLength&&(await y.write(f(k)),k=P.$ce.alloc(Math.min(v.bufferSize,typeof h=="number"?h:v.bufferSize)),i=0);while(d>0&&(typeof h!="number"||h>0)&&u(m)&&a($,v));if(i>0){let o=i;typeof h=="number"&&(o=Math.min(i,h)),y.write(f(k.slice(0,o)))}}catch($){throw(0,R.$nk)($)}finally{await g.close(w)}}function u(g){if(g.isCancellationRequested)throw(0,A.$6)();return!0}function a(g,b){if(typeof b?.limits?.size=="number"&&g>b.limits.size)throw(0,R.$mk)((0,s.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[64],ne([0,1,104,2,9,4,7,16]),function(J,e,P,A,s,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;function u($){return $.recursive===!0}e.$Sp=u;class a extends A.$Sc{static{this.a=5}constructor(d,h,k,c){super(),this.h=d,this.j=h,this.m=k,this.n=c,this.c=this.B(new A.$Tc),this.f=void 0,this.g=0}s(){const d=new A.$Rc;this.c.value=d,this.b=this.r(d),this.b.setVerboseLogging(this.m),d.add(this.b.onDidChangeFile(h=>this.h(h))),d.add(this.b.onDidLogMessage(h=>this.j(h))),d.add(this.b.onDidError(h=>this.t(h)))}t(d){this.n.restartOnError?this.g<a.a&&this.f?(this.w(`restarting watcher after error: ${d}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${d}`):this.w(d)}u(d){this.g++,this.s(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.m=d,await this.b?.setVerboseLogging(d)}w(d){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${d}`})}y(d){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Tp=a;class g extends a{constructor(d,h,k){super(d,h,k,{type:"node.js",restartOnError:!1})}}e.$Up=g;class b extends a{constructor(d,h,k){super(d,h,k,{type:"universal",restartOnError:!0})}}e.$Vp=b;function y($){return $.map(d=>({type:d.type,resource:C.URI.revive(d.resource),cId:d.cId}))}e.$Wp=y;function f($){const d=new w;for(const h of $)d.processEvent(h);return d.coalesce()}e.$Xp=f;function v($,d){return typeof d=="string"&&!d.startsWith(P.$tj)&&!(0,s.$ic)(d)?{base:$,pattern:d}:d}e.$Yp=v;function m($,d){const h=[];for(const k of d)h.push((0,P.$xj)(v($,k)));return h}e.$Zp=m;class w{constructor(){this.a=new Set,this.b=new Map}c(d){return R.$l?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const h=this.b.get(this.c(d));let k=!1;if(h){const c=h.type,i=d.type;h.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?k=!0:c===1&&i===2?(this.b.delete(this.c(d)),this.a.delete(h)):c===2&&i===1?h.type=0:c===1&&i===0||(h.type=i)}else k=!0;k&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],h=[];return Array.from(this.a).filter(k=>k.type!==2?(d.push(k),!1):!0).sort((k,c)=>k.resource.fsPath.length-c.resource.fsPath.length).filter(k=>h.some(c=>(0,S.$tk)(k.resource.fsPath,c,!R.$l))?!1:(h.push(k.resource.fsPath),!0)).concat(d)}}}),define(ie[213],ne([0,1,17,49,14,3,2,61,32,16,64]),function(J,e,P,A,s,R,C,S,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0,e.$vN="localFilesystem";class b extends C.$Sc{constructor(f,v){super(),this.a=f,this.b=v,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.$Od),this.onDidChangeFile=this.f.event,this.g=this.B(new R.$Od),this.onDidWatchError=this.g.event,this.h=(0,u.$fg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,v){const{buffer:m}=await this.a.call("readFile",[f,v]);return m}readFileStream(f,v,m){const w=(0,S.$3d)(d=>P.$ce.concat(d.map(h=>P.$ce.wrap(h))).buffer),$=new C.$Rc;return $.add(this.a.listen("readFileStream",[f,v])(d=>{if(d instanceof P.$ce)w.write(d.buffer);else{if(d==="end")w.end();else{let h;if(d instanceof Error)h=d;else{const k=d;h=(0,a.$mk)(k.message??(0,A.$Bi)(k),k.code??a.FileSystemProviderErrorCode.Unknown)}w.error(h),w.end()}$.dispose()}})),$.add(m.onCancellationRequested(()=>{w.error((0,s.$6)()),w.end(),$.dispose()})),w}writeFile(f,v,m){return this.a.call("writeFile",[f,P.$ce.wrap(v),m])}open(f,v){return this.a.call("open",[f,v])}close(f){return this.a.call("close",[f])}async read(f,v,m,w,$){const[d,h]=await this.a.call("read",[f,v,$]);return m.set(d.buffer.slice(0,h),w),h}write(f,v,m,w,$){return this.a.call("write",[f,v,P.$ce.wrap(m),w,$])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,v){return this.a.call("delete",[f,v])}rename(f,v,m){return this.a.call("rename",[f,v,m])}copy(f,v,m){return this.a.call("copy",[f,v,m])}cloneFile(f,v){return this.a.call("cloneFile",[f,v])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const v=f;this.f.fire((0,g.$Wp)(v))}else{const v=f;this.g.fire(v)}}))}watch(f,v){const m=(0,u.$fg)();return this.a.call("watch",[this.h,m,f,v]),(0,C.$Qc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$wN=b}),define(ie[214],ne([0,1,45,8,22,33,2,85,9,4,19,7,105,21,64]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;class m extends C.$Sc{static{this.a=100}static{this.b=75}constructor(d,h,k,c){super(),this.m=d,this.n=h,this.r=k,this.s=c,this.c=this.B(new A.$0g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new A.$9g(i=>this.z(i),m.b)),this.g=(0,v.$Zp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Zp)(this.m.path,this.m.includes):void 0,this.j=new s.$Yd,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await f.Promises.stat(d);this.B(await this.w(d,h.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let h=d.path;try{h=await f.Promises.realpath(d.path),d.path===h&&(h=await(0,y.$0p)(d.path)??d.path),d.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${h})`)}catch{}return h}async w(d,h){if(a.$k&&(0,R.$Yf)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Sc.None;const k=new s.$Yd(this.j.token),c=new C.$Rc;try{const i=b.URI.file(this.m.path),o=(0,u.$nc)(d),r=(0,P.watch)(d);c.add((0,C.$Qc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${d}'`);const t=new Set;if(h)try{for(const l of await f.Promises.readdir(d))t.add(l)}catch(l){this.D(l)}const n=new Map;c.add((0,C.$Qc)(()=>{for(const[,l]of n)l.dispose();n.clear()})),r.on("error",(l,p)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${l}, ${p})`),this.dispose()}),r.on("change",(l,p)=>{if(k.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${p}`);let O="";if(p&&(O=p.toString(),a.$k&&(O=(0,S.$pl)(O))),!(!O||l!=="change"&&l!=="rename"))if(h)if(l==="rename"){n.get(O)?.dispose();const D=setTimeout(async()=>{if(n.delete(O),O===o&&!await f.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,u.$jc)(d,O));if(k.token.isCancellationRequested)return;let I;E?t.has(O)?I=0:(I=1,t.add(O)):(t.delete(O),I=2),this.y({resource:(0,g.$wg)(i,O),type:I,cId:this.m.correlationId})},m.a);n.set(O,(0,C.$Qc)(()=>clearTimeout(D)))}else{let D;t.has(O)?D=0:(D=1,t.add(O)),this.y({resource:(0,g.$wg)(i,O),type:D,cId:this.m.correlationId})}else if(l==="rename"||O!==o){const D=setTimeout(async()=>{const E=await f.Promises.exists(d);k.token.isCancellationRequested||(E?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),c.add(await this.w(d,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},m.a);c.clear(),c.add((0,C.$Qc)(()=>clearTimeout(D)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await f.Promises.exists(d)&&!k.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${i.toString()})`)}return(0,C.$Qc)(()=>{k.dispose(!0),c.dispose()})}y(d,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!h&&this.g.some(k=>k(d.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${d.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(k=>k(d.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}z(d){const h=(0,v.$Xp)(d);if(h.length>0){if(this.s)for(const c of h)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(a.$l)return f.Promises.exists(d);try{const h=(0,u.$nc)(d);return(await f.Promises.readdir((0,u.$mc)(d))).some(c=>c===h)}catch(h){return this.G(h),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$aq=m;async function w($,d,h,k,c=512){const i=await f.Promises.open($,"r"),o=Buffer.allocUnsafe(c),r=new s.$Yd(k);let t,n=!1;const l={path:$,excludes:[],recursive:!1},p=new m(l,O=>{(async()=>{for(const{type:D}of O)if(D===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await f.Promises.read(i,o,0,c,null);if(!E||r.token.isCancellationRequested)break;d(o.slice(0,E))}}catch(E){t=new Error(E),r.dispose(!0)}finally{n=!1}}})()});return await p.ready,h(),new Promise((O,D)=>{r.token.onCancellationRequested(async()=>{p.dispose();try{await f.Promises.close(i)}catch(E){t=new Error(E)}t?D(t):O()})})}e.$bq=w}),define(ie[215],ne([0,1,3,104,2,4,214]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class S extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new P.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$Od),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(a){const g=this.j(a),b=g.filter(f=>{const v=this.c.get(f.path);return v?!(0,A.$Bj)(v.request.excludes,f.excludes)||!(0,A.$Bj)(v.request.includes,f.includes):!0}),y=Array.from(this.c.values()).filter(({request:f})=>!g.find(v=>v.path===f.path&&(0,A.$Bj)(v.excludes,f.excludes)&&(0,A.$Bj)(v.includes,f.includes))).map(({request:f})=>f.path);b.length&&this.m(`Request to start watching: ${b.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const f of y)this.h(f);for(const f of b)this.g(f)}g(a){const g=new C.$aq(a,y=>this.a.fire(y),y=>this.b.fire(y),this.f),b={request:a,instance:g};this.c.set(a.path,b)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const g=this.c.get(a);g&&(this.c.delete(a),g.instance.dispose())}j(a){const g=new Map;for(const b of a){const y=R.$l?b.path:b.path.toLowerCase();let f=g.get(b.correlationId);f||(f=new Map,g.set(b.correlationId,f)),f.set(y,b)}return Array.from(g.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,g]of this.c)g.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,g){return g?`[File Watcher (node.js)] ${a} (path: ${g.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$cq=S}),define(ie[216],ne([0,1,64,215]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class s extends P.$Up{constructor(C,S,u){super(C,S,u),this.s()}r(C){return C.add(new A.$cq)}}e.$dq=s}),define(ie[217],ne([0,1,13,42,160,64]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class C extends R.$Vp{constructor(u,a,g){super(u,a,g),this.s()}r(u){const a=u.add(new s.$7p(P.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:g,signal:b})=>this.t(`terminated by itself with code ${g}, signal: ${b}`))),A.ProxyChannel.toService((0,A.$xh)(a.getChannel("watcher")))}}e.$8p=C}),define(ie[92],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=void 0;class P{constructor(...s){this.a=new Map;for(const[R,C]of s)this.set(R,C)}set(s,R){const C=this.a.get(s);return this.a.set(s,R),C}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Oh=P}),define(ie[218],ne([0,1,8,14,2,77,208,5,92,101]),function(J,e,P,A,s,R,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;const g=!1;class b extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class y{constructor(w=new u.$Oh,$=!1,d,h=g){this.f=w,this.g=$,this.h=d,this.i=h,this.o=new Set,this.f.set(S.$Ph,this),this._globalGraph=h?d?._globalGraph??new C.$gq(k=>k):void 0}createChild(w){return new y(w,this.g,this,this.i)}invokeFunction(w,...$){const d=v.traceInvocation(this.i,w);let h=!1;try{return w({get:c=>{if(h)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(c,d);if(!i)throw new Error(`[invokeFunction] unknown service '${c}'`);return i}},...$)}finally{h=!0,d.stop()}}createInstance(w,...$){let d,h;return w instanceof R.$Nh?(d=v.traceCreation(this.i,w.ctor),h=this.j(w.ctor,w.staticArguments.concat($),d)):(d=v.traceCreation(this.i,w),h=this.j(w,$,d)),d.stop(),h}j(w,$=[],d){const h=S._util.getServiceDependencies(w).sort((i,o)=>i.index-o.index),k=[];for(const i of h){const o=this.m(i.id,d);o||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${i.id}.`,!1),k.push(o)}const c=h.length>0?h[0].index:$.length;if($.length!==c){console.trace(`[createInstance] First service dependency of ${w.name} at position ${c+1} conflicts with ${$.length} static arguments`);const i=c-$.length;i>0?$=$.concat(new Array(i)):$=$.slice(0,c)}return Reflect.construct(w,$.concat(k))}k(w,$){if(this.f.get(w)instanceof R.$Nh)this.f.set(w,$);else if(this.h)this.h.k(w,$);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const $=this.f.get(w);return!$&&this.h?this.h.l(w):$}m(w,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const d=this.l(w);return d instanceof R.$Nh?this.q(w,d,$.branch(w,!0)):($.branch(w,!1),d)}q(w,$,d){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,$,d)}finally{this.o.delete(w)}}r(w,$,d){const h=new C.$gq(i=>i.id.toString());let k=0;const c=[{id:w,desc:$,_trace:d}];for(;c.length;){const i=c.pop();if(h.lookupOrInsertNode(i),k++>1e3)throw new b(h);for(const o of S._util.getServiceDependencies(i.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),r instanceof R.$Nh){const t={id:o.id,desc:r,_trace:i._trace.branch(o.id,!0)};h.insertEdge(i,t),c.push(t)}}}for(;;){const i=h.roots();if(i.length===0){if(!h.isEmpty())throw new b(h);break}for(const{data:o}of i){if(this.l(o.id)instanceof R.$Nh){const t=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,t)}h.removeNode(o)}}return this.l(w)}s(w,$,d=[],h,k){if(this.f.get(w)instanceof R.$Nh)return this.t(w,$,d,h,k);if(this.h)return this.h.s(w,$,d,h,k);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}t(w,$,d=[],h,k){if(h){const c=new y(void 0,this.g,this,this.i);c.c=String(w);const i=new Map,o=new P.$_g(()=>{const r=c.j($,d,k);for(const[t,n]of i){const l=r[t];if(typeof l=="function")for(const p of n)l.apply(r,p)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let p=i.get(t);return p||(p=new a.$2c,i.set(t,p)),(D,E,I)=>{const j=p.push([D,E,I]);return(0,s.$Qc)(j)}}if(t in r)return r[t];const n=o.value;let l=n[t];return typeof l!="function"||(l=l.bind(n),r[t]=l),l},set(r,t,n){return o.value[t]=n,!0},getPrototypeOf(r){return $.prototype}})}else return this.j($,d,k)}u(w,$){if($&&console.warn(w),this.g)throw new Error(w)}}e.$hq=y;var f;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(f||(f={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,$){return w?new v(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(w,$){return w?new v(1,$.name):v.c}static{this.f=0}constructor(w,$){this.type=w,this.name=$,this.g=Date.now(),this.h=[]}branch(w,$){const d=new v(3,w.toString());return this.h.push([w,$,d]),d}stop(){const w=Date.now()-this.g;v.f+=w;let $=!1;function d(k,c){const i=[],o=new Array(k+1).join("	");for(const[r,t,n]of c.h)if(t&&n){$=!0,i.push(`${o}CREATES -> ${r}`);const l=d(k+1,n);l&&i.push(l)}else i.push(`${o}uses -> ${r}`);return i.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(w>2||$)&&v.all.add(h.join(`
`))}}e.$iq=v}),define(ie[219],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mxb=e.IssueType=void 0;var A;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(A||(e.IssueType=A={})),e.$mxb=(0,P.$Qh)("issueService")}),define(ie[6],ne([0,1,49,3,55,2,31,4,19,12,7,114,5]),function(J,e,P,A,s,R,C,S,u,a,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.log=e.$bj=e.LogLevel=e.$aj=e.$_i=e.$$i=void 0,e.$$i=(0,y.$Qh)("logService"),e.$_i=(0,y.$Qh)("loggerService");function f(){return new Date().toISOString()}function v(D){return(0,a.$Df)(D)}e.$aj=v;var m;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$bj=m.Info;function w(D,E,I){switch(E){case m.Trace:D.trace(I);break;case m.Debug:D.debug(I);break;case m.Info:D.info(I);break;case m.Warning:D.warn(I);break;case m.Error:D.error(I);break;case m.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=w;function $(D,E=!1){let I="";for(let j=0;j<D.length;j++){let U=D[j];if(U instanceof Error&&(U=(0,P.$Bi)(U,E)),typeof U=="object")try{U=JSON.stringify(U)}catch{}I+=(j>0?" ":"")+U}return I}class d extends R.$Sc{constructor(){super(...arguments),this.b=e.$bj,this.c=this.B(new A.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==m.Off&&this.b<=E}}e.$dj=d;class h extends d{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...I){this.f(m.Trace)&&this.g(m.Trace,$([E,...I],!0))}debug(E,...I){this.f(m.Debug)&&this.g(m.Debug,$([E,...I]))}info(E,...I){this.f(m.Info)&&this.g(m.Info,$([E,...I]))}warn(E,...I){this.f(m.Warning)&&this.g(m.Warning,$([E,...I]))}error(E,...I){if(this.f(m.Error))if(E instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=E.stack,this.g(m.Error,$(j))}else this.g(m.Error,$([E,...I]))}flush(){}}e.$ej=h;class k extends d{constructor(E=e.$bj){super(),this.setLevel(E),this.g=!S.$j}trace(E,...I){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,E,...I):console.log(`[main ${f()}]`,E,...I))}debug(E,...I){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,E,...I):console.log(`[main ${f()}]`,E,...I))}info(E,...I){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,E,...I):console.log(`[main ${f()}]`,E,...I))}warn(E,...I){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,E,...I):console.warn(`[main ${f()}]`,E,...I))}error(E,...I){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,E,...I):console.error(`[main ${f()}]`,E,...I))}dispose(){}flush(){}}e.$fj=k;class c extends d{constructor(E=e.$bj,I=!0){super(),this.g=I,this.setLevel(E)}trace(E,...I){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...I):console.log(E,...I))}debug(E,...I){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...I):console.log(E,...I))}info(E,...I){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...I):console.log(E,...I))}warn(E,...I){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...I):console.log(E,...I))}error(E,...I){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...I):console.error(E,...I))}dispose(){}flush(){}}e.$gj=c;class i extends d{constructor(E,I=e.$bj){super(),this.g=E,this.setLevel(I)}trace(E,...I){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(E),...I])}debug(E,...I){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(E),...I])}info(E,...I){this.f(m.Info)&&this.g.log(m.Info,[this.h(E),...I])}warn(E,...I){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(E),...I])}error(E,...I){this.f(m.Error)&&this.g.log(m.Error,[this.h(E),...I])}h(E){return typeof E=="string"?E:(0,P.$Bi)(E,this.f(m.Trace))}dispose(){}flush(){}}e.$hj=i;class o extends d{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const I of this.g)I.setLevel(E);super.setLevel(E)}trace(E,...I){for(const j of this.g)j.trace(E,...I)}debug(E,...I){for(const j of this.g)j.debug(E,...I)}info(E,...I){for(const j of this.g)j.info(E,...I)}warn(E,...I){for(const j of this.g)j.warn(E,...I)}error(E,...I){for(const j of this.g)j.error(E,...I)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$ij=o;class r extends R.$Sc{constructor(E,I,j){if(super(),this.h=E,this.j=I,this.b=new C.$Ac,this.c=this.B(new A.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Od),this.onDidChangeVisibility=this.g.event,j)for(const U of j)this.b.set(U.resource,{logger:void 0,info:U})}m(E){return(0,a.$zf)(E)?[...this.b.values()].find(I=>I.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,I){const j=this.n(E),U=(0,a.$zf)(E)?E:I?.id??(0,s.$Ei)(j.toString()).toString(16);let z=this.b.get(j)?.logger;const X=I?.logLevel==="always"?m.Trace:I?.logLevel;z||(z=this.s(j,X??this.getLogLevel(j)??this.h,{...I,id:U}));const x={logger:z,info:{resource:j,id:U,logLevel:X,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(x.info),this.b.set(j,x),z}n(E){return(0,a.$zf)(E)?(0,u.$wg)(this.j,`${E}.log`):E}setLogLevel(E,I){if(g.URI.isUri(E)){const j=E,U=I,z=this.b.get(j);z&&U!==z.info.logLevel&&(z.info.logLevel=U===this.h?void 0:U,z.logger?.setLevel(U),this.b.set(z.info.resource,z),this.f.fire([j,U]))}else{this.h=E;for(const[j,U]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,I){const j=this.m(E);j&&I!==!j.info.hidden&&(j.info.hidden=!I,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,I]))}getLogLevel(E){let I;return E&&(I=this.b.get(E)?.info.logLevel),I??this.h}registerLogger(E){const I=this.b.get(E.resource);I?I.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const I=this.b.get(E);I&&(I.logger&&I.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jj=r;class t{constructor(){this.onDidChangeLogLevel=new A.$Od().event}setLevel(E){}getLevel(){return m.Info}trace(E,...I){}debug(E,...I){}info(E,...I){}warn(E,...I){}error(E,...I){}critical(E,...I){}dispose(){}flush(){}}e.$kj=t;class n extends t{}e.$lj=n;function l(D){if(D.verbose)return m.Trace;if(typeof D.logLevel=="string"){const E=O(D.logLevel.toLowerCase());if(E!==void 0)return E}return e.$bj}e.$mj=l;function p(D){switch(D){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$nj=p;function O(D){switch(D){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$oj=O,e.$pj=new b.$8i("logLevel",p(m.Info))});var te=this&&this.__param||function(J,e){return function(P,A){e(P,A,J)}};define(ie[220],ne([0,1,15,4,6]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n7b=void 0;const R=P.safeStorage;let C=class{constructor(u){this.a=u,P.app.commandLine.getSwitchValue("password-store")==="basic"&&R.setUsePlainTextEncryption?.(!0)}async encrypt(u){this.a.trace("[EncryptionMainService] Encrypting value.");try{const a=JSON.stringify(R.encryptString(u));return this.a.trace("[EncryptionMainService] Encrypted value."),a}catch(a){throw this.a.error(a),a}}async decrypt(u){let a;try{if(a=JSON.parse(u),!a.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${u}`);const g=Buffer.from(a.data);this.a.trace("[EncryptionMainService] Decrypting value.");const b=R.decryptString(g);return this.a.trace("[EncryptionMainService] Decrypted value."),b}catch(g){throw this.a.error(g),g}}isEncryptionAvailable(){return Promise.resolve(R.isEncryptionAvailable())}getKeyStorageProvider(){if(A.$j)return Promise.resolve("dpapi");if(A.$k)return Promise.resolve("keychain_access");if(R.getSelectedStorageBackend)try{const u=R.getSelectedStorageBackend();return Promise.resolve(u)}catch(u){this.a.error(u)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(A.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(A.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!R.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");R.setUsePlainTextEncryption(!0)}};e.$n7b=C,e.$n7b=C=Ee([te(0,s.$$i)],C)}),define(ie[221],ne([0,1,23,8,14,3,2,9,64,6]),function(J,e,P,A,s,R,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class g extends C.$Sc{constructor(y,f){super(),this.a=y,this.b=f,this.c=this.B(new R.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$Sg(0)),this.w=[],this.y=this.B(new A.$Sg(0))}watch(y,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(y,f):this.z(y,f)}n(y,f){const v={path:this.H(y),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},m=(0,P.$Ub)(this.j,v);return this.r(),(0,C.$Qc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$1)(y))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,u.$Wp)(f)),f=>this.G(f),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const f of this.j)(0,u.$Sp)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const f of this.j)(0,u.$Sp)(f)&&y.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,f){const v={path:this.H(y),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},m=(0,P.$Ub)(this.w,v);return this.C(),(0,C.$Qc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,u.$Wp)(y)),y=>this.G(y),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,S.$hc)(y.fsPath)}}e.$1p=g}),define(ie[222],ne([0,1,23,8,17,22,3,55,70,2,56,13,65,19,61,175,16,118,6,14]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;let c=class extends a.$Sc{static{k=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new C.$Od),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$Od),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$Od),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$Od),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$Od),this.Y=this.B(new C.$Od),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$Od),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$4g)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${o}`);const t=new a.$Rc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),t.add(r.onDidChangeFile(n=>{const l=new w.$sk(n,!this.S(r));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,a.$Qc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,a.$Nc)(t)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(t){r.push(t)}}),!this.h.has(o)&&await A.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const t=this.h.get(o.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return u.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,f.$Ag)(o))throw new w.$uk((0,m.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const t=new h.$bb;throw t.message=(0,m.localize)(1,null,o.toString()),t}return r}async m(o){const r=await this.j(o);if((0,w.$fk)(r)||(0,w.$ck)(r)||(0,w.$gk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,w.$fk)(r)||(0,w.$ck)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(t){throw(0,w.$pk)(t)===w.FileSystemProviderErrorCode.FileNotFound?new w.$uk((0,m.localize)(2,null,this.sb(o)),1):(0,w.$nk)(t)}}async s(o,r){const t=await this.j(o),n=this.S(t),l=r?.resolveTo,p=r?.resolveSingleChildDescendants,O=r?.resolveMetadata,D=await t.stat(o);let E;return this.t(t,o,D,void 0,!!O,(I,j)=>(E||(E=g.$Wh.forUris(()=>!n),E.set(o,!0),l&&E.fill(!0,l)),E.get(I.resource)||E.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&p?j===1:!1))}async t(o,r,t,n,l,p){const{providerExtUri:O}=this.R(o),D={resource:r,name:O.basename(r),isFile:(t.type&w.FileType.File)!==0,isDirectory:(t.type&w.FileType.Directory)!==0,isSymbolicLink:(t.type&w.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((t.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Fk)({mtime:t.mtime,size:t.size}),children:void 0};if(D.isDirectory&&p(D,n)){try{const E=await o.readdir(r),I=await A.Promises.settled(E.map(async([j,U])=>{try{const z=O.joinPath(r,j),X=l?await o.stat(z):{type:U};return await this.t(o,z,X,E.length,l,p)}catch(z){return this.b.trace(z),null}}));D.children=(0,P.$Hb)(I)}catch(E){this.b.trace(E),D.children=[]}return D}return D}async resolveAll(o){return A.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),t=await r.stat(o);return this.t(r,o,t,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(t){return t}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new w.$uk((0,m.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$ce.fromString(""),t){await this.u(o,t);const n=await this.writeFile(o,r);return this.r.fire(new w.$rk(o,0,n)),n}async writeFile(o,r,t){const n=this.qb(await this.n(o),o),{providerExtUri:l}=this.R(n);let p=t;if((0,w.$ik)(n)&&!p?.atomic){const O=n.enforceAtomicWriteFile?.(o);O&&(p={...t,atomic:O})}try{await this.w(n,o,p)||await this.U(n,l.dirname(o));let D;if((0,w.$ck)(n)&&!(r instanceof s.$ce))if((0,v.$1d)(r)){const E=await(0,v.$8d)(r,3);E.ended?D=s.$ce.concat(E.buffer):D=E}else D=(0,v.$5d)(r,E=>s.$ce.concat(E),3);else D=r;!(0,w.$fk)(n)||(0,w.$ck)(n)&&D instanceof s.$ce||(0,w.$ck)(n)&&(0,w.$ik)(n)&&p?.atomic?await this.hb(n,o,p,D):await this.db(n,o,p,D instanceof s.$ce?(0,s.$ne)(D):D),this.r.fire(new w.$rk(o,4))}catch(O){throw new w.$uk((0,m.localize)(4,null,this.sb(o),(0,w.$nk)(O).toString()),(0,w.$qk)(O),p)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,t){const n=!!t?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,m.localize)(5,null,this.sb(r)));if(!!t?.atomic){if(!(o.capabilities&32768))throw new Error((0,m.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,m.localize)(7,null,this.sb(r)));if(n)throw new Error((0,m.localize)(8,null,this.sb(r)))}let p;try{p=await o.stat(r)}catch{return}if(p.type&w.FileType.Directory)throw new w.$uk((0,m.localize)(9,null,this.sb(r)),0,t);if(this.rb(r,p),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==w.$Ek&&typeof p.mtime=="number"&&typeof p.size=="number"&&t.mtime<p.mtime&&t.etag!==(0,w.$Fk)({mtime:t.mtime,size:p.size}))throw new w.$uk((0,m.localize)(10,null),3,t);return p}async readFile(o,r,t){const n=await this.m(o);return r?.atomic?this.z(n,o,r,t):this.C(n,o,r,t)}async z(o,r,t,n){return new Promise((l,p)=>{this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{try{const O=await this.C(o,r,t,n);l(O)}catch(O){p(O)}})})}async C(o,r,t,n){const l=await this.D(o,r,{...t,preferUnbuffered:!0},n);return{...l,value:await(0,s.$oe)(l.value)}}async readFileStream(o,r,t){const n=await this.m(o);return this.D(n,o,r,t)}async D(o,r,t,n){const l=new R.$Yd(n);let p=t;(0,w.$hk)(o)&&o.enforceAtomicReadFile?.(r)&&(p={...t,atomic:!0});const O=this.J(r,p).then(E=>E,E=>{throw l.dispose(!0),E});let D;try{return typeof p?.etag=="string"&&p.etag!==w.$Ek&&await O,p?.atomic&&(0,w.$hk)(o)||!((0,w.$fk)(o)||(0,w.$gk)(o))||(0,w.$ck)(o)&&p?.preferUnbuffered?D=this.I(o,r,p):(0,w.$gk)(o)?D=this.G(o,r,l.token,p):D=this.H(o,r,l.token,p),D.on("end",()=>l.dispose()),D.on("error",()=>l.dispose()),{...await O,value:D}}catch(E){throw D&&await(0,v.$6d)(D),this.F(E,r,p)}}F(o,r,t){const n=(0,m.localize)(11,null,this.sb(r),(0,w.$nk)(o).toString());return o instanceof w.$wk?new w.$wk(n,o.stat,t):o instanceof w.$vk?new w.$vk(n,o.fileOperationResult,o.size,o.options):new w.$uk(n,(0,w.$qk)(o),t)}G(o,r,t,n=Object.create(null)){const l=o.readFileStream(r,n,t);return(0,v.$_d)(l,{data:p=>p instanceof s.$ce?p:s.$ce.wrap(p),error:p=>this.F(p,r,n)},p=>s.$ce.concat(p))}H(o,r,t,n=Object.create(null)){const l=(0,s.$se)();return(0,$.$Qp)(o,r,l,p=>p,{...n,bufferSize:this.a,errorTransformer:p=>this.F(p,r,n)},t),l}I(o,r,t){const n=(0,v.$3d)(l=>s.$ce.concat(l));return(async()=>{try{let l;t?.atomic&&(0,w.$hk)(o)?l=await o.readFile(r,{atomic:!0}):l=await o.readFile(r),typeof t?.position=="number"&&(l=l.slice(t.position)),typeof t?.length=="number"&&(l=l.slice(0,t.length)),this.L(r,l.byteLength,t),n.end(s.$ce.wrap(l))}catch(l){n.error(l),n.end()}})(),n}async J(o,r){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new w.$uk((0,m.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==w.$Ek&&r.etag===t.etag)throw new w.$wk((0,m.localize)(13,null),t,r);return this.L(o,t.size,r),t}L(o,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new w.$vk((0,m.localize)(14,null,this.sb(o)),7,r,t)}async canMove(o,r,t){return this.M(o,r,"move",t)}async canCopy(o,r,t){return this.M(o,r,"copy",t)}async M(o,r,t,n){if(o.toString()!==r.toString())try{const l=t==="move"?this.qb(await this.n(o),o):await this.m(o),p=this.qb(await this.n(r),r);await this.Q(l,o,p,r,t,n)}catch(l){return l}return!0}async move(o,r,t){const n=this.qb(await this.n(o),o),l=this.qb(await this.n(r),r),p=await this.N(n,o,l,r,"move",!!t),O=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$rk(o,p==="move"?2:3,O)),O}async copy(o,r,t){const n=await this.m(o),l=this.qb(await this.n(r),r),p=await this.N(n,o,l,r,"copy",!!t),O=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$rk(o,p==="copy"?3:2,O)),O}async N(o,r,t,n,l,p){if(r.toString()===n.toString())return l;const{exists:O,isSameResourceWithDifferentPathCase:D}=await this.Q(o,r,t,n,l,p);if(O&&!D&&p&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),l==="copy"){if(o===t&&(0,w.$dk)(o))await o.copy(r,n,{overwrite:p});else{const E=await this.resolve(r);E.isDirectory?await this.P(o,E,t,n):await this.O(o,r,t,n)}return l}else return o===t?(await o.rename(r,n,{overwrite:p}),l):(await this.N(o,r,t,n,"copy",p),await this.del(r,{recursive:!0}),"copy")}async O(o,r,t,n){if((0,w.$fk)(o)&&(0,w.$fk)(t))return this.jb(o,r,t,n);if((0,w.$fk)(o)&&(0,w.$ck)(t))return this.pb(o,r,t,n);if((0,w.$ck)(o)&&(0,w.$fk)(t))return this.nb(o,r,t,n);if((0,w.$ck)(o)&&(0,w.$ck)(t))return this.lb(o,r,t,n)}async P(o,r,t,n){await t.mkdir(n),Array.isArray(r.children)&&await A.Promises.settled(r.children.map(async l=>{const p=this.R(t).providerExtUri.joinPath(n,l.name);return l.isDirectory?this.P(o,await this.resolve(l.resource),t,p):this.O(o,l.resource,t,p)}))}async Q(o,r,t,n,l,p){let O=!1;if(o===t){const{providerExtUri:E,isPathCaseSensitive:I}=this.R(o);if(I||(O=E.isEqual(r,n)),O&&l==="copy")throw new Error((0,m.localize)(15,null,this.sb(r),this.sb(n)));if(!O&&E.isEqualOrParent(n,r))throw new Error((0,m.localize)(16,null,this.sb(r),this.sb(n)))}const D=await this.exists(n);if(D&&!O){if(!p)throw new w.$uk((0,m.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===t){const{providerExtUri:E}=this.R(o);if(E.isEqualOrParent(r,n))throw new Error((0,m.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:D,isSameResourceWithDifferentPathCase:O}}R(o){const r=this.S(o);return{providerExtUri:r?f.$mg:f.$og,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const t=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$rk(o,0,t)),t}async U(o,r){const t=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&w.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(r)));break}catch(l){if((0,w.$pk)(l)!==w.FileSystemProviderErrorCode.FileNotFound)throw l;t.push(n.basename(r)),r=n.dirname(r)}for(let l=t.length-1;l>=0;l--){r=n.joinPath(r,t[l]);try{await o.mkdir(r)}catch(p){if((0,w.$pk)(p)!==w.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(o,r){try{await this.W(o,r)}catch(t){return t}return!0}async W(o,r){const t=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,m.localize)(20,null,this.sb(o)));const l=r?.atomic;if(l&&!(t.capabilities&65536))throw new Error((0,m.localize)(21,null,this.sb(o)));if(n&&l)throw new Error((0,m.localize)(22,null,this.sb(o)));let p;try{p=await t.stat(o)}catch{}if(p)this.rb(o,p);else throw new w.$uk((0,m.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const D=await this.resolve(o);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(o)))}return t}async del(o,r){const t=await this.W(o,r);let n=r;if((0,w.$jk)(t)&&!n?.atomic){const D=t.enforceAtomicDelete?.(o);D&&(n={...r,atomic:D})}const l=!!n?.useTrash,p=!!n?.recursive,O=n?.atomic??!1;await t.delete(o,{recursive:p,useTrash:l,atomic:O}),this.r.fire(new w.$rk(o,1))}async cloneFile(o,r){const t=await this.j(o),n=this.qb(await this.n(r),r);if(t===n&&this.R(t).providerExtUri.isEqual(o,r))return;if(t===n&&(0,w.$ek)(t))return t.cloneFile(o,r);await this.U(n,this.R(n).providerExtUri.dirname(r));const l=this.cb.queueFor(o,this.R(t).providerExtUri);return t===n&&(0,w.$dk)(t)?l.queue(()=>t.copy(o,r,{overwrite:!0})):l.queue(()=>this.O(t,o,n,r))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:k.ab++})}watch(o,r={recursive:!1,excludes:[]}){const t=new a.$Rc;let n=!1,l=()=>{n=!0};t.add((0,a.$Qc)(()=>l())),(async()=>{try{const O=await this.bb(o,r);n?(0,a.$Nc)(O):l=()=>(0,a.$Nc)(O)}catch(O){this.b.error(O)}})();const p=r.correlationId;if(typeof p=="number"){const O=t.add(new C.$Od);return t.add(this.X.event(E=>{E.correlates(p)&&O.fire(E)})),{onDidChange:O.event,dispose:()=>t.dispose()}}return t}async bb(o,r){const t=await this.j(o),n=(0,S.$Ei)([this.R(t).providerExtUri.getComparisonKey(o),r]);let l=this.$.get(n);return l||(l={count:0,disposable:t.watch(o,r)},this.$.set(n,l)),l.count+=1,(0,a.$Qc)(()=>{l&&(l.count--,l.count===0&&((0,a.$Nc)(l.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,a.$Nc)(o.disposable);this.$.clear()}async db(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{const l=await o.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,v.$1d)(n)||(0,v.$2d)(n)?await this.eb(o,l,n):await this.fb(o,l,n)}catch(p){throw(0,w.$nk)(p)}finally{await o.close(l)}})}async eb(o,r,t){let n=0,l;if((0,v.$2d)(t)){if(t.buffer.length>0){const p=s.$ce.concat(t.buffer);await this.gb(o,r,p,p.byteLength,n,0),n+=p.byteLength}if(t.ended)return;l=t.stream}else l=t;return new Promise((p,O)=>{(0,v.$7d)(l,{onData:async D=>{l.pause();try{await this.gb(o,r,D,D.byteLength,n,0)}catch(E){return O(E)}n+=D.byteLength,setTimeout(()=>l.resume())},onError:D=>O(D),onEnd:()=>p()})})}async fb(o,r,t){let n=0,l;for(;(l=t.read())!==null;)await this.gb(o,r,l,l.byteLength,n,0),n+=l.byteLength}async gb(o,r,t,n,l,p){let O=0;for(;O<n;){const D=await o.write(r,l+O,t.buffer,p+O,n-O);O+=D}}async hb(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(()=>this.ib(o,r,t,n))}async ib(o,r,t,n){let l;n instanceof s.$ce?l=n:(0,v.$1d)(n)?l=await(0,s.$oe)(n):(0,v.$2d)(n)?l=await(0,s.$pe)(n):l=(0,s.$me)(n),await o.writeFile(r,l.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.kb(o,r,t,n))}async kb(o,r,t,n){let l,p;try{l=await o.open(r,{create:!1}),p=await t.open(n,{create:!0,unlock:!1});const O=s.$ce.alloc(this.a);let D=0,E=0,I=0;do I=await o.read(l,D,O.buffer,E,O.byteLength-E),await this.gb(t,p,O,I,D,E),D+=I,E+=I,E===O.byteLength&&(E=0);while(I>0)}catch(O){throw(0,w.$nk)(O)}finally{await A.Promises.settled([typeof l=="number"?o.close(l):Promise.resolve(),typeof p=="number"?t.close(p):Promise.resolve()])}}async lb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.mb(o,r,t,n))}async mb(o,r,t,n){return t.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.ob(o,r,t,n))}async ob(o,r,t,n){const l=await t.open(n,{create:!0,unlock:!1});try{const p=await o.readFile(r);await this.gb(t,l,s.$ce.wrap(p),p.byteLength,0,0)}catch(p){throw(0,w.$nk)(p)}finally{await t.close(l)}}async pb(o,r,t,n){const l=await(0,s.$oe)(this.H(o,r,R.CancellationToken.None));await this.hb(t,n,void 0,l)}qb(o,r){if(o.capabilities&2048)throw new w.$uk((0,m.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&w.FilePermission.Readonly)throw new w.$uk((0,m.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===b.Schemas.file?o.fsPath:o.toString(!0)}};e.$Rp=c,e.$Rp=c=k=Ee([te(0,d.$$i)],c)}),define(ie[93],ne([0,1,45,311,8,31,17,3,33,2,9,4,19,61,21,179,16,118,221,49,217,216]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0,(()=>{try{(0,A.gracefulify)(P)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.$Bi)(o)}`)}})();class i extends d.$1p{static{this.I=!1}constructor(r,t){super(r,t),this.onDidChangeCapabilities=S.Event.None,this.N=new R.$Ac(n=>y.$ng.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,b.$l&&(this.J|=1024)),this.J}async stat(r){try{const{stat:t,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(r));return{type:this.M(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:w.FilePermission.Locked}}catch(t){throw this.fb(t)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const t=await v.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async l=>{try{let p;l.isSymbolicLink()?p=(await this.stat((0,y.$wg)(r,l.name))).type:p=this.M(l),n.push([l.name,p])}catch(p){this.a.trace(p)}})),n}catch(t){throw this.fb(t)}}M(r,t){let n;return t?.dangling?n=w.FileType.Unknown:r.isFile()?n=w.FileType.File:r.isDirectory()?n=w.FileType.Directory:n=w.FileType.Unknown,t&&(n|=w.FileType.SymbolicLink),n}async O(r){const t=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const l=new s.$Tg;return this.N.set(r,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,a.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.N.get(r)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),l.open()})}async readFile(r,t){let n;try{t?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const l=this.H(r);return await v.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{n?.dispose()}}P(r){i.I&&this.a.trace(r)}readFileStream(r,t,n){const l=(0,f.$3d)(p=>C.$ce.concat(p.map(O=>C.$ce.wrap(O))).buffer);return(0,$.$Qp)(this,r,l,p=>p.buffer,{...t,bufferSize:256*1024},n),l}async writeFile(r,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,y.$wg)((0,y.$vg)(r),`${(0,y.$tg)(r)}${n.atomic.postfix}`),t,n):this.S(r,t,n)}async Q(r){try{const t=this.H(r),{symbolicLink:n}=await v.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async R(r,t,n,l){const p=new a.$Rc;try{p.add(await this.O(r)),p.add(await this.O(t)),await this.S(t,n,l,!0);try{await this.rename(t,r,{overwrite:!0})}catch(O){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw O}}finally{p.dispose()}}async S(r,t,n,l){let p;try{const O=this.H(r);if(!n.create||!n.overwrite){if(await v.Promises.exists(O)){if(!n.overwrite)throw(0,w.$mk)((0,m.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,w.$mk)((0,m.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:n.unlock},l),await this.write(p,0,t,0,t.byteLength)}catch(O){throw await this.gb(r,O)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(r){i.Y=r}async open(r,t,n){const l=this.H(r);let p;(0,w.$ak)(t)&&!n&&(p=await this.O(r));let O;try{if((0,w.$ak)(t)&&t.unlock)try{const{stat:E}=await v.SymlinkSupport.stat(l);E.mode&128||await v.Promises.chmod(l,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let D;if((0,w.$ak)(t)){if(b.$j)try{await v.Promises.truncate(l,0),D="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}D||(D="w")}else D="r";O=await v.Promises.open(l,D)}catch(D){throw p?.dispose(),(0,w.$ak)(t)?await this.gb(r,D):this.fb(D)}if(this.U.set(O,0),(0,w.$ak)(t)&&this.X.set(O,r),p){const D=this.W.get(O);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${O} (${l})`),this.W.set(O,p),D&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${O} (${l})`),D.dispose())}return O}async close(r){const t=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&i.Y)try{await v.Promises.fdatasync(r)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(r)}catch(n){throw this.fb(n)}finally{t&&(this.W.get(r)===t&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),t.dispose())}}async read(r,t,n,l,p){const O=this.Z(r,t);let D=null;try{D=(await v.Promises.read(r,n,l,p,O)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(r,O,D)}return D}Z(r,t){return t===this.U.get(r)?null:t}$(r,t,n){const l=this.U.get(r);typeof l=="number"&&(typeof t=="number"||(typeof n=="number"?this.U.set(r,l+n):this.U.delete(r)))}async write(r,t,n,l,p){return(0,s.$ah)(()=>this.ab(r,t,n,l,p),100,3)}async ab(r,t,n,l,p){const O=this.Z(r,t);let D=null;try{D=(await v.Promises.write(r,n,l,p,O)).bytesWritten}catch(E){throw await this.gb(this.X.get(r),E)}finally{this.$(r,O,D)}return D}async mkdir(r){try{await v.Promises.mkdir(this.H(r))}catch(t){throw this.fb(t)}}async delete(r,t){try{const n=this.H(r);if(t.recursive){let l;t?.atomic!==!1&&t.atomic.postfix&&(l=(0,g.$jc)((0,g.$mc)(n),`${(0,g.$nc)(n)}${t.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,l)}else try{await v.Promises.unlink(n)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let p=!1;try{const{stat:O,symbolicLink:D}=await v.SymlinkSupport.stat(n);p=O.isDirectory()&&!D}catch{}if(p)await v.Promises.rmdir(n);else throw l}else throw l}}catch(n){throw this.fb(n)}}async rename(r,t,n){const l=this.H(r),p=this.H(t);if(l!==p)try{await this.bb(r,t,"move",n.overwrite),await v.Promises.rename(l,p)}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,m.localize)(2,null,(0,g.$nc)(l),(0,g.$nc)((0,g.$mc)(p)),O.toString()))),this.fb(O)}}async copy(r,t,n){const l=this.H(r),p=this.H(t);if(l!==p)try{await this.bb(r,t,"copy",n.overwrite),await v.Promises.copy(l,p,{preserveSymlinks:!0})}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,m.localize)(3,null,(0,g.$nc)(l),(0,g.$nc)((0,g.$mc)(p)),O.toString()))),this.fb(O)}}async bb(r,t,n,l){const p=this.H(r),O=this.H(t);let D=!1;if(!!(this.capabilities&1024)||(D=(0,u.$Xf)(p,O,!0)),D){if(n==="copy")throw(0,w.$mk)((0,m.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.L(r);if(!I)throw(0,w.$mk)((0,m.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(t);if(j){if(!l)throw(0,w.$mk)((0,m.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);I.type&w.FileType.File&&j.type&w.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,t){return this.cb(r,t,!1)}async cb(r,t,n){const l=this.H(r),p=this.H(t),O=!!(this.capabilities&1024);if((0,u.$Xf)(l,p,!O))return;const D=new a.$Rc;try{D.add(await this.O(r)),D.add(await this.O(t)),n&&await v.Promises.mkdir((0,g.$mc)(p),{recursive:!0}),await v.Promises.copyFile(l,p)}catch(E){if(E.code==="ENOENT"&&!n)return this.cb(r,t,!0);throw this.fb(E)}finally{D.dispose()}}t(r,t,n){return new k.$8p(l=>r(l),l=>t(l),n)}F(r,t,n){return new c.$dq(l=>r(l),l=>t(l),n)}fb(r){if(r instanceof w.$lk)return r;let t=r,n;switch(r.code){case"ENOENT":n=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=w.FileSystemProviderErrorCode.Unknown;break;default:n=w.FileSystemProviderErrorCode.Unknown}return(0,w.$mk)(t,n)}async gb(r,t){let n=this.fb(t);if(r&&n.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await v.SymlinkSupport.stat(this.H(r));l.mode&128||(n=(0,w.$mk)(t,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return n}}e.$eq=i}),define(ie[223],ne([0,1,3,93,2,17,61,22]),function(J,e,P,A,s,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=void 0;class u extends s.$Sc{constructor(b,y){super(),this.a=b,this.b=y,this.F=new Map,this.G=new Map}call(b,y,f){const v=this.c(b);switch(y){case"stat":return this.g(v,f[0]);case"readdir":return this.h(v,f[0]);case"open":return this.r(v,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(v,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(v,f[0],f[1],f[2]);case"rename":return this.z(v,f[0],f[1],f[2]);case"copy":return this.C(v,f[0],f[1],f[2]);case"cloneFile":return this.D(v,f[0],f[1]);case"mkdir":return this.w(v,f[0]);case"delete":return this.y(v,f[0],f[1]);case"watch":return this.I(v,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${y} not found`)}listen(b,y,f){const v=this.c(b);switch(y){case"fileChange":return this.H(v,f[0]);case"readFileStream":return this.m(v,f[0],f[1])}throw new Error(`Unknown event ${y}`)}g(b,y){const f=this.f(b,y,!0);return this.a.stat(f)}h(b,y){const f=this.f(b,y);return this.a.readdir(f)}async j(b,y,f){const v=this.f(b,y,!0),m=await this.a.readFile(v,f);return R.$ce.wrap(m)}m(b,y,f){const v=this.f(b,y,!0),m=new S.$Yd,w=new P.$Od({onDidRemoveLastListener:()=>{m.cancel()}}),$=this.a.readFileStream(v,f,m.token);return(0,C.$7d)($,{onData:d=>w.fire(R.$ce.wrap(d)),onError:d=>w.fire(d),onEnd:()=>{w.fire("end"),w.dispose(),m.dispose()}}),w.event}n(b,y,f,v){const m=this.f(b,y);return this.a.writeFile(m,f.buffer,v)}r(b,y,f){const v=this.f(b,y,!0);return this.a.open(v,f)}s(b){return this.a.close(b)}async t(b,y,f){const v=R.$ce.alloc(f),m=0,w=await this.a.read(b,y,v.buffer,m,f);return[v,w]}u(b,y,f,v,m){return this.a.write(b,y,f.buffer,v,m)}w(b,y){const f=this.f(b,y);return this.a.mkdir(f)}y(b,y,f){const v=this.f(b,y);return this.a.delete(v,f)}z(b,y,f,v){const m=this.f(b,y),w=this.f(b,f);return this.a.rename(m,w,v)}C(b,y,f,v){const m=this.f(b,y),w=this.f(b,f);return this.a.copy(m,w,v)}D(b,y,f){const v=this.f(b,y),m=this.f(b,f);return this.a.cloneFile(v,m)}H(b,y){const f=new P.$Od({onWillAddFirstListener:()=>{this.F.set(y,this.L(b,f))},onDidRemoveLastListener:()=>{(0,s.$Nc)(this.F.get(y)),this.F.delete(y)}});return f.event}async I(b,y,f,v,m){const w=this.F.get(y);if(w){const $=this.f(b,v),d=w.watch(f,$,m);this.G.set(y+f,d)}}async J(b,y){const f=b+y,v=this.G.get(f);v&&((0,s.$Nc)(v),this.G.delete(f))}dispose(){super.dispose();for(const[,b]of this.G)b.dispose();this.G.clear();for(const[,b]of this.F)b.dispose();this.F.clear()}}e.$Mr=u;class a extends s.$Sc{constructor(b,y,f,v){super(),this.c=b,this.f=f,this.g=v,this.a=new Map,this.b=this.B(new A.$eq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(b){const y=this.B(new P.$Od);this.B(y.event(f=>{b.fire(f.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type,cId:v.cId})))})),this.B(this.b.onDidChangeFile(f=>y.fire(f))),this.B(this.b.onDidWatchError(f=>b.fire(f)))}j(b){}m(b){}watch(b,y,f){const v=this.m(this.g);return Array.isArray(v)&&(f.excludes=[...f.excludes,...v]),this.a.set(b,this.b.watch(y,f)),(0,s.$Qc)(()=>{(0,s.$Nc)(this.a.get(b)),this.a.delete(b)})}dispose(){for(const[,b]of this.a)b.dispose();this.a.clear(),super.dispose()}}e.$Nr=a}),define(ie[224],ne([0,1,15,178,4,7,16,9,223,155]),function(J,e,P,A,s,R,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=void 0;class g extends u.$Mr{constructor(f,v,m){super(f,v),this.M=m}c(f){return a.$Nm}f(f,v){return R.URI.revive(v)}async y(f,v,m){if(!m.useTrash)return super.y(f,v,m);const w=this.f(f,v),$=(0,S.$hc)(w.fsPath);try{await P.shell.trashItem($)}catch{throw(0,C.$mk)(s.$j?(0,A.localize)(0,null,(0,S.$nc)($)):(0,A.localize)(1,null,(0,S.$nc)($)),C.FileSystemProviderErrorCode.Unknown)}}L(f,v){return new b(f,v,this.b,this.M)}}e.$v7b=g;class b extends u.$Nr{watch(f,v,m){if(m.recursive)throw(0,C.$mk)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(f,v,m)}}}),define(ie[225],ne([0,1,6]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l4b=void 0;class A extends P.$ej{constructor(R=P.$bj){super(),this.m=[],this.n=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(C=>{this.n?.setLevel(C)}))}set logger(R){this.n=R;for(const{level:C,message:S}of this.m)(0,P.log)(R,C,S);this.m=[]}g(R,C){this.n?(0,P.log)(this.n,R,C):this.getLevel()<=R&&this.m.push({level:R,message:C})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$l4b=A}),define(ie[226],ne([0,1,7,3,6,2]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.$cr=void 0;class C extends s.$jj{constructor(b,y,f,v,m){super(y,f,v),this.r=b,this.t=m,this.B(m.listen("onDidChangeLogLevel",b)(w=>{(0,s.$aj)(w)?super.setLogLevel(w):super.setLogLevel(P.URI.revive(w[0]),w[1])})),this.B(m.listen("onDidChangeVisibility",b)(([w,$])=>super.setVisibility(P.URI.revive(w),$))),this.B(m.listen("onDidChangeLoggers",b)(({added:w,removed:$})=>{for(const d of w)super.registerLogger({...d,resource:P.URI.revive(d.resource)});for(const d of $)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new s.$hj({log:(b,y)=>{this.t.call("consoleLog",[b,y])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,y){super.setLogLevel(b,y),this.t.call("setLogLevel",[b,y])}setVisibility(b,y){super.setVisibility(b,y),this.t.call("setVisibility",[this.n(b),y])}s(b,y,f){return new S(this.t,b,y,f,this.r)}static setLogLevel(b,y,f){return b.call("setLogLevel",[y,f])}}e.$cr=C;class S extends s.$ej{constructor(b,y,f,v,m){super(v?.logLevel==="always"),this.r=b,this.s=y,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[y,v,m]).then(()=>{this.u(this.n),this.m=!0})}g(b,y){const f=[[b,y]];this.m?this.u(f):this.n.push(...f)}u(b){this.r.call("log",[this.s,b])}}class u{constructor(b,y){this.a=b,this.b=y}listen(b,y){const f=this.b(b);switch(y){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map(m=>this.c(m,f)),removed:[...v.removed].map(m=>this.c(m,f))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,v=>[f.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,v=>(0,s.$aj)(v)?v:[f.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${y}`)}async call(b,y,f){const v=this.b(b);switch(y){case"setLogLevel":return(0,s.$aj)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(P.URI.revive(v.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,v)))}throw new Error(`Call not found: ${y}`)}c(b,y){return{...b,resource:y.transformOutgoingURI(b.resource)}}}e.$dr=u;class a extends R.$Sc{constructor(b,y){super(),y.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(f=>y.call("setLogLevel",[f]))),y.call("getRegisteredLoggers").then(f=>{for(const v of f)b.registerLogger({...v,resource:P.URI.revive(v.resource)})}),this.B(y.listen("onDidChangeVisibility")(([f,v])=>b.setVisibility(P.URI.revive(f),v))),this.B(y.listen("onDidChangeLoggers")(({added:f,removed:v})=>{for(const m of f)b.registerLogger({...m,resource:P.URI.revive(m.resource)});for(const m of v)b.deregisterLogger(m.resource)}))}}e.$er=a}),define(ie[227],ne([0,1,2,6]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;class s extends P.$Sc{constructor(C,S=[]){super(),this.a=new A.$ij([C,...S]),this.B(C.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...S){this.a.trace(C,...S)}debug(C,...S){this.a.debug(C,...S)}info(C,...S){this.a.info(C,...S)}warn(C,...S){this.a.warn(C,...S)}error(C,...S){this.a.error(C,...S)}flush(){this.a.flush()}}e.$NN=s}),define(ie[228],ne([0,1,31,7,6]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=void 0;class R{constructor(S){this.b=S,this.a=new P.$Ac}listen(S,u,a){switch(u){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${u}`)}async call(S,u,a){switch(u){case"createLogger":this.c(A.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(A.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,s.$aj)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(A.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(A.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:A.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(A.URI.revive(a[0]))}throw new Error(`Call not found: ${u}`)}c(S,u,a){this.a.set(S,this.b.createLogger(S,u,a))}d(S,u){let a=console.log;switch(S){case s.LogLevel.Error:a=console.error;break;case s.LogLevel.Warning:a=console.warn;break;case s.LogLevel.Info:a=console.info;break}a.call(console,...u)}e(S,u){const a=this.a.get(S);if(!a)throw new Error("Create the logger before logging");for(const[g,b]of u)(0,s.log)(a,g,b)}}e.$p8b=R}),define(ie[229],ne([0,1,16,6]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;var s;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(s||(s={}));async function R(a,g,b,y,f){try{const v=await new Promise((w,$)=>{J(["@vscode/spdlog"],w,$)});v.setFlushOn(s.Trace);const m=await v.createAsyncRotatingLogger(a,g,b,y);return f?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(v){console.error(v)}return null}function C(a,g,b){switch(g){case A.LogLevel.Trace:a.trace(b);break;case A.LogLevel.Debug:a.debug(b);break;case A.LogLevel.Info:a.info(b);break;case A.LogLevel.Warning:a.warn(b);break;case A.LogLevel.Error:a.error(b);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function S(a,g){switch(g){case A.LogLevel.Trace:a.setLevel(s.Trace);break;case A.LogLevel.Debug:a.setLevel(s.Debug);break;case A.LogLevel.Info:a.setLevel(s.Info);break;case A.LogLevel.Warning:a.setLevel(s.Warning);break;case A.LogLevel.Error:a.setLevel(s.Error);break;case A.LogLevel.Off:a.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class u extends A.$ej{constructor(g,b,y,f,v){super(),this.m=[],this.setLevel(v),this.n=this.s(g,b,y,f),this.B(this.onDidChangeLogLevel(m=>{this.r&&S(this.r,m)}))}async s(g,b,y,f){const v=y?6:1,m=30/v*P.$Hk.MB,w=await R(g,b,m,v,f);if(w){this.r=w,S(this.r,this.getLevel());for(const{level:$,message:d}of this.m)C(this.r,$,d);this.m=[]}}g(g,b){this.r?C(this.r,g,b):this.getLevel()<=g&&this.m.push({level:g,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$CN=u}),define(ie[230],ne([0,1,32,6,229]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;class R extends A.$jj{s(S,u,a){return new s.$CN((0,P.$fg)(),S.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$DN=R}),define(ie[66],ne([0,1,31,3,5,6,230]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=e.$86b=void 0,e.$86b=(0,s.$Rh)(R.$_i);class S extends C.$DN{constructor(){super(...arguments),this.u=new P.$Ac}createLogger(a,g,b){b!==void 0&&this.u.set(this.n(a),b);try{return super.createLogger(a,g)}catch(y){throw this.u.delete(this.n(a)),y}}registerLogger(a,g){g!==void 0&&this.u.set(a.resource,g),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const g=[];for(const b of super.getRegisteredLoggers())a===this.u.get(b.resource)&&g.push(b);return g}getOnDidChangeLogLevelEvent(a){return A.Event.filter(this.onDidChangeLogLevel,g=>(0,R.$aj)(g)||this.w(g[0],a))}getOnDidChangeVisibilityEvent(a){return A.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,a))}getOnDidChangeLoggersEvent(a){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(y=>this.w(y.resource,a)),removed:[...g.removed].filter(y=>this.w(y.resource,a))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(a){for(const[g,b]of this.u)b===a&&this.deregisterLogger(g)}w(a,g){const b=this.u.get(a);return b===void 0||b===g}dispose(){super.dispose(),this.u.clear()}}e.$96b=S}),define(ie[231],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K7b=e.$J7b=e.$I7b=e.$H7b=void 0;function P(C){return C.submenu!==void 0}e.$H7b=P;function A(C){return C.id==="vscode.menubar.separator"}e.$I7b=A;function s(C){return C.uri!==void 0}e.$J7b=s;function R(C){return!P(C)&&!A(C)&&!s(C)}e.$K7b=R}),define(ie[39],ne([0,1,3,70,2,5]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=void 0,e.$mn=(0,R.$Qh)("policy");class C extends s.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$Od),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const g=Object.keys(this.f).length;return this.f={...a,...this.f},g!==Object.keys(this.f).length&&await this.j(a),A.Iterable.reduce(this.g.entries(),(b,[y,f])=>({...b,[y]:f}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(a,[g,b])=>({...a,[g]:{definition:b,value:this.g.get(g)}}),{})}}e.$nn=C;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$on=S}),define(ie[232],ne([0,1,8,3,70,12,16,6,39]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I8b=void 0;function a(b,y){const f=[];for(const v of new Set(s.Iterable.concat(b.keys(),y.keys())))b.get(v)!==y.get(v)&&f.push(v);return f}let g=class extends u.$nn{constructor(y,f,v){super(),this.m=y,this.n=f,this.s=v,this.c=this.B(new P.$Sg(500));const m=A.Event.filter(f.onDidFilesChange,w=>w.affects(y));this.B(f.watch(y)),this.B(m(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const f=await this.n.readFile(this.m),v=JSON.parse(f.value.toString());if(!(0,R.$Bf)(v))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(v))this.f[m]&&y.set(m,v[m])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return y}async w(){const y=await this.u(),f=a(this.g,y);this.g=y,f.length>0&&this.h.fire(f)}};e.$I8b=g,e.$I8b=g=Ee([te(1,C.$_j),te(2,S.$$i)],g)}),define(ie[233],ne([0,1,3,2,39]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h8b=e.$g8b=void 0;class R{constructor(u){this.b=u,this.a=new A.$Rc}listen(u,a){switch(a){case"onDidChange":return P.Event.map(this.b.onDidChange,g=>g.reduce((b,y)=>({...b,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(u,a,g){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$g8b=R;class C extends s.$nn{constructor(u,a){super(),this.a=a;for(const g in u){const{definition:b,value:y}=u[g];this.f[g]=b,y!==void 0&&this.g.set(g,y)}this.a.listen("onDidChange")(g=>{for(const b in g){const y=g[b];y===null?this.g.delete(b):this.g.set(b,y)}this.h.fire(Object.keys(g))})}async j(u){const a=await this.a.call("updatePolicyDefinitions",u);for(const g in a)this.g.set(g,a[g])}}e.$h8b=C}),define(ie[234],ne([0,1,39,8,312,2,6]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=void 0;let S=class extends P.$nn{constructor(a,g){super(),this.m=a,this.n=g,this.a=new A.$Og,this.b=this.B(new R.$Tc)}async j(a){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(a).length} policy definitions`),await this.a.queue(()=>new Promise((g,b)=>{try{this.b.value=(0,s.createWatcher)(this.n,a,y=>{this.t(y),g()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),b(y)}}))}t(a){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(a)}`);for(const g in a){const b=a[g];b===void 0?this.g.delete(g):this.g.set(g,b)}this.h.fire(Object.keys(a))}};e.$H8b=S,e.$H8b=S=Ee([te(0,C.$$i)],S)}),define(ie[79],ne([0,1,4,35]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof P.$h.vscode<"u"&&typeof P.$h.vscode.context<"u"){const R=P.$h.vscode.context.configuration();if(R)s=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:R.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(ie[25],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=void 0,e.$qj=(0,P.$Qh)("productService"),e.$rj="vscode://schemas/vscode-product"}),define(ie[235],ne([0,1,8,6]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=void 0;let s=class{constructor(C,S,u){this.a=C,this.b=S,this.c=u}async inspect(C){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$Vg)(C);const u=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),u.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.$y7b=s,e.$y7b=s=Ee([te(2,A.$$i)],s)}),define(ie[80],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=void 0,e.$X6b=(0,P.$Qh)("protocolMainService")}),define(ie[43],ne([0,1,137,12]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0;class s{constructor(){this.a=new Map}add(C,S){P.ok(A.$zf(C)),P.ok(A.$Bf(S)),P.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,S)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$kn=new s}),define(ie[236],ne([0,1,3,43]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0,e.$ln={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class R{constructor(){this.b=new P.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[s(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const C=new R;A.$kn.add(e.$ln.JSONContribution,C)}),define(ie[57],ne([0,1,23,3,12,163,18,236,43]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ConfigurationScope=e.$pn=e.EditPresentationTypes=void 0;var a;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$pn={Configuration:"base.contributions.configuration"};var g;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn="vscode://schemas/settings/resourceLanguage",e.$xn="vscode://schemas/settings/configurationDefaults";const b=u.$kn.as(S.$ln.JSONContribution);class y{constructor(){this.h=new Set,this.i=new A.$Od,this.onDidSchemaChange=this.i.event,this.j=new A.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$wn,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const r=new Set;this.n(i,o,r),b.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const o=new Set;this.o(i,o),b.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const r=new Set;this.o(o,r),this.n(i,!1,r),b.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const r=[];for(const{overrides:t,source:n}of i)for(const l in t)if(o.add(l),e.$zn.test(l)){const p=this.a.get(l),O=p?.valuesSources??new Map;if(n)for(const j of Object.keys(t[l]))O.set(j,n);const D={...p?.value||{},...t[l]};this.a.set(l,{source:n,value:D,valuesSources:O});const E=(0,C.$ui)(l),I={type:"object",default:D,description:R.localize(1,null,E),$ref:e.$wn,defaultDefaultValue:D,source:s.$zf(n)?void 0:n,defaultValueSource:n};r.push(...m(l)),this.d[l]=I,this.b.properties[l]=I}else{this.a.set(l,{value:t[l],source:n});const p=this.d[l];p&&(this.w(l,p),this.r(l,p))}this.m(r)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:r,source:t}of i)for(const n in r){const l=this.a.get(n),p=s.$zf(t)?t:t?.id,O=s.$zf(l?.source)?l?.source:l?.source?.id;if(p===O)if(o.add(n),this.a.delete(n),e.$zn.test(n))delete this.d[n],delete this.b.properties[n];else{const D=this.d[n];D&&(this.w(n,D),this.r(n,D))}}this.u()}deltaConfiguration(i){let o=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,r){i.forEach(t=>{this.p(t,o,t.extensionInfo,t.restrictedProperties,void 0,r),this.c.push(t),this.q(t)})}o(i,o){const r=t=>{if(t.properties)for(const n in t.properties){o.add(n);const l=this.d[n];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>r(n))};for(const t of i){r(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,o=!0,r,t,n=3,l){n=s.$If(i.scope)?n:i.scope;const p=i.properties;if(p)for(const D in p){const E=p[D];if(o&&h(D,E)){delete p[D];continue}if(E.source=r,E.defaultDefaultValue=p[D].default,this.w(D,E),e.$zn.test(D)?E.scope=void 0:(E.scope=s.$If(E.scope)?n:E.scope,E.restricted=s.$If(E.restricted)?!!t?.includes(D):E.restricted),p[D].hasOwnProperty("included")&&!p[D].included){this.f[D]=p[D],delete p[D];continue}else this.d[D]=p[D],p[D].policy?.name&&this.e.set(p[D].policy.name,D);!p[D].deprecationMessage&&p[D].markdownDeprecationMessage&&(p[D].deprecationMessage=p[D].markdownDeprecationMessage),l.add(D)}const O=i.allOf;if(O)for(const D of O)this.p(D,o,r,t,n,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=r=>{const t=r.properties;if(t)for(const l in t)this.r(l,t[l]);r.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$qn.properties[i]=o,o.scope){case 1:e.$rn.properties[i]=o;break;case 2:e.$sn.properties[i]=o;break;case 6:e.$tn.properties[i]=o;break;case 3:e.$un.properties[i]=o;break;case 4:e.$vn.properties[i]=o;break;case 5:e.$vn.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$qn.properties[i],o.scope){case 1:delete e.$rn.properties[i];break;case 2:delete e.$sn.properties[i];break;case 6:delete e.$tn.properties[i];break;case 3:delete e.$un.properties[i];break;case 4:case 5:delete e.$vn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$wn};this.w(o,r),e.$qn.properties[o]=r,e.$rn.properties[o]=r,e.$sn.properties[o]=r,e.$tn.properties[o]=r,e.$un.properties[o]=r,e.$vn.properties[o]=r}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$wn};e.$qn.patternProperties[e.$yn]=i,e.$rn.patternProperties[e.$yn]=i,e.$sn.patternProperties[e.$yn]=i,e.$tn.patternProperties[e.$yn]=i,e.$un.patternProperties[e.$yn]=i,e.$vn.patternProperties[e.$yn]=i,this.i.fire()}w(i,o){const r=this.a.get(i);let t=r?.value,n=r?.source;s.$Gf(t)&&(t=o.defaultDefaultValue,n=void 0),s.$Gf(t)&&(t=$(o.type)),o.default=t,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",v=new RegExp(f,"g");e.$yn=`^(${f})+$`,e.$zn=new RegExp(e.$yn);function m(c){const i=[];if(e.$zn.test(c)){let o=v.exec(c);for(;o?.length;){const r=o[1].trim();r&&i.push(r),o=v.exec(c)}}return(0,P.$Mb)(i)}e.$An=m;function w(c){return c.reduce((i,o)=>`${i}[${o}]`,"")}e.$Bn=w;function $(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Cn=$;const d=new y;u.$kn.add(e.$pn.Configuration,d);function h(c,i){return c.trim()?e.$zn.test(c)?R.localize(7,null,c):d.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,c,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.$Dn=h;function k(){const c=[],i=d.getConfigurationProperties();for(const o of Object.keys(i))c.push([o,i[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$En=k}),define(ie[119],ne([0,1,23,3,44,2,31,37,12,7,18,57,43]),function(J,e,P,A,s,R,C,S,u,a,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function f(o){return Object.isFrozen(o)?o:S.$9m(o)}class v{constructor(r={},t=[],n=[],l){this.b=r,this.c=t,this.d=n,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof v)return t;const n=new m("");return n.parseRaw(t),n.configurationModel});this.f=r.reduce((t,n)=>n===t?n:t.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,g.$si)(this.contents,r):this.contents}inspect(r,t){const n=this.rawConfiguration.getValue(r),l=t?this.rawConfiguration.getOverrideValue(r,t):void 0,p=t?this.rawConfiguration.override(t).getValue(r):n;return{value:n,override:l,merged:p}}getOverrideValue(r,t){const n=this.i(t);return n?r?(0,g.$si)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const n of this.overrides)n.identifiers.includes(r)&&t.push(...n.keys);return P.$Mb(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return P.$Mb(r)}override(r){let t=this.a.get(r);return t||(t=this.g(r),this.a.set(r,t)),t}merge(...r){const t=S.$8m(this.contents),n=S.$8m(this.overrides),l=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const O of r)if(p.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.h(t,O.contents);for(const D of O.overrides){const[E]=n.filter(I=>P.$ub(I.identifiers,D.identifiers));E?(this.h(E.contents,D.contents),E.keys.push(...D.keys),E.keys=P.$Mb(E.keys)):n.push(S.$8m(D))}for(const D of O.keys)l.indexOf(D)===-1&&l.push(D)}return new v(t,l,n,p.every(O=>O instanceof v)?void 0:p)}g(r){const t=this.i(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const l of P.$Mb([...Object.keys(this.contents),...Object.keys(t)])){let p=this.contents[l];const O=t[l];O&&(typeof p=="object"&&typeof O=="object"?(p=S.$8m(p),this.h(p,O)):p=O),n[l]=p}return new v(n,this.keys,this.overrides)}h(r,t){for(const n of Object.keys(t)){if(n in r&&u.$Bf(r[n])&&u.$Bf(t[n])){this.h(r[n],t[n]);continue}r[n]=S.$8m(t[n])}}i(r){let t=null,n=null;const l=p=>{p&&(n?this.h(n,p):n=S.$8m(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===r?t=p.contents:p.identifiers.includes(r)&&l(p.contents);return l(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,t){this.j(r,t,!0)}setValue(r,t){this.j(r,t,!1)}removeValue(r){const t=this.keys.indexOf(r);t!==-1&&(this.keys.splice(t,1),(0,g.$ri)(this.contents,r),b.$zn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.$ub(n.identifiers,(0,b.$An)(r))),1))}j(r,t,n){(0,g.$qi)(this.contents,r,t,l=>console.error(l)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),b.$zn.test(r)&&this.overrides.push({identifiers:(0,b.$An)(r),keys:Object.keys(this.contents[r]),contents:(0,g.$pi)(this.contents[r],l=>console.error(l))})}}e.$Fn=v;class m{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!u.$If(r)){const n=this.g(r);this.parseRaw(n,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:n,keys:l,overrides:p,restricted:O,hasExcludedProperties:D}=this.h(r,t);this.b=new v(n,l,p,D?[r]:void 0),this.c=O||[]}g(r){let t={},n=null,l=[];const p=[],O=[];function D(I){Array.isArray(l)?l.push(I):n!==null&&(l[n]=I)}const E={onObjectBegin:()=>{const I={};D(I),p.push(l),l=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{l=p.pop()},onArrayBegin:()=>{const I=[];D(I),p.push(l),l=I,n=null},onArrayEnd:()=>{l=p.pop()},onLiteralValue:D,onError:(I,j,U)=>{O.push({error:I,offset:j,length:U})}};if(r)try{s.$5m(r,E),t=l[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return t}h(r,t){const n=y.$kn.as(b.$pn.Configuration).getConfigurationProperties(),l=this.i(r,n,!0,t);r=l.raw;const p=(0,g.$pi)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),O=Object.keys(r),D=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:p,keys:O,overrides:D,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(r,t,n,l){let p=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:p};const O={},D=[];for(const E in r)if(b.$zn.test(E)&&n){const I=this.i(r[E],t,!1,l);O[E]=I.raw,p=p||I.hasExcludedProperties,D.push(...I.restricted)}else{const I=t[E],j=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&D.push(E),!l.exclude?.includes(E)&&(l.include?.includes(E)||(j===void 0||l.scopes===void 0||l.scopes.includes(j))&&!(l.skipRestricted&&I?.restricted))?O[E]=r[E]:p=!0}return{raw:O,restricted:D,hasExcludedProperties:p}}j(r,t){const n=[];for(const l of Object.keys(r))if(b.$zn.test(l)){const p={};for(const O in r[l])p[O]=r[l][O];n.push({identifiers:(0,b.$An)(l),keys:Object.keys(p),contents:(0,g.$pi)(p,t)})}return n}}e.$Gn=m;class w extends R.$Sc{constructor(r,t,n,l){super(),this.c=r,this.f=t,this.g=l,this.b=this.B(new A.$Od),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&n.isEqual(p.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Hn=w;class ${constructor(r,t,n,l,p,O,D,E,I,j,U,z,X){this.a=r,this.b=t,this.c=n,this.overrideIdentifiers=l,this.d=p,this.f=O,this.g=D,this.h=E,this.i=I,this.j=j,this.k=U,this.l=z,this.m=X}get value(){return f(this.c)}n(r,t,n){const l=r.inspect(t,n);return{get value(){return f(l.value)},get override(){return f(l.override)},get merged(){return f(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(r,t,n,l,p=new v,O=new v,D=new C.$Ac,E=new v,I=new C.$Ac){this.c=r,this.d=t,this.f=n,this.g=l,this.h=p,this.i=O,this.j=D,this.l=E,this.m=I,this.a=null,this.b=new C.$Ac,this.n=null}getValue(r,t,n){return this.q(r,t,n).getValue(r)}updateValue(r,t,n={}){let l;n.resource?(l=this.m.get(n.resource),l||(l=new v,this.m.set(n.resource,l))):l=this.l,t===void 0?l.removeValue(r):l.setValue(r,t),n.resource||(this.a=null)}inspect(r,t,n){const l=this.q(r,t,n),p=this.u(t.resource,n),O=t.resource?this.m.get(t.resource)||this.l:this.l,D=new Set;for(const E of l.overrides)for(const I of E.identifiers)l.getOverrideValue(r,I)!==void 0&&D.add(I);return new $(r,t,l.getValue(r),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,p||void 0,O)}keys(r){const t=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.j.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const n=[];if(!t){const{added:l,updated:p,removed:O}=c(this.c,r);t=[...l,...p,...O]}for(const l of t)for(const p of(0,b.$An)(l)){const O=this.c.getKeysForOverrideIdentifier(p),D=r.getKeysForOverrideIdentifier(p),E=[...D.filter(I=>O.indexOf(I)===-1),...O.filter(I=>D.indexOf(I)===-1),...O.filter(I=>!S.$_m(this.c.override(p).getValue(I),r.override(p).getValue(I)))];n.push([p,E])}return this.updateDefaultConfiguration(r),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:n,removed:l}=c(this.d,r),p=[...t,...n,...l];return p.length&&this.updatePolicyConfiguration(r),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:n,removed:l,overrides:p}=c(this.applicationConfiguration,r),O=[...t,...n,...l];return O.length&&this.updateApplicationConfiguration(r),{keys:O,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:n,removed:l,overrides:p}=c(this.localUserConfiguration,r),O=[...t,...n,...l];return O.length&&this.updateLocalUserConfiguration(r),{keys:O,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:n,removed:l,overrides:p}=c(this.remoteUserConfiguration,r),O=[...t,...n,...l];return O.length&&this.updateRemoteUserConfiguration(r),{keys:O,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:n,removed:l,overrides:p}=c(this.workspaceConfiguration,r),O=[...t,...n,...l];return O.length&&this.updateWorkspaceConfiguration(r),{keys:O,overrides:p}}compareAndUpdateFolderConfiguration(r,t){const n=this.p.get(r),{added:l,updated:p,removed:O,overrides:D}=c(n,t),E=[...l,...p,...O];return(E.length||!n)&&this.updateFolderConfiguration(r,t),{keys:E,overrides:D}}compareAndDeleteFolderConfiguration(r){const t=this.p.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:l,removed:p,overrides:O}=c(t,void 0);return{keys:[...n,...l,...p],overrides:O}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,t,n){let l=this.r(t,n);return t.overrideIdentifier&&(l=l.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(l=l.merge(this.d)),l}r({resource:r},t){let n=this.s();if(t&&r){const l=t.getFolder(r);l&&(n=this.t(l.uri)||n);const p=this.m.get(r);p&&(n=n.merge(p))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let t=this.b.get(r);if(!t){const n=this.s(),l=this.j.get(r);l?(t=n.merge(l),this.b.set(r,t)):t=n}return t}u(r,t){if(t&&r){const n=t.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,t)=>{const{contents:n,overrides:l,keys:p}=this.j.get(t);return r.push([t,{contents:n,overrides:l,keys:p}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(t=>r.add(t)),this.userConfiguration.keys.forEach(t=>r.add(t)),this.i.keys.forEach(t=>r.add(t)),this.j.forEach(t=>t.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(l=>t.add(l))),[...t.values()]}static parse(r){const t=this.x(r.defaults),n=this.x(r.policy),l=this.x(r.application),p=this.x(r.user),O=this.x(r.workspace),D=r.folders.reduce((E,I)=>(E.set(a.URI.revive(I[0]),this.x(I[1])),E),new C.$Ac);return new d(t,n,l,p,new v,O,D,new v,new C.$Ac)}static x(r){return new v(r.contents,r.keys,r.overrides)}}e.$In=d;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,t=new Map;for(const l of o)l.keys.forEach(p=>r.add(p)),l.overrides.forEach(([p,O])=>{const D=(0,C.$xc)(t,p,new Set);O.forEach(E=>D.add(E))});const n=[];return t.forEach((l,p)=>n.push([p,[...l.values()]])),{keys:[...r.values()],overrides:n}}e.$Jn=h;class k{constructor(r,t,n,l){this.change=r,this.f=t,this.g=n,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const p of r.keys)this.affectedKeys.add(p);for(const[,p]of r.overrides)for(const O of p)this.affectedKeys.add(O);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(r,t){const n=this.a+r,l=this.d.indexOf(n);if(l<0)return!1;const p=l+n.length;if(p>=this.d.length)return!1;const O=this.d.charCodeAt(p);if(O!==this.b&&O!==this.c)return!1;if(t){const D=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.f?.workspace):void 0,E=this.g.getValue(r,t,this.h);return!S.$_m(D,E)}return!0}}e.$Kn=k;function c(o,r){const{added:t,removed:n,updated:l}=i(r?.rawConfiguration,o?.rawConfiguration),p=[],O=o?.getAllOverrideIdentifiers()||[],D=r?.getAllOverrideIdentifiers()||[];if(r){const E=D.filter(I=>!O.includes(I));for(const I of E)p.push([I,r.getKeysForOverrideIdentifier(I)])}if(o){const E=O.filter(I=>!D.includes(I));for(const I of E)p.push([I,o.getKeysForOverrideIdentifier(I)])}if(r&&o){for(const E of O)if(D.includes(E)){const I=i({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});p.push([E,[...I.added,...I.removed,...I.updated]])}}return{added:t,removed:n,updated:l,overrides:p}}function i(o,r){const t=o?r?o.keys.filter(p=>r.keys.indexOf(p)===-1):[...o.keys]:[],n=r?o?r.keys.filter(p=>o.keys.indexOf(p)===-1):[...r.keys]:[],l=[];if(o&&r){for(const p of r.keys)if(o.keys.indexOf(p)!==-1){const O=(0,g.$si)(r.contents,p),D=(0,g.$si)(o.contents,p);S.$_m(O,D)||l.push(p)}}return{added:t,removed:n,updated:l}}}),define(ie[237],ne([0,1,23,3,2,37,12,119,57,6,39,43]),function(J,e,P,A,s,R,C,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=void 0;class y extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new A.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new S.$Fn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.$kn.as(u.$pn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:$})=>this.c(Array.from(w),$))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,$){this.h(w,b.$kn.as(u.$pn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new S.$Fn;const w=b.$kn.as(u.$pn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,$){const d=this.f();for(const h of w){const k=d[h],c=$[h];k!==void 0?this.b.addValue(h,k):c?this.b.addValue(h,c.default):this.b.removeValue(h)}}}e.$Ln=y;class f{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new S.$Fn}async initialize(){return this.configurationModel}}e.$Mn=f;let v=class extends s.$Sc{get configurationModel(){return this.b}constructor(w,$,d){super(),this.c=w,this.f=$,this.g=d,this.a=this.B(new A.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new S.$Fn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const $={},d=[],h=b.$kn.as(u.$pn.Configuration).getConfigurationProperties();for(const k of w){const c=h[k];if(!c){d.push(k);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}d.push(k),$[c.policy.name]={type:c.type}}}return(0,C.$Mf)($)||await this.f.updatePolicyDefinitions($),d}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const $=b.$kn.as(u.$pn.Configuration).getPolicyConfigurations(),d=(0,P.$Hb)(w.map(h=>$.get(h)));this.m(d,!0)}m(w,$){this.g.trace("PolicyConfiguration#update",w);const d=b.$kn.as(u.$pn.Configuration).getConfigurationProperties(),h=[],k=this.b.isEmpty();for(const c of w){const i=d[c]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(k?o!==void 0:!(0,R.$_m)(this.b.getValue(c),o))&&h.push([c,o])}else this.b.getValue(c)!==void 0&&h.push([c,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const c=this.b;this.b=new S.$Fn;for(const i of c.keys)this.b.setValue(i,c.getValue(i));for(const[i,o]of h)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);$&&this.a.fire(this.b)}}};e.$Nn=v,e.$Nn=v=Ee([te(1,g.$mn),te(2,a.$$i)],v)}),define(ie[238],ne([0,1,8,3,2,19,18,119,237,39]),function(J,e,P,A,s,R,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0;class g extends s.$Sc{constructor(y,f,v,m){super(),this.j=y,this.h=this.B(new A.$Od),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$Ln),this.c=v instanceof a.$on?new u.$Mn:this.B(new u.$Nn(this.b,v,m)),this.f=this.B(new S.$Hn(this.j,{},R.$ng,f)),this.a=new S.$In(this.b.configurationModel,this.c.configurationModel,new S.$Fn,new S.$Fn),this.g=this.B(new P.$7g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:$})=>this.n(w,$))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,f,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$In(y,f,new S.$Fn,v)}getConfigurationData(){return this.a.toData()}getValue(y,f){const v=typeof y=="string"?y:void 0,m=(0,C.$li)(y)?y:(0,C.$li)(f)?f:{};return this.a.getValue(v,m,void 0)}updateValue(y,f,v,m){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.m(y)}m(y){const f=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(y);this.s(v,f,2)}n(y,f){const v=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(y,f);this.s(m,v,7)}r(y){const f=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(y);this.s(v,f,7)}s(y,f,v){const m=new S.$Kn(y,{data:f},this.a);m.source=v,m.sourceConfig=this.t(v),this.h.fire(m)}t(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$On=g}),define(ie[239],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8b=e.$v8b=e.$u8b=void 0,e.$u8b="request",e.$v8b="remoteResourceHandler";class P{async routeCall(s,R,C){if(R!==e.$u8b)throw new Error(`Call not found: ${R}`);const S=C[0];if(S?.authority){const u=s.connections.find(a=>a.ctx===S.authority);if(u)return u}throw new Error("Caller not found")}routeEvent(s,R){throw new Error(`Event not found: ${R}`)}}e.$w8b=P}),define(ie[240],ne([0,1,14,5]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.RemoteAuthorityResolverErrorCode=e.$Sk=e.$Rk=e.RemoteConnectionType=e.$Qk=void 0,e.$Qk=(0,A.$Qh)("remoteAuthorityResolverService");var s;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class R{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.$Rk=R;class C{constructor(b,y){this.host=b,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sk=C;var S;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class u extends P.$bb{static isNotAvailable(b){return b instanceof u&&b._code===S.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof u&&b._code===S.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof u&&b._code===S.NoResolverFound}static isInvalidAuthority(b){return b instanceof u&&b._code===S.InvalidAuthority}static isHandled(b){return b instanceof u&&b.isHandled}constructor(b,y=S.Unknown,f){super(b),this._message=b,this._code=y,this._detail=f,this.isHandled=y===S.NotAvailable&&f===!0,Object.setPrototypeOf(this,u.prototype)}}e.$Tk=u;function a(g){const b=g.indexOf("+");return b===-1?g:g.substring(0,b)}e.$Uk=a}),define(ie[58],ne([0,1,13]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0;function A(a){return a.scheme===P.Schemas.vscodeRemote?a.authority:void 0}e.$Vk=A;function s(a){if(!a)return;const g=a.indexOf("+");return g<0?a:a.substr(0,g)}e.$Wk=s;function R(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$Xk=R;function C(a){const{host:g,port:b}=u(a);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:g,port:b}}e.$Yk=C;function S(a,g){let{host:b,port:y}=u(a);return typeof y>"u"&&(y=g),{host:b,port:y}}e.$Zk=S;function u(a){const g=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const b=a.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const y=a.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:a,port:void 0}}}),define(ie[120],ne([0,1,27,5,58]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.TargetPlatform=e.ExtensionType=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l="extensions.user.cache",e.$2l="extensions.builtin.cache",e.$3l="undefined_publisher",e.$4l=["ui","workspace","web"];function R(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$5l=R,e.$6l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(C||(e.ExtensionType=C={}));var S;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class u{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,$){if(typeof w>"u"||w===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof w=="string"||typeof $=="string"){const d=typeof w=="string"?w:w.value,h=typeof $=="string"?$:$.value;return P.$3e(d,h)}return w._lower===$._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$7l=u;class a{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const $ of w)this.add($)}add(w){this.c.add(u.toKey(w))}delete(w){return this.c.delete(u.toKey(w))}has(w){return this.c.has(u.toKey(w))}}e.$8l=a;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(u.toKey(w))}get(w){return this.c.get(u.toKey(w))}has(w){return this.c.has(u.toKey(w))}set(w,$){this.c.set(u.toKey(w),$)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$9l=g;function b(m){return y(m)}e.$0l=b;function y(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$$l=y;function f(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$_l=f;function v(m,w){if(w){const $=`onResolveRemoteAuthority:${(0,s.$Wk)(w)}`;return!!m.activationEvents?.includes($)}return!1}e.$am=v,e.$bm=(0,A.$Qh)("IBuiltinExtensionsScannerService")}),define(ie[241],ne([0,1,8,17,22,14,3,2,65,72,32,109,240,58]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.PersistentConnectionEventType=e.$7k=e.$6k=e.$5k=e.ConnectionType=void 0;const v=30*1e3;var m;(function(L){L[L.Management=1]="Management",L[L.ExtensionHost=2]="ExtensionHost",L[L.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function w(L){switch(L){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(L){const M=new s.$Yd;return setTimeout(()=>M.cancel(),L),M.token}function d(L,M){if(L.isCancellationRequested||M.isCancellationRequested)return s.CancellationToken.Cancelled;const N=new s.$Yd;return L.onCancellationRequested(()=>N.cancel()),M.onCancellationRequested(()=>N.cancel()),N.token}class h{get didTimeout(){return this.c==="timedout"}constructor(M){this.c="pending",this.d=new S.$Rc,this.promise=new Promise((N,T)=>{this.f=N,this.g=T}),M.isCancellationRequested?this.h():this.d.add(M.onCancellationRequested(()=>this.h()))}registerDisposable(M){this.c==="pending"?this.d.add(M):M.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const M=new Error("Time limit reached");return M.code="ETIMEDOUT",M.syscall="connect",M}resolve(M){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(M))}reject(M){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(M))}}function k(L,M){const N=new h(M);return N.registerDisposable(L.onControlMessage(T=>{const F=JSON.parse(T.toString()),B=q(F);B?N.reject(B):N.resolve(F)})),N.promise}function c(L,M,N,T,F,B,V,ae){const de=new h(ae),ue=a.$Kd.create(!1);return L.info(`Creating a socket (${V})...`),u.mark(`code/willCreateSocket/${B}`),M.connect(N,T,F,V).then(he=>{de.didTimeout?(u.mark(`code/didCreateSocketError/${B}`),L.info(`Creating a socket (${V}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(u.mark(`code/didCreateSocketOK/${B}`),L.info(`Creating a socket (${V}) was successful after ${ue.elapsed()} ms.`),de.resolve(he))},he=>{u.mark(`code/didCreateSocketError/${B}`),L.info(`Creating a socket (${V}) returned an error after ${ue.elapsed()} ms.`),L.error(he),de.reject(he)}),de.promise}function i(L,M){const N=new h(M);return L.then(T=>{N.didTimeout||N.resolve(T)},T=>{N.didTimeout||N.reject(T)}),N.promise}async function o(L,M,N,T){const F=Z(L,M);L.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let B;try{B=await c(L.logService,L.remoteSocketFactoryService,L.connectTo,(0,f.$Xk)(L),`reconnectionToken=${L.reconnectionToken}&reconnection=${L.reconnectionProtocol?"true":"false"}`,w(M),`renderer-${w(M)}-${L.reconnectionToken}`,T)}catch(he){throw L.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),L.logService.error(he),he}L.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let V,ae;L.reconnectionProtocol?(L.reconnectionProtocol.beginAcceptReconnection(B,null),V=L.reconnectionProtocol,ae=!1):(V=new b.$Eh({socket:B}),ae=!0),L.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const de=await i(L.signService.createNewMessage((0,g.$fg)()),T),ue={type:"auth",auth:L.connectionToken||"00000000000000000000",data:de.data};V.sendControl(A.$ce.fromString(JSON.stringify(ue)));try{const he=await k(V,d(T,$(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(L.logService.trace(`${F} 4/6. received SignRequest control message.`),!await i(L.signService.validate(de,he.signedData),T)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const be=await i(L.signService.sign(he.data),T),ye={type:"connectionType",commit:L.commit,signedData:be,desiredConnectionType:M};return N&&(ye.args=N),L.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(A.$ce.fromString(JSON.stringify(ye))),{protocol:V,ownsProtocol:ae}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(L.logService.error(`${F} the handshake timed out. Error:`),L.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(L.logService.error(`${F} received error control message when negotiating connection. Error:`),L.logService.error(he)),ae&&Q(V),he}}async function r(L,M,N,T){const F=Date.now(),B=Z(L,M),{protocol:V,ownsProtocol:ae}=await o(L,M,N,T),de=new h(T);return de.registerDisposable(V.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),ve=q(he);ve?(L.logService.error(`${B} received error control message when negotiating connection. Error:`),L.logService.error(ve),ae&&Q(V),de.reject(ve)):(L.reconnectionProtocol?.endAcceptReconnection(),L.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${re(F)}!`),de.resolve({protocol:V,firstMessage:he}))})),de.promise}async function t(L,M){const{protocol:N}=await r(L,1,void 0,M);return{protocol:N}}async function n(L,M,N){const{protocol:T,firstMessage:F}=await r(L,2,M,N),B=F&&F.debugPort;return{protocol:T,debugPort:B}}async function l(L,M,N){const T=Date.now(),F=Z(L,3),{protocol:B}=await o(L,3,M,N);return L.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${re(T)}!`),B}async function p(L,M,N){const{connectTo:T,connectionToken:F}=await L.addressProvider.getAddress();return{commit:L.commit,quality:L.quality,connectTo:T,connectionToken:F,reconnectionToken:M,reconnectionProtocol:N,remoteSocketFactoryService:L.remoteSocketFactoryService,signService:L.signService,logService:L.logService}}async function O(L,M,N){return E(L,async T=>{const{protocol:F}=await t(T,s.CancellationToken.None);return new Y(L,M,N,T.reconnectionToken,F)})}e.$5k=O;async function D(L,M){return E(L,async N=>{const{protocol:T,debugPort:F}=await n(N,M,s.CancellationToken.None);return new K(L,M,N.reconnectionToken,T,F)})}e.$6k=D;async function E(L,M){for(let T=1;;T++)try{const F=(0,g.$fg)(),B=await p(L,F,null);return await M(B)}catch(F){if(T<5)L.logService.error(`[remote-connection][attempt ${T}] An error occurred in initial connection! Will retry... Error:`),L.logService.error(F);else throw L.logService.error(`[remote-connection][attempt ${T}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),L.logService.error(F),ce.triggerPermanentFailure(0,0,y.$Tk.isHandled(F)),F}}async function I(L,M,N){const T=await p(L,(0,g.$fg)(),null);return await l(T,{host:M,port:N},s.CancellationToken.None)}e.$7k=I;function j(L){return(0,P.$Ig)(M=>new Promise((N,T)=>{const F=setTimeout(N,L*1e3);M.onCancellationRequested(()=>{clearTimeout(F),N()})}))}var U;(function(L){L[L.ConnectionLost=0]="ConnectionLost",L[L.ReconnectionWait=1]="ReconnectionWait",L[L.ReconnectionRunning=2]="ReconnectionRunning",L[L.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",L[L.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class z{constructor(M,N){this.reconnectionToken=M,this.millisSinceLastIncomingData=N,this.type=0}}e.$8k=z;class X{constructor(M,N,T,F){this.reconnectionToken=M,this.millisSinceLastIncomingData=N,this.durationSeconds=T,this.c=F,this.type=1}skipWait(){this.c.cancel()}}e.$9k=X;class x{constructor(M,N,T){this.reconnectionToken=M,this.millisSinceLastIncomingData=N,this.attempt=T,this.type=2}}e.$0k=x;class oe{constructor(M,N,T){this.reconnectionToken=M,this.millisSinceLastIncomingData=N,this.attempt=T,this.type=4}}e.$$k=oe;class se{constructor(M,N,T,F){this.reconnectionToken=M,this.millisSinceLastIncomingData=N,this.attempt=T,this.handled=F,this.type=3}}e.$_k=se;class ce extends S.$Sc{static triggerPermanentFailure(M,N,T){this._permanentFailure=!0,this.f=M,this.g=N,this.h=T,this.j.forEach(F=>F.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(M=>M.y())}static debugPauseSocketWriting(){this.j.forEach(M=>M.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(M,N,T,F,B){super(),this.t=M,this.u=N,this.reconnectionToken=T,this.protocol=F,this.w=B,this.m=this.B(new C.$Od),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new oe(this.reconnectionToken,0,0)),this.B(F.onSocketClose(V=>{const ae=H(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${ae} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${ae} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${ae} received socket close event.`),this.y()})),this.B(F.onSocketTimeout(V=>{const ae=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ae} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,S.$Qc)(()=>{const V=ce.j.indexOf(this);V>=0&&ce.j.splice(V,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const M=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${M} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const F=T<N.length?N[T]:N[N.length-1];try{if(F>0){const V=j(F);this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,V)),this.u.logService.info(`${M} waiting for ${F} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${M} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this.u.logService.info(`${M} resolving connection...`);const B=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${M} connecting to ${B.connectTo}...`),await this.G(B,$(v)),this.u.logService.info(`${M} reconnected!`),this.m.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${M} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this.u.logService.error(`${M} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(y.$Tk.isTemporarilyNotAvailable(B)){this.u.logService.info(`${M} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this.u.logService.info(`${M} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((0,R.$4)(B)){this.u.logService.info(`${M} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if(B instanceof y.$Tk){this.u.logService.error(`${M} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,y.$Tk.isHandled(B));break}this.u.logService.error(`${M} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!this.n&&!this.s)}C(M,N,T){this.w?ce.triggerPermanentFailure(M,N,T):this.D(M,N,T)}D(M,N,T){this.m.fire(new se(this.reconnectionToken,M,N,T)),Q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$al=ce;class Y extends ce{constructor(M,N,T,F,B){super(1,M,F,B,!0),this.client=this.B(new b.$Ch(B,{remoteAuthority:N,clientId:T},M.ipcLogger))}async G(M,N){await t(M,N)}}e.$bl=Y;class K extends ce{constructor(M,N,T,F,B){super(2,M,T,F,!1),this.H=N,this.debugPort=B}async G(M,N){await n(M,this.H,N)}}e.$cl=K;function Q(L){try{L.acceptDisconnect();const M=L.getSocket();L.dispose(),M.dispose()}catch(M){(0,R.$1)(M)}}function q(L){if(L&&L.type==="error"){const M=new Error(`Connection error: ${L.reason}`);return M.code="VSCODE_CONNECTION_ERROR",M}return null}function W(L,M){for(;L.length<M;)L+=" ";return L}function G(L,M){return`[remote-connection][${W(w(L),13)}][${M.substr(0,5)}\u2026]`}function H(L,M,N){return`${G(L,M)}[${N?"reconnect":"initial"}]`}function Z(L,M){return`${H(M,L.reconnectionToken,!!L.reconnectionProtocol)}[${L.connectTo}]`}function re(L){return`${Date.now()-L} ms`}}),define(ie[242],ne([0,1,2,5]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=void 0,e.$1k=(0,A.$Qh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(C,S){return this.a[C]??=[],this.a[C].push(S),(0,P.$Qc)(()=>{const u=this.a[C]?.indexOf(S);typeof u=="number"&&u>=0&&this.a[C]?.splice(u,1)})}b(C){return(this.a[C.type]||[]).find(u=>u.supports(C))}connect(C,S,u,a){const g=this.b(C);if(!g)throw new Error(`No socket factory found for ${C}`);return g.connect(C,S,u,a)}}e.$2k=s}),define(ie[243],ne([0,1,28,47,21,113]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x7b=void 0;let C;async function S(f=!1){return(C===void 0||f)&&(C=u()),C}e.$x7b=S;async function u(){const f=a();if(f===void 0)return!1;if(f>=22e3){const v=b();if(v)return new Promise(m=>{A.execFile(v,["--status"],w=>m(!w))})}else{const v=y();if(v)try{if((await s.Promises.stat(v)).isFile())return!0}catch{}}return!1}function a(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(f)return parseInt(f[3])}function g(f){const v=process.env.SystemRoot;if(v){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(v,m?"Sysnative":"System32",f)}}function b(){return g("wsl.exe")}function y(){return g("lxss\\LxssManager.dll")}}),define(ie[50],ne([0,1,17,14,2,183,57,5,6,43]),function(J,e,P,A,s,R,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$Wo=(0,S.$Qh)("requestService");class g{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?c[i]="*****":c[i]=this.b[i];this.a=c}return this.a}}class b extends s.$Sc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,R.localize)(0,null),when:u.$pj.isEqualTo((0,u.$nj)(u.LogLevel.Trace)).serialize()})}async c(c,i,o){const r=`${c} #${++this.b}: ${i.url}`;this.a.trace(`${r} - begin`,i.type,new g(i.headers??{}));try{const t=await o();return this.a.trace(`${r} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,i.type,(0,A.$0)(t)),t}}}e.$Xo=b;function y(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}e.$Yo=y;function f(k){return k.res.statusCode===204}e.$Zo=f;async function v(k){return f(k)?null:(await(0,P.$oe)(k.stream)).toString()}e.$1o=v;async function m(k){if(!y(k))throw new Error("Server returned "+k.res.statusCode);return v(k)}e.$2o=m;async function w(k){if(!y(k))throw new Error("Server returned "+k.res.statusCode);if(f(k))return null;const i=(await(0,P.$oe)(k.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$3o=w;function $(k){h(k)}e.$4o=$;let d;function h(k){const c=a.$kn.as(C.$pn.Configuration),i=d;d={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},c.updateConfigurations({add:[d],remove:i?[i]:[]})}h(1)}),define(ie[244],ne([0,1,17,22]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class s{constructor(S){this.a=S}listen(S,u){throw new Error("Invalid listen")}call(S,u,a,g=A.CancellationToken.None){switch(u){case"request":return this.a.request(a[0],g).then(async({res:b,stream:y})=>{const f=await(0,P.$oe)(y);return[{statusCode:b.statusCode,headers:b.headers},f]});case"resolveProxy":return this.a.resolveProxy(a[0])}throw new Error("Invalid call")}}e.$Zq=s;class R{constructor(S){this.a=S}async request(S,u){const[a,g]=await this.a.call("request",[S],u);return{res:a,stream:(0,P.$qe)(g)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}}e.$1q=R}),define(ie[245],ne([0,1,246,12]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;function s(C,S){return C.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:C.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function R(C,S,u={}){const a=(0,P.parse)(C),g=u.proxyUrl||s(a,S);if(!g)return null;const b=(0,P.parse)(g);if(!/^https?:$/.test(b.protocol||""))return null;const y={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,A.$Ff)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((f,v)=>{J(["http-proxy-agent"],f,v)})).HttpProxyAgent(g,y):new(await new Promise((f,v)=>{J(["https-proxy-agent"],f,v)})).HttpsProxyAgent(g,y)}e.$2q=R}),define(ie[247],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7b=e.$R7b=e.$Q7b=void 0,e.$Q7b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$R7b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$S7b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ie[94],ne([0,1,47,9,184,22,49,14,4,32,108,62,8,140]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=void 0;let v;async function m($,d,h,k){return h["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$j?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Ol)(k)&&!h["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Ol)(k)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=y.Promises.withAsyncBody(async(c,i)=>{const o=new R.$Yd;let r=1e4;const t=$.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,f.$Pl)(t,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),i(new Error((0,s.localize)(0,null)))},r);try{c(await w(d,o.token))}catch(l){!(0,S.$4)(l)&&!o.token.isCancellationRequested?i(new Error((0,s.localize)(1,null,(0,C.$Bi)(l)))):c({})}finally{clearTimeout(n),o.dispose()}})),v)}e.$Ul=m;async function w($,d){const h=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",h);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",k);const c=(0,a.$fg)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"({.*})"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",o);const r=await(0,g.$El)(u.OS,o);return $.trace("getUnixShellEnvironment#shell",r),new Promise((t,n)=>{if(d.isCancellationRequested)return n(new S.$5);const l=(0,A.$nc)(r);let p,O;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(p=`& '${process.execPath}' ${D} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,O=["-Login","-Command"]):l==="nu"?(p=`^'${process.execPath}' ${D} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,O=["-i","-l","-c"]):(p=`'${process.execPath}' ${D} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,l==="tcsh"||l==="csh"?O=["-ic"]:O=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(O),p);const E=(0,P.spawn)(r,[...O,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});d.onCancellationRequested(()=>(E.kill(),n(new S.$5))),E.on("error",U=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,C.$Bi)(U)),n(U)});const I=[];E.stdout.on("data",U=>I.push(U));const j=[];E.stderr.on("data",U=>j.push(U)),E.on("close",(U,z)=>{const X=Buffer.concat(I).toString("utf8");$.trace("getUnixShellEnvironment#raw",X);const x=Buffer.concat(j).toString("utf8");if(x.trim()&&$.trace("getUnixShellEnvironment#stderr",x),U||z)return n(new Error((0,s.localize)(2,null,U,z)));const oe=i.exec(X),se=oe?oe[1]:"{}";try{const ce=JSON.parse(se);h?ce.ELECTRON_RUN_AS_NODE=h:delete ce.ELECTRON_RUN_AS_NODE,k?ce.ELECTRON_NO_ATTACH_CONSOLE=k:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",ce),t(ce)}catch(ce){$.error("getUnixShellEnvironment#errorCaught",(0,C.$Bi)(ce)),n(ce)}})})}}),define(ie[248],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M3b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const R=await this.c();if(R){const C=String(P.a++);return this.b.set(C,R),{id:C,data:R.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,R){if(!s.id)return!0;const C=this.b.get(s.id);if(!C)return!1;this.b.delete(s.id);try{return C.validate(R)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$M3b=P}),define(ie[95],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=void 0,e.$3k="signService",e.$4k=(0,P.$Qh)(e.$3k)}),define(ie[249],ne([0,1,248]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=void 0;class A extends P.$M3b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(C=>new C.signer().sign(R))}h(){return new Promise((R,C)=>J(["vsda"],R,C))}}e.$G8b=A}),define(ie[34],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0,e.$EN=(0,P.$Qh)("stateReadService"),e.$FN=(0,P.$Qh)("stateService")}),define(ie[121],ne([0,1,8,17,2,12,36,16,6]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=e.$HN=e.$GN=e.SaveStrategy=void 0;var a;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class g extends s.$Sc{constructor(v,m,w,$){super(),this.h=v,this.j=w,this.m=$,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=m===0?void 0:this.B(new P.$Sg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.j.error(v)}}getItem(v,m){const w=this.a[v];return(0,R.$If)(w)?m:w}setItem(v,m){this.setItems([{key:v,data:m}])}setItems(v){let m=!1;for(const{key:w,data:$}of v)this.a[w]!==$&&((0,R.$If)($)?(0,R.$Gf)(this.a[w])||(this.a[w]=void 0,m=!0):(this.a[w]=$,m=!0));m&&this.r()}removeItem(v){(0,R.$Gf)(this.a[v])||(this.a[v]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.m.writeFile(this.h,A.$ce.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(m){this.j.error(m)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$GN=g;let b=class extends s.$Sc{constructor(v,m,w,$){super(),this.a=this.B(new g(m.stateResource,v,w,$))}async init(){await this.a.init()}getItem(v,m){return this.a.getItem(v,m)}};e.$HN=b,e.$HN=b=Ee([te(1,C.$Xh),te(2,u.$$i),te(3,S.$_j)],b);class y extends b{setItem(v,m){this.a.setItem(v,m)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$IN=y}),define(ie[122],ne([0,1,4,35,32]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=void 0;function R(u){if(P.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function C(u,a,g,b,y,f,v,m,w){const $=Object.create(null);$["common.machineId"]=f,$["common.sqmId"]=v,$.sessionID=(0,s.$fg)()+Date.now(),$.commitHash=b,$.version=y,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,P.$i)(P.$u),$["common.nodePlatform"]=A.$dc,$["common.nodeArch"]=g,$["common.product"]=w||"desktop",m&&($["common.msftInternal"]=m);let d=0;const h=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),P.$m&&($["common.snap"]="true");const k=R(a);return k&&($["common.platformDetail"]=k),$}e.$lo=C;function S(u){const a=A.env.USERDNSDOMAIN;if(!a)return!1;const g=a.toLowerCase();return u.some(b=>g===b)}e.$mo=S}),define(ie[26],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0,e.$dl=(0,P.$Qh)("telemetryService"),e.$el=(0,P.$Qh)("customEndpointTelemetryService"),e.$fl="telemetry.currentSessionDate",e.$gl="telemetry.firstSessionDate",e.$hl="telemetry.lastSessionDate",e.$il="telemetry.machineId",e.$jl="telemetry.sqmId",e.$kl="telemetry",e.$ll="telemetry.telemetryLevel",e.$ml="telemetry.enableCrashReporter",e.$nl="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var s;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ie[250],ne([0,1,28,8,44,13,9,4,7,88,21,107,91,16,25,26]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0;const w=new Map;async function $(i,o){const r=`${i}::${o.join(":")}`,t=w.get(r);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,p=new Map,O=2e4;function D(I,j,U,z){const X=j.substring(I.length+1);return A.Promises.withAsyncBody(async x=>{let oe;try{oe=await g.Promises.readdir(j,{withFileTypes:!0})}catch{x();return}if(z.count>=O){z.count+=oe.length,z.maxReached=!0,x();return}let se=oe.length;if(se===0){x();return}let ce=oe;z.count+oe.length>O&&(z.maxReached=!0,se=O-z.count,ce=oe.slice(0,se)),z.count+=oe.length;for(const Y of ce)if(Y.isDirectory()){if(U.includes(Y.name)||await D(I,(0,C.$jc)(j,Y.name),U,z),--se===0){x();return}}else{const K=Y.name.lastIndexOf(".");if(K>=0){const Q=Y.name.substring(K+1);Q&&l.set(Q,(l.get(Q)??0)+1)}for(const Q of n)Q.relativePathPattern?.test(X)!==!1&&Q.filePattern.test(Y.name)&&p.set(Q.tag,(p.get(Q.tag)??0)+1);if(--se===0){x();return}}})}const E=A.Promises.withAsyncBody(async I=>{const j={count:0,maxReached:!1};await D(i,i,o,j);const U=await k(i);I({configFiles:d(p),fileTypes:d(l),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:U})});return w.set(r,E),E}e.$Hr=$;function d(i){return Array.from(i.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function h(){const i={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/f.$Hk.GB).toFixed(2)}GB (${(P.freemem()/f.$Hk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(a.$Sm.value()*100)}%`},o=P.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$Ir=h;async function k(i){try{const o=new Map,r=(0,C.$jc)(i,".vscode","launch.json"),t=await g.Promises.readFile(r),n=[],l=(0,s.$Xm)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$7m)(l)==="object"&&l.configurations)for(const p of l.configurations){const O=p.type;O&&(o.has(O)?o.set(O,o.get(O)+1):o.set(O,1))}return d(o)}catch{return[]}}e.$Jr=k;let c=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const t=P.cpus();return t&&t.length>0&&r.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/f.$Hk.GB).toFixed(2)}GB (${(P.freemem()/f.$Hk.GB).toFixed(2)}GB free)`),S.$j||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(a.$Sm.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,b.$Gr)(o.mainPID),this.k(o)]).then(async t=>{let[n,l]=t,p=this.m(o,n);return r.forEach(O=>{if((0,y.$sm)(O))p+=`
${O.errorMessage}`,l+=`
${O.errorMessage}`;else if(p+=`

Remote: ${O.hostName}`,O.processes&&(p+=`
${this.m(o,O.processes)}`),O.workspaceMetadata){l+=`
|  Remote: ${O.hostName}`;for(const D of Object.keys(O.workspaceMetadata)){const E=O.workspaceMetadata[D];let I=`${E.fileCount} files`;E.maxFilesReached&&(I=`more than ${I}`),l+=`|    Folder (${D}): ${I}`,l+=this.h(E)}}}),{processInfo:p,workspaceInfo:l}})}async getSystemInfo(o,r){const{memory:t,vmHint:n,os:l,cpus:p}=h(),O={os:l,memory:t,cpus:p,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return S.$j||(O.load=`${P.loadavg().map(D=>Math.round(D)).join(", ")}`),S.$l&&(O.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(O)}async getDiagnostics(o,r){const t=[];return(0,b.$Gr)(o.mainPID).then(async n=>(t.push(""),t.push(this.g(o)),t.push(""),t.push(this.m(o,n)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(o))),r.forEach(l=>{if((0,y.$sm)(l))t.push(`
${l.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${l.hostName}`),t.push(this.f(l.machineInfo)),l.processes&&t.push(this.m(o,l.processes)),l.workspaceMetadata)for(const p of Object.keys(l.workspaceMetadata)){const O=l.workspaceMetadata[p];let D=`${O.fileCount} files`;O.maxFilesReached&&(D=`more than ${D}`),t.push(`Folder (${p}): ${D}`),t.push(this.h(O))}}),t.push(""),t.push(""),t.join(`
`)))}h(o){const r=[];let n=0;const l=(E,I)=>{const j=` ${E}(${I})`;n+j.length>60?(r.push(p),p="|                 ",n=p.length):n+=j.length,p+=j};let p="|      File types:";const O=10,D=o.fileTypes.length>O?O:o.fileTypes.length;for(let E=0;E<D;E++){const I=o.fileTypes[E];l(I.name,I.count)}if(r.push(p),o.configFiles.length>=0&&(p="|      Conf files:",n=0,o.configFiles.forEach(E=>{l(E.name,E.count)}),r.push(p)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(I=>{const j=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;E+=j}),r.push(E)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(r-t.length)}  ${o[t]}`).join(`
                  `)}k(o){const r=[],t=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(l=>{const p=u.URI.revive(l);if(p.scheme===R.Schemas.file){const O=p.fsPath;t.push($(O,["node_modules",".git"]).then(D=>{let E=`${D.fileCount} files`;D.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,C.$nc)(O)}): ${E}`),r.push(this.h(D))}).catch(D=>{r.push(`|      Error: Unable to collect workspace stats for folder ${O} (${D.toString()})`)}))}else r.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const t=new Map;o.windows.forEach(l=>t.set(l.pid,`window [${l.id}] (${l.title})`)),o.pidToNames.forEach(({pid:l,name:p})=>t.set(l,p));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,t,n,r,0),n.join(`
`)}n(o,r,t,n,l){const p=l===0;let O;p?O=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?O=r.get(n.pid):O=`${"  ".repeat(l)} ${n.name}`;const D=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(D/f.$Hk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${O}`),Array.isArray(n.children)&&n.children.forEach(E=>this.n(o,r,t,E,l+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:t}of o.folders){const n=u.URI.revive(t);if(n.scheme!==R.Schemas.file)continue;const l=n.fsPath;try{(await $(l,["node_modules",".git"])).fileTypes.forEach(O=>r.add(O.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const t=u.URI.revive(r);if(t.scheme!==R.Schemas.file)continue;const n=t.fsPath;try{const l=await $(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),l.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})}),l.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$Kr=c,e.$Kr=c=Ee([te(0,m.$dl),te(1,v.$qj)],c)}),define(ie[251],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=e.$V7b=void 0;class P{constructor(R){this.b=R}listen(R,C){throw new Error(`Event not found: ${C}`)}call(R,C,{eventName:S,data:u}){return this.b.forEach(a=>a.log(S,u)),Promise.resolve(null)}}e.$V7b=P;class A{constructor(R){this.b=R}log(R,C){return this.b.call("log",{eventName:R,data:C}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$W7b=A}),define(ie[51],ne([0,1,37,12,3,18,58,122,26]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$no=a;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$oo=g,e.$po=new g;class b{async publicLog(n,l,p){}async publicLogError(n,l,p){}}e.$qo=b,e.$ro="telemetry",e.$so="extensionTelemetryLog",e.$to={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,n){return s.Event.debounce(n.onDidChangeConfiguration,(p,O)=>{const D=p?new Set([...p.affectedKeys,...O.affectedKeys]):O.affectedKeys;return{...O,affectedKeys:D}},1e3,!0)(p=>{p.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,R.$ni)(p.source),configurationKeys:Array.from(p.affectedKeys)})})}e.$uo=y;function f(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.$vo=f;function v(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$wo=v;function m(t){const n=t.getValue(u.$ll),l=t.getValue(u.$ml);if(t.getValue(u.$nl)===!1||l===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$xo=m;function w(t){const n={},l={},p={};h(t,p);for(let O in p){O=O.length>150?O.substr(O.length-149):O;const D=p[O];typeof D=="number"?l[O]=D:typeof D=="boolean"?l[O]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${O} has been trimmed to 8192, the original length is ${D.length}`),n[O]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(n[O]=D)}return{properties:n,measurements:l}}e.$yo=w;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(t){if(!t)return"none";const n=(0,C.$Wk)(t);return $.has(n)?n:"other"}e.$zo=d;function h(t,n,l=0,p){if(t)for(const O of Object.getOwnPropertyNames(t)){const D=t[O],E=p?p+O:O;Array.isArray(D)?n[E]=(0,P.$an)(D):D instanceof Date?n[E]=D.toISOString():(0,A.$Bf)(D)?l<2?h(D,n,l+1,E+"."):n[E]=(0,P.$an)(D):n[E]=D}}function k(t,n){const l=t.msftInternalDomains||[],p=n.getValue("telemetry.internalTesting");return(0,S.$mo)(l)||p}e.$Ao=k;function c(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Bo=c;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let l=t;const p=[];for(const I of n)for(;;){const j=I.exec(t);if(!j)break;p.push([j.index,I.lastIndex])}const O=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(l="";;){const I=D.exec(t);if(!I)break;const j=p.some(([U,z])=>I.index<z&&U<D.lastIndex);!O.test(I[0])&&!j&&(l+=t.substring(E,I.index)+"<REDACTED: user-file-path>",E=D.lastIndex)}return E<t.length&&(l+=t.substr(E)),l}function o(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of n)if(l.regex.test(t))return`<REDACTED: ${l.label}>`;return t}function r(t,n){return(0,P.$0m)(t,l=>{if(l instanceof a||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let p=l.replaceAll("%20"," ");p=i(p,n);for(const O of n)p=p.replace(O,"");return p=o(p),p}})}e.$Co=r}),define(ie[123],ne([0,1,27,117,120,4,7,14,35,51]),function(J,e,P,A,s,R,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;function g(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,P.$Xe)(r.id,t.id)===0}e.$Do=g;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(t){const n=t.manifest?t.manifest.version:t.version,l=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new y(t.identifier,n,l)}static parse(t){const n=b.exec(t);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,l="undefined"){this.version=n,this.targetPlatform=l,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof y?g(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Eo=y;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const t=f.exec(r);return t&&t[1]?[w(t[1]),t[2]]:[w(r),void 0]}e.$Fo=v;function m(r,t){return`${r}.${t}`}e.$Go=m;function w(r){return r.toLowerCase()}e.$Ho=w;function $(r,t){return w(m(r??s.$3l,t))}e.$Io=$;function d(r,t){const n=[],l=p=>{for(const O of n)if(O.some(D=>g(t(D),t(p))))return O;return null};for(const p of r){const O=l(p);O?O.push(p):n.push([p])}return n}e.$Jo=d;function h(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$Ko=h;function k(r){return{id:new a.$no(r.identifier.id),name:new a.$no(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Lo=k,e.$Mo=new s.$7l("pprice.better-merge");function c(r,t){const n=[],l=t.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const p=l.shift();if(p&&n.every(O=>!g(O.identifier,{id:p}))){const O=r.filter(D=>g(D.identifier,{id:p}));O.length===1&&(n.push(O[0]),l.push(...O[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$No=c;async function i(r,t){if(!R.$l)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){t.debug("Error while getting the os-release file.",(0,S.$0)(p))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,t){const n=await i(r,t),l=(0,A.$0n)(n?"alpine":R.$u,u.$ec);return t.debug("ComputeTargetPlatform:",l),l}e.$Oo=o}),define(ie[252],ne([0,1,206,51]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;async function s(R,C,S,u,a,g,b){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${C.nameShort})`};if((0,A.$vo)(C,S)&&(0,A.$xo)(u)===3){const f=await(0,P.$dp)(S,a,g);y["X-Market-User-Id"]=f,y["VSCode-SessionId"]=b.machineId||f}return y}e.$ep=s}),define(ie[253],ne([0,1,2,37,4,27,185,18,57,79,25,43,26,51]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,d,h){this.k=d,this.l=h,this.d={},this.i=new P.$Rc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,R.$Ge)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.$Ge)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(y.$ll)||k.affectsConfiguration(y.$nl)||k.affectsConfiguration(y.$ml))&&this.m()}))}setExperimentProperty($,d){this.d[$]=d}m(){let $=(0,f.$xo)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const h=d.usage?3:d.error?2:0;$=Math.min($,h)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,d,h){this.g<d||(h=(0,A.$$m)(h,this.d),h=(0,f.$Co)(h,this.j),h=(0,A.$$m)(h,this.c),this.b.forEach(k=>k.log($,h)))}publicLog($,d){this.n($,3,d)}publicLog2($,d){this.publicLog($,d)}publicLogError($,d){this.h&&this.n($,2,d)}publicLogError2($,d){this.publicLogError($,d)}};e.$5q=v,e.$5q=v=Ee([te(1,S.$ki),te(2,g.$qj)],v);function m(){const w=(0,C.localize)(0,null,a.default.nameLong),$=a.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=s.$p?"":(0,C.localize)(3,null),h=(0,C.localize)(4,null),k=(0,C.localize)(5,null),c=(0,C.localize)(6,null),i=(0,C.localize)(7,null),o=`
|       | ${h} | ${k} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${w} ${$} ${d}

&nbsp;

${i}
${o}

&nbsp;

${r}
`}b.$kn.as(u.$pn.Configuration).registerConfiguration({id:y.$kl,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[y.$ll]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$kn.as(u.$pn.Configuration).registerConfiguration({id:y.$kl,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[y.$nl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,C.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,C.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${y.$ll}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[254],ne([0,1,4,88,26]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m8b=e.$l8b=void 0;async function R(S,u){let a=S.getItem(s.$il);return(typeof a!="string"||P.$k&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,A.$Tm)(u.error.bind(u))),a}e.$l8b=R;async function C(S,u){let a=S.getItem(s.$jl);return typeof a!="string"&&(a=await(0,A.$Um)(u.error.bind(u))),a}e.$m8b=C}),define(ie[255],ne([0,1,26,254]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8b=e.$n8b=void 0;async function s(C,S){const u=await(0,A.$l8b)(C,S);return C.setItem(P.$il,u),u}e.$n8b=s;async function R(C,S){const u=await(0,A.$m8b)(C,S);return C.setItem(P.$jl,u),u}e.$o8b=R}),define(ie[124],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(ie[256],ne([0,1,4,124]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;const s=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class R{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((b,y)=>{this.d(b,y);const f=b.map.entries();let v=f.next();for(;!v.done;){const m=v.value[1],w=v.value[0];let $=this.a.get(w);if($||($=[],this.a.set(w,$)),$.length>0&&$[0].type===A.EnvironmentVariableMutatorType.Replace){v=f.next();continue}const d={extensionIdentifier:y,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};d.scope||delete d.scope,$.unshift(d),v=f.next()}})}async applyToProcessEnvironment(g,b,y){let f;P.$j&&(f={},Object.keys(g).forEach(v=>f[v.toLowerCase()]=v));for(const[v,m]of this.getVariableMap(b)){const w=P.$j&&f[v.toLowerCase()]||v;for(const $ of m){const d=y?await y($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case A.EnvironmentVariableMutatorType.Append:g[w]=(g[w]||"")+d;break;case A.EnvironmentVariableMutatorType.Prepend:g[w]=d+(g[w]||"");break;case A.EnvironmentVariableMutatorType.Replace:g[w]=d;break}if($.options?.applyAtShellIntegration??!1){const h=`VSCODE_ENV_${s.get($.type)}`;g[h]=(g[h]?g[h]+":":"")+v+"="+this.c(d)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,b){const y=new Map,f=new Map,v=new Map;if(g.getVariableMap(b).forEach((m,w)=>{const $=this.getVariableMap(b).get(w),d=S(m,$);d&&y.set(w,d)}),this.getVariableMap(b).forEach((m,w)=>{const $=g.getVariableMap(b).get(w),d=S(m,$);d&&v.set(w,d)}),this.getVariableMap(b).forEach((m,w)=>{const $=g.getVariableMap(b).get(w),d=u(m,$);d&&f.set(w,d)}),!(y.size===0&&f.size===0&&v.size===0))return{added:y,changed:f,removed:v}}getVariableMap(g){const b=new Map;for(const y of this.a.values()){const f=y.filter(v=>C(v,g));f.length>0&&b.set(f[0].variable,f)}return b}getDescriptionMap(g){const b=new Map;for(const y of this.b.values()){const f=y.filter(v=>C(v,g,!0));for(const v of f)b.set(v.extensionIdentifier,v.description)}return b}d(g,b){if(!g.descriptionMap)return;const y=g.descriptionMap.entries();let f=y.next();for(;!f.done;){const v=f.value[1],m=f.value[0];let w=this.b.get(m);w||(w=[],this.b.set(m,w));const $={extensionIdentifier:b,scope:v.scope,description:v.description};$.scope||delete $.scope,w.push($),f=y.next()}}}e.$ur=R;function C(a,g,b=!1){return a.scope?!!(a.scope.workspaceFolder&&g?.workspaceFolder&&a.scope.workspaceFolder.index===g.workspaceFolder.index):b?g===a.scope:!0}function S(a,g){if(!g)return a;const b=new Set;g.forEach(f=>b.add(f.extensionIdentifier));const y=[];return a.forEach(f=>{b.has(f.extensionIdentifier)||y.push(f)}),y.length===0?void 0:y}function u(a,g){if(!g)return;const b=new Map;g.forEach(f=>b.set(f.extensionIdentifier,f));const y=[];return a.forEach(f=>{const v=b.get(f.extensionIdentifier);v&&(f.type!==v.type||f.value!==v.value||f.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&y.push(v)}),y.length===0?void 0:y}}),define(ie[257],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=e.$qr=e.$pr=e.$or=void 0;function P(u){return[...u.entries()]}e.$or=P;function A(u){return u?[...u.entries()]:[]}e.$pr=A;function s(u){return new Map(u)}e.$qr=s;function R(u){return new Map(u??[])}e.$rr=R;function C(u){return Array.from(u.entries()).map(a=>[a[0],P(a[1].map),A(a[1].descriptionMap)])}e.$sr=C;function S(u){return new Map(u.map(a=>[a[0],{map:s(a[1]),descriptionMap:R(a[2])}]))}e.$tr=S}),define(ie[258],ne([0,1,8,22,3,2,6]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;let S=class extends R.$Sc{constructor(a,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Od),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,R.$Qc)(()=>{for(const b of this.f.values())(0,R.$Nc)(b)}))}createRequest(a){return new Promise((g,b)=>{const y=++this.a;this.c.set(y,g),this.g.fire({requestId:y,...a});const f=new A.$Yd;(0,P.$Vg)(this.b,f.token).then(()=>b(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,R.$Qc)(()=>f.cancel())])})}acceptReply(a,g){const b=this.c.get(a);b?(this.c.delete(a),(0,R.$Nc)(this.f.get(a)||[]),this.f.delete(a),b(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$fr=S,e.$fr=S=Ee([te(1,C.$$i)],S)}),define(ie[125],ne([0,1,5,114,43]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=e.$_q=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$$q=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$0q=void 0,e.$0q=new A.$8i("terminalTabFocusMode",!1,!0);var R;(function(c){c.AutomationProfile="terminal.integrated.automationProfile.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var C;(function(c){c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.TabStopWidth="terminal.integrated.tabStopWidth",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorStyleInactive="terminal.integrated.cursorStyleInactive",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.TabFocusMode="terminal.integrated.tabFocusMode",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.HideOnStartup="terminal.integrated.hideOnStartup",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",c.EnableImages="terminal.integrated.enableImages",c.SmoothScrolling="terminal.integrated.smoothScrolling",c.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",c.FocusAfterRun="terminal.integrated.focusAfterRun",c.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",c.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",c.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",c.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var S;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(S||(e.PosixShellType=S={}));var u;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(u||(e.WindowsShellType=u={}));var a;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var g;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.PtyHostWindow="ptyHostWindow",c.Logger="logger",c.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var b;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.$$q=(0,P.$Qh)("ptyService");var y;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var f;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var v;(function(c){c.TerminalView="view",c.Editor="editor"})(v||(e.TerminalLocationString=v={}));var m;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var w;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var $;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var d;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var h;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(h||(e.TerminalExitReason=h={})),e.$_q={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const o=this.b(i.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}s.$kn.add(e.$_q.Backend,new k),e.$ar=(0,P.$Qh)("localPtyService"),e.$br=(0,P.$Qh)("terminalLogService")}),define(ie[259],ne([0,1,74,7,187,102]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=e.$gr=void 0;function C(y,f){const v=[{name:null,description:(0,s.localize)(0,null)}];return v.push(...y.map(m=>({name:m.profileName,description:S(m)}))),f&&v.push(...f.map(m=>({name:m.title,description:u(m)}))),{values:v.map(m=>m.name),markdownDescriptions:v.map(m=>m.description)}}e.$gr=C;function S(y){let f=`$(${R.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:P.$Vj.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?f+=`
- args: "${y.args}"`:f+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(f+=`
- overrideName: ${y.overrideName}`),y.color&&(f+=`
- color: ${y.color}`),y.env&&(f+=`
- env: ${JSON.stringify(y.env)}`),f}function u(y){return`$(${R.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:P.$Vj.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function a(y,f){if(!y&&!f)return!0;if(typeof y=="string"&&typeof f=="string")return y===f;if(Array.isArray(y)&&Array.isArray(f)){if(y.length!==f.length)return!1;for(let v=0;v<y.length;v++)if(y[v]!==f[v])return!1;return!0}return!1}e.$hr=a;function g(y,f){if(!y&&!f)return!0;if(!y||!f)return!1;if(R.ThemeIcon.isThemeIcon(y)&&R.ThemeIcon.isThemeIcon(f))return y.id===f.id&&y.color===f.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof f=="object"&&"light"in f&&"dark"in f){const v=y,m=f;if((A.URI.isUri(v.light)||b(v.light))&&(A.URI.isUri(v.dark)||b(v.dark))&&(A.URI.isUri(m.light)||b(m.light))&&(A.URI.isUri(m.dark)||b(m.dark)))return v.light.path===m.light.path&&v.dark.path===m.dark.path}if(A.URI.isUri(y)&&A.URI.isUri(f)||b(y)||b(f)){const v=y,m=f;return v.path===m.path&&v.scheme===m.scheme}return!1}e.$ir=g;function b(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$jr=b}),define(ie[260],ne([0,1,74,4,186,57,43,259]),function(J,e,P,A,s,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=e.$kr=void 0,e.$kr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$lr={type:"string",enum:Array.from((0,P.$Uj)(),w=>w.id),markdownEnumDescriptions:Array.from((0,P.$Uj)(),w=>`$(${w.id})`)};const u={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$lr},color:{description:(0,s.localize)(3,null),...e.$kr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},a={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...u}},g={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...u}};function b(w){const $=w===2?"linux":w===1?"osx":"windows";return(0,s.localize)(7,null,(0,A.$i)(w),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...u}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...u}},{type:"null"},a]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...u}},{type:"null"},a]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...u}},{type:"null"},a]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){C.$kn.as(R.$pn.Configuration).registerConfiguration(y),m()}e.$mr=f;let v;function m(w,$){const d=C.$kn.as(R.$pn.Configuration);let h;w&&(h=(0,S.$gr)(w?.profiles,$));const k=v;v={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?h?.values:void 0,markdownEnumDescriptions:w?.os===3?h?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?h?.values:void 0,markdownEnumDescriptions:w?.os===2?h?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?h?.values:void 0,markdownEnumDescriptions:w?.os===1?h?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[v],remove:k?[k]:[]})}e.$nr=m}),define(ie[261],ne([0,1,28,13,37,9,4,35,27,12,21,124,257,256]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.$vr=void 0;function v(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.$vr=v;async function m(t,n,l,p=S.env,O=g.Promises.exists){if(R.$ic(t))return await O(t)?t:void 0;if(n===void 0&&(n=S.cwd()),R.$mc(t)!=="."){const j=R.$jc(n,t);return await O(j)?j:void 0}const E=(0,s.$cn)(p,"PATH");if(l===void 0&&(0,a.$zf)(E)&&(l=E.split(R.$tc)),l===void 0||l.length===0){const j=R.$jc(n,t);return await O(j)?j:void 0}for(const j of l){let U;if(R.$ic(j)?U=R.$jc(j,t):U=R.$jc(n,j,t),await O(U))return U;if(C.$j){let z=U+".com";if(await O(z)||(z=U+".exe",await O(z)))return z}}const I=R.$jc(n,t);return await O(I)?I:void 0}e.$wr=m;function w(t,n,l,p,O){const D=C.$j&&(!n.windowsEnableConpty||v()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||D)return;const E=t.args,I=S.$dc==="win32"?R.$nc(t.executable).toLowerCase():R.$nc(t.executable),j=R.$mc(A.$dg.asFileUri("").fsPath);let U;const z={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(z.VSCODE_NONCE=n.shellIntegration.nonce),C.$j){if(I==="pwsh.exe"||I==="powershell.exe")return!E||o(E)?U=h.get(d.WindowsPwsh):i(E)&&(U=h.get(d.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,u.$De)(U[U.length-1],j,""),{newArgs:U,envMixin:z}):void 0;p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(I){case"bash":return!E||E.length===0?U=h.get(d.Bash):r(E)&&(z.VSCODE_SHELL_LOGIN="1",$(n,z),U=h.get(d.Bash)),U?(U=[...U],U[U.length-1]=(0,u.$De)(U[U.length-1],j),{newArgs:U,envMixin:z}):void 0;case"fish":{const X=l?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",x=R.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${X}:${x}`,$(n,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!E||o(E)?U=h.get(d.Pwsh):i(E)&&(U=h.get(d.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,u.$De)(U[U.length-1],j,""),{newArgs:U,envMixin:z}):void 0;case"zsh":{if(!E||E.length===0?U=h.get(d.Zsh):r(E)?(U=h.get(d.ZshLogin),$(n,z)):(E===h.get(d.Zsh)||E===h.get(d.ZshLogin))&&(U=E),!U)return;U=[...U],U[U.length-1]=(0,u.$De)(U[U.length-1],j);let X;try{X=P.userInfo().username}catch{X="unknown"}const x=R.$jc(P.tmpdir(),`${X}-${O.applicationName}-zsh`);z.ZDOTDIR=x;const oe=l?.ZDOTDIR??P.homedir()??"~";z.USER_ZDOTDIR=oe;const se=[];return se.push({source:R.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.$jc(x,".zshrc")}),se.push({source:R.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.$jc(x,".zprofile")}),se.push({source:R.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.$jc(x,".zshenv")}),se.push({source:R.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.$jc(x,".zlogin")}),{newArgs:U,envMixin:z,filesToCopy:se}}}p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.$xr=w;function $(t,n){if(C.$k&&t.environmentVariableCollections){const l=(0,y.$tr)(t.environmentVariableCollections),O=new f.$ur(l).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),D=[];if(O)for(const E of O)E.type===b.EnvironmentVariableMutatorType.Prepend&&D.push(E.value);D.length>0&&(n.VSCODE_PATH_PREFIX=D.join(""))}}var d;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(d||(d={}));const h=new Map;h.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),h.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),h.set(d.Zsh,["-i"]),h.set(d.ZshLogin,["-il"]),h.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],c=["-nol","-nologo"];function i(t){return typeof t=="string"?k.includes(t.toLowerCase()):t.length===1&&k.includes(t[0].toLowerCase())||t.length===2&&(k.includes(t[0].toLowerCase())||k.includes(t[1].toLowerCase()))&&(c.includes(t[0].toLowerCase())||c.includes(t[1].toLowerCase()))}function o(t){return typeof t=="string"?c.includes(t.toLowerCase()):t.length===0||t?.length===1&&c.includes(t[0].toLowerCase())}function r(t){return t==="string"&&k.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&k.includes(t[0].toLowerCase())}}),define(ie[262],ne([0,1,47,74,9,4,12,21,106,261,113]),function(J,e,P,A,s,R,C,S,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;let b,y=!0;function f(n,l,p,O,D=process.env,E,I,j,U){return E=E||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},R.$j?v(p,E,D,I,O.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:O.getValue("terminal.integrated.profiles.windows"),typeof l=="string"?l:O.getValue("terminal.integrated.defaultProfile.windows"),U,j):o(E,I,p,n&&typeof n=="object"?{...n}:O.getValue(R.$l?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof l=="string"?l:O.getValue(R.$l?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,j,D)}e.$yr=f;async function v(n,l,p,O,D,E,I,j,U){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),X=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let x=!1;(0,a.$vr)()>=16299&&(x=!0),await d(j);const oe=new Map;if(n){oe.set("PowerShell",{source:"PowerShell",icon:A.$Vj.terminalPowershell,isAutoDetected:!0}),oe.set("Windows PowerShell",{path:`${X}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.$Vj.terminalPowershell,isAutoDetected:!0}),oe.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),oe.set("Command Prompt",{path:`${X}\\cmd.exe`,icon:A.$Vj.terminalCmd,isAutoDetected:!0}),oe.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),oe.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.$Vj.terminalBash,isAutoDetected:!0});const ce=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;oe.set("Cmder",{path:`${X}\\cmd.exe`,args:["/K",ce],requiresPath:process.env.CMDER_ROOT?ce:{path:ce,isUnsafe:!0},isAutoDetected:!0})}r(E,oe);const se=await m(oe.entries(),I,l,p,O,U);if(n&&D)try{const ce=await c(`${X}\\${x?"wsl":"bash"}.exe`,I);for(const Y of ce)(!E||!(Y.profileName in E))&&se.push(Y)}catch{y&&(O?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return se}async function m(n,l,p,O=process.env,D,E){const I=[];for(const[j,U]of n)I.push(w(j,U,l,p,O,D,E));return(await Promise.all(I)).filter(j=>!!j)}async function w(n,l,p,O,D=process.env,E,I){if(l===null)return;let j,U,z;if("source"in l&&!("path"in l)){const se=b?.get(l.source);if(!se)return;j=se.paths,U=l.args||se.args,l.icon?z=$(l.icon):se.icon&&(z=se.icon)}else j=Array.isArray(l.path)?l.path:[l.path],U=R.$j||Array.isArray(l.args)?l.args:void 0,z=$(l.icon);let X;if(I){const se=j.map(Y=>typeof Y=="string"?Y:Y.path),ce=await I(se);X=new Array(j.length);for(let Y=0;Y<j.length;Y++)typeof j[Y]=="string"?X[Y]=ce[Y]:X[Y]={path:ce[Y],isUnsafe:!0}}else X=j.slice();let x;if(l.requiresPath){let se;if((0,C.$zf)(l.requiresPath)?se=l.requiresPath:(se=l.requiresPath.path,l.requiresPath.isUnsafe&&(x=se)),!await O.existsFile(se))return}const oe=await t(n,p,X,O,D,U,l.env,l.overrideName,l.isAutoDetected,x);if(!oe){E?.debug("Terminal profile not validated",n,j);return}return oe.isAutoDetected=l.isAutoDetected,oe.icon=z,oe.color=l.color,oe}function $(n){return typeof n=="string"?{id:n}:n}async function d(n){if(b&&!n)return;const[l,p]=await Promise.all([h(),n||k()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:l,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:p,icon:A.$Vj.terminalPowershell})}async function h(){const n=new Set,l=await(0,a.$wr)("git.exe");if(l){const D=(0,g.dirname)(l);n.add((0,g.resolve)(D,"../.."))}function p(D,E){E&&D.add(E)}p(n,process.env.ProgramW6432),p(n,process.env.ProgramFiles),p(n,process.env["ProgramFiles(X86)"]),p(n,`${process.env.LocalAppData}\\Program`);const O=[];for(const D of n)O.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return O.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),O.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),O}async function k(){const n=[];for await(const l of(0,u.$yl)())n.push(l.exePath);return n}async function c(n,l){const p=[],O=await new Promise((I,j)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,z)=>{if(U)return j("Problem occurred when getting wsl distros");I(z)})});if(!O)return[];const D=new RegExp(/[\r?\n]/),E=O.split(D).filter(I=>I.trim().length>0&&I!=="");for(const I of E){if(I===""||I.startsWith("docker-desktop"))continue;const j=`${I} (WSL)`,U={profileName:j,path:n,args:["-d",`${I}`],isDefault:j===l,icon:i(I),isAutoDetected:!1};p.push(U)}return p}function i(n){return n.includes("Ubuntu")?A.$Vj.terminalUbuntu:n.includes("Debian")?A.$Vj.terminalDebian:A.$Vj.terminalLinux}async function o(n,l,p,O,D,E,I,j){const U=new Map;if(p){const z=(await n.readFile("/etc/shells")).toString(),X=(E||z.split(`
`)).map(oe=>{const se=oe.indexOf("#");return se===-1?oe:oe.substring(0,se)}).filter(oe=>oe.trim().length>0),x=new Map;for(const oe of X){let se=(0,s.$nc)(oe),ce=x.get(se)||0;ce++,ce>1&&(se=`${se} (${ce})`),x.set(se,ce),U.set(se,{path:oe,isAutoDetected:!0})}}return r(O,U),await m(U.entries(),D,n,j,l,I)}function r(n,l){if(n)for(const[p,O]of Object.entries(n))O===null||typeof O!="object"||!("path"in O)&&!("source"in O)?l.delete(p):(O.icon=O.icon||l.get(p)?.icon,l.set(p,O))}async function t(n,l,p,O,D,E,I,j,U,z){if(p.length===0)return Promise.resolve(void 0);const X=p.shift();if(X==="")return t(n,l,p,O,D,E,I,j,U);const x=typeof X!="string"&&X.isUnsafe,oe=typeof X=="string"?X:X.path,se={profileName:n,path:oe,args:E,env:I,overrideName:j,isAutoDetected:U,isDefault:n===l,isUnsafePath:x,requiresUnsafePath:z};if((0,s.$nc)(oe)===oe){const Y=D.PATH?D.PATH.split(s.$tc):void 0,K=await(0,a.$wr)(oe,void 0,Y,void 0,O.existsFile);return K?(se.path=K,se.isFromPath=!0,se):t(n,l,p,O,D,E)}return await O.existsFile((0,s.$hc)(oe))?se:t(n,l,p,O,D,E,I,j,U)}}),define(ie[263],ne([0,1,3,2,4,42,18,6,226,94,258,125,260,262,108,72]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;var w;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let $=class extends A.$Sc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(h,k,c,i){super(),this.M=h,this.N=k,this.O=c,this.P=i,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$Od),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$Od),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$Od),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$Od),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$Od),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$Od),this.onProcessData=this.D.event,this.F=this.B(new P.$Od),this.onProcessReady=this.F.event,this.G=this.B(new P.$Od),this.onProcessReplay=this.G.event,this.H=this.B(new P.$Od),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$Od),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$Od),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$Od),this.onProcessExit=this.L.event,(0,y.$mr)(),this.B(this.M),this.B((0,A.$Qc)(()=>this.W())),this.j=this.B(new g.$fr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$j)return process.env;try{return await(0,a.$Ul)(this.N,this.O,{_:[]},process.env)}catch(h){return this.O.error("ptyHost was unable to resolve shell environment",h),{}}}U(){const h=this.M.start(),k=h.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),R.ProxyChannel.toService(k.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(h.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=w.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const i=R.ProxyChannel.toService(k.getChannel(b.TerminalIpcChannels.PtyHost));return this.B(i.onProcessData(o=>this.D.fire(o))),this.B(i.onProcessReady(o=>this.F.fire(o))),this.B(i.onProcessExit(o=>this.L.fire(o))),this.B(i.onDidChangeProperty(o=>this.J.fire(o))),this.B(i.onProcessReplay(o=>this.G.fire(o))),this.B(i.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(i.onDidRequestDetach(o=>this.I.fire(o))),this.B(new u.$er(this.P,k.getChannel(b.TerminalIpcChannels.Logger))),this.a=h,this.b=i,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[h,i]}async createProcess(h,k,c,i,o,r,t,n,l,p,O){const D=setTimeout(()=>this.$(),b.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(h,k,c,i,o,r,t,n,l,p,O);return clearTimeout(D),E}updateTitle(h,k,c){return this.f.updateTitle(h,k,c)}updateIcon(h,k,c,i){return this.f.updateIcon(h,k,c,i)}attachToProcess(h){return this.f.attachToProcess(h)}detachFromProcess(h,k){return this.f.detachFromProcess(h,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(h){return this.f.start(h)}shutdown(h,k){return this.f.shutdown(h,k)}input(h,k){return this.f.input(h,k)}processBinary(h,k){return this.f.processBinary(h,k)}resize(h,k,c){return this.f.resize(h,k,c)}clearBuffer(h){return this.f.clearBuffer(h)}acknowledgeDataEvent(h,k){return this.f.acknowledgeDataEvent(h,k)}setUnicodeVersion(h,k){return this.f.setUnicodeVersion(h,k)}getInitialCwd(h){return this.f.getInitialCwd(h)}getCwd(h){return this.f.getCwd(h)}async getLatency(){const h=new m.$Kd,k=await this.f.getLatency();return h.stop(),[{label:"ptyhostservice<->ptyhost",latency:h.elapsed()},...k]}orphanQuestionReply(h){return this.f.orphanQuestionReply(h)}installAutoReply(h,k){return this.f.installAutoReply(h,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(h){return this.f.uninstallAutoReply(h)}getDefaultSystemShell(h){return this.g?.getDefaultSystemShell(h)??(0,v.$El)(h??s.OS,process.env)}async getProfiles(h,k,c,i=!1){const o=await this.S();return(0,f.$yr)(k,c,i,this.N,o,void 0,this.O,this.bb.bind(this,h))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(h,k){return this.f.getWslPath(h,k)}getRevivedPtyNewId(h,k){return this.f.getRevivedPtyNewId(h,k)}setTerminalLayoutInfo(h){return this.f.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return this.g?.getTerminalLayoutInfo(h)}async requestDetachInstance(h,k){return this.f.requestDetachInstance(h,k)}async acceptDetachInstanceReply(h,k){return this.f.acceptDetachInstanceReply(h,k)}async freePortKillProcess(h){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(h)}async serializeTerminalState(h){return this.f.serializeTerminalState(h)}async reviveTerminalProcesses(h,k,c){return this.f.reviveTerminalProcesses(h,k,c)}async refreshProperty(h,k){return this.f.refreshProperty(h,k)}async updateProperty(h,k,c){return this.f.updateProperty(h,k,c)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(h){this.ab(),this.s=setTimeout(()=>this.Y(),h?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(h,k){return this.j.createRequest({workspaceId:h,originalText:k})}async acceptPtyHostResolvedVariables(h,k){this.j.acceptReply(h,k)}};e.$zr=$,e.$zr=$=Ee([te(1,C.$ki),te(2,S.$$i),te(3,S.$_i)],$)}),define(ie[67],ne([0,1,15,3,2,4,18,5,34]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=e.$P6b=void 0;const a="#FFFFFF",g="#1E1E1E",b="#000000",y="#FFFFFF",f="theme",v="themeBackground",m="windowSplash";e.$P6b=(0,S.$Qh)("themeMainService");let w=class extends s.$Sc{constructor(d,h){super(),this.b=d,this.c=h,this.a=this.B(new A.$Od),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.$j){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.$k){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.$l&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const d=this.getColorScheme();if(d.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return d.dark?b:y;let h=this.b.getItem(v,null);if(!h)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":h=a;break;case"hc-black":h=b;break;case"hc-light":h=y;break;default:h=g}return R.$k&&h.toUpperCase()===g&&(h="#171717"),h}saveWindowSplash(d,h){this.b.setItems([{key:f,data:h.baseTheme},{key:v,data:h.colorInfo.background},{key:m,data:h}]),typeof d=="number"&&this.f(d,h)}f(d,h){for(const k of P.BrowserWindow.getAllWindows())if(k.id===d){k.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(m)}};e.$Q6b=w,e.$Q6b=w=Ee([te(0,u.$FN),te(1,C.$ki)],w)}),define(ie[126],ne([0,1,3,18,5,6]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.ProvidedOnAutoForward=e.$dv=e.TunnelPrivacyId=e.TunnelProtocol=e.$cv=e.$bv=void 0,e.$bv=(0,s.$Qh)("tunnelService"),e.$cv=(0,s.$Qh)("sharedTunnelsService");var C;(function(w){w.Http="http",w.Https="https"})(C||(e.TunnelProtocol=C={}));var S;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(S||(e.TunnelPrivacyId=S={}));function u(w){return!!w.forwardPort}e.$dv=u;var a;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function g(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const $=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if($)return{address:$[1],port:+$[2]}}e.$ev=g,e.$fv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(w){return e.$fv.indexOf(w)>=0}e.$gv=b,e.$hv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(w){return e.$hv.indexOf(w)>=0}e.$iv=y;function f(w,$,d,h){if(d===1)return!1;if(d===2&&y($)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(k?.length===4&&parseInt(k[1])>=18)return!1}return w<1024}e.$jv=f;class v{constructor($,d,h){this.remoteAddress=$,this.localAddress=d,this.b=h,this.a=new P.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$kv=v;let m=class{constructor($,d){this.j=$,this.k=d,this.a=new P.$Od,this.onTunnelOpened=this.a.event,this.b=new P.$Od,this.onTunnelClosed=this.b.event,this.c=new P.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const $=this.k.getValue("remote.localPortHost");return!$||$==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider($){return this.f=$,$?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures($){this.g=$.elevation,this.h=$.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const $=[],d=Array.from(this.e.values());for(const h of d){const k=Array.from(h.values());for(const c of k){const i=await c.value;i&&typeof i!="string"&&$.push(i)}}return $}async dispose(){for(const $ of this.e.values()){for(const{value:d}of $.values())await d.then(h=>typeof h!="string"?h?.dispose():void 0);$.clear()}this.e.clear()}setEnvironmentTunnel($,d,h,k,c){this.p($,d,Promise.resolve({tunnelRemoteHost:$,tunnelRemotePort:d,localAddress:h,privacy:k,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel($,d){(y($)||b($))&&($=e.$fv[0]);const h=this.r($,d);if(h)return++h.refcount,h.value}openTunnel($,d,h,k,c,i=!1,o,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${h} on local port ${c}.`);const t=this.f??$;if(!t)return;if(d||(d="localhost"),k||(k=this.l),this.f&&this.i.has(h)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(t,d,h,k,c,i,o,r);return n?n.then(l=>{if(l){if(typeof l=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(d,h),l}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(d,h);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.n(l);return(l.tunnelRemoteHost!==d||l.tunnelRemotePort!==h)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&l.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n($){return{tunnelRemotePort:$.tunnelRemotePort,tunnelRemoteHost:$.tunnelRemoteHost,tunnelLocalPort:$.tunnelLocalPort,localAddress:$.localAddress,privacy:$.privacy,protocol:$.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${$.tunnelRemoteHost}:${$.tunnelRemotePort} `);const d=this.e.get($.tunnelRemoteHost);if(d){const h=d.get($.tunnelRemotePort);h&&(h.refcount--,await this.o($.tunnelRemoteHost,$.tunnelRemotePort,h))}}}}async o($,d,h){if(h.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${$}:${d}.`);const k=h.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has($)&&this.e.get($).delete(d),k}}async closeTunnel($,d){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${$}:${d} `);const h=this.e.get($);if(h&&h.has(d)){const k=h.get(d);k.refcount=0,await this.o($,d,k)}}p($,d,h){this.e.has($)||this.e.set($,new Map),this.e.get($).set(d,{refcount:1,value:h})}async q($,d){const h=this.e.get($);if(h){const k=h.get(d),c=k?await k.value:void 0;(!c||typeof c=="string")&&h.delete(d),h.size===0&&this.e.delete($)}}r($,d){const h=[$];b($)?(h.push(...e.$fv),h.push(...e.$hv)):y($)&&h.push(...e.$hv);const k=h.map(c=>this.e.get(c));for(const c of k){const i=c?.get(d);if(i)return i}}canTunnel($){return!!g($)}t($,d,h,k,c,i,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${h} on local port ${k}.`);const r=h;this.i.add(r);const t=k===void 0?h:k,n={elevationRequired:c?this.isPortPrivileged(t):!1},l={remoteAddress:{host:d,port:h},localAddressPort:k,privacy:i,public:i?i!==S.Private:void 0,protocol:o},p=$.forwardPort(l,n);return p?(this.p(d,h,p),p.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),p}};e.$lv=m,e.$lv=m=Ee([te(0,R.$$i),te(1,A.$ki)],m)}),define(ie[48],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wU=e.$vU=e.DisablementReason=e.UpdateType=e.StateType=void 0;var A;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(A||(e.StateType=A={}));var s;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var R;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(R||(e.DisablementReason=R={})),e.$vU={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,S)=>({type:"idle",updateType:C,error:S}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.$wU=(0,P.$Qh)("updateService")}),define(ie[264],ne([0,1,4,188,57,43]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.$kn.as(s.$pn.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:P.$j&&!P.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ie[265],ne([0,1,3,48]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=e.$X7b=void 0;class s{constructor(S){this.a=S}listen(S,u){switch(u){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${u}`)}call(S,u,a){switch(u){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${u}`)}}e.$X7b=s;class R{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$Od,this.onStateChange=this.a.event,this.b=A.$vU.Uninitialized,this.c.listen("onStateChange")(u=>this.state=u),this.c.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$Y7b=R}),define(ie[40],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=void 0,e.$Jk=(0,P.$Qh)("IUriIdentityService")}),define(ie[266],ne([0,1,40,207,16,19,141,3,2]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;class a{static{this._clock=0}constructor(y){this.uri=y,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let g=class{constructor(y){this.g=y,this.c=new u.$Rc,this.f=2**16;const f=new Map,v=m=>{let w=f.get(m.scheme);return w===void 0&&(w=y.hasProvider(m)&&!this.g.hasCapability(m,1024),f.set(m.scheme,w)),w};this.c.add(S.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(m=>{f.delete(m.scheme)})),this.extUri=new R.$lg(v),this.d=new C.$Cr((m,w)=>this.extUri.compare(m,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,R.$xg)(y));const f=this.d.get(y);return f?f.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new a(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((v,m)=>v[1].time<m[1].time?1:v[1].time>m[1].time?-1:0);a._clock=0,this.d.clear();const f=this.f*.5;for(let v=0;v<f;v++)this.d.set(y[v][0],y[v][1].touch())}};e.$Dr=g,e.$Dr=g=Ee([te(0,s.$_j)],g),(0,A.$Ar)(P.$Jk,g,1)}),define(ie[127],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kU=void 0,e.$kU=(0,P.$Qh)("urlService")}),define(ie[267],ne([0,1,7]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=e.$77b=e.$67b=void 0;class A{constructor(S){this.a=S}listen(S,u){throw new Error(`Event not found: ${u}`)}call(S,u,a){switch(u){case"handleURL":return this.a.handleURL(P.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${u}`)}}e.$67b=A;class s{constructor(S){this.a=S}handleURL(S,u){return this.a.call("handleURL",[S.toJSON(),u])}}e.$77b=s;class R{constructor(S,u){this.a=S,this.b=u}async routeCall(S,u,a,g){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(Array.isArray(a)&&a.length>0){const b=P.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const y=/\bwindowId=(\d+)/.exec(b.query);if(y){const f=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,b.toString(!0));const v=new RegExp(`window:${f}`),m=S.connections.find(w=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),v.test(w.ctx)));if(m)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),m;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,u,a,g)}routeEvent(S,u){throw new Error(`Event not found: ${u}`)}}e.$87b=R}),define(ie[268],ne([0,1,8,2,7,25]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mU=e.$lU=void 0;class C extends A.$Sc{constructor(){super(...arguments),this.a=new Set}open(a,g){const b=[...this.a.values()];return(0,P.$Yg)(b.map(y=>()=>y.handleURL(a,g)),void 0,!1).then(y=>y||!1)}registerHandler(a){return this.a.add(a),(0,A.$Qc)(()=>this.a.delete(a))}}e.$lU=C;let S=class extends C{constructor(a){super(),this.b=a}create(a){let{authority:g,path:b,query:y,fragment:f}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&b&&b.indexOf("/")!==0&&(b=`/${b}`),s.URI.from({scheme:this.b.urlProtocol,authority:g,path:b,query:y,fragment:f})}};e.$mU=S,e.$mU=S=Ee([te(0,R.$qj)],S)}),define(ie[269],ne([0,1,15,8,3,2,4,7]),function(J,e,P,A,s,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97b=void 0;class u extends R.$Sc{constructor(g,b,y,f,v,m){if(super(),this.c=b,this.f=m,this.a=[],this.b=0,g&&(m.trace("ElectronURLListener initialUrisToHandle:",g.map(d=>d.originalUrl)),this.a=g),C.$j){const d=f.isBuilt?[]:[`"${f.appRoot}"`];d.push("--open-url","--"),P.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,d)}const w=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(d,h)=>({event:d,url:h})),({event:d,url:h})=>(d.preventDefault(),h));this.B(w(d=>{const h=this.g(d);h&&this.c.open(h,{originalUrl:d})})),y.getWindows().filter(d=>d.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(y.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return S.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const b of this.a)await this.c.open(b.uri,{originalUrl:b.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),g.push(b));g.length!==0&&(this.a=g,(0,A.$Wg)(()=>this.h(),500,this.q))}}e.$97b=u}),define(ie[270],ne([0,1,3,2,16,56,31]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J8b=void 0;class S extends A.$Sc{constructor(a,g,b,y,f,v){super(),this.f=a,this.g=g,this.h=b,this.j=y,this.m=f,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$Od),this.onDidChangeFile=this.a.event,this.b=R.$Wh.forUris(()=>!(this.capabilities&1024)),this.c=new C.$Bc(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,g){return this.g.open(this.t(a),g)}close(a){return this.g.close(a)}read(a,g,b,y,f){return this.g.read(a,g,b,y,f)}write(a,g,b,y,f){return this.g.write(a,g,b,y,f)}watch(a,g){this.b.set(a,a);const b=this.g.watch(this.t(a),g);return(0,A.$Qc)(()=>{this.b.delete(a),b.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,g,b){return this.g.rename(this.t(a),this.t(g),b)}readFile(a,g){return this.g.readFile(this.t(a),g)}readFileStream(a,g,b){return this.g.readFileStream(this.t(a),g,b)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,g,b){return this.g.writeFile(this.t(a),g,b)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,g){return this.g.delete(this.t(a),g)}copy(a,g,b){if((0,s.$dk)(this.g))return this.g.copy(this.t(a),this.t(g),b);throw new Error("copy not supported")}cloneFile(a,g){if((0,s.$ek)(this.g))return this.g.cloneFile(this.t(a),this.t(g));throw new Error("clone not supported")}s(a){const g=[];for(const b of a){if(b.resource.scheme!==this.f)continue;const y=this.u(b.resource);this.b.findSubstr(y)&&g.push({resource:y,type:b.type,cId:b.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$J8b=S}),define(ie[271],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q8b=void 0,e.$q8b="utilityProcessWorker"}),define(ie[272],ne([0,1,5]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=void 0,e.$07b=(0,P.$Qh)("webviewManagerService")}),define(ie[273],ne([0,1,15,2,13,7]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$7b=void 0;class C extends A.$Sc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const u=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,u)}b(u,a){try{const g=R.URI.parse(u.url),b=C.a.get(g.path);if(typeof b=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${b}`,f=s.$dg.asFileUri(y);return a({path:f.fsPath,headers:{...s.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$$7b=C}),define(ie[68],ne([0,1,4]),function(J,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.$pC=e.$oC=e.$nC=e.$mC=e.$lC=e.$kC=e.$jC=void 0,e.$jC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(g){return!!g.workspaceUri}e.$kC=A;function s(g){return!!g.folderUri}e.$lC=s;function R(g){return!!g.fileUri}e.$mC=R;function C(g){const b=S(g),y=g.getValue("window.menuBarVisibility");return y==="default"||b==="native"&&y==="compact"||P.$k&&P.$n?"classic":y}e.$nC=C;function S(g){if(P.$p)return"custom";const b=g.getValue("window");if(b){if(P.$k&&b.nativeTabs===!0||P.$k&&b.nativeFullScreen===!1)return"native";const v=b.titleBarStyle;if(v==="native"||v==="custom")return v}return P.$l?"native":"custom"}e.$oC=S;function u(g){return!(!P.$j||P.$p||S(g)==="native")}e.$pC=u;function a(g=0){return Math.pow(1.2,g)}e.$qC=a}),define(ie[128],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$A6b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var A;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(A||(e.UnloadReason=A={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$A6b=s;var R;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(R||(e.WindowMode=R={}));var C;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(C||(e.WindowError=C={}))}),define(ie[274],ne([0,1,8,3,2]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=void 0;class R extends s.$Sc{constructor({onDidOpenWindow:S,onDidFocusWindow:u,getActiveWindowId:a}){super(),this.a=this.B(new s.$Rc),A.Event.latch(A.Event.any(S,u))(this.f,this,this.a),this.b=(0,P.$Ig)(()=>a()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$e8b=R}),define(ie[30],ne([0,1,192,9,56,19,7,5,13]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.WorkbenchState=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0,e.$Zh=(0,S.$Qh)("contextService");function a(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}e.$1h=a;function g(t){return typeof t?.id=="string"&&!a(t)&&!y(t)}e.$2h=g,e.$3h={id:"ext-dev"},e.$4h={id:"empty-window"};function b(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,A.$nc)(t)}:n?e.$3h:e.$4h;const l=t;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$5h=b;function y(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}e.$6h=y;function f(t){const n=t;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const l=t;if(l?.configPath)return{id:l.id,configPath:C.URI.revive(l.configPath)};if(t?.id)return{id:t.id}}e.$7h=f;var v;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function m(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$8h=m;function w(t){const n=t;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$9h=w;class ${constructor(n,l,p,O,D){this.h=n,this.j=p,this.k=O,this.l=D,this.c=s.$Wh.forUris(this.l,()=>!0),this.folders=l}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Wh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$0h=$;class d{constructor(n,l){this.raw=l,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.$wg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$$h=d;function h(t){return new d({uri:t,index:0,name:(0,R.$sg)(t)},{uri:t.toString()})}e.$_h=h,e.$ai="code-workspace",e.$bi=`.${e.$ai}`,e.$ci=[{name:(0,P.localize)(0,null),extensions:[e.$ai]}],e.$di="workspace.json";function k(t,n){return R.$ng.isEqualOrParent(t,n.untitledWorkspacesHome)}e.$ei=k;function c(t){let n;return C.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===u.Schemas.tmp}e.$fi=c,e.$gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$gi}e.$hi=i;function o(t,n){return!k(t,n)&&!c(t)}e.$ii=o;function r(t){return(typeof t=="string"?(0,A.$oc)(t):(0,R.$ug)(t))===e.$bi}e.$ji=r}),define(ie[59],ne([0,1,15,8,55,46,2,85,4,21,167,115,5,6,25,30]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W6b=e.$V6b=void 0,e.$V6b=(0,y.$Qh)("dialogMainService");let w=class{constructor(d,h){this.d=d,this.e=h,this.a=new Map,this.b=new Map,this.c=new A.$2g}pickFileFolder(d,h){return this.f({...d,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},h)}pickFolder(d,h){return this.f({...d,pickFolders:!0,title:(0,g.localize)(1,null)},h)}pickFile(d,h){return this.f({...d,pickFiles:!0,title:(0,g.localize)(2,null)},h)}pickWorkspace(d,h){const k=(0,g.localize)(3,null),c=(0,R.$Cv)((0,g.localize)(4,null)),i=m.$ci;return this.f({...d,pickFiles:!0,title:k,filters:i,buttonLabel:c},h)}async f(d,h){const k={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(k.properties=void 0,d.pickFiles&&d.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),u.$k&&k.properties.push("treatPackageAsDirectory");const c=await this.showOpenDialog(k,(h||P.BrowserWindow.getFocusedWindow())??void 0);if(c&&c.filePaths&&c.filePaths.length>0)return c.filePaths}g(d){if(d){let h=this.b.get(d.id);return h||(h=new A.$2g,this.b.set(d.id,h)),h}else return this.c}showMessageBox(d,h){return this.g(h).queue(async()=>{const{options:k,buttonIndeces:c}=(0,b.$Jv)(d,this.e);let i;return h?i=await P.dialog.showMessageBox(h,k):i=await P.dialog.showMessageBox(k),{response:c[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(d,h){const k=this.j(d,h);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(h).queue(async()=>{let c;return h?c=await P.dialog.showSaveDialog(h,d):c=await P.dialog.showSaveDialog(d),c.filePath=this.h(c.filePath),c})}finally{(0,C.$Nc)(k)}}h(d){return d&&u.$k&&(d=(0,S.$pl)(d)),d}i(d){return d.map(h=>this.h(h))}async showOpenDialog(d,h){d.defaultPath&&(await a.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const k=this.j(d,h);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(h).queue(async()=>{let c;return h?c=await P.dialog.showOpenDialog(h,d):c=await P.dialog.showOpenDialog(d),c.filePaths=this.i(c.filePaths),c})}finally{(0,C.$Nc)(k)}}j(d,h){if(!h)return C.$Sc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",d);let k=this.a.get(h.id);k||(k=new Set,this.a.set(h.id,k));const c=(0,s.$Ei)(d);if(!k.has(c))return this.d.trace("[DialogMainService]: new file dialog lock created",d),k.add(c),(0,C.$Qc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",d),k?.delete(c),k?.size===0&&this.a.delete(h.id)})}};e.$W6b=w,e.$W6b=w=Ee([te(0,f.$$i),te(1,v.$qj)],w)}),define(ie[275],ne([0,1,3,2,76,30]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=void 0;class C extends A.$Sc{static{this.a=100}constructor(u,a){super(),this.f=u,this.g=a,this.b=this.B(new P.$Od),this.c=new Map,this.h(a.applicationStorage,this.b)}h(u,a){this.B(P.Event.debounce(u.onDidChangeStorage,(g,b)=>(g?g.push(b):g=[b],g),C.a)(g=>{g.length&&a.fire(this.j(g,u))}))}j(u,a){const g=new Map,b=new Set;return u.forEach(y=>{const f=a.get(y.key);typeof f=="string"?g.set(y.key,f):b.add(y.key)}),{changed:Array.from(g.entries()),deleted:Array.from(b.values())}}listen(u,a,g){switch(a){case"onDidChangeStorage":{const b=g.profile?(0,s.$nh)(g.profile):void 0;if(!b)return this.b.event;let y=this.c.get(b.id);return y||(y=this.B(new P.$Od),this.h(this.g.profileStorage(b),y),this.c.set(b.id,y)),y.event}}throw new Error(`Event not found: ${a}`)}async call(u,a,g){const b=g.profile?(0,s.$nh)(g.profile):void 0,y=(0,R.$7h)(g.workspace),f=await this.m(b,y);switch(a){case"getItems":return Array.from(f.items.entries());case"updateItems":{const v=g;if(v.insert)for(const[m,w]of v.insert)f.set(m,w);v.delete?.forEach(m=>f.delete(m));break}case"optimize":return f.optimize();case"isUsed":{const v=g.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${a}`)}}async m(u,a){let g;a?g=this.g.workspaceStorage(a):u?g=this.g.profileStorage(u):g=this.g.applicationStorage;try{await g.init()}catch(b){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":u?"profile":"application"} storage due to ${b}`)}return g}}e.$U7b=C}),define(ie[41],ne([0,1,55,3,2,19,7,189,36,16,5,6,30,31,40,8,32,27,12]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.ProfileResourceType=void 0;var h;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function k(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.$Kk=k,e.$Lk=(0,g.$Qh)("IUserDataProfilesService");function c(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:C.URI.revive(t.location).with({scheme:n}),globalStorageHome:C.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:C.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.$Mk=c;function i(t,n,l,p,O,D){return{id:t,name:n,location:l,isDefault:!1,shortName:O?.shortName,icon:O?.icon,globalStorageHome:D&&O?.useDefaultFlags?.globalState?D.globalStorageHome:(0,R.$wg)(l,"globalStorage"),settingsResource:D&&O?.useDefaultFlags?.settings?D.settingsResource:(0,R.$wg)(l,"settings.json"),keybindingsResource:D&&O?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,R.$wg)(l,"keybindings.json"),tasksResource:D&&O?.useDefaultFlags?.tasks?D.tasksResource:(0,R.$wg)(l,"tasks.json"),snippetsHome:D&&O?.useDefaultFlags?.snippets?D.snippetsHome:(0,R.$wg)(l,"snippets"),extensionsResource:D&&O?.useDefaultFlags?.extensions?D.extensionsResource:(0,R.$wg)(l,"extensions.json"),cacheHome:(0,R.$wg)(p,t),useDefaultFlags:O?.useDefaultFlags,isTransient:O?.transient}}e.$Nk=i;let o=class extends s.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,l,p,O){super(),this.t=n,this.u=l,this.w=p,this.y=O,this.f=!0,this.h=this.B(new A.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),l=[n];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,d.$zf)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}l.push(i((0,R.$tg)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},n))}}catch(D){this.y.error(D)}const p=new f.$Ac,O=new Map;if(l.length)try{const D=this.Q();if(D.workspaces)for(const[E,I]of Object.entries(D.workspaces)){const j=C.URI.parse(E),U=l.find(z=>z.id===I);U&&p.set(j,U)}if(D.emptyWindows)for(const[E,I]of Object.entries(D.emptyWindows)){const j=l.find(U=>U.id===I);j&&O.set(E,j)}}catch(D){this.y.error(D)}this.z={profiles:l,workspaces:p,emptyWindows:O}}return this.z}D(){const n=i("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const l="Temp",p=new RegExp(`${(0,$.$Ge)(l)}\\s(\\d+)`);let O=0;for(const E of this.profiles){const I=p.exec(E.name),j=I?parseInt(I[1]):0;O=j>O?j:O}const D=`${l} ${O+1}`;return this.createProfile((0,P.$Ei)((0,w.$fg)()).toString(16),D,{transient:!0},n)}async createNamedProfile(n,l,p){return this.createProfile((0,P.$Ei)((0,w.$fg)()).toString(16),n,l,p)}async createProfile(n,l,p,O){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(n,l,p);return O&&await this.setProfileForWorkspace(O,D),D}async F(n,l,p){if(!(0,d.$zf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let O=this.r.get(l);return O||(O=(async()=>{try{const D=this.profiles.find(j=>j.name===l||j.id===n);if(D)return D;const E=i(n,l,(0,R.$wg)(this.profilesHome,n),this.g,p,this.defaultProfile);await this.u.createFolder(E.location);const I=[];return this.j.fire({profile:E,join(j){I.push(j)}}),await m.Promises.settled(I),this.I([E],[],[]),E}finally{this.r.delete(l)}})(),this.r.set(l,O)),O}async updateProfile(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(O=>O.id===n.id);if(!p)throw new Error(`Profile '${n.name}' does not exist`);return p=i(p.id,l.name??p.name,p.location,this.g,{shortName:l.shortName??p.shortName,icon:l.icon===null?void 0:l.icon??p.icon,transient:l.transient??p.isTransient,useDefaultFlags:l.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(O=>O.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);const p=[];this.m.fire({profile:l,join(O){p.push(O)}});try{await Promise.allSettled(p)}catch(O){this.y.error(O)}for(const O of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(O)?.id&&this.C.emptyWindows.delete(O);for(const O of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(O)?.id&&this.C.workspaces.delete(O);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(O){(0,a.$qk)(O)!==1&&this.y.error(O)}}async setProfileForWorkspace(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(O=>O.id===l.id);if(!p)throw new Error(`Profile '${l.name}' does not exist`);this.L(n,p)}unsetWorkspace(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(l=>l.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(n.map(l=>this.removeProfile(l)))}getProfileForWorkspace(n){const l=this.G(n);return C.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(n){return(0,y.$1h)(n)?n.uri:(0,y.$6h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,n.location)))}I(n,l,p){const O=[...this.profiles,...n],D=[];this.s.profiles=[];for(let E of O)E.isDefault||l.some(I=>E.id===I.id)||(E=p.find(I=>E.id===I.id)??E,E.isTransient?this.s.profiles.push(E):D.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(D),this.z=void 0,this.J(n,l,p)}J(n,l,p){this.h.fire({added:n,removed:l,updated:p,all:this.profiles})}L(n,l,p){p=l?.isTransient?!0:p,p||this.L(n,void 0,!0);const O=this.G(n),D=p?this.s:this.C;C.URI.isUri(O)?(D.workspaces.delete(O),l&&D.workspaces.set(O,l)):(D.emptyWindows.delete(O),l&&D.emptyWindows.set(O,l)),p||this.M()}M(){const n={};for(const[p,O]of this.C.workspaces.entries())n[p.toString()]=O.id;const l={};for(const[p,O]of this.C.emptyWindows.entries())l[p.toString()]=O.id;this.R({workspaces:n,emptyWindows:l}),this.z=void 0}N(n){const l={},p=this.D();if(n.workspaces)for(const[D,E]of Object.entries(n.workspaces)){const I=C.URI.parse(E);l[D]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}const O={};if(n.emptyWindows)for(const[D,E]of Object.entries(n.emptyWindows)){const I=C.URI.parse(E);O[D]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}return{workspaces:l,emptyWindows:O}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ok=o,e.$Ok=o=Ee([te(0,u.$Xh),te(1,a.$_j),te(2,v.$Jk),te(3,b.$$i)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Pk=r}),define(ie[81],ne([0,1,8,17,2,3,31,7,117,123,16,5,6,41,40,12,14,26]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class h extends Error{constructor(r,t){super(r),this.code=t}}e.$xp=h,e.$yp=(0,b.$Qh)("IExtensionsProfileScannerService");let k=class extends s.$Sc{constructor(r,t,n,l,p,O){super(),this.j=r,this.m=t,this.n=n,this.r=l,this.s=p,this.t=O,this.b=this.B(new R.$Od),this.onAddExtensions=this.b.event,this.c=this.B(new R.$Od),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.$Od),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.$Od),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Ac}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t){const n=[],l=[];try{return await this.u(t,p=>{const O=[];for(const D of p)r.some(([E])=>(0,a.$Do)(E.identifier,D.identifier)&&E.manifest.version!==D.version)?n.push(D):O.push(D);for(const[D,E]of r){const I=O.findIndex(U=>(0,a.$Do)(U.identifier,D.identifier)&&U.version===D.manifest.version),j={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:E};I===-1?(l.push(j),O.push(j)):O.splice(I,1,j)}return l.length&&this.b.fire({extensions:l,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),O}),l.length&&this.c.fire({extensions:l,profileLocation:t}),n.length&&this.g.fire({extensions:n,profileLocation:t}),l}catch(p){throw l.length&&this.c.fire({extensions:l,error:p,profileLocation:t}),n.length&&this.g.fire({extensions:n,error:p,profileLocation:t}),p}}async updateMetadata(r,t){const n=[];return await this.u(t,l=>{const p=[];for(const O of l){const D=r.find(([E])=>(0,a.$Do)(E.identifier,O.identifier)&&E.manifest.version===O.version);D&&(O.metadata={...O.metadata,...D[1]},n.push(O)),p.push(O)}return p}),n}async removeExtensionFromProfile(r,t){const n=[];try{await this.u(t,l=>{const p=[];for(const O of l)(0,a.$Do)(O.identifier,r.identifier)?n.push(O):p.push(O);return n.length&&this.f.fire({extensions:n,profileLocation:t}),p}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(l){throw n.length&&this.g.fire({extensions:n,error:l,profileLocation:t}),l}}async u(r,t,n){return this.F(r).queue(async()=>{let l=[],p;try{const O=await this.m.readFile(r);p=JSON.parse(O.value.toString().trim()||"[]")}catch(O){if((0,g.$qk)(O)!==1)throw O;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&n?.bailOutWhenFileNotFound)throw new h((0,w.$0)(O),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(r);let O=!1;for(const D of p){c(D)||this.w(r);let E;if((0,m.$zf)(D.relativeLocation)&&D.relativeLocation)E=this.z(D.relativeLocation);else if((0,m.$zf)(D.location))E=this.z(D.location),O=!0,D.relativeLocation=D.location,D.location=E.toJSON();else{E=S.URI.revive(D.location);const I=this.y(E);I&&(O=!0,D.relativeLocation=I)}l.push({identifier:D.identifier,location:E,version:D.version,metadata:D.metadata})}O&&await this.m.writeFile(r,A.$ce.fromString(JSON.stringify(p)))}if(t){l=t(l);const O=l.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(r,A.$ce.fromString(JSON.stringify(O)))}return l})}w(r){const t=new h(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(p){if((0,g.$qk)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",r.toString());let l;try{const p=JSON.parse(n);Array.isArray(p)&&p.every(O=>c(O))?l=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ce.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,g.$qk)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(r)}catch(p){(0,g.$qk)(p)!==1&&this.t.error(p)}try{await this.m.del(t)}catch(p){(0,g.$qk)(p)!==1&&this.t.error(p)}return l})()),this.C}F(r){let t=this.h.get(r);return t||(t=new P.$2g,this.h.set(r,t)),t}};e.$zp=k,e.$zp=k=Ee([te(1,g.$_j),te(2,f.$Lk),te(3,v.$Jk),te(4,$.$dl),te(5,y.$$i)],k);function c(o){return(0,m.$Bf)(o)&&(0,u.$ao)(o.identifier)&&(i(o.location)||(0,m.$zf)(o.location)&&o.location)&&((0,m.$Gf)(o.relativeLocation)||(0,m.$zf)(o.relativeLocation))&&o.version&&(0,m.$zf)(o.version)}function i(o){return o?(0,m.$zf)(o.path)&&(0,m.$zf)(o.scheme):!1}}),define(ie[129],ne([0,1,23,8,37,17,14,44,152,2,13,9,4,19,205,73,12,7,172,36,123,120,204,16,5,6,25,3,76,81,41,40,203]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k,c,i,o,r,t,n,l,p,O,D,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.Translations=void 0;var j;(function(ce){function Y(K,Q){if(K===Q)return!0;const q=Object.keys(K),W=new Set;for(const G of Object.keys(Q))W.add(G);if(q.length!==W.size)return!1;for(const G of q){if(K[G]!==Q[G])return!1;W.delete(G)}return W.size===0}ce.equals=Y})(j||(e.Translations=j={})),e.$Cp=(0,r.$Qh)("IExtensionsScannerService");let U=class extends a.$Sc{constructor(Y,K,Q,q,W,G,H,Z,re,L,M,N){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=K,this.r=Q,this.s=q,this.t=W,this.u=G,this.w=H,this.y=Z,this.z=re,this.C=L,this.D=M,this.F=N,this.g=this.B(new l.$Od),this.onDidChangeCache=this.g.event,this.h=(0,f.$wg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(x,this.s,this.h)),this.m=this.B(this.F.createInstance(x,this.s,this.h)),this.n=this.B(this.F.createInstance(X,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,k.$Oo)(this.w,this.y)),this.G}async scanAllExtensions(Y,K,Q){const[q,W]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(K)]),G=Q?await this.scanExtensionsUnderDevelopment(Y,[...q,...W]):[];return this.L(q,W,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const K=[];K.push(this.M(!!Y.useCache,Y.language)),K.push(this.N(Y.language,!!Y.checkControlFile));const[Q,q]=await Promise.all(K);return this.J([...Q,...q],0,Y,!1)}async scanUserExtensions(Y){const K=Y.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const Q=this.D.extUri.isEqual(Y.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(K,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,Q),W=Y.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let G;try{G=await W.scanExtensions(q)}catch(H){if(H instanceof O.$xp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await W.scanExtensions(q);else throw H}return G=await this.J(G,1,Y,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Y,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const Q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===g.Schemas.file).map(async q=>{const W=await this.P(q,!1,1,!0,Y.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(W)).map(H=>(H.type=K.find(Z=>(0,k.$Do)(Z.identifier,H.identifier))?.type??H.type,this.n.validate(H,W)))}))).flat();return this.J(Q,"development",Y,!0)}return[]}async scanExistingExtension(Y,K,Q){const q=await this.P(Y,!1,K,!0,Q.language,!0,void 0),W=await this.n.scanExtension(q);return!W||!Q.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(Y,K,Q){const q=await this.P(Y,!1,K,!0,Q.language,!0,void 0),W=await this.n.scanOneOrMultipleExtensions(q);return this.J(W,K,Q,!0)}async scanMetadata(Y){const K=(0,f.$wg)(Y,"package.json"),Q=(await this.w.readFile(K)).value.toString();return JSON.parse(Q).__metadata}async updateMetadata(Y,K){const Q=(0,f.$wg)(Y,"package.json"),q=(await this.w.readFile(Q)).value.toString(),W=JSON.parse(q);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,W.__metadata={...W.__metadata,...K},await this.w.writeFile((0,f.$wg)(Y,"package.json"),R.$ce.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof O.$xp&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Y}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.u.addExtensionsToProfile(Y.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,R.$ce.fromString(JSON.stringify([])))}catch(K){(0,o.$qk)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.y.error(Y)}finally{this.H=void 0}})()),this.H}async J(Y,K,Q,q){return Q.includeAllVersions||(Y=this.L(K===0?Y:void 0,K===1?Y:void 0,K==="development"?Y:void 0,await this.getTargetPlatform(),q)),Q.includeInvalid||(Y=Y.filter(W=>W.isValid)),Y.sort((W,G)=>{const H=b.$nc(W.location.fsPath),Z=b.$nc(G.location.fsPath);return H<Z?-1:H>Z?1:0})}L(Y,K,Q,q,W){const G=(Z,re,L)=>{if(Z.isValid&&!re.isValid)return!1;if(Z.isValid===re.isValid){if(W&&v.gt(Z.manifest.version,re.manifest.version))return this.y.debug(`Skipping extension ${re.location.path} with lower version ${re.manifest.version} in favour of ${Z.location.path} with version ${Z.manifest.version}`),!1;if(v.eq(Z.manifest.version,re.manifest.version)){if(Z.type===0)return this.y.debug(`Skipping extension ${re.location.path} in favour of system extension ${Z.location.path} with same version`),!1;if(Z.targetPlatform===q)return this.y.debug(`Skipping extension ${re.location.path} from different target platform ${re.targetPlatform}`),!1}}return L?this.y.warn(`Overwriting user extension ${Z.location.path} with ${re.location.path}.`):this.y.debug(`Overwriting user extension ${Z.location.path} with ${re.location.path}.`),!0},H=new c.$9l;return Y?.forEach(Z=>{const re=H.get(Z.identifier.id);(!re||G(re,Z,!1))&&H.set(Z.identifier.id,Z)}),K?.forEach(Z=>{const re=H.get(Z.identifier.id);if(!re&&Y&&Z.type===0){this.y.debug(`Skipping obsolete system extension ${Z.location.path}.`);return}(!re||G(re,Z,!1))&&H.set(Z.identifier.id,Z)}),Q?.forEach(Z=>{const re=H.get(Z.identifier.id);(!re||G(re,Z,!0))&&H.set(Z.identifier.id,Z),H.set(Z.identifier.id,Z)}),[...H.values()]}async M(Y,K){this.y.trace("Started scanning system extensions");const Q=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),W=await(Y&&!Q.devMode?this.j:this.n).scanExtensions(Q);return this.y.trace("Scanned system extensions:",W.length),W}async N(Y,K){const Q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!Q?.length)return[];this.y.trace("Started scanning dev system extensions");const q=K?await this.O():{},W=[],G=$.URI.file(b.$hc(b.$jc(g.$dg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Z of Q){const re=q[Z.name]||"marketplace";switch(re){case"disabled":break;case"marketplace":W.push((0,f.$wg)(G,Z.name));break;default:W.push($.URI.file(re));break}}const H=await Promise.all(W.map(async Z=>this.n.scanExtension(await this.P(Z,!1,0,!0,Y,!0,void 0))));return this.y.trace("Scanned dev system extensions:",H.length),(0,P.$Hb)(H)}async O(){try{const Y=await this.w.readFile(this.r);return JSON.parse(Y.value.toString())}catch{return{}}}async P(Y,K,Q,q,W,G,H){const Z=await this.f(W??y.$w),re=await this.Q(Y),L=K&&!this.D.extUri.isEqual(Y,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=L?await this.Q(L):void 0;return new z(Y,re,L,M,K,H,Q,q,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,W,Z)}async Q(Y){try{const K=await this.w.stat(Y);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$Dp=U,e.$Dp=U=Ee([te(4,D.$Lk),te(5,O.$yp),te(6,o.$_j),te(7,t.$$i),te(8,h.$Xh),te(9,n.$qj),te(10,E.$Jk),te(11,r.$Ph)],U);class z{constructor(Y,K,Q,q,W,G,H,Z,re,L,M,N,T,F,B){this.location=Y,this.mtime=K,this.applicationExtensionslocation=Q,this.applicationExtensionslocationMtime=q,this.profile=W,this.profileScanOptions=G,this.type=H,this.excludeObsolete=Z,this.validate=re,this.productVersion=L,this.productDate=M,this.productCommit=N,this.devMode=T,this.language=F,this.translations=B}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,K){return(0,f.$pg)(Y.location,K.location)&&Y.mtime===K.mtime&&(0,f.$pg)(Y.applicationExtensionslocation,K.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&Y.profile===K.profile&&s.$_m(Y.profileScanOptions,K.profileScanOptions)&&Y.type===K.type&&Y.excludeObsolete===K.excludeObsolete&&Y.validate===K.validate&&Y.productVersion===K.productVersion&&Y.productDate===K.productDate&&Y.productCommit===K.productCommit&&Y.devMode===K.devMode&&Y.language===K.language&&j.equals(Y.translations,K.translations)}}e.$Ep=z;let X=class extends a.$Sc{constructor(Y,K,Q,q,W){super(),this.f=Y,this.g=K,this.h=Q,this.j=q,this.m=W}async scanExtensions(Y){const K=Y.profile?await this.r(Y):await this.n(Y);let Q={};if(Y.excludeObsolete&&Y.type===1)try{const q=(await this.j.readFile(this.f)).value.toString();Q=JSON.parse(q)}catch{}return(0,w.$Mf)(Q)?K:K.filter(q=>!Q[k.$Eo.create(q).toString()])}async n(Y){const K=await this.j.resolve(Y.location);if(!K.children?.length)return[];const Q=await Promise.all(K.children.map(async q=>{if(!q.isDirectory||Y.type===1&&(0,f.$tg)(q.resource).indexOf(".")===0)return null;const W=new z(q.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(W)}));return(0,P.$Hb)(Q).sort((q,W)=>q.location.path<W.location.path?-1:1)}async r(Y){let K=await this.s(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){K=K.filter(q=>!q.metadata?.isApplicationScoped);const Q=await this.s(Y.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,Y);K.push(...Q)}return K}async s(Y,K,Q){const q=await this.g.scanProfileExtensions(Y,Q.profileScanOptions);if(!q.length)return[];const W=await Promise.all(q.map(async G=>{if(K(G)){const H=new z(G.location,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(H,G.metadata)}return null}));return(0,P.$Hb)(W)}async scanOneOrMultipleExtensions(Y){try{if(await this.j.exists((0,f.$wg)(Y.location,"package.json"))){const K=await this.scanExtension(Y);return K?[K]:[]}else return await this.scanExtensions(Y)}catch(K){return this.m.error(`Error scanning extensions at ${Y.location.path}:`,(0,C.$0)(K)),[]}}async scanExtension(Y,K){try{let Q=await this.scanExtensionManifest(Y.location);if(Q){Q.publisher||(Q.publisher=c.$3l),K=K??Q.__metadata,delete Q.__metadata;const q=(0,k.$Io)(Q.publisher,Q.name),W=K?.id?{id:q,uuid:K.id}:{id:q},G=K?.isSystem?0:Y.type,H=G===0||!!K?.isBuiltin;Q=await this.t(Y.location,Q,z.createNlsConfiguration(Y));const Z={type:G,identifier:W,manifest:Q,location:Y.location,isBuiltin:H,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return Y.validate?this.validate(Z,Y):Z}}catch(Q){Y.type!==0&&this.m.error(Q)}return null}validate(Y,K){let Q=!0;const q=(0,i.$To)(K.productVersion,K.productDate,K.location,Y.manifest,Y.isBuiltin);for(const[W,G]of q)W===m.default.Error&&(Q=!1,this.m.error(this.z(K.location,G)));return Y.isValid=Q,Y.validations=q,Y}async scanExtensionManifest(Y){const K=(0,f.$wg)(Y,"package.json");let Q;try{Q=(await this.j.readFile(K)).value.toString()}catch(W){return(0,o.$qk)(W)!==1&&this.m.error(this.z(Y,(0,d.localize)(0,null,K.path,W.message))),null}let q;try{q=JSON.parse(Q)}catch{const G=[];(0,S.$Xm)(Q,G);for(const H of G)this.m.error(this.z(Y,(0,d.localize)(1,null,K.path,H.offset,H.length,(0,u.$Ap)(H.error))));return null}return(0,S.$7m)(q)!=="object"?(this.m.error(this.z(Y,(0,d.localize)(2,null,K.path))),null):q}async t(Y,K,Q){const q=await this.u(Y,K,Q);if(q)try{const W=[],G=await this.w(q.default,W);if(W.length>0)return W.forEach(Z=>{this.m.error(this.z(Y,(0,d.localize)(3,null,q.default?.path,(0,u.$Ap)(Z.error))))}),K;if((0,S.$7m)(q)!=="object")return this.m.error(this.z(Y,(0,d.localize)(4,null,q.default?.path))),K;const H=q.values||Object.create(null);return(0,I.$Bp)(this.m,K,H,G)}catch{}return K}async u(Y,K,Q){const q=(0,f.$wg)(Y,"package.nls.json"),W=(re,L)=>{L.forEach(M=>{this.m.error(this.z(Y,(0,d.localize)(5,null,re?.path,(0,u.$Ap)(M.error))))})},G=re=>{this.m.error(this.z(Y,(0,d.localize)(6,null,re?.path)))},H=`${K.publisher}.${K.name}`,Z=Q.translations[H];if(Z)try{const re=$.URI.file(Z),L=(await this.j.readFile(re)).value.toString(),M=[],N=(0,S.$Xm)(L,M);return M.length>0?(W(re,M),{values:void 0,default:q}):(0,S.$7m)(N)!=="object"?(G(re),{values:void 0,default:q}):{values:N.contents?N.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.j.exists(q))return;let L;try{L=await this.y(Y,Q)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const M=(await this.j.readFile(L.localized)).value.toString(),N=[],T=(0,S.$Xm)(M,N);return N.length>0?(W(L.localized,N),{values:void 0,default:L.original}):(0,S.$7m)(T)!=="object"?(G(L.localized),{values:void 0,default:L.original}):{values:T,default:L.original}}catch{return{values:void 0,default:L.original}}}}async w(Y,K){if(Y)try{const Q=(await this.j.readFile(Y)).value.toString();return(0,S.$Xm)(Q,K)}catch{}}y(Y,K){return new Promise((Q,q)=>{const W=G=>{const H=(0,f.$wg)(Y,`package.nls.${G}.json`);this.j.exists(H).then(Z=>{Z&&Q({localized:H,original:(0,f.$wg)(Y,"package.nls.json")});const re=G.lastIndexOf("-");re===-1?Q({localized:(0,f.$wg)(Y,"package.nls.json"),original:null}):(G=G.substring(0,re),W(G))})};if(K.devMode||K.pseudo||!K.language)return Q({localized:(0,f.$wg)(Y,"package.nls.json"),original:null});W(K.language)})}z(Y,K){return`[${Y.path}]: ${K}`}};X=Ee([te(1,O.$yp),te(2,E.$Jk),te(3,o.$_j),te(4,t.$$i)],X);let x=class extends X{constructor(Y,K,Q,q,W,G,H){super(K,q,W,G,H),this.G=Y,this.H=Q,this.D=this.B(new A.$Sg(3e3)),this.F=this.B(new l.$Od),this.onDidChangeCache=this.F.event}async scanExtensions(Y){const K=this.M(Y),Q=await this.I(K);if(this.C=Y,Q&&Q.input&&z.equals(Q.input,this.C))return this.m.debug("Using cached extensions scan result",Y.location.toString()),this.D.trigger(()=>this.L()),Q.result.map(W=>(W.location=$.URI.revive(W.location),W));const q=await super.scanExtensions(Y);return await this.J(K,{input:Y,result:q}),q}async I(Y){try{const K=await this.j.readFile(Y),Q=JSON.parse(K.value.toString());return{result:Q.result,input:(0,p.$nh)(Q.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",Y.path,(0,C.$0)(K))}return null}async J(Y,K){try{await this.j.writeFile(Y,R.$ce.fromString(JSON.stringify(K)))}catch(Q){this.m.debug("Error while writing the extension cache file:",Y.path,(0,C.$0)(Q))}}async L(){if(!this.C)return;const Y=this.M(this.C),K=await this.I(Y);if(!K)return;const Q=K.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$_m(q,Q))try{this.m.info("Invalidating Cache",Q,q),await this.j.del(Y),this.F.fire()}catch(W){this.m.error(W)}}M(Y){const K=this.N(Y);return this.h.extUri.joinPath(K.cacheHome,Y.type===0?c.$2l:c.$1l)}N(Y){return Y.type===0?this.H.defaultProfile:Y.profile?this.h.extUri.isEqual(Y.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(Y.location,K.extensionsResource))??this.G:this.H.defaultProfile}};x=Ee([te(2,D.$Lk),te(3,O.$yp),te(4,E.$Jk),te(5,o.$_j),te(6,t.$$i)],x);function oe(ce,Y){const K=(0,k.$Go)(ce.manifest.publisher,ce.manifest.name);return{id:K,identifier:new c.$7l(K),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:Y,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.$Fp=oe;class se extends U{constructor(Y,K,Q,q,W,G,H,Z,re,L,M,N){super(Y,K,(0,f.$wg)(Q,".vscode-oss-dev","extensions","control.json"),q,W,G,H,Z,re,L,M,N),this.R=(async()=>{if(y.$z)try{const T=await this.w.readFile($.URI.file(y.$z));return JSON.parse(T.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.R}}e.$Gp=se}),define(ie[276],ne([0,1,6,41,40,26,81,16,36,7]),function(J,e,P,A,s,R,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0;let g=class extends C.$zp{constructor(y,f,v,m,w,$){super(a.URI.file(y.extensionsPath),f,v,m,w,$)}};e.$MN=g,e.$MN=g=Ee([te(0,u.$Yh),te(1,S.$_j),te(2,A.$Lk),te(3,s.$Jk),te(4,R.$dl),te(5,P.$$i)],g)}),define(ie[277],ne([0,1,7,36,81,129,16,5,6,25,40,41]),function(J,e,P,A,s,R,C,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=void 0;let y=class extends R.$Gp{constructor(v,m,w,$,d,h,k,c){super(P.URI.file(d.builtinExtensionsPath),P.URI.file(d.extensionsPath),d.userHome,v.defaultProfile,v,m,w,$,d,h,k,c)}};e.$i8b=y,e.$i8b=y=Ee([te(0,b.$Lk),te(1,s.$yp),te(2,C.$_j),te(3,u.$$i),te(4,A.$Yh),te(5,a.$qj),te(6,g.$Jk),te(7,S.$Ph)],y)}),define(ie[278],ne([0,1,15,2,13,9,4,56,7,32,38,36,6,41]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8b=void 0;let v=class extends A.$Sc{constructor(w,$,d){super(),this.c=w,this.f=d,this.a=S.$Wh.forPaths(!C.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:w}=P.session;w.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,($,d)=>this.j($,d)),w.protocol.interceptFileProtocol(s.Schemas.file,($,d)=>this.h($,d)),this.B((0,A.$Qc)(()=>{w.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(w){const $=(0,R.$hc)(w);return this.a.get($)?A.$Sc.None:(this.a.set($,!0),(0,A.$Qc)(()=>this.a.delete($)))}h(w,$){const d=u.URI.parse(w.url);return this.f.error(`Refused to load resource ${d.fsPath} from ${s.Schemas.file}: protocol (original URL: ${w.url})`),$({error:-3})}j(w,$){const d=this.m(w);let h;return this.c.crossOriginIsolated&&((0,R.$nc)(d)==="workbench.html"||(0,R.$nc)(d)==="workbench-dev.html"?h=s.COI.CoopAndCoep:h=s.COI.getHeadersFromQuery(w.url)),this.a.findSubstr(d)?$({path:d,headers:h}):this.b.has((0,R.$oc)(d).toLowerCase())?$({path:d}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${d} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),$({error:-3}))}m(w){const $=u.URI.parse(w.url),d=s.$dg.uriToFileUri($);return(0,R.$hc)(d.fsPath)}createIPCObjectUrl(){let w;const $=u.URI.from({scheme:"vscode",path:(0,a.$fg)()}),d=$.toString(),h=async()=>w;return g.$wT.handle(d,h),this.f.trace(`IPC Object URL: Registered new channel ${d}.`),{resource:$,update:k=>w=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${d}.`),g.$wT.removeHandler(d)}}}};e.$A8b=v,e.$A8b=v=Ee([te(0,b.$Yh),te(1,f.$Lk),te(2,y.$$i)],v)}),define(ie[96],ne([0,1,8,3,2,65,12,111,5,41]),function(J,e,P,A,s,R,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$0o=e.$9o=e.$8o=void 0,e.$8o="__$__isNewStorageMarker",e.$9o="__$__targetStorageMarker",e.$0o=(0,u.$Qh)("storageService");var g;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var y;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function f(d){const h=d.get(e.$9o);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$$o=f;class v extends s.$Sc{static{this.a=60*1e3}constructor(h={flushInterval:v.a}){super(),this.m=h,this.b=this.B(new A.$Rd),this.c=this.B(new A.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new P.$7g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,k,c){return A.Event.filter(this.b.event,i=>i.scope===h&&(k===void 0||i.key===k),c)}n(){this.j.value=(0,P.$$g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,k){const{key:c,external:i}=k;if(c===e.$9o){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:c,target:this.J(h)[c],external:i})}w(h){this.f.fire({reason:h})}get(h,k,c){return this.P(k)?.get(h,c)}getBoolean(h,k,c){return this.P(k)?.getBoolean(h,c)}getNumber(h,k,c){return this.P(k)?.getNumber(h,c)}getObject(h,k,c){return this.P(k)?.getObject(h,c)}storeAll(h,k){this.y(()=>{for(const c of h)this.store(c.key,c.value,c.scope,c.target,k)})}store(h,k,c,i,o=!1){if((0,C.$If)(k)){this.remove(h,c,o);return}this.y(()=>{this.z(h,c,i),this.P(c)?.set(h,k,o)})}remove(h,k,c=!1){this.y(()=>{this.z(h,k,void 0),this.P(k)?.delete(h,c)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,k){const c=[],i=this.J(h);for(const o of Object.keys(i))i[o]===k&&c.push(o);return c}z(h,k,c,i=!1){const o=this.J(k);typeof c=="number"?o[h]!==c&&(o[h]=c,this.P(k)?.set(e.$9o,JSON.stringify(o),i)):typeof o[h]=="number"&&(delete o[h],this.P(k)?.set(e.$9o,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const k=this.P(h);return k?f(k):Object.create(null)}isNew(h){return this.getBoolean(e.$8o,h)===!0}async flush(h=g.NONE){this.f.fire({reason:h});const k=this.P(-1),c=this.P(0),i=this.P(1);switch(h){case g.NONE:await P.Promises.settled([k?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await P.Promises.settled([k?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,k=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return $(h,k,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,k){return this.w(g.NONE),(0,a.$Kk)(h)?this.R(h,k):this.S(h,k)}M(h,k){return!(h.id===k.id||m(k)&&m(h))}N(h,k,c){this.y(()=>{const i=new Set;for(const[o,r]of h)i.add(o),k.get(o)!==r&&this.u(c,{key:o,external:!0});for(const[o]of k.items)i.has(o)||this.u(c,{key:o,external:!0})})}}e.$_o=v;function m(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.$ap=m;class w extends v{constructor(){super(),this.U=this.B(new S.$6o(new S.$7o,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$6o(new S.$7o,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$6o(new S.$7o,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$bp=w;async function $(d,h,k,c,i,o){const r=j=>{try{return JSON.parse(j)}catch{return j}},t=new Map,n=new Map;d.forEach((j,U)=>{t.set(U,j),n.set(U,r(j))});const l=new Map,p=new Map;h.forEach((j,U)=>{l.set(U,j),p.set(U,r(j))});const O=new Map,D=new Map;k.forEach((j,U)=>{O.set(U,j),D.set(U,r(j))}),console.group(c!==i?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const E=[];if(t.forEach((j,U)=>{E.push({key:U,value:j})}),console.table(E),console.groupEnd(),console.log(n),c!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const j=[];l.forEach((U,z)=>{j.push({key:z,value:U})}),console.table(j),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${o})`);const I=[];O.forEach((j,U)=>{I.push({key:U,value:j})}),console.table(I),console.groupEnd(),console.log(D)}e.$cp=$}),define(ie[279],ne([0,1,23,8,3,2,9,72,7,21,111,161,6,96,26,30,13]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=e.$H6b=e.$G6b=e.$F6b=void 0;class $ extends R.$Sc{static{this.a=2e3}get storage(){return this.f}constructor(r,t){super(),this.m=r,this.n=t,this.b=this.B(new s.$Od),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Od),this.onDidCloseStorage=this.c.event,this.f=this.B(new g.$6o(new g.$7o,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new A.$dh,this.whenInit=this.h.p,this.j=g.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===g.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const t=r.getBoolean(f.$8o);t===void 0?r.set(f.$8o,!0):t&&r.set(f.$8o,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=g.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,t){return this.f.get(r,t)}set(r,t){return this.f.set(r,t)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$Kd(!1);await this.w(),r.stop(),r.elapsed()>$.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const t=(0,P.top)(Array.from(this.f.items.entries()).map(([l,p])=>({key:l,length:p.length})),(l,p)=>p.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),n=(await this.n.stat(u.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async w(){this.g&&await this.g,this.j=g.StorageState.Closed,await this.f.close()}}class d extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,C.$jc)(this.z.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,d.y)}constructor(r,t,n,l){super(n,l),this.z=r,this.C=t}async t(){return new g.$6o(new b.$2T(this.path??b.$2T.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:g.StorageHint.STORAGE_IN_MEMORY})}}class h extends d{constructor(r,t,n,l){super(r,t,n,l)}}e.$F6b=h;class k extends d{constructor(r,t,n,l){super(t.defaultProfile,r,n,l)}async s(r){await super.s(r),this.G(r)}G(r){r.get(v.$gl,void 0)===void 0&&r.set(v.$gl,new Date().toUTCString());const n=r.get(v.$fl,void 0),l=new Date().toUTCString();r.set(v.$hl,typeof n>"u"?null:n),r.set(v.$fl,l)}}e.$G6b=k;class c extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,C.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id,c.y)}constructor(r,t,n,l,p){super(n,p),this.C=r,this.D=t,this.F=l}async t(){const{storageFilePath:r,wasCreated:t}=await this.H();return new g.$6o(new b.$2T(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?g.StorageHint.STORAGE_IN_MEMORY:t?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:b.$2T.IN_MEMORY_PATH,wasCreated:!0};const r=(0,C.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id),t=(0,C.$jc)(r,c.y);return await a.Promises.exists(r)?{storageFilePath:t,wasCreated:!1}:(await a.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:t,wasCreated:!0})}async I(r){let t;if((0,m.$1h)(this.C)?t={folder:this.C.uri.toString()}:(0,m.$6h)(this.C)&&(t={workspace:this.C.configPath.toString()}),t)try{const n=(0,C.$jc)(r,c.z);await a.Promises.exists(n)||await a.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$H6b=c;class i extends ${get path(){}async t(){return new g.$6o(new g.$7o,{hint:g.StorageHint.STORAGE_IN_MEMORY})}}e.$I6b=i}),define(ie[280],ne([0,1,3,2,96]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=void 0;class R extends A.$Sc{constructor(S,u,a){super(),this.b=S,this.c=u,this.f=a;const g=this.B(new A.$Tc);this.a=this.B(new P.$Od({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new A.$Rc;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(u,a)=>(u?u.push(a.key):u=[a.key],u),100)(u=>this.h(u))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(u,a)=>{u||(u=new Map);let g=u.get(a.profile.id);return g||u.set(a.profile.id,g={profile:a.profile,keys:[],storage:a.storage}),g.keys.push(a.key),u},100)(u=>this.j(u))),S}h(S){const u=S.includes(s.$9o)?[this.c.defaultProfile]:[],a=[];if(S=S.filter(g=>g!==s.$9o),S.length){const g=(0,s.$$o)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:S.map(b=>({key:b,scope:0,target:g[b]}))})}this.m(u,a)}j(S){const u=[],a=new Map;for(const[g,b]of S.entries()){b.keys.includes(s.$9o)&&u.push(b.profile);const y=b.keys.filter(f=>f!==s.$9o);if(y.length){const f=(0,s.$$o)(b.storage.storage);a.set(g,{profile:b.profile,changes:y.map(v=>({key:v,scope:0,target:f[v]}))})}}this.m(u,[...a.values()])}m(S,u){(S.length||u.length)&&this.a.fire({valueChanges:u,targetChanges:S})}listen(S,u,a){switch(u){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${u}`)}async call(S,u){throw new Error(`Call not found: ${u}`)}}e.$k8b=R}),define(ie[281],ne([0,1,7,36,16,6,34,40,41,12,121]),function(J,e,P,A,s,R,C,S,u,a,g){"use strict";var b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.$JN=void 0;let f=class extends u.$Ok{static{b=this}static{this.a="profileAssociationsMigration"}constructor($,d,h,k,c){super(h,k,d,c),this.U=$,this.W=h}O(){return this.U.getItem(b.b,[]).map(d=>({...d,location:(0,a.$zf)(d.location)?this.w.extUri.joinPath(this.profilesHome,d.location):P.URI.revive(d.location)}))}Q(){const $=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$JN=f,e.$JN=f=b=Ee([te(0,C.$EN),te(1,S.$Jk),te(2,A.$Yh),te(3,s.$_j),te(4,R.$$i)],f);let v=y=class extends f{constructor($,d,h,k,c){super($,d,h,k,c),this.$=$}P($){$.length?this.$.setItem(y.b,$.map(d=>({...d,location:this.w.extUri.basename(d.location)}))):this.$.removeItem(y.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(y.c,$):this.$.removeItem(y.c)}Q(){const $="workspaceAndProfileInfo",d=this.$.getItem($,void 0);if(d){this.$.removeItem($);const k=d.reduce((c,{workspace:i,profile:o})=>(c[P.URI.revive(i).toString()]=P.URI.revive(o).toString(),c),{});this.$.setItem(y.c,{workspaces:k})}const h=super.Q();return this.$.getItem(y.a,!1)||(this.R(h),this.$.setItem(y.a,!0)),h}};e.$KN=v,e.$KN=v=y=Ee([te(0,C.$FN),te(1,S.$Jk),te(2,A.$Yh),te(3,s.$_j),te(4,R.$$i)],v);let m=class extends v{constructor($,d,h,k){super(new g.$IN(0,d,k,h),$,d,h,k)}async init(){return await this.$.init(),super.init()}};e.$LN=m,e.$LN=m=Ee([te(0,S.$Jk),te(1,A.$Yh),te(2,s.$_j),te(3,R.$$i)],m)}),define(ie[52],ne([0,1,36,16,5,6,40,41,281,34]),function(J,e,P,A,s,R,C,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=e.$J6b=void 0,e.$J6b=(0,s.$Rh)(S.$Lk);let g=class extends u.$KN{constructor(y,f,v,m,w){super(y,f,v,m,w)}getAssociatedEmptyWindows(){const y=[];for(const f of this.C.emptyWindows.keys())y.push({id:f});return y}};e.$K6b=g,e.$K6b=g=Ee([te(0,a.$FN),te(1,C.$Jk),te(2,P.$Yh),te(3,A.$_j),te(4,R.$$i)],g)}),define(ie[130],ne([0,1,19,7,30]),function(J,e,P,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$16b=e.$Z6b=e.$Y6b=void 0;async function R(u,a,g){for(const y of u){const f=y.openedWorkspace;if((0,s.$6h)(f)){const v=await g(f);if(v){if(v.folders.some(m=>P.$ng.isEqualOrParent(a,m.uri)))return y}else if(P.$ng.isEqualOrParent(a,f.configPath))return y}}const b=u.filter(y=>(0,s.$1h)(y.openedWorkspace)&&P.$ng.isEqualOrParent(a,y.openedWorkspace.uri));if(b.length)return b.sort((y,f)=>-(y.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.$Y6b=R;function C(u,a){for(const g of u)if((0,s.$6h)(g.openedWorkspace)&&P.$ng.isEqual(g.openedWorkspace.configPath,a)||(0,s.$1h)(g.openedWorkspace)&&P.$ng.isEqual(g.openedWorkspace.uri,a))return g}e.$Z6b=C;function S(u,a){const g=b=>a.some(y=>P.$ng.isEqual(A.URI.file(y),A.URI.file(b)));for(const b of u)if(b.config?.extensionDevelopmentPath?.some(y=>g(y)))return b}e.$16b=S}),define(ie[97],ne([0,1,33,44,139,46,13,9,4,19,7,5,58,30]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3U=e.$2U=e.$1U=e.$ZU=e.$YU=e.$XU=e.$WU=e.$VU=e.$UU=e.$TU=void 0,e.$TU=(0,b.$Qh)("workspacesService");function v(D){return D.hasOwnProperty("workspace")}e.$UU=v;function m(D){return D.hasOwnProperty("folderUri")}e.$VU=m;function w(D){return D.hasOwnProperty("fileUri")}e.$WU=w;function $(D){return d(D)||h(D)}e.$XU=$;function d(D){const E=D;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function h(D){const E=D;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function k(D,E,I,j,U){if(D.scheme!==j.scheme)return{name:I,uri:D.toString(!0)};let z=E?void 0:U.relativePath(j,D);if(z!==void 0)z.length===0?z=".":u.$j&&(z=c(z));else if(D.scheme===C.Schemas.file)z=D.fsPath,u.$j&&(z=c(z));else if(U.isEqualAuthority(D.authority,j.authority))z=D.path;else return{name:I,uri:D.toString(!0)};return{name:I,path:z}}e.$YU=k;function c(D){return D=(0,R.$wv)(D),(0,P.$Vf)(D)||(D=(0,P.$Sf)(D)),D}function i(D,E,I){const j=[],U=new Set,z=I.dirname(E);for(const X of D){let x;if(d(X))X.path&&(x=I.resolvePath(z,X.path));else if(h(X))try{x=g.URI.parse(X.uri),x.path[0]!==S.$gc.sep&&(x=x.with({path:S.$gc.sep+x.path}))}catch(oe){console.warn(oe)}if(x){const oe=I.getComparisonKey(x);if(!U.has(oe)){U.add(oe);const se=X.name||I.basenameOrAuthority(x);j.push(new f.$$h({uri:x,name:se,index:j.length},X))}}}return j}e.$ZU=i;function o(D,E,I,j,U){const z=r(E,D),X=U.dirname(E),x=U.dirname(j),oe=[];for(const K of z.folders){const Q=d(K)?U.resolvePath(X,K.path):g.URI.parse(K.uri);let q;I?q=!1:q=!d(K)||(0,S.$ic)(K.path),oe.push(k(Q,q,K.name,x,U))}const se={insertSpaces:!1,tabSize:4,eol:u.$l||u.$k?`
`:`\r
`},ce=s.$eT(D,["folders"],oe,se);let Y=s.$hT(D,ce);return(0,a.$Bg)(z.remoteAuthority,(0,y.$Vk)(j))&&(Y=s.$hT(Y,s.$dT(Y,["remoteAuthority"],se))),Y}e.$1U=o;function r(D,E){const I=A.$Xm(E);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(j=>$(j));else throw new Error(`${D} looks like an invalid workspace file.`);return I}function t(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function n(D){return typeof D.folderUri=="string"}function l(D){return typeof D.fileUri=="string"}function p(D,E){const I={workspaces:[],files:[]};if(D){const j=function(z,X){for(let x=0;x<z.length;x++)try{X(z[x],x)}catch(oe){E.warn(`Error restoring recent entry ${JSON.stringify(z[x])}: ${oe.toString()}. Skip entry.`)}},U=D;Array.isArray(U.entries)&&j(U.entries,z=>{const X=z.label,x=z.remoteAuthority;t(z)?I.workspaces.push({label:X,remoteAuthority:x,workspace:{id:z.workspace.id,configPath:g.URI.parse(z.workspace.configPath)}}):n(z)?I.workspaces.push({label:X,remoteAuthority:x,folderUri:g.URI.parse(z.folderUri)}):l(z)&&I.files.push({label:X,remoteAuthority:x,fileUri:g.URI.parse(z.fileUri)})})}return I}e.$2U=p;function O(D){const E={entries:[]};for(const I of D.workspaces)m(I)?E.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):E.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of D.files)E.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return E}e.$3U=O}),define(ie[98],ne([0,1,86,13,4,19]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=e.$46b=e.$36b=e.$26b=void 0,e.$26b=128/4;function C(a){function g(){let b=a.scheme===A.Schemas.file?(0,R.$kg)(a):a.toString();return s.$l||(b=b.toLowerCase()),(0,P.createHash)("md5").update(b).digest("hex")}return{id:g(),configPath:a}}e.$36b=C;function S(a,g){function b(){if(a.scheme!==A.Schemas.file)return(0,P.createHash)("md5").update(a.toString()).digest("hex");if(!g)return;let f;return s.$l?f=g.ino:s.$k?f=g.birthtime.getTime():s.$j&&(typeof g.birthtimeMs=="number"?f=Math.floor(g.birthtimeMs):f=g.birthtime.getTime()),(0,P.createHash)("md5").update(a.fsPath).update(f?String(f):"").digest("hex")}const y=b();if(typeof y=="string")return{id:y,uri:a}}e.$46b=S;function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$56b=u}),define(ie[99],ne([0,1,86,87,28,282,17,14,3,2,9,4,32,42,109]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;class m{traceSocketEvent(E,I){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,I)}constructor(E,I=""){this.f=!0,this.debugLabel=I,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,S.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const I=j=>{this.traceSocketEvent("read",j),E(C.$ce.wrap(j))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(E){const I=j=>{E({type:0,hadError:j,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(E){const I=()=>{E()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,S.$1)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,S.$1)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Fh=m;var w;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var $;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})($||($={}));class d extends a.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,I){this.socket.traceSocketEvent(E,I)}constructor(E,I,j,U){super(),this.f=this.B(new u.$Od),this.g=this.B(new u.$Od),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:j?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new h(this,I,j,U,this.f,(z,X)=>this.m(z,X))),this.B(this.a.onError(z=>{console.error(z),(0,S.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new v.$Ah,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let I=0;for(;I<E.byteLength;)this.a.writeMessage(E.slice(I,Math.min(I+262144,E.byteLength)),{compressed:!0,opcode:2}),I+=262144}m(E,{compressed:I,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let U=2;E.byteLength<126?U+=0:E.byteLength<2**16?U+=2:U+=8;const z=C.$ce.alloc(U),X=I?64:0,x=j&15;if(z.writeUInt8(128|X|x,0),E.byteLength<126)z.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){z.writeUInt8(126,1);let oe=1;z.writeUInt8(E.byteLength>>>8&255,++oe),z.writeUInt8(E.byteLength>>>0&255,++oe)}else{z.writeUInt8(127,1);let oe=1;z.writeUInt8(0,++oe),z.writeUInt8(0,++oe),z.writeUInt8(0,++oe),z.writeUInt8(0,++oe),z.writeUInt8(E.byteLength>>>24&255,++oe),z.writeUInt8(E.byteLength>>>16&255,++oe),z.writeUInt8(E.byteLength>>>8&255,++oe),z.writeUInt8(E.byteLength>>>0&255,++oe)}this.socket.write(C.$ce.concat([z,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),j=I.readUInt8(0),U=(j&128)>>>7,z=(j&64)>>>6,X=j&15,x=I.readUInt8(1),oe=(x&128)>>>7,se=x&127;this.j.state=2,this.j.readLen=2+(oe?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),j=I.readUInt8(1),U=(j&128)>>>7;let z=j&127,X=1;z===126?z=I.readUInt8(++X)*2**8+I.readUInt8(++X):z===127&&(z=I.readUInt8(++X)*0+I.readUInt8(++X)*0+I.readUInt8(++X)*0+I.readUInt8(++X)*0+I.readUInt8(++X)*2**24+I.readUInt8(++X)*2**16+I.readUInt8(++X)*2**8+I.readUInt8(++X));let x=0;U&&(x=I.readUInt8(++X)*2**24+I.readUInt8(++X)*2**16+I.readUInt8(++X)*2**8+I.readUInt8(++X)),this.j.state=3,this.j.readLen=z,this.j.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),i(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Gh=d;class h extends a.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$ce.alloc(0)}constructor(E,I,j,U,z,X){super(),this.n=E,this.r=z,this.s=X,this.a=this.B(new u.$Od),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new u.$Od),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new u.$Od),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new k(this.n,U,j,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(x=>this.a.fire(x))),this.B(this.f.onError(x=>this.a.fire(x)))):(this.b=null,this.f=null)}writeMessage(E,I){this.g.push({data:E,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:I}=this.g.shift();if(this.f&&I.compressed){const j=await this.w(this.f,E);this.s(j,I)}else this.s(E,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,I){return new Promise((j,U)=>{E.write(I),E.flush(z=>j(z))})}acceptFrame(E,I,j){this.h.push({data:E,isCompressed:I,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const I=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,I,j){return new Promise((U,z)=>{E.write(I),j&&E.write(C.$ce.fromByteArray([0,0,255,255])),E.flush(X=>U(X))})}}class k extends a.$Sc{get recordedInflateBytes(){return this.j?C.$ce.concat(this.f):C.$ce.alloc(0)}constructor(E,I,j,U){super(),this.h=E,this.j=I,this.a=this.B(new u.$Od),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(U),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(C.$ce.wrap(z))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=C.$ce.concat(this.g);this.g.length=0,E(I)})}}class c extends a.$Sc{constructor(E,I){super(),this.g=E,this.a=this.B(new u.$Od),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(C.$ce.wrap(j))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=C.$ce.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),E(I)})}}function i(D,E){if(E===0)return;const I=D.byteLength>>>2;for(let oe=0;oe<I;oe++){const se=D.readUInt32BE(oe*4);D.writeUInt32BE(se^E,oe*4)}const j=I*4,U=D.byteLength-j,z=E>>>24&255,X=E>>>16&255,x=E>>>8&255;U>=1&&D.writeUInt8(D.readUInt8(j)^z,j),U>=2&&D.writeUInt8(D.readUInt8(j+1)^X,j+1),U>=3&&D.writeUInt8(D.readUInt8(j+2)^x,j+2)}e.$Hh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function r(){const D=(0,y.$fg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const E=process.platform!=="darwin"&&e.$Hh?e.$Hh:(0,s.tmpdir)(),I=(0,g.$jc)(E,`vscode-ipc-${D}.sock`);return n(I),I}e.$Ih=r;function t(D,E,I){const j=(0,P.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${I}-${E}-sock`;const U=I.substr(0,4),z=E.substr(0,6),X=j.substr(0,8);let x;return process.platform!=="darwin"&&e.$Hh&&!process.env.VSCODE_PORTABLE?x=(0,g.$jc)(e.$Hh,`vscode-${X}-${U}-${z}.sock`):x=(0,g.$jc)(D,`${U}-${z}.sock`),n(x),x}e.$Jh=t;function n(D){const E=o[b.$u];typeof E=="number"&&D.length>=E&&console.warn(`WARNING: IPC handle "${D}" is longer than ${E} chars, try a shorter --user-data-dir`)}class l extends f.$uh{static b(E){const I=u.Event.fromNodeEventEmitter(E,"connection");return u.Event.map(I,j=>({protocol:new v.$Bh(new m(j,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(j,"close"))}))}constructor(E){super(l.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Kh=l;function p(D){return new Promise((E,I)=>{const j=(0,A.createServer)();j.on("error",I),j.listen(D,()=>{j.removeListener("error",I),E(new l(j))})})}e.$Lh=p;function O(D,E){return new Promise((I,j)=>{const U=(0,A.createConnection)(D,()=>{U.removeListener("error",j),I(v.$Ch.fromSocket(new m(U,`ipc-client${E}`),E))});U.once("error",j)})}e.$Mh=O}),define(ie[24],ne([0,1,54,9,4,99,36,90,5]),function(J,e,P,A,s,R,C,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C6b=e.$B6b=void 0,e.$B6b=(0,u.$Rh)(C.$Xh);class a extends S.$km{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,A.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,A.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,R.$Jh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,A.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$l){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const y=b.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[b]?process.env[y]=process.env[b]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$l)for(const b in this.d)process.env[b]=this.d[b],delete this.d[b]}}e.$C6b=a,Ee([P.$ih],a.prototype,"cachedLanguagesPath",null),Ee([P.$ih],a.prototype,"backupHome",null),Ee([P.$ih],a.prototype,"mainIPCHandle",null),Ee([P.$ih],a.prototype,"mainLockfile",null),Ee([P.$ih],a.prototype,"disableUpdates",null),Ee([P.$ih],a.prototype,"crossOriginIsolated",null),Ee([P.$ih],a.prototype,"codeCachePath",null),Ee([P.$ih],a.prototype,"useCodeCache",null)}),define(ie[283],ne([0,1,86,33,13,9,4,19,21,196,18,24,34,16,6,195,30,98]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=void 0;let h=class{static{d=this}static{this.a="backupWorkspaces"}constructor(c,i,o,r){this.j=c,this.k=i,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$ng,this.i={isEqual:(t,n)=>(0,A.$Xf)(t,n,!C.$l)}}async initialize(){const c=this.m.getItem(d.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(c.emptyWindows),this.d=await this.u((0,a.$S6b)(c)),this.e=await this.v((0,a.$T6b)(c)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.$yk.OFF}q(){return this.s()===f.$yk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.$yk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(c,i){this.d.some(r=>c.workspace.id===r.workspace.id)||(this.d.push(c),this.C());const o=(0,R.$jc)(this.c,c.workspace.id);return i?this.t(o,i).then(()=>o):o}async t(c,i){if(await u.Promises.exists(c)&&await this.z(c),await u.Promises.exists(i))try{await u.Promises.rename(i,c,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(c){return this.e.some(i=>this.h.isEqual(c.folderUri,i.folderUri))||(this.e.push(c),this.C()),(0,R.$jc)(this.c,this.D(c))}registerEmptyWindowBackup(c){return this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,c.backupFolder))||(this.g.push(c),this.C()),(0,R.$jc)(this.c,c.backupFolder)}async u(c){if(!Array.isArray(c))return[];const i=new Set,o=[];for(const r of c){const t=r.workspace;if(!(0,w.$6h)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,R.$jc)(this.c,t.id);await this.B(n)?t.configPath.scheme!==s.Schemas.file||await u.Promises.exists(t.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(c){if(!Array.isArray(c))return[];const i=[],o=new Set;for(const r of c){const t=r.folderUri,n=this.h.getComparisonKey(t);if(!o.has(n)){o.add(n);const l=(0,R.$jc)(this.c,this.D(r));await this.B(l)?t.scheme!==s.Schemas.file||await u.Promises.exists(t.fsPath)?i.push(r):await this.z(l):await this.x(l)}}return i}async w(c){if(!Array.isArray(c))return[];const i=[],o=new Set;for(const r of c){const t=r.backupFolder;if(typeof t!="string")return[];if(!o.has(t)){o.add(t);const n=(0,R.$jc)(this.c,t);await this.B(n)?i.push(r):await this.x(n)}}return i}async x(c){try{await u.Promises.rm(c,u.RimRafMode.MOVE)}catch(i){this.l.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}y(){let c=(0,$.$56b)();for(;this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,c.id));)c=(0,$.$56b)();return{backupFolder:c.id}}async z(c){const i=this.y(),o=(0,R.$jc)(this.c,i.backupFolder);try{await u.Promises.rename(c,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(i),!0}async getDirtyWorkspaces(){const c=[];for(const i of this.d)await this.A(i)&&c.push(i);for(const i of this.e)await this.A(i)&&c.push(i);return c}A(c){let i;return(0,a.$R6b)(c)?i=(0,R.$jc)(this.c,c.backupFolder):(0,m.$RU)(c)?i=(0,R.$jc)(this.c,this.D(c)):i=(0,R.$jc)(this.c,c.workspace.id),this.B(i)}async B(c){try{const i=await u.Promises.readdir(c);for(const o of i)try{if((await u.Promises.readdir((0,R.$jc)(c,o))).length>0)return!0}catch{}}catch{}return!1}C(){const c={workspaces:this.d.map(({workspace:i,remoteAuthority:o})=>{const r={id:i.id,configURIPath:i.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:i,remoteAuthority:o})=>{const r={folderUri:i.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:i,remoteAuthority:o})=>{const r={backupFolder:i};return o&&(r.remoteAuthority=o),r})};this.m.setItem(d.a,c)}D(c){const i=c.folderUri;let o;return i.scheme===s.Schemas.file?o=C.$l?i.fsPath:i.fsPath.toLowerCase():o=i.toString().toLowerCase(),(0,P.createHash)("md5").update(o).digest("hex")}};e.$g7b=h,e.$g7b=h=d=Ee([te(0,b.$B6b),te(1,g.$ki),te(2,v.$$i),te(3,y.$FN)],h)}),define(ie[20],ne([0,1,15,38,8,3,2,4,35,12,5,6,34,24]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=e.LifecycleMainPhase=e.ShutdownReason=e.$D6b=void 0,e.$D6b=(0,g.$Qh)("lifecycleMainService");var m;(function(d){d[d.QUIT=1]="QUIT",d[d.KILL=2]="KILL"})(m||(e.ShutdownReason=m={}));var w;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen",d[d.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let $=class extends C.$Sc{static{v=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(h,k,c){super(),this.F=h,this.G=k,this.H=c,this.c=this.B(new R.$Od),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.$Od),this.onWillShutdown=this.f.event,this.g=this.B(new R.$Od),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.$Od),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(v.b),this.m&&this.G.removeItem(v.b)}J(){const h=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$k&&this.t===0&&this.L(1))};P.app.addListener("before-quit",h);const k=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$k)&&P.app.quit()};P.app.addListener("window-all-closed",k),P.app.once("will-quit",c=>{this.S("Lifecycle#app.on(will-quit) - begin"),c.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",h),P.app.removeListener("window-all-closed",k),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L(h){if(this.y)return this.y;const k=this.F;this.S("Lifecycle#onWillShutdown.fire()");const c=[];return this.f.fire({reason:h,join(i,o){k.trace(`Lifecycle#onWillShutdown - begin '${i}'`),c.push(o.finally(()=>{k.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(c)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(h){if(h<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===h)return;this.S(`lifecycle (main): phase changed (value: ${h})`),this.n=h;const k=this.C.get(this.n);k&&(k.open(),this.C.delete(this.n))}async when(h){if(h<=this.n)return;let k=this.C.get(h);k||(k=new s.$Tg,this.C.set(h,k)),await k.wait()}registerWindow(h){const k=new C.$Rc;this.t++,k.add(h.onWillLoad(i=>this.g.fire({window:h,workspace:i.workspace,reason:i.reason})));const c=(0,a.$Kf)(h.win);c.on("close",i=>{const o=h.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${h.id}`),i.preventDefault(),this.unload(h,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(h),h.close()})}),c.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${h.id}`),this.t--,k.dispose(),this.t===0&&(!S.$k||this.j)&&this.L(1)})}async reload(h,k){await this.unload(h,3)||h.reload(k)}unload(h,k){const c=this.z.get(h.id);if(c)return c;const i=this.M(h,k).finally(()=>{this.z.delete(h.id)});return this.z.set(h.id,i),i}async M(h,k){if(!h.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${h.id}`);const c=this.j?2:k,i=await this.P(h,c);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${h.id})`),this.N(i)):(await this.Q(h,c),!1)}N(h){return h?(this.O(!0),this.j=!1,!0):!1}O(h){this.w&&(this.w(h),this.w=void 0,this.u=void 0)}P(h,k){return new Promise(c=>{const i=this.s++,o=`vscode:ok${i}`,r=`vscode:cancel${i}`;A.$wT.once(o,()=>{c(!1)}),A.$wT.once(r,()=>{c(!0)}),h.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:k})})}Q(h,k){return new Promise(c=>{const o=`vscode:reply${this.s++}`;A.$wT.once(o,()=>c()),h.send("vscode:onWillUnload",{replyChannel:o,reason:k})})}quit(h){return this.R(h).then(k=>{if(!k&&h)try{if(S.$j){const c=(0,u.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.F.error(c)}return k})}R(h){return this.S(`Lifecycle#quit() - begin (willRestart: ${h})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(h&&this.G.setItem(v.b,!0),this.u=new Promise(k=>{this.w=k,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S(h){this.H.args["enable-smoke-test-driver"]?this.F.info(h):this.F.trace(h)}setRelaunchHandler(h){this.D=h}async relaunch(h){this.S("Lifecycle#relaunch()");const k=process.argv.slice(1);if(h?.addArgs&&k.push(...h.addArgs),h?.removeArgs)for(const o of h.removeArgs){const r=k.indexOf(o);r>=0&&k.splice(r,1)}const c=()=>{this.D?.handleRelaunch(h)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:k}))};P.app.once("quit",c),await this.quit(!0)&&P.app.removeListener("quit",c)}async kill(h){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Vg)(1e3),(async()=>{for(const k of P.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let c;k.webContents&&!k.webContents.isDestroyed()?c=new Promise(i=>k.once("closed",i)):c=Promise.resolve(),k.destroy(),await c}})()]),P.app.exit(h)}};e.$E6b=$,e.$E6b=$=v=Ee([te(0,b.$$i),te(1,y.$FN),te(2,f.$B6b)],$)}),define(ie[284],ne([0,1,4,3,2,5,20]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=e.$C7b=void 0,e.$C7b=(0,R.$Qh)("keyboardLayoutMainService");let S=class extends s.$Sc{constructor(g){super(),this.a=this.B(new A.$Od),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((b,y)=>{J(["native-keymap"],b,y)});this.c=u(g),P.$t||g.onDidChangeKeyboardLayout(()=>{this.c=u(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$D7b=S,e.$D7b=S=Ee([te(0,C.$D6b)],S);function u(a){const g=a.getKeyMap(),b=a.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:b}}}),define(ie[285],ne([0,1,246,8,17,14,12,18,36,94,6,50,245,282]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=void 0;let v=class extends b.$Xo{constructor(d,h,k,c){super(c),this.m=d,this.n=h,this.r=k,this.s(),this.B(d.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const d=this.m.getValue("http");this.f=d?.proxy,this.g=!!d?.proxyStrictSSL,this.h=d?.proxyAuthorization}async request(d,h){const{f:k,g:c}=this;let i;try{i=await(0,a.$Ul)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,R.$0)(t)))}const o={...process.env,...i},r=d.agent?d.agent:await(0,y.$2q)(d.url||"",o,{proxyUrl:k,strictSSL:c});return d.agent=r,d.strictSSL=c,this.h&&(d.headers={...d.headers||{},"Proxy-Authorization":this.h}),this.c(d.isChromiumNetwork?"electron":"node",d,()=>w(d,h))}async resolveProxy(d){}};e.$3q=v,e.$3q=v=Ee([te(0,S.$ki),te(1,u.$Yh),te(2,g.$$i),te(3,g.$_i)],v);async function m($){return((0,P.parse)($.url).protocol==="https:"?await new Promise((k,c)=>{J(["https"],k,c)}):await new Promise((k,c)=>{J(["http"],k,c)})).request}async function w($,d){return A.Promises.withAsyncBody(async(h,k)=>{const c=(0,P.parse)($.url),i=$.getRawRequest?$.getRawRequest($):await m($),o={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,C.$Ff)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(o.auth=$.user+":"+$.password);const r=i(o,t=>{const n=(0,C.$Df)($.followRedirects)?$.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)w({...$,url:t.headers.location,followRedirects:n-1},d).then(h,k);else{let l=t;!$.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(l=t.pipe((0,f.createGunzip)())),h({res:t,stream:(0,s.$re)(l)})}});r.on("error",k),$.timeout&&r.setTimeout($.timeout),$.isChromiumNetwork&&r.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&r.write($.data),r.end(),d.onCancellationRequested(()=>{r.abort(),k(new R.$5)})})}e.$4q=w}),define(ie[286],ne([0,1,15,285]),function(J,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F8b=void 0;function s(C){return P.net.request}class R extends A.$3q{request(S,u){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},u)}}e.$F8b=R}),define(ie[82],ne([0,1,7,3,2,36,16,5,20,6,96,279,41,52,40,13]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O6b=e.$N6b=e.$M6b=e.$L6b=void 0,e.$L6b=(0,S.$Qh)("storageMainService");let w=class extends s.$Sc{constructor(h,k,c,i,o,r){super(),this.c=h,this.f=k,this.g=c,this.h=i,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new A.$Od),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(h=>{h.window.profile&&this.profileStorage(h.window.profile).init(),h.workspace&&this.workspaceStorage(h.workspace).init()})),this.B(this.h.onWillShutdown(h=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=h.reason,h.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.t)h.join("profileStorage",k.close());for(const[,k]of this.w)h.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(h=>{h.join((async()=>{await this.j.exists(h.profile.globalStorageHome)||await this.j.createFolder(h.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(h=>{const k=this.t.get(h.profile.id);k&&h.join(k.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const h=new b.$G6b(this.n(),this.g,this.c,this.j);return this.B(A.Event.once(h.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),h}profileStorage(h){if((0,g.$ap)(h))return this.applicationStorage;let k=this.t.get(h.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${h.name})`),k=this.B(this.u(h)),this.t.set(h.id,k);const c=this.B(k.onDidChangeStorage(i=>this.b.fire({...i,storage:k,profile:h})));this.B(A.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${h.name})`),this.t.delete(h.id),c.dispose()}))}return k}u(h){return this.a===2?new b.$I6b(this.c,this.j):new b.$F6b(h,this.n(),this.c,this.j)}workspaceStorage(h){let k=this.w.get(h.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${h.id})`),k=this.B(this.y(h)),this.w.set(h.id,k),this.B(A.Event.once(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${h.id})`),this.w.delete(h.id)}))),k}y(h){return this.a===2?new b.$I6b(this.c,this.j):new b.$H6b(h,this.n(),this.c,this.f,this.j)}isUsed(h){const k=P.URI.file(h);for(const c of[this.applicationStorage,...this.t.values(),...this.w.values()])if(c.path&&this.m.extUri.isEqualOrParent(P.URI.file(c.path),k))return!0;return!1}};e.$M6b=w,e.$M6b=w=Ee([te(0,a.$$i),te(1,R.$Xh),te(2,f.$J6b),te(3,u.$D6b),te(4,C.$_j),te(5,v.$Jk)],w),e.$N6b=(0,S.$Qh)("applicationStorageMainService");let $=class extends g.$_o{constructor(h,k){super(),this.s=h,this.U=k,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(h){if(h===-1)return this.U.applicationStorage.storage}Q(h){if(h===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$O6b=$,e.$O6b=$=Ee([te(0,y.$Lk),te(1,e.$L6b)],$)}),define(ie[287],ne([0,1,87,28,103,99,8,2,4,18,6,25,241,242,95,126,17]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=e.$D8b=e.$C8b=e.$B8b=void 0;async function $(i,o,r,t,n){let l;for(let p=3;p&&(l?.dispose(),l=await new d(i,o,r,t,n).waitForReady(),!(n&&s.$ig[n]||!s.$ig[l.tunnelLocalPort]));p--);return l}class d extends S.$Sc{constructor(o,r,t,n,l){super(),this.m=r,this.n=l,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=P.createServer(),this.c=new C.$Tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,m.$iv)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,s.$jg)(o,2,1e3,r),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,m.$gv)(this.tunnelRemoteHost)||(0,m.$iv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,y.$7k)(this.a,r,this.tunnelRemotePort),n=t.getSocket(),l=t.readEntireBuffer();t.dispose(),l.byteLength>0&&o.write(l.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof R.$Fh?n.socket.destroy():n.end()}),n instanceof R.$Fh?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(t=>o.write(t.buffer)),o.on("data",t=>r.write(w.$ce.wrap(t))),o.resume()}t(o,r){const t=r.socket;t.on("end",()=>o.end()),t.on("close",()=>o.end()),t.on("error",()=>{o.destroy()}),t.pipe(o),o.pipe(t)}}e.$B8b=d;let h=class extends m.$lv{constructor(o,r,t,n,l){super(r,l),this.u=o,this.v=t,this.w=n}isPortPrivileged(o){return(0,m.$jv)(o,this.l,u.OS,A.release())}s(o,r,t,n,l,p,O,D){const E=this.r(r,t);if(E)return++E.refcount,E.value;if((0,m.$dv)(o))return this.t(o,r,t,l,p,O,D);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${t} on local port ${l}.`);const I={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=$(I,n,r,t,l);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,t,j),j}}};e.$C8b=h,e.$C8b=h=Ee([te(0,f.$1k),te(1,g.$$i),te(2,v.$4k),te(3,b.$qj),te(4,a.$ki)],h);let k=class extends h{constructor(o,r,t,n,l){super(o,r,t,n,l)}};e.$D8b=k,e.$D8b=k=Ee([te(0,f.$1k),te(1,g.$$i),te(2,v.$4k),te(3,b.$qj),te(4,a.$ki)],k);let c=class extends S.$Sc{constructor(o,r,t,n,l){super(),this.b=o,this.c=r,this.f=t,this.g=n,this.h=l,this.a=new Map}async openTunnel(o,r,t,n,l,p,O,D,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${p}.`),!this.a.has(o)){const I=new k(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(o,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,t,n,l,p,O,D,E)}};e.$E8b=c,e.$E8b=c=Ee([te(0,f.$1k),te(1,g.$$i),te(2,b.$qj),te(3,v.$4k),te(4,a.$ki)],c)}),define(ie[100],ne([0,1,8,22,3,18,24,20,6,25,50,48]),function(J,e,P,A,s,R,C,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=e.$Z7b=void 0;function y(v,m,w){return`${w.updateUrl}/api/update/${v}/${m}/${w.commit}`}e.$Z7b=y;let f=class{get state(){return this.b}d(m){this.j.info("update#setState",m.type),this.b=m,this.c.fire(m)}constructor(m,w,$,d,h,k){this.f=m,this.g=w,this.h=$,this.i=d,this.j=h,this.k=k,this.b=b.$vU.Uninitialized,this.c=new s.$Od,this.onStateChange=this.c.event,m.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(b.$vU.Disabled(0));return}if(this.h.disableUpdates){this.d(b.$vU.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(b.$vU.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.g.getValue("update.mode"),w=this.m(m);if(!w){this.d(b.$vU.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(w),!this.a){this.d(b.$vU.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(b.$vU.Idle(this.q())),m==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(m){return m==="none"?void 0:this.k.quality}n(m=60*60*1e3){return(0,P.$Vg)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(m){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(m)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(m){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},A.CancellationToken.None)).res.statusCode===204}catch(w){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(w);return}}async _applySpecificUpdate(m){}q(){return 1}r(){}};e.$17b=f,e.$17b=f=Ee([te(0,S.$D6b),te(1,R.$ki),te(2,C.$B6b),te(3,g.$Wo),te(4,u.$$i),te(5,a.$qj)],f)}),define(ie[288],ne([0,1,15,54,3,2,18,24,20,6,25,50,26,48,100]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0;let m=class extends v.$17b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",($,d)=>d)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",($,d,h)=>({url:d,version:h,productVersion:h}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",($,d,h,k)=>({releaseNotes:d,version:h,productVersion:h,date:k}))}constructor($,d,h,k,c,i,o){super($,d,k,c,i,o),this.z=h,this.u=new R.$Rc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.j.error("UpdateService error:",$);const d=this.state.type==="checking for updates"&&this.state.explicit?$:void 0;this.d(f.$vU.Idle(1,d))}s($){let d;this.k.darwinUniversalAssetId?d=this.k.darwinUniversalAssetId:d=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,v.$Z7b)(d,$,this.k);try{P.autoUpdater.setFeedURL({url:h})}catch(k){this.j.error("Failed to set update feed URL",k);return}return h}t($){this.d(f.$vU.CheckingForUpdates($)),P.autoUpdater.checkForUpdates()}E($){this.state.type==="checking for updates"&&this.d(f.$vU.Downloading($))}F($){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$vU.Ready($)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$vU.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$27b=m,Ee([A.$ih],m.prototype,"v",null),Ee([A.$ih],m.prototype,"w",null),Ee([A.$ih],m.prototype,"x",null),Ee([A.$ih],m.prototype,"y",null),e.$27b=m=Ee([te(0,u.$D6b),te(1,C.$ki),te(2,y.$dl),te(3,S.$B6b),te(4,b.$Wo),te(5,a.$$i),te(6,g.$qj)],m)}),define(ie[289],ne([0,1,47,45,8,3,9,24,20,6,26,48]),function(J,e,P,A,s,R,C,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$47b=void 0;let y=class{get state(){return this.a}d(m){this.g.info("update#setState",m.type),this.a=m,this.b.fire(m)}constructor(m,w,$){if(this.f=m,this.g=$,this.a=b.$vU.Uninitialized,this.b=new R.$Od,this.onStateChange=this.b.event,w.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(b.$vU.Idle(this.k())),this.h(30*1e3).then(void 0,d=>this.g.error(d))}h(m=60*60*1e3){return(0,s.$Vg)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(m){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(m)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(m){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(m){}};y=Ee([te(0,u.$D6b),te(1,S.$B6b),te(2,a.$$i)],y);let f=class extends y{constructor(m,w,$,d,h,k){super($,d,h),this.o=m,this.p=w,this.q=k;const c=(0,A.watch)(C.$mc(this.o)),i=R.Event.fromNodeEventEmitter(c,"change",(n,l)=>l),o=R.Event.filter(i,n=>n==="current"),t=R.Event.debounce(o,(n,l)=>l,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{t.dispose(),c.close()})}m(){this.d(b.$vU.CheckingForUpdates(!1)),this.u().then(m=>{m?this.d(b.$vU.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$vU.Idle(2)))},m=>{this.g.error(m),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$vU.Idle(2,m.message||m))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+C.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const m=await new Promise(($,d)=>(0,A.realpath)(`${C.$mc(this.o)}/current`,(h,k)=>h?d(h):$(k))),w=C.$nc(m);return this.p!==w}isLatestVersion(){return this.u().then(void 0,m=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$47b=f,e.$47b=f=Ee([te(2,u.$D6b),te(3,S.$B6b),te(4,a.$$i),te(5,g.$dl)],f)}),define(ie[29],ne([0,1,4,5,68,67,25,18,24,9,78]),function(J,e,P,A,s,R,C,S,u,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=e.$d7b=e.$c7b=e.OpenContext=e.$b7b=void 0,e.$b7b=(0,A.$Qh)("windowsMainService");var b;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(b||(e.OpenContext=b={}));function y(m,w,$){const d=m.get(R.$P6b),h=m.get(C.$qj),k=m.get(S.$ki),c=m.get(u.$B6b),i=k.getValue("window"),o={backgroundColor:d.getBackgroundColor(),minWidth:s.$jC.WIDTH,minHeight:s.$jC.HEIGHT,title:h.nameLong,...$,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$qC)(i?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...$?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return w&&(o.x=w.x,o.y=w.y,o.width=w.width,o.height=w.height),P.$l?o.icon=(0,a.$jc)(c.appRoot,"resources/linux/code.png"):P.$j&&!c.isBuilt&&(o.icon=(0,a.$jc)(c.appRoot,"resources/win32/code_150x150.png")),P.$k&&(o.acceptFirstMouse=!0,i?.clickThroughInactive===!1&&(o.acceptFirstMouse=!1)),o}e.$c7b=y;function f(m){const w=m.get(e.$b7b),$=m.get(g.$a7b),d=w.getFocusedWindow()??$.getFocusedWindow();if(d)return d;const h=w.getLastActiveWindow(),k=$.getLastActiveWindow();return h&&k?h.lastFocusTime<k.lastFocusTime?k:h:h??k}e.$d7b=f;function v(m){let w,$=Number.MIN_VALUE;for(const d of m)d.lastFocusTime>$&&($=d.lastFocusTime,w=d);return w}e.$e7b=v}),define(ie[290],ne([0,1,15,22,3,55,2,32,116,6,82,29]),function(J,e,P,A,s,R,C,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=void 0;var y;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let f=class extends C.$Sc{constructor(m,w,$,d){super(),this.g=m,this.h=w,this.j=$,this.m=d,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const m=s.Event.fromNodeEventEmitter(P.app,"login",(w,$,d,h,k)=>({event:w,webContents:$,req:d,authInfo:h,callback:k}));this.B(m(this.r,this))}async r({event:m,authInfo:w,req:$,callback:d}){if(!w.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let h;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{h=await this.b}finally{this.b=void 0}}d(h?.username,h?.password)}async s(m){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t(m);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(m){this.g.trace("auth#doResolveProxyCredentials - enter",m);const w=String((0,R.$Ei)({scheme:m.scheme,host:m.host,port:m.port}));let $,d;try{const i=this.m.get(this.a+w,-1);if(i){const o=JSON.parse(await this.j.decrypt(i));$=o.username,d=o.password}}catch(i){this.g.error(i)}if(this.c!==y.StoredCredentialsUsed&&typeof $=="string"&&typeof d=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:$,password:d};const h=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!h){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const k={authInfo:m,username:this.f?.username??$,password:this.f?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,S.$fg)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,k),this.c=y.LoginDialogShown;const c=await new Promise(i=>{const o=async(r,t,n)=>{if(t===k.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",o),n){const l={username:n.username,password:n.password};try{if(n.remember){const p=await this.j.encrypt(JSON.stringify(l));this.m.store(this.a+w,p,-1,1)}else this.m.remove(this.a+w,-1)}catch(p){this.g.error(p)}i({username:l.username,password:l.password})}else i(void 0)};h.win?.webContents.on("ipc-message",o)});return this.f=c,c}};e.$f7b=f,e.$f7b=f=Ee([te(0,a.$$i),te(1,b.$b7b),te(2,u.$eU),te(3,g.$N6b)],f)}),define(ie[291],ne([0,1,15,23,4,7,21,18,62,5,6,127,29]),function(J,e,P,A,s,R,C,S,u,a,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=e.$F7b=e.ID=void 0,e.ID="launchMainService",e.$F7b=(0,a.$Qh)(e.ID);let f=class{constructor(m,w,$,d){this.a=m,this.b=w,this.c=$,this.d=d}async start(m,w){this.a.trace("Received data from other instance: ",m,w),s.$k&&P.app.focus({steal:!0});const $=this.e(m);if($.length){let d=Promise.resolve();if(this.b.getWindowCount()===0){const h=(0,A.$Ob)(await this.b.openEmptyWindow({context:4}));h&&(d=h.ready())}d.then(()=>{for(const{uri:h,originalUrl:k}of $)this.c.open(h,{originalUrl:k})})}else return this.f(m,w)}e(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,A.$Hb)(m._urls.map(w=>{try{return{uri:R.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async f(m,w){const $=(0,u.$Ol)(w)?0:4;let d=[];const h=m.wait&&m.waitMarkerFilePath?R.URI.file(m.waitMarkerFilePath):void 0,k=m.remote||void 0,c={context:$,cli:m,userEnv:w,waitMarkerFileURI:h,remoteAuthority:k,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,c);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let i=!1;if(m["new-window"]||m["unity-launch"]||c.forceProfile||c.forceTempProfile)i=!0;else if(m["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!s.$k}if(i)d=await this.b.open({...c,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,c),d=[o]):d=await this.b.open({...c,forceEmpty:!0})}}else d=await this.b.open({...c,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(h&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,C.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$G7b=f,e.$G7b=f=Ee([te(0,g.$$i),te(1,y.$b7b),te(2,b.$kU),te(3,S.$ki)],f)}),define(ie[292],ne([0,1,2,20,52,30,8,29]),function(J,e,P,A,s,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j8b=void 0;let u=class extends P.$Sc{constructor(g,b,y){super(),this.a=b,this.b=y,this.B(g.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(g.onBeforeCloseWindow(f=>this.c(f))),this.B(new C.$7g(()=>this.g(),30*1e3)).schedule()}async c(g){const b=this.f(g),y=this.a.getProfileForWorkspace(b);y?.isTransient&&(this.a.unsetWorkspace(b,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(g){return g.openedWorkspace??(0,R.$5h)(g.backupPath,g.isExtensionDevelopmentHost)}g(){const g=this.a.getAssociatedEmptyWindows();if(g.length===0)return;const b=this.b.getWindows().map(y=>this.f(y));for(const y of g)b.some(f=>f.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$j8b=u,e.$j8b=u=Ee([te(0,A.$D6b),te(1,s.$J6b),te(2,S.$b7b)],u)}),define(ie[60],ne([0,1,15,2,3,6,313,8,13,29,73,26,20,75,37,4,131]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=e.$i7b=void 0;function d(c){return typeof c.responseWindowId=="number"}let h=class extends A.$Sc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(i,o,r){super(),this.t=i,this.u=o,this.w=r,this.c=String(++$.a),this.f=this.B(new s.$Od),this.onStdout=this.f.event,this.g=this.B(new s.$Od),this.onStderr=this.g.event,this.h=this.B(new s.$Od),this.onMessage=this.h.event,this.j=this.B(new s.$Od),this.onExit=this.j.event,this.m=this.B(new s.$Od),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(i,o){let r;switch(this.s?.correlationId?r=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`:r=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`,o){case g.default.Error:this.t.error(r);break;case g.default.Warning:this.t.warn(r);break;case g.default.Info:this.t.trace(r);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(i){const o=this.C(i);return o&&i.payload&&this.postMessage(i.payload),o}C(i){if(!this.z())return!1;this.s=i;const o=`${this.s.type}-${this.c}`,r=u.$dg.asFileUri("bootstrap-fork.js").fsPath,t=this.s.args??[],n=this.s.execArgv??[],l=this.s.allowLoadingUnsignedLibraries,p=this.s.forceAllocationsToV8Sandbox,O="pipe",D=this.D(i);return this.y("creating new...",g.default.Info),this.n=P.utilityProcess.fork(r,t,{serviceName:o,env:D,execArgv:n,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:p,stdio:O}),this.F(this.n,this.s,o),!0}D(i){const o=i.env?{...i.env}:{...(0,v.$8m)(process.env)};o.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,m.$j&&((0,w.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,f.$Bl)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}F(i,o,r){if(i.stdout){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:t.write(n))))}this.B(s.Event.fromNodeEventEmitter(i,"message")(t=>this.h.fire(t))),this.B(s.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.r=i.pid,typeof i.pid=="number"&&$.b.set(i.pid,{pid:i.pid,name:d(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.y("successfully created",g.default.Info)})),this.B(s.Event.fromNodeEventEmitter(i,"exit")(t=>{this.y(`received exit event with code ${t}`,g.default.Info),this.j.fire({pid:this.r,code:t,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===r&&(this.y(`crashed with code ${t.exitCode} and reason '${t.reason}'`,g.default.Error),this.u.publicLog2("utilityprocesscrash",{type:o.type,reason:t.reason,code:t.exitCode}),this.m.fire({pid:this.r,code:t.exitCode,reason:t.reason}),this.G())}))}once(i,o){const r=this.B(this.h.event(t=>{t===i&&(r.dispose(),o())}))}postMessage(i,o){this.n&&this.n.postMessage(i,o)}connect(i){const{port1:o,port2:r}=new P.MessageChannelMain;return this.postMessage(i,[r]),o}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",g.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",g.default.Info),this.n.kill()?(this.y("successfully killed the process",g.default.Info),this.G()):this.y("unable to kill the process",g.default.Warning)}G(){typeof this.r=="number"&&$.b.delete(this.r),this.n=void 0}async waitForExit(i){this.n&&(this.y("waiting to exit...",g.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$Vg)(i)]),this.n&&(this.y(`did not exit within ${i}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$i7b=h,e.$i7b=h=$=Ee([te(0,R.$$i),te(1,b.$dl),te(2,y.$D6b)],h);let k=class extends h{constructor(i,o,r,t){super(i,r,t),this.H=o}start(i){const o=this.H.getWindowById(i.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.C(i))return!1;this.I(o.win,i);const t=this.connect(i.payload);return o.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}I(i,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,r=>r.window.win===i)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.$j7b=k,e.$j7b=k=Ee([te(0,R.$$i),te(1,a.$b7b),te(2,b.$dl),te(3,y.$D6b)],k)}),define(ie[293],ne([0,1,14,6,20,8,60,29,26]),function(J,e,P,A,s,R,C,S,u){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0;let g=class{static{a=this}static{this.a=0}constructor(y,f,v,m){this.d=y,this.f=f,this.g=v,this.h=m,this.b=new Map,this.c=!1,this.f.onWillShutdown(w=>{this.c=!0,w.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(y){const f=this.b.get(y);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(y){return this.i(y).onStdout}onDynamicStderr(y){return this.i(y).onStderr}onDynamicMessage(y){return this.i(y).onMessage}onDynamicExit(y){return this.i(y).onExit}async createExtensionHost(){if(this.c)throw(0,P.$6)();const y=String(++a.a),f=new C.$j7b(this.d,this.g,this.h,this.f);return this.b.set(y,f),f.onExit(({pid:v,code:m,signal:w})=>{this.d.info(`Extension host with pid ${v} exited with code: ${m}, signal: ${w}.`),setTimeout(()=>{f.dispose(),this.b.delete(y)}),setTimeout(()=>{try{process.kill(v,0),this.d.error(`Extension host with pid ${v} still exists, forcefully killing it...`),process.kill(v)}catch{}},1e3)}),{id:y}}async start(y,f){if(this.c)throw(0,P.$6)();this.i(y).start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y})}async enableInspectPort(y){if(this.c)throw(0,P.$6)();const f=this.b.get(y);return f?f.enableInspectPort():!1}async kill(y){if(this.c)throw(0,P.$6)();const f=this.b.get(y);f&&f.kill()}async _killAllNow(){for(const[,y]of this.b)y.kill()}async _waitForAllExit(y){const f=[];for(const[,v]of this.b)f.push(v.waitForExit(y));return R.Promises.settled(f).then(()=>{})}};e.$q7b=g,e.$q7b=g=a=Ee([te(0,A.$$i),te(1,s.$D6b),te(2,S.$b7b),te(3,u.$dl)],g)}),define(ie[294],ne([0,1,38,8,2,24,20,6,41,39,66,60,51,90,12,247]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7b=void 0;let w=class extends s.$Sc{constructor(d,h,k,c,i,o,r,t){super(),this.c=d,this.f=h,this.g=k,this.h=c,this.j=i,this.m=o,this.n=r,this.r=t,this.a=new A.$Tg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$wT.on(m.$R7b.request,(d,h)=>this.t(d,h,m.$R7b.response)),P.$wT.on(m.$S7b.request,(d,h)=>this.t(d,h,m.$S7b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(d,h,k){this.m.trace(`[SharedProcess] onWindowConnection for: ${k}`),this.a.isOpen()||this.a.open(),await this.whenReady();const c=await this.connect(k);if(d.sender.isDestroyed())return c.close();d.sender.postMessage(k,h,[c])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(m.$Q7b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const d=new A.$dh;this.b?this.b.once(m.$Q7b.initDone,()=>d.complete()):P.$wT.once(m.$Q7b.initDone,()=>d.complete()),await d.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const d=new A.$dh;this.b?this.b.once(m.$Q7b.ipcReady,()=>d.complete()):P.$wT.once(m.$Q7b.ipcReady,()=>d.complete()),await d.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new b.$i7b(this.m,y.$po,this.j));const d=(0,f.$mm)(this.g.args,this.g.isBuilt);let h;d.port&&(h=["--nolazy"],d.break?h.push(`--inspect-brk=${d.port}`):h.push(`--inspect=${d.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:h})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(d){return await this.z,(0,v.$Kf)(this.b).connect(d)}};e.$T7b=w,e.$T7b=w=Ee([te(2,R.$B6b),te(3,u.$Lk),te(4,C.$D6b),te(5,S.$$i),te(6,g.$86b),te(7,a.$mn)],w)}),define(ie[295],ne([0,1,24,90,20,6,51,60,110,38,2,3,37,18,13]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0;let m=class extends g.$Sc{constructor($,d,h,k,c){super(),this.f=$,this.g=d,this.h=h,this.j=k,this.m=c,this.a=void 0,this.b=new b.$Od,this.onRequestConnection=this.b.event,this.c=new b.$Od,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),a.$wT.on("vscode:createPtyHostMessageChannel",(i,o)=>this.r(i,o)),this.B((0,g.$Qc)(()=>{a.$wT.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$i7b(this.m,C.$po,this.j);const $=(0,A.$lm)(this.h.args,this.h.isBuilt),d=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:d,args:["--logsPath",this.h.logsHome.with({scheme:v.Schemas.file}).fsPath],env:this.n()});const h=this.a.connect(),k=new u.$ET(h,"ptyHost"),c=new g.$Rc;return c.add(k),c.add((0,g.$Qc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:k,store:c,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,y.$8m)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},d=this.g.getValue("terminal.integrated.developer.ptyHost.latency");d&&typeof d=="number"&&($.VSCODE_LATENCY=String(d));const h=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return h&&typeof h=="number"&&($.VSCODE_STARTUP_DELAY=String(h)),this.h.restoreSnapExportedVariables(),$}r($,d){this.b.fire();const h=this.a.connect();if($.sender.isDestroyed()){h.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",d,[h])}};e.$t8b=m,e.$t8b=m=Ee([te(1,f.$ki),te(2,P.$B6b),te(3,s.$D6b),te(4,R.$$i)],m)}),define(ie[296],ne([0,1,2,5,6,29,60,26,55,3,8,20]),function(J,e,P,A,s,R,C,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=e.$r8b=void 0,e.$r8b=(0,A.$Qh)("utilityProcessWorker");let y=class extends P.$Sc{constructor(m,w,$,d){super(),this.b=m,this.c=w,this.f=$,this.g=d,this.a=new Map}async createWorker(m){const w=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${w})`);const $=this.h(m);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(m));const d=new f(this.b,this.c,this.f,this.g,m);if(!d.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,d);const h=new g.$dh;return a.Event.once(d.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete($),h.complete({reason:k})}),h.p}h(m){return(0,u.$Ei)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const w=this.h(m),$=this.a.get(w);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),$.kill(),this.a.delete(w))}};e.$s8b=y,e.$s8b=y=Ee([te(0,s.$$i),te(1,R.$b7b),te(2,S.$dl),te(3,b.$D6b)],y);let f=class extends P.$Sc{constructor(m,w,$,d,h){super(),this.c=m,this.f=w,this.g=$,this.h=d,this.j=h,this.a=this.B(new a.$Od),this.onDidTerminate=this.a.event,this.b=new C.$j7b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(m=>this.a.fire({code:m.code,signal:m.signal}))),this.B(this.b.onCrash(m=>this.a.fire({code:m.code,signal:"ECRASH"})))}spawn(){const w=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};f=Ee([te(0,s.$$i),te(1,R.$b7b),te(2,S.$dl),te(3,b.$D6b)],f)}),define(ie[297],ne([0,1,15,3,2,273,29]),function(J,e,P,A,s,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=void 0;let S=class extends s.$Sc{constructor(a){super(),this.b=a,this.a=this.B(new A.$Od),this.onFoundInFrame=this.a.event,this.B(new R.$$7b)}async setIgnoreMenuShortcuts(a,g){let b;if(typeof a.windowId=="number"){const{windowId:y}=a,f=this.b.getWindowById(y);if(!f?.win)throw new Error(`Invalid windowId: ${y}`);b=f.win.webContents}else{const{webContentsId:y}=a;if(b=P.webContents.fromId(y),!b)throw new Error(`Invalid webContentsId: ${y}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(g)}async findInFrame(a,g,b,y){const v=this.c(a,g);if(typeof v.findInFrame=="function"){v.findInFrame(b,{findNext:y.findNext,forward:y.forward});const m=(w,$)=>{$.finalUpdate&&(this.a.fire($),v.removeListener("found-in-frame",m))};v.on("found-in-frame",m)}}async stopFindInFrame(a,g,b){const f=this.c(a,g);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}c(a,g){const b=this.b.getWindowById(a.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${a}`);const y=b.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===g);if(!y)throw new Error(`Unknown frame: ${g}`);return y}};e.$_7b=S,e.$_7b=S=Ee([te(0,C.$b7b)],S)}),define(ie[298],ne([0,1,15,2,4,19,7,18,20,6,34,29,128,30]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$c8b=e.$b8b=e.$a8b=void 0;let m=class extends A.$Sc{static{v=this}static{this.a="windowsState"}get state(){return this.b}constructor(c,i,o,r,t){super(),this.g=c,this.h=i,this.j=o,this.m=r,this.n=t,this.b=w(this.h.getItem(v.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(c=>this.u(c)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(c=>this.u(c))}s(){this.f=!0,this.t()}t(){const c=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!i.lastActiveWindow){let t=this.g.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.w(t),i.lastActiveWindow.uiState.mode===3&&c.add(i.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(i.lastPluginDevelopmentHostWindow=this.w(o),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(c.has(i.lastPluginDevelopmentHostWindow.uiState.display)?s.$k&&!o.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):c.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(i.openedWindows=this.g.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.w(t);return n.uiState.mode===3&&(c.has(n.uiState.display)?s.$k&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):c.add(n.uiState.display)),n}));const r=d(i);this.h.setItem(v.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(c){if(this.j.quitRequested)return;const i=this.w(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=i:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,f.$6h)(c.openedWorkspace)&&o.workspace?.id===c.openedWorkspace.id,t=(0,f.$1h)(c.openedWorkspace)&&o.folderUri&&R.$ng.isEqual(o.folderUri,c.openedWorkspace.uri);(r||t)&&(o.uiState=i.uiState)}),this.g.getWindowCount()===1&&(this.c=i)}w(c){return{windowId:c.id,workspace:(0,f.$6h)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,f.$1h)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const i=this.z(c),o=this.n.getValue("window");if(i.mode===3){let r;i.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(i.mode=1)}return i}z(c){const i=this.g.getLastActiveWindow();if(!c.extensionTestsPath){if(c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const p=c.workspace;if((0,f.$6h)(p)){const D=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===p.id).map(E=>E.uiState);if(D.length)return D[0]}if((0,f.$1h)(p)){const D=this.state.openedWindows.filter(E=>E.folderUri&&R.$ng.isEqual(E.folderUri,p.uri)).map(E=>E.uiState);if(D.length)return D[0]}else if(c.backupPath){const D=this.state.openedWindows.filter(E=>E.backupPath===c.backupPath).map(E=>E.uiState);if(D.length)return D[0]}const O=this.c||this.state.lastActiveWindow;if(!i&&O)return O.uiState}let o;const r=P.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$k){const p=P.screen.getCursorScreenPoint();o=P.screen.getDisplayNearestPoint(p)}!o&&i&&(o=P.screen.getDisplayMatching(i.getBounds())),o||(o=P.screen.getPrimaryDisplay()||r[0])}let t=(0,y.$A6b)();t.x=Math.round(o.bounds.x+o.bounds.width/2-t.width/2),t.y=Math.round(o.bounds.y+o.bounds.height/2-t.height/2);const n=this.n.getValue("window");let l=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,l=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,l=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const p=i.serializeWindowState();p.mode===3?t.mode=3:t=p,l=t.mode!==3&&n.newWindowDimensions==="offset"}}return l&&(t=this.C(t)),t.hasDefaultState=!0,t}C(c){if(this.g.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const i=this.g.getWindows().map(o=>o.getBounds());for(;i.some(o=>o.x===c.x||o.y===c.y);)c.x+=30,c.y+=30;return c}};e.$a8b=m,e.$a8b=m=v=Ee([te(0,b.$b7b),te(1,g.$FN),te(2,u.$D6b),te(3,a.$$i),te(4,S.$ki)],m);function w(k){const c={openedWindows:[]},i=k||{openedWindows:[]};return i.lastActiveWindow&&(c.lastActiveWindow=$(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=$(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(c.openedWindows=i.openedWindows.map(o=>$(o))),c}e.$b8b=w;function $(k){const c={uiState:k.uiState};return k.backupPath&&(c.backupPath=k.backupPath),k.remoteAuthority&&(c.remoteAuthority=k.remoteAuthority),k.folder&&(c.folderUri=C.URI.parse(k.folder)),k.workspaceIdentifier&&(c.workspace={id:k.workspaceIdentifier.id,configPath:C.URI.parse(k.workspaceIdentifier.configURIPath)}),c}function d(k){return{lastActiveWindow:k.lastActiveWindow&&h(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&h(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(c=>h(c))}}e.$c8b=d;function h(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(ie[53],ne([0,1,15,3,44,2,13,9,19,21,194,63,59,24,5,6,52,130,30,97,98]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=e.$66b=void 0,e.$66b=(0,v.$Qh)("workspacesManagementMainService");let c=class extends R.$Sc{constructor(o,r,t,n,l){super(),this.g=o,this.h=r,this.j=t,this.m=n,this.n=l,this.a=this.B(new A.$Od),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new A.$Od),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await a.Promises.readdir(this.c.with({scheme:C.Schemas.file}).fsPath)).map(r=>(0,u.$wg)(this.c,r,d.$di));for(const r of o){const t=(0,k.$36b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>a.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===C.Schemas.file)try{const t=r(o.fsPath);return t instanceof Promise?t.then(n=>this.t(o,n),n=>{}):this.t(o,t)}catch{return}}s(o){return(0,d.$ei)(o,this.g)||(0,d.$ji)(o)}t(o,r){try{const t=this.u(o,r),n=(0,k.$36b)(o);return{id:n.id,configPath:n.configPath,folders:(0,h.$ZU)(t.folders,n.configPath,u.$ng),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.h.warn(t.toString())}}u(o,r){const t=(0,s.$Xm)(r);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,h.$XU)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(o,r){const{workspace:t,storedWorkspace:n}=this.w(o,r),l=t.configPath.fsPath;return await a.Promises.mkdir((0,S.$mc)(l),{recursive:!0}),await a.Promises.writeFile(l,JSON.stringify(n,null,"	")),this.f.push({workspace:t,remoteAuthority:r}),t}w(o=[],r){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,u.$wg)(this.c,t),l=(0,u.$wg)(n,d.$di),p=[];for(const O of o)p.push((0,h.$YU)(O.uri,!0,O.name,n,u.$ng));return{workspace:(0,k.$36b)(l),storedWorkspace:{folders:p,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,k.$36b)(o)}isUntitledWorkspace(o){return(0,d.$ei)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,u.$kg)(o.configPath);try{await a.Promises.rm((0,S.$mc)(r));const t=(0,S.$jc)(this.g.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,o.id);await a.Promises.exists(t)&&await a.Promises.writeFile((0,S.$jc)(t,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(t){this.h.warn(`Unable to delete untitled workspace ${r} (${t}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,t){if(!o||!o.win||!o.isReady||!await this.z(o,r,t))return;const l=await this.C(o,(0,k.$36b)(t));if(l)return this.b.fire({window:o,workspace:l.workspace}),l}async z(o,r,t){return t?(0,d.$6h)(o.openedWorkspace)&&u.$ng.isEqual(o.openedWorkspace.configPath,t)?!1:(0,$.$Z6b)(r,t)?(await this.n.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:(0,g.localize)(1,null,(0,u.$tg)(t)),detail:(0,g.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let t;return o.config.extensionDevelopmentPath||(o.config.backupPath?t=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):t=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,d.$6h)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=t,{workspace:r,backupPath:t}}};e.$76b=c,e.$76b=c=Ee([te(0,f.$B6b),te(1,m.$$i),te(2,w.$J6b),te(3,b.$U6b),te(4,y.$V6b)],c)}),define(ie[132],ne([0,1,15,38,22,5,29,30,53,12,6,60]),function(J,e,P,A,s,R,C,S,u,a,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m7b=e.$l7b=e.ID=void 0,e.ID="diagnosticsMainService",e.$l7b=(0,R.$Qh)(e.ID);let y=class{constructor(v,m,w){this.a=v,this.b=m,this.c=w}async getRemoteDiagnostics(v){const m=this.a.getWindows();return(await Promise.all(m.map(async $=>{const d=$.remoteAuthority;if(!d)return;const h=`vscode:getDiagnosticInfoResponse${$.id}`,k={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(c=>{$.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:h,args:k}),A.$wT.once(h,(i,o)=>{o||c({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),c(o)}),setTimeout(()=>{c({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const w of P.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(w.id);$?v.push(await this.d($)):v.push(this.e(w))}const m=[];for(const{pid:w,name:$}of b.$i7b.getAll())m.push({pid:w,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:m,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(v){const m=await this.f(v),w=(0,a.$Kf)(v.win);return this.e(w,m,v.remoteAuthority)}e(v,m=[],w){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:m,remoteAuthority:w}}async f(v){const m=[],w=v.openedWorkspace;if((0,S.$1h)(w))m.push(w.uri);else if((0,S.$6h)(w)){const $=await this.b.resolveLocalWorkspace(w.configPath);$&&$.folders.forEach(h=>{m.push(h.uri)})}return m}};e.$m7b=y,e.$m7b=y=Ee([te(0,C.$b7b),te(1,u.$66b),te(2,g.$$i)],y)}),define(ie[69],ne([0,1,47,15,28,156,54,3,2,13,9,4,7,105,88,21,103,182,59,24,5,20,6,25,67,29,30,53,17,243,235,78]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k,c,i,o,r,t,n,l,p,O,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A7b=e.$z7b=void 0,e.$z7b=(0,k.$Qh)("nativeHostMainService");let I=class extends u.$Sc{constructor(U,z,X,x,oe,se,ce,Y,K,Q){super(),this.a=U,this.b=z,this.c=X,this.f=x,this.g=oe,this.h=se,this.j=ce,this.m=Y,this.n=K,this.r=Q,this.onDidOpenWindow=S.Event.map(this.a.onDidOpenWindow,q=>q.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:q,x:W,y:G})=>({windowId:q.id,x:W,y:G})),({windowId:q})=>!!this.a.getWindowById(q)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(q,W)=>W.id),q=>!!this.a.getWindowById(q)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(q,W)=>W.id),q=>!!this.a.getWindowById(q)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(q,W)=>W.id),q=>!!this.a.getWindowById(q)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),q=>!!q),q=>q.id),S.Event.filter(S.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(q,W)=>W.id),q=>!!this.a.getWindowById(q))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new S.$Od),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(q,W,G)=>G),q=>!(Array.isArray(q)&&q.length===1&&q[0]==="workArea")),S.Event.fromNodeEventEmitter(A.screen,"display-added"),S.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(z=>({id:z.id,workspace:z.openedWorkspace??(0,n.$5h)(z.backupPath,z.isExtensionDevelopmentHost),title:z.win?.getTitle()??"",filename:z.getRepresentedFilename(),dirty:z.isDocumentEdited()}))}async getWindowCount(U){return this.a.getWindowCount()}async getActiveWindowId(U){const z=A.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(z)return z.id}openWindow(U,z,X){return Array.isArray(z)?this.t(U,z,X):this.u(U,z)}async t(U,z,X=Object.create(null)){z.length>0&&await this.a.open({context:5,contextWindowId:U,urisToOpen:z,cli:this.g.args,forceNewWindow:X.forceNewWindow,forceReuseWindow:X.forceReuseWindow,preferNewWindow:X.preferNewWindow,diffMode:X.diffMode,mergeMode:X.mergeMode,addMode:X.addMode,gotoLineMode:X.gotoLineMode,noRecentEntry:X.noRecentEntry,waitMarkerFileURI:X.waitMarkerFileURI,remoteAuthority:X.remoteAuthority||void 0,forceProfile:X.forceProfile,forceTempProfile:X.forceTempProfile})}async u(U,z){await this.a.openEmptyWindow({context:5,contextWindowId:U},z)}async toggleFullScreen(U){this.F(U)?.toggleFullScreen()}async handleTitleDoubleClick(U){this.F(U)?.handleTitleDoubleClick()}async isMaximized(U){const z=this.F(U);return z?.win?z.win.isMaximized():!1}async maximizeWindow(U){const z=this.F(U);z?.win&&z.win.maximize()}async unmaximizeWindow(U){const z=this.F(U);z?.win&&z.win.unmaximize()}async minimizeWindow(U){const z=this.F(U);z?.win&&z.win.minimize()}async moveWindowTop(U,z){const X=this.D(z?.targetWindowId)??this.F(U);X?.win&&X.win.moveTop()}async positionWindow(U,z,X){const x=this.D(X?.targetWindowId)??this.F(U);if(x?.win){if(x.win.isFullScreen()){const oe=S.Event.toPromise(S.Event.once(S.Event.fromNodeEventEmitter(x.win,"leave-full-screen")));x.win.setFullScreen(!1),await oe}x.win.setBounds(z)}}async updateWindowControls(U,z){const X=this.F(U);X&&X.updateWindowControls(z)}async focusWindow(U,z){(this.D(z?.targetWindowId)??this.F(U))?.focus({force:z?.force??!1})}async setMinimumSize(U,z,X){const x=this.F(U);if(x?.win){const[oe,se]=x.win.getSize(),[ce,Y]=x.win.getMinimumSize(),[K,Q]=[z??ce,X??Y],[q,W]=[Math.max(oe,K),Math.max(se,Q)];(ce!==K||Y!==Q)&&x.win.setMinimumSize(K,Q),(oe!==q||se!==W)&&x.win.setSize(q,W)}}async saveWindowSplash(U,z){this.m.saveWindowSplash(U,z)}async installShellCommand(U){const{source:z,target:X}=await this.w();try{const{symbolicLink:x}=await m.SymlinkSupport.stat(z);if(x&&!x.dangling){const oe=await(0,f.$$p)(z);if(X===oe)return}await m.Promises.unlink(z)}catch(x){if(x.code!=="ENOENT")throw x}try{await m.Promises.symlink(X,z)}catch(x){if(x.code!=="EACCES"&&x.code!=="ENOENT")throw x;const{response:oe}=await this.showMessageBox(U,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(oe===0)try{const se=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${X}' '${z}'\\" with administrator privileges"`;await(0,R.promisify)(P.exec)(se)}catch{throw new Error((0,$.localize)(3,null,z))}}}async uninstallShellCommand(U){const{source:z}=await this.w();try{await m.Promises.unlink(z)}catch(X){switch(X.code){case"EACCES":{const{response:x}=await this.showMessageBox(U,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(x===0)try{const oe=`osascript -e "do shell script \\"rm '${z}'\\" with administrator privileges"`;await(0,R.promisify)(P.exec)(oe)}catch{throw new Error((0,$.localize)(7,null,z))}break}case"ENOENT":break;default:throw X}}}async w(){const U=(0,g.$kc)(this.g.appRoot,"bin","code"),z=`/usr/local/bin/${this.j.applicationName}`;if(!await m.Promises.exists(U))throw new Error((0,$.localize)(8,null,U));return{source:z,target:U}}async showMessageBox(U,z){const X=this.H(U);return this.c.showMessageBox(z,X?.win??void 0)}async showSaveDialog(U,z){const X=this.H(U);return this.c.showSaveDialog(z,X?.win??void 0)}async showOpenDialog(U,z){const X=this.H(U);return this.c.showOpenDialog(z,X?.win??void 0)}async pickFileFolderAndOpen(U,z){const X=await this.c.pickFileFolder(z);X&&await this.z(await Promise.all(X.map(async x=>await m.SymlinkSupport.existsDirectory(x)?{folderUri:y.URI.file(x)}:{fileUri:y.URI.file(x)})),z,U)}async pickFolderAndOpen(U,z){const X=await this.c.pickFolder(z);X&&await this.z(X.map(x=>({folderUri:y.URI.file(x)})),z,U)}async pickFileAndOpen(U,z){const X=await this.c.pickFile(z);X&&await this.z(X.map(x=>({fileUri:y.URI.file(x)})),z,U)}async pickWorkspaceAndOpen(U,z){const X=await this.c.pickWorkspace(z);X&&await this.z(X.map(x=>({workspaceUri:y.URI.file(x)})),z,U)}async z(U,z,X){await this.a.open({context:3,contextWindowId:X,cli:this.g.args,urisToOpen:U,forceNewWindow:z.forceNewWindow})}async showItemInFolder(U,z){A.shell.showItemInFolder(z)}async setRepresentedFilename(U,z){this.F(U)?.setRepresentedFilename(z)}async setDocumentEdited(U,z){this.F(U)?.setDocumentEdited(z)}async openExternal(U,z){return this.g.unsetSnapExportedVariables(),A.shell.openExternal(z),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(U,z){return A.shell.trashItem(z)}async isAdmin(){let U;return b.$j?U=(await new Promise((z,X)=>{J(["native-is-elevated"],z,X)}))():U=process.getuid?.()===0,U}async writeElevated(U,z,X,x){const oe=await new Promise((se,ce)=>{J(["@vscode/sudo-prompt"],se,ce)});return new Promise((se,ce)=>{const Y=[`"${this.C}"`];x?.unlock&&Y.push("--file-chmod"),Y.push("--file-write",`"${z.fsPath}"`,`"${X.fsPath}"`);const K={name:this.j.nameLong.replace("-",""),icns:b.$k&&this.g.isBuilt?(0,g.$jc)((0,g.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};oe.exec(Y.join(" "),K,(Q,q,W)=>{q&&this.h.trace(`[sudo-prompt] received stdout: ${q}`),W&&this.h.trace(`[sudo-prompt] received stderr: ${W}`),Q?ce(Q):se(void 0)})})}async isRunningUnderARM64Translation(){return b.$l||b.$j?!1:A.app.runningUnderARM64Translation}get C(){return b.$j?this.g.isBuilt?(0,g.$jc)((0,g.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.bat"):b.$l?this.g.isBuilt?(0,g.$jc)((0,g.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,g.$jc)(this.g.appRoot,"bin","code"):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return v.$Sm.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return b.$j&&(0,O.$x7b)()}async killProcess(U,z,X){process.kill(z,X)}async readClipboardText(U,z){return A.clipboard.readText(z)}async writeClipboardText(U,z,X){return A.clipboard.writeText(z,X)}async readClipboardFindText(U){return A.clipboard.readFindText()}async writeClipboardFindText(U,z){return A.clipboard.writeFindText(z)}async writeClipboardBuffer(U,z,X,x){return A.clipboard.writeBuffer(z,Buffer.from(X.buffer),x)}async readClipboardBuffer(U,z){return p.$ce.wrap(A.clipboard.readBuffer(z))}async hasClipboard(U,z,X){return A.clipboard.has(z,X)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(U,z){this.F(U)?.updateTouchBar(z)}async notifyReady(U){this.F(U)?.setReady()}async relaunch(U,z){return this.f.relaunch(z)}async reload(U,z){const X=this.F(U);if(X){if((0,n.$6h)(X.openedWorkspace)){const x=X.openedWorkspace.configPath;if(x.scheme===a.Schemas.file&&(await this.n.resolveLocalWorkspace(x))?.transient)return this.openWindow(X.id,{forceReuseWindow:!0})}return this.f.reload(X,z?.disableExtensions!==void 0?{_:[],"disable-extensions":z.disableExtensions}:void 0)}}async closeWindow(U){this.closeWindowById(U,U)}async closeWindowById(U,z){return(this.D(z)??this.F(z))?.win?.close()}async quit(U){const z=this.a.getLastActiveWindow();z?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&z.win?z.win.close():this.f.quit()}async exit(U,z){await this.f.kill(z)}async resolveProxy(U,z){return this.F(U)?.win?.webContents?.session?.resolveProxy(z)}findFreePort(U,z,X,x,oe=1){return(0,w.$hg)(z,X,x,oe)}async openDevTools(U,z){this.H(U)?.win?.webContents.openDevTools(z)}async toggleDevTools(U){this.H(U)?.win?.webContents.toggleDevTools()}async sendInputEvent(U,z){const X=this.F(U);X?.win&&(z.type==="mouseDown"||z.type==="mouseUp")&&X.win.webContents.sendInputEvent(z)}async profileRenderer(U,z,X){const x=this.F(U);if(!x||!x.win)throw new Error;return await new D.$y7b(x.win,z,this.h).inspect(X)}async windowsGetStringRegKey(U,z,X,x){if(!b.$j)return;const oe=await new Promise((se,ce)=>{J(["@vscode/windows-registry"],se,ce)});try{return oe.GetStringRegKey(z,X,x)}catch{return}}D(U){return this.F(U)??this.G(U)}F(U){if(typeof U=="number")return this.a.getWindowById(U)}G(U){if(typeof U=="number")return this.b.getWindowById(U)}H(U){let z=this.r.invokeFunction(t.$d7b);return z||(z=this.D(U)),z}};e.$A7b=I,Ee([C.$ih],I.prototype,"C",null),e.$A7b=I=Ee([te(0,t.$b7b),te(1,E.$a7b),te(2,d.$V6b),te(3,c.$D6b),te(4,h.$B6b),te(5,i.$$i),te(6,o.$qj),te(7,r.$P6b),te(8,l.$66b),te(9,k.$Ph)],I)}),define(ie[299],ne([0,1,15,28,8,22,33,2,13,4,7,107,38,180,91,132,59,24,6,69,79,25,80,34,60,68,29]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k,c,i,o,r,t,n){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=void 0;const p="issue.processExplorerWindowState";let O=class{static{l=this}static{this.a="#1E1E1E"}constructor(I,j,U,z,X,x,oe,se,ce,Y,K){this.g=I,this.h=j,this.i=U,this.j=z,this.k=X,this.l=x,this.m=oe,this.n=se,this.o=ce,this.p=Y,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){y.$wT.on("vscode:listProcesses",async I=>{const j=[];try{j.push({name:(0,f.localize)(0,null),rootProcess:await(0,b.$Gr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(z=>{(0,v.$sm)(z)?j.push({name:z.hostName,rootProcess:z}):z.processes&&j.push({name:z.hostName,rootProcess:z.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(I,"vscode:listProcessesResponse",j)}),y.$wT.on("vscode:workbenchCommand",(I,j)=>{const{id:U,from:z,args:X}=j;let x;switch(z){case"processExplorer":x=this.f;break;default:throw new Error(`Unexpected command source: ${z}`)}x?.webContents.send("vscode:runAction",{id:U,from:z,args:X})}),y.$wT.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),y.$wT.on("vscode:pidToNameRequest",async I=>{const j=await this.k.getMainDiagnostics(),U=[];for(const z of j.windows)U.push([z.pid,`window [${z.id}] (${z.title})`]);for(const{pid:z,name:X}of r.$i7b.getAll())U.push([z,X]);this.t(I,"vscode:pidToNameResponse",U)})}async openReporter(I){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const j=new S.$Rc,U=j.add(this.n.createIPCObjectUrl()),z=this.v(this.c,700,800);this.b=this.u(z,U,{backgroundColor:I.styles.backgroundColor,title:(0,f.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,A.type)(),arch:(0,A.arch)(),release:(0,A.release)()},product:k.default}),this.b.loadURL(u.$dg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(I){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const j=new S.$Rc,U=j.add(this.n.createIPCObjectUrl()),z=this.p.getItem(p,void 0),X=D(z)?z:this.v(this.f,800,500);this.d=this.u(X,U,{backgroundColor:I.styles.backgroundColor,title:(0,f.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:k.default}),this.d.loadURL(u.$dg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const x=()=>{if(!this.d)return;const oe=this.d.getSize(),se=this.d.getPosition();if(!oe||!se)return;const ce={width:oe[0],height:oe[1],x:se[0],y:se[1]};this.p.setItem(p,ce)};this.d.on("moved",x),this.d.on("resized",x)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await P.contentTracing.stopRecording(`${(0,C.$7f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null,I),buttons:[(0,f.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,j)}async $getSystemInfo(){const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,j)}async $getPerformanceInfo(){try{const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,j)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,f.localize)(6,null),buttons:[(0,f.localize)(7,null),(0,f.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,f.localize)(9,null),buttons:[(0,f.localize)(10,null),(0,f.localize)(11,null)]},this.b);return I===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const I=this.q.getWindowById(this.c.id);if(!I)throw new Error("Window not found");return I}async $getIssueReporterUri(I){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return s.Promises.withAsyncBody(async(z,X)=>{const x=new R.$Yd;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",x.token,{replyChannel:U,extensionId:I}),y.$wT.once(U,(oe,se)=>{z(g.URI.parse(se))});try{await(0,s.$Vg)(5e3),x.cancel(),X(new Error("Timed out waiting for issue reporter URI"))}finally{y.$wT.removeHandler(U)}})}async $getIssueReporterData(I){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataProviderResponse${j.id}`;return s.Promises.withAsyncBody(async z=>{const X=new R.$Yd;j.sendWhenReady("vscode:triggerIssueDataProvider",X.token,{replyChannel:U,extensionId:I}),y.$wT.once(U,(x,oe)=>{z(oe)});try{await(0,s.$Vg)(5e3),X.cancel(),z("Error: Extension timed out waiting for issue reporter data")}finally{y.$wT.removeHandler(U)}})}async $getIssueReporterTemplate(I){const j=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataTemplateResponse${j.id}`;return s.Promises.withAsyncBody(async z=>{const X=new R.$Yd;j.sendWhenReady("vscode:triggerIssueDataTemplate",X.token,{replyChannel:U,extensionId:I}),y.$wT.once(U,(x,oe)=>{z(oe)});try{await(0,s.$Vg)(5e3),X.cancel(),z("Error: Extension timed out waiting for issue reporter template")}finally{y.$wT.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,j,...U){I.sender.isDestroyed()||I.sender.send(j,...U)}u(I,j,U,z){const X=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:U.title,backgroundColor:U.backgroundColor||l.a,webPreferences:{preload:u.$dg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$qC)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return X.setMenuBarVisibility(!1),X}v(I,j,U){let z;const X=P.screen.getAllDisplays();if(X.length===1)z=X[0];else{if(a.$k){const se=P.screen.getCursorScreenPoint();z=P.screen.getDisplayNearestPoint(se)}!z&&I&&(z=P.screen.getDisplayMatching(I.getBounds())),z||(z=P.screen.getPrimaryDisplay()||X[0])}const x=z.bounds,oe={width:j,height:U,x:x.x+x.width/2-j/2,y:x.y+x.height/2-U/2};return x.width>0&&x.height>0&&(oe.x<x.x&&(oe.x=x.x),oe.y<x.y&&(oe.y=x.y),oe.x>x.x+x.width&&(oe.x=x.x),oe.y>x.y+x.height&&(oe.y=x.y),oe.width>x.width&&(oe.width=x.width),oe.height>x.height&&(oe.height=x.height)),oe}};e.$B7b=O,e.$B7b=O=l=Ee([te(1,$.$B6b),te(2,d.$$i),te(3,v.$rm),te(4,m.$l7b),te(5,w.$V6b),te(6,h.$z7b),te(7,i.$X6b),te(8,c.$qj),te(9,o.$FN),te(10,n.$b7b)],O);function D(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(ie[300],ne([0,1,22,18,24,20,6,69,25,50,26,48,100]),function(J,e,P,A,s,R,C,S,u,a,g,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$37b=void 0;let f=class extends y.$17b{constructor(m,w,$,d,h,k,c,i){super(m,w,d,h,k,i),this.e=$,this.u=c}s(m){return(0,y.$Z7b)(`linux-${process.arch}`,m,this.k)}t(m){this.a&&(this.d(b.$vU.CheckingForUpdates(m)),this.i.request({url:this.a},P.CancellationToken.None).then(a.$3o).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!m}),this.d(b.$vU.Idle(1))):this.d(b.$vU.AvailableForDownload(w))}).then(void 0,w=>{this.j.error(w),this.e.publicLog2("update:notAvailable",{explicit:!!m});const $=m?w.message||w:void 0;this.d(b.$vU.Idle(1,$))}))}async o(m){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):m.update.url&&this.u.openExternal(void 0,m.update.url),this.d(b.$vU.Idle(1))}};e.$37b=f,e.$37b=f=Ee([te(0,R.$D6b),te(1,A.$ki),te(2,g.$dl),te(3,s.$B6b),te(4,a.$Wo),te(5,C.$$i),te(6,S.$z7b),te(7,u.$qj)],f)}),define(ie[301],ne([0,1,47,45,28,8,22,54,9,7,144,21,18,24,16,20,6,69,25,50,26,48,100]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$57b=void 0;async function o(l,p=1e3){for(;!l();)await(0,R.$Vg)(p)}let r;function t(){return typeof r>"u"&&(r=A.existsSync(u.$jc(u.$mc(process.execPath),"unins000.exe"))?0:1),r}let n=class extends i.$17b{get cachePath(){const p=u.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return b.Promises.mkdir(p,{recursive:!0}).then(()=>p)}constructor(p,O,D,E,I,j,U,z,X){super(p,O,E,I,j,X),this.u=D,this.v=U,this.w=z,p.setRelaunchHandler(this)}handleRelaunch(p){return p?.addArgs||p?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(c.$vU.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(p){let O=`win32-${process.arch}`;return t()===1?O+="-archive":this.k.target==="user"&&(O+="-user"),(0,i.$Z7b)(O,p,this.k)}t(p){this.a&&(this.d(c.$vU.CheckingForUpdates(p)),this.i.request({url:this.a},C.CancellationToken.None).then(h.$3o).then(O=>{const D=t();return!O||!O.url||!O.version||!O.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!p}),this.d(c.$vU.Idle(D)),Promise.resolve(null)):D===1?(this.d(c.$vU.AvailableForDownload(O)),Promise.resolve(null)):(this.d(c.$vU.Downloading(O)),this.C(O.version).then(()=>this.B(O.version).then(E=>b.Promises.exists(E).then(I=>{if(I)return Promise.resolve(E);const j=O.url,U=O.hash,z=`${E}.tmp`;return this.i.request({url:j},C.CancellationToken.None).then(X=>this.v.writeFile(a.URI.file(z),X.stream)).then(U?()=>(0,g.$rT)(z,O.hash):()=>{}).then(()=>b.Promises.rename(z,E,!1)).then(()=>E)})).then(E=>{const I=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:E},I?this.k.target==="user"?this.p():this.d(c.$vU.Downloaded(O)):this.d(c.$vU.Ready(O))})))}).then(void 0,O=>{this.j.error(O),this.u.publicLog2("update:notAvailable",{explicit:!!p});const D=p?O.message||O:void 0;this.d(c.$vU.Idle(t(),D))}))}async o(p){p.update.url&&this.w.openExternal(void 0,p.update.url),this.d(c.$vU.Idle(t()))}async B(p){const O=await this.cachePath;return u.$jc(O,`CodeSetup-${this.k.quality}-${p}.exe`)}async C(p=null){const O=p?j=>!new RegExp(`${this.k.quality}-${p}\\.exe$`).test(j):()=>!0,D=await this.cachePath,I=(await b.Promises.readdir(D)).filter(O).map(async j=>{try{await b.Promises.unlink(u.$jc(D,j))}catch{}});await Promise.all(I)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const p=this.state.update;this.d(c.$vU.Updating(p));const O=await this.cachePath;this.e.updateFilePath=u.$jc(O,`CodeSetup-${this.k.quality}-${p.version}.flag`),await b.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(c.$vU.Idle(t()))});const E=`${this.k.win32MutexName}-ready`,I=await new Promise((j,U)=>{J(["@vscode/windows-mutex"],j,U)});o(()=>I.isActive(E)).then(()=>this.d(c.$vU.Ready(p)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?A.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return t()}async _applySpecificUpdate(p){if(this.state.type!=="idle")return;const O=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown"};this.d(c.$vU.Downloading(D)),this.e={packagePath:p},O?this.k.target==="user"?this.p():this.d(c.$vU.Downloaded(D)):this.d(c.$vU.Ready(D))}};e.$57b=n,Ee([S.$ih],n.prototype,"cachePath",null),e.$57b=n=Ee([te(0,m.$D6b),te(1,y.$ki),te(2,k.$dl),te(3,f.$B6b),te(4,h.$Wo),te(5,w.$$i),te(6,v.$_j),te(7,$.$z7b),te(8,d.$qj)],n)}),define(ie[133],ne([0,1,15,8,22,49,3,2,13,65,4,7,190,63,18,59,24,62,16,20,6,25,80,252,82,26,102,67,68,29,30,53,128,136,39,34,52,66,23,5]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k,c,i,o,r,t,n,l,p,O,D,E,I,j,U,z,X,x,oe,se){"use strict";var ce;Object.defineProperty(e,"__esModule",{value:!0}),e.$$6b=e.$06b=void 0;var Y;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(Y||(Y={}));class K extends S.$Sc{focus(W){g.$k&&W?.force&&P.app.focus({steal:!0});const G=this.a();G&&(G.isMinimized()&&G.restore(),G.focus())}}e.$06b=K;let Q=class extends K{static{ce=this}static{this.b="windowControlHeight"}get id(){return this.m}get win(){return this.n}a(){return this.n}get lastFocusTime(){return this.s}get backupPath(){return this.t?.backupPath}get openedWorkspace(){return this.t?.workspace}get profile(){if(!this.config)return;const W=this.U.profiles.find(G=>G.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.U.getProfileForWorkspace(this.config.workspace??(0,D.$5h)(this.backupPath,this.isExtensionDevelopmentHost))??this.U.defaultProfile}get remoteAuthority(){return this.t?.remoteAuthority}get config(){return this.t}get isExtensionDevelopmentHost(){return!!this.t?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.t?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.t?.debugId}constructor(W,G,H,Z,re,L,M,N,T,F,B,V,ae,de,ue,he,ve,be,ye,Ie,Te){super(),this.P=G,this.Q=H,this.R=Z,this.S=re,this.U=L,this.W=M,this.X=N,this.Y=T,this.Z=F,this.$=B,this.ab=V,this.bb=ae,this.db=de,this.eb=ue,this.fb=he,this.gb=ve,this.hb=be,this.ib=ye,this.jb=Ie,this.c=this.B(new C.$Od),this.onWillLoad=this.c.event,this.f=this.B(new C.$Od),this.onDidSignalReady=this.f.event,this.g=this.B(new C.$Od),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new C.$Od),this.onDidClose=this.h.event,this.j=this.B(new C.$Od),this.onDidDestroy=this.j.event,this.s=-1,this.z=void 0,this.C=void 0,this.G=!1,this.H=[],this.I=[],this.J=void 0,this.L=void 0,this.M=this.B(this.hb.createIPCObjectUrl()),this.O=!1,this.lb=0;{const[me,we]=this.vb(W.state);this.u=me,this.P.trace("window#ctor: using window state",me);const _=this.u.mode===0||this.u.mode===3,le=this.Z.getValue("window"),ge=Te.invokeFunction(O.$c7b,this.u,{show:!_,webPreferences:{preload:u.$dg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.M.resource.toString()}`],v8CacheOptions:this.R.useCodeCache?"bypassHeatCheck":"none"}});g.$k&&!this.Cb()&&(ge.fullscreenable=!1);const Oe=g.$k&&le?.nativeTabs===!0;Oe&&(ge.tabbingIdentifier=this.gb.nameShort);const Ce=(0,p.$oC)(this.Z)==="custom";if(Ce&&(ge.titleBarStyle="hidden",g.$k||(ge.frame=!1),(0,p.$pC)(this.Z))){const Le=this.$.getWindowSplash()?.colorInfo.titleBarBackground??this.$.getBackgroundColor(),Re=j.$2s.fromHex(Le).isDarker()?"#FFFFFF":"#000000";ge.titleBarOverlay={height:29,color:Le,symbolColor:Re},this.G=!0}if((0,a.mark)("code/willCreateCodeBrowserWindow"),this.n=new P.BrowserWindow(ge),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.m=this.n.id,g.$k&&Ce&&this.n.setSheetOffset(22),Ce&&(g.$j&&(0,p.$pC)(this.Z)||g.$k)){const Le=this.jb.getItem(ce.b);Le&&this.updateWindowControls({height:Le})}g.$j&&Ce&&this.n.hookWindowMessage(278,()=>{const[Re,He]=this.n.getPosition(),ze=P.screen.getCursorScreenPoint(),ee=ze.x-Re,fe=ze.y-He;return(()=>!(ee>30&&fe>=0&&fe<=Math.max(this.n.getBounds().height*.15,35)))()||(this.n.setEnabled(!1),this.n.setEnabled(!0),this.g.fire({x:ee,y:fe})),0}),(g.$k||g.$j)&&we&&(!Oe||P.BrowserWindow.getAllWindows().length===1)&&[this.u.width,this.u.height,this.u.x,this.u.y].every(Le=>typeof Le=="number")&&this.n.setBounds({width:this.u.width,height:this.u.height,x:this.u.x,y:this.u.y}),_&&((0,a.mark)("code/willMaximizeCodeWindow"),this.n.maximize(),this.u.mode===3?(this.kb("WindowMode.Fullscreen"),this.yb(!0)):this.kb("WindowMode.Maximized"),this.n.show(),(0,a.mark)("code/didMaximizeCodeWindow")),this.s=Date.now()}this.R.args["open-devtools"]===!0&&this.n.webContents.openDevTools(),this.sb(),this.Gb(),this.mb()}kb(W){this.Z.getValue("window.logFullScreenTransitions")&&this.P.info(`window-fullscreen-bug: ${W})`)}setRepresentedFilename(W){g.$k?this.n.setRepresentedFilename(W):this.D=W}getRepresentedFilename(){return g.$k?this.n.getRepresentedFilename():this.D}setDocumentEdited(W){g.$k&&this.n.setDocumentEdited(W),this.F=W}isDocumentEdited(){return g.$k?this.n.isDocumentEdited():!!this.F}setReady(){for(this.P.trace(`window#load: window reported ready (id: ${this.m})`),this.lb=2;this.H.length;)this.H.pop()(this);this.f.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.H.push(W)})}get isReady(){return this.lb===2}get whenClosedOrLoaded(){return new Promise(W=>{function G(){H.dispose(),Z.dispose(),W()}const H=this.onDidClose(()=>G()),Z=this.onWillLoad(()=>G())})}mb(){this.n.on("unresponsive",()=>this.pb(1)),this.n.webContents.on("render-process-gone",(G,H)=>this.pb(2,{...H})),this.n.webContents.on("did-fail-load",(G,H,Z)=>this.pb(3,{reason:Z,exitCode:H})),this.n.webContents.on("will-prevent-unload",G=>{G.preventDefault()}),this.n.on("closed",()=>{this.h.fire(),this.dispose()}),this.n.webContents.on("did-finish-load",()=>{this.N&&(this.t=this.N,this.N=void 0)}),this.n.on("focus",()=>{this.s=Date.now()}),this.n.on("maximize",G=>{this.t&&(this.t.maximized=!0),P.app.emit("browser-window-maximize",G,this.n)}),this.n.on("unmaximize",G=>{this.t&&(this.t.maximized=!1),P.app.emit("browser-window-unmaximize",G,this.n)}),this.n.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.kb(`enter-full-screen: ${Date.now()}`),this.C?.complete(),this.C=void 0}),this.n.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.kb(`leave-full-screen: ${Date.now()}`),this.C?.complete(),this.C=void 0}),this.B(this.Z.onDidChangeConfiguration(G=>this.sb(G))),this.B(this.ab.onDidDeleteUntitledWorkspace(G=>this.rb(G)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.n.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(G,H)=>{const Z=await this.ob();H({cancel:!1,requestHeaders:Object.assign(G.requestHeaders,Z)})})}ob(){return this.nb||(this.nb=(0,o.$ep)(this.gb.version,this.gb,this.R,this.Z,this.W,this.X,this.db)),this.nb}async pb(W,G){switch(W){case 2:this.P.error(`CodeWindow: renderer process gone (reason: ${G?.reason||"<unknown>"}, code: ${G?.exitCode||"<unknown>"})`);break;case 1:this.P.error("CodeWindow: detected unresponsive");break;case 3:this.P.error(`CodeWindow: failed to load (reason: ${G?.reason||"<unknown>"}, code: ${G?.exitCode||"<unknown>"})`);break}switch(this.db.publicLog2("windowerror",{type:W,reason:G?.reason,code:G?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.fb.kill(1);return}if(this.R.args["enable-smoke-test-driver"]){await this.qb(!1,!1),this.fb.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.n&&this.n.webContents&&this.n.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:Z}=await this.eb.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null),(0,y.localize)(2,null)],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),checkboxLabel:this.t?.workspace?(0,y.localize)(5,null):void 0},this.n);if(H!==2){const re=H===0;await this.qb(re,Z)}}else if(W===2){let H;G?H=(0,y.localize)(7,null,G.reason,G.exitCode??"<unknown>"):H=(0,y.localize)(6,null);const{response:Z,checkboxChecked:re}=await this.eb.showMessageBox({type:"warning",buttons:[this.t?.workspace?(0,y.localize)(8,null):(0,y.localize)(9,null),(0,y.localize)(10,null)],message:H,detail:this.t?.workspace?(0,y.localize)(11,null):(0,y.localize)(12,null),checkboxLabel:this.t?.workspace?(0,y.localize)(13,null):void 0},this.n),L=Z===0;await this.qb(L,re)}break}}async qb(W,G){const H=this.t?.workspace;if(G&&H)try{const Z=this.Y.workspaceStorage(H);await Z.init(),Z.delete("memento/workbench.parts.editor"),await Z.close()}catch(Z){this.P.error(Z)}if(this.j.fire(),this.n?.destroy(),W&&this.t){let Z,re;(0,D.$1h)(H)?Z={folderUri:H.uri}:(0,D.$6h)(H)?Z={workspaceUri:H.configPath}:re=!0,(0,oe.$Ob)(await this.ib.open({context:5,userEnv:this.t.userEnv,cli:{...this.R.args,_:[]},urisToOpen:Z?[Z]:void 0,forceEmpty:re,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}rb(W){this.t?.workspace?.id===W.id&&(this.t.workspace=void 0)}sb(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const G=this.Db();G!==this.w&&(this.w=G,this.Eb(G))}if(!W||W.affectsConfiguration("http.proxy")){let G=(this.Z.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;G?.endsWith("/")&&(G=G.substr(0,G.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((G||"").indexOf("@")===-1&&(G!==this.J||H!==this.L)){this.J=G,this.L=H;const Z=G||"",re=H?`${H},<local>`:"<local>";this.P.trace(`Setting proxy to '${Z}', bypassing '${re}'`),this.n.webContents.session.setProxy({proxyRules:Z,proxyBypassRules:re,pacScript:""})}}}addTabbedWindow(W){g.$k&&W.win&&this.n.addTabbedWindow(W.win)}load(W,G=Object.create(null)){this.P.trace(`window#load: attempt to load window (id: ${this.m})`),this.isDocumentEdited()&&(!G.isReload||!this.bb.isHotExitEnabled())&&this.setDocumentEdited(!1),G.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.n.setTitle(this.gb.nameLong)),this.tb(W,G),this.lb===0?this.t=W:this.N=W,this.lb=1,this.n.loadURL(u.$dg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.R.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.O;this.O=!0,!this.R.isBuilt&&!this.R.extensionTestsLocationURI&&this.B(new A.$7g(()=>{this.n&&!this.n.isVisible()&&!this.n.isMinimized()&&(this.n.show(),this.focus({force:!0}),this.n.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:W.workspace,reason:G.isReload?3:H?2:1})}tb(W,G){const H=(this.t??this.N)?.userEnv;if(H){const Z=(0,$.$Ol)(H)&&!(0,$.$Ol)(W.userEnv),re=this.isExtensionDevelopmentHost;(Z||re)&&(W.userEnv={...H,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),G.disableExtensions!==void 0&&(W["disable-extensions"]=G.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this.n.isMaximized(),W.partsSplash=this.$.getWindowSplash(),(0,a.mark)("code/willOpenNewWindow"),W.perfMarks=(0,a.getMarks)(),this.M.update(W)}async reload(W){const G=Object.assign({},this.t);G.workspace=await this.ub(G),delete G.filesToOpenOrCreate,delete G.filesToDiff,delete G.filesToMerge,delete G.filesToWait,this.isExtensionDevelopmentHost&&W&&(G.verbose=W.verbose,G.debugId=W.debugId,G.extensionEnvironment=W.extensionEnvironment,G["inspect-extensions"]=W["inspect-extensions"],G["inspect-brk-extensions"]=W["inspect-brk-extensions"],G["extensions-dir"]=W["extensions-dir"]),G.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),G.isInitialStartup=!1,G.policiesData=this.S.serialize(),G.continueOn=this.R.continueOn,G.profiles={all:this.U.profiles,profile:this.profile||this.U.defaultProfile,home:this.U.profilesHome},G.logLevel=this.Q.getLogLevel(),G.loggers={window:this.Q.getRegisteredLoggers(this.id),global:this.Q.getRegisteredLoggers()},this.load(G,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async ub(W){if((0,D.$6h)(W.workspace)){const G=W.workspace.configPath;if(G.scheme===u.Schemas.file&&!await this.W.exists(G))return}else if((0,D.$1h)(W.workspace)){const G=W.workspace.uri;if(G.scheme===u.Schemas.file&&!await this.W.exists(G))return}return W.workspace}serializeWindowState(){if(!this.n)return(0,I.$A6b)();if(this.isFullScreen){let H;try{H=P.screen.getDisplayMatching(this.getBounds())}catch{}const Z=(0,I.$A6b)();return{mode:3,display:H?H.id:void 0,width:this.u.width||Z.width,height:this.u.height||Z.height,x:this.u.x||0,y:this.u.y||0}}const W=Object.create(null);let G;if(!g.$k&&this.n.isMaximized()?G=0:G=1,G===0?W.mode=0:W.mode=1,G===1||G===0){let H;G===1?H=this.getBounds():H=this.n.getNormalBounds(),W.x=H.x,W.y=H.y,W.width=H.width,W.height=H.height}return W}updateWindowControls(W){if(W.height&&this.jb.setItem(ce.b,W.height),g.$j&&this.G)this.n.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if(g.$k&&W.height!==void 0){const G=(W.height-15)/2;G?this.n.setWindowButtonPosition({x:G,y:G}):this.n.setWindowButtonPosition(null)}}vb(W){(0,a.mark)("code/willRestoreCodeWindowState");let G=!1;if(W)try{const H=P.screen.getAllDisplays();G=H.length>1,W=this.wb(W,H)}catch(H){this.P.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,a.mark)("code/didRestoreCodeWindowState"),[W||(0,I.$A6b)(),G]}wb(W,G){if(this.P.trace(`window#validateWindowState: validating window state on ${G.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.P.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.P.trace("window#validateWindowState: unexpected negative values");return}if(G.length===1){const re=this.xb(G[0]);if(re){let L=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!re||(W.x<re.x&&(W.x=re.x),W.y<re.y&&(W.y=re.y))};this.P.trace("window#validateWindowState: 1 monitor working area",re),L(),W.width>re.width&&(W.width=re.width),W.height>re.height&&(W.height=re.height),W.x>re.x+re.width-128&&(W.x=re.x+re.width-W.width),W.y>re.y+re.height-128&&(W.y=re.y+re.height-W.height),L()}return W}if(W.display&&W.mode===3){const re=G.find(L=>L.id===W.display);if(re&&typeof re.bounds?.x=="number"&&typeof re.bounds?.y=="number"){this.P.trace("window#validateWindowState: restoring fullscreen to previous display");const L=(0,I.$A6b)(3);return L.x=re.bounds.x,L.y=re.bounds.y,L}}let H,Z;try{H=P.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),Z=this.xb(H)}catch{}if(H&&Z&&W.x+W.width>Z.x&&W.y+W.height>Z.y&&W.x<Z.x+Z.width&&W.y<Z.y+Z.height)return this.P.trace("window#validateWindowState: multi-monitor working area",Z),W}xb(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,G]=this.n.getPosition(),[H,Z]=this.n.getSize();return{x:W,y:G,width:H,height:Z}}toggleFullScreen(){this.yb(!this.isFullScreen)}yb(W){this.Cb()?this.zb(W):this.Bb(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.w&&this.Eb(this.w,!1)}get isFullScreen(){if(this.kb(`isFullScreen(): begin at ${Date.now()}`),g.$k&&typeof this.z=="boolean")return this.kb(`isFullScreen(): returning transientIsNativeFullScreen = ${this.z}`),this.z;const W=this.n.isFullScreen(),G=this.n.isSimpleFullScreen();return this.kb(`isFullScreen(): returning natively, isFullScreen = ${W}, isSimpleFullScreen = ${G}`),W||G}zb(W){this.n.isSimpleFullScreen()&&this.n.setSimpleFullScreen(!1),this.Ab(W)}Ab(W){g.$k&&(this.kb(`doSetNativeFullScreen(${W}): begin at ${Date.now()}`),this.z=W,this.C=new A.$dh,Promise.race([this.C.p,(0,A.$Vg)(1e4)]).finally(()=>{this.kb(`doSetNativeFullScreen(${W}): finish at ${Date.now()}`),this.z=void 0})),this.n.setFullScreen(W)}Bb(W){this.n.isFullScreen()&&this.Ab(!1),this.n.setSimpleFullScreen(W),this.n.webContents.focus()}Cb(){const W=this.Z.getValue("window");return!W||typeof W.nativeFullScreen!="boolean"||W.nativeTabs?!0:W.nativeFullScreen!==!1}isMinimized(){return this.n.isMinimized()}Db(){let W=(0,p.$nC)(this.Z);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}Eb(W,G=!0){g.$k||(W==="toggle"&&G&&this.send("vscode:showInfoMessage",(0,y.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.Fb(W)}):this.Fb(W))}Fb(W){const G=this.isFullScreen;switch(W){case"classic":this.n.setMenuBarVisibility(!G),this.n.autoHideMenuBar=G;break;case"visible":this.n.setMenuBarVisibility(!0),this.n.autoHideMenuBar=!1;break;case"toggle":this.n.setMenuBarVisibility(!1),this.n.autoHideMenuBar=!0;break;case"hidden":this.n.setMenuBarVisibility(!1),this.n.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.$k)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.n.minimize();break;case"None":break;case"Maximize":default:this.n.isMaximized()?this.n.unmaximize():this.n.maximize()}else this.n.isMaximized()?this.n.unmaximize():this.n.maximize()}close(){this.n?.close()}sendWhenReady(W,G,...H){this.isReady?this.send(W,...H):this.ready().then(()=>{G.isCancellationRequested||this.send(W,...H)})}send(W,...G){if(this.n){if(this.n.isDestroyed()||this.n.webContents.isDestroyed()){this.P.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this.n.webContents.send(W,...G)}catch(H){this.P.warn(`Error sending IPC message to channel '${W}' of window ${this.m}: ${(0,R.$Bi)(H)}`)}}}updateTouchBar(W){g.$k&&this.I.forEach((G,H)=>{const Z=W[H];G.segments=this.Ib(Z)})}Gb(){if(g.$k){for(let W=0;W<10;W++){const G=this.Hb();this.I.push(G)}this.n.setTouchBar(new P.TouchBar({items:this.I}))}}Hb(W=[]){const G=this.Ib(W),H=new P.TouchBar.TouchBarSegmentedControl({segments:G,mode:"buttons",segmentStyle:"automatic",change:Z=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:H.segments[Z].id,from:"touchbar"})}});return H}Ib(W=[]){return W.map(H=>{let Z;H.icon&&!n.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===u.Schemas.file&&(Z=P.nativeImage.createFromPath(b.URI.revive(H.icon.dark).fsPath),Z.isEmpty()&&(Z=void 0));let re;return typeof H.title=="string"?re=H.title:re=H.title.value,{id:H.id,label:Z?void 0:re,icon:Z}})}dispose(){super.dispose(),this.Q.deregisterLoggers(this.id),this.n=null}};e.$$6b=Q,e.$$6b=Q=ce=Ee([te(1,k.$$i),te(2,x.$86b),te(3,w.$B6b),te(4,U.$mn),te(5,X.$J6b),te(6,d.$_j),te(7,r.$N6b),te(8,r.$L6b),te(9,v.$ki),te(10,l.$P6b),te(11,E.$66b),te(12,f.$U6b),te(13,t.$dl),te(14,m.$V6b),te(15,h.$D6b),te(16,c.$qj),te(17,i.$X6b),te(18,O.$b7b),te(19,z.$FN),te(20,se.$Ph)],Q)}),define(ie[302],ne([0,1,15,3,24,133]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=void 0;let C=class extends R.$06b{get win(){return this.c||this.tryClaimWindow(),this.c}a(){return this.win}get lastFocusTime(){return this.g}constructor(u,a){super(),this.h=u,this.j=a,this.id=this.h.id,this.b=this.B(new A.$Od),this.onDidClose=this.b.event,this.c=null,this.g=Date.now(),this.m()}m(){this.j.args["open-devtools"]===!0&&this.h.openDevTools({mode:"bottom"}),this.tryClaimWindow()}tryClaimWindow(){if(this.c||this.q.isDisposed||this.h.isDestroyed())return;const u=P.BrowserWindow.fromWebContents(this.h);u&&(this.c=u,u.setMenu(null),this.n(u))}n(u){u.on("closed",()=>{this.b.fire(),this.dispose()}),u.on("focus",()=>{this.g=Date.now()})}dispose(){super.dispose(),this.c=null}};e.$_6b=C,e.$_6b=C=Ee([te(1,s.$B6b)],C)}),define(ie[303],ne([0,1,15,3,13,302,5,29]),function(J,e,P,A,s,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x8b=void 0;let u=class{constructor(g){this.b=g,this.a=new Map,this.c()}c(){P.app.on("browser-window-created",(g,b)=>{const y=this.getWindowById(b.id);y&&y.tryClaimWindow()})}createWindow(){return this.b.invokeFunction(S.$c7b,void 0,{webPreferences:{preload:s.$dg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-slim.js").fsPath}})}registerWindow(g){const b=this.b.createInstance(R.$_6b,g);this.a.set(b.id,b),A.Event.once(b.onDidClose)(()=>this.a.delete(b.id))}getWindowById(g){return this.a.get(g)}getFocusedWindow(){const g=P.BrowserWindow.getFocusedWindow();if(g)return this.getWindowById(g.id)}getLastActiveWindow(){return(0,S.$e7b)(Array.from(this.a.values()))}getWindows(){return Array.from(this.a.values())}};e.$x8b=u,e.$x8b=u=Ee([te(0,C.$Ph)],u)}),define(ie[83],ne([0,1,15,23,8,3,46,2,13,4,19,7,21,193,5,20,6,82,97,30,53,31]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k,c){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=e.$L7b=void 0,e.$L7b=(0,v.$Qh)("workspacesHistoryMainService");let o=class extends S.$Sc{static{i=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(t,n,l,p){super(),this.f=t,this.g=n,this.h=l,this.j=p,this.c=this.B(new R.$Od),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Sg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(t=>this.addRecentlyOpened([{workspace:t.workspace,remoteAuthority:t.window.remoteAuthority}])))}async addRecentlyOpened(t){let n=[],l=[];for(const O of t)if((0,d.$UU)(O))!this.g.isUntitledWorkspace(O.workspace)&&!this.u(n,O.workspace)&&n.push(O);else if((0,d.$VU)(O))this.w(n,O.folderUri)||n.push(O);else{const D=this.y(l,O.fileUri),E=O.fileUri.scheme===u.Schemas.file&&i.F.indexOf((0,g.$tg)(O.fileUri))>=0;!D&&!E&&(l.push(O),a.$j&&O.fileUri.scheme===u.Schemas.file&&P.app.addRecentDocument(O.fileUri.fsPath))}const p=await this.n({workspaces:n,files:l});n=p.workspaces,l=p.files,n.length>i.a&&(n.length=i.a),l.length>i.a&&(l.length=i.a),await this.s({workspaces:n,files:l}),this.c.fire(),a.$k&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(t){const n=D=>{const E=this.t(D);for(const I of t)if(g.$ng.isEqual(I,E))return!1;return!0},l=await this.getRecentlyOpened(),p=l.workspaces.filter(n),O=l.files.filter(n);(p.length!==l.workspaces.length||O.length!==l.files.length)&&(await this.s({files:O,workspaces:p}),this.c.fire(),a.$k&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(t){const n=new c.$Ac(O=>g.$ng.getComparisonKey(O));if(t?.workspaces)for(const O of t.workspaces)n.set(this.t(O),O);const l=new c.$Ac(O=>g.$ng.getComparisonKey(O));if(t?.files)for(const O of t.files)l.set(this.t(O),O);const p=await this.r();for(const O of p.workspaces){const D=n.get(this.t(O));D?D.label=D.label??O.label:n.set(this.t(O),O)}for(const O of p.files){const D=l.get(this.t(O));D?D.label=D.label??O.label:l.set(this.t(O),O)}return{workspaces:[...n.values()],files:[...l.values()]}}async r(){await this.j.whenReady;let t;const n=this.j.get(i.b,-1);if(typeof n=="string")try{t=JSON.parse(n)}catch(l){this.f.error("Unexpected error parsing opened paths list",l)}return(0,d.$2U)(t,this.f)}async s(t){await this.j.whenReady,this.j.store(i.b,JSON.stringify((0,d.$3U)(t)),-1,1)}t(t){return(0,d.$VU)(t)?t.folderUri:(0,d.$WU)(t)?t.fileUri:t.workspace.configPath}u(t,n){return!!t.find(l=>(0,d.$UU)(l)&&l.workspace.id===n.id)}w(t,n){return!!t.find(l=>(0,d.$VU)(l)&&g.$ng.isEqual(l.folderUri,n))}y(t,n){return!!t.find(l=>g.$ng.isEqual(l.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){a.$j&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!a.$j)return;const t=[];if(t.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const O of P.app.getJumpListSettings().removedItems){const D=O.args;if(D){const E=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);E&&n.push(b.URI.parse(E[2]))}}await this.removeRecentlyOpened(n);let l=!1;const p=(0,A.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,i.D).map(O=>{const D=(0,d.$UU)(O)?O.workspace:O.folderUri,{title:E,description:I}=this.J(D,O.label);let j;return b.URI.isUri(D)?j=`--folder-uri "${D.toString()}"`:(l=!0,j=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:E.substr(0,255),description:I.substr(0,255),program:process.execPath,args:j,iconPath:"explorer.exe",iconIndex:0}}));p.length>0&&t.push({type:"custom",name:l?(0,f.localize)(2,null):(0,f.localize)(3,null),items:p})}t.push({type:"recent"});try{const n=P.app.setJumpList(t);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(t,n){if(n)return{title:(0,C.$Ev)(n).name,description:n};if(b.URI.isUri(t))return{title:(0,g.$tg)(t),description:this.L(t)};if(this.g.isUntitledWorkspace(t))return{title:(0,f.localize)(4,null),description:""};let l=(0,g.$tg)(t.configPath);return l.endsWith(h.$ai)&&(l=l.substr(0,l.length-h.$ai.length-1)),{title:(0,f.localize)(5,null,l),description:this.L(t.configPath)}}L(t){return t.scheme==="file"?(0,C.$wv)(t.fsPath):t.toString()}async M(){if(!a.$k)return;P.app.clearRecentDocuments();const t=await this.getRecentlyOpened(),n=[];let l=0;for(let O=0;O<t.workspaces.length&&l<i.z;O++){const D=this.t(t.workspaces[O]);if(D.scheme===u.Schemas.file){const E=(0,g.$kg)(D);await y.Promises.exists(E)&&(n.push(E),l++)}}const p=[];for(let O=0;O<t.files.length&&l<i.C;O++){const D=this.t(t.files[O]);if(D.scheme===u.Schemas.file){const E=(0,g.$kg)(D);if(i.F.includes((0,g.$tg)(D))||n.includes(E))continue;await y.Promises.exists(E)&&(p.push(E),l++)}}p.reverse().forEach(O=>P.app.addRecentDocument(O)),n.reverse().forEach(O=>P.app.addRecentDocument(O))}};e.$M7b=o,e.$M7b=o=i=Ee([te(0,w.$$i),te(1,k.$66b),te(2,m.$D6b),te(3,$.$N6b)],o)}),define(ie[304],ne([0,1,15,8,22,46,4,7,181,78,18,24,20,6,231,69,25,34,26,48,68,29,83]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k,c,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$N7b=void 0;const r="menu";let t=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(p,O,D,E,I,j,U,z,X,x,oe,se){this.n=p,this.o=O,this.p=D,this.q=E,this.r=I,this.s=j,this.t=U,this.u=z,this.v=X,this.w=x,this.x=oe,this.y=se,this.m=Object.create(null),this.g=new A.$7g(()=>this.F(),0),this.h=new A.$7g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.$k||(0,k.$oC)(this.o)==="native")&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const p=this.t.getItem(o.a);p&&(p.menus&&(this.k=p.menus),p.keybindings&&(this.l=p.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(j,U,z)=>this.p.openEmptyWindow({context:2,contextWindowId:U?.id}),this.m["workbench.action.newWindow"]=(j,U,z)=>this.p.openEmptyWindow({context:2,contextWindowId:U?.id}),this.m["workbench.action.files.openFileFolder"]=(j,U,z)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(z),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(j,U,z)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(z),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(j,U,z)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(z),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const p=this.x.youTubeUrl;p&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(p,"openYouTubeUrl"));const O=this.x.requestFeatureUrl;O&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(O,"openUserVoiceUrl"));const D=this.x.reportIssueUrl;D&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(D,"openReportIssues"));const E=this.x.licenseUrl;E&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.$w){const j=E.indexOf("?")>0?"&":"?";this.ab(`${E}${j}lang=${C.$w}`,"openLicenseUrl")}else this.ab(E,"openLicenseUrl")});const I=this.x.privacyStatementUrl;I&&E&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(I,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(p=>this.G(p)),this.w.onDidBlurWindow(()=>this.H()),this.w.onDidFocusWindow(()=>this.H())}get C(){const p=this.o.getValue("window.enableMenuBarMnemonics");return typeof p!="boolean"?!0:p}get D(){if(!C.$k)return!1;const p=this.o.getValue("window.nativeTabs");return typeof p!="boolean"?!1:p}updateMenu(p,O){this.k=p.menus,this.l=p.keybindings,this.t.setItem(o.a,p),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(p){C.$k&&(p.oldCount===0&&p.newCount>0||p.oldCount>0&&p.newCount===0)&&(this.d=p.newCount===0,this.E())}H(){C.$k&&(this.f=!P.BrowserWindow.getFocusedWindow(),this.E())}I(){const p=P.Menu.getApplicationMenu();if(p&&this.j.push(p),Object.keys(this.k).length===0){this.J(C.$k?new P.Menu:null);return}const O=new P.Menu;let D;if(C.$k){const I=new P.Menu;D=new P.MenuItem({label:this.x.nameShort,submenu:I}),this.K(I),O.append(D)}if(C.$k&&!this.c){this.c=!0;const I=new P.Menu;I.append(new P.MenuItem({label:this.cb(u.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(I)}if(this.M("File")){const I=new P.Menu,j=new P.MenuItem({label:this.cb(u.localize(1,null)),submenu:I});this.O(I,"File"),O.append(j)}if(this.M("Edit")){const I=new P.Menu,j=new P.MenuItem({label:this.cb(u.localize(2,null)),submenu:I});this.O(I,"Edit"),O.append(j)}if(this.M("Selection")){const I=new P.Menu,j=new P.MenuItem({label:this.cb(u.localize(3,null)),submenu:I});this.O(I,"Selection"),O.append(j)}if(this.M("View")){const I=new P.Menu,j=new P.MenuItem({label:this.cb(u.localize(4,null)),submenu:I});this.O(I,"View"),O.append(j)}if(this.M("Go")){const I=new P.Menu,j=new P.MenuItem({label:this.cb(u.localize(5,null)),submenu:I});this.O(I,"Go"),O.append(j)}if(this.M("Run")){const I=new P.Menu,j=new P.MenuItem({label:this.cb(u.localize(6,null)),submenu:I});this.O(I,"Run"),O.append(j)}if(this.M("Terminal")){const I=new P.Menu,j=new P.MenuItem({label:this.cb(u.localize(7,null)),submenu:I});this.O(I,"Terminal"),O.append(j)}let E;if(this.M("Window")){const I=new P.Menu;E=new P.MenuItem({label:this.cb(u.localize(8,null)),submenu:I,role:"window"}),this.U(I)}if(E&&O.append(E),this.M("Help")){const I=new P.Menu,j=new P.MenuItem({label:this.cb(u.localize(9,null)),submenu:I,role:"help"});this.O(I,"Help"),O.append(j)}O.items&&O.items.length>0?this.J(O):this.J(null),this.h.schedule()}J(p){P.Menu.setApplicationMenu(p);for(const O of this.y.getWindows())O.win?.setMenu(null)}K(p){const O=this.W(u.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),D=this.V();let E;if(this.M("Preferences")){const se=new P.Menu;this.O(se,"Preferences"),E=new P.MenuItem({label:this.cb(u.localize(11,null)),submenu:se})}const I=new P.Menu,j=new P.MenuItem({label:u.localize(12,null),role:"services",submenu:I}),U=new P.MenuItem({label:u.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),z=new P.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),X=new P.MenuItem({label:u.localize(15,null),role:"unhide"}),x=new P.MenuItem(this.$("workbench.action.quit",{label:u.localize(16,null,this.x.nameLong),click:async(se,ce,Y)=>{const K=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.L(Y)&&this.w.quit(void 0)}})),oe=[O];oe.push(...D),E&&oe.push(n(),E),oe.push(n(),j,n(),U,z,X,n(),x),oe.forEach(se=>p.append(se))}async L(p){if(this.p.getWindowCount()===0)return!0;const O=this.o.getValue("window.confirmBeforeClose");if(O==="always"||O==="keyboardOnly"&&this.S(p)){const{response:D}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[u.localize(17,null),u.localize(18,null)],message:u.localize(19,null)});return D===0}return!0}M(p){if(!C.$k&&(0,k.$oC)(this.o)==="custom")return!1;switch(p){case"File":case"Help":if(C.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[p];case"Window":if(C.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[p]}}N(p,O){O.forEach(D=>{if((0,v.$I7b)(D))p.append(n());else if((0,v.$H7b)(D)){const E=new P.Menu,I=new P.MenuItem({label:this.cb(D.label),submenu:E});this.N(E,D.submenu.items),p.append(I)}else(0,v.$J7b)(D)?p.append(this.Q(D)):(0,v.$K7b)(D)&&(D.id==="workbench.action.showAboutDialog"&&this.P(p),C.$k?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[D.id]?p.append(new P.MenuItem(this.$(D.id,{label:this.cb(D.label),click:this.m[D.id]}))):p.append(this.W(D.label,D.id,!1,D.checked)):p.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)):p.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)))})}O(p,O){this.k&&this.k[O]&&this.N(p,this.k[O].items)}P(p){const O=this.V();O.length&&(O.forEach(D=>p.append(D)),p.append(n()))}Q(p){const O=S.URI.revive(p.uri),D=p.id,E=D==="openRecentFile"?{fileUri:O}:D==="openRecentWorkspace"?{workspaceUri:O}:{folderUri:O};return new P.MenuItem(this.$(D,{label:p.label,click:async(I,j,U)=>{const z=this.R(U);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[E],forceNewWindow:z,gotoLineMode:!1,remoteAuthority:p.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([O])}},!1))}R(p){return!!(p&&(!C.$k&&(p.ctrlKey||p.shiftKey)||C.$k&&(p.metaKey||p.altKey)))}S(p){return!!(p.triggeredByAccelerator||p.altKey||p.ctrlKey||p.metaKey||p.shiftKey)}T(p,O,D){const E={label:this.cb(p),role:D,enabled:!0};return new P.MenuItem(this.Z(O,E))}U(p){const O=new P.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),D=new P.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),E=new P.MenuItem({label:u.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),I=this.W(u.localize(23,null),"workbench.action.switchWindow"),j=[];this.D&&(j.push(n()),j.push(this.W(u.localize(24,null),"workbench.action.newWindowTab")),j.push(this.T(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),j.push(this.T(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),j.push(this.T(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),j.push(this.T(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[O,D,n(),I,...j,n(),E].forEach(U=>p.append(U))}V(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.cb(u.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.cb(u.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.cb(u.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.cb(u.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(p,O,D,E){const I=this.cb(p),j=typeof O=="function"?O:(oe,se,ce)=>{const Y=oe?oe.userSettingsLabel:null;let K=O;Array.isArray(O)&&(K=this.R(ce)?O[1]:O[0]),Y&&ce.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Y}):this.Y({type:"commandId",commandId:K})},U=typeof D=="boolean"?D:this.p.getWindowCount()>0,z=typeof E=="boolean"?E:!1,X={label:I,click:j,enabled:U};z&&(X.type="checkbox",X.checked=z);let x;return typeof O=="string"?x=O:Array.isArray(O)&&(x=O[0]),C.$k&&(x==="editor.action.clipboardCutAction"?X.role="cut":x==="editor.action.clipboardCopyAction"?X.role="copy":x==="editor.action.clipboardPasteAction"&&(X.role="paste"),x==="undo"?X.click=this.X(j,{inDevTools:oe=>oe.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):x==="redo"?X.click=this.X(j,{inDevTools:oe=>oe.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):x==="editor.action.selectAll"&&(X.click=this.X(j,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.Z(x,X))}X(p,O){return(D,E,I)=>{const j=P.BrowserWindow.getFocusedWindow();if(!j)return O.inNoWindow();if(j.webContents.isDevToolsFocused()&&j.webContents.devToolsWebContents)return O.inDevTools(j.webContents.devToolsWebContents);p(D,E||j,I)}}Y(p){let O=P.BrowserWindow.getFocusedWindow();if(!O){const E=this.p.getLastActiveWindow();E?.isMinimized()&&(O=E.win)}const D=O?this.p.getWindowById(O.id):void 0;if(D){if(this.v.trace("menubar#runActionInRenderer",p),C.$k&&!this.q.isBuilt&&!D.isReady&&(p.type==="commandId"&&p.commandId==="workbench.action.toggleDevTools"||p.type!=="commandId"&&p.userSettingsLabel==="alt+cmd+i"))return;if(p.type==="commandId"){const E={id:p.commandId,from:"menu"};D.sendWhenReady("vscode:runAction",s.CancellationToken.None,E)}else{const E={userSettingsLabel:p.userSettingsLabel};D.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,E)}}else this.v.trace("menubar#runActionInRenderer: no active window found",p)}Z(p,O){const D=typeof p=="string"?this.l[p]:void 0;if(D?.label){if(D.isNative!==!1)O.accelerator=D.label,O.userSettingsLabel=D.userSettingsLabel;else if(typeof O.label=="string"){const E=O.label.indexOf("[");E>=0?O.label=`${O.label.substr(0,E)} [${D.label}]`:O.label=`${O.label} [${D.label}]`}}else O.accelerator=void 0;return O}$(p,O,D=!O.accelerator){D&&(O=this.Z(p,O));const E=O.click;return O.click=(I,j,U)=>{this.bb(p),E?.(I,j,U)},O}ab(p,O){this.w.openExternal(void 0,p),this.bb(O)}bb(p){this.r.publicLog2("workbenchActionExecuted",{id:p,from:r})}cb(p){return(0,R.$Bv)(p,!this.C)}};e.$N7b=t,e.$N7b=t=o=Ee([te(0,h.$wU),te(1,g.$ki),te(2,c.$b7b),te(3,b.$B6b),te(4,d.$dl),te(5,i.$L7b),te(6,$.$FN),te(7,y.$D6b),te(8,f.$$i),te(9,m.$z7b),te(10,w.$qj),te(11,a.$a7b)],t);function n(){return new P.MenuItem({type:"separator"})}}),define(ie[305],ne([0,1,5,20,6,304]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=e.$O7b=void 0,e.$O7b=(0,P.$Qh)("menubarMainService");let C=class{constructor(u,a,g){this.b=u,this.c=a,this.d=g,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.$N7b)}async updateMenubar(u,a){this.d.trace("menubarService#updateMenubar",u),(await this.a).updateMenu(a,u)}};e.$P7b=C,e.$P7b=C=Ee([te(0,P.$Ph),te(1,A.$D6b),te(2,s.$$i)],C)}),define(ie[306],ne([0,1,15,21,131,28,23,22,3,33,46,2,13,9,65,4,35,19,12,7,191,63,18,59,24,16,5,20,6,79,80,58,34,68,133,29,130,298,30,98,83,53,67,39,52,66]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k,c,i,o,r,t,n,l,p,O,D,E,I,j,U,z,X,x,oe,se,ce,Y,K,Q,q,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=void 0;function G(re){return(0,oe.$6h)(re?.workspace)}function H(re){return(0,oe.$1h)(re?.workspace)}let Z=class extends b.$Sc{constructor(L,M,N,T,F,B,V,ae,de,ue,he,ve,be,ye,Ie,Te,me,we,_){super(),this.m=L,this.n=M,this.r=N,this.s=T,this.t=F,this.u=B,this.w=V,this.z=ae,this.C=de,this.D=ue,this.F=he,this.G=ve,this.H=be,this.I=ye,this.J=Ie,this.L=Te,this.M=me,this.N=we,this.O=_,this.a=this.B(new u.$Od),this.onDidOpenWindow=this.a.event,this.b=this.B(new u.$Od),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new u.$Od),this.onDidDestroyWindow=this.c.event,this.f=this.B(new u.$Od),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new u.$Od),this.onDidTriggerSystemContextMenu=this.g.event,this.h=new Map,this.j=this.B(new x.$a8b(this,this.u,this.D,this.s,this.G)),this.P()}P(){this.B(this.I.onDidEnterWorkspace(L=>this.b.fire(L.window))),this.B(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const M=new b.$Rc;if(M.add(u.Event.any(L.onDidClose,L.onDidDestroy)(()=>M.dispose())),L.config.extensionDevelopmentPath)for(const N of L.config.extensionDevelopmentPath)M.add(this.N.addValidFileRoot(N));L.config.extensionTestsPath&&M.add(this.N.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,M){const N=this.z.args,T=M?.remoteAuthority||void 0,F=!0,B=M?.forceReuseWindow,V=!B;return this.open({...L,cli:N,forceEmpty:F,forceNewWindow:V,forceReuseWindow:B,remoteAuthority:T})}openExistingWindow(L,M){L.focus(),this.Q(M,[L])}async open(L){this.s.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const M=[],N=[],T=[],F=[],B=[];let V,ae=0;const de=await this.Y(L);this.s.trace("windowsManager#open pathsToOpen",de);for(const ye of de)H(ye)?L.addMode?M.push(ye):N.push(ye):G(ye)?T.push(ye):ye.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ye.remoteAuthority}),V.filesToOpenOrCreate.push(ye)):ye.backupPath?B.push({backupFolder:(0,f.$nc)(ye.backupPath),remoteAuthority:ye.remoteAuthority}):ae++;L.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),L.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&L.waitMarkerFileURI&&(V.filesToWait={paths:(0,C.$Hb)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(F.push(...this.I.getUntitledWorkspaces()),T.push(...F),B.push(...this.F.getEmptyWindowBackups())):B.length=0;const{windows:ue,filesOpenedInWindow:he}=await this.R(L,T,N,B,ae,V,M);if(this.s.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${T.length}, foldersToOpen: ${N.length}, emptyToRestore: ${B.length}, emptyToOpen: ${ae})`),ue.length>1)if(he)he.focus();else{const ye=this.j.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ie=!0,Te=!0;if(ye){const me=ue.filter(we=>this.j.state.lastActiveWindow&&we.backupPath===this.j.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ie=!1,Te=!1)}if(Ie)for(let me=ue.length-1;me>=0;me--){const we=ue[me];if(!(we.openedWorkspace&&F.some(_=>we.openedWorkspace&&_.workspace.id===we.openedWorkspace.id)||we.backupPath&&B.some(_=>we.backupPath&&_.backupFolder===(0,f.$nc)(we.backupPath)))){we.focus(),Te=!1;break}}Te&&ue[ue.length-1].focus()}const ve=V&&V.filesToDiff.length>0,be=V&&V.filesToMerge.length>0;if(!ue.some(ye=>ye.isExtensionDevelopmentHost)&&!ve&&!be&&!L.noRecentEntry){const ye=[];for(const Ie of de)G(Ie)&&!Ie.transient?ye.push({label:Ie.label,workspace:Ie.workspace,remoteAuthority:Ie.remoteAuthority}):H(Ie)?ye.push({label:Ie.label,folderUri:Ie.workspace.uri,remoteAuthority:Ie.remoteAuthority}):Ie.fileUri&&ye.push({label:Ie.label,fileUri:Ie.fileUri,remoteAuthority:Ie.remoteAuthority});this.H.addRecentlyOpened(ye)}return this.Q(L,ue),ue}Q(L,M){const N=L.waitMarkerFileURI;L.context===0&&N&&M.length===1&&M[0]&&(async()=>{await M[0].whenClosedOrLoaded;try{await this.M.del(N)}catch{}})()}async R(L,M,N,T,F,B,V){const ae=[];let de;function ue(me,we){ae.push(me),we&&(de=me,B=void 0)}let{openFolderInNewWindow:he,openFilesInNewWindow:ve}=this.jb(L);if(!L.initialStartup&&V.length>0){const me=V[0].remoteAuthority,we=this.ob(me);we&&ue(this.U(we,V.map(_=>_.workspace.uri)))}const be=N.length+M.length+T.length;if(B&&be===0){const me=B.filesToOpenOrCreate[0]||B.filesToDiff[0]||B.filesToMerge[3],we=this.getWindows().filter(le=>B&&(0,$.$Bg)(le.remoteAuthority,B.remoteAuthority));let _;me?.fileUri&&!ve&&((L.context===4||L.context===0||L.context===1)&&(_=await(0,X.$Y6b)(we,me.fileUri,async le=>le.configPath.scheme===y.Schemas.file?this.I.resolveLocalWorkspace(le.configPath):void 0)),_||(_=this.pb(we))),_?(0,oe.$6h)(_.openedWorkspace)?M.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):(0,oe.$1h)(_.openedWorkspace)?N.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):ue(this.S(L,_,B),!0):ue(await this.kb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const ye=(0,C.$Mb)(M,me=>me.workspace.id);if(ye.length>0){const me=(0,C.$Hb)(ye.map(we=>(0,X.$Z6b)(this.getWindows(),we.workspace.configPath)));if(me.length>0){const we=me[0],_=(0,$.$Bg)(B?.remoteAuthority,we.remoteAuthority)?B:void 0;ue(this.S(L,we,_),!!_),he=!0}for(const we of ye){if(me.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===we.workspace.id))continue;const _=we.remoteAuthority,le=(0,$.$Bg)(B?.remoteAuthority,_)?B:void 0;ue(await this.X(L,we,he,le),!!le),he=!0}}const Ie=(0,C.$Mb)(N,me=>$.$ng.getComparisonKey(me.workspace.uri));if(Ie.length>0){const me=(0,C.$Hb)(Ie.map(we=>(0,X.$Z6b)(this.getWindows(),we.workspace.uri)));if(me.length>0){const we=me[0],_=(0,$.$Bg)(B?.remoteAuthority,we.remoteAuthority)?B:void 0;ue(this.S(L,we,_),!!_),he=!0}for(const we of Ie){if(me.some(ge=>(0,oe.$1h)(ge.openedWorkspace)&&$.$ng.isEqual(ge.openedWorkspace.uri,we.workspace.uri)))continue;const _=we.remoteAuthority,le=(0,$.$Bg)(B?.remoteAuthority,_)?B:void 0;ue(await this.X(L,we,he,le),!!le),he=!0}}const Te=(0,C.$Mb)(T,me=>me.backupFolder);if(Te.length>0)for(const me of Te){const we=me.remoteAuthority,_=(0,$.$Bg)(B?.remoteAuthority,we)?B:void 0;ue(await this.W(L,!0,we,_,me),!!_),he=!0}if(ae.length===0||B){B&&!F&&F++;const me=B?B.remoteAuthority:L.remoteAuthority;for(let we=0;we<F;we++)ue(await this.W(L,he,me,B),!!B),he=!0}return{windows:(0,C.$Mb)(ae),filesOpenedInWindow:de}}S(L,M,N){this.s.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),M.focus();const T={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return M.sendWhenReady("vscode:openFiles",S.CancellationToken.None,T),M}U(L,M){this.s.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:M}),L.focus();const N={foldersToAdd:M};return L.sendWhenReady("vscode:addFolders",S.CancellationToken.None,N),L}W(L,M,N,T,F){this.s.trace("windowsManager#doOpenEmpty",{restore:!!F,remoteAuthority:N,filesToOpen:T,forceNewWindow:M});let B;return!M&&typeof L.contextWindowId=="number"&&(B=this.getWindowById(L.contextWindowId)),this.kb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:N,forceNewWindow:M,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:T,windowToUse:B,emptyWindowBackupInfo:F,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}X(L,M,N,T,F){return this.s.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:M,filesToOpen:T}),!N&&!F&&typeof L.contextWindowId=="number"&&(F=this.getWindowById(L.contextWindowId)),this.kb({workspace:M.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:M.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:T,windowToUse:F,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async Y(L){let M,N=!1,T=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(M=await this.Z(L),N=!0):L.forceEmpty?M=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(M=await this.$(L.cli),M.length===0&&M.push(Object.create(null)),N=!0):(M=await this.bb(),M.length===0&&M.push(Object.create(null)),T=!0),!L.addMode&&N){const F=M.filter(B=>H(B));if(F.length>1){const B=F[0].remoteAuthority;if(F.every(V=>(0,$.$Bg)(V.remoteAuthority,B))){const V=await this.I.createUntitledWorkspace(F.map(ae=>({uri:ae.workspace.uri})));M.push({workspace:V,remoteAuthority:B}),M=M.filter(ae=>!H(ae))}}}if(L.initialStartup&&!T&&this.G.getValue("window")?.restoreWindows==="preserve"){const F=await this.bb();M.unshift(...F.filter(B=>G(B)||H(B)||B.backupPath))}return M}async Z(L){const M={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},N=await Promise.all((0,C.$Hb)(L.urisToOpen||[]).map(async T=>{const F=await this.db(T,M);if(F)return F.label=T.label,F;const B=this.fb(T);this.L.showMessageBox({type:"info",buttons:[(0,k.localize)(0,null)],message:B.scheme===y.Schemas.file?(0,k.localize)(1,null):(0,k.localize)(2,null),detail:B.scheme===y.Schemas.file?(0,k.localize)(3,null,(0,g.$vv)(B,{os:m.OS,tildify:this.z})):(0,k.localize)(4,null,B.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.$Hb)(N)}async $(L){const M=[],N={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},T=L["folder-uri"];if(T){const V=await Promise.all(T.map(ae=>{const de=this.ab(ae);if(de)return this.db({folderUri:de},N)}));M.push(...(0,C.$Hb)(V))}const F=L["file-uri"];if(F){const V=await Promise.all(F.map(ae=>{const de=this.ab(ae);if(de)return this.db((0,oe.$ji)(ae)?{workspaceUri:de}:{fileUri:de},N)}));M.push(...(0,C.$Hb)(V))}const B=await Promise.all(L._.map(V=>N.remoteAuthority?this.ib(V,N):this.gb(V,N)));return M.push(...(0,C.$Hb)(B)),M}ab(L){try{const M=h.URI.parse(L);if(!M.scheme){this.s.error(`Invalid URI input string, scheme missing: ${L}`);return}return M.path?M:M.with({path:"/"})}catch(M){this.s.error(`Invalid URI input string: ${L}, ${M.message}`)}}async bb(){const L=this.cb();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const M=[];L!=="one"&&M.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&M.push(this.j.state.lastActiveWindow);const N=await Promise.all(M.map(async T=>{if(T.workspace){const F=await this.db({workspaceUri:T.workspace.configPath},{remoteAuthority:T.remoteAuthority,rejectTransientWorkspaces:!0});if(G(F))return F}else if(T.folderUri){const F=await this.db({folderUri:T.folderUri},{remoteAuthority:T.remoteAuthority});if(H(F))return F}else if(L!=="folders"&&T.backupPath)return{backupPath:T.backupPath,remoteAuthority:T.remoteAuthority}}));return(0,C.$Hb)(N)}}}cb(){let L;return this.D.wasRestarted?L="all":(L=this.G.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async db(L,M=Object.create(null)){const N=this.fb(L);return N.scheme===y.Schemas.file?((0,j.$mC)(L)&&(M={...M,forceOpenWorkspaceAsFile:!0}),this.gb(N.fsPath,M)):this.eb(L,M)}eb(L,M){let N=this.fb(L);const T=(0,E.$Vk)(N)||M.remoteAuthority;if(N=(0,$.$Dg)((0,$.$xg)(N)),(0,j.$mC)(L)){if(M.gotoLineMode){const{path:F,line:B,column:V}=(0,a.$6f)(N.path);return{fileUri:N.with({path:F}),options:{selection:B?{startLineNumber:B,startColumn:V||1}:void 0},remoteAuthority:T}}return{fileUri:N,remoteAuthority:T}}else if((0,j.$kC)(L))return{workspace:(0,se.$36b)(N),remoteAuthority:T};return{workspace:(0,se.$46b)(N),remoteAuthority:T}}fb(L){return(0,j.$kC)(L)?L.workspaceUri:(0,j.$lC)(L)?L.folderUri:L.fileUri}async gb(L,M,N){let T,F;M.gotoLineMode&&({path:L,line:T,column:F}=(0,a.$6f)(L)),L=(0,a.$1f)((0,f.$hc)(L),(0,w.cwd)());try{const B=await A.Promises.stat(L);if(B.isFile()){if(!M.forceOpenWorkspaceAsFile){const V=await this.I.resolveLocalWorkspace(h.URI.file(L));if(V)return V.transient&&M.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:t.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:h.URI.file(L),type:t.FileType.File,exists:!0,options:{selection:T?{startLineNumber:T,startColumn:F||1}:void 0}}}else{if(B.isDirectory())return{workspace:(0,se.$46b)(h.URI.file(L),B),type:t.FileType.Directory,exists:!0};if(!m.$j&&L==="/dev/null")return{fileUri:h.URI.file(L),type:t.FileType.File,exists:!0}}}catch(B){if(B.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!N)return this.hb(L,M);const V=h.URI.file(L);if(this.H.removeRecentlyOpened([V]),M.ignoreFileNotFound)return{fileUri:V,type:t.FileType.File,exists:!1}}}async hb(L,M){const N=h.URI.file(L),{response:T,checkboxChecked:F}=await this.L.showMessageBox({type:"warning",buttons:[(0,k.localize)(5,null),(0,k.localize)(6,null),(0,k.localize)(7,null)],message:(0,k.localize)(8,null,N.authority),detail:(0,k.localize)(9,null,(0,g.$vv)(N,{os:m.OS,tildify:this.z})),checkboxLabel:(0,k.localize)(10,null,N.authority),cancelId:1});if(T===0){if((0,s.addUNCHostToAllowlist)(N.authority),F){const B={channel:"vscode:configureAllowedUNCHost",args:N.authority};this.sendToFocused(B.channel,B.args),this.sendToOpeningWindow(B.channel,B.args)}return this.gb(L,M,!0)}if(T===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.hb(L,M)}ib(L,M){const N=L.charCodeAt(0),T=M.remoteAuthority;let F,B;M.gotoLineMode&&({path:L,line:F,column:B}=(0,a.$6f)(L)),N!==47&&((0,a.$Zf)(N)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,a.$Sf)(L)),L=`/${L}`);const V=h.URI.from({scheme:y.Schemas.vscodeRemote,authority:T,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,oe.$ji)(L))return M.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:F?{startLineNumber:F,startColumn:B||1}:void 0},remoteAuthority:M.remoteAuthority}:{workspace:(0,se.$36b)(V),remoteAuthority:T};if(M.gotoLineMode||f.$gc.basename(L).indexOf(".")!==-1)return{fileUri:V,options:{selection:F?{startLineNumber:F,startColumn:B||1}:void 0},remoteAuthority:T}}return{workspace:(0,se.$46b)(V),remoteAuthority:T}}jb(L){const M=this.G.getValue("window"),N=M?.openFoldersInNewWindow||"default",T=M?.openFilesInNewWindow||"off";let F=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(N==="on"||N==="off")&&(F=N==="on");let B=!1;return L.forceNewWindow||L.forceReuseWindow?B=!!L.forceNewWindow&&!L.forceReuseWindow:(m.$k?L.context===1&&(B=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!L.cli.extensionDevelopmentPath&&(T==="on"||T==="off")&&(B=T==="on")),{openFolderInNewWindow:!!F,openFilesInNewWindow:B}}async openExtensionDevelopmentHostWindow(L,M){const N=(0,X.$16b)(this.getWindows(),L);if(N)return this.D.reload(N,M.cli),N.focus(),[N];let T=M.cli["folder-uri"]||[],F=M.cli["file-uri"]||[],B=M.cli._;if(!B.length&&!T.length&&!F.length&&!M.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,ue=de?.workspace??de?.folderUri;ue&&(h.URI.isUri(ue)?ue.scheme===y.Schemas.file?B=[ue.fsPath]:T=[ue.toString()]:ue.configPath.scheme===y.Schemas.file?B=[(0,$.$kg)(ue.configPath)]:F=[ue.configPath.toString()])}let V=M.remoteAuthority;for(const de of L)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=h.URI.parse(de),he=(0,E.$Vk)(ue);he&&(V?(0,$.$Bg)(he,V)||this.s.error("more than one extension development path authority"):V=he)}B=B.filter(de=>{const ue=h.URI.file(de);return(0,X.$Z6b)(this.getWindows(),ue)?!1:(0,$.$Bg)((0,E.$Vk)(ue),V)}),T=T.filter(de=>{const ue=this.ab(de);return ue&&(0,X.$Z6b)(this.getWindows(),ue)?!1:ue?(0,$.$Bg)((0,E.$Vk)(ue),V):!1}),F=F.filter(de=>{const ue=this.ab(de);return ue&&(0,X.$Z6b)(this.getWindows(),ue)?!1:ue?(0,$.$Bg)((0,E.$Vk)(ue),V):!1}),M.cli._=B,M.cli["folder-uri"]=T,M.cli["file-uri"]=F;const ae={context:M.context,cli:M.cli,forceNewWindow:!0,forceEmpty:!B.length&&!T.length&&!F.length,userEnv:M.userEnv,noRecentEntry:!0,waitMarkerFileURI:M.waitMarkerFileURI,remoteAuthority:V,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile};return this.open(ae)}async kb(L){const M=this.G.getValue("window"),N=this.getLastActiveWindow(),T=N?.profile??this.C.defaultProfile;let F;!L.forceNewWindow&&!L.forceNewTabbedWindow&&(F=L.windowToUse||N,F&&F.focus());const B={...this.z.args,...L.cli,machineId:this.m,sqmId:this.n,windowId:-1,mainPid:process.pid,appRoot:this.z.appRoot,execPath:process.execPath,codeCachePath:this.z.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,f.$jc)(this.z.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.C.profilesHome,all:this.C.profiles,profile:T},homeDir:this.z.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.z.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.z.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.r,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.t.getLogLevel(),loggers:{window:[],global:this.t.getRegisteredLoggers()},logsPath:this.z.logsHome.with({scheme:y.Schemas.file}).fsPath,product:O.default,isInitialStartup:L.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)(),arch:(0,R.arch)()},zoomLevel:typeof M?.zoomLevel=="number"?M.zoomLevel:void 0,autoDetectHighContrast:M?.autoDetectHighContrast??!0,autoDetectColorScheme:M?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.O.getColorScheme(),policiesData:this.w.serialize(),continueOn:this.z.continueOn};if(F){const V=F.config;!B.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=V.extensionDevelopmentPath,B.extensionDevelopmentKind=V.extensionDevelopmentKind,B["enable-proposed-api"]=V["enable-proposed-api"],B.verbose=V.verbose,B["inspect-extensions"]=V["inspect-extensions"],B["inspect-brk-extensions"]=V["inspect-brk-extensions"],B.debugId=V.debugId,B.extensionEnvironment=V.extensionEnvironment,B["extensions-dir"]=V["extensions-dir"],B["disable-extensions"]=V["disable-extensions"]),B.loggers={global:B.loggers.global,window:V?.loggers.window??B.loggers.window}}else{const V=this.j.getNewWindowState(B);(0,v.mark)("code/willCreateCodeWindow");const ae=F=this.J.createInstance(U.$$6b,{state:V,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ae),this.h.set(ae.id,ae),this.a.fire(ae),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const de=new b.$Rc;de.add(ae.onDidSignalReady(()=>this.b.fire(ae))),de.add(u.Event.once(ae.onDidClose)(()=>this.nb(ae,de))),de.add(u.Event.once(ae.onDidDestroy)(()=>this.c.fire(ae))),de.add(ae.onDidTriggerSystemContextMenu(({x:he,y:ve})=>this.g.fire({window:ae,x:he,y:ve})));const ue=(0,d.$Kf)(ae.win?.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.D.reload(ae)),this.D.registerWindow(ae)}return B.windowId=F.id,F.isReady?this.D.unload(F,4).then(async V=>{V||await this.lb(F,B,L,T)}):await this.lb(F,B,L,T),F}async lb(L,M,N,T){if(M.extensionDevelopmentPath||((0,oe.$6h)(M.workspace)?M.backupPath=this.F.registerWorkspaceBackup({workspace:M.workspace,remoteAuthority:M.remoteAuthority}):(0,oe.$1h)(M.workspace)?M.backupPath=this.F.registerFolderBackup({folderUri:M.workspace.uri,remoteAuthority:M.remoteAuthority}):M.backupPath=this.F.registerEmptyWindowBackup({backupFolder:N.emptyWindowBackupInfo?.backupFolder??(0,se.$56b)().id,remoteAuthority:M.remoteAuthority})),this.C.isEnabled()){const F=M.workspace??(0,oe.$5h)(M.backupPath,!1),B=this.mb(N,F,T),V=B instanceof Promise?await B:B;M.profiles.profile=V,M.extensionDevelopmentPath||await this.C.setProfileForWorkspace(F,V)}L.load(M)}mb(L,M,N){return L.forceProfile?this.C.profiles.find(T=>T.name===L.forceProfile)??this.C.createNamedProfile(L.forceProfile):L.forceTempProfile?this.C.createTransientProfile():this.C.getProfileForWorkspace(M)??N}nb(L,M){this.h.delete(L.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),M.dispose()}getFocusedWindow(){const L=P.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.pb(this.getWindows())}ob(L){return this.pb(this.getWindows().filter(M=>(0,$.$Bg)(M.remoteAuthority,L)))}pb(L){return(0,z.$e7b)(L)}sendToFocused(L,...M){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,S.CancellationToken.None,...M)}sendToOpeningWindow(L,...M){this.B(u.Event.once(this.onDidSignalReadyWindow)(N=>{N.sendWhenReady(L,S.CancellationToken.None,...M)}))}sendToAll(L,M,N){for(const T of this.getWindows())N&&N.indexOf(T.id)>=0||T.sendWhenReady(L,S.CancellationToken.None,M)}getWindows(){return Array.from(this.h.values())}getWindowCount(){return this.h.size}getWindowById(L){return this.h.get(L)}getWindowByWebContents(L){const M=P.BrowserWindow.fromWebContents(L);if(M)return this.getWindowById(M.id)}};e.$d8b=Z,e.$d8b=Z=Ee([te(3,p.$$i),te(4,W.$86b),te(5,I.$FN),te(6,Q.$mn),te(7,r.$B6b),te(8,q.$J6b),te(9,l.$D6b),te(10,c.$U6b),te(11,i.$ki),te(12,ce.$L7b),te(13,Y.$66b),te(14,n.$Ph),te(15,o.$V6b),te(16,t.$_j),te(17,D.$X6b),te(18,K.$P6b)],Z)}),define(ie[307],ne([0,1,63,29,83,53]),function(J,e,P,A,s,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=void 0;let C=class{constructor(u,a,g,b){this.a=u,this.b=a,this.c=g,this.d=b,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(u,a){const g=this.b.getWindowById(u);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),a)}createUntitledWorkspace(u,a,g){return this.a.createUntitledWorkspace(a,g)}deleteUntitledWorkspace(u,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(u,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(u){return this.c.getRecentlyOpened()}addRecentlyOpened(u,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(u,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(u){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$f8b=C,e.$f8b=C=Ee([te(0,R.$66b),te(1,A.$b7b),te(2,s.$L7b),te(3,P.$U6b)],C)}),define(ie[308],ne([0,1,15,131,38,28,17,49,14,33,3,44,46,2,13,9,4,12,7,32,158,42,159,110,290,162,63,283,18,200,91,132,59,116,220,24,62,94,209,293,211,212,213,16,224,93,77,5,92,219,299,284,291,20,6,305,69,25,58,294,95,34,275,82,122,26,251,253,51,48,265,288,300,289,301,127,267,268,269,272,297,29,306,274,30,97,83,307,53,39,233,52,244,50,81,129,277,292,280,8,255,276,228,66,296,271,23,125,295,263,239,71,78,303]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k,c,i,o,r,t,n,l,p,O,D,E,I,j,U,z,X,x,oe,se,ce,Y,K,Q,q,W,G,H,Z,re,L,M,N,T,F,B,V,ae,de,ue,he,ve,be,ye,Ie,Te,me,we,_,le,ge,Oe,Ce,Le,Re,He,ze,ee,fe,$e,ke,De,Ne,je,Fe,Ve,Ge,Qe,Ze,Xe,it,nt,wt,bt,pt,yt,vt,kt,Et,rt,ht,St,Pt,It,ot,Ot,ft,at,Dt,Ct,ct,At,dt,Rt){"use strict";var lt;Object.defineProperty(e,"__esModule",{value:!0}),e.$y8b=void 0;let ut=class extends f.$Sc{static{lt=this}static{this.a={[v.Schemas.file]:"security.promptForLocalFileProtocolHandling",[v.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Se,Pe,Ae,pe,Me,Ue,Be,Je,qe,We,Ke,Ye){super(),this.g=Se,this.h=Pe,this.j=Ae,this.m=pe,this.n=Me,this.s=Ue,this.t=Be,this.u=Je,this.w=qe,this.y=We,this.z=Ke,this.C=Ye,this.D(),this.F()}D(){const Se=qe=>qe?.startsWith(`${v.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((qe,We,Ke,Ye)=>Se(Ye.requestingUrl)?Ke(Pe.has(We)):Ke(!1)),P.session.defaultSession.setPermissionCheckHandler((qe,We,Ke,Ye)=>Se(Ye.requestingUrl)?Pe.has(We):!1);const Ae=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),pe=qe=>{for(let We=qe;We;We=We.parent)if(We.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},Me=qe=>qe.resourceType==="xhr"||pe(qe.frame),Ue=qe=>{const We=qe.frame;if(!We||!this.b)return!1;const Ke=P.BrowserWindow.getAllWindows();for(const Ye of Ke)if(We.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Be=(qe,We)=>{if(qe.path!=="/index.html")return!0;const Ke=We.frame;if(!Ke||!this.b)return!1;for(const Ye of this.b.getWindows())if(Ye.win&&Ke.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((qe,We)=>{const Ke=d.URI.parse(qe.url);return Ke.scheme===v.Schemas.vscodeWebview&&!Be(Ke,qe)?(this.m.error("Blocked vscode-webview request",qe.url),We({cancel:!0})):Ke.scheme===v.Schemas.vscodeFileResource&&!Ue(qe)?(this.m.error("Blocked vscode-file request",qe.url),We({cancel:!0})):Ke.path.endsWith(".svg")&&!Ae.has(Ke.scheme)?We({cancel:!Me(qe)}):We({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((qe,We)=>{const Ke=qe.responseHeaders,Ye=Ke["content-type"]||Ke["Content-Type"];if(Ye&&Array.isArray(Ye)){const xe=d.URI.parse(qe.url);if(xe.path.endsWith(".svg")&&Ae.has(xe.scheme))return Ke["Content-Type"]=["image/svg+xml"],We({cancel:!1,responseHeaders:Ke});if(!xe.path.endsWith(v.Schemas.vscodeRemoteResource)&&Ye.some(et=>et.toLowerCase().includes("image/svg")))return We({cancel:!Me(qe)})}return We({cancel:!1})});const Je=P.session.defaultSession;typeof Je.setCodeCachePath=="function"&&this.s.codeCachePath&&Je.setCodeCachePath((0,m.$jc)(this.s.codeCachePath,"chrome")),w.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,A.disableUNCAccessRestrictions)():(0,A.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,u.setUnexpectedErrorHandler)(Ae=>this.H(Ae)),process.on("uncaughtException",Ae=>{(0,u.$Z)(Ae)||(0,u.$1)(Ae)}),process.on("unhandledRejection",Ae=>(0,u.$1)(Ae)),this.t.onWillShutdown(()=>this.dispose()),(0,k.$xT)(),P.app.on("accessibility-support-changed",(Ae,pe)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",pe)}),P.app.on("activate",async(Ae,pe)=>{this.m.trace("app#activate"),pe||await this.b?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(Ae,pe)=>{pe?.opener?.url.startsWith(`${v.Schemas.vscodeFileResource}://${v.$cg}/`)&&this.c?.registerWindow(pe),pe.on("will-navigate",Ue=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ue.preventDefault()}),pe.setWindowOpenHandler(Ue=>Ue.url==="about:blank"?(this.m.trace("webContents#setWindowOpenHandler: Allowing about:blank window to open"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ue.url}}`),this.f?.openExternal(void 0,Ue.url),{action:"deny"}))});let Se=[],Pe;P.app.on("open-file",(Ae,pe)=>{this.m.trace("app#open-file: ",pe),Ae.preventDefault(),Se.push((0,Fe.$ji)(pe)?{workspaceUri:d.URI.file(pe)}:{fileUri:d.URI.file(pe)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Se,gotoLineMode:!1,preferNewWindow:!0}),Se=[],Pe=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$wT.handle("vscode:getWindowId",Ae=>Promise.resolve(Ae.sender.id)),s.$wT.handle("vscode:fetchShellEnv",Ae=>{const pe=this.b?.getWindowByWebContents(Ae.sender);let Me,Ue;return pe?.config?(Me=pe.config,Ue={...process.env,...pe.config.userEnv}):(Me=this.s.args,Ue=process.env),this.X(Me,Ue,!1)}),s.$wT.handle("vscode:writeNlsFile",(Ae,pe,Me)=>{const Ue=this.G([pe]);if(!Ue||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Ue,C.$ce.fromString(Me))}),s.$wT.handle("vscode:readNlsFile",async(Ae,...pe)=>{const Me=this.G(pe);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Me)).value.toString()}),s.$wT.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),s.$wT.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),s.$wT.on("vscode:reloadWindow",Ae=>Ae.sender.reload())}G(Se){let Pe;for(const Ae of Se)typeof Ae=="string"&&(typeof Pe!="string"?Pe=Ae:Pe=(0,m.$jc)(Pe,Ae));if(!(typeof Pe!="string"||!(0,m.$ic)(Pe)||!(0,a.$Yf)(Pe,this.s.cachedLanguagesPath,!w.$l)))return d.URI.file(Pe)}H(Se){if(Se){const Pe={message:`[uncaught exception in main]: ${Se.message}`,stack:Se.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.m.error(`[uncaught exception in main]: ${Se}`),Se.stack&&this.m.error(Se.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Se=this.z.win32AppUserModelId;w.$j&&Se&&P.app.setAppUserModelId(Se);try{w.$k&&this.u.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.m.error(We)}const Pe=new i.$DT;this.t.onWillShutdown(We=>{We.reason===2&&Pe.dispose()}),this.m.trace("Resolving machine identifier...");const[Ae,pe]=await Promise.all([(0,ht.$n8b)(this.w,this.m),(0,ht.$o8b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcessReady:Me,sharedProcessClient:Ue}=this.P(Ae,pe),Be=await this.Q(Ae,pe,Me);this.B(Be.createInstance(r.$f7b)),this.B(Be.createInstance(kt.$j8b)),Be.invokeFunction(We=>this.R(We,Pe,Ue));const Je=await Be.invokeFunction(We=>this.I(We,Pe));this.J(Pe),this.t.phase=2,await Be.invokeFunction(We=>this.S(We,Je)),this.t.phase=3,this.U(),this.B(new rt.$7g(()=>{this.B((0,rt.$$g)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Se,Pe){const Ae=this.b=Se.get(De.$b7b),pe=Se.get(He.$kU),Me=this.f=Se.get(V.$z7b),Ue=Se.get(I.$V6b),Be=this;pe.registerHandler({async handleURL(xe,et){return Be.O(Ae,Ue,pe,xe,et)}});const Je=this.B(new je.$e8b({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),qe=new c.$yh(xe=>Je.getActiveClientId().then(et=>xe===et)),We=new ze.$87b(qe,this.m),Ke=Pe.getChannel("urlHandler",We);pe.registerHandler(new ze.$77b(Ke));const Ye=await this.L(Ae,Ue);return this.B(new fe.$97b(Ye?.urls,pe,Ae,this.s,this.z,this.m)),Ye}J(Se){const Pe=()=>({statusCode:404,data:"Not found"}),Ae=new At.$V(()=>Se.getChannel(ct.$v8b,new ct.$w8b));P.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(pe,Me)=>{const Ue=d.URI.parse(pe.url);if(!Ue.authority.startsWith("window:"))return Me(Pe());Ae.value.call(ct.$u8b,[Ue]).then(Be=>Me({...Be,data:Buffer.from(Be.body,"base64")}),Be=>{this.m.warn("error dispatching remote resource call",Be),Me({statusCode:500,data:String(Be)})})})}async L(Se,Pe){const Ae=this.s.args["open-url"]?this.s.args._urls||[]:[];Ae.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ae);const pe=global.getOpenUrls()||[];if(pe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",pe),Ae.length+pe.length===0)return;const Me=[...Ae,...pe].map(Je=>{try{return{uri:d.URI.parse(Je),originalUrl:Je}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Je);return}}),Ue=[],Be=[];for(const Je of Me){if(!Je)continue;if(await this.M(Je.uri,Se,Pe)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Je.uri.toString(!0));continue}const qe=this.N(Je.uri);qe?(this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Je.uri.toString(!0),qe),Ue.push(qe)):(this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Je.uri.toString(!0)),Be.push(Je))}return{urls:Be,openables:Ue}}async M(Se,Pe,Ae){if(Se.authority!==v.Schemas.file&&Se.authority!==v.Schemas.vscodeRemote||this.u.getValue(lt.a[Se.authority])===!1)return!1;const{response:Me,checkboxChecked:Ue}=await Ae.showMessageBox({type:"warning",buttons:[(0,t.localize)(0,null),(0,t.localize)(1,null)],message:(0,t.localize)(2,null,Se.authority===v.Schemas.file?(0,y.$vv)(Se,{os:w.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort),detail:(0,t.localize)(3,null),checkboxLabel:Se.authority===v.Schemas.file?(0,t.localize)(4,null):(0,t.localize)(5,null),cancelId:1});if(Me!==0)return!0;if(Ue){const Be={channel:"vscode:disablePromptForProtocolHandling",args:Se.authority===v.Schemas.file?"local":"remote"};Pe.sendToFocused(Be.channel,Be.args),Pe.sendToOpeningWindow(Be.channel,Be.args)}return!1}N(Se){if(Se.path){if(Se.authority===v.Schemas.file){const Pe=d.URI.file(Se.fsPath);return(0,Fe.$ji)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Se.authority===v.Schemas.vscodeRemote){const Pe=Se.path.indexOf(m.$gc.sep,1);if(Pe!==-1){const Ae=Se.path.substring(1,Pe),pe=Se.path.substring(Pe);let Me=Se.query;const Ue=new URLSearchParams(Se.query);Ue.get("windowId")==="_blank"&&(Ue.delete("windowId"),Me=Ue.toString());const Be=d.URI.from({scheme:v.Schemas.vscodeRemote,authority:Ae,path:pe,query:Me,fragment:Se.fragment});return(0,Fe.$ji)(pe)?{workspaceUri:Be}:/:[\d]+$/.test(pe)?{fileUri:Be}:{folderUri:Be}}}}}async O(Se,Pe,Ae,pe,Me){if(this.m.trace("app#handleProtocolUrl():",pe.toString(!0),Me),pe.scheme===this.z.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:d.URI.parse(pe.query).path,query:""})),await this.M(pe,Se,Pe))return this.m.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let Ue=!1;const Be=new URLSearchParams(pe.query);Be.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Be.delete("windowId"),pe=pe.with({query:Be.toString()}),Ue=!0):w.$k&&Se.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Ue=!0);const Je=Be.get("continueOn");Je!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Be.delete("continueOn"),pe=pe.with({query:Be.toString()}),this.s.continueOn=Je??void 0);const qe=this.N(pe);return qe?(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",qe,pe.toString(!0)),(0,ft.$Ob)(await Se.open({context:5,cli:{...this.s.args},urisToOpen:[qe],forceNewWindow:Ue,gotoLineMode:!0}))?.focus(),!0):Ue?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,ft.$Ob)(await Se.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.$Vk)(pe)}))?.ready(),Ae.open(pe,Me)):(this.m.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Me),!1)}P(Se,Pe){const Ae=this.B(this.j.createInstance(ue.$T7b,Se,Pe)),pe=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ue=await Ae.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$ET(Ue,"main")})();return{sharedProcessReady:(async()=>(await Ae.whenReady(),pe))(),sharedProcessClient:pe}}async Q(Se,Pe,Ae){const pe=new Z.$Oh;switch(process.platform){case"win32":pe.set(le.$wU,new G.$Nh(Re.$57b));break;case"linux":w.$m?pe.set(le.$wU,new G.$Nh(Le.$47b,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(le.$wU,new G.$Nh(Ce.$37b));break;case"darwin":pe.set(le.$wU,new G.$Nh(Oe.$27b));break}pe.set(De.$b7b,new G.$Nh(Ne.$d8b,[Se,Pe,this.h],!1)),pe.set(dt.$a7b,new G.$Nh(Rt.$x8b,void 0,!1));const Me=new I.$W6b(this.m,this.z);pe.set(I.$V6b,Me),pe.set(N.$F7b,new G.$Nh(N.$G7b,void 0,!1)),pe.set(E.$l7b,new G.$Nh(E.$m7b,void 0,!1)),pe.set(D.$rm,c.ProxyChannel.toService((0,c.$wh)(Ae.then(We=>We.getChannel("diagnostics"))))),pe.set(re.$mxb,new G.$Nh(L.$B7b,[this.h])),pe.set(j.$eU,new G.$Nh(U.$n7b)),pe.set(M.$C7b,new G.$Nh(M.$D7b)),pe.set(V.$z7b,new G.$Nh(V.$A7b,void 0,!1)),pe.set($e.$07b,new G.$Nh(ke.$_7b)),pe.set(B.$O7b,new G.$Nh(B.$P7b)),pe.set(oe.$o7b,new G.$Nh(se.$q7b)),pe.set(ye.$L6b,new G.$Nh(ye.$M6b)),pe.set(ye.$N6b,new G.$Nh(ye.$O6b));const Ue=new Dt.$t8b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Be=new Ct.$zr(Ue,this.u,this.m,this.n);pe.set(at.$ar,Be),w.$j?pe.set(ce.$r7b,new G.$Nh(Y.$s7b)):w.$k?pe.set(ce.$r7b,new G.$Nh(Y.$t7b)):w.$l&&pe.set(ce.$r7b,new G.$Nh(Y.$u7b));const Je=new l.$g7b(this.s,this.u,this.m,this.w);pe.set(n.$U6b,Je);const qe=new Ze.$76b(this.s,this.m,this.C,Je,Me);if(pe.set(Ze.$66b,qe),pe.set(Ve.$TU,new G.$Nh(Qe.$f8b,void 0,!1)),pe.set(Ge.$L7b,new G.$Nh(Ge.$M7b,void 0,!1)),pe.set(He.$kU,new G.$Nh(ee.$mU,void 0,!1)),(0,_.$vo)(this.z,this.s)){const We=(0,_.$Ao)(this.z,this.u),Ke=(0,c.$wh)(Ae.then(st=>st.getChannel("telemetryAppender"))),Ye=new me.$W7b(Ke),xe=(0,Ie.$lo)((0,R.release)(),(0,R.hostname)(),process.arch,this.z.commit,this.z.version,Se,Pe,We),et=(0,_.$Bo)(this.s),tt={appenders:[Ye],commonProperties:xe,piiPaths:et,sendErrorTelemetry:!0};pe.set(Te.$dl,new G.$Nh(we.$5q,[tt],!1))}else pe.set(Te.$dl,_.$po);return pe.set(pt.$yp,new G.$Nh(St.$MN,void 0,!0)),pe.set(yt.$Cp,new G.$Nh(vt.$i8b,void 0,!0)),pe.set(ot.$r8b,new G.$Nh(ot.$s8b,void 0,!0)),await rt.Promises.settled([Je.initialize(),qe.initialize()]),this.j.createChild(pe)}R(Se,Pe,Ae){const pe=this.B(new f.$Rc),Me=c.ProxyChannel.fromService(Se.get(N.$F7b),pe,{disableMarshalling:!0});this.g.registerChannel("launch",Me);const Ue=c.ProxyChannel.fromService(Se.get(E.$l7b),pe,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Ue);const Be=new it.$g8b(Se.get(Xe.$mn));Pe.registerChannel("policy",Be),Ae.then(_e=>_e.registerChannel("policy",Be));const Je=this.y.getProvider(v.Schemas.file);(0,$.$Jf)(Je instanceof W.$eq);const qe=new q.$v7b(Je,this.m,this.s);Pe.registerChannel(K.$vN,qe),Ae.then(_e=>_e.registerChannel(K.$vN,qe));const We=c.ProxyChannel.fromService(Se.get(nt.$J6b),pe);Pe.registerChannel("userDataProfiles",We),Ae.then(_e=>_e.registerChannel("userDataProfiles",We));const Ke=new wt.$Zq(Se.get(bt.$Wo));Ae.then(_e=>_e.registerChannel("request",Ke));const Ye=new ge.$X7b(Se.get(le.$wU));Pe.registerChannel("update",Ye);const xe=c.ProxyChannel.fromService(Se.get(re.$mxb),pe);Pe.registerChannel("issue",xe);const et=c.ProxyChannel.fromService(Se.get(j.$eU),pe);Pe.registerChannel("encryption",et);const tt=c.ProxyChannel.fromService(Se.get(he.$4k),pe);Pe.registerChannel("sign",tt);const st=c.ProxyChannel.fromService(Se.get(M.$C7b),pe);Pe.registerChannel("keyboardLayout",st),this.f=Se.get(V.$z7b);const gt=c.ProxyChannel.fromService(this.f,pe);Pe.registerChannel("nativeHost",gt),Ae.then(_e=>_e.registerChannel("nativeHost",gt));const Mt=c.ProxyChannel.fromService(Se.get(Ve.$TU),pe);Pe.registerChannel("workspaces",Mt);const jt=c.ProxyChannel.fromService(Se.get(B.$O7b),pe);Pe.registerChannel("menubar",jt);const Lt=c.ProxyChannel.fromService(Se.get(He.$kU),pe);Pe.registerChannel("url",Lt);const Ft=c.ProxyChannel.fromService(Se.get($e.$07b),pe);Pe.registerChannel("webview",Ft);const $t=this.B(new be.$U7b(this.m,Se.get(ye.$L6b)));Pe.registerChannel("storage",$t),Ae.then(_e=>_e.registerChannel("storage",$t));const Ut=this.B(new Et.$k8b(Se.get(ye.$L6b),Se.get(nt.$J6b),this.m));Ae.then(_e=>_e.registerChannel("profileStorageListener",Ut));const Nt=c.ProxyChannel.fromService(Se.get(at.$ar),pe);Pe.registerChannel(at.TerminalIpcChannels.LocalPty,Nt);const Wt=c.ProxyChannel.fromService(Se.get(ce.$r7b),pe);Pe.registerChannel("externalTerminal",Wt);const mt=new Pt.$p8b(Se.get(It.$86b));Pe.registerChannel("logger",mt),Ae.then(_e=>_e.registerChannel("logger",mt));const Tt=new O.$h7b(Se.get(De.$b7b));Pe.registerChannel("extensionhostdebugservice",Tt);const zt=c.ProxyChannel.fromService(Se.get(oe.$o7b),pe);Pe.registerChannel(oe.$p7b,zt);const Bt=c.ProxyChannel.fromService(Se.get(ot.$r8b),pe);Pe.registerChannel(Ot.$q8b,Bt)}async S(Se,Pe){const Ae=this.b=Se.get(De.$b7b);this.c=Se.get(dt.$a7b);const pe=(0,X.$Ol)(process.env)?0:4,Me=this.s.args;if(Pe){if(Pe.openables.length>0)return Ae.open({context:pe,cli:Me,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const tt of Pe.urls){const st=new URLSearchParams(tt.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:st.toString()}),Ae.open({context:pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ue=global.macOpenFiles,Be=Me._.length,Je=!!Me["folder-uri"],qe=!!Me["file-uri"],We=Me["skip-add-to-recently-opened"]===!0,Ke=Me.wait&&Me.waitMarkerFilePath?d.URI.file(Me.waitMarkerFilePath):void 0,Ye=Me.remote||void 0,xe=Me.profile,et=Me["profile-temp"];if(!Be&&!Je&&!qe){if(Me["new-window"]||xe||et)return Ae.open({context:pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:We,waitMarkerFileURI:Ke,initialStartup:!0,remoteAuthority:Ye,forceProfile:xe,forceTempProfile:et});if(Ue.length)return Ae.open({context:1,cli:Me,urisToOpen:Ue.map(tt=>(0,Fe.$ji)(tt)?{workspaceUri:d.URI.file(tt)}:{fileUri:d.URI.file(tt)}),noRecentEntry:We,waitMarkerFileURI:Ke,initialStartup:!0})}return Ae.open({context:pe,cli:Me,forceNewWindow:Me["new-window"]||!Be&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:We,waitMarkerFileURI:Ke,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:xe,forceTempProfile:et})}U(){this.W(),P.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Se,Pe)=>{Pe({url:Se.url.replace(/^vscode-remote-resource:/,"http:"),method:Se.method})}),this.X(this.s.args,process.env,!0),this.Y(),w.$k&&P.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Se=this.z.win32MutexName;if(w.$j&&Se)try{const Pe=await new Promise((pe,Me)=>{J(["@vscode/windows-mutex"],pe,Me)}),Ae=new Pe.Mutex(Se);g.Event.once(this.t.onWillShutdown)(()=>Ae.release())}catch(Pe){this.m.error(Pe)}}async X(Se,Pe,Ae){try{return await(0,x.$Ul)(this.u,this.m,Se,Pe)}catch(pe){const Me=(0,S.$Bi)(pe);Ae?this.b?.sendToFocused("vscode:showResolveShellEnvError",Me):this.m.error(Me)}return{}}async Y(){try{const Pe=(await this.y.readFile(this.s.argvResource)).value.toString(),Ae=JSON.parse((0,b.$6m)(Pe)),Me=(0,_.$xo)(this.u)>=1;if(Ae["enable-crash-reporter"]===void 0){const Ue=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.$fg)()}"`,"}"],Be=Pe.substring(0,Pe.length-2).concat(`,
`,Ue.join(`
`));await this.y.writeFile(this.s.argvResource,C.$ce.fromString(Be))}else{const Ue=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);Ue!==Pe&&await this.y.writeFile(this.s.argvResource,C.$ce.fromString(Ue))}}catch(Se){this.m.error(Se)}}};e.$y8b=ut,e.$y8b=ut=lt=Ee([te(2,H.$Ph),te(3,F.$$i),te(4,F.$_i),te(5,z.$B6b),te(6,T.$D6b),te(7,p.$ki),te(8,ve.$FN),te(9,Q.$_j),te(10,ae.$qj),te(11,nt.$J6b)],ut)}),define(ie[314],ne([0,1,15,45,7,23,8,49,14,33,3,46,13,9,65,4,35,27,21,42,99,308,10,18,238,250,24,62,202,16,222,93,77,218,92,20,225,6,79,25,80,278,126,287,50,286,95,249,34,51,67,52,39,234,232,2,40,266,66,227,115,121,270,264]),function(J,e,P,A,s,R,C,S,u,a,g,b,y,f,v,m,w,$,d,h,k,c,i,o,r,t,n,l,p,O,D,E,I,j,U,z,X,x,oe,se,ce,Y,K,Q,q,W,G,H,Z,re,L,M,N,T,F,B,V,ae,de,ue,he,ve,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.a()}catch(me){console.error(me.message),P.app.exit(1)}}async a(){(0,u.setUnexpectedErrorHandler)(Re=>console.error(Re));const[me,we,_,le,ge,Oe,Ce,Le]=this.b();try{try{await this.d(_,Le,le,ge,Ce)}catch(Re){throw this.f(_,Ce,Re),Re}await me.invokeFunction(async Re=>{const He=Re.get(x.$$i),ze=Re.get(z.$D6b),ee=Re.get(O.$_j),fe=Re.get(x.$_i),$e=await this.e(He,_,ze,me,Ce,!0);return d.Promises.writeFile(_.mainLockfile,String(process.pid)).catch(ke=>{He.warn(`app#startup(): Error writing main lockfile: ${ke.stack}`)}),Oe.logger=fe.createLogger("main",{name:(0,i.localize)(0,null)}),g.Event.once(ze.onWillShutdown)(ke=>{ee.dispose(),le.dispose(),ke.join("instanceLockfile",d.Promises.unlink(_.mainLockfile).catch(()=>{}))}),me.createInstance(c.$y8b,$e,we).startup()})}catch(Re){me.invokeFunction(this.i,Re)}}b(){const me=new U.$Oh,we=new B.$Rc;process.once("exit",()=>we.dispose());const _={_serviceBrand:void 0,...oe.default};me.set(se.$qj,_);const le=new n.$C6b(this.j(),_),ge=this.c(le);me.set(n.$B6b,le);const Oe=new de.$96b((0,x.$mj)(le),le.logsHome);me.set(de.$86b,Oe);const Ce=new X.$l4b(Oe.getLogLevel()),Le=we.add(new ue.$NN(Ce,[new x.$fj(Oe.getLogLevel())]));me.set(x.$$i,Le);const Re=new D.$Rp(Le);me.set(O.$_j,Re);const He=new E.$eq(Le);Re.registerProvider(y.Schemas.file,He);const ze=new ae.$Dr(Re);me.set(V.$Jk,ze);const ee=new ve.$IN(1,le,Le,Re);me.set(Z.$EN,ee),me.set(Z.$FN,ee);const fe=new M.$K6b(ee,ze,le,Re,Le);me.set(M.$J6b,fe),Re.registerProvider(y.Schemas.vscodeUserData,new be.$J8b(y.Schemas.file,He,y.Schemas.vscodeUserData,fe,ze,Le));const $e=m.$j&&_.win32RegValueName?we.add(new T.$H8b(Le,_.win32RegValueName)):le.policyFile?we.add(new F.$I8b(le.policyFile,Re,Le)):new N.$on;me.set(N.$mn,$e);const ke=new r.$On(fe.defaultProfile.settingsResource,Re,$e,Le);return me.set(o.$ki,ke),me.set(z.$D6b,new I.$Nh(z.$E6b,void 0,!1)),me.set(q.$Wo,new I.$Nh(W.$F8b,void 0,!0)),me.set(L.$P6b,new I.$Nh(L.$Q6b)),me.set(G.$4k,new I.$Nh(H.$G8b,void 0,!1)),me.set(K.$bv,new I.$Nh(Q.$D8b)),me.set(ce.$X6b,new Y.$A8b(le,fe,Le)),[new j.$hq(me,!0),ge,le,ke,ee,Ce,_,fe]}c(me){const we={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(_=>{const le=process.env[_];typeof le=="string"&&(we[_]=le)}),Object.assign(process.env,we),we}async d(me,we,_,le,ge){await C.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsHome.with({scheme:y.Schemas.file}).fsPath,we.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,me.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,me.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,me.backupHome].map(Oe=>Oe?d.Promises.mkdir(Oe,{recursive:!0}):void 0)),le.init(),_.initialize()]),we.init()}async e(me,we,_,le,ge,Oe){let Ce;try{(0,v.mark)("code/willStartMainServer"),Ce=await(0,k.$Lh)(we.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),g.Event.once(_.onWillShutdown)(()=>Ce.dispose())}catch(Le){if(Le.code!=="EADDRINUSE")throw this.f(we,ge,Le),Le;let Re;try{Re=await(0,k.$Mh)(we.mainIPCHandle,"main")}catch(fe){if(!Oe||m.$j||fe.code!=="ECONNREFUSED")throw fe.code==="EPERM"&&this.g((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),fe;try{(0,A.unlinkSync)(we.mainIPCHandle)}catch($e){throw me.warn("Could not delete obsolete instance handle",$e),$e}return this.e(me,we,_,le,ge,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const fe=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw me.error(fe),Re.dispose(),new Error(fe)}let He;!we.args.wait&&!we.args.status&&(He=setTimeout(()=>{this.g((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const ze=h.ProxyChannel.toService(Re.getChannel("launch"),{disableMarshalling:!0}),ee=h.ProxyChannel.toService(Re.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return le.invokeFunction(async()=>{const fe=new t.$Kr(re.$po,ge),$e=await ee.getMainDiagnostics(),ke=await ee.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),De=await fe.getDiagnostics($e,ke);throw console.log(De),new u.$ab});throw m.$j&&await this.h(ze,me),me.trace("Sending env to running instance..."),await ze.start(we.args,process.env),Re.dispose(),He&&clearTimeout(He),new u.$ab("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new u.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}f(me,we,_){if(_.code==="EACCES"||_.code==="EPERM"){const le=(0,R.$Hb)([me.userDataPath,me.extensionsPath,k.$Hh]).map(ge=>(0,b.$vv)(s.URI.file(ge),{os:m.OS,tildify:me}));this.g((0,i.localize)(6,null),(0,i.localize)(7,null,(0,S.$Bi)(_),le.join(`
`)),we)}}g(me,we,_){P.dialog.showMessageBoxSync((0,he.$Jv)({type:"warning",buttons:[(0,i.localize)(8,null)],message:me,detail:we},_).options)}async h(me,we){if(m.$j){const _=await me.getMainProcessId();we.trace("Sending some foreground love to the running instance:",_);try{(await new Promise((le,ge)=>{J(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(_)}catch(le){we.error(le)}}}i(me,we){const _=me.get(x.$$i),le=me.get(z.$D6b);let ge=0;we&&(we.isExpected?we.message&&_.trace(we.message):(ge=1,we.stack?_.error(we.stack):_.error(`Startup error: ${we.toString()}`))),le.kill(ge)}j(){const me=this.k((0,l.$Ll)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const we=(0,p.$z8b)(me.verbose);we&&((0,l.$Nl)(process.argv,"--waitMarkerFilePath",we),me.waitMarkerFilePath=we)}return me}k(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const we=this.l(me._,me.goto);me._=we}return me}l(me,we){const _=(0,w.cwd)(),le=me.map(Ce=>{let Le=String(Ce),Re;we&&(Re=(0,a.$6f)(Le),Le=Re.path),Le&&(Le=this.m(_,Le));const He=(0,a.$1f)(Le,_),ze=(0,f.$nc)(He);return ze&&!(0,a.$Wf)(ze)?null:we&&Re?(Re.path=He,this.n(Re)):He}),ge=m.$j||m.$k,Oe=(0,R.$Mb)(le,Ce=>Ce&&ge?Ce.toLowerCase():Ce||"");return(0,R.$Hb)(Oe)}m(me,we){return m.$j&&(we=(0,$.$Le)(we,'"')),we=(0,$.$Je)((0,$.$Je)(we," "),"	"),m.$j&&(we=(0,f.$kc)(me,we),we=(0,$.$Le)(we,".")),we}n(me){const we=[me.path];return typeof me.line=="number"&&we.push(String(me.line)),typeof me.column=="number"&&we.push(String(me.column)),we.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/35419fc016b8d3d5dbc59aa11a0be957b0897309/core/vs/code/electron-main/main.js.map
