/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],I=0,N=te.length;I<N;I++)e[I]=oe[te[I]];return e};define(oe[123],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class I{static get(){const L=new Map,A=new Map,O=new Map,R=new Map;function k(c,$){c.has($.detail)||c.set($.detail,-$.timestamp)}function g(c,$){const p=c.get($.detail);p&&(p>=0||c.set($.detail,p+$.timestamp))}let C=[];typeof te=="function"&&typeof te.getStats=="function"&&(C=te.getStats().slice(0).sort((c,$)=>c.timestamp-$.timestamp));for(const c of C)switch(c.type){case 10:k(L,c);break;case 11:case 12:g(L,c);break;case 21:k(A,c);break;case 22:g(A,c);break;case 33:k(O,c);break;case 34:g(O,c);break;case 31:k(R,c);break;case 32:g(R,c);break}let S=0;O.forEach(c=>S+=c);function b(c){const $=[];return c.forEach((p,y)=>$.push([y,p])),$}return{amdLoad:b(L),amdInvoke:b(A),nodeRequire:b(O),nodeEval:b(R),nodeRequireTotal:S}}static toMarkdownTable(L,A){let O="";const R=[];return L.forEach((k,g)=>{R[g]=k.length}),A.forEach(k=>{k.forEach((g,C)=>{typeof g>"u"&&(g=k[C]="-");const S=g.toString().length;R[C]=Math.max(S,R[C])})}),L.forEach((k,g)=>{O+=`| ${k+" ".repeat(R[g]-k.toString().length)} `}),O+=`|
`,L.forEach((k,g)=>{O+=`| ${"-".repeat(R[g])} `}),O+=`|
`,A.forEach(k=>{k.forEach((g,C)=>{typeof g<"u"&&(O+=`| ${g+" ".repeat(R[C]-g.toString().length)} `)}),O+=`|
`}),O}}e.$U=I}),define(oe[124],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function I(p,y,h){const f=N(p,y);if(f!==-1)return p[f]}e.$fb=I;function N(p,y,h=p.length-1){for(let f=h;f>=0;f--){const u=p[f];if(y(u))return f}return-1}e.$gb=N;function L(p,y){const h=A(p,y);return h===-1?void 0:p[h]}e.$hb=L;function A(p,y,h=0,f=p.length){let u=h,d=f;for(;u<d;){const E=Math.floor((u+d)/2);y(p[E])?u=E+1:d=E}return u-1}e.$ib=A;function O(p,y){const h=R(p,y);return h===p.length?void 0:p[h]}e.$jb=O;function R(p,y,h=0,f=p.length){let u=h,d=f;for(;u<d;){const E=Math.floor((u+d)/2);y(p[E])?d=E:u=E+1}return u}e.$kb=R;function k(p,y,h=0,f=p.length){const u=R(p,y,h,f);return u===p.length?-1:u}e.$lb=k;class g{static{this.assertInvariants=!1}constructor(y){this.e=y,this.c=0}findLastMonotonous(y){if(g.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!y(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=y}const h=A(this.e,y,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$mb=g;function C(p,y){if(p.length===0)return;let h=p[0];for(let f=1;f<p.length;f++){const u=p[f];y(u,h)>0&&(h=u)}return h}e.$nb=C;function S(p,y){if(p.length===0)return;let h=p[0];for(let f=1;f<p.length;f++){const u=p[f];y(u,h)>=0&&(h=u)}return h}e.$ob=S;function b(p,y){return C(p,(h,f)=>-y(h,f))}e.$pb=b;function c(p,y){if(p.length===0)return-1;let h=0;for(let f=1;f<p.length;f++){const u=p[f];y(u,p[h])>0&&(h=f)}return h}e.$qb=c;function $(p,y){for(const h of p){const f=y(h);if(f!==void 0)return f}}e.$rb=$}),define(oe[125],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function I(O,R){const k=Object.create(null);for(const g of O){const C=R(g);let S=k[C];S||(S=k[C]=[]),S.push(g)}return k}e.$J=I;function N(O,R){const k=[],g=[];for(const C of O)R.has(C)||k.push(C);for(const C of R)O.has(C)||g.push(C);return{removed:k,added:g}}e.$K=N;function L(O,R){const k=[],g=[];for(const[C,S]of O)R.has(C)||k.push(S);for(const[C,S]of R)O.has(C)||g.push(S);return{removed:k,added:g}}e.$L=L;function A(O,R){const k=new Set;for(const g of R)O.has(g)&&k.add(g);return k}e.$M=A}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function I(O){return(R,k,g)=>{let C=null,S=null;if(typeof g.value=="function"?(C="value",S=g.value):typeof g.get=="function"&&(C="get",S=g.get),!S)throw new Error("not supported");g[C]=O(S,k)}}function N(O,R,k){let g=null,C=null;if(typeof k.value=="function"?(g="value",C=k.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(g="get",C=k.get),!C)throw new Error("not supported");const S=`$memoize$${R}`;k[g]=function(...b){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,b)}),this[S]}}e.$ih=N;function L(O,R,k){return I((g,C)=>{const S=`$debounce$${C}`,b=`$debounce$result$${C}`;return function(...c){this[b]||(this[b]=k?k():void 0),clearTimeout(this[S]),R&&(this[b]=R(this[b],...c),c=[this[b]]),this[S]=setTimeout(()=>{g.apply(this,c),this[b]=k?k():void 0},O)}})}e.$jh=L;function A(O,R,k){return I((g,C)=>{const S=`$throttle$timer$${C}`,b=`$throttle$result$${C}`,c=`$throttle$lastRun$${C}`,$=`$throttle$pending$${C}`;return function(...p){if(this[b]||(this[b]=k?k():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),R&&(this[b]=R(this[b],...p)),this[$])return;const y=this[c]+O;y<=Date.now()?(this[c]=Date.now(),g.apply(this,[this[b]]),this[b]=k?k():void 0):(this[$]=!0,this[S]=setTimeout(()=>{this[$]=!1,this[c]=Date.now(),g.apply(this,[this[b]]),this[b]=k?k():void 0},y-Date.now()))}})}e.$kh=A}),define(oe[7],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class I{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?u.isErrorNoTelemetry(s)?new u(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(o=>{o(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$W=I,e.$X=new I;function N(E){e.$X.setUnexpectedErrorHandler(E)}e.setUnexpectedErrorHandler=N;function L(E){if(!E||typeof E!="object")return!1;const s=E;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.$Z=L;function A(E){g(E)||e.$X.onUnexpectedError(E)}e.$1=A;function O(E){g(E)||e.$X.onUnexpectedExternalError(E)}e.$2=O;function R(E){if(E instanceof Error){const{name:s,message:o}=E,n=E.stacktrace||E.stack;return{$isError:!0,name:s,message:o,stack:n,noTelemetry:u.isErrorNoTelemetry(E)}}return E}e.$3=R;const k="Canceled";function g(E){return E instanceof C?!0:E instanceof Error&&E.name===k&&E.message===k}e.$4=g;class C extends Error{constructor(){super(k),this.name=this.message}}e.$5=C;function S(){const E=new Error(k);return E.name=E.message,E}e.$6=S;function b(E){return E?new Error(`Illegal argument: ${E}`):new Error("Illegal argument")}e.$7=b;function c(E){return E?new Error(`Illegal state: ${E}`):new Error("Illegal state")}e.$8=c;class $ extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=$;function p(E){return E?E.message?E.message:E.stack?E.stack.split(`
`)[0]:String(E):"Error"}e.$0=p;class y extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$$=y;class h extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$_=h;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class u extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof u)return s;const o=new u;return o.message=s.message,o.stack=s.stack,o}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$bb=u;class d extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$cb=d}),define(oe[18],ae([0,1,7,124]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function L(F,H=0){return F[F.length-(1+H)]}e.$sb=L;function A(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$tb=A;function O(F,H,J=(re,ce)=>re===ce){if(F===H)return!0;if(!F||!H||F.length!==H.length)return!1;for(let re=0,ce=F.length;re<ce;re++)if(!J(F[re],H[re]))return!1;return!0}e.$ub=O;function R(F,H){const J=F.length-1;H<J&&(F[H]=F[J]),F.pop()}e.$vb=R;function k(F,H,J){return g(F.length,re=>J(F[re],H))}e.$wb=k;function g(F,H){let J=0,re=F-1;for(;J<=re;){const ce=(J+re)/2|0,ue=H(ce);if(ue<0)J=ce+1;else if(ue>0)re=ce-1;else return ce}return-(J+1)}e.$xb=g;function C(F,H,J){if(F=F|0,F>=H.length)throw new TypeError("invalid index");const re=H[Math.floor(H.length*Math.random())],ce=[],ue=[],he=[];for(const $e of H){const de=J($e,re);de<0?ce.push($e):de>0?ue.push($e):he.push($e)}return F<ce.length?C(F,ce,J):F<ce.length+he.length?he[0]:C(F-(ce.length+he.length),ue,J)}e.$yb=C;function S(F,H){const J=[];let re;for(const ce of F.slice(0).sort(H))!re||H(re[0],ce)!==0?(re=[ce],J.push(re)):re.push(ce);return J}e.$zb=S;function*b(F,H){let J,re;for(const ce of F)re!==void 0&&H(re,ce)?J.push(ce):(J&&(yield J),J=[ce]),re=ce;J&&(yield J)}e.$Ab=b;function c(F,H){for(let J=0;J<=F.length;J++)H(J===0?void 0:F[J-1],J===F.length?void 0:F[J])}e.$Bb=c;function $(F,H){for(let J=0;J<F.length;J++)H(J===0?void 0:F[J-1],F[J],J+1===F.length?void 0:F[J+1])}e.$Cb=$;function p(F,H,J){const re=[];function ce($e,de,we){if(de===0&&we.length===0)return;const ve=re[re.length-1];ve&&ve.start+ve.deleteCount===$e?(ve.deleteCount+=de,ve.toInsert.push(...we)):re.push({start:$e,deleteCount:de,toInsert:we})}let ue=0,he=0;for(;;){if(ue===F.length){ce(ue,0,H.slice(he));break}if(he===H.length){ce(ue,F.length-ue,[]);break}const $e=F[ue],de=H[he],we=J($e,de);we===0?(ue+=1,he+=1):we<0?(ce(ue,1,[]),ue+=1):we>0&&(ce(ue,0,[de]),he+=1)}return re}e.$Db=p;function y(F,H,J){const re=p(F,H,J),ce=[],ue=[];for(const he of re)ce.push(...F.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:ce,added:ue}}e.$Eb=y;function h(F,H,J){if(J===0)return[];const re=F.slice(0,J).sort(H);return u(F,H,re,J,F.length),re}e.top=h;function f(F,H,J,re,ce){return J===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const $e=F.length,de=F.slice(0,J).sort(H);for(let we=J,ve=Math.min(J+re,$e);we<$e;we=ve,ve=Math.min(ve+re,$e)){if(we>J&&await new Promise(Oe=>setTimeout(Oe)),ce&&ce.isCancellationRequested)throw new I.$5;u(F,H,de,we,ve)}return de})().then(ue,he)})}e.$Gb=f;function u(F,H,J,re,ce){for(const ue=J.length;re<ce;re++){const he=F[re];if(H(he,J[ue-1])<0){J.pop();const $e=(0,N.$kb)(J,de=>H(he,de)<0);J.splice($e,0,he)}}}function d(F){return F.filter(H=>!!H)}e.$Hb=d;function E(F){let H=0;for(let J=0;J<F.length;J++)F[J]&&(F[H]=F[J],H+=1);F.length=H}e.$Ib=E;function s(F,H,J){F.splice(J,0,F.splice(H,1)[0])}e.$Jb=s;function o(F){return!Array.isArray(F)||F.length===0}e.$Kb=o;function n(F){return Array.isArray(F)&&F.length>0}e.$Lb=n;function i(F,H=J=>J){const J=new Set;return F.filter(re=>{const ce=H(re);return J.has(ce)?!1:(J.add(ce),!0)})}e.$Mb=i;function t(F){const H=new Set;return J=>{const re=F(J);return H.has(re)?!1:(H.add(re),!0)}}e.$Nb=t;function r(F,H){return F.length>0?F[0]:H}e.$Ob=r;function a(F,H){return F.length>0?F[F.length-1]:H}e.$Pb=a;function v(F,H,J=(re,ce)=>re===ce){let re=0;for(let ce=0,ue=Math.min(F.length,H.length);ce<ue&&J(F[ce],H[ce]);ce++)re++;return re}e.$Qb=v;function w(F){return[].concat(...F)}e.$Rb=w;function l(F,H){let J=typeof H=="number"?F:0;typeof H=="number"?J=F:(J=0,H=F);const re=[];if(J<=H)for(let ce=J;ce<H;ce++)re.push(ce);else for(let ce=J;ce>H;ce--)re.push(ce);return re}e.$Sb=l;function m(F,H,J){return F.reduce((re,ce)=>(re[H(ce)]=J?J(ce):ce,re),Object.create(null))}e.$Tb=m;function D(F,H){return F.push(H),()=>T(F,H)}e.$Ub=D;function T(F,H){const J=F.indexOf(H);if(J>-1)return F.splice(J,1),H}e.$Vb=T;function z(F,H,J){const re=F.slice(0,H),ce=F.slice(H);return re.concat(J,ce)}e.$Wb=z;function U(F,H){let J;if(typeof H=="number"){let re=H;J=()=>{const ce=Math.sin(re++)*179426549;return ce-Math.floor(ce)}}else J=Math.random;for(let re=F.length-1;re>0;re-=1){const ce=Math.floor(J()*(re+1)),ue=F[re];F[re]=F[ce],F[ce]=ue}}e.$Xb=U;function B(F,H){const J=F.indexOf(H);J>-1&&(F.splice(J,1),F.unshift(H))}e.$Yb=B;function Z(F,H){const J=F.indexOf(H);J>-1&&(F.splice(J,1),F.push(H))}e.$Zb=Z;function Q(F,H){for(const J of H)F.push(J)}e.$1b=Q;function x(F,H){return Array.isArray(F)?F.map(H):H(F)}e.$2b=x;function W(F){return Array.isArray(F)?F:[F]}e.$3b=W;function X(F){return F[Math.floor(Math.random()*F.length)]}e.$4b=X;function G(F,H,J){const re=ee(F,H),ce=F.length,ue=J.length;F.length=ce+ue;for(let he=ce-1;he>=re;he--)F[he+ue]=F[he];for(let he=0;he<ue;he++)F[he+re]=J[he]}e.$5b=G;function V(F,H,J,re){const ce=ee(F,H);let ue=F.splice(ce,J);return ue===void 0&&(ue=[]),G(F,ce,re),ue}e.$6b=V;function ee(F,H){return H<0?Math.max(H+F.length,0):Math.min(H,F.length)}var ie;(function(F){function H(ue){return ue<0}F.isLessThan=H;function J(ue){return ue<=0}F.isLessThanOrEqual=J;function re(ue){return ue>0}F.isGreaterThan=re;function ce(ue){return ue===0}F.isNeitherLessOrGreaterThan=ce,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function _(F,H){return(J,re)=>H(F(J),F(re))}e.$7b=_;function ne(...F){return(H,J)=>{for(const re of F){const ce=re(H,J);if(!ie.isNeitherLessOrGreaterThan(ce))return ce}return ie.neitherLessOrGreaterThan}}e.$8b=ne;const K=(F,H)=>F-H;e.$9b=K;const q=(F,H)=>(0,e.$9b)(F?1:0,H?1:0);e.$0b=q;function P(F){return(H,J)=>-F(H,J)}e.$$b=P;class j{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let J=this.c;for(;J<this.g.length&&H(this.g[J]);)J++;const re=J===this.c?null:this.g.slice(this.c,J);return this.c=J,re}takeFromEndWhile(H){let J=this.d;for(;J>=0&&H(this.g[J]);)J--;const re=J===this.d?null:this.g.slice(J+1,this.d+1);return this.d=J,re}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const J=this.g.slice(this.c,this.c+H);return this.c+=H,J}}e.$_b=j;class M{static{this.empty=new M(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(J=>(H(J),!0))}toArray(){const H=[];return this.iterate(J=>(H.push(J),!0)),H}filter(H){return new M(J=>this.iterate(re=>H(re)?J(re):!0))}map(H){return new M(J=>this.iterate(re=>J(H(re))))}some(H){let J=!1;return this.iterate(re=>(J=H(re),!J)),J}findFirst(H){let J;return this.iterate(re=>H(re)?(J=re,!1):!0),J}findLast(H){let J;return this.iterate(re=>(H(re)&&(J=re),!0)),J}findLastMaxBy(H){let J,re=!0;return this.iterate(ce=>((re||ie.isGreaterThan(H(ce,J)))&&(re=!1,J=ce),!0)),J}}e.$ac=M}),define(oe[126],ae([0,1,7]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function N(k,g){if(!k)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=N;function L(k,g="Unreachable"){throw new Error(g)}e.$4c=L;function A(k){if(!k)throw new I.$cb("Assertion Failed")}e.$5c=A;function O(k){if(!k()){debugger;k(),(0,I.$1)(new I.$cb("Assertion Failed"))}}e.$6c=O;function R(k,g){let C=0;for(;C<k.length-1;){const S=k[C],b=k[C+1];if(!g(S,b))return!1;C++}return!0}e.$7c=R}),define(oe[85],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function I(N){const L=this;let A=!1,O;return function(){return A||(A=!0,O=N.apply(L,arguments)),O}}e.$db=I}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(N){function L(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}N.is=L;const A=Object.freeze([]);function O(){return A}N.empty=O;function*R(E){yield E}N.single=R;function k(E){return L(E)?E:R(E)}N.wrap=k;function g(E){return E||A}N.from=g;function*C(E){for(let s=E.length-1;s>=0;s--)yield E[s]}N.reverse=C;function S(E){return!E||E[Symbol.iterator]().next().done===!0}N.isEmpty=S;function b(E){return E[Symbol.iterator]().next().value}N.first=b;function c(E,s){for(const o of E)if(s(o))return!0;return!1}N.some=c;function $(E,s){for(const o of E)if(s(o))return o}N.find=$;function*p(E,s){for(const o of E)s(o)&&(yield o)}N.filter=p;function*y(E,s){let o=0;for(const n of E)yield s(n,o++)}N.map=y;function*h(...E){for(const s of E)for(const o of s)yield o}N.concat=h;function f(E,s,o){let n=o;for(const i of E)n=s(n,i);return n}N.reduce=f;function*u(E,s,o=E.length){for(s<0&&(s+=E.length),o<0?o+=E.length:o>E.length&&(o=E.length);s<o;s++)yield E[s]}N.slice=u;function d(E,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,E];const n=E[Symbol.iterator]();for(let i=0;i<s;i++){const t=n.next();if(t.done)return[o,N.empty()];o.push(t.value)}return[o,{[Symbol.iterator](){return n}}]}N.consume=d})(I||(e.Iterable=I={}))}),define(oe[35],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var N;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(s,o=!1){let n=0;const i=s.length;let t="",r=0,a=16,v=0;function w(B){let Z=0,Q=0;for(;Z<B;){const x=s.charCodeAt(n);if(x>=48&&x<=57)Q=Q*16+x-48;else if(x>=65&&x<=70)Q=Q*16+x-65+10;else if(x>=97&&x<=102)Q=Q*16+x-97+10;else break;n++,Z++}return Z<B&&(Q=-1),Q}function l(B){n=B,t="",r=0,a=16,v=0}function m(){const B=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&g(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&g(s.charCodeAt(n)))for(n++;n<s.length&&g(s.charCodeAt(n));)n++;else return v=3,s.substring(B,n);let Z=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&g(s.charCodeAt(n))){for(n++;n<s.length&&g(s.charCodeAt(n));)n++;Z=n}else v=3;return s.substring(B,Z)}function D(){let B="",Z=n;for(;;){if(n>=i){B+=s.substring(Z,n),v=2;break}const Q=s.charCodeAt(n);if(Q===34){B+=s.substring(Z,n),n++;break}if(Q===92){if(B+=s.substring(Z,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const W=w(4);W>=0?B+=String.fromCharCode(W):v=4;break}default:v=5}Z=n;continue}if(Q>=0&&Q<=31)if(k(Q)){B+=s.substring(Z,n),v=2;break}else v=6;n++}return B}function T(){if(t="",v=0,r=n,n>=i)return r=i,a=17;let B=s.charCodeAt(n);if(R(B)){do n++,t+=String.fromCharCode(B),B=s.charCodeAt(n);while(R(B));return a=15}if(k(B))return n++,t+=String.fromCharCode(B),B===13&&s.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(B){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=D(),a=10;case 47:{const Z=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!k(s.charCodeAt(n));)n++;return t=s.substring(Z,n),a=12}if(s.charCodeAt(n+1)===42){n+=2;const Q=i-1;let x=!1;for(;n<Q;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=s.substring(Z,n),a=13}return t+=String.fromCharCode(B),n++,a=16}case 45:if(t+=String.fromCharCode(B),n++,n===i||!g(s.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=m(),a=11;default:for(;n<i&&z(B);)n++,B=s.charCodeAt(n);if(r!==n){switch(t=s.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(B),n++,a=16}}function z(B){if(R(B)||k(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=T();while(B>=12&&B<=15);return B}return{setPosition:l,getPosition:()=>n,scan:o?U:T,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$Vm=O;function R(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function k(s){return s===10||s===13||s===8232||s===8233}function g(s){return s>=48&&s<=57}var C;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(C||(C={}));function S(s,o){const n=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(w,l,m,D){r.value=w,r.offset=l,r.length=m,r.type=D,r.colonOffset=void 0,t=r}try{u(s,{onObjectBegin:(w,l)=>{if(o<=w)throw i;t=void 0,a=o>w,n.push("")},onObjectProperty:(w,l,m)=>{if(o<l||(v(w,l,m,"property"),n[n.length-1]=w,o<=l+m))throw i},onObjectEnd:(w,l)=>{if(o<=w)throw i;t=void 0,n.pop()},onArrayBegin:(w,l)=>{if(o<=w)throw i;t=void 0,n.push(0)},onArrayEnd:(w,l)=>{if(o<=w)throw i;t=void 0,n.pop()},onLiteralValue:(w,l,m)=>{if(o<l||(v(w,l,m,E(w)),o<=l+m))throw i},onSeparator:(w,l,m)=>{if(o<=l)throw i;if(w===":"&&t&&t.type==="property")t.colonOffset=l,a=!1,t=void 0;else if(w===","){const D=n[n.length-1];typeof D=="number"?n[n.length-1]=D+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(w){if(w!==i)throw w}return{path:n,previousNode:t,isAtPropertyKey:a,matches:w=>{let l=0;for(let m=0;l<w.length&&m<n.length;m++)if(w[l]===n[m]||w[l]==="*")l++;else if(w[l]!=="**")return!1;return l===w.length}}}e.$Wm=S;function b(s,o=[],n=A.DEFAULT){let i=null,t=[];const r=[];function a(w){Array.isArray(t)?t.push(w):i!==null&&(t[i]=w)}return u(s,{onObjectBegin:()=>{const w={};a(w),r.push(t),t=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const w=[];a(w),r.push(t),t=w,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(w,l,m)=>{o.push({error:w,offset:l,length:m})}},n),t[0]}e.$Xm=b;function c(s,o=[],n=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function r(w){return i.children.push(w),w}u(s,{onObjectBegin:w=>{i=r({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,l,m)=>{i=r({type:"property",offset:l,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:l,length:m,parent:i})},onObjectEnd:(w,l)=>{i.length=w+l-i.offset,i=i.parent,t(w+l)},onArrayBegin:(w,l)=>{i=r({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,l)=>{i.length=w+l-i.offset,i=i.parent,t(w+l)},onLiteralValue:(w,l,m)=>{r({type:E(w),offset:l,length:m,parent:i,value:w}),t(l+m)},onSeparator:(w,l,m)=>{i.type==="property"&&(w===":"?i.colonOffset=l:w===","&&t(l))},onError:(w,l,m)=>{o.push({error:w,offset:l,length:m})}},n);const v=i.children[0];return v&&delete v.parent,v}e.$Ym=c;function $(s,o){if(!s)return;let n=s;for(const i of o)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===i){n=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$Zm=$;function p(s){if(!s.parent||!s.parent.children)return[];const o=p(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;o.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&o.push(n)}return o}e.$1m=p;function y(s){switch(s.type){case"array":return s.children.map(y);case"object":{const o=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(o[n.children[0].value]=y(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$2m=y;function h(s,o,n=!1){return o>=s.offset&&o<s.offset+s.length||n&&o===s.offset+s.length}e.$3m=h;function f(s,o,n=!1){if(h(s,o,n)){const i=s.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=o;t++){const r=f(i[t],o,n);if(r)return r}return s}}e.$4m=f;function u(s,o,n=A.DEFAULT){const i=O(s,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?ne=>_(ne,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),v=r(o.onObjectProperty),w=t(o.onObjectEnd),l=t(o.onArrayBegin),m=t(o.onArrayEnd),D=r(o.onLiteralValue),T=r(o.onSeparator),z=t(o.onComment),U=r(o.onError),B=n&&n.disallowComments,Z=n&&n.allowTrailingComma;function Q(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:B||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:B?x(10):z();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,ne=[],K=[]){if(U(_),ne.length+K.length>0){let q=i.getToken();for(;q!==17;){if(ne.indexOf(q)!==-1){Q();break}else if(K.indexOf(q)!==-1)break;q=Q()}}}function W(_){const ne=i.getTokenValue();return _?D(ne):v(ne),Q(),!0}function X(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}D(_);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return Q(),!0}function G(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(W(!1),i.getToken()===6?(T(":"),Q(),ie()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function V(){a(),Q();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),Q(),i.getToken()===2&&Z)break}else _&&x(6,[],[]);G()||x(4,[],[2,5]),_=!0}return w(),i.getToken()!==2?x(7,[2],[]):Q(),!0}function ee(){l(),Q();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),Q(),i.getToken()===4&&Z)break}else _&&x(6,[],[]);ie()||x(4,[],[4,5]),_=!0}return m(),i.getToken()!==4?x(8,[4],[]):Q(),!0}function ie(){switch(i.getToken()){case 3:return ee();case 1:return V();case 10:return W(!0);default:return X()}}return Q(),i.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):ie()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$5m=u;function d(s,o){const n=O(s),i=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&i.push(s.substring(r,a)),o!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return i.join("")}e.$6m=d;function E(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$7m=E}),define(oe[41],ae([0,1,35]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cT=e.$bT=e.$aT=e.$_S=void 0;function N(g,C,S){let b,c,$,p,y;if(C){for(p=C.offset,y=p+C.length,$=p;$>0&&!k(g,$-1);)$--;let a=y;for(;a<g.length&&!k(g,a);)a++;c=g.substring($,a),b=O(c,S)}else c=g,b=0,$=0,p=0,y=g.length;const h=R(S,g);let f=!1,u=0,d;S.insertSpaces?d=A(" ",S.tabSize||4):d="	";const E=(0,I.$Vm)(c,!1);let s=!1;function o(){return h+A(d,b+u)}function n(){let a=E.scan();for(f=!1;a===15||a===14;)f=f||a===14,a=E.scan();return s=a===16||E.getTokenError()!==0,a}const i=[];function t(a,v,w){!s&&v<y&&w>p&&g.substring(v,w)!==a&&i.push({offset:v,length:w-v,content:a})}let r=n();if(r!==17){const a=E.getTokenOffset()+$,v=A(d,b);t(v,$,a)}for(;r!==17;){let a=E.getTokenOffset()+E.getTokenLength()+$,v=n(),w="";for(;!f&&(v===12||v===13);){const m=E.getTokenOffset()+$;t(" ",a,m),a=E.getTokenOffset()+E.getTokenLength()+$,w=v===12?o():"",v=n()}if(v===2)r!==1&&(u--,w=o());else if(v===4)r!==3&&(u--,w=o());else{switch(r){case 3:case 1:u++,w=o();break;case 5:case 12:w=o();break;case 13:f?w=o():w=" ";break;case 6:w=" ";break;case 10:if(v===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?w=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}f&&(v===12||v===13)&&(w=o())}const l=E.getTokenOffset()+$;t(w,a,l),r=v}return i}e.$_S=N;function L(g,C){const S=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?S.replace(/\r\n|\r|\n/g,C.eol):S}e.$aT=L;function A(g,C){let S="";for(let b=0;b<C;b++)S+=g;return S}function O(g,C){let S=0,b=0;const c=C.tabSize||4;for(;S<g.length;){const $=g.charAt(S);if($===" ")b++;else if($==="	")b+=c;else break;S++}return Math.floor(b/c)}function R(g,C){for(let S=0;S<C.length;S++){const b=C.charAt(S);if(b==="\r")return S+1<C.length&&C.charAt(S+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return g&&g.eol||`
`}e.$bT=R;function k(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}e.$cT=k}),define(oe[86],ae([0,1,35,41]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hT=e.$gT=e.$fT=e.$eT=e.$dT=void 0;function L(g,C,S){return A(g,C,void 0,S)}e.$dT=L;function A(g,C,S,b,c){const $=C.slice(),p=[],y=(0,I.$Ym)(g,p);let h,f;for(;$.length>0&&(f=$.pop(),h=(0,I.$Zm)(y,$),h===void 0&&S!==void 0);)typeof f=="string"?S={[f]:S}:S=[S];if(h)if(h.type==="object"&&typeof f=="string"&&Array.isArray(h.children)){const u=(0,I.$Zm)(h,[f]);if(u!==void 0)if(S===void 0){if(!u.parent)throw new Error("Malformed AST");const d=h.children.indexOf(u.parent);let E,s=u.parent.offset+u.parent.length;if(d>0){const o=h.children[d-1];E=o.offset+o.length}else E=h.offset+1,h.children.length>1&&(s=h.children[1].offset);return O(g,{offset:E,length:s-E,content:""},b)}else return O(g,{offset:u.offset,length:u.length,content:JSON.stringify(S)},b);else{if(S===void 0)return[];const d=`${JSON.stringify(f)}: ${JSON.stringify(S)}`,E=c?c(h.children.map(o=>o.children[0].value)):h.children.length;let s;if(E>0){const o=h.children[E-1];s={offset:o.offset+o.length,length:0,content:","+d}}else h.children.length===0?s={offset:h.offset+1,length:0,content:d}:s={offset:h.offset+1,length:0,content:d+","};return O(g,s,b)}}else if(h.type==="array"&&typeof f=="number"&&Array.isArray(h.children))if(S!==void 0){const u=`${JSON.stringify(S)}`;let d;if(h.children.length===0||f===0)d={offset:h.offset+1,length:0,content:h.children.length===0?u:u+","};else{const E=f===-1||f>h.children.length?h.children.length:f,s=h.children[E-1];d={offset:s.offset+s.length,length:0,content:","+u}}return O(g,d,b)}else{const u=f,d=h.children[u];let E;if(h.children.length===1)E={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===u){const s=h.children[u-1],o=s.offset+s.length,n=h.offset+h.length;E={offset:o,length:n-2-o,content:""}}else E={offset:d.offset,length:h.children[u+1].offset-d.offset,content:""};return O(g,E,b)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${h.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return O(g,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(S)},b)}}e.$eT=A;function O(g,C,S){let b=R(g,C),c=C.offset,$=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;c>0&&!(0,N.$cT)(b,c-1);)c--;for(;$<b.length&&!(0,N.$cT)(b,$);)$++}const p=(0,N.$_S)(b,{offset:c,length:$-c},S);for(let h=p.length-1;h>=0;h--){const f=p[h];b=R(b,f),c=Math.min(c,f.offset),$=Math.max($,f.offset+f.length),$+=f.content.length-f.length}const y=g.length-(b.length-$)-c;return[{offset:c,length:y,content:b.substring(c,$)}]}e.$fT=O;function R(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}e.$gT=R;function k(g,C){const S=C.slice(0).sort((c,$)=>{const p=c.offset-$.offset;return p===0?c.length-$.length:p});let b=g.length;for(let c=S.length-1;c>=0;c--){const $=S[c];if($.offset+$.length<=b)g=R(g,$);else throw new Error("Overlapping edit");b=$.offset}return g}e.$hT=k}),define(oe[60],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class I{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=I}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(A){this.element=A,this.next=I.Undefined,this.prev=I.Undefined}}class N{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let A=this.a;for(;A!==I.Undefined;){const O=A.next;A.prev=I.Undefined,A.next=I.Undefined,A=O}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const R=new I(A);if(this.a===I.Undefined)this.a=R,this.b=R;else if(O){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(R))}}shift(){if(this.a!==I.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==I.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==I.Undefined&&A.next!==I.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===I.Undefined&&A.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):A.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):A.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==I.Undefined;)yield A.element,A=A.next}}e.$2c=N}),define(oe[34],ae([0,1]),function(te,e){"use strict";var I,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function A(f,u,d){let E=f.get(u);return E===void 0&&(E=d,f.set(u,E)),E}e.$xc=A;function O(f){const u=[];return f.forEach((d,E)=>{u.push(`${E} => ${d}`)}),`Map(${f.size}) {${u.join(", ")}}`}e.$yc=O;function R(f){const u=[];return f.forEach(d=>{u.push(d)}),`Set(${f.size}) {${u.join(", ")}}`}e.$zc=R;class k{constructor(u,d){this.uri=u,this.value=d}}function g(f){return Array.isArray(f)}class C{static{this.a=u=>u.toString()}constructor(u,d){if(this[I]="ResourceMap",u instanceof C)this.b=new Map(u.b),this.c=d??C.a;else if(g(u)){this.b=new Map,this.c=d??C.a;for(const[E,s]of u)this.set(E,s)}else this.b=new Map,this.c=u??C.a}set(u,d){return this.b.set(this.c(u),new k(u,d)),this}get(u){return this.b.get(this.c(u))?.value}has(u){return this.b.has(this.c(u))}get size(){return this.b.size}clear(){this.b.clear()}delete(u){return this.b.delete(this.c(u))}forEach(u,d){typeof d<"u"&&(u=u.bind(d));for(const[E,s]of this.b)u(s.value,s.uri,this)}*values(){for(const u of this.b.values())yield u.value}*keys(){for(const u of this.b.values())yield u.uri}*entries(){for(const u of this.b.values())yield[u.uri,u.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.b)yield[u.uri,u.value]}}e.$Ac=C;class S{constructor(u,d){this[N]="ResourceSet",!u||typeof u=="function"?this.a=new C(u):(this.a=new C(d),u.forEach(this.add,this))}get size(){return this.a.size}add(u){return this.a.set(u,u),this}clear(){this.a.clear()}delete(u){return this.a.delete(u)}forEach(u,d){this.a.forEach((E,s)=>u.call(d,s,s,this))}has(u){return this.a.has(u)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var b;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class c{constructor(){this[L]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(u){return this.a.has(u)}get(u,d=0){const E=this.a.get(u);if(E)return d!==0&&this.j(E,d),E.value}set(u,d,E=0){let s=this.a.get(u);if(s)s.value=d,E!==0&&this.j(s,E);else{switch(s={key:u,value:d,next:void 0,previous:void 0},E){case 0:this.h(s);break;case 1:this.g(s);break;case 2:this.h(s);break;default:this.h(s);break}this.a.set(u,s),this.d++}return this}delete(u){return!!this.remove(u)}remove(u){const d=this.a.get(u);if(d)return this.a.delete(u),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const u=this.b;return this.a.delete(u.key),this.i(u),this.d--,u.value}forEach(u,d){const E=this.e;let s=this.b;for(;s;){if(d?u.bind(d)(s.value,s.key,this):u(s.value,s.key,this),this.e!==E)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const u=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:E.key,done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}values(){const u=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:E.value,done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}entries(){const u=this,d=this.e;let E=this.b;const s={[Symbol.iterator](){return s},next(){if(u.e!==d)throw new Error("LinkedMap got modified during iteration.");if(E){const o={value:[E.key,E.value],done:!1};return E=E.next,o}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(u){if(u>=this.size)return;if(u===0){this.clear();return}let d=this.b,E=this.size;for(;d&&E>u;)this.a.delete(d.key),d=d.next,E--;this.b=d,this.d=E,d&&(d.previous=void 0),this.e++}g(u){if(!this.b&&!this.c)this.c=u;else if(this.b)u.next=this.b,this.b.previous=u;else throw new Error("Invalid list");this.b=u,this.e++}h(u){if(!this.b&&!this.c)this.b=u;else if(this.c)u.previous=this.c,this.c.next=u;else throw new Error("Invalid list");this.c=u,this.e++}i(u){if(u===this.b&&u===this.c)this.b=void 0,this.c=void 0;else if(u===this.b){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.b=u.next}else if(u===this.c){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.c=u.previous}else{const d=u.next,E=u.previous;if(!d||!E)throw new Error("Invalid list");d.previous=E,E.next=d}u.next=void 0,u.previous=void 0,this.e++}j(u,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(u===this.b)return;const E=u.next,s=u.previous;u===this.c?(s.next=void 0,this.c=s):(E.previous=s,s.next=E),u.previous=void 0,u.next=this.b,this.b.previous=u,this.b=u,this.e++}else if(d===2){if(u===this.c)return;const E=u.next,s=u.previous;u===this.b?(E.previous=void 0,this.b=E):(E.previous=s,s.next=E),u.next=void 0,u.previous=this.c,this.c.next=u,this.c=u,this.e++}}}toJSON(){const u=[];return this.forEach((d,E)=>{u.push([E,d])}),u}fromJSON(u){this.clear();for(const[d,E]of u)this.set(d,E)}}e.$Cc=c;class $ extends c{constructor(u,d=1){super(),this.k=u,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(u){this.k=u,this.m()}get ratio(){return this.l}set ratio(u){this.l=Math.min(Math.max(0,u),1),this.m()}get(u,d=2){return super.get(u,d)}peek(u){return super.get(u,0)}set(u,d){return super.set(u,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=$;class p{constructor(){this.a=new Map}add(u){return this.a.set(u,(this.a.get(u)||0)+1),this}delete(u){let d=this.a.get(u)||0;return d===0?!1:(d--,d===0?this.a.delete(u):this.a.set(u,d),!0)}has(u){return this.a.has(u)}}e.$Ec=p;class y{constructor(u){if(this.a=new Map,this.b=new Map,u)for(const[d,E]of u)this.set(d,E)}clear(){this.a.clear(),this.b.clear()}set(u,d){this.a.set(u,d),this.b.set(d,u)}get(u){return this.a.get(u)}getKey(u){return this.b.get(u)}delete(u){const d=this.a.get(u);return d===void 0?!1:(this.a.delete(u),this.b.delete(d),!0)}forEach(u,d){this.a.forEach((E,s)=>{u.call(d,E,s,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=y;class h{constructor(){this.a=new Map}add(u,d){let E=this.a.get(u);E||(E=new Set,this.a.set(u,E)),E.add(d)}delete(u,d){const E=this.a.get(u);E&&(E.delete(d),E.size===0&&this.a.delete(u))}forEach(u,d){const E=this.a.get(u);E&&E.forEach(d)}get(u){const d=this.a.get(u);return d||new Set}}e.$Gc=h}),define(oe[2],ae([0,1,18,125,34,85,59]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const R=!1;let k=null;class g{constructor(){this.b=new Map}static{this.a=0}c(m){let D=this.b.get(m);return D||(D={parent:null,source:null,isSingleton:!1,value:m,idx:g.a++},this.b.set(m,D)),D}trackDisposable(m){const D=this.c(m);D.source||(D.source=new Error().stack)}setParent(m,D){const T=this.c(m);T.parent=D}markAsDisposed(m){this.b.delete(m)}markAsSingleton(m){this.c(m).isSingleton=!0}f(m,D){const T=D.get(m);if(T)return T;const z=m.parent?this.f(this.c(m.parent),D):m;return D.set(m,z),z}getTrackedDisposables(){const m=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,m).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(m=10,D){let T;if(D)T=D;else{const Q=new Map,x=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,Q).isSingleton);if(x.length===0)return;const W=new Set(x.map(X=>X.value));if(T=x.filter(X=>!(X.parent&&W.has(X.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function z(Q){function x(X,G){for(;X.length>0&&G.some(V=>typeof V=="string"?V===X[0]:X[0].match(V));)X.shift()}const W=Q.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return x(W,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),W.reverse()}const U=new L.$Gc;for(const Q of T){const x=z(Q);for(let W=0;W<=x.length;W++)U.add(x.slice(0,W).join(`
`),Q)}T.sort((0,I.$7b)(Q=>Q.idx,I.$9b));let B="",Z=0;for(const Q of T.slice(0,m)){Z++;const x=z(Q),W=[];for(let X=0;X<x.length;X++){let G=x[X];G=`(shared with ${U.get(x.slice(0,X+1).join(`
`)).size}/${T.length} leaks) at ${G}`;const ee=U.get(x.slice(0,X).join(`
`)),ie=(0,N.$J)([...ee].map(_=>z(_)[X]),_=>_);delete ie[x[X]];for(const[_,ne]of Object.entries(ie))W.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${_}`);W.unshift(G)}B+=`


==================== Leaking disposable ${Z}/${T.length}: ${Q.value.constructor.name} ====================
${W.join(`
`)}
============================================================

`}return T.length>m&&(B+=`


... and ${T.length-m} more leaking disposables

`),{leaks:T,details:B}}}e.$Hc=g;function C(l){k=l}if(e.$Ic=C,R){const l="__is_disposable_tracked__";C(new class{trackDisposable(m){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[l]||console.log(D)},3e3)}setParent(m,D){if(m&&m!==s.None)try{m[l]=!0}catch{}}markAsDisposed(m){if(m&&m!==s.None)try{m[l]=!0}catch{}}markAsSingleton(m){}})}function S(l){return k?.trackDisposable(l),l}e.$Jc=S;function b(l){k?.markAsDisposed(l)}e.$Kc=b;function c(l,m){k?.setParent(l,m)}function $(l,m){if(k)for(const D of l)k.setParent(D,m)}function p(l){return k?.markAsSingleton(l),l}e.$Lc=p;function y(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.$Mc=y;function h(l){if(O.Iterable.is(l)){const m=[];for(const D of l)if(D)try{D.dispose()}catch(T){m.push(T)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.$Nc=h;function f(l){for(const m of l)y(m)&&m.dispose();return[]}e.$Oc=f;function u(...l){const m=d(()=>h(l));return $(l,m),m}e.$Pc=u;function d(l){const m=S({dispose:(0,A.$db)(()=>{b(m),l()})});return m}e.$Qc=d;class E{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return c(m,this),this.g?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(m),m}delete(m){if(m){if(m===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(m),m.dispose()}}deleteAndLeak(m){m&&this.f.has(m)&&(this.f.delete(m),c(m,null))}}e.$Rc=E;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new E,S(this),c(this.q,this)}dispose(){b(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}e.$Sc=s;class o{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&c(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&c(m,null),m}}e.$Tc=o;class n{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=n;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(m){let D=m;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,b(this))},this}}e.$Vc=i;class t{constructor(){this.a=new Map}acquire(m,...D){let T=this.a.get(m);T||(T={counter:0,object:this.b(m,...D)},this.a.set(m,T));const{object:z}=T,U=(0,A.$db)(()=>{--T.counter===0&&(this.c(m,T.object),this.a.delete(m))});return T.counter++,{object:z,dispose:U}}}e.$Wc=t;class r{constructor(m){this.a=m}async acquire(m,...D){const T=this.a.acquire(m,...D);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(z){throw T.dispose(),z}}}e.$Xc=r;class a{constructor(m){this.object=m}dispose(){}}e.$Yc=a;function v(l){const m=new E;try{l(m)}finally{m.dispose()}}e.$Zc=v;class w{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get size(){return this.a.size}get(m){return this.a.get(m)}set(m,D,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(m)?.dispose(),this.a.set(m,D)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=w}),define(oe[88],ae([0,1,34]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$pl=void 0;const N=new I.$Dc(1e4);function L(g){return k(g,"NFC",N)}e.$pl=L;const A=new I.$Dc(1e4);function O(g){return k(g,"NFD",A)}e.$ql=O;const R=/[^\u0000-\u0080]/;function k(g,C,S){if(!g)return g;const b=S.get(g);if(b)return b;let c;return R.test(g)?c=g.normalize(C):c=g,S.set(g,c),c}e.$rl=function(){const g=/[\u0300-\u036f]/g;return function(C){return O(C).replace(g,"")}}()}),function(){function te(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function O(k){A.push(k,Date.now())}function R(){const k=[];for(let g=0;g<A.length;g+=2)k.push({name:A[g],startTime:A[g+1]});return k}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(L+O.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function I(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=I(N))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var N in I)(typeof exports=="object"?exports:te)[N]=I[N]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function I(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return te[N].call(L.exports,L,L.exports,I),L.l=!0,L.exports}return I.m=te,I.c=e,I.d=function(N,L,A){I.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:A})},I.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},I.t=function(N,L){if(1&L&&(N=I(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(I.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var O in N)I.d(A,O,function(R){return N[R]}.bind(null,O));return A},I.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return I.d(L,"a",L),L},I.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},I.p="",I(I.s=0)}([function(te,e,I){(function(N){var L;e=te.exports=K,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],k=e.src=[],g=0,C=g++;k[C]="0|[1-9]\\d*";var S=g++;k[S]="[0-9]+";var b=g++;k[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=g++;k[c]="("+k[C]+")\\.("+k[C]+")\\.("+k[C]+")";var $=g++;k[$]="("+k[S]+")\\.("+k[S]+")\\.("+k[S]+")";var p=g++;k[p]="(?:"+k[C]+"|"+k[b]+")";var y=g++;k[y]="(?:"+k[S]+"|"+k[b]+")";var h=g++;k[h]="(?:-("+k[p]+"(?:\\."+k[p]+")*))";var f=g++;k[f]="(?:-?("+k[y]+"(?:\\."+k[y]+")*))";var u=g++;k[u]="[0-9A-Za-z-]+";var d=g++;k[d]="(?:\\+("+k[u]+"(?:\\."+k[u]+")*))";var E=g++,s="v?"+k[c]+k[h]+"?"+k[d]+"?";k[E]="^"+s+"$";var o="[v=\\s]*"+k[$]+k[f]+"?"+k[d]+"?",n=g++;k[n]="^"+o+"$";var i=g++;k[i]="((?:<|>)?=?)";var t=g++;k[t]=k[S]+"|x|X|\\*";var r=g++;k[r]=k[C]+"|x|X|\\*";var a=g++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[h]+")?"+k[d]+"?)?)?";var v=g++;k[v]="[v=\\s]*("+k[t]+")(?:\\.("+k[t]+")(?:\\.("+k[t]+")(?:"+k[f]+")?"+k[d]+"?)?)?";var w=g++;k[w]="^"+k[i]+"\\s*"+k[a]+"$";var l=g++;k[l]="^"+k[i]+"\\s*"+k[v]+"$";var m=g++;k[m]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=g++;k[D]="(?:~>?)";var T=g++;k[T]="(\\s*)"+k[D]+"\\s+",R[T]=new RegExp(k[T],"g");var z=g++;k[z]="^"+k[D]+k[a]+"$";var U=g++;k[U]="^"+k[D]+k[v]+"$";var B=g++;k[B]="(?:\\^)";var Z=g++;k[Z]="(\\s*)"+k[B]+"\\s+",R[Z]=new RegExp(k[Z],"g");var Q=g++;k[Q]="^"+k[B]+k[a]+"$";var x=g++;k[x]="^"+k[B]+k[v]+"$";var W=g++;k[W]="^"+k[i]+"\\s*("+o+")$|^$";var X=g++;k[X]="^"+k[i]+"\\s*("+s+")$|^$";var G=g++;k[G]="(\\s*)"+k[i]+"\\s*("+o+"|"+k[a]+")",R[G]=new RegExp(k[G],"g");var V=g++;k[V]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var ee=g++;k[ee]="^\\s*("+k[v]+")\\s+-\\s+("+k[v]+")\\s*$";var ie=g++;k[ie]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)L(_,k[_]),R[_]||(R[_]=new RegExp(k[_]));function ne(le,ge){if(le instanceof K)return le;if(typeof le!="string"||le.length>A||!(ge?R[n]:R[E]).test(le))return null;try{return new K(le,ge)}catch{return null}}function K(le,ge){if(le instanceof K){if(le.loose===ge)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof K))return new K(le,ge);L("SemVer",le,ge),this.loose=ge;var be=le.trim().match(ge?R[n]:R[E]);if(!be)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var Pe=+ke;if(Pe>=0&&Pe<O)return Pe}return ke}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ne,e.valid=function(le,ge){var be=ne(le,ge);return be?be.version:null},e.clean=function(le,ge){var be=ne(le.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(le){return L("SemVer.compare",this.version,this.loose,le),le instanceof K||(le=new K(le,this.loose)),this.compareMain(le)||this.comparePre(le)},K.prototype.compareMain=function(le){return le instanceof K||(le=new K(le,this.loose)),P(this.major,le.major)||P(this.minor,le.minor)||P(this.patch,le.patch)},K.prototype.comparePre=function(le){if(le instanceof K||(le=new K(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],ke=le.prerelease[ge];if(L("prerelease compare",ge,be,ke),be===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(be===void 0)return-1;if(be!==ke)return P(be,ke)}while(++ge)},K.prototype.inc=function(le,ge){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,ge,be,ke){typeof be=="string"&&(ke=be,be=void 0);try{return new K(le,be).inc(ge,ke).version}catch{return null}},e.diff=function(le,ge){if(H(le,ge))return null;var be=ne(le),ke=ne(ge);if(be.prerelease.length||ke.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return Pe},e.compareIdentifiers=P;var q=/^[0-9]+$/;function P(le,ge){var be=q.test(le),ke=q.test(ge);return be&&ke&&(le=+le,ge=+ge),be&&!ke?-1:ke&&!be?1:le<ge?-1:le>ge?1:0}function j(le,ge,be){return new K(le,be).compare(new K(ge,be))}function M(le,ge,be){return j(le,ge,be)>0}function F(le,ge,be){return j(le,ge,be)<0}function H(le,ge,be){return j(le,ge,be)===0}function J(le,ge,be){return j(le,ge,be)!==0}function re(le,ge,be){return j(le,ge,be)>=0}function ce(le,ge,be){return j(le,ge,be)<=0}function ue(le,ge,be,ke){var Pe;switch(ge){case"===":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le===be;break;case"!==":typeof le=="object"&&(le=le.version),typeof be=="object"&&(be=be.version),Pe=le!==be;break;case"":case"=":case"==":Pe=H(le,be,ke);break;case"!=":Pe=J(le,be,ke);break;case">":Pe=M(le,be,ke);break;case">=":Pe=re(le,be,ke);break;case"<":Pe=F(le,be,ke);break;case"<=":Pe=ce(le,be,ke);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function he(le,ge){if(le instanceof he){if(le.loose===ge)return le;le=le.value}if(!(this instanceof he))return new he(le,ge);L("comparator",le,ge),this.loose=ge,this.parse(le),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(le,ge){return P(ge,le)},e.major=function(le,ge){return new K(le,ge).major},e.minor=function(le,ge){return new K(le,ge).minor},e.patch=function(le,ge){return new K(le,ge).patch},e.compare=j,e.compareLoose=function(le,ge){return j(le,ge,!0)},e.rcompare=function(le,ge,be){return j(ge,le,be)},e.sort=function(le,ge){return le.sort(function(be,ke){return e.compare(be,ke,ge)})},e.rsort=function(le,ge){return le.sort(function(be,ke){return e.rcompare(be,ke,ge)})},e.gt=M,e.lt=F,e.eq=H,e.neq=J,e.gte=re,e.lte=ce,e.cmp=ue,e.Comparator=he;var $e={};function de(le,ge){if(le instanceof de)return le.loose===ge?le:new de(le.raw,ge);if(le instanceof he)return new de(le.value,ge);if(!(this instanceof de))return new de(le,ge);if(this.loose=ge,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function we(le){return!le||le.toLowerCase()==="x"||le==="*"}function ve(le,ge,be,ke,Pe,ze,je,Ue,Fe,se,fe,me,pe){return((ge=we(be)?"":we(ke)?">="+be+".0.0":we(Pe)?">="+be+"."+ke+".0":">="+ge)+" "+(Ue=we(Fe)?"":we(se)?"<"+(+Fe+1)+".0.0":we(fe)?"<"+Fe+"."+(+se+1)+".0":me?"<="+Fe+"."+se+"."+fe+"-"+me:"<="+Ue)).trim()}function Oe(le,ge){for(var be=0;be<le.length;be++)if(!le[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<le.length;be++)if(L(le[be].semver),le[be].semver!==$e&&le[be].semver.prerelease.length>0){var ke=le[be].semver;if(ke.major===ge.major&&ke.minor===ge.minor&&ke.patch===ge.patch)return!0}return!1}return!0}function Ne(le,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(le)}function Me(le,ge,be,ke){var Pe,ze,je,Ue,Fe;switch(le=new K(le,ke),ge=new de(ge,ke),be){case">":Pe=M,ze=ce,je=F,Ue=">",Fe=">=";break;case"<":Pe=F,ze=re,je=M,Ue="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(le,ge,ke))return!1;for(var se=0;se<ge.set.length;++se){var fe=ge.set[se],me=null,pe=null;if(fe.forEach(function(Se){Se.semver===$e&&(Se=new he(">=0.0.0")),me=me||Se,pe=pe||Se,Pe(Se.semver,me.semver,ke)?me=Se:je(Se.semver,pe.semver,ke)&&(pe=Se)}),me.operator===Ue||me.operator===Fe||(!pe.operator||pe.operator===Ue)&&ze(le,pe.semver)||pe.operator===Fe&&je(le,pe.semver))return!1}return!0}he.prototype.parse=function(le){var ge=this.loose?R[W]:R[X],be=le.match(ge);if(!be)throw new TypeError("Invalid comparator: "+le);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new K(be[2],this.loose):this.semver=$e},he.prototype.toString=function(){return this.value},he.prototype.test=function(le){return L("Comparator.test",le,this.loose),this.semver===$e||(typeof le=="string"&&(le=new K(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},he.prototype.intersects=function(le,ge){if(!(le instanceof he))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(le.value,ge),Ne(this.value,be,ge);if(le.operator==="")return be=new de(this.value,ge),Ne(le.semver,be,ge);var ke=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),ze=this.semver.version===le.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Ue=ue(this.semver,"<",le.semver,ge)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Fe=ue(this.semver,">",le.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return ke||Pe||ze&&je||Ue||Fe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(le){var ge=this.loose;le=le.trim(),L("range",le,ge);var be=ge?R[ee]:R[V];le=le.replace(be,ve),L("hyphen replace",le),le=le.replace(R[G],"$1$2$3"),L("comparator trim",le,R[G]),le=(le=(le=le.replace(R[T],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var ke=ge?R[W]:R[X],Pe=le.split(" ").map(function(ze){return function(je,Ue){return L("comp",je),je=function(Fe,se){return Fe.trim().split(/\s+/).map(function(fe){return function(me,pe){L("caret",me,pe);var Se=pe?R[x]:R[Q];return me.replace(Se,function(Re,Ce,Ie,De,Ae){var Te;return L("caret",me,Re,Ce,Ie,De,Ae),we(Ce)?Te="":we(Ie)?Te=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(De)?Te=Ce==="0"?">="+Ce+"."+Ie+".0 <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+".0 <"+(+Ce+1)+".0.0":Ae?(L("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=Ce==="0"?Ie==="0"?">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+Ie+"."+(+De+1):">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+"."+De+Ae+" <"+(+Ce+1)+".0.0"):(L("no pr"),Te=Ce==="0"?Ie==="0"?">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+Ie+"."+(+De+1):">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+"."+De+" <"+(+Ce+1)+".0.0"),L("caret return",Te),Te})}(fe,se)}).join(" ")}(je,Ue),L("caret",je),je=function(Fe,se){return Fe.trim().split(/\s+/).map(function(fe){return function(me,pe){var Se=pe?R[U]:R[z];return me.replace(Se,function(Re,Ce,Ie,De,Ae){var Te;return L("tilde",me,Re,Ce,Ie,De,Ae),we(Ce)?Te="":we(Ie)?Te=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(De)?Te=">="+Ce+"."+Ie+".0 <"+Ce+"."+(+Ie+1)+".0":Ae?(L("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+(+Ie+1)+".0"):Te=">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+(+Ie+1)+".0",L("tilde return",Te),Te})}(fe,se)}).join(" ")}(je,Ue),L("tildes",je),je=function(Fe,se){return L("replaceXRanges",Fe,se),Fe.split(/\s+/).map(function(fe){return function(me,pe){me=me.trim();var Se=pe?R[l]:R[w];return me.replace(Se,function(Re,Ce,Ie,De,Ae,Te){L("xRange",me,Re,Ce,Ie,De,Ae,Te);var Be=we(Ie),qe=Be||we(De),We=qe||we(Ae);return Ce==="="&&We&&(Ce=""),Be?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&We?(qe&&(De=0),We&&(Ae=0),Ce===">"?(Ce=">=",qe?(Ie=+Ie+1,De=0,Ae=0):We&&(De=+De+1,Ae=0)):Ce==="<="&&(Ce="<",qe?Ie=+Ie+1:De=+De+1),Re=Ce+Ie+"."+De+"."+Ae):qe?Re=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":We&&(Re=">="+Ie+"."+De+".0 <"+Ie+"."+(+De+1)+".0"),L("xRange return",Re),Re})}(fe,se)}).join(" ")}(je,Ue),L("xrange",je),je=function(Fe,se){return L("replaceStars",Fe,se),Fe.trim().replace(R[ie],"")}(je,Ue),L("stars",je),je}(ze,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(ze){return!!ze.match(ke)})),Pe=Pe.map(function(ze){return new he(ze,ge)})},de.prototype.intersects=function(le,ge){if(!(le instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(ke){return le.set.some(function(Pe){return Pe.every(function(ze){return ke.intersects(ze,ge)})})})})},e.toComparators=function(le,ge){return new de(le,ge).set.map(function(be){return be.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},de.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new K(le,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Oe(this.set[ge],le))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(le,ge,be){var ke=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return le.forEach(function(je){ze.test(je)&&(ke&&Pe.compare(je)!==-1||(Pe=new K(ke=je,be)))}),ke},e.minSatisfying=function(le,ge,be){var ke=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return le.forEach(function(je){ze.test(je)&&(ke&&Pe.compare(je)!==1||(Pe=new K(ke=je,be)))}),ke},e.validRange=function(le,ge){try{return new de(le,ge).range||"*"}catch{return null}},e.ltr=function(le,ge,be){return Me(le,ge,"<",be)},e.gtr=function(le,ge,be){return Me(le,ge,">",be)},e.outside=Me,e.prerelease=function(le,ge){var be=ne(le,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(le,ge,be){return le=new de(le,be),ge=new de(ge,be),le.intersects(ge)},e.coerce=function(le){if(le instanceof K)return le;if(typeof le!="string")return null;var ge=le.match(R[m]);return ge==null?null:ne((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,I(1))},function(te,e){var I,N,L=te.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(y){if(I===setTimeout)return setTimeout(y,0);if((I===A||!I)&&setTimeout)return I=setTimeout,setTimeout(y,0);try{return I(y,0)}catch{try{return I.call(null,y,0)}catch{return I.call(this,y,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:A}catch{I=A}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var k,g=[],C=!1,S=-1;function b(){C&&k&&(C=!1,k.length?g=k.concat(g):S=-1,g.length&&c())}function c(){if(!C){var y=R(b);C=!0;for(var h=g.length;h;){for(k=g,g=[];++S<h;)k&&k[S].run();S=-1,h=g.length}k=null,C=!1,function(f){if(N===clearTimeout)return clearTimeout(f);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(f);try{N(f)}catch{try{return N.call(null,f)}catch{return N.call(this,f)}}}(y)}}function $(y,h){this.fun=y,this.array=h}function p(){}L.nextTick=function(y){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];g.push(new $(y,h)),g.length!==1||C||R(c)},$.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=p,L.addListener=p,L.once=p,L.off=p,L.removeListener=p,L.removeAllListeners=p,L.emit=p,L.prependListener=p,L.prependOnceListener=p,L.listeners=function(y){return[]},L.binding=function(y){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(y){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(oe[127],ae([0,1]),function(te,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;class N{constructor(R,k,g){this.level=R,this.key=k,this.value=g,this.forward=[]}}const L=void 0;class A{constructor(R,k=2**16){this.comparator=R,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new N(this.c,L,L)}get size(){return this.f}clear(){this.e=new N(this.c,L,L),this.f=0}has(R){return!!A.g(this,R,this.comparator)}get(R){return A.g(this,R,this.comparator)?.value}set(R,k){return A.h(this,R,k,this.comparator)&&(this.f+=1),this}delete(R){const k=A.k(this,R,this.comparator);return k&&(this.f-=1),k}forEach(R,k){let g=this.e.forward[0];for(;g;)R.call(k,g.value,g.key,this),g=g.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",k=this.e.forward[0];for(;k;)R+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return R}static g(R,k,g){let C=R.e;for(let S=R.d-1;S>=0;S--)for(;C.forward[S]&&g(C.forward[S].key,k)<0;)C=C.forward[S];if(C=C.forward[0],C&&g(C.key,k)===0)return C}static h(R,k,g,C){const S=[];let b=R.e;for(let c=R.d-1;c>=0;c--){for(;b.forward[c]&&C(b.forward[c].key,k)<0;)b=b.forward[c];S[c]=b}if(b=b.forward[0],b&&C(b.key,k)===0)return b.value=g,!1;{const c=A.j(R);if(c>R.d){for(let $=R.d;$<c;$++)S[$]=R.e;R.d=c}b=new N(c,k,g);for(let $=0;$<c;$++)b.forward[$]=S[$].forward[$],S[$].forward[$]=b;return!0}}static j(R,k=.5){let g=1;for(;Math.random()<k&&g<R.c;)g+=1;return g}static k(R,k,g){const C=[];let S=R.e;for(let b=R.d-1;b>=0;b--){for(;S.forward[b]&&g(S.forward[b].key,k)<0;)S=S.forward[b];C[b]=S}if(S=S.forward[0],!S||g(S.key,k)!==0)return!1;for(let b=0;b<R.d&&C[b].forward[b]===S;b++)C[b].forward[b]=S.forward[b];for(;R.d>0&&R.e.forward[R.d-1]===L;)R.d-=1;return!0}}e.$Cr=A}),define(oe[61],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=I&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Kd=N}),define(oe[3],ae([0,1,7,85,2,87,61]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.Event=void 0;const R=!1,k=!1;var g;(function(w){w.None=()=>L.$Sc.None;function l(ue){if(k){const{onDidAddListener:he}=ue,$e=$.create();let de=0;ue.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),he?.()}}}function m(ue,he){return X(ue,()=>{},0,void 0,!0,void 0,he)}w.defer=m;function D(ue){return(he,$e=null,de)=>{let we=!1,ve;return ve=ue(Oe=>{if(!we)return ve?ve.dispose():we=!0,he.call($e,Oe)},null,de),we&&ve.dispose(),ve}}w.once=D;function T(ue,he,$e){return x((de,we=null,ve)=>ue(Oe=>de.call(we,he(Oe)),null,ve),$e)}w.map=T;function z(ue,he,$e){return x((de,we=null,ve)=>ue(Oe=>{he(Oe),de.call(we,Oe)},null,ve),$e)}w.forEach=z;function U(ue,he,$e){return x((de,we=null,ve)=>ue(Oe=>he(Oe)&&de.call(we,Oe),null,ve),$e)}w.filter=U;function B(ue){return ue}w.signal=B;function Z(...ue){return(he,$e=null,de)=>{const we=(0,L.$Pc)(...ue.map(ve=>ve(Oe=>he.call($e,Oe))));return W(we,de)}}w.any=Z;function Q(ue,he,$e,de){let we=$e;return T(ue,ve=>(we=he(we,ve),we),de)}w.reduce=Q;function x(ue,he){let $e;const de={onWillAddFirstListener(){$e=ue(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};he||l(de);const we=new u(de);return he?.add(we),we.event}function W(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function X(ue,he,$e=100,de=!1,we=!1,ve,Oe){let Ne,Me,le,ge=0,be;const ke={leakWarningThreshold:ve,onWillAddFirstListener(){Ne=ue(ze=>{ge++,Me=he(Me,ze),de&&!le&&(Pe.fire(Me),Me=void 0),be=()=>{const je=Me;Me=void 0,le=void 0,(!de||ge>1)&&Pe.fire(je),ge=0},typeof $e=="number"?(clearTimeout(le),le=setTimeout(be,$e)):le===void 0&&(le=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Ne.dispose()}};Oe||l(ke);const Pe=new u(ke);return Oe?.add(Pe),Pe.event}w.debounce=X;function G(ue,he=0,$e){return w.debounce(ue,(de,we)=>de?(de.push(we),de):[we],he,void 0,!0,void 0,$e)}w.accumulate=G;function V(ue,he=(de,we)=>de===we,$e){let de=!0,we;return U(ue,ve=>{const Oe=de||!he(ve,we);return de=!1,we=ve,Oe},$e)}w.latch=V;function ee(ue,he,$e){return[w.filter(ue,he,$e),w.filter(ue,de=>!he(de),$e)]}w.split=ee;function ie(ue,he=!1,$e=[],de){let we=$e.slice(),ve=ue(Me=>{we?we.push(Me):Ne.fire(Me)});de&&de.add(ve);const Oe=()=>{we?.forEach(Me=>Ne.fire(Me)),we=null},Ne=new u({onWillAddFirstListener(){ve||(ve=ue(Me=>Ne.fire(Me)),de&&de.add(ve))},onDidAddFirstListener(){we&&(he?setTimeout(Oe):Oe())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return de&&de.add(Ne),Ne.event}w.buffer=ie;function _(ue,he){return(de,we,ve)=>{const Oe=he(new K);return ue(function(Ne){const Me=Oe.evaluate(Ne);Me!==ne&&de.call(we,Me)},void 0,ve)}}w.chain=_;const ne=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push($e=>(he($e),$e)),this}filter(he){return this.f.push($e=>he($e)?$e:ne),this}reduce(he,$e){let de=$e;return this.f.push(we=>(de=he(de,we),de)),this}latch(he=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const ve=$e||!he(we,de);return $e=!1,de=we,ve?we:ne}),this}evaluate(he){for(const $e of this.f)if(he=$e(he),he===ne)break;return he}}function q(ue,he,$e=de=>de){const de=(...Ne)=>Oe.fire($e(...Ne)),we=()=>ue.on(he,de),ve=()=>ue.removeListener(he,de),Oe=new u({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Oe.event}w.fromNodeEventEmitter=q;function P(ue,he,$e=de=>de){const de=(...Ne)=>Oe.fire($e(...Ne)),we=()=>ue.addEventListener(he,de),ve=()=>ue.removeEventListener(he,de),Oe=new u({onWillAddFirstListener:we,onDidRemoveLastListener:ve});return Oe.event}w.fromDOMEventEmitter=P;function j(ue){return new Promise(he=>D(ue)(he))}w.toPromise=j;function M(ue){const he=new u;return ue.then($e=>{he.fire($e)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}w.fromPromise=M;function F(ue,he,$e){return he($e),ue(de=>he(de))}w.runAndSubscribe=F;function H(ue,he){let $e=null;function de(ve){$e?.dispose(),$e=new L.$Rc,he(ve,$e)}de(void 0);const we=ue(ve=>de(ve));return(0,L.$Qc)(()=>{we.dispose(),$e?.dispose()})}w.runAndSubscribeWithStore=H;class J{constructor(he,$e){this._observable=he,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};$e||l(de),this.emitter=new u(de),$e&&$e.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,$e){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function re(ue,he){return new J(ue,he).emitter.event}w.fromObservable=re;function ce(ue){return he=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(ue.reportChanges(),de&&(de=!1,he()))},handlePossibleChange(){},handleChange(){de=!0}};return ue.addObserver(we),ue.reportChanges(),{dispose(){ue.removeObserver(we)}}}}w.fromObservableLight=ce})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.f=0}constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${C.f++}`,C.all.add(this)}start(l){this.g=new O.$Kd,this.listenerCount=l}stop(){if(this.g){const l=this.g.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this.g=void 0}}}e.$Md=C;let S=-1;function b(w){const l=S;return S=w,{dispose(){S=l}}}e.$Nd=b;class c{constructor(l,m=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=m,this.g=0}dispose(){this.f?.clear()}check(l,m){const D=this.threshold;if(D<=0||m<D)return;this.f||(this.f=new Map);const T=this.f.get(l.value)||0;if(this.f.set(l.value,T+1),this.g-=1,this.g<=0){this.g=D*.5;let z,U=0;for(const[B,Z]of this.f)(!z||U<Z)&&(z=B,U=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${U}):`),console.warn(z)}return()=>{const z=this.f.get(l.value)||0;this.f.set(l.value,z-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class y{constructor(l){this.value=l,this.id=p++}}const h=2,f=(w,l)=>{if(w instanceof y)l(w);else for(let m=0;m<w.length;m++){const D=w[m];D&&l(D)}};class u{constructor(l){this.w=0,this.f=l,this.g=S>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??S):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const l=this.t;queueMicrotask(()=>{f(l,m=>m.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(l,m,D)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Sc.None;if(this.m)return L.$Sc.None;m&&(l=l.bind(m));const T=new y(l);let z,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=$.create(),z=this.g.check(T.stack,this.w+1)),R&&(T.stack=U??$.create()),this.t?this.t instanceof y?(this.u??=new E,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const B=(0,L.$Qc)(()=>{z?.(),this.x(T)});return D instanceof L.$Rc?D.add(B):Array.isArray(D)&&D.push(B),B},this.q}x(l){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const m=this.t,D=m.indexOf(l);if(D===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,m[D]=void 0;const T=this.u.current===this;if(this.w*h<=m.length){let z=0;for(let U=0;U<m.length;U++)m[U]?m[z++]=m[U]:T&&(this.u.end--,z<this.u.i&&this.u.i--);m.length=z}}y(l,m){if(!l)return;const D=this.f?.onListenerError||I.$1;if(!D){l.value(m);return}try{l.value(m)}catch(T){D(T)}}z(l){const m=l.current.t;for(;l.i<l.end;)this.y(m[l.i++],l.value);l.reset()}fire(l){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof y)this.y(this.t,l);else{const m=this.u;m.enqueue(this,l,this.t.length),this.z(m)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Od=u;const d=()=>new E;e.$Pd=d;class E{constructor(){this.i=-1,this.end=0}enqueue(l,m,D){this.i=0,this.end=D,this.current=l,this.value=m}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends u{async fireAsync(l,m,D){if(this.t)for(this.h||(this.h=new A.$2c),f(this.t,T=>this.h.push([T.value,l]));this.h.size>0&&!m.isCancellationRequested;){const[T,z]=this.h.shift(),U=[],B={...z,token:m,waitUntil:Z=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");D&&(Z=D(Z,T)),U.push(Z)}};try{T(B)}catch(Z){(0,I.$1)(Z);continue}Object.freeze(U),await Promise.allSettled(U).then(Z=>{for(const Q of Z)Q.status==="rejected"&&(0,I.$1)(Q.reason)})}}}e.$Qd=s;class o extends u{get isPaused(){return this.h!==0}constructor(l){super(l),this.h=0,this.s=new A.$2c,this.A=l?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const l=Array.from(this.s);this.s.clear(),super.fire(this.A(l))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(l){this.w&&(this.h!==0?this.s.push(l):super.fire(l))}}e.$Rd=o;class n extends o{constructor(l){super(l),this.k=l.delay??100}fire(l){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(l)}}e.$Sd=n;class i extends u{constructor(l){super(l),this.h=[],this.k=l?.merge}fire(l){this.hasListeners()&&(this.h.push(l),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(m=>super.fire(m)),this.h=[]}))}}e.$Td=i;class t{constructor(){this.g=!1,this.h=[],this.f=new u({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(l){const m={event:l,listener:null};this.h.push(m),this.g&&this.m(m);const D=()=>{this.g&&this.o(m);const T=this.h.indexOf(m);this.h.splice(T,1)};return(0,L.$Qc)((0,N.$db)(D))}j(){this.g=!0,this.h.forEach(l=>this.m(l))}k(){this.g=!1,this.h.forEach(l=>this.o(l))}m(l){l.listener=l.event(m=>this.f.fire(m))}o(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.f.dispose()}}e.$Ud=t;class r{constructor(l,m,D,T){this.f=new L.$Rc;const z=this.f.add(new t),U=this.f.add(new L.$1c);function B(Z){U.set(Z,z.add(T(Z)))}for(const Z of l)B(Z);this.f.add(m(Z=>{B(Z)})),this.f.add(D(Z=>{U.deleteAndDispose(Z)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Vd=r;class a{constructor(){this.f=[]}wrapEvent(l){return(m,D,T)=>l(z=>{const U=this.f[this.f.length-1];U?U.push(()=>m.call(D,z)):m.call(D,z)},void 0,T)}bufferEvents(l){const m=[];this.f.push(m);const D=l();return this.f.pop(),m.forEach(T=>T()),D}}e.$Wd=a;class v{constructor(){this.f=!1,this.g=g.None,this.h=L.$Sc.None,this.j=new u({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(l){this.g=l,this.f&&(this.h.dispose(),this.h=l(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Xd=v}),define(oe[26],ae([0,1,3]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.CancellationToken=void 0;const N=Object.freeze(function(R,k){const g=setTimeout(R.bind(k),0);return{dispose(){clearTimeout(g)}}});var L;(function(R){function k(g){return g===R.None||g===R.Cancelled||g instanceof A?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=k,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new I.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=L.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=L.None}}e.$Yd=O}),define(oe[128],ae([0,1,26]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=void 0;class N{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new I.$Yd,k=this.b(R.token);return this.a={promise:k,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$xe=N;class L{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const k=JSON.stringify(R);return this.b!==k&&(this.b=k,this.a=this.c(R)),this.a}}e.$ye=L;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const k=this.b(R);return this.a.set(R,k),k}}e.$ze=A}),define(oe[46],ae([0,1,7,2]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function L(d){const E=d;return E?typeof E.read=="function":!1}e.$Zd=L;function A(d){const E=d;return E?[E.on,E.pause,E.resume,E.destroy].every(s=>typeof s=="function"):!1}e.$1d=A;function O(d){const E=d;return E?A(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$2d=O;function R(d,E){return new k(d,E)}e.$3d=R;class k{constructor(E,s){this.e=E,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(s=>s(E))}h(E){this.c.error.length===0?(0,I.$1)(E):this.c.error.slice(0).forEach(s=>s(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,s){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(E,s){if(this.a.destroyed)return;let o;switch(E){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(s);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(d,E){const s=[];let o;for(;(o=d.read())!==null;)s.push(o);return E(s)}e.$4d=g;function C(d,E,s){const o=[];let n;for(;(n=d.read())!==null&&o.length<s;)o.push(n);return n===null&&o.length>0?E(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return d.read()}}}e.$5d=C;function S(d,E){return new Promise((s,o)=>{const n=[];b(d,{onData:i=>{E&&n.push(i)},onError:i=>{E?o(i):s(void 0)},onEnd:()=>{s(E?E(n):void 0)}})})}e.$6d=S;function b(d,E,s){d.on("error",o=>{s?.isCancellationRequested||E.onError(o)}),d.on("end",()=>{s?.isCancellationRequested||E.onEnd()}),d.on("data",o=>{s?.isCancellationRequested||E.onData(o)})}e.$7d=b;function c(d,E){return new Promise((s,o)=>{const n=new N.$Rc,i=[],t=v=>{if(i.push(v),i.length>E)return n.dispose(),d.pause(),s({stream:d,buffer:i,ended:!1})},r=v=>(n.dispose(),o(v)),a=()=>(n.dispose(),s({stream:d,buffer:i,ended:!0}));n.add((0,N.$Qc)(()=>d.removeListener("error",r))),d.on("error",r),n.add((0,N.$Qc)(()=>d.removeListener("end",a))),d.on("end",a),n.add((0,N.$Qc)(()=>d.removeListener("data",t))),d.on("data",t)})}e.$8d=c;function $(d,E){const s=R(E);return s.end(d),s}e.$9d=$;function p(){const d=R(()=>{throw new Error("not supported")});return d.end(),d}e.$0d=p;function y(d){let E=!1;return{read:()=>E?null:(E=!0,d)}}e.$$d=y;function h(d,E,s){const o=R(s);return b(d,{onData:n=>o.write(E.data(n)),onError:n=>o.error(E.error?E.error(n):n),onEnd:()=>o.end()}),o}e.$_d=h;function f(d,E,s){let o=!1;return{read:()=>{const n=E.read();return o?n:(o=!0,n!==null?s([d,n]):d)}}}e.$ae=f;function u(d,E,s){let o=!1;const n=R(s);return b(E,{onData:i=>o?n.write(i):(o=!0,n.write(s([d,i]))),onError:i=>n.error(i),onEnd:()=>{o||(o=!0,n.write(d)),n.end()}}),n}e.$be=u}),define(oe[15],ae([0,1,60,46]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const L=typeof Buffer<"u",A=new I.$V(()=>new Uint8Array(256));let O,R;class k{static alloc(m){return L?new k(Buffer.allocUnsafe(m)):new k(new Uint8Array(m))}static wrap(m){return L&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new k(m)}static fromString(m,D){return!(D?.dontUseNodeBuffer||!1)&&L?new k(Buffer.from(m)):(O||(O=new TextEncoder),new k(O.encode(m)))}static fromByteArray(m){const D=k.alloc(m.length);for(let T=0,z=m.length;T<z;T++)D.buffer[T]=m[T];return D}static concat(m,D){if(typeof D>"u"){D=0;for(let U=0,B=m.length;U<B;U++)D+=m[U].byteLength}const T=k.alloc(D);let z=0;for(let U=0,B=m.length;U<B;U++){const Z=m[U];T.set(Z,z),z+=Z.byteLength}return T}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=k.alloc(this.byteLength);return m.set(this),m}toString(){return L?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(m,D){return new k(this.buffer.subarray(m,D))}set(m,D){if(m instanceof k)this.buffer.set(m.buffer,D);else if(m instanceof Uint8Array)this.buffer.set(m,D);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),D);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return b(this.buffer,m)}writeUInt32BE(m,D){c(this.buffer,m,D)}readUInt32LE(m){return $(this.buffer,m)}writeUInt32LE(m,D){p(this.buffer,m,D)}readUInt8(m){return y(this.buffer,m)}writeUInt8(m,D){h(this.buffer,m,D)}indexOf(m,D=0){return g(this.buffer,m instanceof k?m.buffer:m,D)}}e.$ce=k;function g(l,m,D=0){const T=m.byteLength,z=l.byteLength;if(T===0)return 0;if(T===1)return l.indexOf(m[0]);if(T>z-D)return-1;const U=A.value;U.fill(m.length);for(let x=0;x<m.length;x++)U[m[x]]=m.length-x-1;let B=D+m.length-1,Z=B,Q=-1;for(;B<z;)if(l[B]===m[Z]){if(Z===0){Q=B;break}B--,Z--}else B+=Math.max(m.length-Z,U[l[B]]),Z=m.length-1;return Q}e.$de=g;function C(l,m){return l[m+0]<<0>>>0|l[m+1]<<8>>>0}e.$ee=C;function S(l,m,D){l[D+0]=m&255,m=m>>>8,l[D+1]=m&255}e.$fe=S;function b(l,m){return l[m]*2**24+l[m+1]*2**16+l[m+2]*2**8+l[m+3]}e.$ge=b;function c(l,m,D){l[D+3]=m,m=m>>>8,l[D+2]=m,m=m>>>8,l[D+1]=m,m=m>>>8,l[D]=m}e.$he=c;function $(l,m){return l[m+0]<<0>>>0|l[m+1]<<8>>>0|l[m+2]<<16>>>0|l[m+3]<<24>>>0}e.$ie=$;function p(l,m,D){l[D+0]=m&255,m=m>>>8,l[D+1]=m&255,m=m>>>8,l[D+2]=m&255,m=m>>>8,l[D+3]=m&255}e.$je=p;function y(l,m){return l[m]}e.$ke=y;function h(l,m,D){l[D]=m}e.$le=h;function f(l){return N.$4d(l,m=>k.concat(m))}e.$me=f;function u(l){return N.$$d(l)}e.$ne=u;function d(l){return N.$6d(l,m=>k.concat(m))}e.$oe=d;async function E(l){return l.ended?k.concat(l.buffer):k.concat([...l.buffer,await d(l.stream)])}e.$pe=E;function s(l){return N.$9d(l,m=>k.concat(m))}e.$qe=s;function o(l){return N.$_d(l,{data:m=>typeof m=="string"?k.fromString(m):k.wrap(m)},m=>k.concat(m))}e.$re=o;function n(l){return N.$3d(m=>k.concat(m),l)}e.$se=n;function i(l,m){return N.$ae(l,m,D=>k.concat(D))}e.$te=i;function t(l,m){return N.$be(l,m,D=>k.concat(D))}e.$ue=t;function r(l){let m=0,D=0,T=0;const z=new Uint8Array(Math.floor(l.length/4*3)),U=Z=>{switch(D){case 3:z[T++]=m|Z,D=0;break;case 2:z[T++]=m|Z>>>2,m=Z<<6,D=3;break;case 1:z[T++]=m|Z>>>4,m=Z<<4,D=2;break;default:m=Z<<2,D=1}};for(let Z=0;Z<l.length;Z++){const Q=l.charCodeAt(Z);if(Q>=65&&Q<=90)U(Q-65);else if(Q>=97&&Q<=122)U(Q-97+26);else if(Q>=48&&Q<=57)U(Q-48+52);else if(Q===43||Q===45)U(62);else if(Q===47||Q===95)U(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${l[Z]}`)}}const B=T;for(;D>0;)U(0);return k.wrap(z).slice(0,B)}e.$ve=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:l},m=!0,D=!1){const T=D?v:a;let z="";const U=l.byteLength%3;let B=0;for(;B<l.byteLength-U;B+=3){const Z=l[B+0],Q=l[B+1],x=l[B+2];z+=T[Z>>>2],z+=T[(Z<<4|Q>>>4)&63],z+=T[(Q<<2|x>>>6)&63],z+=T[x&63]}if(U===1){const Z=l[B+0];z+=T[Z>>>2],z+=T[Z<<4&63],m&&(z+="==")}else if(U===2){const Z=l[B+0],Q=l[B+1];z+=T[Z>>>2],z+=T[(Z<<4|Q>>>4)&63],z+=T[Q<<2&63],m&&(z+="=")}return z}e.$we=w}),define(oe[27],ae([0,1,128,60]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yf=e.$xf=e.$wf=e.$vf=e.GraphemeBreakType=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function L(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.$Ce=L;const A=/{(\d+)}/g;function O(se,...fe){return fe.length===0?se:se.replace(A,function(me,pe){const Se=parseInt(pe,10);return isNaN(Se)||Se<0||Se>=fe.length?me:fe[Se]})}e.$De=O;const R=/{([^}]+)}/g;function k(se,fe){return Object.keys(fe).length===0?se:se.replace(R,(me,pe)=>fe[pe]??me)}e.$Ee=k;function g(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Fe=g;function C(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ge=C;function S(se,fe){let me=0;const pe=fe.charCodeAt(0);for(let Se=se.length-1;Se>=0;Se--)se.charCodeAt(Se)===pe&&me++;return me}e.$He=S;function b(se,fe,me="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${me}`}e.$Ie=b;function c(se,fe=" "){const me=$(se,fe);return p(me,fe)}e.$Je=c;function $(se,fe){if(!se||!fe)return se;const me=fe.length;if(me===0||se.length===0)return se;let pe=0;for(;se.indexOf(fe,pe)===pe;)pe=pe+me;return se.substring(pe)}e.$Ke=$;function p(se,fe){if(!se||!fe)return se;const me=fe.length,pe=se.length;if(me===0||pe===0)return se;let Se=pe,Re=-1;for(;Re=se.lastIndexOf(fe,Se-1),!(Re===-1||Re+me!==Se);){if(Re===0)return"";Se=Re}return se.substring(0,Se)}e.$Le=p;function y(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Me=y;function h(se){return se.replace(/\*/g,"")}e.$Ne=h;function f(se,fe,me={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=C(se)),me.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(se,pe)}e.$Oe=f;function u(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.$Pe=u;function d(se){return se.split(/\r\n|\r|\n/)}e.$Qe=d;function E(se){for(let fe=0,me=se.length;fe<me;fe++){const pe=se.charCodeAt(fe);if(pe!==32&&pe!==9)return fe}return-1}e.$Re=E;function s(se,fe=0,me=se.length){for(let pe=fe;pe<me;pe++){const Se=se.charCodeAt(pe);if(Se!==32&&Se!==9)return se.substring(fe,pe)}return se.substring(fe,me)}e.$Se=s;function o(se,fe=se.length-1){for(let me=fe;me>=0;me--){const pe=se.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$Te=o;function n(se,fe,me){const pe=[];let Se=0;for(const Re of se.matchAll(fe)){if(pe.push(se.slice(Se,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Se=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,se,Re.groups))}return pe.push(se.slice(Se)),Promise.all(pe).then(Re=>Re.join(""))}e.$Ue=n;function i(se,fe){return se<fe?-1:se>fe?1:0}e.$Ve=i;function t(se,fe,me=0,pe=se.length,Se=0,Re=fe.length){for(;me<pe&&Se<Re;me++,Se++){const De=se.charCodeAt(me),Ae=fe.charCodeAt(Se);if(De<Ae)return-1;if(De>Ae)return 1}const Ce=pe-me,Ie=Re-Se;return Ce<Ie?-1:Ce>Ie?1:0}e.$We=t;function r(se,fe){return a(se,fe,0,se.length,0,fe.length)}e.$Xe=r;function a(se,fe,me=0,pe=se.length,Se=0,Re=fe.length){for(;me<pe&&Se<Re;me++,Se++){let De=se.charCodeAt(me),Ae=fe.charCodeAt(Se);if(De===Ae)continue;if(De>=128||Ae>=128)return t(se.toLowerCase(),fe.toLowerCase(),me,pe,Se,Re);w(De)&&(De-=32),w(Ae)&&(Ae-=32);const Te=De-Ae;if(Te!==0)return Te}const Ce=pe-me,Ie=Re-Se;return Ce<Ie?-1:Ce>Ie?1:0}e.$Ye=a;function v(se){return se>=48&&se<=57}e.$Ze=v;function w(se){return se>=97&&se<=122}e.$1e=w;function l(se){return se>=65&&se<=90}e.$2e=l;function m(se,fe){return se.length===fe.length&&a(se,fe)===0}e.$3e=m;function D(se,fe){const me=fe.length;return fe.length>se.length?!1:a(se,fe,0,me)===0}e.$4e=D;function T(se,fe){const me=Math.min(se.length,fe.length);let pe;for(pe=0;pe<me;pe++)if(se.charCodeAt(pe)!==fe.charCodeAt(pe))return pe;return me}e.$5e=T;function z(se,fe){const me=Math.min(se.length,fe.length);let pe;const Se=se.length-1,Re=fe.length-1;for(pe=0;pe<me;pe++)if(se.charCodeAt(Se-pe)!==fe.charCodeAt(Re-pe))return pe;return me}e.$6e=z;function U(se){return 55296<=se&&se<=56319}e.$7e=U;function B(se){return 56320<=se&&se<=57343}e.$8e=B;function Z(se,fe){return(se-55296<<10)+(fe-56320)+65536}e.$9e=Z;function Q(se,fe,me){const pe=se.charCodeAt(me);if(U(pe)&&me+1<fe){const Se=se.charCodeAt(me+1);if(B(Se))return Z(pe,Se)}return pe}e.$0e=Q;function x(se,fe){const me=se.charCodeAt(fe-1);if(B(me)&&fe>1){const pe=se.charCodeAt(fe-2);if(U(pe))return Z(pe,me)}return me}class W{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=x(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=Q(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$$e=W;class X{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new W(fe,me)}nextGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let Se=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.nextCodePoint());if(Me(Se,Ce)){me.setOffset(Re);break}Se=Ce}return me.offset-pe}prevGraphemeLength(){const fe=ge.getInstance(),me=this.c,pe=me.offset;let Se=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=fe.getGraphemeBreakType(me.prevCodePoint());if(Me(Ce,Se)){me.setOffset(Re);break}Se=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$_e=X;function G(se,fe){return new X(se,fe).nextGraphemeLength()}e.$af=G;function V(se,fe){return new X(se,fe).prevGraphemeLength()}e.$bf=V;function ee(se,fe){fe>0&&B(se.charCodeAt(fe))&&fe--;const me=fe+G(se,fe);return[me-V(se,me),me]}e.$cf=ee;function ie(se){const fe=new X(se);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$df=ie;let _;function ne(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(se){return _||(_=ne()),_.test(se)}e.$ef=K;const q=/^[\t\n\r\x20-\x7E]*$/;function P(se){return q.test(se)}e.$ff=P,e.$gf=/[\u2028\u2029]/;function j(se){return e.$gf.test(se)}e.$hf=j;function M(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.$if=M;function F(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.$jf=F;function H(se,fe){if(se.length<fe)return se;const me=/\b/g;let pe=0;for(;me.test(se)&&!(se.length-me.lastIndex<fe);)pe=me.lastIndex,me.lastIndex+=1;return se.substring(pe).replace(/^\s/,"")}e.$kf=H;const J=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function ce(se){return se&&(se=se.replace(J,"").replace(re,"")),se}e.$lf=ce,e.$mf=String.fromCharCode(65279);function ue(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.$nf=ue;function he(se){return ue(se)?se.substr(1):se}e.$of=he;function $e(se,fe){if(!se||!fe||se.length<fe.length)return!1;const me=fe.length,pe=se.toLowerCase();let Se=0,Re=-1;for(;Se<me;){const Ce=pe.indexOf(fe[Se],Re+1);if(Ce<0)return!1;Re=Ce,Se++}return!0}e.$pf=$e;function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.$qf=de;function we(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.$rf=we;function ve(se,fe=1){if(fe===0)return"";let me=-1;do me=se.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?se:(se[me-1]==="\r"&&me--,se.substr(0,me))}e.$sf=ve;function Oe(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.$tf=Oe;function Ne(se){return ge.getInstance().getGraphemeBreakType(se)}e.$uf=Ne;function Me(se,fe){return se===0?fe!==5&&fe!==7:se===2&&fe===3?!1:se===4||se===2||se===3||fe===4||fe===2||fe===3?!0:!(se===8&&(fe===8||fe===9||fe===11||fe===12)||(se===11||se===9)&&(fe===9||fe===10)||(se===12||se===10)&&fe===10||fe===5||fe===13||fe===7||se===1||se===13&&fe===14||se===6&&fe===6)}var le;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(le||(e.GraphemeBreakType=le={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,pe=me.length/3;let Se=1;for(;Se<=pe;)if(fe<me[3*Se])Se=2*Se;else if(fe>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ke(se,fe){if(se===0)return 0;const me=Pe(se,fe);if(me!==void 0)return me;const pe=new W(fe,se);return pe.prevCodePoint(),pe.offset}e.$vf=ke;function Pe(se,fe){const me=new W(fe,se);let pe=me.prevCodePoint();for(;ze(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!F(pe))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function ze(se){return 127995<=se&&se<=127999}var je;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$wf="\xA0";class Ue{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$ye(fe=>{function me(Te){const Be=new Map;for(let qe=0;qe<Te.length;qe+=2)Be.set(Te[qe],Te[qe+1]);return Be}function pe(Te,Be){const qe=new Map(Te);for(const[We,_e]of Be)qe.set(We,_e);return qe}function Se(Te,Be){if(!Te)return Be;const qe=new Map;for(const[We,_e]of Te)Be.has(We)&&qe.set(We,_e);return qe}const Re=this.c.value;let Ce=fe.filter(Te=>!Te.startsWith("_")&&Te in Re);Ce.length===0&&(Ce=["_default"]);let Ie;for(const Te of Ce){const Be=me(Re[Te]);Ie=Se(Ie,Be)}const De=me(Re._common),Ae=pe(De,Ie);return new Ue(Ae)})}static getInstance(fe){return Ue.d.get(Array.from(fe))}static{this.e=new N.$V(()=>Object.keys(Ue.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$xf=Ue;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(fe){return Fe.e().has(fe)}static get codePoints(){return Fe.e()}}e.$yf=Fe}),define(oe[52],ae([0,1,27]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;function N(h){return L(h,0)}e.$Ei=N;function L(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?k(h,f):g(h,f);case"string":return R(h,f);case"boolean":return O(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$Fi=L;function A(h,f){return(f<<5)-f+h|0}e.$Gi=A;function O(h,f){return A(h?433:863,f)}function R(h,f){f=A(149417,f);for(let u=0,d=h.length;u<d;u++)f=A(h.charCodeAt(u),f);return f}e.$Hi=R;function k(h,f){return f=A(104579,f),h.reduce((u,d)=>L(d,u),f)}function g(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((u,d)=>(u=R(d,u),L(h[d],u)),f)}class C{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=L(f,this.g),this.g}}e.$Ii=C;var S;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function b(h,f,u=32){const d=u-f,E=~((1<<d)-1);return(h<<f|(E&h)>>>d)>>>0}function c(h,f=0,u=h.byteLength,d=0){for(let E=0;E<u;E++)h[f+E]=d}function $(h,f,u="0"){for(;h.length<f;)h=u+h;return h}function p(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(u=>u.toString(16).padStart(2,"0")).join(""):$((h>>>0).toString(16),f/4)}e.$Ji=p;class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const u=f.length;if(u===0)return;const d=this.p;let E=this.r,s=this.u,o,n;for(s!==0?(o=s,n=-1,s=0):(o=f.charCodeAt(0),n=0);;){let i=o;if(I.$7e(o))if(n+1<u){const t=f.charCodeAt(n+1);I.$8e(t)?(n++,i=I.$9e(o,t)):i=65533}else{s=o;break}else I.$8e(o)&&(i=65533);if(E=this.w(d,E,i),n++,n<u)o=f.charCodeAt(n);else break}this.r=E,this.u=s}w(f,u,d){return d<128?f[u++]=d:d<2048?(f[u++]=192|(d&1984)>>>6,f[u++]=128|(d&63)>>>0):d<65536?(f[u++]=224|(d&61440)>>>12,f[u++]=128|(d&4032)>>>6,f[u++]=128|(d&63)>>>0):(f[u++]=240|(d&1835008)>>>18,f[u++]=128|(d&258048)>>>12,f[u++]=128|(d&4032)>>>6,f[u++]=128|(d&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=y.g,u=this.q;for(let a=0;a<64;a+=4)f.setUint32(a,u.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)f.setUint32(a,b(f.getUint32(a-12,!1)^f.getUint32(a-32,!1)^f.getUint32(a-56,!1)^f.getUint32(a-64,!1),1),!1);let d=this.h,E=this.l,s=this.m,o=this.n,n=this.o,i,t,r;for(let a=0;a<80;a++)a<20?(i=E&s|~E&o,t=1518500249):a<40?(i=E^s^o,t=1859775393):a<60?(i=E&s|E&o|s&o,t=2400959708):(i=E^s^o,t=3395469782),r=b(d,5)+i+n+t+f.getUint32(a*4,!1)&4294967295,n=o,o=s,s=b(E,30),E=d,d=r;this.h=this.h+d&4294967295,this.l=this.l+E&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$Ki=y}),define(oe[89],ae([0,1,27]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const A="error",O="warning",R="warn",k="info",g="ignore";function C(b){return b?I.$3e(A,b)?L.Error:I.$3e(O,b)||I.$3e(R,b)?L.Warning:I.$3e(k,b)?L.Info:L.Ignore:L.Ignore}L.fromValue=C;function S(b){switch(b){case L.Error:return A;case L.Warning:return O;case L.Info:return k;default:return g}}L.toString=S}(N||(N={})),e.default=N}),define(oe[129],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,18,27]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class L{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const $=c.charCodeAt(0),p=this.b.charCodeAt(this.c);return $-p}value(){return this.b[this.c]}}e.$Sh=L;class A{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,N.$We)(c,this.b,0,c.length,this.c,this.d):(0,N.$Ye)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Th=A;class O{constructor(c=!0,$=!0){this.f=c,this.g=$}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let $=c.length-1;$>=0;$--,this.c--){const p=this.b.charCodeAt($);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,N.$We)(c,this.b,0,c.length,this.d,this.e):(0,N.$Ye)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Uh=O;var R;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(R||(R={}));class k{constructor(c,$){this.f=c,this.g=$,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(3)),this.g(c)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===1)return(0,N.$Xe)(c,this.c.scheme);if(this.d[this.e]===2)return(0,N.$Xe)(c,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(c);if(this.d[this.e]===4)return(0,N.$Ve)(c,this.c.query);if(this.d[this.e]===5)return(0,N.$Ve)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Vh=k;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(C||(C={}));class S{static forUris(c=()=>!1,$=()=>!1){return new S(new k(c,$))}static forPaths(c=!1){return new S(new O(void 0,!c))}static forStrings(){return new S(new L)}static forConfigKeys(){return new S(new A)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,$){if($){const p=$.slice(0);(0,I.$Xb)(p);for(const y of p)this.set(y,c)}else{const p=c.slice(0);(0,I.$Xb)(p);for(const y of p)this.set(y[0],y[1])}}set(c,$){const p=this.b.reset(c);let y;this.c||(this.c=new g,this.c.segment=p.value());const h=[];for(y=this.c;;){const u=p.cmp(y.segment);if(u>0)y.left||(y.left=new g,y.left.segment=p.value()),h.push([-1,y]),y=y.left;else if(u<0)y.right||(y.right=new g,y.right.segment=p.value()),h.push([1,y]),y=y.right;else if(p.hasNext())p.next(),y.mid||(y.mid=new g,y.mid.segment=p.value()),h.push([0,y]),y=y.mid;else break}const f=y.value;y.value=$,y.key=c;for(let u=h.length-1;u>=0;u--){const d=h[u][1];d.updateHeight();const E=d.balanceFactor();if(E<-1||E>1){const s=h[u][0],o=h[u+1][0];if(s===1&&o===1)h[u][1]=d.rotateLeft();else if(s===-1&&o===-1)h[u][1]=d.rotateRight();else if(s===1&&o===-1)d.right=h[u+1][1]=h[u+1][1].rotateRight(),h[u][1]=d.rotateLeft();else if(s===-1&&o===1)d.left=h[u+1][1]=h[u+1][1].rotateLeft(),h[u][1]=d.rotateRight();else throw new Error;if(u>0)switch(h[u-1][0]){case-1:h[u-1][1].left=h[u][1];break;case 1:h[u-1][1].right=h[u][1];break;case 0:h[u-1][1].mid=h[u][1];break}else this.c=h[0][1]}}return f}get(c){return this.d(c)?.value}d(c){const $=this.b.reset(c);let p=this.c;for(;p;){const y=$.cmp(p.segment);if(y>0)p=p.left;else if(y<0)p=p.right;else if($.hasNext())$.next(),p=p.mid;else break}return p}has(c){const $=this.d(c);return!($?.value===void 0&&$?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,$){const p=this.b.reset(c),y=[];let h=this.c;for(;h;){const f=p.cmp(h.segment);if(f>0)y.push([-1,h]),h=h.left;else if(f<0)y.push([1,h]),h=h.right;else if(p.hasNext())p.next(),y.push([0,h]),h=h.mid;else break}if(h){if($?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const f=this.f(h.right);if(f.key){const{key:u,value:d,segment:E}=f;this.e(f.key,!1),h.key=u,h.value=d,h.segment=E}}else{const f=h.left??h.right;if(y.length>0){const[u,d]=y[y.length-1];switch(u){case-1:d.left=f;break;case 0:d.mid=f;break;case 1:d.right=f;break}}else this.c=f}for(let f=y.length-1;f>=0;f--){const u=y[f][1];u.updateHeight();const d=u.balanceFactor();if(d>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),y[f][1]=u.rotateLeft()):d<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),y[f][1]=u.rotateRight()),f>0)switch(y[f-1][0]){case-1:y[f-1][1].left=y[f][1];break;case 1:y[f-1][1].right=y[f][1];break;case 0:y[f-1][1].mid=y[f][1];break}else this.c=y[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const $=this.b.reset(c);let p=this.c,y;for(;p;){const h=$.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if($.hasNext())$.next(),y=p.value||y,p=p.mid;else break}return p&&p.value||y}findSuperstr(c){return this.g(c,!1)}g(c,$){const p=this.b.reset(c);let y=this.c;for(;y;){const h=p.cmp(y.segment);if(h>0)y=y.left;else if(h<0)y=y.right;else if(p.hasNext())p.next(),y=y.mid;else return y.mid?this.h(y.mid):$?y.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[$,p]of this)c(p,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const $=[];return this.j(c,$),$[Symbol.iterator]()}j(c,$){c&&(c.left&&this.j(c.left,$),c.value&&$.push([c.key,c.value]),c.mid&&this.j(c.mid,$),c.right&&this.j(c.right,$))}_isBalanced(){const c=$=>{if(!$)return!0;const p=$.balanceFactor();return p<-1||p>1?!1:c($.left)&&c($.right)};return c(this.c)}}e.$Wh=S}),define(oe[12],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=void 0;function I(E){return typeof E=="string"}e.$zf=I;function N(E){return Array.isArray(E)&&E.every(s=>I(s))}e.$Af=N;function L(E){return typeof E=="object"&&E!==null&&!Array.isArray(E)&&!(E instanceof RegExp)&&!(E instanceof Date)}e.$Bf=L;function A(E){const s=Object.getPrototypeOf(Uint8Array);return typeof E=="object"&&E instanceof s}e.$Cf=A;function O(E){return typeof E=="number"&&!isNaN(E)}e.$Df=O;function R(E){return!!E&&typeof E[Symbol.iterator]=="function"}e.$Ef=R;function k(E){return E===!0||E===!1}e.$Ff=k;function g(E){return typeof E>"u"}e.$Gf=g;function C(E){return!S(E)}e.$Hf=C;function S(E){return g(E)||E===null}e.$If=S;function b(E,s){if(!E)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$Jf=b;function c(E){if(S(E))throw new Error("Assertion Failed: argument is undefined or null");return E}e.$Kf=c;function $(...E){const s=[];for(let o=0;o<E.length;o++){const n=E[o];if(S(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);s.push(n)}return s}e.$Lf=$;const p=Object.prototype.hasOwnProperty;function y(E){if(!L(E))return!1;for(const s in E)if(p.call(E,s))return!1;return!0}e.$Mf=y;function h(E){return typeof E=="function"}e.$Nf=h;function f(...E){return E.length>0&&E.every(h)}e.$Of=f;function u(E,s){const o=Math.min(E.length,s.length);for(let n=0;n<o;n++)d(E[n],s[n])}e.$Pf=u;function d(E,s){if(I(s)){if(typeof E!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(h(s)){try{if(E instanceof s)return}catch{}if(!S(E)&&E.constructor===s||s.length===1&&s.call(void 0,E)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Qf=d}),define(oe[30],ae([0,1,12]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=void 0;function N(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const E=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([s,o])=>{E[s]=o&&typeof o=="object"?N(o):o}),E}e.$8m=N;function L(d){if(!d||typeof d!="object")return d;const E=[d];for(;E.length>0;){const s=E.shift();Object.freeze(s);for(const o in s)if(A.call(s,o)){const n=s[o];typeof n=="object"&&!Object.isFrozen(n)&&!(0,I.$Cf)(n)&&E.push(n)}}return d}e.$9m=L;const A=Object.prototype.hasOwnProperty;function O(d,E){return R(d,E,new Set)}e.$0m=O;function R(d,E,s){if((0,I.$If)(d))return d;const o=E(d);if(typeof o<"u")return o;if(Array.isArray(d)){const n=[];for(const i of d)n.push(R(i,E,s));return n}if((0,I.$Bf)(d)){if(s.has(d))throw new Error("Cannot clone recursive data-structure");s.add(d);const n={};for(const i in d)A.call(d,i)&&(n[i]=R(d[i],E,s));return s.delete(d),n}return d}function k(d,E,s=!0){return(0,I.$Bf)(d)?((0,I.$Bf)(E)&&Object.keys(E).forEach(o=>{o in d?s&&((0,I.$Bf)(d[o])&&(0,I.$Bf)(E[o])?k(d[o],E[o],s):d[o]=E[o]):d[o]=E[o]}),d):E}e.$$m=k;function g(d,E){if(d===E)return!0;if(d==null||E===null||E===void 0||typeof d!=typeof E||typeof d!="object"||Array.isArray(d)!==Array.isArray(E))return!1;let s,o;if(Array.isArray(d)){if(d.length!==E.length)return!1;for(s=0;s<d.length;s++)if(!g(d[s],E[s]))return!1}else{const n=[];for(o in d)n.push(o);n.sort();const i=[];for(o in E)i.push(o);if(i.sort(),!g(n,i))return!1;for(s=0;s<n.length;s++)if(!g(d[n[s]],E[n[s]]))return!1}return!0}e.$_m=g;function C(d){const E=new Set;return JSON.stringify(d,(s,o)=>{if((0,I.$Bf)(o)||Array.isArray(o)){if(E.has(o))return"[Circular]";E.add(o)}return o})}e.$an=C;function S(d,E){const s=Object.create(null);return!d||!E||Object.keys(E).forEach(n=>{const i=d[n],t=E[n];g(i,t)||(s[n]=t)}),s}e.$bn=S;function b(d,E){const s=E.toLowerCase(),o=Object.keys(d).find(n=>n.toLowerCase()===s);return o?d[o]:d[E]}e.$cn=b;function c(d,E){const s=Object.create(null);for(const[o,n]of Object.entries(d))E(o,n)&&(s[o]=n);return s}e.$dn=c;function $(d){let E=[];for(;Object.prototype!==d;)E=E.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return E}e.$en=$;function p(d){const E=[];for(const s of $(d))typeof d[s]=="function"&&E.push(s);return E}e.$fn=p;function y(d,E){const s=n=>function(){const i=Array.prototype.slice.call(arguments,0);return E(n,i)},o={};for(const n of d)o[n]=s(n);return o}e.$gn=y;function h(d,E,s){typeof E=="string"&&d[E]!==void 0&&typeof d[E]!="boolean"&&(d[E]=s)}e.$hn=h;function f(d,E,s){typeof E=="string"&&d[E]!==void 0&&typeof d[E]!="number"&&(d[E]=s)}e.$in=f;function u(d,E,s,o){if(typeof E!="string")return;const n=d[E];n!==void 0&&(typeof n!="string"||!s.includes(n))&&(d[E]=o)}e.$jn=u}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return I.test(L)}e.$eg=N,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(R){for(let k=0;k<R.length;k++)R[k]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let k=0,g="";return g+=O[A[k++]],g+=O[A[k++]],g+=O[A[k++]],g+=O[A[k++]],g+="-",g+=O[A[k++]],g+=O[A[k++]],g+="-",g+=O[A[k++]],g+=O[A[k++]],g+="-",g+=O[A[k++]],g+=O[A[k++]],g+="-",g+=O[A[k++]],g+=O[A[k++]],g+=O[A[k++]],g+=O[A[k++]],g+=O[A[k++]],g+=O[A[k++]],g}}()}),define(oe[130],ae([0,1,36]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const R=O.replace(/\-/g,":").toLowerCase();return!N.has(R)}function A(){const O=(0,I.networkInterfaces)();for(const R in O){const k=O[R];if(k){for(const{mac:g}of k)if(L(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Rm=A}),define(oe[131],ae([0,1,266,15]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sT=void 0;class L extends I.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const R=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(O,R,k){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,N.$de)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),k()}_flush(O){this.a&&this.push(this.a),O()}}e.$sT=L}),define(oe[132],ae([0,1,62]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=e.$ig=e.$hg=void 0;function N(R,k,g,C=1){let S=!1;return new Promise(b=>{const c=setTimeout(()=>{if(!S)return S=!0,b(0)},g);L(R,k,C,$=>{if(!S)return S=!0,clearTimeout(c),b($)})})}e.$hg=N;function L(R,k,g,C){if(k===0)return C(0);const S=new I.Socket;S.once("connect",()=>(O(S),L(R+g,k-1,g,C))),S.once("data",()=>{}),S.once("error",b=>(O(S),b.code!=="ECONNREFUSED"?L(R+g,k-1,g,C):C(R))),S.connect(R,"127.0.0.1")}e.$ig={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,k,g,C="127.0.0.1"){let S=!1,b,c=1;const $=I.createServer({pauseOnConnect:!0});function p(y,h){S||(S=!0,$.removeAllListeners(),$.close(),b&&clearTimeout(b),h(y))}return new Promise(y=>{b=setTimeout(()=>{p(0,y)},g),$.on("listening",()=>{p(R,y)}),$.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&c<k?(R++,c++,$.listen(R,C)):p(0,y)}),$.on("close",()=>{p(0,y)}),$.listen(R,C)})}e.$jg=A;function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(k){console.error(k)}}}),define(oe[133],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IT=void 0;function I(N){return!!N.parentPort}e.$IT=I}),define(oe[134],ae([13,9]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[63],ae([0,1,134]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=void 0;const N=60,L=N*60,A=L*24,O=A*7,R=A*30,k=A*365;function g(S,b,c,$){typeof S!="number"&&(S=S.getTime());const p=Math.round((new Date().getTime()-S)/1e3);if(p<-30)return(0,I.localize)(0,null,g(new Date().getTime()+p*1e3,!1));if(!$&&p<30)return(0,I.localize)(1,null);let y;return p<N?(y=p,b?y===1?c?(0,I.localize)(2,null,y):(0,I.localize)(3,null,y):c?(0,I.localize)(4,null,y):(0,I.localize)(5,null,y):y===1?c?(0,I.localize)(6,null,y):(0,I.localize)(7,null,y):c?(0,I.localize)(8,null,y):(0,I.localize)(9,null,y)):p<L?(y=Math.floor(p/N),b?y===1?c?(0,I.localize)(10,null,y):(0,I.localize)(11,null,y):c?(0,I.localize)(12,null,y):(0,I.localize)(13,null,y):y===1?c?(0,I.localize)(14,null,y):(0,I.localize)(15,null,y):c?(0,I.localize)(16,null,y):(0,I.localize)(17,null,y)):p<A?(y=Math.floor(p/L),b?y===1?c?(0,I.localize)(18,null,y):(0,I.localize)(19,null,y):c?(0,I.localize)(20,null,y):(0,I.localize)(21,null,y):y===1?c?(0,I.localize)(22,null,y):(0,I.localize)(23,null,y):c?(0,I.localize)(24,null,y):(0,I.localize)(25,null,y)):p<O?(y=Math.floor(p/A),b?y===1?(0,I.localize)(26,null,y):(0,I.localize)(27,null,y):y===1?(0,I.localize)(28,null,y):(0,I.localize)(29,null,y)):p<R?(y=Math.floor(p/O),b?y===1?c?(0,I.localize)(30,null,y):(0,I.localize)(31,null,y):c?(0,I.localize)(32,null,y):(0,I.localize)(33,null,y):y===1?c?(0,I.localize)(34,null,y):(0,I.localize)(35,null,y):c?(0,I.localize)(36,null,y):(0,I.localize)(37,null,y)):p<k?(y=Math.floor(p/R),b?y===1?c?(0,I.localize)(38,null,y):(0,I.localize)(39,null,y):c?(0,I.localize)(40,null,y):(0,I.localize)(41,null,y):y===1?c?(0,I.localize)(42,null,y):(0,I.localize)(43,null,y):c?(0,I.localize)(44,null,y):(0,I.localize)(45,null,y)):(y=Math.floor(p/k),b?y===1?c?(0,I.localize)(46,null,y):(0,I.localize)(47,null,y):c?(0,I.localize)(48,null,y):(0,I.localize)(49,null,y):y===1?c?(0,I.localize)(50,null,y):(0,I.localize)(51,null,y):c?(0,I.localize)(52,null,y):(0,I.localize)(53,null,y))}e.$em=g;function C(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$fm=C}),define(oe[135],ae([13,9]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,18,12,135]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=void 0;function A(S,b){return b&&(S.stack||S.stacktrace)?L.localize(0,null,R(S),O(S.stack)||O(S.stacktrace)):R(S)}function O(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?L.localize(1,null,S.message):S.message||L.localize(2,null)}function k(S=null,b=!1){if(!S)return L.localize(3,null);if(Array.isArray(S)){const c=I.$Hb(S),$=k(c[0],b);return c.length>1?L.localize(4,null,$,c.length):$}if(N.$zf(S))return S;if(S.detail){const c=S.detail;if(c.error)return A(c.error,b);if(c.exception)return A(c.exception,b)}return S.stack?A(S,b):S.message?S.message:L.localize(5,null)}e.$Bi=k;function g(S){const b=S;return b instanceof Error&&Array.isArray(b.actions)}e.$Ci=g;function C(S,b){let c;return typeof S=="string"?c=new Error(S):c=S,c.actions=b,c}e.$Di=C}),define(oe[136],ae([13,9]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[137],ae([0,1,136]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;function N(L){switch(L){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.$Ap=N}),define(oe[138],ae([13,9]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,138]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let N=!1,L=!1,A=!1,O=!1,R=!1,k=!1,g=!1,C=!1,S=!1,b=!1,c,$=e.$g,p=e.$g,y,h;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?f=e.$h.vscode.process:typeof process<"u"&&(f=process);const u=typeof f?.versions?.electron=="string",d=u&&f?.type==="renderer";if(typeof navigator=="object"&&!d)h=navigator.userAgent,N=h.indexOf("Windows")>=0,L=h.indexOf("Macintosh")>=0,C=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,b=h?.indexOf("Mobi")>=0,k=!0,c=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,$=c,p=navigator.language;else if(typeof f=="object"){N=f.platform==="win32",L=f.platform==="darwin",A=f.platform==="linux",O=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,g=u,S=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.$g,$=e.$g;const v=f.env.VSCODE_NLS_CONFIG;if(v)try{const w=JSON.parse(v),l=w.availableLanguages["*"];c=w.locale,p=w.osLocale,$=l||e.$g,y=w._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var E;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(E||(e.Platform=E={}));function s(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=s;let o=0;L?o=1:N?o=3:A&&(o=2),e.$j=N,e.$k=L,e.$l=A,e.$m=O,e.$n=R,e.$o=g,e.$p=k,e.$q=k&&typeof e.$h.importScripts=="function",e.$r=C,e.$s=b,e.$t=S,e.$u=o,e.$v=h,e.$w=$;var n;(function(v){function w(){return e.$w}v.value=w;function l(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=l;function m(){return e.$w==="en"}v.isDefault=m})(n||(e.Language=n={})),e.$x=c,e.$y=p,e.$z=y,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const v=[];e.$h.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let m=0,D=v.length;m<D;m++){const T=v[m];if(T.id===l.data.vscodeScheduleAsyncWork){v.splice(m,1),T.callback();return}}});let w=0;return l=>{const m=++w;v.push({id:m,callback:l}),e.$h.postMessage({vscodeScheduleAsyncWork:m},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=L||C?2:N?1:3;let t=!0,r=!1;function a(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,t=new Uint16Array(v.buffer)[0]===(2<<8)+1}return t}e.$D=a,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(oe[37],ae([0,1,5]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.process<"u"){const L=I.$h.vscode.process;N={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return I.$j?"win32":I.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(oe[16],ae([0,1,37]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,L=97,A=90,O=122,R=46,k=47,g=92,C=58,S=63;class b extends Error{constructor(o,n,i){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function c(s,o){if(s===null||typeof s!="object")throw new b(o,"Object",s)}function $(s,o){if(typeof s!="string")throw new b(o,"string",s)}const p=I.$dc==="win32";function y(s){return s===k||s===g}function h(s){return s===k}function f(s){return s>=N&&s<=A||s>=L&&s<=O}function u(s,o,n,i){let t="",r=0,a=-1,v=0,w=0;for(let l=0;l<=s.length;++l){if(l<s.length)w=s.charCodeAt(l);else{if(i(w))break;w=k}if(i(w)){if(!(a===l-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const m=t.lastIndexOf(n);m===-1?(t="",r=0):(t=t.slice(0,m),r=t.length-1-t.lastIndexOf(n)),a=l,v=0;continue}else if(t.length!==0){t="",r=0,a=l,v=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${s.slice(a+1,l)}`:t=s.slice(a+1,l),r=l-a-1;a=l,v=0}else w===R&&v!==-1?++v:v=-1}return t}function d(s,o){c(o,"pathObject");const n=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${i}`:`${n}${s}${i}`:i}e.$fc={resolve(...s){let o="",n="",i=!1;for(let t=s.length-1;t>=-1;t--){let r;if(t>=0){if(r=s[t],$(r,"path"),r.length===0)continue}else o.length===0?r=I.cwd():(r=I.env[`=${o}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let v=0,w="",l=!1;const m=r.charCodeAt(0);if(a===1)y(m)&&(v=1,l=!0);else if(y(m))if(l=!0,y(r.charCodeAt(1))){let D=2,T=D;for(;D<a&&!y(r.charCodeAt(D));)D++;if(D<a&&D!==T){const z=r.slice(T,D);for(T=D;D<a&&y(r.charCodeAt(D));)D++;if(D<a&&D!==T){for(T=D;D<a&&!y(r.charCodeAt(D));)D++;(D===a||D!==T)&&(w=`\\\\${z}\\${r.slice(T,D)}`,v=D)}}}else v=1;else f(m)&&r.charCodeAt(1)===C&&(w=r.slice(0,2),v=2,a>2&&y(r.charCodeAt(2))&&(l=!0,v=3));if(w.length>0)if(o.length>0){if(w.toLowerCase()!==o.toLowerCase())continue}else o=w;if(i){if(o.length>0)break}else if(n=`${r.slice(v)}\\${n}`,i=l,l&&o.length>0)break}return n=u(n,!i,"\\",y),i?`${o}\\${n}`:`${o}${n}`||"."},normalize(s){$(s,"path");const o=s.length;if(o===0)return".";let n=0,i,t=!1;const r=s.charCodeAt(0);if(o===1)return h(r)?"\\":s;if(y(r))if(t=!0,y(s.charCodeAt(1))){let v=2,w=v;for(;v<o&&!y(s.charCodeAt(v));)v++;if(v<o&&v!==w){const l=s.slice(w,v);for(w=v;v<o&&y(s.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!y(s.charCodeAt(v));)v++;if(v===o)return`\\\\${l}\\${s.slice(w)}\\`;v!==w&&(i=`\\\\${l}\\${s.slice(w,v)}`,n=v)}}}else n=1;else f(r)&&s.charCodeAt(1)===C&&(i=s.slice(0,2),n=2,o>2&&y(s.charCodeAt(2))&&(t=!0,n=3));let a=n<o?u(s.slice(n),!t,"\\",y):"";return a.length===0&&!t&&(a="."),a.length>0&&y(s.charCodeAt(o-1))&&(a+="\\"),i===void 0?t?`\\${a}`:a:t?`${i}\\${a}`:`${i}${a}`},isAbsolute(s){$(s,"path");const o=s.length;if(o===0)return!1;const n=s.charCodeAt(0);return y(n)||o>2&&f(n)&&s.charCodeAt(1)===C&&y(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,n;for(let r=0;r<s.length;++r){const a=s[r];$(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let i=!0,t=0;if(typeof n=="string"&&y(n.charCodeAt(0))){++t;const r=n.length;r>1&&y(n.charCodeAt(1))&&(++t,r>2&&(y(n.charCodeAt(2))?++t:i=!1))}if(i){for(;t<o.length&&y(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$fc.normalize(o)},relative(s,o){if($(s,"from"),$(o,"to"),s===o)return"";const n=e.$fc.resolve(s),i=e.$fc.resolve(o);if(n===i||(s=n.toLowerCase(),o=i.toLowerCase(),s===o))return"";let t=0;for(;t<s.length&&s.charCodeAt(t)===g;)t++;let r=s.length;for(;r-1>t&&s.charCodeAt(r-1)===g;)r--;const a=r-t;let v=0;for(;v<o.length&&o.charCodeAt(v)===g;)v++;let w=o.length;for(;w-1>v&&o.charCodeAt(w-1)===g;)w--;const l=w-v,m=a<l?a:l;let D=-1,T=0;for(;T<m;T++){const U=s.charCodeAt(t+T);if(U!==o.charCodeAt(v+T))break;U===g&&(D=T)}if(T!==m){if(D===-1)return i}else{if(l>m){if(o.charCodeAt(v+T)===g)return i.slice(v+T+1);if(T===2)return i.slice(v+T)}a>m&&(s.charCodeAt(t+T)===g?D=T:T===2&&(D=3)),D===-1&&(D=0)}let z="";for(T=t+D+1;T<=r;++T)(T===r||s.charCodeAt(T)===g)&&(z+=z.length===0?"..":"\\..");return v+=D,z.length>0?`${z}${i.slice(v,w)}`:(i.charCodeAt(v)===g&&++v,i.slice(v,w))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const o=e.$fc.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const n=o.charCodeAt(2);if(n!==S&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return s},dirname(s){$(s,"path");const o=s.length;if(o===0)return".";let n=-1,i=0;const t=s.charCodeAt(0);if(o===1)return y(t)?s:".";if(y(t)){if(n=i=1,y(s.charCodeAt(1))){let v=2,w=v;for(;v<o&&!y(s.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&y(s.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!y(s.charCodeAt(v));)v++;if(v===o)return s;v!==w&&(n=i=v+1)}}}}else f(t)&&s.charCodeAt(1)===C&&(n=o>2&&y(s.charCodeAt(2))?3:2,i=n);let r=-1,a=!0;for(let v=o-1;v>=i;--v)if(y(s.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return s.slice(0,r)},basename(s,o){o!==void 0&&$(o,"ext"),$(s,"path");let n=0,i=-1,t=!0,r;if(s.length>=2&&f(s.charCodeAt(0))&&s.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,v=-1;for(r=s.length-1;r>=n;--r){const w=s.charCodeAt(r);if(y(w)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=n;--r)if(y(s.charCodeAt(r))){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){$(s,"path");let o=0,n=-1,i=0,t=-1,r=!0,a=0;s.length>=2&&s.charCodeAt(1)===C&&f(s.charCodeAt(0))&&(o=i=2);for(let v=s.length-1;v>=o;--v){const w=s.charCodeAt(v);if(y(w)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),w===R?n===-1?n=v:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===i+1?"":s.slice(n,t)},format:d.bind(null,"\\"),parse(s){$(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.length;let i=0,t=s.charCodeAt(0);if(n===1)return y(t)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(y(t)){if(i=1,y(s.charCodeAt(1))){let D=2,T=D;for(;D<n&&!y(s.charCodeAt(D));)D++;if(D<n&&D!==T){for(T=D;D<n&&y(s.charCodeAt(D));)D++;if(D<n&&D!==T){for(T=D;D<n&&!y(s.charCodeAt(D));)D++;D===n?i=D:D!==T&&(i=D+1)}}}}else if(f(t)&&s.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=s,o;if(i=2,y(s.charCodeAt(2))){if(n===3)return o.root=o.dir=s,o;i=3}}i>0&&(o.root=s.slice(0,i));let r=-1,a=i,v=-1,w=!0,l=s.length-1,m=0;for(;l>=i;--l){if(t=s.charCodeAt(l),y(t)){if(!w){a=l+1;break}continue}v===-1&&(w=!1,v=l+1),t===R?r===-1?r=l:m!==1&&(m=1):r!==-1&&(m=-1)}return v!==-1&&(r===-1||m===0||m===1&&r===v-1&&r===a+1?o.base=o.name=s.slice(a,v):(o.name=s.slice(a,r),o.base=s.slice(a,v),o.ext=s.slice(r,v))),a>0&&a!==i?o.dir=s.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const E=(()=>{if(p){const s=/\\/g;return()=>{const o=I.cwd().replace(s,"/");return o.slice(o.indexOf("/"))}}return()=>I.cwd()})();e.$gc={resolve(...s){let o="",n=!1;for(let i=s.length-1;i>=-1&&!n;i--){const t=i>=0?s[i]:E();$(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===k)}return o=u(o,!n,"/",h),n?`/${o}`:o.length>0?o:"."},normalize(s){if($(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===k,n=s.charCodeAt(s.length-1)===k;return s=u(s,!o,"/",h),s.length===0?o?"/":n?"./":".":(n&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return $(s,"path"),s.length>0&&s.charCodeAt(0)===k},join(...s){if(s.length===0)return".";let o;for(let n=0;n<s.length;++n){const i=s[n];$(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(s,o){if($(s,"from"),$(o,"to"),s===o||(s=e.$gc.resolve(s),o=e.$gc.resolve(o),s===o))return"";const n=1,i=s.length,t=i-n,r=1,a=o.length-r,v=t<a?t:a;let w=-1,l=0;for(;l<v;l++){const D=s.charCodeAt(n+l);if(D!==o.charCodeAt(r+l))break;D===k&&(w=l)}if(l===v)if(a>v){if(o.charCodeAt(r+l)===k)return o.slice(r+l+1);if(l===0)return o.slice(r+l)}else t>v&&(s.charCodeAt(n+l)===k?w=l:l===0&&(w=0));let m="";for(l=n+w+1;l<=i;++l)(l===i||s.charCodeAt(l)===k)&&(m+=m.length===0?"..":"/..");return`${m}${o.slice(r+w)}`},toNamespacedPath(s){return s},dirname(s){if($(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===k;let n=-1,i=!0;for(let t=s.length-1;t>=1;--t)if(s.charCodeAt(t)===k){if(!i){n=t;break}}else i=!1;return n===-1?o?"/":".":o&&n===1?"//":s.slice(0,n)},basename(s,o){o!==void 0&&$(o,"ext"),$(s,"path");let n=0,i=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let a=o.length-1,v=-1;for(r=s.length-1;r>=0;--r){const w=s.charCodeAt(r);if(w===k){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return n===i?i=v:i===-1&&(i=s.length),s.slice(n,i)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===k){if(!t){n=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":s.slice(n,i)},extname(s){$(s,"path");let o=-1,n=0,i=-1,t=!0,r=0;for(let a=s.length-1;a>=0;--a){const v=s.charCodeAt(a);if(v===k){if(!t){n=a+1;break}continue}i===-1&&(t=!1,i=a+1),v===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===n+1?"":s.slice(o,i)},format:d.bind(null,"/"),parse(s){$(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const n=s.charCodeAt(0)===k;let i;n?(o.root="/",i=1):i=0;let t=-1,r=0,a=-1,v=!0,w=s.length-1,l=0;for(;w>=i;--w){const m=s.charCodeAt(w);if(m===k){if(!v){r=w+1;break}continue}a===-1&&(v=!1,a=w+1),m===R?t===-1?t=w:l!==1&&(l=1):t!==-1&&(l=-1)}if(a!==-1){const m=r===0&&n?1:r;t===-1||l===0||l===1&&t===a-1&&t===r+1?o.base=o.name=s.slice(m,a):(o.name=s.slice(m,t),o.base=s.slice(m,a),o.ext=s.slice(t,a))}return r>0?o.dir=s.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(oe[48],ae([0,1,16,5,27,12]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function O(r){return r===47||r===92}e.$Rf=O;function R(r){return r.replace(/[\\/]/g,I.$gc.sep)}e.$Sf=R;function k(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Tf=k;function g(r,a=I.$gc.sep){if(!r)return"";const v=r.length,w=r.charCodeAt(0);if(O(w)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let m=3;const D=m;for(;m<v&&!O(r.charCodeAt(m));m++);if(D!==m&&!O(r.charCodeAt(m+1))){for(m+=1;m<v;m++)if(O(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,a)}}return a}else if(h(w)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let l=r.indexOf("://");if(l!==-1){for(l+=3;l<v;l++)if(O(r.charCodeAt(l)))return r.slice(0,l+1)}return""}e.$Uf=g;function C(r){if(!N.$j||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const w=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(w===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$Vf=C;const S=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(r,a=N.$j){const v=a?S:b;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&c.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$Wf=$;function p(r,a,v){const w=r===a;return!v||w?w:!r||!a?!1:(0,L.$3e)(r,a)}e.$Xf=p;function y(r,a,v,w=I.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,L.$4e)(r,a))return!1;if(a.length===r.length)return!0;let m=a.length;return a.charAt(a.length-1)===w&&m--,r.charAt(m)===w}return a.charAt(a.length-1)!==w&&(a+=w),r.indexOf(a)===0}e.$Yf=y;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Zf=h;function f(r,a){return N.$j&&r.endsWith(":")&&(r+=I.sep),(0,I.$ic)(r)||(r=(0,I.$jc)(a,r)),r=(0,I.$hc)(r),N.$j?(r=(0,L.$Le)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,L.$Le)(r,I.sep),r||(r=I.sep)),r}e.$1f=f;function u(r){const a=(0,I.$hc)(r);return N.$j?r.length>3?!1:d(a)&&(r.length===2||a.charCodeAt(2)===92):a===I.$gc.sep}e.$2f=u;function d(r,a=N.$j){return a?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$3f=d;function E(r,a=N.$j){return d(r,a)?r[0]:void 0}e.$4f=E;function s(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$5f=s;function o(r){const a=r.split(":");let v,w,l;for(const m of a){const D=Number(m);(0,A.$Df)(D)?w===void 0?w=D:l===void 0&&(l=D):v=v?[v,m].join(":"):m}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:w!==void 0?w:void 0,column:l!==void 0?l:w!==void 0?1:void 0}}e.$6f=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let w="";for(let m=0;m<v;m++){let D;m===0&&N.$j&&!a&&(v===3||v===4)?D=i:D=n,w+=D.charAt(Math.floor(Math.random()*D.length))}let l;return a?l=`${a}-${w}`:l=w,r?(0,I.$jc)(r,l):l}e.$7f=t}),define(oe[139],ae([0,1,16]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=e.$Ur=e.$Tr=void 0,e.$Tr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const S=(0,I.$oc)(C),b=N[S.toLowerCase()];return b!==void 0?b:O(C)}e.$Ur=A;function O(C){const S=(0,I.$oc)(C);return L[S.toLowerCase()]}e.$Vr=O;function R(C){for(const S in L)if(L[S]===C)return S}e.$Wr=R;const k=/^(.+)\/(.+?)(;.+)?$/;function g(C,S){const b=k.exec(C);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:S?void 0:C}e.$Xr=g}),define(oe[90],ae([0,1,5]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.TerminateResponseCode=e.Source=void 0;var N;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(R,...k){const g=k.reduce((b,c)=>(b[c]=!0,b),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(b=>!g[b]).forEach(b=>{for(let c=0;c<C.length;c++)if(b.search(C[c])!==-1){delete R[b];break}})}e.$Al=A;function O(R){R&&(delete R.DEBUG,I.$k&&delete R.DYLD_LIBRARY_PATH,I.$l&&delete R.LD_PRELOAD)}e.$Bl=O}),define(oe[10],ae([0,1,16,5]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(i,t){return!i&&!t?"file":i}function g(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==S&&(t=S+t):t=S;break}return t}const C="",S="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(t){return t instanceof c?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,w,l=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=k(t,l),this.authority=r||C,this.path=g(this.scheme,a||C),this.query=v||C,this.fragment=w||C,R(this,l))}get fsPath(){return d(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:w,fragment:l}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),v===void 0?v=this.path:v===null&&(v=C),w===void 0?w=this.query:w===null&&(w=C),l===void 0?l=this.fragment:l===null&&(l=C),r===this.scheme&&a===this.authority&&v===this.path&&w===this.query&&l===this.fragment?this:new y(r,a,v,w,l)}static parse(t,r=!1){const a=b.exec(t);return a?new y(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new y(C,C,C,C,C)}static file(t){let r=C;if(N.$j&&(t=t.replace(/\\/g,S)),t[0]===S&&t[1]===S){const a=t.indexOf(S,2);a===-1?(r=t.substring(2),t=S):(r=t.substring(2,a),t=t.substring(a)||S)}return new y("file",r,t,C,C)}static from(t,r){return new y(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$j&&t.scheme==="file"?a=c.file(I.$fc.join(d(t,!0),...r)).path:a=I.$gc.join(t.path,...r),t.with({path:a})}toString(t=!1){return E(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof c)return t;{const r=new y(t);return r._formatted=t.external??null,r._fsPath=t._sep===p?t.fsPath??null:null,r}}else return t}}e.URI=c;function $(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=$;const p=N.$j?1:void 0;class y extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(t=!1){return t?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(i,t,r){let a,v=-1;for(let w=0;w<i.length;w++){const l=i.charCodeAt(w);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||t&&l===47||r&&l===91||r&&l===93||r&&l===58)v!==-1&&(a+=encodeURIComponent(i.substring(v,w)),v=-1),a!==void 0&&(a+=i.charAt(w));else{a===void 0&&(a=i.substr(0,w));const m=h[l];m!==void 0?(v!==-1&&(a+=encodeURIComponent(i.substring(v,w)),v=-1),a+=m):v===-1&&(v=w)}}return v!==-1&&(a+=encodeURIComponent(i.substring(v))),a!==void 0?a:i}function u(i){let t;for(let r=0;r<i.length;r++){const a=i.charCodeAt(r);a===35||a===63?(t===void 0&&(t=i.substr(0,r)),t+=h[a]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function d(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,N.$j&&(r=r.replace(/\//g,"\\")),r}e.$wc=d;function E(i,t){const r=t?u:f;let a="",{scheme:v,authority:w,path:l,query:m,fragment:D}=i;if(v&&(a+=v,a+=":"),(w||v==="file")&&(a+=S,a+=S),w){let T=w.indexOf("@");if(T!==-1){const z=w.substr(0,T);w=w.substr(T+1),T=z.lastIndexOf(":"),T===-1?a+=r(z,!1,!1):(a+=r(z.substr(0,T),!1,!1),a+=":",a+=r(z.substr(T+1),!1,!0)),a+="@"}w=w.toLowerCase(),T=w.lastIndexOf(":"),T===-1?a+=r(w,!1,!0):(a+=r(w.substr(0,T),!1,!0),a+=w.substr(T))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const T=l.charCodeAt(1);T>=65&&T<=90&&(l=`/${String.fromCharCode(T+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const T=l.charCodeAt(0);T>=65&&T<=90&&(l=`${String.fromCharCode(T+32)}:${l.substr(2)}`)}a+=r(l,!0,!1)}return m&&(a+="?",a+=r(m,!1,!1)),D&&(a+="#",a+=t?D:f(D,!1,!1)),a}function s(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+s(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(o)?i.replace(o,t=>s(t)):i}}),define(oe[140],ae([0,1,10]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$4p=e.$3p=e.$2p=void 0;function N(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$2p=N;function L(g){const C=[];let S;try{const b=JSON.parse(g.arguments),c=b[b.length-1];c&&c.__$stack&&(b.pop(),S=c.__$stack),C.push(...b)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:S}}e.$3p=L;function A(g){if(typeof g!="string")return A(L(g).stack);const C=g;if(C){const S=O(C),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(b&&b.length===4)return{uri:I.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$4p=A;function O(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function R(g,C){const{args:S,stack:b}=L(g),c=typeof S[0]=="string"&&S.length===1;let $=O(b);$&&($=`(${$.trim()})`);let p=[];if(typeof S[0]=="string"?$&&c?p=[`%c[${C}] %c${S[0]} %c${$}`,k("blue"),k(""),k("grey")]:p=[`%c[${C}] %c${S[0]}`,k("blue"),k(""),...S.slice(1)]:p=[`%c[${C}]%`,k("blue"),...S],$&&!c&&p.push($),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,p)}e.log=R;function k(g){return`color: ${g}`}}),define(oe[64],ae([0,1,15,10]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function L(k){return JSON.stringify(k,O)}e.$lh=L;function A(k){let g=JSON.parse(k);return g=R(g),g}e.$mh=A;function O(k,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(k,g=0){if(!k||g>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return N.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof I.$ce||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=R(k[C],g+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=R(k[C],g+1))}return k}e.$nh=R}),define(oe[23],ae([0,1,7,5,10]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var A;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$8f="vscode-tkn",e.$9f="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${A.vscodeRemoteResource}`}set(C,S,b){this.a[C]=S,this.b[C]=b}setConnectionToken(C,S){this.c[C]=S}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(y){return I.$1(y),C}const S=C.authority;let b=this.a[S];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const c=this.b[S],$=this.c[S];let p=`path=${encodeURIComponent(C.path)}`;return typeof $=="string"&&(p+=`&${e.$9f}=${encodeURIComponent($)}`),L.URI.from({scheme:N.$p?this.d:A.vscodeRemoteResource,authority:`${b}:${c}`,path:this.f,query:p})}}e.$0f=new O,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class R{static{this.a=e.$cg}asBrowserUri(C){const S=this.b(C,te);return this.uriToBrowserUri(S)}uriToBrowserUri(C){return C.scheme===A.vscodeRemote?e.$0f.rewrite(C):C.scheme===A.file&&(N.$n||N.$q&&N.$h.origin===`${A.vscodeFileResource}://${R.a}`)?C.with({scheme:A.vscodeFileResource,authority:C.authority||R.a,query:null,fragment:null}):C}asFileUri(C){const S=this.b(C,te);return this.uriToFileUri(S)}uriToFileUri(C){return C.scheme===A.vscodeFileResource?C.with({scheme:A.file,authority:C.authority!==R.a?C.authority:null,query:null,fragment:null}):C}b(C,S){return L.URI.isUri(C)?C:L.URI.parse(S.toUrl(C))}}e.$dg=new R;var k;(function(g){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(C.get("3"));const S="vscode-coi";function b($){let p;typeof $=="string"?p=new URL($).searchParams:$ instanceof URL?p=$.searchParams:L.URI.isUri($)&&(p=new URL($.toString(!0)).searchParams);const y=p?.get(S);if(y)return C.get(y)}g.getHeadersFromQuery=b;function c($,p,y){if(!globalThis.crossOriginIsolated)return;const h=p&&y?"3":y?"2":"1";$ instanceof URLSearchParams?$.set(S,h):$[S]=h}g.addSearchParam=c})(k||(e.COI=k={}))}),define(oe[141],ae([0,1,123,23,5,10]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=void 0;class O{constructor(b,c,$){this.id=b,this.dependencies=c,this.callback=$}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,c,$)=>{typeof b!="string"&&($=c,c=b,b=null),(typeof c!="object"||!Array.isArray(c))&&($=c,c=null),this.c.push(new O(b,c,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const c=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!c)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h(b){return new Promise((c,$)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const y=()=>{p.removeEventListener("load",h),p.removeEventListener("error",f)},h=u=>{y(),c(this.c.pop())},f=u=>{y(),$(u)};p.addEventListener("load",h),p.addEventListener("error",f),this.f&&(b=this.f.createScriptURL(b)),p.setAttribute("src",b),document.getElementsByTagName("head")[0].appendChild(p)})}i(b){return new Promise((c,$)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),c(this.c.pop())}catch(p){$(p)}})}async j(b){try{const c=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,y=A.URI.parse(b).fsPath,h=c.readFileSync(y).toString(),f=p.wrap(h.replace(/^#!.*/,""));return new $.Script(f).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const k=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(S,b,c){if(I.$T){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[S]&&(S=g[S]);const $=`${S}/${b}`;if(k.has($))return k.get($);let p;if(/^\w[\w\d+.-]*:\/\//.test($))p=$;else{const u=`${c&&!L.$p?N.$ag:N.$_f}/${$}`;p=N.$dg.asBrowserUri(u).toString(!0)}const y=R.INSTANCE.load(p);return k.set($,y),y}else return await new Promise(($,p)=>{te([S],$,p)})}e.$zC=C}),define(oe[19],ae([0,1,48,23,16,5,27,10]),function(te,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function k(c){return(0,R.$wc)(c,!0)}e.$kg=k;class g{constructor($){this.a=$}compare($,p,y=!1){return $===p?0:(0,O.$Ve)(this.getComparisonKey($,y),this.getComparisonKey(p,y))}isEqual($,p,y=!1){return $===p?!0:!$||!p?!1:this.getComparisonKey($,y)===this.getComparisonKey(p,y)}getComparisonKey($,p=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,p,y=!1){if($.scheme===p.scheme){if($.scheme===N.Schemas.file)return I.$Yf(k($),k(p),this.a($))&&$.query===p.query&&(y||$.fragment===p.fragment);if((0,e.$Bg)($.authority,p.authority))return I.$Yf($.path,p.path,this.a($),"/")&&$.query===p.query&&(y||$.fragment===p.fragment)}return!1}joinPath($,...p){return R.URI.joinPath($,...p)}basenameOrAuthority($){return(0,e.$tg)($)||$.authority}basename($){return L.$gc.basename($.path)}extname($){return L.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let p;return $.scheme===N.Schemas.file?p=R.URI.file(L.$mc(k($))).path:(p=L.$gc.dirname($.path),$.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),p="/")),$.with({path:p})}normalizePath($){if(!$.path.length)return $;let p;return $.scheme===N.Schemas.file?p=R.URI.file(L.$hc(k($))).path:p=L.$gc.normalize($.path),$.with({path:p})}relativePath($,p){if($.scheme!==p.scheme||!(0,e.$Bg)($.authority,p.authority))return;if($.scheme===N.Schemas.file){const f=L.$lc(k($),k(p));return A.$j?I.$Sf(f):f}let y=$.path||"/";const h=p.path||"/";if(this.a($)){let f=0;for(const u=Math.min(y.length,h.length);f<u&&!(y.charCodeAt(f)!==h.charCodeAt(f)&&y.charAt(f).toLowerCase()!==h.charAt(f).toLowerCase());f++);y=h.substr(0,f)+y.substr(f)}return L.$gc.relative(y,h)}resolvePath($,p){if($.scheme===N.Schemas.file){const y=R.URI.file(L.$kc(k($),p));return $.with({authority:y.authority,path:y.path})}return p=I.$Tf(p),$.with({path:L.$gc.resolve($.path,p)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,p){return $===p||$!==void 0&&p!==void 0&&(0,O.$3e)($,p)}hasTrailingPathSeparator($,p=L.sep){if($.scheme===N.Schemas.file){const y=k($);return y.length>I.$Uf(y).length&&y[y.length-1]===p}else{const y=$.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,p=L.sep){return(0,e.$Cg)($,p)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,p=L.sep){let y=!1;if($.scheme===N.Schemas.file){const h=k($);y=h!==void 0&&h.length===I.$Uf(h).length&&h[h.length-1]===p}else{p="/";const h=$.path;y=h.length===1&&h.charCodeAt(h.length-1)===47}return!y&&!(0,e.$Cg)($,p)?$.with({path:$.path+"/"}):$}}e.$lg=g,e.$mg=new g(()=>!1),e.$ng=new g(c=>c.scheme===N.Schemas.file?!A.$l:!0),e.$og=new g(c=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function C(c,$){const p=[];for(let y=0;y<c.length;y++){const h=$(c[y]);c.some((f,u)=>u===y?!1:(0,e.$qg)(h,$(f)))||p.push(c[y])}return p}e.$Fg=C;var S;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function $(p){const y=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(u=>{const[d,E]=u.split(":");d&&E&&y.set(d,E)});const f=p.path.substring(0,p.path.indexOf(";"));return f&&y.set(c.META_DATA_MIME,f),y}c.parseMetaData=$})(S||(e.DataUri=S={}));function b(c,$,p){if($){let y=c.path;return y&&y[0]!==L.$gc.sep&&(y=L.$gc.sep+y),c.with({scheme:p,authority:$,path:y})}return c.with({scheme:p})}e.$Gg=b}),define(oe[6],ae([0,1,26,7,3,2,19,5,129]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.Promises=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function g(j){return!!j&&typeof j.then=="function"}e.$Hg=g;function C(j){const M=new I.$Yd,F=j(M.token),H=new Promise((J,re)=>{const ce=M.token.onCancellationRequested(()=>{ce.dispose(),M.dispose(),re(new N.$5)});Promise.resolve(F).then(ue=>{ce.dispose(),M.dispose(),J(ue)},ue=>{ce.dispose(),M.dispose(),re(ue)})});return new class{cancel(){M.cancel()}then(J,re){return H.then(J,re)}catch(J){return this.then(void 0,J)}finally(J){return H.finally(J)}}}e.$Ig=C;function S(j,M,F){return new Promise((H,J)=>{const re=M.onCancellationRequested(()=>{re.dispose(),H(F)});j.then(H,J).finally(()=>re.dispose())})}e.$Jg=S;function b(j,M){return new Promise((F,H)=>{const J=M.onCancellationRequested(()=>{J.dispose(),H(new N.$5)});j.then(F,H).finally(()=>J.dispose())})}e.$Kg=b;async function c(j){let M=-1;const F=j.map((H,J)=>H.then(re=>(M=J,re)));try{return await Promise.race(F)}finally{j.forEach((H,J)=>{J!==M&&H.cancel()})}}e.$Lg=c;function $(j,M,F){let H;const J=setTimeout(()=>{H?.(void 0),F?.()},M);return Promise.race([j.finally(()=>clearTimeout(J)),new Promise(re=>H=re)])}e.$Mg=$;function p(j){return new Promise((M,F)=>{const H=j();g(H)?H.then(M,F):M(H)})}e.$Ng=p;class y{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(M){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=M,!this.b){const F=()=>{if(this.b=null,this.f)return;const H=this.queue(this.d);return this.d=null,H};this.b=new Promise(H=>{this.a.then(F,F).then(H)})}return new Promise((F,H)=>{this.b.then(F,H)})}return this.a=M(),new Promise((F,H)=>{this.a.then(J=>{this.a=null,F(J)},J=>{this.a=null,H(J)})})}dispose(){this.f=!0}}e.$Og=y;class h{constructor(){this.a=Promise.resolve(null)}queue(M){return this.a=this.a.then(()=>M(),()=>M())}}e.$Pg=h;class f{constructor(){this.a=new Map}queue(M,F){const J=(this.a.get(M)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(M)===J&&this.a.delete(M)});return this.a.set(M,J),J}}e.$Qg=f;const u=(j,M)=>{let F=!0;const H=setTimeout(()=>{F=!1,M()},j);return{isTriggered:()=>F,dispose:()=>{clearTimeout(H),F=!1}}},d=j=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,j())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class E{constructor(M){this.defaultDelay=M,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(M,F=this.defaultDelay){this.g=M,this.h(),this.b||(this.b=new Promise((J,re)=>{this.d=J,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const J=this.g;return this.g=null,J()}}));const H=()=>{this.a=null,this.d?.(null)};return this.a=F===k.$Ld?d(H):u(F,H),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=E;class s{constructor(M){this.a=new E(M),this.b=new y}trigger(M,F){return this.a.trigger(()=>this.b.queue(M),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=s;class o{constructor(){this.a=!1,this.b=new Promise((M,F)=>{this.d=M})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=o;class n extends o{constructor(M){super(),this.f=setTimeout(()=>this.open(),M)}open(){clearTimeout(this.f),super.open()}}e.$Ug=n;function i(j,M){return M?new Promise((F,H)=>{const J=setTimeout(()=>{re.dispose(),F()},j),re=M.onCancellationRequested(()=>{clearTimeout(J),re.dispose(),H(new N.$5)})}):C(F=>i(j,F))}e.$Vg=i;function t(j,M=0,F){const H=setTimeout(()=>{j(),F&&J.dispose()},M),J=(0,A.$Qc)(()=>{clearTimeout(H),F?.deleteAndLeak(J)});return F?.add(J),J}e.$Wg=t;function r(j){const M=[];let F=0;const H=j.length;function J(){return F<H?j[F++]():null}function re(ce){ce!=null&&M.push(ce);const ue=J();return ue?ue.then(re):Promise.resolve(M)}return Promise.resolve(null).then(re)}e.$Xg=r;function a(j,M=H=>!!H,F=null){let H=0;const J=j.length,re=()=>{if(H>=J)return Promise.resolve(F);const ce=j[H++];return Promise.resolve(ce()).then(he=>M(he)?Promise.resolve(he):re())};return re()}e.$Yg=a;function v(j,M=H=>!!H,F=null){if(j.length===0)return Promise.resolve(F);let H=j.length;const J=()=>{H=-1;for(const re of j)re.cancel?.()};return new Promise((re,ce)=>{for(const ue of j)ue.then(he=>{--H>=0&&M(he)?(J(),re(he)):H===0&&re(F)}).catch(he=>{--H>=0&&(J(),ce(he))})})}e.$Zg=v;class w{constructor(M){this.a=0,this.d=M,this.f=[],this.b=0,this.g=new L.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(M){return this.a++,new Promise((F,H)=>{this.f.push({factory:M,c:F,e:H}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const M=this.f.shift();this.b++;const F=M.factory();F.then(M.c,M.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=w;class l extends w{constructor(){super(1)}}e.$2g=l;class m{constructor(){this.a=new X,this.b=0}queue(M){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,M())):this.a.run(this.b++,M())}}e.$3g=m;class D{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const M=new ee;return this.b.add(M),M.p}g(){for(const[,M]of this.a)if(M.size>0)return!1;return!0}queueFor(M,F=O.$mg){const H=F.getComparisonKey(M);let J=this.a.get(H);if(!J){J=new l;const re=this.f++,ce=L.Event.once(J.onDrained)(()=>{J?.dispose(),this.a.delete(H),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$1c),this.d.set(re,ce),this.a.set(H,J)}return J}h(){this.g()&&this.j()}j(){for(const M of this.b)M.complete();this.b.clear()}dispose(){for(const[,M]of this.a)M.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=D;class T{constructor(M,F){this.a=-1,typeof M=="function"&&typeof F=="number"&&this.setIfNotSet(M,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(M,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,M()},F)}setIfNotSet(M,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,M()},F))}}e.$5g=T;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(M,F){this.cancel(),this.a=setInterval(()=>{M()},F)}}e.$6g=z;class U{constructor(M,F){this.b=-1,this.a=M,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(M=this.d){this.cancel(),this.b=setTimeout(this.f,M)}get delay(){return this.d}set delay(M){this.d=M}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=U;class B{constructor(M,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=M,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(M=this.b){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(M/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=B;class Z extends U{constructor(M,F){super(M,F),this.j=[]}work(M){this.j.push(M),this.isScheduled()||this.schedule()}h(){const M=this.j;this.j=[],this.a?.(M)}dispose(){this.j=[],super.dispose()}}e.$9g=Z;class Q extends A.$Sc{constructor(M,F){super(),this.g=M,this.h=F,this.a=[],this.b=this.B(new A.$Tc),this.f=!1}get pending(){return this.a.length}work(M){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+M.length>this.g.maxBufferedWork)return!1}else if(this.pending+M.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of M)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=Q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$$g=j=>{(0,R.$B)(()=>{if(M)return;const F=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.$$g=(j,M)=>{const F=requestIdleCallback(j,typeof M=="number"?{timeout:M}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(F))}}}}();class x{constructor(M){this.d=!1,this.a=()=>{try{this.f=M()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$_g=x;async function W(j,M,F){let H;for(let J=0;J<F;J++)try{return await j()}catch(re){H=re,await i(M)}throw H}e.$ah=W;class X{isRunning(M){return typeof M=="number"?this.a?.taskId===M:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(M,F,H){return this.a={taskId:M,cancel:()=>H?.(),promise:F},F.then(()=>this.d(M),()=>this.d(M)),F}d(M){this.a&&M===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const M=this.b;this.b=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}queue(M){if(this.b)this.b.run=M;else{let F,H;const J=new Promise((re,ce)=>{F=re,H=ce});this.b={run:M,promise:J,promiseResolve:F,promiseReject:H}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$bh=X;class G{constructor(M,F=()=>Date.now()){this.d=M,this.f=F,this.a=0,this.b=0}increment(){const M=this.f();return M-this.a>this.d&&(this.a=M,this.b=0),this.b++,this.b}}e.$ch=G;var V;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(V||(V={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((M,F)=>{this.a=M,this.b=F})}complete(M){return new Promise(F=>{this.a(M),this.d={outcome:0,value:M},F()})}error(M){return new Promise(F=>{this.b(M),this.d={outcome:1,value:M},F()})}cancel(){return this.error(new N.$5)}}e.$dh=ee;var ie;(function(j){async function M(H){let J;const re=await Promise.all(H.map(ce=>ce.then(ue=>ue,ue=>{J||(J=ue)})));if(typeof J<"u")throw J;return re}j.settled=M;function F(H){return new Promise(async(J,re)=>{try{await H(J,re)}catch(ce){re(ce)}})}j.withAsyncBody=F})(ie||(e.Promises=ie={}));var _;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(_||(_={}));class ne{static fromArray(M){return new ne(F=>{F.emitMany(M)})}static fromPromise(M){return new ne(async F=>{F.emitMany(await M)})}static fromPromises(M){return new ne(async F=>{await Promise.all(M.map(async H=>F.emitOne(await H)))})}static merge(M){return new ne(async F=>{await Promise.all(M.map(async H=>{for await(const J of H)F.emitOne(J)}))})}static{this.EMPTY=ne.fromArray([])}constructor(M){this.a=0,this.b=[],this.d=null,this.f=new L.$Od,queueMicrotask(async()=>{const F={emitOne:H=>this.g(H),emitMany:H=>this.h(H),reject:H=>this.k(H)};try{await Promise.resolve(M(F)),this.j()}catch(H){this.k(H)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(M<this.b.length)return{done:!1,value:this.b[M++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(M,F){return new ne(async H=>{for await(const J of M)H.emitOne(F(J))})}map(M){return ne.map(this,M)}static filter(M,F){return new ne(async H=>{for await(const J of M)F(J)&&H.emitOne(J)})}filter(M){return ne.filter(this,M)}static coalesce(M){return ne.filter(M,F=>!!F)}coalesce(){return ne.coalesce(this)}static async toPromise(M){const F=[];for await(const H of M)F.push(H);return F}toPromise(){return ne.toPromise(this)}g(M){this.a===0&&(this.b.push(M),this.f.fire())}h(M){this.a===0&&(this.b=this.b.concat(M),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(M){this.a===0&&(this.a=2,this.d=M,this.f.fire())}}e.$eh=ne;class K extends ne{constructor(M,F){super(F),this.l=M}cancel(){this.l.cancel()}}e.$fh=K;function q(j){const M=new I.$Yd,F=j(M.token);return new K(M,async H=>{const J=M.token.onCancellationRequested(()=>{J.dispose(),M.dispose(),H.reject(new N.$5)});try{for await(const re of F){if(M.token.isCancellationRequested)return;H.emitOne(re)}J.dispose(),M.dispose()}catch(re){J.dispose(),M.dispose(),H.reject(re)}})}e.$gh=q;class P{constructor(){this.a=new ee,this.b=new ne(H=>{if(M){H.reject(M);return}return F&&H.emitMany(F),this.d=J=>H.reject(J),this.f=J=>H.emitOne(J),this.a.p});let M,F;this.f=H=>{F||(F=[]),F.push(H)},this.d=H=>{M||(M=H)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(M){this.d(M),this.a.complete()}emitOne(M){this.f(M)}}e.$hh=P}),define(oe[91],ae([0,1,18,6,48,34,16,5,27]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=void 0;function g(){return Object.create(null)}e.$sj=g,e.$tj="**",e.$uj="/";const C="[/\\\\]",S="[^/\\\\]",b=/\//g;function c(X,G){switch(X){case 0:return"";case 1:return`${S}*?`;default:return`(?:${C}|${S}+${C}${G?`|${C}${S}+`:""})*?`}}function $(X,G){if(!X)return[];const V=[];let ee=!1,ie=!1,_="";for(const ne of X){switch(ne){case G:if(!ee&&!ie){V.push(_),_="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}_+=ne}return _&&V.push(_),V}e.$vj=$;function p(X){if(!X)return"";let G="";const V=$(X,e.$uj);if(V.every(ee=>ee===e.$tj))G=".*";else{let ee=!1;V.forEach((ie,_)=>{if(ie===e.$tj){if(ee)return;G+=c(2,_===V.length-1)}else{let ne=!1,K="",q=!1,P="";for(const j of ie){if(j!=="}"&&ne){K+=j;continue}if(q&&(j!=="]"||!P)){let M;j==="-"?M=j:(j==="^"||j==="!")&&!P?M="^":j===e.$uj?M="":M=(0,k.$Ge)(j),P+=M;continue}switch(j){case"{":ne=!0;continue;case"[":q=!0;continue;case"}":{const F=`(?:${$(K,",").map(H=>p(H)).join("|")})`;G+=F,ne=!1,K="";break}case"]":{G+="["+P+"]",q=!1,P="";break}case"?":G+=S;continue;case"*":G+=c(1);continue;default:G+=(0,k.$Ge)(j)}}_<V.length-1&&(V[_+1]!==e.$tj||_+2<V.length)&&(G+=C)}ee=ie===e.$tj})}return G}const y=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new A.$Dc(1e4),o=function(){return!1},n=function(){return null};function i(X,G){if(!X)return n;let V;typeof X!="string"?V=X.pattern:V=X,V=V.trim();const ee=`${V}_${!!G.trimForExclusions}`;let ie=s.get(ee);if(ie)return t(ie,X);let _;return y.test(V)?ie=a(V.substr(4),V):(_=h.exec(r(V,G)))?ie=v(_[1],V):(G.trimForExclusions?u:f).test(V)?ie=w(V,G):(_=d.exec(r(V,G)))?ie=l(_[1].substr(1),V,!0):(_=E.exec(r(V,G)))?ie=l(_[1],V,!1):ie=m(V),s.set(ee,ie),t(ie,X)}function t(X,G){if(typeof G=="string")return X;const V=function(ee,ie){return(0,L.$Yf)(ee,G.base,!R.$l)?X((0,k.$Ke)(ee.substr(G.base.length),O.sep),ie):null};return V.allBasenames=X.allBasenames,V.allPaths=X.allPaths,V.basenames=X.basenames,V.patterns=X.patterns,V}function r(X,G){return G.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function a(X,G){return function(V,ee){return typeof V=="string"&&V.endsWith(X)?G:null}}function v(X,G){const V=`/${X}`,ee=`\\${X}`,ie=function(ne,K){return typeof ne!="string"?null:K?K===X?G:null:ne===X||ne.endsWith(V)||ne.endsWith(ee)?G:null},_=[X];return ie.basenames=_,ie.patterns=[G],ie.allBasenames=_,ie}function w(X,G){const V=x(X.slice(1,-1).split(",").map(K=>i(K,G)).filter(K=>K!==n),X),ee=V.length;if(!ee)return n;if(ee===1)return V[0];const ie=function(K,q){for(let P=0,j=V.length;P<j;P++)if(V[P](K,q))return X;return null},_=V.find(K=>!!K.allBasenames);_&&(ie.allBasenames=_.allBasenames);const ne=V.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return ne.length&&(ie.allPaths=ne),ie}function l(X,G,V){const ee=O.sep===O.$gc.sep,ie=ee?X:X.replace(b,O.sep),_=O.sep+ie,ne=O.$gc.sep+X;let K;return V?K=function(q,P){return typeof q=="string"&&(q===ie||q.endsWith(_)||!ee&&(q===X||q.endsWith(ne)))?G:null}:K=function(q,P){return typeof q=="string"&&(q===ie||!ee&&q===X)?G:null},K.allPaths=[(V?"*/":"./")+X],K}function m(X){try{const G=new RegExp(`^${p(X)}$`);return function(V){return G.lastIndex=0,typeof V=="string"&&G.test(V)?X:null}}catch{return n}}function D(X,G,V){return!X||typeof G!="string"?!1:T(X)(G,void 0,V)}e.$wj=D;function T(X,G={}){if(!X)return o;if(typeof X=="string"||z(X)){const V=i(X,G);if(V===n)return o;const ee=function(ie,_){return!!V(ie,_)};return V.allBasenames&&(ee.allBasenames=V.allBasenames),V.allPaths&&(ee.allPaths=V.allPaths),ee}return Z(X,G)}e.$xj=T;function z(X){const G=X;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$yj=z;function U(X){return X.allBasenames||[]}e.$zj=U;function B(X){return X.allPaths||[]}e.$Aj=B;function Z(X,G){const V=x(Object.getOwnPropertyNames(X).map(K=>Q(K,X[K],G)).filter(K=>K!==n)),ee=V.length;if(!ee)return n;if(!V.some(K=>!!K.requiresSiblings)){if(ee===1)return V[0];const K=function(j,M){let F;for(let H=0,J=V.length;H<J;H++){const re=V[H](j,M);if(typeof re=="string")return re;(0,N.$Hg)(re)&&(F||(F=[]),F.push(re))}return F?(async()=>{for(const H of F){const J=await H;if(typeof J=="string")return J}return null})():null},q=V.find(j=>!!j.allBasenames);q&&(K.allBasenames=q.allBasenames);const P=V.reduce((j,M)=>M.allPaths?j.concat(M.allPaths):j,[]);return P.length&&(K.allPaths=P),K}const ie=function(K,q,P){let j,M;for(let F=0,H=V.length;F<H;F++){const J=V[F];J.requiresSiblings&&P&&(q||(q=(0,O.$nc)(K)),j||(j=q.substr(0,q.length-(0,O.$oc)(K).length)));const re=J(K,q,j,P);if(typeof re=="string")return re;(0,N.$Hg)(re)&&(M||(M=[]),M.push(re))}return M?(async()=>{for(const F of M){const H=await F;if(typeof H=="string")return H}return null})():null},_=V.find(K=>!!K.allBasenames);_&&(ie.allBasenames=_.allBasenames);const ne=V.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return ne.length&&(ie.allPaths=ne),ie}function Q(X,G,V){if(G===!1)return n;const ee=i(X,V);if(ee===n)return n;if(typeof G=="boolean")return ee;if(G){const ie=G.when;if(typeof ie=="string"){const _=(ne,K,q,P)=>{if(!P||!ee(ne,K))return null;const j=ie.replace("$(basename)",()=>q),M=P(j);return(0,N.$Hg)(M)?M.then(F=>F?X:null):M?X:null};return _.requiresSiblings=!0,_}}return ee}function x(X,G){const V=X.filter(K=>!!K.basenames);if(V.length<2)return X;const ee=V.reduce((K,q)=>{const P=q.basenames;return P?K.concat(P):K},[]);let ie;if(G){ie=[];for(let K=0,q=ee.length;K<q;K++)ie.push(G)}else ie=V.reduce((K,q)=>{const P=q.patterns;return P?K.concat(P):K},[]);const _=function(K,q){if(typeof K!="string")return null;if(!q){let j;for(j=K.length;j>0;j--){const M=K.charCodeAt(j-1);if(M===47||M===92)break}q=K.substr(j)}const P=ee.indexOf(q);return P!==-1?ie[P]:null};_.basenames=ee,_.patterns=ie,_.allBasenames=ee;const ne=X.filter(K=>!K.basenames);return ne.push(_),ne}function W(X,G){return(0,I.$ub)(X,G,(V,ee)=>typeof V=="string"&&typeof ee=="string"?V===ee:typeof V!="string"&&typeof ee!="string"?V.base===ee.base&&V.pattern===ee.pattern:!1)}e.$Bj=W}),define(oe[92],ae([0,1,15,10]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0;function L(S){return S.toJSON()}class A{constructor(b){this.a=b}transformIncoming(b){const c=this.a.transformIncoming(b);return c===b?b:L(N.URI.from(c))}transformOutgoing(b){const c=this.a.transformOutgoing(b);return c===b?b:L(N.URI.from(c))}transformOutgoingURI(b){const c=this.a.transformOutgoing(b);return c===b?b:N.URI.from(c)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Mm=A,e.$Nm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function O(S,b,c){if(!S||c>200)return null;if(typeof S=="object"){if(S instanceof N.URI)return b.transformOutgoing(S);for(const $ in S)if(Object.hasOwnProperty.call(S,$)){const p=O(S[$],b,c+1);p!==null&&(S[$]=p)}}return null}function R(S,b){const c=O(S,b,0);return c===null?S:c}e.$Om=R;function k(S,b,c,$){if(!S||$>200)return null;if(typeof S=="object"){if(S.$mid===1)return c?N.URI.revive(b.transformIncoming(S)):b.transformIncoming(S);if(S instanceof I.$ce)return null;for(const p in S)if(Object.hasOwnProperty.call(S,p)){const y=k(S[p],b,c,$+1);y!==null&&(S[p]=y)}}return null}function g(S,b){const c=k(S,b,!1,0);return c===null?S:c}e.$Pm=g;function C(S,b){const c=k(S,b,!0,0);return c===null?S:c}e.$Qm=C}),define(oe[142],ae([0,1,36,47,32,130,5]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Sm=new class{c(b){return this.a||(this.a=N.$Wh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,c=0;const $=(0,I.networkInterfaces)();for(const p in $){const y=$[p];if(y)for(const{mac:h,internal:f}of y)f||(c+=1,this.c(h.toUpperCase())&&(b+=1))}this.b=c>0?b/c:0}return this.b}};let R;async function k(b){return R||(R=(async()=>await g(b)||L.$fg())()),R}e.$Tm=k;async function g(b){try{const c=await new Promise((p,y)=>{te(["crypto"],p,y)}),$=(0,A.$Rm)();return c.createHash("sha256").update($,"utf8").digest("hex")}catch(c){b(c);return}}const C="Software\\Microsoft\\SQMClient";async function S(b){if(O.$j){const c=await new Promise(($,p)=>{te(["@vscode/windows-registry"],$,p)});try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch($){return b($),""}}return""}e.$Um=S}),define(oe[31],ae([0,1,53,36,267,6,48,88,16,5,19,10]),function(te,e,I,N,L,A,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function c(Q,x=b.UNLINK,W){if((0,O.$2f)(Q))throw new Error("rimraf - will refuse to recursively delete root");return x===b.UNLINK?p(Q):$(Q,W)}async function $(Q,x=(0,O.$7f)((0,N.tmpdir)())){try{try{await I.promises.rename(Q,x)}catch(W){return W.code==="ENOENT"?void 0:p(Q)}p(x).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function p(Q){return(0,L.promisify)(I.rm)(Q,{recursive:!0,force:!0,maxRetries:3})}function y(Q){if((0,O.$2f)(Q))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function h(Q,x){return d(await(x?f(Q):(0,L.promisify)(I.readdir)(Q)))}async function f(Q){try{return await(0,L.promisify)(I.readdir)(Q,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const x=[],W=await h(Q);for(const X of W){let G=!1,V=!1,ee=!1;try{const ie=await e.Promises.lstat((0,k.$jc)(Q,X));G=ie.isFile(),V=ie.isDirectory(),ee=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}x.push({name:X,isFile:()=>G,isDirectory:()=>V,isSymbolicLink:()=>ee})}return x}function u(Q){return d(I.readdirSync(Q))}e.readdirSync=u;function d(Q){return Q.map(x=>typeof x=="string"?g.$k?(0,R.$pl)(x):x:(x.name=g.$k?(0,R.$pl)(x.name):x.name,x))}async function E(Q){const x=await h(Q),W=[];for(const X of x)await o.existsDirectory((0,k.$jc)(Q,X))&&W.push(X);return W}function s(Q,x=1e3){return new Promise(W=>{let X=!1;const G=setInterval(()=>{X||(X=!0,I.access(Q,V=>{X=!1,V&&(clearInterval(G),W(void 0))}))},x)})}e.whenDeleted=s;var o;(function(Q){async function x(G){let V;try{if(V=await e.Promises.lstat(G),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(g.$j&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw ie}throw ee}}Q.stat=x;async function W(G){try{const{stat:V,symbolicLink:ee}=await Q.stat(G);return V.isFile()&&ee?.dangling!==!0}catch{}return!1}Q.existsFile=W;async function X(G){try{const{stat:V,symbolicLink:ee}=await Q.stat(G);return V.isDirectory()&&ee?.dangling!==!0}catch{}return!1}Q.existsDirectory=X})(o||(e.SymlinkSupport=o={}));const n=new A.$4g;function i(Q,x,W){return n.queueFor(S.URI.file(Q),C.$ng).queue(()=>{const X=w(W);return new Promise((G,V)=>a(Q,x,X,ee=>ee?V(ee):G()))})}let t=!0;function r(Q){t=Q}e.configureFlushOnWrite=r;function a(Q,x,W,X){if(!t)return I.writeFile(Q,x,{mode:W.mode,flag:W.flag},X);I.open(Q,W.flag,W.mode,(G,V)=>{if(G)return X(G);I.writeFile(V,x,ee=>{if(ee)return I.close(V,()=>X(ee));I.fdatasync(V,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),r(!1)),I.close(V,_=>X(_))))})})}function v(Q,x,W){const X=w(W);if(!t)return I.writeFileSync(Q,x,{mode:X.mode,flag:X.flag});const G=I.openSync(Q,X.flag,X.mode);try{I.writeFileSync(G,x);try{I.fdatasyncSync(G)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{I.closeSync(G)}}e.writeFileSync=v;function w(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function l(Q,x,W=6e4){if(Q!==x)try{g.$j&&typeof W=="number"?await m(Q,x,Date.now(),W):await(0,L.promisify)(I.rename)(Q,x)}catch(X){if(Q.toLowerCase()!==x.toLowerCase()&&X.code==="EXDEV"||Q.endsWith("."))await D(Q,x,{preserveSymlinks:!1}),await c(Q,b.MOVE);else throw X}}async function m(Q,x,W,X,G=0){try{return await(0,L.promisify)(I.rename)(Q,x)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-W>=X)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${V}`),V;if(G===0){let ee=!1;try{const{stat:ie}=await o.stat(x);ie.isFile()||(ee=!0)}catch{}if(ee)throw V}return await(0,A.$Vg)(Math.min(100,G*10)),m(Q,x,W,X,G+1)}}async function D(Q,x,W){return z(Q,x,{root:{source:Q,target:x},options:W,handledSourcePaths:new Set})}const T=511;async function z(Q,x,W){if(W.handledSourcePaths.has(Q))return;W.handledSourcePaths.add(Q);const{stat:X,symbolicLink:G}=await o.stat(Q);if(G){if(W.options.preserveSymlinks)try{return await Z(Q,x,W)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(G.dangling)return}return X.isDirectory()?U(Q,x,X.mode&T,W):B(Q,x,X.mode&T)}async function U(Q,x,W,X){await e.Promises.mkdir(x,{recursive:!0,mode:W});const G=await h(Q);for(const V of G)await z((0,k.$jc)(Q,V),(0,k.$jc)(x,V),X)}async function B(Q,x,W){await e.Promises.copyFile(Q,x),await e.Promises.chmod(x,W)}async function Z(Q,x,W){let X=await e.Promises.readlink(Q);(0,O.$Yf)(X,W.root.source,!g.$l)&&(X=(0,k.$jc)(W.root.target,X.substr(W.root.source.length+1))),await e.Promises.symlink(X,x)}e.Promises=new class{get access(){return(0,L.promisify)(I.access)}get stat(){return(0,L.promisify)(I.stat)}get lstat(){return(0,L.promisify)(I.lstat)}get utimes(){return(0,L.promisify)(I.utimes)}get read(){return(Q,x,W,X,G)=>new Promise((V,ee)=>{I.read(Q,x,W,X,G,(ie,_,ne)=>ie?ee(ie):V({bytesRead:_,buffer:ne}))})}get readFile(){return(0,L.promisify)(I.readFile)}get write(){return(Q,x,W,X,G)=>new Promise((V,ee)=>{I.write(Q,x,W,X,G,(ie,_,ne)=>ie?ee(ie):V({bytesWritten:_,buffer:ne}))})}get appendFile(){return(0,L.promisify)(I.appendFile)}get fdatasync(){return(0,L.promisify)(I.fdatasync)}get truncate(){return(0,L.promisify)(I.truncate)}get copyFile(){return(0,L.promisify)(I.copyFile)}get open(){return(0,L.promisify)(I.open)}get close(){return(0,L.promisify)(I.close)}get symlink(){return(0,L.promisify)(I.symlink)}get readlink(){return(0,L.promisify)(I.readlink)}get chmod(){return(0,L.promisify)(I.chmod)}get mkdir(){return(0,L.promisify)(I.mkdir)}get unlink(){return(0,L.promisify)(I.unlink)}get rmdir(){return(0,L.promisify)(I.rmdir)}get realpath(){return(0,L.promisify)(I.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return E}get writeFile(){return i}get rm(){return c}get rename(){return l}get copy(){return D}}}),define(oe[143],ae([0,1,53,16,5,27,31]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.$9p=void 0;function R(b){if(L.$l)return b;const c=(0,N.$mc)(b);if(b===c)return b;const $=((0,N.$nc)(b)||b).toLowerCase();try{const y=(0,O.readdirSync)(c).filter(h=>h.toLowerCase()===$);if(y.length===1){const h=R(c);if(h)return(0,N.$jc)(h,y[0])}else if(y.length>1){const h=y.indexOf($);if(h>=0){const f=R(c);if(f)return(0,N.$jc)(f,y[h])}}}catch{}return null}e.$9p=R;async function k(b){if(L.$l)return b;const c=(0,N.$mc)(b);if(b===c)return b;const $=((0,N.$nc)(b)||b).toLowerCase();try{const y=(await O.Promises.readdir(c)).filter(h=>h.toLowerCase()===$);if(y.length===1){const h=await k(c);if(h)return(0,N.$jc)(h,y[0])}else if(y.length>1){const h=y.indexOf($);if(h>=0){const f=await k(c);if(f)return(0,N.$jc)(f,y[h])}}}catch{}return null}e.$0p=k;async function g(b){try{return await O.Promises.realpath(b)}catch{const $=S(b);return await O.Promises.access($,I.constants.R_OK),$}}e.$$p=g;function C(b){try{return I.realpathSync(b)}catch{const $=S(b);return I.accessSync($,I.constants.R_OK),$}}e.$_p=C;function S(b){return(0,A.$Le)((0,N.$hc)(b),N.sep)}}),define(oe[144],ae([0,1,16,5,37,90,12,31]),function(te,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Dl=e.$Cl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function k(S=L.env){return S.comspec||"cmd.exe"}e.$Cl=k;function g(S){let b=[],c=!1;const $=function(p){if(c){b.push(p);return}(!S.send(p,h=>{if(h&&console.error(h),c=!1,b.length>0){const f=b.slice(0);b=[],f.forEach(u=>$(u))}})||N.$j)&&(c=!0)};return{send:$}}e.$Dl=g;var C;(function(S){async function b(c,$,p){if(I.$ic(c))return c;if($===void 0&&($=L.cwd()),I.$mc(c)!=="."||(p===void 0&&O.$zf(L.env.PATH)&&(p=L.env.PATH.split(I.$tc)),p===void 0||p.length===0))return I.$jc($,c);async function h(f){if(await R.Promises.exists(f)){let u;try{u=await R.Promises.stat(f)}catch(d){d.message.startsWith("EACCES")&&(u=await R.Promises.lstat(f))}return u?!u.isDirectory():!1}return!1}for(const f of p){let u;if(I.$ic(f)?u=I.$jc(f,c):u=I.$jc($,f,c),await h(u))return u;let d=u+".com";if(await h(d)||(d=u+".exe",await h(d)))return d}return I.$jc($,c)}S.findExecutable=b})(C||(e.win32=C={}))}),define(oe[145],ae([0,1,65,23]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;function L(O){return new Promise((R,k)=>{let g;const C=new Map;function S(c,$,p,y,h){const f=C.get($);if(c===O||f){const u={name:b(p),cmd:p,pid:c,ppid:$,load:y,mem:h};C.set(c,u),c===O&&(g=u),f&&(f.children||(f.children=[]),f.children.push(u),f.children.length>1&&(f.children=f.children.sort((d,E)=>d.pid-E.pid)))}}function b(c){const $=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,y=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(y.exec(c))return"electron-crash-reporter";if(h.exec(c))return"winpty-agent";if(f.exec(c))return"conpty-agent";let d=u.exec(c);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?$.exec(c)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const E=/[a-zA-Z-]+\.js/g;let s="";do d=E.exec(c),d&&(s+=d+" ");while(d);return s&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${s})`:p.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,p)=>{te(["@vscode/windows-process-tree"],$,p)}).then($=>{$.getProcessList(O,p=>{if(!p){k(new Error(`Root process ${O} not found`));return}$.getProcessCpuUsage(p,y=>{const h=new Map;y.forEach(f=>{const u=c(f.commandLine||"");h.set(f.pid,{name:b(u),cmd:u,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),g=h.get(O),g?(h.forEach(f=>{const u=h.get(f.ppid);u&&(u.children||(u.children=[]),u.children.push(f))}),h.forEach(f=>{f.children&&(f.children=f.children.sort((u,d)=>u.pid-d.pid))}),R(g)):k(new Error(`Root process ${O} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let c=function(){let $=[g];const p=[];for(;$.length;){const h=$.shift();h&&(p.push(h.pid),h.children&&($=$.concat(h.children)))}let y=JSON.stringify(N.$dg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+p.join(" "),(0,I.exec)(y,{},(h,f,u)=>{if(h||u)k(h||new Error(u.toString()));else{const d=f.toString().split(`
`);for(let E=0;E<p.length;E++){const s=C.get(p[E]);s.load=parseFloat(d[E])}if(!g){k(new Error(`Root process ${O} not found`));return}R(g)}})};(0,I.exec)("which ps",{},($,p,y)=>{if($||y)if(process.platform!=="linux")k($||new Error(y.toString()));else{const h=JSON.stringify(N.$dg.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(h,{},(f,u,d)=>{f||d?k(f||new Error(d.toString())):(A(u,S),c())})}else{const h=p.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${h} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,d,E)=>{u||E&&!E.includes("screen size is bogus")?k(u||new Error(E.toString())):(A(d,S),process.platform==="linux"?c():g?R(g):k(new Error(`Root process ${O} not found`)))})}})}})}e.$Gr=L;function A(O,R){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=O.toString().split(`
`);for(const C of g){const S=k.exec(C.trim());S&&S.length===6&&R(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}});var ye=this&&this.__decorate||function(te,e,I,N){var L=arguments.length,A=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,I):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(te,e,I,N);else for(var R=te.length-1;R>=0;R--)(O=te[R])&&(A=(L<3?O(A):L>3?O(e,I,A):O(e,I))||A);return L>3&&A&&Object.defineProperty(e,I,A),A};define(oe[42],ae([0,1,18,6,15,26,84,7,3,2,64,27,12]),function(te,e,I,N,L,A,O,R,k,g,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.ProxyChannel=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.RequestInitiator=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;var c;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(c||(c={}));function $(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(p||(p={}));function y(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(h||(h={}));function f(G){let V=0;for(let ee=0;;ee+=7){const ie=G.read(1);if(V|=(ie.buffer[0]&127)<<ee,!(ie.buffer[0]&128))return V}}const u=n(0);function d(G,V){if(V===0){G.write(u);return}let ee=0;for(let _=V;_!==0;_=_>>>7)ee++;const ie=L.$ce.alloc(ee);for(let _=0;V!==0;_++)ie.buffer[_]=V&127,V=V>>>7,V>0&&(ie.buffer[_]|=128);G.write(ie)}class E{constructor(V){this.b=V,this.a=0}read(V){const ee=this.b.slice(this.a,this.a+V);return this.a+=ee.byteLength,ee}}e.$oh=E;class s{constructor(){this.a=[]}get buffer(){return L.$ce.concat(this.a)}write(V){this.a.push(V)}}e.$ph=s;var o;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(o||(o={}));function n(G){const V=L.$ce.alloc(1);return V.writeUInt8(G,0),V}const i={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(G,V){if(typeof V>"u")G.write(i.Undefined);else if(typeof V=="string"){const ee=L.$ce.fromString(V);G.write(i.String),d(G,ee.byteLength),G.write(ee)}else if(t&&Buffer.isBuffer(V)){const ee=L.$ce.wrap(V);G.write(i.Buffer),d(G,ee.byteLength),G.write(ee)}else if(V instanceof L.$ce)G.write(i.VSBuffer),d(G,V.byteLength),G.write(V);else if(Array.isArray(V)){G.write(i.Array),d(G,V.length);for(const ee of V)r(G,ee)}else if(typeof V=="number"&&(V|0)===V)G.write(i.Uint),d(G,V);else{const ee=L.$ce.fromString(JSON.stringify(V));G.write(i.Object),d(G,ee.byteLength),G.write(ee)}}e.$qh=r;function a(G){switch(G.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return G.read(f(G)).toString();case o.Buffer:return G.read(f(G)).buffer;case o.VSBuffer:return G.read(f(G));case o.Array:{const ee=f(G),ie=[];for(let _=0;_<ee;_++)ie.push(a(G));return ie}case o.Object:return JSON.parse(G.read(f(G)).toString());case o.Int:return f(G)}}e.$rh=a;class v{constructor(V,ee,ie=null,_=1e3){this.h=V,this.j=ee,this.k=ie,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:200})}registerChannel(V,ee){this.b.set(V,ee),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const ee=this.o([V.type]);this.k?.logOutgoing(ee,0,1,y(V.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([V.type,V.id],V.data);this.k?.logOutgoing(ee,V.id,1,y(V.type),V.data);return}}}o(V,ee=void 0){const ie=new s;return r(ie,V),r(ie,ee),this.p(ie.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const ee=new E(V),ie=a(ee),_=a(ee),ne=ie[0];switch(ne){case 100:return this.k?.logIncoming(V.byteLength,ie[1],1,`${$(ne)}: ${ie[2]}.${ie[3]}`,_),this.s({type:ne,id:ie[1],channelName:ie[2],name:ie[3],arg:_});case 102:return this.k?.logIncoming(V.byteLength,ie[1],1,`${$(ne)}: ${ie[2]}.${ie[3]}`,_),this.t({type:ne,id:ie[1],channelName:ie[2],name:ie[3],arg:_});case 101:return this.k?.logIncoming(V.byteLength,ie[1],1,`${$(ne)}`),this.u({type:ne,id:ie[1]});case 103:return this.k?.logIncoming(V.byteLength,ie[1],1,`${$(ne)}`),this.u({type:ne,id:ie[1]})}}s(V){const ee=this.b.get(V.channelName);if(!ee){this.v(V);return}const ie=new A.$Yd;let _;try{_=ee.call(this.j,V.name,V.arg,ie.token)}catch(q){_=Promise.reject(q)}const ne=V.id;_.then(q=>{this.m({id:ne,data:q,type:201})},q=>{q instanceof Error?this.m({id:ne,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:ne,data:q,type:203})}).finally(()=>{K.dispose(),this.d.delete(V.id)});const K=(0,g.$Qc)(()=>ie.cancel());this.d.set(V.id,K)}t(V){const ee=this.b.get(V.channelName);if(!ee){this.v(V);return}const ie=V.id,ne=ee.listen(this.j,V.name,V.arg)(K=>this.m({id:ie,data:K,type:204}));this.d.set(V.id,ne)}u(V){const ee=this.d.get(V.id);ee&&(ee.dispose(),this.d.delete(V.id))}v(V){let ee=this.g.get(V.channelName);ee||(ee=[],this.g.set(V.channelName,ee));const ie=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:V,timeoutTimer:ie})}w(V){const ee=this.g.get(V);if(ee){for(const ie of ee)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Nc)(this.d.values()),this.d.clear()}}e.$sh=v;var w;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class l{constructor(V,ee=null){this.l=V,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=ee}getChannel(V){const ee=this;return{call(ie,_,ne){return ee.a?Promise.reject(new R.$5):ee.m(V,ie,_,ne)},listen(ie,_){return ee.a?k.Event.None:ee.o(V,ie,_)}}}m(V,ee,ie,_=A.CancellationToken.None){const ne=this.g++,q={id:ne,type:100,channelName:V,name:ee,arg:ie};if(_.isCancellationRequested)return Promise.reject(new R.$5);let P;return new Promise((M,F)=>{if(_.isCancellationRequested)return F(new R.$5);const H=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(ne),M(he.data);break;case 202:{this.f.delete(ne);const $e=new Error(he.data.message);$e.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,$e.name=he.data.name,F($e);break}case 203:this.f.delete(ne),F(he.data);break}};this.f.set(ne,ue),this.p(q)};let J=null;this.b===h.Idle?H():(J=(0,N.$Ig)(ue=>this.u()),J.then(()=>{J=null,H()}));const re=()=>{J?(J.cancel(),J=null):this.p({id:ne,type:101}),F(new R.$5)},ce=_.onCancellationRequested(re);P=(0,g.$Pc)((0,g.$Qc)(re),ce),this.d.add(P)}).finally(()=>{P.dispose(),this.d.delete(P)})}o(V,ee,ie){const _=this.g++,K={id:_,type:102,channelName:V,name:ee,arg:ie};let q=null;const P=new k.$Od({onWillAddFirstListener:()=>{q=(0,N.$Ig)(M=>this.u()),q.then(()=>{q=null,this.d.add(P),this.p(K)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(P),this.p({id:_,type:103}))}}),j=M=>P.fire(M.data);return this.f.set(_,j),P.event}p(V){switch(V.type){case 100:case 102:{const ee=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(ee,V.id,0,`${$(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const ee=this.q([V.type,V.id]);this.j?.logOutgoing(ee,V.id,0,$(V.type));return}}}q(V,ee=void 0){const ie=new s;return r(ie,V),r(ie,ee),this.r(ie.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const ee=new E(V),ie=a(ee),_=a(ee),ne=ie[0];switch(ne){case 200:return this.j?.logIncoming(V.byteLength,0,0,y(ne)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ie[1],0,y(ne),_),this.t({type:ie[0],id:ie[1],data:_})}}t(V){if(V.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Nc)(this.d.values()),this.d.clear()}}e.$th=l,ye([O.$ih],l.prototype,"onDidInitializePromise",null);class m{get connections(){const V=[];return this.f.forEach(ee=>V.push(ee)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new k.$Od,this.onDidAddConnection=this.g.event,this.h=new k.$Od,this.onDidRemoveConnection=this.h.event,this.j=new g.$Rc,this.j.add(V(({protocol:ee,onDidClientDisconnect:ie})=>{const _=k.Event.once(ee.onMessage);this.j.add(_(ne=>{const K=new E(ne),q=a(K),P=new v(ee,q),j=new l(ee);this.a.forEach((F,H)=>P.registerChannel(H,F));const M={channelServer:P,channelClient:j,ctx:q};this.f.add(M),this.g.fire(M),this.j.add(ie(()=>{P.dispose(),j.dispose(),this.f.delete(M),this.h.fire(M)}))}))}))}getChannel(V,ee){const ie=this;return{call(_,ne,K){let q;if((0,b.$Nf)(ee)){const j=(0,I.$4b)(ie.connections.filter(ee));q=j?Promise.resolve(j):k.Event.toPromise(k.Event.filter(ie.onDidAddConnection,ee))}else q=ee.routeCall(ie,_,ne);const P=q.then(j=>j.channelClient.getChannel(V));return T(P).call(_,ne,K)},listen(_,ne){if((0,b.$Nf)(ee))return ie.k(V,ee,_,ne);const K=ee.routeEvent(ie,_,ne).then(q=>q.channelClient.getChannel(V));return T(K).listen(_,ne)}}}k(V,ee,ie,_){const ne=this;let K;const q=new k.$Od({onWillAddFirstListener:()=>{K=new g.$Rc;const P=new k.$Ud,j=new Map,M=H=>{const re=H.channelClient.getChannel(V).listen(ie,_),ce=P.add(re);j.set(H,ce)},F=H=>{const J=j.get(H);J&&(J.dispose(),j.delete(H))};ne.connections.filter(ee).forEach(M),k.Event.filter(ne.onDidAddConnection,ee)(M,void 0,K),ne.onDidRemoveConnection(F,void 0,K),P.event(q.fire,q,K),K.add(P)},onDidRemoveLastListener:()=>{K?.dispose(),K=void 0}});return q.event}registerChannel(V,ee){this.a.set(V,ee);for(const ie of this.f)ie.channelServer.registerChannel(V,ee)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$uh=m;class D{constructor(V,ee,ie=null){const _=new s;r(_,ee),V.send(_.buffer),this.a=new l(V,ie),this.d=new v(V,ee,ie)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,ee){this.d.registerChannel(V,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$vh=D;function T(G){return{call(V,ee,ie){return G.then(_=>_.call(V,ee,ie))},listen(V,ee){const ie=new k.$Xd;return G.then(_=>ie.input=_.listen(V,ee)),ie.event}}}e.$wh=T;function z(G){let V=!1;return{call(ee,ie,_){return V?G.call(ee,ie,_):(0,N.$Vg)(0).then(()=>V=!0).then(()=>G.call(ee,ie,_))},listen(ee,ie){if(V)return G.listen(ee,ie);const _=new k.$Xd;return(0,N.$Vg)(0).then(()=>V=!0).then(()=>_.input=G.listen(ee,ie)),_.event}}}e.$xh=z;class U{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const ee of V.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await k.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$yh=U;var B;(function(G){function V(ne,K,q){const P=ne,j=q&&q.disableMarshalling,M=new Map;for(const F in P)ie(F)&&M.set(F,k.Event.buffer(P[F],!0,void 0,K));return new class{listen(F,H,J){const re=M.get(H);if(re)return re;if(_(H)){const ce=P[H];if(typeof ce=="function")return ce.call(P,J)}throw new R.$bb(`Event not found: ${H}`)}call(F,H,J){const re=P[H];if(typeof re=="function"){if(!j&&Array.isArray(J))for(let ue=0;ue<J.length;ue++)J[ue]=(0,C.$nh)(J[ue]);let ce=re.apply(P,J);return ce instanceof Promise||(ce=Promise.resolve(ce)),ce}throw new R.$bb(`Method not found: ${H}`)}}}G.fromService=V;function ee(ne,K){const q=K&&K.disableMarshalling;return new Proxy({},{get(P,j){if(typeof j=="string")return K?.properties?.has(j)?K.properties.get(j):_(j)?function(M){return ne.listen(j,M)}:ie(j)?ne.listen(j):async function(...M){let F;K&&!(0,b.$If)(K.context)?F=[K.context,...M]:F=M;const H=await ne.call(j,F);return q?H:(0,C.$nh)(H)};throw new R.$bb(`Property not found: ${String(j)}`)}})}G.toService=ee;function ie(ne){return ne[0]==="o"&&ne[1]==="n"&&S.$2e(ne.charCodeAt(2))}function _(ne){return/^onDynamic/.test(ne)&&S.$2e(ne.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const V=G.toString();if(V!=="[object Object]")return V}return G}function x(G){return Array.isArray(G)?G.map(Q):Q(G)}function W(G,V,ee,ie,_,ne,K){K=x(K);const q=Z[_],P=q[ie%q.length];let j=[`%c[${G}]%c[${String(V).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(ne)?(j=j.concat(K),j.push(")")):j.push(K),console.log.apply(console,j)}class X{constructor(V,ee){this.d=V,this.f=ee,this.a=0,this.b=0}logOutgoing(V,ee,ie,_,ne){this.b+=V,W(this.d,this.b,V,ee,ie,_,ne)}logIncoming(V,ee,ie,_,ne){this.a+=V,W(this.f,this.a,V,ee,ie,_,ne)}}e.$zh=X}),define(oe[66],ae([0,1,15,3,2,42]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.ProtocolConstants=e.$Ah=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function a(w,l){if(!t.has(w)){const m=String(++r);t.set(w,m)}return t.get(w)}function v(w,l,m,D){if(!i.enableDiagnostics)return;const T=a(w,l);if(D instanceof I.$ce||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const z=I.$ce.alloc(D.byteLength);z.set(D),i.records.push({timestamp:Date.now(),id:T,label:l,type:m,buff:z})}else i.records.push({timestamp:Date.now(),id:T,label:l,type:m,data:D})}i.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var k;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let g=null;function C(){return g||(g=I.$ce.alloc(0)),g}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const l=this.a[0];return r&&(this.a.shift(),this.b-=t),l}if(this.a[0].byteLength>t){const l=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),l}const a=I.$ce.alloc(t);let v=0,w=0;for(;t>0;){const l=this.a[w];if(l.byteLength>t){const m=l.slice(0,t);a.set(m,v),v+=t,r&&(this.a[w]=l.slice(t),this.b-=t),t-=t}else a.set(l,v),v+=l.byteLength,r?(this.a.shift(),this.b-=l.byteLength):w++,t-=l.byteLength}return a}}e.$Ah=S;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(b||(b={}));function c(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class p{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends L.$Sc{constructor(t){super(),this.f=this.B(new N.$Od),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new S,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:c(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(a,v,w,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$ce.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:c(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=I.$ce.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class f extends L.$Sc{constructor(t){super(),this.f=new N.$Od,this.onMessage=this.f.event,this.g=new N.$Od,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new h(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new p(1,0,0,t))}}e.$Bh=f;class u extends A.$vh{static fromSocket(t,r){return new u(new f(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Ch=u;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Od({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Dh=d;class E{constructor(t){this.data=t,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new E(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let v=0;v<o.a;v++)t-this.c[v]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Rc,this.o=t.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new p(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new p(7,0,0,C());this.p.write(t)}sendResume(){const t=new p(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new L.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new y(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new p(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new p(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new p(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const w=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new p(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new p(9,0,this.h,C());this.p.write(t)}}e.$Eh=n}),define(oe[93],ae([0,1,65,6,15,26,140,7,3,2,30,144,90,42]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class $ extends c.$sh{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",f=>L.$ce.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$6p=$;class p{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new k.$Od,this.onDidProcessExit=this.h.event;const u=f&&f.timeout?f.timeout:6e4;this.b=new N.$Rg(u),this.d=null,this.f=null}getChannel(h){const f=this;return{call(u,d,E){return f.k(h,u,d,E)},listen(u,d){return f.l(h,u,d)}}}k(h,f,u,d=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const E=this.n(h),s=(0,N.$Ig)(i=>E.call(f,u,i)),o=d.onCancellationRequested(()=>s.cancel()),n=(0,g.$Qc)(()=>s.cancel());return this.c.add(n),s.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(h,f,u){if(!this.b)return k.Event.None;this.b.cancel();let d;const E=new k.$Od({onWillAddFirstListener:()=>{d=this.n(h).listen(f,u)(E.fire,E),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,C.$8m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,b.$Bl)(f.env),this.d=(0,I.fork)(this.i,h,f);const u=new k.$Od;k.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$2p)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}u.fire(L.$ce.wrap(Buffer.from(t,"base64")))});const E=this.j.useQueue?(0,S.$Dl)(this.d):this.d,s=t=>this.d&&this.d.connected&&E.send(t.buffer.toString("base64")),o=u.event,n={send:s,onMessage:o};this.f=new c.$th(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(a=>(0,g.$Nc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7p=p}),define(oe[146],ae([0,1,133,15,42,3,12,18]),function(te,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KT=e.$JT=void 0;class k{constructor(b){this.a=b,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",c=>N.$ce.wrap(c.data)),b.start()}send(b){this.a.postMessage(b.buffer)}disconnect(){this.a.close()}}class g extends L.$uh{static b(b){(0,O.$Jf)((0,I.$IT)(process),"Electron Utility Process");const c=new A.$Od;return process.parentPort.on("message",$=>{if(b?.handledClientConnection($))return;const p=(0,R.$Ob)($.ports);p&&c.fire(p)}),A.Event.map(c.event,$=>({protocol:new k($),onDidClientDisconnect:A.Event.fromNodeEventEmitter($,"close")}))}constructor(b){super(g.b(b))}}e.$JT=g;function C(S,b,c){const $=p=>{p.data===b&&(S.removeListener("message",$),c())};S.on("message",$)}e.$KT=C}),define(oe[67],ae([0,1,6,3,2,64,12]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.StorageState=e.$5o=e.StorageHint=void 0;var R;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function k(b){const c=b;return c?.changed instanceof Map||c?.deleted instanceof Set}e.$5o=k;var g;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends L.$Sc{static{this.a=100}constructor(c,$=Object.create(null)){super(),this.r=c,this.s=$,this.b=this.B(new N.$Rd),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new I.$Sg(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(c=>this.u(c)))}u(c){this.b.pause();try{c.changed?.forEach(($,p)=>this.w(p,$)),c.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(c,$){if(this.c===g.Closed)return;let p=!1;(0,O.$If)($)?p=this.f.delete(c):this.f.get(c)!==$&&(this.f.set(c,$),p=!0),p&&this.b.fire({key:c,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(c,$){const p=this.f.get(c);return(0,O.$If)(p)?$:p}getBoolean(c,$){const p=this.get(c);return(0,O.$If)(p)?$:p==="true"}getNumber(c,$){const p=this.get(c);return(0,O.$If)(p)?$:parseInt(p,10)}getObject(c,$){const p=this.get(c);return(0,O.$If)(p)?$:(0,A.$mh)(p)}async set(c,$,p=!1){if(this.c===g.Closed)return;if((0,O.$If)($))return this.delete(c,p);const y=(0,O.$Bf)($)||Array.isArray($)?(0,A.$lh)($):String($);if(this.f.get(c)!==y)return this.f.set(c,y),this.j.set(c,y),this.h.delete(c),this.b.fire({key:c,external:p}),this.D()}async delete(c,$=!1){if(!(this.c===g.Closed||!this.f.delete(c)))return this.h.has(c)||this.h.add(c),this.j.delete(c),this.b.fire({key:c,external:$}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const c={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(c).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(c){if(this.z)return this.D(c)}async D(c){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),c)}async whenFlushed(){if(this.z)return new Promise(c=>this.n.push(c))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$6o=C;class S{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(c){c.insert?.forEach(($,p)=>this.a.set(p,$)),c.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$7o=S}),define(oe[147],ae([13,9]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[148],ae([13,9]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[149],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[150],ae([13,9]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[151],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[152],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[153],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[154],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[155],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[156],ae([13,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[157],ae([13,9]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[158],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[159],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[160],ae([13,9]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[161],ae([13,9]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[162],ae([13,9]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[163],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[164],ae([13,9]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[165],ae([13,9]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[166],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[167],ae([13,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[168],ae([13,9]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[169],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[170],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[171],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[172],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[173],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[174],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[175],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[176],ae([13,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[177],ae([13,9]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[178],ae([0,1,7,150]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.TokenType=void 0;var L;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(L||(e.TokenType=L={}));function A(...g){switch(g.length){case 1:return(0,N.localize)(0,null,g[0]);case 2:return(0,N.localize)(1,null,g[0],g[1]);case 3:return(0,N.localize)(2,null,g[0],g[1],g[2]);default:return}}const O=(0,N.localize)(3,null),R=(0,N.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const S=this.d,b=this.c.substring(this.d,this.e),c={type:19,offset:this.d,lexeme:b};this.g.push({offset:S,lexeme:b,additionalInfo:C}),this.f.push(c)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const S=this.c.substring(this.d,this.e),b=k.b.get(S);b?this.k(b):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,S=!1,b=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const $=this.c.charCodeAt(C);if(S)S=!1;else if($===47&&!b){C++;break}else $===91?b=!0:$===92?S=!0:$===93&&(b=!1);C++}for(;C<this.c.length&&k.a.has(this.c.charCodeAt(C));)C++;this.e=C;const c=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Li=k}),define(oe[179],ae([0,1,63,84,23,16,37,19,10]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.$gm=void 0,e.$gm=/^([^.]+\..+):(.+)$/;class g{get appRoot(){return(0,A.$mc)(L.$dg.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,R.$wg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$wg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,I.$fm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",c)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$wg)(k.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$wg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$wg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$wg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=O.env.VSCODE_PORTABLE;return c?k.URI.file((0,A.$jc)(c,"argv.json")):(0,R.$wg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,A.$kc)(c):(0,A.$hc)((0,A.$jc)(L.$dg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?k.URI.file((0,A.$kc)(c)):k.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,A.$kc)(c);const $=O.env.VSCODE_EXTENSIONS;if($)return $;const p=O.env.VSCODE_PORTABLE;return p?(0,A.$jc)(p,"extensions"):(0,R.$wg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map($=>/^[^:/?#]+?:\/\//.test($)?k.URI.parse($):k.URI.file((0,A.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?k.URI.parse(c):k.URI.file((0,A.$hc)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.$gm.test(c))}get extensionLogLevel(){const c=[];for(const $ of this.args.log||[]){const p=e.$gm.exec($);p&&p[1]&&p[2]&&c.push([p[1],p[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,R.$wg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=O.env.VSCODE_PORTABLE;return c?k.URI.file((0,A.$jc)(c,"policy.json")):(0,R.$wg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this.a}constructor(c,$,p){this.a=c,this.b=$,this.c=p,this.editSessionId=this.args.editSessionId}}e.$hm=g,ye([N.$ih],g.prototype,"appRoot",null),ye([N.$ih],g.prototype,"userHome",null),ye([N.$ih],g.prototype,"userDataPath",null),ye([N.$ih],g.prototype,"appSettingsHome",null),ye([N.$ih],g.prototype,"tmpDir",null),ye([N.$ih],g.prototype,"cacheHome",null),ye([N.$ih],g.prototype,"stateResource",null),ye([N.$ih],g.prototype,"userRoamingDataHome",null),ye([N.$ih],g.prototype,"userDataSyncHome",null),ye([N.$ih],g.prototype,"sync",null),ye([N.$ih],g.prototype,"machineSettingsResource",null),ye([N.$ih],g.prototype,"workspaceStorageHome",null),ye([N.$ih],g.prototype,"localHistoryHome",null),ye([N.$ih],g.prototype,"keyboardLayoutResource",null),ye([N.$ih],g.prototype,"argvResource",null),ye([N.$ih],g.prototype,"isExtensionDevelopment",null),ye([N.$ih],g.prototype,"untitledWorkspacesHome",null),ye([N.$ih],g.prototype,"builtinExtensionsPath",null),ye([N.$ih],g.prototype,"extensionsPath",null),ye([N.$ih],g.prototype,"extensionDevelopmentLocationURI",null),ye([N.$ih],g.prototype,"extensionDevelopmentKind",null),ye([N.$ih],g.prototype,"extensionTestsLocationURI",null),ye([N.$ih],g.prototype,"debugExtensionHost",null),ye([N.$ih],g.prototype,"logLevel",null),ye([N.$ih],g.prototype,"extensionLogLevel",null),ye([N.$ih],g.prototype,"serviceMachineIdResource",null),ye([N.$ih],g.prototype,"disableTelemetry",null),ye([N.$ih],g.prototype,"disableWorkspaceTrust",null),ye([N.$ih],g.prototype,"useInMemorySecretStorage",null),ye([N.$ih],g.prototype,"policyFile",null);function C(b,c){return S(b["inspect-extensions"],b["inspect-brk-extensions"],5870,c,b.debugId,b.extensionEnvironment)}e.$im=C;function S(b,c,$,p,y,h){const u=Number(c||b)||(p?null:$),d=u?!!c:!1;let E;if(h)try{E=JSON.parse(h)}catch{}return{port:u,break:d,debugId:y,env:E}}e.$jm=S}),function(){"use strict";function te(e,I,N){function L(O,R){const k=A(O,R),g=[k];return e.isAbsolute(k)||g.unshift(N),e.resolve(...g)}function A(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(S,"AppData","Roaming")}break;case"darwin":g=e.join(I.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:L}}if(typeof define=="function")define(oe[180],ae([268,36,37]),function(e,I,N){return te(e,I,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=te(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[181],ae([0,1,36,179,180]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=e.$km=void 0;class A extends N.$hm{constructor(g,C){super(g,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,L.getUserDataPath)(g,C.nameShort)},C)}}e.$km=A;function O(k,g){return(0,N.$jm)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,g,k.extensionEnvironment)}e.$lm=O;function R(k,g){return(0,N.$jm)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,g,k.extensionEnvironment)}e.$mm=R}),define(oe[182],ae([0,1,12,153]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;function L(O,R,k,g){try{A(O,R,k,g)}catch(C){O.error(C?.message??C)}return R}e.$Bp=L;function A(O,R,k,g){const C=(S,b,c)=>{const $=S[b];if((0,I.$zf)($)){const p=$,y=p.length;if(y>1&&p[0]==="%"&&p[y-1]==="%"){const h=p.substr(1,y-2);let f=k[h];f===void 0&&g&&(f=g[h]);const u=typeof f=="string"?f:f?.message,d=g?.[h],E=typeof d=="string"?d:d?.message;if(!u){E||O.warn(`[${R.name}]: ${(0,N.localize)(0,null,h)}`);return}if(c&&(b==="title"||b==="category")&&E&&E!==u){const s={value:u,original:E};S[b]=s}else S[b]=u}}else if((0,I.$Bf)($))for(const p in $)$.hasOwnProperty(p)&&(p==="commands"?C($,p,!0):C($,p,c));else if(Array.isArray($))for(let p=0;p<$.length;p++)C($,p,c)};for(const S in R)R.hasOwnProperty(S)&&C(R,S)}}),define(oe[183],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E9b=e.$D9b=void 0;class I{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$D9b=I;class N{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${O}`)}}e.$E9b=N}),define(oe[68],ae([0,1,19,89,157,54]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(h){return h=h.trim(),h==="*"||O.test(h)}e.$Po=k;function g(h){if(!k(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(O);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Qo=g;function C(h){if(!h)return null;const f=h.majorBase,u=h.majorMustEqual,d=h.minorBase;let E=h.minorMustEqual;const s=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(f===0||(E=!1),o=!1);let n=0;if(h.preRelease){const i=R.exec(h.preRelease);if(i){const[,t,r,a]=i;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:f,majorMustEqual:u,minorBase:d,minorMustEqual:E,patchBase:s,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:n}}e.$Ro=C;function S(h,f,u){let d;typeof h=="string"?d=C(g(h)):d=h;let E;f instanceof Date?E=f.getTime():typeof f=="string"&&(E=new Date(f).getTime());let s;if(typeof u=="string"?s=C(g(u)):s=u,!d||!s)return!1;const o=d.majorBase,n=d.minorBase,i=d.patchBase;let t=s.majorBase,r=s.minorBase,a=s.patchBase;const v=s.notBefore;let w=s.majorMustEqual,l=s.minorMustEqual,m=s.patchMustEqual;return s.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||E&&E<v?!1:i>=a:(o===1&&t===0&&(!w||!l||!m)&&(t=1,r=0,a=0,w=!0,l=!1,m=!1),o<t?!1:o>t?!w:n<r?!1:n>r?!l:i<a?!1:i>a?!m:!(E&&E<v))}e.$So=S;function b(h,f,u,d,E){const s=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return s.push([N.default.Error,L.localize(0,null)]),s;if(typeof d.name!="string")return s.push([N.default.Error,L.localize(1,null,"name")]),s;if(typeof d.version!="string")return s.push([N.default.Error,L.localize(2,null,"version")]),s;if(!d.engines)return s.push([N.default.Error,L.localize(3,null,"engines")]),s;if(typeof d.engines.vscode!="string")return s.push([N.default.Error,L.localize(4,null,"engines.vscode")]),s;if(typeof d.extensionDependencies<"u"&&!y(d.extensionDependencies))return s.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),s;if(typeof d.activationEvents<"u"){if(!y(d.activationEvents))return s.push([N.default.Error,L.localize(6,null,"activationEvents")]),s;if(typeof d.main>"u"&&typeof d.browser>"u")return s.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),s}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&s.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return s.push([N.default.Error,L.localize(9,null,"main")]),s;{const i=(0,I.$wg)(u,d.main);(0,I.$qg)(i,u)||s.push([N.default.Warning,L.localize(10,null,i.path,u.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return s.push([N.default.Error,L.localize(11,null,"browser")]),s;{const i=(0,I.$wg)(u,d.browser);(0,I.$qg)(i,u)||s.push([N.default.Warning,L.localize(12,null,i.path,u.path)])}}if(!A.valid(d.version))return s.push([N.default.Error,L.localize(13,null)]),s;const o=[];if(!c(h,f,d,E,o))for(const i of o)s.push([N.default.Error,i]);return s}e.$To=b;function c(h,f,u,d,E){return d||typeof u.main>"u"&&typeof u.browser>"u"?!0:p(h,f,u.engines.vscode,E)}e.$Uo=c;function $(h,f,u){return h==="*"||p(f,u,h)}e.$Vo=$;function p(h,f,u,d=[]){const E=C(g(u));if(!E)return d.push(L.localize(14,null,u)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return d.push(L.localize(15,null,u)),!1}else if(!E.majorMustEqual)return d.push(L.localize(16,null,u)),!1;return S(h,f,E)?!0:(d.push(L.localize(17,null,h,u)),!1)}function y(h){if(!Array.isArray(h))return!1;for(let f=0,u=h.length;f<u;f++)if(typeof h[f]!="string")return!1;return!0}}),define(oe[43],ae([0,1,15,32]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;async function L(A,O,R){let k=R&&R.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const C=(await O.readFile(A.serviceMachineIdResource)).value.toString();k=(0,N.$eg)(C)?C:null}catch{k=null}if(!k){k=(0,N.$fg)();try{await O.writeFile(A.serviceMachineIdResource,I.$ce.fromString(k))}catch{}}return R?.store("storage.serviceMachineId",k,-1,1),k}e.$dp=L}),define(oe[69],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class I{constructor(L,A=[],O=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$Nh=I}),define(oe[184],ae([0,1,69]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.InstantiationType=void 0;const N=[];var L;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(R,k,g){k instanceof I.$Nh||(k=new I.$Nh(k,[],!!g)),N.push([R,k])}e.$Ar=A;function O(){return N}e.$Br=O}),define(oe[185],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class I{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$fq=I;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const R=this.lookupOrInsertNode(A),k=this.lookupOrInsertNode(O);R.outgoing.set(k.key,k),k.incoming.set(R.key,R)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let R=this.a.get(O);return R||(R=new I(O,A),this.a.set(O,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,R]of this.a)A.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const R=new Set([A]),k=this.c(O,R);if(k)return k}}c(A,O){for(const[R,k]of A.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const g=this.c(k,O);if(g)return g;O.delete(R)}}}e.$gq=N}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e._util=void 0;var I;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(k){return k[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(I||(e._util=I={})),e.$Ph=L("instantiationService");function N(O,R,k){R[I.DI_TARGET]===R?R[I.DI_DEPENDENCIES].push({id:O,index:k}):(R[I.DI_DEPENDENCIES]=[{id:O,index:k}],R[I.DI_TARGET]=R)}function L(O){if(I.serviceIds.has(O))return I.serviceIds.get(O);const R=function(k,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(R,k,C)};return R.toString=()=>O,I.serviceIds.set(O,R),R}e.$Qh=L;function A(O){return O}e.$Rh=A}),define(oe[186],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a9b=void 0,e.$a9b=(0,I.$Qh)("checksumService")}),define(oe[20],ae([0,1,12,10,4]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.ConfigurationTarget=e.$mi=e.$li=e.$ki=void 0,e.$ki=(0,L.$Qh)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof N.URI)}e.$li=A;function O(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof N.URI)}e.$mi=O;var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function k(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ni=k;function g(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$oi=g;function C(h,f){const u=Object.create(null);for(const d in h)S(u,d,h[d],f);return u}e.$pi=C;function S(h,f,u,d){const E=f.split("."),s=E.pop();let o=h;for(let n=0;n<E.length;n++){const i=E[n];let t=o[i];switch(typeof t){case"undefined":t=o[i]=Object.create(null);break;case"object":break;default:d(`Ignoring ${f} as ${E.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[s]=u}catch{d(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(o)}`)}e.$qi=S;function b(h,f){const u=f.split(".");c(h,u)}e.$ri=b;function c(h,f){const u=f.shift();if(f.length===0){delete h[u];return}if(Object.keys(h).indexOf(u)!==-1){const d=h[u];typeof d=="object"&&!Array.isArray(d)&&(c(d,f),Object.keys(d).length===0&&delete h[u])}}function $(h,f,u){function d(o,n){let i=o;for(const t of n){if(typeof i!="object"||i===null)return;i=i[t]}return i}const E=f.split("."),s=d(h,E);return typeof s>"u"?u:s}e.$si=$;function p(h,f,u){Object.keys(f).forEach(d=>{d!=="__proto__"&&(d in h?I.$Bf(h[d])&&I.$Bf(f[d])?p(h[d],f[d],u):u&&(h[d]=f[d]):h[d]=f[d])})}e.$ti=p;function y(h){return h.replace(/[\[\]]/g,"")}e.$ui=y}),define(oe[94],ae([0,1,5,27,178,4,149,7]),function(te,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ContextKeyExprType=e.$Mi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",I.$k),k.set("isLinux",I.$l),k.set("isWindows",I.$j),k.set("isWeb",I.$p),k.set("isMacNative",I.$k&&!I.$p),k.set("isEdge",I.$H),k.set("isFirefox",I.$F),k.set("isChrome",I.$E),k.set("isSafari",I.$G);function g(q,P){if(k.get(q)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(q,P)}e.$Mi=g;const C=Object.prototype.hasOwnProperty;var S;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const b={regexParsingWithErrorRecovery:!0},c=(0,O.localize)(0,null),$=(0,O.localize)(1,null),p=(0,O.localize)(2,null),y=(0,O.localize)(3,null),h=(0,O.localize)(4,null),f=(0,O.localize)(5,null),u=(0,O.localize)(6,null),d=(0,O.localize)(7,null);class E{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=b){this.k=P,this.d=new L.$Li,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const M=this.D(),F=M.type===17?f:void 0;throw this.h.push({message:h,offset:M.offset,lexeme:L.$Li.getLexeme(M),additionalInfo:F}),E.c}return j}catch(j){if(j!==E.c)throw j;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const j=this.o();P.push(j)}return P.length===1?P[0]:s.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const j=this.s();P.push(j)}return P.length===1?P[0]:s.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,y),j?.negate()}case 17:return this.z(),D.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const j=this.l();return this.A(1,y),j}case 17:{const j=P.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const H=F.lexeme,J=H.lastIndexOf("/"),re=J===H.length-1?void 0:this.w(H.substring(J+1));let ce;try{ce=new RegExp(H.substring(1,J),re)}catch{throw this.B("REGEX",F)}return Q.create(j,ce)}switch(F.type){case 10:case 19:{const H=[F.lexeme];this.z();let J=this.D(),re=0;for(let de=0;de<F.lexeme.length;de++)F.lexeme.charCodeAt(de)===40?re++:F.lexeme.charCodeAt(de)===41&&re--;for(;!this.E()&&J.type!==15&&J.type!==16;){switch(J.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let de=0;de<J.lexeme.length;de++)J.lexeme.charCodeAt(de)===40?re++:F.lexeme.charCodeAt(de)===41&&re--}if(re<0)break;H.push(L.$Li.getLexeme(J)),this.z(),J=this.D()}const ce=H.join(""),ue=ce.lastIndexOf("/"),he=ue===ce.length-1?void 0:this.w(ce.substring(ue+1));let $e;try{$e=new RegExp(ce.substring(1,ue),he)}catch{throw this.B("REGEX",F)}return s.regex(j,$e)}case 18:{const H=F.lexeme;this.z();let J=null;if(!(0,N.$Ce)(H)){const re=H.indexOf("/"),ce=H.lastIndexOf("/");if(re!==ce&&re>=0){const ue=H.slice(re+1,ce),he=H[ce+1]==="i"?"i":"";try{J=new RegExp(ue,he)}catch{throw this.B("REGEX",F)}}}if(J===null)throw this.B("REGEX",F);return Q.create(j,J)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const F=this.u();return s.notIn(j,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return s.equals(j,F);switch(F){case"true":return s.has(j);case"false":return s.not(j);default:return s.equals(j,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return s.notEquals(j,F);switch(F){case"true":return s.not(j);case"false":return s.has(j);default:return s.notEquals(j,F)}}case 5:return this.z(),B.create(j,this.u());case 6:return this.z(),Z.create(j,this.u());case 7:return this.z(),z.create(j,this.u());case 8:return this.z(),U.create(j,this.u());case 13:return this.z(),s.in(j,this.u());default:return s.has(j)}}case 20:throw this.h.push({message:u,offset:P.offset,lexeme:"",additionalInfo:d}),E.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,j){if(this.C(P))return this.z();throw this.B(j,this.D())}B(P,j,M){const F=(0,O.localize)(8,null,P,L.$Li.getLexeme(j)),H=j.offset,J=L.$Li.getLexeme(j);return this.h.push({message:F,offset:H,lexeme:J,additionalInfo:M}),E.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ni=E;class s{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(P){return a.create(P)}static equals(P,j){return v.create(P,j)}static notEquals(P,j){return m.create(P,j)}static regex(P,j){return Q.create(P,j)}static in(P,j){return w.create(P,j)}static notIn(P,j){return l.create(P,j)}static not(P){return D.create(P)}static and(...P){return X.create(P,null,!0)}static or(...P){return G.create(P,null,!0)}static greater(P,j){return z.create(P,j)}static greaterEquals(P,j){return U.create(P,j)}static smaller(P,j){return B.create(P,j)}static smallerEquals(P,j){return Z.create(P,j)}static{this.c=new E({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.$Oi=s;function o(q){const P=new E({regexParsingWithErrorRecovery:!1});return q.map(j=>(P.parse(j),P.lexingErrors.length>0?P.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,O.localize)(9,null,M.additionalInfo):(0,O.localize)(10,null),offset:M.offset,length:M.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.$Pi=o;function n(q,P){const j=q?q.substituteConstants():void 0,M=P?P.substituteConstants():void 0;return!j&&!M?!0:!j||!M?!1:j.equals(M)}e.$Qi=n;function i(q,P){return q.cmp(P)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return r.INSTANCE}}e.$Ri=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return t.INSTANCE}}e.$Si=r;class a{static create(P,j=null){const M=k.get(P);return typeof M=="boolean"?M?r.INSTANCE:t.INSTANCE:new a(P,j)}constructor(P,j){this.key=P,this.c=j,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=k.get(this.key);return typeof P=="boolean"?P?r.INSTANCE:t.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$Ti=a;class v{static create(P,j,M=null){if(typeof j=="boolean")return j?a.create(P,M):D.create(P,M);const F=k.get(P);return typeof F=="boolean"?j===(F?"true":"false")?r.INSTANCE:t.INSTANCE:new v(P,j,M)}constructor(P,j,M){this.c=P,this.d=j,this.f=M,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=k.get(this.c);if(typeof P=="boolean"){const j=P?"true":"false";return this.d===j?r.INSTANCE:t.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.$Ui=v;class w{static create(P,j){return new w(P,j)}constructor(P,j){this.d=P,this.f=j,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const j=P.getValue(this.f),M=P.getValue(this.d);return Array.isArray(j)?j.includes(M):typeof M=="string"&&typeof j=="object"&&j!==null?C.call(j,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=l.create(this.d,this.f)),this.c}}e.$Vi=w;class l{static create(P,j){return new l(P,j)}constructor(P,j){this.d=P,this.f=j,this.type=11,this.c=w.create(P,j)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Wi=l;class m{static create(P,j,M=null){if(typeof j=="boolean")return j?D.create(P,M):a.create(P,M);const F=k.get(P);return typeof F=="boolean"?j===(F?"true":"false")?t.INSTANCE:r.INSTANCE:new m(P,j,M)}constructor(P,j,M){this.c=P,this.d=j,this.f=M,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=k.get(this.c);if(typeof P=="boolean"){const j=P?"true":"false";return this.d===j?t.INSTANCE:r.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Xi=m;class D{static create(P,j=null){const M=k.get(P);return typeof M=="boolean"?M?t.INSTANCE:r.INSTANCE:new D(P,j)}constructor(P,j){this.c=P,this.d=j,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=k.get(this.c);return typeof P=="boolean"?P?t.INSTANCE:r.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Yi=D;function T(q,P){if(typeof q=="string"){const j=parseFloat(q);isNaN(j)||(q=j)}return typeof q=="string"||typeof q=="number"?P(q):t.INSTANCE}class z{static create(P,j,M=null){return T(j,F=>new z(P,F,M))}constructor(P,j,M){this.c=P,this.d=j,this.f=M,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Zi=z;class U{static create(P,j,M=null){return T(j,F=>new U(P,F,M))}constructor(P,j,M){this.c=P,this.d=j,this.f=M,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$1i=U;class B{static create(P,j,M=null){return T(j,F=>new B(P,F,M))}constructor(P,j,M){this.c=P,this.d=j,this.f=M,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$2i=B;class Z{static create(P,j,M=null){return T(j,F=>new Z(P,F,M))}constructor(P,j,M){this.c=P,this.d=j,this.f=M,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:ie(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$3i=Z;class Q{static create(P,j){return new Q(P,j)}constructor(P,j){this.d=P,this.f=j,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const j=this.f?this.f.source:"",M=P.f?P.f.source:"";return j<M?-1:j>M?1:0}equals(P){if(P.type===this.type){const j=this.f?this.f.source:"",M=P.f?P.f.source:"";return this.d===P.d&&j===M}return!1}substituteConstants(){return this}evaluate(P){const j=P.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$4i=Q;class x{static create(P){return new x(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new x(this.c.map(P))}negate(){return this.c}}e.$5i=x;function W(q){let P=null;for(let j=0,M=q.length;j<M;j++){const F=q[j].substituteConstants();if(q[j]!==F&&P===null){P=[];for(let H=0;H<j;H++)P[H]=q[H]}P!==null&&(P[j]=F)}return P===null?q:P}class X{static create(P,j,M){return X.d(P,j,M)}constructor(P,j){this.expr=P,this.c=j,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let j=0,M=this.expr.length;j<M;j++){const F=i(this.expr[j],P.expr[j]);if(F!==0)return F}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let j=0,M=this.expr.length;j<M;j++)if(!this.expr[j].equals(P.expr[j]))return!1;return!0}return!1}substituteConstants(){const P=W(this.expr);return P===this.expr?this:X.create(P,this.c,!1)}evaluate(P){for(let j=0,M=this.expr.length;j<M;j++)if(!this.expr[j].evaluate(P))return!1;return!0}static d(P,j,M){const F=[];let H=!1;for(const J of P)if(J){if(J.type===1){H=!0;continue}if(J.type===0)return t.INSTANCE;if(J.type===6){F.push(...J.expr);continue}F.push(J)}if(F.length===0&&H)return r.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(i);for(let J=1;J<F.length;J++)F[J-1].equals(F[J])&&(F.splice(J,1),J--);if(F.length===1)return F[0];for(;F.length>1;){const J=F[F.length-1];if(J.type!==9)break;F.pop();const re=F.pop(),ce=F.length===0,ue=G.create(J.expr.map(he=>X.create([he,re],null,M)),null,ce);ue&&(F.push(ue),F.sort(i))}if(F.length===1)return F[0];if(M){for(let J=0;J<F.length;J++)for(let re=J+1;re<F.length;re++)if(F[J].negate().equals(F[re]))return t.INSTANCE;if(F.length===1)return F[0]}return new X(F,j)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const j of this.expr)P.push(...j.keys());return P}map(P){return new X(this.expr.map(j=>j.map(P)),null)}negate(){if(!this.c){const P=[];for(const j of this.expr)P.push(j.negate());this.c=G.create(P,this,!0)}return this.c}}e.$6i=X;class G{static create(P,j,M){return G.d(P,j,M)}constructor(P,j){this.expr=P,this.c=j,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let j=0,M=this.expr.length;j<M;j++){const F=i(this.expr[j],P.expr[j]);if(F!==0)return F}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let j=0,M=this.expr.length;j<M;j++)if(!this.expr[j].equals(P.expr[j]))return!1;return!0}return!1}substituteConstants(){const P=W(this.expr);return P===this.expr?this:G.create(P,this.c,!1)}evaluate(P){for(let j=0,M=this.expr.length;j<M;j++)if(this.expr[j].evaluate(P))return!0;return!1}static d(P,j,M){let F=[],H=!1;if(P){for(let J=0,re=P.length;J<re;J++){const ce=P[J];if(ce){if(ce.type===0){H=!0;continue}if(ce.type===1)return r.INSTANCE;if(ce.type===9){F=F.concat(ce.expr);continue}F.push(ce)}}if(F.length===0&&H)return t.INSTANCE;F.sort(i)}if(F.length!==0){if(F.length===1)return F[0];for(let J=1;J<F.length;J++)F[J-1].equals(F[J])&&(F.splice(J,1),J--);if(F.length===1)return F[0];if(M){for(let J=0;J<F.length;J++)for(let re=J+1;re<F.length;re++)if(F[J].negate().equals(F[re]))return r.INSTANCE;if(F.length===1)return F[0]}return new G(F,j)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const j of this.expr)P.push(...j.keys());return P}map(P){return new G(this.expr.map(j=>j.map(P)),null)}negate(){if(!this.c){const P=[];for(const j of this.expr)P.push(j.negate());for(;P.length>1;){const j=P.shift(),M=P.shift(),F=[];for(const H of K(j))for(const J of K(M))F.push(X.create([H,J],null,!1));P.unshift(G.create(F,null,!1))}this.c=G.create(P,this,!0)}return this.c}}e.$7i=G;class V extends a{static{this.d=[]}static all(){return V.d.values()}constructor(P,j,M){super(P,null),this.f=j,typeof M=="object"?V.d.push({...M,key:P}):M!==!0&&V.d.push({key:P,description:M,type:j!=null?typeof j:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return v.create(this.key,P)}notEqualsTo(P){return m.create(this.key,P)}}e.$8i=V,e.$9i=(0,A.$Qh)("contextKeyService");function ee(q,P){return q<P?-1:q>P?1:0}function ie(q,P,j,M){return q<j?-1:q>j?1:P<M?-1:P>M?1:0}function _(q,P){if(q.type===0||P.type===1)return!0;if(q.type===9)return P.type===9?ne(q.expr,P.expr):!1;if(P.type===9){for(const j of P.expr)if(_(q,j))return!0;return!1}if(q.type===6){if(P.type===6)return ne(P.expr,q.expr);for(const j of q.expr)if(_(j,P))return!0;return!1}return q.equals(P)}e.$0i=_;function ne(q,P){let j=0,M=0;for(;j<q.length&&M<P.length;){const F=q[j].cmp(P[M]);if(F<0)return!1;F===0&&j++,M++}return j===q.length}function K(q){return q.type===9?q.expr:[q]}}),define(oe[95],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.ID=void 0,e.ID="diagnosticsService",e.$rm=(0,I.$Qh)(e.ID);function N(A){return!!A.hostName&&!!A.errorMessage}e.$sm=N;class L{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$tm=L}),define(oe[96],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Sn=(0,I.$Qh)("downloadService")}),define(oe[14],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=void 0,e.$Xh=(0,I.$Qh)("environmentService"),e.$Yh=(0,I.$Rh)(e.$Xh)}),define(oe[29],ae([0,1,152,4]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0,e.$2n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3n=new RegExp(e.$2n),e.$4n="__web_extension",e.$5n="skipWalkthrough",e.$6n="extensionsSync",e.$7n="dependecyOrPackExtensionInstall";function L(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$8n=L;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$9n=A;function O(h,f){switch(h){case 3:return f==="x64"?"win32-x64":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$0n=O;function R(h,f){return f==="web"&&!h.includes("web")}e.$$n=R;function k(h,f,u){return R(f,u)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===u}e.$_n=k;function g(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$ao=g;var C;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var S;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var b;(function(h){h.Install="install",h.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var c;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$bo=(0,N.$Qh)("extensionGalleryService");var $;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var p;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class y extends Error{constructor(f,u){super(f),this.code=u,this.name=u}}e.$co=y,e.$do=(0,N.$Qh)("extensionManagementService"),e.$eo="extensionsIdentifiers/disabled",e.$fo="extensionsIdentifiers/enabled",e.$go=(0,N.$Qh)("IGlobalExtensionEnablementService"),e.$ho=(0,N.$Qh)("IExtensionTipsService"),e.$io=(0,I.localize)(0,null),e.$jo={value:e.$io,original:"Extensions"},e.$ko={value:(0,I.localize)(1,null),original:"Preferences"}}),define(oe[187],ae([0,1,3,2,30,10,92,29]),function(te,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=void 0;function k(y,h){return y?A.URI.revive(h?h.transformIncoming(y):y):void 0}function g(y,h){return h?h.transformOutgoingURI(y):y}function C(y,h){h=h||O.$Nm;const f=y.manifest;return{...(0,O.$Qm)({...y,manifest:void 0},h),manifest:f}}function S(y,h){return y?.profileLocation?(0,O.$Qm)(y,h??O.$Nm):y}function b(y,h){return h?(0,L.$0m)(y,f=>f instanceof A.URI?h.transformOutgoingURI(f):void 0):y}class c{constructor(h,f){this.a=h,this.b=f,this.onInstallExtension=I.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,f){const u=this.b(h);switch(f){case"onInstallExtension":return I.Event.map(this.onInstallExtension,d=>({...d,profileLocation:d.profileLocation?g(d.profileLocation,u):d.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,d=>d.map(E=>({...E,local:E.local?b(E.local,u):E.local,profileLocation:E.profileLocation?g(E.profileLocation,u):E.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,d=>({...d,profileLocation:d.profileLocation?g(d.profileLocation,u):d.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,d=>({...d,profileLocation:d.profileLocation?g(d.profileLocation,u):d.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,d=>b(d,u))}throw new Error("Invalid listen")}async call(h,f,u){const d=this.b(h);switch(f){case"zip":{const E=C(u[0],d),s=await this.a.zip(E);return g(s,d)}case"unzip":return this.a.unzip(k(u[0],d));case"install":return this.a.install(k(u[0],d),S(u[1],d));case"installFromLocation":return this.a.installFromLocation(k(u[0],d),k(u[1],d));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(u[0],k(u[1],d),k(u[2],d));case"getManifest":return this.a.getManifest(k(u[0],d));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(u[0]);case"installFromGallery":return this.a.installFromGallery(u[0],S(u[1],d));case"installGalleryExtensions":{const E=u[0];return this.a.installGalleryExtensions(E.map(({extension:s,options:o})=>({extension:s,options:S(o,d)??{}})))}case"uninstall":return this.a.uninstall(C(u[0],d),S(u[1],d));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(u[0],d));case"getInstalled":return(await this.a.getInstalled(u[0],k(u[1],d))).map(s=>b(s,d));case"toggleAppliationScope":{const E=await this.a.toggleAppliationScope(C(u[0],d),k(u[1],d));return b(E,d)}case"copyExtensions":return this.a.copyExtensions(k(u[0],d),k(u[1],d));case"updateMetadata":{const E=await this.a.updateMetadata(C(u[0],d),u[1],k(u[2],d));return b(E,d)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(u[0],u[1],u[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$lp=c;class $ extends N.$Sc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new I.$Od),this.f=this.B(new I.$Od),this.g=this.B(new I.$Od),this.h=this.B(new I.$Od),this.j=this.B(new I.$Od),this.B(this.m.listen("onInstallExtension")(f=>this.n(this.c,{...f,source:this.r(f.source)?A.URI.revive(f.source):f.source,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(f=>this.n(this.f,f.map(u=>({...u,local:u.local?C(u.local,null):u.local,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(f=>this.n(this.g,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(f=>this.n(this.h,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(f=>this.j.fire(C(f,null))))}n(h,f){h.fire(f)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const f=await this.getTargetPlatform();return h.allTargetPlatforms.some(u=>(0,R.$_n)(u,h.allTargetPlatforms,f))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(f=>A.URI.revive(f)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,f){return Promise.resolve(this.m.call("install",[h,f])).then(u=>C(u,null))}installFromLocation(h,f){return Promise.resolve(this.m.call("installFromLocation",[h,f])).then(u=>C(u,null))}async installExtensionsFromProfile(h,f,u){return(await this.m.call("installExtensionsFromProfile",[h,f,u])).map(E=>C(E,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,f){return Promise.resolve(this.m.call("installFromGallery",[h,f])).then(u=>C(u,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map(u=>({...u,local:u.local?C(u.local,null):u.local,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))}uninstall(h,f){return Promise.resolve(this.m.call("uninstall",[h,f]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(f=>C(f,null))}getInstalled(h=null,f){return Promise.resolve(this.m.call("getInstalled",[h,f])).then(u=>u.map(d=>C(d,null)))}updateMetadata(h,f,u){return Promise.resolve(this.m.call("updateMetadata",[h,f,u])).then(d=>C(d,null))}toggleAppliationScope(h,f){return this.m.call("toggleAppliationScope",[h,f]).then(u=>C(u,null))}copyExtensions(h,f){return this.m.call("copyExtensions",[h,f])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,f,u){const d=await this.m.call("download",[h,f,u]);return A.URI.revive(d)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$mp=$;class p{constructor(h){this.a=h}listen(h,f){throw new Error("Invalid listen")}call(h,f,u){switch(f){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$np=p}),define(oe[97],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=void 0,e.$ip=(0,I.$Qh)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((A,O)=>te(["node-vsce-sign"],async R=>A(R),O))),this.a}async verify(A,O,R){let k;try{k=await this.b()}catch{return!1}return k.verify(A,O,R)}}e.$jp=N}),define(oe[98],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Vb=e.RecommendationsNotificationResult=e.$0Vb=e.RecommendationSource=void 0;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$0Vb=L;var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$$Vb=(0,I.$Qh)("IExtensionRecommendationNotificationService")}),define(oe[11],ae([0,1,47,16,27,12,10,159,4,5,23,60]),function(te,e,I,N,L,A,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileKind=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileOperationResult=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileChangeType=e.$rk=e.FileOperation=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderErrorCode=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderCapabilities=e.$bk=e.FilePermission=e.FileType=e.$ak=e.$_j=void 0,e.$_j=(0,k.$Qh)("fileService");function b(_){return _.create===!0}e.$ak=b;var c;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var $;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})($||(e.FilePermission=$={}));function p(_){const ne=_;return!!ne&&typeof ne.onDidChange=="function"}e.$bk=p;var y;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function h(_){return!!(_.capabilities&2)}e.$ck=h;function f(_){return!!(_.capabilities&8)}e.$dk=f;function u(_){return!!(_.capabilities&131072)}e.$ek=u;function d(_){return!!(_.capabilities&4)}e.$fk=d;function E(_){return!!(_.capabilities&16)}e.$gk=E;function s(_){return h(_)?!!(_.capabilities&16384):!1}e.$hk=s;function o(_){return h(_)?!!(_.capabilities&32768):!1}e.$ik=o;function n(_){return!!(_.capabilities&65536)}e.$jk=n;function i(_){return!!(_.capabilities&2048)}e.$kk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ne,K){const q=new r(ne.toString(),K);return w(q,K),q}constructor(ne,K){super(ne),this.code=K}}e.$lk=r;function a(_,ne){return r.create(_,ne)}e.$mk=a;function v(_){return _||a((0,R.localize)(0,null),t.Unknown)}e.$nk=v;function w(_,ne){return _.name=ne?`${ne} (FileSystemError)`:"FileSystemError",_}e.$ok=w;function l(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const ne=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ne)return t.Unknown;switch(ne[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$pk=l;function m(_){if(_ instanceof Z)return _.fileOperationResult;switch(l(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$qk=m;var D;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class T{constructor(ne,K,q){this.resource=ne,this.operation=K,this.target=q}isOperation(ne){return this.operation===ne}}e.$rk=T;var z;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class U{static{this.a=null}constructor(ne,K){this.c=K,this.b=void 0,this.d=new S.$V(()=>{const q=I.$Wh.forUris(()=>this.c);return q.fill(this.rawAdded.map(P=>[P,!0])),q}),this.f=new S.$V(()=>{const q=I.$Wh.forUris(()=>this.c);return q.fill(this.rawUpdated.map(P=>[P,!0])),q}),this.g=new S.$V(()=>{const q=I.$Wh.forUris(()=>this.c);return q.fill(this.rawDeleted.map(P=>[P,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of ne){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==U.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(ne,...K){return this.h(ne,{includeChildren:!1},...K)}affects(ne,...K){return this.h(ne,{includeChildren:!0},...K)}h(ne,K,...q){if(!ne)return!1;const P=q.length>0;return!!((!P||q.includes(1))&&(this.d.value.get(ne)||K.includeChildren&&this.d.value.findSuperstr(ne))||(!P||q.includes(0))&&(this.f.value.get(ne)||K.includeChildren&&this.f.value.findSuperstr(ne))||(!P||q.includes(2))&&(this.g.value.findSubstr(ne)||K.includeChildren&&this.g.value.findSuperstr(ne)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ne){return this.b===ne}hasCorrelation(){return typeof this.b=="number"}}e.$sk=U;function B(_,ne,K){return!_||!ne||_===ne||ne.length>_.length?!1:(ne.charAt(ne.length-1)!==N.sep&&(ne+=N.sep),K?(0,L.$4e)(_,ne):_.indexOf(ne)===0)}e.$tk=B;class Z extends Error{constructor(ne,K,q){super(ne),this.fileOperationResult=K,this.options=q}}e.$uk=Z;class Q extends Z{constructor(ne,K,q,P){super(ne,K,P),this.fileOperationResult=K,this.size=q}}e.$vk=Q;class x extends Z{constructor(ne,K,q){super(ne,2,q),this.stat=K}}e.$wk=x;var W;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zk="files.associations",e.$Ak="files.exclude",e.$Bk="files.readonlyInclude",e.$Ck="files.readonlyExclude",e.$Dk="files.readonlyFromPermissions";var X;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$Ek="";function G(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Fk=G;async function V(_,ne){if(!ne.hasProvider(O.URI.from({scheme:_.scheme})))return new Promise(K=>{const q=ne.onDidChangeFileSystemProviderRegistrations(P=>{P.scheme===_.scheme&&P.added&&(q.dispose(),K())})})}e.$Gk=V;class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ne){return(0,A.$Df)(ne)||(ne=0),ne<ee.KB?(0,R.localize)(1,null,ne.toFixed(0)):ne<ee.MB?(0,R.localize)(2,null,(ne/ee.KB).toFixed(2)):ne<ee.GB?(0,R.localize)(3,null,(ne/ee.MB).toFixed(2)):ne<ee.TB?(0,R.localize)(4,null,(ne/ee.GB).toFixed(2)):(0,R.localize)(5,null,(ne/ee.TB).toFixed(2))}}e.$Hk=ee;function ie(_){const ne=typeof _=="string"||_?.scheme===C.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===C.Schemas.file?1024*ee.MB:ne?10*ee.MB:g.$p?50*ee.MB:1024*ee.MB}e.$Ik=ie});var Y=this&&this.__param||function(te,e){return function(I,N){e(I,N,te)}};define(oe[188],ae([0,1,70,46,11]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b9b=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const k=(await this.a.readFileStream(R)).value;return new Promise((g,C)=>{const S=(0,I.createHash)("md5");(0,N.$7d)(k,{onData:b=>S.update(b.buffer),onError:b=>C(b),onEnd:()=>g(S.digest("base64").replace(/=+$/,""))})})}};e.$b9b=A,e.$b9b=A=ye([Y(0,L.$_j)],A)}),define(oe[99],ae([0,1,15,7,160,11]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;async function O(C,S,b,c,$,p){let y;try{await R(C,S,b,c,$,p)}catch(h){y=h}finally{y&&$.errorTransformer&&(y=$.errorTransformer(y)),typeof y<"u"&&b.error(y),b.end()}}e.$Qp=O;async function R(C,S,b,c,$,p){k(p);const y=await C.open(S,{create:!1});try{k(p);let h=0,f=0,u=$&&typeof $.length=="number"?$.length:void 0,d=I.$ce.alloc(Math.min($.bufferSize,typeof u=="number"?u:$.bufferSize)),E=$&&typeof $.position=="number"?$.position:0,s=0;do f=await C.read(y,E,d.buffer,s,d.byteLength-s),E+=f,s+=f,h+=f,typeof u=="number"&&(u-=f),s===d.byteLength&&(await b.write(c(d)),d=I.$ce.alloc(Math.min($.bufferSize,typeof u=="number"?u:$.bufferSize)),s=0);while(f>0&&(typeof u!="number"||u>0)&&k(p)&&g(h,$));if(s>0){let o=s;typeof u=="number"&&(o=Math.min(s,u)),b.write(c(d.slice(0,o)))}}catch(h){throw(0,A.$nk)(h)}finally{await C.close(y)}}function k(C){if(C.isCancellationRequested)throw(0,N.$6)();return!0}function g(C,S){if(typeof S?.limits?.size=="number"&&C>S.limits.size)throw(0,A.$mk)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[49],ae([0,1,91,2,16,5,10,11]),function(te,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;function k(h){return h.recursive===!0}e.$Sp=k;class g extends N.$Sc{static{this.a=5}constructor(f,u,d,E){super(),this.h=f,this.j=u,this.m=d,this.n=E,this.c=this.B(new N.$Tc),this.f=void 0,this.g=0}s(){const f=new N.$Rc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(u=>this.h(u))),f.add(this.b.onDidLogMessage(u=>this.j(u))),f.add(this.b.onDidError(u=>this.t(u)))}t(f){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Tp=g;class C extends g{constructor(f,u,d){super(f,u,d,{type:"node.js",restartOnError:!1})}}e.$Up=C;class S extends g{constructor(f,u,d){super(f,u,d,{type:"universal",restartOnError:!0})}}e.$Vp=S;function b(h){return h.map(f=>({type:f.type,resource:O.URI.revive(f.resource),cId:f.cId}))}e.$Wp=b;function c(h){const f=new y;for(const u of h)f.processEvent(u);return f.coalesce()}e.$Xp=c;function $(h,f){return typeof f=="string"&&!f.startsWith(I.$tj)&&!(0,L.$ic)(f)?{base:h,pattern:f}:f}e.$Yp=$;function p(h,f){const u=[];for(const d of f)u.push((0,I.$xj)($(h,d)));return u}e.$Zp=p;class y{constructor(){this.a=new Set,this.b=new Map}c(f){return A.$l?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const u=this.b.get(this.c(f));let d=!1;if(u){const E=u.type,s=f.type;u.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?d=!0:E===1&&s===2?(this.b.delete(this.c(f)),this.a.delete(u)):E===2&&s===1?u.type=0:E===1&&s===0||(u.type=s)}else d=!0;d&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],u=[];return Array.from(this.a).filter(d=>d.type!==2?(f.push(d),!1):!0).sort((d,E)=>d.resource.fsPath.length-E.resource.fsPath.length).filter(d=>u.some(E=>(0,R.$tk)(d.resource.fsPath,E,!A.$l))?!1:(u.push(d.resource.fsPath),!0)).concat(f)}}}),define(oe[189],ae([0,1,15,38,7,3,2,46,32,11,49]),function(te,e,I,N,L,A,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0,e.$vN="localFilesystem";class S extends O.$Sc{constructor(c,$){super(),this.a=c,this.b=$,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$Od),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$Od),this.onDidWatchError=this.g.event,this.h=(0,k.$fg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(c){return this.a.call("stat",[c])}readdir(c){return this.a.call("readdir",[c])}async readFile(c,$){const{buffer:p}=await this.a.call("readFile",[c,$]);return p}readFileStream(c,$,p){const y=(0,R.$3d)(f=>I.$ce.concat(f.map(u=>I.$ce.wrap(u))).buffer),h=new O.$Rc;return h.add(this.a.listen("readFileStream",[c,$])(f=>{if(f instanceof I.$ce)y.write(f.buffer);else{if(f==="end")y.end();else{let u;if(f instanceof Error)u=f;else{const d=f;u=(0,g.$mk)(d.message??(0,N.$Bi)(d),d.code??g.FileSystemProviderErrorCode.Unknown)}y.error(u),y.end()}h.dispose()}})),h.add(p.onCancellationRequested(()=>{y.error((0,L.$6)()),y.end(),h.dispose()})),y}writeFile(c,$,p){return this.a.call("writeFile",[c,I.$ce.wrap($),p])}open(c,$){return this.a.call("open",[c,$])}close(c){return this.a.call("close",[c])}async read(c,$,p,y,h){const[f,u]=await this.a.call("read",[c,$,h]);return p.set(f.buffer.slice(0,u),y),u}write(c,$,p,y,h){return this.a.call("write",[c,$,I.$ce.wrap(p),y,h])}mkdir(c){return this.a.call("mkdir",[c])}delete(c,$){return this.a.call("delete",[c,$])}rename(c,$,p){return this.a.call("rename",[c,$,p])}copy(c,$,p){return this.a.call("copy",[c,$,p])}cloneFile(c,$){return this.a.call("cloneFile",[c,$])}j(){this.B(this.a.listen("fileChange",[this.h])(c=>{if(Array.isArray(c)){const $=c;this.f.fire((0,C.$Wp)($))}else{const $=c;this.g.fire($)}}))}watch(c,$){const p=(0,k.$fg)();return this.a.call("watch",[this.h,p,c,$]),(0,O.$Qc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$wN=S}),define(oe[190],ae([0,1,53,6,26,48,2,88,16,5,19,10,143,31,49]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;class p extends O.$Sc{static{this.a=100}static{this.b=75}constructor(f,u,d,E){super(),this.m=f,this.n=u,this.r=d,this.s=E,this.c=this.B(new N.$0g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.n(s))),this.f=this.B(new N.$9g(s=>this.z(s),p.b)),this.g=(0,$.$Zp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$Zp)(this.m.path,this.m.includes):void 0,this.j=new L.$Yd,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const u=await c.Promises.stat(f);this.B(await this.w(f,u.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let u=f.path;try{u=await c.Promises.realpath(f.path),f.path===u&&(u=await(0,b.$0p)(f.path)??f.path),f.path!==u&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${u})`)}catch{}return u}async w(f,u){if(g.$k&&(0,A.$Yf)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Sc.None;const d=new L.$Yd(this.j.token),E=new O.$Rc;try{const s=S.URI.file(this.m.path),o=(0,k.$nc)(f),n=(0,I.watch)(f);E.add((0,O.$Qc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${f}'`);const i=new Set;if(u)try{for(const r of await c.Promises.readdir(f))i.add(r)}catch(r){this.D(r)}const t=new Map;E.add((0,O.$Qc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(d.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let v="";if(a&&(v=a.toString(),g.$k&&(v=(0,R.$pl)(v))),!(!v||r!=="change"&&r!=="rename"))if(u)if(r==="rename"){t.get(v)?.dispose();const w=setTimeout(async()=>{if(t.delete(v),v===o&&!await c.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.C((0,k.$jc)(f,v));if(d.token.isCancellationRequested)return;let m;l?i.has(v)?m=0:(m=1,i.add(v)):(i.delete(v),m=2),this.y({resource:(0,C.$wg)(s,v),type:m,cId:this.m.correlationId})},p.a);t.set(v,(0,O.$Qc)(()=>clearTimeout(w)))}else{let w;i.has(v)?w=0:(w=1,i.add(v)),this.y({resource:(0,C.$wg)(s,v),type:w,cId:this.m.correlationId})}else if(r==="rename"||v!==o){const w=setTimeout(async()=>{const l=await c.Promises.exists(f);d.token.isCancellationRequested||(l?(this.y({resource:s,type:0,cId:this.m.correlationId},!0),E.add(await this.w(f,!1))):(this.y({resource:s,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);E.clear(),E.add((0,O.$Qc)(()=>clearTimeout(w)))}else this.y({resource:s,type:0,cId:this.m.correlationId},!0)})}catch(s){await c.Promises.exists(f)&&!d.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${s.toString()})`)}return(0,O.$Qc)(()=>{d.dispose(!0),E.dispose()})}y(f,u=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!u&&this.g.some(d=>d(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!u&&this.h&&this.h.length>0&&!this.h.some(d=>d(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const u=(0,$.$Xp)(f);if(u.length>0){if(this.s)for(const E of u)this.G(` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(g.$l)return c.Promises.exists(f);try{const u=(0,k.$nc)(f);return(await c.Promises.readdir((0,k.$mc)(f))).some(E=>E===u)}catch(u){return this.G(u),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$aq=p;async function y(h,f,u,d,E=512){const s=await c.Promises.open(h,"r"),o=Buffer.allocUnsafe(E),n=new L.$Yd(d);let i,t=!1;const r={path:h,excludes:[],recursive:!1},a=new p(r,v=>{(async()=>{for(const{type:w}of v)if(w===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:l}=await c.Promises.read(s,o,0,E,null);if(!l||n.token.isCancellationRequested)break;f(o.slice(0,l))}}catch(l){i=new Error(l),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,u(),new Promise((v,w)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await c.Promises.close(s)}catch(l){i=new Error(l)}i?w(i):v()})})}e.$bq=y}),define(oe[191],ae([0,1,3,91,2,5,190]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class R extends L.$Sc{constructor(){super(...arguments),this.a=this.B(new I.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$Od),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(g){const C=this.j(g),S=C.filter(c=>{const $=this.c.get(c.path);return $?!(0,N.$Bj)($.request.excludes,c.excludes)||!(0,N.$Bj)($.request.includes,c.includes):!0}),b=Array.from(this.c.values()).filter(({request:c})=>!C.find($=>$.path===c.path&&(0,N.$Bj)($.excludes,c.excludes)&&(0,N.$Bj)($.includes,c.includes))).map(({request:c})=>c.path);S.length&&this.m(`Request to start watching: ${S.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const c of b)this.h(c);for(const c of S)this.g(c)}g(g){const C=new O.$aq(g,b=>this.a.fire(b),b=>this.b.fire(b),this.f),S={request:g,instance:C};this.c.set(g.path,S)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const C=this.c.get(g);C&&(this.c.delete(g),C.instance.dispose())}j(g){const C=new Map;for(const S of g){const b=A.$l?S.path:S.path.toLowerCase();let c=C.get(S.correlationId);c||(c=new Map,C.set(S.correlationId,c)),c.set(b,S)}return Array.from(C.values()).map(S=>Array.from(S.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,C]of this.c)C.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$cq=R}),define(oe[192],ae([0,1,49,191]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class L extends I.$Up{constructor(O,R,k){super(O,R,k),this.s()}r(O){return O.add(new N.$cq)}}e.$dq=L}),define(oe[193],ae([0,1,23,42,93,49]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class O extends A.$Vp{constructor(k,g,C){super(k,g,C),this.s()}r(k){const g=k.add(new L.$7p(I.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(g.onDidProcessExit(({code:C,signal:S})=>this.t(`terminated by itself with code ${C}, signal: ${S}`))),N.ProxyChannel.toService((0,N.$xh)(g.getChannel("watcher")))}}e.$8p=O}),define(oe[71],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=void 0;class I{constructor(...L){this.a=new Map;for(const[A,O]of L)this.set(A,O)}set(L,A){const O=this.a.get(L);return this.a.set(L,A),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$Oh=I}),define(oe[194],ae([0,1,6,7,2,69,185,4,71,87]),function(te,e,I,N,L,A,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;const C=!1;class S extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class b{constructor(y=new k.$Oh,h=!1,f,u=C){this.f=y,this.g=h,this.h=f,this.i=u,this.o=new Set,this.f.set(R.$Ph,this),this._globalGraph=u?f?._globalGraph??new O.$gq(d=>d):void 0}createChild(y){return new b(y,this.g,this,this.i)}invokeFunction(y,...h){const f=$.traceInvocation(this.i,y);let u=!1;try{return y({get:E=>{if(u)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(E,f);if(!s)throw new Error(`[invokeFunction] unknown service '${E}'`);return s}},...h)}finally{u=!0,f.stop()}}createInstance(y,...h){let f,u;return y instanceof A.$Nh?(f=$.traceCreation(this.i,y.ctor),u=this.j(y.ctor,y.staticArguments.concat(h),f)):(f=$.traceCreation(this.i,y),u=this.j(y,h,f)),f.stop(),u}j(y,h=[],f){const u=R._util.getServiceDependencies(y).sort((s,o)=>s.index-o.index),d=[];for(const s of u){const o=this.m(s.id,f);o||this.u(`[createInstance] ${y.name} depends on UNKNOWN service ${s.id}.`,!1),d.push(o)}const E=u.length>0?u[0].index:h.length;if(h.length!==E){console.trace(`[createInstance] First service dependency of ${y.name} at position ${E+1} conflicts with ${h.length} static arguments`);const s=E-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,E)}return Reflect.construct(y,h.concat(d))}k(y,h){if(this.f.get(y)instanceof A.$Nh)this.f.set(y,h);else if(this.h)this.h.k(y,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(y){const h=this.f.get(y);return!h&&this.h?this.h.l(y):h}m(y,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const f=this.l(y);return f instanceof A.$Nh?this.q(y,f,h.branch(y,!0)):(h.branch(y,!1),f)}q(y,h,f){if(this.o.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.o.add(y);try{return this.r(y,h,f)}finally{this.o.delete(y)}}r(y,h,f){const u=new O.$gq(s=>s.id.toString());let d=0;const E=[{id:y,desc:h,_trace:f}];for(;E.length;){const s=E.pop();if(u.lookupOrInsertNode(s),d++>1e3)throw new S(u);for(const o of R._util.getServiceDependencies(s.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${y} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),n instanceof A.$Nh){const i={id:o.id,desc:n,_trace:s._trace.branch(o.id,!0)};u.insertEdge(s,i),E.push(i)}}}for(;;){const s=u.roots();if(s.length===0){if(!u.isEmpty())throw new S(u);break}for(const{data:o}of s){if(this.l(o.id)instanceof A.$Nh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}u.removeNode(o)}}return this.l(y)}s(y,h,f=[],u,d){if(this.f.get(y)instanceof A.$Nh)return this.t(y,h,f,u,d);if(this.h)return this.h.s(y,h,f,u,d);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(y,h,f=[],u,d){if(u){const E=new b(void 0,this.g,this,this.i);E.c=String(y);const s=new Map,o=new I.$_g(()=>{const n=E.j(h,f,d);for(const[i,t]of s){const r=n[i];if(typeof r=="function")for(const a of t)r.apply(n,a)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let a=s.get(i);return a||(a=new g.$2c,s.set(i,a)),(w,l,m)=>{const D=a.push([w,l,m]);return(0,L.$Qc)(D)}}if(i in n)return n[i];const t=o.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),n[i]=r),r},set(n,i,t){return o.value[i]=t,!0},getPrototypeOf(n){return h.prototype}})}else return this.j(h,f,d)}u(y,h){if(h&&console.warn(y),this.g)throw new Error(y)}}e.$hq=b;var c;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(c||(c={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(y,h){return y?new $(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(y,h){return y?new $(1,h.name):$.c}static{this.f=0}constructor(y,h){this.type=y,this.name=h,this.g=Date.now(),this.h=[]}branch(y,h){const f=new $(3,y.toString());return this.h.push([y,h,f]),f}stop(){const y=Date.now()-this.g;$.f+=y;let h=!1;function f(d,E){const s=[],o=new Array(d+1).join("	");for(const[n,i,t]of E.h)if(i&&t){h=!0,s.push(`${o}CREATES -> ${n}`);const r=f(d+1,t);r&&s.push(r)}else s.push(`${o}uses -> ${n}`);return s.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(y>2||h)&&$.all.add(u.join(`
`))}}e.$iq=$}),define(oe[72],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L8b=e.$K8b=void 0,e.$K8b=(0,I.$Qh)("mainProcessService");class N{constructor(A,O){this.a=A,this.b=O}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,O){this.a.registerChannel(A,O)}}e.$L8b=N}),define(oe[73],ae([0,1,26,2,5,162,29,4]),function(te,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=e.$Vq=void 0;function k(C){return C.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$Vq=k,e.$Wq=(0,R.$Qh)("languagePackService");let g=class extends N.$Sc{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new I.$Yd;setTimeout(()=>S.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const $=b.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(y=>y.startsWith("lp-"))).map(p=>{const y=p.properties.localizedLanguages?.[0],h=k(p);return{...this.f(h,y,p),extensionId:p.identifier.id,galleryExtension:p}});return $.push(this.f("en","English")),$}f(S,b,c){const $=b??S;let p;if($!==S&&(p=`(${S})`),S.toLowerCase()===L.$w.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),c?.installCount){p??="";const y=c.installCount;let h;y>1e6?h=`${Math.floor(y/1e5)/10}M`:y>1e3?h=`${Math.floor(y/1e3)}K`:h=String(y),p+=` $(cloud-download) ${h}`}return{id:S,label:$,description:p}}};e.$Xq=g,e.$Xq=g=ye([Y(0,O.$bo)],g)}),define(oe[195],ae([0,1,2,73]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$08b=void 0;let L=class extends I.$Sc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$08b=L,e.$08b=L=ye([Y(0,N.$Wq)],L)}),define(oe[8],ae([0,1,38,3,52,2,34,5,19,12,10,94,4]),function(te,e,I,N,L,A,O,R,k,g,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.log=e.$bj=e.LogLevel=e.$aj=e.$_i=e.$$i=void 0,e.$$i=(0,b.$Qh)("logService"),e.$_i=(0,b.$Qh)("loggerService");function c(){return new Date().toISOString()}function $(w){return(0,g.$Df)(w)}e.$aj=$;var p;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$bj=p.Info;function y(w,l,m){switch(l){case p.Trace:w.trace(m);break;case p.Debug:w.debug(m);break;case p.Info:w.info(m);break;case p.Warning:w.warn(m);break;case p.Error:w.error(m);break;case p.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=y;function h(w,l=!1){let m="";for(let D=0;D<w.length;D++){let T=w[D];if(T instanceof Error&&(T=(0,I.$Bi)(T,l)),typeof T=="object")try{T=JSON.stringify(T)}catch{}m+=(D>0?" ":"")+T}return m}class f extends A.$Sc{constructor(){super(...arguments),this.b=e.$bj,this.c=this.B(new N.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==p.Off&&this.b<=l}}e.$dj=f;class u extends f{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...m){this.f(p.Trace)&&this.g(p.Trace,h([l,...m],!0))}debug(l,...m){this.f(p.Debug)&&this.g(p.Debug,h([l,...m]))}info(l,...m){this.f(p.Info)&&this.g(p.Info,h([l,...m]))}warn(l,...m){this.f(p.Warning)&&this.g(p.Warning,h([l,...m]))}error(l,...m){if(this.f(p.Error))if(l instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=l.stack,this.g(p.Error,h(D))}else this.g(p.Error,h([l,...m]))}flush(){}}e.$ej=u;class d extends f{constructor(l=e.$bj){super(),this.setLevel(l),this.g=!R.$j}trace(l,...m){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...m):console.log(`[main ${c()}]`,l,...m))}debug(l,...m){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...m):console.log(`[main ${c()}]`,l,...m))}info(l,...m){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,l,...m):console.log(`[main ${c()}]`,l,...m))}warn(l,...m){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,l,...m):console.warn(`[main ${c()}]`,l,...m))}error(l,...m){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,l,...m):console.error(`[main ${c()}]`,l,...m))}dispose(){}flush(){}}e.$fj=d;class E extends f{constructor(l=e.$bj,m=!0){super(),this.g=m,this.setLevel(l)}trace(l,...m){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",l,...m):console.log(l,...m))}debug(l,...m){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",l,...m):console.log(l,...m))}info(l,...m){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",l,...m):console.log(l,...m))}warn(l,...m){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",l,...m):console.log(l,...m))}error(l,...m){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",l,...m):console.error(l,...m))}dispose(){}flush(){}}e.$gj=E;class s extends f{constructor(l,m=e.$bj){super(),this.g=l,this.setLevel(m)}trace(l,...m){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(l),...m])}debug(l,...m){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(l),...m])}info(l,...m){this.f(p.Info)&&this.g.log(p.Info,[this.h(l),...m])}warn(l,...m){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(l),...m])}error(l,...m){this.f(p.Error)&&this.g.log(p.Error,[this.h(l),...m])}h(l){return typeof l=="string"?l:(0,I.$Bi)(l,this.f(p.Trace))}dispose(){}flush(){}}e.$hj=s;class o extends f{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const m of this.g)m.setLevel(l);super.setLevel(l)}trace(l,...m){for(const D of this.g)D.trace(l,...m)}debug(l,...m){for(const D of this.g)D.debug(l,...m)}info(l,...m){for(const D of this.g)D.info(l,...m)}warn(l,...m){for(const D of this.g)D.warn(l,...m)}error(l,...m){for(const D of this.g)D.error(l,...m)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.$ij=o;class n extends A.$Sc{constructor(l,m,D){if(super(),this.h=l,this.j=m,this.b=new O.$Ac,this.c=this.B(new N.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Od),this.onDidChangeVisibility=this.g.event,D)for(const T of D)this.b.set(T.resource,{logger:void 0,info:T})}m(l){return(0,g.$zf)(l)?[...this.b.values()].find(m=>m.info.id===l):this.b.get(l)}getLogger(l){return this.m(l)?.logger}createLogger(l,m){const D=this.n(l),T=(0,g.$zf)(l)?l:m?.id??(0,L.$Ei)(D.toString()).toString(16);let z=this.b.get(D)?.logger;const U=m?.logLevel==="always"?p.Trace:m?.logLevel;z||(z=this.s(D,U??this.getLogLevel(D)??this.h,{...m,id:T}));const B={logger:z,info:{resource:D,id:T,logLevel:U,name:m?.name,hidden:m?.hidden,extensionId:m?.extensionId,when:m?.when}};return this.registerLogger(B.info),this.b.set(D,B),z}n(l){return(0,g.$zf)(l)?(0,k.$wg)(this.j,`${l}.log`):l}setLogLevel(l,m){if(C.URI.isUri(l)){const D=l,T=m,z=this.b.get(D);z&&T!==z.info.logLevel&&(z.info.logLevel=T===this.h?void 0:T,z.logger?.setLevel(T),this.b.set(z.info.resource,z),this.f.fire([D,T]))}else{this.h=l;for(const[D,T]of this.b.entries())this.b.get(D)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(l,m){const D=this.m(l);D&&m!==!D.info.hidden&&(D.info.hidden=!m,this.b.set(D.info.resource,D),this.g.fire([D.info.resource,m]))}getLogLevel(l){let m;return l&&(m=this.b.get(l)?.info.logLevel),m??this.h}registerLogger(l){const m=this.b.get(l.resource);m?m.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.b.set(l.resource,{info:l,logger:void 0}),this.c.fire({added:[l],removed:[]}))}deregisterLogger(l){const m=this.b.get(l);m&&(m.logger&&m.logger.dispose(),this.b.delete(l),this.c.fire({added:[],removed:[m.info]}))}*getRegisteredLoggers(){for(const l of this.b.values())yield l.info}getRegisteredLogger(l){return this.b.get(l)?.info}dispose(){this.b.forEach(l=>l.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jj=n;class i{constructor(){this.onDidChangeLogLevel=new N.$Od().event}setLevel(l){}getLevel(){return p.Info}trace(l,...m){}debug(l,...m){}info(l,...m){}warn(l,...m){}error(l,...m){}critical(l,...m){}dispose(){}flush(){}}e.$kj=i;class t extends i{}e.$lj=t;function r(w){if(w.verbose)return p.Trace;if(typeof w.logLevel=="string"){const l=v(w.logLevel.toLowerCase());if(l!==void 0)return l}return e.$bj}e.$mj=r;function a(w){switch(w){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$nj=a;function v(w){switch(w){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$oj=v,e.$pj=new S.$8i("logLevel",a(p.Info))}),define(oe[196],ae([0,1,6,7,2,23,16,19,31,14,8]),function(te,e,I,N,L,A,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$8b=void 0;let S=class extends L.$Sc{constructor(c,$){super(),this.a=c,this.b=$,this.B(new I.$7g(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,R.$tg)(this.a.logsHome),$=(0,R.$vg)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,h=(await k.Promises.readdir($)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==c),f=h.slice(0,Math.max(0,h.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(u=>k.Promises.rm((0,O.$jc)($,u)))))}catch(c){(0,N.$1)(c)}}};e.$$8b=S,e.$$8b=S=ye([Y(0,g.$Xh),Y(1,C.$$i)],S)}),define(oe[197],ae([0,1,18,6,7,3,2,16,49,8]),function(te,e,I,N,L,A,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class C extends O.$Sc{constructor(b,c){super(),this.a=b,this.b=c,this.c=this.B(new A.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Sg(0)),this.w=[],this.y=this.B(new N.$Sg(0))}watch(b,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(b,c):this.z(b,c)}n(b,c){const $={path:this.H(b),excludes:c.excludes,includes:c.includes,recursive:c.recursive,correlationId:c.correlationId},p=(0,I.$Ub)(this.j,$);return this.r(),(0,O.$Qc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,L.$1)(b))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,k.$Wp)(c)),c=>this.G(c),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const c of this.j)(0,k.$Sp)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const c of this.j)(0,k.$Sp)(c)&&b.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,c){const $={path:this.H(b),excludes:c.excludes,includes:c.includes,recursive:!1,correlationId:c.correlationId},p=(0,I.$Ub)(this.w,$);return this.C(),(0,O.$Qc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,L.$1)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,k.$Wp)(b)),b=>this.G(b),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,R.$hc)(b.fsPath)}}e.$1p=C}),define(oe[198],ae([0,1,18,6,15,26,3,52,59,2,47,23,100,19,46,158,11,99,8,7]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;let E=class extends g.$Sc{static{d=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new O.$Od),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$Od),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$Od),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$Od),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$Od),this.Y=this.B(new O.$Od),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$Od),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$4g)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${o}`);const i=new g.$Rc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),i.add(n.onDidChangeFile(t=>{const r=new y.$sk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&i.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,g.$Qc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,g.$Nc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(i){n.push(i)}}),!this.h.has(o)&&await N.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&n)}listCapabilities(){return k.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,c.$Ag)(o))throw new y.$uk((0,p.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const i=new u.$bb;throw i.message=(0,p.localize)(1,null,o.toString()),i}return n}async m(o){const n=await this.j(o);if((0,y.$fk)(n)||(0,y.$ck)(n)||(0,y.$gk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,y.$fk)(n)||(0,y.$ck)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(i){throw(0,y.$pk)(i)===y.FileSystemProviderErrorCode.FileNotFound?new y.$uk((0,p.localize)(2,null,this.sb(o)),1):(0,y.$nk)(i)}}async s(o,n){const i=await this.j(o),t=this.S(i),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,w=await i.stat(o);let l;return this.t(i,o,w,void 0,!!v,(m,D)=>(l||(l=C.$Wh.forUris(()=>!t),l.set(o,!0),r&&l.fill(!0,r)),l.get(m.resource)||l.findSuperstr(m.resource.with({query:null,fragment:null}))?!0:m.isDirectory&&a?D===1:!1))}async t(o,n,i,t,r,a){const{providerExtUri:v}=this.R(o),w={resource:n,name:v.basename(n),isFile:(i.type&y.FileType.File)!==0,isDirectory:(i.type&y.FileType.Directory)!==0,isSymbolicLink:(i.type&y.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&y.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&y.FilePermission.Locked),etag:(0,y.$Fk)({mtime:i.mtime,size:i.size}),children:void 0};if(w.isDirectory&&a(w,t)){try{const l=await o.readdir(n),m=await N.Promises.settled(l.map(async([D,T])=>{try{const z=v.joinPath(n,D),U=r?await o.stat(z):{type:T};return await this.t(o,z,U,l.length,r,a)}catch(z){return this.b.trace(z),null}}));w.children=(0,I.$Hb)(m)}catch(l){this.b.trace(l),w.children=[]}return w}return w}async resolveAll(o){return N.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),i=await n.stat(o);return this.t(n,o,i,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(i){return i}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new y.$uk((0,p.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=L.$ce.fromString(""),i){await this.u(o,i);const t=await this.writeFile(o,n);return this.r.fire(new y.$rk(o,0,t)),t}async writeFile(o,n,i){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=i;if((0,y.$ik)(t)&&!a?.atomic){const v=t.enforceAtomicWriteFile?.(o);v&&(a={...i,atomic:v})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let w;if((0,y.$ck)(t)&&!(n instanceof L.$ce))if((0,$.$1d)(n)){const l=await(0,$.$8d)(n,3);l.ended?w=L.$ce.concat(l.buffer):w=l}else w=(0,$.$5d)(n,l=>L.$ce.concat(l),3);else w=n;!(0,y.$fk)(t)||(0,y.$ck)(t)&&w instanceof L.$ce||(0,y.$ck)(t)&&(0,y.$ik)(t)&&a?.atomic?await this.hb(t,o,a,w):await this.db(t,o,a,w instanceof L.$ce?(0,L.$ne)(w):w),this.r.fire(new y.$rk(o,4))}catch(v){throw new y.$uk((0,p.localize)(4,null,this.sb(o),(0,y.$nk)(v).toString()),(0,y.$qk)(v),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,i){const t=!!i?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(t)throw new Error((0,p.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&y.FileType.Directory)throw new y.$uk((0,p.localize)(9,null,this.sb(n)),0,i);if(this.rb(n,a),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==y.$Ek&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==(0,y.$Fk)({mtime:i.mtime,size:a.size}))throw new y.$uk((0,p.localize)(10,null),3,i);return a}async readFile(o,n,i){const t=await this.m(o);return n?.atomic?this.z(t,o,n,i):this.C(t,o,n,i)}async z(o,n,i,t){return new Promise((r,a)=>{this.cb.queueFor(n,this.R(o).providerExtUri).queue(async()=>{try{const v=await this.C(o,n,i,t);r(v)}catch(v){a(v)}})})}async C(o,n,i,t){const r=await this.D(o,n,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,L.$oe)(r.value)}}async readFileStream(o,n,i){const t=await this.m(o);return this.D(t,o,n,i)}async D(o,n,i,t){const r=new A.$Yd(t);let a=i;(0,y.$hk)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...i,atomic:!0});const v=this.J(n,a).then(l=>l,l=>{throw r.dispose(!0),l});let w;try{return typeof a?.etag=="string"&&a.etag!==y.$Ek&&await v,a?.atomic&&(0,y.$hk)(o)||!((0,y.$fk)(o)||(0,y.$gk)(o))||(0,y.$ck)(o)&&a?.preferUnbuffered?w=this.I(o,n,a):(0,y.$gk)(o)?w=this.G(o,n,r.token,a):w=this.H(o,n,r.token,a),w.on("end",()=>r.dispose()),w.on("error",()=>r.dispose()),{...await v,value:w}}catch(l){throw w&&await(0,$.$6d)(w),this.F(l,n,a)}}F(o,n,i){const t=(0,p.localize)(11,null,this.sb(n),(0,y.$nk)(o).toString());return o instanceof y.$wk?new y.$wk(t,o.stat,i):o instanceof y.$vk?new y.$vk(t,o.fileOperationResult,o.size,o.options):new y.$uk(t,(0,y.$qk)(o),i)}G(o,n,i,t=Object.create(null)){const r=o.readFileStream(n,t,i);return(0,$.$_d)(r,{data:a=>a instanceof L.$ce?a:L.$ce.wrap(a),error:a=>this.F(a,n,t)},a=>L.$ce.concat(a))}H(o,n,i,t=Object.create(null)){const r=(0,L.$se)();return(0,h.$Qp)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},i),r}I(o,n,i){const t=(0,$.$3d)(r=>L.$ce.concat(r));return(async()=>{try{let r;i?.atomic&&(0,y.$hk)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(n,r.byteLength,i),t.end(L.$ce.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new y.$uk((0,p.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==y.$Ek&&n.etag===i.etag)throw new y.$wk((0,p.localize)(13,null),i,n);return this.L(o,i.size,n),i}L(o,n,i){if(typeof i?.limits?.size=="number"&&n>i.limits.size)throw new y.$vk((0,p.localize)(14,null,this.sb(o)),7,n,i)}async canMove(o,n,i){return this.M(o,n,"move",i)}async canCopy(o,n,i){return this.M(o,n,"copy",i)}async M(o,n,i,t){if(o.toString()!==n.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,i,t)}catch(r){return r}return!0}async move(o,n,i){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new y.$rk(o,a==="move"?2:3,v)),v}async copy(o,n,i){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!i),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new y.$rk(o,a==="copy"?3:2,v)),v}async N(o,n,i,t,r,a){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:w}=await this.Q(o,n,i,t,r,a);if(v&&!w&&a&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(o===i&&(0,y.$dk)(o))await o.copy(n,t,{overwrite:a});else{const l=await this.resolve(n);l.isDirectory?await this.P(o,l,i,t):await this.O(o,n,i,t)}return r}else return o===i?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,i,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,i,t){if((0,y.$fk)(o)&&(0,y.$fk)(i))return this.jb(o,n,i,t);if((0,y.$fk)(o)&&(0,y.$ck)(i))return this.pb(o,n,i,t);if((0,y.$ck)(o)&&(0,y.$fk)(i))return this.nb(o,n,i,t);if((0,y.$ck)(o)&&(0,y.$ck)(i))return this.lb(o,n,i,t)}async P(o,n,i,t){await i.mkdir(t),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async r=>{const a=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,a):this.O(o,r.resource,i,a)}))}async Q(o,n,i,t,r,a){let v=!1;if(o===i){const{providerExtUri:l,isPathCaseSensitive:m}=this.R(o);if(m||(v=l.isEqual(n,t)),v&&r==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&l.isEqualOrParent(t,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(t)))}const w=await this.exists(t);if(w&&!v){if(!a)throw new y.$uk((0,p.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===i){const{providerExtUri:l}=this.R(o);if(l.isEqualOrParent(n,t))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:w,isSameResourceWithDifferentPathCase:v}}R(o){const n=this.S(o);return{providerExtUri:n?c.$mg:c.$og,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new y.$rk(o,0,i)),i}async U(o,n){const i=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&y.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(r){if((0,y.$pk)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(n)),n=t.dirname(n)}for(let r=i.length-1;r>=0;r--){n=t.joinPath(n,i[r]);try{await o.mkdir(n)}catch(a){if((0,y.$pk)(a)!==y.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(i){return i}return!0}async W(o,n){const i=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,p.localize)(22,null,this.sb(o)));let a;try{a=await i.stat(o)}catch{}if(a)this.rb(o,a);else throw new y.$uk((0,p.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const w=await this.resolve(o);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(o)))}return i}async del(o,n){const i=await this.W(o,n);let t=n;if((0,y.$jk)(i)&&!t?.atomic){const w=i.enforceAtomicDelete?.(o);w&&(t={...n,atomic:w})}const r=!!t?.useTrash,a=!!t?.recursive,v=t?.atomic??!1;await i.delete(o,{recursive:a,useTrash:r,atomic:v}),this.r.fire(new y.$rk(o,1))}async cloneFile(o,n){const i=await this.j(o),t=this.qb(await this.n(n),n);if(i===t&&this.R(i).providerExtUri.isEqual(o,n))return;if(i===t&&(0,y.$ek)(i))return i.cloneFile(o,n);await this.U(t,this.R(t).providerExtUri.dirname(n));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===t&&(0,y.$dk)(i)?r.queue(()=>i.copy(o,n,{overwrite:!0})):r.queue(()=>this.O(i,o,t,n))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:d.ab++})}watch(o,n={recursive:!1,excludes:[]}){const i=new g.$Rc;let t=!1,r=()=>{t=!0};i.add((0,g.$Qc)(()=>r())),(async()=>{try{const v=await this.bb(o,n);t?(0,g.$Nc)(v):r=()=>(0,g.$Nc)(v)}catch(v){this.b.error(v)}})();const a=n.correlationId;if(typeof a=="number"){const v=i.add(new O.$Od);return i.add(this.X.event(l=>{l.correlates(a)&&v.fire(l)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(o,n){const i=await this.j(o),t=(0,R.$Ei)([this.R(i).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,g.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Nc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Nc)(o.disposable);this.$.clear()}async db(o,n,i,t){return this.cb.queueFor(n,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(n,{create:!0,unlock:i?.unlock??!1});try{(0,$.$1d)(t)||(0,$.$2d)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,y.$nk)(a)}finally{await o.close(r)}})}async eb(o,n,i){let t=0,r;if((0,$.$2d)(i)){if(i.buffer.length>0){const a=L.$ce.concat(i.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,v)=>{(0,$.$7d)(r,{onData:async w=>{r.pause();try{await this.gb(o,n,w,w.byteLength,t,0)}catch(l){return v(l)}t+=w.byteLength,setTimeout(()=>r.resume())},onError:w=>v(w),onEnd:()=>a()})})}async fb(o,n,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,i,t,r,a){let v=0;for(;v<t;){const w=await o.write(n,r+v,i.buffer,a+v,t-v);v+=w}}async hb(o,n,i,t){return this.cb.queueFor(n,this.R(o).providerExtUri).queue(()=>this.ib(o,n,i,t))}async ib(o,n,i,t){let r;t instanceof L.$ce?r=t:(0,$.$1d)(t)?r=await(0,L.$oe)(t):(0,$.$2d)(t)?r=await(0,L.$pe)(t):r=(0,L.$me)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(o,n,i,t))}async kb(o,n,i,t){let r,a;try{r=await o.open(n,{create:!1}),a=await i.open(t,{create:!0,unlock:!1});const v=L.$ce.alloc(this.a);let w=0,l=0,m=0;do m=await o.read(r,w,v.buffer,l,v.byteLength-l),await this.gb(i,a,v,m,w,l),w+=m,l+=m,l===v.byteLength&&(l=0);while(m>0)}catch(v){throw(0,y.$nk)(v)}finally{await N.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async lb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(o,n,i,t))}async mb(o,n,i,t){return i.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(o,n,i,t))}async ob(o,n,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(i,r,L.$ce.wrap(a),a.byteLength,0,0)}catch(a){throw(0,y.$nk)(a)}finally{await i.close(r)}}async pb(o,n,i,t){const r=await(0,L.$oe)(this.H(o,n,A.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new y.$uk((0,p.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&y.FilePermission.Readonly)throw new y.$uk((0,p.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===S.Schemas.file?o.fsPath:o.toString(!0)}};e.$Rp=E,e.$Rp=E=d=ye([Y(0,f.$$i)],E)}),define(oe[199],ae([0,1,53,269,6,34,15,3,48,2,16,5,19,46,31,161,11,99,197,38,193,192]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0,(()=>{try{(0,N.gracefulify)(I)}catch(o){console.error(`Error enabling graceful-fs: ${(0,u.$Bi)(o)}`)}})();class s extends f.$1p{static{this.I=!1}constructor(n,i){super(n,i),this.onDidChangeCapabilities=R.Event.None,this.N=new A.$Ac(t=>b.$ng.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,S.$l&&(this.J|=1024)),this.J}async stat(n){try{const{stat:i,symbolicLink:t}=await $.SymlinkSupport.stat(this.H(n));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:y.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const i=await $.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,b.$wg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(i){throw this.fb(i)}}M(n,i){let t;return i?.dangling?t=y.FileType.Unknown:n.isFile()?t=y.FileType.File:n.isDirectory()?t=y.FileType.Directory:t=y.FileType.Unknown,i&&(t|=y.FileType.SymbolicLink),t}async O(n){const i=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new L.$Tg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(n,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await $.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){s.I&&this.a.trace(n)}readFileStream(n,i,t){const r=(0,c.$3d)(a=>O.$ce.concat(a.map(v=>O.$ce.wrap(v))).buffer);return(0,h.$Qp)(this,n,r,a=>a.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(n,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,b.$wg)((0,b.$vg)(n),`${(0,b.$tg)(n)}${t.atomic.postfix}`),i,t):this.S(n,i,t)}async Q(n){try{const i=this.H(n),{symbolicLink:t}=await $.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(n,i,t,r){const a=new g.$Rc;try{a.add(await this.O(n)),a.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,n,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{a.dispose()}}async S(n,i,t,r){let a;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await $.Promises.exists(v)){if(!t.overwrite)throw(0,y.$mk)((0,p.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,y.$mk)((0,p.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,i,0,i.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){s.Y=n}async open(n,i,t){const r=this.H(n);let a;(0,y.$ak)(i)&&!t&&(a=await this.O(n));let v;try{if((0,y.$ak)(i)&&i.unlock)try{const{stat:l}=await $.SymlinkSupport.stat(r);l.mode&128||await $.Promises.chmod(r,l.mode|128)}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}let w;if((0,y.$ak)(i)){if(S.$j)try{await $.Promises.truncate(r,0),w="r+"}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}w||(w="w")}else w="r";v=await $.Promises.open(r,w)}catch(w){throw a?.dispose(),(0,y.$ak)(i)?await this.gb(n,w):this.fb(w)}if(this.U.set(v,0),(0,y.$ak)(i)&&this.X.set(v,n),a){const w=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,a),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),w.dispose())}return v}async close(n){const i=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&s.Y)try{await $.Promises.fdatasync(n)}catch(t){s.configureFlushOnWrite(!1),this.a.error(t)}return await $.Promises.close(n)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(n)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,t,r,a){const v=this.Z(n,i);let w=null;try{w=(await $.Promises.read(n,t,r,a,v)).bytesRead}catch(l){throw this.fb(l)}finally{this.$(n,v,w)}return w}Z(n,i){return i===this.U.get(n)?null:i}$(n,i,t){const r=this.U.get(n);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,i,t,r,a){return(0,L.$ah)(()=>this.ab(n,i,t,r,a),100,3)}async ab(n,i,t,r,a){const v=this.Z(n,i);let w=null;try{w=(await $.Promises.write(n,t,r,a,v)).bytesWritten}catch(l){throw await this.gb(this.X.get(n),l)}finally{this.$(n,v,w)}return w}async mkdir(n){try{await $.Promises.mkdir(this.H(n))}catch(i){throw this.fb(i)}}async delete(n,i){try{const t=this.H(n);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,C.$jc)((0,C.$mc)(t),`${(0,C.$nc)(t)}${i.atomic.postfix}`)),await $.Promises.rm(t,$.RimRafMode.MOVE,r)}else try{await $.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:w}=await $.SymlinkSupport.stat(t);a=v.isDirectory()&&!w}catch{}if(a)await $.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,i,t){const r=this.H(n),a=this.H(i);if(r!==a)try{await this.bb(n,i,"move",t.overwrite),await $.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),v.toString()))),this.fb(v)}}async copy(n,i,t){const r=this.H(n),a=this.H(i);if(r!==a)try{await this.bb(n,i,"copy",t.overwrite),await $.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),v.toString()))),this.fb(v)}}async bb(n,i,t,r){const a=this.H(n),v=this.H(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,k.$Xf)(a,v,!0)),w){if(t==="copy")throw(0,y.$mk)((0,p.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const m=await this.L(n);if(!m)throw(0,y.$mk)((0,p.localize)(5,null),y.FileSystemProviderErrorCode.FileNotFound);const D=await this.L(i);if(D){if(!r)throw(0,y.$mk)((0,p.localize)(6,null),y.FileSystemProviderErrorCode.FileExists);m.type&y.FileType.File&&D.type&y.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,i){return this.cb(n,i,!1)}async cb(n,i,t){const r=this.H(n),a=this.H(i),v=!!(this.capabilities&1024);if((0,k.$Xf)(r,a,!v))return;const w=new g.$Rc;try{w.add(await this.O(n)),w.add(await this.O(i)),t&&await $.Promises.mkdir((0,C.$mc)(a),{recursive:!0}),await $.Promises.copyFile(r,a)}catch(l){if(l.code==="ENOENT"&&!t)return this.cb(n,i,!0);throw this.fb(l)}finally{w.dispose()}}t(n,i,t){return new d.$8p(r=>n(r),r=>i(r),t)}F(n,i,t){return new E.$dq(r=>n(r),r=>i(r),t)}fb(n){if(n instanceof y.$lk)return n;let i=n,t;switch(n.code){case"ENOENT":t=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=y.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=y.FileSystemProviderErrorCode.Unknown;break;default:t=y.FileSystemProviderErrorCode.Unknown}return(0,y.$mk)(i,t)}async gb(n,i){let t=this.fb(i);if(n&&t.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,y.$mk)(i,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$eq=s}),define(oe[101],ae([0,1,3,2,4,8]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B9b=e.$A9b=void 0,e.$A9b=(0,L.$Qh)("sharedProcessLifecycleService");let O=class extends N.$Sc{constructor(k){super(),this.b=k,this.a=this.B(new I.$Od),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$B9b=O,e.$B9b=O=ye([Y(0,A.$$i)],O)}),define(oe[200],ae([0,1,10,3,8,2]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.$cr=void 0;class O extends L.$jj{constructor(S,b,c,$,p){super(b,c,$),this.r=S,this.t=p,this.B(p.listen("onDidChangeLogLevel",S)(y=>{(0,L.$aj)(y)?super.setLogLevel(y):super.setLogLevel(I.URI.revive(y[0]),y[1])})),this.B(p.listen("onDidChangeVisibility",S)(([y,h])=>super.setVisibility(I.URI.revive(y),h))),this.B(p.listen("onDidChangeLoggers",S)(({added:y,removed:h})=>{for(const f of y)super.registerLogger({...f,resource:I.URI.revive(f.resource)});for(const f of h)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new L.$hj({log:(S,b)=>{this.t.call("consoleLog",[S,b])}})}registerLogger(S){super.registerLogger(S),this.t.call("registerLogger",[S,this.r])}deregisterLogger(S){super.deregisterLogger(S),this.t.call("deregisterLogger",[S,this.r])}setLogLevel(S,b){super.setLogLevel(S,b),this.t.call("setLogLevel",[S,b])}setVisibility(S,b){super.setVisibility(S,b),this.t.call("setVisibility",[this.n(S),b])}s(S,b,c){return new R(this.t,S,b,c,this.r)}static setLogLevel(S,b,c){return S.call("setLogLevel",[b,c])}}e.$cr=O;class R extends L.$ej{constructor(S,b,c,$,p){super($?.logLevel==="always"),this.r=S,this.s=b,this.m=!1,this.n=[],this.setLevel(c),this.r.call("createLogger",[b,$,p]).then(()=>{this.u(this.n),this.m=!0})}g(S,b){const c=[[S,b]];this.m?this.u(c):this.n.push(...c)}u(S){this.r.call("log",[this.s,S])}}class k{constructor(S,b){this.a=S,this.b=b}listen(S,b){const c=this.b(S);switch(b){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(p=>this.c(p,c)),removed:[...$.removed].map(p=>this.c(p,c))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,$=>[c.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,$=>(0,L.$aj)($)?$:[c.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${b}`)}async call(S,b,c){const $=this.b(S);switch(b){case"setLogLevel":return(0,L.$aj)(c[0])?this.a.setLogLevel(c[0]):this.a.setLogLevel(I.URI.revive($.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,$)))}throw new Error(`Call not found: ${b}`)}c(S,b){return{...S,resource:b.transformOutgoingURI(S.resource)}}}e.$dr=k;class g extends A.$Sc{constructor(S,b){super(),b.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(c=>b.call("setLogLevel",[c]))),b.call("getRegisteredLoggers").then(c=>{for(const $ of c)S.registerLogger({...$,resource:I.URI.revive($.resource)})}),this.B(b.listen("onDidChangeVisibility")(([c,$])=>S.setVisibility(I.URI.revive(c),$))),this.B(b.listen("onDidChangeLoggers")(({added:c,removed:$})=>{for(const p of c)S.registerLogger({...p,resource:I.URI.revive(p.resource)});for(const p of $)S.deregisterLogger(p.resource)}))}}e.$er=g}),define(oe[201],ae([0,1,2,8]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;class L extends I.$Sc{constructor(O,R=[]){super(),this.a=new N.$ij([O,...R]),this.B(O.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$NN=L}),define(oe[55],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=void 0,e.$w7b=(0,I.$Qh)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=void 0,e.$mn=(0,A.$Qh)("policy");class O extends L.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$Od),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.j(g),N.Iterable.reduce(this.g.entries(),(S,[b,c])=>({...S,[b]:c}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(g,[C,S])=>({...g,[C]:{definition:S,value:this.g.get(C)}}),{})}}e.$nn=O;class R{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$on=R}),define(oe[202],ae([0,1,3,2,56]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h8b=e.$g8b=void 0;class A{constructor(k){this.b=k,this.a=new N.$Rc}listen(k,g){switch(g){case"onDidChange":return I.Event.map(this.b.onDidChange,C=>C.reduce((S,b)=>({...S,[b]:this.b.getPolicyValue(b)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(k,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$g8b=A;class O extends L.$nn{constructor(k,g){super(),this.a=g;for(const C in k){const{definition:S,value:b}=k[C];this.f[C]=S,b!==void 0&&this.g.set(C,b)}this.a.listen("onDidChange")(C=>{for(const S in C){const b=C[S];b===null?this.g.delete(S):this.g.set(S,b)}this.h.fire(Object.keys(C))})}async j(k){const g=await this.a.call("updatePolicyDefinitions",k);for(const C in g)this.g.set(C,g[C])}}e.$h8b=O}),define(oe[102],ae([0,1,5,37]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(typeof I.$h.vscode<"u"&&typeof I.$h.vscode.context<"u"){const A=I.$h.vscode.context.configuration();if(A)L=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:A.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(oe[25],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=void 0,e.$qj=(0,I.$Qh)("productService"),e.$rj="vscode://schemas/vscode-product"}),define(oe[203],ae([0,1,6,7,2,16,31,8,25]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$88b=void 0;let g=class extends L.$Sc{constructor(S,b,c){super(),this.b=b,this.c=c,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.B(new I.$7g(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const b=Date.now(),c=(0,A.$mc)(S),$=(0,A.$nc)(S),p=await O.Promises.readdir(c);await Promise.all(p.map(async y=>{if(y===$)return;const h=(0,A.$jc)(c,y),f=await O.Promises.stat(h);if(f.isDirectory()&&b-f.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),O.Promises.rm(h)}))}catch(b){(0,N.$1)(b)}}};e.$88b=g,e.$88b=g=ye([Y(1,k.$qj),Y(2,R.$$i)],g)}),define(oe[204],ae([0,1,6,7,2,16,31,14,8,25]),function(te,e,I,N,L,A,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$98b=void 0;let C=class extends L.$Sc{constructor(b,c,$){super(),this.b=b,this.c=c,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$7g(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const b=Object.create(null),c=JSON.parse(await O.Promises.readFile((0,A.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(c)){const u=c[f];b[`${u.hash}.${f}`]=!0}const $=(0,A.$jc)(this.b.userDataPath,"clp");if(!await O.Promises.exists($))return;const y=await O.Promises.readdir($);for(const f of y){if(b[f]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await O.Promises.rm((0,A.$jc)($,f))}const h=Date.now();for(const f of Object.keys(b)){const u=(0,A.$jc)($,f),d=await O.Promises.readdir(u);for(const E of d){if(E==="tcf.json")continue;const s=(0,A.$jc)(u,E),o=await O.Promises.stat(s);o.isDirectory()&&h-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$jc)(f,E)}`),await O.Promises.rm(s))}}}catch(b){(0,N.$1)(b)}}};e.$98b=C,e.$98b=C=ye([Y(0,R.$Yh),Y(1,k.$$i),Y(2,g.$qj)],C)}),define(oe[205],ae([0,1,16,4]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$4E=void 0,e.$4E=(0,N.$Qh)("IV8InspectProfilingService");var L;(function(A){function O(k){return!!(k.samples&&k.timeDeltas)}A.isValidProfile=O;function R(k,g="noAbsolutePaths"){for(const C of k.nodes)C.callFrame&&C.callFrame.url&&((0,I.$ic)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,I.$jc)(g,(0,I.$nc)(C.callFrame.url)));return k}A.rewriteAbsolutePaths=R})(L||(e.Utils=L={}))}),define(oe[206],ae([0,1,32]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q9b=void 0;class N{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((g,C)=>{te(["v8-inspect-profiler"],g,C)})).startProfiling({port:A.port,checkForPaused:!0}),k=(0,I.$fg)();return this.a.set(k,R),k}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const R=await O.stop();return this.a.delete(A),R.profile}}e.$q9b=N}),define(oe[40],ae([0,1,126,12]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0;class L{constructor(){this.a=new Map}add(O,R){I.ok(N.$zf(O)),I.ok(N.$Bf(R)),I.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$kn=new L}),define(oe[103],ae([0,1,3,40]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0,e.$ln={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new I.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,g){this.a[L(k)]=g,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;N.$kn.add(e.$ln.JSONContribution,O)}),define(oe[50],ae([0,1,18,3,12,148,20,103,40]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ConfigurationScope=e.$pn=e.EditPresentationTypes=void 0;var g;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$pn={Configuration:"base.contributions.configuration"};var C;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn="vscode://schemas/settings/resourceLanguage",e.$xn="vscode://schemas/settings/configurationDefaults";const S=k.$kn.as(R.$ln.JSONContribution);class b{constructor(){this.h=new Set,this.i=new N.$Od,this.onDidSchemaChange=this.i.event,this.j=new N.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$wn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const n=new Set;this.n(s,o,n),S.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const o=new Set;this.o(s,o),S.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const n=new Set;this.o(o,n),this.n(s,!1,n),S.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const n=[];for(const{overrides:i,source:t}of s)for(const r in i)if(o.add(r),e.$zn.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const D of Object.keys(i[r]))v.set(D,t);const w={...a?.value||{},...i[r]};this.a.set(r,{source:t,value:w,valuesSources:v});const l=(0,O.$ui)(r),m={type:"object",default:w,description:A.localize(1,null,l),$ref:e.$wn,defaultDefaultValue:w,source:L.$zf(t)?void 0:t,defaultValueSource:t};n.push(...p(r)),this.d[r]=m,this.b.properties[r]=m}else{this.a.set(r,{value:i[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:n,source:i}of s)for(const t in n){const r=this.a.get(t),a=L.$zf(i)?i:i?.id,v=L.$zf(r?.source)?r?.source:r?.source?.id;if(a===v)if(o.add(t),this.a.delete(t),e.$zn.test(t))delete this.d[t],delete this.b.properties[t];else{const w=this.d[t];w&&(this.w(t,w),this.r(t,w))}}this.u()}deltaConfiguration(s){let o=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,n){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(s,o){const n=i=>{if(i.properties)for(const t in i.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>n(t))};for(const i of s){n(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(s,o=!0,n,i,t=3,r){t=L.$If(s.scope)?t:s.scope;const a=s.properties;if(a)for(const w in a){const l=a[w];if(o&&u(w,l)){delete a[w];continue}if(l.source=n,l.defaultDefaultValue=a[w].default,this.w(w,l),e.$zn.test(w)?l.scope=void 0:(l.scope=L.$If(l.scope)?t:l.scope,l.restricted=L.$If(l.restricted)?!!i?.includes(w):l.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.f[w]=a[w],delete a[w];continue}else this.d[w]=a[w],a[w].policy?.name&&this.e.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),r.add(w)}const v=s.allOf;if(v)for(const w of v)this.p(w,o,n,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=n=>{const i=n.properties;if(i)for(const r in i)this.r(r,i[r]);n.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$qn.properties[s]=o,o.scope){case 1:e.$rn.properties[s]=o;break;case 2:e.$sn.properties[s]=o;break;case 6:e.$tn.properties[s]=o;break;case 3:e.$un.properties[s]=o;break;case 4:e.$vn.properties[s]=o;break;case 5:e.$vn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$qn.properties[s],o.scope){case 1:delete e.$rn.properties[s];break;case 2:delete e.$sn.properties[s];break;case 6:delete e.$tn.properties[s];break;case 3:delete e.$un.properties[s];break;case 4:case 5:delete e.$vn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$wn};this.w(o,n),e.$qn.properties[o]=n,e.$rn.properties[o]=n,e.$sn.properties[o]=n,e.$tn.properties[o]=n,e.$un.properties[o]=n,e.$vn.properties[o]=n}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$wn};e.$qn.patternProperties[e.$yn]=s,e.$rn.patternProperties[e.$yn]=s,e.$sn.patternProperties[e.$yn]=s,e.$tn.patternProperties[e.$yn]=s,e.$un.patternProperties[e.$yn]=s,e.$vn.patternProperties[e.$yn]=s,this.i.fire()}w(s,o){const n=this.a.get(s);let i=n?.value,t=n?.source;L.$Gf(i)&&(i=o.defaultDefaultValue,t=void 0),L.$Gf(i)&&(i=h(o.type)),o.default=i,o.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",$=new RegExp(c,"g");e.$yn=`^(${c})+$`,e.$zn=new RegExp(e.$yn);function p(E){const s=[];if(e.$zn.test(E)){let o=$.exec(E);for(;o?.length;){const n=o[1].trim();n&&s.push(n),o=$.exec(E)}}return(0,I.$Mb)(s)}e.$An=p;function y(E){return E.reduce((s,o)=>`${s}[${o}]`,"")}e.$Bn=y;function h(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Cn=h;const f=new b;k.$kn.add(e.$pn.Configuration,f);function u(E,s){return E.trim()?e.$zn.test(E)?A.localize(7,null,E):f.getConfigurationProperties()[E]!==void 0?A.localize(8,null,E):s.policy?.name&&f.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,E,s.policy?.name,f.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$Dn=u;function d(){const E=[],s=f.getConfigurationProperties();for(const o of Object.keys(s))E.push([o,s[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.$En=d}),define(oe[74],ae([0,1,18,3,35,2,34,30,12,10,20,50,40]),function(te,e,I,N,L,A,O,R,k,g,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function c(o){return Object.isFrozen(o)?o:R.$9m(o)}class ${constructor(n={},i=[],t=[],r){this.b=n,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof $)return i;const t=new p("");return t.parseRaw(i),t.configurationModel});this.f=n.reduce((i,t)=>t===i?t:i.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$si)(this.contents,n):this.contents}inspect(n,i){const t=this.rawConfiguration.getValue(n),r=i?this.rawConfiguration.getOverrideValue(n,i):void 0,a=i?this.rawConfiguration.override(i).getValue(n):t;return{value:t,override:r,merged:a}}getOverrideValue(n,i){const t=this.i(i);return t?n?(0,C.$si)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const t of this.overrides)t.identifiers.includes(n)&&i.push(...t.keys);return I.$Mb(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return I.$Mb(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=R.$8m(this.contents),t=R.$8m(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of n)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const w of v.overrides){const[l]=t.filter(m=>I.$ub(m.identifiers,w.identifiers));l?(this.h(l.contents,w.contents),l.keys.push(...w.keys),l.keys=I.$Mb(l.keys)):t.push(R.$8m(w))}for(const w of v.keys)r.indexOf(w)===-1&&r.push(w)}return new $(i,r,t,a.every(v=>v instanceof $)?void 0:a)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of I.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r];const v=i[r];v&&(typeof a=="object"&&typeof v=="object"?(a=R.$8m(a),this.h(a,v)):a=v),t[r]=a}return new $(t,this.keys,this.overrides)}h(n,i){for(const t of Object.keys(i)){if(t in n&&k.$Bf(n[t])&&k.$Bf(i[t])){this.h(n[t],i[t]);continue}n[t]=R.$8m(i[t])}}i(n){let i=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$8m(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?i=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,C.$ri)(this.contents,n),S.$zn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>I.$ub(t.identifiers,(0,S.$An)(n))),1))}j(n,i,t){(0,C.$qi)(this.contents,n,i,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),S.$zn.test(n)&&this.overrides.push({identifiers:(0,S.$An)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$pi)(this.contents[n],r=>console.error(r))})}}e.$Fn=$;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!k.$If(n)){const t=this.g(n);this.parseRaw(t,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:w}=this.h(n,i);this.b=new $(t,r,a,w?[n]:void 0),this.c=v||[]}g(n){let i={},t=null,r=[];const a=[],v=[];function w(m){Array.isArray(r)?r.push(m):t!==null&&(r[t]=m)}const l={onObjectBegin:()=>{const m={};w(m),a.push(r),r=m,t=null},onObjectProperty:m=>{t=m},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const m=[];w(m),a.push(r),r=m,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(m,D,T)=>{v.push({error:m,offset:D,length:T})}};if(n)try{L.$5m(n,l),i=r[0]||{}}catch(m){console.error(`Error while parsing settings file ${this.f}: ${m}`),this.d=[m]}return i}h(n,i){const t=b.$kn.as(S.$pn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,i);n=r.raw;const a=(0,C.$pi)(n,l=>console.error(`Conflict in settings file ${this.f}: ${l}`)),v=Object.keys(n),w=this.j(n,l=>console.error(`Conflict in settings file ${this.f}: ${l}`));return{contents:a,keys:v,overrides:w,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,i,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const v={},w=[];for(const l in n)if(S.$zn.test(l)&&t){const m=this.i(n[l],i,!1,r);v[l]=m.raw,a=a||m.hasExcludedProperties,w.push(...m.restricted)}else{const m=i[l],D=m?typeof m.scope<"u"?m.scope:3:void 0;m?.restricted&&w.push(l),!r.exclude?.includes(l)&&(r.include?.includes(l)||(D===void 0||r.scopes===void 0||r.scopes.includes(D))&&!(r.skipRestricted&&m?.restricted))?v[l]=n[l]:a=!0}return{raw:v,restricted:w,hasExcludedProperties:a}}j(n,i){const t=[];for(const r of Object.keys(n))if(S.$zn.test(r)){const a={};for(const v in n[r])a[v]=n[r][v];t.push({identifiers:(0,S.$An)(r),keys:Object.keys(a),contents:(0,C.$pi)(a,i)})}return t}}e.$Gn=p;class y extends A.$Sc{constructor(n,i,t,r){super(),this.c=n,this.f=i,this.g=r,this.b=this.B(new N.$Od),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Hn=y;class h{constructor(n,i,t,r,a,v,w,l,m,D,T,z,U){this.a=n,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=w,this.h=l,this.i=m,this.j=D,this.k=T,this.l=z,this.m=U}get value(){return c(this.c)}n(n,i,t){const r=n.inspect(i,t);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(n,i,t,r,a=new $,v=new $,w=new O.$Ac,l=new $,m=new O.$Ac){this.c=n,this.d=i,this.f=t,this.g=r,this.h=a,this.i=v,this.j=w,this.l=l,this.m=m,this.a=null,this.b=new O.$Ac,this.n=null}getValue(n,i,t){return this.q(n,i,t).getValue(n)}updateValue(n,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new $,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(n):r.setValue(n,i),t.resource||(this.a=null)}inspect(n,i,t){const r=this.q(n,i,t),a=this.u(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,w=new Set;for(const l of r.overrides)for(const m of l.identifiers)r.getOverrideValue(n,m)!==void 0&&w.add(m);return new h(n,i,r.getValue(n),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const t=[];if(!i){const{added:r,updated:a,removed:v}=E(this.c,n);i=[...r,...a,...v]}for(const r of i)for(const a of(0,S.$An)(r)){const v=this.c.getKeysForOverrideIdentifier(a),w=n.getKeysForOverrideIdentifier(a),l=[...w.filter(m=>v.indexOf(m)===-1),...v.filter(m=>w.indexOf(m)===-1),...v.filter(m=>!R.$_m(this.c.override(a).getValue(m),n.override(a).getValue(m)))];t.push([a,l])}return this.updateDefaultConfiguration(n),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:t,removed:r}=E(this.d,n),a=[...i,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.applicationConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.localUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.remoteUserConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:t,removed:r,overrides:a}=E(this.workspaceConfiguration,n),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(n,i){const t=this.p.get(n),{added:r,updated:a,removed:v,overrides:w}=E(t,i),l=[...r,...a,...v];return(l.length||!t)&&this.updateFolderConfiguration(n,i),{keys:l,overrides:w}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:v}=E(i,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,t){let r=this.r(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},i){let t=this.s();if(i&&n){const r=i.getFolder(n);r&&(t=this.t(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const t=this.s(),r=this.j.get(n);r?(i=t.merge(r),this.b.set(n,i)):i=t}return i}u(n,i){if(i&&n){const t=i.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:t,overrides:r,keys:a}=this.j.get(i);return n.push([i,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(t=>n.add(t))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r))),[...i.values()]}static parse(n){const i=this.x(n.defaults),t=this.x(n.policy),r=this.x(n.application),a=this.x(n.user),v=this.x(n.workspace),w=n.folders.reduce((l,m)=>(l.set(g.URI.revive(m[0]),this.x(m[1])),l),new O.$Ac);return new f(i,t,r,a,new $,v,w,new $,new O.$Ac)}static x(n){return new $(n.contents,n.keys,n.overrides)}}e.$In=f;function u(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,i=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,v])=>{const w=(0,O.$xc)(i,a,new Set);v.forEach(l=>w.add(l))});const t=[];return i.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$Jn=u;class d{constructor(n,i,t,r){this.change=n,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(n,i){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(i){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,l=this.g.getValue(n,i,this.h);return!R.$_m(w,l)}return!0}}e.$Kn=d;function E(o,n){const{added:i,removed:t,updated:r}=s(n?.rawConfiguration,o?.rawConfiguration),a=[],v=o?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const l=w.filter(m=>!v.includes(m));for(const m of l)a.push([m,n.getKeysForOverrideIdentifier(m)])}if(o){const l=v.filter(m=>!w.includes(m));for(const m of l)a.push([m,o.getKeysForOverrideIdentifier(m)])}if(n&&o){for(const l of v)if(w.includes(l)){const m=s({contents:o.getOverrideValue(void 0,l)||{},keys:o.getKeysForOverrideIdentifier(l)},{contents:n.getOverrideValue(void 0,l)||{},keys:n.getKeysForOverrideIdentifier(l)});a.push([l,[...m.added,...m.removed,...m.updated]])}}return{added:i,removed:t,updated:r,overrides:a}}function s(o,n){const i=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const v=(0,C.$si)(n.contents,a),w=(0,C.$si)(o.contents,a);R.$_m(v,w)||r.push(a)}}return{added:i,removed:t,updated:r}}}),define(oe[207],ae([0,1,18,3,2,30,12,74,50,8,56,40]),function(te,e,I,N,L,A,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=void 0;class b extends L.$Sc{constructor(){super(...arguments),this.a=this.B(new N.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Fn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$kn.as(k.$pn.Configuration).onDidUpdateConfiguration(({properties:y,defaultsOverrides:h})=>this.c(Array.from(y),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(y,h){this.h(y,S.$kn.as(k.$pn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:y})}f(){return{}}g(){this.b=new R.$Fn;const y=S.$kn.as(k.$pn.Configuration).getConfigurationProperties();this.h(Object.keys(y),y)}h(y,h){const f=this.f();for(const u of y){const d=f[u],E=h[u];d!==void 0?this.b.addValue(u,d):E?this.b.addValue(u,E.default):this.b.removeValue(u)}}}e.$Ln=b;class c{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new R.$Fn}async initialize(){return this.configurationModel}}e.$Mn=c;let $=class extends L.$Sc{get configurationModel(){return this.b}constructor(y,h,f){super(),this.c=y,this.f=h,this.g=f,this.a=this.B(new N.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Fn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(y=>this.j(y))),this.B(this.c.onDidChangeConfiguration(async({properties:y})=>this.m(await this.h(y),!0))),this.b}async h(y){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",y);const h={},f=[],u=S.$kn.as(k.$pn.Configuration).getConfigurationProperties();for(const d of y){const E=u[d];if(!E){f.push(d);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}f.push(d),h[E.policy.name]={type:E.type}}}return(0,O.$Mf)(h)||await this.f.updatePolicyDefinitions(h),f}j(y){this.g.trace("PolicyConfiguration#onDidChangePolicies",y);const h=S.$kn.as(k.$pn.Configuration).getPolicyConfigurations(),f=(0,I.$Hb)(y.map(u=>h.get(u)));this.m(f,!0)}m(y,h){this.g.trace("PolicyConfiguration#update",y);const f=S.$kn.as(k.$pn.Configuration).getConfigurationProperties(),u=[],d=this.b.isEmpty();for(const E of y){const s=f[E]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(d?o!==void 0:!(0,A.$_m)(this.b.getValue(E),o))&&u.push([E,o])}else this.b.getValue(E)!==void 0&&u.push([E,void 0])}if(u.length){this.g.trace("PolicyConfiguration#changed",u);const E=this.b;this.b=new R.$Fn;for(const s of E.keys)this.b.setValue(s,E.getValue(s));for(const[s,o]of u)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);h&&this.a.fire(this.b)}}};e.$Nn=$,e.$Nn=$=ye([Y(1,C.$mn),Y(2,g.$$i)],$)}),define(oe[208],ae([0,1,6,3,2,19,20,74,207,56]),function(te,e,I,N,L,A,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0;class C extends L.$Sc{constructor(b,c,$,p){super(),this.j=b,this.h=this.B(new N.$Od),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new k.$Ln),this.c=$ instanceof g.$on?new k.$Mn:this.B(new k.$Nn(this.b,$,p)),this.f=this.B(new R.$Hn(this.j,{},A.$ng,c)),this.a=new R.$In(this.b.configurationModel,this.c.configurationModel,new R.$Fn,new R.$Fn),this.g=this.B(new I.$7g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:y,properties:h})=>this.n(y,h))),this.B(this.c.onDidChangeConfiguration(y=>this.r(y))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,c,$]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$In(b,c,new R.$Fn,$)}getConfigurationData(){return this.a.toData()}getValue(b,c){const $=typeof b=="string"?b:void 0,p=(0,O.$li)(b)?b:(0,O.$li)(c)?c:{};return this.a.getValue($,p,void 0)}updateValue(b,c,$,p){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.m(b)}m(b){const c=this.a.toData(),$=this.a.compareAndUpdateLocalUserConfiguration(b);this.s($,c,2)}n(b,c){const $=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(b,c);this.s(p,$,7)}r(b){const c=this.a.toData(),$=this.a.compareAndUpdatePolicyConfiguration(b);this.s($,c,7)}s(b,c,$){const p=new R.$Kn(b,{data:c},this.a);p.source=$,p.sourceConfig=this.t($),this.h.fire(p)}t(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$On=C}),define(oe[209],ae([0,1,15,3,2,66]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkb=e.$Pkb=e.$Okb=e.$Nkb=void 0;const O=(g,C,S)=>{const b=new Uint8Array(16);for(let p=0;p<16;p++)b[p]=Math.round(Math.random()*256);const c=(0,I.$we)(I.$ce.wrap(b));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.$Nkb=O,e.$Okb=I.$ce.fromString(`\r
\r
`);async function R(g,C,S,b,c){g.write(I.$ce.fromString((0,e.$Nkb)(C,S,b)));const $=new L.$Rc;try{return await new Promise((p,y)=>{let h;$.add(g.onData(f=>{h?h=I.$ce.concat([h,f],h.byteLength+f.byteLength):h=f;const u=h.indexOf(e.$Okb);if(u===-1)return;p(g),g.pauseData();const d=h.slice(u+e.$Okb.byteLength);d.byteLength&&c.onData.fire(d)})),$.add(g.onClose(f=>y(f??new Error("socket closed")))),$.add(g.onEnd(()=>y(new Error("socket ended"))))})}catch(p){throw g.dispose(),p}finally{$.dispose()}}e.$Pkb=R;class k extends L.$Sc{constructor(C,S){super(),this.g=C,this.a=this.B(new N.$Rd),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new N.$Od),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event(b=>this.a.fire(b))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,S){A.SocketDiagnostics.traceSocketEvent(this,this.g,C,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Qkb=k}),define(oe[210],ae([0,1,7,4]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.RemoteAuthorityResolverErrorCode=e.$Sk=e.$Rk=e.RemoteConnectionType=e.$Qk=void 0,e.$Qk=(0,N.$Qh)("remoteAuthorityResolverService");var L;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class A{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Rk=A;class O{constructor(S,b){this.host=S,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sk=O;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class k extends I.$bb{static isNotAvailable(S){return S instanceof k&&S._code===R.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof k&&S._code===R.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof k&&S._code===R.NoResolverFound}static isInvalidAuthority(S){return S instanceof k&&S._code===R.InvalidAuthority}static isHandled(S){return S instanceof k&&S.isHandled}constructor(S,b=R.Unknown,c){super(S),this._message=S,this._code=b,this._detail=c,this.isHandled=b===R.NotAvailable&&c===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Tk=k;function g(C){const S=C.indexOf("+");return S===-1?C:C.substring(0,S)}e.$Uk=g}),define(oe[75],ae([0,1,23]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0;function N(g){return g.scheme===I.Schemas.vscodeRemote?g.authority:void 0}e.$Vk=N;function L(g){if(!g)return;const C=g.indexOf("+");return C<0?g:g.substr(0,C)}e.$Wk=L;function A(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Xk=A;function O(g){const{host:C,port:S}=k(g);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:S}}e.$Yk=O;function R(g,C){let{host:S,port:b}=k(g);return typeof b>"u"&&(b=C),{host:S,port:b}}e.$Zk=R;function k(g){const C=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const b=g.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:g,port:void 0}}}),define(oe[44],ae([0,1,27,4,75]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.TargetPlatform=e.ExtensionType=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l="extensions.user.cache",e.$2l="extensions.builtin.cache",e.$3l="undefined_publisher",e.$4l=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$5l=A,e.$6l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class k{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,h){if(typeof y>"u"||y===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof y=="string"||typeof h=="string"){const f=typeof y=="string"?y:y.value,u=typeof h=="string"?h:h.value;return I.$3e(f,u)}return y._lower===h._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.$7l=k;class g{get size(){return this.c.size}constructor(y){if(this.c=new Set,y)for(const h of y)this.add(h)}add(y){this.c.add(k.toKey(y))}delete(y){return this.c.delete(k.toKey(y))}has(y){return this.c.has(k.toKey(y))}}e.$8l=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(y){this.c.delete(k.toKey(y))}get(y){return this.c.get(k.toKey(y))}has(y){return this.c.has(k.toKey(y))}set(y,h){this.c.set(k.toKey(y),h)}values(){return this.c.values()}forEach(y){this.c.forEach(y)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$9l=C;function S(p){return b(p)}e.$0l=S;function b(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$$l=b;function c(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$_l=c;function $(p,y){if(y){const h=`onResolveRemoteAuthority:${(0,L.$Wk)(y)}`;return!!p.activationEvents?.includes(h)}return!1}e.$am=$,e.$bm=(0,N.$Qh)("IBuiltinExtensionsScannerService")}),define(oe[211],ae([0,1,2,44,11]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class A extends I.$Sc{constructor(R,k,g,C,S){super(),this.a=R,this.b=k,this.c=g,this.f=S,this.B(C.onDidInstallExtensions(b=>this.g(b))),this.B(C.onDidUninstallExtension(b=>this.h(b)))}g(R){for(const k of R)k.local&&this.invalidate(k.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,R)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,N.$1l))}catch(k){(0,L.$qk)(k)!==1&&this.f.error(k)}}}e.$Kp=A}),define(oe[212],ae([0,1,6,15,26,7,3,2,100,61,32,66,210,75]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.PersistentConnectionEventType=e.$7k=e.$6k=e.$5k=e.ConnectionType=void 0;const $=30*1e3;var p;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function y(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(q){const P=new L.$Yd;return setTimeout(()=>P.cancel(),q),P.token}function f(q,P){if(q.isCancellationRequested||P.isCancellationRequested)return L.CancellationToken.Cancelled;const j=new L.$Yd;return q.onCancellationRequested(()=>j.cancel()),P.onCancellationRequested(()=>j.cancel()),j.token}class u{get didTimeout(){return this.c==="timedout"}constructor(P){this.c="pending",this.d=new R.$Rc,this.promise=new Promise((j,M)=>{this.f=j,this.g=M}),P.isCancellationRequested?this.h():this.d.add(P.onCancellationRequested(()=>this.h()))}registerDisposable(P){this.c==="pending"?this.d.add(P):P.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const P=new Error("Time limit reached");return P.code="ETIMEDOUT",P.syscall="connect",P}resolve(P){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(P))}reject(P){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(P))}}function d(q,P){const j=new u(P);return j.registerDisposable(q.onControlMessage(M=>{const F=JSON.parse(M.toString()),H=V(F);H?j.reject(H):j.resolve(F)})),j.promise}function E(q,P,j,M,F,H,J,re){const ce=new u(re),ue=g.$Kd.create(!1);return q.info(`Creating a socket (${J})...`),k.mark(`code/willCreateSocket/${H}`),P.connect(j,M,F,J).then(he=>{ce.didTimeout?(k.mark(`code/didCreateSocketError/${H}`),q.info(`Creating a socket (${J}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(k.mark(`code/didCreateSocketOK/${H}`),q.info(`Creating a socket (${J}) was successful after ${ue.elapsed()} ms.`),ce.resolve(he))},he=>{k.mark(`code/didCreateSocketError/${H}`),q.info(`Creating a socket (${J}) returned an error after ${ue.elapsed()} ms.`),q.error(he),ce.reject(he)}),ce.promise}function s(q,P){const j=new u(P);return q.then(M=>{j.didTimeout||j.resolve(M)},M=>{j.didTimeout||j.reject(M)}),j.promise}async function o(q,P,j,M){const F=ne(q,P);q.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let H;try{H=await E(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,c.$Xk)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,y(P),`renderer-${y(P)}-${q.reconnectionToken}`,M)}catch(he){throw q.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),q.logService.error(he),he}q.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let J,re;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(H,null),J=q.reconnectionProtocol,re=!1):(J=new S.$Eh({socket:H}),re=!0),q.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const ce=await s(q.signService.createNewMessage((0,C.$fg)()),M),ue={type:"auth",auth:q.connectionToken||"00000000000000000000",data:ce.data};J.sendControl(N.$ce.fromString(JSON.stringify(ue)));try{const he=await d(J,f(M,h(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(q.logService.trace(`${F} 4/6. received SignRequest control message.`),!await s(q.signService.validate(ce,he.signedData),M)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const de=await s(q.signService.sign(he.data),M),we={type:"connectionType",commit:q.commit,signedData:de,desiredConnectionType:P};return j&&(we.args=j),q.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(N.$ce.fromString(JSON.stringify(we))),{protocol:J,ownsProtocol:re}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(q.logService.error(`${F} the handshake timed out. Error:`),q.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${F} received error control message when negotiating connection. Error:`),q.logService.error(he)),re&&G(J),he}}async function n(q,P,j,M){const F=Date.now(),H=ne(q,P),{protocol:J,ownsProtocol:re}=await o(q,P,j,M),ce=new u(M);return ce.registerDisposable(J.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),$e=V(he);$e?(q.logService.error(`${H} received error control message when negotiating connection. Error:`),q.logService.error($e),re&&G(J),ce.reject($e)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${K(F)}!`),ce.resolve({protocol:J,firstMessage:he}))})),ce.promise}async function i(q,P){const{protocol:j}=await n(q,1,void 0,P);return{protocol:j}}async function t(q,P,j){const{protocol:M,firstMessage:F}=await n(q,2,P,j),H=F&&F.debugPort;return{protocol:M,debugPort:H}}async function r(q,P,j){const M=Date.now(),F=ne(q,3),{protocol:H}=await o(q,3,P,j);return q.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${K(M)}!`),H}async function a(q,P,j){const{connectTo:M,connectionToken:F}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:M,connectionToken:F,reconnectionToken:P,reconnectionProtocol:j,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function v(q,P,j){return l(q,async M=>{const{protocol:F}=await i(M,L.CancellationToken.None);return new W(q,P,j,M.reconnectionToken,F)})}e.$5k=v;async function w(q,P){return l(q,async j=>{const{protocol:M,debugPort:F}=await t(j,P,L.CancellationToken.None);return new X(q,P,j.reconnectionToken,M,F)})}e.$6k=w;async function l(q,P){for(let M=1;;M++)try{const F=(0,C.$fg)(),H=await a(q,F,null);return await P(H)}catch(F){if(M<5)q.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(F);else throw q.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(F),x.triggerPermanentFailure(0,0,b.$Tk.isHandled(F)),F}}async function m(q,P,j){const M=await a(q,(0,C.$fg)(),null);return await r(M,{host:P,port:j},L.CancellationToken.None)}e.$7k=m;function D(q){return(0,I.$Ig)(P=>new Promise((j,M)=>{const F=setTimeout(j,q*1e3);P.onCancellationRequested(()=>{clearTimeout(F),j()})}))}var T;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class z{constructor(P,j){this.reconnectionToken=P,this.millisSinceLastIncomingData=j,this.type=0}}e.$8k=z;class U{constructor(P,j,M,F){this.reconnectionToken=P,this.millisSinceLastIncomingData=j,this.durationSeconds=M,this.c=F,this.type=1}skipWait(){this.c.cancel()}}e.$9k=U;class B{constructor(P,j,M){this.reconnectionToken=P,this.millisSinceLastIncomingData=j,this.attempt=M,this.type=2}}e.$0k=B;class Z{constructor(P,j,M){this.reconnectionToken=P,this.millisSinceLastIncomingData=j,this.attempt=M,this.type=4}}e.$$k=Z;class Q{constructor(P,j,M,F){this.reconnectionToken=P,this.millisSinceLastIncomingData=j,this.attempt=M,this.handled=F,this.type=3}}e.$_k=Q;class x extends R.$Sc{static triggerPermanentFailure(P,j,M){this._permanentFailure=!0,this.f=P,this.g=j,this.h=M,this.j.forEach(F=>F.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(P=>P.y())}static debugPauseSocketWriting(){this.j.forEach(P=>P.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(P,j,M,F,H){super(),this.t=P,this.u=j,this.reconnectionToken=M,this.protocol=F,this.w=H,this.m=this.B(new O.$Od),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Z(this.reconnectionToken,0,0)),this.B(F.onSocketClose(J=>{const re=_(this.t,this.reconnectionToken,!0);J?J.type===0?(this.u.logService.info(`${re} received socket close event (hadError: ${J.hadError}).`),J.error&&this.u.logService.error(J.error)):(this.u.logService.info(`${re} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.u.logService.error(J.event)):this.u.logService.info(`${re} received socket close event.`),this.y()})),this.B(F.onSocketTimeout(J=>{const re=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Qc)(()=>{const J=x.j.indexOf(this);J>=0&&x.j.splice(J,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const P=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${P} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const F=M<j.length?j[M]:j[j.length-1];try{if(F>0){const J=D(F);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,J)),this.u.logService.info(`${P} waiting for ${F} seconds before reconnecting...`);try{await J}catch{}}if(this.n){this.u.logService.error(`${P} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this.u.logService.info(`${P} resolving connection...`);const H=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${P} connecting to ${H.connectTo}...`),await this.G(H,h($)),this.u.logService.info(`${P} reconnected!`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${P} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this.u.logService.error(`${P} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(b.$Tk.isTemporarilyNotAvailable(H)){this.u.logService.info(`${P} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this.u.logService.info(`${P} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((0,A.$4)(H)){this.u.logService.info(`${P} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if(H instanceof b.$Tk){this.u.logService.error(`${P} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,b.$Tk.isHandled(H));break}this.u.logService.error(`${P} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this.n&&!this.s)}C(P,j,M){this.w?x.triggerPermanentFailure(P,j,M):this.D(P,j,M)}D(P,j,M){this.m.fire(new Q(this.reconnectionToken,P,j,M)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$al=x;class W extends x{constructor(P,j,M,F,H){super(1,P,F,H,!0),this.client=this.B(new S.$Ch(H,{remoteAuthority:j,clientId:M},P.ipcLogger))}async G(P,j){await i(P,j)}}e.$bl=W;class X extends x{constructor(P,j,M,F,H){super(2,P,M,F,!1),this.H=j,this.debugPort=H}async G(P,j){await t(P,this.H,j)}}e.$cl=X;function G(q){try{q.acceptDisconnect();const P=q.getSocket();q.dispose(),P.dispose()}catch(P){(0,A.$1)(P)}}function V(q){if(q&&q.type==="error"){const P=new Error(`Connection error: ${q.reason}`);return P.code="VSCODE_CONNECTION_ERROR",P}return null}function ee(q,P){for(;q.length<P;)q+=" ";return q}function ie(q,P){return`[remote-connection][${ee(y(q),13)}][${P.substr(0,5)}\u2026]`}function _(q,P,j){return`${ie(q,P)}[${j?"reconnect":"initial"}]`}function ne(q,P){return`${_(P,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function K(q){return`${Date.now()-q} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=void 0,e.$1k=(0,N.$Qh)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,R){return this.a[O]??=[],this.a[O].push(R),(0,I.$Qc)(()=>{const k=this.a[O]?.indexOf(R);typeof k=="number"&&k>=0&&this.a[O]?.splice(k,1)})}b(O){return(this.a[O.type]||[]).find(k=>k.supports(O))}connect(O,R,k,g){const C=this.b(O);if(!C)throw new Error(`No socket factory found for ${O}`);return C.connect(O,R,k,g)}}e.$2k=L}),define(oe[213],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o9b=e.$n9b=void 0,e.$n9b=(0,I.$Qh)("sharedProcessTunnelService"),e.$o9b="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,163]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y9b=e.$x9b=e.$w9b=e.$v9b=e.$u9b=e.TunnelStates=e.$t9b=e.$s9b=void 0,e.$s9b=(0,I.$Qh)("IRemoteTunnelService"),e.$t9b={active:!1};var L;(function(A){A.disconnected=O=>({type:"disconnected",onTokenFailed:O}),A.connected=(O,R)=>({type:"connected",info:O,serviceInstallFailed:R}),A.connecting=O=>({type:"connecting",progress:O}),A.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$u9b="remote.tunnels.access",e.$v9b=e.$u9b+".hostNameOverride",e.$w9b=e.$u9b+".preventSleep",e.$x9b="remoteTunnelService",e.$y9b=(0,N.localize)(0,null)}),define(oe[57],ae([0,1,15,7,2,165,50,4,8,40]),function(te,e,I,N,L,A,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$Wo=(0,R.$Qh)("requestService");class C{constructor(E){this.b=E}toJSON(){if(!this.a){const E=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?E[s]="*****":E[s]=this.b[s];this.a=E}return this.a}}class S extends L.$Sc{constructor(E){super(),this.b=0,this.a=E.createLogger("network",{name:(0,A.localize)(0,null),when:k.$pj.isEqualTo((0,k.$nj)(k.LogLevel.Trace)).serialize()})}async c(E,s,o){const n=`${E} #${++this.b}: ${s.url}`;this.a.trace(`${n} - begin`,s.type,new C(s.headers??{}));try{const i=await o();return this.a.trace(`${n} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${n} - error`,s.type,(0,N.$0)(i)),i}}}e.$Xo=S;function b(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.$Yo=b;function c(d){return d.res.statusCode===204}e.$Zo=c;async function $(d){return c(d)?null:(await(0,I.$oe)(d.stream)).toString()}e.$1o=$;async function p(d){if(!b(d))throw new Error("Server returned "+d.res.statusCode);return $(d)}e.$2o=p;async function y(d){if(!b(d))throw new Error("Server returned "+d.res.statusCode);if(c(d))return null;const s=(await(0,I.$oe)(d.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$3o=y;function h(d){u(d)}e.$4o=h;let f;function u(d){const E=g.$kn.as(O.$pn.Configuration),s=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},E.updateConfigurations({add:[f],remove:s?[s]:[]})}u(1)}),define(oe[214],ae([0,1,26,23,11,57]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3N=void 0;let O=class{constructor(k,g){this.a=k,this.b=g}async download(k,g,C=I.CancellationToken.None){if(k.scheme===N.Schemas.file||k.scheme===N.Schemas.vscodeRemote){await this.b.copy(k,g);return}const S={type:"GET",url:k.toString(!0)},b=await this.a.request(S,C);if(b.res.statusCode===200)await this.b.writeFile(g,b.stream);else{const c=await(0,A.$2o)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${c}`)}}};e.$3N=O,e.$3N=O=ye([Y(0,A.$Wo),Y(1,L.$_j)],O)}),define(oe[215],ae([0,1,15,26]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class L{constructor(R){this.a=R}listen(R,k){throw new Error("Invalid listen")}call(R,k,g,C=N.CancellationToken.None){switch(k){case"request":return this.a.request(g[0],C).then(async({res:S,stream:b})=>{const c=await(0,I.$oe)(b);return[{statusCode:S.statusCode,headers:S.headers},c]});case"resolveProxy":return this.a.resolveProxy(g[0])}throw new Error("Invalid call")}}e.$Zq=L;class A{constructor(R){this.a=R}async request(R,k){const[g,C]=await this.a.call("request",[R],k);return{res:g,stream:(0,I.$qe)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$1q=A}),define(oe[216],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7b=e.$R7b=e.$Q7b=void 0,e.$Q7b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$R7b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$S7b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[217],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M3b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const A=await this.c();if(A){const O=String(I.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$M3b=I}),define(oe[106],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=void 0,e.$3k="signService",e.$4k=(0,I.$Qh)(e.$3k)}),define(oe[218],ae([0,1,217]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=void 0;class N extends I.$M3b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(O=>new O.signer().sign(A))}h(){return new Promise((A,O)=>te(["vsda"],A,O))}}e.$G8b=N}),define(oe[76],ae([0,1,3,2]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zDb=e.$yDb=e.$xDb=e.$wDb=void 0;class L extends N.$Sc{constructor(S,b,c){super(),this.a=S,this.b=b,this.c=c}async getItems(){const S={profile:this.b,workspace:this.c},b=await this.a.call("getItems",S);return new Map(b)}updateItems(S){const b={profile:this.b,workspace:this.c};return S.insert&&(b.insert=Array.from(S.insert.entries())),S.delete&&(b.delete=Array.from(S.delete.values())),this.a.call("updateItems",b)}optimize(){const S={profile:this.b,workspace:this.c};return this.a.call("optimize",S)}}class A extends L{constructor(S,b){super(S,b,void 0),this.f=this.B(new I.$Od),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class O extends A{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.$wDb=O;class R extends A{constructor(S,b){super(S,b)}async close(){this.dispose()}}e.$xDb=R;class k extends L{constructor(S,b){super(S,void 0,b),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$yDb=k;class g{constructor(S){this.a=S}isUsed(S){const b={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",b)}}e.$zDb=g}),define(oe[107],ae([0,1,5,37,32]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=void 0;function A(k){if(I.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function O(k,g,C,S,b,c,$,p,y){const h=Object.create(null);h["common.machineId"]=c,h["common.sqmId"]=$,h.sessionID=(0,L.$fg)()+Date.now(),h.commitHash=S,h.version=b,h["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,I.$i)(I.$u),h["common.nodePlatform"]=N.$dc,h["common.nodeArch"]=C,h["common.product"]=y||"desktop",p&&(h["common.msftInternal"]=p);let f=0;const u=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),I.$m&&(h["common.snap"]="true");const d=A(g);return d&&(h["common.platformDetail"]=d),h}e.$lo=O;function R(k){const g=N.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return k.some(S=>C===S)}e.$mo=R}),define(oe[22],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0,e.$dl=(0,I.$Qh)("telemetryService"),e.$el=(0,I.$Qh)("customEndpointTelemetryService"),e.$fl="telemetry.currentSessionDate",e.$gl="telemetry.firstSessionDate",e.$hl="telemetry.lastSessionDate",e.$il="telemetry.machineId",e.$jl="telemetry.sqmId",e.$kl="telemetry",e.$ll="telemetry.telemetryLevel",e.$ml="telemetry.enableCrashReporter",e.$nl="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(oe[219],ae([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.$Ir=e.$Hr=void 0;const y=new Map;async function h(s,o){const n=`${s}::${o.join(":")}`,i=y.get(n);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function w(m,D,T,z){const U=D.substring(m.length+1);return N.Promises.withAsyncBody(async B=>{let Z;try{Z=await C.Promises.readdir(D,{withFileTypes:!0})}catch{B();return}if(z.count>=v){z.count+=Z.length,z.maxReached=!0,B();return}let Q=Z.length;if(Q===0){B();return}let x=Z;z.count+Z.length>v&&(z.maxReached=!0,Q=v-z.count,x=Z.slice(0,Q)),z.count+=Z.length;for(const W of x)if(W.isDirectory()){if(T.includes(W.name)||await w(m,(0,O.$jc)(D,W.name),T,z),--Q===0){B();return}}else{const X=W.name.lastIndexOf(".");if(X>=0){const G=W.name.substring(X+1);G&&r.set(G,(r.get(G)??0)+1)}for(const G of t)G.relativePathPattern?.test(U)!==!1&&G.filePattern.test(W.name)&&a.set(G.tag,(a.get(G.tag)??0)+1);if(--Q===0){B();return}}})}const l=N.Promises.withAsyncBody(async m=>{const D={count:0,maxReached:!1};await w(s,s,o,D);const T=await d(s);m({configFiles:f(a),fileTypes:f(r),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:T})});return y.set(n,l),l}e.$Hr=h;function f(s){return Array.from(s.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function u(){const s={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/c.$Hk.GB).toFixed(2)}GB (${(I.freemem()/c.$Hk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$Sm.value()*100)}%`},o=I.cpus();return o&&o.length>0&&(s.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),s}e.$Ir=u;async function d(s){try{const o=new Map,n=(0,O.$jc)(s,".vscode","launch.json"),i=await C.Promises.readFile(n),t=[],r=(0,L.$Xm)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$7m)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(o.has(v)?o.set(v,o.get(v)+1):o.set(v,1))}return f(o)}catch{return[]}}e.$Jr=d;let E=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const i=I.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/c.$Hk.GB).toFixed(2)}GB (${(I.freemem()/c.$Hk.GB).toFixed(2)}GB free)`),R.$j||n.push(`Load (avg):       ${I.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.$Sm.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,S.$Gr)(o.mainPID),this.k(o)]).then(async i=>{let[t,r]=i,a=this.m(o,t);return n.forEach(v=>{if((0,b.$sm)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(o,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const w of Object.keys(v.workspaceMetadata)){const l=v.workspaceMetadata[w];let m=`${l.fileCount} files`;l.maxFilesReached&&(m=`more than ${m}`),r+=`|    Folder (${w}): ${m}`,r+=this.h(l)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:i,vmHint:t,os:r,cpus:a}=u(),v={os:r,memory:i,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$j||(v.load=`${I.loadavg().map(w=>Math.round(w)).join(", ")}`),R.$l&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(o,n){const i=[];return(0,S.$Gr)(o.mainPID).then(async t=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),n.forEach(r=>{if((0,b.$sm)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let w=`${v.fileCount} files`;v.maxFilesReached&&(w=`more than ${w}`),i.push(`Folder (${a}): ${w}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const n=[];let t=0;const r=(l,m)=>{const D=` ${l}(${m})`;t+D.length>60?(n.push(a),a="|                 ",t=a.length):t+=D.length,a+=D};let a="|      File types:";const v=10,w=o.fileTypes.length>v?v:o.fileTypes.length;for(let l=0;l<w;l++){const m=o.fileTypes[l];r(m.name,m.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(l=>{r(l.name,l.count)}),n.push(a)),o.launchConfigFiles.length>0){let l="|      Launch Configs:";o.launchConfigFiles.forEach(m=>{const D=m.count>1?` ${m.name}(${m.count})`:` ${m.name}`;l+=D}),n.push(l)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const n=[],i=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=k.URI.revive(r);if(a.scheme===A.Schemas.file){const v=a.fsPath;i.push(h(v,["node_modules",".git"]).then(w=>{let l=`${w.fileCount} files`;w.maxFilesReached&&(l=`more than ${l}`),n.push(`|    Folder (${(0,O.$nc)(v)}): ${l}`),n.push(this.h(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${w.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const i=new Map;o.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>i.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,i,t,n,0),t.join(`
`)}n(o,n,i,t,r){const a=r===0;let v;a?v=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const w=process.platform==="win32"?t.mem:I.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(w/c.$Hk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(l=>this.n(o,n,i,l,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:i}of o.folders){const t=k.URI.revive(i);if(t.scheme!==A.Schemas.file)continue;const r=t.fsPath;try{(await h(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const i=k.URI.revive(n);if(i.scheme!==A.Schemas.file)continue;const t=i.fsPath;try{const r=await h(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Kr=E,e.$Kr=E=ye([Y(0,p.$dl),Y(1,$.$qj)],E)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=e.$V7b=void 0;class I{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:R,data:k}){return this.b.forEach(g=>g.log(R,k)),Promise.resolve(null)}}e.$V7b=I;class N{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$W7b=N}),define(oe[45],ae([0,1,30,12,3,20,75,107,22]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;class g{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$no=g;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$oo=C,e.$po=new C;class S{async publicLog(t,r,a){}async publicLogError(t,r,a){}}e.$qo=S,e.$ro="telemetry",e.$so="extensionTelemetryLog",e.$to={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,t){return L.Event.debounce(t.onDidChangeConfiguration,(a,v)=>{const w=a?new Set([...a.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:w}},1e3,!0)(a=>{a.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$ni)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$uo=b;function c(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$vo=c;function $(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$wo=$;function p(i){const t=i.getValue(k.$ll),r=i.getValue(k.$ml);if(i.getValue(k.$nl)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$xo=p;function y(i){const t={},r={},a={};u(i,a);for(let v in a){v=v.length>150?v.substr(v.length-149):v;const w=a[v];typeof w=="number"?r[v]=w:typeof w=="boolean"?r[v]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${w.length}`),t[v]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(t[v]=w)}return{properties:t,measurements:r}}e.$yo=y;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(i){if(!i)return"none";const t=(0,O.$Wk)(i);return h.has(t)?t:"other"}e.$zo=f;function u(i,t,r=0,a){if(i)for(const v of Object.getOwnPropertyNames(i)){const w=i[v],l=a?a+v:v;Array.isArray(w)?t[l]=(0,I.$an)(w):w instanceof Date?t[l]=w.toISOString():(0,N.$Bf)(w)?r<2?u(w,t,r+1,l+"."):t[l]=(0,I.$an)(w):t[l]=w}}function d(i,t){const r=i.msftInternalDomains||[],a=t.getValue("telemetry.internalTesting");return(0,R.$mo)(r)||a}e.$Ao=d;function E(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Bo=E;function s(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const a=[];for(const m of t)for(;;){const D=m.exec(i);if(!D)break;a.push([D.index,m.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(r="";;){const m=w.exec(i);if(!m)break;const D=a.some(([T,z])=>m.index<z&&T<w.lastIndex);!v.test(m[0])&&!D&&(r+=i.substring(l,m.index)+"<REDACTED: user-file-path>",l=w.lastIndex)}return l<i.length&&(r+=i.substr(l)),r}function o(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function n(i,t){return(0,I.$0m)(i,r=>{if(r instanceof g||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=s(a,t);for(const v of t)a=a.replace(v,"");return a=o(a),a}})}e.$Co=n}),define(oe[33],ae([0,1,27,29,44,5,10,7,37,45]),function(te,e,I,N,L,A,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;function C(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,I.$Xe)(n.id,i.id)===0}e.$Do=C;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,t,r)}static parse(i){const t=S.exec(i);return t&&t[1]&&t[2]?new b({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?C(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Eo=b;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const i=c.exec(n);return i&&i[1]?[y(i[1]),i[2]]:[y(n),void 0]}e.$Fo=$;function p(n,i){return`${n}.${i}`}e.$Go=p;function y(n){return n.toLowerCase()}e.$Ho=y;function h(n,i){return y(p(n??L.$3l,i))}e.$Io=h;function f(n,i){const t=[],r=a=>{for(const v of t)if(v.some(w=>C(i(w),i(a))))return v;return null};for(const a of n){const v=r(a);v?v.push(a):t.push([a])}return t}e.$Jo=f;function u(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Ko=u;function d(n){return{id:new g.$no(n.identifier.id),name:new g.$no(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Lo=d,e.$Mo=new L.$7l("pprice.better-merge");function E(n,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!C(v.identifier,{id:a}))){const v=n.filter(w=>C(w.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$No=E;async function s(n,i){if(!A.$l)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,i){const t=await s(n,i),r=(0,N.$0n)(t?"alpine":A.$u,k.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$Oo=o}),define(oe[220],ae([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S5b=e.$R5b=void 0;let $=class extends N.$Sc{constructor(u,d){super(),this.b=u,this.c=d,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,E])=>this.a.set(E.configPath,E))}getConfigBasedTips(u){return this.f(u)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(u){const d=[];for(const[E,s]of this.a)if(!(s.configScheme&&s.configScheme!==u.scheme))try{const o=(await this.b.readFile((0,L.$wg)(u,E))).value.toString();for(const[n,i]of Object.entries(s.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(o))&&d.push({extensionId:n,extensionName:i.name,configName:s.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return d}};e.$R5b=$,e.$R5b=$=ye([Y(0,O.$_j),Y(1,R.$qj)],$);const p="extensionTips/promptedExecutableTips",y="extensionTips/lastPromptedMediumImpExeTime";class h extends ${constructor(u,d,E,s,o,n,i,t){super(i,t),this.r=u,this.s=d,this.t=E,this.u=s,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],w=[],l=[];Object.entries(a.recommendations).forEach(([m,D])=>{D.important?a.important?v.push({extensionId:m,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):w.push({extensionId:m,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):l.push({extensionId:m,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),w.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),l.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:l})}),(0,k.$Wg)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const u=await this.O(this.g),d=await this.O(this.h);return[...u,...d]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const u=await this.O(this.g),d=await this.O(this.h),E=await this.u.getInstalled();this.m=this.D(u,E),this.n=this.D(d,E)}D(u,d){const E=new Map;u.forEach(t=>E.set(t.extensionId.toLowerCase(),t));const{installed:s,uninstalled:o}=this.N([...E.keys()],d);for(const t of s){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),i=new Map;for(const t of o){const r=E.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=i.get(r.exeName);a||(a=[],i.set(r.exeName,a)),a.push(r)}}return i}F(){if(this.m.size===0)return;const[u,d]=[...this.m.entries()][0];this.H(d).then(E=>{switch(E){case"reacted":this.M(d[0].exeName,d);break;case"ignored":this.m.delete(u);break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(s(()=>this.F()));break}case"toomany":{const s=this.B(new N.$Tc);s.value=(0,k.$Wg)(()=>{s.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const u=this.I(),d=Date.now()-u,E=7*24*60*60*1e3;if(d<E){const n=this.B(new N.$Tc);n.value=(0,k.$Wg)(()=>{n.dispose(),this.G()},E-d);return}const[s,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(s),this.M(o[0].exeName,o);const i=this.B(new N.$Tc);i.value=(0,k.$Wg)(()=>{i.dispose(),this.G()},E);break}case"ignored":this.n.delete(s),this.G();break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new N.$Tc);i.value=(0,k.$Wg)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(u){const d=await this.u.getInstalled(1),E=u.filter(s=>!s.whenNotInstalled||s.whenNotInstalled.every(o=>d.every(n=>!(0,c.$Do)(n.identifier,{id:o})))).map(({extensionId:s})=>s.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:E,source:3,name:u[0].exeFriendlyName,searchValue:`@exe:"${u[0].exeName}"`})}I(){let u=this.w.getNumber(y,-1);return u||(u=Date.now(),this.J(u)),u}J(u){this.w.store(y,u,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(u,d){const E=this.L();E[u]=d.map(({extensionId:s})=>s.toLowerCase()),this.w.store(p,JSON.stringify(E),-1,0)}N(u,d){const E=[],s=[],o=d.reduce((n,i)=>(n.add(i.identifier.id.toLowerCase()),n),new Set);return u.forEach(n=>{o.has(n.toLowerCase())?E.push(n):s.push(n)}),{installed:E,uninstalled:s}}async O(u){const d=[],E=new Map;for(const s of u.keys()){const o=u.get(s);if(!o||!(0,I.$Lb)(o.recommendations))continue;const n=[];S.$j?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>b.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>b.env.ProgramFiles).replace("%APPDATA%",()=>b.env.APPDATA).replace("%WINDIR%",()=>b.env.WINDIR)):(n.push((0,C.$jc)("/usr/local/bin",s)),n.push((0,C.$jc)("/usr/bin",s)),n.push((0,C.$jc)(this.r.fsPath,s)));for(const i of n){let t=E.get(i);if(t===void 0&&(t=await this.b.exists(A.URI.file(i)),E.set(i,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:w}of o.recommendations)d.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:s,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:w})}}return d}}e.$S5b=h}),define(oe[221],ae([0,1,26,33]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oWb=void 0;async function L(A,O,R,k,g){try{const C=await A.getExtensionsControlManifest();if(!C.deprecated)return;const S=await A.getInstalled(1);for(const[b,c]of Object.entries(C.deprecated)){if(!c?.extension)continue;const{id:$,autoMigrate:p,preRelease:y}=c.extension;if(!p)continue;const h=S.find(u=>(0,N.$Do)(u.identifier,{id:b}));if(!h)continue;const f=(await O.getExtensions([{id:$,preRelease:y}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!f){g.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{g.info(`Migrating '${h.identifier.id}' extension to '${$}' extension...`);const u=!k.getDisabledExtensions().some(E=>(0,N.$Do)(E,h.identifier));await A.uninstall(h),g.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let d=S.find(E=>(0,N.$Do)(E.identifier,{id:$}));(!d||!d.isPreReleaseVersion&&u)&&(d=await A.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${d.identifier.id}'`),u||(await k.disableExtension(d.identifier),g.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),p.storage&&(R.addToMigrationList((0,N.$Go)(h.manifest.publisher,h.manifest.name),(0,N.$Go)(d.manifest.publisher,d.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${h.identifier.id}' extension to '${$}' extension.`)}catch(u){g.error(u)}}}catch(C){g.error(C)}}e.$oWb=L}),define(oe[222],ae([0,1,3,2,34,33,44]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;class R extends N.$Sc{constructor(g,C,S,b,c,$,p){super(),this.f=g,this.g=C,this.h=S,this.j=b,this.m=c,this.n=$,this.r=p,this.a=this.B(new I.$Od),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$1c),this.s().then(null,y=>p.error(y))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,N.$Pc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(g){for(const C of g.extensions)this.I(this.L(C.identifier,C.version),g.profileLocation)}async y(g){for(const C of g.extensions){const S=this.L(C.identifier,C.version);g.error?this.J(S,g.profileLocation):this.I(S,g.profileLocation)}}async z(g){for(const C of g.extensions)this.J(this.L(C.identifier,C.version),g.profileLocation)}async C(g){const C=[],S=[];for(const b of g.extensions){const c=this.L(b.identifier,b.version);g.error?this.I(c,g.profileLocation):(this.J(c,g.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),S.push(this.f.scanInstalledExtensionAtLocation(b.location).then($=>{$?C.push($):this.r.info("Extension not found at the location",b.location.toString())},$=>this.r.error($)))))}try{await Promise.all(S),C.length&&await this.H(C)}catch(b){this.r.error(b)}}D(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(g){const C=[],S=[],b=await this.j.scanProfileExtensions(g),c=new Set,$=new Set;for(const[p,y]of this.b)y.has(g)&&$.add(p);for(const p of b){const y=this.L(p.identifier,p.version);c.add(y),$.has(y)||(C.push(p.identifier),this.I(y,g))}for(const p of $)if(!c.has(p)){const y=this.M(p);y&&(S.push(y.identifier),this.J(p,g))}(C.length||S.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:S.length?{extensions:S,profileLocation:g}:void 0})}async G(g){const C=await this.j.scanProfileExtensions(g);for(const S of C)this.I(this.L(S.identifier,S.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.L(S.identifier,S.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,C){let S=this.b.get(g);S||this.b.set(g,S=new L.$Bc(b=>this.m.extUri.getComparisonKey(b))),S.add(C)}J(g,C){const S=this.b.get(g);S&&S.delete(C),S?.size||this.b.delete(g)}L(g,C){return`${O.$7l.toKey(g.id)}@${C}`}M(g){const[C,S]=(0,A.$Fo)(g);return S?{identifier:{id:C},version:S}:void 0}}e.$Lp=R}),define(oe[223],ae([0,1,43,45]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;async function L(A,O,R,k,g,C,S){const b={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,N.$vo)(O,R)&&(0,N.$xo)(k)===3){const c=await(0,I.$dp)(R,g,C);b["X-Market-User-Id"]=c,b["VSCode-SessionId"]=S.machineId||c}return b}e.$ep=L}),define(oe[224],ae([0,1,70,18,6,2,23,16,31,14,29,33,8,73,10]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;let p=class extends c.$Xq{constructor(u,d,E,s){super(E),this.h=u,this.j=s,this.g=this.B(new y(d,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(u,d){const s=(await this.g.getLanguagePacks())[d];if(!s){this.j.warn(`No language pack found for ${d}`);return}const o=s.translations[u];return o?$.URI.file(o):void 0}async getInstalledLanguages(){const u=await this.g.getLanguagePacks(),d=Object.keys(u).map(E=>{const s=u[E];return{...this.f(E,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return d.push(this.f("en","English")),d.sort((E,s)=>E.label.localeCompare(s.label)),d}async m(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",u.identifier.id),await this.update())}async n(u){const d=await this.g.getLanguagePacks();Object.keys(d).some(E=>d[E]&&d[E].extensions.some(s=>(0,S.$Do)(s.extensionIdentifier,u.identifier)))&&(this.j.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,d]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),E=await this.g.update(d);return!(0,N.$ub)(Object.keys(u),Object.keys(E))}};e.$Yq=p,e.$Yq=p=ye([Y(0,C.$do),Y(1,g.$Yh),Y(2,C.$bo),Y(3,b.$$i)],p);let y=class extends A.$Sc{constructor(u,d){super(),this.j=d,this.c={},this.f=(0,R.$jc)(u.userDataPath,"languagepacks.json"),this.g=new L.$2g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(u){return this.s(d=>{Object.keys(d).forEach(E=>delete d[E]),this.m(d,...u)}).then(()=>this.c)}m(u,...d){for(const E of d)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.n(u,E);Object.keys(u).forEach(E=>this.r(u[E]))}n(u,d){const E=d.identifier,s=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const o of s)if(d.location.scheme===O.Schemas.file&&h(o)){let n=u[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},u[o.languageId]=n);const i=n.extensions.filter(t=>(0,S.$Do)(t.extensionIdentifier,E))[0];i?i.version=d.manifest.version:n.extensions.push({extensionIdentifier:E,version:d.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.$jc)(d.location.fsPath,t.path)}}r(u){if(u){const d=(0,I.createHash)("md5");for(const E of u.extensions)d.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);u.hash=d.digest("hex")}}s(u=()=>null){return this.g.queue(()=>{let d=null;return k.Promises.readFile(this.f,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(d=u(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.c=E,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),k.Promises.writeFile(this.f,s)}).then(()=>d,E=>this.j.error(E))})}};y=ye([Y(0,g.$Yh),Y(1,b.$$i)],y);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const u of f.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(oe[225],ae([0,1,141,7,30,45]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function k(C,S,b){const c=await(0,I.$zC)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,I.$zC)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new c.AppInsightsCore,y=new $.PostChannel,h={instrumentationKey:C,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(b){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:b};h.extensionConfig[y.identifier]=f}return p.initialize(h,[]),p.addTelemetryInitializer(f=>{S&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),p}class g{constructor(S,b,c,$,p){this.e=S,this.f=b,this.g=c,this.h=p,this.c=O,this.d=R,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(b=>{S(b)},b=>{(0,N.$1)(b),console.error(b)})}}log(S,b){if(!this.a)return;b=(0,L.$$m)(b,this.g),b=(0,A.$yo)(b);const c=this.f+"/"+S;try{this.i($=>{$.pluginVersionString=b?.properties.version??"Unknown",$.track({name:c,baseData:{name:c,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$AN=g}),define(oe[109],ae([0,1,2,166,14,8,25,45]),function(te,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g5b=void 0;let k=class extends I.$Sc{constructor(C,S,b,c,$=""){super(),this.b=$;const p=S.getLogger(R.$ro);if(p)this.a=this.B(p);else{const h=(0,R.$wo)(c,b)?" (Not Sent)":"",f=()=>(0,R.$vo)(c,b)&&C.getLevel()===A.LogLevel.Trace;this.a=this.B(S.createLogger(R.$ro,{name:(0,N.localize)(0,null,h),hidden:!f()})),this.B(C.onDidChangeLogLevel(()=>S.setVisibility(R.$ro,f()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,S){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$yo)(S))}};e.$g5b=k,e.$g5b=k=ye([Y(0,A.$$i),Y(1,A.$_i),Y(2,L.$Xh),Y(3,O.$qj)],k)}),define(oe[110],ae([0,1,2,30,5,27,167,20,50,102,25,40,22,45]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,u){this.k=f,this.l=u,this.d={},this.i=new I.$Rc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,A.$Ge)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ge)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(b.$ll)||d.affectsConfiguration(b.$nl)||d.affectsConfiguration(b.$ml))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,c.$xo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const u=f.usage?3:f.error?2:0;h=Math.min(h,u)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,u){this.g<f||(u=(0,N.$$m)(u,this.d),u=(0,c.$Co)(u,this.j),u=(0,N.$$m)(u,this.c),this.b.forEach(d=>d.log(h,u)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$5q=$,e.$5q=$=ye([Y(1,R.$ki),Y(2,C.$qj)],$);function p(){const y=(0,O.localize)(0,null,g.default.nameLong),h=g.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=L.$p?"":(0,O.localize)(3,null),u=(0,O.localize)(4,null),d=(0,O.localize)(5,null),E=(0,O.localize)(6,null),s=(0,O.localize)(7,null),o=`
|       | ${u} | ${d} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${y} ${h} ${f}

&nbsp;

${s}
${o}

&nbsp;

${n}
`}S.$kn.as(k.$pn.Configuration).registerConfiguration({id:b.$kl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[b.$ll]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$kn.as(k.$pn.Configuration).registerConfiguration({id:b.$kl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[b.$nl]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,O.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,O.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${b.$ll}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[226],ae([0,1,15,26,270,225]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;async function O(C,S){const b=await S.request(C,N.CancellationToken.None),c=(await(0,I.$oe)(b.stream)).toString(),$=b.res.statusCode??200;return{headers:b.res.headers,statusCode:$,responseData:c}}async function R(C){const S={method:C.type,headers:C.headers};return new Promise((c,$)=>{const p=L.request(C.url??"",S,y=>{y.on("data",function(h){c({headers:y.headers,statusCode:y.statusCode??200,responseData:h.toString()})}),y.on("error",function(h){$(h)})});p.write(C.data,y=>{y&&$(y)}),p.end()})}async function k(C,S,b){const c=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),$={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:c};try{const p=C?await O($,C):await R($);b(p.statusCode,p.headers,p.responseData)}catch{b(0,{})}}class g extends A.$AN{constructor(S,b,c,$,p){const y={sendPOST:(h,f)=>{k(S,h,f)}};super(b,c,$,p,y)}}e.$BN=g}),define(oe[227],ae([0,1,23,93,20,14,8,25,22,108,109,110]),function(te,e,I,N,L,A,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c9b=void 0;let b=class{constructor($,p,y,h,f,u){this.b=$,this.c=p,this.d=y,this.e=h,this.f=f,this.g=u,this.a=new Map}h($){if(!this.a.has($.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const y=[$.id,JSON.stringify(p),$.aiKey],f=new N.$7p(I.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:y,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new g.$W7b(f),new C.$g5b(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new S.$5q({appenders:u,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,p,y){this.h($).publicLog(p,y)}publicLogError($,p,y){this.h($).publicLogError(p,y)}};e.$c9b=b,e.$c9b=b=ye([Y(0,L.$ki),Y(1,k.$dl),Y(2,O.$$i),Y(3,O.$_i),Y(4,A.$Xh),Y(5,R.$qj)],b)}),define(oe[77],ae([0,1,3,20,4,8]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.ProvidedOnAutoForward=e.$dv=e.TunnelPrivacyId=e.TunnelProtocol=e.$cv=e.$bv=void 0,e.$bv=(0,L.$Qh)("tunnelService"),e.$cv=(0,L.$Qh)("sharedTunnelsService");var O;(function(y){y.Http="http",y.Https="https"})(O||(e.TunnelProtocol=O={}));var R;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(R||(e.TunnelPrivacyId=R={}));function k(y){return!!y.forwardPort}e.$dv=k;var g;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function C(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(h)return{address:h[1],port:+h[2]}}e.$ev=C,e.$fv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(y){return e.$fv.indexOf(y)>=0}e.$gv=S,e.$hv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(y){return e.$hv.indexOf(y)>=0}e.$iv=b;function c(y,h,f,u){if(f===1)return!1;if(f===2&&b(h)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(d?.length===4&&parseInt(d[1])>=18)return!1}return y<1024}e.$jv=c;class ${constructor(h,f,u){this.remoteAddress=h,this.localAddress=f,this.b=u,this.a=new I.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$kv=$;let p=class{constructor(h,f){this.j=h,this.k=f,this.a=new I.$Od,this.onTunnelOpened=this.a.event,this.b=new I.$Od,this.onTunnelClosed=this.b.event,this.c=new I.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const h=this.k.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.h=h.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const h=[],f=Array.from(this.e.values());for(const u of f){const d=Array.from(u.values());for(const E of d){const s=await E.value;s&&typeof s!="string"&&h.push(s)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:f}of h.values())await f.then(u=>typeof u!="string"?u?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,f,u,d,E){this.p(h,f,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:f,localAddress:u,privacy:d,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,f){(b(h)||S(h))&&(h=e.$fv[0]);const u=this.r(h,f);if(u)return++u.refcount,u.value}openTunnel(h,f,u,d,E,s=!1,o,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${u} on local port ${E}.`);const i=this.f??h;if(!i)return;if(f||(f="localhost"),d||(d=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,f,u,d,E,s,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(f,u),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(f,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.n(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const f=this.e.get(h.tunnelRemoteHost);if(f){const u=f.get(h.tunnelRemotePort);u&&(u.refcount--,await this.o(h.tunnelRemoteHost,h.tunnelRemotePort,u))}}}}async o(h,f,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${f}.`);const d=u.value.then(async E=>{E&&typeof E!="string"&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(f),d}}async closeTunnel(h,f){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${f} `);const u=this.e.get(h);if(u&&u.has(f)){const d=u.get(f);d.refcount=0,await this.o(h,f,d)}}p(h,f,u){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(f,{refcount:1,value:u})}async q(h,f){const u=this.e.get(h);if(u){const d=u.get(f),E=d?await d.value:void 0;(!E||typeof E=="string")&&u.delete(f),u.size===0&&this.e.delete(h)}}r(h,f){const u=[h];S(h)?(u.push(...e.$fv),u.push(...e.$hv)):b(h)&&u.push(...e.$hv);const d=u.map(E=>this.e.get(E));for(const E of d){const s=E?.get(f);if(s)return s}}canTunnel(h){return!!C(h)}t(h,f,u,d,E,s,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${u} on local port ${d}.`);const n=u;this.i.add(n);const i=d===void 0?u:d,t={elevationRequired:E?this.isPortPrivileged(i):!1},r={remoteAddress:{host:f,port:u},localAddressPort:d,privacy:s,public:s?s!==R.Private:void 0,protocol:o},a=h.forwardPort(r,t);return a?(this.p(f,u,a),a.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),a}};e.$lv=p,e.$lv=p=ye([Y(0,A.$$i),Y(1,N.$ki)],p)}),define(oe[228],ae([0,1,8,77,2,7,6]),function(te,e,I,N,L,A,O){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$p9b=void 0;class k extends L.$Sc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$dh),this.b.p)}setAddress(S){this.a=S,this.b&&(this.b.complete(S),this.b=null)}setTunnel(S){this.B(S)}}let g=class extends L.$Sc{static{R=this}static{this.a=0}constructor(S,b){super(),this.f=S,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(S=>S.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(S,b,c,$,p,y,h){const f=new k,u=await Promise.resolve(this.f.openTunnel(S,f,c,$,p,y,h));if(!u||typeof u=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${$} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),f.dispose(),await u.dispose(),(0,A.$6)();return f.setTunnel(u),this.b.set(b,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${u.localAddress} (local) to ${c}:${$} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(S,b){const c=this.b.get(S);c&&c.setAddress(b)}async destroyTunnel(S){const b=this.b.get(S);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${S}.`),this.b.delete(S),await b.dispose();return}this.c.add(S)}};e.$p9b=g,e.$p9b=g=R=ye([Y(0,N.$cv),Y(1,I.$$i)],g)}),define(oe[28],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=void 0,e.$Jk=(0,I.$Qh)("IUriIdentityService")}),define(oe[229],ae([0,1,28,184,11,19,127,3,2]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;class g{static{this._clock=0}constructor(b){this.uri=b,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor(b){this.g=b,this.c=new k.$Rc,this.f=2**16;const c=new Map,$=p=>{let y=c.get(p.scheme);return y===void 0&&(y=b.hasProvider(p)&&!this.g.hasCapability(p,1024),c.set(p.scheme,y)),y};this.c.add(R.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(p=>{c.delete(p.scheme)})),this.extUri=new A.$lg($),this.d=new O.$Cr((p,y)=>this.extUri.compare(p,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,A.$xg)(b));const c=this.d.get(b);return c?c.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new g(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort(($,p)=>$[1].time<p[1].time?1:$[1].time>p[1].time?-1:0);g._clock=0,this.d.clear();const c=this.f*.5;for(let $=0;$<c;$++)this.d.set(b[$][0],b[$][1].touch())}};e.$Dr=C,e.$Dr=C=ye([Y(0,L.$_j)],C),(0,N.$Ar)(I.$Jk,C,1)}),define(oe[230],ae([0,1,3,2,11,47,34]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J8b=void 0;class R extends N.$Sc{constructor(g,C,S,b,c,$){super(),this.f=g,this.g=C,this.h=S,this.j=b,this.m=c,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$Od),this.onDidChangeFile=this.a.event,this.b=A.$Wh.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Bc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(b.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,C){return this.g.open(this.t(g),C)}close(g){return this.g.close(g)}read(g,C,S,b,c){return this.g.read(g,C,S,b,c)}write(g,C,S,b,c){return this.g.write(g,C,S,b,c)}watch(g,C){this.b.set(g,g);const S=this.g.watch(this.t(g),C);return(0,N.$Qc)(()=>{this.b.delete(g),S.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,C,S){return this.g.rename(this.t(g),this.t(C),S)}readFile(g,C){return this.g.readFile(this.t(g),C)}readFileStream(g,C,S){return this.g.readFileStream(this.t(g),C,S)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,C,S){return this.g.writeFile(this.t(g),C,S)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,C){return this.g.delete(this.t(g),C)}copy(g,C,S){if((0,L.$dk)(this.g))return this.g.copy(this.t(g),this.t(C),S);throw new Error("copy not supported")}cloneFile(g,C){if((0,L.$ek)(this.g))return this.g.cloneFile(this.t(g),this.t(C));throw new Error("clone not supported")}s(g){const C=[];for(const S of g){if(S.resource.scheme!==this.f)continue;const b=this.u(S.resource);this.b.findSubstr(b)&&C.push({resource:b,type:S.type,cId:S.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$J8b=R}),define(oe[78],ae([0,1,86]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dDb=e.$cDb=e.edit=void 0;function N(O,R,k,g){const C=(0,I.$eT)(O,R,k,g)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}e.edit=N;function L(O,R,k){let g=k;for(;g>=0;){if(O.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&O.charAt(g)===R.charAt(0))return g+2}return 0}e.$cDb=L;function A(O,R,k){let g=k;for(;g>=0;)if(O.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&O.charAt(g)===R.charAt(1)))return g;return O.length-1}e.$dDb=A}),define(oe[231],ae([0,1,30,54,12]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$13b=void 0;function A(c,$,p,y,h,f){const u=[],d=[],E=[];if(!$){const B=c.filter(({identifier:Z})=>h.every(Q=>Q.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:u,removed:d,updated:E},remote:B.length>0?{added:B,updated:[],removed:[],all:B}:null}}c=c.map(S),$=$.map(S),p=p?p.map(S):null;const s=new Map,o=B=>{B.uuid&&s.set(B.id.toLowerCase(),B.uuid)};c.forEach(({identifier:B})=>o(B)),$.forEach(({identifier:B})=>o(B)),p?.forEach(({identifier:B})=>o(B)),y?.forEach(({identifier:B})=>o(B)),f?.forEach(B=>o(B));const n=B=>{const Z=B.identifier.uuid||s.get(B.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${B.identifier.id.toLowerCase()}`},i=(B,Z)=>(B.set(n(Z),Z),B),t=c.reduce(i,new Map),r=$.reduce(i,new Map),a=$.reduce((B,Z)=>i(B,(0,I.$8m)(Z)),new Map),v=p?p.reduce(i,new Map):null,w=y.reduce(i,new Map),l=h.reduce((B,Z)=>{const Q=s.get(Z.toLowerCase());return B.add(Q?`uuid:${Q}`:`id:${Z.toLowerCase()}`)},new Set),m=f?f.reduce((B,{id:Z,uuid:Q})=>(Q=Q??s.get(Z.toLowerCase()),B.add(Q?`uuid:${Q}`:`id:${Z.toLowerCase()}`)),new Set):null,D=O(t,r,l,!1);if(D.added.size>0||D.removed.size>0||D.updated.size>0){const B=O(v,t,l,!1),Z=O(v,r,l,!0),Q=(x,W,X,G)=>{let V,ee,ie;return W.installed?(V=G.pinned,ie=G.preRelease,V&&(ee=G.version)):(V=X.pinned,ie=X.preRelease,V&&(ee=X.version)),V===void 0&&(V=W.pinned,V&&(ee=W.version)),ie===void 0&&(ie=W.preRelease),{...G,installed:W.installed||X.installed,pinned:V,preRelease:ie,version:ee??(X.version&&(!W.installed||N.gt(X.version,W.version))?X.version:W.version),state:k(W,X,v?.get(x))}};for(const x of Z.removed.values()){const W=t.get(x);if(!W)continue;const X=(0,L.$Kf)(v?.get(x)),G=m&&!m.has(x)&&X.installed;W.installed&&G?d.push(W.identifier):a.set(x,W)}for(const x of Z.added.values()){const W=(0,L.$Kf)(r.get(x)),X=t.get(x);if(X){if(D.updated.has(x)){const G=Q(x,X,W,W);R(X,W,!1,!1)||E.push(b(G,x)),a.set(x,G)}}else W.installed&&u.push(b(W,x))}for(const x of Z.updated.values()){const W=(0,L.$Kf)(r.get(x)),X=(0,L.$Kf)(v?.get(x)),G=t.get(x);if(G)if(m&&!m.has(x)&&X.installed&&G.installed&&!W.installed)d.push(G.identifier);else{const ee=Q(x,G,W,W);E.push(b(ee,x)),a.set(x,ee)}else W.installed&&u.push(b(W,x))}for(const x of B.added.values())Z.added.has(x)||a.set(x,(0,L.$Kf)(t.get(x)));for(const x of B.updated.values()){if(Z.removed.has(x)||Z.updated.has(x))continue;const W=(0,L.$Kf)(t.get(x)),X=(0,L.$Kf)(r.get(x));a.set(x,Q(x,W,X,W))}for(const x of B.removed.values())Z.updated.has(x)||Z.removed.has(x)||w.has(x)||(0,L.$Kf)(r.get(x)).installed&&m&&(m.has(x)||!(0,L.$Kf)(v?.get(x)).installed||a.delete(x))}const T=[],z=O(r,a,new Set,!0),U=z.added.size>0||z.updated.size>0||z.removed.size>0;return U&&a.forEach((B,Z)=>T.push(b(B,Z))),{local:{added:u,removed:d,updated:E},remote:U?{added:[...z.added].map(B=>a.get(B)),updated:[...z.updated].map(B=>a.get(B)),removed:[...z.removed].map(B=>r.get(B)),all:T}:null}}e.$13b=A;function O(c,$,p,y){const h=c?[...c.keys()].filter(s=>!p.has(s)):[],f=[...$.keys()].filter(s=>!p.has(s)),u=f.filter(s=>!h.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),d=h.filter(s=>!f.includes(s)).reduce((s,o)=>(s.add(o),s),new Set),E=new Set;for(const s of h){if(d.has(s))continue;const o=c.get(s),n=$.get(s);(!n||!R(o,n,y,!0))&&E.add(s)}return{added:u,removed:d,updated:E}}function R(c,$,p,y){return!(c.disabled!==$.disabled||!!c.isApplicationScoped!=!!$.isApplicationScoped||y&&c.installed!==$.installed||c.installed&&$.installed&&(c.preRelease!==$.preRelease||c.pinned!==$.pinned||$.pinned&&c.version!==$.version)||!C(c.state,$.state)||p&&c.version!==$.version)}function k(c,$,p){const y=c.state,h=$.state,f=p?.state;if(!$.version||y&&N.gt(c.version,$.version))return y;if(h&&N.gt($.version,c.version)||!y)return h;if(!h)return y;const u=(0,I.$8m)(y),d=f?g(f,h):{added:Object.keys(h).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set},E=f?g(f,y):{added:Object.keys(y).reduce((s,o)=>(s.add(o),s),new Set),removed:new Set,updated:new Set};for(const s of[...d.added.values(),...d.updated.values()])u[s]=h[s];for(const s of d.removed.values())E.updated.has(s)||delete u[s];return u}function g(c,$){const p=Object.keys(c),y=Object.keys($),h=y.filter(d=>!p.includes(d)).reduce((d,E)=>(d.add(E),d),new Set),f=p.filter(d=>!y.includes(d)).reduce((d,E)=>(d.add(E),d),new Set),u=new Set;for(const d of p){if(f.has(d))continue;const E=c[d],s=$[d];(0,I.$_m)(E,s)||u.add(d)}return{added:h,removed:f,updated:u}}function C(c={},$={}){const{added:p,removed:y,updated:h}=g(c,$);return p.size===0&&y.size===0&&h.size===0}function S(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function b(c,$){const p={...c,identifier:{id:c.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete p.disabled,c.installed||delete p.installed,c.state||delete p.state,c.isApplicationScoped||delete p.isApplicationScoped,p}}),define(oe[111],ae([0,1,18,20,4]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aFb=e.$_Eb=void 0,e.$_Eb=(0,L.$Qh)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const k=R.filter(b=>b.isMachineScoped).map(b=>b.identifier.id.toLowerCase()),g=this.b().map(b=>b.toLowerCase()),C=[],S=[];if(Array.isArray(g))for(const b of g)b.startsWith("-")?S.push(b.substring(1)):C.push(b);return(0,I.$Mb)([...k,...C].filter(b=>!S.includes(b)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$aFb=A,e.$aFb=A=ye([Y(0,N.$ki)],A)}),define(oe[232],ae([0,1,18,35,30,94,78]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$73b=void 0;function R(d){return(0,N.$Xm)(d)||[]}async function k(d,E,s,o,n){const i=R(d),t=R(E),r=s?R(s):null,a=[...i,...t,...r||[]].map(Q=>Q.key),v=await n.resolveUserBindings(a),w=C(i,t,r,v);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:E,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const l=b(i),m=b(t),D=r?b(r):null,T=$(l,m,v),z=D?$(D,l,v):{added:[...l.keys()].reduce((Q,x)=>(Q.add(x),Q),new Set),removed:new Set,updated:new Set},U=D?$(D,m,v):{added:[...m.keys()].reduce((Q,x)=>(Q.add(x),Q),new Set),removed:new Set,updated:new Set},B=g(T,z,U);let Z=d;for(const Q of B.removed.values())B.conflicts.has(Q)||(Z=f(Z,Q,o));for(const Q of B.added.values()){if(B.conflicts.has(Q))continue;const x=m.get(Q);if(x.some(W=>W.command!==`-${Q}`&&w.conflicts.has(v[W.key]))){B.conflicts.add(Q);continue}Z=h(Z,x,o)}for(const Q of B.updated.values()){if(B.conflicts.has(Q))continue;const x=m.get(Q);if(x.some(W=>W.command!==`-${Q}`&&w.conflicts.has(v[W.key]))){B.conflicts.add(Q);continue}Z=u(Z,Q,x,o)}return{mergeContent:Z,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.$73b=k;function g(d,E,s){const o=new Set,n=new Set,i=new Set,t=new Set;for(const r of E.removed.values())s.updated.has(r)&&t.add(r);for(const r of s.removed.values())t.has(r)||(E.updated.has(r)?t.add(r):n.add(r));for(const r of E.added.values())t.has(r)||s.added.has(r)&&d.updated.has(r)&&t.add(r);for(const r of s.added.values())t.has(r)||(E.added.has(r)?d.updated.has(r)&&t.add(r):o.add(r));for(const r of E.updated.values())t.has(r)||s.updated.has(r)&&d.updated.has(r)&&t.add(r);for(const r of s.updated.values())t.has(r)||(E.updated.has(r)?d.updated.has(r)&&t.add(r):i.add(r));return{added:o,removed:n,updated:i,conflicts:t}}function C(d,E,s,o){const n=new Set,i=S(d,o),t=S(E,o),r=s?S(s,o):null,a=c(i,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?c(r,i):{added:[...i.keys()].reduce((z,U)=>(z.add(U),z),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=r?c(r,t):{added:[...t.keys()].reduce((z,U)=>(z.add(U),z),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:l,removed:m,updated:D,conflicts:T}=g(a,v,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:l,removed:m,updated:D,conflicts:T}}function S(d,E){const s=new Map;for(const o of d){const n=E[o.key];let i=s.get(n);i||(i=[],s.set(n,i)),i.push(o)}return s}function b(d){const E=new Map;for(const s of d){const o=s.command[0]==="-"?s.command.substring(1):s.command;let n=E.get(o);n||(n=[],E.set(o,n)),n.push(s)}return E}function c(d,E){const s=[...d.keys()],o=[...E.keys()],n=o.filter(r=>!s.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=s.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of s){if(i.has(r))continue;const a=d.get(r).map(w=>({...w,key:r})),v=E.get(r).map(w=>({...w,key:r}));(0,I.$ub)(a,v,(w,l)=>y(w,l))||t.add(r)}return{added:n,removed:i,updated:t}}function $(d,E,s){const o=[...d.keys()],n=[...E.keys()],i=n.filter(a=>!o.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const v=d.get(a).map(l=>({...l,key:s[l.key]})),w=E.get(a).map(l=>({...l,key:s[l.key]}));p(v,w)||r.add(a)}return{added:i,removed:t,updated:r}}function p(d,E){return!(!(0,I.$ub)(d.filter(({command:s})=>s[0]!=="-"),E.filter(({command:s})=>s[0]!=="-"),(s,o)=>y(s,o))||!(0,I.$ub)(d.filter(({command:s})=>s[0]==="-"),E.filter(({command:s})=>s[0]==="-"),(s,o)=>y(s,o)))}function y(d,E){if(d.command!==E.command||d.key!==E.key)return!1;const s=A.$Oi.deserialize(d.when),o=A.$Oi.deserialize(E.when);return!(s&&!o||!s&&o||s&&o&&!s.equals(o)||!L.$_m(d.args,E.args))}function h(d,E,s){for(const o of E)d=O.edit(d,[-1],o,s);return d}function f(d,E,s){const o=R(d);for(let n=o.length-1;n>=0;n--)(o[n].command===E||o[n].command===`-${E}`)&&(d=O.edit(d,[n],void 0,s));return d}function u(d,E,s,o){const n=R(d),i=n.findIndex(t=>t.command===E||t.command===`-${E}`);for(let t=n.length-1;t>=0;t--)(n[t].command===E||n[t].command===`-${E}`)&&(d=O.edit(d,[t],void 0,o));for(let t=s.length-1;t>=0;t--)d=O.edit(d,[i],s[t],o);return d}}),define(oe[233],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c4b=e.$b4b=void 0;function I(A,O,R){const k={},g={},C=new Set;if(!O)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const S=N(A,O);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const b=N(R,A),c=N(R,O),$={},p={},y=new Set,h=new Set;for(const f of b.removed.values())c.updated.has(f)?k[f]=O[f]:y.add(f);for(const f of c.removed.values())h.has(f)||(b.updated.has(f)?h.add(f):C.add(f));for(const f of b.updated.values())h.has(f)||(c.updated.has(f)?S.updated.has(f)&&h.add(f):p[f]=A[f]);for(const f of c.updated.values())h.has(f)||(b.updated.has(f)?S.updated.has(f)&&h.add(f):A[f]!==void 0&&(g[f]=O[f]));for(const f of b.added.values())h.has(f)||(c.added.has(f)?S.updated.has(f)&&h.add(f):$[f]=A[f]);for(const f of c.added.values())h.has(f)||(b.added.has(f)?S.updated.has(f)&&h.add(f):k[f]=O[f]);return{local:{added:k,removed:[...C.values()],updated:g},remote:{added:$,removed:[...y.values()],updated:p},conflicts:[...h.values()]}}e.$b4b=I;function N(A,O){const R=A?Object.keys(A):[],k=O?Object.keys(O):[],g=k.filter(b=>!R.includes(b)).reduce((b,c)=>(b.add(c),b),new Set),C=R.filter(b=>!k.includes(b)).reduce((b,c)=>(b.add(c),b),new Set),S=new Set;for(const b of R){if(C.has(b))continue;const c=A[b],$=O[b];c!==$&&S.add(b)}return{added:g,removed:C,updated:S}}function L(A,O){const{added:R,removed:k,updated:g}=N(A,O);return R.size===0&&k.size===0&&g.size===0}e.$c4b=L}),define(oe[234],ae([0,1,30]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=void 0;function N(A,O,R,k){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!O){const b=A.filter(({id:c})=>!k.includes(c));return b.length?C.added=b:C=null,{local:g,remote:C}}const S=L(A,O,k);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const b=L(R,A,k),c=L(R,O,k);for(const $ of c.removed){const p=A.find(y=>y.id===$);p&&g.removed.push(p)}for(const $ of c.added){const p=O.find(y=>y.id===$);b.added.includes($)?S.updated.includes($)&&g.updated.push(p):g.added.push(p)}for(const $ of c.updated)g.updated.push(O.find(p=>p.id===$));for(const $ of b.added)c.added.includes($)||C.added.push(A.find(p=>p.id===$));for(const $ of b.updated)c.removed.includes($)||c.updated.includes($)||C.updated.push(A.find(p=>p.id===$));for(const $ of b.removed){const p=O.find(y=>y.id===$);p&&C.removed.push(p)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}e.$V5b=N;function L(A,O,R){A=A?A.filter(({id:c})=>!R.includes(c)):[],O=O.filter(({id:c})=>!R.includes(c));const k=A.map(({id:c})=>c),g=O.map(({id:c})=>c),C=g.filter(c=>!k.includes(c)),S=k.filter(c=>!g.includes(c)),b=[];for(const{id:c,name:$,shortName:p,icon:y,useDefaultFlags:h}of A){if(S.includes(c))continue;const f=O.find(u=>u.id===c);(!f||f.name!==$||f.shortName!==p||f.icon!==y||!(0,I.$_m)(f.useDefaultFlags,h))&&b.push(c)}return{added:C,removed:S,updated:b}}}),define(oe[24],ae([0,1,18,12,173,50,29,4,103,40]),function(te,e,I,N,L,A,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahb=e.$_gb=e.$$gb=e.$0gb=e.$9gb=e.$8gb=e.$7gb=e.$6gb=e.$5gb=e.$4gb=e.$3gb=e.MergeState=e.Change=e.SyncStatus=e.$2gb=e.$1gb=e.$Zgb=e.UserDataSyncErrorCode=e.$Ygb=e.$Xgb=e.$Wgb=e.$Vgb=e.$Ugb=e.$Tgb=e.$Sgb=e.$Rgb=e.$Qgb=e.SyncResource=e.$Pgb=e.$Ogb=e.$Ngb=e.$Mgb=e.$Lgb=e.$Kgb=void 0;function C(){const t=g.$kn.as(A.$pn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$Kgb=C;function S(){const t=g.$kn.as(A.$pn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(w=>!!t[w].ignoreSync),a=Object.keys(t).filter(w=>t[w].scope===2||t[w].scope===6),v=C();return(0,I.$Mb)([...r,...a,...v])}e.$Lgb=S,e.$Mgb="settingsSync",e.$Ngb="settingsSync.keybindingsPerPlatform";function b(){const t="vscode://schemas/ignoredSettings",r=g.$kn.as(A.$pn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$Ngb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$2n,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$kn.as(k.$ln.JSONContribution),v=()=>{const w=C(),l=S(),m=Object.keys(A.$qn.properties).filter(z=>!l.includes(z)),D=l.filter(z=>!w.includes(z)),T={items:{type:"string",enum:[...m,...D.map(z=>`-${z}`)]}};a.registerSchema(t,T)};return r.onDidUpdateConfiguration(()=>v())}e.$Ogb=b;function c(t){return t&&(0,N.$Bf)(t)&&(0,N.$zf)(t.id)&&Array.isArray(t.scopes)}e.$Pgb=c;var $;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$Qgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(t,...r){return t?[t,...r]:r}e.$Rgb=p;function y(t,r,a,v){return v.joinPath(a.userDataSyncHome,...p(t,r,`lastSync${r}.json`))}e.$Sgb=y,e.$Tgb=(0,R.$Qh)("IUserDataSyncStoreManagementService"),e.$Ugb=(0,R.$Qh)("IUserDataSyncStoreService"),e.$Vgb=(0,R.$Qh)("IUserDataSyncLocalStoreService"),e.$Wgb="x-operation-id",e.$Xgb="X-Execution-Id";function h(t){const r={};return r[e.$Xgb]=t,r}e.$Ygb=h;var f;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(f||(e.UserDataSyncErrorCode=f={}));class u extends Error{constructor(r,a,v,w){super(r),this.code=a,this.resource=v,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Zgb=u;class d extends u{constructor(r,a,v,w,l){super(r,v,void 0,l),this.url=a,this.serverCode=w}}e.$1gb=d;class E extends u{constructor(r,a){super(r,a)}}e.$2gb=E,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const w=v[2]==="unknown"?void 0:v[2],l=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],w,l)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(u||(e.$Zgb=u={}));var s;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$3gb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$4gb=i,e.$5gb=(0,R.$Qh)("IUserDataSyncEnablementService"),e.$6gb=(0,R.$Qh)("IUserDataSyncService"),e.$7gb=(0,R.$Qh)("IUserDataSyncResourceProviderService"),e.$8gb=(0,R.$Qh)("IUserDataAutoSyncService"),e.$9gb=(0,R.$Qh)("IUserDataSyncUtilService"),e.$0gb=(0,R.$Qh)("IUserDataSyncLogService"),e.$$gb="userDataSync",e.$_gb="vscode-userdata-sync",e.$ahb="preview"}),define(oe[235],ae([0,1,30,24]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vEb=void 0;function L(O,R,k,g,C){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const S=A(O,R);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const b=k?A(k,R):{added:Object.keys(R).reduce((f,u)=>(f.add(u),f),new Set),removed:new Set,updated:new Set},c=k?A(k,O):{added:Object.keys(O).reduce((f,u)=>(f.add(u),f),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},p=I.$8m(R),y=!k;for(const f of c.added.values())f!==N.$3gb&&y&&b.added.has(f)||(p[f]=O[f]);for(const f of c.updated.values())p[f]=O[f];for(const f of c.removed.values())g.unregistered.includes(f)||delete p[f];for(const f of b.added.values()){const u=R[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(k&&c.added.has(f))continue;const d=O[f];d&&d.value===u.value||f===N.$3gb&&y&&c.added.has(f)||(d?$.updated[f]=u:$.added[f]=u)}for(const f of b.updated.values()){const u=R[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(f)||c.removed.has(f))continue;const d=O[f];d&&d.value===u.value||($.updated[f]=u)}for(const f of b.removed.values()){if(g.machine.includes(f)){C.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}c.updated.has(f)||c.removed.has(f)||$.removed.push(f)}const h=A(R,p);return{local:$,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:p}}}e.$vEb=L;function A(O,R){const k=Object.keys(O),g=Object.keys(R),C=g.filter(c=>!k.includes(c)).reduce((c,$)=>(c.add($),c),new Set),S=k.filter(c=>!g.includes(c)).reduce((c,$)=>(c.add($),c),new Set),b=new Set;for(const c of k){if(S.has(c))continue;const $=O[c],p=R[c];I.$_m($,p)||b.add(c)}return{added:C,removed:S,updated:b}}}),define(oe[236],ae([0,1,18,35,86,41,30,78,24]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jDb=e.$iDb=e.$hDb=e.$gDb=e.$fDb=e.$eDb=void 0;function g(a,v,w){let l=[];w?l=S(w):l=C(v);const m=[],D=[...(0,k.$Kgb)()];if(Array.isArray(l))for(const T of l)T.startsWith("-")?D.push(T.substring(1)):m.push(T);return(0,I.$Mb)([...a,...m].filter(T=>!D.includes(T)))}e.$eDb=g;function C(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function S(a){const v=(0,N.$Xm)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function b(a,v){const w=(0,N.$Xm)(a)||{};let l="{}";for(const m of Object.keys(w)){const D=(0,L.$eT)(l,[m],w[m],v);l=(0,L.$hT)(l,D)}return l}e.$fDb=b;function c(a,v,w,l){if(w.length){const m=r(v),D=(0,N.$Xm)(v)||{},T=(0,N.$Xm)(a);if(!T)return a;const z=[];for(const U of w){const B=D[U],Z=T[U];B===void 0?a=R.edit(a,[U],void 0,l):Z!==void 0?a=R.edit(a,[U],B,l):z.push(s(U,m))}z.sort((U,B)=>U.startOffset-B.startOffset),z.forEach(U=>a=f(U.setting.key,v,a,l))}return a}e.$gDb=c;function $(a,v,w,l,m,D){const T=c(a,v,l,D),z=w!==T,U=w!==v;if(!z&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!U)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(U&&!z)return{conflictsSettings:[],localContent:c(v,a,l,D),remoteContent:null,hasConflicts:!1};if(w===null&&y(a)){const j=p(a,v,l)?null:c(v,a,l,D);return{conflictsSettings:[],localContent:j,remoteContent:null,hasConflicts:!1}}let B=a,Z=v;const Q=(0,N.$Xm)(a),x=(0,N.$Xm)(v),W=w?(0,N.$Xm)(w):null,X=l.reduce((j,M)=>(j.add(M),j),new Set),G=h(Q,x,X),V=h(W,Q,X),ee=h(W,x,X),ie=new Map,_=new Set,ne=j=>{_.add(j);const M=m.filter(({key:F})=>F===j)[0];M?(B=R.edit(B,[j],M.value,D),Z=R.edit(Z,[j],M.value,D)):ie.set(j,{key:j,localValue:Q[j],remoteValue:x[j]})};for(const j of V.removed.values())ee.updated.has(j)?ne(j):Z=R.edit(Z,[j],void 0,D);for(const j of ee.removed.values())_.has(j)||(V.updated.has(j)?ne(j):B=R.edit(B,[j],void 0,D));for(const j of V.updated.values())_.has(j)||(ee.updated.has(j)?G.updated.has(j)&&ne(j):Z=R.edit(Z,[j],Q[j],D));for(const j of ee.updated.values())_.has(j)||(V.updated.has(j)?G.updated.has(j)&&ne(j):B=R.edit(B,[j],x[j],D));for(const j of V.added.values())_.has(j)||(ee.added.has(j)?G.updated.has(j)&&ne(j):Z=f(j,B,Z,D));for(const j of ee.added.values())_.has(j)||(V.added.has(j)?G.updated.has(j)&&ne(j):B=f(j,Z,B,D));const K=ie.size>0||!p(B,Z,l),q=K||!p(B,a,[]),P=K||!p(Z,v,[]);return{localContent:q?B:null,remoteContent:P?Z:null,conflictsSettings:[...ie.values()],hasConflicts:K}}e.$hDb=$;function p(a,v,w){if(a===v)return!0;const l=(0,N.$Xm)(a),m=(0,N.$Xm)(v),D=w.reduce((U,B)=>(U.add(B),U),new Set),T=r(a).filter(U=>!(U.setting&&D.has(U.setting.key))),z=r(v).filter(U=>!(U.setting&&D.has(U.setting.key)));if(T.length!==z.length)return!1;for(let U=0;U<T.length;U++){const B=T[U],Z=z[U];if(B.setting&&Z.setting){if(B.setting.key!==Z.setting.key||!O.$_m(l[B.setting.key],m[B.setting.key]))return!1}else if(!B.setting&&!Z.setting){if(B.value!==Z.value)return!1}else return!1}return!0}function y(a){return a?r(a).length===0:!0}e.$iDb=y;function h(a,v,w){const l=a?Object.keys(a).filter(U=>!w.has(U)):[],m=Object.keys(v).filter(U=>!w.has(U)),D=m.filter(U=>!l.includes(U)).reduce((U,B)=>(U.add(B),U),new Set),T=l.filter(U=>!m.includes(U)).reduce((U,B)=>(U.add(B),U),new Set),z=new Set;if(a)for(const U of l){if(T.has(U))continue;const B=a[U],Z=v[U];O.$_m(B,Z)||z.add(U)}return{added:D,removed:T,updated:z}}function f(a,v,w,l){const m=(0,N.$Xm)(v),D=r(v),T=r(w),z=u(a,D,T);return d(w,a,m[a],z,T,l)}e.$jDb=f;function u(a,v,w){const l=v.findIndex(D=>D.setting?.key===a),m=v[l-1];if(m){if(m.setting){const T=s(m.setting.key,w);if(T)return{index:w.indexOf(T),insertAfter:!0}}else{const T=o(l,v);if(T){const z=s(T.setting.key,w);if(z){const U=n(w.indexOf(z),w),B=i(v,T,v[l]);if(U){const Z=i(w,z,U),Q=t(B,Z);return Q?{index:w.indexOf(Q),insertAfter:!0}:{index:w.indexOf(U),insertAfter:!1}}else{const Z=i(w,z,w[w.length-1]),Q=t(B,Z);return Q?{index:w.indexOf(Q),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const D=v[l+1];if(D)if(D.setting){const T=s(D.setting.key,w);if(T)return{index:w.indexOf(T),insertAfter:!1}}else{const T=n(l,v);if(T){const z=s(T.setting.key,w);if(z){const U=o(w.indexOf(z),w),B=i(v,v[l],T);if(U){const Z=i(w,U,z),Q=t(B.reverse(),Z.reverse());return Q?{index:w.indexOf(Q),insertAfter:!1}:{index:w.indexOf(U),insertAfter:!0}}else{const Z=i(w,w[0],z),Q=t(B.reverse(),Z.reverse());return Q?{index:w.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function d(a,v,w,l,m,D){let T;return l.index===-1?T=(0,L.$eT)(a,[v],w,D):T=E(a,v,w,l,m,D).map(z=>(0,L.$fT)(a,z,D)[0]),(0,L.$hT)(a,T)}function E(a,v,w,l,m,D){const T=`${JSON.stringify(v)}: ${JSON.stringify(w)}`,z=(0,A.$bT)(D,a),U=m[l.index];if(l.insertAfter){const B=[];if(U.setting)B.push({offset:U.endOffset,length:0,content:","+T});else{const Z=n(l.index,m),Q=o(l.index,m),x=Q?.setting?.commaOffset;Q&&x===void 0&&B.push({offset:Q.endOffset,length:0,content:","});const W=x!==void 0&&x>U.endOffset;B.push({offset:W?x+1:U.endOffset,length:0,content:Z?z+T+",":z+T})}return B}else{if(U.setting)return[{offset:U.startOffset,length:0,content:T+","}];const B=(m[l.index-1]&&!m[l.index-1].setting?z:"")+T+(n(l.index,m)?",":"")+z;return[{offset:U.startOffset,length:0,content:B}]}}function s(a,v){return v.filter(w=>w.setting?.key===a)[0]}function o(a,v){for(let w=a-1;w>=0;w--)if(v[w].setting)return v[w]}function n(a,v){for(let w=a+1;w<v.length;w++)if(v[w].setting)return v[w]}function i(a,v,w){const l=a.indexOf(v),m=a.indexOf(w);return a.filter((D,T)=>l<T&&T<m)}function t(a,v){if(a.length&&v.length){let w=0;for(;w<v.length&&w<a.length;w++)if(a[w].value!==v[w].value)return v[w-1];return v[w-1]}}function r(a){const v=[];let w=-1,l,m;const D={onObjectBegin:T=>{w++},onObjectProperty:(T,z,U)=>{w===0&&(l=z,m=T)},onObjectEnd:(T,z)=>{w--,w===0&&v.push({startOffset:l,endOffset:T+z,value:a.substring(l,T+z),setting:{key:m,commaOffset:void 0}})},onArrayBegin:(T,z)=>{w++},onArrayEnd:(T,z)=>{w--,w===0&&v.push({startOffset:l,endOffset:T+z,value:a.substring(l,T+z),setting:{key:m,commaOffset:void 0}})},onLiteralValue:(T,z,U)=>{w===0&&v.push({startOffset:l,endOffset:z+U,value:a.substring(l,z+U),setting:{key:m,commaOffset:void 0}})},onSeparator:(T,z,U)=>{if(w===0&&T===","){let B=v.length-1;for(;B>=0&&!v[B].setting;B--);const Z=v[B];Z&&v.splice(B,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:z}})}},onComment:(T,z)=>{w===0&&v.push({startOffset:T,endOffset:T+z,value:a.substring(T,T+z)})}};return(0,N.$5m)(a,D),v}}),define(oe[79],ae([0,1,3,2,4,24]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Cb=e.$1Cb=void 0,e.$1Cb=(0,L.$Qh)("IUserDataSyncAccountService");let O=class extends N.$Sc{get account(){return this.a}constructor(k,g){super(),this.g=k,this.h=g,this.b=this.B(new I.$Od),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$Od),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$2Cb=O,e.$2Cb=O=ye([Y(0,A.$Ugb),Y(1,A.$0gb)],O)}),define(oe[237],ae([0,1,2,10]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j9b=e.$i9b=e.$h9b=e.$g9b=e.$f9b=e.$e9b=e.$d9b=void 0;class L{constructor(b){this.a=b}listen(b,c){switch(c){case"onError":return this.a.onError}throw new Error(`Event not found: ${c}`)}call(b,c,$){switch(c){case"triggerSync":return this.a.triggerSync($[0],$[1],$[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff($[0])}throw new Error("Invalid call")}}e.$d9b=L;class A{constructor(b){this.a=b}listen(b,c){throw new Error(`Event not found: ${c}`)}call(b,c,$){switch(c){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings($[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive($[0]))}throw new Error("Invalid call")}}e.$e9b=A;class O{constructor(b){this.a=b}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(b){return this.a.call("resolveUserKeybindings",[b])}async resolveFormattingOptions(b){return this.a.call("resolveFormattingOptions",[b])}}e.$f9b=O;class R{constructor(b){this.a=b}listen(b,c){switch(c){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${c}`)}async call(b,c,$){switch(c){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine($[0],$[1]);case"setEnablements":return this.a.setEnablements($)}throw new Error("Invalid call")}}e.$g9b=R;class k{constructor(b){this.a=b}listen(b,c){switch(c){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${c}`)}call(b,c,$){switch(c){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount($)}throw new Error("Invalid call")}}e.$h9b=k;class g{constructor(b){this.a=b}listen(b,c){switch(c){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call(b,c,$){switch(c){case"switch":return this.a.switch($[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$i9b=g;class C extends I.$Sc{constructor(b){super(),this.a=b,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(b){return this.a.call("switch",[b])}async getPreviousUserDataSyncStore(){const b=await this.a.call("getPreviousUserDataSyncStore");return this.b(b)}b(b){return{url:N.URI.revive(b.url),type:b.type,defaultUrl:N.URI.revive(b.defaultUrl),insidersUrl:N.URI.revive(b.insidersUrl),stableUrl:N.URI.revive(b.stableUrl),canSwitch:b.canSwitch,authenticationProviders:b.authenticationProviders}}}e.$j9b=C}),define(oe[238],ae([0,1,19,174,14,8,24]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bFb=void 0;let R=class extends A.$dj{constructor(g,C){super(),this.g=this.B(g.createLogger((0,I.$wg)(C.logsHome,`${O.$$gb}.log`),{id:O.$$gb,name:(0,N.localize)(0,null)}))}trace(g,...C){this.g.trace(g,...C)}debug(g,...C){this.g.debug(g,...C)}info(g,...C){this.g.info(g,...C)}warn(g,...C){this.g.warn(g,...C)}error(g,...C){this.g.error(g,...C)}flush(){this.g.flush()}};e.$bFb=R,e.$bFb=R=ye([Y(0,A.$_i),Y(1,L.$Xh)],R)}),define(oe[239],ae([0,1,6,3,2]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=void 0;class A extends L.$Sc{constructor({onDidOpenWindow:R,onDidFocusWindow:k,getActiveWindowId:g}){super(),this.a=this.B(new L.$Rc),N.Event.latch(N.Event.any(R,k))(this.f,this,this.a),this.b=(0,I.$Ig)(()=>g()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$e8b=A}),define(oe[112],ae([0,1,177,16,47,19,10,4,23]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.WorkbenchState=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0,e.$Zh=(0,R.$Qh)("contextService");function g(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.$1h=g;function C(i){return typeof i?.id=="string"&&!g(i)&&!b(i)}e.$2h=C,e.$3h={id:"ext-dev"},e.$4h={id:"empty-window"};function S(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,N.$nc)(i)}:t?e.$3h:e.$4h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$5h=S;function b(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.$6h=b;function c(i){const t=i;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$7h=c;var $;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function p(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$8h=p;function y(i){const t=i;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$9h=y;class h{constructor(t,r,a,v,w){this.h=t,this.j=a,this.k=v,this.l=w,this.c=L.$Wh.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=L.$Wh.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$0h=h;class f{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.$wg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$$h=f;function u(i){return new f({uri:i,index:0,name:(0,A.$sg)(i)},{uri:i.toString()})}e.$_h=u,e.$ai="code-workspace",e.$bi=`.${e.$ai}`,e.$ci=[{name:(0,I.localize)(0,null),extensions:[e.$ai]}],e.$di="workspace.json";function d(i,t){return A.$ng.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$ei=d;function E(i){let t;return O.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===k.Schemas.tmp}e.$fi=E,e.$gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$gi}e.$hi=s;function o(i,t){return!d(i,t)&&!E(i)}e.$ii=o;function n(i){return(typeof i=="string"?(0,N.$oc)(i):(0,A.$ug)(i))===e.$bi}e.$ji=n}),define(oe[17],ae([0,1,52,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.ProfileResourceType=void 0;var u;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(u||(e.ProfileResourceType=u={}));function d(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$Kk=d,e.$Lk=(0,C.$Qh)("IUserDataProfilesService");function E(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:O.URI.revive(i.location).with({scheme:t}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Mk=E;function s(i,t,r,a,v,w){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:w&&v?.useDefaultFlags?.globalState?w.globalStorageHome:(0,A.$wg)(r,"globalStorage"),settingsResource:w&&v?.useDefaultFlags?.settings?w.settingsResource:(0,A.$wg)(r,"settings.json"),keybindingsResource:w&&v?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,A.$wg)(r,"keybindings.json"),tasksResource:w&&v?.useDefaultFlags?.tasks?w.tasksResource:(0,A.$wg)(r,"tasks.json"),snippetsHome:w&&v?.useDefaultFlags?.snippets?w.snippetsHome:(0,A.$wg)(r,"snippets"),extensionsResource:w&&v?.useDefaultFlags?.extensions?w.extensionsResource:(0,A.$wg)(r,"extensions.json"),cacheHome:(0,A.$wg)(a,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Nk=s;let o=class extends L.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new N.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new c.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,f.$zf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}r.push(s((0,A.$tg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},t))}}catch(w){this.y.error(w)}const a=new c.$Ac,v=new Map;if(r.length)try{const w=this.Q();if(w.workspaces)for(const[l,m]of Object.entries(w.workspaces)){const D=O.URI.parse(l),T=r.find(z=>z.id===m);T&&a.set(D,T)}if(w.emptyWindows)for(const[l,m]of Object.entries(w.emptyWindows)){const D=r.find(T=>T.id===m);D&&v.set(l,D)}}catch(w){this.y.error(w)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=s("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,h.$Ge)(r)}\\s(\\d+)`);let v=0;for(const l of this.profiles){const m=a.exec(l.name),D=m?parseInt(m[1]):0;v=D>v?D:v}const w=`${r} ${v+1}`;return this.createProfile((0,I.$Ei)((0,y.$fg)()).toString(16),w,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,I.$Ei)((0,y.$fg)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,w),w}async F(t,r,a){if(!(0,f.$zf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const w=this.profiles.find(D=>D.name===r||D.id===t);if(w)return w;const l=s(t,r,(0,A.$wg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(l.location);const m=[];return this.j.fire({profile:l,join(D){m.push(D)}}),await p.Promises.settled(m),this.I([l],[],[]),l}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=s(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,g.$qk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,b.$1h)(t)?t.uri:(0,b.$6h)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],w=[];this.s.profiles=[];for(let l of v)l.isDefault||r.some(m=>l.id===m.id)||(l=a.find(m=>l.id===m.id)??l,l.isTransient?this.s.profiles.push(l):w.push({location:l.location,name:l.name,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags}));this.P(w),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),w=a?this.s:this.C;O.URI.isUri(v)?(w.workspaces.delete(v),r&&w.workspaces.set(v,r)):(w.emptyWindows.delete(v),r&&w.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[w,l]of Object.entries(t.workspaces)){const m=O.URI.parse(l);r[w]=this.w.extUri.isEqual(m,a.location)?a.id:this.w.extUri.basename(m)}const v={};if(t.emptyWindows)for(const[w,l]of Object.entries(t.emptyWindows)){const m=O.URI.parse(l);v[w]=this.w.extUri.isEqual(m,a.location)?a.id:this.w.extUri.basename(m)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Ok=o,e.$Ok=o=ye([Y(0,k.$Xh),Y(1,g.$_j),Y(2,$.$Jk),Y(3,S.$$i)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Pk=n}),define(oe[240],ae([0,1,6,2,17]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r9b=void 0;let A=class extends N.$Sc{constructor(R){super(),this.B(new I.$7g(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$r9b=A,e.$r9b=A=ye([Y(0,L.$Lk)],A)}),define(oe[241],ae([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=void 0;let d=class extends R.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,w,l){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=w,this.H=l,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$Od),this.s=this.B(new O.$Od),this.t=this.B(new O.$Od),this.u=this.B(new O.$Od),this.w=this.B(new O.$Od),this.y=[],this.B((0,R.$Qc)(()=>{this.j.forEach(({task:m})=>m.cancel()),this.m.forEach(m=>m.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,b.$_n)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:w})=>(0,c.$Do)(w,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:s(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(a){throw s(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new b.$co(S.localize(0,null),b.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:w})=>{try{const l=await this.O(v,!!w?.installGivenVersion,!!w?.installPreReleaseVersion);a.push({...l,options:w})}catch(l){r.push({identifier:v.identifier,operation:2,source:v,error:l})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,c.$Lo)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,$.$0l)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const w=(await this.getInstalled(1,v.extensionsResource)).find(l=>(0,c.$Do)(l.identifier,t.identifier));w?this.w.fire(w):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const v=await this.J(a,(w,l)=>t.some(m=>(0,c.$Ho)(l.identifier.id)===(0,c.$Io)(m.manifest.publisher,m.manifest.name))?!1:this.L(w,l));r.push(...v)}catch(v){r.push({identifier:{id:(0,c.$Io)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:a},v){const w=a.isApplicationScoped||a.isBuiltin||(0,$.$0l)(t),l={...a,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:w,profileLocation:w?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},m=Z=>`${c.$Eo.create(Z).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const Z=this.j.get(m(r));if(Z)return this.F.info("Extensions is already requested to install",r.identifier.id),await Z.task.waitUntilTaskIsFinished(),[]}const D=[],T=[],z=[],U=this.Z(t,r,l);C.URI.isUri(r)||this.j.set(m(r),{task:U,waitingTasks:[]}),this.n.fire({identifier:U.identifier,source:r,profileLocation:l.profileLocation}),this.F.info("Installing extension:",U.identifier.id),D.push({task:U,manifest:t});let B=!1;try{if(l.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",U.identifier.id);else try{const Q=await this.N(U.identifier,t,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),x=await this.getInstalled(void 0,l.profileLocation),W={...l,donotIncludePackAndDependencies:!0,context:{...l.context,[b.$7n]:!0}};for(const{gallery:X,manifest:G}of(0,I.$Mb)(Q,({gallery:V})=>V.identifier.id)){B=B||!!G.extensionDependencies?.some(ie=>(0,c.$Do)({id:ie},U.identifier));const V=m(X),ee=this.j.get(V);if(ee){if(v(U,ee.task)){const ie=ee.task.identifier;this.F.info("Waiting for already requested installing extension",ie.id,U.identifier.id),ee.waitingTasks.push(U),T.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,_=>_.some(ne=>(0,c.$Do)(ne.identifier,ie)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",ie.id,U.identifier.id),!_.find(K=>(0,c.$Do)(K.identifier,ie))?.local)throw new Error(`Extension ${ie.id} is not installed`)}))}}else if(!x.some(({identifier:ie})=>(0,c.$Do)(ie,X.identifier))){const ie=this.Z(G,X,W);this.j.set(V,{task:ie,waitingTasks:[U]}),this.n.fire({identifier:ie.identifier,source:X,profileLocation:l.profileLocation}),this.F.info("Installing extension:",ie.identifier.id,U.identifier.id),D.push({task:ie,manifest:G})}}}catch(Q){if(C.URI.isUri(U.source))(0,I.$Lb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",U.identifier.id,Q.message),(0,I.$Lb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",U.identifier.id,Q.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",U.identifier.id),Q}const Z=D.reduce((Q,{task:x,manifest:W})=>(Q.set(x.identifier.id.toLowerCase(),{task:x,manifest:W}),Q),new Map);for(;Z.size;){let Q;const x=[...Z.values()].filter(({manifest:W})=>!W.extensionDependencies?.some(X=>Z.has(X.toLowerCase())));x.length?Q=Z.size===1?x:x.filter(({task:W})=>!(W===U&&!B)):(this.F.info("Found extensions with circular dependencies",x.map(({task:W})=>W.identifier.id)),Q=[...Z.values()]),await this.M(Q.map(async({task:W})=>{const X=new Date().getTime();try{const G=await W.run();if(await this.M(this.y.map(V=>V.postInstall(G,W.source,l,L.CancellationToken.None))),!C.URI.isUri(W.source)){const V=W.operation===3,ee=V?void 0:(new Date().getTime()-W.source.lastUpdated)/1e3;if(o(this.C,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Lo)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-X,durationSinceUpdate:ee}),k.$p&&W.operation!==3)try{await this.z.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}z.push({local:G,identifier:W.identifier,operation:W.operation,source:W.source,context:W.options.context,profileLocation:W.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw C.URI.isUri(W.source)||o(this.C,W.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Lo)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-X,error:G}),this.F.error("Error while installing the extension:",W.identifier.id),G}finally{Z.delete(W.identifier.id.toLowerCase())}}))}return T.length&&await this.M(T),z.forEach(({identifier:Q})=>this.F.info("Extension installed successfully:",Q.id)),z}catch(Z){if(D.forEach(({task:Q})=>Q.cancel()),z.length)try{const Q=await Promise.allSettled(z.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let x=0;x<Q.length;x++){const W=Q[x],{identifier:X}=z[x];W.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",X.id):this.F.warn("Rollback: Error while uninstalling extension",X.id,(0,A.$0)(W.reason))}}catch(Q){this.F.warn("Error while rolling back extensions",(0,A.$0)(Q),z.map(({identifier:x})=>x.id))}return D.map(({task:Q})=>({identifier:Q.identifier,operation:2,source:Q.source,context:l.context,profileLocation:l.profileLocation,error:Z}))}finally{for(const{task:Z}of D)Z.source&&!C.URI.isUri(Z.source)&&this.j.delete(m(Z.source))}}L(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(w=>this.L(w,r)))||a===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],a=[],v=await Promise.allSettled(t);for(const w of v)w.status==="fulfilled"?r.push(w.value):a.push(w.reason);if(a.length)throw E(a);return r}async N(t,r,a,v,w){if(!this.z.isEnabled())return[];const l=await this.getInstalled(void 0,w),m=[],D=[],T=async(z,U)=>{m.push(z);const B=U.extensionDependencies||[],Z=[...B];if(U.extensionPack){const Q=a?l.find(x=>(0,c.$Do)(x.identifier,z)):void 0;for(const x of U.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(W=>(0,c.$Do)({id:W},{id:x}))||Z.every(W=>!(0,c.$Do)({id:W},{id:x}))&&Z.push(x)}if(Z.length){const Q=Z.filter(x=>m.every(W=>!(0,c.$Do)(W,{id:x})));if(Q.length){const x=await this.z.getExtensions(Q.map(W=>({id:W,preRelease:v})),L.CancellationToken.None);for(const W of x){if(m.find(V=>(0,c.$Do)(V,W.identifier)))continue;const X=B.some(V=>(0,c.$Do)({id:V},W.identifier));let G;try{G=await this.O(W,!1,v)}catch(V){if(X)throw V;this.F.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,A.$0)(V));continue}D.push({gallery:G.extension,manifest:G.manifest}),await T(G.extension.identifier,G.manifest)}}}};return await T(t,r),D}async O(t,r,a){let v;const w=await this.getExtensionsControlManifest();if(w.malicious.some(D=>(0,c.$Do)(t.identifier,D)))throw new b.$co(S.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);const l=w.deprecated[t.identifier.id.toLowerCase()];if(l?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${l.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:l.extension.id,preRelease:l.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0],!v)throw new b.$co(S.localize(2,null,t.identifier.id,l.extension.id),b.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const D=await this.getTargetPlatform();throw new b.$co(S.localize(3,null,t.identifier.id,this.G.nameLong,(0,b.$8n)(D)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,a),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],L.CancellationToken.None))[0]?new b.$co(S.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$co(S.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),b.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const m=await this.z.getManifest(v,L.CancellationToken.None);if(m===null)throw new b.$co(`Missing manifest for extension ${v.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(m.version!==v.version)throw new b.$co(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:m}}async P(t,r,a){const v=await this.getTargetPlatform();let w=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(w=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null),!w&&await this.z.isExtensionCompatible(t,a,v)&&(w=t),w||(r?w=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},L.CancellationToken.None))[0]||null:w=await this.z.getCompatibleExtension(t,a,v)),w}async Q(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=z=>`${z.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,w=this.m.get(v(t.identifier));if(w)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),w.waitUntilTaskIsFinished();const l=z=>{const U=this.$(z,a);return this.m.set(v(U.extension.identifier),U),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${z.identifier.id}@${z.manifest.version}`),this.t.fire({identifier:z.identifier,profileLocation:a.profileLocation,applicationScoped:z.isApplicationScoped}),U},m=(z,U)=>{U?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${z.identifier.id}@${z.manifest.version}`,U.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${z.identifier.id}@${z.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,c.$Ko)(z),error:U}),this.u.fire({identifier:z.identifier,error:U?.code,profileLocation:a.profileLocation,applicationScoped:z.isApplicationScoped})},D=[],T=[];try{D.push(l(t));const z=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const U=this.U(t,z);for(const B of U)this.m.has(v(B.identifier))?this.F.info("Extensions is already requested to uninstall",B.identifier.id):D.push(l(B))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(D.map(U=>U.extension),z,t),await this.M(D.map(async U=>{try{if(await U.run(),await this.M(this.y.map(B=>B.postUninstall(U.extension,a,L.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}m(U.extension)}catch(B){const Z=B instanceof b.$co?B:new b.$co((0,A.$0)(B),b.ExtensionManagementErrorCode.Internal);throw m(U.extension,Z),Z}finally{T.push(U)}}))}catch(z){const U=z instanceof b.$co?z:new b.$co((0,A.$0)(z),b.ExtensionManagementErrorCode.Internal);for(const B of D){try{B.cancel()}catch{}T.includes(B)||m(B.extension,U)}throw U}finally{for(const z of D)this.m.delete(v(z.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",z.extension.identifier.id)}}R(t,r,a){for(const v of t){const w=this.W(v,r);if(w.length){const l=w.filter(m=>!t.some(D=>(0,c.$Do)(D.identifier,m.identifier)));if(l.length)throw new Error(this.S(v,l,a))}}}S(t,r,a){return a===t?r.length===1?S.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?S.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const w=r.filter(m=>!m.isBuiltin&&v.some(D=>(0,c.$Do)({id:D},m.identifier))),l=[];for(const m of w)l.push(...this.U(m,r,a));return[...w,...l]}return[]}W(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,c.$Do)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$tp=d,e.$tp=d=ye([Y(0,b.$bo),Y(1,h.$dl),Y(2,f.$Jk),Y(3,p.$$i),Y(4,y.$qj),Y(5,u.$Lk)],d);function E(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$up=E;function s(i){if(i instanceof b.$co)return i;const t=new b.$co(i.message,b.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$vp=s;function o(i,t,{extensionData:r,verificationStatus:a,duration:v,error:w,durationSinceUpdate:l}){let m,D;(0,g.$Hf)(a)&&(a===!0?a="Verified":(a===!1||(m=b.ExtensionManagementErrorCode.Signature,D=a),a="Unverified")),w&&(w instanceof b.$co?(m=w.code,w.code===b.ExtensionManagementErrorCode.Signature&&(D=w.message)):m=b.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:a,success:!w,duration:v,errorcode:m,errorcodeDetail:D,durationSinceUpdate:l})}class n{constructor(){this.d=new N.$Tg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$Ig)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$Ig)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$wp=n}),define(oe[51],ae([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class u extends Error{constructor(n,i){super(n),this.code=i}}e.$xp=u,e.$yp=(0,S.$Qh)("IExtensionsProfileScannerService");let d=class extends L.$Sc{constructor(n,i,t,r,a,v){super(),this.j=n,this.m=i,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new A.$Od),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Od),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Od),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Od),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Ac}scanProfileExtensions(n,i){return this.u(n,void 0,i)}async addExtensionsToProfile(n,i){const t=[],r=[];try{return await this.u(i,a=>{const v=[];for(const w of a)n.some(([l])=>(0,g.$Do)(l.identifier,w.identifier)&&l.manifest.version!==w.version)?t.push(w):v.push(w);for(const[w,l]of n){const m=v.findIndex(T=>(0,g.$Do)(T.identifier,w.identifier)&&T.version===w.manifest.version),D={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:l};m===-1?(r.push(D),v.push(D)):v.splice(m,1,D)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:i}),a}}async updateMetadata(n,i){const t=[];return await this.u(i,r=>{const a=[];for(const v of r){const w=n.find(([l])=>(0,g.$Do)(l.identifier,v.identifier)&&l.manifest.version===v.version);w&&(v.metadata={...v.metadata,...w[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(n,i){const t=[];try{await this.u(i,r=>{const a=[];for(const v of r)(0,g.$Do)(v.identifier,n.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),a}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(n,i,t){return this.F(n).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(n);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$qk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new u((0,y.$0)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let v=!1;for(const w of a){E(w)||this.w(n);let l;if((0,p.$zf)(w.relativeLocation)&&w.relativeLocation)l=this.z(w.relativeLocation);else if((0,p.$zf)(w.location))l=this.z(w.location),v=!0,w.relativeLocation=w.location,w.location=l.toJSON();else{l=R.URI.revive(w.location);const m=this.y(l);m&&(v=!0,w.relativeLocation=m)}r.push({identifier:w.identifier,location:l,version:w.version,metadata:w.metadata})}v&&await this.m.writeFile(n,N.$ce.fromString(JSON.stringify(a)))}if(i){r=i(r);const v=r.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.y(w.location),metadata:w.metadata}));await this.m.writeFile(n,N.$ce.fromString(JSON.stringify(v)))}return r})}w(n){const i=new u(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$qk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>E(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$ce.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$qk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$qk)(a)!==1&&this.t.error(a)}try{await this.m.del(i)}catch(a){(0,C.$qk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let i=this.h.get(n);return i||(i=new I.$2g,this.h.set(n,i)),i}};e.$zp=d,e.$zp=d=ye([Y(1,C.$_j),Y(2,c.$Lk),Y(3,$.$Jk),Y(4,h.$dl),Y(5,b.$$i)],d);function E(o){return(0,p.$Bf)(o)&&(0,k.$ao)(o.identifier)&&(s(o.location)||(0,p.$zf)(o.location)&&o.location)&&((0,p.$Gf)(o.relativeLocation)||(0,p.$zf)(o.relativeLocation))&&o.version&&(0,p.$zf)(o.version)}function s(o){return o?(0,p.$zf)(o.path)&&(0,p.$zf)(o.scheme):!1}}),define(oe[80],ae([0,1,18,6,30,15,7,35,137,2,23,16,5,19,54,89,12,10,154,14,33,44,68,11,4,8,25,3,64,51,17,28,182]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d,E,s,o,n,i,t,r,a,v,w,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.Translations=void 0;var D;(function(x){function W(X,G){if(X===G)return!0;const V=Object.keys(X),ee=new Set;for(const ie of Object.keys(G))ee.add(ie);if(V.length!==ee.size)return!1;for(const ie of V){if(X[ie]!==G[ie])return!1;ee.delete(ie)}return ee.size===0}x.equals=W})(D||(e.Translations=D={})),e.$Cp=(0,n.$Qh)("IExtensionsScannerService");let T=class extends g.$Sc{constructor(W,X,G,V,ee,ie,_,ne,K,q,P,j){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=X,this.r=G,this.s=V,this.t=ee,this.u=ie,this.w=_,this.y=ne,this.z=K,this.C=q,this.D=P,this.F=j,this.g=this.B(new r.$Od),this.onDidChangeCache=this.g.event,this.h=(0,c.$wg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(B,this.s,this.h)),this.m=this.B(this.F.createInstance(B,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$Oo)(this.w,this.y)),this.G}async scanAllExtensions(W,X,G){const[V,ee]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(X)]),ie=G?await this.scanExtensionsUnderDevelopment(W,[...V,...ee]):[];return this.L(V,ee,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const X=[];X.push(this.M(!!W.useCache,W.language)),X.push(this.N(W.language,!!W.checkControlFile));const[G,V]=await Promise.all(X);return this.J([...G,...V],0,W,!1)}async scanUserExtensions(W){const X=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const G=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(X,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,G),ee=W.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let ie;try{ie=await ee.scanExtensions(V)}catch(_){if(_ instanceof v.$xp&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ie=await ee.scanExtensions(V);else throw _}return ie=await this.J(ie,1,W,!0),this.y.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(W,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===C.Schemas.file).map(async V=>{const ee=await this.P(V,!1,1,!0,W.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ee)).map(_=>(_.type=X.find(ne=>(0,d.$Do)(ne.identifier,_.identifier))?.type??_.type,this.n.validate(_,ee)))}))).flat();return this.J(G,"development",W,!0)}return[]}async scanExistingExtension(W,X,G){const V=await this.P(W,!1,X,!0,G.language,!0,void 0),ee=await this.n.scanExtension(V);return!ee||!G.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(W,X,G){const V=await this.P(W,!1,X,!0,G.language,!0,void 0),ee=await this.n.scanOneOrMultipleExtensions(V);return this.J(ee,X,G,!0)}async scanMetadata(W){const X=(0,c.$wg)(W,"package.json"),G=(await this.w.readFile(X)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(W,X){const G=(0,c.$wg)(W,"package.json"),V=(await this.w.readFile(G)).value.toString(),ee=JSON.parse(V);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,ee.__metadata={...ee.__metadata,...X},await this.w.writeFile((0,c.$wg)(W,"package.json"),A.$ce.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof v.$xp&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ce.fromString(JSON.stringify([])))}catch(X){(0,o.$qk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,X,G,V){return G.includeAllVersions||(W=this.L(X===0?W:void 0,X===1?W:void 0,X==="development"?W:void 0,await this.getTargetPlatform(),V)),G.includeInvalid||(W=W.filter(ee=>ee.isValid)),W.sort((ee,ie)=>{const _=S.$nc(ee.location.fsPath),ne=S.$nc(ie.location.fsPath);return _<ne?-1:_>ne?1:0})}L(W,X,G,V,ee){const ie=(ne,K,q)=>{if(ne.isValid&&!K.isValid)return!1;if(ne.isValid===K.isValid){if(ee&&$.gt(ne.manifest.version,K.manifest.version))return this.y.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${ne.location.path} with version ${ne.manifest.version}`),!1;if($.eq(ne.manifest.version,K.manifest.version)){if(ne.type===0)return this.y.debug(`Skipping extension ${K.location.path} in favour of system extension ${ne.location.path} with same version`),!1;if(ne.targetPlatform===V)return this.y.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${ne.location.path} with ${K.location.path}.`):this.y.debug(`Overwriting user extension ${ne.location.path} with ${K.location.path}.`),!0},_=new E.$9l;return W?.forEach(ne=>{const K=_.get(ne.identifier.id);(!K||ie(K,ne,!1))&&_.set(ne.identifier.id,ne)}),X?.forEach(ne=>{const K=_.get(ne.identifier.id);if(!K&&W&&ne.type===0){this.y.debug(`Skipping obsolete system extension ${ne.location.path}.`);return}(!K||ie(K,ne,!1))&&_.set(ne.identifier.id,ne)}),G?.forEach(ne=>{const K=_.get(ne.identifier.id);(!K||ie(K,ne,!0))&&_.set(ne.identifier.id,ne),_.set(ne.identifier.id,ne)}),[..._.values()]}async M(W,X){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),ee=await(W&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(W,X){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const V=X?await this.O():{},ee=[],ie=h.URI.file(S.$hc(S.$jc(C.$dg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ne of G){const K=V[ne.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":ee.push((0,c.$wg)(ie,ne.name));break;default:ee.push(h.URI.file(K));break}}const _=await Promise.all(ee.map(async ne=>this.n.scanExtension(await this.P(ne,!1,0,!0,W,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,I.$Hb)(_)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,X,G,V,ee,ie,_){const ne=await this.f(ee??b.$w),K=await this.Q(W),q=X&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=q?await this.Q(q):void 0;return new z(W,K,q,P,X,_,G,V,ie,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ee,ne)}async Q(W){try{const X=await this.w.stat(W);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$Dp=T,e.$Dp=T=ye([Y(4,w.$Lk),Y(5,v.$yp),Y(6,o.$_j),Y(7,i.$$i),Y(8,u.$Xh),Y(9,t.$qj),Y(10,l.$Jk),Y(11,n.$Ph)],T);class z{constructor(W,X,G,V,ee,ie,_,ne,K,q,P,j,M,F,H){this.location=W,this.mtime=X,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=V,this.profile=ee,this.profileScanOptions=ie,this.type=_,this.excludeObsolete=ne,this.validate=K,this.productVersion=q,this.productDate=P,this.productCommit=j,this.devMode=M,this.language=F,this.translations=H}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,X){return(0,c.$pg)(W.location,X.location)&&W.mtime===X.mtime&&(0,c.$pg)(W.applicationExtensionslocation,X.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&W.profile===X.profile&&L.$_m(W.profileScanOptions,X.profileScanOptions)&&W.type===X.type&&W.excludeObsolete===X.excludeObsolete&&W.validate===X.validate&&W.productVersion===X.productVersion&&W.productDate===X.productDate&&W.productCommit===X.productCommit&&W.devMode===X.devMode&&W.language===X.language&&D.equals(W.translations,X.translations)}}e.$Ep=z;let U=class extends g.$Sc{constructor(W,X,G,V,ee){super(),this.f=W,this.g=X,this.h=G,this.j=V,this.m=ee}async scanExtensions(W){const X=W.profile?await this.r(W):await this.n(W);let G={};if(W.excludeObsolete&&W.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(V)}catch{}return(0,y.$Mf)(G)?X:X.filter(V=>!G[d.$Eo.create(V).toString()])}async n(W){const X=await this.j.resolve(W.location);if(!X.children?.length)return[];const G=await Promise.all(X.children.map(async V=>{if(!V.isDirectory||W.type===1&&(0,c.$tg)(V.resource).indexOf(".")===0)return null;const ee=new z(V.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ee)}));return(0,I.$Hb)(G).sort((V,ee)=>V.location.path<ee.location.path?-1:1)}async r(W){let X=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){X=X.filter(V=>!V.metadata?.isApplicationScoped);const G=await this.s(W.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,W);X.push(...G)}return X}async s(W,X,G){const V=await this.g.scanProfileExtensions(W,G.profileScanOptions);if(!V.length)return[];const ee=await Promise.all(V.map(async ie=>{if(X(ie)){const _=new z(ie.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(_,ie.metadata)}return null}));return(0,I.$Hb)(ee)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,c.$wg)(W.location,"package.json"))){const X=await this.scanExtension(W);return X?[X]:[]}else return await this.scanExtensions(W)}catch(X){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,O.$0)(X)),[]}}async scanExtension(W,X){try{let G=await this.scanExtensionManifest(W.location);if(G){G.publisher||(G.publisher=E.$3l),X=X??G.__metadata,delete G.__metadata;const V=(0,d.$Io)(G.publisher,G.name),ee=X?.id?{id:V,uuid:X.id}:{id:V},ie=X?.isSystem?0:W.type,_=ie===0||!!X?.isBuiltin;G=await this.t(W.location,G,z.createNlsConfiguration(W));const ne={type:ie,identifier:ee,manifest:G,location:W.location,isBuiltin:_,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return W.validate?this.validate(ne,W):ne}}catch(G){W.type!==0&&this.m.error(G)}return null}validate(W,X){let G=!0;const V=(0,s.$To)(X.productVersion,X.productDate,X.location,W.manifest,W.isBuiltin);for(const[ee,ie]of V)ee===p.default.Error&&(G=!1,this.m.error(this.z(X.location,ie)));return W.isValid=G,W.validations=V,W}async scanExtensionManifest(W){const X=(0,c.$wg)(W,"package.json");let G;try{G=(await this.j.readFile(X)).value.toString()}catch(ee){return(0,o.$qk)(ee)!==1&&this.m.error(this.z(W,(0,f.localize)(0,null,X.path,ee.message))),null}let V;try{V=JSON.parse(G)}catch{const ie=[];(0,R.$Xm)(G,ie);for(const _ of ie)this.m.error(this.z(W,(0,f.localize)(1,null,X.path,_.offset,_.length,(0,k.$Ap)(_.error))));return null}return(0,R.$7m)(V)!=="object"?(this.m.error(this.z(W,(0,f.localize)(2,null,X.path))),null):V}async t(W,X,G){const V=await this.u(W,X,G);if(V)try{const ee=[],ie=await this.w(V.default,ee);if(ee.length>0)return ee.forEach(ne=>{this.m.error(this.z(W,(0,f.localize)(3,null,V.default?.path,(0,k.$Ap)(ne.error))))}),X;if((0,R.$7m)(V)!=="object")return this.m.error(this.z(W,(0,f.localize)(4,null,V.default?.path))),X;const _=V.values||Object.create(null);return(0,m.$Bp)(this.m,X,_,ie)}catch{}return X}async u(W,X,G){const V=(0,c.$wg)(W,"package.nls.json"),ee=(K,q)=>{q.forEach(P=>{this.m.error(this.z(W,(0,f.localize)(5,null,K?.path,(0,k.$Ap)(P.error))))})},ie=K=>{this.m.error(this.z(W,(0,f.localize)(6,null,K?.path)))},_=`${X.publisher}.${X.name}`,ne=G.translations[_];if(ne)try{const K=h.URI.file(ne),q=(await this.j.readFile(K)).value.toString(),P=[],j=(0,R.$Xm)(q,P);return P.length>0?(ee(K,P),{values:void 0,default:V}):(0,R.$7m)(j)!=="object"?(ie(K),{values:void 0,default:V}):{values:j.contents?j.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let q;try{q=await this.y(W,G)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const P=(await this.j.readFile(q.localized)).value.toString(),j=[],M=(0,R.$Xm)(P,j);return j.length>0?(ee(q.localized,j),{values:void 0,default:q.original}):(0,R.$7m)(M)!=="object"?(ie(q.localized),{values:void 0,default:q.original}):{values:M,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(W,X){if(W)try{const G=(await this.j.readFile(W)).value.toString();return(0,R.$Xm)(G,X)}catch{}}y(W,X){return new Promise((G,V)=>{const ee=ie=>{const _=(0,c.$wg)(W,`package.nls.${ie}.json`);this.j.exists(_).then(ne=>{ne&&G({localized:_,original:(0,c.$wg)(W,"package.nls.json")});const K=ie.lastIndexOf("-");K===-1?G({localized:(0,c.$wg)(W,"package.nls.json"),original:null}):(ie=ie.substring(0,K),ee(ie))})};if(X.devMode||X.pseudo||!X.language)return G({localized:(0,c.$wg)(W,"package.nls.json"),original:null});ee(X.language)})}z(W,X){return`[${W.path}]: ${X}`}};U=ye([Y(1,v.$yp),Y(2,l.$Jk),Y(3,o.$_j),Y(4,i.$$i)],U);let B=class extends U{constructor(W,X,G,V,ee,ie,_){super(X,V,ee,ie,_),this.G=W,this.H=G,this.D=this.B(new N.$Sg(3e3)),this.F=this.B(new r.$Od),this.onDidChangeCache=this.F.event}async scanExtensions(W){const X=this.M(W),G=await this.I(X);if(this.C=W,G&&G.input&&z.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),G.result.map(ee=>(ee.location=h.URI.revive(ee.location),ee));const V=await super.scanExtensions(W);return await this.J(X,{input:W,result:V}),V}async I(W){try{const X=await this.j.readFile(W),G=JSON.parse(X.value.toString());return{result:G.result,input:(0,a.$nh)(G.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",W.path,(0,O.$0)(X))}return null}async J(W,X){try{await this.j.writeFile(W,A.$ce.fromString(JSON.stringify(X)))}catch(G){this.m.debug("Error while writing the extension cache file:",W.path,(0,O.$0)(G))}}async L(){if(!this.C)return;const W=this.M(this.C),X=await this.I(W);if(!X)return;const G=X.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$_m(V,G))try{this.m.info("Invalidating Cache",G,V),await this.j.del(W),this.F.fire()}catch(ee){this.m.error(ee)}}M(W){const X=this.N(W);return this.h.extUri.joinPath(X.cacheHome,W.type===0?E.$2l:E.$1l)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(W.location,X.extensionsResource))??this.G:this.H.defaultProfile}};B=ye([Y(2,w.$Lk),Y(3,v.$yp),Y(4,l.$Jk),Y(5,o.$_j),Y(6,i.$$i)],B);function Z(x,W){const X=(0,d.$Go)(x.manifest.publisher,x.manifest.name);return{id:X,identifier:new E.$7l(X),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:W,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Fp=Z;class Q extends T{constructor(W,X,G,V,ee,ie,_,ne,K,q,P,j){super(W,X,(0,c.$wg)(G,".vscode-oss-dev","extensions","control.json"),V,ee,ie,_,ne,K,q,P,j),this.R=(async()=>{if(b.$z)try{const M=await this.w.readFile(h.URI.file(b.$z));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}f(W){return this.R}}e.$Gp=Q}),define(oe[242],ae([0,1,65,6,38,3,2,23,16,31,8,17]),function(te,e,I,N,L,A,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;let b=class extends O.$Sc{constructor($,p){super(),this.b=$,this.f=p,this.a=new N.$1g(5)}async postUninstall($){const p=this.g($,"uninstall");p&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(y){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(y)}}));try{await g.Promises.rm(this.m($))}catch(y){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(y)}}g($,p){const y=`vscode:${p}`;if($.location.scheme===R.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[y]=="string"){const h=$.manifest.scripts[y].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn($.identifier.id,$.manifest.version,`${y} should be a node script`),null):{script:(0,k.$jc)($.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h($,p,y,h,f){return new Promise((u,d)=>{const E=this.j($,p,y,f);let s;const o=n=>{s&&(clearTimeout(s),s=null),n?d(n):u(void 0)};E.on("error",n=>{o((0,L.$Bi)(n)||"Unknown")}),E.on("exit",(n,i)=>{o(n?`post-${p} process exited with code ${n}`:void 0)}),h&&(s=setTimeout(()=>{s=null,E.kill(),d("timed out")},5e3))})}j($,p,y,h){const f={silent:!0,execArgv:void 0},u=(0,I.fork)($,[`--type=extension-post-${p}`,...y],f);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const d=A.Event.fromNodeEventEmitter(u.stdout,"data"),E=A.Event.fromNodeEventEmitter(u.stderr,"data");d(n=>this.f.info(h.identifier.id,h.manifest.version,`post-${p}`,n)),E(n=>this.f.error(h.identifier.id,h.manifest.version,`post-${p}`,n));const s=A.Event.any(A.Event.map(d,n=>({data:`%c${n}`,format:[""]})),A.Event.map(E,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(s,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(h.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),u}m($){return(0,k.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$Ip=b,e.$Ip=b=ye([Y(0,S.$Lk),Y(1,C.$$i)],b)}),define(oe[243],ae([0,1,8,17,28,22,51,11,14,10]),function(te,e,I,N,L,A,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0;let C=class extends O.$zp{constructor(b,c,$,p,y,h){super(g.URI.file(b.extensionsPath),c,$,p,y,h)}};e.$MN=C,e.$MN=C=ye([Y(0,k.$Yh),Y(1,R.$_j),Y(2,N.$Lk),Y(3,L.$Jk),Y(4,A.$dl),Y(5,I.$$i)],C)}),define(oe[244],ae([0,1,10,14,51,80,11,4,8,25,28,17]),function(te,e,I,N,L,A,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=void 0;let b=class extends A.$Gp{constructor($,p,y,h,f,u,d,E){super(I.URI.file(f.builtinExtensionsPath),I.URI.file(f.extensionsPath),f.userHome,$.defaultProfile,$,p,y,h,f,u,d,E)}};e.$i8b=b,e.$i8b=b=ye([Y(0,S.$Lk),Y(1,L.$yp),Y(2,O.$_j),Y(3,k.$$i),Y(4,N.$Yh),Y(5,g.$qj),Y(6,C.$Jk),Y(7,R.$Ph)],b)}),define(oe[21],ae([0,1,6,3,2,100,12,67,4,17]),function(te,e,I,N,L,A,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$0o=e.$9o=e.$8o=void 0,e.$8o="__$__isNewStorageMarker",e.$9o="__$__targetStorageMarker",e.$0o=(0,k.$Qh)("storageService");var C;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var S;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var b;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function c(f){const u=f.get(e.$9o);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.$$o=c;class $ extends L.$Sc{static{this.a=60*1e3}constructor(u={flushInterval:$.a}){super(),this.m=u,this.b=this.B(new N.$Rd),this.c=this.B(new N.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new I.$7g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(u,d,E){return N.Event.filter(this.b.event,s=>s.scope===u&&(d===void 0||s.key===d),E)}n(){this.j.value=(0,I.$$g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(u,d){const{key:E,external:s}=d;if(E===e.$9o){switch(u){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:E,target:this.J(u)[E],external:s})}w(u){this.f.fire({reason:u})}get(u,d,E){return this.P(d)?.get(u,E)}getBoolean(u,d,E){return this.P(d)?.getBoolean(u,E)}getNumber(u,d,E){return this.P(d)?.getNumber(u,E)}getObject(u,d,E){return this.P(d)?.getObject(u,E)}storeAll(u,d){this.y(()=>{for(const E of u)this.store(E.key,E.value,E.scope,E.target,d)})}store(u,d,E,s,o=!1){if((0,O.$If)(d)){this.remove(u,E,o);return}this.y(()=>{this.z(u,E,s),this.P(E)?.set(u,d,o)})}remove(u,d,E=!1){this.y(()=>{this.z(u,d,void 0),this.P(d)?.delete(u,E)})}y(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,d){const E=[],s=this.J(u);for(const o of Object.keys(s))s[o]===d&&E.push(o);return E}z(u,d,E,s=!1){const o=this.J(d);typeof E=="number"?o[u]!==E&&(o[u]=E,this.P(d)?.set(e.$9o,JSON.stringify(o),s)):typeof o[u]=="number"&&(delete o[u],this.P(d)?.set(e.$9o,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(u){switch(u){case-1:return this.I;case 0:return this.G;default:return this.D}}L(u){const d=this.P(u);return d?c(d):Object.create(null)}isNew(u){return this.getBoolean(e.$8o,u)===!0}async flush(u=C.NONE){this.f.fire({reason:u});const d=this.P(-1),E=this.P(0),s=this.P(1);switch(u){case C.NONE:await I.Promises.settled([d?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await I.Promises.settled([d?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,E=this.P(1)?.items??new Map;return h(u,d,E,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(u){return await this.flush(),this.P(u)?.optimize()}async switch(u,d){return this.w(C.NONE),(0,g.$Kk)(u)?this.R(u,d):this.S(u,d)}M(u,d){return!(u.id===d.id||p(d)&&p(u))}N(u,d,E){this.y(()=>{const s=new Set;for(const[o,n]of u)s.add(o),d.get(o)!==n&&this.u(E,{key:o,external:!0});for(const[o]of d.items)s.has(o)||this.u(E,{key:o,external:!0})})}}e.$_o=$;function p(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$ap=p;class y extends ${constructor(){super(),this.U=this.B(new R.$6o(new R.$7o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$6o(new R.$7o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$6o(new R.$7o,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(u=>this.u(1,u))),this.B(this.W.onDidChangeStorage(u=>this.u(0,u))),this.B(this.U.onDidChangeStorage(u=>this.u(-1,u)))}P(u){switch(u){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(u){return!1}}e.$bp=y;async function h(f,u,d,E,s,o){const n=D=>{try{return JSON.parse(D)}catch{return D}},i=new Map,t=new Map;f.forEach((D,T)=>{i.set(T,D),t.set(T,n(D))});const r=new Map,a=new Map;u.forEach((D,T)=>{r.set(T,D),a.set(T,n(D))});const v=new Map,w=new Map;d.forEach((D,T)=>{v.set(T,D),w.set(T,n(D))}),console.group(E!==s?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const l=[];if(i.forEach((D,T)=>{l.push({key:T,value:D})}),console.table(l),console.groupEnd(),console.log(t),E!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const D=[];r.forEach((T,z)=>{D.push({key:z,value:T})}),console.table(D),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const m=[];v.forEach((D,T)=>{m.push({key:T,value:D})}),console.table(m),console.groupEnd(),console.log(w)}e.$cp=h}),define(oe[113],ae([0,1,3,2,12,29,33,21]),function(te,e,I,N,L,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZCb=e.$YCb=void 0;let k=class extends N.$Sc{constructor(S,b){super(),this.a=new I.$Od,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(S)),this.B(this.b.onDidChange(c=>this.a.fire({extensions:c,source:"storage"}))),this.B(b.onDidInstallExtensions(c=>c.forEach(({local:$,operation:p})=>{$&&p===4&&this.f($.identifier)})))}async enableExtension(S,b){return this.f(S)?(this.a.fire({extensions:[S],source:b}),!0):!1}async disableExtension(S,b){return this.c(S)?(this.a.fire({extensions:[S],source:b}),!0):!1}getDisabledExtensions(){return this.h(A.$eo)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const b=this.getDisabledExtensions();return b.every(c=>!(0,O.$Do)(c,S))?(b.push(S),this.g(b),!0):!1}f(S){const b=this.getDisabledExtensions();for(let c=0;c<b.length;c++){const $=b[c];if((0,O.$Do)($,S))return b.splice(c,1),this.g(b),!0}return!1}g(S){this.j(A.$eo,S)}h(S){return this.b.get(S,0)}j(S,b){this.b.set(S,b,0)}};e.$YCb=k,e.$YCb=k=ye([Y(0,R.$0o),Y(1,A.$do)],k);class g extends N.$Sc{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.B(new I.$Od),this.onDidChange=this.b.event,this.B(S.onDidChangeValue(0,void 0,this.B(new N.$Rc))(b=>this.f(b)))}get(S,b){let c;return b===0?((0,L.$If)(this.a[S])&&(this.a[S]=this.g(S,b)),c=this.a[S]):c=this.g(S,b),JSON.parse(c)}set(S,b,c){const $=JSON.stringify(b.map(({id:y,uuid:h})=>({id:y,uuid:h})));this.g(S,c)!==$&&(c===0&&(b.length?this.a[S]=$:delete this.a[S]),this.h(S,b.length?$:void 0,c))}f(S){if(!(0,L.$If)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const c=this.get(S.key,S.scope);delete this.a[S.key];const $=this.get(S.key,S.scope),p=c.filter(h=>!$.some(f=>(0,O.$Do)(h,f))),y=$.filter(h=>!c.some(f=>(0,O.$Do)(f,h)));(p.length||y.length)&&this.b.fire([...p,...y])}}g(S,b){return this.c.get(S,b,"[]")}h(S,b,c){b?this.c.store(S,b,c,1):this.c.remove(S,c)}}e.$ZCb=g}),define(oe[245],ae([0,1,18,26,7,5,37,12,10,20,14,29,33,68,11,8,25,57,223,21,22,61]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=e.$gp=e.$fp=void 0;const s=A.$p?"web":(0,S.$0n)(A.$u,O.$ec),o="X-Market-Search-Activity-Id";var n;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function i(...P){return String(P.reduce((j,M)=>j|M,0))}var t;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class l{constructor(j=w){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,M=this.d.pageSize){return new l({...this.d,pageNumber:j,pageSize:M})}withFilter(j,...M){const F=[...this.d.criteria,...M.length?M.map(H=>({filterType:j,value:H})):[{filterType:j}]];return new l({...this.d,criteria:F})}withSortBy(j){return new l({...this.d,sortBy:j})}withSortOrder(j){return new l({...this.d,sortOrder:j})}withFlags(...j){return new l({...this.d,flags:j.reduce((M,F)=>M|F,0)})}withAssetTypes(...j){return new l({...this.d,assetTypes:j})}withSource(j){return new l({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:M,pageSize:F,sortBy:H,sortOrder:J,flags:re,assetTypes:ce}=this.d;return{filters:[{criteria:j,pageNumber:M,pageSize:F,sortBy:H,sortOrder:J}],assetTypes:ce,flags:re}}get searchText(){const j=this.d.criteria.filter(M=>M.filterType===t.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function m(P,j){const M=(P||[]).filter(F=>F.statisticName===j)[0];return M?M.value:0}function D(P){const j="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(F=>F.assetType.indexOf(j)===0).reduce((F,H)=>{const J=U(P,H.assetType);return J&&F.push([H.assetType.substring(j.length),J]),F},[])}function T(P){if(P.properties){const j=P.properties.filter(H=>H.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=j.filter(H=>M.test(H.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return U(P,r.Repository)}function z(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function U(P,j){return P.files.filter(F=>F.assetType===j)[0]?{uri:`${P.assetUri}/${j}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${j}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function B(P,j){const M=P.properties?P.properties.filter(H=>H.key===j):[],F=M.length>0&&M[0].value;return F?F.split(",").map(H=>(0,b.$Ho)(H)):[]}function Z(P){const j=P.properties?P.properties.filter(M=>M.key===a.Engine):[];return j.length>0&&j[0].value||""}function Q(P){const j=P.properties?P.properties.filter(M=>M.key===a.PreRelease):[];return j.length>0&&j[0].value==="true"}function x(P){const j=P.properties?P.properties.filter(F=>F.key===a.LocalizedLanguages):[],M=j.length>0&&j[0].value||"";return M?M.split(","):[]}function W(P){return P.properties?.find(j=>j.key===a.SponsorLink)?.value}function X(P){return P.indexOf("preview")!==-1}function G(P){return P.targetPlatform?(0,S.$9n)(P.targetPlatform):"undefined"}function V(P){const j=(0,I.$Mb)(P.versions.map(G)),M=!!P.tags?.includes(S.$4n),F=j.indexOf("web");return M?F===-1&&j.push("web"):F!==-1&&j.splice(F,1),j}function ee(P,j){for(let M=0;M<P.length;M++){const F=P[M];if(F.version===P[M-1]?.version){let H=M;if(G(F)===j)for(;H>0&&P[H-1].version===F.version;)H--;H!==M&&(P.splice(M,1),P.splice(H,0,F))}}return P}e.$fp=ee;function ie(P,j,M){P.telemetryData={index:j,querySource:M,queryActivityId:P.queryContext?.[o]}}function _(P,j,M,F){const H=P.versions[0],J={manifest:U(j,r.Manifest),readme:U(j,r.Details),changelog:U(j,r.Changelog),license:U(j,r.License),repository:T(j),download:z(j),icon:U(j,r.Icon),signature:U(j,r.Signature),coreTranslations:D(j)};return{identifier:{id:(0,b.$Io)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:j.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(H),description:P.shortDescription||"",installCount:m(P.statistics,"install"),rating:m(P.statistics,"averagerating"),ratingCount:m(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:M,assets:J,properties:{dependencies:B(j,a.Dependency),extensionPack:B(j,a.ExtensionPack),engine:Z(j),localizedLanguages:x(j),targetPlatform:G(j),isPreReleaseVersion:Q(j)},hasPreReleaseVersion:Q(H),hasReleaseVersion:!0,preview:X(P.flags),isSigned:!!J.signature,queryContext:F}}let ne=class{constructor(j,M,F,H,J,re,ce,ue){this.k=M,this.l=F,this.n=H,this.o=J,this.q=re,this.u=ce,this.w=ue;const he=ce.extensionsGallery,$e=he?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=$e?he.servicePPEUrl:he?.serviceUrl,this.g=$e?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,f.$ep)(ce.version,ce,this.n,this.w,this.q,j,this.o)}x(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,M,F){const H=N.CancellationToken.isCancellationToken(M)?{}:M,J=N.CancellationToken.isCancellationToken(M)?M:F,re=[],ce=[],ue=[],he=[];let $e=!0;for(const ve of j){ve.uuid?ce.push(ve.uuid):re.push(ve.id);const Oe=!!(ve.version||ve.preRelease);ue.push({id:ve.id,uuid:ve.uuid,includePreRelease:Oe}),ve.version&&he.push({id:ve.id,uuid:ve.uuid,version:ve.version}),$e=$e&&!!ve.hasPreRelease&&!Oe}if(!ce.length&&!re.length)return[];let de=new l().withPage(1,j.length);ce.length&&(de=de.withFilter(t.ExtensionId,...ce)),re.length&&(de=de.withFilter(t.ExtensionName,...re)),(H.queryAllVersions||$e)&&(de=de.withFlags(de.flags,n.IncludeVersions)),H.source&&(de=de.withSource(H.source));const{extensions:we}=await this.z(de,{targetPlatform:H.targetPlatform??s,includePreRelease:ue,versions:he,compatible:!!H.compatible},J);return H.source&&we.forEach((ve,Oe)=>ie(ve,Oe,H.source)),we}async getCompatibleExtension(j,M,F){if((0,S.$$n)(j.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(j,M,F))return j;const H=new l().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,j.identifier.uuid),{extensions:J}=await this.z(H,{targetPlatform:F,compatible:!0,includePreRelease:M},N.CancellationToken.None);return J[0]||null}async isExtensionCompatible(j,M,F){if(!(0,S.$_n)(j.properties.targetPlatform,j.allTargetPlatforms,F)||!M&&j.properties.isPreReleaseVersion)return!1;let H=j.properties.engine;if(!H){const J=await this.getManifest(j,N.CancellationToken.None);if(!J)throw new Error("Manifest was not found");H=J.engines.vscode}return(0,c.$Vo)(H,this.u.version,this.u.date)}async y(j,M,F,H,J){if(!(0,S.$_n)(G(j),H,J)||M!=="any"&&Q(j)!==(M==="prerelease"))return!1;if(F)try{const re=await this.E(j);if(!(0,c.$Vo)(re,this.u.version,this.u.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${j.version}.`,(0,L.$0)(re)),!1}return!0}async query(j,M){let F=j.text||"";const H=j.pageSize??50;let J=new l().withPage(1,H);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(J=J.withFilter(t.Category,we||de),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(J=J.withFilter(t.Tag,we||de),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(t.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),J=J.withFilter(t.SearchText,F)),J=J.withSortBy(0)):j.ids?J=J.withFilter(t.ExtensionId,...j.ids):j.names?J=J.withFilter(t.ExtensionName,...j.names):J=J.withSortBy(4),typeof j.sortBy=="number"&&(J=J.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(J=J.withSortOrder(j.sortOrder)),j.source&&(J=J.withSource(j.source));const re=async($e,de)=>{const{extensions:we,total:ve}=await this.z($e,{targetPlatform:s,compatible:!1,includePreRelease:!!j.includePreRelease},de);return we.forEach((Oe,Ne)=>ie(Oe,($e.pageNumber-1)*$e.pageSize+Ne,j.source)),{extensions:we,total:ve}},{extensions:ce,total:ue}=await re(J,M),he=async($e,de)=>{if(de.isCancellationRequested)throw new L.$5;const{extensions:we}=await re(J.withPage($e+1),de);return we};return{firstPage:ce,total:ue,pageSize:J.pageSize,getPage:he}}async z(j,M,F){const H=j.flags;j.flags&n.IncludeLatestVersionOnly&&j.flags&n.IncludeVersions&&(j=j.withFlags(j.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(j.flags&n.IncludeLatestVersionOnly)&&!(j.flags&n.IncludeVersions)&&(j=j.withFlags(j.flags,n.IncludeLatestVersionOnly)),M.versions?.length&&(j=j.withFlags(j.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),j=j.withFlags(j.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:J,total:re,context:ce}=await this.B(j,F);if(!(j.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of J){const ve=await this.A(we,M,ce);ve&&de.push(ve)}return{extensions:de,total:re}}const he=[],$e=new Map;for(let de=0;de<J.length;de++){const we=J[de],ve={id:(0,b.$Io)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Oe=(0,R.$Ff)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Me=>(0,b.$Do)(Me,ve))?.includePreRelease;if(M.compatible&&(0,S.$$n)(V(we),M.targetPlatform))continue;const Ne=await this.A(we,M,ce);!Ne||Ne.properties.isPreReleaseVersion&&(!Oe||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==M.targetPlatform&&Ne.hasPreReleaseVersion?$e.set(we.extensionId,de):he.push([de,Ne])}if($e.size){const de=new E.$Kd,we=new l().withFlags(H&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,$e.size).withFilter(t.ExtensionId,...$e.keys()),{extensions:ve}=await this.z(we,M,F);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const Oe of ve){const Ne=$e.get(Oe.identifier.uuid);he.push([Ne,Oe])}}return{extensions:he.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:re}}async A(j,M,F){const H={id:(0,b.$Io)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},J=M.versions?.find(he=>(0,b.$Do)(he,H))?.version,re=(0,R.$Ff)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(he=>(0,b.$Do)(he,H))?.includePreRelease,ce=V(j),ue=ee(j.versions,M.targetPlatform);if(M.compatible&&(0,S.$$n)(ce,M.targetPlatform))return null;for(let he=0;he<ue.length;he++){const $e=ue[he];if(!(J&&$e.version!==J)){if(await this.y($e,re?"any":"release",M.compatible,ce,M.targetPlatform))return _(j,$e,ce,F);if(J&&$e.version===J)return null}}return J||M.compatible?null:_(j,j.versions[0],ce)}async B(j,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(n.Unpublished));const F=await this.j,H=JSON.stringify(j.raw),J={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},re=new E.$Kd;let ce,ue,he=0;try{if(ce=await this.k.request({type:"POST",url:this.g&&j.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:H,headers:J},M),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:he};const $e=await(0,h.$3o)(ce);if($e){const de=$e.results[0],we=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return he=ve&&ve.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:he,context:{[o]:ce.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch($e){throw ue=$e,$e}finally{this.o.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(H.length),duration:re.elapsed(),success:!!ce&&(0,h.$Yo)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:ue?(0,L.$4)(ue)?"canceled":(0,L.$0)(ue).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(j,M,F,H){if(!this.isEnabled())return;const J=A.$p?this.x(`/itemName/${j}.${M}/version/${F}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${j}/extensions/${M}/${F}/stats?statType=${H}`),re=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:re};try{await this.k.request({type:"POST",url:J,headers:ue},N.CancellationToken.None)}catch{}}async download(j,M,F){this.l.trace("ExtensionGalleryService#download",j.identifier.id);const H=(0,b.$Lo)(j),J=new Date().getTime(),re=de=>this.o.publicLog("galleryService:downloadVSIX",{...H,duration:de}),ce=F===2?"install":F===3?"update":"",ue=ce?{uri:`${j.assets.download.uri}${k.URI.parse(j.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${j.assets.download.fallbackUri}${k.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:j.assets.download,he=j.queryContext?.[o]?{[o]:j.queryContext[o]}:void 0,$e=await this.D(ue,he?{headers:he}:void 0);await this.q.writeFile(M,$e.stream),re(new Date().getTime()-J)}async downloadSignatureArchive(j,M){if(!j.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const F=await this.D(j.assets.signature);await this.q.writeFile(M,F.stream)}async getReadme(j,M){if(j.assets.readme){const F=await this.D(j.assets.readme,{},M);return await(0,h.$2o)(F)||""}return""}async getManifest(j,M){if(j.assets.manifest){const F=await this.D(j.assets.manifest,{},M),H=await(0,h.$2o)(F);return H?JSON.parse(H):null}return null}async C(j,M){const F=U(j,r.Manifest);if(!F)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},J=await this.D(F,{headers:H});return await(0,h.$3o)(J)}async getCoreTranslation(j,M){const F=j.assets.coreTranslations.filter(H=>H[0]===M.toUpperCase())[0];if(F){const H=await this.D(F[1]),J=await(0,h.$2o)(H);return J?JSON.parse(J):null}return null}async getChangelog(j,M){if(j.assets.changelog){const F=await this.D(j.assets.changelog,{},M);return await(0,h.$2o)(F)||""}return""}async getAllCompatibleVersions(j,M,F){let H=new l().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?H=H.withFilter(t.ExtensionId,j.identifier.uuid):H=H.withFilter(t.ExtensionName,j.identifier.id);const{galleryExtensions:J}=await this.B(H,N.CancellationToken.None);if(!J.length)return[];const re=V(J[0]);if((0,S.$$n)(re,F))return[];const ce=[];await Promise.all(J[0].versions.map(async $e=>{try{await this.y($e,M?"any":"release",!0,re,F)&&ce.push($e)}catch{}}));const ue=[],he=new Set;for(const $e of ee(ce,F))he.has($e.version)||(he.add($e.version),ue.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:Q($e)}));return ue}async D(j,M={},F=N.CancellationToken.None){const H=await this.j,J={type:"GET"},re={...H,...M.headers||{}};M={...M,...J,headers:re};const ce=j.uri,ue=j.fallbackUri,he={...M,url:ce};try{const $e=await this.k.request(he,F);if($e.res.statusCode===200)return $e;const de=await(0,h.$2o)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,L.$4)($e))throw $e;const de=(0,L.$0)($e);this.o.publicLog2("galleryService:cdnFallback",{url:ce,message:de});const we={...M,url:ue};return this.k.request(we,F)}}async E(j){let M=Z(j);if(!M){const F=await this.C(j,N.CancellationToken.None);if(!F)throw new Error("Manifest was not found");M=F.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,h.$3o)(j),F=[],H={},J=[];if(M){for(const re of M.malicious)F.push({id:re});if(M.migrateToPreRelease)for(const[re,ce]of Object.entries(M.migrateToPreRelease))(!ce.engine||(0,c.$Vo)(ce.engine,this.u.version,this.u.date))&&(H[re.toLowerCase()]={disallowInstall:!0,extension:{id:ce.id,displayName:ce.displayName,autoMigrate:{storage:!!ce.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[re,ce]of Object.entries(M.deprecated))ce&&(H[re.toLowerCase()]=(0,R.$Ff)(ce)?{}:ce);if(M.search)for(const re of M.search)J.push(re)}return{malicious:F,deprecated:H,search:J}}};ne=ye([Y(1,h.$Wo),Y(2,p.$$i),Y(3,C.$Xh),Y(4,d.$dl),Y(5,$.$_j),Y(6,y.$qj),Y(7,g.$ki)],ne);let K=class extends ne{constructor(j,M,F,H,J,re,ce,ue){super(j,M,F,H,J,re,ce,ue)}};e.$gp=K,e.$gp=K=ye([Y(0,u.$0o),Y(1,h.$Wo),Y(2,p.$$i),Y(3,C.$Xh),Y(4,d.$dl),Y(5,$.$_j),Y(6,y.$qj),Y(7,g.$ki)],K);let q=class extends ne{constructor(j,M,F,H,J,re,ce){super(void 0,j,M,F,H,J,re,ce)}};e.$hp=q,e.$hp=q=ye([Y(0,h.$Wo),Y(1,p.$$i),Y(2,C.$Xh),Y(3,d.$dl),Y(4,$.$_j),Y(5,y.$qj),Y(6,g.$ki)],q)}),define(oe[81],ae([0,1,4,3,2,21,33,25,18,8,12]),function(te,e,I,N,L,A,O,R,k,g,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=void 0,e.$1u=(0,I.$Qh)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends L.$Sc{static{S=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,O.$Ho)(p.id)}@${p.version}`}static c(p){const y=b.exec(p);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(p,y){const h=await p.getInstalled(),f=[];for(const[u,d]of S.f(y)){const E=h.find(s=>(0,O.$Do)(s.identifier,{id:u}))?.manifest.version;for(const s of d)E!==s&&f.push(S.b({id:u,version:s}))}for(const u of f)y.remove(u,0)}static f(p){const y=new Map,h=p.keys(0,1);for(const f of h){const u=S.c(f);if(u){let d=y.get(u.id.toLowerCase());d||y.set(u.id.toLowerCase(),d=[]),d.push(u.version)}}return y}constructor(p,y,h){super(),this.j=p,this.m=y,this.n=h,this.g=this.B(new N.$Od),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=S.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Rc))(f=>this.r(f)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const y=S.c(p.key);if(y){if(this.j.get(p.key,0)===void 0)this.h.delete(y.id.toLowerCase());else{let h=this.h.get(y.id.toLowerCase());h||this.h.set(y.id.toLowerCase(),h=[]),h.push(y.version),this.g.fire()}return}}s(p){if((0,C.$zf)(p))return p;const y=p.manifest?p.manifest.publisher:p.publisher,h=p.manifest?p.manifest.name:p.name;return(0,O.$Go)(y,h)}getExtensionState(p,y){const h=this.s(p),f=this.getExtensionStateRaw(p,y);if(f)try{return JSON.parse(f)}catch(u){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${y}): ${u}`)}}getExtensionStateRaw(p,y){const h=this.s(p),f=this.j.get(h,y?0:1);return f&&f?.length>S.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${y}): ${f.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),f}setExtensionState(p,y,h){const f=this.s(p);y===void 0?this.j.remove(f,h?0:1):this.j.store(f,JSON.stringify(y),h?0:1,1)}setKeysForSync(p,y){this.j.store(S.b(p),JSON.stringify(y),0,1)}getKeysForSync(p){const y=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],h=this.j.get(S.b(p),0),f=h?JSON.parse(h):void 0;return f&&y?(0,k.$Mb)([...f,...y]):f||y}addToMigrationList(p,y){if(p!==y){const h=this.t.filter(f=>!f.includes(p)&&!f.includes(y));h.push([p,y]),this.t=h}}getSourceExtensionToMigrate(p){const y=this.t.find(([,h])=>p===h);return y?y[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(p);if(Array.isArray(y))return y}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$2u=c,e.$2u=c=S=ye([Y(0,A.$0o),Y(1,R.$qj),Y(2,g.$$i)],c)}),define(oe[246],ae([0,1,29,11,25,14,98,55,21,22,220]),function(te,e,I,N,L,A,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=void 0;let S=class extends C.$S5b{constructor(c,$,p,y,h,f,u,d){super(c.userHome,h,$,p,y,f,u,d)}};e.$G9b=S,e.$G9b=S=ye([Y(0,A.$Yh),Y(1,g.$dl),Y(2,I.$do),Y(3,k.$0o),Y(4,R.$w7b),Y(5,O.$$Vb),Y(6,N.$_j),Y(7,L.$qj)],S)}),define(oe[247],ae([0,1,105,3,22,14,2,8,16,65,25,5,6,101,20,164,36,21,12,131,19]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C9b=void 0;const E=[I.$v9b,I.$w9b],s="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends O.$Sc{constructor(a,v,w,l,m,D,T){super(),this.y=a,this.z=v,this.C=w,this.D=D,this.F=T,this.f=new N.$Od,this.onDidTokenFailed=this.f.event,this.g=new N.$Od,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$Od,this.onDidChangeMode=this.h.event,this.n=I.$t9b,this.w=!1,this.I=(z,U)=>{U?this.j.error(z):this.j.info(z)},this.j=this.B(l.createLogger((0,d.$wg)(w.logsHome,`${I.$x9b}.log`),{id:I.$x9b,name:I.$y9b})),this.t=new b.$Rg(100),this.B(this.j.onDidChangeLogLevel(z=>this.j.info("Log level changed to "+(0,R.$nj)(z)))),this.B(m.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(D.onDidChangeConfiguration(z=>{E.some(U=>z.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;S.$k?a=this.C.appRoot:a=(0,k.$mc)((0,k.$mc)(this.C.appRoot)),this.u=(0,k.$jc)(a,"bin",`${this.z.tunnelApplicationName}${S.$j?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const a=this.n.asService;this.H(I.$t9b);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const w=(U,B)=>{B?this.j.error(U):a+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,p.localize)(0,null)))},l=this.O("status",["status"],w);this.r=l;try{if(await l,this.r!==l)return;const U=JSON.parse(a.trim().split(`
`).find(B=>B.startsWith("{")));if(v=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(I.TunnelStates.disconnected());return}finally{this.r===l&&(this.r=void 0)}const m=this.n.active?this.n.session:void 0;if(m&&m.token){const U=m.token;this.G(I.TunnelStates.connecting((0,p.localize)(1,null,m.accountLabel,m.providerId)));const B=(Q,x)=>{Q=Q.replaceAll(U,"*".repeat(4)),w(Q,x)},Z=this.O("login",["user","login","--provider",m.providerId,"--access-token",U,"--log",(0,R.$nj)(this.j.getLevel())],B);this.r=Z;try{if(await Z,this.r!==Z)return}catch(Q){this.j.error(Q),this.r=void 0,this.f.fire(m),this.G(I.TunnelStates.disconnected(m));return}}const D=this.Q();D?this.G(I.TunnelStates.connecting((0,p.localize)(2,null,D))):this.G(I.TunnelStates.connecting((0,p.localize)(3,null)));const T=["--accept-server-license-terms","--log",(0,R.$nj)(this.j.getLevel())];D?T.push("--name",D):T.push("--random-name");let z=!1;return this.n.active&&this.n.asService&&!v&&(z=await this.M(T)===!1),this.N(m,T,z)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(w){this.j.error(w),v=1}if(v!==0){const w=(0,p.localize)(4,null);return this.j.warn(w),this.G(I.TunnelStates.connecting(w)),!1}return!0}async N(a,v,w){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let l=!1;const m=this.O("tunnel",v,(D,T)=>{T?this.j.error(D):this.j.info(D),D.includes("Connected to an existing tunnel process")&&(l=!0);const z=D.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(z){const U={link:z[1],domain:z[2],tunnelName:z[4],isAttached:l};this.G(I.TunnelStates.connected(U,w))}else D.match(/error refreshing token/)&&(m.cancel(),this.f.fire(a),this.G(I.TunnelStates.disconnected(a)))});this.r=m,m.finally(()=>{m===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$t9b,this.G(I.TunnelStates.disconnected()))})}O(a,v,w=this.I){return(0,b.$Ig)(l=>new Promise((m,D)=>{l.isCancellationRequested&&m(-1);let T;const z=["ignore","pipe","pipe"];if(l.onCancellationRequested(()=>{T&&(this.j.info(`${a} terminating(${T.pid})`),T.kill())}),!this.C.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),T=(0,g.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,k.$jc)(this.C.appRoot,"cli"),stdio:z});else{w(`Running tunnel CLI
`,!1);const U=this.J();w(`${a} Spawning: ${U} tunnel ${v.join(" ")}
`,!1),T=(0,g.spawn)(U,["tunnel",...v],{cwd:(0,y.homedir)(),stdio:z})}T.stdout.pipe(new u.$sT(`
`)).on("data",U=>{if(T){const B=U.toString();w(B,!1)}}),T.stderr.pipe(new u.$sT(`
`)).on("data",U=>{if(T){const B=U.toString();w(B,!0)}}),T.on("exit",U=>{T&&(w(`${a} exit(${T.pid}): + ${U} `,!1),T=void 0,m(U||0))}),T.on("error",U=>{T&&(w(`${a} error(${T.pid}): + ${U} `,!0),T=void 0,D())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$w9b)}Q(){let a=this.D.getValue(I.$v9b)||(0,y.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(s,-1),v=this.F.getBoolean(o,-1,!1);if(a){const w=JSON.parse(a);if(w&&(0,f.$zf)(w.accountLabel)&&(0,f.$zf)(w.sessionId)&&(0,f.$zf)(w.providerId))return{active:!0,session:w,asService:v};this.j.error("Problems restoring session from storage, invalid format",w)}}catch(a){this.j.error("Problems restoring session from storage",a)}return I.$t9b}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(s,JSON.stringify(v),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(s,-1),this.F.remove(o,-1)}};e.$C9b=n,e.$C9b=n=ye([Y(0,L.$dl),Y(1,C.$qj),Y(2,A.$Yh),Y(3,R.$_i),Y(4,c.$A9b),Y(5,$.$ki),Y(6,h.$0o)],n);function i(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&i(r.session,a.session):!0}),define(oe[248],ae([0,1,6,2,23,19,67,21,76,17]),function(te,e,I,N,L,A,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H9b=void 0;class C extends R.$_o{constructor(b,c,$,p){super(),this.bb=b,this.cb=c,this.db=$,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Rc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Rc),this.ab=this.hb(this.bb)}fb(){const b=this.B(new k.$wDb(this.db.getChannel("storage"))),c=this.B(new O.$6o(b));return this.B(c.onDidChangeStorage($=>this.u(-1,$))),c}gb(b){this.X.clear(),this.W=b;let c;if((0,R.$ap)(b))c=this.U;else{const $=this.X.add(new k.$xDb(this.db.getChannel("storage"),b));c=this.X.add(new O.$6o($))}return this.X.add(c.onDidChangeStorage($=>this.u(0,$))),c}hb(b){this.$.clear(),this.Z=b?.id;let c;if(b){const $=this.$.add(new k.$yDb(this.db.getChannel("storage"),b));c=this.$.add(new O.$6o($)),this.$.add(c.onDidChangeStorage(p=>this.u(1,p)))}return c}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(b){switch(b){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(b){switch(b){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$wg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(b){if(!this.M(this.W,b))return;const c=this.Y,$=c.items;c!==this.U&&await c.close(),this.Y=this.gb(b),await this.Y.init(),this.N($,this.Y,0)}async S(b,c){const $=this.ab,p=$?.items??new Map;await $?.close(),this.ab=this.hb(b),await this.ab.init(),this.N(p,this.ab,1)}hasScope(b){return(0,g.$Kk)(b)?this.W.id===b.id:this.Z===b.id}}e.$H9b=C}),define(oe[249],ae([0,1,3,2,17,92]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.$TN=void 0;class O{constructor(g,C){this.a=g,this.b=C}listen(g,C){const S=this.b(g);switch(C){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(c=>(0,A.$Om)({...c},S)),added:b.added.map(c=>(0,A.$Om)({...c},S)),removed:b.removed.map(c=>(0,A.$Om)({...c},S)),updated:b.updated.map(c=>(0,A.$Om)({...c},S))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,S){const b=this.b(g);switch(C){case"createProfile":{const c=await this.a.createProfile(S[0],S[1],S[2]);return(0,A.$Om)({...c},b)}case"updateProfile":{let c=(0,L.$Mk)((0,A.$Pm)(S[0],b),this.a.profilesHome.scheme);return c=await this.a.updateProfile(c,S[1]),(0,A.$Om)({...c},b)}case"removeProfile":{const c=(0,L.$Mk)((0,A.$Pm)(S[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(c)}}throw new Error(`Invalid call ${C}`)}}e.$TN=O;class R extends N.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,S){super(),this.profilesHome=C,this.f=S,this.a=[],this.b=this.B(new I.$Od),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(b=>(0,L.$Mk)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const c=b.added.map(y=>(0,L.$Mk)(y,this.profilesHome.scheme)),$=b.removed.map(y=>(0,L.$Mk)(y,this.profilesHome.scheme)),p=b.updated.map(y=>(0,L.$Mk)(y,this.profilesHome.scheme));this.a=b.all.map(y=>(0,L.$Mk)(y,this.profilesHome.scheme)),this.b.fire({added:c,removed:$,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,S){const b=await this.f.call("createNamedProfile",[g,C,S]);return(0,L.$Mk)(b,this.profilesHome.scheme)}async createProfile(g,C,S,b){const c=await this.f.call("createProfile",[g,C,S,b]);return(0,L.$Mk)(c,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,L.$Mk)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const S=await this.f.call("updateProfile",[g,C]);return(0,L.$Mk)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$UN=R}),define(oe[58],ae([0,1,2,67,4,21,3,76,17]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CDb=e.$BDb=e.$ADb=void 0,e.$ADb=(0,L.$Qh)("IUserDataProfileStorageService");let g=class extends I.$Sc{constructor(c){super(),this.a=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async $=>this.b($))}async updateStorageData(c,$,p){return this.withProfileScopedStorageService(c,async y=>this.c(y,$,p))}async withProfileScopedStorageService(c,$){if(this.a.hasScope(c))return $(this.a);const p=await this.g(c),y=new S(p);try{await y.initialize();const h=await $(y);return await y.flush(),h}finally{y.dispose(),await this.f(p)}}b(c){const $=new Map,p=y=>{for(const h of c.keys(0,y))$.set(h,{value:c.get(h,0),target:y})};return p(0),p(1),$}c(c,$,p){c.storeAll(Array.from($.entries()).map(([y,h])=>({key:y,value:h,scope:0,target:p})),!0)}async f(c){try{await c.close()}finally{(0,I.$Mc)(c)&&c.dispose()}}};e.$BDb=g,e.$BDb=g=ye([Y(0,A.$0o)],g);class C extends g{constructor(c,$,p,y){super(p),this.j=c;const h=c.getChannel("profileStorageListener"),f=this.B(new I.$Tc);this.h=this.B(new O.$Od({onWillAddFirstListener:()=>{f.value=h.listen("onDidChange")(u=>{y.trace("profile storage changes",u),this.h.fire({targetChanges:u.targetChanges.map(d=>(0,k.$Mk)(d,$.profilesHome.scheme)),valueChanges:u.valueChanges.map(d=>({...d,profile:(0,k.$Mk)(d.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>f.value=void 0})),this.onDidChange=this.h.event}async g(c){const $=this.j.getChannel("storage");return(0,A.$ap)(c)?new R.$wDb($):new R.$xDb($,c)}}e.$CDb=C;class S extends A.$_o{constructor(c){super({flushInterval:100}),this.s=this.B(new N.$6o(c))}O(){return this.s.init()}P(c){return c===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(oe[250],ae([0,1,21,8,17,72,58]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m9b=void 0;let R=class extends O.$CDb{constructor(g,C,S,b){super(g,C,S,b)}};e.$m9b=R,e.$m9b=R=ye([Y(0,A.$K8b),Y(1,L.$Lk),Y(2,I.$0o),Y(3,N.$$i)],R)}),define(oe[39],ae([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uEb=e.$tEb=e.$sEb=e.$rEb=e.$qEb=e.$pEb=e.$oEb=void 0;function s(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||o(v.syncData)))}e.$oEb=s;function o(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$pEb=o;function n(v,w){return`${(0,g.$rf)(v)}${w.isDefault?"":` (${w.name})`}`}e.$qEb=n;let i=class extends k.$Sc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(w,l,m,D,T,z,U,B,Z,Q,x,W){super(),this.syncResource=w,this.collection=l,this.G=m,this.H=D,this.I=T,this.J=z,this.L=U,this.M=B,this.N=Z,this.O=Q,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$Od),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$Od),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$Sg(50)),this.w=this.B(new O.$Od),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(w.syncResource,w.profile),this.h=W.extUri,this.f=this.h.joinPath(D.userDataSyncHome,...(0,d.$Rgb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,d.$ahb),this.y=(0,d.$Sgb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,D,this.h),this.j=(0,y.$dp)(D,m,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const l=await this.Y(w.remoteUserData,w.lastSyncUserData,!0,this.ob());this.S(l)}else{this.O.trace(`${this.D}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.ub(w):!0)&&this.w.fire()}}S(w){this.m!==w&&(this.m=w,this.n.fire(w))}async sync(w,l={}){await this.U(w,!0,this.ob(),l)}async preview(w,l,m={}){return this.U(w,!1,l,m)}async apply(w,l={}){try{this.F={...l};const m=await this.ab(w);return this.S(m),this.c}finally{this.F={}}}async U(w,l,m,D){try{if(this.F={...D},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let T="idle";try{const z=await this.getLastSyncUserData(),U=await this.X(w,z);return T=await this.Y(U,z,l,m),T==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace(w){const l=this.kb(w);if(!l)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const m=await this.getLastSyncUserData(),D=await this.X(null,m),T=await this.W(D),z=await this.qb({ref:D.ref,syncData:l},m,T,this.ob(),A.CancellationToken.None),U=[];for(const B of z){const Z=await this.sb(B,B.remoteResource,void 0,A.CancellationToken.None),{remoteChange:Q}=await this.sb(B,B.previewResource,B.remoteContent,A.CancellationToken.None);U.push([B,{...Z,remoteChange:Q!==0?Q:2}])}await this.tb(D,m,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(w){const l=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===l}async X(w,l){if(l){const m=w?w[this.resource]:void 0;if(l.ref===m||m===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async Y(w,l,m,D){if(w.syncData&&w.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new d.$Zgb((0,S.localize)(0,null,this.resource,this.pb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(w,l,m,D)}catch(T){if(T instanceof d.$Zgb)switch(T.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(w,l,m,D);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.Y(w,l,m,D)}throw T}}async Z(w,l,m,D){try{const T=await this.W(w),z=!T&&l===null&&this.gb()!==void 0,U=m&&!z;this.c||(this.c=(0,N.$Ig)(Z=>this.eb(w,l,T,U,D,Z)));let B=await this.c;if(m&&z){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of B.resourcePreviews)B=await this.accept(Z.remoteResource)||B}return this.cb(B.resourcePreviews),B.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":m?await this.ab(!1):"syncing"}catch(T){throw this.c=null,T}}async merge(w){return await this.$(w,async l=>{const m=await this.rb(l,A.CancellationToken.None);await this.G.writeFile(l.previewResource,L.$ce.fromString(m?.content||""));const D=m&&!m.hasConflicts?await this.sb(l,l.previewResource,void 0,A.CancellationToken.None):void 0;return l.acceptResult=D,l.mergeState=m.hasConflicts?"conflict":D?"accepted":"preview",l.localChange=D?D.localChange:m.localChange,l.remoteChange=D?D.remoteChange:m.remoteChange,l}),this.c}async accept(w,l){return await this.$(w,async m=>{const D=await this.sb(m,w,l,A.CancellationToken.None);return m.acceptResult=D,m.mergeState="accepted",m.localChange=D.localChange,m.remoteChange=D.remoteChange,m}),this.c}async discard(w){return await this.$(w,async l=>{const m=await this.rb(l,A.CancellationToken.None);return await this.G.writeFile(l.previewResource,L.$ce.fromString(m.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=m.localChange,l.remoteChange=m.remoteChange,l}),this.c}async $(w,l){if(!this.c)return;let m=await this.c;const D=m.resourcePreviews.findIndex(({localResource:T,remoteResource:z,previewResource:U})=>this.h.isEqual(T,w)||this.h.isEqual(z,w)||this.h.isEqual(U,w));D!==-1&&(this.c=(0,N.$Ig)(async T=>{const z=[...m.resourcePreviews];return z[D]=await l(z[D]),{...m,resourcePreviews:z}}),m=await this.c,this.cb(m.resourcePreviews),m.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(w){if(!this.c)return"idle";const l=await this.c;return l.resourcePreviews.some(({mergeState:m})=>m==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:m})=>m!=="accepted")?"syncing":(await this.tb(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(m=>[m,m.acceptResult]),w),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(w){const l=w.filter(({mergeState:m})=>m==="conflict");(0,I.$ub)(this.s,l,(m,D)=>this.h.isEqual(m.previewResource,D.previewResource))||(this.s=l,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async db(w){const l=this.c?await this.c:null;if(l)for(const m of l.resourcePreviews){if(this.h.isEqual(m.acceptedResource,w))return m.acceptResult?m.acceptResult.content:null;if(this.h.isEqual(m.remoteResource,w))return m.remoteContent;if(this.h.isEqual(m.localResource,w))return m.localContent;if(this.h.isEqual(m.baseResource,w))return m.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(w){(0,$.$qk)(w)!==1&&this.O.error(w)}}async eb(w,l,m,D,T,z){const U=await this.qb(w,l,m,T,z),B=[];for(const Z of U){const Q=Z.previewResource.with({scheme:d.$_gb,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)B.push({...Z,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=D?await this.rb(Z,z):void 0;if(z.isCancellationRequested)break;await this.G.writeFile(Z.previewResource,L.$ce.fromString(x?.content||""));const W=x&&!x.hasConflicts?await this.sb(Z,Z.previewResource,void 0,z):void 0;B.push({...Z,acceptResult:W,mergeState:x?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:x?x.localChange:Z.localChange,remoteChange:W?W.remoteChange:x?x.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:l,resourcePreviews:B,isLastSyncFromCurrentMachine:m}}async getLastSyncUserData(){let w=this.gb();if(w||(w=await this.jb()),!w)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const l=JSON.parse(w),m=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!l.version&&!!m&&l.version!==m,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${m}.`),await this.resetLocal(),null;let D,T=1;for(;D===void 0&&T++<6;)try{const z=await this.hb();z&&(z.ref===l.ref?D=z.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(z){if(z instanceof $.$uk&&z.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(z instanceof d.$Zgb)throw z;this.O.error(z,T)}}if(D===void 0)try{const z=await this.J.resolveResourceContent(this.resource,l.ref,this.collection,this.F);D=z===null?null:this.kb(z),await this.ib({ref:l.ref,syncData:D})}catch(z){if(z instanceof d.$Zgb&&z.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw z}return D===void 0?null:{...l,syncData:D}}async fb(w,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const m=this.M.getResourceSyncStateVersion(this.resource),D={ref:w.ref,version:m,...l};this.I.store(this.z,JSON.stringify(D),-1,1),await this.ib(w)}gb(){return this.I.get(this.z,-1)}async hb(){const w=(await this.G.readFile(this.y)).value.toString();try{const l=w?JSON.parse(w):void 0;if(s(l))return l}catch(l){this.O.error(l)}}async ib(w){await this.G.writeFile(this.y,L.$ce.fromString(JSON.stringify(w)))}async jb(){try{const w=await this.G.readFile(this.y),l=JSON.parse(w.value.toString());await this.G.del(this.y),l.ref&&l.content!==void 0?(this.I.store(this.z,JSON.stringify({...l,content:void 0}),-1,1),await this.ib({ref:l.ref,syncData:l.content===null?null:JSON.parse(l.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,l)}catch(w){w instanceof $.$uk&&w.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(w)}return this.I.get(this.z,-1)}async getRemoteUserData(w){const{ref:l,content:m}=await this.lb(w);let D=null;return m!==null&&(D=this.kb(m)),{ref:l,syncData:D}}kb(w){try{const l=JSON.parse(w);if(o(l))return l}catch(l){this.O.error(l)}throw new d.$Zgb((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(w){const l=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.J.readResource(this.resource,l,this.collection,this.F)}async mb(w,l){const m=await this.j,D={version:this.pb,machineId:m,content:w};try{return l=await this.J.writeResource(this.resource,JSON.stringify(D),l,this.collection,this.F),{ref:l,syncData:D}}catch(T){throw T instanceof d.$Zgb&&T.code==="TooLarge"&&(T=new d.$Zgb(T.message,T.code,this.resource)),T}}async nb(w){const l={version:this.pb,content:w};return this.L.writeResource(this.resource,JSON.stringify(l),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(d.$Mgb)}};e.$rEb=i,e.$rEb=i=ye([Y(2,$.$_j),Y(3,c.$Xh),Y(4,h.$0o),Y(5,d.$Ugb),Y(6,d.$Vgb),Y(7,d.$5gb),Y(8,f.$dl),Y(9,d.$0gb),Y(10,b.$ki),Y(11,u.$Jk)],i);let t=class extends i{constructor(w,l,m,D,T,z,U,B,Z,Q,x,W,X){super(l,m,D,T,z,U,B,Z,Q,x,W,X),this.r=w,this.B(this.G.watch(this.h.dirname(w))),this.B(this.G.onDidFilesChange(G=>this.yb(G)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(w,l,m){try{l?await this.G.writeFile(this.r,L.$ce.fromString(w),m?void 0:l):await this.G.createFile(this.r,L.$ce.fromString(w),{overwrite:m})}catch(D){throw D instanceof $.$uk&&D.fileOperationResult===1||D instanceof $.$uk&&D.fileOperationResult===3?new d.$Zgb(D.message,"LocalPreconditionFailed"):D}}async xb(){try{await this.G.del(this.r)}catch(w){if(!(w instanceof $.$uk&&w.fileOperationResult===1))throw w}}yb(w){w.contains(this.r)&&this.Q()}};e.$sEb=t,e.$sEb=t=ye([Y(3,$.$_j),Y(4,c.$Xh),Y(5,h.$0o),Y(6,d.$Ugb),Y(7,d.$Vgb),Y(8,d.$5gb),Y(9,f.$dl),Y(10,d.$0gb),Y(11,b.$ki),Y(12,u.$Jk)],t);let r=class extends t{constructor(w,l,m,D,T,z,U,B,Z,Q,x,W,X,G){super(w,l,m,D,T,z,U,B,Z,Q,x,X,G),this.zb=W,this.Bb=void 0}Ab(w,l){const m=[],D=(0,R.$Xm)(w,m,{allowEmptyContent:!0,allowTrailingComma:!0});return m.length>0||!(0,C.$Gf)(D)&&l!==Array.isArray(D)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$tEb=r,e.$tEb=r=ye([Y(3,$.$_j),Y(4,c.$Xh),Y(5,h.$0o),Y(6,d.$Ugb),Y(7,d.$Vgb),Y(8,d.$5gb),Y(9,f.$dl),Y(10,d.$0gb),Y(11,d.$9gb),Y(12,b.$ki),Y(13,u.$Jk)],r);let a=class{constructor(w,l,m,D,T,z,U){this.resource=w,this.g=l,this.h=m,this.j=D,this.k=T,this.l=z,this.d=U.extUri,this.f=(0,d.$Sgb)(void 0,this.resource,m,this.d)}async initialize({ref:w,content:l}){if(!l){this.j.info("Remote content does not exist.",this.resource);return}const m=this.m(l);if(m)try{await this.o({ref:w,syncData:m})}catch(D){this.j.error(D)}}m(w){try{const l=JSON.parse(w);if(o(l))return l}catch(l){this.j.error(l)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const m={ref:w.ref,version:void 0,...l};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(m),-1,1),await this.k.writeFile(this.f,L.$ce.fromString(JSON.stringify(w)))}};e.$uEb=a,e.$uEb=a=ye([Y(1,E.$Lk),Y(2,c.$Xh),Y(3,p.$$i),Y(4,$.$_j),Y(5,h.$0o),Y(6,u.$Jk)],a)}),define(oe[114],ae([0,1,6,26,7,3,41,2,27,20,14,113,29,33,81,44,11,4,71,8,21,22,28,17,39,231,111,24,58]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d,E,s,o,n,i,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$63b=e.$53b=e.$43b=e.$33b=e.$23b=void 0;async function v(z,U){const B=JSON.parse(z.content);if(z.version===1||z.version===2){const Z=(await U.getInstalled(0)).filter(Q=>Q.isBuiltin);for(const Q of B)z.version===1&&(Q.enabled===!1&&(Q.disabled=!0),delete Q.enabled),z.version===2&&Z.every(x=>!(0,c.$Do)(x.identifier,Q.identifier))&&(Q.installed=!0)}return B}function w(z){return JSON.parse(z.content)}e.$23b=w;function l(z,U){return z.sort((B,Z)=>!B.identifier.uuid&&Z.identifier.uuid?-1:B.identifier.uuid&&!Z.identifier.uuid?1:(0,k.$Ve)(B.identifier.id,Z.identifier.id)),U?(0,O.$aT)(z,{}):JSON.stringify(z)}e.$33b=l;let m=class extends n.$rEb{constructor(U,B,Z,Q,x,W,X,G,V,ee,ie,_,ne,K,q,P,j){super({syncResource:"extensions",profile:U},B,Q,Z,x,W,X,_,ne,ee,ie,q),this.Cb=G,this.Db=V,this.Eb=j,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$_gb,authority:"base"}),this.yb=this.wb.with({scheme:r.$_gb,authority:"local"}),this.zb=this.wb.with({scheme:r.$_gb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$_gb,authority:"accepted"}),this.Bb=this.Eb.createInstance(D),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,M=>M.some(({local:F})=>!!F)),A.Event.filter(this.Cb.onDidUninstallExtension,M=>!M.error),A.Event.filter(P.onDidChange,M=>M.valueChanges.some(({profile:F,changes:H})=>this.syncResource.profile.id===F.id&&H.some(J=>J.key===b.$eo))),K.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,B){const Z=U.syncData?await v(U.syncData,this.Cb):null,Q=B?.skippedExtensions??[],x=B?.builtinExtensions??null,W=B?.syncData?await v(B.syncData,this.Cb):null,{localExtensions:X,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile);Z?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:ee}=(0,i.$13b)(X,Z,W,Q,G,x),ie={local:V,remote:ee,content:this.Hb(X,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:ee!==null?2:0},_=this.Ob(X,!1);return[{skippedExtensions:Q,builtinExtensions:x,baseResource:this.xb,baseContent:W?this.Ob(W,!1):_,localResource:this.yb,localContent:_,localExtensions:X,remoteResource:this.zb,remoteExtensions:Z,remoteContent:Z?this.Ob(Z,!1):null,previewResource:this.wb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.Ab}]}async ub(U){const B=U.syncData?await v(U.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:Q}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$13b)(Z,B,B,U.skippedExtensions||[],Q,U.builtinExtensions||[]);return x!==null}Hb(U,B,Z,Q){const x=[...B,...Z],W=new Set,X=G=>{W.add(G.id.toLowerCase()),G.uuid&&W.add(G.uuid)};x.forEach(({identifier:G})=>X(G)),Q.forEach(X);for(const G of U)W.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&W.has(G.identifier.uuid)||x.push(G);return this.Ob(x,!1)}async rb(U,B){return{...U.previewResult,hasConflicts:!1}}async sb(U,B,Z,Q){if(this.h.isEqual(B,this.yb))return this.Kb(U);if(this.h.isEqual(B,this.zb))return this.Lb(U);if(this.h.isEqual(B,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${B.toString()}`)}async Kb(U){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(B),Q=(0,i.$13b)(U.localExtensions,null,null,U.skippedExtensions,Z,U.builtinExtensions),{local:x,remote:W}=Q;return{content:U.localContent,local:x,remote:W,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(U){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(B),Q=U.remoteContent?JSON.parse(U.remoteContent):null;if(Q!==null){const x=(0,i.$13b)(U.localExtensions,Q,U.localExtensions,[],Z,U.builtinExtensions),{local:W,remote:X}=x;return{content:U.remoteContent,local:W,remote:X,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:X!==null?2:0}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(U,B,Z,Q){let{skippedExtensions:x,builtinExtensions:W,localExtensions:X}=Z[0][0];const{local:G,remote:V,localChange:ee,remoteChange:ie}=Z[0][1];if(ee===0&&ie===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==0&&(await this.nb(JSON.stringify(X)),x=await this.Bb.updateLocalExtensions(G.added,G.removed,G.updated,x,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(V.all);U=await this.mb(_,Q?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(ne=>ne.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(ne=>ne.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(ne=>ne.identifier.id))}.`:""}`)}B?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(X,W),await this.fb(U,{skippedExtensions:x,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(U,B){const Z=new Set,Q=[];for(const x of U)Z.add(x.identifier.id.toLowerCase()),x.installed||Q.push(x.identifier);if(B)for(const x of B)Z.has(x.id.toLowerCase())||Q.push(x);return Q}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const B=await this.db(U);return B&&this.Ob(JSON.parse(B),!0)}return null}Ob(U,B){return l(U,B)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(B=>B.installed||B.disabled))return!0}catch{}return!1}};e.$43b=m,e.$43b=m=ye([Y(2,C.$Xh),Y(3,y.$_j),Y(4,d.$0o),Y(5,r.$Ugb),Y(6,r.$Vgb),Y(7,b.$do),Y(8,t.$_Eb),Y(9,r.$0gb),Y(10,g.$ki),Y(11,r.$5gb),Y(12,E.$dl),Y(13,$.$1u),Y(14,s.$Jk),Y(15,a.$ADb),Y(16,h.$Ph)],m);let D=class{constructor(U,B,Z,Q,x,W){this.a=U,this.b=B,this.c=Z,this.d=Q,this.f=x,this.g=W}async getLocalExtensions(U){const B=await this.a.getInstalled(void 0,U.extensionsResource),Z=this.d.getIgnoredExtensions(B);return{localExtensions:await this.j(U,async(x,W)=>{const X=x.getDisabledExtensions();return B.map(G=>{const{identifier:V,isBuiltin:ee,manifest:ie,preRelease:_,pinned:ne,isApplicationScoped:K}=G,q={identifier:V,preRelease:_,version:ie.version,pinned:!!ne};K&&!(0,p.$0l)(ie)&&(q.isApplicationScoped=K),X.some(P=>(0,c.$Do)(P,V))&&(q.disabled=!0),ee||(q.installed=!0);try{const P=W.getKeysForSync({id:V.id,version:ie.version});if(P){const j=W.getExtensionState(G,!0)||{};q.state=Object.keys(j).reduce((M,F)=>(P.includes(F)&&(M[F]=j[F]),M),{})}}catch(P){this.g.info(`${(0,n.$qEb)("extensions",U)}: Error while parsing extension state`,(0,L.$0)(P))}return q})}),ignoredExtensions:Z}}async updateLocalExtensions(U,B,Z,Q,x){const W=(0,n.$qEb)("extensions",x),X=[],G=new Map,V=[],ee=[],ie=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||Z.length)&&await this.j(x,async(K,q)=>{await I.Promises.settled([...U,...Z].map(async P=>{const j=ie.find(H=>(0,c.$Do)(H.identifier,P.identifier));if(j&&j.isBuiltin){P.state&&j.manifest.version===P.version&&this.h(P.state,j,j.manifest.version,q),K.getDisabledExtensions().some(J=>(0,c.$Do)(J,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${W}: Disabling extension...`,P.identifier.id),await K.disableExtension(P.identifier),this.g.info(`${W}: Disabled extension`,P.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,P.identifier.id),await K.enableExtension(P.identifier),this.g.info(`${W}: Enabled extension`,P.identifier.id))),V.push(P.identifier);return}const M=P.pinned?P.version:void 0,F=(await this.c.getExtensions([{...P.identifier,version:M,preRelease:M?void 0:P.preRelease}],N.CancellationToken.None))[0];if(P.state&&(j?j.manifest.version===P.version:F)&&this.h(P.state,j||F,j?.manifest.version,q),F)try{K.getDisabledExtensions().some(J=>(0,c.$Do)(J,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${W}: Disabling extension...`,P.identifier.id,F.version),await K.disableExtension(F.identifier),this.g.info(`${W}: Disabled extension`,P.identifier.id,F.version)):(this.g.trace(`${W}: Enabling extension...`,P.identifier.id,F.version),await K.enableExtension(F.identifier),this.g.info(`${W}: Enabled extension`,P.identifier.id,F.version))),(!j||j.preRelease!==P.preRelease||j.pinned!==P.pinned||M&&j.manifest.version!==M)&&(await this.a.canInstall(F)?(X.push({extension:F,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:P.pinned&&!!P.version,installPreReleaseVersion:P.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:P.isApplicationScoped,context:{[b.$5n]:!0,[b.$6n]:!0}}}),G.set(F.identifier.id.toLowerCase(),P)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,F.displayName||F.identifier.id),ee.push(P)))}catch(H){ee.push(P),this.g.error(H),this.g.info(`${W}: Skipped synchronizing extension`,F.displayName||F.identifier.id)}else ee.push(P),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,P.identifier.id)}))}),B.length){const K=ie.filter(({identifier:q,isBuiltin:P})=>!P&&B.some(j=>(0,c.$Do)(q,j)));await I.Promises.settled(K.map(async q=>{this.g.trace(`${W}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,q.identifier.id),V.push(q.identifier)}))}const _=await this.a.installGalleryExtensions(X);for(const{identifier:K,local:q,error:P,source:j}of _){const M=j;if(q)this.g.info(`${W}: Installed extension.`,K.id,M.version),V.push(K);else{const F=G.get(K.id.toLowerCase());F&&(ee.push(F),this.g.info(`${W}: Skipped synchronizing extension`,M.displayName||M.identifier.id)),P instanceof b.$co&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(P.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):P&&this.g.error(P)}}const ne=[];for(const K of Q)V.some(q=>(0,c.$Do)(q,K.identifier))||ne.push(K);for(const K of ee)ne.some(q=>(0,c.$Do)(q.identifier,K.identifier))||ne.push(K);return ne}h(U,B,Z,Q){const x=Q.getExtensionState(B,!0)||{},W=Z?Q.getKeysForSync({id:B.identifier.id,version:Z}):void 0;W?W.forEach(X=>{x[X]=U[X]}):Object.keys(U).forEach(X=>x[X]=U[X]),Q.setExtensionState(B,x,!0)}async j(U,B){return this.b.withProfileScopedStorageService(U,async Z=>{const Q=new R.$Rc,x=this.f.createChild(new f.$Oh([d.$0o,Z])),W=Q.add(x.createInstance(S.$YCb)),X=Q.add(x.createInstance($.$2u));try{return await B(W,X)}finally{Q.dispose()}})}};e.$53b=D,e.$53b=D=ye([Y(0,b.$do),Y(1,a.$ADb),Y(2,b.$bo),Y(3,t.$_Eb),Y(4,h.$Ph),Y(5,r.$0gb)],D);let T=class extends n.$uEb{constructor(U,B,Z,Q,x,W,X,G){super("extensions",Q,x,W,Z,X,G),this.p=U,this.q=B}async t(U){return U.syncData?await v(U.syncData,this.p):null}u(U,B){const Z=[],Q=[],x=[];for(const W of U){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const X=B.find(G=>(0,c.$Do)(G.identifier,W.identifier));X?(Z.push(X),W.disabled&&x.push(W.identifier)):W.installed&&(Q.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&x.push(W.identifier))}return{installedExtensions:Z,newExtensions:Q,disabledExtensions:x,remoteExtensions:U}}};e.$63b=T,e.$63b=T=ye([Y(0,b.$do),Y(1,t.$_Eb),Y(2,y.$_j),Y(3,o.$Lk),Y(4,C.$Xh),Y(5,u.$$i),Y(6,d.$0o),Y(7,s.$Jk)],T)}),define(oe[115],ae([0,1,15,7,3,35,41,5,32,20,14,11,8,43,21,22,28,39,78,235,24,17,58,4]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d,E,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AEb=e.$zEb=e.$yEb=e.$xEb=e.$wEb=void 0;const n="globalState.argv.",i=["locale"];function t(m,D){const T=m.storage?Object.keys(m.storage).sort():[],z={};return T.forEach(U=>z[U]=m.storage[U]),m.storage=z,D?(0,O.$aT)(m,{}):JSON.stringify(m)}e.$wEb=t;const r=1;let a=class extends h.$rEb{constructor(D,T,z,U,B,Z,Q,x,W,X,G,V,ee,ie){super({syncResource:"globalState",profile:D},T,U,x,V,B,Z,W,X,Q,G,ee),this.Bb=z,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:d.$_gb,authority:"base"}),this.xb=this.vb.with({scheme:d.$_gb,authority:"local"}),this.yb=this.vb.with({scheme:d.$_gb,authority:"remote"}),this.zb=this.vb.with({scheme:d.$_gb,authority:"accepted"}),this.Ab=ie.createInstance(v),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(U.onDidFilesChange,_=>_.contains(this.H.argvResource)),L.Event.filter(z.onDidChange,_=>!!(_.targetChanges.some(ne=>this.syncResource.profile.id===ne.id)||_.valueChanges.some(({profile:ne,changes:K})=>this.syncResource.profile.id===ne.id&&K.some(q=>q.target===0)))))(()=>this.Q()))}async qb(D,T,z){const U=D.syncData?JSON.parse(D.syncData.content):null;T=T===null&&z?D:T;const B=T&&T.syncData?JSON.parse(T.syncData.content):null,Z=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.Jb(B),{local:x,remote:W}=(0,u.$vEb)(Z.storage,U?U.storage:null,B?B.storage:null,Q,this.O),X={content:null,local:x,remote:W,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:W.all!==null?2:0},G=t(Z,!1);return[{baseResource:this.wb,baseContent:B?t(B,!1):G,localResource:this.xb,localContent:G,localUserData:Z,remoteResource:this.yb,remoteContent:U?t(U,!1):null,previewResource:this.vb,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.zb,storageKeys:Q}]}async ub(D){const T=D.syncData?JSON.parse(D.syncData.content):null;if(T===null)return!0;const z=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(T),{remote:B}=(0,u.$vEb)(z.storage,T.storage,T.storage,U,this.O);return B.all!==null}async rb(D,T){return{...D.previewResult,hasConflicts:!1}}async sb(D,T,z,U){if(this.h.isEqual(T,this.xb))return this.Gb(D);if(this.h.isEqual(T,this.yb))return this.Hb(D);if(this.h.isEqual(T,this.vb))return D.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(D.localUserData.storage),removed:[],updated:[],all:D.localUserData.storage},localChange:0,remoteChange:2}}async Hb(D){if(D.remoteContent!==null){const T=JSON.parse(D.remoteContent),{local:z,remote:U}=(0,u.$vEb)(D.localUserData.storage,T.storage,null,D.storageKeys,this.O);return{content:D.remoteContent,local:z,remote:U,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(D,T,z,U){const{localUserData:B}=z[0][0],{local:Z,remote:Q,localChange:x,remoteChange:W}=z[0][1];if(x===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(B)),await this.Ab.writeLocalGlobalState(Z,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const X=JSON.stringify({storage:Q.all});D=await this.mb(X,U?null:D.ref),this.O.info(`${this.D}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}T?.ref!==D.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(D),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(D){if(this.h.isEqual(this.yb,D)||this.h.isEqual(this.wb,D)||this.h.isEqual(this.xb,D)||this.h.isEqual(this.zb,D)){const T=await this.db(D);return T&&t(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:D}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(D).length>1||D[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(D){const T=await this.Bb.readStorageData(this.syncResource.profile),z=[],U=[];for(const[Q,x]of T)x.target===0?z.push(Q):x.target===1&&U.push(Q);const B=[...z,...U],Z=D?.storage?Object.keys(D.storage).filter(Q=>!Q.startsWith(n)&&!B.includes(Q)&&T.get(Q)!==void 0):[];if(!R.$p){const Q=[...d.$Qgb.map(x=>(0,d.$4gb)(x)),d.$3gb];Z.push(...Q),U.push(...Q)}return{user:z,machine:U,unregistered:Z}}};e.$xEb=a,e.$xEb=a=ye([Y(2,s.$ADb),Y(3,S.$_j),Y(4,d.$Ugb),Y(5,d.$Vgb),Y(6,d.$0gb),Y(7,C.$Xh),Y(8,d.$5gb),Y(9,p.$dl),Y(10,g.$ki),Y(11,$.$0o),Y(12,y.$Jk),Y(13,o.$Ph)],a);let v=class{constructor(D,T,z,U){this.a=D,this.b=T,this.c=z,this.d=U}async getLocalGlobalState(D){const T={};if(D.isDefault){const U=await this.f(),B=(0,A.$Xm)(U);for(const Z of i)B[Z]!==void 0&&(T[`${n}${Z}`]={version:1,value:B[Z]})}const z=await this.c.readStorageData(D);for(const[U,B]of z)B.value&&B.target===0&&(T[U]={version:1,value:B.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const D=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),D.value.toString()}catch(D){this.d.debug((0,N.$0)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:T,updated:z},U){const B=(0,h.$qEb)("globalState",U),Z={},Q=new Map,x=await this.c.readStorageData(U),W=(X,G)=>{for(const V of X){if(V.startsWith(n)){Z[V.substring(n.length)]=G?G[V].value:void 0;continue}if(G){const ee=G[V];ee.value!==x.get(V)?.value&&Q.set(V,ee.value)}else x.get(V)!==void 0&&Q.set(V,void 0)}};if(W(Object.keys(D),D),W(Object.keys(z),z),W(T),Object.keys(Z).length){this.d.trace(`${B}: Updating locale...`);const X=await this.f();let G=X;for(const V of Object.keys(Z))G=(0,f.edit)(G,[V],Z[V],{});X!==G&&(this.d.trace(`${B}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$ce.fromString(G)),this.d.info(`${B}: Updated locale.`)),this.d.info(`${B}: Updated locale`)}Q.size&&(this.d.trace(`${B}: Updating global state...`),await this.c.updateStorageData(U,Q,0),this.d.info(`${B}: Updated global state`,[...Q.keys()]))}};e.$yEb=v,e.$yEb=v=ye([Y(0,S.$_j),Y(1,C.$Xh),Y(2,s.$ADb),Y(3,d.$0gb)],v);let w=class extends h.$uEb{constructor(D,T,z,U,B,Z){super("globalState",z,U,B,T,D,Z)}async o(D){const T=D.syncData?JSON.parse(D.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const z={},U={};for(const B of Object.keys(T.storage))B.startsWith(n)?z[B.substring(n.length)]=T.storage[B].value:this.l.get(B,0)===void 0&&(U[B]=T.storage[B].value);if(Object.keys(z).length){let B="{}";try{B=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Z of Object.keys(z))B=(0,f.edit)(B,[Z],z[Z],{});await this.k.writeFile(this.h.argvResource,I.$ce.fromString(B))}if(Object.keys(U).length){const B=[];for(const Z of Object.keys(U))B.push({key:Z,value:U[Z],scope:0,target:0});this.l.storeAll(B,!0)}}};e.$zEb=w,e.$zEb=w=ye([Y(0,$.$0o),Y(1,S.$_j),Y(2,E.$Lk),Y(3,C.$Xh),Y(4,d.$0gb),Y(5,y.$Jk)],w);let l=class{constructor(D,T,z,U,B){this.a=D,this.b=T,this.c=z,this.d=U,this.f=B}getSyncStoreType(D){return this.h(D)?.storage[d.$3gb]?.value}async sync(D){const T=(0,d.$Ygb)((0,k.$fg)());try{return await this.g(D,T)}catch(z){if(z instanceof d.$Zgb)switch(z.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(D,T)}throw z}}async g(D,T){const z=await this.a.readResource("globalState",null,void 0,T),U=this.h(z)||{storage:{}};U.storage[d.$3gb]={value:D,version:r};const B=await(0,c.$dp)(this.c,this.d,this.b),Z={version:r,machineId:B,content:t(U,!1)};await this.a.writeResource("globalState",JSON.stringify(Z),z.ref,void 0,T)}h({content:D}){if(!D)return null;const T=JSON.parse(D);if((0,h.$pEb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$AEb=l,e.$AEb=l=ye([Y(1,$.$0o),Y(2,C.$Xh),Y(3,S.$_j),Y(4,b.$$i)],l)}),define(oe[116],ae([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,232,24]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$03b=e.$93b=e.$83b=void 0;function u(s,o,n){try{const i=JSON.parse(s);if(!o)return(0,R.$Gf)(i.all)?null:i.all;switch(O.OS){case 2:return(0,R.$Gf)(i.mac)?null:i.mac;case 3:return(0,R.$Gf)(i.linux)?null:i.linux;case 1:return(0,R.$Gf)(i.windows)?null:i.windows}}catch(i){return n.error(i),null}}e.$83b=u;let d=class extends y.$tEb{constructor(o,n,i,t,r,a,v,w,l,m,D,T,z){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,w,l,m,i,t,v,T,r,D,a,z),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:f.$_gb,authority:"base"}),this.Gb=this.Eb.with({scheme:f.$_gb,authority:"local"}),this.Hb=this.Eb.with({scheme:f.$_gb,authority:"remote"}),this.Ib=this.Eb.with({scheme:f.$_gb,authority:"accepted"}),this.B(L.Event.filter(a.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,i,t){const r=o.syncData?u(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&i?o:n;const a=n?this.Ob(n):null,v=await this.vb(),w=await this.Cb();let l=null,m=!1,D=!1,T=!1;if(r){let B=v?v.value.toString():"[]";if(B=B||"[]",this.Ab(B,!0))throw new f.$Zgb((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==B||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Z=await(0,h.$73b)(B,r,a,w,this.zb);Z.hasChanges&&(l=Z.mergeContent,T=Z.hasConflicts,m=T||Z.mergeContent!==B,D=T||Z.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),l=v.value.toString(),D=!0);const z={content:T?a:l,localChange:m?v?2:1:0,remoteChange:D?2:0,hasConflicts:T},U=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:U,localChange:z.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:z.remoteChange,previewResource:this.Eb,previewResult:z,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),a=await(0,h.$73b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,i,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,i,t){const{fileContent:r}=i[0][0];let{content:a,localChange:v,remoteChange:w}=i[0][1];if(v===0&&w===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new f.$Zgb((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),w!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const l=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(l,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,A.$Xm)(o.value.toString());if((0,I.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:u(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let i={};try{i=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=o,O.OS){case 2:i.mac=o;break;case 3:i.linux=o;break;case 1:i.windows=o;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(f.$Ngb)}};e.$93b=d,e.$93b=d=ye([Y(2,f.$Ugb),Y(3,f.$Vgb),Y(4,f.$0gb),Y(5,g.$ki),Y(6,f.$5gb),Y(7,S.$_j),Y(8,C.$Xh),Y(9,b.$0o),Y(10,f.$9gb),Y(11,c.$dl),Y(12,$.$Jk)],d);let E=class extends y.$uEb{constructor(o,n,i,t,r,a){super("keybindings",n,i,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$ce.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Xm)(o.value.toString());return!(0,I.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return u(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$03b=E,e.$03b=E=ye([Y(0,S.$_j),Y(1,p.$Lk),Y(2,C.$Xh),Y(3,f.$0gb),Y(4,b.$0o),Y(5,$.$Jk)],E)}),define(oe[117],ae([0,1,15,3,171,20,74,14,29,11,21,22,28,17,39,236,24]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a4b=e.$_3b=e.$$3b=void 0;function h(E){return E&&E.settings&&typeof E.settings=="string"&&Object.keys(E).length===1}function f(E){const s=JSON.parse(E);return h(s)?s:{settings:E}}e.$$3b=f;let u=class extends $.$tEb{constructor(s,o,n,i,t,r,a,v,w,l,m,D,T,z){super(s.settingsResource,{syncResource:"settings",profile:s},o,n,i,t,r,a,m,D,v,w,l,z),this.Eb=T,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:y.$_gb,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.$_gb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.$_gb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.$_gb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(s){const o=await this.getLastSyncUserData(),n=await this.X(s,o),i=this.Lb(n),t=new O.$Gn(y.$Mgb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(y.$Mgb)||{}}async qb(s,o,n){const i=await this.vb(),t=await this.Cb(),r=this.Lb(s);o=o===null&&n?s:o;const a=o?this.Lb(o):null,v=await this.Pb();let w=null,l=!1,m=!1,D=!1;if(r){let B=i?i.value.toString().trim():"{}";B=B||"{}",this.Qb(B),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Z=(0,p.$hDb)(B,r.settings,a?a.settings:null,v,[],t);w=Z.localContent||Z.remoteContent,l=Z.localContent!==null,m=Z.remoteContent!==null,D=Z.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),w=i.value.toString().trim()||"{}",this.Qb(w),m=!0);const T=i?i.value.toString():null,z=a?.settings??null,U={content:D?z:w,localChange:l?2:0,remoteChange:m?2:0,hasConflicts:D};return[{fileContent:i,baseResource:this.baseResource,baseContent:z,localResource:this.localResource,localContent:T,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async ub(s){const o=this.Lb(s);if(o===null)return!0;const n=await this.vb(),i=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,p.$hDb)(i||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(s,o){const n=await this.Cb(),i=await this.Pb();return{...s.previewResult,content:s.previewResult.content?(0,p.$gDb)(s.previewResult.content,"{}",i,n):null}}async sb(s,o,n,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:s.fileContent?(0,p.$gDb)(s.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:s.remoteContent!==null?(0,p.$gDb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,p.$gDb)(n,s.fileContent?s.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(s,o,n,i){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:v}=n[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const w=await this.Cb(),l=this.Lb(s),m=await this.Pb(r);r=(0,p.$gDb)(r,l?l.settings:"{}",m,w),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Nb(r)),i?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,p.$iDb)(s.value.toString())}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let o=await super.db(s);if(o){const n=await this.Cb(),i=await this.Pb();o=(0,p.$gDb)(o,"{}",i,n)}return o}Lb(s){return s.syncData?this.Mb(s.syncData.content):null}Mb(s){try{return f(s)}catch(o){this.O.error(o)}return null}Nb(s){return{settings:s}}async Pb(s){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,p.$eDb)(o,this.P,s)}Qb(s){if(this.Ab(s,!1))throw new y.$Zgb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$_3b=u,e.$_3b=u=ye([Y(2,g.$_j),Y(3,R.$Xh),Y(4,C.$0o),Y(5,y.$Ugb),Y(6,y.$Vgb),Y(7,y.$0gb),Y(8,y.$9gb),Y(9,A.$ki),Y(10,y.$5gb),Y(11,S.$dl),Y(12,k.$do),Y(13,b.$Jk)],u);let d=class extends $.$uEb{constructor(s,o,n,i,t,r){super("settings",o,n,i,s,t,r)}async o(s){const o=s.syncData?this.p(s.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$ce.fromString(o.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$iDb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}p(s){try{return f(s)}catch(o){this.j.error(o)}return null}};e.$a4b=d,e.$a4b=d=ye([Y(0,g.$_j),Y(1,c.$Lk),Y(2,R.$Xh),Y(3,y.$0gb),Y(4,C.$0o),Y(5,b.$Jk)],d)}),define(oe[118],ae([0,1,15,3,30,20,14,11,21,22,28,17,39,233,24]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f4b=e.$e4b=e.$d4b=void 0;function p(f){return JSON.parse(f.content)}e.$d4b=p;let y=class extends b.$rEb{constructor(u,d,E,s,o,n,i,t,r,a,v,w){super({syncResource:"snippets",profile:u},d,s,E,o,n,i,a,v,t,r,w),this.pb=1,this.vb=u.snippetsHome,this.B(this.G.watch(E.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,l=>l.affects(this.vb))(()=>this.Q()))}async qb(u,d,E){const s=await this.Hb(),o=this.Gb(s),n=u.syncData?this.Fb(u.syncData):null;d=d===null&&E?u:d;const i=d&&d.syncData?this.Fb(d.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,c.$b4b)(o,n,i);return this.Bb(t,s,n||{},i||{})}async ub(u){const d=u.syncData?this.Fb(u.syncData):null;if(d===null)return!0;const E=await this.Hb(),s=this.Gb(E),o=(0,c.$b4b)(s,d,d);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(u,d){return u.previewResult}async sb(u,d,E,s){if(this.h.isEqualOrParent(d,this.g.with({scheme:$.$_gb,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:$.$_gb,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return E===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:E,localChange:E===null?u.fileContent!==null?3:0:2,remoteChange:E===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(u,d,E,s){const o=E.map(([n,i])=>({...n,acceptResult:i}));o.every(({localChange:n,remoteChange:i})=>n===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,s)),o.some(({remoteChange:n})=>n!==0)&&(u=await this.Eb(o,u,s)),d?.ref!==u.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(u),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(u,d,E,s){const o=new Map;for(const n of Object.keys(u.local.added)){const i={content:u.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"accepted"})})}for(const n of Object.keys(u.local.updated)){const i={content:u.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"accepted"})})}for(const n of u.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"accepted"})})}for(const n of Object.keys(u.remote.added)){const i={content:u.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"accepted"})})}for(const n of Object.keys(u.remote.updated)){const i={content:u.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"local"}),fileContent:d[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"accepted"})})}for(const n of u.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"remote"}),remoteContent:E[n],previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"accepted"})})}for(const n of u.conflicts){const i={content:s[n]??null,hasConflicts:!0,localChange:d[n]?2:1,remoteChange:E[n]?2:1},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"local"}),fileContent:d[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"remote"}),remoteContent:E[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"accepted"})})}for(const n of Object.keys(d))if(!o.has(n)){const i={content:d[n]?d[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=d[n]?d[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"base"}),baseContent:s[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"local"}),fileContent:d[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"remote"}),remoteContent:E[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$_gb,authority:"accepted"})})}return[...o.values()]}async resolveContent(u){return this.h.isEqualOrParent(u,this.g.with({scheme:$.$_gb,authority:"remote"}))||this.h.isEqualOrParent(u,this.g.with({scheme:$.$_gb,authority:"local"}))||this.h.isEqualOrParent(u,this.g.with({scheme:$.$_gb,authority:"base"}))||this.h.isEqualOrParent(u,this.g.with({scheme:$.$_gb,authority:"accepted"}))?this.db(u):null}async hasLocalData(){try{const u=await this.Hb();if(Object.keys(u).length)return!0}catch{}return!1}async Cb(u){const d={};for(const E of u)E.fileContent&&(d[this.h.basename(E.localResource)]=E.fileContent);await this.nb(JSON.stringify(this.Gb(d)))}async Db(u,d){for(const{fileContent:E,acceptResult:s,localResource:o,remoteResource:n,localChange:i}of u)if(i!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$ce.fromString(s.content),{overwrite:d}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$ce.fromString(s.content),d?void 0:E),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(u,d,E){const s=d.syncData?this.Fb(d.syncData):{},o=(0,L.$8m)(s);for(const{acceptResult:n,localResource:i,remoteResource:t,remoteChange:r}of u)if(r!==0){const a=i?this.h.basename(i):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,c.$c4b)(s,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),d=await this.mb(JSON.stringify(o),E?null:d.ref),this.O.info(`${this.D}: Updated remote snippets`)),d}Fb(u){return p(u)}Gb(u){const d={};for(const E of Object.keys(u))d[E]=u[E].value.toString();return d}async Hb(){const u={};let d;try{d=await this.G.resolve(this.vb)}catch(E){if(E instanceof R.$uk&&E.fileOperationResult===1)return u;throw E}for(const E of d.children||[]){const s=E.resource,o=this.h.extname(s);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,s),i=await this.G.readFile(s);u[n]=i}}return u}};e.$e4b=y,e.$e4b=y=ye([Y(2,O.$Xh),Y(3,R.$_j),Y(4,k.$0o),Y(5,$.$Ugb),Y(6,$.$Vgb),Y(7,$.$0gb),Y(8,A.$ki),Y(9,$.$5gb),Y(10,g.$dl),Y(11,C.$Jk)],y);let h=class extends b.$uEb{constructor(u,d,E,s,o,n){super("snippets",d,E,s,u,o,n)}async o(u){const d=u.syncData?JSON.parse(u.syncData.content):null;if(!d){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const s of Object.keys(d)){const o=d[s];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,s);await this.k.createFile(n,I.$ce.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(u)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(u){return u.fileOperationResult===1}}};e.$f4b=h,e.$f4b=h=ye([Y(0,R.$_j),Y(1,S.$Lk),Y(2,O.$Xh),Y(3,$.$0gb),Y(4,k.$0o),Y(5,C.$Jk)],h)}),define(oe[119],ae([0,1,15,20,14,11,21,22,28,17,39,24]),function(te,e,I,N,L,A,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i4b=e.$h4b=e.$g4b=void 0;function b(y,h){try{return JSON.parse(y).tasks??null}catch(f){return h.error(f),null}}e.$g4b=b;let c=class extends C.$sEb{constructor(h,f,u,d,E,s,o,n,i,t,r,a){super(h.tasksResource,{syncResource:"tasks",profile:h},f,n,i,t,u,d,o,r,E,s,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:S.$_gb,authority:"base"}),this.Cb=this.Ab.with({scheme:S.$_gb,authority:"local"}),this.Db=this.Ab.with({scheme:S.$_gb,authority:"remote"}),this.Eb=this.Ab.with({scheme:S.$_gb,authority:"accepted"})}async qb(h,f,u,d){const E=h.syncData?b(h.syncData.content,this.O):null;f=f===null&&u?h:f;const s=f?.syncData?b(f.syncData.content,this.O):null,o=await this.vb();let n=null,i=!1,t=!1,r=!1;if(h.syncData){const w=o?o.value.toString():null;if(!s||s!==w||s!==E){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const l=p(w,E,s);n=l.content,r=l.hasConflicts,i=l.hasLocalChanged,t=l.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?s:n,localChange:i?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:s,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:E,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(h){const f=h?.syncData?b(h.syncData.content,this.O):null;if(f===null)return!0;const u=await this.vb(),d=u?u.value.toString():null,E=p(d,f,f);return E.hasLocalChanged||E.hasRemoteChanged}async rb(h,f){return h.previewResult}async sb(h,f,u,d){if(this.h.isEqual(f,this.Cb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(f,this.Db))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(f,this.Ab))return u===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async tb(h,f,u,d){const{fileContent:E}=u[0][0],{content:s,localChange:o,remoteChange:n}=u[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),E&&await this.nb(JSON.stringify(this.Kb(E.value.toString()))),s?await this.wb(s,E,d):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(s));h=await this.mb(i,d?null:h.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}f?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(h){return this.h.isEqual(this.Db,h)||this.h.isEqual(this.Bb,h)||this.h.isEqual(this.Cb,h)||this.h.isEqual(this.Eb,h)?this.db(h):null}Kb(h){return h?{tasks:h}:{}}};e.$h4b=c,e.$h4b=c=ye([Y(2,S.$Ugb),Y(3,S.$Vgb),Y(4,S.$0gb),Y(5,N.$ki),Y(6,S.$5gb),Y(7,A.$_j),Y(8,L.$Xh),Y(9,O.$0o),Y(10,R.$dl),Y(11,k.$Jk)],c);let $=class extends C.$uEb{constructor(h,f,u,d,E,s){super("tasks",f,u,d,h,E,s),this.c=this.g.defaultProfile.tasksResource}async o(h){const f=h.syncData?b(h.syncData.content,this.j):null;if(!f){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$ce.fromString(f)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.$i4b=$,e.$i4b=$=ye([Y(0,A.$_j),Y(1,g.$Lk),Y(2,L.$Xh),Y(3,S.$0gb),Y(4,O.$0o),Y(5,k.$Jk)],$);function p(y,h,f){if(y===null&&h===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=f!==y,d=f!==h;return!u&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!d?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!u?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[120],ae([0,1,41,20,14,11,21,22,28,17,39,234,24]),function(te,e,I,N,L,A,O,R,k,g,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.$X5b=e.$W5b=void 0;let c=class extends C.$rEb{constructor(h,f,u,d,E,s,o,n,i,t,r,a,v){super({syncResource:"profiles",profile:h},f,d,E,s,o,n,r,a,i,t,v),this.vb=u,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:b.$_gb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$_gb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$_gb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$_gb,authority:"accepted"}),this.B(u.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?p(h.syncData):null}async getRemoteSyncedProfiles(h){const f=await this.getLastSyncUserData(),u=await this.X(h,f);return u?.syncData?p(u.syncData):null}async qb(h,f,u){if(!this.vb.isEnabled())throw new b.$Zgb("Cannot sync profiles because they are disabled","LocalError");const d=h.syncData?p(h.syncData):null,E=f?.syncData?p(f.syncData):null,s=this.Db(),{local:o,remote:n}=(0,S.$V5b)(s,d,E,[]),i={local:o,remote:n,content:E?this.Eb(E):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=$(s,!1);return[{baseResource:this.baseResource,baseContent:E?this.Eb(E):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:d?this.Eb(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(h){const f=h?.syncData?p(h.syncData):null,u=this.Db(),{remote:d}=(0,S.$V5b)(u,f,f,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async rb(h,f){return{...h.previewResult,hasConflicts:!1}}async sb(h,f,u,d){if(this.h.isEqual(f,this.localResource))return this.Ab(h);if(this.h.isEqual(f,this.remoteResource))return this.Bb(h);if(this.h.isEqual(f,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async Ab(h){const f=this.Db(),u=(0,S.$V5b)(f,null,null,[]),{local:d,remote:E}=u;return{content:h.localContent,local:d,remote:E,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:E!==null?2:0}}async Bb(h){const f=h.remoteContent?JSON.parse(h.remoteContent):null,u=[],d=[];for(const E of this.Db()){const s=f?.find(o=>o.id===E.id);s&&(u.push({id:E.id,name:E.name,collection:s.collection}),d.push(E))}if(f!==null){const E=(0,S.$V5b)(d,f,u,[]),{local:s,remote:o}=E;return{content:h.remoteContent,local:s,remote:o,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(h,f,u,d){const{local:E,remote:s,localChange:o,remoteChange:n}=u[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=u[0][0].remoteProfiles||[];if(i.length+(s?.added.length??0)-(s?.removed.length??0)>20)throw new b.$Zgb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb($(this.Db(),!1));const t=[];for(const r of E.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of E.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of E.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(s?.added.length??0)<=20;if(r)for(const a of s?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of s?.removed||[])i.splice(i.findIndex(({id:v})=>a.id===v),1);for(const a of s?.updated||[]){const v=i.find(({id:w})=>a.id===w);v&&i.splice(i.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{h=await this.updateRemoteProfiles(i,d?null:h.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&s?.added.length?` Added: ${JSON.stringify(s.added.map(a=>a.name))}.`:""}${s?.updated.length?` Updated: ${JSON.stringify(s.updated.map(a=>a.name))}.`:""}${s?.removed.length?` Removed: ${JSON.stringify(s.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of s?.removed||[])await this.J.deleteCollection(a.collection,this.F)}f?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,f){return this.mb(this.Eb(h),f)}async hasLocalData(){return this.Db().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const f=await this.db(h);return f&&(0,I.$aT)(JSON.parse(f),{})}return null}Db(){return this.vb.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Eb(h){return JSON.stringify([...h].sort((f,u)=>f.name.localeCompare(u.name)))}};e.$W5b=c,e.$W5b=c=ye([Y(2,g.$Lk),Y(3,A.$_j),Y(4,L.$Xh),Y(5,O.$0o),Y(6,b.$Ugb),Y(7,b.$Vgb),Y(8,b.$0gb),Y(9,N.$ki),Y(10,b.$5gb),Y(11,R.$dl),Y(12,k.$Jk)],c);function $(y,h){const f=[...y].sort((u,d)=>u.name.localeCompare(d.name)).map(u=>({id:u.id,name:u.name}));return h?(0,I.$aT)(f,{}):JSON.stringify(f)}e.$X5b=$;function p(y){return JSON.parse(y.content)}e.$Y5b=p}),define(oe[251],ae([0,1,3,2,5,14,21,22,24]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J5b=void 0;const g="sync.enable";let C=class extends N.$Sc{constructor(b,c,$,p){super(),this.c=b,this.f=c,this.g=$,this.h=p,this.a=new I.$Od,this.onDidChangeEnablement=this.a.event,this.b=new I.$Od,this.onDidChangeResourceEnablement=this.b.event,this.B(b.onDidChangeValue(-1,void 0,this.B(new N.$Rc))(y=>this.m(y)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(b){b&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:b}),this.c.store(g,b,-1,1))}isResourceEnabled(b){return this.c.getBoolean((0,k.$4gb)(b),-1,!0)}setResourceEnablement(b,c){if(this.isResourceEnabled(b)!==c){const $=(0,k.$4gb)(b);this.j($,c)}}getResourceSyncStateVersion(b){}j(b,c){this.c.store(b,c,-1,L.$p?0:1)}m(b){if(g===b.key){this.a.fire(this.isEnabled());return}const c=k.$Qgb.filter($=>(0,k.$4gb)($)===b.key)[0];if(c){this.b.fire([c,this.isResourceEnabled(c)]);return}}};e.$J5b=C,e.$J5b=C=ye([Y(0,O.$0o),Y(1,R.$dl),Y(2,A.$Xh),Y(3,k.$Tgb)],C)}),define(oe[252],ae([0,1,6,15,63,2,19,20,14,11,17,24]),function(te,e,I,N,L,A,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U5b=void 0;let b=class extends A.$Sc{constructor($,p,y,h,f){super(),this.a=$,this.b=p,this.c=y,this.f=h,this.g=f,this.h()}async h(){for(const p of this.g.profiles)for(const y of S.$Qgb)try{await this.m(this.j(y,p.isDefault?void 0:p.id))}catch(h){this.f.error(h)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,g.$qk)(p)!==1&&this.f.error(p);return}if($.children){for(const p of $.children)if(p.isDirectory&&!this.g.profiles.some(y=>y.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(y){this.f.error(y)}}}async getAllResourceRefs($,p,y){const h=this.j($,p,y);try{const f=await this.b.resolve(h);if(f.children)return f.children.filter(d=>d.isFile&&!d.name.startsWith("lastSync")).sort().reverse().map(d=>({ref:d.name,created:this.n(d)}))}catch(f){if((0,g.$qk)(f)!==1)throw f}return[]}async resolveResourceContent($,p,y,h){const f=this.j($,y,h),u=(0,O.$wg)(f,p);try{return(await this.b.readFile(u)).value.toString()}catch(d){return this.f.error(d),null}}async writeResource($,p,y,h,f){const u=this.j($,h,f),d=(0,O.$wg)(u,`${(0,L.$fm)(y).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,N.$ce.fromString(p))}catch(E){this.f.error(E)}}j($,p,y=this.a.userDataSyncHome){return(0,O.$wg)(y,...p?[p,$]:[$])}async m($){try{try{if(!await this.b.exists($))return}catch{return}const p=await this.b.resolve($);if(p.children){const y=p.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let f=y.filter(d=>Date.now()-this.n(d)>h);const u=y.length-f.length;u<10&&(f=f.slice(10-u)),await I.Promises.settled(f.map(async d=>{this.f.info("Deleting from backup",d.resource.path),await this.b.del(d.resource)}))}}catch(p){this.f.error(p)}}n($){return new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$U5b=b,e.$U5b=b=ye([Y(0,k.$Xh),Y(1,g.$_j),Y(2,R.$ki),Y(3,S.$0gb),Y(4,C.$Lk)],b)}),define(oe[82],ae([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgb=e.$Igb=e.$Hgb=void 0,e.$Hgb=(0,g.$Qh)("IUserDataSyncMachinesService");const p="sync.currentMachineName",y="Safari",h="Chrome",f="Edge",u="Firefox",d="Android";function E(n){switch(n){case y:case h:case f:case u:case d:case(0,L.$i)(0):return!0}return!1}e.$Igb=E;function s(){return L.$G?y:L.$E?h:L.$H?f:L.$F?u:L.$I?d:(0,L.$i)(L.$p?0:L.$u)}let o=class extends N.$Sc{static{$=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,a,v,w){super(),this.h=r,this.j=a,this.m=v,this.n=w,this.c=this.B(new I.$Od),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.$dp)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:s()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(i,t,r){const a=await this.s(r),v=a.machines.find(({id:w})=>w===i);if(v){v.name=t,await this.t(a);const w=await this.f;i===w&&this.h.store(p,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,a]of i){const v=t.machines.find(w=>w.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(p,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${s()} (${this.n.nameShort})`,a=new RegExp(`${(0,A.$Ge)(r)}\\s#(\\d+)`);let v=0;for(const w of i){const l=a.exec(w.name),m=l?parseInt(l[1]):0;v=m>v?m:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==$.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource($.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[$.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource($.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:$.a,machines:[]}}};e.$Jgb=o,e.$Jgb=o=$=ye([Y(0,R.$Xh),Y(1,k.$_j),Y(2,b.$0o),Y(3,c.$Ugb),Y(4,c.$0gb),Y(5,C.$qj)],o)}),define(oe[253],ae([0,1,6,63,38,7,3,2,5,19,10,172,25,21,22,24,79,82]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$15b=void 0;const f="sync.disableMachineEventually",u="sync.sessionId",d="sync.storeUrl",E="sync.productQuality";let s=class extends R.$Sc{get n(){const i=this.H.get(d,-1);return i?C.URI.parse(i):void 0}set n(i){i?this.H.store(d,i.toString(),-1,1):this.H.remove(d,-1)}get s(){return this.H.get(E,-1)}set s(i){i?this.H.store(E,i,-1,1):this.H.remove(E,-1)}constructor(i,t,r,a,v,w,l,m,D,T){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=w,this.D=l,this.F=m,this.G=D,this.H=T,this.a=this.B(new R.$Tc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$Od),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$Sg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$pg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(l.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(z=>this.triggerSync([z],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$fm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(u,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=p.$Zgb.toUserDataSyncError(i);t instanceof p.$2gb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?k.$p&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(f,!0,-1,1),await(0,I.$Vg)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(f,-1,!1)}R(){this.H.remove(f,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$15b=s,e.$15b=s=ye([Y(0,b.$qj),Y(1,p.$Tgb),Y(2,p.$Ugb),Y(3,p.$5gb),Y(4,p.$6gb),Y(5,p.$0gb),Y(6,y.$1Cb),Y(7,$.$dl),Y(8,h.$Hgb),Y(9,c.$0o)],s);class o extends R.$Sc{static{this.a="Interval"}constructor(i,t,r,a,v,w,l,m,D){super(),this.m=i,this.n=t,this.r=r,this.s=a,this.u=v,this.w=w,this.y=l,this.z=m,this.C=D,this.b=this.B(new R.$Tc),this.c=this.B(new O.$Od),this.onDidStartSync=this.c.event,this.f=this.B(new O.$Od),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Qc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,I.$Wg)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,I.$Ig)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,A.$4)(v))return}return this.H(i,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$pg)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,g.$pg)(t.defaultUrl,i.defaultUrl)||!(0,g.$pg)(t.insidersUrl,i.insidersUrl)||!(0,g.$pg)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,p.$Zgb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(w){this.y.error(w),a=w}}this.f.fire(a)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$2gb((0,S.localize)(0,null),"DefaultServiceChanged"):new p.$2gb((0,S.localize)(1,null),"ServiceChanged"):new p.$2gb((0,S.localize)(2,null),"TurnedOff");const r=this.C.get(u,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$2gb((0,S.localize)(3,null),"DefaultServiceChanged"):new p.$2gb((0,S.localize)(4,null),"ServiceChanged"):new p.$2gb((0,S.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(l=>l.isCurrent);if(v?.disabled)throw new p.$2gb((0,S.localize)(6,null),"TurnedOff");const w=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-w}),this.g===null)try{this.g=await this.s.manifest(null)}catch(l){throw new p.$2gb((0,L.$Bi)(l),l instanceof p.$Zgb?l.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(u,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(oe[254],ae([0,1,10,176,14,11,43,21,28,24,17,39,118,117,116,20,119,114,115,4,120,41,27]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d,E,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,w,l,m,D,T,z){this.e=t,this.f=r,this.g=a,this.h=w,this.i=l,this.j=m,this.k=D,this.l=T,this.n=z,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,d.$Y5b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,d.$Y5b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(w=>({...w,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:w})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:w,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:w,ref:l})=>({created:w,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:l,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,O.$dp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,w){if(t){const{content:l}=await this.M(r,v,a);return l}return this.f.resolveResourceContent(r,v,a,w)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,c.$$3b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,$.$83b)(t.content,!!this.l.getValue(g.$Ngb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,y.$g4b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const w=(0,b.$d4b)(v),l=[];for(const m of Object.keys(w)){const D=this.d.joinPath(t,m),T=r?this.d.joinPath(r.snippetsHome,m):this.d.joinPath(t,o.a);l.push({resource:D,comparableResource:T})}return l}}return[]}z(t,r){return(0,b.$d4b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,h.$33b)((0,h.$23b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(h.$53b).getLocalExtensions(t);return(0,h.$33b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,f.$wEb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(f.$yEb).getLocalGlobalState(t);return(0,f.$wEb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,E.$aT)(JSON.parse(t.content),{})}return null}async I(t){return(0,d.$X5b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,s.$Je)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(I.URI.from({scheme:g.$_gb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==g.$_gb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let v,w;const l=[];let m,D,T,z,U;for(;r.length;){const B=r.shift();B.startsWith("scheme:")?v=B.substring(7):B.startsWith("authority:")?w=B.substring(10):B.startsWith("syncResource:")?m=B.substring(13):B.startsWith("profile:")?D=B.substring(8):B.startsWith("collection:")?T=B.substring(11):B.startsWith("ref:")?z=B.substring(4):m?U=B:l.push(B)}return{remote:a,syncResource:m,profile:D,collection:T,ref:z,node:U,location:v&&w!==void 0?this.d.joinPath(I.URI.from({scheme:v,authority:w,query:t.query,fragment:t.fragment,path:"/"}),...l):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,S.$pEb)(a))return a}catch(a){this.g.error(a)}throw new g.$Zgb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$y6b=n,e.$y6b=n=o=ye([Y(0,g.$Ugb),Y(1,g.$Vgb),Y(2,g.$0gb),Y(3,k.$Jk),Y(4,L.$Xh),Y(5,R.$0o),Y(6,A.$_j),Y(7,C.$Lk),Y(8,p.$ki),Y(9,u.$Ph)],n)}),define(oe[255],ae([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,114,115,116,117,118,119,120,24]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d,E,s,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z5b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Sc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(m,D,T,z,U,B,Z,Q,x,W,X){super(),this.C=m,this.D=D,this.F=T,this.G=z,this.H=U,this.I=B,this.J=Z,this.L=Q,this.M=x,this.N=W,this.O=X,this.f="uninitialized",this.g=this.B(new O.$Od),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$Od),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$Od),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$Od),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$Od),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$Od),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$Od),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=T.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Qc)(()=>this.bb()))}async createSyncTask(m,D){this.cb(),this.H.info("Sync started.");const T=new Date().getTime(),z=(0,C.$fg)();try{const Q=(0,i.$Ygb)(z);D&&(Q["Cache-Control"]="no-cache"),m=await this.D.manifest(m,Q)}catch(Q){const x=i.$Zgb.toUserDataSyncError(Q);throw w(x,z,this.F,this.I),x}const U=!1,B=this;let Z;return{manifest:m,async run(){if(U)throw new Error("Can run a task only once");Z=(0,N.$Ig)(Q=>B.P(m,!1,z,Q)),await Z.finally(()=>Z=void 0),B.H.info(`Sync done. Took ${new Date().getTime()-T}ms`),B.$()},stop(){return Z?.cancel(),B.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$Zgb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const m=new Date().getTime(),D=(0,C.$fg)(),T=(0,i.$Ygb)(D);let z;try{z=await this.D.manifest(null,T)}catch(Z){const Q=i.$Zgb.toUserDataSyncError(Z);throw w(Q,D,this.F,this.I),Q}await this.resetLocal();const U=this,B=new L.$Yd;return{id:D,async merge(){return U.P(z,!0,D,B.token)},async apply(){try{try{await U.R(z,D,B.token)}catch(Z){if(i.$Zgb.toUserDataSyncError(Z).code==="MethodNotFound")U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(z,D,B.token);else throw Z}}catch(Z){throw U.H.error(Z),Z}U.H.info(`Sync done. Took ${new Date().getTime()-m}ms`),U.$()},async stop(){B.cancel(),await U.U(),await U.resetLocal()}}}async P(m,D,T,z){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,m,D,T,z));const B=U.enabled.find(Z=>Z.resource==="profiles");if(B){const Z=await B.getLastSyncedProfiles()||[];if(z.isCancellationRequested)return;await this.Q(Z,m,D,T,z)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(m,D,T,z,U){for(const B of m){if(U.isCancellationRequested)return;const Z=this.M.profiles.find(x=>x.id===B.id);if(!Z){this.H.error(`Profile with id:${B.id} and name: ${B.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",B.name);const Q=this.getOrCreateActiveProfileSynchronizer(Z,B);this.n.push(...await this.S(Q,D,T,z,U))}for(const[B,Z]of this.z.entries())this.M.profiles.some(Q=>Q.id===Z[0].profile.id)||(Z[1].dispose(),this.z.delete(B))}async R(m,D,T){const z=this.ab();for(const x of z){if(T.isCancellationRequested)return;await x.apply(D,T)}const U=z.find(x=>x.profile.isDefault);if(!U)return;const B=U.enabled.find(x=>x.resource==="profiles");if(!B)return;const Q=(await B.getRemoteSyncedProfiles(m?.latest??null)||[]).filter(x=>z.every(W=>W.profile.id!==x.id));Q.length&&await this.Q(Q,m,!1,D,T)}async S(m,D,T,z,U){return(await m.sync(D,T,z,U)).map(([Z,Q])=>({profile:m.profile,syncResource:Z,error:Q}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(m=>m.stop()))}async resolveContent(m){const D=await this.N.resolveContent(m);if(D)return D;for(const T of this.ab())for(const z of T.enabled){const U=await z.resolveContent(m);if(U)return U}return null}async replace(m){this.cb();const D=this.N.resolveUserDataSyncResource(m);if(!D)return;const T=await this.resolveContent(m.uri);T&&await this.W(D.profile,async z=>{if(D.syncResource===z.resource)return await z.replace(T),!0})}async accept(m,D,T,z){this.cb(),await this.W(m.profile,async U=>{if(m.syncResource===U.resource)return await U.accept(D,T),z&&await U.apply((0,g.$Ff)(z)?!1:z.force,(0,i.$Ygb)((0,C.$fg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async D=>{if(D.resource!=="globalState"&&await D.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async D=>{if(await D.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(m){this.H.error(m)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[m]of this.z.values())try{await m.resetLocal()}catch(D){this.H.error(D)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const m=await this.N.getRemoteSyncedProfiles(),D=m.map(B=>B.collection),T=await this.D.getAllCollections(),z=T.filter(B=>!D.includes(B));z.length&&(this.H.info(`Deleting ${z.length} redundant collections on server`),await Promise.allSettled(z.map(B=>this.D.deleteCollection(B))),this.H.info("Deleted redundant collections on server"));const U=m.filter(B=>T.includes(B.collection));if(U.length!==m.length){const B=this.G.createInstance(n.$W5b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await B.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await B.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{B.dispose()}}}async saveRemoteActivityData(m){this.cb();const D=await this.D.getActivityData();await this.C.writeFile(m,D)}async extractActivityData(m,D){const T=(await this.C.readFile(m)).value.toString(),z=JSON.parse(T);if(z.resources)for(const U in z.resources)for(const B of z.resources[U])await this.O.writeResource(U,B.content,new Date(B.created*1e3),void 0,D);if(z.collections)for(const U in z.collections)for(const B in z.collections[U].resources)for(const Z of z.collections[U].resources?.[B]??[])await this.O.writeResource(B,Z.content,new Date(Z.created*1e3),U,D)}async W(m,D){const T=new R.$Rc;try{const z=this.z.get(m.id);if(z){const x=await this.X(z[0],D,T);return(0,g.$Gf)(x)?null:x}if(m.isDefault){const x=T.add(this.G.createInstance(a,m,void 0)),W=await this.X(x,D,T);return(0,g.$Gf)(W)?null:W}if(this.M.isEnabled())return null;const U=T.add(this.G.createInstance(n.$W5b,m,void 0)),B=await this.D.manifest(null),Q=(await U.getRemoteSyncedProfiles(B?.latest??null)||[]).find(x=>x.id===m.id);if(Q){const x=T.add(this.G.createInstance(a,m,Q.collection)),W=await this.X(x,D,T);return(0,g.$Gf)(W)?null:W}return null}finally{T.dispose()}}async X(m,D,T){const z=[...m.enabled,...m.disabled.reduce((U,B)=>(B!=="workspaceState"&&U.push(T.add(m.createSynchronizer(B))),U),[])];for(const U of z){const B=await D(U);if(!(0,g.$Gf)(B))return B}}Y(m){const D=this.f;this.f!==m&&(this.f=m,this.g.fire(m),D==="hasConflicts"&&this.$())}Z(){const m=this.ab().map(D=>D.conflicts).flat();(0,I.$ub)(this.j,m,(D,T)=>D.profile.id===T.profile.id&&D.syncResource===T.syncResource&&(0,I.$ub)(D.conflicts,T.conflicts,(z,U)=>(0,k.$pg)(z.previewResource,U.previewResource)))||(this.j=m,this.m.fire(m))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(m,D){let T=this.z.get(m.id);if(T&&T[0].collection!==D?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.z.delete(m.id)),!T){const z=new R.$Rc,U=z.add(this.G.createInstance(a,m,D?.collection));z.add(U.onDidChangeStatus(B=>this.Y(B))),z.add(U.onDidChangeConflicts(B=>this.Z())),z.add(U.onDidChangeLocal(B=>this.h.fire(B))),this.z.set(m.id,T=[U,z])}return T[0]}ab(){const m=[];for(const[D]of this.z.values())m.push(D);return m}bb(){this.z.forEach(([,m])=>m.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$Z5b=r,e.$Z5b=r=ye([Y(0,c.$_j),Y(1,i.$Ugb),Y(2,i.$Tgb),Y(3,$.$Ph),Y(4,i.$0gb),Y(5,y.$dl),Y(6,p.$0o),Y(7,i.$5gb),Y(8,h.$Lk),Y(9,i.$7gb),Y(10,i.$Vgb)],r);let a=class extends R.$Sc{get enabled(){return this.f.sort((m,D)=>m[1]-D[1]).map(([m])=>m)}get disabled(){return i.$Qgb.filter(m=>!this.r.isResourceEnabled(m))}get status(){return this.g}get conflicts(){return this.m}constructor(m,D,T,z,U,B,Z,Q,x,W){super(),this.profile=m,this.collection=D,this.r=T,this.t=z,this.u=U,this.w=B,this.y=Z,this.z=Q,this.C=x,this.D=W,this.f=[],this.g="idle",this.h=this.B(new O.$Od),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$Od),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$Od),this.onDidChangeConflicts=this.n.event,this.B(T.onDidChangeResourceEnablement(([X,G])=>this.F(X,G))),this.B((0,R.$Qc)(()=>this.f.splice(0,this.f.length).forEach(([,,X])=>X.dispose())));for(const X of i.$Qgb)T.isResourceEnabled(X)&&this.G(X)}F(m,D){D?this.G(m):this.H(m)}G(m){if(this.f.some(([U])=>U.resource===m))return;if(m==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(m==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||m==="workspaceState")return;if(m!=="profiles"&&this.profile.useDefaultFlags?.[m]){this.z.debug(`Skipping syncing ${m} in ${this.profile.name} because it is already synced by default profile`);return}const D=new R.$Rc,T=D.add(this.createSynchronizer(m));D.add(T.onDidChangeStatus(()=>this.L())),D.add(T.onDidChangeConflicts(()=>this.M())),D.add(T.onDidChangeLocal(()=>this.j.fire(m)));const z=this.N(m);this.f.push([T,z,D])}H(m){const D=this.f.findIndex(([T])=>T.resource===m);if(D!==-1){const[[T,,z]]=this.f.splice(D,1);z.dispose(),this.L(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,U=>this.z.error(U))}}createSynchronizer(m){switch(m){case"settings":return this.t.createInstance(E.$_3b,this.profile,this.collection);case"keybindings":return this.t.createInstance(d.$93b,this.profile,this.collection);case"snippets":return this.t.createInstance(s.$e4b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$h4b,this.profile,this.collection);case"globalState":return this.t.createInstance(u.$xEb,this.profile,this.collection);case"extensions":return this.t.createInstance(f.$43b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$W5b,this.profile,this.collection)}}async sync(m,D,T,z){if(z.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const B=[],Z=(0,i.$Ygb)(T),Q=(this.collection?m?.collections?.[this.collection]?.latest:m?.latest)??null,x=D?await this.I(Q):{};for(const W of U){if(z.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(D){const X=await W.preview(Q,x,Z);if(X)for(const G of X.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await W.merge(G.previewResource)}else await W.sync(Q,Z)}catch(X){const G=i.$Zgb.toUserDataSyncError(X);if(w(G,T,this.w,this.y),v(X))throw G;this.z.error(X),this.z.error(`${W.resource}: ${(0,A.$Bi)(X)}`),B.push([W.resource,G])}}return B}finally{this.L()}}async apply(m,D){const T=(0,i.$Ygb)(m);for(const z of this.enabled){if(D.isCancellationRequested)return;try{await z.apply(!1,T)}catch(U){const B=i.$Zgb.toUserDataSyncError(U);if(w(B,m,this.w,this.y),v(U))throw B;this.z.error(U),this.z.error(`${z.resource}: ${(0,A.$Bi)(U)}`)}}}async stop(){for(const m of this.enabled)try{m.status!=="idle"&&await m.stop()}catch(D){this.z.error(D)}}async resetLocal(){for(const m of this.enabled)try{await m.resetLocal()}catch(D){this.z.error(`${m.resource}: ${(0,A.$Bi)(D)}`),this.z.error(D)}}async I(m){if(!this.profile.isDefault)return{};const D=this.D.getValue(i.$Mgb),T=this.enabled.find(z=>z instanceof E.$_3b);if(T){const z=await T.getRemoteUserDataSyncConfiguration(m);return{...D,...z}}return D}J(m){this.g!==m&&(this.g=m,this.h.fire(m))}L(){return this.M(),this.enabled.some(m=>m.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(m=>m.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const m=this.enabled.filter(D=>D.status==="hasConflicts").filter(D=>D.conflicts.conflicts.length>0).map(D=>D.conflicts);(0,I.$ub)(this.m,m,(D,T)=>D.syncResource===T.syncResource&&(0,I.$ub)(D.conflicts,T.conflicts,(z,U)=>(0,k.$pg)(z.previewResource,U.previewResource)))||(this.m=m,this.n.fire(m))}N(m){switch(m){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([Y(2,i.$5gb),Y(3,$.$Ph),Y(4,b.$bo),Y(5,i.$Tgb),Y(6,y.$dl),Y(7,i.$0gb),Y(8,h.$Lk),Y(9,S.$ki)],a);function v(l){if(l instanceof i.$Zgb)switch(l.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(l,m,D,T){T.publicLog2("sync/error",{code:l.code,serverCode:l instanceof i.$1gb?String(l.serverCode):void 0,url:l instanceof i.$1gb?l.url:void 0,resource:l.resource,executionId:m,service:D.userDataSyncStore.url.toString()})}}),define(oe[256],ae([0,1,3,2,10,17,24]),function(te,e,I,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l9b=e.$k9b=void 0;function R(b,c){return{...b,profile:(0,A.$Mk)(b.profile,c.profilesHome.scheme)}}function k(b){return{created:b.created,uri:L.URI.revive(b.uri)}}class g{constructor(c,$,p){this.c=c,this.d=$,this.f=p,this.a=new Map,this.b=new I.$Od}listen(c,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${$}`)}async call(c,$,p){try{return await this.g(c,$,p)}catch(y){throw this.f.error(y),y}}async g(c,$,p){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(p[0]));case"accept":return this.c.accept(R(p[0],this.d),L.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(k(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(p[0]),L.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const y=$.substring(11),h=p[0],f=this.h(h);switch(p=p.slice(1),y){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.a.delete(this.j(f.id)));case"stop":return f.stop().finally(()=>this.a.delete(this.j(f.id)))}}throw new Error("Invalid call")}h(c){const $=this.a.get(this.j(c));if(!$)throw new Error(`Manual sync taks not found: ${c}`);return $}async i(){const c=await this.c.createManualSyncTask();return this.a.set(this.j(c.id),c),c.id}j(c){return`manualSyncTask-${c}`}}e.$k9b=g;let C=class extends N.$Sc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(c,$){super(),this.n=$,this.b="uninitialized",this.c=this.B(new I.$Od),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$Od),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$Od),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$Od),this.onSyncErrors=this.m.event,this.a={call(p,y,h){return c.call(p,y,h).then(null,f=>{throw O.$Zgb.toUserDataSyncError(f)})},listen(p,y){return c.listen(p,y)}},this.a.call("_getInitialData").then(([p,y,h])=>{this.s(p),this.t(y),h&&this.u(h),this.B(this.a.listen("onDidChangeStatus")(f=>this.s(f))),this.B(this.a.listen("onDidChangeLastSyncTime")(f=>this.u(f)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(y=>({...y,error:O.$Zgb.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.a.call("createManualSyncTask"),$=this;return new S(c,{async call(y,h,f){return $.a.call(`manualSync/${y}`,[c,...Array.isArray(h)?h:[h]],f)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(c,$,p,y){return this.a.call("accept",[c,$,p,y])}resolveContent(c){return this.a.call("resolveContent",[c])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(c){return this.a.call("replace",[c])}saveRemoteActivityData(c){return this.a.call("getRemoteActivityData",[c])}extractActivityData(c,$){return this.a.call("extractActivityData",[c,$])}async s(c){this.b=c,this.c.fire(c)}async t(c){this.f=c.map($=>({syncResource:$.syncResource,profile:(0,A.$Mk)($.profile,this.n.profilesHome.scheme),conflicts:$.conflicts.map(p=>({...p,baseResource:L.URI.revive(p.baseResource),localResource:L.URI.revive(p.localResource),remoteResource:L.URI.revive(p.remoteResource),previewResource:L.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(c){this.h!==c&&(this.h=c,this.j.fire(c))}};e.$l9b=C,e.$l9b=C=ye([Y(1,A.$Lk)],C);class S extends N.$Sc{constructor(c,$){super(),this.id=c,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[257],ae([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,57,43,21,24]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nEb=e.$mEb=e.$lEb=e.$kEb=e.$jEb=void 0;const E="configurationSync.store",s="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends O.$Sc{get userDataSyncStore(){return this.b}get c(){return this.h.get(d.$3gb,-1)}set c(T){this.h.store(d.$3gb,T,-1,k.$p?0:1)}constructor(T,z,U){super(),this.f=T,this.g=z,this.h=U,this.a=this.B(new A.$Od),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const B=this.B(new O.$Rc);this.B(A.Event.filter(U.onDidChangeValue(-1,d.$3gb,B),()=>this.c!==this.userDataSyncStore?.type,B)(()=>this.j()))}j(){this.b=this.m(this.f[E]),this.a.fire()}m(T){if(T&&(T=k.$p&&T.web?{...T,...T.web}:T,(0,C.$zf)(T.url)&&(0,C.$Bf)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(z=>Array.isArray(T.authenticationProviders[z].scopes)))){const z=T,U=!!z.canSwitch,B=z.url===z.insidersUrl?"insiders":"stable",Z=(U?this.c:void 0)||B,Q=Z==="insiders"?z.insidersUrl:Z==="stable"?z.stableUrl:z.url;return{url:S.URI.parse(Q),type:Z,defaultType:B,defaultUrl:S.URI.parse(z.url),stableUrl:S.URI.parse(z.stableUrl),insidersUrl:S.URI.parse(z.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(z.authenticationProviders).reduce((x,W)=>(x.push({id:W,scopes:z.authenticationProviders[W].scopes}),x),[])}}}};e.$jEb=a,e.$jEb=a=ye([Y(0,y.$qj),Y(1,c.$ki),Y(2,u.$0o)],a);let v=class extends a{constructor(T,z,U){super(T,z,U);const B=this.h.get(s,-1);B&&(this.n=JSON.parse(B));const Z=this.f[E];Z?this.h.store(s,JSON.stringify(Z),-1,1):this.h.remove(s,-1)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$kEb=v,e.$kEb=v=ye([Y(0,y.$qj),Y(1,c.$ki),Y(2,u.$0o)],v);let w=class extends O.$Sc{get donotMakeRequestsUntil(){return this.j}constructor(T,z,U,B,Z,Q,x){super(),this.n=U,this.r=B,this.s=x,this.g=this.B(new A.$Od),this.onTokenFailed=this.g.event,this.h=this.B(new A.$Od),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$Od),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,f.$dp)(Z,Q,x).then(W=>{const X={"X-Client-Name":`${z.applicationName}${k.$p?"-web":""}`,"X-Client-Version":z.version};return z.commit&&(X["X-Client-Commit"]=z.commit),X}),this.f=new m(t,r,this.n,this.r),this.u(),this.B((0,O.$Qc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,z){this.b={token:T,type:z}}t(T){this.a=T?(0,g.$wg)(T,"v1"):void 0}u(){const T=this.s.getNumber(o,-1);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,I.$Ig)(z=>(0,I.$Vg)(this.j.getTime()-Date.now(),z).then(()=>this.y(void 0))),this.w.then(null,z=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,g.$wg)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const U=await this.D(z,{type:"GET",headers:T},[],N.CancellationToken.None);return(await(0,h.$3o)(U))?.map(({id:B})=>B)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,g.$wg)(this.a,"collection").toString();T={...T},T["Content-Type"]=R.$Tr.text;const U=await this.D(z,{type:"POST",headers:T},[],N.CancellationToken.None),B=await(0,h.$2o)(U);if(!B)throw new d.$1gb("Server did not return the collection id",z,"NoCollection",U.res.statusCode,U.res.headers[d.$Wgb]);return B}async deleteCollection(T,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=T?(0,g.$wg)(this.a,"collection",T).toString():(0,g.$wg)(this.a,"collection").toString();z={...z},await this.D(U,{type:"DELETE",headers:z},[],N.CancellationToken.None)}async getAllResourceRefs(T,z){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,z,T),B={},Z=await this.D(U.toString(),{type:"GET",headers:B},[],N.CancellationToken.None);return(await(0,h.$3o)(Z)||[]).map(({url:x,created:W})=>({ref:(0,g.$yg)(U,U.with({path:x})),created:W*1e3}))}async resolveResourceContent(T,z,U,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$wg)(this.z(this.a,U,T),z).toString();B={...B},B["Cache-Control"]="no-cache";const Q=await this.D(Z,{type:"GET",headers:B},[],N.CancellationToken.None);return await(0,h.$2o)(Q)}async deleteResource(T,z,U){if(!this.a)throw new Error("No settings sync store url configured.");const B=z!==null?(0,g.$wg)(this.z(this.a,U,T),z).toString():this.z(this.a,U,T).toString(),Z={};await this.D(B,{type:"DELETE",headers:Z},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,g.$wg)(this.a,"resource").toString(),z={"Content-Type":R.$Tr.text};await this.D(T,{type:"DELETE",headers:z},[],N.CancellationToken.None)}async readResource(T,z,U,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$wg)(this.z(this.a,U,T),"latest").toString();B={...B},B["Cache-Control"]="no-cache",z&&(B["If-None-Match"]=z.ref);const Q=await this.D(Z,{type:"GET",headers:B},[304],N.CancellationToken.None);let x=null;if(Q.res.statusCode===304&&(x=z),x===null){const W=Q.res.headers.etag;if(!W)throw new d.$1gb("Server did not return the ref",Z,"NoRef",Q.res.statusCode,Q.res.headers[d.$Wgb]);const X=await(0,h.$2o)(Q);if(!X&&Q.res.statusCode===304)throw new d.$1gb("Empty response",Z,"EmptyResponse",Q.res.statusCode,Q.res.headers[d.$Wgb]);x={ref:W,content:X}}return x}async writeResource(T,z,U,B,Z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=this.z(this.a,B,T).toString();Z={...Z},Z["Content-Type"]=R.$Tr.text,U&&(Z["If-Match"]=U);const x=await this.D(Q,{type:"POST",data:z,headers:Z},[],N.CancellationToken.None),W=x.res.headers.etag;if(!W)throw new d.$1gb("Server did not return the ref",Q,"NoRef",x.res.statusCode,x.res.headers[d.$Wgb]);return W}async manifest(T,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,g.$wg)(this.a,"manifest").toString();z={...z},z["Content-Type"]="application/json",T&&(z["If-None-Match"]=T.ref);const B=await this.D(U,{type:"GET",headers:z},[304],N.CancellationToken.None);let Z=null;if(B.res.statusCode===304&&(Z=T),!Z){const x=B.res.headers.etag;if(!x)throw new d.$1gb("Server did not return the ref",U,"NoRef",B.res.statusCode,B.res.headers[d.$Wgb]);const W=await(0,h.$2o)(B);if(!W&&B.res.statusCode===304)throw new d.$1gb("Empty response",U,"EmptyResponse",B.res.statusCode,B.res.headers[d.$Wgb]);W&&(Z={...JSON.parse(W),ref:x})}const Q=this.s.get(n,-1);return Q&&Z&&Q!==Z.session&&this.C(),Z===null&&Q&&this.C(),Z&&this.s.store(n,Z.session,-1,1),Z}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,g.$wg)(this.a,"download").toString(),z={},U=await this.D(T,{type:"GET",headers:z},[],N.CancellationToken.None);if(!(0,h.$Yo)(U))throw new d.$1gb("Server returned "+U.res.statusCode,T,"EmptyResponse",U.res.statusCode,U.res.headers[d.$Wgb]);if((0,h.$Zo)(U))throw new d.$1gb("Empty response",T,"EmptyResponse",U.res.statusCode,U.res.headers[d.$Wgb]);return U.stream}z(T,z,U){return z?(0,g.$wg)(T,"collection",z,"resource",U):(0,g.$wg)(T,"resource",U)}C(){this.s.remove(n,-1),this.s.remove(i,-1)}async D(T,z,U,B){if(!this.b)throw new d.$1gb("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new d.$1gb(`${z.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Z=await this.c;z.headers={...z.headers||{},...Z,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(z.headers),this.r.trace("Sending request to server",{url:T,type:z.type,headers:{...z.headers,authorization:void 0}});let Q;try{Q=await this.f.request(T,z,B)}catch(V){if(!(V instanceof d.$1gb)){let ee="RequestFailed";const ie=(0,L.$0)(V).toLowerCase();ie.includes("xhr timeout")?ee="RequestTimeout":ie.includes("protocol")&&ie.includes("not supported")?ee="RequestProtocolNotSupported":ie.includes("request path contains unescaped characters")?ee="RequestPathNotEscaped":ie.includes("headers must be an object")?ee="RequestHeadersNotObject":(0,L.$4)(V)&&(ee="RequestCanceled"),V=new d.$1gb(`Connection refused for the request '${T}'.`,T,ee,void 0,void 0)}throw this.r.info("Request failed",T),V}const x=Q.res.headers[d.$Wgb],W={url:T,status:Q.res.statusCode,"execution-id":z.headers[d.$Xgb],"operation-id":x},X=(0,h.$Yo)(Q)||Q.res.statusCode&&U.includes(Q.res.statusCode);let G="";if(X?this.r.trace("Request succeeded",W):(G=await(0,h.$1o)(Q)||"",this.r.info("Request failed",W,G)),Q.res.statusCode===401||Q.res.statusCode===403){if(this.b=void 0,Q.res.statusCode===401)throw this.g.fire("Unauthorized"),new d.$1gb(`${z.type} request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",Q.res.statusCode,x);if(Q.res.statusCode===403)throw this.g.fire("Forbidden"),new d.$1gb(`${z.type} request '${T}' failed because the access is forbidden (403).`,T,"Forbidden",Q.res.statusCode,x)}if(this.h.fire(),Q.res.statusCode===404)throw new d.$1gb(`${z.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",Q.res.statusCode,x);if(Q.res.statusCode===405)throw new d.$1gb(`${z.type} request '${T}' failed because the requested endpoint is not found (405). ${G}`,T,"MethodNotFound",Q.res.statusCode,x);if(Q.res.statusCode===409)throw new d.$1gb(`${z.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",Q.res.statusCode,x);if(Q.res.statusCode===410)throw new d.$1gb(`${z.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",Q.res.statusCode,x);if(Q.res.statusCode===412)throw new d.$1gb(`${z.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",Q.res.statusCode,x);if(Q.res.statusCode===413)throw new d.$1gb(`${z.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",Q.res.statusCode,x);if(Q.res.statusCode===426)throw new d.$1gb(`${z.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",Q.res.statusCode,x);if(Q.res.statusCode===429){const V=Q.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new d.$1gb(`${z.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",Q.res.statusCode,x)):new d.$1gb(`${z.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",Q.res.statusCode,x)}if(!X)throw new d.$1gb("Server returned "+Q.res.statusCode,T,"Unknown",Q.res.statusCode,x);return Q}F(T){let z=this.s.get(i,-1);z===void 0&&(z=(0,b.$fg)(),this.s.store(i,z,-1,1)),T["X-Machine-Session-Id"]=z;const U=this.s.get(n,-1);U!==void 0&&(T["X-User-Session-Id"]=U)}};e.$lEb=w,e.$lEb=w=ye([Y(1,y.$qj),Y(2,h.$Wo),Y(3,d.$0gb),Y(4,$.$Xh),Y(5,p.$_j),Y(6,u.$0o)],w);let l=class extends w{constructor(T,z,U,B,Z,Q,x){super(T.userDataSyncStore?.url,z,U,B,Z,Q,x),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$mEb=l,e.$mEb=l=ye([Y(0,d.$Tgb),Y(1,y.$qj),Y(2,h.$Wo),Y(3,d.$0gb),Y(4,$.$Xh),Y(5,p.$_j),Y(6,u.$0o)],l);class m{constructor(T,z,U,B){this.c=T,this.d=z,this.f=U,this.g=B,this.a=[],this.b=void 0}request(T,z,U){if(this.h()&&this.i(),z.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new d.$1gb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(z,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$nEb=m}),define(oe[258],ae([0,1,3,55,25,21,22,253,24,79,82]),function(te,e,I,N,L,A,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F9b=void 0;let S=class extends R.$15b{constructor(c,$,p,y,h,f,u,d,E,s,o){super(c,$,p,y,h,u,d,E,s,o),this.B(I.Event.debounce(I.Event.any(I.Event.map(f.onDidFocusWindow,()=>"windowFocus"),I.Event.map(f.onDidOpenWindow,()=>"windowOpen")),(n,i)=>n?[...n,i]:[i],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$F9b=S,e.$F9b=S=ye([Y(0,L.$qj),Y(1,k.$Tgb),Y(2,k.$Ugb),Y(3,k.$5gb),Y(4,k.$6gb),Y(5,N.$w7b),Y(6,k.$0gb),Y(7,g.$1Cb),Y(8,O.$dl),Y(9,C.$Hgb),Y(10,A.$0o)],S)}),define(oe[259],ae([0,1,70,23,5,19]),function(te,e,I,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=e.$46b=e.$36b=e.$26b=void 0,e.$26b=128/4;function O(g){function C(){let S=g.scheme===N.Schemas.file?(0,A.$kg)(g):g.toString();return L.$l||(S=S.toLowerCase()),(0,I.createHash)("md5").update(S).digest("hex")}return{id:C(),configPath:g}}e.$36b=O;function R(g,C){function S(){if(g.scheme!==N.Schemas.file)return(0,I.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let c;return L.$l?c=C.ino:L.$k?c=C.birthtime.getTime():L.$j&&(typeof C.birthtimeMs=="number"?c=Math.floor(C.birthtimeMs):c=C.birthtime.getTime()),(0,I.createHash)("md5").update(g.fsPath).update(c?String(c):"").digest("hex")}const b=S();if(typeof b=="string")return{id:b,uri:g}}e.$46b=R;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$56b=k}),define(oe[260],ae([0,1,6,7,2,16,31,14,8,76,112,259,55,72,23]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_8b=void 0;let p=class extends L.$Sc{constructor(h,f,u,d){super(),this.a=h,this.b=f,this.c=u,this.f=d,this.B(new I.$7g(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=this.a.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,f=await O.Promises.readdir(h),u=new g.$zDb(this.f.getChannel("storage"));await Promise.all(f.map(async d=>{const E=(0,A.$jc)(h,d);d.length===S.$26b||d===C.$3h.id||(await this.c.getWindows()).some(n=>n.workspace?.id===d)||await u.isUsed(E)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await O.Promises.rm(E))}))}catch(h){(0,N.$1)(h)}}};e.$_8b=p,e.$_8b=p=ye([Y(0,R.$Yh),Y(1,k.$$i),Y(2,b.$w7b),Y(3,c.$K8b)],p)}),define(oe[83],ae([0,1,53,6,16,12,31,147,271,272]),function(te,e,I,N,L,A,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.zip=e.$pp=e.$op=void 0,e.$op="end of central directory record signature not found";const C=new RegExp(e.$op);class S extends Error{constructor(o,n){let i=n.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=n}}e.$pp=S;function b(s){const o=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>o&n).reduce((n,i)=>n+i,o&61440)}function c(s){if(s instanceof S)return s;let o;return C.test(s.message)&&(o="CorruptZip"),new S(o,s)}function $(s,o,n,i,t,r){const a=L.$mc(o),v=L.$jc(i,a);if(!v.startsWith(i))return Promise.reject(new Error(R.localize(0,null,o)));const w=L.$jc(i,o);let l;return r.onCancellationRequested(()=>{l?.destroy()}),Promise.resolve(O.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((m,D)=>{if(!r.isCancellationRequested)try{l=(0,I.createWriteStream)(w,{mode:n}),l.once("close",()=>m()),l.once("error",D),s.once("error",D),s.pipe(l)}catch(T){D(T)}}))}function p(s,o,n,i){let t=(0,N.$Ig)(()=>Promise.resolve()),r=0;const a=i.onCancellationRequested(()=>{t.cancel(),s.close()});return new Promise((v,w)=>{const l=new N.$Pg,m=D=>{D.isCancellationRequested||(r++,s.readEntry())};s.once("error",w),s.once("close",()=>t.then(()=>{i.isCancellationRequested||s.entryCount===r?v():w(new S("Incomplete",new Error(R.localize(1,null,r,s.entryCount))))},w)),s.readEntry(),s.on("entry",D=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(D.fileName)){m(i);return}const T=D.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(T)){const B=L.$jc(o,T);t=(0,N.$Ig)(Z=>O.Promises.mkdir(B,{recursive:!0}).then(()=>m(Z)).then(void 0,w));return}const z=h(s,D),U=b(D);t=(0,N.$Ig)(B=>l.queue(()=>z.then(Z=>$(Z,T,U,o,n,B).then(()=>m(B)))).then(null,w))})}).finally(()=>a.dispose())}function y(s,o=!1){return new Promise((n,i)=>{(0,k.open)(s,o?{lazyEntries:!0}:void 0,(t,r)=>{t?i(c(t)):n((0,A.$Kf)(r))})})}function h(s,o){return new Promise((n,i)=>{s.openReadStream(o,(t,r)=>{t?i(c(t)):n((0,A.$Kf)(r))})})}function f(s,o){return new Promise((n,i)=>{const t=new g.ZipFile;o.forEach(a=>{a.contents?t.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&t.addFile(a.localPath,a.path)}),t.end();const r=(0,I.createWriteStream)(s);t.outputStream.pipe(r),t.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>n(s))})}e.zip=f;function u(s,o,n={},i){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=y(s,!0);return n.overwrite&&(r=r.then(a=>O.Promises.rm(o).then(()=>a))),r.then(a=>p(a,o,{sourcePathRegex:t},i))}e.$rp=u;function d(s,o){return y(s).then(n=>new Promise((i,t)=>{n.on("entry",r=>{r.fileName===o&&h(n,r).then(a=>i(a),a=>t(a))}),n.once("close",()=>t(new Error(R.localize(2,null,o))))}))}function E(s,o){return d(s,o).then(n=>new Promise((i,t)=>{const r=[];n.once("error",t),n.on("data",a=>r.push(a)),n.on("end",()=>i(Buffer.concat(r)))}))}e.$sp=E}),define(oe[261],ae([0,1,6,7,2,23,19,54,12,32,31,83,20,14,29,33,97,11,8]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;let d=class extends L.$Sc{static{u=this}static{this.c=".sigzip"}constructor(s,o,n,i,t,r){super(),this.h=o,this.j=n,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,n){await this.g;const i=(0,O.$wg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new $.$co(r.message,$.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(s)){const r=await this.u(s);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${v.output}`),t===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new $.$co(S.$op,$.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${s.identifier.id}`),{location:i,verificationStatus:t}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,k.$Ff)(o)?o:!0}async u(s){await this.g;const o=(0,O.$wg)(this.extensionsDownloadDir,`${this.z(s)}${u.c}`);return await this.w(s,o,n=>this.j.downloadSignatureArchive(s,n)),o}async w(s,o,n){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await n(o);return}const i=(0,O.$wg)(this.extensionsDownloadDir,`.${(0,g.$fg)()}`);await this.h.exists(i)||await n(i);try{await C.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],n=[],i=[];for(const a of s.children)if(a.name.endsWith(u.c))i.push(a.resource);else{const v=p.$Eo.parse(a.name);v&&n.push([v,a])}const t=(0,p.$Jo)(n,([a])=>a),r=[];for(const a of t)a.sort((v,w)=>R.rcompare(v[0].version,w[0].version)),o.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...i),await I.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(s){this.r.error(s)}}z(s){return this.f?p.$Eo.create(s).toString().toLowerCase():(0,g.$fg)()}};e.$Hp=d,e.$Hp=d=u=ye([Y(0,c.$Yh),Y(1,h.$_j),Y(2,$.$bo),Y(3,b.$ki),Y(4,y.$ip),Y(5,f.$$i)],d)}),define(oe[262],ae([0,1,83,156]),function(te,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;function L(A){return(0,I.$sp)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$Jp=L}),define(oe[121],ae([0,1,6,15,26,38,7,3,52,2,34,23,16,19,54,12,10,32,31,83,155,96,14,241,29,33,51,80,261,242,262,211,222,68,11,4,8,25,22,28,17]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d,E,s,o,n,i,t,r,a,v,w,l,m,D,T,z,U,B,Z,Q,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.$Np=e.$Mp=void 0,e.$Mp=(0,z.$Rh)(n.$do);const W=".vsctmp";let X=class extends o.$tp{constructor(K,q,P,j,M,F,H,J,re,ce,ue,he){super(K,q,ue,P,ce,he),this.fb=M,this.gb=F,this.hb=H,this.ib=re,this.eb=new Map,this.rb=new C.$Bc;const $e=this.B(J.createInstance(v.$Ip));this.bb=this.B(J.createInstance(G,we=>$e.postUninstall(we))),this.cb=this.B(new l.$Kp(he,re,ue,this,this.F)),this.db=this.B(J.createInstance(a.$Hp));const de=this.B(new m.$Lp(this,this.fb,he,F,ue,re,P));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Oo)(this.ib,this.F)),this.jb}async zip(K){this.F.trace("ExtensionManagementService#zip",K.identifier.id);const q=await this.pb(K),P=await(0,u.zip)((0,c.$wg)(this.db.extensionsDownloadDir,(0,h.$fg)()).fsPath,q);return y.URI.file(P)}async unzip(K){return this.F.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:q,cleanup:P}=await this.lb(K),j=b.$kc(q.fsPath);try{return await(0,w.$Jp)(j)}finally{await P()}}getInstalled(K,q=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(K??null,q)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.bb.scanUserExtensionAtLocation(K)}async install(K,q={}){this.F.trace("ExtensionManagementService#install",K.toString());const{location:P,cleanup:j}=await this.lb(K);try{const M=await(0,w.$Jp)(b.$kc(P.fsPath)),F=(0,i.$Io)(M.publisher,M.name);if(M.engines&&M.engines.vscode&&!(0,D.$Vo)(M.engines.vscode,this.G.version,this.G.date))throw new Error(d.localize(0,null,F,this.G.version));const J=(await this.I([{manifest:M,extension:P,options:q}])).find(({identifier:re})=>(0,i.$Do)(re,{id:F}));if(J?.local)return J.local;throw J?.error?J.error:(0,o.$vp)(new Error(`Unknown error while installing extension ${F}`))}finally{await j()}}async installFromLocation(K,q){this.F.trace("ExtensionManagementService#installFromLocation",K.toString());const P=await this.bb.scanUserExtensionAtLocation(K);if(!P)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.ub([[P,void 0]],q),this.F.info("Successfully installed extension",P.identifier.id,q.toString()),P}async installExtensionsFromProfile(K,q,P){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",K,q.toString(),P.toString());const j=(await this.bb.scanExtensions(1,q)).filter(M=>K.some(F=>(0,i.$Do)(F,M.identifier)));if(j.length){const M=await Promise.all(j.map(F=>this.bb.scanMetadata(F,q)));await this.ub(j.map((F,H)=>[F,M[H]]),P),this.F.info("Successfully installed extensions",j.map(F=>F.identifier.id),P.toString())}return j}async updateMetadata(K,q,P=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",K.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),K=await this.bb.updateMetadata(K,q,P),this.cb.invalidate(P),this.w.fire(K),K}async reinstallFromGallery(K){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.z.isEnabled())throw new Error(d.localize(1,null));const q=await this.getTargetPlatform(),[P]=await this.z.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:q,compatible:!0},L.CancellationToken.None);if(!P)throw new Error(d.localize(2,null));await this.bb.setUninstalled(K);try{await this.bb.removeUninstalledExtension(K)}catch(j){throw new Error(d.localize(3,null,(0,A.$Bi)(j)))}return this.installFromGallery(P)}ab(K,q,P,j){return this.bb.copyExtension(K,q,P,j)}copyExtensions(K,q){return this.bb.copyExtensions(K,q)}markAsUninstalled(...K){return this.bb.setUninstalled(...K)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(K){this.F.error(K)}}async download(K,q,P){const{location:j}=await this.db.download(K,q,!P);return j}async lb(K){if(K.scheme===S.Schemas.file)return{location:K,async cleanup(){}};this.F.trace("Downloading extension from",K.toString());const q=(0,c.$wg)(this.db.extensionsDownloadDir,(0,h.$fg)());return await this.hb.download(K,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(j){this.F.error(j)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(K,q,P){if(y.URI.isUri(q))return new ie(K,q,P,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const j=i.$Eo.create(q).toString();let M=this.eb.get(j);return M||(this.eb.set(j,M=new ee(K,q,P,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),M.waitUntilTaskIsFinished().finally(()=>this.eb.delete(j))),M}$(K,q){return new _(K,q.profileLocation,this.gb)}async pb(K){const q=async j=>{let M=await f.Promises.readdir(j);M=M.map(J=>b.$jc(j,J));const F=await Promise.all(M.map(J=>f.Promises.stat(J)));let H=Promise.resolve([]);return F.forEach((J,re)=>{const ce=M[re];J.isFile()&&(H=H.then(ue=>[...ue,ce])),J.isDirectory()&&(H=H.then(ue=>q(ce).then(he=>[...ue,...he])))}),H};return(await q(K.location.fsPath)).map(j=>({path:`extension/${b.$lc(K.location.fsPath,j)}`,localPath:j}))}async qb({added:K,removed:q}){if(q){const P=K&&this.D.extUri.isEqual(q.profileLocation,K.profileLocation)?q.extensions.filter(j=>K.extensions.every(M=>!(0,i.$Do)(M,j))):q.extensions;for(const j of P)this.F.info("Extensions removed from another source",j.id,q.profileLocation.toString()),this.u.fire({identifier:j,profileLocation:q.profileLocation})}if(K){const j=(await this.bb.scanExtensions(1,K.profileLocation)).filter(M=>K.extensions.some(F=>(0,i.$Do)(F,M.identifier)));this.s.fire(j.map(M=>(this.F.info("Extensions added from another source",M.identifier.id,K.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:K.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(q=>this.rb.add(q)));const K=await this.ib.resolve(this.fb.userExtensionsLocation);for(const q of K.children??[])q.isDirectory&&this.rb.add(q.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.tb(q)))}async tb(K){if(!K.affects(this.fb.userExtensionsLocation,1))return;const q=[];for(const P of K.rawAdded){if(this.rb.has(P)||!this.D.extUri.isEqual(this.D.extUri.dirname(P),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(P,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(P).startsWith(".")||!(await this.ib.stat(P)).isDirectory)continue;const j=await this.bb.scanUserExtensionAtLocation(P);j&&j.installedTimestamp===void 0&&(this.rb.add(P),q.push(j))}q.length&&(await this.ub(q.map(P=>[P,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(P=>P.identifier.id)))}async ub(K,q){const P=K.map(j=>j[0]);await this.vb(P),await this.gb.addExtensionsToProfile(K,q),this.s.fire(P.map(j=>({local:j,identifier:j.identifier,operation:1,profileLocation:q})))}async vb(K){const q=await this.bb.getUninstalledExtensions();for(const P of K){const j=i.$Eo.create(P);q[j.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",j.id),await this.bb.setInstalled(j),this.F.info("Removed the extension from uninstalled list:",j.id))}}};e.$Np=X,e.$Np=X=ye([Y(0,n.$bo),Y(1,Z.$dl),Y(2,U.$$i),Y(3,s.$Yh),Y(4,r.$Cp),Y(5,t.$yp),Y(6,E.$Sn),Y(7,z.$Ph),Y(8,T.$_j),Y(9,B.$qj),Y(10,Q.$Jk),Y(11,x.$Lk)],X);let G=class extends g.$Sc{constructor(K,q,P,j,M,F){super(),this.j=K,this.m=q,this.n=P,this.s=j,this.t=M,this.u=F,this.h=this.B(new R.$Od),this.onExtract=this.h.event,this.c=(0,c.$wg)(this.n.userExtensionsLocation,".obsolete"),this.g=new I.$2g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(K,q){const P={includeInvalid:!0,profileLocation:q};let j=[];return K===null||K===0?j.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):K===1&&j.push(...await this.n.scanUserExtensions(P)),j=K!==null?j.filter(M=>M.type===K):j,Promise.all(j.map(M=>this.F(M)))}async scanAllUserExtensions(K){const q=await this.n.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(q.map(P=>this.F(P)))}async scanUserExtensionAtLocation(K){try{const q=await this.n.scanExistingExtension(K,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(K,q,P,j,M){const F=K.toString(),H=y.URI.file(b.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$fg)()}`)),J=y.URI.file(b.$jc(this.n.userExtensionsLocation.fsPath,F));let re=await this.m.exists(J);if(re&&j){try{await this.y(K.id,J,"removeExisting")}catch{throw new n.$co(d.localize(4,null,J.fsPath,K.id),n.ExtensionManagementErrorCode.Delete)}re=!1}if(!re)try{try{this.u.trace(`Started extracting the extension from ${q} to ${J.fsPath}`),await(0,u.$rp)(q,H.fsPath,{sourcePath:"extension",overwrite:!0},M),this.u.info(`Extracted extension to ${J}:`,K.id)}catch(ce){let ue=n.ExtensionManagementErrorCode.Extract;throw ce instanceof u.$pp&&(ce.type==="CorruptZip"?ue=n.ExtensionManagementErrorCode.CorruptZip:ce.type==="Incomplete"&&(ue=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$co(ce.message,ue)}await this.n.updateMetadata(H,P);try{this.u.trace(`Started renaming the extension from ${H.fsPath} to ${J.fsPath}`),await this.C(H.fsPath,J.fsPath),this.u.info("Renamed to",J.fsPath)}catch(ce){if(ce.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(ce)}. Deleted from extracted location`,H),ce}this.h.fire(J)}catch(ce){try{await this.m.del(H,{recursive:!0})}catch{}throw ce}return this.D(J,1)}async scanMetadata(K,q){return q?(await this.w(K,q))?.metadata:this.n.scanMetadata(K.location)}async w(K,q){return(await this.s.scanProfileExtensions(q)).find(j=>(0,i.$Do)(j.identifier,K.identifier))}async updateMetadata(K,q,P){return P?await this.s.updateMetadata([[K,q]],P):await this.n.updateMetadata(K.location,q),this.D(K.location,K.type,P)}getUninstalledExtensions(){return this.z()}async setUninstalled(...K){const q=K.map(P=>i.$Eo.create(P));await this.z(P=>q.forEach(j=>{P[j.toString()]=!0,this.u.info("Marked extension as uninstalled",j.toString())}))}async setInstalled(K){await this.z(q=>delete q[K.toString()])}async removeExtension(K,q){if(this.t.extUri.isEqualOrParent(K.location,this.n.userExtensionsLocation))return this.y(K.identifier.id,K.location,q)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.z(q=>delete q[i.$Eo.create(K).toString()])}async copyExtension(K,q,P,j){const M=await this.w(K,q),F=await this.w(K,P);return j={...M?.metadata,...j},F?await this.s.updateMetadata([[K,{...F.metadata,...j}]],P):await this.s.addExtensionsToProfile([[K,j]],P),this.D(K.location,K.type,P)}async copyExtensions(K,q){const P=await this.scanExtensions(1,K),j=await Promise.all(P.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,K)]));await this.s.addExtensionsToProfile(j,q)}async y(K,q,P){this.u.trace(`Deleting ${P} extension from disk`,K,q.fsPath);const j=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,k.$Ei)((0,h.$fg)()).toString(16)}${W}`);await this.C(q.fsPath,j.fsPath),await this.m.del(j,{recursive:!0}),this.u.info(`Deleted ${P} extension from disk`,K,q.fsPath)}async z(K){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(j){if((0,T.$qk)(j)!==1)throw j}let P={};if(q)try{P=JSON.parse(q)}catch{}return K&&(K(P),Object.keys(P).length?await this.m.writeFile(this.c,N.$ce.fromString(JSON.stringify(P))):await this.m.del(this.c)),P})}async C(K,q){try{await f.Promises.rename(K,q,2*60*1e3)}catch(P){throw new n.$co(P.message||d.localize(5,null,K,q),P.code||n.ExtensionManagementErrorCode.Rename)}}async D(K,q,P){if(P){const M=(await this.n.scanUserExtensions({profileLocation:P})).find(F=>this.t.extUri.isEqual(F.location,K));if(M)return this.F(M)}else{const j=await this.n.scanExistingExtension(K,q,{includeInvalid:!0});if(j)return this.F(j)}throw new Error(d.localize(6,null,K.path))}async F(K){const q=await this.m.resolve(K.location);let P,j;return q.children&&(P=q.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,j=q.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:P,changelogUrl:j,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async G(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(K));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),P=new Set;for(const M of q)K[i.$Eo.create(M).toString()]||P.add(M.identifier.id.toLowerCase());try{const M=(0,i.$Jo)(q,F=>F.identifier);await I.Promises.settled(M.map(async F=>{const H=F.sort((J,re)=>$.rcompare(J.manifest.version,re.manifest.version))[0];P.has(H.identifier.id.toLowerCase())||await this.j(await this.F(H))}))}catch(M){this.u.error(M)}const j=q.filter(M=>M.metadata&&K[i.$Eo.create(M).toString()]);await Promise.allSettled(j.map(M=>this.removeUninstalledExtension(M)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,T.$qk)(q)!==1&&this.u.error(q);return}if(K?.children)try{await Promise.allSettled(K.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(P){(0,T.$qk)(P)!==1&&this.u.error(P)}}}))}catch{}}};e.$Op=G,e.$Op=G=ye([Y(1,T.$_j),Y(2,r.$Cp),Y(3,t.$yp),Y(4,Q.$Jk),Y(5,U.$$i)],G);class V extends o.$wp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$Gf)(this.options.operation)?this.l:this.options.operation}constructor(K,q,P,j,M,F,H,J,re){super(),this.identifier=K,this.source=q,this.options=P,this.m=j,this.n=M,this.o=F,this.p=H,this.q=J,this.s=re,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(K){const[q,P]=await this.x(K);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,P]],this.j),q}async u({zipPath:K,key:q,metadata:P},j,M){let F=await this.v(q);return F||(this.s.trace("Extracting extension...",q.id),F=await this.m.extractUserExtension(q,K,P,j,M),this.s.info("Extracting extension completed.",q.id)),F}async v(K){return await this.w(K)?(this.s.trace("Removing the extension from uninstalled list:",K.id),await this.m.setInstalled(K),this.s.info("Removed the extension from uninstalled list:",K.id),(await this.m.scanAllUserExtensions(!0)).find(j=>i.$Eo.create(j).equals(K))):void 0}async w(K){return!!(await this.m.getUninstalledExtensions())[K.toString()]}}class ee extends V{constructor(K,q,P,j,M,F,H,J,re,ce){super(q.identifier,q,P,M,F,H,J,re,ce),this.y=q,this.z=j}async x(K){const P=(await this.m.scanExtensions(null,this.options.profileLocation)).find(H=>(0,i.$Do)(H.identifier,this.y.identifier));P&&(this.l=3);const j={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,isSystem:P?.type===0?!0:void 0,updated:!!P,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,p.$Ff)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:P?.preRelease)};if(P?.manifest.version===this.y.version)return[await this.m.updateMetadata(P,j),j];const{location:M,verificationStatus:F}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=F,this.B(M.fsPath),[await this.u({zipPath:M.fsPath,key:i.$Eo.create(this.y),metadata:j},!1,K),j]}catch(H){try{await this.z.delete(M)}catch(J){this.s.warn("Error while deleting the downloaded file",M.toString(),(0,O.$0)(J))}throw H}}async B(K){try{await(0,w.$Jp)(K)}catch(q){throw new n.$co((0,o.$up)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Pp=ee;class ie extends V{constructor(K,q,P,j,M,F,H,J,re,ce){super({id:(0,i.$Io)(K.publisher,K.name)},q,P,M,F,H,J,re,ce),this.y=K,this.z=q,this.A=j}async h(K){const q=await super.h(K);return this.D(q,K),q}async x(K){const q=new i.$Eo(this.identifier,this.y.version),j=(await this.m.scanExtensions(1,this.options.profileLocation)).find(H=>(0,i.$Do)(this.identifier,H.identifier)),M={isApplicationScoped:this.options.isApplicationScoped||j?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||j?.isMachineScoped,isBuiltin:this.options.isBuiltin||j?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(j)if(this.l=3,q.equals(new i.$Eo(j.identifier,j.manifest.version)))try{await this.m.removeExtension(j,"existing")}catch{throw new Error(d.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(j.manifest.version,this.y.version)&&await this.m.setUninstalled(j);else{const H=await this.v(q);if(H)try{await this.m.removeExtension(H,"existing")}catch{throw new Error(d.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:b.$kc(this.z.fsPath),key:q,metadata:M},!0,K),M]}async D(K,q){try{let[P]=await this.A.getExtensions([{id:K.identifier.id,version:K.manifest.version}],q);if(P||([P]=await this.A.getExtensions([{id:K.identifier.id}],q)),P){const j={id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId,isPreReleaseVersion:P.properties.isPreReleaseVersion,preRelease:P.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(K,j,this.options.profileLocation)}}catch{}}}class _ extends o.$wp{constructor(K,q,P){super(),this.extension=K,this.j=q,this.k=P}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[263],ae([0,1,2,29,81,221,121,8,21]),function(te,e,I,N,L,A,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z9b=void 0;let g=class extends I.$Sc{constructor(S,b,c,$,p,y){super(),S.cleanUp(),(0,A.$oWb)(S,b,c,$,y),L.$2u.removeOutdatedExtensionVersions(S,p)}};e.$z9b=g,e.$z9b=g=ye([Y(0,O.$Mp),Y(1,N.$bo),Y(2,L.$1u),Y(3,N.$go),Y(4,k.$0o),Y(5,R.$$i)],g)}),define(oe[122],ae([0,1,70,62,36,273,15,7,3,2,16,5,32,42,66]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;class p{traceSocketEvent(l,m){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,m)}constructor(l,m=""){this.f=!0,this.debugLabel=m,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,R.$1)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(l){const m=D=>{this.traceSocketEvent("read",D),l(O.$ce.wrap(D))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(l){const m=D=>{l({type:0,hadError:D,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(l){const m=()=>{l()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(l){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,R.$1)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,R.$1)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$Fh=p;var y;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(y||(y={}));var h;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(h||(h={}));class f extends g.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(l,m){this.socket.traceSocketEvent(l,m)}constructor(l,m,D,T){super(),this.f=this.B(new k.$Od),this.g=this.B(new k.$Od),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:D?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new u(this,m,D,T,this.f,(z,U)=>this.m(z,U))),this.B(this.a.onError(z=>{console.error(z),(0,R.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new $.$Ah,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this.f.event(l)}onClose(l){return this.g.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let m=0;for(;m<l.byteLength;)this.a.writeMessage(l.slice(m,Math.min(m+262144,l.byteLength)),{compressed:!0,opcode:2}),m+=262144}m(l,{compressed:m,opcode:D}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let T=2;l.byteLength<126?T+=0:l.byteLength<2**16?T+=2:T+=8;const z=O.$ce.alloc(T),U=m?64:0,B=D&15;if(z.writeUInt8(128|U|B,0),l.byteLength<126)z.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){z.writeUInt8(126,1);let Z=1;z.writeUInt8(l.byteLength>>>8&255,++Z),z.writeUInt8(l.byteLength>>>0&255,++Z)}else{z.writeUInt8(127,1);let Z=1;z.writeUInt8(0,++Z),z.writeUInt8(0,++Z),z.writeUInt8(0,++Z),z.writeUInt8(0,++Z),z.writeUInt8(l.byteLength>>>24&255,++Z),z.writeUInt8(l.byteLength>>>16&255,++Z),z.writeUInt8(l.byteLength>>>8&255,++Z),z.writeUInt8(l.byteLength>>>0&255,++Z)}this.socket.write(O.$ce.concat([z,l]))}end(){this.h=!0,this.socket.end()}n(l){if(l.byteLength!==0){for(this.b.acceptChunk(l);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const m=this.b.peek(this.j.readLen),D=m.readUInt8(0),T=(D&128)>>>7,z=(D&64)>>>6,U=D&15,B=m.readUInt8(1),Z=(B&128)>>>7,Q=B&127;this.j.state=2,this.j.readLen=2+(Z?4:0)+(Q===126?2:0)+(Q===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const m=this.b.read(this.j.readLen),D=m.readUInt8(1),T=(D&128)>>>7;let z=D&127,U=1;z===126?z=m.readUInt8(++U)*2**8+m.readUInt8(++U):z===127&&(z=m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*0+m.readUInt8(++U)*2**24+m.readUInt8(++U)*2**16+m.readUInt8(++U)*2**8+m.readUInt8(++U));let B=0;T&&(B=m.readUInt8(++U)*2**24+m.readUInt8(++U)*2**16+m.readUInt8(++U)*2**8+m.readUInt8(++U)),this.j.state=3,this.j.readLen=z,this.j.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const m=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),s(m,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(m,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(m,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Gh=f;class u extends g.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$ce.alloc(0)}constructor(l,m,D,T,z,U){super(),this.n=l,this.r=z,this.s=U,this.a=this.B(new k.$Od),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$Od),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$Od),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,m?(this.b=this.B(new d(this.n,T,D,{windowBits:15})),this.f=this.B(new E(this.n,{windowBits:15})),this.B(this.b.onError(B=>this.a.fire(B))),this.B(this.f.onError(B=>this.a.fire(B)))):(this.b=null,this.f=null)}writeMessage(l,m){this.g.push({data:l,options:m}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:l,options:m}=this.g.shift();if(this.f&&m.compressed){const D=await this.w(this.f,l);this.s(D,m)}else this.s(l,{...m,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(l,m){return new Promise((D,T)=>{l.write(m),l.flush(z=>D(z))})}acceptFrame(l,m,D){this.h.push({data:l,isCompressed:m,isLastFrameOfMessage:D}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const l=this.h.shift();if(this.b&&l.isCompressed){const m=await this.C(this.b,l.data,l.isLastFrameOfMessage);this.r.fire(m)}else this.r.fire(l.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(l,m,D){return new Promise((T,z)=>{l.write(m),D&&l.write(O.$ce.fromByteArray([0,0,255,255])),l.flush(U=>T(U))})}}class d extends g.$Sc{get recordedInflateBytes(){return this.j?O.$ce.concat(this.f):O.$ce.alloc(0)}constructor(l,m,D,T){super(),this.h=l,this.j=m,this.a=this.B(new k.$Od),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(T),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(O.$ce.wrap(z))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(l){this.j&&this.f.push(l.clone()),this.h.traceSocketEvent("zlibInflateWrite",l),this.b.write(l.buffer)}flush(l){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const m=O.$ce.concat(this.g);this.g.length=0,l(m)})}}class E extends g.$Sc{constructor(l,m){super(),this.g=l,this.a=this.B(new k.$Od),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(O.$ce.wrap(D))})}write(l){this.g.traceSocketEvent("zlibDeflateWrite",l.buffer),this.b.write(l.buffer)}flush(l){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let m=O.$ce.concat(this.f);this.f.length=0,m=m.slice(0,m.byteLength-4),l(m)})}}function s(w,l){if(l===0)return;const m=w.byteLength>>>2;for(let Z=0;Z<m;Z++){const Q=w.readUInt32BE(Z*4);w.writeUInt32BE(Q^l,Z*4)}const D=m*4,T=w.byteLength-D,z=l>>>24&255,U=l>>>16&255,B=l>>>8&255;T>=1&&w.writeUInt8(w.readUInt8(D)^z,D),T>=2&&w.writeUInt8(w.readUInt8(D+1)^U,D+1),T>=3&&w.writeUInt8(w.readUInt8(D+2)^B,D+2)}e.$Hh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const w=(0,b.$fg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const l=process.platform!=="darwin"&&e.$Hh?e.$Hh:(0,L.tmpdir)(),m=(0,C.$jc)(l,`vscode-ipc-${w}.sock`);return t(m),m}e.$Ih=n;function i(w,l,m){const D=(0,I.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${m}-${l}-sock`;const T=m.substr(0,4),z=l.substr(0,6),U=D.substr(0,8);let B;return process.platform!=="darwin"&&e.$Hh&&!process.env.VSCODE_PORTABLE?B=(0,C.$jc)(e.$Hh,`vscode-${U}-${T}-${z}.sock`):B=(0,C.$jc)(w,`${T}-${z}.sock`),t(B),B}e.$Jh=i;function t(w){const l=o[S.$u];typeof l=="number"&&w.length>=l&&console.warn(`WARNING: IPC handle "${w}" is longer than ${l} chars, try a shorter --user-data-dir`)}class r extends c.$uh{static b(l){const m=k.Event.fromNodeEventEmitter(l,"connection");return k.Event.map(m,D=>({protocol:new $.$Bh(new p(D,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(D,"close"))}))}constructor(l){super(r.b(l)),this.d=l}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Kh=r;function a(w){return new Promise((l,m)=>{const D=(0,N.createServer)();D.on("error",m),D.listen(w,()=>{D.removeListener("error",m),l(new r(D))})})}e.$Lh=a;function v(w,l){return new Promise((m,D)=>{const T=(0,N.createConnection)(w,()=>{T.removeListener("error",D),m($.$Ch.fromSocket(new p(T,`ipc-client${l}`),l))});T.once("error",D)})}e.$Mh=v}),define(oe[264],ae([0,1,62,122,209]),function(te,e,I,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I9b=void 0,e.$I9b=new class{supports(A){return!0}connect({host:A,port:O},R,k,g){return new Promise((C,S)=>{const b=I.createConnection({host:A,port:O},()=>{b.removeListener("error",S),b.write((0,L.$Nkb)(R,k,g));const c=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",c),C(new N.$Fh(b,g)))};b.on("data",c)});b.setNoDelay(!0),b.once("error",S)})}}}),define(oe[265],ae([0,1,62,36,132,122,6,2,5,20,8,25,212,104,106,77,15]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=e.$D8b=e.$C8b=e.$B8b=void 0;async function h(s,o,n,i,t){let r;for(let a=3;a&&(r?.dispose(),r=await new f(s,o,n,i,t).waitForReady(),!(t&&L.$ig[t]||!L.$ig[r.tunnelLocalPort]));a--);return r}class f extends R.$Sc{constructor(o,n,i,t,r){super(),this.m=n,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=I.createServer(),this.c=new O.$Tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,p.$iv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,L.$jg)(o,2,1e3,n),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,p.$gv)(this.tunnelRemoteHost)||(0,p.$iv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,b.$7k)(this.a,n,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof A.$Fh?t.socket.destroy():t.end()}),t instanceof A.$Fh?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(i=>o.write(i.buffer)),o.on("data",i=>n.write(y.$ce.wrap(i))),o.resume()}t(o,n){const i=n.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$B8b=f;let u=class extends p.$lv{constructor(o,n,i,t,r){super(n,r),this.u=o,this.v=i,this.w=t}isPortPrivileged(o){return(0,p.$jv)(o,this.l,k.OS,N.release())}s(o,n,i,t,r,a,v,w){const l=this.r(n,i);if(l)return++l.refcount,l.value;if((0,p.$dv)(o))return this.t(o,n,i,r,a,v,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${i} on local port ${r}.`);const m={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},D=h(m,t,n,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,i,D),D}}};e.$C8b=u,e.$C8b=u=ye([Y(0,c.$1k),Y(1,C.$$i),Y(2,$.$4k),Y(3,S.$qj),Y(4,g.$ki)],u);let d=class extends u{constructor(o,n,i,t,r){super(o,n,i,t,r)}};e.$D8b=d,e.$D8b=d=ye([Y(0,c.$1k),Y(1,C.$$i),Y(2,$.$4k),Y(3,S.$qj),Y(4,g.$ki)],d);let E=class extends R.$Sc{constructor(o,n,i,t,r){super(),this.b=o,this.c=n,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,i,t,r,a,v,w,l){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${a}.`),!this.a.has(o)){const m=new d(this.b,this.c,this.g,this.f,this.h);this.B(m),this.a.set(o,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,i,t,r,a,v,w,l)}};e.$E8b=E,e.$E8b=E=ye([Y(0,c.$1k),Y(1,C.$$i),Y(2,S.$qj),Y(3,$.$4k),Y(4,g.$ki)],E)}),define(oe[274],ae([0,1,36,38,7,2,23,10,18,3,42,146,203,204,195,196,260,186,188,20,208,95,219,96,214,14,113,245,29,97,187,121,98,11,198,199,69,4,194,71,73,224,8,200,102,25,57,21,107,22,108,109,110,45,227,81,111,24,79,252,237,238,82,251,255,256,257,58,250,239,106,218,77,265,213,228,28,229,5,230,189,206,205,80,244,17,51,202,56,249,226,240,105,254,263,9,201,101,247,243,215,183,55,258,246,72,248,104,264,181,216]),function(te,e,I,N,L,A,O,R,k,g,C,S,b,c,$,p,y,h,f,u,d,E,s,o,n,i,t,r,a,v,w,l,m,D,T,z,U,B,Z,Q,x,W,X,G,V,ee,ie,_,ne,K,q,P,j,M,F,H,J,re,ce,ue,he,$e,de,we,ve,Oe,Ne,Me,le,ge,be,ke,Pe,ze,je,Ue,Fe,se,fe,me,pe,Se,Re,Ce,Ie,De,Ae,Te,Be,qe,We,_e,ut,pt,vt,Et,St,ft,kt,Ct,Pt,Rt,Ot,It,Dt,dt,jt,gt,Lt,At,it){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Nt extends A.$Sc{constructor(Ee){super(),this.f=Ee,this.a=this.B(new S.$JT(this)),this.b=void 0,this.c=this.B(new g.$Od),this.g()}g(){let Ee=!1;const Le=()=>{Ee||(Ee=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Le),(0,S.$KT)(process.parentPort,it.$Q7b.exit,Le)}async init(){const Ee=await this.h();(0,re.$Ogb)(),Ee.invokeFunction(Le=>{const Qe=Le.get(X.$$i),Ve=Le.get(K.$dl),Ke=Le.get(De.$Lk);Qe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Le),this.m(Qe),this.n(Ve,Ke),this.B(Ke.onDidChangeProfiles(()=>this.n(Ve,Ke)))}),this.B((0,A.$Pc)(Ee.createInstance(b.$88b,this.f.codeCachePath),Ee.createInstance(c.$98b),Ee.createInstance(y.$_8b),Ee.createInstance(p.$$8b),Ee.createInstance($.$08b),Ee.createInstance(vt.$z9b),Ee.createInstance(_e.$r9b)))}async h(){const Ee=new Q.$Oh,Le={_serviceBrand:void 0,...V.default};Ee.set(ee.$qj,Le);const Qe=new C.$yh(He=>He==="main"),Ve=new dt.$L8b(this.a,Qe);Ee.set(dt.$K8b,Ve);const Ke=this.f.policiesData?new Te.$h8b(this.f.policiesData,Ve.getChannel("policy")):new Be.$on;Ee.set(Be.$mn,Ke);const Ge=new At.$km(this.f.args,Le);Ee.set(i.$Yh,Ge);const xe=new G.$cr(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:R.URI.revive(He.resource)})),Ve.getChannel("logger"));Ee.set(X.$_i,xe);const st=this.B(xe.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ct=this.B(new X.$gj(st.getLevel())),Je=this.B(new St.$NN(st,[ct]));Ee.set(X.$$i,Je),this.b=this.B(new ft.$B9b(Je)),Ee.set(ft.$A9b,this.b);const Xe=this.B(new T.$Rp(Je));Ee.set(D.$_j,Xe);const lt=this.B(new z.$eq(Je));Xe.registerProvider(O.Schemas.file,lt);const rt=new se.$Dr(Xe);Ee.set(Fe.$Jk,rt);const Ye=this.B(new qe.$UN(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Ee.set(De.$Lk,Ye);const ht=this.B(new me.$J8b(O.Schemas.file,this.B(new pe.$wN(Ve.getChannel(pe.$vN),{pathCaseSensitive:fe.$l})),O.Schemas.vscodeUserData,Ye,rt,Je));Xe.registerProvider(O.Schemas.vscodeUserData,ht);const Ze=this.B(new d.$On(Ye.defaultProfile.settingsResource,Xe,Ke,Je));Ee.set(u.$ki,Ze);const et=new jt.$H9b(void 0,{defaultProfile:Ye.defaultProfile,currentProfile:Ye.defaultProfile},Ve,Ge);Ee.set(_.$0o,et),this.B((0,A.$Qc)(()=>et.flush())),await Promise.all([Ze.initialize(),et.initialize()]);const mt=new Pt.$1q(Ve.getChannel("request"));Ee.set(ie.$Wo,mt),Ee.set(h.$a9b,new U.$Nh(f.$b9b,void 0,!1)),Ee.set(Re.$4E,new U.$Nh(Se.$q9b,void 0,!1));const bt=C.ProxyChannel.toService(Ve.getChannel("nativeHost"));Ee.set(Ot.$w7b,bt),Ee.set(o.$Sn,new U.$Nh(n.$3N,void 0,!0));const Tt=this.B(new ge.$e8b(bt)),Ft=new C.$yh(He=>Tt.getActiveClientId().then(at=>He===at));Ee.set(m.$$Vb,new Rt.$D9b(this.a.getChannel("extensionRecommendationNotification",Ft)));let ot;const tt=[],wt=(0,M.$Ao)(Le,Ze);if((0,M.$vo)(Le,Ge)){const He=new P.$g5b(Je,xe,Ge,Le);if(tt.push(He),!(0,M.$wo)(Le,Ge)&&Le.aiConfig?.ariaKey){const at=new We.$BN(mt,wt,"monacoworkbench",null,Le.aiConfig.ariaKey);this.B((0,A.$Qc)(()=>at.flush())),tt.push(at)}ot=new j.$5q({appenders:tt,commonProperties:(0,ne.$lo)((0,I.release)(),(0,I.hostname)(),process.arch,Le.commit,Le.version,this.f.machineId,this.f.sqmId,wt),sendErrorTelemetry:!0,piiPaths:(0,M.$Bo)(Ge)},Ze,Le)}else{ot=M.$po;const He=M.$to;tt.push(He)}this.a.registerChannel("telemetryAppender",new q.$V7b(tt)),Ee.set(K.$dl,ot);const Mt=new F.$c9b(Ze,ot,Je,xe,Ge,Le);Ee.set(K.$el,Mt),Ee.set(Ae.$yp,new U.$Nh(Ct.$MN,void 0,!0)),Ee.set(Ce.$Cp,new U.$Nh(Ie.$i8b,void 0,!0)),Ee.set(v.$ip,new U.$Nh(v.$jp,void 0,!0)),Ee.set(l.$Mp,new U.$Nh(l.$Np,void 0,!0)),Ee.set(a.$bo,new U.$Nh(r.$gp,void 0,!0)),Ee.set(a.$ho,new U.$Nh(Dt.$G9b,void 0,!1)),Ee.set(x.$Wq,new U.$Nh(W.$Yq,void 0,!1)),Ee.set(E.$rm,new U.$Nh(s.$Kr,void 0,!1)),Ee.set(ce.$1Cb,new U.$Nh(ce.$2Cb,void 0,!0)),Ee.set(re.$0gb,new U.$Nh($e.$bFb,void 0,!0)),Ee.set(re.$9gb,new he.$f9b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Ee.set(a.$go,new U.$Nh(t.$YCb,void 0,!1)),Ee.set(J.$_Eb,new U.$Nh(J.$aFb,void 0,!0)),Ee.set(H.$1u,new U.$Nh(H.$2u)),Ee.set(re.$Tgb,new U.$Nh(Ne.$kEb,void 0,!0)),Ee.set(re.$Ugb,new U.$Nh(Ne.$mEb,void 0,!0)),Ee.set(de.$Hgb,new U.$Nh(de.$Jgb,void 0,!0)),Ee.set(re.$Vgb,new U.$Nh(ue.$U5b,void 0,!1)),Ee.set(re.$5gb,new U.$Nh(we.$J5b,void 0,!0)),Ee.set(re.$6gb,new U.$Nh(ve.$Z5b,void 0,!1)),Ee.set(Me.$ADb,new U.$Nh(le.$m9b,void 0,!0)),Ee.set(re.$7gb,new U.$Nh(pt.$y6b,void 0,!0)),Ee.set(be.$4k,new U.$Nh(ke.$G8b,void 0,!1));const yt=new gt.$2k;return Ee.set(gt.$1k,yt),yt.register(0,Lt.$I9b),Ee.set(Pe.$cv,new U.$Nh(ze.$E8b)),Ee.set(je.$n9b,new U.$Nh(Ue.$p9b)),Ee.set(ut.$s9b,new U.$Nh(kt.$C9b)),new Z.$hq(Ee)}j(Ee){const Le=this.B(new A.$Rc),Qe=new w.$lp(Ee.get(a.$do),()=>null);this.a.registerChannel("extensions",Qe);const Ve=C.ProxyChannel.fromService(Ee.get(x.$Wq),Le);this.a.registerChannel("languagePacks",Ve);const Ke=C.ProxyChannel.fromService(Ee.get(E.$rm),Le);this.a.registerChannel("diagnostics",Ke);const Ge=new w.$np(Ee.get(a.$ho));this.a.registerChannel("extensionTipsService",Ge);const xe=C.ProxyChannel.fromService(Ee.get(h.$a9b),Le);this.a.registerChannel("checksum",xe);const st=C.ProxyChannel.fromService(Ee.get(Re.$4E),Le);this.a.registerChannel("v8InspectProfiling",st);const ct=new he.$g9b(Ee.get(de.$Hgb));this.a.registerChannel("userDataSyncMachines",ct);const Je=C.ProxyChannel.fromService(Ee.get(K.$el),Le);this.a.registerChannel("customEndpointTelemetry",Je);const Xe=new he.$h9b(Ee.get(ce.$1Cb));this.a.registerChannel("userDataSyncAccount",Xe);const lt=new he.$i9b(Ee.get(re.$Tgb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Oe.$k9b(Ee.get(re.$6gb),Ee.get(De.$Lk),Ee.get(X.$$i));this.a.registerChannel("userDataSync",rt);const Ye=this.B(Ee.get(B.$Ph).createInstance(It.$F9b)),ht=new he.$d9b(Ye);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Ee.get(re.$7gb),Le));const Ze=C.ProxyChannel.fromService(Ee.get(je.$n9b),Le);this.a.registerChannel(je.$o9b,Ze);const et=C.ProxyChannel.fromService(Ee.get(ut.$s9b),Le);this.a.registerChannel("remoteTunnel",et)}m(Ee){process.on("uncaughtException",Le=>(0,L.$1)(Le)),process.on("unhandledRejection",Le=>(0,L.$1)(Le)),(0,L.setUnexpectedErrorHandler)(Le=>{const Qe=(0,N.$Bi)(Le,!0);Qe&&Ee.error(`[uncaught exception in sharedProcess]: ${Qe}`)})}n(Ee,Le){Ee.publicLog2("profilesInfo",{count:Le.profiles.length})}handledClientConnection(Ee){if(Ee.data!==it.$S7b.response)return!1;const Le=(0,k.$Ob)(Ee.ports);return Le?(this.c.fire(Le),!0):!1}}async function $t(nt){const Ee=new Nt(nt);process.parentPort.postMessage(it.$Q7b.ipcReady),await Ee.init(),process.parentPort.postMessage(it.$Q7b.initDone)}e.main=$t,process.parentPort.once("message",nt=>{$t(nt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/35419fc016b8d3d5dbc59aa11a0be957b0897309/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
