/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/base/common/stopwatch","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function($e){for(var e=[],C=0,O=$e.length;C<O;C++)e[C]=De[$e[C]];return e};define(De[156],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class C{static get(){const f=new Map,R=new Map,A=new Map,m=new Map;function E(y,k){y.has(k.detail)||y.set(k.detail,-k.timestamp)}function b(y,k){const v=y.get(k.detail);v&&(v>=0||y.set(k.detail,v+k.timestamp))}let L=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(L=$e.getStats().slice(0).sort((y,k)=>y.timestamp-k.timestamp));for(const y of L)switch(y.type){case 10:E(f,y);break;case 11:case 12:b(f,y);break;case 21:E(R,y);break;case 22:b(R,y);break;case 33:E(A,y);break;case 34:b(A,y);break;case 31:E(m,y);break;case 32:b(m,y);break}let P=0;A.forEach(y=>P+=y);function p(y){const k=[];return y.forEach((v,h)=>k.push([h,v])),k}return{amdLoad:p(f),amdInvoke:p(R),nodeRequire:p(A),nodeEval:p(m),nodeRequireTotal:P}}static toMarkdownTable(f,R){let A="";const m=[];return f.forEach((E,b)=>{m[b]=E.length}),R.forEach(E=>{E.forEach((b,L)=>{typeof b>"u"&&(b=E[L]="-");const P=b.toString().length;m[L]=Math.max(P,m[L])})}),f.forEach((E,b)=>{A+=`| ${E+" ".repeat(m[b]-E.toString().length)} `}),A+=`|
`,f.forEach((E,b)=>{A+=`| ${"-".repeat(m[b])} `}),A+=`|
`,R.forEach(E=>{E.forEach((b,L)=>{typeof b<"u"&&(A+=`| ${b+" ".repeat(m[L]-b.toString().length)} `)}),A+=`|
`}),A}}e.$U=C}),define(De[118],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function C(v,h,o){const l=O(v,h);if(l!==-1)return v[l]}e.$fb=C;function O(v,h,o=v.length-1){for(let l=o;l>=0;l--){const c=v[l];if(h(c))return l}return-1}e.$gb=O;function f(v,h){const o=R(v,h);return o===-1?void 0:v[o]}e.$hb=f;function R(v,h,o=0,l=v.length){let c=o,d=l;for(;c<d;){const a=Math.floor((c+d)/2);h(v[a])?c=a+1:d=a}return c-1}e.$ib=R;function A(v,h){const o=m(v,h);return o===v.length?void 0:v[o]}e.$jb=A;function m(v,h,o=0,l=v.length){let c=o,d=l;for(;c<d;){const a=Math.floor((c+d)/2);h(v[a])?d=a:c=a+1}return c}e.$kb=m;function E(v,h,o=0,l=v.length){const c=m(v,h,o,l);return c===v.length?-1:c}e.$lb=E;class b{static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if(b.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!h(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const o=R(this.e,h,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=b;function L(v,h){if(v.length===0)return;let o=v[0];for(let l=1;l<v.length;l++){const c=v[l];h(c,o)>0&&(o=c)}return o}e.$nb=L;function P(v,h){if(v.length===0)return;let o=v[0];for(let l=1;l<v.length;l++){const c=v[l];h(c,o)>=0&&(o=c)}return o}e.$ob=P;function p(v,h){return L(v,(o,l)=>-h(o,l))}e.$pb=p;function y(v,h){if(v.length===0)return-1;let o=0;for(let l=1;l<v.length;l++){const c=v[l];h(c,v[o])>0&&(o=l)}return o}e.$qb=y;function k(v,h){for(const o of v){const l=h(o);if(l!==void 0)return l}}e.$rb=k}),define(De[74],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function C(A,m){const E=Object.create(null);for(const b of A){const L=m(b);let P=E[L];P||(P=E[L]=[]),P.push(b)}return E}e.$J=C;function O(A,m){const E=[],b=[];for(const L of A)m.has(L)||E.push(L);for(const L of m)A.has(L)||b.push(L);return{removed:E,added:b}}e.$K=O;function f(A,m){const E=[],b=[];for(const[L,P]of A)m.has(L)||E.push(P);for(const[L,P]of m)A.has(L)||b.push(P);return{removed:E,added:b}}e.$L=f;function R(A,m){const E=new Set;for(const b of m)A.has(b)&&E.add(b);return E}e.$M=R}),define(De[57],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function C(A){return(m,E,b)=>{let L=null,P=null;if(typeof b.value=="function"?(L="value",P=b.value):typeof b.get=="function"&&(L="get",P=b.get),!P)throw new Error("not supported");b[L]=A(P,E)}}function O(A,m,E){let b=null,L=null;if(typeof E.value=="function"?(b="value",L=E.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",L=E.get),!L)throw new Error("not supported");const P=`$memoize$${m}`;E[b]=function(...p){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,p)}),this[P]}}e.$ih=O;function f(A,m,E){return C((b,L)=>{const P=`$debounce$${L}`,p=`$debounce$result$${L}`;return function(...y){this[p]||(this[p]=E?E():void 0),clearTimeout(this[P]),m&&(this[p]=m(this[p],...y),y=[this[p]]),this[P]=setTimeout(()=>{b.apply(this,y),this[p]=E?E():void 0},A)}})}e.$jh=f;function R(A,m,E){return C((b,L)=>{const P=`$throttle$timer$${L}`,p=`$throttle$result$${L}`,y=`$throttle$lastRun$${L}`,k=`$throttle$pending$${L}`;return function(...v){if(this[p]||(this[p]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),m&&(this[p]=m(this[p],...v)),this[k])return;const h=this[y]+A;h<=Date.now()?(this[y]=Date.now(),b.apply(this,[this[p]]),this[p]=E?E():void 0):(this[k]=!0,this[P]=setTimeout(()=>{this[k]=!1,this[y]=Date.now(),b.apply(this,[this[p]]),this[p]=E?E():void 0},h-Date.now()))}})}e.$kh=R}),define(De[9],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(i=>{i(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=C,e.$X=new C;function O(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=O;function f(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=f;function R(a){b(a)||e.$X.onUnexpectedError(a)}e.$1=R;function A(a){b(a)||e.$X.onUnexpectedExternalError(a)}e.$2=A;function m(a){if(a instanceof Error){const{name:t,message:i}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:i,stack:s,noTelemetry:c.isErrorNoTelemetry(a)}}return a}e.$3=m;const E="Canceled";function b(a){return a instanceof L?!0:a instanceof Error&&a.name===E&&a.message===E}e.$4=b;class L extends Error{constructor(){super(E),this.name=this.message}}e.$5=L;function P(){const a=new Error(E);return a.name=a.message,a}e.$6=P;function p(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=p;function y(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=y;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=v;class h extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=h;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class l extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=l;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const i=new c;return i.message=t.message,i.stack=t.stack,i}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=c;class d extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$cb=d}),define(De[19],Ce([1,0,9,118]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function f(X,_=0){return X[X.length-(1+_)]}e.$sb=f;function R(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.$tb=R;function A(X,_,x=(pe,ae)=>pe===ae){if(X===_)return!0;if(!X||!_||X.length!==_.length)return!1;for(let pe=0,ae=X.length;pe<ae;pe++)if(!x(X[pe],_[pe]))return!1;return!0}e.$ub=A;function m(X,_){const x=X.length-1;_<x&&(X[_]=X[x]),X.pop()}e.$vb=m;function E(X,_,x){return b(X.length,pe=>x(X[pe],_))}e.$wb=E;function b(X,_){let x=0,pe=X-1;for(;x<=pe;){const ae=(x+pe)/2|0,fe=_(ae);if(fe<0)x=ae+1;else if(fe>0)pe=ae-1;else return ae}return-(x+1)}e.$xb=b;function L(X,_,x){if(X=X|0,X>=_.length)throw new TypeError("invalid index");const pe=_[Math.floor(_.length*Math.random())],ae=[],fe=[],ee=[];for(const de of _){const be=x(de,pe);be<0?ae.push(de):be>0?fe.push(de):ee.push(de)}return X<ae.length?L(X,ae,x):X<ae.length+ee.length?ee[0]:L(X-(ae.length+ee.length),fe,x)}e.$yb=L;function P(X,_){const x=[];let pe;for(const ae of X.slice(0).sort(_))!pe||_(pe[0],ae)!==0?(pe=[ae],x.push(pe)):pe.push(ae);return x}e.$zb=P;function*p(X,_){let x,pe;for(const ae of X)pe!==void 0&&_(pe,ae)?x.push(ae):(x&&(yield x),x=[ae]),pe=ae;x&&(yield x)}e.$Ab=p;function y(X,_){for(let x=0;x<=X.length;x++)_(x===0?void 0:X[x-1],x===X.length?void 0:X[x])}e.$Bb=y;function k(X,_){for(let x=0;x<X.length;x++)_(x===0?void 0:X[x-1],X[x],x+1===X.length?void 0:X[x+1])}e.$Cb=k;function v(X,_,x){const pe=[];function ae(de,be,Pe){if(be===0&&Pe.length===0)return;const U=pe[pe.length-1];U&&U.start+U.deleteCount===de?(U.deleteCount+=be,U.toInsert.push(...Pe)):pe.push({start:de,deleteCount:be,toInsert:Pe})}let fe=0,ee=0;for(;;){if(fe===X.length){ae(fe,0,_.slice(ee));break}if(ee===_.length){ae(fe,X.length-fe,[]);break}const de=X[fe],be=_[ee],Pe=x(de,be);Pe===0?(fe+=1,ee+=1):Pe<0?(ae(fe,1,[]),fe+=1):Pe>0&&(ae(fe,0,[be]),ee+=1)}return pe}e.$Db=v;function h(X,_,x){const pe=v(X,_,x),ae=[],fe=[];for(const ee of pe)ae.push(...X.slice(ee.start,ee.start+ee.deleteCount)),fe.push(...ee.toInsert);return{removed:ae,added:fe}}e.$Eb=h;function o(X,_,x){if(x===0)return[];const pe=X.slice(0,x).sort(_);return c(X,_,pe,x,X.length),pe}e.top=o;function l(X,_,x,pe,ae){return x===0?Promise.resolve([]):new Promise((fe,ee)=>{(async()=>{const de=X.length,be=X.slice(0,x).sort(_);for(let Pe=x,U=Math.min(x+pe,de);Pe<de;Pe=U,U=Math.min(U+pe,de)){if(Pe>x&&await new Promise(Q=>setTimeout(Q)),ae&&ae.isCancellationRequested)throw new C.$5;c(X,_,be,Pe,U)}return be})().then(fe,ee)})}e.$Gb=l;function c(X,_,x,pe,ae){for(const fe=x.length;pe<ae;pe++){const ee=X[pe];if(_(ee,x[fe-1])<0){x.pop();const de=(0,O.$kb)(x,be=>_(ee,be)<0);x.splice(de,0,ee)}}}function d(X){return X.filter(_=>!!_)}e.$Hb=d;function a(X){let _=0;for(let x=0;x<X.length;x++)X[x]&&(X[_]=X[x],_+=1);X.length=_}e.$Ib=a;function t(X,_,x){X.splice(x,0,X.splice(_,1)[0])}e.$Jb=t;function i(X){return!Array.isArray(X)||X.length===0}e.$Kb=i;function s(X){return Array.isArray(X)&&X.length>0}e.$Lb=s;function n(X,_=x=>x){const x=new Set;return X.filter(pe=>{const ae=_(pe);return x.has(ae)?!1:(x.add(ae),!0)})}e.$Mb=n;function r(X){const _=new Set;return x=>{const pe=X(x);return _.has(pe)?!1:(_.add(pe),!0)}}e.$Nb=r;function u(X,_){return X.length>0?X[0]:_}e.$Ob=u;function I(X,_){return X.length>0?X[X.length-1]:_}e.$Pb=I;function S(X,_,x=(pe,ae)=>pe===ae){let pe=0;for(let ae=0,fe=Math.min(X.length,_.length);ae<fe&&x(X[ae],_[ae]);ae++)pe++;return pe}e.$Qb=S;function $(X){return[].concat(...X)}e.$Rb=$;function g(X,_){let x=typeof _=="number"?X:0;typeof _=="number"?x=X:(x=0,_=X);const pe=[];if(x<=_)for(let ae=x;ae<_;ae++)pe.push(ae);else for(let ae=x;ae>_;ae--)pe.push(ae);return pe}e.$Sb=g;function w(X,_,x){return X.reduce((pe,ae)=>(pe[_(ae)]=x?x(ae):ae,pe),Object.create(null))}e.$Tb=w;function D(X,_){return X.push(_),()=>T(X,_)}e.$Ub=D;function T(X,_){const x=X.indexOf(_);if(x>-1)return X.splice(x,1),_}e.$Vb=T;function M(X,_,x){const pe=X.slice(0,_),ae=X.slice(_);return pe.concat(x,ae)}e.$Wb=M;function F(X,_){let x;if(typeof _=="number"){let pe=_;x=()=>{const ae=Math.sin(pe++)*179426549;return ae-Math.floor(ae)}}else x=Math.random;for(let pe=X.length-1;pe>0;pe-=1){const ae=Math.floor(x()*(pe+1)),fe=X[pe];X[pe]=X[ae],X[ae]=fe}}e.$Xb=F;function z(X,_){const x=X.indexOf(_);x>-1&&(X.splice(x,1),X.unshift(_))}e.$Yb=z;function j(X,_){const x=X.indexOf(_);x>-1&&(X.splice(x,1),X.push(_))}e.$Zb=j;function N(X,_){for(const x of _)X.push(x)}e.$1b=N;function q(X,_){return Array.isArray(X)?X.map(_):_(X)}e.$2b=q;function K(X){return Array.isArray(X)?X:[X]}e.$3b=K;function me(X){return X[Math.floor(Math.random()*X.length)]}e.$4b=me;function te(X,_,x){const pe=J(X,_),ae=X.length,fe=x.length;X.length=ae+fe;for(let ee=ae-1;ee>=pe;ee--)X[ee+fe]=X[ee];for(let ee=0;ee<fe;ee++)X[ee+pe]=x[ee]}e.$5b=te;function G(X,_,x,pe){const ae=J(X,_);let fe=X.splice(ae,x);return fe===void 0&&(fe=[]),te(X,ae,pe),fe}e.$6b=G;function J(X,_){return _<0?Math.max(_+X.length,0):Math.min(_,X.length)}var le;(function(X){function _(fe){return fe<0}X.isLessThan=_;function x(fe){return fe<=0}X.isLessThanOrEqual=x;function pe(fe){return fe>0}X.isGreaterThan=pe;function ae(fe){return fe===0}X.isNeitherLessOrGreaterThan=ae,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(le||(e.CompareResult=le={}));function ie(X,_){return(x,pe)=>_(X(x),X(pe))}e.$7b=ie;function ce(...X){return(_,x)=>{for(const pe of X){const ae=pe(_,x);if(!le.isNeitherLessOrGreaterThan(ae))return ae}return le.neitherLessOrGreaterThan}}e.$8b=ce;const ye=(X,_)=>X-_;e.$9b=ye;const H=(X,_)=>(0,e.$9b)(X?1:0,_?1:0);e.$0b=H;function B(X){return(_,x)=>-X(_,x)}e.$$b=B;class Y{constructor(_){this.g=_,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(_){let x=this.c;for(;x<this.g.length&&_(this.g[x]);)x++;const pe=x===this.c?null:this.g.slice(this.c,x);return this.c=x,pe}takeFromEndWhile(_){let x=this.d;for(;x>=0&&_(this.g[x]);)x--;const pe=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,pe}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const _=this.g[this.c];return this.c++,_}removeLast(){const _=this.g[this.d];return this.d--,_}takeCount(_){const x=this.g.slice(this.c,this.c+_);return this.c+=_,x}}e.$_b=Y;class re{static{this.empty=new re(_=>{})}constructor(_){this.iterate=_}forEach(_){this.iterate(x=>(_(x),!0))}toArray(){const _=[];return this.iterate(x=>(_.push(x),!0)),_}filter(_){return new re(x=>this.iterate(pe=>_(pe)?x(pe):!0))}map(_){return new re(x=>this.iterate(pe=>x(_(pe))))}some(_){let x=!1;return this.iterate(pe=>(x=_(pe),!x)),x}findFirst(_){let x;return this.iterate(pe=>_(pe)?(x=pe,!1):!0),x}findLast(_){let x;return this.iterate(pe=>(_(pe)&&(x=pe),!0)),x}findLastMaxBy(_){let x,pe=!0;return this.iterate(ae=>((pe||le.isGreaterThan(_(ae,x)))&&(pe=!1,x=ae),!0)),x}}e.$ac=re}),define(De[58],Ce([1,0,9]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function O(E,b){if(!E)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=O;function f(E,b="Unreachable"){throw new Error(b)}e.$4c=f;function R(E){if(!E)throw new C.$cb("Assertion Failed")}e.$5c=R;function A(E){if(!E()){debugger;E(),(0,C.$1)(new C.$cb("Assertion Failed"))}}e.$6c=A;function m(E,b){let L=0;for(;L<E.length-1;){const P=E[L],p=E[L+1];if(!b(P,p))return!1;L++}return!0}e.$7c=m}),define(De[75],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function C(O){const f=this;let R=!1,A;return function(){return R||(R=!0,A=O.apply(f,arguments)),A}}e.$db=C}),define(De[119],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=void 0;class C{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$vM=C,e.$wM=new C("id#")}),define(De[51],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(O){function f(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}O.is=f;const R=Object.freeze([]);function A(){return R}O.empty=A;function*m(a){yield a}O.single=m;function E(a){return f(a)?a:m(a)}O.wrap=E;function b(a){return a||R}O.from=b;function*L(a){for(let t=a.length-1;t>=0;t--)yield a[t]}O.reverse=L;function P(a){return!a||a[Symbol.iterator]().next().done===!0}O.isEmpty=P;function p(a){return a[Symbol.iterator]().next().value}O.first=p;function y(a,t){for(const i of a)if(t(i))return!0;return!1}O.some=y;function k(a,t){for(const i of a)if(t(i))return i}O.find=k;function*v(a,t){for(const i of a)t(i)&&(yield i)}O.filter=v;function*h(a,t){let i=0;for(const s of a)yield t(s,i++)}O.map=h;function*o(...a){for(const t of a)for(const i of t)yield i}O.concat=o;function l(a,t,i){let s=i;for(const n of a)s=t(s,n);return s}O.reduce=l;function*c(a,t,i=a.length){for(t<0&&(t+=a.length),i<0?i+=a.length:i>a.length&&(i=a.length);t<i;t++)yield a[t]}O.slice=c;function d(a,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,a];const s=a[Symbol.iterator]();for(let n=0;n<t;n++){const r=s.next();if(r.done)return[i,O.empty()];i.push(r.value)}return[i,{[Symbol.iterator](){return s}}]}O.consume=d})(C||(e.Iterable=C={}))}),define(De[157],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function A(t,i=!1){let s=0;const n=t.length;let r="",u=0,I=16,S=0;function $(z){let j=0,N=0;for(;j<z;){const q=t.charCodeAt(s);if(q>=48&&q<=57)N=N*16+q-48;else if(q>=65&&q<=70)N=N*16+q-65+10;else if(q>=97&&q<=102)N=N*16+q-97+10;else break;s++,j++}return j<z&&(N=-1),N}function g(z){s=z,r="",u=0,I=16,S=0}function w(){const z=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&b(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&b(t.charCodeAt(s)))for(s++;s<t.length&&b(t.charCodeAt(s));)s++;else return S=3,t.substring(z,s);let j=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&b(t.charCodeAt(s))){for(s++;s<t.length&&b(t.charCodeAt(s));)s++;j=s}else S=3;return t.substring(z,j)}function D(){let z="",j=s;for(;;){if(s>=n){z+=t.substring(j,s),S=2;break}const N=t.charCodeAt(s);if(N===34){z+=t.substring(j,s),s++;break}if(N===92){if(z+=t.substring(j,s),s++,s>=n){S=2;break}switch(t.charCodeAt(s++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const K=$(4);K>=0?z+=String.fromCharCode(K):S=4;break}default:S=5}j=s;continue}if(N>=0&&N<=31)if(E(N)){z+=t.substring(j,s),S=2;break}else S=6;s++}return z}function T(){if(r="",S=0,u=s,s>=n)return u=n,I=17;let z=t.charCodeAt(s);if(m(z)){do s++,r+=String.fromCharCode(z),z=t.charCodeAt(s);while(m(z));return I=15}if(E(z))return s++,r+=String.fromCharCode(z),z===13&&t.charCodeAt(s)===10&&(s++,r+=`
`),I=14;switch(z){case 123:return s++,I=1;case 125:return s++,I=2;case 91:return s++,I=3;case 93:return s++,I=4;case 58:return s++,I=6;case 44:return s++,I=5;case 34:return s++,r=D(),I=10;case 47:{const j=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!E(t.charCodeAt(s));)s++;return r=t.substring(j,s),I=12}if(t.charCodeAt(s+1)===42){s+=2;const N=n-1;let q=!1;for(;s<N;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,q=!0;break}s++}return q||(s++,S=1),r=t.substring(j,s),I=13}return r+=String.fromCharCode(z),s++,I=16}case 45:if(r+=String.fromCharCode(z),s++,s===n||!b(t.charCodeAt(s)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=w(),I=11;default:for(;s<n&&M(z);)s++,z=t.charCodeAt(s);if(u!==s){switch(r=t.substring(u,s),r){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return r+=String.fromCharCode(z),s++,I=16}}function M(z){if(m(z)||E(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let z;do z=T();while(z>=12&&z<=15);return z}return{setPosition:g,getPosition:()=>s,scan:i?F:T,getToken:()=>I,getTokenValue:()=>r,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>S}}e.$Vm=A;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function P(t,i){const s=[],n=new Object;let r;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function S($,g,w,D){u.value=$,u.offset=g,u.length=w,u.type=D,u.colonOffset=void 0,r=u}try{c(t,{onObjectBegin:($,g)=>{if(i<=$)throw n;r=void 0,I=i>$,s.push("")},onObjectProperty:($,g,w)=>{if(i<g||(S($,g,w,"property"),s[s.length-1]=$,i<=g+w))throw n},onObjectEnd:($,g)=>{if(i<=$)throw n;r=void 0,s.pop()},onArrayBegin:($,g)=>{if(i<=$)throw n;r=void 0,s.push(0)},onArrayEnd:($,g)=>{if(i<=$)throw n;r=void 0,s.pop()},onLiteralValue:($,g,w)=>{if(i<g||(S($,g,w,a($)),i<=g+w))throw n},onSeparator:($,g,w)=>{if(i<=g)throw n;if($===":"&&r&&r.type==="property")r.colonOffset=g,I=!1,r=void 0;else if($===","){const D=s[s.length-1];typeof D=="number"?s[s.length-1]=D+1:(I=!0,s[s.length-1]=""),r=void 0}}})}catch($){if($!==n)throw $}return{path:s,previousNode:r,isAtPropertyKey:I,matches:$=>{let g=0;for(let w=0;g<$.length&&w<s.length;w++)if($[g]===s[w]||$[g]==="*")g++;else if($[g]!=="**")return!1;return g===$.length}}}e.$Wm=P;function p(t,i=[],s=R.DEFAULT){let n=null,r=[];const u=[];function I($){Array.isArray(r)?r.push($):n!==null&&(r[n]=$)}return c(t,{onObjectBegin:()=>{const $={};I($),u.push(r),r=$,n=null},onObjectProperty:$=>{n=$},onObjectEnd:()=>{r=u.pop()},onArrayBegin:()=>{const $=[];I($),u.push(r),r=$,n=null},onArrayEnd:()=>{r=u.pop()},onLiteralValue:I,onError:($,g,w)=>{i.push({error:$,offset:g,length:w})}},s),r[0]}e.$Xm=p;function y(t,i=[],s=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r($){n.type==="property"&&(n.length=$-n.offset,n=n.parent)}function u($){return n.children.push($),$}c(t,{onObjectBegin:$=>{n=u({type:"object",offset:$,length:-1,parent:n,children:[]})},onObjectProperty:($,g,w)=>{n=u({type:"property",offset:g,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:$,offset:g,length:w,parent:n})},onObjectEnd:($,g)=>{n.length=$+g-n.offset,n=n.parent,r($+g)},onArrayBegin:($,g)=>{n=u({type:"array",offset:$,length:-1,parent:n,children:[]})},onArrayEnd:($,g)=>{n.length=$+g-n.offset,n=n.parent,r($+g)},onLiteralValue:($,g,w)=>{u({type:a($),offset:g,length:w,parent:n,value:$}),r(g+w)},onSeparator:($,g,w)=>{n.type==="property"&&($===":"?n.colonOffset=g:$===","&&r(g))},onError:($,g,w)=>{i.push({error:$,offset:g,length:w})}},s);const S=n.children[0];return S&&delete S.parent,S}e.$Ym=y;function k(t,i){if(!t)return;let s=t;for(const n of i)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===n){s=u.children[1],r=!0;break}if(!r)return}else{const r=n;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.$Zm=k;function v(t){if(!t.parent||!t.parent.children)return[];const i=v(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.$1m=v;function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const i=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(i[s.children[0].value]=h(n))}return i}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$2m=h;function o(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.$3m=o;function l(t,i,s=!1){if(o(t,i,s)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=i;r++){const u=l(n[r],i,s);if(u)return u}return t}}e.$4m=l;function c(t,i,s=R.DEFAULT){const n=A(t,!1);function r(ie){return ie?()=>ie(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(ie){return ie?ce=>ie(ce,n.getTokenOffset(),n.getTokenLength()):()=>!0}const I=r(i.onObjectBegin),S=u(i.onObjectProperty),$=r(i.onObjectEnd),g=r(i.onArrayBegin),w=r(i.onArrayEnd),D=u(i.onLiteralValue),T=u(i.onSeparator),M=r(i.onComment),F=u(i.onError),z=s&&s.disallowComments,j=s&&s.allowTrailingComma;function N(){for(;;){const ie=n.scan();switch(n.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:z||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(ie){case 12:case 13:z?q(10):M();break;case 16:q(1);break;case 15:case 14:break;default:return ie}}}function q(ie,ce=[],ye=[]){if(F(ie),ce.length+ye.length>0){let H=n.getToken();for(;H!==17;){if(ce.indexOf(H)!==-1){N();break}else if(ye.indexOf(H)!==-1)break;H=N()}}}function K(ie){const ce=n.getTokenValue();return ie?D(ce):S(ce),N(),!0}function me(){switch(n.getToken()){case 11:{let ie=0;try{ie=JSON.parse(n.getTokenValue()),typeof ie!="number"&&(q(2),ie=0)}catch{q(2)}D(ie);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return N(),!0}function te(){return n.getToken()!==10?(q(3,[],[2,5]),!1):(K(!1),n.getToken()===6?(T(":"),N(),le()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function G(){I(),N();let ie=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ie||q(4,[],[]),T(","),N(),n.getToken()===2&&j)break}else ie&&q(6,[],[]);te()||q(4,[],[2,5]),ie=!0}return $(),n.getToken()!==2?q(7,[2],[]):N(),!0}function J(){g(),N();let ie=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ie||q(4,[],[]),T(","),N(),n.getToken()===4&&j)break}else ie&&q(6,[],[]);le()||q(4,[],[4,5]),ie=!0}return w(),n.getToken()!==4?q(8,[4],[]):N(),!0}function le(){switch(n.getToken()){case 3:return J();case 1:return G();case 10:return K(!0);default:return me()}}return N(),n.getToken()===17?s.allowEmptyContent?!0:(q(4,[],[]),!1):le()?(n.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.$5m=c;function d(t,i){const s=A(t),n=[];let r,u=0,I;do switch(I=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:u!==I&&n.push(t.substring(u,I)),i!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,i)),u=s.getPosition();break}while(r!==17);return n.join("")}e.$6m=d;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$7m=a}),define(De[47],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class C{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=C}),define(De[76],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class C{static{this.Undefined=new C(void 0)}constructor(R){this.element=R,this.next=C.Undefined,this.prev=C.Undefined}}class O{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let R=this.a;for(;R!==C.Undefined;){const A=R.next;R.prev=C.Undefined,R.next=C.Undefined,R=A}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,A){const m=new C(R);if(this.a===C.Undefined)this.a=m,this.b=m;else if(A){const b=this.b;this.b=m,m.prev=b,b.next=m}else{const b=this.a;this.a=m,m.next=b,b.prev=m}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(m))}}shift(){if(this.a!==C.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==C.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==C.Undefined&&R.next!==C.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===C.Undefined&&R.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):R.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):R.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==C.Undefined;)yield R.element,R=R.next}}e.$2c=O}),define(De[28],Ce([1,0]),function($e,e){"use strict";var C,O,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function R(l,c,d){let a=l.get(c);return a===void 0&&(a=d,l.set(c,a)),a}e.$xc=R;function A(l){const c=[];return l.forEach((d,a)=>{c.push(`${a} => ${d}`)}),`Map(${l.size}) {${c.join(", ")}}`}e.$yc=A;function m(l){const c=[];return l.forEach(d=>{c.push(d)}),`Set(${l.size}) {${c.join(", ")}}`}e.$zc=m;class E{constructor(c,d){this.uri=c,this.value=d}}function b(l){return Array.isArray(l)}class L{static{this.a=c=>c.toString()}constructor(c,d){if(this[C]="ResourceMap",c instanceof L)this.b=new Map(c.b),this.c=d??L.a;else if(b(c)){this.b=new Map,this.c=d??L.a;for(const[a,t]of c)this.set(a,t)}else this.b=new Map,this.c=c??L.a}set(c,d){return this.b.set(this.c(c),new E(c,d)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,d){typeof d<"u"&&(c=c.bind(d));for(const[a,t]of this.b)c(t.value,t.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$Ac=L;class P{constructor(c,d){this[O]="ResourceSet",!c||typeof c=="function"?this.a=new L(c):(this.a=new L(d),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,d){this.a.forEach((a,t)=>c.call(d,t,t,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=P;var p;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class y{constructor(){this[f]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,d=0){const a=this.a.get(c);if(a)return d!==0&&this.j(a,d),a.value}set(c,d,a=0){let t=this.a.get(c);if(t)t.value=d,a!==0&&this.j(t,a);else{switch(t={key:c,value:d,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(c,t),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const d=this.a.get(c);if(d)return this.a.delete(c),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,d){const a=this.e;let t=this.b;for(;t;){if(d?c.bind(d)(t.value,t.key,this):c(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,d=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const i={value:a.key,done:!1};return a=a.next,i}else return{value:void 0,done:!0}}};return t}values(){const c=this,d=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const i={value:a.value,done:!1};return a=a.next,i}else return{value:void 0,done:!0}}};return t}entries(){const c=this,d=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const i={value:[a.key,a.value],done:!1};return a=a.next,i}else return{value:void 0,done:!0}}};return t}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let d=this.b,a=this.size;for(;d&&a>c;)this.a.delete(d.key),d=d.next,a--;this.b=d,this.d=a,d&&(d.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const d=c.next,a=c.previous;if(!d||!a)throw new Error("Invalid list");d.previous=a,a.next=d}c.next=void 0,c.previous=void 0,this.e++}j(c,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(c===this.b)return;const a=c.next,t=c.previous;c===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(d===2){if(c===this.c)return;const a=c.next,t=c.previous;c===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((d,a)=>{c.push([a,d])}),c}fromJSON(c){this.clear();for(const[d,a]of c)this.set(d,a)}}e.$Cc=y;class k extends y{constructor(c,d=1){super(),this.k=c,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,d=2){return super.get(c,d)}peek(c){return super.get(c,0)}set(c,d){return super.set(c,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=k;class v{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let d=this.a.get(c)||0;return d===0?!1:(d--,d===0?this.a.delete(c):this.a.set(c,d),!0)}has(c){return this.a.has(c)}}e.$Ec=v;class h{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[d,a]of c)this.set(d,a)}clear(){this.a.clear(),this.b.clear()}set(c,d){this.a.set(c,d),this.b.set(d,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const d=this.a.get(c);return d===void 0?!1:(this.a.delete(c),this.b.delete(d),!0)}forEach(c,d){this.a.forEach((a,t)=>{c.call(d,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=h;class o{constructor(){this.a=new Map}add(c,d){let a=this.a.get(c);a||(a=new Set,this.a.set(c,a)),a.add(d)}delete(c,d){const a=this.a.get(c);a&&(a.delete(d),a.size===0&&this.a.delete(c))}forEach(c,d){const a=this.a.get(c);a&&a.forEach(d)}get(c){const d=this.a.get(c);return d||new Set}}e.$Gc=o}),define(De[3],Ce([1,0,19,74,28,75,51]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const m=!1;let E=null;class b{constructor(){this.b=new Map}static{this.a=0}c(w){let D=this.b.get(w);return D||(D={parent:null,source:null,isSingleton:!1,value:w,idx:b.a++},this.b.set(w,D)),D}trackDisposable(w){const D=this.c(w);D.source||(D.source=new Error().stack)}setParent(w,D){const T=this.c(w);T.parent=D}markAsDisposed(w){this.b.delete(w)}markAsSingleton(w){this.c(w).isSingleton=!0}f(w,D){const T=D.get(w);if(T)return T;const M=w.parent?this.f(this.c(w.parent),D):w;return D.set(w,M),M}getTrackedDisposables(){const w=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,w).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(w=10,D){let T;if(D)T=D;else{const N=new Map,q=[...this.b.values()].filter(me=>me.source!==null&&!this.f(me,N).isSingleton);if(q.length===0)return;const K=new Set(q.map(me=>me.value));if(T=q.filter(me=>!(me.parent&&K.has(me.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function M(N){function q(me,te){for(;me.length>0&&te.some(G=>typeof G=="string"?G===me[0]:me[0].match(G));)me.shift()}const K=N.source.split(`
`).map(me=>me.trim().replace("at ","")).filter(me=>me!=="");return q(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const F=new f.$Gc;for(const N of T){const q=M(N);for(let K=0;K<=q.length;K++)F.add(q.slice(0,K).join(`
`),N)}T.sort((0,C.$7b)(N=>N.idx,C.$9b));let z="",j=0;for(const N of T.slice(0,w)){j++;const q=M(N),K=[];for(let me=0;me<q.length;me++){let te=q[me];te=`(shared with ${F.get(q.slice(0,me+1).join(`
`)).size}/${T.length} leaks) at ${te}`;const J=F.get(q.slice(0,me).join(`
`)),le=(0,O.$J)([...J].map(ie=>M(ie)[me]),ie=>ie);delete le[q[me]];for(const[ie,ce]of Object.entries(le))K.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${ie}`);K.unshift(te)}z+=`


==================== Leaking disposable ${j}/${T.length}: ${N.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return T.length>w&&(z+=`


... and ${T.length-w} more leaking disposables

`),{leaks:T,details:z}}}e.$Hc=b;function L(g){E=g}if(e.$Ic=L,m){const g="__is_disposable_tracked__";L(new class{trackDisposable(w){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{w[g]||console.log(D)},3e3)}setParent(w,D){if(w&&w!==t.None)try{w[g]=!0}catch{}}markAsDisposed(w){if(w&&w!==t.None)try{w[g]=!0}catch{}}markAsSingleton(w){}})}function P(g){return E?.trackDisposable(g),g}e.$Jc=P;function p(g){E?.markAsDisposed(g)}e.$Kc=p;function y(g,w){E?.setParent(g,w)}function k(g,w){if(E)for(const D of g)E.setParent(D,w)}function v(g){return E?.markAsSingleton(g),g}e.$Lc=v;function h(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.$Mc=h;function o(g){if(A.Iterable.is(g)){const w=[];for(const D of g)if(D)try{D.dispose()}catch(T){w.push(T)}if(w.length===1)throw w[0];if(w.length>1)throw new AggregateError(w,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}e.$Nc=o;function l(g){for(const w of g)h(w)&&w.dispose();return[]}e.$Oc=l;function c(...g){const w=d(()=>o(g));return k(g,w),w}e.$Pc=c;function d(g){const w=P({dispose:(0,R.$db)(()=>{p(w),g()})});return w}e.$Qc=d;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(w){if(!w)return w;if(w===this)throw new Error("Cannot register a disposable on itself!");return y(w,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(w),w}delete(w){if(w){if(w===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(w),w.dispose()}}deleteAndLeak(w){w&&this.f.has(w)&&(this.f.delete(w),y(w,null))}}e.$Rc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,P(this),y(this.q,this)}dispose(){p(this),this.q.dispose()}B(w){if(w===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(w)}}e.$Sc=t;class i{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(w){this.b||w===this.a||(this.a?.dispose(),w&&y(w,this),this.a=w)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const w=this.a;return this.a=void 0,w&&y(w,null),w}}e.$Tc=i;class s{constructor(w){this.b=w,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=s;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(w){let D=w;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,p(this))},this}}e.$Vc=n;class r{constructor(){this.a=new Map}acquire(w,...D){let T=this.a.get(w);T||(T={counter:0,object:this.b(w,...D)},this.a.set(w,T));const{object:M}=T,F=(0,R.$db)(()=>{--T.counter===0&&(this.c(w,T.object),this.a.delete(w))});return T.counter++,{object:M,dispose:F}}}e.$Wc=r;class u{constructor(w){this.a=w}async acquire(w,...D){const T=this.a.acquire(w,...D);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(M){throw T.dispose(),M}}}e.$Xc=u;class I{constructor(w){this.object=w}dispose(){}}e.$Yc=I;function S(g){const w=new a;try{g(w)}finally{w.dispose()}}e.$Zc=S;class ${constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(w){return this.a.has(w)}get size(){return this.a.size}get(w){return this.a.get(w)}set(w,D,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(w)?.dispose(),this.a.set(w,D)}deleteAndDispose(w){this.a.get(w)?.dispose(),this.a.delete(w)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=$}),function($e,e){typeof define=="function"&&define.amd?define(De[158],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(_,x){for(var pe=0;pe<x.length;pe++){var ae=x[pe];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(_,ae.key,ae)}}function C(_,x,pe){return x&&e(_.prototype,x),pe&&e(_,pe),Object.defineProperty(_,"prototype",{writable:!1}),_}function O(_,x){if(_){if(typeof _=="string")return f(_,x);var pe=Object.prototype.toString.call(_).slice(8,-1);if(pe==="Object"&&_.constructor&&(pe=_.constructor.name),pe==="Map"||pe==="Set")return Array.from(_);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return f(_,x)}}function f(_,x){(x==null||x>_.length)&&(x=_.length);for(var pe=0,ae=new Array(x);pe<x;pe++)ae[pe]=_[pe];return ae}function R(_,x){var pe=typeof Symbol<"u"&&_[Symbol.iterator]||_["@@iterator"];if(pe)return(pe=pe.call(_)).next.bind(pe);if(Array.isArray(_)||(pe=O(_))||x&&_&&typeof _.length=="number"){pe&&(_=pe);var ae=0;return function(){return ae>=_.length?{done:!0}:{done:!1,value:_[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=A();function m(_){$e.defaults=_}var E=/[&<>"']/,b=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(x){return p[x]};function k(_,x){if(x){if(E.test(_))return _.replace(b,y)}else if(L.test(_))return _.replace(P,y);return _}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(_){return _.replace(v,function(x,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var o=/(^|[^\[])\^/g;function l(_,x){_=typeof _=="string"?_:_.source,x=x||"";var pe={replace:function(fe,ee){return ee=ee.source||ee,ee=ee.replace(o,"$1"),_=_.replace(fe,ee),pe},getRegex:function(){return new RegExp(_,x)}};return pe}var c=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(_,x,pe){if(_){var ae;try{ae=decodeURIComponent(h(pe)).replace(c,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}x&&!d.test(pe)&&(pe=r(x,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch{return null}return pe}var t={},i=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(_,x){t[" "+_]||(i.test(_)?t[" "+_]=_+"/":t[" "+_]=$(_,"/",!0)),_=t[" "+_];var pe=_.indexOf(":")===-1;return x.substring(0,2)==="//"?pe?x:_.replace(s,"$1")+x:x.charAt(0)==="/"?pe?x:_.replace(n,"$1")+x:_+x}var u={exec:function(){}};function I(_){for(var x=1,pe,ae;x<arguments.length;x++){pe=arguments[x];for(ae in pe)Object.prototype.hasOwnProperty.call(pe,ae)&&(_[ae]=pe[ae])}return _}function S(_,x){var pe=_.replace(/\|/g,function(ee,de,be){for(var Pe=!1,U=de;--U>=0&&be[U]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ae=pe.split(/ \|/),fe=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>x)ae.splice(x);else for(;ae.length<x;)ae.push("");for(;fe<ae.length;fe++)ae[fe]=ae[fe].trim().replace(/\\\|/g,"|");return ae}function $(_,x,pe){var ae=_.length;if(ae===0)return"";for(var fe=0;fe<ae;){var ee=_.charAt(ae-fe-1);if(ee===x&&!pe)fe++;else if(ee!==x&&pe)fe++;else break}return _.slice(0,ae-fe)}function g(_,x){if(_.indexOf(x[1])===-1)return-1;for(var pe=_.length,ae=0,fe=0;fe<pe;fe++)if(_[fe]==="\\")fe++;else if(_[fe]===x[0])ae++;else if(_[fe]===x[1]&&(ae--,ae<0))return fe;return-1}function w(_){_&&_.sanitize&&!_.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(_,x){if(x<1)return"";for(var pe="";x>1;)x&1&&(pe+=_),x>>=1,_+=_;return pe+_}function T(_,x,pe,ae){var fe=x.href,ee=x.title?k(x.title):null,de=_[1].replace(/\\([\[\]])/g,"$1");if(_[0].charAt(0)!=="!"){ae.state.inLink=!0;var be={type:"link",raw:pe,href:fe,title:ee,text:de,tokens:ae.inlineTokens(de)};return ae.state.inLink=!1,be}return{type:"image",raw:pe,href:fe,title:ee,text:k(de)}}function M(_,x){var pe=_.match(/^(\s+)(?:```)/);if(pe===null)return x;var ae=pe[1];return x.split(`
`).map(function(fe){var ee=fe.match(/^\s+/);if(ee===null)return fe;var de=ee[0];return de.length>=ae.length?fe.slice(ae.length):fe}).join(`
`)}var F=function(){function _(pe){this.options=pe||$e.defaults}var x=_.prototype;return x.space=function(ae){var fe=this.rules.block.newline.exec(ae);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},x.code=function(ae){var fe=this.rules.block.code.exec(ae);if(fe){var ee=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:$(ee,`
`)}}},x.fences=function(ae){var fe=this.rules.block.fences.exec(ae);if(fe){var ee=fe[0],de=M(ee,fe[3]||"");return{type:"code",raw:ee,lang:fe[2]?fe[2].trim():fe[2],text:de}}},x.heading=function(ae){var fe=this.rules.block.heading.exec(ae);if(fe){var ee=fe[2].trim();if(/#$/.test(ee)){var de=$(ee,"#");(this.options.pedantic||!de||/ $/.test(de))&&(ee=de.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:ee,tokens:this.lexer.inline(ee)}}},x.hr=function(ae){var fe=this.rules.block.hr.exec(ae);if(fe)return{type:"hr",raw:fe[0]}},x.blockquote=function(ae){var fe=this.rules.block.blockquote.exec(ae);if(fe){var ee=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},x.list=function(ae){var fe=this.rules.block.list.exec(ae);if(fe){var ee,de,be,Pe,U,Q,se,oe,Z,ge,Ee,ze,We=fe[1].trim(),_e=We.length>1,Ye={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(ze=!1,!(!(fe=it.exec(ae))||this.rules.block.hr.test(ae)));){if(ee=fe[0],ae=ae.substring(ee.length),oe=fe[2].split(`
`,1)[0],Z=ae.split(`
`,1)[0],this.options.pedantic?(Pe=2,Ee=oe.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,Ee=oe.slice(Pe),Pe+=fe[1].length),Q=!1,!oe&&/^ *$/.test(Z)&&(ee+=Z+`
`,ae=ae.substring(Z.length+1),ze=!0),!ze)for(var tt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Te=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ae&&(ge=ae.split(`
`,1)[0],oe=ge,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Te.test(oe)||qe.test(oe)||tt.test(oe)||Ae.test(ae)));){if(oe.search(/[^ ]/)>=Pe||!oe.trim())Ee+=`
`+oe.slice(Pe);else if(!Q)Ee+=`
`+oe;else break;!Q&&!oe.trim()&&(Q=!0),ee+=ge+`
`,ae=ae.substring(ge.length+1)}Ye.loose||(se?Ye.loose=!0:/\n *\n *$/.test(ee)&&(se=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(Ee),de&&(be=de[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ee,task:!!de,checked:be,loose:!1,text:Ee}),Ye.raw+=ee}Ye.items[Ye.items.length-1].raw=ee.trimRight(),Ye.items[Ye.items.length-1].text=Ee.trimRight(),Ye.raw=Ye.raw.trimRight();var Le=Ye.items.length;for(U=0;U<Le;U++){this.lexer.state.top=!1,Ye.items[U].tokens=this.lexer.blockTokens(Ye.items[U].text,[]);var Xe=Ye.items[U].tokens.filter(function(ue){return ue.type==="space"}),he=Xe.every(function(ue){for(var Ie=ue.raw.split(""),Ke=0,Ue=R(Ie),Ze;!(Ze=Ue()).done;){var nt=Ze.value;if(nt===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ye.loose&&Xe.length&&he&&(Ye.loose=!0,Ye.items[U].loose=!0)}return Ye}},x.html=function(ae){var fe=this.rules.block.html.exec(ae);if(fe){var ee={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]);ee.type="paragraph",ee.text=de,ee.tokens=this.lexer.inline(de)}return ee}},x.def=function(ae){var fe=this.rules.block.def.exec(ae);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var ee=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:fe[0],href:fe[2],title:fe[3]}}},x.table=function(ae){var fe=this.rules.block.table.exec(ae);if(fe){var ee={type:"table",header:S(fe[1]).map(function(se){return{text:se}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=fe[0];var de=ee.align.length,be,Pe,U,Q;for(be=0;be<de;be++)/^ *-+: *$/.test(ee.align[be])?ee.align[be]="right":/^ *:-+: *$/.test(ee.align[be])?ee.align[be]="center":/^ *:-+ *$/.test(ee.align[be])?ee.align[be]="left":ee.align[be]=null;for(de=ee.rows.length,be=0;be<de;be++)ee.rows[be]=S(ee.rows[be],ee.header.length).map(function(se){return{text:se}});for(de=ee.header.length,Pe=0;Pe<de;Pe++)ee.header[Pe].tokens=this.lexer.inline(ee.header[Pe].text);for(de=ee.rows.length,Pe=0;Pe<de;Pe++)for(Q=ee.rows[Pe],U=0;U<Q.length;U++)Q[U].tokens=this.lexer.inline(Q[U].text);return ee}}},x.lheading=function(ae){var fe=this.rules.block.lheading.exec(ae);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},x.paragraph=function(ae){var fe=this.rules.block.paragraph.exec(ae);if(fe){var ee=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:ee,tokens:this.lexer.inline(ee)}}},x.text=function(ae){var fe=this.rules.block.text.exec(ae);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},x.escape=function(ae){var fe=this.rules.inline.escape.exec(ae);if(fe)return{type:"escape",raw:fe[0],text:k(fe[1])}},x.tag=function(ae){var fe=this.rules.inline.tag.exec(ae);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]):fe[0]}},x.link=function(ae){var fe=this.rules.inline.link.exec(ae);if(fe){var ee=fe[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var de=$(ee.slice(0,-1),"\\");if((ee.length-de.length)%2===0)return}else{var be=g(fe[2],"()");if(be>-1){var Pe=fe[0].indexOf("!")===0?5:4,U=Pe+fe[1].length+be;fe[2]=fe[2].substring(0,be),fe[0]=fe[0].substring(0,U).trim(),fe[3]=""}}var Q=fe[2],se="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Q);oe&&(Q=oe[1],se=oe[3])}else se=fe[3]?fe[3].slice(1,-1):"";return Q=Q.trim(),/^</.test(Q)&&(this.options.pedantic&&!/>$/.test(ee)?Q=Q.slice(1):Q=Q.slice(1,-1)),T(fe,{href:Q&&Q.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},x.reflink=function(ae,fe){var ee;if((ee=this.rules.inline.reflink.exec(ae))||(ee=this.rules.inline.nolink.exec(ae))){var de=(ee[2]||ee[1]).replace(/\s+/g," ");if(de=fe[de.toLowerCase()],!de||!de.href){var be=ee[0].charAt(0);return{type:"text",raw:be,text:be}}return T(ee,de,ee[0],this.lexer)}},x.emStrong=function(ae,fe,ee){ee===void 0&&(ee="");var de=this.rules.inline.emStrong.lDelim.exec(ae);if(de&&!(de[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=de[1]||de[2]||"";if(!be||be&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Pe=de[0].length-1,U,Q,se=Pe,oe=0,Z=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Z.lastIndex=0,fe=fe.slice(-1*ae.length+Pe);(de=Z.exec(fe))!=null;)if(U=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!U){if(Q=U.length,de[3]||de[4]){se+=Q;continue}else if((de[5]||de[6])&&Pe%3&&!((Pe+Q)%3)){oe+=Q;continue}if(se-=Q,!(se>0)){if(Q=Math.min(Q,Q+se+oe),Math.min(Pe,Q)%2){var ge=ae.slice(1,Pe+de.index+Q);return{type:"em",raw:ae.slice(0,Pe+de.index+Q+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var Ee=ae.slice(2,Pe+de.index+Q-1);return{type:"strong",raw:ae.slice(0,Pe+de.index+Q+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},x.codespan=function(ae){var fe=this.rules.inline.code.exec(ae);if(fe){var ee=fe[2].replace(/\n/g," "),de=/[^ ]/.test(ee),be=/^ /.test(ee)&&/ $/.test(ee);return de&&be&&(ee=ee.substring(1,ee.length-1)),ee=k(ee,!0),{type:"codespan",raw:fe[0],text:ee}}},x.br=function(ae){var fe=this.rules.inline.br.exec(ae);if(fe)return{type:"br",raw:fe[0]}},x.del=function(ae){var fe=this.rules.inline.del.exec(ae);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},x.autolink=function(ae,fe){var ee=this.rules.inline.autolink.exec(ae);if(ee){var de,be;return ee[2]==="@"?(de=k(this.options.mangle?fe(ee[1]):ee[1]),be="mailto:"+de):(de=k(ee[1]),be=de),{type:"link",raw:ee[0],text:de,href:be,tokens:[{type:"text",raw:de,text:de}]}}},x.url=function(ae,fe){var ee;if(ee=this.rules.inline.url.exec(ae)){var de,be;if(ee[2]==="@")de=k(this.options.mangle?fe(ee[0]):ee[0]),be="mailto:"+de;else{var Pe;do Pe=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Pe!==ee[0]);de=k(ee[0]),ee[1]==="www."?be="http://"+de:be=de}return{type:"link",raw:ee[0],text:de,href:be,tokens:[{type:"text",raw:de,text:de}]}}},x.inlineText=function(ae,fe){var ee=this.rules.inline.text.exec(ae);if(ee){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):k(ee[0]):ee[0]:de=k(this.options.smartypants?fe(ee[0]):ee[0]),{type:"text",raw:ee[0],text:de}}},_}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=l(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=l(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=l(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=l(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=l(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=l(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=I({},z),z.gfm=I({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=l(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=l(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=I({},z.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:l(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=l(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=l(z._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=l(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=l(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=l(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=l(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=l(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=l(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=l(j.reflink).replace("label",j._label).replace("ref",z._label).getRegex(),j.nolink=l(j.nolink).replace("ref",z._label).getRegex(),j.reflinkSearch=l(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=I({},j),j.pedantic=I({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=I({},j.normal,{escape:l(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=l(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=I({},j.gfm,{br:l(j.br).replace("{2,}","*").getRegex(),text:l(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(_){return _.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(_){var x="",pe,ae,fe=_.length;for(pe=0;pe<fe;pe++)ae=_.charCodeAt(pe),Math.random()>.5&&(ae="x"+ae.toString(16)),x+="&#"+ae+";";return x}var K=function(){function _(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||$e.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:z.normal,inline:j.normal};this.options.pedantic?(ae.block=z.pedantic,ae.inline=j.pedantic):this.options.gfm&&(ae.block=z.gfm,this.options.breaks?ae.inline=j.breaks:ae.inline=j.gfm),this.tokenizer.rules=ae}_.lex=function(ae,fe){var ee=new _(fe);return ee.lex(ae)},_.lexInline=function(ae,fe){var ee=new _(fe);return ee.inlineTokens(ae)};var x=_.prototype;return x.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},x.blockTokens=function(ae,fe){var ee=this;fe===void 0&&(fe=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(se,oe,Z){return oe+"    ".repeat(Z.length)});for(var de,be,Pe,U;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(de=se.call({lexer:ee},ae,fe))?(ae=ae.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.space(ae)){ae=ae.substring(de.raw.length),de.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(de);continue}if(de=this.tokenizer.code(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de);continue}if(de=this.tokenizer.fences(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.heading(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.hr(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.blockquote(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.list(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.html(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.def(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+de.raw,be.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.lheading(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(Pe=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,oe=ae.slice(1),Z=void 0;ee.options.extensions.startBlock.forEach(function(ge){Z=ge.call({lexer:this},oe),typeof Z=="number"&&Z>=0&&(se=Math.min(se,Z))}),se<1/0&&se>=0&&(Pe=ae.substring(0,se+1))}(),this.state.top&&(de=this.tokenizer.paragraph(Pe))){be=fe[fe.length-1],U&&be.type==="paragraph"?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de),U=Pe.length!==ae.length,ae=ae.substring(de.raw.length);continue}if(de=this.tokenizer.text(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&be.type==="text"?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de);continue}if(ae){var Q="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return this.state.top=!0,fe},x.inline=function(ae,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:ae,tokens:fe}),fe},x.inlineTokens=function(ae,fe){var ee=this;fe===void 0&&(fe=[]);var de,be,Pe,U=ae,Q,se,oe;if(this.tokens.links){var Z=Object.keys(this.tokens.links);if(Z.length>0)for(;(Q=this.tokenizer.rules.inline.reflinkSearch.exec(U))!=null;)Z.includes(Q[0].slice(Q[0].lastIndexOf("[")+1,-1))&&(U=U.slice(0,Q.index)+"["+D("a",Q[0].length-2)+"]"+U.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Q=this.tokenizer.rules.inline.blockSkip.exec(U))!=null;)U=U.slice(0,Q.index)+"["+D("a",Q[0].length-2)+"]"+U.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Q=this.tokenizer.rules.inline.escapedEmSt.exec(U))!=null;)U=U.slice(0,Q.index)+"++"+U.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(se||(oe=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(de=Ee.call({lexer:ee},ae,fe))?(ae=ae.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.escape(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.tag(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&de.type==="text"&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.link(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&de.type==="text"&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.emStrong(ae,U,oe)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.codespan(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.br(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.del(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.autolink(ae,q)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(ae,q))){ae=ae.substring(de.raw.length),fe.push(de);continue}if(Pe=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,ze=ae.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},ze),typeof We=="number"&&We>=0&&(Ee=Math.min(Ee,We))}),Ee<1/0&&Ee>=0&&(Pe=ae.substring(0,Ee+1))}(),de=this.tokenizer.inlineText(Pe,N)){ae=ae.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(oe=de.raw.slice(-1)),se=!0,be=fe[fe.length-1],be&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(ae){var ge="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return fe},C(_,null,[{key:"rules",get:function(){return{block:z,inline:j}}}]),_}(),me=function(){function _(pe){this.options=pe||$e.defaults}var x=_.prototype;return x.code=function(ae,fe,ee){var de=(fe||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(ae,de);be!=null&&be!==ae&&(ee=!0,ae=be)}return ae=ae.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+k(de,!0)+'">'+(ee?ae:k(ae,!0))+`</code></pre>
`:"<pre><code>"+(ee?ae:k(ae,!0))+`</code></pre>
`},x.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},x.html=function(ae){return ae},x.heading=function(ae,fe,ee,de){if(this.options.headerIds){var be=this.options.headerPrefix+de.slug(ee);return"<h"+fe+' id="'+be+'">'+ae+"</h"+fe+`>
`}return"<h"+fe+">"+ae+"</h"+fe+`>
`},x.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},x.list=function(ae,fe,ee){var de=fe?"ol":"ul",be=fe&&ee!==1?' start="'+ee+'"':"";return"<"+de+be+`>
`+ae+"</"+de+`>
`},x.listitem=function(ae){return"<li>"+ae+`</li>
`},x.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},x.paragraph=function(ae){return"<p>"+ae+`</p>
`},x.table=function(ae,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+fe+`</table>
`},x.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},x.tablecell=function(ae,fe){var ee=fe.header?"th":"td",de=fe.align?"<"+ee+' align="'+fe.align+'">':"<"+ee+">";return de+ae+("</"+ee+`>
`)},x.strong=function(ae){return"<strong>"+ae+"</strong>"},x.em=function(ae){return"<em>"+ae+"</em>"},x.codespan=function(ae){return"<code>"+ae+"</code>"},x.br=function(){return this.options.xhtml?"<br/>":"<br>"},x.del=function(ae){return"<del>"+ae+"</del>"},x.link=function(ae,fe,ee){if(ae=a(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var de='<a href="'+k(ae)+'"';return fe&&(de+=' title="'+fe+'"'),de+=">"+ee+"</a>",de},x.image=function(ae,fe,ee){if(ae=a(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var de='<img src="'+ae+'" alt="'+ee+'"';return fe&&(de+=' title="'+fe+'"'),de+=this.options.xhtml?"/>":">",de},x.text=function(ae){return ae},_}(),te=function(){function _(){}var x=_.prototype;return x.strong=function(ae){return ae},x.em=function(ae){return ae},x.codespan=function(ae){return ae},x.del=function(ae){return ae},x.html=function(ae){return ae},x.text=function(ae){return ae},x.link=function(ae,fe,ee){return""+ee},x.image=function(ae,fe,ee){return""+ee},x.br=function(){return""},_}(),G=function(){function _(){this.seen={}}var x=_.prototype;return x.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},x.getNextSafeSlug=function(ae,fe){var ee=ae,de=0;if(this.seen.hasOwnProperty(ee)){de=this.seen[ae];do de++,ee=ae+"-"+de;while(this.seen.hasOwnProperty(ee))}return fe||(this.seen[ae]=de,this.seen[ee]=0),ee},x.slug=function(ae,fe){fe===void 0&&(fe={});var ee=this.serialize(ae);return this.getNextSafeSlug(ee,fe.dryrun)},_}(),J=function(){function _(pe){this.options=pe||$e.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new G}_.parse=function(ae,fe){var ee=new _(fe);return ee.parse(ae)},_.parseInline=function(ae,fe){var ee=new _(fe);return ee.parseInline(ae)};var x=_.prototype;return x.parse=function(ae,fe){fe===void 0&&(fe=!0);var ee="",de,be,Pe,U,Q,se,oe,Z,ge,Ee,ze,We,_e,Ye,it,tt,Ae,Te,qe,Le=ae.length;for(de=0;de<Le;de++){if(Ee=ae[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(qe=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){ee+=qe||"";continue}switch(Ee.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,h(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(Z="",oe="",U=Ee.header.length,be=0;be<U;be++)oe+=this.renderer.tablecell(this.parseInline(Ee.header[be].tokens),{header:!0,align:Ee.align[be]});for(Z+=this.renderer.tablerow(oe),ge="",U=Ee.rows.length,be=0;be<U;be++){for(se=Ee.rows[be],oe="",Q=se.length,Pe=0;Pe<Q;Pe++)oe+=this.renderer.tablecell(this.parseInline(se[Pe].tokens),{header:!1,align:Ee.align[Pe]});ge+=this.renderer.tablerow(oe)}ee+=this.renderer.table(Z,ge);continue}case"blockquote":{ge=this.parse(Ee.tokens),ee+=this.renderer.blockquote(ge);continue}case"list":{for(ze=Ee.ordered,We=Ee.start,_e=Ee.loose,U=Ee.items.length,ge="",be=0;be<U;be++)it=Ee.items[be],tt=it.checked,Ae=it.task,Ye="",it.task&&(Te=this.renderer.checkbox(tt),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Te+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Te+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Te}):Ye+=Te),Ye+=this.parse(it.tokens,_e),ge+=this.renderer.listitem(Ye,Ae,tt);ee+=this.renderer.list(ge,ze,We);continue}case"html":{ee+=this.renderer.html(Ee.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(ge=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;de+1<Le&&ae[de+1].type==="text";)Ee=ae[++de],ge+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);ee+=fe?this.renderer.paragraph(ge):ge;continue}default:{var Xe='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return ee},x.parseInline=function(ae,fe){fe=fe||this.renderer;var ee="",de,be,Pe,U=ae.length;for(de=0;de<U;de++){if(be=ae[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Pe=this.options.extensions.renderers[be.type].call({parser:this},be),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){ee+=Pe||"";continue}switch(be.type){case"escape":{ee+=fe.text(be.text);break}case"html":{ee+=fe.html(be.text);break}case"link":{ee+=fe.link(be.href,be.title,this.parseInline(be.tokens,fe));break}case"image":{ee+=fe.image(be.href,be.title,be.text);break}case"strong":{ee+=fe.strong(this.parseInline(be.tokens,fe));break}case"em":{ee+=fe.em(this.parseInline(be.tokens,fe));break}case"codespan":{ee+=fe.codespan(be.text);break}case"br":{ee+=fe.br();break}case"del":{ee+=fe.del(this.parseInline(be.tokens,fe));break}case"text":{ee+=fe.text(be.text);break}default:{var Q='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return ee},_}();function le(_,x,pe){if(typeof _>"u"||_===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");if(typeof x=="function"&&(pe=x,x=null),x=I({},le.defaults,x||{}),w(x),pe){var ae=x.highlight,fe;try{fe=K.lex(_,x)}catch(U){return pe(U)}var ee=function(Q){var se;if(!Q)try{x.walkTokens&&le.walkTokens(fe,x.walkTokens),se=J.parse(fe,x)}catch(oe){Q=oe}return x.highlight=ae,Q?pe(Q):pe(null,se)};if(!ae||ae.length<3||(delete x.highlight,!fe.length))return ee();var de=0;le.walkTokens(fe,function(U){U.type==="code"&&(de++,setTimeout(function(){ae(U.text,U.lang,function(Q,se){if(Q)return ee(Q);se!=null&&se!==U.text&&(U.text=se,U.escaped=!0),de--,de===0&&ee()})},0))}),de===0&&ee();return}function be(U){if(U.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+k(U.message+"",!0)+"</pre>";throw U}try{var Pe=K.lex(_,x);if(x.walkTokens){if(x.async)return Promise.all(le.walkTokens(Pe,x.walkTokens)).then(function(){return J.parse(Pe,x)}).catch(be);le.walkTokens(Pe,x.walkTokens)}return J.parse(Pe,x)}catch(U){be(U)}}le.options=le.setOptions=function(_){return I(le.defaults,_),m(le.defaults),le},le.getDefaults=A,le.defaults=$e.defaults,le.use=function(){for(var _=arguments.length,x=new Array(_),pe=0;pe<_;pe++)x[pe]=arguments[pe];var ae=I.apply(void 0,[{}].concat(x)),fe=le.defaults.extensions||{renderers:{},childTokens:{}},ee;x.forEach(function(de){if(de.extensions&&(ee=!0,de.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var U=fe.renderers?fe.renderers[Pe.name]:null;U?fe.renderers[Pe.name]=function(){for(var Q=arguments.length,se=new Array(Q),oe=0;oe<Q;oe++)se[oe]=arguments[oe];var Z=Pe.renderer.apply(this,se);return Z===!1&&(Z=U.apply(this,se)),Z}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),de.renderer&&function(){var Pe=le.defaults.renderer||new me,U=function(oe){var Z=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,Ee=new Array(ge),ze=0;ze<ge;ze++)Ee[ze]=arguments[ze];var We=de.renderer[oe].apply(Pe,Ee);return We===!1&&(We=Z.apply(Pe,Ee)),We}};for(var Q in de.renderer)U(Q);ae.renderer=Pe}(),de.tokenizer&&function(){var Pe=le.defaults.tokenizer||new F,U=function(oe){var Z=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,Ee=new Array(ge),ze=0;ze<ge;ze++)Ee[ze]=arguments[ze];var We=de.tokenizer[oe].apply(Pe,Ee);return We===!1&&(We=Z.apply(Pe,Ee)),We}};for(var Q in de.tokenizer)U(Q);ae.tokenizer=Pe}(),de.walkTokens){var be=le.defaults.walkTokens;ae.walkTokens=function(Pe){var U=[];return U.push(de.walkTokens.call(this,Pe)),be&&(U=U.concat(be.call(this,Pe))),U}}ee&&(ae.extensions=fe),le.setOptions(ae)})},le.walkTokens=function(_,x){for(var pe=[],ae=function(){var be=ee.value;switch(pe=pe.concat(x.call(le,be)),be.type){case"table":{for(var Pe=R(be.header),U;!(U=Pe()).done;){var Q=U.value;pe=pe.concat(le.walkTokens(Q.tokens,x))}for(var se=R(be.rows),oe;!(oe=se()).done;)for(var Z=oe.value,ge=R(Z),Ee;!(Ee=ge()).done;){var ze=Ee.value;pe=pe.concat(le.walkTokens(ze.tokens,x))}break}case"list":{pe=pe.concat(le.walkTokens(be.items,x));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[be.type]?le.defaults.extensions.childTokens[be.type].forEach(function(We){pe=pe.concat(le.walkTokens(be[We],x))}):be.tokens&&(pe=pe.concat(le.walkTokens(be.tokens,x)))}},fe=R(_),ee;!(ee=fe()).done;)ae();return pe},le.parseInline=function(_,x){if(typeof _>"u"||_===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");x=I({},le.defaults,x||{}),w(x);try{var pe=K.lexInline(_,x);return x.walkTokens&&le.walkTokens(pe,x.walkTokens),J.parseInline(pe,x)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+k(ae.message+"",!0)+"</pre>";throw ae}},le.Parser=J,le.parser=J.parse,le.Renderer=me,le.TextRenderer=te,le.Lexer=K,le.lexer=K.lex,le.Tokenizer=F,le.Slugger=G,le.parse=le;var ie=le.options,ce=le.setOptions,ye=le.use,H=le.walkTokens,B=le.parseInline,Y=le,re=J.parse,X=K.lex;$e.Lexer=K,$e.Parser=J,$e.Renderer=me,$e.Slugger=G,$e.TextRenderer=te,$e.Tokenizer=F,$e.getDefaults=A,$e.lexer=X,$e.marked=le,$e.options=ie,$e.parse=Y,$e.parseInline=B,$e.parser=re,$e.setOptions=ce,$e.use=ye,$e.walkTokens=H,Object.defineProperty($e,"__esModule",{value:!0})}),define(De[77],Ce([1,0,28]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$pl=void 0;const O=new C.$Dc(1e4);function f(b){return E(b,"NFC",O)}e.$pl=f;const R=new C.$Dc(1e4);function A(b){return E(b,"NFD",R)}e.$ql=A;const m=/[^\u0000-\u0080]/;function E(b,L,P){if(!b)return b;const p=P.get(b);if(p)return p;let y;return m.test(b)?y=b.normalize(L):y=b,P.set(b,y),y}e.$rl=function(){const b=/[\u0300-\u036f]/g;return function(L){return A(L).replace(b,"")}}()}),define(De[120],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=e.rot=e.$Pl=void 0;function C(m,E,b){return Math.min(Math.max(m,E),b)}e.$Pl=C;function O(m,E){return(E+m%E)%E}e.rot=O;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$Rl=f;class R{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Sl=R;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const b=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Tl=A}),function(){function $e(f){const R=[];typeof f=="number"&&R.push("code/timeOrigin",f);function A(E){R.push(E,Date.now())}function m(){const E=[];for(let b=0;b<R.length;b+=2)E.push({name:R[b],startTime:R[b+1]});return E}return{mark:A,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(f+A.startTime)});return R}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function C(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=C(O))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var O in C)(typeof exports=="object"?exports:$e)[O]=C[O]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function C(O){if(e[O])return e[O].exports;var f=e[O]={i:O,l:!1,exports:{}};return $e[O].call(f.exports,f,f.exports,C),f.l=!0,f.exports}return C.m=$e,C.c=e,C.d=function(O,f,R){C.o(O,f)||Object.defineProperty(O,f,{enumerable:!0,get:R})},C.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},C.t=function(O,f){if(1&f&&(O=C(O)),8&f||4&f&&typeof O=="object"&&O&&O.__esModule)return O;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:O}),2&f&&typeof O!="string")for(var A in O)C.d(R,A,function(m){return O[m]}.bind(null,A));return R},C.n=function(O){var f=O&&O.__esModule?function(){return O.default}:function(){return O};return C.d(f,"a",f),f},C.o=function(O,f){return Object.prototype.hasOwnProperty.call(O,f)},C.p="",C(C.s=0)}([function($e,e,C){(function(O){var f;e=$e.exports=ye,f=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],E=e.src=[],b=0,L=b++;E[L]="0|[1-9]\\d*";var P=b++;E[P]="[0-9]+";var p=b++;E[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=b++;E[y]="("+E[L]+")\\.("+E[L]+")\\.("+E[L]+")";var k=b++;E[k]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var v=b++;E[v]="(?:"+E[L]+"|"+E[p]+")";var h=b++;E[h]="(?:"+E[P]+"|"+E[p]+")";var o=b++;E[o]="(?:-("+E[v]+"(?:\\."+E[v]+")*))";var l=b++;E[l]="(?:-?("+E[h]+"(?:\\."+E[h]+")*))";var c=b++;E[c]="[0-9A-Za-z-]+";var d=b++;E[d]="(?:\\+("+E[c]+"(?:\\."+E[c]+")*))";var a=b++,t="v?"+E[y]+E[o]+"?"+E[d]+"?";E[a]="^"+t+"$";var i="[v=\\s]*"+E[k]+E[l]+"?"+E[d]+"?",s=b++;E[s]="^"+i+"$";var n=b++;E[n]="((?:<|>)?=?)";var r=b++;E[r]=E[P]+"|x|X|\\*";var u=b++;E[u]=E[L]+"|x|X|\\*";var I=b++;E[I]="[v=\\s]*("+E[u]+")(?:\\.("+E[u]+")(?:\\.("+E[u]+")(?:"+E[o]+")?"+E[d]+"?)?)?";var S=b++;E[S]="[v=\\s]*("+E[r]+")(?:\\.("+E[r]+")(?:\\.("+E[r]+")(?:"+E[l]+")?"+E[d]+"?)?)?";var $=b++;E[$]="^"+E[n]+"\\s*"+E[I]+"$";var g=b++;E[g]="^"+E[n]+"\\s*"+E[S]+"$";var w=b++;E[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=b++;E[D]="(?:~>?)";var T=b++;E[T]="(\\s*)"+E[D]+"\\s+",m[T]=new RegExp(E[T],"g");var M=b++;E[M]="^"+E[D]+E[I]+"$";var F=b++;E[F]="^"+E[D]+E[S]+"$";var z=b++;E[z]="(?:\\^)";var j=b++;E[j]="(\\s*)"+E[z]+"\\s+",m[j]=new RegExp(E[j],"g");var N=b++;E[N]="^"+E[z]+E[I]+"$";var q=b++;E[q]="^"+E[z]+E[S]+"$";var K=b++;E[K]="^"+E[n]+"\\s*("+i+")$|^$";var me=b++;E[me]="^"+E[n]+"\\s*("+t+")$|^$";var te=b++;E[te]="(\\s*)"+E[n]+"\\s*("+i+"|"+E[I]+")",m[te]=new RegExp(E[te],"g");var G=b++;E[G]="^\\s*("+E[I]+")\\s+-\\s+("+E[I]+")\\s*$";var J=b++;E[J]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var le=b++;E[le]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)f(ie,E[ie]),m[ie]||(m[ie]=new RegExp(E[ie]));function ce(Z,ge){if(Z instanceof ye)return Z;if(typeof Z!="string"||Z.length>R||!(ge?m[s]:m[a]).test(Z))return null;try{return new ye(Z,ge)}catch{return null}}function ye(Z,ge){if(Z instanceof ye){if(Z.loose===ge)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ye))return new ye(Z,ge);f("SemVer",Z,ge),this.loose=ge;var Ee=Z.trim().match(ge?m[s]:m[a]);if(!Ee)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var We=+ze;if(We>=0&&We<A)return We}return ze}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Z,ge){var Ee=ce(Z,ge);return Ee?Ee.version:null},e.clean=function(Z,ge){var Ee=ce(Z.trim().replace(/^[=v]+/,""),ge);return Ee?Ee.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(Z){return f("SemVer.compare",this.version,this.loose,Z),Z instanceof ye||(Z=new ye(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},ye.prototype.compareMain=function(Z){return Z instanceof ye||(Z=new ye(Z,this.loose)),B(this.major,Z.major)||B(this.minor,Z.minor)||B(this.patch,Z.patch)},ye.prototype.comparePre=function(Z){if(Z instanceof ye||(Z=new ye(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ge=0;do{var Ee=this.prerelease[ge],ze=Z.prerelease[ge];if(f("prerelease compare",ge,Ee,ze),Ee===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==ze)return B(Ee,ze)}while(++ge)},ye.prototype.inc=function(Z,ge){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ge,Ee,ze){typeof Ee=="string"&&(ze=Ee,Ee=void 0);try{return new ye(Z,Ee).inc(ge,ze).version}catch{return null}},e.diff=function(Z,ge){if(_(Z,ge))return null;var Ee=ce(Z),ze=ce(ge);if(Ee.prerelease.length||ze.prerelease.length){for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==ze[We])return"pre"+We;return"prerelease"}for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==ze[We])return We},e.compareIdentifiers=B;var H=/^[0-9]+$/;function B(Z,ge){var Ee=H.test(Z),ze=H.test(ge);return Ee&&ze&&(Z=+Z,ge=+ge),Ee&&!ze?-1:ze&&!Ee?1:Z<ge?-1:Z>ge?1:0}function Y(Z,ge,Ee){return new ye(Z,Ee).compare(new ye(ge,Ee))}function re(Z,ge,Ee){return Y(Z,ge,Ee)>0}function X(Z,ge,Ee){return Y(Z,ge,Ee)<0}function _(Z,ge,Ee){return Y(Z,ge,Ee)===0}function x(Z,ge,Ee){return Y(Z,ge,Ee)!==0}function pe(Z,ge,Ee){return Y(Z,ge,Ee)>=0}function ae(Z,ge,Ee){return Y(Z,ge,Ee)<=0}function fe(Z,ge,Ee,ze){var We;switch(ge){case"===":typeof Z=="object"&&(Z=Z.version),typeof Ee=="object"&&(Ee=Ee.version),We=Z===Ee;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof Ee=="object"&&(Ee=Ee.version),We=Z!==Ee;break;case"":case"=":case"==":We=_(Z,Ee,ze);break;case"!=":We=x(Z,Ee,ze);break;case">":We=re(Z,Ee,ze);break;case">=":We=pe(Z,Ee,ze);break;case"<":We=X(Z,Ee,ze);break;case"<=":We=ae(Z,Ee,ze);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function ee(Z,ge){if(Z instanceof ee){if(Z.loose===ge)return Z;Z=Z.value}if(!(this instanceof ee))return new ee(Z,ge);f("comparator",Z,ge),this.loose=ge,this.parse(Z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(Z,ge){return B(ge,Z)},e.major=function(Z,ge){return new ye(Z,ge).major},e.minor=function(Z,ge){return new ye(Z,ge).minor},e.patch=function(Z,ge){return new ye(Z,ge).patch},e.compare=Y,e.compareLoose=function(Z,ge){return Y(Z,ge,!0)},e.rcompare=function(Z,ge,Ee){return Y(ge,Z,Ee)},e.sort=function(Z,ge){return Z.sort(function(Ee,ze){return e.compare(Ee,ze,ge)})},e.rsort=function(Z,ge){return Z.sort(function(Ee,ze){return e.rcompare(Ee,ze,ge)})},e.gt=re,e.lt=X,e.eq=_,e.neq=x,e.gte=pe,e.lte=ae,e.cmp=fe,e.Comparator=ee;var de={};function be(Z,ge){if(Z instanceof be)return Z.loose===ge?Z:new be(Z.raw,ge);if(Z instanceof ee)return new be(Z.value,ge);if(!(this instanceof be))return new be(Z,ge);if(this.loose=ge,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Pe(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function U(Z,ge,Ee,ze,We,_e,Ye,it,tt,Ae,Te,qe,Le){return((ge=Pe(Ee)?"":Pe(ze)?">="+Ee+".0.0":Pe(We)?">="+Ee+"."+ze+".0":">="+ge)+" "+(it=Pe(tt)?"":Pe(Ae)?"<"+(+tt+1)+".0.0":Pe(Te)?"<"+tt+"."+(+Ae+1)+".0":qe?"<="+tt+"."+Ae+"."+Te+"-"+qe:"<="+it)).trim()}function Q(Z,ge){for(var Ee=0;Ee<Z.length;Ee++)if(!Z[Ee].test(ge))return!1;if(ge.prerelease.length){for(Ee=0;Ee<Z.length;Ee++)if(f(Z[Ee].semver),Z[Ee].semver!==de&&Z[Ee].semver.prerelease.length>0){var ze=Z[Ee].semver;if(ze.major===ge.major&&ze.minor===ge.minor&&ze.patch===ge.patch)return!0}return!1}return!0}function se(Z,ge,Ee){try{ge=new be(ge,Ee)}catch{return!1}return ge.test(Z)}function oe(Z,ge,Ee,ze){var We,_e,Ye,it,tt;switch(Z=new ye(Z,ze),ge=new be(ge,ze),Ee){case">":We=re,_e=ae,Ye=X,it=">",tt=">=";break;case"<":We=X,_e=pe,Ye=re,it="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(Z,ge,ze))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Te=ge.set[Ae],qe=null,Le=null;if(Te.forEach(function(Xe){Xe.semver===de&&(Xe=new ee(">=0.0.0")),qe=qe||Xe,Le=Le||Xe,We(Xe.semver,qe.semver,ze)?qe=Xe:Ye(Xe.semver,Le.semver,ze)&&(Le=Xe)}),qe.operator===it||qe.operator===tt||(!Le.operator||Le.operator===it)&&_e(Z,Le.semver)||Le.operator===tt&&Ye(Z,Le.semver))return!1}return!0}ee.prototype.parse=function(Z){var ge=this.loose?m[K]:m[me],Ee=Z.match(ge);if(!Ee)throw new TypeError("Invalid comparator: "+Z);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new ye(Ee[2],this.loose):this.semver=de},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Z){return f("Comparator.test",Z,this.loose),this.semver===de||(typeof Z=="string"&&(Z=new ye(Z,this.loose)),fe(Z,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Z,ge){if(!(Z instanceof ee))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new be(Z.value,ge),se(this.value,Ee,ge);if(Z.operator==="")return Ee=new be(this.value,ge),se(Z.semver,Ee,ge);var ze=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),_e=this.semver.version===Z.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),it=fe(this.semver,"<",Z.semver,ge)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),tt=fe(this.semver,">",Z.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return ze||We||_e&&Ye||it||tt},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Z){var ge=this.loose;Z=Z.trim(),f("range",Z,ge);var Ee=ge?m[J]:m[G];Z=Z.replace(Ee,U),f("hyphen replace",Z),Z=Z.replace(m[te],"$1$2$3"),f("comparator trim",Z,m[te]),Z=(Z=(Z=Z.replace(m[T],"$1~")).replace(m[j],"$1^")).split(/\s+/).join(" ");var ze=ge?m[K]:m[me],We=Z.split(" ").map(function(_e){return function(Ye,it){return f("comp",Ye),Ye=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Te){return function(qe,Le){f("caret",qe,Le);var Xe=Le?m[q]:m[N];return qe.replace(Xe,function(he,ue,Ie,Ke,Ue){var Ze;return f("caret",qe,he,ue,Ie,Ke,Ue),Pe(ue)?Ze="":Pe(Ie)?Ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ke)?Ze=ue==="0"?">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+".0 <"+(+ue+1)+".0.0":Ue?(f("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+Ie+"."+(+Ke+1):">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ke+Ue+" <"+(+ue+1)+".0.0"):(f("no pr"),Ze=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+Ie+"."+(+Ke+1):">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ke+" <"+(+ue+1)+".0.0"),f("caret return",Ze),Ze})}(Te,Ae)}).join(" ")}(Ye,it),f("caret",Ye),Ye=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Te){return function(qe,Le){var Xe=Le?m[F]:m[M];return qe.replace(Xe,function(he,ue,Ie,Ke,Ue){var Ze;return f("tilde",qe,he,ue,Ie,Ke,Ue),Pe(ue)?Ze="":Pe(Ie)?Ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ke)?Ze=">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":Ue?(f("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+(+Ie+1)+".0"):Ze=">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+(+Ie+1)+".0",f("tilde return",Ze),Ze})}(Te,Ae)}).join(" ")}(Ye,it),f("tildes",Ye),Ye=function(tt,Ae){return f("replaceXRanges",tt,Ae),tt.split(/\s+/).map(function(Te){return function(qe,Le){qe=qe.trim();var Xe=Le?m[g]:m[$];return qe.replace(Xe,function(he,ue,Ie,Ke,Ue,Ze){f("xRange",qe,he,ue,Ie,Ke,Ue,Ze);var nt=Pe(Ie),ct=nt||Pe(Ke),bt=ct||Pe(Ue);return ue==="="&&bt&&(ue=""),nt?he=ue===">"||ue==="<"?"<0.0.0":"*":ue&&bt?(ct&&(Ke=0),bt&&(Ue=0),ue===">"?(ue=">=",ct?(Ie=+Ie+1,Ke=0,Ue=0):bt&&(Ke=+Ke+1,Ue=0)):ue==="<="&&(ue="<",ct?Ie=+Ie+1:Ke=+Ke+1),he=ue+Ie+"."+Ke+"."+Ue):ct?he=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":bt&&(he=">="+Ie+"."+Ke+".0 <"+Ie+"."+(+Ke+1)+".0"),f("xRange return",he),he})}(Te,Ae)}).join(" ")}(Ye,it),f("xrange",Ye),Ye=function(tt,Ae){return f("replaceStars",tt,Ae),tt.trim().replace(m[le],"")}(Ye,it),f("stars",Ye),Ye}(_e,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(ze)})),We=We.map(function(_e){return new ee(_e,ge)})},be.prototype.intersects=function(Z,ge){if(!(Z instanceof be))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(ze){return Z.set.some(function(We){return We.every(function(_e){return ze.intersects(_e,ge)})})})})},e.toComparators=function(Z,ge){return new be(Z,ge).set.map(function(Ee){return Ee.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new ye(Z,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Q(this.set[ge],Z))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(Z,ge,Ee){var ze=null,We=null;try{var _e=new be(ge,Ee)}catch{return null}return Z.forEach(function(Ye){_e.test(Ye)&&(ze&&We.compare(Ye)!==-1||(We=new ye(ze=Ye,Ee)))}),ze},e.minSatisfying=function(Z,ge,Ee){var ze=null,We=null;try{var _e=new be(ge,Ee)}catch{return null}return Z.forEach(function(Ye){_e.test(Ye)&&(ze&&We.compare(Ye)!==1||(We=new ye(ze=Ye,Ee)))}),ze},e.validRange=function(Z,ge){try{return new be(Z,ge).range||"*"}catch{return null}},e.ltr=function(Z,ge,Ee){return oe(Z,ge,"<",Ee)},e.gtr=function(Z,ge,Ee){return oe(Z,ge,">",Ee)},e.outside=oe,e.prerelease=function(Z,ge){var Ee=ce(Z,ge);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(Z,ge,Ee){return Z=new be(Z,Ee),ge=new be(ge,Ee),Z.intersects(ge)},e.coerce=function(Z){if(Z instanceof ye)return Z;if(typeof Z!="string")return null;var ge=Z.match(m[w]);return ge==null?null:ce((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,C(1))},function($e,e){var C,O,f=$e.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function m(h){if(C===setTimeout)return setTimeout(h,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(h,0);try{return C(h,0)}catch{try{return C.call(null,h,0)}catch{return C.call(this,h,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{O=typeof clearTimeout=="function"?clearTimeout:A}catch{O=A}})();var E,b=[],L=!1,P=-1;function p(){L&&E&&(L=!1,E.length?b=E.concat(b):P=-1,b.length&&y())}function y(){if(!L){var h=m(p);L=!0;for(var o=b.length;o;){for(E=b,b=[];++P<o;)E&&E[P].run();P=-1,o=b.length}E=null,L=!1,function(l){if(O===clearTimeout)return clearTimeout(l);if((O===A||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(l);try{O(l)}catch{try{return O.call(null,l)}catch{return O.call(this,l)}}}(h)}}function k(h,o){this.fun=h,this.array=o}function v(){}f.nextTick=function(h){var o=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)o[l-1]=arguments[l];b.push(new k(h,o)),b.length!==1||L||m(y)},k.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=v,f.addListener=v,f.once=v,f.off=v,f.removeListener=v,f.removeAllListeners=v,f.emit=v,f.prependListener=v,f.prependOnceListener=v,f.listeners=function(h){return[]},f.binding=function(h){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(h){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(De[35],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(R){return new O(R)}constructor(R){this.c=C&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Kd=O}),define(De[4],Ce([1,0,9,75,3,76,35]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.Event=void 0;const m=!1,E=!1;var b;(function($){$.None=()=>f.$Sc.None;function g(fe){if(E){const{onDidAddListener:ee}=fe,de=k.create();let be=0;fe.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),ee?.()}}}function w(fe,ee){return me(fe,()=>{},0,void 0,!0,void 0,ee)}$.defer=w;function D(fe){return(ee,de=null,be)=>{let Pe=!1,U;return U=fe(Q=>{if(!Pe)return U?U.dispose():Pe=!0,ee.call(de,Q)},null,be),Pe&&U.dispose(),U}}$.once=D;function T(fe,ee,de){return q((be,Pe=null,U)=>fe(Q=>be.call(Pe,ee(Q)),null,U),de)}$.map=T;function M(fe,ee,de){return q((be,Pe=null,U)=>fe(Q=>{ee(Q),be.call(Pe,Q)},null,U),de)}$.forEach=M;function F(fe,ee,de){return q((be,Pe=null,U)=>fe(Q=>ee(Q)&&be.call(Pe,Q),null,U),de)}$.filter=F;function z(fe){return fe}$.signal=z;function j(...fe){return(ee,de=null,be)=>{const Pe=(0,f.$Pc)(...fe.map(U=>U(Q=>ee.call(de,Q))));return K(Pe,be)}}$.any=j;function N(fe,ee,de,be){let Pe=de;return T(fe,U=>(Pe=ee(Pe,U),Pe),be)}$.reduce=N;function q(fe,ee){let de;const be={onWillAddFirstListener(){de=fe(Pe.fire,Pe)},onDidRemoveLastListener(){de?.dispose()}};ee||g(be);const Pe=new c(be);return ee?.add(Pe),Pe.event}function K(fe,ee){return ee instanceof Array?ee.push(fe):ee&&ee.add(fe),fe}function me(fe,ee,de=100,be=!1,Pe=!1,U,Q){let se,oe,Z,ge=0,Ee;const ze={leakWarningThreshold:U,onWillAddFirstListener(){se=fe(_e=>{ge++,oe=ee(oe,_e),be&&!Z&&(We.fire(oe),oe=void 0),Ee=()=>{const Ye=oe;oe=void 0,Z=void 0,(!be||ge>1)&&We.fire(Ye),ge=0},typeof de=="number"?(clearTimeout(Z),Z=setTimeout(Ee,de)):Z===void 0&&(Z=0,queueMicrotask(Ee))})},onWillRemoveListener(){Pe&&ge>0&&Ee?.()},onDidRemoveLastListener(){Ee=void 0,se.dispose()}};Q||g(ze);const We=new c(ze);return Q?.add(We),We.event}$.debounce=me;function te(fe,ee=0,de){return $.debounce(fe,(be,Pe)=>be?(be.push(Pe),be):[Pe],ee,void 0,!0,void 0,de)}$.accumulate=te;function G(fe,ee=(be,Pe)=>be===Pe,de){let be=!0,Pe;return F(fe,U=>{const Q=be||!ee(U,Pe);return be=!1,Pe=U,Q},de)}$.latch=G;function J(fe,ee,de){return[$.filter(fe,ee,de),$.filter(fe,be=>!ee(be),de)]}$.split=J;function le(fe,ee=!1,de=[],be){let Pe=de.slice(),U=fe(oe=>{Pe?Pe.push(oe):se.fire(oe)});be&&be.add(U);const Q=()=>{Pe?.forEach(oe=>se.fire(oe)),Pe=null},se=new c({onWillAddFirstListener(){U||(U=fe(oe=>se.fire(oe)),be&&be.add(U))},onDidAddFirstListener(){Pe&&(ee?setTimeout(Q):Q())},onDidRemoveLastListener(){U&&U.dispose(),U=null}});return be&&be.add(se),se.event}$.buffer=le;function ie(fe,ee){return(be,Pe,U)=>{const Q=ee(new ye);return fe(function(se){const oe=Q.evaluate(se);oe!==ce&&be.call(Pe,oe)},void 0,U)}}$.chain=ie;const ce=Symbol("HaltChainable");class ye{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(de=>(ee(de),de)),this}filter(ee){return this.f.push(de=>ee(de)?de:ce),this}reduce(ee,de){let be=de;return this.f.push(Pe=>(be=ee(be,Pe),be)),this}latch(ee=(de,be)=>de===be){let de=!0,be;return this.f.push(Pe=>{const U=de||!ee(Pe,be);return de=!1,be=Pe,U?Pe:ce}),this}evaluate(ee){for(const de of this.f)if(ee=de(ee),ee===ce)break;return ee}}function H(fe,ee,de=be=>be){const be=(...se)=>Q.fire(de(...se)),Pe=()=>fe.on(ee,be),U=()=>fe.removeListener(ee,be),Q=new c({onWillAddFirstListener:Pe,onDidRemoveLastListener:U});return Q.event}$.fromNodeEventEmitter=H;function B(fe,ee,de=be=>be){const be=(...se)=>Q.fire(de(...se)),Pe=()=>fe.addEventListener(ee,be),U=()=>fe.removeEventListener(ee,be),Q=new c({onWillAddFirstListener:Pe,onDidRemoveLastListener:U});return Q.event}$.fromDOMEventEmitter=B;function Y(fe){return new Promise(ee=>D(fe)(ee))}$.toPromise=Y;function re(fe){const ee=new c;return fe.then(de=>{ee.fire(de)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}$.fromPromise=re;function X(fe,ee,de){return ee(de),fe(be=>ee(be))}$.runAndSubscribe=X;function _(fe,ee){let de=null;function be(U){de?.dispose(),de=new f.$Rc,ee(U,de)}be(void 0);const Pe=fe(U=>be(U));return(0,f.$Qc)(()=>{Pe.dispose(),de?.dispose()})}$.runAndSubscribeWithStore=_;class x{constructor(ee,de){this._observable=ee,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};de||g(be),this.emitter=new c(be),de&&de.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,de){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(fe,ee){return new x(fe,ee).emitter.event}$.fromObservable=pe;function ae(fe){return ee=>{let de=0,be=!1;const Pe={beginUpdate(){de++},endUpdate(){de--,de===0&&(fe.reportChanges(),be&&(be=!1,ee()))},handlePossibleChange(){},handleChange(){be=!0}};return fe.addObserver(Pe),fe.reportChanges(),{dispose(){fe.removeObserver(Pe)}}}}$.fromObservableLight=ae})(b||(e.Event=b={}));class L{static{this.all=new Set}static{this.f=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${L.f++}`,L.all.add(this)}start(g){this.g=new A.$Kd,this.listenerCount=g}stop(){if(this.g){const g=this.g.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this.g=void 0}}}e.$Md=L;let P=-1;function p($){const g=P;return P=$,{dispose(){P=g}}}e.$Nd=p;class y{constructor(g,w=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=w,this.g=0}dispose(){this.f?.clear()}check(g,w){const D=this.threshold;if(D<=0||w<D)return;this.f||(this.f=new Map);const T=this.f.get(g.value)||0;if(this.f.set(g.value,T+1),this.g-=1,this.g<=0){this.g=D*.5;let M,F=0;for(const[z,j]of this.f)(!M||F<j)&&(M=z,F=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${F}):`),console.warn(M)}return()=>{const M=this.f.get(g.value)||0;this.f.set(g.value,M-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class h{constructor(g){this.value=g,this.id=v++}}const o=2,l=($,g)=>{if($ instanceof h)g($);else for(let w=0;w<$.length;w++){const D=$[w];D&&g(D)}};class c{constructor(g){this.w=0,this.f=g,this.g=P>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new L(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const g=this.t;queueMicrotask(()=>{l(g,w=>w.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(g,w,D)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Sc.None;if(this.m)return f.$Sc.None;w&&(g=g.bind(w));const T=new h(g);let M,F;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=k.create(),M=this.g.check(T.stack,this.w+1)),m&&(T.stack=F??k.create()),this.t?this.t instanceof h?(this.u??=new a,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const z=(0,f.$Qc)(()=>{M?.(),this.x(T)});return D instanceof f.$Rc?D.add(z):Array.isArray(D)&&D.push(z),z},this.q}x(g){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const w=this.t,D=w.indexOf(g);if(D===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,w[D]=void 0;const T=this.u.current===this;if(this.w*o<=w.length){let M=0;for(let F=0;F<w.length;F++)w[F]?w[M++]=w[F]:T&&(this.u.end--,M<this.u.i&&this.u.i--);w.length=M}}y(g,w){if(!g)return;const D=this.f?.onListenerError||C.$1;if(!D){g.value(w);return}try{g.value(w)}catch(T){D(T)}}z(g){const w=g.current.t;for(;g.i<g.end;)this.y(w[g.i++],g.value);g.reset()}fire(g){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,g);else{const w=this.u;w.enqueue(this,g,this.t.length),this.z(w)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Od=c;const d=()=>new a;e.$Pd=d;class a{constructor(){this.i=-1,this.end=0}enqueue(g,w,D){this.i=0,this.end=D,this.current=g,this.value=w}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(g,w,D){if(this.t)for(this.h||(this.h=new R.$2c),l(this.t,T=>this.h.push([T.value,g]));this.h.size>0&&!w.isCancellationRequested;){const[T,M]=this.h.shift(),F=[],z={...M,token:w,waitUntil:j=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");D&&(j=D(j,T)),F.push(j)}};try{T(z)}catch(j){(0,C.$1)(j);continue}Object.freeze(F),await Promise.allSettled(F).then(j=>{for(const N of j)N.status==="rejected"&&(0,C.$1)(N.reason)})}}}e.$Qd=t;class i extends c{get isPaused(){return this.h!==0}constructor(g){super(g),this.h=0,this.s=new R.$2c,this.A=g?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const g=Array.from(this.s);this.s.clear(),super.fire(this.A(g))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(g){this.w&&(this.h!==0?this.s.push(g):super.fire(g))}}e.$Rd=i;class s extends i{constructor(g){super(g),this.k=g.delay??100}fire(g){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(g)}}e.$Sd=s;class n extends c{constructor(g){super(g),this.h=[],this.k=g?.merge}fire(g){this.hasListeners()&&(this.h.push(g),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(w=>super.fire(w)),this.h=[]}))}}e.$Td=n;class r{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(g){const w={event:g,listener:null};this.h.push(w),this.g&&this.m(w);const D=()=>{this.g&&this.o(w);const T=this.h.indexOf(w);this.h.splice(T,1)};return(0,f.$Qc)((0,O.$db)(D))}j(){this.g=!0,this.h.forEach(g=>this.m(g))}k(){this.g=!1,this.h.forEach(g=>this.o(g))}m(g){g.listener=g.event(w=>this.f.fire(w))}o(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.f.dispose()}}e.$Ud=r;class u{constructor(g,w,D,T){this.f=new f.$Rc;const M=this.f.add(new r),F=this.f.add(new f.$1c);function z(j){F.set(j,M.add(T(j)))}for(const j of g)z(j);this.f.add(w(j=>{z(j)})),this.f.add(D(j=>{F.deleteAndDispose(j)})),this.event=M.event}dispose(){this.f.dispose()}}e.$Vd=u;class I{constructor(){this.f=[]}wrapEvent(g){return(w,D,T)=>g(M=>{const F=this.f[this.f.length-1];F?F.push(()=>w.call(D,M)):w.call(D,M)},void 0,T)}bufferEvents(g){const w=[];this.f.push(w);const D=g();return this.f.pop(),w.forEach(T=>T()),D}}e.$Wd=I;class S{constructor(){this.f=!1,this.g=b.None,this.h=f.$Sc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(g){this.g=g,this.f&&(this.h.dispose(),this.h=g(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Xd=S}),define(De[21],Ce([1,0,4]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.CancellationToken=void 0;const O=Object.freeze(function(m,E){const b=setTimeout(m.bind(E),0);return{dispose(){clearTimeout(b)}}});var f;(function(m){function E(b){return b===m.None||b===m.Cancelled||b instanceof R?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}m.isCancellationToken=E,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(f||(e.CancellationToken=f={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new C.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=f.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=f.None}}e.$Yd=A}),define(De[159],Ce([1,0,21]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=void 0;class O{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new C.$Yd,E=this.b(m.token);return this.a={promise:E,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$xe=O;class f{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const E=JSON.stringify(m);return this.b!==E&&(this.b=E,this.a=this.c(m)),this.a}}e.$ye=f;class R{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const E=this.b(m);return this.a.set(m,E),E}}e.$ze=R}),define(De[96],Ce([1,0,9,3]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function f(d){const a=d;return a?typeof a.read=="function":!1}e.$Zd=f;function R(d){const a=d;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$1d=R;function A(d){const a=d;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$2d=A;function m(d,a){return new E(d,a)}e.$3d=m;class E{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,C.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let i;switch(a){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const s=i.indexOf(t);s>=0&&i.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(d,a){const t=[];let i;for(;(i=d.read())!==null;)t.push(i);return a(t)}e.$4d=b;function L(d,a,t){const i=[];let s;for(;(s=d.read())!==null&&i.length<t;)i.push(s);return s===null&&i.length>0?a(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return d.read()}}}e.$5d=L;function P(d,a){return new Promise((t,i)=>{const s=[];p(d,{onData:n=>{a&&s.push(n)},onError:n=>{a?i(n):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}e.$6d=P;function p(d,a,t){d.on("error",i=>{t?.isCancellationRequested||a.onError(i)}),d.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),d.on("data",i=>{t?.isCancellationRequested||a.onData(i)})}e.$7d=p;function y(d,a){return new Promise((t,i)=>{const s=new O.$Rc,n=[],r=S=>{if(n.push(S),n.length>a)return s.dispose(),d.pause(),t({stream:d,buffer:n,ended:!1})},u=S=>(s.dispose(),i(S)),I=()=>(s.dispose(),t({stream:d,buffer:n,ended:!0}));s.add((0,O.$Qc)(()=>d.removeListener("error",u))),d.on("error",u),s.add((0,O.$Qc)(()=>d.removeListener("end",I))),d.on("end",I),s.add((0,O.$Qc)(()=>d.removeListener("data",r))),d.on("data",r)})}e.$8d=y;function k(d,a){const t=m(a);return t.end(d),t}e.$9d=k;function v(){const d=m(()=>{throw new Error("not supported")});return d.end(),d}e.$0d=v;function h(d){let a=!1;return{read:()=>a?null:(a=!0,d)}}e.$$d=h;function o(d,a,t){const i=m(t);return p(d,{onData:s=>i.write(a.data(s)),onError:s=>i.error(a.error?a.error(s):s),onEnd:()=>i.end()}),i}e.$_d=o;function l(d,a,t){let i=!1;return{read:()=>{const s=a.read();return i?s:(i=!0,s!==null?t([d,s]):d)}}}e.$ae=l;function c(d,a,t){let i=!1;const s=m(t);return p(a,{onData:n=>i?s.write(n):(i=!0,s.write(t([d,n]))),onError:n=>s.error(n),onEnd:()=>{i||(i=!0,s.write(d)),s.end()}}),s}e.$be=c}),define(De[22],Ce([1,0,47,96]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const f=typeof Buffer<"u",R=new C.$V(()=>new Uint8Array(256));let A,m;class E{static alloc(w){return f?new E(Buffer.allocUnsafe(w)):new E(new Uint8Array(w))}static wrap(w){return f&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new E(w)}static fromString(w,D){return!(D?.dontUseNodeBuffer||!1)&&f?new E(Buffer.from(w)):(A||(A=new TextEncoder),new E(A.encode(w)))}static fromByteArray(w){const D=E.alloc(w.length);for(let T=0,M=w.length;T<M;T++)D.buffer[T]=w[T];return D}static concat(w,D){if(typeof D>"u"){D=0;for(let F=0,z=w.length;F<z;F++)D+=w[F].byteLength}const T=E.alloc(D);let M=0;for(let F=0,z=w.length;F<z;F++){const j=w[F];T.set(j,M),M+=j.byteLength}return T}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=E.alloc(this.byteLength);return w.set(this),w}toString(){return f?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(w,D){return new E(this.buffer.subarray(w,D))}set(w,D){if(w instanceof E)this.buffer.set(w.buffer,D);else if(w instanceof Uint8Array)this.buffer.set(w,D);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),D);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return p(this.buffer,w)}writeUInt32BE(w,D){y(this.buffer,w,D)}readUInt32LE(w){return k(this.buffer,w)}writeUInt32LE(w,D){v(this.buffer,w,D)}readUInt8(w){return h(this.buffer,w)}writeUInt8(w,D){o(this.buffer,w,D)}indexOf(w,D=0){return b(this.buffer,w instanceof E?w.buffer:w,D)}}e.$ce=E;function b(g,w,D=0){const T=w.byteLength,M=g.byteLength;if(T===0)return 0;if(T===1)return g.indexOf(w[0]);if(T>M-D)return-1;const F=R.value;F.fill(w.length);for(let q=0;q<w.length;q++)F[w[q]]=w.length-q-1;let z=D+w.length-1,j=z,N=-1;for(;z<M;)if(g[z]===w[j]){if(j===0){N=z;break}z--,j--}else z+=Math.max(w.length-j,F[g[z]]),j=w.length-1;return N}e.$de=b;function L(g,w){return g[w+0]<<0>>>0|g[w+1]<<8>>>0}e.$ee=L;function P(g,w,D){g[D+0]=w&255,w=w>>>8,g[D+1]=w&255}e.$fe=P;function p(g,w){return g[w]*2**24+g[w+1]*2**16+g[w+2]*2**8+g[w+3]}e.$ge=p;function y(g,w,D){g[D+3]=w,w=w>>>8,g[D+2]=w,w=w>>>8,g[D+1]=w,w=w>>>8,g[D]=w}e.$he=y;function k(g,w){return g[w+0]<<0>>>0|g[w+1]<<8>>>0|g[w+2]<<16>>>0|g[w+3]<<24>>>0}e.$ie=k;function v(g,w,D){g[D+0]=w&255,w=w>>>8,g[D+1]=w&255,w=w>>>8,g[D+2]=w&255,w=w>>>8,g[D+3]=w&255}e.$je=v;function h(g,w){return g[w]}e.$ke=h;function o(g,w,D){g[D]=w}e.$le=o;function l(g){return O.$4d(g,w=>E.concat(w))}e.$me=l;function c(g){return O.$$d(g)}e.$ne=c;function d(g){return O.$6d(g,w=>E.concat(w))}e.$oe=d;async function a(g){return g.ended?E.concat(g.buffer):E.concat([...g.buffer,await d(g.stream)])}e.$pe=a;function t(g){return O.$9d(g,w=>E.concat(w))}e.$qe=t;function i(g){return O.$_d(g,{data:w=>typeof w=="string"?E.fromString(w):E.wrap(w)},w=>E.concat(w))}e.$re=i;function s(g){return O.$3d(w=>E.concat(w),g)}e.$se=s;function n(g,w){return O.$ae(g,w,D=>E.concat(D))}e.$te=n;function r(g,w){return O.$be(g,w,D=>E.concat(D))}e.$ue=r;function u(g){let w=0,D=0,T=0;const M=new Uint8Array(Math.floor(g.length/4*3)),F=j=>{switch(D){case 3:M[T++]=w|j,D=0;break;case 2:M[T++]=w|j>>>2,w=j<<6,D=3;break;case 1:M[T++]=w|j>>>4,w=j<<4,D=2;break;default:w=j<<2,D=1}};for(let j=0;j<g.length;j++){const N=g.charCodeAt(j);if(N>=65&&N<=90)F(N-65);else if(N>=97&&N<=122)F(N-97+26);else if(N>=48&&N<=57)F(N-48+52);else if(N===43||N===45)F(62);else if(N===47||N===95)F(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${g[j]}`)}}const z=T;for(;D>0;)F(0);return E.wrap(M).slice(0,z)}e.$ve=u;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:g},w=!0,D=!1){const T=D?S:I;let M="";const F=g.byteLength%3;let z=0;for(;z<g.byteLength-F;z+=3){const j=g[z+0],N=g[z+1],q=g[z+2];M+=T[j>>>2],M+=T[(j<<4|N>>>4)&63],M+=T[(N<<2|q>>>6)&63],M+=T[q&63]}if(F===1){const j=g[z+0];M+=T[j>>>2],M+=T[j<<4&63],w&&(M+="==")}else if(F===2){const j=g[z+0],N=g[z+1];M+=T[j>>>2],M+=T[(j<<4|N>>>4)&63],M+=T[N<<2&63],w&&(M+="=")}return M}e.$we=$}),define(De[15],Ce([1,0,159,47]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yf=e.$xf=e.$wf=e.$vf=e.GraphemeBreakType=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function f(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Ce=f;const R=/{(\d+)}/g;function A(Ae,...Te){return Te.length===0?Ae:Ae.replace(R,function(qe,Le){const Xe=parseInt(Le,10);return isNaN(Xe)||Xe<0||Xe>=Te.length?qe:Te[Xe]})}e.$De=A;const m=/{([^}]+)}/g;function E(Ae,Te){return Object.keys(Te).length===0?Ae:Ae.replace(m,(qe,Le)=>Te[Le]??qe)}e.$Ee=E;function b(Ae){return Ae.replace(/[<>&]/g,function(Te){switch(Te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Te}})}e.$Fe=b;function L(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ge=L;function P(Ae,Te){let qe=0;const Le=Te.charCodeAt(0);for(let Xe=Ae.length-1;Xe>=0;Xe--)Ae.charCodeAt(Xe)===Le&&qe++;return qe}e.$He=P;function p(Ae,Te,qe="\u2026"){return Ae.length<=Te?Ae:`${Ae.substr(0,Te)}${qe}`}e.$Ie=p;function y(Ae,Te=" "){const qe=k(Ae,Te);return v(qe,Te)}e.$Je=y;function k(Ae,Te){if(!Ae||!Te)return Ae;const qe=Te.length;if(qe===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Te,Le)===Le;)Le=Le+qe;return Ae.substring(Le)}e.$Ke=k;function v(Ae,Te){if(!Ae||!Te)return Ae;const qe=Te.length,Le=Ae.length;if(qe===0||Le===0)return Ae;let Xe=Le,he=-1;for(;he=Ae.lastIndexOf(Te,Xe-1),!(he===-1||he+qe!==Xe);){if(he===0)return"";Xe=he}return Ae.substring(0,Xe)}e.$Le=v;function h(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Me=h;function o(Ae){return Ae.replace(/\*/g,"")}e.$Ne=o;function l(Ae,Te,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Te||(Ae=L(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return qe.global&&(Le+="g"),qe.matchCase||(Le+="i"),qe.multiline&&(Le+="m"),qe.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Oe=l;function c(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Pe=c;function d(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Qe=d;function a(Ae){for(let Te=0,qe=Ae.length;Te<qe;Te++){const Le=Ae.charCodeAt(Te);if(Le!==32&&Le!==9)return Te}return-1}e.$Re=a;function t(Ae,Te=0,qe=Ae.length){for(let Le=Te;Le<qe;Le++){const Xe=Ae.charCodeAt(Le);if(Xe!==32&&Xe!==9)return Ae.substring(Te,Le)}return Ae.substring(Te,qe)}e.$Se=t;function i(Ae,Te=Ae.length-1){for(let qe=Te;qe>=0;qe--){const Le=Ae.charCodeAt(qe);if(Le!==32&&Le!==9)return qe}return-1}e.$Te=i;function s(Ae,Te,qe){const Le=[];let Xe=0;for(const he of Ae.matchAll(Te)){if(Le.push(Ae.slice(Xe,he.index)),he.index===void 0)throw new Error("match.index should be defined");Xe=he.index+he[0].length,Le.push(qe(he[0],...he.slice(1),he.index,Ae,he.groups))}return Le.push(Ae.slice(Xe)),Promise.all(Le).then(he=>he.join(""))}e.$Ue=s;function n(Ae,Te){return Ae<Te?-1:Ae>Te?1:0}e.$Ve=n;function r(Ae,Te,qe=0,Le=Ae.length,Xe=0,he=Te.length){for(;qe<Le&&Xe<he;qe++,Xe++){const Ke=Ae.charCodeAt(qe),Ue=Te.charCodeAt(Xe);if(Ke<Ue)return-1;if(Ke>Ue)return 1}const ue=Le-qe,Ie=he-Xe;return ue<Ie?-1:ue>Ie?1:0}e.$We=r;function u(Ae,Te){return I(Ae,Te,0,Ae.length,0,Te.length)}e.$Xe=u;function I(Ae,Te,qe=0,Le=Ae.length,Xe=0,he=Te.length){for(;qe<Le&&Xe<he;qe++,Xe++){let Ke=Ae.charCodeAt(qe),Ue=Te.charCodeAt(Xe);if(Ke===Ue)continue;if(Ke>=128||Ue>=128)return r(Ae.toLowerCase(),Te.toLowerCase(),qe,Le,Xe,he);$(Ke)&&(Ke-=32),$(Ue)&&(Ue-=32);const Ze=Ke-Ue;if(Ze!==0)return Ze}const ue=Le-qe,Ie=he-Xe;return ue<Ie?-1:ue>Ie?1:0}e.$Ye=I;function S(Ae){return Ae>=48&&Ae<=57}e.$Ze=S;function $(Ae){return Ae>=97&&Ae<=122}e.$1e=$;function g(Ae){return Ae>=65&&Ae<=90}e.$2e=g;function w(Ae,Te){return Ae.length===Te.length&&I(Ae,Te)===0}e.$3e=w;function D(Ae,Te){const qe=Te.length;return Te.length>Ae.length?!1:I(Ae,Te,0,qe)===0}e.$4e=D;function T(Ae,Te){const qe=Math.min(Ae.length,Te.length);let Le;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Le)!==Te.charCodeAt(Le))return Le;return qe}e.$5e=T;function M(Ae,Te){const qe=Math.min(Ae.length,Te.length);let Le;const Xe=Ae.length-1,he=Te.length-1;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Xe-Le)!==Te.charCodeAt(he-Le))return Le;return qe}e.$6e=M;function F(Ae){return 55296<=Ae&&Ae<=56319}e.$7e=F;function z(Ae){return 56320<=Ae&&Ae<=57343}e.$8e=z;function j(Ae,Te){return(Ae-55296<<10)+(Te-56320)+65536}e.$9e=j;function N(Ae,Te,qe){const Le=Ae.charCodeAt(qe);if(F(Le)&&qe+1<Te){const Xe=Ae.charCodeAt(qe+1);if(z(Xe))return j(Le,Xe)}return Le}e.$0e=N;function q(Ae,Te){const qe=Ae.charCodeAt(Te-1);if(z(qe)&&Te>1){const Le=Ae.charCodeAt(Te-2);if(F(Le))return j(Le,qe)}return qe}class K{get offset(){return this.e}constructor(Te,qe=0){this.c=Te,this.d=Te.length,this.e=qe}setOffset(Te){this.e=Te}prevCodePoint(){const Te=q(this.c,this.e);return this.e-=Te>=65536?2:1,Te}nextCodePoint(){const Te=N(this.c,this.d,this.e);return this.e+=Te>=65536?2:1,Te}eol(){return this.e>=this.d}}e.$$e=K;class me{get offset(){return this.c.offset}constructor(Te,qe=0){this.c=new K(Te,qe)}nextGraphemeLength(){const Te=ge.getInstance(),qe=this.c,Le=qe.offset;let Xe=Te.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const he=qe.offset,ue=Te.getGraphemeBreakType(qe.nextCodePoint());if(oe(Xe,ue)){qe.setOffset(he);break}Xe=ue}return qe.offset-Le}prevGraphemeLength(){const Te=ge.getInstance(),qe=this.c,Le=qe.offset;let Xe=Te.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const he=qe.offset,ue=Te.getGraphemeBreakType(qe.prevCodePoint());if(oe(ue,Xe)){qe.setOffset(he);break}Xe=ue}return Le-qe.offset}eol(){return this.c.eol()}}e.$_e=me;function te(Ae,Te){return new me(Ae,Te).nextGraphemeLength()}e.$af=te;function G(Ae,Te){return new me(Ae,Te).prevGraphemeLength()}e.$bf=G;function J(Ae,Te){Te>0&&z(Ae.charCodeAt(Te))&&Te--;const qe=Te+te(Ae,Te);return[qe-G(Ae,qe),qe]}e.$cf=J;function le(Ae){const Te=new me(Ae);let qe=0;for(;!Te.eol();)qe++,Te.nextGraphemeLength();return qe}e.$df=le;let ie;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ye(Ae){return ie||(ie=ce()),ie.test(Ae)}e.$ef=ye;const H=/^[\t\n\r\x20-\x7E]*$/;function B(Ae){return H.test(Ae)}e.$ff=B,e.$gf=/[\u2028\u2029]/;function Y(Ae){return e.$gf.test(Ae)}e.$hf=Y;function re(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$if=re;function X(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$jf=X;function _(Ae,Te){if(Ae.length<Te)return Ae;const qe=/\b/g;let Le=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Te);)Le=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$kf=_;const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,pe=/\x1b\].*?\x07/g;function ae(Ae){return Ae&&(Ae=Ae.replace(x,"").replace(pe,"")),Ae}e.$lf=ae,e.$mf=String.fromCharCode(65279);function fe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$nf=fe;function ee(Ae){return fe(Ae)?Ae.substr(1):Ae}e.$of=ee;function de(Ae,Te){if(!Ae||!Te||Ae.length<Te.length)return!1;const qe=Te.length,Le=Ae.toLowerCase();let Xe=0,he=-1;for(;Xe<qe;){const ue=Le.indexOf(Te[Xe],he+1);if(ue<0)return!1;he=ue,Xe++}return!0}e.$pf=de;function be(Ae,Te=!1){return Ae?(Te&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$qf=be;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$rf=Pe;function U(Ae,Te=1){if(Te===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Te--;while(Te>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$sf=U;function Q(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$tf=Q;function se(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$uf=se;function oe(Ae,Te){return Ae===0?Te!==5&&Te!==7:Ae===2&&Te===3?!1:Ae===4||Ae===2||Ae===3||Te===4||Te===2||Te===3?!0:!(Ae===8&&(Te===8||Te===9||Te===11||Te===12)||(Ae===11||Ae===9)&&(Te===9||Te===10)||(Ae===12||Ae===10)&&Te===10||Te===5||Te===13||Te===7||Ae===1||Ae===13&&Te===14||Ae===6&&Te===6)}var Z;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Z||(e.GraphemeBreakType=Z={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=Ee()}getGraphemeBreakType(Te){if(Te<32)return Te===10?3:Te===13?2:4;if(Te<127)return 0;const qe=this.d,Le=qe.length/3;let Xe=1;for(;Xe<=Le;)if(Te<qe[3*Xe])Xe=2*Xe;else if(Te>qe[3*Xe+1])Xe=2*Xe+1;else return qe[3*Xe+2];return 0}}function Ee(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(Ae,Te){if(Ae===0)return 0;const qe=We(Ae,Te);if(qe!==void 0)return qe;const Le=new K(Te,Ae);return Le.prevCodePoint(),Le.offset}e.$vf=ze;function We(Ae,Te){const qe=new K(Te,Ae);let Le=qe.prevCodePoint();for(;_e(Le)||Le===65039||Le===8419;){if(qe.offset===0)return;Le=qe.prevCodePoint()}if(!X(Le))return;let Xe=qe.offset;return Xe>0&&qe.prevCodePoint()===8205&&(Xe=qe.offset),Xe}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$wf="\xA0";class it{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$ye(Te=>{function qe(Ze){const nt=new Map;for(let ct=0;ct<Ze.length;ct+=2)nt.set(Ze[ct],Ze[ct+1]);return nt}function Le(Ze,nt){const ct=new Map(Ze);for(const[bt,Et]of nt)ct.set(bt,Et);return ct}function Xe(Ze,nt){if(!Ze)return nt;const ct=new Map;for(const[bt,Et]of Ze)nt.has(bt)&&ct.set(bt,Et);return ct}const he=this.c.value;let ue=Te.filter(Ze=>!Ze.startsWith("_")&&Ze in he);ue.length===0&&(ue=["_default"]);let Ie;for(const Ze of ue){const nt=qe(he[Ze]);Ie=Xe(Ie,nt)}const Ke=qe(he._common),Ue=Le(Ke,Ie);return new it(Ue)})}static getInstance(Te){return it.d.get(Array.from(Te))}static{this.e=new O.$V(()=>Object.keys(it.c.value).filter(Te=>!Te.startsWith("_")))}static getLocales(){return it.e.value}constructor(Te){this.f=Te}isAmbiguous(Te){return this.f.has(Te)}getPrimaryConfusable(Te){return this.f.get(Te)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$xf=it;class tt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(tt.c())),this.d}static isInvisibleCharacter(Te){return tt.e().has(Te)}static get codePoints(){return tt.e()}}e.$yf=tt}),define(De[121],Ce([1,0,28,15]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.FuzzyScore=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.or=void 0;function f(...ee){return function(de,be){for(let Pe=0,U=ee.length;Pe<U;Pe++){const Q=ee[Pe](de,be);if(Q)return Q}return null}}e.or=f,e.$Dj=R.bind(void 0,!1),e.$Ej=R.bind(void 0,!0);function R(ee,de,be){if(!be||be.length<de.length)return null;let Pe;return ee?Pe=O.$4e(be,de):Pe=be.indexOf(de)===0,Pe?de.length>0?[{start:0,end:de.length}]:[]:null}function A(ee,de){const be=de.toLowerCase().indexOf(ee.toLowerCase());return be===-1?null:[{start:be,end:be+ee.length}]}e.$Fj=A;function m(ee,de){return E(ee.toLowerCase(),de.toLowerCase(),0,0)}e.$Gj=m;function E(ee,de,be,Pe){if(be===ee.length)return[];if(Pe===de.length)return null;if(ee[be]===de[Pe]){let U=null;return(U=E(ee,de,be+1,Pe+1))?o({start:Pe,end:Pe+1},U):null}return E(ee,de,be,Pe+1)}function b(ee){return 97<=ee&&ee<=122}function L(ee){return 65<=ee&&ee<=90}e.$Hj=L;function P(ee){return 48<=ee&&ee<=57}function p(ee){return ee===32||ee===9||ee===10||ee===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>y.add(ee.charCodeAt(0)));function k(ee){return p(ee)||y.has(ee)}function v(ee,de){return ee===de||k(ee)&&k(de)}function h(ee){return b(ee)||L(ee)||P(ee)}function o(ee,de){return de.length===0?de=[ee]:ee.end===de[0].start?de[0].start=ee.start:de.unshift(ee),de}function l(ee,de){for(let be=de;be<ee.length;be++){const Pe=ee.charCodeAt(be);if(L(Pe)||P(Pe)||be>0&&!h(ee.charCodeAt(be-1)))return be}return ee.length}function c(ee,de,be,Pe){if(be===ee.length)return[];if(Pe===de.length)return null;if(ee[be]!==de[Pe].toLowerCase())return null;{let U=null,Q=Pe+1;for(U=c(ee,de,be+1,Pe+1);!U&&(Q=l(de,Q))<de.length;)U=c(ee,de,be+1,Q),Q++;return U===null?null:o({start:Pe,end:Pe+1},U)}}function d(ee){let de=0,be=0,Pe=0,U=0,Q=0;for(let Ee=0;Ee<ee.length;Ee++)Q=ee.charCodeAt(Ee),L(Q)&&de++,b(Q)&&be++,h(Q)&&Pe++,P(Q)&&U++;const se=de/ee.length,oe=be/ee.length,Z=Pe/ee.length,ge=U/ee.length;return{upperPercent:se,lowerPercent:oe,alphaPercent:Z,numericPercent:ge}}function a(ee){const{upperPercent:de,lowerPercent:be}=ee;return be===0&&de>.6}function t(ee){const{upperPercent:de,lowerPercent:be,alphaPercent:Pe,numericPercent:U}=ee;return be>.2&&de<.8&&Pe>.6&&U<.2}function i(ee){let de=0,be=0,Pe=0,U=0;for(let Q=0;Q<ee.length;Q++)Pe=ee.charCodeAt(Q),L(Pe)&&de++,b(Pe)&&be++,p(Pe)&&U++;return(de===0||be===0)&&U===0?ee.length<=30:de<=5}function s(ee,de){if(!de||(de=de.trim(),de.length===0)||!i(ee)||de.length>60)return null;const be=d(de);if(!t(be)){if(!a(be))return null;de=de.toLowerCase()}let Pe=null,U=0;for(ee=ee.toLowerCase();U<de.length&&(Pe=c(ee,de,0,U))===null;)U=l(de,U+1);return Pe}e.$Ij=s;function n(ee,de,be=!1){if(!de||de.length===0)return null;let Pe=null,U=0;for(ee=ee.toLowerCase(),de=de.toLowerCase();U<de.length&&(Pe=r(ee,de,0,U,be))===null;)U=u(de,U+1);return Pe}e.$Jj=n;function r(ee,de,be,Pe,U){if(be===ee.length)return[];if(Pe===de.length)return null;if(v(ee.charCodeAt(be),de.charCodeAt(Pe))){let Q=null,se=Pe+1;if(Q=r(ee,de,be+1,Pe+1,U),!U)for(;!Q&&(se=u(de,se))<de.length;)Q=r(ee,de,be+1,se,U),se++;return Q?ee.charCodeAt(be)!==de.charCodeAt(Pe)?Q:o({start:Pe,end:Pe+1},Q):null}else return null}function u(ee,de){for(let be=de;be<ee.length;be++)if(k(ee.charCodeAt(be))||be>0&&k(ee.charCodeAt(be-1)))return be;return ee.length}const I=f(e.$Ej,s,A),S=f(e.$Ej,s,m),$=new C.$Dc(1e4);function g(ee,de,be=!1){if(typeof ee!="string"||typeof de!="string")return null;let Pe=$.get(ee);Pe||(Pe=new RegExp(O.$Me(ee),"i"),$.set(ee,Pe));const U=Pe.exec(de);return U?[{start:U.index,end:U.index+U[0].length}]:be?S(ee,de):I(ee,de)}e.$Kj=g;function w(ee,de){const be=re(ee,ee.toLowerCase(),0,de,de.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?T(be):null}e.$Lj=w;function D(ee,de,be,Pe,U,Q){const se=Math.min(13,ee.length);for(;be<se;be++){const oe=re(ee,de,be,Pe,U,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,Q]}e.$Mj=D;function T(ee){if(typeof ee>"u")return[];const de=[],be=ee[1];for(let Pe=ee.length-1;Pe>1;Pe--){const U=ee[Pe]+be,Q=de[de.length-1];Q&&Q.end===U?Q.end=U+1:de.push({start:U,end:U+1})}return de}e.$Nj=T;const M=128;function F(){const ee=[],de=[];for(let be=0;be<=M;be++)de[be]=0;for(let be=0;be<=M;be++)ee.push(de.slice(0));return ee}function z(ee){const de=[];for(let be=0;be<=ee;be++)de[be]=0;return de}const j=z(2*M),N=z(2*M),q=F(),K=F(),me=F(),te=!1;function G(ee,de,be,Pe,U){function Q(oe,Z,ge=" "){for(;oe.length<Z;)oe=ge+oe;return oe}let se=` |   |${Pe.split("").map(oe=>Q(oe,3)).join("|")}
`;for(let oe=0;oe<=be;oe++)oe===0?se+=" |":se+=`${de[oe-1]}|`,se+=ee[oe].slice(0,U+1).map(Z=>Q(Z.toString(),3)).join("|")+`
`;return se}function J(ee,de,be,Pe){ee=ee.substr(de),be=be.substr(Pe),console.log(G(K,ee,ee.length,be,be.length)),console.log(G(me,ee,ee.length,be,be.length)),console.log(G(q,ee,ee.length,be,be.length))}function le(ee,de){if(de<0||de>=ee.length)return!1;const be=ee.codePointAt(de);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$jf(be)}}function ie(ee,de){if(de<0||de>=ee.length)return!1;switch(ee.charCodeAt(de)){case 32:case 9:return!0;default:return!1}}function ce(ee,de,be){return de[ee]!==be[ee]}function ye(ee,de,be,Pe,U,Q,se=!1){for(;de<be&&U<Q;)ee[de]===Pe[U]&&(se&&(j[de]=U),de+=1),U+=1;return de===be}e.$Oj=ye;var H;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(H||(H={}));var B;(function(ee){ee.Default=[-100,0];function de(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}ee.isDefault=de})(B||(e.FuzzyScore=B={}));class Y{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(de,be){this.firstMatchCanBeWeak=de,this.boostFullMatch=be}}e.$Pj=Y;function re(ee,de,be,Pe,U,Q,se=Y.default){const oe=ee.length>M?M:ee.length,Z=Pe.length>M?M:Pe.length;if(be>=oe||Q>=Z||oe-be>Z-Q||!ye(de,be,oe,U,Q,Z,!0))return;X(oe,Z,be,Q,de,U);let ge=1,Ee=1,ze=be,We=Q;const _e=[!1];for(ge=1,ze=be;ze<oe;ge++,ze++){const Te=j[ze],qe=N[ze],Le=ze+1<oe?N[ze+1]:Z;for(Ee=Te-Q+1,We=Te;We<Le;Ee++,We++){let Xe=Number.MIN_SAFE_INTEGER,he=!1;We<=qe&&(Xe=_(ee,de,ze,be,Pe,U,We,Z,Q,q[ge-1][Ee-1]===0,_e));let ue=0;Xe!==Number.MAX_SAFE_INTEGER&&(he=!0,ue=Xe+K[ge-1][Ee-1]);const Ie=We>Te,Ke=Ie?K[ge][Ee-1]+(q[ge][Ee-1]>0?-5:0):0,Ue=We>Te+1&&q[ge][Ee-1]>0,Ze=Ue?K[ge][Ee-2]+(q[ge][Ee-2]>0?-5:0):0;if(Ue&&(!Ie||Ze>=Ke)&&(!he||Ze>=ue))K[ge][Ee]=Ze,me[ge][Ee]=3,q[ge][Ee]=0;else if(Ie&&(!he||Ke>=ue))K[ge][Ee]=Ke,me[ge][Ee]=2,q[ge][Ee]=0;else if(he)K[ge][Ee]=ue,me[ge][Ee]=1,q[ge][Ee]=q[ge-1][Ee-1]+1;else throw new Error("not possible")}}if(te&&J(ee,be,Pe,Q),!_e[0]&&!se.firstMatchCanBeWeak)return;ge--,Ee--;const Ye=[K[ge][Ee],Q];let it=0,tt=0;for(;ge>=1;){let Te=Ee;do{const qe=me[ge][Te];if(qe===3)Te=Te-2;else if(qe===2)Te=Te-1;else break}while(Te>=1);it>1&&de[be+ge-1]===U[Q+Ee-1]&&!ce(Te+Q-1,Pe,U)&&it+1>q[ge][Te]&&(Te=Ee),Te===Ee?it++:it=1,tt||(tt=Te),ge--,Ee=Te-1,Ye.push(Ee)}Z===oe&&se.boostFullMatch&&(Ye[0]+=2);const Ae=tt-oe;return Ye[0]-=Ae,Ye}e.$Qj=re;function X(ee,de,be,Pe,U,Q){let se=ee-1,oe=de-1;for(;se>=be&&oe>=Pe;)U[se]===Q[oe]&&(N[se]=oe,se--),oe--}function _(ee,de,be,Pe,U,Q,se,oe,Z,ge,Ee){if(de[be]!==Q[se])return Number.MIN_SAFE_INTEGER;let ze=1,We=!1;return se===be-Pe?ze=ee[be]===U[se]?7:5:ce(se,U,Q)&&(se===0||!ce(se-1,U,Q))?(ze=ee[be]===U[se]?7:5,We=!0):le(Q,se)&&(se===0||!le(Q,se-1))?ze=5:(le(Q,se-1)||ie(Q,se-1))&&(ze=5,We=!0),ze>1&&be===Pe&&(Ee[0]=!0),We||(We=ce(se,U,Q)||le(Q,se-1)||ie(Q,se-1)),be===Pe?se>Z&&(ze-=We?3:5):ge?ze+=We?2:0:ze+=We?0:1,se+1===oe&&(ze-=We?3:5),ze}function x(ee,de,be,Pe,U,Q,se){return ae(ee,de,be,Pe,U,Q,!0,se)}e.$Rj=x;function pe(ee,de,be,Pe,U,Q,se){return ae(ee,de,be,Pe,U,Q,!1,se)}e.$Sj=pe;function ae(ee,de,be,Pe,U,Q,se,oe){let Z=re(ee,de,be,Pe,U,Q,oe);if(Z&&!se)return Z;if(ee.length>=3){const ge=Math.min(7,ee.length-1);for(let Ee=be+1;Ee<ge;Ee++){const ze=fe(ee,Ee);if(ze){const We=re(ze,ze.toLowerCase(),be,Pe,U,Q,oe);We&&(We[0]-=3,(!Z||We[0]>Z[0])&&(Z=We))}}}return Z}function fe(ee,de){if(de+1>=ee.length)return;const be=ee[de],Pe=ee[de+1];if(be!==Pe)return ee.slice(0,de)+Pe+be+ee.slice(de+2)}}),define(De[52],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;function O(o){return f(o,0)}e.$Ei=O;function f(o,l){switch(typeof o){case"object":return o===null?R(349,l):Array.isArray(o)?E(o,l):b(o,l);case"string":return m(o,l);case"boolean":return A(o,l);case"number":return R(o,l);case"undefined":return R(937,l);default:return R(617,l)}}e.$Fi=f;function R(o,l){return(l<<5)-l+o|0}e.$Gi=R;function A(o,l){return R(o?433:863,l)}function m(o,l){l=R(149417,l);for(let c=0,d=o.length;c<d;c++)l=R(o.charCodeAt(c),l);return l}e.$Hi=m;function E(o,l){return l=R(104579,l),o.reduce((c,d)=>f(d,c),l)}function b(o,l){return l=R(181387,l),Object.keys(o).sort().reduce((c,d)=>(c=m(d,c),f(o[d],c)),l)}class L{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=f(l,this.g),this.g}}e.$Ii=L;var P;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function p(o,l,c=32){const d=c-l,a=~((1<<d)-1);return(o<<l|(a&o)>>>d)>>>0}function y(o,l=0,c=o.byteLength,d=0){for(let a=0;a<c;a++)o[l+a]=d}function k(o,l,c="0"){for(;o.length<l;)o=c+o;return o}function v(o,l=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(c=>c.toString(16).padStart(2,"0")).join(""):k((o>>>0).toString(16),l/4)}e.$Ji=v;class h{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const c=l.length;if(c===0)return;const d=this.p;let a=this.r,t=this.u,i,s;for(t!==0?(i=t,s=-1,t=0):(i=l.charCodeAt(0),s=0);;){let n=i;if(C.$7e(i))if(s+1<c){const r=l.charCodeAt(s+1);C.$8e(r)?(s++,n=C.$9e(i,r)):n=65533}else{t=i;break}else C.$8e(i)&&(n=65533);if(a=this.w(d,a,n),s++,s<c)i=l.charCodeAt(s);else break}this.r=a,this.u=t}w(l,c,d){return d<128?l[c++]=d:d<2048?(l[c++]=192|(d&1984)>>>6,l[c++]=128|(d&63)>>>0):d<65536?(l[c++]=224|(d&61440)>>>12,l[c++]=128|(d&4032)>>>6,l[c++]=128|(d&63)>>>0):(l[c++]=240|(d&1835008)>>>18,l[c++]=128|(d&258048)>>>12,l[c++]=128|(d&4032)>>>6,l[c++]=128|(d&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=h.g,c=this.q;for(let I=0;I<64;I+=4)l.setUint32(I,c.getUint32(I,!1),!1);for(let I=64;I<320;I+=4)l.setUint32(I,p(l.getUint32(I-12,!1)^l.getUint32(I-32,!1)^l.getUint32(I-56,!1)^l.getUint32(I-64,!1),1),!1);let d=this.h,a=this.l,t=this.m,i=this.n,s=this.o,n,r,u;for(let I=0;I<80;I++)I<20?(n=a&t|~a&i,r=1518500249):I<40?(n=a^t^i,r=1859775393):I<60?(n=a&t|a&i|t&i,r=2400959708):(n=a^t^i,r=3395469782),u=p(d,5)+n+s+r+l.getUint32(I*4,!1)&4294967295,s=i,i=t,t=p(a,30),a=d,d=u;this.h=this.h+d&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+i&4294967295,this.o=this.o+s&4294967295}}e.$Ki=h}),define(De[38],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(O||(O={})),function(f){const R="error",A="warning",m="warn",E="info",b="ignore";function L(p){return p?C.$3e(R,p)?f.Error:C.$3e(A,p)||C.$3e(m,p)?f.Warning:C.$3e(E,p)?f.Info:f.Ignore:f.Ignore}f.fromValue=L;function P(p){switch(p){case f.Error:return R;case f.Warning:return A;case f.Info:return E;default:return b}}f.toString=P}(O||(O={})),e.default=O}),define(De[160],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(De[78],Ce([1,0,19,15]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class f{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const k=y.charCodeAt(0),v=this.b.charCodeAt(this.c);return k-v}value(){return this.b[this.c]}}e.$Sh=f;class R{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,O.$We)(y,this.b,0,y.length,this.c,this.d):(0,O.$Ye)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Th=R;class A{constructor(y=!0,k=!0){this.f=y,this.g=k}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let k=y.length-1;k>=0;k--,this.c--){const v=this.b.charCodeAt(k);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,O.$We)(y,this.b,0,y.length,this.d,this.e):(0,O.$Ye)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Uh=A;var m;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(m||(m={}));class E{constructor(y,k){this.f=y,this.g=k,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,O.$Xe)(y,this.c.scheme);if(this.d[this.e]===2)return(0,O.$Xe)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,O.$Ve)(y,this.c.query);if(this.d[this.e]===5)return(0,O.$Ve)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Vh=E;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(L||(L={}));class P{static forUris(y=()=>!1,k=()=>!1){return new P(new E(y,k))}static forPaths(y=!1){return new P(new A(void 0,!y))}static forStrings(){return new P(new f)}static forConfigKeys(){return new P(new R)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,k){if(k){const v=k.slice(0);(0,C.$Xb)(v);for(const h of v)this.set(h,y)}else{const v=y.slice(0);(0,C.$Xb)(v);for(const h of v)this.set(h[0],h[1])}}set(y,k){const v=this.b.reset(y);let h;this.c||(this.c=new b,this.c.segment=v.value());const o=[];for(h=this.c;;){const c=v.cmp(h.segment);if(c>0)h.left||(h.left=new b,h.left.segment=v.value()),o.push([-1,h]),h=h.left;else if(c<0)h.right||(h.right=new b,h.right.segment=v.value()),o.push([1,h]),h=h.right;else if(v.hasNext())v.next(),h.mid||(h.mid=new b,h.mid.segment=v.value()),o.push([0,h]),h=h.mid;else break}const l=h.value;h.value=k,h.key=y;for(let c=o.length-1;c>=0;c--){const d=o[c][1];d.updateHeight();const a=d.balanceFactor();if(a<-1||a>1){const t=o[c][0],i=o[c+1][0];if(t===1&&i===1)o[c][1]=d.rotateLeft();else if(t===-1&&i===-1)o[c][1]=d.rotateRight();else if(t===1&&i===-1)d.right=o[c+1][1]=o[c+1][1].rotateRight(),o[c][1]=d.rotateLeft();else if(t===-1&&i===1)d.left=o[c+1][1]=o[c+1][1].rotateLeft(),o[c][1]=d.rotateRight();else throw new Error;if(c>0)switch(o[c-1][0]){case-1:o[c-1][1].left=o[c][1];break;case 1:o[c-1][1].right=o[c][1];break;case 0:o[c-1][1].mid=o[c][1];break}else this.c=o[0][1]}}return l}get(y){return this.d(y)?.value}d(y){const k=this.b.reset(y);let v=this.c;for(;v;){const h=k.cmp(v.segment);if(h>0)v=v.left;else if(h<0)v=v.right;else if(k.hasNext())k.next(),v=v.mid;else break}return v}has(y){const k=this.d(y);return!(k?.value===void 0&&k?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,k){const v=this.b.reset(y),h=[];let o=this.c;for(;o;){const l=v.cmp(o.segment);if(l>0)h.push([-1,o]),o=o.left;else if(l<0)h.push([1,o]),o=o.right;else if(v.hasNext())v.next(),h.push([0,o]),o=o.mid;else break}if(o){if(k?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const l=this.f(o.right);if(l.key){const{key:c,value:d,segment:a}=l;this.e(l.key,!1),o.key=c,o.value=d,o.segment=a}}else{const l=o.left??o.right;if(h.length>0){const[c,d]=h[h.length-1];switch(c){case-1:d.left=l;break;case 0:d.mid=l;break;case 1:d.right=l;break}}else this.c=l}for(let l=h.length-1;l>=0;l--){const c=h[l][1];c.updateHeight();const d=c.balanceFactor();if(d>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),h[l][1]=c.rotateLeft()):d<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),h[l][1]=c.rotateRight()),l>0)switch(h[l-1][0]){case-1:h[l-1][1].left=h[l][1];break;case 1:h[l-1][1].right=h[l][1];break;case 0:h[l-1][1].mid=h[l][1];break}else this.c=h[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const k=this.b.reset(y);let v=this.c,h;for(;v;){const o=k.cmp(v.segment);if(o>0)v=v.left;else if(o<0)v=v.right;else if(k.hasNext())k.next(),h=v.value||h,v=v.mid;else break}return v&&v.value||h}findSuperstr(y){return this.g(y,!1)}g(y,k){const v=this.b.reset(y);let h=this.c;for(;h;){const o=v.cmp(h.segment);if(o>0)h=h.left;else if(o<0)h=h.right;else if(v.hasNext())v.next(),h=h.mid;else return h.mid?this.h(h.mid):k?h.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[k,v]of this)y(v,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const k=[];return this.j(y,k),k[Symbol.iterator]()}j(y,k){y&&(y.left&&this.j(y.left,k),y.value&&k.push([y.key,y.value]),y.mid&&this.j(y.mid,k),y.right&&this.j(y.right,k))}_isBalanced(){const y=k=>{if(!k)return!0;const v=k.balanceFactor();return v<-1||v>1?!1:y(k.left)&&y(k.right)};return y(this.c)}}e.$Wh=P}),define(De[17],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=void 0;function C(a){return typeof a=="string"}e.$zf=C;function O(a){return Array.isArray(a)&&a.every(t=>C(t))}e.$Af=O;function f(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Bf=f;function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Cf=R;function A(a){return typeof a=="number"&&!isNaN(a)}e.$Df=A;function m(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Ef=m;function E(a){return a===!0||a===!1}e.$Ff=E;function b(a){return typeof a>"u"}e.$Gf=b;function L(a){return!P(a)}e.$Hf=L;function P(a){return b(a)||a===null}e.$If=P;function p(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Jf=p;function y(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Kf=y;function k(...a){const t=[];for(let i=0;i<a.length;i++){const s=a[i];if(P(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(s)}return t}e.$Lf=k;const v=Object.prototype.hasOwnProperty;function h(a){if(!f(a))return!1;for(const t in a)if(v.call(a,t))return!1;return!0}e.$Mf=h;function o(a){return typeof a=="function"}e.$Nf=o;function l(...a){return a.length>0&&a.every(o)}e.$Of=l;function c(a,t){const i=Math.min(a.length,t.length);for(let s=0;s<i;s++)d(a[s],t[s])}e.$Pf=c;function d(a,t){if(C(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!P(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Qf=d}),define(De[79],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=void 0;const O=Object.create(null);function f(m,E){if((0,C.$zf)(E)){const b=O[E];if(b===void 0)throw new Error(`${m} references an unknown codicon: ${E}`);E=b}return O[m]=E,{id:m}}function R(){return O}e.$Tj=R;function A(){return Object.values(e.$Vj)}e.$Uj=A,e.$Vj={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(De[24],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=void 0;function O(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const a=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([t,i])=>{a[t]=i&&typeof i=="object"?O(i):i}),a}e.$8m=O;function f(d){if(!d||typeof d!="object")return d;const a=[d];for(;a.length>0;){const t=a.shift();Object.freeze(t);for(const i in t)if(R.call(t,i)){const s=t[i];typeof s=="object"&&!Object.isFrozen(s)&&!(0,C.$Cf)(s)&&a.push(s)}}return d}e.$9m=f;const R=Object.prototype.hasOwnProperty;function A(d,a){return m(d,a,new Set)}e.$0m=A;function m(d,a,t){if((0,C.$If)(d))return d;const i=a(d);if(typeof i<"u")return i;if(Array.isArray(d)){const s=[];for(const n of d)s.push(m(n,a,t));return s}if((0,C.$Bf)(d)){if(t.has(d))throw new Error("Cannot clone recursive data-structure");t.add(d);const s={};for(const n in d)R.call(d,n)&&(s[n]=m(d[n],a,t));return t.delete(d),s}return d}function E(d,a,t=!0){return(0,C.$Bf)(d)?((0,C.$Bf)(a)&&Object.keys(a).forEach(i=>{i in d?t&&((0,C.$Bf)(d[i])&&(0,C.$Bf)(a[i])?E(d[i],a[i],t):d[i]=a[i]):d[i]=a[i]}),d):a}e.$$m=E;function b(d,a){if(d===a)return!0;if(d==null||a===null||a===void 0||typeof d!=typeof a||typeof d!="object"||Array.isArray(d)!==Array.isArray(a))return!1;let t,i;if(Array.isArray(d)){if(d.length!==a.length)return!1;for(t=0;t<d.length;t++)if(!b(d[t],a[t]))return!1}else{const s=[];for(i in d)s.push(i);s.sort();const n=[];for(i in a)n.push(i);if(n.sort(),!b(s,n))return!1;for(t=0;t<s.length;t++)if(!b(d[s[t]],a[s[t]]))return!1}return!0}e.$_m=b;function L(d){const a=new Set;return JSON.stringify(d,(t,i)=>{if((0,C.$Bf)(i)||Array.isArray(i)){if(a.has(i))return"[Circular]";a.add(i)}return i})}e.$an=L;function P(d,a){const t=Object.create(null);return!d||!a||Object.keys(a).forEach(s=>{const n=d[s],r=a[s];b(n,r)||(t[s]=r)}),t}e.$bn=P;function p(d,a){const t=a.toLowerCase(),i=Object.keys(d).find(s=>s.toLowerCase()===t);return i?d[i]:d[a]}e.$cn=p;function y(d,a){const t=Object.create(null);for(const[i,s]of Object.entries(d))a(i,s)&&(t[i]=s);return t}e.$dn=y;function k(d){let a=[];for(;Object.prototype!==d;)a=a.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return a}e.$en=k;function v(d){const a=[];for(const t of k(d))typeof d[t]=="function"&&a.push(t);return a}e.$fn=v;function h(d,a){const t=s=>function(){const n=Array.prototype.slice.call(arguments,0);return a(s,n)},i={};for(const s of d)i[s]=t(s);return i}e.$gn=h;function o(d,a,t){typeof a=="string"&&d[a]!==void 0&&typeof d[a]!="boolean"&&(d[a]=t)}e.$hn=o;function l(d,a,t){typeof a=="string"&&d[a]!==void 0&&typeof d[a]!="number"&&(d[a]=t)}e.$in=l;function c(d,a,t,i){if(typeof a!="string")return;const s=d[a];s!==void 0&&(typeof s!="string"||!t.includes(s))&&(d[a]=i)}e.$jn=c}),define(De[59],Ce([1,0,79]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Wj=e.ThemeColor=void 0;var O;(function(A){function m(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=m})(O||(e.ThemeColor=O={}));function f(A){return{id:A}}e.$Wj=f;var R;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(l){const c=m.exec(l.id);if(!c)return E(C.$Vj.error);const[,d,a]=c,t=["codicon","codicon-"+d];return a&&t.push("codicon-modifier-"+a.substring(1)),t}A.asClassNameArray=E;function b(l){return E(l).join(" ")}A.asClassName=b;function L(l){return"."+E(l).join(".")}A.asCSSSelector=L;function P(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||O.isThemeColor(l.color))}A.isThemeIcon=P;const p=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function y(l){const c=p.exec(l);if(!c)return;const[,d]=c;return{id:d}}A.fromString=y;function k(l){return{id:l}}A.fromId=k;function v(l,c){let d=l.id;const a=d.lastIndexOf("~");return a!==-1&&(d=d.substring(0,a)),c&&(d=`${d}~${c}`),{id:d}}A.modify=v;function h(l){const c=l.id.lastIndexOf("~");if(c!==-1)return l.id.substring(c+1)}A.getModifier=h;function o(l,c){return l.id===c.id&&l.color?.id===c.color?.id}A.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(De[161],Ce([1,0,121,15,59]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=void 0;const R="$(",A=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${A.source}`,"g");function E(o){return o.replace(m,(l,c)=>c?l:`\\${l}`)}e.$Xj=E;const b=new RegExp(`\\\\${A.source}`,"g");function L(o){return o.replace(b,l=>`\\${l}`)}e.$Yj=L;const P=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function p(o){return o.indexOf(R)===-1?o:o.replace(P,(l,c,d,a)=>d?l:c||a||"")}e.$Zj=p;function y(o){return o?o.replace(/\$\((.*?)\)/g,(l,c)=>` ${c} `).trim():""}e.$1j=y;const k=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function v(o){k.lastIndex=0;let l="";const c=[];let d=0;for(;;){const a=k.lastIndex,t=k.exec(o),i=o.substring(a,t?.index);if(i.length>0){l+=i;for(let s=0;s<i.length;s++)c.push(d)}if(!t)break;d+=t[0].length}return{text:l,iconOffsets:c}}e.$2j=v;function h(o,l,c=!1){const{text:d,iconOffsets:a}=l;if(!a||a.length===0)return(0,C.$Kj)(o,d,c);const t=(0,O.$Ke)(d," "),i=d.length-t.length,s=(0,C.$Kj)(o,t,c);if(s)for(const n of s){const r=a[n.start+i]+i;n.start+=r,n.end+=r}return s}e.$3j=h}),define(De[122],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.Constants=void 0;var C;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function O(R){return R<0?0:R>255?255:R|0}e.$Ae=O;function f(R){return R<0?0:R>4294967295?4294967295:R|0}e.$Be=f}),define(De[31],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(f){return C.test(f)}e.$eg=O,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(m){for(let E=0;E<m.length;E++)m[E]=Math.floor(Math.random()*256);return m};const R=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));return function(){f(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let E=0,b="";return b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b+="-",b+=A[R[E++]],b+=A[R[E++]],b+="-",b+=A[R[E++]],b+=A[R[E++]],b+="-",b+=A[R[E++]],b+=A[R[E++]],b+="-",b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b}}()}),define(De[162],Ce([1,0,19,51,31]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.$6s=e.$5s=e.$4s=e.$3s=void 0;function R(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.$3s=R;function A(P,p,y){const k={id:(0,f.$fg)(),name:P,uri:p,data:y};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$4s=A;class m{constructor(){this.a=new Map}get size(){let p=0;for(const y of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const y=[...this.a.keys()];return O.Iterable.some(this,([k,v])=>v.asFile())&&y.push("files"),L(E(p),y)}get(p){return this.a.get(this.b(p))?.[0]}append(p,y){const k=this.a.get(p);k?k.push(y):this.a.set(this.b(p),[y])}replace(p,y){this.a.set(this.b(p),[y])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,y]of this.a)for(const k of y)yield[p,k]}b(p){return E(p)}}e.$5s=m;function E(P){return P.toLowerCase()}function b(P,p){return L(E(P),p.map(E))}e.$6s=b;function L(P,p){if(P==="*/*")return p.length>0;if(p.includes(P))return!0;const y=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[k,v,h]=y;return h==="*"?p.some(o=>o.startsWith(v+"/")):!1}e.$7s=Object.freeze({create:P=>(0,C.$Mb)(P.map(p=>p.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$7s.split(P).filter(p=>!p.startsWith("#"))})}),define(De[163],Ce([1,0,60]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=e.$ig=e.$hg=void 0;function O(m,E,b,L=1){let P=!1;return new Promise(p=>{const y=setTimeout(()=>{if(!P)return P=!0,p(0)},b);f(m,E,L,k=>{if(!P)return P=!0,clearTimeout(y),p(k)})})}e.$hg=O;function f(m,E,b,L){if(E===0)return L(0);const P=new C.Socket;P.once("connect",()=>(A(P),f(m+b,E-1,b,L))),P.once("data",()=>{}),P.once("error",p=>(A(P),p.code!=="ECONNREFUSED"?f(m+b,E-1,b,L):L(m))),P.connect(m,"127.0.0.1")}e.$ig={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(m,E,b,L="127.0.0.1"){let P=!1,p,y=1;const k=C.createServer({pauseOnConnect:!0});function v(h,o){P||(P=!0,k.removeAllListeners(),k.close(),p&&clearTimeout(p),o(h))}return new Promise(h=>{p=setTimeout(()=>{v(0,h)},b),k.on("listening",()=>{v(m,h)}),k.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&y<E?(m++,y++,k.listen(m,L)):v(0,h)}),k.on("close",()=>{v(0,h)}),k.listen(m,L)})}e.$jg=R;function A(m){try{m.removeAllListeners("connect"),m.removeAllListeners("error"),m.end(),m.destroy(),m.unref()}catch(E){console.error(E)}}}),define(De[123],Ce([1,0,122]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=void 0;class O{constructor(m){const E=(0,C.$Ae)(m);this.c=E,this.a=O.d(E),this.b=new Map}static d(m){const E=new Uint8Array(256);return E.fill(m),E}set(m,E){const b=(0,C.$Ae)(E);m>=0&&m<256?this.a[m]=b:this.b.set(m,b)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Us=O;var f;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(f||(f={}));class R{constructor(){this.a=new O(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}e.$Vs=R}),define(De[61],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;class C{constructor(f,R){this.lineNumber=f,this.column=R}with(f=this.lineNumber,R=this.column){return f===this.lineNumber&&R===this.column?this:new C(f,R)}delta(f=0,R=0){return this.with(this.lineNumber+f,this.column+R)}equals(f){return C.equals(this,f)}static equals(f,R){return!f&&!R?!0:!!f&&!!R&&f.lineNumber===R.lineNumber&&f.column===R.column}isBefore(f){return C.isBefore(this,f)}static isBefore(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<R.column}isBeforeOrEqual(f){return C.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<=R.column}static compare(f,R){const A=f.lineNumber|0,m=R.lineNumber|0;if(A===m){const E=f.column|0,b=R.column|0;return E-b}return A-m}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new C(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}}e.$ws=C}),define(De[32],Ce([1,0,61]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;class O{constructor(R,A,m,E){R>m||R===m&&A>E?(this.startLineNumber=m,this.startColumn=E,this.endLineNumber=R,this.endColumn=A):(this.startLineNumber=R,this.startColumn=A,this.endLineNumber=m,this.endColumn=E)}isEmpty(){return O.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return O.containsPosition(this,R)}static containsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<R.startColumn||A.lineNumber===R.endLineNumber&&A.column>R.endColumn)}static strictContainsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<=R.startColumn||A.lineNumber===R.endLineNumber&&A.column>=R.endColumn)}containsRange(R){return O.containsRange(this,R)}static containsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>R.endColumn)}strictContainsRange(R){return O.strictContainsRange(this,R)}static strictContainsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<=R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>=R.endColumn)}plusRange(R){return O.plusRange(this,R)}static plusRange(R,A){let m,E,b,L;return A.startLineNumber<R.startLineNumber?(m=A.startLineNumber,E=A.startColumn):A.startLineNumber===R.startLineNumber?(m=A.startLineNumber,E=Math.min(A.startColumn,R.startColumn)):(m=R.startLineNumber,E=R.startColumn),A.endLineNumber>R.endLineNumber?(b=A.endLineNumber,L=A.endColumn):A.endLineNumber===R.endLineNumber?(b=A.endLineNumber,L=Math.max(A.endColumn,R.endColumn)):(b=R.endLineNumber,L=R.endColumn),new O(m,E,b,L)}intersectRanges(R){return O.intersectRanges(this,R)}static intersectRanges(R,A){let m=R.startLineNumber,E=R.startColumn,b=R.endLineNumber,L=R.endColumn;const P=A.startLineNumber,p=A.startColumn,y=A.endLineNumber,k=A.endColumn;return m<P?(m=P,E=p):m===P&&(E=Math.max(E,p)),b>y?(b=y,L=k):b===y&&(L=Math.min(L,k)),m>b||m===b&&E>L?null:new O(m,E,b,L)}equalsRange(R){return O.equalsRange(this,R)}static equalsRange(R,A){return!R&&!A?!0:!!R&&!!A&&R.startLineNumber===A.startLineNumber&&R.startColumn===A.startColumn&&R.endLineNumber===A.endLineNumber&&R.endColumn===A.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(R){return new C.$ws(R.endLineNumber,R.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(R){return new C.$ws(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,A){return new O(this.startLineNumber,this.startColumn,R,A)}setStartPosition(R,A){return new O(R,A,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(R){return new O(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(R){return new O(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new O(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,A=R){return new O(R.lineNumber,R.column,A.lineNumber,A.column)}static lift(R){return R?new O(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn)}static areIntersecting(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,A){if(R&&A){const b=R.startLineNumber|0,L=A.startLineNumber|0;if(b===L){const P=R.startColumn|0,p=A.startColumn|0;if(P===p){const y=R.endLineNumber|0,k=A.endLineNumber|0;if(y===k){const v=R.endColumn|0,h=A.endColumn|0;return v-h}return y-k}return P-p}return b-L}return(R?1:0)-(A?1:0)}static compareRangesUsingEnds(R,A){return R.endLineNumber===A.endLineNumber?R.endColumn===A.endColumn?R.startLineNumber===A.startLineNumber?R.startColumn-A.startColumn:R.startLineNumber-A.startLineNumber:R.endColumn-A.endColumn:R.endLineNumber-A.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$xs=O}),define(De[164],Ce([1,0,32]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class O{static insert(R,A){return{range:new C.$xs(R.lineNumber,R.column,R.lineNumber,R.column),text:A,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,A){return{range:R,text:A}}static replaceMove(R,A){return{range:R,text:A,forceMoveMarkers:!0}}}e.$ys=O}),define(De[165],Ce([1,0,61,32]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=e.SelectionDirection=void 0;var f;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class R extends O.$xs{constructor(m,E,b,L){super(m,E,b,L),this.selectionStartLineNumber=m,this.selectionStartColumn=E,this.positionLineNumber=b,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return R.selectionsEqual(this,m)}static selectionsEqual(m,E){return m.selectionStartLineNumber===E.selectionStartLineNumber&&m.selectionStartColumn===E.selectionStartColumn&&m.positionLineNumber===E.positionLineNumber&&m.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,E){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,m,E):new R(m,E,this.startLineNumber,this.startColumn)}getPosition(){return new C.$ws(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$ws(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,E){return this.getDirection()===0?new R(m,E,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,m,E)}static fromPositions(m,E=m){return new R(m.lineNumber,m.column,E.lineNumber,E.column)}static fromRange(m,E){return E===0?new R(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new R(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new R(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,E){if(m&&!E||!m&&E)return!1;if(!m&&!E)return!0;if(m.length!==E.length)return!1;for(let b=0,L=m.length;b<L;b++)if(!this.selectionsEqual(m[b],E[b]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,E,b,L,P){return P===0?new R(m,E,b,L):new R(b,L,m,E)}}e.$zs=R}),define(De[166],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=void 0,e.$7r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.WordCharacterClass=void 0;var O;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class f extends C.$Us{constructor(m){super(0);for(let E=0,b=m.length;E<b;E++)this.set(m.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Ws=f;function R(A){const m={};return E=>(m.hasOwnProperty(E)||(m[E]=A(E)),m[E])}e.$Xs=R(A=>new f(A))}),define(De[124],Ce([1,0,51,3,76]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=e.$0r=e.$9r=e.$8r=void 0,e.$8r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$8r)P.indexOf(y)>=0||(p+="\\"+y);return p+="\\s]+)",new RegExp(p,"g")}e.$9r=R();function A(P){let p=e.$9r;if(P&&P instanceof RegExp)if(P.global)p=P;else{let y="g";P.ignoreCase&&(y+="i"),P.multiline&&(y+="m"),P.unicode&&(y+="u"),p=new RegExp(P.source,y)}return p.lastIndex=0,p}e.$0r=A;const m=new f.$2c;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(P){const p=m.unshift(P);return(0,O.$Qc)(p)}e.$$r=E;function b(P,p,y,k,v){if(v||(v=C.Iterable.first(m)),y.length>v.maxLen){let d=P-v.maxLen/2;return d<0?d=0:k+=d,y=y.substring(d,P+v.maxLen/2),b(P,p,y,k,v)}const h=Date.now(),o=P-1-k;let l=-1,c=null;for(let d=1;!(Date.now()-h>=v.timeBudget);d++){const a=o-v.windowSize*d;p.lastIndex=Math.max(0,a);const t=L(p,y,o,l);if(!t&&c||(c=t,a<=0))break;l=a}if(c){const d={word:c[0],startColumn:k+1+c.index,endColumn:k+1+c.index+c[0].length};return p.lastIndex=0,d}return null}e.$_r=b;function L(P,p,y,k){let v;for(;v=P.exec(p);){const h=v.index||0;if(h<=y&&P.lastIndex>=y)return v;if(k>0&&h>k)return null}return null}}),define(De[168],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.$tt=e.IndentAction=void 0;var C;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class O{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let E=0,b=m.notIn.length;E<b;E++)switch(m.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,E){if(m.getTokenCount()===0)return!0;const b=m.findTokenIndexAtOffset(E-2),L=m.getStandardTokenType(b);return this.isOK(L)}g(m,E){for(let b=m;b<=E;b++){const L=String.fromCharCode(b);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$tt=O;class f{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of m)R(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),R(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),R(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),R(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&R(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$ut=f;function R(A,m,E){A.has(m)?A.get(m).push(E):A.set(m,[E])}}),define(De[169],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bZ=e.$aZ=e.$_Y=e.State=void 0;var O;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class f{constructor(k,v,h){const o=new Uint8Array(k*v);for(let l=0,c=k*v;l<c;l++)o[l]=h;this.a=o,this.rows=k,this.cols=v}get(k,v){return this.a[k*this.cols+v]}set(k,v,h){this.a[k*this.cols+v]=h}}class R{constructor(k){let v=0,h=0;for(let l=0,c=k.length;l<c;l++){const[d,a,t]=k[l];a>v&&(v=a),d>h&&(h=d),t>h&&(h=t)}v++,h++;const o=new f(h,v,0);for(let l=0,c=k.length;l<c;l++){const[d,a,t]=k[l];o.set(d,a,t)}this.a=o,this.b=v}nextState(k,v){return v<0||v>=this.b?0:this.a.get(k,v)}}e.$_Y=R;let A=null;function m(){return A===null&&(A=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let b=null;function L(){if(b===null){b=new C.$Us(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<y.length;v++)b.set(y.charCodeAt(v),1);const k=".,;:";for(let v=0;v<k.length;v++)b.set(k.charCodeAt(v),2)}return b}class P{static a(k,v,h,o,l){let c=l-1;do{const d=v.charCodeAt(c);if(k.get(d)!==2)break;c--}while(c>o);if(o>0){const d=v.charCodeAt(o-1),a=v.charCodeAt(c);(d===40&&a===41||d===91&&a===93||d===123&&a===125)&&c--}return{range:{startLineNumber:h,startColumn:o+1,endLineNumber:h,endColumn:c+2},url:v.substring(o,c+1)}}static computeLinks(k,v=m()){const h=L(),o=[];for(let l=1,c=k.getLineCount();l<=c;l++){const d=k.getLineContent(l),a=d.length;let t=0,i=0,s=0,n=1,r=!1,u=!1,I=!1,S=!1;for(;t<a;){let $=!1;const g=d.charCodeAt(t);if(n===13){let w;switch(g){case 40:r=!0,w=0;break;case 41:w=r?0:1;break;case 91:I=!0,u=!0,w=0;break;case 93:I=!1,w=u?0:1;break;case 123:S=!0,w=0;break;case 125:w=S?0:1;break;case 39:case 34:case 96:s===g?w=1:s===39||s===34||s===96?w=0:w=1;break;case 42:w=s===42?1:0;break;case 124:w=s===124?1:0;break;case 32:w=I?0:1;break;default:w=h.get(g)}w===1&&(o.push(P.a(h,d,l,i,t)),$=!0)}else if(n===12){let w;g===91?(u=!0,w=0):w=h.get(g),w===1?$=!0:n=13}else n=v.nextState(n,g),n===0&&($=!0);$&&(n=1,r=!1,u=!1,S=!1,i=t+1,s=g),t++}n===13&&o.push(P.a(h,d,l,i,a))}return o}}e.$aZ=P;function p(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:P.computeLinks(y)}e.$bZ=p}),define(De[125],Ce([1,0,24]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tu=e.$Su=e.$Ru=e.$Qu=e.ModelConstants=e.PositionAffinity=e.$Pu=e.TrackedRangeStickiness=e.$Ou=e.$Nu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var O;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var f;(function(d){d[d.Left=1]="Left",d[d.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var R;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var A;(function(d){d[d.Both=0]="Both",d[d.Right=1]="Right",d[d.Left=2]="Left",d[d.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var m;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var E;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var b;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(b||(e.EndOfLineSequence=b={}));class L{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,C.$_m)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Nu=L;class P{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Ou=P;var p;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function y(d){return d&&typeof d.read=="function"}e.$Pu=y;var k;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right",d[d.None=2]="None",d[d.LeftOfInjectedText=3]="LeftOfInjectedText",d[d.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var v;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(e.ModelConstants=v={}));class h{constructor(a,t,i,s,n,r){this.identifier=a,this.range=t,this.text=i,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=n,this._isTracked=r}}e.$Qu=h;class o{constructor(a,t,i){this.regex=a,this.wordSeparators=t,this.simpleSearch=i}}e.$Ru=o;class l{constructor(a,t,i){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=i}}e.$Su=l;function c(d){return!d.isTooLargeForSyncing()&&!d.isForSimpleWidget}e.$Tu=c}),define(De[170],Ce([1,0,19,122]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=e.$Xu=e.$Wu=void 0;class f{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,b){E=(0,O.$Be)(E);const L=this.a,P=this.b,p=b.length;return p===0?!1:(this.a=new Uint32Array(L.length+p),this.a.set(L.subarray(0,E),0),this.a.set(L.subarray(E),E+p),this.a.set(b,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(E,b){return E=(0,O.$Be)(E),b=(0,O.$Be)(b),this.a[E]===b?!1:(this.a[E]=b,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,b){E=(0,O.$Be)(E),b=(0,O.$Be)(b);const L=this.a,P=this.b;if(E>=L.length)return!1;const p=L.length-E;return b>=p&&(b=p),b===0?!1:(this.a=new Uint32Array(L.length-b),this.a.set(L.subarray(0,E),0),this.a.set(L.subarray(E+b),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,O.$Be)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let b=this.c[0]+1;b===0&&(this.b[0]=this.a[0],b++),E>=this.a.length&&(E=this.a.length-1);for(let L=b;L<=E;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let b=0,L=this.a.length-1,P=0,p=0,y=0;for(;b<=L;)if(P=b+(L-b)/2|0,p=this.b[P],y=p-this.a[P],E<y)L=P-1;else if(E>=p)b=P+1;else break;return new A(P,E-y)}}e.$Wu=f;class R{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const b=this.e[E],L=b>0?this.d[b-1]:0;return new A(b,E-L)}removeValues(E,b){this.a.splice(E,b),this.f(E)}insertValues(E,b){this.a=(0,C.$Wb)(this.a,E,b),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,b=this.a.length;E<b;E++){const L=this.a[E],P=E>0?this.d[E-1]:0;this.d[E]=P+L;for(let p=0;p<L;p++)this.e[P+p]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,b){this.a[E]!==b&&(this.a[E]=b,this.f(E))}}e.$Xu=R;class A{constructor(E,b){this.index=E,this.remainder=b,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=b}}e.$Yu=A}),define(De[171],Ce([1,0,15,61,170]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zu=void 0;class R{constructor(m,E,b,L){this.d=m,this.f=E,this.g=b,this.h=L,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(m){m.eol&&m.eol!==this.g&&(this.g=m.eol,this.j=null);const E=m.changes;for(const b of E)this.o(b.range),this.p(new O.$ws(b.range.startLineNumber,b.range.startColumn),b.text);this.h=m.versionId,this.k=null}l(){if(!this.j){const m=this.g.length,E=this.f.length,b=new Uint32Array(E);for(let L=0;L<E;L++)b[L]=this.f[L].length+m;this.j=new f.$Wu(b)}}n(m,E){this.f[m]=E,this.j&&this.j.setValue(m,this.f[m].length+this.g.length)}o(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.startLineNumber-1].substring(m.endColumn-1));return}this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.endLineNumber-1].substring(m.endColumn-1)),this.f.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.j&&this.j.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}p(m,E){if(E.length===0)return;const b=(0,C.$Qe)(E);if(b.length===1){this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]+this.f[m.lineNumber-1].substring(m.column-1));return}b[b.length-1]+=this.f[m.lineNumber-1].substring(m.column-1),this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]);const L=new Uint32Array(b.length-1);for(let P=1;P<b.length;P++)this.f.splice(m.lineNumber+P-1,0,b[P]),L[P-1]=b[P].length+this.g.length;this.j&&this.j.insertValues(m.lineNumber,L)}}e.$Zu=R}),define(De[172],Ce([1,0,15,167,61,32,125]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DB=e.$CB=e.$BB=e.$AB=e.$zB=e.$yB=void 0;const m=999;class E{constructor(l,c,d,a){this.searchString=l,this.isRegex=c,this.matchCase=d,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=b(this.searchString):l=this.searchString.indexOf(`
`)>=0;let c=null;try{c=C.$Oe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch{return null}if(!c)return null;let d=!this.isRegex&&!l;return d&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(d=this.matchCase),new A.$Ru(c,this.wordSeparators?(0,O.$Xs)(this.wordSeparators):null,d?this.searchString:null)}}e.$yB=E;function b(o){if(!o||o.length===0)return!1;for(let l=0,c=o.length;l<c;l++){const d=o.charCodeAt(l);if(d===10)return!0;if(d===92){if(l++,l>=c)break;const a=o.charCodeAt(l);if(a===110||a===114||a===87)return!0}}return!1}e.$zB=b;function L(o,l,c){if(!c)return new A.$Ou(o,null);const d=[];for(let a=0,t=l.length;a<t;a++)d[a]=l[a];return new A.$Ou(o,d)}e.$AB=L;class P{constructor(l){const c=[];let d=0;for(let a=0,t=l.length;a<t;a++)l.charCodeAt(a)===10&&(c[d++]=a);this.a=c}findLineFeedCountBeforeOffset(l){const c=this.a;let d=0,a=c.length-1;if(a===-1||l<=c[0])return 0;for(;d<a;){const t=d+((a-d)/2>>0);c[t]>=l?a=t-1:c[t+1]>=l?(d=t,a=t):d=t+1}return d+1}}class p{static findMatches(l,c,d,a,t){const i=c.parseSearchRequest();return i?i.regex.multiline?this.b(l,d,new h(i.wordSeparators,i.regex),a,t):this.c(l,d,i,a,t):[]}static a(l,c,d,a,t,i){let s,n=0;a?(n=a.findLineFeedCountBeforeOffset(t),s=c+t+n):s=c+t;let r;if(a){const $=a.findLineFeedCountBeforeOffset(t+i.length)-n;r=s+i.length+$}else r=s+i.length;const u=l.getPositionAt(s),I=l.getPositionAt(r);return new R.$xs(u.lineNumber,u.column,I.lineNumber,I.column)}static b(l,c,d,a,t){const i=l.getOffsetAt(c.getStartPosition()),s=l.getValueInRange(c,1),n=l.getEOL()===`\r
`?new P(s):null,r=[];let u=0,I;for(d.reset(0);I=d.next(s);)if(r[u++]=L(this.a(l,i,s,n,I.index,I[0]),I,a),u>=t)return r;return r}static c(l,c,d,a,t){const i=[];let s=0;if(c.startLineNumber===c.endLineNumber){const r=l.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return s=this.d(d,r,c.startLineNumber,c.startColumn-1,s,i,a,t),i}const n=l.getLineContent(c.startLineNumber).substring(c.startColumn-1);s=this.d(d,n,c.startLineNumber,c.startColumn-1,s,i,a,t);for(let r=c.startLineNumber+1;r<c.endLineNumber&&s<t;r++)s=this.d(d,l.getLineContent(r),r,0,s,i,a,t);if(s<t){const r=l.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);s=this.d(d,r,c.endLineNumber,0,s,i,a,t)}return i}static d(l,c,d,a,t,i,s,n){const r=l.wordSeparators;if(!s&&l.simpleSearch){const S=l.simpleSearch,$=S.length,g=c.length;let w=-$;for(;(w=c.indexOf(S,w+$))!==-1;)if((!r||v(r,c,g,w,$))&&(i[t++]=new A.$Ou(new R.$xs(d,w+1+a,d,w+1+$+a),null),t>=n))return t;return t}const u=new h(l.wordSeparators,l.regex);let I;u.reset(0);do if(I=u.next(c),I&&(i[t++]=L(new R.$xs(d,I.index+1+a,d,I.index+1+I[0].length+a),I,s),t>=n))return t;while(I);return t}static findNextMatch(l,c,d,a){const t=c.parseSearchRequest();if(!t)return null;const i=new h(t.wordSeparators,t.regex);return t.regex.multiline?this.e(l,d,i,a):this.f(l,d,i,a)}static e(l,c,d,a){const t=new f.$ws(c.lineNumber,1),i=l.getOffsetAt(t),s=l.getLineCount(),n=l.getValueInRange(new R.$xs(t.lineNumber,t.column,s,l.getLineMaxColumn(s)),1),r=l.getEOL()===`\r
`?new P(n):null;d.reset(c.column-1);const u=d.next(n);return u?L(this.a(l,i,n,r,u.index,u[0]),u,a):c.lineNumber!==1||c.column!==1?this.e(l,new f.$ws(1,1),d,a):null}static f(l,c,d,a){const t=l.getLineCount(),i=c.lineNumber,s=l.getLineContent(i),n=this.g(d,s,i,c.column,a);if(n)return n;for(let r=1;r<=t;r++){const u=(i+r-1)%t,I=l.getLineContent(u+1),S=this.g(d,I,u+1,1,a);if(S)return S}return null}static g(l,c,d,a,t){l.reset(a-1);const i=l.next(c);return i?L(new R.$xs(d,i.index+1,d,i.index+1+i[0].length),i,t):null}static findPreviousMatch(l,c,d,a){const t=c.parseSearchRequest();if(!t)return null;const i=new h(t.wordSeparators,t.regex);return t.regex.multiline?this.h(l,d,i,a):this.j(l,d,i,a)}static h(l,c,d,a){const t=this.b(l,new R.$xs(1,1,c.lineNumber,c.column),d,a,10*m);if(t.length>0)return t[t.length-1];const i=l.getLineCount();return c.lineNumber!==i||c.column!==l.getLineMaxColumn(i)?this.h(l,new f.$ws(i,l.getLineMaxColumn(i)),d,a):null}static j(l,c,d,a){const t=l.getLineCount(),i=c.lineNumber,s=l.getLineContent(i).substring(0,c.column-1),n=this.k(d,s,i,a);if(n)return n;for(let r=1;r<=t;r++){const u=(t+i-r-1)%t,I=l.getLineContent(u+1),S=this.k(d,I,u+1,a);if(S)return S}return null}static k(l,c,d,a){let t=null,i;for(l.reset(0);i=l.next(c);)t=L(new R.$xs(d,i.index+1,d,i.index+1+i[0].length),i,a);return t}}e.$BB=p;function y(o,l,c,d,a){if(d===0)return!0;const t=l.charCodeAt(d-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const i=l.charCodeAt(d);if(o.get(i)!==0)return!0}return!1}function k(o,l,c,d,a){if(d+a===c)return!0;const t=l.charCodeAt(d+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const i=l.charCodeAt(d+a-1);if(o.get(i)!==0)return!0}return!1}function v(o,l,c,d,a){return y(o,l,c,d,a)&&k(o,l,c,d,a)}e.$CB=v;class h{constructor(l,c){this._wordSeparators=l,this.a=c,this.b=-1,this.c=0}reset(l){this.a.lastIndex=l,this.b=-1,this.c=0}next(l){const c=l.length;let d;do{if(this.b+this.c===c||(d=this.a.exec(l),!d))return null;const a=d.index,t=d[0].length;if(a===this.b&&t===this.c){if(t===0){C.$0e(l,c,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||v(this._wordSeparators,l,c,a,t))return d}while(d);return null}}e.$DB=h}),define(De[173],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z7=e.$Y7=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const A=this.a.get(R);return this.a.delete(R),A}}addDragOperationTransfer(R,A){this.a.set(R,A)}}e.$Y7=C;class O{constructor(R){this.identifier=R}}e.$Z7=O}),define(De[174],Ce([1,0,4,3]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$Od,this.onDidChange=this.c.event,this.d=null}handleChange(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,E){return this.a.set(m,E),this.handleChange([m]),(0,O.$Qc)(()=>{this.a.get(m)===E&&(this.a.delete(m),this.handleChange([m]))})}get(m){return this.a.get(m)||null}registerFactory(m,E){this.b.get(m)?.dispose();const b=new R(this,m,E);return this.b.set(m,b),(0,O.$Qc)(()=>{const L=this.b.get(m);!L||L!==b||(this.b.delete(m),L.dispose())})}async getOrCreate(m){const E=this.get(m);if(E)return E;const b=this.b.get(m);return!b||b.isResolved?null:(await b.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const b=this.b.get(m);return!!(!b||b.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$9s=f;class R extends O.$Sc{get isResolved(){return this.c}constructor(m,E,b){super(),this.f=m,this.g=E,this.h=b,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const m=await this.h.tokenizationSupport;this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),define(De[175],Ce([10,11]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(De[176],Ce([1,0,4,3,175]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;class R extends O.$Sc{constructor(p,y="",k="",v=!0,h){super(),this.h=this.B(new C.$Od),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=y,this.u=k,this.w=v,this.C=h}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,y){this.C&&await this.C(p)}}e.$vi=R;class A extends O.$Sc{constructor(){super(...arguments),this.f=this.B(new C.$Od),this.onWillRun=this.f.event,this.m=this.B(new C.$Od),this.onDidRun=this.m.event}async run(p,y){if(!p.enabled)return;this.f.fire({action:p});let k;try{await this.u(p,y)}catch(v){k=v}this.m.fire({action:p,error:k})}async u(p,y){await p.run(y)}}e.$wi=A;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let y=[];for(const k of p)k.length&&(y.length?y=[...y,new m,...k]:y=k);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$xi=m;class E{get actions(){return this.a}constructor(p,y,k,v){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=y,this.class=v,this.a=k}async run(){}}e.$yi=E;class b extends R{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,f.localize(0,null),void 0,!1)}}e.$zi=b;function L(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async(...p)=>P.run(...p),tooltip:P.label}}e.$Ai=L}),define(De[177],Ce([10,11]),function($e,e){return $e.create("vs/base/common/date",e)}),define(De[178],Ce([1,0,177]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=void 0;const O=60,f=O*60,R=f*24,A=R*7,m=R*30,E=R*365;function b(P,p,y,k){typeof P!="number"&&(P=P.getTime());const v=Math.round((new Date().getTime()-P)/1e3);if(v<-30)return(0,C.localize)(0,null,b(new Date().getTime()+v*1e3,!1));if(!k&&v<30)return(0,C.localize)(1,null);let h;return v<O?(h=v,p?h===1?y?(0,C.localize)(2,null,h):(0,C.localize)(3,null,h):y?(0,C.localize)(4,null,h):(0,C.localize)(5,null,h):h===1?y?(0,C.localize)(6,null,h):(0,C.localize)(7,null,h):y?(0,C.localize)(8,null,h):(0,C.localize)(9,null,h)):v<f?(h=Math.floor(v/O),p?h===1?y?(0,C.localize)(10,null,h):(0,C.localize)(11,null,h):y?(0,C.localize)(12,null,h):(0,C.localize)(13,null,h):h===1?y?(0,C.localize)(14,null,h):(0,C.localize)(15,null,h):y?(0,C.localize)(16,null,h):(0,C.localize)(17,null,h)):v<R?(h=Math.floor(v/f),p?h===1?y?(0,C.localize)(18,null,h):(0,C.localize)(19,null,h):y?(0,C.localize)(20,null,h):(0,C.localize)(21,null,h):h===1?y?(0,C.localize)(22,null,h):(0,C.localize)(23,null,h):y?(0,C.localize)(24,null,h):(0,C.localize)(25,null,h)):v<A?(h=Math.floor(v/R),p?h===1?(0,C.localize)(26,null,h):(0,C.localize)(27,null,h):h===1?(0,C.localize)(28,null,h):(0,C.localize)(29,null,h)):v<m?(h=Math.floor(v/A),p?h===1?y?(0,C.localize)(30,null,h):(0,C.localize)(31,null,h):y?(0,C.localize)(32,null,h):(0,C.localize)(33,null,h):h===1?y?(0,C.localize)(34,null,h):(0,C.localize)(35,null,h):y?(0,C.localize)(36,null,h):(0,C.localize)(37,null,h)):v<E?(h=Math.floor(v/m),p?h===1?y?(0,C.localize)(38,null,h):(0,C.localize)(39,null,h):y?(0,C.localize)(40,null,h):(0,C.localize)(41,null,h):h===1?y?(0,C.localize)(42,null,h):(0,C.localize)(43,null,h):y?(0,C.localize)(44,null,h):(0,C.localize)(45,null,h)):(h=Math.floor(v/E),p?h===1?y?(0,C.localize)(46,null,h):(0,C.localize)(47,null,h):y?(0,C.localize)(48,null,h):(0,C.localize)(49,null,h):h===1?y?(0,C.localize)(50,null,h):(0,C.localize)(51,null,h):y?(0,C.localize)(52,null,h):(0,C.localize)(53,null,h))}e.$em=b;function L(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$fm=L}),define(De[179],Ce([10,11]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(De[41],Ce([1,0,19,17,179]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=void 0;function R(P,p){return p&&(P.stack||P.stacktrace)?f.localize(0,null,m(P),A(P.stack)||A(P.stacktrace)):m(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function m(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?f.localize(1,null,P.message):P.message||f.localize(2,null)}function E(P=null,p=!1){if(!P)return f.localize(3,null);if(Array.isArray(P)){const y=C.$Hb(P),k=E(y[0],p);return y.length>1?f.localize(4,null,k,y.length):k}if(O.$zf(P))return P;if(P.detail){const y=P.detail;if(y.error)return R(y.error,p);if(y.exception)return R(y.exception,p)}return P.stack?R(P,p):P.message?P.message:f.localize(5,null)}e.$Bi=E;function b(P){const p=P;return p instanceof Error&&Array.isArray(p.actions)}e.$Ci=b;function L(P,p){let y;return typeof P=="string"?y=new Error(P):y=P,y.actions=p,y}e.$Di=L}),define(De[180],Ce([10,11]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(De[12],Ce([1,0,180]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let O=!1,f=!1,R=!1,A=!1,m=!1,E=!1,b=!1,L=!1,P=!1,p=!1,y,k=e.$g,v=e.$g,h,o;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?l=e.$h.vscode.process:typeof process<"u"&&(l=process);const c=typeof l?.versions?.electron=="string",d=c&&l?.type==="renderer";if(typeof navigator=="object"&&!d)o=navigator.userAgent,O=o.indexOf("Windows")>=0,f=o.indexOf("Macintosh")>=0,L=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,p=o?.indexOf("Mobi")>=0,E=!0,y=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$g,k=y,v=navigator.language;else if(typeof l=="object"){O=l.platform==="win32",f=l.platform==="darwin",R=l.platform==="linux",A=R&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,b=c,P=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,k=e.$g;const S=l.env.VSCODE_NLS_CONFIG;if(S)try{const $=JSON.parse(S),g=$.availableLanguages["*"];y=$.locale,v=$.osLocale,k=g||e.$g,h=$._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var a;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(a||(e.Platform=a={}));function t(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let i=0;f?i=1:O?i=3:R&&(i=2),e.$j=O,e.$k=f,e.$l=R,e.$m=A,e.$n=m,e.$o=b,e.$p=E,e.$q=E&&typeof e.$h.importScripts=="function",e.$r=L,e.$s=p,e.$t=P,e.$u=i,e.$v=o,e.$w=k;var s;(function(S){function $(){return e.$w}S.value=$;function g(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}S.isDefaultVariant=g;function w(){return e.$w==="en"}S.isDefault=w})(s||(e.Language=s={})),e.$x=y,e.$y=v,e.$z=h,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const S=[];e.$h.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let w=0,D=S.length;w<D;w++){const T=S[w];if(T.id===g.data.vscodeScheduleAsyncWork){S.splice(w,1),T.callback();return}}});let $=0;return g=>{const w=++$;S.push({id:w,callback:g}),e.$h.postMessage({vscodeScheduleAsyncWork:w},"*")}}return S=>setTimeout(S)})();var n;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=f||L?2:O?1:3;let r=!0,u=!1;function I(){if(!u){u=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,r=new Uint16Array(S.buffer)[0]===(2<<8)+1}return r}e.$D=I,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(De[48],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let O;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.process<"u"){const f=C.$h.vscode.process;O={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return C.$j?"win32":C.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$dc=O.platform,e.$ec=O.arch}),define(De[16],Ce([1,0,48]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const O=65,f=97,R=90,A=122,m=46,E=47,b=92,L=58,P=63;class p extends Error{constructor(i,s,n){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const u=i.indexOf(".")!==-1?"property":"argument";let I=`The "${i}" ${u} ${r} of type ${s}`;I+=`. Received type ${typeof n}`,super(I),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,i){if(t===null||typeof t!="object")throw new p(i,"Object",t)}function k(t,i){if(typeof t!="string")throw new p(i,"string",t)}const v=C.$dc==="win32";function h(t){return t===E||t===b}function o(t){return t===E}function l(t){return t>=O&&t<=R||t>=f&&t<=A}function c(t,i,s,n){let r="",u=0,I=-1,S=0,$=0;for(let g=0;g<=t.length;++g){if(g<t.length)$=t.charCodeAt(g);else{if(n($))break;$=E}if(n($)){if(!(I===g-1||S===1))if(S===2){if(r.length<2||u!==2||r.charCodeAt(r.length-1)!==m||r.charCodeAt(r.length-2)!==m){if(r.length>2){const w=r.lastIndexOf(s);w===-1?(r="",u=0):(r=r.slice(0,w),u=r.length-1-r.lastIndexOf(s)),I=g,S=0;continue}else if(r.length!==0){r="",u=0,I=g,S=0;continue}}i&&(r+=r.length>0?`${s}..`:"..",u=2)}else r.length>0?r+=`${s}${t.slice(I+1,g)}`:r=t.slice(I+1,g),u=g-I-1;I=g,S=0}else $===m&&S!==-1?++S:S=-1}return r}function d(t,i){y(i,"pathObject");const s=i.dir||i.root,n=i.base||`${i.name||""}${i.ext||""}`;return s?s===i.root?`${s}${n}`:`${s}${t}${n}`:n}e.$fc={resolve(...t){let i="",s="",n=!1;for(let r=t.length-1;r>=-1;r--){let u;if(r>=0){if(u=t[r],k(u,"path"),u.length===0)continue}else i.length===0?u=C.cwd():(u=C.env[`=${i}`]||C.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==i.toLowerCase()&&u.charCodeAt(2)===b)&&(u=`${i}\\`));const I=u.length;let S=0,$="",g=!1;const w=u.charCodeAt(0);if(I===1)h(w)&&(S=1,g=!0);else if(h(w))if(g=!0,h(u.charCodeAt(1))){let D=2,T=D;for(;D<I&&!h(u.charCodeAt(D));)D++;if(D<I&&D!==T){const M=u.slice(T,D);for(T=D;D<I&&h(u.charCodeAt(D));)D++;if(D<I&&D!==T){for(T=D;D<I&&!h(u.charCodeAt(D));)D++;(D===I||D!==T)&&($=`\\\\${M}\\${u.slice(T,D)}`,S=D)}}}else S=1;else l(w)&&u.charCodeAt(1)===L&&($=u.slice(0,2),S=2,I>2&&h(u.charCodeAt(2))&&(g=!0,S=3));if($.length>0)if(i.length>0){if($.toLowerCase()!==i.toLowerCase())continue}else i=$;if(n){if(i.length>0)break}else if(s=`${u.slice(S)}\\${s}`,n=g,g&&i.length>0)break}return s=c(s,!n,"\\",h),n?`${i}\\${s}`:`${i}${s}`||"."},normalize(t){k(t,"path");const i=t.length;if(i===0)return".";let s=0,n,r=!1;const u=t.charCodeAt(0);if(i===1)return o(u)?"\\":t;if(h(u))if(r=!0,h(t.charCodeAt(1))){let S=2,$=S;for(;S<i&&!h(t.charCodeAt(S));)S++;if(S<i&&S!==$){const g=t.slice($,S);for($=S;S<i&&h(t.charCodeAt(S));)S++;if(S<i&&S!==$){for($=S;S<i&&!h(t.charCodeAt(S));)S++;if(S===i)return`\\\\${g}\\${t.slice($)}\\`;S!==$&&(n=`\\\\${g}\\${t.slice($,S)}`,s=S)}}}else s=1;else l(u)&&t.charCodeAt(1)===L&&(n=t.slice(0,2),s=2,i>2&&h(t.charCodeAt(2))&&(r=!0,s=3));let I=s<i?c(t.slice(s),!r,"\\",h):"";return I.length===0&&!r&&(I="."),I.length>0&&h(t.charCodeAt(i-1))&&(I+="\\"),n===void 0?r?`\\${I}`:I:r?`${n}\\${I}`:`${n}${I}`},isAbsolute(t){k(t,"path");const i=t.length;if(i===0)return!1;const s=t.charCodeAt(0);return h(s)||i>2&&l(s)&&t.charCodeAt(1)===L&&h(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let i,s;for(let u=0;u<t.length;++u){const I=t[u];k(I,"path"),I.length>0&&(i===void 0?i=s=I:i+=`\\${I}`)}if(i===void 0)return".";let n=!0,r=0;if(typeof s=="string"&&h(s.charCodeAt(0))){++r;const u=s.length;u>1&&h(s.charCodeAt(1))&&(++r,u>2&&(h(s.charCodeAt(2))?++r:n=!1))}if(n){for(;r<i.length&&h(i.charCodeAt(r));)r++;r>=2&&(i=`\\${i.slice(r)}`)}return e.$fc.normalize(i)},relative(t,i){if(k(t,"from"),k(i,"to"),t===i)return"";const s=e.$fc.resolve(t),n=e.$fc.resolve(i);if(s===n||(t=s.toLowerCase(),i=n.toLowerCase(),t===i))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===b;)r++;let u=t.length;for(;u-1>r&&t.charCodeAt(u-1)===b;)u--;const I=u-r;let S=0;for(;S<i.length&&i.charCodeAt(S)===b;)S++;let $=i.length;for(;$-1>S&&i.charCodeAt($-1)===b;)$--;const g=$-S,w=I<g?I:g;let D=-1,T=0;for(;T<w;T++){const F=t.charCodeAt(r+T);if(F!==i.charCodeAt(S+T))break;F===b&&(D=T)}if(T!==w){if(D===-1)return n}else{if(g>w){if(i.charCodeAt(S+T)===b)return n.slice(S+T+1);if(T===2)return n.slice(S+T)}I>w&&(t.charCodeAt(r+T)===b?D=T:T===2&&(D=3)),D===-1&&(D=0)}let M="";for(T=r+D+1;T<=u;++T)(T===u||t.charCodeAt(T)===b)&&(M+=M.length===0?"..":"\\..");return S+=D,M.length>0?`${M}${n.slice(S,$)}`:(n.charCodeAt(S)===b&&++S,n.slice(S,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const i=e.$fc.resolve(t);if(i.length<=2)return t;if(i.charCodeAt(0)===b){if(i.charCodeAt(1)===b){const s=i.charCodeAt(2);if(s!==P&&s!==m)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(l(i.charCodeAt(0))&&i.charCodeAt(1)===L&&i.charCodeAt(2)===b)return`\\\\?\\${i}`;return t},dirname(t){k(t,"path");const i=t.length;if(i===0)return".";let s=-1,n=0;const r=t.charCodeAt(0);if(i===1)return h(r)?t:".";if(h(r)){if(s=n=1,h(t.charCodeAt(1))){let S=2,$=S;for(;S<i&&!h(t.charCodeAt(S));)S++;if(S<i&&S!==$){for($=S;S<i&&h(t.charCodeAt(S));)S++;if(S<i&&S!==$){for($=S;S<i&&!h(t.charCodeAt(S));)S++;if(S===i)return t;S!==$&&(s=n=S+1)}}}}else l(r)&&t.charCodeAt(1)===L&&(s=i>2&&h(t.charCodeAt(2))?3:2,n=s);let u=-1,I=!0;for(let S=i-1;S>=n;--S)if(h(t.charCodeAt(S))){if(!I){u=S;break}}else I=!1;if(u===-1){if(s===-1)return".";u=s}return t.slice(0,u)},basename(t,i){i!==void 0&&k(i,"ext"),k(t,"path");let s=0,n=-1,r=!0,u;if(t.length>=2&&l(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(s=2),i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let I=i.length-1,S=-1;for(u=t.length-1;u>=s;--u){const $=t.charCodeAt(u);if(h($)){if(!r){s=u+1;break}}else S===-1&&(r=!1,S=u+1),I>=0&&($===i.charCodeAt(I)?--I===-1&&(n=u):(I=-1,n=S))}return s===n?n=S:n===-1&&(n=t.length),t.slice(s,n)}for(u=t.length-1;u>=s;--u)if(h(t.charCodeAt(u))){if(!r){s=u+1;break}}else n===-1&&(r=!1,n=u+1);return n===-1?"":t.slice(s,n)},extname(t){k(t,"path");let i=0,s=-1,n=0,r=-1,u=!0,I=0;t.length>=2&&t.charCodeAt(1)===L&&l(t.charCodeAt(0))&&(i=n=2);for(let S=t.length-1;S>=i;--S){const $=t.charCodeAt(S);if(h($)){if(!u){n=S+1;break}continue}r===-1&&(u=!1,r=S+1),$===m?s===-1?s=S:I!==1&&(I=1):s!==-1&&(I=-1)}return s===-1||r===-1||I===0||I===1&&s===r-1&&s===n+1?"":t.slice(s,r)},format:d.bind(null,"\\"),parse(t){k(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const s=t.length;let n=0,r=t.charCodeAt(0);if(s===1)return h(r)?(i.root=i.dir=t,i):(i.base=i.name=t,i);if(h(r)){if(n=1,h(t.charCodeAt(1))){let D=2,T=D;for(;D<s&&!h(t.charCodeAt(D));)D++;if(D<s&&D!==T){for(T=D;D<s&&h(t.charCodeAt(D));)D++;if(D<s&&D!==T){for(T=D;D<s&&!h(t.charCodeAt(D));)D++;D===s?n=D:D!==T&&(n=D+1)}}}}else if(l(r)&&t.charCodeAt(1)===L){if(s<=2)return i.root=i.dir=t,i;if(n=2,h(t.charCodeAt(2))){if(s===3)return i.root=i.dir=t,i;n=3}}n>0&&(i.root=t.slice(0,n));let u=-1,I=n,S=-1,$=!0,g=t.length-1,w=0;for(;g>=n;--g){if(r=t.charCodeAt(g),h(r)){if(!$){I=g+1;break}continue}S===-1&&($=!1,S=g+1),r===m?u===-1?u=g:w!==1&&(w=1):u!==-1&&(w=-1)}return S!==-1&&(u===-1||w===0||w===1&&u===S-1&&u===I+1?i.base=i.name=t.slice(I,S):(i.name=t.slice(I,u),i.base=t.slice(I,S),i.ext=t.slice(u,S))),I>0&&I!==n?i.dir=t.slice(0,I-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(v){const t=/\\/g;return()=>{const i=C.cwd().replace(t,"/");return i.slice(i.indexOf("/"))}}return()=>C.cwd()})();e.$gc={resolve(...t){let i="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const r=n>=0?t[n]:a();k(r,"path"),r.length!==0&&(i=`${r}/${i}`,s=r.charCodeAt(0)===E)}return i=c(i,!s,"/",o),s?`/${i}`:i.length>0?i:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===E,s=t.charCodeAt(t.length-1)===E;return t=c(t,!i,"/",o),t.length===0?i?"/":s?"./":".":(s&&(t+="/"),i?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let i;for(let s=0;s<t.length;++s){const n=t[s];k(n,"path"),n.length>0&&(i===void 0?i=n:i+=`/${n}`)}return i===void 0?".":e.$gc.normalize(i)},relative(t,i){if(k(t,"from"),k(i,"to"),t===i||(t=e.$gc.resolve(t),i=e.$gc.resolve(i),t===i))return"";const s=1,n=t.length,r=n-s,u=1,I=i.length-u,S=r<I?r:I;let $=-1,g=0;for(;g<S;g++){const D=t.charCodeAt(s+g);if(D!==i.charCodeAt(u+g))break;D===E&&($=g)}if(g===S)if(I>S){if(i.charCodeAt(u+g)===E)return i.slice(u+g+1);if(g===0)return i.slice(u+g)}else r>S&&(t.charCodeAt(s+g)===E?$=g:g===0&&($=0));let w="";for(g=s+$+1;g<=n;++g)(g===n||t.charCodeAt(g)===E)&&(w+=w.length===0?"..":"/..");return`${w}${i.slice(u+$)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===E;let s=-1,n=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===E){if(!n){s=r;break}}else n=!1;return s===-1?i?"/":".":i&&s===1?"//":t.slice(0,s)},basename(t,i){i!==void 0&&k(i,"ext"),k(t,"path");let s=0,n=-1,r=!0,u;if(i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let I=i.length-1,S=-1;for(u=t.length-1;u>=0;--u){const $=t.charCodeAt(u);if($===E){if(!r){s=u+1;break}}else S===-1&&(r=!1,S=u+1),I>=0&&($===i.charCodeAt(I)?--I===-1&&(n=u):(I=-1,n=S))}return s===n?n=S:n===-1&&(n=t.length),t.slice(s,n)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===E){if(!r){s=u+1;break}}else n===-1&&(r=!1,n=u+1);return n===-1?"":t.slice(s,n)},extname(t){k(t,"path");let i=-1,s=0,n=-1,r=!0,u=0;for(let I=t.length-1;I>=0;--I){const S=t.charCodeAt(I);if(S===E){if(!r){s=I+1;break}continue}n===-1&&(r=!1,n=I+1),S===m?i===-1?i=I:u!==1&&(u=1):i!==-1&&(u=-1)}return i===-1||n===-1||u===0||u===1&&i===n-1&&i===s+1?"":t.slice(i,n)},format:d.bind(null,"/"),parse(t){k(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const s=t.charCodeAt(0)===E;let n;s?(i.root="/",n=1):n=0;let r=-1,u=0,I=-1,S=!0,$=t.length-1,g=0;for(;$>=n;--$){const w=t.charCodeAt($);if(w===E){if(!S){u=$+1;break}continue}I===-1&&(S=!1,I=$+1),w===m?r===-1?r=$:g!==1&&(g=1):r!==-1&&(g=-1)}if(I!==-1){const w=u===0&&s?1:u;r===-1||g===0||g===1&&r===I-1&&r===u+1?i.base=i.name=t.slice(w,I):(i.name=t.slice(w,r),i.base=t.slice(w,I),i.ext=t.slice(r,I))}return u>0?i.dir=t.slice(0,u-1):s&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=v?e.$fc.normalize:e.$gc.normalize,e.$ic=v?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=v?e.$fc.join:e.$gc.join,e.$kc=v?e.$fc.resolve:e.$gc.resolve,e.$lc=v?e.$fc.relative:e.$gc.relative,e.$mc=v?e.$fc.dirname:e.$gc.dirname,e.$nc=v?e.$fc.basename:e.$gc.basename,e.$oc=v?e.$fc.extname:e.$gc.extname,e.$pc=v?e.$fc.format:e.$gc.format,e.$qc=v?e.$fc.parse:e.$gc.parse,e.$rc=v?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=v?e.$fc.sep:e.$gc.sep,e.$tc=v?e.$fc.delimiter:e.$gc.delimiter}),define(De[126],Ce([1,0,47,16]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=void 0;const f=new C.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),R=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(S,$,g=!1){const w=S||"",D=$||"",T=f.value.collator.compare(w,D);return f.value.collatorIsNumeric&&T===0&&w!==D?w<D?-1:1:T}e.$lq=m;function E(S,$){const g=R.value.collator;return S=S||"",$=$||"",d(g,S,$)}e.$mq=E;function b(S,$){const g=R.value.collator;return S=S||"",$=$||"",s(S,$)||d(g,S,$)}e.$nq=b;function L(S,$){const g=R.value.collator;return S=S||"",$=$||"",i(S,$)||d(g,S,$)}e.$oq=L;function P(S,$){return S=S||"",$=$||"",S===$?0:S<$?-1:1}e.$pq=P;function p(S,$){const[g,w]=l(S),[D,T]=l($);let M=f.value.collator.compare(w,T);if(M===0){if(f.value.collatorIsNumeric&&w!==T)return w<T?-1:1;if(M=f.value.collator.compare(g,D),f.value.collatorIsNumeric&&M===0&&g!==D)return g<D?-1:1}return M}e.$qq=p;function y(S,$){S=S||"",$=$||"";const g=c(S),w=c($),D=R.value.collator,T=A.value.collator;return d(T,g,w)||d(D,S,$)}e.$rq=y;function k(S,$){S=S||"",$=$||"";const g=c(S),w=c($),D=R.value.collator,T=A.value.collator;return d(T,g,w)||s(S,$)||d(D,S,$)}e.$sq=k;function v(S,$){S=S||"",$=$||"";const g=c(S),w=c($),D=R.value.collator,T=A.value.collator;return d(T,g,w)||i(S,$)||d(D,S,$)}e.$tq=v;function h(S,$){S=S||"",$=$||"";const g=c(S).toLowerCase(),w=c($).toLowerCase();return g!==w?g<w?-1:1:S!==$?S<$?-1:1:0}e.$uq=h;const o=/^(.*?)(\.([^.]*))?$/;function l(S,$=!1){const g=S?o.exec(S):[];let w=[g&&g[1]||"",g&&g[3]||""];return $&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function c(S){const $=S?o.exec(S):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function d(S,$,g){const w=S.compare($,g);return w!==0?w:$.length!==g.length?$.length<g.length?-1:1:0}function a(S){const $=S.charAt(0);return $.toLocaleUpperCase()!==$}function t(S){const $=S.charAt(0);return $.toLocaleLowerCase()!==$}function i(S,$){return a(S)&&t($)?-1:t(S)&&a($)?1:0}function s(S,$){return t(S)&&a($)?-1:a(S)&&t($)?1:0}function n(S,$,g=!1){return g||(S=S&&S.toLowerCase(),$=$&&$.toLowerCase()),S===$?0:S<$?-1:1}function r(S,$,g=!1){const w=S.split(O.sep),D=$.split(O.sep),T=w.length-1,M=D.length-1;let F,z;for(let j=0;;j++){if(F=T===j,z=M===j,F&&z)return m(w[j],D[j],g);if(F)return-1;if(z)return 1;const N=n(w[j],D[j],g);if(N!==0)return N}}e.$vq=r;function u(S,$,g){const w=S.toLowerCase(),D=$.toLowerCase(),T=I(S,$,g);if(T)return T;const M=w.endsWith(g),F=D.endsWith(g);if(M!==F)return M?-1:1;const z=m(w,D);return z!==0?z:w.localeCompare(D)}e.$wq=u;function I(S,$,g){const w=S.toLowerCase(),D=$.toLowerCase(),T=w.startsWith(g),M=D.startsWith(g);if(T!==M)return T?-1:1;if(T&&M){if(w.length<D.length)return-1;if(w.length>D.length)return 1}return 0}e.$xq=I}),define(De[33],Ce([1,0,16,12,15,17]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function A(u){return u===47||u===92}e.$Rf=A;function m(u){return u.replace(/[\\/]/g,C.$gc.sep)}e.$Sf=m;function E(u){return u.indexOf("/")===-1&&(u=m(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.$Tf=E;function b(u,I=C.$gc.sep){if(!u)return"";const S=u.length,$=u.charCodeAt(0);if(A($)){if(A(u.charCodeAt(1))&&!A(u.charCodeAt(2))){let w=3;const D=w;for(;w<S&&!A(u.charCodeAt(w));w++);if(D!==w&&!A(u.charCodeAt(w+1))){for(w+=1;w<S;w++)if(A(u.charCodeAt(w)))return u.slice(0,w+1).replace(/[\\/]/g,I)}}return I}else if(o($)&&u.charCodeAt(1)===58)return A(u.charCodeAt(2))?u.slice(0,2)+I:u.slice(0,2);let g=u.indexOf("://");if(g!==-1){for(g+=3;g<S;g++)if(A(u.charCodeAt(g)))return u.slice(0,g+1)}return""}e.$Uf=b;function L(u){if(!O.$j||!u||u.length<5)return!1;let I=u.charCodeAt(0);if(I!==92||(I=u.charCodeAt(1),I!==92))return!1;let S=2;const $=S;for(;S<u.length&&(I=u.charCodeAt(S),I!==92);S++);return!($===S||(I=u.charCodeAt(S+1),isNaN(I)||I===92))}e.$Vf=L;const P=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(u,I=O.$j){const S=I?P:p;return!(!u||u.length===0||/^\s+$/.test(u)||(S.lastIndex=0,S.test(u))||I&&y.test(u)||u==="."||u===".."||I&&u[u.length-1]==="."||I&&u.length!==u.trim().length||u.length>255)}e.$Wf=k;function v(u,I,S){const $=u===I;return!S||$?$:!u||!I?!1:(0,f.$3e)(u,I)}e.$Xf=v;function h(u,I,S,$=C.sep){if(u===I)return!0;if(!u||!I||I.length>u.length)return!1;if(S){if(!(0,f.$4e)(u,I))return!1;if(I.length===u.length)return!0;let w=I.length;return I.charAt(I.length-1)===$&&w--,u.charAt(w)===$}return I.charAt(I.length-1)!==$&&(I+=$),u.indexOf(I)===0}e.$Yf=h;function o(u){return u>=65&&u<=90||u>=97&&u<=122}e.$Zf=o;function l(u,I){return O.$j&&u.endsWith(":")&&(u+=C.sep),(0,C.$ic)(u)||(u=(0,C.$jc)(I,u)),u=(0,C.$hc)(u),O.$j?(u=(0,f.$Le)(u,C.sep),u.endsWith(":")&&(u+=C.sep)):(u=(0,f.$Le)(u,C.sep),u||(u=C.sep)),u}e.$1f=l;function c(u){const I=(0,C.$hc)(u);return O.$j?u.length>3?!1:d(I)&&(u.length===2||I.charCodeAt(2)===92):I===C.$gc.sep}e.$2f=c;function d(u,I=O.$j){return I?o(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.$3f=d;function a(u,I=O.$j){return d(u,I)?u[0]:void 0}e.$4f=a;function t(u,I,S){return I.length>u.length?-1:u===I?0:(S&&(u=u.toLowerCase(),I=I.toLowerCase()),u.indexOf(I))}e.$5f=t;function i(u){const I=u.split(":");let S,$,g;for(const w of I){const D=Number(w);(0,R.$Df)(D)?$===void 0?$=D:g===void 0&&(g=D):S=S?[S,w].join(":"):w}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:$!==void 0?$:void 0,column:g!==void 0?g:$!==void 0?1:void 0}}e.$6f=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(u,I,S=8){let $="";for(let w=0;w<S;w++){let D;w===0&&O.$j&&!I&&(S===3||S===4)?D=n:D=s,$+=D.charAt(Math.floor(Math.random()*D.length))}let g;return I?g=`${I}-${$}`:g=$,u?(0,C.$jc)(u,g):g}e.$7f=r}),define(De[127],Ce([1,0,126,121,52,16,12,15]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=void 0;const E=0,b=[E,[]];function L(q,K,me,te){if(!q||!K)return b;const G=q.length,J=K.length;if(G<J)return b;const le=q.toLowerCase();return P(K,me,J,q,le,G,te)}e.$yq=L;function P(q,K,me,te,G,J,le){const ie=[],ce=[];for(let Y=0;Y<me;Y++){const re=Y*J,X=re-J,_=Y>0,x=q[Y],pe=K[Y];for(let ae=0;ae<J;ae++){const fe=ae>0,ee=re+ae,de=ee-1,be=X+ae-1,Pe=fe?ie[de]:0,U=_&&fe?ie[be]:0,Q=_&&fe?ce[be]:0;let se;!U&&_?se=0:se=p(x,pe,te,G,ae,Q),se&&U+se>=Pe&&(le||_||G.startsWith(K,ae))?(ce[ee]=Q+1,ie[ee]=U+se):(ce[ee]=E,ie[ee]=Pe)}}const ye=[];let H=me-1,B=J-1;for(;H>=0&&B>=0;){const Y=H*J+B;ce[Y]===E||(ye.push(B),H--),B--}return[ie[me*J-1],ye.reverse()]}function p(q,K,me,te,G,J){let le=0;if(!y(K,te[G]))return le;if(le+=1,J>0&&(le+=J*5),q===me[G]&&(le+=1),G===0)le+=8;else{const ie=k(me.charCodeAt(G-1));ie?le+=ie:(0,O.$Hj)(me.charCodeAt(G))&&J===0&&(le+=2)}return le}function y(q,K){return q===K?!0:q==="/"||q==="\\"?K==="/"||K==="\\":!1}function k(q){switch(q){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function h(q,K,me=0,te=0){const G=K;return G.values&&G.values.length>1?o(q,G.values,me,te):l(q,K,me,te)}e.$zq=h;function o(q,K,me,te){let G=0;const J=[];for(const le of K){const[ie,ce]=l(q,le,me,te);if(typeof ie!="number")return v;G+=ie,J.push(...ce)}return[G,S(J)]}function l(q,K,me,te){const G=(0,O.$Qj)(K.original,K.originalLowercase,me,q,q.toLowerCase(),te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?[G[0],(0,O.$Nj)(G)]:v}const c=Object.freeze({score:0}),d=1<<18,a=1<<17,t=1<<16;function i(q,K,me,te){const G=te.values?te.values:[te];return(0,f.$Ei)({[te.normalized]:{values:G.map(le=>({value:le.normalized,expectContiguousMatch:le.expectContiguousMatch})),label:q,description:K,allowNonContiguousMatches:me}})}function s(q,K,me,te,G){if(!q||!K.normalized)return c;const J=te.getItemLabel(q);if(!J)return c;const le=te.getItemDescription(q),ie=i(J,le,me,K),ce=G[ie];if(ce)return ce;const ye=n(J,le,te.getItemPath(q),K,me);return G[ie]=ye,ye}e.$Aq=s;function n(q,K,me,te,G){const J=!me||!te.containsPathSeparator;return me&&(A.$l?te.pathNormalized===me:(0,m.$3e)(te.pathNormalized,me))?{score:d,labelMatch:[{start:0,end:q.length}],descriptionMatch:K?[{start:0,end:K.length}]:void 0}:te.values&&te.values.length>1?r(q,K,me,te.values,J,G):u(q,K,me,te,J,G)}function r(q,K,me,te,G,J){let le=0;const ie=[],ce=[];for(const ye of te){const{score:H,labelMatch:B,descriptionMatch:Y}=u(q,K,me,ye,G,J);if(H===E)return c;le+=H,B&&ie.push(...B),Y&&ce.push(...Y)}return{score:le,labelMatch:S(ie),descriptionMatch:S(ce)}}function u(q,K,me,te,G,J){if(G||!K){const[le,ie]=L(q,te.normalized,te.normalizedLowercase,J&&!te.expectContiguousMatch);if(le){const ce=(0,O.$Ej)(te.normalized,q);let ye;if(ce){ye=a;const H=Math.round(te.normalized.length/q.length*100);ye+=H}else ye=t;return{score:ye+le,labelMatch:ce||I(ie)}}}if(K){let le=K;me&&(le=`${K}${R.sep}`);const ie=le.length,ce=`${le}${q}`,[ye,H]=L(ce,te.normalized,te.normalizedLowercase,J&&!te.expectContiguousMatch);if(ye){const B=I(H),Y=[],re=[];return B.forEach(X=>{X.start<ie&&X.end>ie?(Y.push({start:0,end:X.end-ie}),re.push({start:X.start,end:ie})):X.start>=ie?Y.push({start:X.start-ie,end:X.end-ie}):re.push(X)}),{score:ye,labelMatch:Y,descriptionMatch:re}}}return c}function I(q){const K=[];if(!q)return K;let me;for(const te of q)me&&me.end===te?me.end+=1:(me={start:te,end:te+1},K.push(me));return K}function S(q){const K=q.sort((G,J)=>G.start-J.start),me=[];let te;for(const G of K)!te||!$(te,G)?(te=G,me.push(G)):(te.start=Math.min(te.start,G.start),te.end=Math.max(te.end,G.end));return me}function $(q,K){return!(q.end<K.start||K.end<q.start)}function g(q,K,me,te,G,J){const le=s(q,me,te,G,J),ie=s(K,me,te,G,J),ce=le.score,ye=ie.score;if((ce===d||ye===d)&&ce!==ye)return ce===d?-1:1;if(ce>t||ye>t){if(ce!==ye)return ce>ye?-1:1;if(ce<a&&ye<a){const x=D(le.labelMatch,ie.labelMatch);if(x!==0)return x}const X=G.getItemLabel(q)||"",_=G.getItemLabel(K)||"";if(X.length!==_.length)return X.length-_.length}if(ce!==ye)return ce>ye?-1:1;const H=Array.isArray(le.labelMatch)&&le.labelMatch.length>0,B=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(H&&!B)return-1;if(B&&!H)return 1;const Y=w(q,le,G),re=w(K,ie,G);return Y&&re&&Y!==re?re>Y?-1:1:T(q,K,me,G)}e.$Bq=g;function w(q,K,me){let te=-1,G=-1;if(K.descriptionMatch&&K.descriptionMatch.length?te=K.descriptionMatch[0].start:K.labelMatch&&K.labelMatch.length&&(te=K.labelMatch[0].start),K.labelMatch&&K.labelMatch.length){if(G=K.labelMatch[K.labelMatch.length-1].end,K.descriptionMatch&&K.descriptionMatch.length){const J=me.getItemDescription(q);J&&(G+=J.length)}}else K.descriptionMatch&&K.descriptionMatch.length&&(G=K.descriptionMatch[K.descriptionMatch.length-1].end);return G-te}function D(q,K){if(!q&&!K||(!q||!q.length)&&(!K||!K.length))return 0;if(!K||!K.length)return-1;if(!q||!q.length)return 1;const me=q[0].start,G=q[q.length-1].end-me,J=K[0].start,ie=K[K.length-1].end-J;return G===ie?0:ie<G?1:-1}function T(q,K,me,te){const G=te.getItemLabel(q)||"",J=te.getItemLabel(K)||"",le=te.getItemDescription(q),ie=te.getItemDescription(K),ce=G.length+(le?le.length:0),ye=J.length+(ie?ie.length:0);if(ce!==ye)return ce-ye;const H=te.getItemPath(q),B=te.getItemPath(K);return H&&B&&H.length!==B.length?H.length-B.length:G!==J?(0,C.$wq)(G,J,me.normalized):le&&ie&&le!==ie?(0,C.$wq)(le,ie,me.normalized):H&&B&&H!==B?(0,C.$wq)(H,B,me.normalized):0}function M(q){return q.startsWith('"')&&q.endsWith('"')}const F=" ";function z(q){typeof q!="string"&&(q="");const K=q.toLowerCase(),{pathNormalized:me,normalized:te,normalizedLowercase:G}=j(q),J=me.indexOf(R.sep)>=0,le=M(q);let ie;const ce=q.split(F);if(ce.length>1)for(const ye of ce){const H=M(ye),{pathNormalized:B,normalized:Y,normalizedLowercase:re}=j(ye);Y&&(ie||(ie=[]),ie.push({original:ye,originalLowercase:ye.toLowerCase(),pathNormalized:B,normalized:Y,normalizedLowercase:re,expectContiguousMatch:H}))}return{original:q,originalLowercase:K,pathNormalized:me,normalized:te,normalizedLowercase:G,values:ie,containsPathSeparator:J,expectContiguousMatch:le}}e.$Cq=z;function j(q){let K;A.$j?K=q.replace(/\//g,R.sep):K=q.replace(/\\/g,R.sep);const me=(0,m.$Ne)(K).replace(/\s|"/g,"");return{pathNormalized:K,normalized:me,normalizedLowercase:me.toLowerCase()}}function N(q){return Array.isArray(q)?z(q.map(K=>K.original).join(F)):z(q.original)}e.$Dq=N}),define(De[97],Ce([1,0,16]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=e.$Ur=e.$Tr=void 0,e.$Tr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const P=(0,C.$oc)(L),p=O[P.toLowerCase()];return p!==void 0?p:A(L)}e.$Ur=R;function A(L){const P=(0,C.$oc)(L);return f[P.toLowerCase()]}e.$Vr=A;function m(L){for(const P in f)if(f[P]===L)return P}e.$Wr=m;const E=/^(.+)\/(.+?)(;.+)?$/;function b(L,P){const p=E.exec(L);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:P?void 0:L}e.$Xr=b}),define(De[98],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.TerminateResponseCode=e.Source=void 0;var O;(function(m){m[m.stdout=0]="stdout",m[m.stderr=1]="stderr"})(O||(e.Source=O={}));var f;(function(m){m[m.Success=0]="Success",m[m.Unknown=1]="Unknown",m[m.AccessDenied=2]="AccessDenied",m[m.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function R(m,...E){const b=E.reduce((p,y)=>(p[y]=!0,p),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(m).filter(p=>!b[p]).forEach(p=>{for(let y=0;y<L.length;y++)if(p.search(L[y])!==-1){delete m[p];break}})}e.$Al=R;function A(m){m&&(delete m.DEBUG,C.$k&&delete m.DYLD_LIBRARY_PATH,C.$l&&delete m.LD_PRELOAD)}e.$Bl=A}),define(De[2],Ce([1,0,16,12]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function m(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!f.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(n,r){return!n&&!r?"file":n}function b(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==P&&(r=P+r):r=P;break}return r}const L="",P="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(r){return r instanceof y?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,u,I,S,$,g=!1){typeof r=="object"?(this.scheme=r.scheme||L,this.authority=r.authority||L,this.path=r.path||L,this.query=r.query||L,this.fragment=r.fragment||L):(this.scheme=E(r,g),this.authority=u||L,this.path=b(this.scheme,I||L),this.query=S||L,this.fragment=$||L,m(this,g))}get fsPath(){return d(this,!1)}with(r){if(!r)return this;let{scheme:u,authority:I,path:S,query:$,fragment:g}=r;return u===void 0?u=this.scheme:u===null&&(u=L),I===void 0?I=this.authority:I===null&&(I=L),S===void 0?S=this.path:S===null&&(S=L),$===void 0?$=this.query:$===null&&($=L),g===void 0?g=this.fragment:g===null&&(g=L),u===this.scheme&&I===this.authority&&S===this.path&&$===this.query&&g===this.fragment?this:new h(u,I,S,$,g)}static parse(r,u=!1){const I=p.exec(r);return I?new h(I[2]||L,s(I[4]||L),s(I[5]||L),s(I[7]||L),s(I[9]||L),u):new h(L,L,L,L,L)}static file(r){let u=L;if(O.$j&&(r=r.replace(/\\/g,P)),r[0]===P&&r[1]===P){const I=r.indexOf(P,2);I===-1?(u=r.substring(2),r=P):(u=r.substring(2,I),r=r.substring(I)||P)}return new h("file",u,r,L,L)}static from(r,u){return new h(r.scheme,r.authority,r.path,r.query,r.fragment,u)}static joinPath(r,...u){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let I;return O.$j&&r.scheme==="file"?I=y.file(C.$fc.join(d(r,!0),...u)).path:I=C.$gc.join(r.path,...u),r.with({path:I})}toString(r=!1){return a(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof y)return r;{const u=new h(r);return u._formatted=r.external??null,u._fsPath=r._sep===v?r.fsPath??null:null,u}}else return r}}e.URI=y;function k(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$vc=k;const v=O.$j?1:void 0;class h extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(r=!1){return r?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=v),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(n,r,u){let I,S=-1;for(let $=0;$<n.length;$++){const g=n.charCodeAt($);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||r&&g===47||u&&g===91||u&&g===93||u&&g===58)S!==-1&&(I+=encodeURIComponent(n.substring(S,$)),S=-1),I!==void 0&&(I+=n.charAt($));else{I===void 0&&(I=n.substr(0,$));const w=o[g];w!==void 0?(S!==-1&&(I+=encodeURIComponent(n.substring(S,$)),S=-1),I+=w):S===-1&&(S=$)}}return S!==-1&&(I+=encodeURIComponent(n.substring(S))),I!==void 0?I:n}function c(n){let r;for(let u=0;u<n.length;u++){const I=n.charCodeAt(u);I===35||I===63?(r===void 0&&(r=n.substr(0,u)),r+=o[I]):r!==void 0&&(r+=n[u])}return r!==void 0?r:n}function d(n,r){let u;return n.authority&&n.path.length>1&&n.scheme==="file"?u=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?u=n.path.substr(1):u=n.path[1].toLowerCase()+n.path.substr(2):u=n.path,O.$j&&(u=u.replace(/\//g,"\\")),u}e.$wc=d;function a(n,r){const u=r?c:l;let I="",{scheme:S,authority:$,path:g,query:w,fragment:D}=n;if(S&&(I+=S,I+=":"),($||S==="file")&&(I+=P,I+=P),$){let T=$.indexOf("@");if(T!==-1){const M=$.substr(0,T);$=$.substr(T+1),T=M.lastIndexOf(":"),T===-1?I+=u(M,!1,!1):(I+=u(M.substr(0,T),!1,!1),I+=":",I+=u(M.substr(T+1),!1,!0)),I+="@"}$=$.toLowerCase(),T=$.lastIndexOf(":"),T===-1?I+=u($,!1,!0):(I+=u($.substr(0,T),!1,!0),I+=$.substr(T))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const T=g.charCodeAt(1);T>=65&&T<=90&&(g=`/${String.fromCharCode(T+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const T=g.charCodeAt(0);T>=65&&T<=90&&(g=`${String.fromCharCode(T+32)}:${g.substr(2)}`)}I+=u(g,!0,!1)}return w&&(I+="?",I+=u(w,!1,!1)),D&&(I+="#",I+=r?D:l(D,!1,!1)),I}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(i)?n.replace(i,r=>t(r)):n}}),define(De[181],Ce([1,0,2]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$4p=e.$3p=e.$2p=void 0;function O(b){const L=b;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.$2p=O;function f(b){const L=[];let P;try{const p=JSON.parse(b.arguments),y=p[p.length-1];y&&y.__$stack&&(p.pop(),P=y.__$stack),L.push(...p)}catch{L.push("Unable to log remote console arguments",b.arguments)}return{args:L,stack:P}}e.$3p=f;function R(b){if(typeof b!="string")return R(f(b).stack);const L=b;if(L){const P=A(L),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(p&&p.length===4)return{uri:C.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$4p=R;function A(b){if(!b)return b;const L=b.indexOf(`
`);return L===-1?b:b.substring(0,L)}function m(b,L){const{args:P,stack:p}=f(b),y=typeof P[0]=="string"&&P.length===1;let k=A(p);k&&(k=`(${k.trim()})`);let v=[];if(typeof P[0]=="string"?k&&y?v=[`%c[${L}] %c${P[0]} %c${k}`,E("blue"),E(""),E("grey")]:v=[`%c[${L}] %c${P[0]}`,E("blue"),E(""),...P.slice(1)]:v=[`%c[${L}]%`,E("blue"),...P],k&&!y&&v.push(k),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,v)}e.log=m;function E(b){return`color: ${b}`}}),define(De[62],Ce([1,0,22,2]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function f(E){return JSON.stringify(E,A)}e.$lh=f;function R(E){let b=JSON.parse(E);return b=m(b),b}e.$mh=R;function A(E,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function m(E,b=0){if(!E||b>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return O.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof C.$ce||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let L=0;L<E.length;++L)E[L]=m(E[L],b+1);else for(const L in E)Object.hasOwnProperty.call(E,L)&&(E[L]=m(E[L],b+1))}return E}e.$nh=m}),define(De[18],Ce([1,0,9,12,2]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var R;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$8f="vscode-tkn",e.$9f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,P,p){this.a[L]=P,this.b[L]=p}setConnectionToken(L,P){this.c[L]=P}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(h){return C.$1(h),L}const P=L.authority;let p=this.a[P];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const y=this.b[P],k=this.c[P];let v=`path=${encodeURIComponent(L.path)}`;return typeof k=="string"&&(v+=`&${e.$9f}=${encodeURIComponent(k)}`),f.URI.from({scheme:O.$p?this.d:R.vscodeRemoteResource,authority:`${p}:${y}`,path:this.f,query:v})}}e.$0f=new A,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class m{static{this.a=e.$cg}asBrowserUri(L){const P=this.b(L,$e);return this.uriToBrowserUri(P)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.$0f.rewrite(L):L.scheme===R.file&&(O.$n||O.$q&&O.$h.origin===`${R.vscodeFileResource}://${m.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||m.a,query:null,fragment:null}):L}asFileUri(L){const P=this.b(L,$e);return this.uriToFileUri(P)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==m.a?L.authority:null,query:null,fragment:null}):L}b(L,P){return f.URI.isUri(L)?L:f.URI.parse(P.toUrl(L))}}e.$dg=new m;var E;(function(b){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(L.get("3"));const P="vscode-coi";function p(k){let v;typeof k=="string"?v=new URL(k).searchParams:k instanceof URL?v=k.searchParams:f.URI.isUri(k)&&(v=new URL(k.toString(!0)).searchParams);const h=v?.get(P);if(h)return L.get(h)}b.getHeadersFromQuery=p;function y(k,v,h){if(!globalThis.crossOriginIsolated)return;const o=v&&h?"3":h?"2":"1";k instanceof URLSearchParams?k.set(P,o):k[P]=o}b.addSearchParam=y})(E||(e.COI=E={}))}),define(De[182],Ce([1,0,156,18,12,2]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=void 0;class A{constructor(p,y,k){this.id=p,this.dependencies=y,this.callback=k}}class m{static{this.INSTANCE=new m}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,y,k)=>{typeof p!="string"&&(k=y,y=p,p=null),(typeof y!="object"||!Array.isArray(y))&&(k=y,y=null),this.c.push(new A(p,y,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const y=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!y)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(p){return new Promise((y,k)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const h=()=>{v.removeEventListener("load",o),v.removeEventListener("error",l)},o=c=>{h(),y(this.c.pop())},l=c=>{h(),k(c)};v.addEventListener("load",o),v.addEventListener("error",l),this.f&&(p=this.f.createScriptURL(p)),v.setAttribute("src",p),document.getElementsByTagName("head")[0].appendChild(v)})}i(p){return new Promise((y,k)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),y(this.c.pop())}catch(v){k(v)}})}async j(p){try{const y=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,h=R.URI.parse(p).fsPath,o=y.readFileSync(h).toString(),l=v.wrap(o.replace(/^#!.*/,""));return new k.Script(l).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const E=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function L(P,p,y){if(C.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[P]&&(P=b[P]);const k=`${P}/${p}`;if(E.has(k))return E.get(k);let v;if(/^\w[\w\d+.-]*:\/\//.test(k))v=k;else{const c=`${y&&!f.$p?O.$ag:O.$_f}/${k}`;v=O.$dg.asBrowserUri(c).toString(!0)}const h=m.INSTANCE.load(v);return E.set(k,h),h}else return await new Promise((k,v)=>{$e([P],k,v)})}e.$zC=L}),define(De[23],Ce([1,0,33,18,16,12,15,2]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function E(y){return(0,m.$wc)(y,!0)}e.$kg=E;class b{constructor(k){this.a=k}compare(k,v,h=!1){return k===v?0:(0,A.$Ve)(this.getComparisonKey(k,h),this.getComparisonKey(v,h))}isEqual(k,v,h=!1){return k===v?!0:!k||!v?!1:this.getComparisonKey(k,h)===this.getComparisonKey(v,h)}getComparisonKey(k,v=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,v,h=!1){if(k.scheme===v.scheme){if(k.scheme===O.Schemas.file)return C.$Yf(E(k),E(v),this.a(k))&&k.query===v.query&&(h||k.fragment===v.fragment);if((0,e.$Bg)(k.authority,v.authority))return C.$Yf(k.path,v.path,this.a(k),"/")&&k.query===v.query&&(h||k.fragment===v.fragment)}return!1}joinPath(k,...v){return m.URI.joinPath(k,...v)}basenameOrAuthority(k){return(0,e.$tg)(k)||k.authority}basename(k){return f.$gc.basename(k.path)}extname(k){return f.$gc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let v;return k.scheme===O.Schemas.file?v=m.URI.file(f.$mc(E(k))).path:(v=f.$gc.dirname(k.path),k.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),v="/")),k.with({path:v})}normalizePath(k){if(!k.path.length)return k;let v;return k.scheme===O.Schemas.file?v=m.URI.file(f.$hc(E(k))).path:v=f.$gc.normalize(k.path),k.with({path:v})}relativePath(k,v){if(k.scheme!==v.scheme||!(0,e.$Bg)(k.authority,v.authority))return;if(k.scheme===O.Schemas.file){const l=f.$lc(E(k),E(v));return R.$j?C.$Sf(l):l}let h=k.path||"/";const o=v.path||"/";if(this.a(k)){let l=0;for(const c=Math.min(h.length,o.length);l<c&&!(h.charCodeAt(l)!==o.charCodeAt(l)&&h.charAt(l).toLowerCase()!==o.charAt(l).toLowerCase());l++);h=o.substr(0,l)+h.substr(l)}return f.$gc.relative(h,o)}resolvePath(k,v){if(k.scheme===O.Schemas.file){const h=m.URI.file(f.$kc(E(k),v));return k.with({authority:h.authority,path:h.path})}return v=C.$Tf(v),k.with({path:f.$gc.resolve(k.path,v)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,v){return k===v||k!==void 0&&v!==void 0&&(0,A.$3e)(k,v)}hasTrailingPathSeparator(k,v=f.sep){if(k.scheme===O.Schemas.file){const h=E(k);return h.length>C.$Uf(h).length&&h[h.length-1]===v}else{const h=k.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,v=f.sep){return(0,e.$Cg)(k,v)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,v=f.sep){let h=!1;if(k.scheme===O.Schemas.file){const o=E(k);h=o!==void 0&&o.length===C.$Uf(o).length&&o[o.length-1]===v}else{v="/";const o=k.path;h=o.length===1&&o.charCodeAt(o.length-1)===47}return!h&&!(0,e.$Cg)(k,v)?k.with({path:k.path+"/"}):k}}e.$lg=b,e.$mg=new b(()=>!1),e.$ng=new b(y=>y.scheme===O.Schemas.file?!R.$l:!0),e.$og=new b(y=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function L(y,k){const v=[];for(let h=0;h<y.length;h++){const o=k(y[h]);y.some((l,c)=>c===h?!1:(0,e.$qg)(o,k(l)))||v.push(y[h])}return v}e.$Fg=L;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function k(v){const h=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(c=>{const[d,a]=c.split(":");d&&a&&h.set(d,a)});const l=v.path.substring(0,v.path.indexOf(";"));return l&&h.set(y.META_DATA_MIME,l),h}y.parseMetaData=k})(P||(e.DataUri=P={}));function p(y,k,v){if(k){let h=y.path;return h&&h[0]!==f.$gc.sep&&(h=f.$gc.sep+h),y.with({scheme:v,authority:k,path:h})}return y.with({scheme:v})}e.$Gg=p}),define(De[8],Ce([1,0,21,9,4,3,23,12,160]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.Promises=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function b(Y){return!!Y&&typeof Y.then=="function"}e.$Hg=b;function L(Y){const re=new C.$Yd,X=Y(re.token),_=new Promise((x,pe)=>{const ae=re.token.onCancellationRequested(()=>{ae.dispose(),re.dispose(),pe(new O.$5)});Promise.resolve(X).then(fe=>{ae.dispose(),re.dispose(),x(fe)},fe=>{ae.dispose(),re.dispose(),pe(fe)})});return new class{cancel(){re.cancel()}then(x,pe){return _.then(x,pe)}catch(x){return this.then(void 0,x)}finally(x){return _.finally(x)}}}e.$Ig=L;function P(Y,re,X){return new Promise((_,x)=>{const pe=re.onCancellationRequested(()=>{pe.dispose(),_(X)});Y.then(_,x).finally(()=>pe.dispose())})}e.$Jg=P;function p(Y,re){return new Promise((X,_)=>{const x=re.onCancellationRequested(()=>{x.dispose(),_(new O.$5)});Y.then(X,_).finally(()=>x.dispose())})}e.$Kg=p;async function y(Y){let re=-1;const X=Y.map((_,x)=>_.then(pe=>(re=x,pe)));try{return await Promise.race(X)}finally{Y.forEach((_,x)=>{x!==re&&_.cancel()})}}e.$Lg=y;function k(Y,re,X){let _;const x=setTimeout(()=>{_?.(void 0),X?.()},re);return Promise.race([Y.finally(()=>clearTimeout(x)),new Promise(pe=>_=pe)])}e.$Mg=k;function v(Y){return new Promise((re,X)=>{const _=Y();b(_)?_.then(re,X):re(_)})}e.$Ng=v;class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(re){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=re,!this.b){const X=()=>{if(this.b=null,this.f)return;const _=this.queue(this.d);return this.d=null,_};this.b=new Promise(_=>{this.a.then(X,X).then(_)})}return new Promise((X,_)=>{this.b.then(X,_)})}return this.a=re(),new Promise((X,_)=>{this.a.then(x=>{this.a=null,X(x)},x=>{this.a=null,_(x)})})}dispose(){this.f=!0}}e.$Og=h;class o{constructor(){this.a=Promise.resolve(null)}queue(re){return this.a=this.a.then(()=>re(),()=>re())}}e.$Pg=o;class l{constructor(){this.a=new Map}queue(re,X){const x=(this.a.get(re)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.a.get(re)===x&&this.a.delete(re)});return this.a.set(re,x),x}}e.$Qg=l;const c=(Y,re)=>{let X=!0;const _=setTimeout(()=>{X=!1,re()},Y);return{isTriggered:()=>X,dispose:()=>{clearTimeout(_),X=!1}}},d=Y=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,Y())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};class a{constructor(re){this.defaultDelay=re,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(re,X=this.defaultDelay){this.g=re,this.h(),this.b||(this.b=new Promise((x,pe)=>{this.d=x,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const x=this.g;return this.g=null,x()}}));const _=()=>{this.a=null,this.d?.(null)};return this.a=X===E.$Ld?d(_):c(X,_),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=a;class t{constructor(re){this.a=new a(re),this.b=new h}trigger(re,X){return this.a.trigger(()=>this.b.queue(re),X)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=t;class i{constructor(){this.a=!1,this.b=new Promise((re,X)=>{this.d=re})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=i;class s extends i{constructor(re){super(),this.f=setTimeout(()=>this.open(),re)}open(){clearTimeout(this.f),super.open()}}e.$Ug=s;function n(Y,re){return re?new Promise((X,_)=>{const x=setTimeout(()=>{pe.dispose(),X()},Y),pe=re.onCancellationRequested(()=>{clearTimeout(x),pe.dispose(),_(new O.$5)})}):L(X=>n(Y,X))}e.$Vg=n;function r(Y,re=0,X){const _=setTimeout(()=>{Y(),X&&x.dispose()},re),x=(0,R.$Qc)(()=>{clearTimeout(_),X?.deleteAndLeak(x)});return X?.add(x),x}e.$Wg=r;function u(Y){const re=[];let X=0;const _=Y.length;function x(){return X<_?Y[X++]():null}function pe(ae){ae!=null&&re.push(ae);const fe=x();return fe?fe.then(pe):Promise.resolve(re)}return Promise.resolve(null).then(pe)}e.$Xg=u;function I(Y,re=_=>!!_,X=null){let _=0;const x=Y.length,pe=()=>{if(_>=x)return Promise.resolve(X);const ae=Y[_++];return Promise.resolve(ae()).then(ee=>re(ee)?Promise.resolve(ee):pe())};return pe()}e.$Yg=I;function S(Y,re=_=>!!_,X=null){if(Y.length===0)return Promise.resolve(X);let _=Y.length;const x=()=>{_=-1;for(const pe of Y)pe.cancel?.()};return new Promise((pe,ae)=>{for(const fe of Y)fe.then(ee=>{--_>=0&&re(ee)?(x(),pe(ee)):_===0&&pe(X)}).catch(ee=>{--_>=0&&(x(),ae(ee))})})}e.$Zg=S;class ${constructor(re){this.a=0,this.d=re,this.f=[],this.b=0,this.g=new f.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(re){return this.a++,new Promise((X,_)=>{this.f.push({factory:re,c:X,e:_}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const re=this.f.shift();this.b++;const X=re.factory();X.then(re.c,re.e),X.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=$;class g extends ${constructor(){super(1)}}e.$2g=g;class w{constructor(){this.a=new me,this.b=0}queue(re){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,re())):this.a.run(this.b++,re())}}e.$3g=w;class D{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const re=new J;return this.b.add(re),re.p}g(){for(const[,re]of this.a)if(re.size>0)return!1;return!0}queueFor(re,X=A.$mg){const _=X.getComparisonKey(re);let x=this.a.get(_);if(!x){x=new g;const pe=this.f++,ae=f.Event.once(x.onDrained)(()=>{x?.dispose(),this.a.delete(_),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$1c),this.d.set(pe,ae),this.a.set(_,x)}return x}h(){this.g()&&this.j()}j(){for(const re of this.b)re.complete();this.b.clear()}dispose(){for(const[,re]of this.a)re.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=D;class T{constructor(re,X){this.a=-1,typeof re=="function"&&typeof X=="number"&&this.setIfNotSet(re,X)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(re,X){this.cancel(),this.a=setTimeout(()=>{this.a=-1,re()},X)}setIfNotSet(re,X){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,re()},X))}}e.$5g=T;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(re,X){this.cancel(),this.a=setInterval(()=>{re()},X)}}e.$6g=M;class F{constructor(re,X){this.b=-1,this.a=re,this.d=X,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(re=this.d){this.cancel(),this.b=setTimeout(this.f,re)}get delay(){return this.d}set delay(re){this.d=re}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=F;class z{constructor(re,X){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.a=re,this.b=X,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(re=this.b){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(re/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=z;class j extends F{constructor(re,X){super(re,X),this.j=[]}work(re){this.j.push(re),this.isScheduled()||this.schedule()}h(){const re=this.j;this.j=[],this.a?.(re)}dispose(){this.j=[],super.dispose()}}e.$9g=j;class N extends R.$Sc{constructor(re,X){super(),this.g=re,this.h=X,this.a=[],this.b=this.B(new R.$Tc),this.f=!1}get pending(){return this.a.length}work(re){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+re.length>this.g.maxBufferedWork)return!1}else if(this.pending+re.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const X of re)this.a.push(X);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$$g=Y=>{(0,m.$B)(()=>{if(re)return;const X=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,X-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$$g=(Y,re)=>{const X=requestIdleCallback(Y,typeof re=="number"?{timeout:re}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(X))}}}}();class q{constructor(re){this.d=!1,this.a=()=>{try{this.f=re()}catch(X){this.g=X}finally{this.d=!0}},this.b=(0,e.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$_g=q;async function K(Y,re,X){let _;for(let x=0;x<X;x++)try{return await Y()}catch(pe){_=pe,await n(re)}throw _}e.$ah=K;class me{isRunning(re){return typeof re=="number"?this.a?.taskId===re:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(re,X,_){return this.a={taskId:re,cancel:()=>_?.(),promise:X},X.then(()=>this.d(re),()=>this.d(re)),X}d(re){this.a&&re===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const re=this.b;this.b=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}queue(re){if(this.b)this.b.run=re;else{let X,_;const x=new Promise((pe,ae)=>{X=pe,_=ae});this.b={run:re,promise:x,promiseResolve:X,promiseReject:_}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$bh=me;class te{constructor(re,X=()=>Date.now()){this.d=re,this.f=X,this.a=0,this.b=0}increment(){const re=this.f();return re-this.a>this.d&&(this.a=re,this.b=0),this.b++,this.b}}e.$ch=te;var G;(function(Y){Y[Y.Resolved=0]="Resolved",Y[Y.Rejected=1]="Rejected"})(G||(G={}));class J{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((re,X)=>{this.a=re,this.b=X})}complete(re){return new Promise(X=>{this.a(re),this.d={outcome:0,value:re},X()})}error(re){return new Promise(X=>{this.b(re),this.d={outcome:1,value:re},X()})}cancel(){return this.error(new O.$5)}}e.$dh=J;var le;(function(Y){async function re(_){let x;const pe=await Promise.all(_.map(ae=>ae.then(fe=>fe,fe=>{x||(x=fe)})));if(typeof x<"u")throw x;return pe}Y.settled=re;function X(_){return new Promise(async(x,pe)=>{try{await _(x,pe)}catch(ae){pe(ae)}})}Y.withAsyncBody=X})(le||(e.Promises=le={}));var ie;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(ie||(ie={}));class ce{static fromArray(re){return new ce(X=>{X.emitMany(re)})}static fromPromise(re){return new ce(async X=>{X.emitMany(await re)})}static fromPromises(re){return new ce(async X=>{await Promise.all(re.map(async _=>X.emitOne(await _)))})}static merge(re){return new ce(async X=>{await Promise.all(re.map(async _=>{for await(const x of _)X.emitOne(x)}))})}static{this.EMPTY=ce.fromArray([])}constructor(re){this.a=0,this.b=[],this.d=null,this.f=new f.$Od,queueMicrotask(async()=>{const X={emitOne:_=>this.g(_),emitMany:_=>this.h(_),reject:_=>this.k(_)};try{await Promise.resolve(re(X)),this.j()}catch(_){this.k(_)}finally{X.emitOne=void 0,X.emitMany=void 0,X.reject=void 0}})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(re<this.b.length)return{done:!1,value:this.b[re++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(re,X){return new ce(async _=>{for await(const x of re)_.emitOne(X(x))})}map(re){return ce.map(this,re)}static filter(re,X){return new ce(async _=>{for await(const x of re)X(x)&&_.emitOne(x)})}filter(re){return ce.filter(this,re)}static coalesce(re){return ce.filter(re,X=>!!X)}coalesce(){return ce.coalesce(this)}static async toPromise(re){const X=[];for await(const _ of re)X.push(_);return X}toPromise(){return ce.toPromise(this)}g(re){this.a===0&&(this.b.push(re),this.f.fire())}h(re){this.a===0&&(this.b=this.b.concat(re),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(re){this.a===0&&(this.a=2,this.d=re,this.f.fire())}}e.$eh=ce;class ye extends ce{constructor(re,X){super(X),this.l=re}cancel(){this.l.cancel()}}e.$fh=ye;function H(Y){const re=new C.$Yd,X=Y(re.token);return new ye(re,async _=>{const x=re.token.onCancellationRequested(()=>{x.dispose(),re.dispose(),_.reject(new O.$5)});try{for await(const pe of X){if(re.token.isCancellationRequested)return;_.emitOne(pe)}x.dispose(),re.dispose()}catch(pe){x.dispose(),re.dispose(),_.reject(pe)}})}e.$gh=H;class B{constructor(){this.a=new J,this.b=new ce(_=>{if(re){_.reject(re);return}return X&&_.emitMany(X),this.d=x=>_.reject(x),this.f=x=>_.emitOne(x),this.a.p});let re,X;this.f=_=>{X||(X=[]),X.push(_)},this.d=_=>{re||(re=_)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(re){this.d(re),this.a.complete()}emitOne(re){this.f(re)}}e.$hh=B}),define(De[36],Ce([1,0,19,8,33,28,16,12,15]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=void 0;function b(){return Object.create(null)}e.$sj=b,e.$tj="**",e.$uj="/";const L="[/\\\\]",P="[^/\\\\]",p=/\//g;function y(me,te){switch(me){case 0:return"";case 1:return`${P}*?`;default:return`(?:${L}|${P}+${L}${te?`|${L}${P}+`:""})*?`}}function k(me,te){if(!me)return[];const G=[];let J=!1,le=!1,ie="";for(const ce of me){switch(ce){case te:if(!J&&!le){G.push(ie),ie="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":le=!0;break;case"]":le=!1;break}ie+=ce}return ie&&G.push(ie),G}e.$vj=k;function v(me){if(!me)return"";let te="";const G=k(me,e.$uj);if(G.every(J=>J===e.$tj))te=".*";else{let J=!1;G.forEach((le,ie)=>{if(le===e.$tj){if(J)return;te+=y(2,ie===G.length-1)}else{let ce=!1,ye="",H=!1,B="";for(const Y of le){if(Y!=="}"&&ce){ye+=Y;continue}if(H&&(Y!=="]"||!B)){let re;Y==="-"?re=Y:(Y==="^"||Y==="!")&&!B?re="^":Y===e.$uj?re="":re=(0,E.$Ge)(Y),B+=re;continue}switch(Y){case"{":ce=!0;continue;case"[":H=!0;continue;case"}":{const X=`(?:${k(ye,",").map(_=>v(_)).join("|")})`;te+=X,ce=!1,ye="";break}case"]":{te+="["+B+"]",H=!1,B="";break}case"?":te+=P;continue;case"*":te+=y(1);continue;default:te+=(0,E.$Ge)(Y)}}ie<G.length-1&&(G[ie+1]!==e.$tj||ie+2<G.length)&&(te+=L)}J=le===e.$tj})}return te}const h=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),i=function(){return!1},s=function(){return null};function n(me,te){if(!me)return s;let G;typeof me!="string"?G=me.pattern:G=me,G=G.trim();const J=`${G}_${!!te.trimForExclusions}`;let le=t.get(J);if(le)return r(le,me);let ie;return h.test(G)?le=I(G.substr(4),G):(ie=o.exec(u(G,te)))?le=S(ie[1],G):(te.trimForExclusions?c:l).test(G)?le=$(G,te):(ie=d.exec(u(G,te)))?le=g(ie[1].substr(1),G,!0):(ie=a.exec(u(G,te)))?le=g(ie[1],G,!1):le=w(G),t.set(J,le),r(le,me)}function r(me,te){if(typeof te=="string")return me;const G=function(J,le){return(0,f.$Yf)(J,te.base,!m.$l)?me((0,E.$Ke)(J.substr(te.base.length),A.sep),le):null};return G.allBasenames=me.allBasenames,G.allPaths=me.allPaths,G.basenames=me.basenames,G.patterns=me.patterns,G}function u(me,te){return te.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function I(me,te){return function(G,J){return typeof G=="string"&&G.endsWith(me)?te:null}}function S(me,te){const G=`/${me}`,J=`\\${me}`,le=function(ce,ye){return typeof ce!="string"?null:ye?ye===me?te:null:ce===me||ce.endsWith(G)||ce.endsWith(J)?te:null},ie=[me];return le.basenames=ie,le.patterns=[te],le.allBasenames=ie,le}function $(me,te){const G=q(me.slice(1,-1).split(",").map(ye=>n(ye,te)).filter(ye=>ye!==s),me),J=G.length;if(!J)return s;if(J===1)return G[0];const le=function(ye,H){for(let B=0,Y=G.length;B<Y;B++)if(G[B](ye,H))return me;return null},ie=G.find(ye=>!!ye.allBasenames);ie&&(le.allBasenames=ie.allBasenames);const ce=G.reduce((ye,H)=>H.allPaths?ye.concat(H.allPaths):ye,[]);return ce.length&&(le.allPaths=ce),le}function g(me,te,G){const J=A.sep===A.$gc.sep,le=J?me:me.replace(p,A.sep),ie=A.sep+le,ce=A.$gc.sep+me;let ye;return G?ye=function(H,B){return typeof H=="string"&&(H===le||H.endsWith(ie)||!J&&(H===me||H.endsWith(ce)))?te:null}:ye=function(H,B){return typeof H=="string"&&(H===le||!J&&H===me)?te:null},ye.allPaths=[(G?"*/":"./")+me],ye}function w(me){try{const te=new RegExp(`^${v(me)}$`);return function(G){return te.lastIndex=0,typeof G=="string"&&te.test(G)?me:null}}catch{return s}}function D(me,te,G){return!me||typeof te!="string"?!1:T(me)(te,void 0,G)}e.$wj=D;function T(me,te={}){if(!me)return i;if(typeof me=="string"||M(me)){const G=n(me,te);if(G===s)return i;const J=function(le,ie){return!!G(le,ie)};return G.allBasenames&&(J.allBasenames=G.allBasenames),G.allPaths&&(J.allPaths=G.allPaths),J}return j(me,te)}e.$xj=T;function M(me){const te=me;return te?typeof te.base=="string"&&typeof te.pattern=="string":!1}e.$yj=M;function F(me){return me.allBasenames||[]}e.$zj=F;function z(me){return me.allPaths||[]}e.$Aj=z;function j(me,te){const G=q(Object.getOwnPropertyNames(me).map(ye=>N(ye,me[ye],te)).filter(ye=>ye!==s)),J=G.length;if(!J)return s;if(!G.some(ye=>!!ye.requiresSiblings)){if(J===1)return G[0];const ye=function(Y,re){let X;for(let _=0,x=G.length;_<x;_++){const pe=G[_](Y,re);if(typeof pe=="string")return pe;(0,O.$Hg)(pe)&&(X||(X=[]),X.push(pe))}return X?(async()=>{for(const _ of X){const x=await _;if(typeof x=="string")return x}return null})():null},H=G.find(Y=>!!Y.allBasenames);H&&(ye.allBasenames=H.allBasenames);const B=G.reduce((Y,re)=>re.allPaths?Y.concat(re.allPaths):Y,[]);return B.length&&(ye.allPaths=B),ye}const le=function(ye,H,B){let Y,re;for(let X=0,_=G.length;X<_;X++){const x=G[X];x.requiresSiblings&&B&&(H||(H=(0,A.$nc)(ye)),Y||(Y=H.substr(0,H.length-(0,A.$oc)(ye).length)));const pe=x(ye,H,Y,B);if(typeof pe=="string")return pe;(0,O.$Hg)(pe)&&(re||(re=[]),re.push(pe))}return re?(async()=>{for(const X of re){const _=await X;if(typeof _=="string")return _}return null})():null},ie=G.find(ye=>!!ye.allBasenames);ie&&(le.allBasenames=ie.allBasenames);const ce=G.reduce((ye,H)=>H.allPaths?ye.concat(H.allPaths):ye,[]);return ce.length&&(le.allPaths=ce),le}function N(me,te,G){if(te===!1)return s;const J=n(me,G);if(J===s)return s;if(typeof te=="boolean")return J;if(te){const le=te.when;if(typeof le=="string"){const ie=(ce,ye,H,B)=>{if(!B||!J(ce,ye))return null;const Y=le.replace("$(basename)",()=>H),re=B(Y);return(0,O.$Hg)(re)?re.then(X=>X?me:null):re?me:null};return ie.requiresSiblings=!0,ie}}return J}function q(me,te){const G=me.filter(ye=>!!ye.basenames);if(G.length<2)return me;const J=G.reduce((ye,H)=>{const B=H.basenames;return B?ye.concat(B):ye},[]);let le;if(te){le=[];for(let ye=0,H=J.length;ye<H;ye++)le.push(te)}else le=G.reduce((ye,H)=>{const B=H.patterns;return B?ye.concat(B):ye},[]);const ie=function(ye,H){if(typeof ye!="string")return null;if(!H){let Y;for(Y=ye.length;Y>0;Y--){const re=ye.charCodeAt(Y-1);if(re===47||re===92)break}H=ye.substr(Y)}const B=J.indexOf(H);return B!==-1?le[B]:null};ie.basenames=J,ie.patterns=le,ie.allBasenames=J;const ce=me.filter(ye=>!ye.basenames);return ce.push(ie),ce}function K(me,te){return(0,C.$ub)(me,te,(G,J)=>typeof G=="string"&&typeof J=="string"?G===J:typeof G!="string"&&typeof J!="string"?G.base===J.base&&G.pattern===J.pattern:!1)}e.$Bj=K}),define(De[80],Ce([1,0,9,161,23,15,2]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class E{constructor(o="",l=!1){if(this.value=o,typeof this.value!="string")throw(0,C.$7)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(o,l=0){return this.value+=p(this.supportThemeIcons?(0,O.$Xj)(o):o).replace(/([ \t]+)/g,(c,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,l){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}appendLink(o,l,c){return this.value+="[",this.value+=this.c(l,"]"),this.value+="](",this.value+=this.c(String(o),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(o,l){const c=new RegExp((0,R.$Ge)(l),"g");return o.replace(c,(d,a)=>o.charAt(a-1)!=="\\"?`\\${d}`:d)}}e.$4j=E;function b(h){return L(h)?!h.value:Array.isArray(h)?h.every(b):!0}e.$5j=b;function L(h){return h instanceof E?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.$6j=L;function P(h,o){return h===o?!0:!h||!o?!1:h.value===o.value&&h.isTrusted===o.isTrusted&&h.supportThemeIcons===o.supportThemeIcons&&h.supportHtml===o.supportHtml&&(h.baseUri===o.baseUri||!!h.baseUri&&!!o.baseUri&&(0,f.$pg)(A.URI.from(h.baseUri),A.URI.from(o.baseUri)))}e.$7j=P;function p(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$8j=p;function y(h){return h.replace(/"/g,"&quot;")}e.$9j=y;function k(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$0j=k;function v(h){const o=[],l=h.split("|").map(d=>d.trim());h=l[0];const c=l[1];if(c){const d=/height=(\d+)/.exec(c),a=/width=(\d+)/.exec(c),t=d?d[1]:"",i=a?a[1]:"",s=isFinite(parseInt(i)),n=isFinite(parseInt(t));s&&o.push(`width="${i}"`),n&&o.push(`height="${t}"`)}return{href:h,dimensions:o}}e.$$j=v}),define(De[99],Ce([1,0,19,33,16,12,23,15]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=void 0;function E(n,r){const{os:u,tildify:I,relative:S}=r;if(S){const w=b(n,S,u);if(typeof w=="string")return w}let $=n.fsPath;if(u===1&&!R.$j?$=$.replace(/\//g,"\\"):u!==1&&R.$j&&($=$.replace(/\\/g,"/")),u!==1&&I?.userHome){const w=I.userHome.fsPath;let D;n.scheme!==I.userHome.scheme&&n.path.startsWith(f.$gc.sep)?D=I.userHome.with({path:n.path}).fsPath:D=n.fsPath,$=p(D,w,u)}return(u===1?f.$fc:f.$gc).normalize(L($,u===1))}e.$vv=E;function b(n,r,u){const I=u===1?f.$fc:f.$gc,S=u===3?A.$mg:A.$og,$=r.getWorkspace(),g=(0,C.$Ob)($.folders);if(!g)return;n.scheme!==g.uri.scheme&&n.path.startsWith(f.$gc.sep)&&(n=g.uri.with({path:n.path}));const w=r.getWorkspaceFolder(n);if(!w)return;let D;if(S.isEqual(w.uri,n)?D="":D=S.relativePath(w.uri,n)??"",D&&(D=I.normalize(D)),$.folders.length>1&&!r.noPrefix){const T=w.name?w.name:S.basenameOrAuthority(w.uri);D=D?`${T} \u2022 ${D}`:T}return D}function L(n,r=R.$j){return(0,O.$3f)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.$wv=L;let P=Object.create(null);function p(n,r,u=R.OS){if(u===1||!n||!r)return n;let I=P.original===r?P.normalized:void 0;I||(I=r,R.$j&&(I=(0,O.$Sf)(I)),I=`${(0,m.$Le)(I,f.$gc.sep)}${f.$gc.sep}`,P={original:r,normalized:I});let S=n;return R.$j&&(S=(0,O.$Sf)(S)),(u===3?S.startsWith(I):(0,m.$4e)(S,I))?`~/${S.substr(I.length)}`:n}e.$xv=p;function y(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.$yv=y;const k="\u2026",v="\\\\",h="~";function o(n,r=f.sep){const u=new Array(n.length);let I=!1;for(let S=0;S<n.length;S++){const $=n[S];if($===""){u[S]=`.${r}`;continue}if(!$){u[S]=$;continue}I=!0;let g="",w=$;w.indexOf(v)===0?(g=w.substr(0,w.indexOf(v)+v.length),w=w.substr(w.indexOf(v)+v.length)):w.indexOf(r)===0?(g=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length)):w.indexOf(h)===0&&(g=w.substr(0,w.indexOf(h)+h.length),w=w.substr(w.indexOf(h)+h.length));const D=w.split(r);for(let T=1;I&&T<=D.length;T++)for(let M=D.length-T;I&&M>=0;M--){I=!1;let F=D.slice(M,M+T).join(r);for(let z=0;!I&&z<n.length;z++)if(z!==S&&n[z]&&n[z].indexOf(F)>-1){const j=M+T===D.length,N=M>0&&n[z].indexOf(r)>-1?r+F:F,q=n[z].endsWith(N);I=!j||q}if(!I){let z="";(D[0].endsWith(":")||g!=="")&&(M===1&&(M=0,T++,F=D[0]+r+F),M>0&&(z=D[0]+r),z=g+z),M>0&&(z=z+k+r),z=z+F,M+T<D.length&&(z=z+r+k),u[S]=z}}I&&(u[S]=$)}return u}e.$zv=o;var l;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function c(n,r=Object.create(null)){const u=[];let I=!1,S="";for(const $ of n)if($==="$"||I&&$==="{")S&&u.push({value:S,type:l.TEXT}),S="",I=!0;else if($==="}"&&I){const g=r[S];if(typeof g=="string")g.length&&u.push({value:g,type:l.VARIABLE});else if(g){const w=u[u.length-1];(!w||w.type!==l.SEPARATOR)&&u.push({value:g.label,type:l.SEPARATOR})}S="",I=!1}else S+=$;return S&&!I&&u.push({value:S,type:l.TEXT}),u.filter(($,g)=>{if($.type===l.SEPARATOR){const w=u[g-1],D=u[g+1];return[w,D].every(T=>T&&(T.type===l.VARIABLE||T.type===l.TEXT)&&T.value.length>0)}return!0}).map($=>$.value).join("")}e.$Av=c;function d(n,r){return R.$k||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):n.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.$Bv=d;function a(n,r){return R.$k||r?n.replace(/\(&&\w\)|&&/g,""):R.$j?n.replace(/&&|&/g,u=>u==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.$Cv=a;function t(n){return n.replace(/&/g,"&&")}e.$Dv=t;function i(n){if(n.endsWith("]")){const r=n.lastIndexOf(" [",n.length-2);if(r!==-1){const u=s(n.substring(0,r));return{name:u.name,parentPath:u.parentPath+n.substring(r)}}}return s(n)}e.$Ev=i;function s(n){const r=n.indexOf("/")!==-1?f.$gc:f.$fc,u=r.basename(n),I=r.dirname(n);return u.length?{name:u,parentPath:I}:{name:I,parentPath:""}}}),define(De[128],Ce([1,0,22,2]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0;function f(P){return P.toJSON()}class R{constructor(p){this.a=p}transformIncoming(p){const y=this.a.transformIncoming(p);return y===p?p:f(O.URI.from(y))}transformOutgoing(p){const y=this.a.transformOutgoing(p);return y===p?p:f(O.URI.from(y))}transformOutgoingURI(p){const y=this.a.transformOutgoing(p);return y===p?p:O.URI.from(y)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Mm=R,e.$Nm=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function A(P,p,y){if(!P||y>200)return null;if(typeof P=="object"){if(P instanceof O.URI)return p.transformOutgoing(P);for(const k in P)if(Object.hasOwnProperty.call(P,k)){const v=A(P[k],p,y+1);v!==null&&(P[k]=v)}}return null}function m(P,p){const y=A(P,p,0);return y===null?P:y}e.$Om=m;function E(P,p,y,k){if(!P||k>200)return null;if(typeof P=="object"){if(P.$mid===1)return y?O.URI.revive(p.transformIncoming(P)):p.transformIncoming(P);if(P instanceof C.$ce)return null;for(const v in P)if(Object.hasOwnProperty.call(P,v)){const h=E(P[v],p,y,k+1);h!==null&&(P[v]=h)}}return null}function b(P,p){const y=E(P,p,!1,0);return y===null?P:y}e.$Pm=b;function L(P,p){const y=E(P,p,!0,0);return y===null?P:y}e.$Qm=L}),define(De[29],Ce([1,0,53,63,374,8,33,77,16,12,23,2]),function($e,e,C,O,f,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function y(N,q=p.UNLINK,K){if((0,A.$2f)(N))throw new Error("rimraf - will refuse to recursively delete root");return q===p.UNLINK?v(N):k(N,K)}async function k(N,q=(0,A.$7f)((0,O.tmpdir)())){try{try{await C.promises.rename(N,q)}catch(K){return K.code==="ENOENT"?void 0:v(N)}v(q).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function v(N){return(0,f.promisify)(C.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function h(N){if((0,A.$2f)(N))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function o(N,q){return d(await(q?l(N):(0,f.promisify)(C.readdir)(N)))}async function l(N){try{return await(0,f.promisify)(C.readdir)(N,{withFileTypes:!0})}catch(me){console.warn("[node.js fs] readdir with filetypes failed with error: ",me)}const q=[],K=await o(N);for(const me of K){let te=!1,G=!1,J=!1;try{const le=await e.Promises.lstat((0,E.$jc)(N,me));te=le.isFile(),G=le.isDirectory(),J=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}q.push({name:me,isFile:()=>te,isDirectory:()=>G,isSymbolicLink:()=>J})}return q}function c(N){return d(C.readdirSync(N))}e.readdirSync=c;function d(N){return N.map(q=>typeof q=="string"?b.$k?(0,m.$pl)(q):q:(q.name=b.$k?(0,m.$pl)(q.name):q.name,q))}async function a(N){const q=await o(N),K=[];for(const me of q)await i.existsDirectory((0,E.$jc)(N,me))&&K.push(me);return K}function t(N,q=1e3){return new Promise(K=>{let me=!1;const te=setInterval(()=>{me||(me=!0,C.access(N,G=>{me=!1,G&&(clearInterval(te),K(void 0))}))},q)})}e.whenDeleted=t;var i;(function(N){async function q(te){let G;try{if(G=await e.Promises.lstat(te),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(te),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(b.$j&&J.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(te)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw le}throw J}}N.stat=q;async function K(te){try{const{stat:G,symbolicLink:J}=await N.stat(te);return G.isFile()&&J?.dangling!==!0}catch{}return!1}N.existsFile=K;async function me(te){try{const{stat:G,symbolicLink:J}=await N.stat(te);return G.isDirectory()&&J?.dangling!==!0}catch{}return!1}N.existsDirectory=me})(i||(e.SymlinkSupport=i={}));const s=new R.$4g;function n(N,q,K){return s.queueFor(P.URI.file(N),L.$ng).queue(()=>{const me=$(K);return new Promise((te,G)=>I(N,q,me,J=>J?G(J):te()))})}let r=!0;function u(N){r=N}e.configureFlushOnWrite=u;function I(N,q,K,me){if(!r)return C.writeFile(N,q,{mode:K.mode,flag:K.flag},me);C.open(N,K.flag,K.mode,(te,G)=>{if(te)return me(te);C.writeFile(G,q,J=>{if(J)return C.close(G,()=>me(J));C.fdatasync(G,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),u(!1)),C.close(G,ie=>me(ie))))})})}function S(N,q,K){const me=$(K);if(!r)return C.writeFileSync(N,q,{mode:me.mode,flag:me.flag});const te=C.openSync(N,me.flag,me.mode);try{C.writeFileSync(te,q);try{C.fdatasyncSync(te)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),u(!1)}}finally{C.closeSync(te)}}e.writeFileSync=S;function $(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function g(N,q,K=6e4){if(N!==q)try{b.$j&&typeof K=="number"?await w(N,q,Date.now(),K):await(0,f.promisify)(C.rename)(N,q)}catch(me){if(N.toLowerCase()!==q.toLowerCase()&&me.code==="EXDEV"||N.endsWith("."))await D(N,q,{preserveSymlinks:!1}),await y(N,p.MOVE);else throw me}}async function w(N,q,K,me,te=0){try{return await(0,f.promisify)(C.rename)(N,q)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-K>=me)throw console.error(`[node.js fs] rename failed after ${te} retries with error: ${G}`),G;if(te===0){let J=!1;try{const{stat:le}=await i.stat(q);le.isFile()||(J=!0)}catch{}if(J)throw G}return await(0,R.$Vg)(Math.min(100,te*10)),w(N,q,K,me,te+1)}}async function D(N,q,K){return M(N,q,{root:{source:N,target:q},options:K,handledSourcePaths:new Set})}const T=511;async function M(N,q,K){if(K.handledSourcePaths.has(N))return;K.handledSourcePaths.add(N);const{stat:me,symbolicLink:te}=await i.stat(N);if(te){if(K.options.preserveSymlinks)try{return await j(N,q,K)}catch(G){console.warn("[node.js fs] copy of symlink failed: ",G)}if(te.dangling)return}return me.isDirectory()?F(N,q,me.mode&T,K):z(N,q,me.mode&T)}async function F(N,q,K,me){await e.Promises.mkdir(q,{recursive:!0,mode:K});const te=await o(N);for(const G of te)await M((0,E.$jc)(N,G),(0,E.$jc)(q,G),me)}async function z(N,q,K){await e.Promises.copyFile(N,q),await e.Promises.chmod(q,K)}async function j(N,q,K){let me=await e.Promises.readlink(N);(0,A.$Yf)(me,K.root.source,!b.$l)&&(me=(0,E.$jc)(K.root.target,me.substr(K.root.source.length+1))),await e.Promises.symlink(me,q)}e.Promises=new class{get access(){return(0,f.promisify)(C.access)}get stat(){return(0,f.promisify)(C.stat)}get lstat(){return(0,f.promisify)(C.lstat)}get utimes(){return(0,f.promisify)(C.utimes)}get read(){return(N,q,K,me,te)=>new Promise((G,J)=>{C.read(N,q,K,me,te,(le,ie,ce)=>le?J(le):G({bytesRead:ie,buffer:ce}))})}get readFile(){return(0,f.promisify)(C.readFile)}get write(){return(N,q,K,me,te)=>new Promise((G,J)=>{C.write(N,q,K,me,te,(le,ie,ce)=>le?J(le):G({bytesWritten:ie,buffer:ce}))})}get appendFile(){return(0,f.promisify)(C.appendFile)}get fdatasync(){return(0,f.promisify)(C.fdatasync)}get truncate(){return(0,f.promisify)(C.truncate)}get copyFile(){return(0,f.promisify)(C.copyFile)}get open(){return(0,f.promisify)(C.open)}get close(){return(0,f.promisify)(C.close)}get symlink(){return(0,f.promisify)(C.symlink)}get readlink(){return(0,f.promisify)(C.readlink)}get chmod(){return(0,f.promisify)(C.chmod)}get mkdir(){return(0,f.promisify)(C.mkdir)}get unlink(){return(0,f.promisify)(C.unlink)}get rmdir(){return(0,f.promisify)(C.rmdir)}get realpath(){return(0,f.promisify)(C.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return n}get rm(){return y}get rename(){return g}get copy(){return D}}}),define(De[100],Ce([1,0,53,16,12,15,29]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.$9p=void 0;function m(p){if(f.$l)return p;const y=(0,O.$mc)(p);if(p===y)return p;const k=((0,O.$nc)(p)||p).toLowerCase();try{const h=(0,A.readdirSync)(y).filter(o=>o.toLowerCase()===k);if(h.length===1){const o=m(y);if(o)return(0,O.$jc)(o,h[0])}else if(h.length>1){const o=h.indexOf(k);if(o>=0){const l=m(y);if(l)return(0,O.$jc)(l,h[o])}}}catch{}return null}e.$9p=m;async function E(p){if(f.$l)return p;const y=(0,O.$mc)(p);if(p===y)return p;const k=((0,O.$nc)(p)||p).toLowerCase();try{const h=(await A.Promises.readdir(y)).filter(o=>o.toLowerCase()===k);if(h.length===1){const o=await E(y);if(o)return(0,O.$jc)(o,h[0])}else if(h.length>1){const o=h.indexOf(k);if(o>=0){const l=await E(y);if(l)return(0,O.$jc)(l,h[o])}}}catch{}return null}e.$0p=E;async function b(p){try{return await A.Promises.realpath(p)}catch{const k=P(p);return await A.Promises.access(k,C.constants.R_OK),k}}e.$$p=b;function L(p){try{return C.realpathSync(p)}catch{const k=P(p);return C.accessSync(k,C.constants.R_OK),k}}e.$_p=L;function P(p){return(0,R.$Le)((0,O.$hc)(p),O.sep)}}),define(De[101],Ce([1,0,16,12,48,98,17,29]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Dl=e.$Cl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function E(P=f.env){return P.comspec||"cmd.exe"}e.$Cl=E;function b(P){let p=[],y=!1;const k=function(v){if(y){p.push(v);return}(!P.send(v,o=>{if(o&&console.error(o),y=!1,p.length>0){const l=p.slice(0);p=[],l.forEach(c=>k(c))}})||O.$j)&&(y=!0)};return{send:k}}e.$Dl=b;var L;(function(P){async function p(y,k,v){if(C.$ic(y))return y;if(k===void 0&&(k=f.cwd()),C.$mc(y)!=="."||(v===void 0&&A.$zf(f.env.PATH)&&(v=f.env.PATH.split(C.$tc)),v===void 0||v.length===0))return C.$jc(k,y);async function o(l){if(await m.Promises.exists(l)){let c;try{c=await m.Promises.stat(l)}catch(d){d.message.startsWith("EACCES")&&(c=await m.Promises.lstat(l))}return c?!c.isDirectory():!1}return!1}for(const l of v){let c;if(C.$ic(l)?c=C.$jc(l,y):c=C.$jc(k,l,y),await o(c))return c;let d=c+".com";if(await o(d)||(d=c+".exe",await o(d)))return d}return C.$jc(k,y)}P.findExecutable=p})(L||(e.win32=L={}))});var He=this&&this.__decorate||function($e,e,C,O){var f=arguments.length,R=f<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,C):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($e,e,C,O);else for(var m=$e.length-1;m>=0;m--)(A=$e[m])&&(R=(f<3?A(R):f>3?A(e,C,R):A(e,C))||R);return f>3&&R&&Object.defineProperty(e,C,R),R};define(De[81],Ce([1,0,19,8,22,21,57,9,4,3,62,15,17]),function($e,e,C,O,f,R,A,m,E,b,L,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.ProxyChannel=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.RequestInitiator=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;var y;(function(te){te[te.Promise=100]="Promise",te[te.PromiseCancel=101]="PromiseCancel",te[te.EventListen=102]="EventListen",te[te.EventDispose=103]="EventDispose"})(y||(y={}));function k(te){switch(te){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(te){te[te.Initialize=200]="Initialize",te[te.PromiseSuccess=201]="PromiseSuccess",te[te.PromiseError=202]="PromiseError",te[te.PromiseErrorObj=203]="PromiseErrorObj",te[te.EventFire=204]="EventFire"})(v||(v={}));function h(te){switch(te){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(te){te[te.Uninitialized=0]="Uninitialized",te[te.Idle=1]="Idle"})(o||(o={}));function l(te){let G=0;for(let J=0;;J+=7){const le=te.read(1);if(G|=(le.buffer[0]&127)<<J,!(le.buffer[0]&128))return G}}const c=s(0);function d(te,G){if(G===0){te.write(c);return}let J=0;for(let ie=G;ie!==0;ie=ie>>>7)J++;const le=f.$ce.alloc(J);for(let ie=0;G!==0;ie++)le.buffer[ie]=G&127,G=G>>>7,G>0&&(le.buffer[ie]|=128);te.write(le)}class a{constructor(G){this.b=G,this.a=0}read(G){const J=this.b.slice(this.a,this.a+G);return this.a+=J.byteLength,J}}e.$oh=a;class t{constructor(){this.a=[]}get buffer(){return f.$ce.concat(this.a)}write(G){this.a.push(G)}}e.$ph=t;var i;(function(te){te[te.Undefined=0]="Undefined",te[te.String=1]="String",te[te.Buffer=2]="Buffer",te[te.VSBuffer=3]="VSBuffer",te[te.Array=4]="Array",te[te.Object=5]="Object",te[te.Int=6]="Int"})(i||(i={}));function s(te){const G=f.$ce.alloc(1);return G.writeUInt8(te,0),G}const n={Undefined:s(i.Undefined),String:s(i.String),Buffer:s(i.Buffer),VSBuffer:s(i.VSBuffer),Array:s(i.Array),Object:s(i.Object),Uint:s(i.Int)},r=typeof Buffer<"u";function u(te,G){if(typeof G>"u")te.write(n.Undefined);else if(typeof G=="string"){const J=f.$ce.fromString(G);te.write(n.String),d(te,J.byteLength),te.write(J)}else if(r&&Buffer.isBuffer(G)){const J=f.$ce.wrap(G);te.write(n.Buffer),d(te,J.byteLength),te.write(J)}else if(G instanceof f.$ce)te.write(n.VSBuffer),d(te,G.byteLength),te.write(G);else if(Array.isArray(G)){te.write(n.Array),d(te,G.length);for(const J of G)u(te,J)}else if(typeof G=="number"&&(G|0)===G)te.write(n.Uint),d(te,G);else{const J=f.$ce.fromString(JSON.stringify(G));te.write(n.Object),d(te,J.byteLength),te.write(J)}}e.$qh=u;function I(te){switch(te.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return te.read(l(te)).toString();case i.Buffer:return te.read(l(te)).buffer;case i.VSBuffer:return te.read(l(te));case i.Array:{const J=l(te),le=[];for(let ie=0;ie<J;ie++)le.push(I(te));return le}case i.Object:return JSON.parse(te.read(l(te)).toString());case i.Int:return l(te)}}e.$rh=I;class S{constructor(G,J,le=null,ie=1e3){this.h=G,this.j=J,this.k=le,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(G,J){this.b.set(G,J),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const J=this.o([G.type]);this.k?.logOutgoing(J,0,1,h(G.type));return}case 201:case 202:case 204:case 203:{const J=this.o([G.type,G.id],G.data);this.k?.logOutgoing(J,G.id,1,h(G.type),G.data);return}}}o(G,J=void 0){const le=new t;return u(le,G),u(le,J),this.p(le.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const J=new a(G),le=I(J),ie=I(J),ce=le[0];switch(ce){case 100:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}: ${le[2]}.${le[3]}`,ie),this.s({type:ce,id:le[1],channelName:le[2],name:le[3],arg:ie});case 102:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}: ${le[2]}.${le[3]}`,ie),this.t({type:ce,id:le[1],channelName:le[2],name:le[3],arg:ie});case 101:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}`),this.u({type:ce,id:le[1]});case 103:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}`),this.u({type:ce,id:le[1]})}}s(G){const J=this.b.get(G.channelName);if(!J){this.v(G);return}const le=new R.$Yd;let ie;try{ie=J.call(this.j,G.name,G.arg,le.token)}catch(H){ie=Promise.reject(H)}const ce=G.id;ie.then(H=>{this.m({id:ce,data:H,type:201})},H=>{H instanceof Error?this.m({id:ce,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.m({id:ce,data:H,type:203})}).finally(()=>{ye.dispose(),this.d.delete(G.id)});const ye=(0,b.$Qc)(()=>le.cancel());this.d.set(G.id,ye)}t(G){const J=this.b.get(G.channelName);if(!J){this.v(G);return}const le=G.id,ce=J.listen(this.j,G.name,G.arg)(ye=>this.m({id:le,data:ye,type:204}));this.d.set(G.id,ce)}u(G){const J=this.d.get(G.id);J&&(J.dispose(),this.d.delete(G.id))}v(G){let J=this.g.get(G.channelName);J||(J=[],this.g.set(G.channelName,J));const le=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:G,timeoutTimer:le})}w(G){const J=this.g.get(G);if(J){for(const le of J)switch(clearTimeout(le.timeoutTimer),le.request.type){case 100:this.s(le.request);break;case 102:this.t(le.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Nc)(this.d.values()),this.d.clear()}}e.$sh=S;var $;(function(te){te[te.LocalSide=0]="LocalSide",te[te.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class g{constructor(G,J=null){this.l=G,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=J}getChannel(G){const J=this;return{call(le,ie,ce){return J.a?Promise.reject(new m.$5):J.m(G,le,ie,ce)},listen(le,ie){return J.a?E.Event.None:J.o(G,le,ie)}}}m(G,J,le,ie=R.CancellationToken.None){const ce=this.g++,H={id:ce,type:100,channelName:G,name:J,arg:le};if(ie.isCancellationRequested)return Promise.reject(new m.$5);let B;return new Promise((re,X)=>{if(ie.isCancellationRequested)return X(new m.$5);const _=()=>{const fe=ee=>{switch(ee.type){case 201:this.f.delete(ce),re(ee.data);break;case 202:{this.f.delete(ce);const de=new Error(ee.data.message);de.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,de.name=ee.data.name,X(de);break}case 203:this.f.delete(ce),X(ee.data);break}};this.f.set(ce,fe),this.p(H)};let x=null;this.b===o.Idle?_():(x=(0,O.$Ig)(fe=>this.u()),x.then(()=>{x=null,_()}));const pe=()=>{x?(x.cancel(),x=null):this.p({id:ce,type:101}),X(new m.$5)},ae=ie.onCancellationRequested(pe);B=(0,b.$Pc)((0,b.$Qc)(pe),ae),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(G,J,le){const ie=this.g++,ye={id:ie,type:102,channelName:G,name:J,arg:le};let H=null;const B=new E.$Od({onWillAddFirstListener:()=>{H=(0,O.$Ig)(re=>this.u()),H.then(()=>{H=null,this.d.add(B),this.p(ye)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(B),this.p({id:ie,type:103}))}}),Y=re=>B.fire(re.data);return this.f.set(ie,Y),B.event}p(G){switch(G.type){case 100:case 102:{const J=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(J,G.id,0,`${k(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const J=this.q([G.type,G.id]);this.j?.logOutgoing(J,G.id,0,k(G.type));return}}}q(G,J=void 0){const le=new t;return u(le,G),u(le,J),this.r(le.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const J=new a(G),le=I(J),ie=I(J),ce=le[0];switch(ce){case 200:return this.j?.logIncoming(G.byteLength,0,0,h(ce)),this.t({type:le[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,le[1],0,h(ce),ie),this.t({type:le[0],id:le[1],data:ie})}}t(G){if(G.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Nc)(this.d.values()),this.d.clear()}}e.$th=g,He([A.$ih],g.prototype,"onDidInitializePromise",null);class w{get connections(){const G=[];return this.f.forEach(J=>G.push(J)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new E.$Od,this.onDidAddConnection=this.g.event,this.h=new E.$Od,this.onDidRemoveConnection=this.h.event,this.j=new b.$Rc,this.j.add(G(({protocol:J,onDidClientDisconnect:le})=>{const ie=E.Event.once(J.onMessage);this.j.add(ie(ce=>{const ye=new a(ce),H=I(ye),B=new S(J,H),Y=new g(J);this.a.forEach((X,_)=>B.registerChannel(_,X));const re={channelServer:B,channelClient:Y,ctx:H};this.f.add(re),this.g.fire(re),this.j.add(le(()=>{B.dispose(),Y.dispose(),this.f.delete(re),this.h.fire(re)}))}))}))}getChannel(G,J){const le=this;return{call(ie,ce,ye){let H;if((0,p.$Nf)(J)){const Y=(0,C.$4b)(le.connections.filter(J));H=Y?Promise.resolve(Y):E.Event.toPromise(E.Event.filter(le.onDidAddConnection,J))}else H=J.routeCall(le,ie,ce);const B=H.then(Y=>Y.channelClient.getChannel(G));return T(B).call(ie,ce,ye)},listen(ie,ce){if((0,p.$Nf)(J))return le.k(G,J,ie,ce);const ye=J.routeEvent(le,ie,ce).then(H=>H.channelClient.getChannel(G));return T(ye).listen(ie,ce)}}}k(G,J,le,ie){const ce=this;let ye;const H=new E.$Od({onWillAddFirstListener:()=>{ye=new b.$Rc;const B=new E.$Ud,Y=new Map,re=_=>{const pe=_.channelClient.getChannel(G).listen(le,ie),ae=B.add(pe);Y.set(_,ae)},X=_=>{const x=Y.get(_);x&&(x.dispose(),Y.delete(_))};ce.connections.filter(J).forEach(re),E.Event.filter(ce.onDidAddConnection,J)(re,void 0,ye),ce.onDidRemoveConnection(X,void 0,ye),B.event(H.fire,H,ye),ye.add(B)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return H.event}registerChannel(G,J){this.a.set(G,J);for(const le of this.f)le.channelServer.registerChannel(G,J)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$uh=w;class D{constructor(G,J,le=null){const ie=new t;u(ie,J),G.send(ie.buffer),this.a=new g(G,le),this.d=new S(G,J,le)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,J){this.d.registerChannel(G,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.$vh=D;function T(te){return{call(G,J,le){return te.then(ie=>ie.call(G,J,le))},listen(G,J){const le=new E.$Xd;return te.then(ie=>le.input=ie.listen(G,J)),le.event}}}e.$wh=T;function M(te){let G=!1;return{call(J,le,ie){return G?te.call(J,le,ie):(0,O.$Vg)(0).then(()=>G=!0).then(()=>te.call(J,le,ie))},listen(J,le){if(G)return te.listen(J,le);const ie=new E.$Xd;return(0,O.$Vg)(0).then(()=>G=!0).then(()=>ie.input=te.listen(J,le)),ie.event}}}e.$xh=M;class F{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const J of G.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await E.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$yh=F;var z;(function(te){function G(ce,ye,H){const B=ce,Y=H&&H.disableMarshalling,re=new Map;for(const X in B)le(X)&&re.set(X,E.Event.buffer(B[X],!0,void 0,ye));return new class{listen(X,_,x){const pe=re.get(_);if(pe)return pe;if(ie(_)){const ae=B[_];if(typeof ae=="function")return ae.call(B,x)}throw new m.$bb(`Event not found: ${_}`)}call(X,_,x){const pe=B[_];if(typeof pe=="function"){if(!Y&&Array.isArray(x))for(let fe=0;fe<x.length;fe++)x[fe]=(0,L.$nh)(x[fe]);let ae=pe.apply(B,x);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new m.$bb(`Method not found: ${_}`)}}}te.fromService=G;function J(ce,ye){const H=ye&&ye.disableMarshalling;return new Proxy({},{get(B,Y){if(typeof Y=="string")return ye?.properties?.has(Y)?ye.properties.get(Y):ie(Y)?function(re){return ce.listen(Y,re)}:le(Y)?ce.listen(Y):async function(...re){let X;ye&&!(0,p.$If)(ye.context)?X=[ye.context,...re]:X=re;const _=await ce.call(Y,X);return H?_:(0,L.$nh)(_)};throw new m.$bb(`Property not found: ${String(Y)}`)}})}te.toService=J;function le(ce){return ce[0]==="o"&&ce[1]==="n"&&P.$2e(ce.charCodeAt(2))}function ie(ce){return/^onDynamic/.test(ce)&&P.$2e(ce.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(te){if(Array.isArray(te))return te;if(te&&typeof te=="object"&&typeof te.toString=="function"){const G=te.toString();if(G!=="[object Object]")return G}return te}function q(te){return Array.isArray(te)?te.map(N):N(te)}function K(te,G,J,le,ie,ce,ye){ye=q(ye);const H=j[ie],B=H[le%H.length];let Y=[`%c[${te}]%c[${String(G).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ce)?(Y=Y.concat(ye),Y.push(")")):Y.push(ye),console.log.apply(console,Y)}class me{constructor(G,J){this.d=G,this.f=J,this.a=0,this.b=0}logOutgoing(G,J,le,ie,ce){this.b+=G,K(this.d,this.b,G,J,le,ie,ce)}logIncoming(G,J,le,ie,ce){this.a+=G,K(this.f,this.a,G,J,le,ie,ce)}}e.$zh=me}),define(De[82],Ce([1,0,22,4,3,81]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.ProtocolConstants=e.$Ah=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var m;(function(n){n.enableDiagnostics=!1,n.records=[];const r=new WeakMap;let u=0;function I($,g){if(!r.has($)){const w=String(++u);r.set($,w)}return r.get($)}function S($,g,w,D){if(!n.enableDiagnostics)return;const T=I($,g);if(D instanceof C.$ce||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const M=C.$ce.alloc(D.byteLength);M.set(D),n.records.push({timestamp:Date.now(),id:T,label:g,type:w,buff:M})}else n.records.push({timestamp:Date.now(),id:T,label:g,type:w,data:D})}n.traceSocketEvent=S})(m||(e.SocketDiagnostics=m={}));var E;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let b=null;function L(){return b||(b=C.$ce.alloc(0)),b}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,u){if(r===0)return L();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const g=this.a[0];return u&&(this.a.shift(),this.b-=r),g}if(this.a[0].byteLength>r){const g=this.a[0].slice(0,r);return u&&(this.a[0]=this.a[0].slice(r),this.b-=r),g}const I=C.$ce.alloc(r);let S=0,$=0;for(;r>0;){const g=this.a[$];if(g.byteLength>r){const w=g.slice(0,r);I.set(w,S),S+=r,u&&(this.a[$]=g.slice(r),this.b-=r),r-=r}else I.set(g,S),S+=g.byteLength,u?(this.a.shift(),this.b-=g.byteLength):$++,r-=g.byteLength}return I}}e.$Ah=P;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(p||(p={}));function y(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class v{constructor(r,u,I,S){this.type=r,this.id=u,this.ack=I,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends f.$Sc{constructor(r){super(),this.f=this.B(new O.$Od),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new P,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const I=this.g.messageType,S=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new v(I,S,$,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=C.$ce.alloc(13);u.writeUInt8(r.type,0),u.writeUInt32BE(r.id,1),u.writeUInt32BE(r.ack,5),u.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(u,r.data)}g(r,u){const I=this.f===0;return this.d.push(r,u),this.f+=r.byteLength+u.byteLength,I}h(){const r=C.$ce.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,u){this.g(r,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class l extends f.$Sc{constructor(r){super(),this.f=new O.$Od,this.onMessage=this.f.event,this.g=new O.$Od,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new o(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new v(1,0,0,r))}}e.$Bh=l;class c extends R.$vh{static fromSocket(r,u){return new c(new l(r),u)}get onDidDispose(){return this.b.onDidDispose}constructor(r,u,I=null){super(r,u,I),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.$Ch=c;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$Od({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.$Dh=d;class a{constructor(r){this.data=r,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let r=0,u=this.a;for(;u;)u=u.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let u=0,I=this.a;for(;I;)r[u++]=I.data,I=I.next;return r}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const u=new a(r);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const r=Date.now();for(let u=0;u<i.a;u++)this.c[u]=r-1e3*u;setInterval(()=>{for(let u=i.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),u=(1+i.a)*1e3;let I=0;for(let S=0;S<i.a;S++)r-this.c[S]<=u&&I++;return 1-I/i.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(r){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=r.loadEstimator??i.getInstance(),this.t=r.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Rc,this.o=r.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),r.initialChunk&&this.q.acceptChunk(r.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const r=new v(5,0,0,L());this.p.write(r),this.p.flush()}sendPause(){const r=new v(7,0,0,L());this.p.write(r)}sendResume(){const r=new v(8,0,0,L());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,u){this.a=!0,this.r.dispose(),this.r=new f.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(I=>this.z(I))),this.r.add(this.o.onClose(I=>this.x.fire(I))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new v(3,0,this.h,L());this.p.write(r);const u=this.b.toArray();for(let I=0,S=u.length;I<S;I++)this.p.write(u[I]);this.B()}acceptDisconnect(){this.w.fire()}z(r){if(r.ack>this.d){this.d=r.ack;do{const u=this.b.peek();if(u&&u.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new v(6,0,0,L())))}else this.g=r.id,this.j=Date.now(),this.A(),this.v.fire(r.data);break}case 2:{this.u.fire(r.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let I=0,S=u.length;I<S;I++)this.p.write(u[I]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const u=++this.c;this.h=this.g;const I=new v(1,u,this.h,r);this.b.push(I),this.a||(this.p.write(I),this.B())}sendControl(r){const u=new v(2,0,0,r);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-r+5)}B(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),u=Date.now()-r.writtenTime,I=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(u>=2e4&&I>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:I});return}const $=Math.max(2e4-u,2e4-I,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const r=new v(3,0,this.h,L());this.p.write(r)}D(){this.h=this.g;const r=new v(9,0,this.h,L());this.p.write(r)}}e.$Eh=s}),define(De[183],Ce([1,0,49,8,22,21,181,9,4,3,24,101,98,81]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;class k extends y.$sh{constructor(o){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",l=>f.$ce.wrap(Buffer.from(l,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$6p=k;class v{constructor(o,l){this.i=o,this.j=l,this.c=new Set,this.g=new Map,this.h=new E.$Od,this.onDidProcessExit=this.h.event;const c=l&&l.timeout?l.timeout:6e4;this.b=new O.$Rg(c),this.d=null,this.f=null}getChannel(o){const l=this;return{call(c,d,a){return l.k(o,c,d,a)},listen(c,d){return l.l(o,c,d)}}}k(o,l,c,d=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(m.$6());this.b.cancel();const a=this.n(o),t=(0,O.$Ig)(n=>a.call(l,c,n)),i=d.onCancellationRequested(()=>t.cancel()),s=(0,b.$Qc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{i.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,l,c){if(!this.b)return E.Event.None;this.b.cancel();let d;const a=new E.$Od({onWillAddFirstListener:()=>{d=this.n(o).listen(l,c)(a.fire,a),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,L.$8m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,p.$Bl)(l.env),this.d=(0,C.fork)(this.i,o,l);const c=new E.$Od;E.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,A.$2p)(r)){(0,A.log)(r,`IPC Library: ${this.j.serverName}`);return}c.fire(f.$ce.wrap(Buffer.from(r,"base64")))});const a=this.j.useQueue?(0,P.$Dl)(this.d):this.d,t=r=>this.d&&this.d.connected&&a.send(r.buffer.toString("base64")),i=c.event,s={send:t,onMessage:i};this.f=new y.$th(s);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,u)=>{process.removeListener("exit",n),this.c.forEach(I=>(0,b.$Nc)(I)),this.c.clear(),r!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:u})})}return this.f}n(o){let l=this.g.get(o);return l||(l=this.m.getChannel(o),this.g.set(o,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7p=v}),define(De[184],Ce([1,0,8,4,3,62,17]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.StorageState=e.$5o=e.StorageHint=void 0;var m;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(m||(e.StorageHint=m={}));function E(p){const y=p;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$5o=E;var b;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(b||(e.StorageState=b={}));class L extends f.$Sc{static{this.a=100}constructor(y,k=Object.create(null)){super(),this.r=y,this.s=k,this.b=this.B(new O.$Rd),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new C.$Sg(L.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((k,v)=>this.w(v,k)),y.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(y,k){if(this.c===b.Closed)return;let v=!1;(0,A.$If)(k)?v=this.f.delete(y):this.f.get(y)!==k&&(this.f.set(y,k),v=!0),v&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==m.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,k){const v=this.f.get(y);return(0,A.$If)(v)?k:v}getBoolean(y,k){const v=this.get(y);return(0,A.$If)(v)?k:v==="true"}getNumber(y,k){const v=this.get(y);return(0,A.$If)(v)?k:parseInt(v,10)}getObject(y,k){const v=this.get(y);return(0,A.$If)(v)?k:(0,R.$mh)(v)}async set(y,k,v=!1){if(this.c===b.Closed)return;if((0,A.$If)(k))return this.delete(y,v);const h=(0,A.$Bf)(k)||Array.isArray(k)?(0,R.$lh)(k):String(k);if(this.f.get(y)!==h)return this.f.set(y,h),this.j.set(y,h),this.h.delete(y),this.b.fire({key:y,external:v}),this.D()}async delete(y,k=!1){if(!(this.c===b.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:k}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===m.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===m.STORAGE_IN_MEMORY}}e.$6o=L;class P{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((k,v)=>this.a.set(v,k)),y.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$7o=P}),define(De[185],Ce([1,0,36,16]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=void 0;function f(R,A,m,E,b,L){if(Array.isArray(R)){let P=0;for(const p of R){const y=f(p,A,m,E,b,L);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof R=="string")return E?R==="*"?5:R===m?10:0:0;if(R){const{language:P,pattern:p,scheme:y,hasAccessToAllModels:k,notebookType:v}=R;if(!E&&!k)return 0;v&&b&&(A=b);let h=0;if(y)if(y===A.scheme)h=10;else if(y==="*")h=5;else return 0;if(P)if(P===m)h=10;else if(P==="*")h=Math.max(h,5);else return 0;if(v)if(v===L)h=10;else if(v==="*"&&L!==void 0)h=Math.max(h,5);else return 0;if(p){let o;if(typeof p=="string"?o=p:o={...p,base:(0,O.$hc)(p.base)},o===A.fsPath||(0,C.$wj)(o,A.fsPath))h=10;else return 0}return h}else return 0}}e.$xE=f}),define(De[129],Ce([1,0,22,12]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$90=e.$80=void 0;var f;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(f||(f={}));function R(P){for(let p=0,y=P.length;p<y;p+=4){const k=P[p+0],v=P[p+1],h=P[p+2],o=P[p+3];P[p+0]=o,P[p+1]=h,P[p+2]=v,P[p+3]=k}}function A(P){const p=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return O.$D()||R(p),C.$ce.wrap(p)}function m(P){const p=P.buffer;if(O.$D()||R(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const y=new Uint8Array(p.byteLength);return y.set(p),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(P){const p=new Uint32Array(b(P));let y=0;if(p[y++]=P.id,P.type==="full")p[y++]=1,p[y++]=P.data.length,p.set(P.data,y),y+=P.data.length;else{p[y++]=2,p[y++]=P.deltas.length;for(const k of P.deltas)p[y++]=k.start,p[y++]=k.deleteCount,k.data?(p[y++]=k.data.length,p.set(k.data,y),y+=k.data.length):p[y++]=0}return A(p)}e.$80=E;function b(P){let p=0;if(p+=1+1,P.type==="full")p+=1+P.data.length;else{p+=1,p+=(1+1+1)*P.deltas.length;for(const y of P.deltas)y.data&&(p+=y.data.length)}return p}function L(P){const p=m(P);let y=0;const k=p[y++];if(p[y++]===1){const l=p[y++],c=p.subarray(y,y+l);return y+=l,{id:k,type:"full",data:c}}const h=p[y++],o=[];for(let l=0;l<h;l++){const c=p[y++],d=p[y++],a=p[y++];let t;a>0&&(t=p.subarray(y,y+a),y+=a),o[l]={start:c,deleteCount:d,data:t}}return{id:k,type:"delta",deltas:o}}e.$90=L}),define(De[186],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ce([1,0,19,24,12,166,124,186]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class b{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=b;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class P{constructor(ue,Ie,Ke,Ue){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ue,Ie){return y(ue,Ie)}compute(ue,Ie,Ke){return Ke}}class p{constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=p;function y(he,ue){if(typeof he!="object"||typeof ue!="object"||!he||!ue)return new p(ue,he!==ue);if(Array.isArray(he)||Array.isArray(ue)){const Ke=Array.isArray(he)&&Array.isArray(ue)&&C.$ub(he,ue);return new p(ue,!Ke)}let Ie=!1;for(const Ke in ue)if(ue.hasOwnProperty(Ke)){const Ue=y(he[Ke],ue[Ke]);Ue.didChange&&(he[Ke]=Ue.newValue,Ie=!0)}return new p(he,Ie)}class k{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return this.defaultValue}}class v{constructor(ue,Ie,Ke,Ue){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ke){return Ke}}function h(he,ue){return typeof he>"u"?ue:he==="false"?!1:!!he}e.boolean=h;class o extends v{constructor(ue,Ie,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=Ke),super(ue,Ie,Ke,Ue)}validate(ue){return h(ue,this.defaultValue)}}function l(he,ue,Ie,Ke){if(typeof he>"u")return ue;let Ue=parseInt(he,10);return isNaN(Ue)?ue:(Ue=Math.max(Ie,Ue),Ue=Math.min(Ke,Ue),Ue|0)}e.clampedInt=l;class c extends v{static clampedInt(ue,Ie,Ke,Ue){return l(ue,Ie,Ke,Ue)}constructor(ue,Ie,Ke,Ue,Ze,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ke,nt.minimum=Ue,nt.maximum=Ze),super(ue,Ie,Ke,nt),this.minimum=Ue,this.maximum=Ze}validate(ue){return c.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function d(he,ue,Ie,Ke){if(typeof he>"u")return ue;const Ue=a.float(he,ue);return a.clamp(Ue,Ie,Ke)}e.clampedFloat=d;class a extends v{static clamp(ue,Ie,Ke){return ue<Ie?Ie:ue>Ke?Ke:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ke=parseFloat(ue);return isNaN(Ke)?Ie:Ke}constructor(ue,Ie,Ke,Ue,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ke),super(ue,Ie,Ke,Ze),this.validationFn=Ue}validate(ue){return this.validationFn(a.float(ue,this.defaultValue))}}class t extends v{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=Ke),super(ue,Ie,Ke,Ue)}validate(ue){return t.string(ue,this.defaultValue)}}function i(he,ue,Ie,Ke){return typeof he!="string"?ue:Ke&&he in Ke?Ke[he]:Ie.indexOf(he)===-1?ue:he}e.stringSet=i;class s extends v{constructor(ue,Ie,Ke,Ue,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ue,Ze.default=Ke),super(ue,Ie,Ke,Ze),this.c=Ue}validate(ue){return i(ue,this.defaultValue,this.c)}}class n extends P{constructor(ue,Ie,Ke,Ue,Ze,nt,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=Ze,ct.default=Ue),super(ue,Ie,Ke,ct),this.c=Ze,this.d=nt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function r(he){switch(he){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ke){return Ke===0?ue.accessibilitySupport:Ke}}class I extends P{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:h(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function $(he){switch(he){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(g||(e.TextEditorCursorStyle=g={}));function w(he){switch(he){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function D(he){switch(he){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class T extends k{constructor(){super(141)}compute(ue,Ie,Ke){const Ue=["monaco-editor"];return Ie.get(39)&&Ue.push(Ie.get(39)),ue.extraEditorClassName&&Ue.push(ue.extraEditorClassName),Ie.get(73)==="default"?Ue.push("mouse-default"):Ie.get(73)==="copy"&&Ue.push("mouse-copy"),Ie.get(111)&&Ue.push("showUnused"),Ie.get(139)&&Ue.push("showDeprecated"),Ue.join(" ")}}class M extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ue,Ie,Ke){return Ke&&ue.emptySelectionClipboard}}class F extends P{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:m.localize(16,null),included:f.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:m.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:h(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":i(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":i(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(Ie.loop,this.defaultValue.loop)}}}class z extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?z.OFF:ue==="true"?z.ON:ue:ue?z.ON:z.OFF}}e.EditorFontLigatures=z;class j extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?j.OFF:ue==="true"?j.TRANSLATE:ue:ue?j.TRANSLATE:j.OFF}compute(ue,Ie,Ke){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class N extends k{constructor(){super(50)}compute(ue,Ie,Ke){return ue.fontInfo}}class q extends v{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(ue){const Ie=a.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(ue,Ie,Ke){return ue.fontInfo.fontSize}}class K extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.d,maximum:K.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(c.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,K.d,K.e))}}class me extends P{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ke,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ke,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ke,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ke,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ke,description:m.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:i(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??i(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??i(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??i(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??i(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??i(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class te extends P{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:m.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),delay:c.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:h(Ie.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:h(Ie.above,this.defaultValue.above)}}}var G;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(G||(e.RenderMinimap=G={}));class J extends k{constructor(){super(144)}compute(ue,Ie,Ke){return J.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ke=Math.floor(ue.paddingTop/ue.lineHeight);let Ue=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Ue=Math.max(Ue,Ie-1));const Ze=(Ke+ue.viewLineCount+Ue)/(ue.pixelRatio*ue.height),nt=Math.floor(ue.viewLineCount/Ze);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Ue,desiredRatio:Ze,minimapLineCount:nt}}static c(ue,Ie){const Ke=ue.outerWidth,Ue=ue.outerHeight,Ze=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const nt=Ie.stableMinimapLayoutInput,ct=nt&&ue.outerHeight===nt.outerHeight&&ue.lineHeight===nt.lineHeight&&ue.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===nt.pixelRatio&&ue.scrollBeyondLastLine===nt.scrollBeyondLastLine&&ue.paddingTop===nt.paddingTop&&ue.paddingBottom===nt.paddingBottom&&ue.minimap.enabled===nt.minimap.enabled&&ue.minimap.side===nt.minimap.side&&ue.minimap.size===nt.minimap.size&&ue.minimap.showSlider===nt.minimap.showSlider&&ue.minimap.renderCharacters===nt.minimap.renderCharacters&&ue.minimap.maxColumn===nt.minimap.maxColumn&&ue.minimap.scale===nt.minimap.scale&&ue.verticalScrollbarWidth===nt.verticalScrollbarWidth&&ue.isViewportWrapping===nt.isViewportWrapping,bt=ue.lineHeight,Et=ue.typicalHalfwidthCharacterWidth,Kt=ue.scrollBeyondLastLine,Ht=ue.minimap.renderCharacters;let pt=Ze>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const zt=ue.minimap.maxColumn,Tt=ue.minimap.size,Gt=ue.minimap.side,Ut=ue.verticalScrollbarWidth,Dt=ue.viewLineCount,Ft=ue.remainingWidth,Bt=ue.isViewportWrapping,Qt=Ht?2:3;let Wt=Math.floor(Ze*Ue);const qt=Wt/Ze;let Nt=!1,ut=!1,ft=Qt*pt,At=pt/Ze,Vt=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Oe,desiredRatio:Se,minimapLineCount:ne}=J.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Kt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Ue,lineHeight:bt,pixelRatio:Ze});if(Dt/ne>1)Nt=!0,ut=!0,pt=1,ft=1,At=pt/Ze;else{let Ve=!1,xe=pt+1;if(Tt==="fit"){const Qe=Math.ceil((Me+Dt+Oe)*ft);Bt&&ct&&Ft<=Ie.stableFitRemainingWidth?(Ve=!0,xe=Ie.stableFitMaxMinimapScale):Ve=Qe>Wt}if(Tt==="fill"||Ve){Nt=!0;const Qe=pt;ft=Math.min(bt*Ze,Math.max(1,Math.floor(1/Se))),Bt&&ct&&Ft<=Ie.stableFitRemainingWidth&&(xe=Ie.stableFitMaxMinimapScale),pt=Math.min(xe,Math.max(1,Math.floor(ft/Qt))),pt>Qe&&(Vt=Math.min(2,pt/Qe)),At=pt/Ze/Vt,Wt=Math.ceil(Math.max(Jt,Me+Dt+Oe)*ft),Bt?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=Ft,Ie.stableFitMaxMinimapScale=pt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Rt=Math.floor(zt*At),at=Math.min(Rt,Math.max(0,Math.floor((Ft-Ut-2)*At/(Et+At)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(Ze*at);const Ot=vt/Ze;vt=Math.floor(vt*Vt);const Pt=Ht?1:2,Ge=Gt==="left"?0:Ke-at-Ut;return{renderMinimap:Pt,minimapLeft:Ge,minimapWidth:at,minimapHeightIsEditorHeight:Nt,minimapIsSampling:ut,minimapScale:pt,minimapLineHeight:ft,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Ot,minimapCanvasOuterHeight:qt}}static computeLayout(ue,Ie){const Ke=Ie.outerWidth|0,Ue=Ie.outerHeight|0,Ze=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,ct=Ie.typicalHalfwidthCharacterWidth,bt=Ie.maxDigitWidth,Et=Ie.pixelRatio,Kt=Ie.viewLineCount,Ht=ue.get(136),pt=Ht==="inherit"?ue.get(135):Ht,zt=pt==="inherit"?ue.get(131):pt,Tt=ue.get(134),Gt=Ie.isDominatedByLongLines,Ut=ue.get(57),Dt=ue.get(67).renderType!==0,Ft=ue.get(68),Bt=ue.get(105),Qt=ue.get(84),Wt=ue.get(72),qt=ue.get(103),Nt=qt.verticalScrollbarSize,ut=qt.verticalHasArrows,ft=qt.arrowSize,At=qt.horizontalScrollbarSize,Vt=ue.get(43),Rt=ue.get(110)!=="never";let at=ue.get(65);Vt&&Rt&&(at+=16);let vt=0;if(Dt){const kt=Math.max(nt,Ft);vt=Math.round(kt*bt)}let Ot=0;Ut&&(Ot=Ze*Ie.glyphMarginDecorationLaneCount);let Pt=0,Ge=Pt+Ot,Jt=Ge+vt,Me=Jt+at;const Oe=Ke-Ot-vt-at;let Se=!1,ne=!1,Fe=-1;pt==="inherit"&&Gt?(Se=!0,ne=!0):zt==="on"||zt==="bounded"?ne=!0:zt==="wordWrapColumn"&&(Fe=Tt);const Ve=J.c({outerWidth:Ke,outerHeight:Ue,lineHeight:Ze,typicalHalfwidthCharacterWidth:ct,pixelRatio:Et,scrollBeyondLastLine:Bt,paddingTop:Qt.top,paddingBottom:Qt.bottom,minimap:Wt,verticalScrollbarWidth:Nt,viewLineCount:Kt,remainingWidth:Oe,isViewportWrapping:ne},Ie.memory||new L);Ve.renderMinimap!==0&&Ve.minimapLeft===0&&(Pt+=Ve.minimapWidth,Ge+=Ve.minimapWidth,Jt+=Ve.minimapWidth,Me+=Ve.minimapWidth);const xe=Oe-Ve.minimapWidth,Qe=Math.max(1,Math.floor((xe-Nt-2)/ct)),rt=ut?ft:0;return ne&&(Fe=Math.max(1,Qe),zt==="bounded"&&(Fe=Math.min(Fe,Tt))),{width:Ke,height:Ue,glyphMarginLeft:Pt,glyphMarginWidth:Ot,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Ge,lineNumbersWidth:vt,decorationsLeft:Jt,decorationsWidth:at,contentLeft:Me,contentWidth:xe,minimap:Ve,viewportColumn:Qe,isWordWrapMinified:Se,isViewportWrapping:ne,wrappingColumn:Fe,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:At,overviewRuler:{top:rt,width:Nt,height:Ue-2*rt,right:0}}}}e.EditorLayoutInfoComputer=J;class le extends P{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(ue){return i(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}class ie extends P{constructor(){const ue={enabled:!0};super(64,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"boolean",default:ue.enabled,description:m.localize(50,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:h(ue.enabled,this.defaultValue.enabled)}}}class ce extends P{constructor(){const ue={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:m.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:10,description:m.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:m.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:m.localize(54,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:i(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:h(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ye extends P{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:m.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(56,null),m.localize(57,null,f.$k?"Ctrl+Option":"Ctrl+Alt"),m.localize(58,null,f.$k?"Ctrl+Option":"Ctrl+Alt"),m.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:m.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:m.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:m.localize(62,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:i(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:h(Ie.padding,this.defaultValue.padding)}}}class H extends P{constructor(){super(65,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):c.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ke){return Ke<0?c.clampedInt(-Ke*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class B extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>a.clamp(ue,0,150),{markdownDescription:m.localize(63,null)})}compute(ue,Ie,Ke){return ue.fontInfo.lineHeight}}class Y extends P{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:m.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:m.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:ue.size,description:m.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:m.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:m.localize(71,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:m.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:m.localize(74,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),autohide:h(Ie.autohide,this.defaultValue.autohide),size:i(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(Ie.side,this.defaultValue.side,["right","left"]),showSlider:i(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Ie.scale,1,1,3),maxColumn:c.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function re(he){return he==="ctrlCmd"?f.$k?"metaKey":"ctrlKey":"altKey"}class X extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(76,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:c.clampedInt(Ie.top,0,0,1e3),bottom:c.clampedInt(Ie.bottom,0,0,1e3)}}}class _ extends P{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:m.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:m.localize(78,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),cycle:h(Ie.cycle,this.defaultValue.cycle)}}}class x extends k{constructor(){super(142)}compute(ue,Ie,Ke){return ue.pixelRatio}}class pe extends P{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(79,null),m.localize(80,null),m.localize(81,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:m.localize(82,null)},comments:{anyOf:Ie,default:ue.comments,description:m.localize(83,null)},other:{anyOf:Ie,default:ue.other,description:m.localize(84,null)}},default:ue,markdownDescription:m.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const Et=ue?"on":"off";return{comments:Et,strings:Et,other:Et}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Ue}=ue,Ze=["on","inline","off"];let nt,ct,bt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=i(Ie,this.defaultValue.other,Ze),typeof Ke=="boolean"?ct=Ke?"on":"off":ct=i(Ke,this.defaultValue.comments,Ze),typeof Ue=="boolean"?bt=Ue?"on":"off":bt=i(Ue,this.defaultValue.strings,Ze),{other:nt,comments:ct,strings:bt}}}var ae;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(ae||(e.RenderLineNumbersType=ae={}));class fe extends P{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(86,null),m.localize(87,null),m.localize(88,null),m.localize(89,null)],default:"on",description:m.localize(90,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ke=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function ee(he){const ue=he.get(98);return ue==="editable"?he.get(91):ue!=="on"}e.filterValidationDecorations=ee;class de extends P{constructor(){const ue=[],Ie={type:"number",description:m.localize(91,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:m.localize(92,null),format:"color-hex"}}}]},default:ue,description:m.localize(93,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ke of ue)if(typeof Ke=="number")Ie.push({column:c.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Ue=Ke;Ie.push({column:c.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return Ie.sort((Ke,Ue)=>Ke.column-Ue.column),Ie}return this.defaultValue}}class be extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(he,ue){if(typeof he!="string")return ue;switch(he){case"hidden":return 2;case"visible":return 3;default:return 1}}class U extends P{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(94,null),m.localize(95,null),m.localize(96,null)],default:"auto",description:m.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:m.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:m.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:m.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:m.localize(105,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ke=c.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=c.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:h(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:c.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:c.clampedInt(Ie.verticalSliderSize,Ue,0,1e3),scrollByPage:h(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:h(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends P{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:m.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:m.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:m.localize(112,null)}})}applyUpdate(ue,Ie){let Ke=!1;Ie.allowedCharacters&&ue&&(O.$_m(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ue&&(O.$_m(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ke=!0));const Ue=super.applyUpdate(ue,Ie);return Ke?new p(Ue.newValue,!0):Ue}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:ge(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ke={};for(const[Ue,Ze]of Object.entries(ue))Ze===!0&&(Ke[Ue]=!0);return Ke}}class se extends P{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:m.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover"],enumDescriptions:[m.localize(114,null),m.localize(115,null)],description:m.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:m.localize(117,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),mode:i(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:h(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:h(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends P{constructor(){const ue={enabled:R.$7r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$7r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:m.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:m.localize(119,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends P{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(120,null),m.localize(121,null),m.localize(122,null)],default:ue.bracketPairs,description:m.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(124,null),m.localize(125,null),m.localize(126,null)],default:ue.bracketPairsHorizontal,description:m.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:m.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:m.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(130,null),m.localize(131,null),m.localize(132,null)],default:ue.highlightActiveIndentation,description:m.localize(133,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:ge(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(he,ue,Ie){const Ke=Ie.indexOf(he);return Ke===-1?ue:Ie[Ke]}class Ee extends P{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(134,null),m.localize(135,null)],default:ue.insertMode,description:m.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:m.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:m.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:m.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(140,null),m.localize(141,null),m.localize(142,null),m.localize(143,null)],default:ue.selectionMode,markdownDescription:m.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:m.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:m.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:m.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:m.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:m.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:i(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:h(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:h(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:h(Ie.preview,this.defaultValue.preview),previewMode:i(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(Ie.showMethods,this.defaultValue.showMethods),showFunctions:h(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:h(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:h(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:h(Ie.showFields,this.defaultValue.showFields),showVariables:h(Ie.showVariables,this.defaultValue.showVariables),showClasses:h(Ie.showClasses,this.defaultValue.showClasses),showStructs:h(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:h(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:h(Ie.showModules,this.defaultValue.showModules),showProperties:h(Ie.showProperties,this.defaultValue.showProperties),showEvents:h(Ie.showEvents,this.defaultValue.showEvents),showOperators:h(Ie.showOperators,this.defaultValue.showOperators),showUnits:h(Ie.showUnits,this.defaultValue.showUnits),showValues:h(Ie.showValues,this.defaultValue.showValues),showConstants:h(Ie.showConstants,this.defaultValue.showConstants),showEnums:h(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:h(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(Ie.showKeywords,this.defaultValue.showKeywords),showWords:h(Ie.showWords,this.defaultValue.showWords),showColors:h(Ie.showColors,this.defaultValue.showColors),showFiles:h(Ie.showFiles,this.defaultValue.showFiles),showReferences:h(Ie.showReferences,this.defaultValue.showReferences),showFolders:h(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:h(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:h(Ie.showUsers,this.defaultValue.showUsers),showIssues:h(Ie.showIssues,this.defaultValue.showIssues)}}}class ze extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(183,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:h(ue.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends P{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(184,null),m.localize(185,null),m.localize(186,null),m.localize(187,null)],description:m.localize(188,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ke){return Ie.get(2)===2?0:Ke}}class Ye extends k{constructor(){super(145)}compute(ue,Ie,Ke){const Ue=Ie.get(144);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class it extends P{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:m.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(191,null),m.localize(192,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),showDropSelector:i(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends P{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:m.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(195,null),m.localize(196,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),showPasteSelector:i(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$k?Te:f.$l?qe:Ae,fontWeight:"normal",fontSize:f.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(he){return e.editorOptionsRegistry[he.id]=he,he}var Xe;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.letterSpacing=63]="letterSpacing",he[he.lightbulb=64]="lightbulb",he[he.lineDecorationsWidth=65]="lineDecorationsWidth",he[he.lineHeight=66]="lineHeight",he[he.lineNumbers=67]="lineNumbers",he[he.lineNumbersMinChars=68]="lineNumbersMinChars",he[he.linkedEditing=69]="linkedEditing",he[he.links=70]="links",he[he.matchBrackets=71]="matchBrackets",he[he.minimap=72]="minimap",he[he.mouseStyle=73]="mouseStyle",he[he.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=75]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",he[he.multiCursorModifier=77]="multiCursorModifier",he[he.multiCursorPaste=78]="multiCursorPaste",he[he.multiCursorLimit=79]="multiCursorLimit",he[he.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",he[he.occurrencesHighlight=81]="occurrencesHighlight",he[he.overviewRulerBorder=82]="overviewRulerBorder",he[he.overviewRulerLanes=83]="overviewRulerLanes",he[he.padding=84]="padding",he[he.pasteAs=85]="pasteAs",he[he.parameterHints=86]="parameterHints",he[he.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",he[he.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",he[he.quickSuggestions=89]="quickSuggestions",he[he.quickSuggestionsDelay=90]="quickSuggestionsDelay",he[he.readOnly=91]="readOnly",he[he.readOnlyMessage=92]="readOnlyMessage",he[he.renameOnType=93]="renameOnType",he[he.renderControlCharacters=94]="renderControlCharacters",he[he.renderFinalNewline=95]="renderFinalNewline",he[he.renderLineHighlight=96]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=98]="renderValidationDecorations",he[he.renderWhitespace=99]="renderWhitespace",he[he.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",he[he.roundedSelection=101]="roundedSelection",he[he.rulers=102]="rulers",he[he.scrollbar=103]="scrollbar",he[he.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=105]="scrollBeyondLastLine",he[he.scrollPredominantAxis=106]="scrollPredominantAxis",he[he.selectionClipboard=107]="selectionClipboard",he[he.selectionHighlight=108]="selectionHighlight",he[he.selectOnLineNumbers=109]="selectOnLineNumbers",he[he.showFoldingControls=110]="showFoldingControls",he[he.showUnused=111]="showUnused",he[he.snippetSuggestions=112]="snippetSuggestions",he[he.smartSelect=113]="smartSelect",he[he.smoothScrolling=114]="smoothScrolling",he[he.stickyScroll=115]="stickyScroll",he[he.stickyTabStops=116]="stickyTabStops",he[he.stopRenderingLineAfter=117]="stopRenderingLineAfter",he[he.suggest=118]="suggest",he[he.suggestFontSize=119]="suggestFontSize",he[he.suggestLineHeight=120]="suggestLineHeight",he[he.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",he[he.suggestSelection=122]="suggestSelection",he[he.tabCompletion=123]="tabCompletion",he[he.tabIndex=124]="tabIndex",he[he.unicodeHighlighting=125]="unicodeHighlighting",he[he.unusualLineTerminators=126]="unusualLineTerminators",he[he.useShadowDOM=127]="useShadowDOM",he[he.useTabStops=128]="useTabStops",he[he.wordBreak=129]="wordBreak",he[he.wordSeparators=130]="wordSeparators",he[he.wordWrap=131]="wordWrap",he[he.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=134]="wordWrapColumn",he[he.wordWrapOverride1=135]="wordWrapOverride1",he[he.wordWrapOverride2=136]="wordWrapOverride2",he[he.wrappingIndent=137]="wrappingIndent",he[he.wrappingStrategy=138]="wrappingStrategy",he[he.showDeprecated=139]="showDeprecated",he[he.inlayHints=140]="inlayHints",he[he.editorClassName=141]="editorClassName",he[he.pixelRatio=142]="pixelRatio",he[he.tabFocusMode=143]="tabFocusMode",he[he.layoutInfo=144]="layoutInfo",he[he.wrappingInfo=145]="wrappingInfo",he[he.defaultColorDecorators=146]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(197,null)})),acceptSuggestionOnEnter:Le(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(198,null),""],markdownDescription:m.localize(199,null)})),accessibilitySupport:Le(new u),accessibilityPageSize:Le(new c(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(200,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",m.localize(201,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Le(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(203,null),m.localize(204,null),""],description:m.localize(205,null)})),autoClosingComments:Le(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(206,null),m.localize(207,null),""],description:m.localize(208,null)})),autoClosingDelete:Le(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(209,null),""],description:m.localize(210,null)})),autoClosingOvertype:Le(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(211,null),""],description:m.localize(212,null)})),autoClosingQuotes:Le(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(213,null),m.localize(214,null),""],description:m.localize(215,null)})),autoIndent:Le(new n(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[m.localize(216,null),m.localize(217,null),m.localize(218,null),m.localize(219,null),m.localize(220,null)],description:m.localize(221,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(222,null),m.localize(223,null),m.localize(224,null),""],description:m.localize(225,null)})),bracketPairColorization:Le(new oe),bracketPairGuides:Le(new Z),stickyTabStops:Le(new o(116,"stickyTabStops",!1,{description:m.localize(226,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:m.localize(227,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:m.localize(228,null)})),codeLensFontSize:Le(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(229,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:m.localize(230,null)})),colorDecoratorActivatedOn:Le(new s(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(231,null),m.localize(232,null),m.localize(233,null)],description:m.localize(234,null)})),colorDecoratorsLimit:Le(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(235,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:m.localize(236,null)})),comments:Le(new I),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(237,null)})),cursorBlinking:Le(new n(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:m.localize(238,null)})),cursorSmoothCaretAnimation:Le(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(239,null),m.localize(240,null),m.localize(241,null)],description:m.localize(242,null)})),cursorStyle:Le(new n(28,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:m.localize(243,null)})),cursorSurroundingLines:Le(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(244,null)})),cursorSurroundingLinesStyle:Le(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(245,null),m.localize(246,null)],markdownDescription:m.localize(247,null)})),cursorWidth:Le(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(248,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:m.localize(249,null)})),emptySelectionClipboard:Le(new M),dropIntoEditor:Le(new it),stickyScroll:Le(new ce),experimentalWhitespaceRendering:Le(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(250,null),m.localize(251,null),m.localize(252,null)],description:m.localize(253,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new a(40,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:m.localize(254,null)})),find:Le(new F),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:m.localize(255,null)})),foldingStrategy:Le(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:m.localize(259,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:m.localize(260,null)})),foldingMaximumRegions:Le(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(261,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(262,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(263,null)})),fontInfo:Le(new N),fontLigatures2:Le(new z),fontSize:Le(new q),fontWeight:Le(new K),fontVariations:Le(new j),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:m.localize(264,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:m.localize(265,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:m.localize(266,null)})),gotoLocation:Le(new me),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:m.localize(267,null)})),hover:Le(new te),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>a.clamp(he,-5,20),{description:m.localize(268,null)})),lightbulb:Le(new ie),lineDecorationsWidth:Le(new H),lineHeight:Le(new B),lineNumbers:Le(new fe),lineNumbersMinChars:Le(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(69,"linkedEditing",!1,{description:m.localize(269,null)})),links:Le(new o(70,"links",!0,{description:m.localize(270,null)})),matchBrackets:Le(new s(71,"matchBrackets","always",["always","near","never"],{description:m.localize(271,null)})),minimap:Le(new Y),mouseStyle:Le(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new a(74,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:m.localize(272,null)})),mouseWheelZoom:Le(new o(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(273,null)})),multiCursorMergeOverlapping:Le(new o(76,"multiCursorMergeOverlapping",!0,{description:m.localize(274,null)})),multiCursorModifier:Le(new n(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],re,{markdownEnumDescriptions:[m.localize(275,null),m.localize(276,null)],markdownDescription:m.localize(277,null)})),multiCursorPaste:Le(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(278,null),m.localize(279,null)],markdownDescription:m.localize(280,null)})),multiCursorLimit:Le(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(281,null)})),occurrencesHighlight:Le(new o(81,"occurrencesHighlight",!0,{description:m.localize(282,null)})),multiDocumentOccurrencesHighlight:Le(new o(80,"multiDocumentOccurrencesHighlight",!1,{description:m.localize(283,null)})),overviewRulerBorder:Le(new o(82,"overviewRulerBorder",!0,{description:m.localize(284,null)})),overviewRulerLanes:Le(new c(83,"overviewRulerLanes",3,0,3)),padding:Le(new X),pasteAs:Le(new tt),parameterHints:Le(new _),peekWidgetDefaultFocus:Le(new s(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(285,null),m.localize(286,null)],description:m.localize(287,null)})),definitionLinkOpensInPeek:Le(new o(88,"definitionLinkOpensInPeek",!1,{description:m.localize(288,null)})),quickSuggestions:Le(new pe),quickSuggestionsDelay:Le(new c(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(289,null)})),readOnly:Le(new o(91,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new o(93,"renameOnType",!1,{description:m.localize(290,null),markdownDeprecationMessage:m.localize(291,null)})),renderControlCharacters:Le(new o(94,"renderControlCharacters",!0,{description:m.localize(292,null),restricted:!0})),renderFinalNewline:Le(new s(95,"renderFinalNewline",f.$l?"dimmed":"on",["off","on","dimmed"],{description:m.localize(293,null)})),renderLineHighlight:Le(new s(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(294,null)],description:m.localize(295,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(296,null)})),renderValidationDecorations:Le(new s(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new s(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(297,null),m.localize(298,null),m.localize(299,null),""],description:m.localize(300,null)})),revealHorizontalRightPadding:Le(new c(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(101,"roundedSelection",!0,{description:m.localize(301,null)})),rulers:Le(new de),scrollbar:Le(new U),scrollBeyondLastColumn:Le(new c(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(302,null)})),scrollBeyondLastLine:Le(new o(105,"scrollBeyondLastLine",!0,{description:m.localize(303,null)})),scrollPredominantAxis:Le(new o(106,"scrollPredominantAxis",!0,{description:m.localize(304,null)})),selectionClipboard:Le(new o(107,"selectionClipboard",!0,{description:m.localize(305,null),included:f.$l})),selectionHighlight:Le(new o(108,"selectionHighlight",!0,{description:m.localize(306,null)})),selectOnLineNumbers:Le(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Le(new s(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(307,null),m.localize(308,null),m.localize(309,null)],description:m.localize(310,null)})),showUnused:Le(new o(111,"showUnused",!0,{description:m.localize(311,null)})),showDeprecated:Le(new o(139,"showDeprecated",!0,{description:m.localize(312,null)})),inlayHints:Le(new ye),snippetSuggestions:Le(new s(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(313,null),m.localize(314,null),m.localize(315,null),m.localize(316,null)],description:m.localize(317,null)})),smartSelect:Le(new ze),smoothScrolling:Le(new o(114,"smoothScrolling",!1,{description:m.localize(318,null)})),stopRenderingLineAfter:Le(new c(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Ee),inlineSuggest:Le(new se),inlineCompletionsAccessibilityVerbose:Le(new o(148,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(319,null)})),suggestFontSize:Le(new c(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new c(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(121,"suggestOnTriggerCharacters",!0,{description:m.localize(322,null)})),suggestSelection:Le(new s(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(323,null),m.localize(324,null),m.localize(325,null)],description:m.localize(326,null)})),tabCompletion:Le(new s(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(327,null),m.localize(328,null),m.localize(329,null)],description:m.localize(330,null)})),tabIndex:Le(new c(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Q),unusualLineTerminators:Le(new s(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(331,null),m.localize(332,null),m.localize(333,null)],description:m.localize(334,null)})),useShadowDOM:Le(new o(127,"useShadowDOM",!0)),useTabStops:Le(new o(128,"useTabStops",!0,{description:m.localize(335,null)})),wordBreak:Le(new s(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(336,null),m.localize(337,null)],description:m.localize(338,null)})),wordSeparators:Le(new t(130,"wordSeparators",A.$8r,{description:m.localize(339,null)})),wordWrap:Le(new s(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(340,null),m.localize(341,null),m.localize(342,null),m.localize(343,null)],description:m.localize(344,null)})),wordWrapBreakAfterCharacters:Le(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new c(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(345,null)})),wordWrapOverride1:Le(new s(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new s(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new T),defaultColorDecorators:Le(new o(146,"defaultColorDecorators",!1,{markdownDescription:m.localize(346,null)})),pixelRatio:Le(new x),tabFocusMode:Le(new o(143,"tabFocusMode",!1,{markdownDescription:m.localize(347,null)})),layoutInfo:Le(new J),wrappingInfo:Le(new Ye),wrappingIndent:Le(new _e),wrappingStrategy:Le(new le)}}),define(De[187],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(De[83],Ce([1,0,79,2,164,32,174,187]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$ot=e.$nt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$mt=e.$lt=e.SymbolKinds=e.SymbolTag=e.$kt=e.$jt=e.SymbolKind=e.$it=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$ht=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$gt=e.$ft=e.$et=void 0;class E{constructor(z,j,N){this.offset=z,this.type=j,this.language=N,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$et=E;class b{constructor(z,j){this.tokens=z,this.endState=j,this._tokenizationResultBrand=void 0}}e.$ft=b;class L{constructor(z,j){this.tokens=z,this.endState=j,this._encodedTokenizationResultBrand=void 0}}e.$gt=L;var P;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var p;(function(F){const z=new Map;z.set(0,C.$Vj.symbolMethod),z.set(1,C.$Vj.symbolFunction),z.set(2,C.$Vj.symbolConstructor),z.set(3,C.$Vj.symbolField),z.set(4,C.$Vj.symbolVariable),z.set(5,C.$Vj.symbolClass),z.set(6,C.$Vj.symbolStruct),z.set(7,C.$Vj.symbolInterface),z.set(8,C.$Vj.symbolModule),z.set(9,C.$Vj.symbolProperty),z.set(10,C.$Vj.symbolEvent),z.set(11,C.$Vj.symbolOperator),z.set(12,C.$Vj.symbolUnit),z.set(13,C.$Vj.symbolValue),z.set(15,C.$Vj.symbolEnum),z.set(14,C.$Vj.symbolConstant),z.set(15,C.$Vj.symbolEnum),z.set(16,C.$Vj.symbolEnumMember),z.set(17,C.$Vj.symbolKeyword),z.set(27,C.$Vj.symbolSnippet),z.set(18,C.$Vj.symbolText),z.set(19,C.$Vj.symbolColor),z.set(20,C.$Vj.symbolFile),z.set(21,C.$Vj.symbolReference),z.set(22,C.$Vj.symbolCustomColor),z.set(23,C.$Vj.symbolFolder),z.set(24,C.$Vj.symbolTypeParameter),z.set(25,C.$Vj.account),z.set(26,C.$Vj.issues);function j(K){let me=z.get(K);return me||(console.info("No codicon found for CompletionItemKind "+K),me=C.$Vj.symbolProperty),me}F.toIcon=j;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function q(K,me){let te=N.get(K);return typeof te>"u"&&!me&&(te=9),te}F.fromString=q})(p||(e.CompletionItemKinds=p={}));var y;(function(F){F[F.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var k;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var v;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(e.CompletionTriggerKind=v={}));var h;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(h||(e.InlineCompletionTriggerKind=h={}));class o{constructor(z,j,N,q){this.range=z,this.text=j,this.completionKind=N,this.isSnippetText=q}equals(z){return R.$xs.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}e.$ht=o;var l;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(l||(e.CodeActionTriggerType=l={}));var c;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(c||(e.SignatureHelpTriggerKind=c={}));var d;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(d||(e.DocumentHighlightKind=d={}));function a(F){return F&&O.URI.isUri(F.uri)&&R.$xs.isIRange(F.range)&&(R.$xs.isIRange(F.originSelectionRange)||R.$xs.isIRange(F.targetSelectionRange))}e.$it=a;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$jt={[17]:(0,m.localize)(0,null),[16]:(0,m.localize)(1,null),[4]:(0,m.localize)(2,null),[13]:(0,m.localize)(3,null),[8]:(0,m.localize)(4,null),[9]:(0,m.localize)(5,null),[21]:(0,m.localize)(6,null),[23]:(0,m.localize)(7,null),[7]:(0,m.localize)(8,null),[0]:(0,m.localize)(9,null),[11]:(0,m.localize)(10,null),[10]:(0,m.localize)(11,null),[19]:(0,m.localize)(12,null),[5]:(0,m.localize)(13,null),[1]:(0,m.localize)(14,null),[2]:(0,m.localize)(15,null),[20]:(0,m.localize)(16,null),[15]:(0,m.localize)(17,null),[18]:(0,m.localize)(18,null),[24]:(0,m.localize)(19,null),[3]:(0,m.localize)(20,null),[6]:(0,m.localize)(21,null),[14]:(0,m.localize)(22,null),[22]:(0,m.localize)(23,null),[25]:(0,m.localize)(24,null),[12]:(0,m.localize)(25,null)};function i(F,z){return(0,m.localize)(26,null,F,e.$jt[z])}e.$kt=i;var s;(function(F){F[F.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var n;(function(F){const z=new Map;z.set(0,C.$Vj.symbolFile),z.set(1,C.$Vj.symbolModule),z.set(2,C.$Vj.symbolNamespace),z.set(3,C.$Vj.symbolPackage),z.set(4,C.$Vj.symbolClass),z.set(5,C.$Vj.symbolMethod),z.set(6,C.$Vj.symbolProperty),z.set(7,C.$Vj.symbolField),z.set(8,C.$Vj.symbolConstructor),z.set(9,C.$Vj.symbolEnum),z.set(10,C.$Vj.symbolInterface),z.set(11,C.$Vj.symbolFunction),z.set(12,C.$Vj.symbolVariable),z.set(13,C.$Vj.symbolConstant),z.set(14,C.$Vj.symbolString),z.set(15,C.$Vj.symbolNumber),z.set(16,C.$Vj.symbolBoolean),z.set(17,C.$Vj.symbolArray),z.set(18,C.$Vj.symbolObject),z.set(19,C.$Vj.symbolKey),z.set(20,C.$Vj.symbolNull),z.set(21,C.$Vj.symbolEnumMember),z.set(22,C.$Vj.symbolStruct),z.set(23,C.$Vj.symbolEvent),z.set(24,C.$Vj.symbolOperator),z.set(25,C.$Vj.symbolTypeParameter);function j(N){let q=z.get(N);return q||(console.info("No codicon found for SymbolKind "+N),q=C.$Vj.symbolProperty),q}F.toIcon=j})(n||(e.SymbolKinds=n={}));class r{static asEditOperation(z){return f.$ys.replace(R.$xs.lift(z.range),z.text)}}e.$lt=r;class u{static{this.Comment=new u("comment")}static{this.Imports=new u("imports")}static{this.Region=new u("region")}static fromValue(z){switch(z){case"comment":return u.Comment;case"imports":return u.Imports;case"region":return u.Region}return new u(z)}constructor(z){this.value=z}}e.$mt=u;var I;(function(F){function z(j){return!j||typeof j!="object"?!1:typeof j.id=="string"&&typeof j.title=="string"}F.is=z})(I||(e.Command=I={}));var S;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(S||(e.CommentThreadCollapsibleState=S={}));var $;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})($||(e.CommentThreadState=$={}));var g;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(g||(e.CommentMode=g={}));var w;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(w||(e.CommentState=w={}));var D;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(D||(e.InlayHintKind=D={}));class T{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$nt=T,e.$ot=new A.$9s;var M;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(M||(e.ExternalUriOpenerPriority=M={}))}),define(De[188],Ce([10,11]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ce([10,11]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ce([10,11]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(De[196],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(De[197],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ce([10,11]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(De[199],Ce([10,11]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ce([10,11]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ce([10,11]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(De[204],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[205],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[206],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[207],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(De[208],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[209],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(De[210],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[211],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[212],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[213],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[214],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[215],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[216],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[217],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(De[218],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(De[219],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[220],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[221],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[222],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[223],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[224],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[225],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[226],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[227],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[228],Ce([1,0,9,190]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.TokenType=void 0;var f;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(f||(e.TokenType=f={}));function R(...b){switch(b.length){case 1:return(0,O.localize)(0,null,b[0]);case 2:return(0,O.localize)(1,null,b[0],b[1]);case 3:return(0,O.localize)(2,null,b[0],b[1],b[2]);default:return}}const A=(0,O.localize)(3,null),m=(0,O.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const P=this.d,p=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:p};this.g.push({offset:P,lexeme:p,additionalInfo:L}),this.f.push(y)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const P=this.c.substring(this.d,this.e),p=E.b.get(P);p?this.k(p):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,P=!1,p=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(m);return}const k=this.c.charCodeAt(L);if(P)P=!1;else if(k===47&&!p){L++;break}else k===91?p=!0:k===92?P=!0:k===93&&(p=!1);L++}for(;L<this.c.length&&E.a.has(this.c.charCodeAt(L));)L++;this.e=L;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Li=E}),define(De[229],Ce([1,0,23,38,193,375]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function E(o){return o=o.trim(),o==="*"||A.test(o)}e.$Po=E;function b(o){if(!E(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=o.match(A);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.$Qo=b;function L(o){if(!o)return null;const l=o.majorBase,c=o.majorMustEqual,d=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let i=o.patchMustEqual;o.hasCaret&&(l===0||(a=!1),i=!1);let s=0;if(o.preRelease){const n=m.exec(o.preRelease);if(n){const[,r,u,I]=n;s=Date.UTC(Number(r),Number(u)-1,Number(I))}}return{majorBase:l,majorMustEqual:c,minorBase:d,minorMustEqual:a,patchBase:t,patchMustEqual:i,isMinimum:o.hasGreaterEquals,notBefore:s}}e.$Ro=L;function P(o,l,c){let d;typeof o=="string"?d=L(b(o)):d=o;let a;l instanceof Date?a=l.getTime():typeof l=="string"&&(a=new Date(l).getTime());let t;if(typeof c=="string"?t=L(b(c)):t=c,!d||!t)return!1;const i=d.majorBase,s=d.minorBase,n=d.patchBase;let r=t.majorBase,u=t.minorBase,I=t.patchBase;const S=t.notBefore;let $=t.majorMustEqual,g=t.minorMustEqual,w=t.patchMustEqual;return t.isMinimum?i>r?!0:i<r?!1:s>u?!0:s<u||a&&a<S?!1:n>=I:(i===1&&r===0&&(!$||!g||!w)&&(r=1,u=0,I=0,$=!0,g=!1,w=!1),i<r?!1:i>r?!$:s<u?!1:s>u?!g:n<I?!1:n>I?!w:!(a&&a<S))}e.$So=P;function p(o,l,c,d,a){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([O.default.Error,f.localize(0,null)]),t;if(typeof d.name!="string")return t.push([O.default.Error,f.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([O.default.Error,f.localize(2,null,"version")]),t;if(!d.engines)return t.push([O.default.Error,f.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([O.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!h(d.extensionDependencies))return t.push([O.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!h(d.activationEvents))return t.push([O.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([O.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([O.default.Warning,f.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([O.default.Error,f.localize(9,null,"main")]),t;{const n=(0,C.$wg)(c,d.main);(0,C.$qg)(n,c)||t.push([O.default.Warning,f.localize(10,null,n.path,c.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([O.default.Error,f.localize(11,null,"browser")]),t;{const n=(0,C.$wg)(c,d.browser);(0,C.$qg)(n,c)||t.push([O.default.Warning,f.localize(12,null,n.path,c.path)])}}if(!R.valid(d.version))return t.push([O.default.Error,f.localize(13,null)]),t;const i=[];if(!y(o,l,d,a,i))for(const n of i)t.push([O.default.Error,n]);return t}e.$To=p;function y(o,l,c,d,a){return d||typeof c.main>"u"&&typeof c.browser>"u"?!0:v(o,l,c.engines.vscode,a)}e.$Uo=y;function k(o,l,c){return o==="*"||v(l,c,o)}e.$Vo=k;function v(o,l,c,d=[]){const a=L(b(c));if(!a)return d.push(f.localize(14,null,c)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return d.push(f.localize(15,null,c)),!1}else if(!a.majorMustEqual)return d.push(f.localize(16,null,c)),!1;return P(o,l,a)?!0:(d.push(f.localize(17,null,o,c)),!1)}function h(o){if(!Array.isArray(o))return!1;for(let l=0,c=o.length;l<c;l++)if(typeof o[l]!="string")return!1;return!0}}),define(De[102],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class C{constructor(f,R=[],A=!1){this.ctor=f,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.$Nh=C}),define(De[103],Ce([1,0,102]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=e.$Ar=e.InstantiationType=void 0;const O=[];var f;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function R(m,E,b){E instanceof C.$Nh||(E=new C.$Nh(E,[],!!b)),O.push([m,E])}e.$Ar=R;function A(){return O}e.$Br=A}),define(De[230],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class C{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$fq=C;class O{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const A of this.a.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const m=this.lookupOrInsertNode(R),E=this.lookupOrInsertNode(A);m.outgoing.set(E.key,E),E.incoming.set(m.key,m)}removeNode(R){const A=this.b(R);this.a.delete(A);for(const m of this.a.values())m.outgoing.delete(A),m.incoming.delete(A)}lookupOrInsertNode(R){const A=this.b(R);let m=this.a.get(A);return m||(m=new C(A,R),this.a.set(A,m)),m}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[A,m]of this.a)R.push(`${A}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this.a){const m=new Set([R]),E=this.c(A,m);if(E)return E}}c(R,A){for(const[m,E]of R.outgoing){if(A.has(m))return[...A,m].join(" -> ");A.add(m);const b=this.c(E,A);if(b)return b;A.delete(m)}}}e.$gq=O}),define(De[5],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e._util=void 0;var C;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function m(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=m})(C||(e._util=C={})),e.$Ph=f("instantiationService");function O(A,m,E){m[C.DI_TARGET]===m?m[C.DI_DEPENDENCIES].push({id:A,index:E}):(m[C.DI_DEPENDENCIES]=[{id:A,index:E}],m[C.DI_TARGET]=m)}function f(A){if(C.serviceIds.has(A))return C.serviceIds.get(A);const m=function(E,b,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(m,E,L)};return m.toString=()=>A,C.serviceIds.set(A,m),m}e.$Qh=f;function R(A){return A}e.$Rh=R}),define(De[50],Ce([1,0,17,2,5]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.ConfigurationTarget=e.$mi=e.$li=e.$ki=void 0,e.$ki=(0,f.$Qh)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}e.$li=R;function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}e.$mi=A;var m;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function E(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ni=E;function b(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$oi=b;function L(o,l){const c=Object.create(null);for(const d in o)P(c,d,o[d],l);return c}e.$pi=L;function P(o,l,c,d){const a=l.split("."),t=a.pop();let i=o;for(let s=0;s<a.length;s++){const n=a[s];let r=i[n];switch(typeof r){case"undefined":r=i[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${l} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}i=r}if(typeof i=="object"&&i!==null)try{i[t]=c}catch{d(`Ignoring ${l} as ${a.join(".")} is ${JSON.stringify(i)}`)}else d(`Ignoring ${l} as ${a.join(".")} is ${JSON.stringify(i)}`)}e.$qi=P;function p(o,l){const c=l.split(".");y(o,c)}e.$ri=p;function y(o,l){const c=l.shift();if(l.length===0){delete o[c];return}if(Object.keys(o).indexOf(c)!==-1){const d=o[c];typeof d=="object"&&!Array.isArray(d)&&(y(d,l),Object.keys(d).length===0&&delete o[c])}}function k(o,l,c){function d(i,s){let n=i;for(const r of s){if(typeof n!="object"||n===null)return;n=n[r]}return n}const a=l.split("."),t=d(o,a);return typeof t>"u"?c:t}e.$si=k;function v(o,l,c){Object.keys(l).forEach(d=>{d!=="__proto__"&&(d in o?C.$Bf(o[d])&&C.$Bf(l[d])?v(o[d],l[d],c):c&&(o[d]=l[d]):o[d]=l[d])})}e.$ti=v;function h(o){return o.replace(/[\[\]]/g,"")}e.$ui=h}),define(De[42],Ce([1,0,12,15,228,5,189,9]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ContextKeyExprType=e.$Mi=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",C.$k),E.set("isLinux",C.$l),E.set("isWindows",C.$j),E.set("isWeb",C.$p),E.set("isMacNative",C.$k&&!C.$p),E.set("isEdge",C.$H),E.set("isFirefox",C.$F),E.set("isChrome",C.$E),E.set("isSafari",C.$G);function b(H,B){if(E.get(H)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(H,B)}e.$Mi=b;const L=Object.prototype.hasOwnProperty;var P;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const p={regexParsingWithErrorRecovery:!0},y=(0,A.localize)(0,null),k=(0,A.localize)(1,null),v=(0,A.localize)(2,null),h=(0,A.localize)(3,null),o=(0,A.localize)(4,null),l=(0,A.localize)(5,null),c=(0,A.localize)(6,null),d=(0,A.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=p){this.k=B,this.d=new f.$Li,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const Y=this.l();if(!this.E()){const re=this.D(),X=re.type===17?l:void 0;throw this.h.push({message:o,offset:re.offset,lexeme:f.$Li.getLexeme(re),additionalInfo:X}),a.c}return Y}catch(Y){if(Y!==a.c)throw Y;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const Y=this.o();B.push(Y)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const Y=this.s();B.push(Y)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),r.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const Y=this.l();return this.A(1,h),Y?.negate()}case 17:return this.z(),D.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const Y=this.l();return this.A(1,h),Y}case 17:{const Y=B.lexeme;if(this.z(),this.y(9)){const X=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),X.type!==10)throw this.B("REGEX",X);const _=X.lexeme,x=_.lastIndexOf("/"),pe=x===_.length-1?void 0:this.w(_.substring(x+1));let ae;try{ae=new RegExp(_.substring(1,x),pe)}catch{throw this.B("REGEX",X)}return N.create(Y,ae)}switch(X.type){case 10:case 19:{const _=[X.lexeme];this.z();let x=this.D(),pe=0;for(let be=0;be<X.lexeme.length;be++)X.lexeme.charCodeAt(be)===40?pe++:X.lexeme.charCodeAt(be)===41&&pe--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:pe++;break;case 1:pe--;break;case 10:case 18:for(let be=0;be<x.lexeme.length;be++)x.lexeme.charCodeAt(be)===40?pe++:X.lexeme.charCodeAt(be)===41&&pe--}if(pe<0)break;_.push(f.$Li.getLexeme(x)),this.z(),x=this.D()}const ae=_.join(""),fe=ae.lastIndexOf("/"),ee=fe===ae.length-1?void 0:this.w(ae.substring(fe+1));let de;try{de=new RegExp(ae.substring(1,fe),ee)}catch{throw this.B("REGEX",X)}return t.regex(Y,de)}case 18:{const _=X.lexeme;this.z();let x=null;if(!(0,O.$Ce)(_)){const pe=_.indexOf("/"),ae=_.lastIndexOf("/");if(pe!==ae&&pe>=0){const fe=_.slice(pe+1,ae),ee=_[ae+1]==="i"?"i":"";try{x=new RegExp(fe,ee)}catch{throw this.B("REGEX",X)}}}if(x===null)throw this.B("REGEX",X);return N.create(Y,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const X=this.u();return t.notIn(Y,X)}switch(this.D().type){case 3:{this.z();const X=this.u();if(this.x().type===18)return t.equals(Y,X);switch(X){case"true":return t.has(Y);case"false":return t.not(Y);default:return t.equals(Y,X)}}case 4:{this.z();const X=this.u();if(this.x().type===18)return t.notEquals(Y,X);switch(X){case"true":return t.not(Y);case"false":return t.has(Y);default:return t.notEquals(Y,X)}}case 5:return this.z(),z.create(Y,this.u());case 6:return this.z(),j.create(Y,this.u());case 7:return this.z(),M.create(Y,this.u());case 8:return this.z(),F.create(Y,this.u());case 13:return this.z(),t.in(Y,this.u());default:return t.has(Y)}}case 20:throw this.h.push({message:c,offset:B.offset,lexeme:"",additionalInfo:d}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,Y){if(this.C(B))return this.z();throw this.B(Y,this.D())}B(B,Y,re){const X=(0,A.localize)(8,null,B,f.$Li.getLexeme(Y)),_=Y.offset,x=f.$Li.getLexeme(Y);return this.h.push({message:X,offset:_,lexeme:x,additionalInfo:re}),a.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ni=a;class t{static false(){return r.INSTANCE}static true(){return u.INSTANCE}static has(B){return I.create(B)}static equals(B,Y){return S.create(B,Y)}static notEquals(B,Y){return w.create(B,Y)}static regex(B,Y){return N.create(B,Y)}static in(B,Y){return $.create(B,Y)}static notIn(B,Y){return g.create(B,Y)}static not(B){return D.create(B)}static and(...B){return me.create(B,null,!0)}static or(...B){return te.create(B,null,!0)}static greater(B,Y){return M.create(B,Y)}static greaterEquals(B,Y){return F.create(B,Y)}static smaller(B,Y){return z.create(B,Y)}static smallerEquals(B,Y){return j.create(B,Y)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Oi=t;function i(H){const B=new a({regexParsingWithErrorRecovery:!1});return H.map(Y=>(B.parse(Y),B.lexingErrors.length>0?B.lexingErrors.map(re=>({errorMessage:re.additionalInfo?(0,A.localize)(9,null,re.additionalInfo):(0,A.localize)(10,null),offset:re.offset,length:re.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(re=>({errorMessage:re.additionalInfo?`${re.message}. ${re.additionalInfo}`:re.message,offset:re.offset,length:re.lexeme.length})):[]))}e.$Pi=i;function s(H,B){const Y=H?H.substituteConstants():void 0,re=B?B.substituteConstants():void 0;return!Y&&!re?!0:!Y||!re?!1:Y.equals(re)}e.$Qi=s;function n(H,B){return H.cmp(B)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return u.INSTANCE}}e.$Ri=r;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return r.INSTANCE}}e.$Si=u;class I{static create(B,Y=null){const re=E.get(B);return typeof re=="boolean"?re?u.INSTANCE:r.INSTANCE:new I(B,Y)}constructor(B,Y){this.key=B,this.c=Y,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:J(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=E.get(this.key);return typeof B=="boolean"?B?u.INSTANCE:r.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$Ti=I;class S{static create(B,Y,re=null){if(typeof Y=="boolean")return Y?I.create(B,re):D.create(B,re);const X=E.get(B);return typeof X=="boolean"?Y===(X?"true":"false")?u.INSTANCE:r.INSTANCE:new S(B,Y,re)}constructor(B,Y,re){this.c=B,this.d=Y,this.f=re,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const Y=B?"true":"false";return this.d===Y?u.INSTANCE:r.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Ui=S;class ${static create(B,Y){return new $(B,Y)}constructor(B,Y){this.d=B,this.f=Y,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:le(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const Y=B.getValue(this.f),re=B.getValue(this.d);return Array.isArray(Y)?Y.includes(re):typeof re=="string"&&typeof Y=="object"&&Y!==null?L.call(Y,re):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$Vi=$;class g{static create(B,Y){return new g(B,Y)}constructor(B,Y){this.d=B,this.f=Y,this.type=11,this.c=$.create(B,Y)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Wi=g;class w{static create(B,Y,re=null){if(typeof Y=="boolean")return Y?D.create(B,re):I.create(B,re);const X=E.get(B);return typeof X=="boolean"?Y===(X?"true":"false")?r.INSTANCE:u.INSTANCE:new w(B,Y,re)}constructor(B,Y,re){this.c=B,this.d=Y,this.f=re,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const Y=B?"true":"false";return this.d===Y?r.INSTANCE:u.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Xi=w;class D{static create(B,Y=null){const re=E.get(B);return typeof re=="boolean"?re?r.INSTANCE:u.INSTANCE:new D(B,Y)}constructor(B,Y){this.c=B,this.d=Y,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:J(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=E.get(this.c);return typeof B=="boolean"?B?r.INSTANCE:u.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Yi=D;function T(H,B){if(typeof H=="string"){const Y=parseFloat(H);isNaN(Y)||(H=Y)}return typeof H=="string"||typeof H=="number"?B(H):r.INSTANCE}class M{static create(B,Y,re=null){return T(Y,X=>new M(B,X,re))}constructor(B,Y,re){this.c=B,this.d=Y,this.f=re,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Zi=M;class F{static create(B,Y,re=null){return T(Y,X=>new F(B,X,re))}constructor(B,Y,re){this.c=B,this.d=Y,this.f=re,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$1i=F;class z{static create(B,Y,re=null){return T(Y,X=>new z(B,X,re))}constructor(B,Y,re){this.c=B,this.d=Y,this.f=re,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$2i=z;class j{static create(B,Y,re=null){return T(Y,X=>new j(B,X,re))}constructor(B,Y,re){this.c=B,this.d=Y,this.f=re,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$3i=j;class N{static create(B,Y){return new N(B,Y)}constructor(B,Y){this.d=B,this.f=Y,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const Y=this.f?this.f.source:"",re=B.f?B.f.source:"";return Y<re?-1:Y>re?1:0}equals(B){if(B.type===this.type){const Y=this.f?this.f.source:"",re=B.f?B.f.source:"";return this.d===B.d&&Y===re}return!1}substituteConstants(){return this}evaluate(B){const Y=B.getValue(this.d);return this.f?this.f.test(Y):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=q.create(this)),this.c}}e.$4i=N;class q{static create(B){return new q(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new q(this.c.map(B))}negate(){return this.c}}e.$5i=q;function K(H){let B=null;for(let Y=0,re=H.length;Y<re;Y++){const X=H[Y].substituteConstants();if(H[Y]!==X&&B===null){B=[];for(let _=0;_<Y;_++)B[_]=H[_]}B!==null&&(B[Y]=X)}return B===null?H:B}class me{static create(B,Y,re){return me.d(B,Y,re)}constructor(B,Y){this.expr=B,this.c=Y,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let Y=0,re=this.expr.length;Y<re;Y++){const X=n(this.expr[Y],B.expr[Y]);if(X!==0)return X}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let Y=0,re=this.expr.length;Y<re;Y++)if(!this.expr[Y].equals(B.expr[Y]))return!1;return!0}return!1}substituteConstants(){const B=K(this.expr);return B===this.expr?this:me.create(B,this.c,!1)}evaluate(B){for(let Y=0,re=this.expr.length;Y<re;Y++)if(!this.expr[Y].evaluate(B))return!1;return!0}static d(B,Y,re){const X=[];let _=!1;for(const x of B)if(x){if(x.type===1){_=!0;continue}if(x.type===0)return r.INSTANCE;if(x.type===6){X.push(...x.expr);continue}X.push(x)}if(X.length===0&&_)return u.INSTANCE;if(X.length!==0){if(X.length===1)return X[0];X.sort(n);for(let x=1;x<X.length;x++)X[x-1].equals(X[x])&&(X.splice(x,1),x--);if(X.length===1)return X[0];for(;X.length>1;){const x=X[X.length-1];if(x.type!==9)break;X.pop();const pe=X.pop(),ae=X.length===0,fe=te.create(x.expr.map(ee=>me.create([ee,pe],null,re)),null,ae);fe&&(X.push(fe),X.sort(n))}if(X.length===1)return X[0];if(re){for(let x=0;x<X.length;x++)for(let pe=x+1;pe<X.length;pe++)if(X[x].negate().equals(X[pe]))return r.INSTANCE;if(X.length===1)return X[0]}return new me(X,Y)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const Y of this.expr)B.push(...Y.keys());return B}map(B){return new me(this.expr.map(Y=>Y.map(B)),null)}negate(){if(!this.c){const B=[];for(const Y of this.expr)B.push(Y.negate());this.c=te.create(B,this,!0)}return this.c}}e.$6i=me;class te{static create(B,Y,re){return te.d(B,Y,re)}constructor(B,Y){this.expr=B,this.c=Y,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let Y=0,re=this.expr.length;Y<re;Y++){const X=n(this.expr[Y],B.expr[Y]);if(X!==0)return X}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let Y=0,re=this.expr.length;Y<re;Y++)if(!this.expr[Y].equals(B.expr[Y]))return!1;return!0}return!1}substituteConstants(){const B=K(this.expr);return B===this.expr?this:te.create(B,this.c,!1)}evaluate(B){for(let Y=0,re=this.expr.length;Y<re;Y++)if(this.expr[Y].evaluate(B))return!0;return!1}static d(B,Y,re){let X=[],_=!1;if(B){for(let x=0,pe=B.length;x<pe;x++){const ae=B[x];if(ae){if(ae.type===0){_=!0;continue}if(ae.type===1)return u.INSTANCE;if(ae.type===9){X=X.concat(ae.expr);continue}X.push(ae)}}if(X.length===0&&_)return r.INSTANCE;X.sort(n)}if(X.length!==0){if(X.length===1)return X[0];for(let x=1;x<X.length;x++)X[x-1].equals(X[x])&&(X.splice(x,1),x--);if(X.length===1)return X[0];if(re){for(let x=0;x<X.length;x++)for(let pe=x+1;pe<X.length;pe++)if(X[x].negate().equals(X[pe]))return u.INSTANCE;if(X.length===1)return X[0]}return new te(X,Y)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const Y of this.expr)B.push(...Y.keys());return B}map(B){return new te(this.expr.map(Y=>Y.map(B)),null)}negate(){if(!this.c){const B=[];for(const Y of this.expr)B.push(Y.negate());for(;B.length>1;){const Y=B.shift(),re=B.shift(),X=[];for(const _ of ye(Y))for(const x of ye(re))X.push(me.create([_,x],null,!1));B.unshift(te.create(X,null,!1))}this.c=te.create(B,this,!0)}return this.c}}e.$7i=te;class G extends I{static{this.d=[]}static all(){return G.d.values()}constructor(B,Y,re){super(B,null),this.f=Y,typeof re=="object"?G.d.push({...re,key:B}):re!==!0&&G.d.push({key:B,description:re,type:Y!=null?typeof Y:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return w.create(this.key,B)}}e.$8i=G,e.$9i=(0,R.$Qh)("contextKeyService");function J(H,B){return H<B?-1:H>B?1:0}function le(H,B,Y,re){return H<Y?-1:H>Y?1:B<re?-1:B>re?1:0}function ie(H,B){if(H.type===0||B.type===1)return!0;if(H.type===9)return B.type===9?ce(H.expr,B.expr):!1;if(B.type===9){for(const Y of B.expr)if(ie(H,Y))return!0;return!1}if(H.type===6){if(B.type===6)return ce(B.expr,H.expr);for(const Y of H.expr)if(ie(Y,B))return!0;return!1}return H.equals(B)}e.$0i=ie;function ce(H,B){let Y=0,re=0;for(;Y<H.length&&re<B.length;){const X=H[Y].cmp(B[re]);if(X<0)return!1;X===0&&Y++,re++}return Y===H.length}function ye(H){return H.type===9?H.expr:[H]}}),define(De[231],Ce([1,0,23,38,191,5,99,12,24]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jv=e.$Iv=e.ConfirmResult=e.$Hv=e.$Gv=e.$Fv=void 0,e.$Fv=(0,R.$Qh)("dialogService");var b;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(b||(b={}));class L{a(h){return this.d(h,b.Confirmation)}b(h){return this.d(h,b.Prompt)}c(h){return this.d(h,b.Input)}d(h,o){const l=[];switch(o){case b.Confirmation:{const c=h;c.primaryButton?l.push(c.primaryButton):l.push((0,f.localize)(0,null)),c.cancelButton?l.push(c.cancelButton):l.push((0,f.localize)(1,null));break}case b.Prompt:{const c=h;Array.isArray(c.buttons)&&c.buttons.length>0&&l.push(...c.buttons.map(d=>d.label)),c.cancelButton&&(c.cancelButton===!0?l.push((0,f.localize)(2,null)):typeof c.cancelButton=="string"?l.push(c.cancelButton):c.cancelButton.label?l.push(c.cancelButton.label):l.push((0,f.localize)(3,null))),l.length===0&&l.push((0,f.localize)(4,null));break}case b.Input:{const c=h;c.primaryButton?l.push(c.primaryButton):l.push((0,f.localize)(5,null)),c.cancelButton?l.push(c.cancelButton):l.push((0,f.localize)(6,null));break}}return l}e(h){if(typeof h=="string")return h;if(typeof h=="number")return h===O.default.Info?"info":h===O.default.Error?"error":h===O.default.Warning?"warning":"none"}f(h,o,l){const c=[...h.buttons??[]];h.cancelButton&&typeof h.cancelButton!="string"&&typeof h.cancelButton!="boolean"&&c.push(h.cancelButton);let d=c[o]?.run({checkboxChecked:l});return d instanceof Promise||(d=Promise.resolve(d)),{result:d,checkboxChecked:l}}}e.$Gv=L,e.$Hv=(0,R.$Qh)("fileDialogService");var P;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const p=10;function y(v){const h=[];return h.push(...v.slice(0,p).map(o=>typeof o=="string"?o:(0,C.$tg)(o))),v.length>p&&(v.length-p===1?h.push((0,f.localize)(7,null)):h.push((0,f.localize)(8,null,v.length-p))),h.push(""),h.join(`
`)}e.$Iv=y;function k(v,h){const o=(0,E.$8m)(v);let l=(o.buttons??[]).map(t=>(0,A.$Cv)(t)),c=(v.buttons||[]).map((t,i)=>i),d=0,a=o.cancelId??l.length-1;if(l.length>1){const t=typeof a=="number"?l[a]:void 0;if(m.$l||m.$k){if(typeof t=="string"&&l.length>1&&a!==1){l.splice(a,1),l.splice(1,0,t);const i=c[a];c.splice(a,1),c.splice(1,0,i),a=1}m.$l&&l.length>1&&(l=l.reverse(),c=c.reverse(),d=l.length-1,typeof t=="string"&&(a=d-1))}else if(m.$j&&typeof t=="string"&&l.length>1&&a!==l.length-1){l.splice(a,1),l.push(t);const i=c[a];c.splice(a,1),c.push(i),a=l.length-1}}return o.buttons=l,o.defaultId=d,o.cancelId=a,o.noLink=!0,o.title=o.title||h.nameLong,{options:o,buttonIndeces:c}}e.$Jv=k}),define(De[131],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=void 0,e.$Xh=(0,C.$Qh)("environmentService"),e.$Yh=(0,C.$Rh)(e.$Xh)}),define(De[132],Ce([1,0,192,5]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=void 0,e.$2n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3n=new RegExp(e.$2n),e.$4n="__web_extension",e.$5n="skipWalkthrough",e.$6n="extensionsSync",e.$7n="dependecyOrPackExtensionInstall";function f(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$8n=f;function R(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$9n=R;function A(o,l){switch(o){case 3:return l==="x64"?"win32-x64":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$0n=A;function m(o,l){return l==="web"&&!o.includes("web")}e.$$n=m;function E(o,l,c){return m(l,c)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===c}e.$_n=E;function b(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$ao=b;var L;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var P;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var p;(function(o){o.Install="install",o.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var y;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$bo=(0,O.$Qh)("extensionGalleryService");var k;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var v;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class h extends Error{constructor(l,c){super(l),this.code=c,this.name=c}}e.$co=h,e.$do=(0,O.$Qh)("extensionManagementService"),e.$eo="extensionsIdentifiers/disabled",e.$fo="extensionsIdentifiers/enabled",e.$go=(0,O.$Qh)("IGlobalExtensionEnablementService"),e.$ho=(0,O.$Qh)("IExtensionTipsService"),e.$io=(0,C.localize)(0,null),e.$jo={value:e.$io,original:"Extensions"},e.$ko={value:(0,C.localize)(1,null),original:"Preferences"}}),define(De[232],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yYb=e.$xYb=void 0,e.$xYb=(0,C.$Qh)("externalTerminal"),e.$yYb="Terminal.app"}),define(De[233],Ce([1,0,49,18,16,12,98,29,101,194,232]),function($e,e,C,O,f,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=e.$t7b=e.$s7b=void 0;const P=b.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends p{static{this.b="cmd.exe"}openTerminal(d,a){return this.spawnTerminal(C,d,E.$Cl(),a)}spawnTerminal(d,a,t,i){const s=a.windowsExec||y.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const n=f.$nc(s,".exe").toLowerCase();if(n==="cmder")return d.spawn(s,i?[i]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),n==="wt"&&r.push("-d ."),new Promise((u,I)=>{const S=h(process),$=d.spawn(t,r,{cwd:i,env:S});$.on("error",I),$.on("exit",()=>u())})}runInTerminal(d,a,t,i,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:y.getDefaultTerminalWindows();return new Promise((r,u)=>{const I=`"${a} - ${P}"`,S=`""${t.join('" "')}" & pause"`,$=Object.assign({},h(process),i);Object.keys($).filter(M=>$[M]===null).forEach(M=>delete $[M]);const g={cwd:a,env:$,windowsVerbatimArguments:!0};let w,D;f.$nc(n,".exe")==="wt"?(w=n,D=["-d",".",y.b,"/c",S]):(w=y.b,D=["/c","start",I,"/wait",n,"/c",S]),C.spawn(w,D,g).on("error",M=>{u(o(M))}),r(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$s7b=y;class k extends p{static{this.b="/usr/bin/osascript"}openTerminal(d,a){return this.spawnTerminal(C,d,a)}runInTerminal(d,a,t,i,s){const n=s.osxExec||L.$yYb;return new Promise((r,u)=>{if(n===L.$yYb||n==="iTerm.app"){const I=n===L.$yYb?"TerminalHelper":"iTermHelper",$=[O.$dg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",d||P,"-w",a];for(const D of t)$.push("-a"),$.push(D);if(i){const D=Object.assign({},h(process),i);for(const T in D){const M=D[T];M===null?($.push("-u"),$.push(T)):($.push("-e"),$.push(`${T}=${M}`))}}let g="";const w=C.spawn(k.b,$);w.on("error",D=>{u(o(D))}),w.stderr.on("data",D=>{g+=D.toString()}),w.on("exit",D=>{if(D===0)r(void 0);else if(g){const T=g.split(`
`,1);u(new Error(T[0]))}else u(new Error(b.localize(1,null,I,D)))})}else u(new Error(b.localize(2,null,n)))})}spawnTerminal(d,a,t){const i=a.osxExec||L.$yYb;return new Promise((s,n)=>{const r=["-a",i];t&&r.push(t);const u=h(process),I=d.spawn("/usr/bin/open",r,{cwd:t,env:u});I.on("error",n),I.on("exit",()=>s())})}}e.$t7b=k;class v extends p{static{this.b=b.localize(3,null)}openTerminal(d,a){return this.spawnTerminal(C,d,a)}runInTerminal(d,a,t,i,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,u)=>{const I=[];n.then(S=>{S.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const $=`${l(t)}; echo; read -p "${v.b}" -n1;`;I.push(`''${$}''`);const g=Object.assign({},h(process),i);Object.keys(g).filter(M=>g[M]===null).forEach(M=>delete g[M]);const w={cwd:a,env:g};let D="";const T=C.spawn(S,I,w);T.on("error",M=>{u(o(M))}),T.stderr.on("data",M=>{D+=M.toString()}),T.on("exit",M=>{if(M===0)r(void 0);else if(D){const F=D.split(`
`,1);u(new Error(F[0]))}else u(new Error(b.localize(4,null,S,M)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!R.$l)v.d=Promise.resolve("xterm");else{const d=await m.Promises.exists("/etc/debian_version");v.d=new Promise(a=>{d?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return v.d}spawnTerminal(d,a,t){const i=a.linuxExec?Promise.resolve(a.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{i.then(r=>{const u=h(process),I=d.spawn(r,[],{cwd:t,env:u});I.on("error",n),I.on("exit",()=>s())})})}}e.$u7b=v;function h(c){const d={...c.env};return(0,A.$Al)(d),d}function o(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(b.localize(5,null,c.path)):c}function l(c){let d="";for(const a of c)a.indexOf(" ")>=0?d+='"'+a+'"':d+=a,d+=" ";return d}}),define(De[30],Ce([1,0,78,16,15,17,2,195,5,12,18,47]),function($e,e,C,O,f,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileKind=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileOperationResult=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileChangeType=e.$rk=e.FileOperation=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderErrorCode=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderCapabilities=e.$bk=e.FilePermission=e.FileType=e.$ak=e.$_j=void 0,e.$_j=(0,E.$Qh)("fileService");function p(ie){return ie.create===!0}e.$ak=p;var y;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var k;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function v(ie){const ce=ie;return!!ce&&typeof ce.onDidChange=="function"}e.$bk=v;var h;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(h||(e.FileSystemProviderCapabilities=h={}));function o(ie){return!!(ie.capabilities&2)}e.$ck=o;function l(ie){return!!(ie.capabilities&8)}e.$dk=l;function c(ie){return!!(ie.capabilities&131072)}e.$ek=c;function d(ie){return!!(ie.capabilities&4)}e.$fk=d;function a(ie){return!!(ie.capabilities&16)}e.$gk=a;function t(ie){return o(ie)?!!(ie.capabilities&16384):!1}e.$hk=t;function i(ie){return o(ie)?!!(ie.capabilities&32768):!1}e.$ik=i;function s(ie){return!!(ie.capabilities&65536)}e.$jk=s;function n(ie){return!!(ie.capabilities&2048)}e.$kk=n;var r;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class u extends Error{static create(ce,ye){const H=new u(ce.toString(),ye);return $(H,ye),H}constructor(ce,ye){super(ce),this.code=ye}}e.$lk=u;function I(ie,ce){return u.create(ie,ce)}e.$mk=I;function S(ie){return ie||I((0,m.localize)(0,null),r.Unknown)}e.$nk=S;function $(ie,ce){return ie.name=ce?`${ce} (FileSystemError)`:"FileSystemError",ie}e.$ok=$;function g(ie){if(!ie)return r.Unknown;if(ie instanceof u)return ie.code;const ce=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!ce)return r.Unknown;switch(ce[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$pk=g;function w(ie){if(ie instanceof j)return ie.fileOperationResult;switch(g(ie)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$qk=w;var D;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class T{constructor(ce,ye,H){this.resource=ce,this.operation=ye,this.target=H}isOperation(ce){return this.operation===ce}}e.$rk=T;var M;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class F{static{this.a=null}constructor(ce,ye){this.c=ye,this.b=void 0,this.d=new P.$V(()=>{const H=C.$Wh.forUris(()=>this.c);return H.fill(this.rawAdded.map(B=>[B,!0])),H}),this.f=new P.$V(()=>{const H=C.$Wh.forUris(()=>this.c);return H.fill(this.rawUpdated.map(B=>[B,!0])),H}),this.g=new P.$V(()=>{const H=C.$Wh.forUris(()=>this.c);return H.fill(this.rawDeleted.map(B=>[B,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of ce){switch(H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}this.b!==F.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ce,...ye){return this.h(ce,{includeChildren:!1},...ye)}affects(ce,...ye){return this.h(ce,{includeChildren:!0},...ye)}h(ce,ye,...H){if(!ce)return!1;const B=H.length>0;return!!((!B||H.includes(1))&&(this.d.value.get(ce)||ye.includeChildren&&this.d.value.findSuperstr(ce))||(!B||H.includes(0))&&(this.f.value.get(ce)||ye.includeChildren&&this.f.value.findSuperstr(ce))||(!B||H.includes(2))&&(this.g.value.findSubstr(ce)||ye.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$sk=F;function z(ie,ce,ye){return!ie||!ce||ie===ce||ce.length>ie.length?!1:(ce.charAt(ce.length-1)!==O.sep&&(ce+=O.sep),ye?(0,f.$4e)(ie,ce):ie.indexOf(ce)===0)}e.$tk=z;class j extends Error{constructor(ce,ye,H){super(ce),this.fileOperationResult=ye,this.options=H}}e.$uk=j;class N extends j{constructor(ce,ye,H,B){super(ce,ye,B),this.fileOperationResult=ye,this.size=H}}e.$vk=N;class q extends j{constructor(ce,ye,H){super(ce,2,H),this.stat=ye}}e.$wk=q;var K;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zk="files.associations",e.$Ak="files.exclude",e.$Bk="files.readonlyInclude",e.$Ck="files.readonlyExclude",e.$Dk="files.readonlyFromPermissions";var me;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.$Ek="";function te(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$Fk=te;async function G(ie,ce){if(!ce.hasProvider(A.URI.from({scheme:ie.scheme})))return new Promise(ye=>{const H=ce.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===ie.scheme&&B.added&&(H.dispose(),ye())})})}e.$Gk=G;class J{static{this.KB=1024}static{this.MB=J.KB*J.KB}static{this.GB=J.MB*J.KB}static{this.TB=J.GB*J.KB}static formatSize(ce){return(0,R.$Df)(ce)||(ce=0),ce<J.KB?(0,m.localize)(1,null,ce.toFixed(0)):ce<J.MB?(0,m.localize)(2,null,(ce/J.KB).toFixed(2)):ce<J.GB?(0,m.localize)(3,null,(ce/J.MB).toFixed(2)):ce<J.TB?(0,m.localize)(4,null,(ce/J.GB).toFixed(2)):(0,m.localize)(5,null,(ce/J.TB).toFixed(2))}}e.$Hk=J;function le(ie){const ce=typeof ie=="string"||ie?.scheme===L.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===L.Schemas.file?1024*J.MB:ce?10*J.MB:b.$p?50*J.MB:1024*J.MB}e.$Ik=le}),define(De[234],Ce([1,0,22,9,196,30]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;async function A(L,P,p,y,k,v){let h;try{await m(L,P,p,y,k,v)}catch(o){h=o}finally{h&&k.errorTransformer&&(h=k.errorTransformer(h)),typeof h<"u"&&p.error(h),p.end()}}e.$Qp=A;async function m(L,P,p,y,k,v){E(v);const h=await L.open(P,{create:!1});try{E(v);let o=0,l=0,c=k&&typeof k.length=="number"?k.length:void 0,d=C.$ce.alloc(Math.min(k.bufferSize,typeof c=="number"?c:k.bufferSize)),a=k&&typeof k.position=="number"?k.position:0,t=0;do l=await L.read(h,a,d.buffer,t,d.byteLength-t),a+=l,t+=l,o+=l,typeof c=="number"&&(c-=l),t===d.byteLength&&(await p.write(y(d)),d=C.$ce.alloc(Math.min(k.bufferSize,typeof c=="number"?c:k.bufferSize)),t=0);while(l>0&&(typeof c!="number"||c>0)&&E(v)&&b(o,k));if(t>0){let i=t;typeof c=="number"&&(i=Math.min(t,c)),p.write(y(d.slice(0,i)))}}catch(o){throw(0,R.$nk)(o)}finally{await L.close(h)}}function E(L){if(L.isCancellationRequested)throw(0,O.$6)();return!0}function b(L,P){if(typeof P?.limits?.size=="number"&&L>P.limits.size)throw(0,R.$mk)((0,f.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[84],Ce([1,0,36,3,16,12,2,30]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;function E(o){return o.recursive===!0}e.$Sp=E;class b extends O.$Sc{static{this.a=5}constructor(l,c,d,a){super(),this.h=l,this.j=c,this.m=d,this.n=a,this.c=this.B(new O.$Tc),this.f=void 0,this.g=0}s(){const l=new O.$Rc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(c=>this.h(c))),l.add(this.b.onDidLogMessage(c=>this.j(c))),l.add(this.b.onDidError(c=>this.t(c)))}t(l){this.n.restartOnError?this.g<b.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Tp=b;class L extends b{constructor(l,c,d){super(l,c,d,{type:"node.js",restartOnError:!1})}}e.$Up=L;class P extends b{constructor(l,c,d){super(l,c,d,{type:"universal",restartOnError:!0})}}e.$Vp=P;function p(o){return o.map(l=>({type:l.type,resource:A.URI.revive(l.resource),cId:l.cId}))}e.$Wp=p;function y(o){const l=new h;for(const c of o)l.processEvent(c);return l.coalesce()}e.$Xp=y;function k(o,l){return typeof l=="string"&&!l.startsWith(C.$tj)&&!(0,f.$ic)(l)?{base:o,pattern:l}:l}e.$Yp=k;function v(o,l){const c=[];for(const d of l)c.push((0,C.$xj)(k(o,d)));return c}e.$Zp=v;class h{constructor(){this.a=new Set,this.b=new Map}c(l){return R.$l?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const c=this.b.get(this.c(l));let d=!1;if(c){const a=c.type,t=l.type;c.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?d=!0:a===1&&t===2?(this.b.delete(this.c(l)),this.a.delete(c)):a===2&&t===1?c.type=0:a===1&&t===0||(c.type=t)}else d=!0;d&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],c=[];return Array.from(this.a).filter(d=>d.type!==2?(l.push(d),!1):!0).sort((d,a)=>d.resource.fsPath.length-a.resource.fsPath.length).filter(d=>c.some(a=>(0,m.$tk)(d.resource.fsPath,a,!R.$l))?!1:(c.push(d.resource.fsPath),!0)).concat(l)}}}),define(De[235],Ce([1,0,53,8,21,33,3,77,16,12,23,2,100,29,84]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;class v extends A.$Sc{static{this.a=100}static{this.b=75}constructor(l,c,d,a){super(),this.m=l,this.n=c,this.r=d,this.s=a,this.c=this.B(new O.$0g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new O.$9g(t=>this.z(t),v.b)),this.g=(0,k.$Zp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$Zp)(this.m.path,this.m.includes):void 0,this.j=new f.$Yd,this.ready=this.t()}async t(){try{const l=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const c=await y.Promises.stat(l);this.B(await this.w(l,c.isDirectory()))}catch(l){l.code!=="ENOENT"?this.D(l):this.G(l)}}async u(l){let c=l.path;try{c=await y.Promises.realpath(l.path),l.path===c&&(c=await(0,p.$0p)(l.path)??l.path),l.path!==c&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${l.path}, real: ${c})`)}catch{}return c}async w(l,c){if(b.$k&&(0,R.$Yf)(l,"/Volumes/",!0))return this.D(`Refusing to watch ${l} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Sc.None;const d=new f.$Yd(this.j.token),a=new A.$Rc;try{const t=P.URI.file(this.m.path),i=(0,E.$nc)(l),s=(0,C.watch)(l);a.add((0,A.$Qc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${l}'`);const n=new Set;if(c)try{for(const u of await y.Promises.readdir(l))n.add(u)}catch(u){this.D(u)}const r=new Map;a.add((0,A.$Qc)(()=>{for(const[,u]of r)u.dispose();r.clear()})),s.on("error",(u,I)=>{this.D(`Failed to watch ${l} for changes using fs.watch() (${u}, ${I})`),this.dispose()}),s.on("change",(u,I)=>{if(d.token.isCancellationRequested)return;this.G(`[raw] ["${u}"] ${I}`);let S="";if(I&&(S=I.toString(),b.$k&&(S=(0,m.$pl)(S))),!(!S||u!=="change"&&u!=="rename"))if(c)if(u==="rename"){r.get(S)?.dispose();const $=setTimeout(async()=>{if(r.delete(S),S===i&&!await y.Promises.exists(l)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const g=await this.C((0,E.$jc)(l,S));if(d.token.isCancellationRequested)return;let w;g?n.has(S)?w=0:(w=1,n.add(S)):(n.delete(S),w=2),this.y({resource:(0,L.$wg)(t,S),type:w,cId:this.m.correlationId})},v.a);r.set(S,(0,A.$Qc)(()=>clearTimeout($)))}else{let $;n.has(S)?$=0:($=1,n.add(S)),this.y({resource:(0,L.$wg)(t,S),type:$,cId:this.m.correlationId})}else if(u==="rename"||S!==i){const $=setTimeout(async()=>{const g=await y.Promises.exists(l);d.token.isCancellationRequested||(g?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(l,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},v.a);a.clear(),a.add((0,A.$Qc)(()=>clearTimeout($)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(l)&&!d.token.isCancellationRequested&&this.D(`Failed to watch ${l} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Qc)(()=>{d.dispose(!0),a.dispose()})}y(l,c=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`),!c&&this.g.some(d=>d(l.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${l.resource.fsPath}`):!c&&this.h&&this.h.length>0&&!this.h.some(d=>d(l.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${l.resource.fsPath}`):this.f.work(l))}z(l){const c=(0,k.$Xp)(l);if(c.length>0){if(this.s)for(const a of c)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(c)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(l){if(b.$l)return y.Promises.exists(l);try{const c=(0,E.$nc)(l);return(await y.Promises.readdir((0,E.$mc)(l))).some(a=>a===c)}catch(c){return this.G(c),!1}}setVerboseLogging(l){this.s=l}D(l){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${l}`})}F(l){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${l}`})}G(l){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${l}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$aq=v;async function h(o,l,c,d,a=512){const t=await y.Promises.open(o,"r"),i=Buffer.allocUnsafe(a),s=new f.$Yd(d);let n,r=!1;const u={path:o,excludes:[],recursive:!1},I=new v(u,S=>{(async()=>{for(const{type:$}of S)if($===0){if(r)return;r=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:g}=await y.Promises.read(t,i,0,a,null);if(!g||s.token.isCancellationRequested)break;l(i.slice(0,g))}}catch(g){n=new Error(g),s.dispose(!0)}finally{r=!1}}})()});return await I.ready,c(),new Promise((S,$)=>{s.token.onCancellationRequested(async()=>{I.dispose();try{await y.Promises.close(t)}catch(g){n=new Error(g)}n?$(n):S()})})}e.$bq=h}),define(De[236],Ce([1,0,4,36,3,12,235]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;class m extends f.$Sc{constructor(){super(...arguments),this.a=this.B(new C.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$Od),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(b){const L=this.j(b),P=L.filter(y=>{const k=this.c.get(y.path);return k?!(0,O.$Bj)(k.request.excludes,y.excludes)||!(0,O.$Bj)(k.request.includes,y.includes):!0}),p=Array.from(this.c.values()).filter(({request:y})=>!L.find(k=>k.path===y.path&&(0,O.$Bj)(k.excludes,y.excludes)&&(0,O.$Bj)(k.includes,y.includes))).map(({request:y})=>y.path);P.length&&this.m(`Request to start watching: ${P.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const y of p)this.h(y);for(const y of P)this.g(y)}g(b){const L=new A.$aq(b,p=>this.a.fire(p),p=>this.b.fire(p),this.f),P={request:b,instance:L};this.c.set(b.path,P)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const L=this.c.get(b);L&&(this.c.delete(b),L.instance.dispose())}j(b){const L=new Map;for(const P of b){const p=R.$l?P.path:P.path.toLowerCase();let y=L.get(P.correlationId);y||(y=new Map,L.set(P.correlationId,y)),y.set(p,P)}return Array.from(L.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging(b){this.f=b;for(const[,L]of this.c)L.instance.setVerboseLogging(b)}m(b){this.f&&this.b.fire({type:"trace",message:this.n(b)})}n(b,L){return L?`[File Watcher (node.js)] ${b} (path: ${L.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$cq=m}),define(De[237],Ce([1,0,84,236]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class f extends C.$Up{constructor(A,m,E){super(A,m,E),this.s()}r(A){return A.add(new O.$cq)}}e.$dq=f}),define(De[238],Ce([1,0,18,81,183,84]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class A extends R.$Vp{constructor(E,b,L){super(E,b,L),this.s()}r(E){const b=E.add(new f.$7p(C.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:L,signal:P})=>this.t(`terminated by itself with code ${L}, signal: ${P}`))),O.ProxyChannel.toService((0,O.$xh)(b.getChannel("watcher")))}}e.$8p=A}),define(De[104],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=void 0;class C{constructor(...f){this.a=new Map;for(const[R,A]of f)this.set(R,A)}set(f,R){const A=this.a.get(f);return this.a.set(f,R),A}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$Oh=C}),define(De[239],Ce([1,0,8,9,3,102,230,5,104,76]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;const L=!1;class P extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class p{constructor(h=new E.$Oh,o=!1,l,c=L){this.f=h,this.g=o,this.h=l,this.i=c,this.o=new Set,this.f.set(m.$Ph,this),this._globalGraph=c?l?._globalGraph??new A.$gq(d=>d):void 0}createChild(h){return new p(h,this.g,this,this.i)}invokeFunction(h,...o){const l=k.traceInvocation(this.i,h);let c=!1;try{return h({get:a=>{if(c)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,l);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{c=!0,l.stop()}}createInstance(h,...o){let l,c;return h instanceof R.$Nh?(l=k.traceCreation(this.i,h.ctor),c=this.j(h.ctor,h.staticArguments.concat(o),l)):(l=k.traceCreation(this.i,h),c=this.j(h,o,l)),l.stop(),c}j(h,o=[],l){const c=m._util.getServiceDependencies(h).sort((t,i)=>t.index-i.index),d=[];for(const t of c){const i=this.m(t.id,l);i||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(i)}const a=c.length>0?c[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(h,o.concat(d))}k(h,o){if(this.f.get(h)instanceof R.$Nh)this.f.set(h,o);else if(this.h)this.h.k(h,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const o=this.f.get(h);return!o&&this.h?this.h.l(h):o}m(h,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const l=this.l(h);return l instanceof R.$Nh?this.q(h,l,o.branch(h,!0)):(o.branch(h,!1),l)}q(h,o,l){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,o,l)}finally{this.o.delete(h)}}r(h,o,l){const c=new A.$gq(t=>t.id.toString());let d=0;const a=[{id:h,desc:o,_trace:l}];for(;a.length;){const t=a.pop();if(c.lookupOrInsertNode(t),d++>1e3)throw new P(c);for(const i of m._util.getServiceDependencies(t.desc.ctor)){const s=this.l(i.id);if(s||this.u(`[createInstance] ${h} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(i.id)),s instanceof R.$Nh){const n={id:i.id,desc:s,_trace:t._trace.branch(i.id,!0)};c.insertEdge(t,n),a.push(n)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new P(c);break}for(const{data:i}of t){if(this.l(i.id)instanceof R.$Nh){const n=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,n)}c.removeNode(i)}}return this.l(h)}s(h,o,l=[],c,d){if(this.f.get(h)instanceof R.$Nh)return this.t(h,o,l,c,d);if(this.h)return this.h.s(h,o,l,c,d);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(h,o,l=[],c,d){if(c){const a=new p(void 0,this.g,this,this.i);a.c=String(h);const t=new Map,i=new C.$_g(()=>{const s=a.j(o,l,d);for(const[n,r]of t){const u=s[n];if(typeof u=="function")for(const I of r)u.apply(s,I)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!i.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let I=t.get(n);return I||(I=new b.$2c,t.set(n,I)),($,g,w)=>{const D=I.push([$,g,w]);return(0,f.$Qc)(D)}}if(n in s)return s[n];const r=i.value;let u=r[n];return typeof u!="function"||(u=u.bind(r),s[n]=u),u},set(s,n,r){return i.value[n]=r,!0},getPrototypeOf(s){return o.prototype}})}else return this.j(o,l,d)}u(h,o){if(o&&console.warn(h),this.g)throw new Error(h)}}e.$hq=p;var y;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(y||(y={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(h,o){return h?new k(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(h,o){return h?new k(1,o.name):k.c}static{this.f=0}constructor(h,o){this.type=h,this.name=o,this.g=Date.now(),this.h=[]}branch(h,o){const l=new k(3,h.toString());return this.h.push([h,o,l]),l}stop(){const h=Date.now()-this.g;k.f+=h;let o=!1;function l(d,a){const t=[],i=new Array(d+1).join("	");for(const[s,n,r]of a.h)if(n&&r){o=!0,t.push(`${i}CREATES -> ${s}`);const u=l(d+1,r);u&&t.push(u)}else t.push(`${i}uses -> ${s}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(h>2||o)&&k.all.add(c.join(`
`))}}e.$iq=k}),define(De[14],Ce([1,0,41,4,52,3,28,12,23,17,2,42,5]),function($e,e,C,O,f,R,A,m,E,b,L,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.log=e.$bj=e.LogLevel=e.$aj=e.$_i=e.$$i=void 0,e.$$i=(0,p.$Qh)("logService"),e.$_i=(0,p.$Qh)("loggerService");function y(){return new Date().toISOString()}function k($){return(0,b.$Df)($)}e.$aj=k;var v;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$bj=v.Info;function h($,g,w){switch(g){case v.Trace:$.trace(w);break;case v.Debug:$.debug(w);break;case v.Info:$.info(w);break;case v.Warning:$.warn(w);break;case v.Error:$.error(w);break;case v.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=h;function o($,g=!1){let w="";for(let D=0;D<$.length;D++){let T=$[D];if(T instanceof Error&&(T=(0,C.$Bi)(T,g)),typeof T=="object")try{T=JSON.stringify(T)}catch{}w+=(D>0?" ":"")+T}return w}class l extends R.$Sc{constructor(){super(...arguments),this.b=e.$bj,this.c=this.B(new O.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==v.Off&&this.b<=g}}e.$dj=l;class c extends l{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...w){this.f(v.Trace)&&this.g(v.Trace,o([g,...w],!0))}debug(g,...w){this.f(v.Debug)&&this.g(v.Debug,o([g,...w]))}info(g,...w){this.f(v.Info)&&this.g(v.Info,o([g,...w]))}warn(g,...w){this.f(v.Warning)&&this.g(v.Warning,o([g,...w]))}error(g,...w){if(this.f(v.Error))if(g instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=g.stack,this.g(v.Error,o(D))}else this.g(v.Error,o([g,...w]))}flush(){}}e.$ej=c;class d extends l{constructor(g=e.$bj){super(),this.setLevel(g),this.g=!m.$j}trace(g,...w){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...w):console.log(`[main ${y()}]`,g,...w))}debug(g,...w){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...w):console.log(`[main ${y()}]`,g,...w))}info(g,...w){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...w):console.log(`[main ${y()}]`,g,...w))}warn(g,...w){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,g,...w):console.warn(`[main ${y()}]`,g,...w))}error(g,...w){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,g,...w):console.error(`[main ${y()}]`,g,...w))}dispose(){}flush(){}}e.$fj=d;class a extends l{constructor(g=e.$bj,w=!0){super(),this.g=w,this.setLevel(g)}trace(g,...w){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",g,...w):console.log(g,...w))}debug(g,...w){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",g,...w):console.log(g,...w))}info(g,...w){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",g,...w):console.log(g,...w))}warn(g,...w){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",g,...w):console.log(g,...w))}error(g,...w){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",g,...w):console.error(g,...w))}dispose(){}flush(){}}e.$gj=a;class t extends l{constructor(g,w=e.$bj){super(),this.g=g,this.setLevel(w)}trace(g,...w){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(g),...w])}debug(g,...w){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(g),...w])}info(g,...w){this.f(v.Info)&&this.g.log(v.Info,[this.h(g),...w])}warn(g,...w){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(g),...w])}error(g,...w){this.f(v.Error)&&this.g.log(v.Error,[this.h(g),...w])}h(g){return typeof g=="string"?g:(0,C.$Bi)(g,this.f(v.Trace))}dispose(){}flush(){}}e.$hj=t;class i extends l{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const w of this.g)w.setLevel(g);super.setLevel(g)}trace(g,...w){for(const D of this.g)D.trace(g,...w)}debug(g,...w){for(const D of this.g)D.debug(g,...w)}info(g,...w){for(const D of this.g)D.info(g,...w)}warn(g,...w){for(const D of this.g)D.warn(g,...w)}error(g,...w){for(const D of this.g)D.error(g,...w)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose()}}e.$ij=i;class s extends R.$Sc{constructor(g,w,D){if(super(),this.h=g,this.j=w,this.b=new A.$Ac,this.c=this.B(new O.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$Od),this.onDidChangeVisibility=this.g.event,D)for(const T of D)this.b.set(T.resource,{logger:void 0,info:T})}m(g){return(0,b.$zf)(g)?[...this.b.values()].find(w=>w.info.id===g):this.b.get(g)}getLogger(g){return this.m(g)?.logger}createLogger(g,w){const D=this.n(g),T=(0,b.$zf)(g)?g:w?.id??(0,f.$Ei)(D.toString()).toString(16);let M=this.b.get(D)?.logger;const F=w?.logLevel==="always"?v.Trace:w?.logLevel;M||(M=this.s(D,F??this.getLogLevel(D)??this.h,{...w,id:T}));const z={logger:M,info:{resource:D,id:T,logLevel:F,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(z.info),this.b.set(D,z),M}n(g){return(0,b.$zf)(g)?(0,E.$wg)(this.j,`${g}.log`):g}setLogLevel(g,w){if(L.URI.isUri(g)){const D=g,T=w,M=this.b.get(D);M&&T!==M.info.logLevel&&(M.info.logLevel=T===this.h?void 0:T,M.logger?.setLevel(T),this.b.set(M.info.resource,M),this.f.fire([D,T]))}else{this.h=g;for(const[D,T]of this.b.entries())this.b.get(D)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,w){const D=this.m(g);D&&w!==!D.info.hidden&&(D.info.hidden=!w,this.b.set(D.info.resource,D),this.g.fire([D.info.resource,w]))}getLogLevel(g){let w;return g&&(w=this.b.get(g)?.info.logLevel),w??this.h}registerLogger(g){const w=this.b.get(g.resource);w?w.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const w=this.b.get(g);w&&(w.logger&&w.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jj=s;class n{constructor(){this.onDidChangeLogLevel=new O.$Od().event}setLevel(g){}getLevel(){return v.Info}trace(g,...w){}debug(g,...w){}info(g,...w){}warn(g,...w){}error(g,...w){}critical(g,...w){}dispose(){}flush(){}}e.$kj=n;class r extends n{}e.$lj=r;function u($){if($.verbose)return v.Trace;if(typeof $.logLevel=="string"){const g=S($.logLevel.toLowerCase());if(g!==void 0)return g}return e.$bj}e.$mj=u;function I($){switch($){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$nj=I;function S($){switch($){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$oj=S,e.$pj=new P.$8i("logLevel",I(v.Info))}),define(De[240],Ce([1,0,19,8,9,4,3,16,84,14]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class L extends A.$Sc{constructor(p,y){super(),this.a=p,this.b=y,this.c=this.B(new R.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$Sg(0)),this.w=[],this.y=this.B(new O.$Sg(0))}watch(p,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(p,y):this.z(p,y)}n(p,y){const k={path:this.H(p),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},v=(0,C.$Ub)(this.j,k);return this.r(),(0,A.$Qc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,f.$1)(p))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,E.$Wp)(y)),y=>this.G(y),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const y of this.j)(0,E.$Sp)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const y of this.j)(0,E.$Sp)(y)&&p.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,y){const k={path:this.H(p),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},v=(0,C.$Ub)(this.w,k);return this.C(),(0,A.$Qc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,f.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,E.$Wp)(p)),p=>this.G(p),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,m.$hc)(p.fsPath)}}e.$1p=L}),define(De[241],Ce([1,0,53,376,8,28,22,4,33,3,16,12,23,96,29,197,30,234,240,41,238,237]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0,(()=>{try{(0,O.gracefulify)(C)}catch(i){console.error(`Error enabling graceful-fs: ${(0,c.$Bi)(i)}`)}})();class t extends l.$1p{static{this.I=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=m.Event.None,this.N=new R.$Ac(r=>p.$ng.getComparisonKey(r)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$l&&(this.J|=1024)),this.J}async stat(s){try{const{stat:n,symbolicLink:r}=await k.SymlinkSupport.stat(this.H(s));return{type:this.M(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:h.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await k.Promises.readdir(this.H(s),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async u=>{try{let I;u.isSymbolicLink()?I=(await this.stat((0,p.$wg)(s,u.name))).type:I=this.M(u),r.push([u.name,I])}catch(I){this.a.trace(I)}})),r}catch(n){throw this.fb(n)}}M(s,n){let r;return n?.dangling?r=h.FileType.Unknown:s.isFile()?r=h.FileType.File:s.isDirectory()?r=h.FileType.Directory:r=h.FileType.Unknown,n&&(r|=h.FileType.SymbolicLink),r}async O(s){const n=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const u=new f.$Tg;return this.N.set(s,u),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(s)===u&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),u.open()})}async readFile(s,n){let r;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),r=await this.O(s));const u=this.H(s);return await k.Promises.readFile(u)}catch(u){throw this.fb(u)}finally{r?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,n,r){const u=(0,y.$3d)(I=>A.$ce.concat(I.map(S=>A.$ce.wrap(S))).buffer);return(0,o.$Qp)(this,s,u,I=>I.buffer,{...n,bufferSize:256*1024},r),u}async writeFile(s,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,p.$wg)((0,p.$vg)(s),`${(0,p.$tg)(s)}${r.atomic.postfix}`),n,r):this.S(s,n,r)}async Q(s){try{const n=this.H(s),{symbolicLink:r}=await k.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async R(s,n,r,u){const I=new b.$Rc;try{I.add(await this.O(s)),I.add(await this.O(n)),await this.S(n,r,u,!0);try{await this.rename(n,s,{overwrite:!0})}catch(S){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{I.dispose()}}async S(s,n,r,u){let I;try{const S=this.H(s);if(!r.create||!r.overwrite){if(await k.Promises.exists(S)){if(!r.overwrite)throw(0,h.$mk)((0,v.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,h.$mk)((0,v.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}I=await this.open(s,{create:!0,unlock:r.unlock},u),await this.write(I,0,n,0,n.byteLength)}catch(S){throw await this.gb(s,S)}finally{typeof I=="number"&&await this.close(I)}}static{this.Y=!0}static configureFlushOnWrite(s){t.Y=s}async open(s,n,r){const u=this.H(s);let I;(0,h.$ak)(n)&&!r&&(I=await this.O(s));let S;try{if((0,h.$ak)(n)&&n.unlock)try{const{stat:g}=await k.SymlinkSupport.stat(u);g.mode&128||await k.Promises.chmod(u,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let $;if((0,h.$ak)(n)){if(P.$j)try{await k.Promises.truncate(u,0),$="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}$||($="w")}else $="r";S=await k.Promises.open(u,$)}catch($){throw I?.dispose(),(0,h.$ak)(n)?await this.gb(s,$):this.fb($)}if(this.U.set(S,0),(0,h.$ak)(n)&&this.X.set(S,s),I){const $=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${u})`),this.W.set(S,I),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${u})`),$.dispose())}return S}async close(s){const n=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&t.Y)try{await k.Promises.fdatasync(s)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await k.Promises.close(s)}catch(r){throw this.fb(r)}finally{n&&(this.W.get(s)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,r,u,I){const S=this.Z(s,n);let $=null;try{$=(await k.Promises.read(s,r,u,I,S)).bytesRead}catch(g){throw this.fb(g)}finally{this.$(s,S,$)}return $}Z(s,n){return n===this.U.get(s)?null:n}$(s,n,r){const u=this.U.get(s);typeof u=="number"&&(typeof n=="number"||(typeof r=="number"?this.U.set(s,u+r):this.U.delete(s)))}async write(s,n,r,u,I){return(0,f.$ah)(()=>this.ab(s,n,r,u,I),100,3)}async ab(s,n,r,u,I){const S=this.Z(s,n);let $=null;try{$=(await k.Promises.write(s,r,u,I,S)).bytesWritten}catch(g){throw await this.gb(this.X.get(s),g)}finally{this.$(s,S,$)}return $}async mkdir(s){try{await k.Promises.mkdir(this.H(s))}catch(n){throw this.fb(n)}}async delete(s,n){try{const r=this.H(s);if(n.recursive){let u;n?.atomic!==!1&&n.atomic.postfix&&(u=(0,L.$jc)((0,L.$mc)(r),`${(0,L.$nc)(r)}${n.atomic.postfix}`)),await k.Promises.rm(r,k.RimRafMode.MOVE,u)}else try{await k.Promises.unlink(r)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let I=!1;try{const{stat:S,symbolicLink:$}=await k.SymlinkSupport.stat(r);I=S.isDirectory()&&!$}catch{}if(I)await k.Promises.rmdir(r);else throw u}else throw u}}catch(r){throw this.fb(r)}}async rename(s,n,r){const u=this.H(s),I=this.H(n);if(u!==I)try{await this.bb(s,n,"move",r.overwrite),await k.Promises.rename(u,I)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,v.localize)(2,null,(0,L.$nc)(u),(0,L.$nc)((0,L.$mc)(I)),S.toString()))),this.fb(S)}}async copy(s,n,r){const u=this.H(s),I=this.H(n);if(u!==I)try{await this.bb(s,n,"copy",r.overwrite),await k.Promises.copy(u,I,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,v.localize)(3,null,(0,L.$nc)(u),(0,L.$nc)((0,L.$mc)(I)),S.toString()))),this.fb(S)}}async bb(s,n,r,u){const I=this.H(s),S=this.H(n);let $=!1;if(!!(this.capabilities&1024)||($=(0,E.$Xf)(I,S,!0)),$){if(r==="copy")throw(0,h.$mk)((0,v.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const w=await this.L(s);if(!w)throw(0,h.$mk)((0,v.localize)(5,null),h.FileSystemProviderErrorCode.FileNotFound);const D=await this.L(n);if(D){if(!u)throw(0,h.$mk)((0,v.localize)(6,null),h.FileSystemProviderErrorCode.FileExists);w.type&h.FileType.File&&D.type&h.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.cb(s,n,!1)}async cb(s,n,r){const u=this.H(s),I=this.H(n),S=!!(this.capabilities&1024);if((0,E.$Xf)(u,I,!S))return;const $=new b.$Rc;try{$.add(await this.O(s)),$.add(await this.O(n)),r&&await k.Promises.mkdir((0,L.$mc)(I),{recursive:!0}),await k.Promises.copyFile(u,I)}catch(g){if(g.code==="ENOENT"&&!r)return this.cb(s,n,!0);throw this.fb(g)}finally{$.dispose()}}t(s,n,r){return new d.$8p(u=>s(u),u=>n(u),r)}F(s,n,r){return new a.$dq(u=>s(u),u=>n(u),r)}fb(s){if(s instanceof h.$lk)return s;let n=s,r;switch(s.code){case"ENOENT":r=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=h.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=h.FileSystemProviderErrorCode.Unknown;break;default:r=h.FileSystemProviderErrorCode.Unknown}return(0,h.$mk)(n,r)}async gb(s,n){let r=this.fb(n);if(s&&r.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await k.SymlinkSupport.stat(this.H(s));u.mode&128||(r=(0,h.$mk)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return r}}e.$eq=t}),define(De[242],Ce([1,0,3,14]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;class f extends C.$Sc{constructor(A,m=[]){super(),this.a=new O.$ij([A,...m]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...m){this.a.trace(A,...m)}debug(A,...m){this.a.debug(A,...m)}info(A,...m){this.a.info(A,...m)}warn(A,...m){this.a.warn(A,...m)}error(A,...m){this.a.error(A,...m)}flush(){this.a.flush()}}e.$NN=f}),define(De[243],Ce([1,0,30,14]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;var f;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(f||(f={}));async function R(b,L,P,p,y){try{const k=await new Promise((h,o)=>{$e(["@vscode/spdlog"],h,o)});k.setFlushOn(f.Trace);const v=await k.createAsyncRotatingLogger(b,L,P,p);return y?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(k){console.error(k)}return null}function A(b,L,P){switch(L){case O.LogLevel.Trace:b.trace(P);break;case O.LogLevel.Debug:b.debug(P);break;case O.LogLevel.Info:b.info(P);break;case O.LogLevel.Warning:b.warn(P);break;case O.LogLevel.Error:b.error(P);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function m(b,L){switch(L){case O.LogLevel.Trace:b.setLevel(f.Trace);break;case O.LogLevel.Debug:b.setLevel(f.Debug);break;case O.LogLevel.Info:b.setLevel(f.Info);break;case O.LogLevel.Warning:b.setLevel(f.Warning);break;case O.LogLevel.Error:b.setLevel(f.Error);break;case O.LogLevel.Off:b.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class E extends O.$ej{constructor(L,P,p,y,k){super(),this.m=[],this.setLevel(k),this.n=this.s(L,P,p,y),this.B(this.onDidChangeLogLevel(v=>{this.r&&m(this.r,v)}))}async s(L,P,p,y){const k=p?6:1,v=30/k*C.$Hk.MB,h=await R(L,P,v,k,y);if(h){this.r=h,m(this.r,this.getLevel());for(const{level:o,message:l}of this.m)A(this.r,o,l);this.m=[]}}g(L,P){this.r?A(this.r,L,P):this.getLevel()<=L&&this.m.push({level:L,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$CN=E}),define(De[133],Ce([1,0,38,198,5]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function b(k,v){return v-k}E.compare=b;const L=Object.create(null);L[E.Error]=(0,O.localize)(0,null),L[E.Warning]=(0,O.localize)(1,null),L[E.Info]=(0,O.localize)(2,null);function P(k){return L[k]||""}E.toString=P;function p(k){switch(k){case C.default.Error:return E.Error;case C.default.Warning:return E.Warning;case C.default.Info:return E.Info;case C.default.Ignore:return E.Hint}}E.fromSeverity=p;function y(k){switch(k){case E.Error:return C.default.Error;case E.Warning:return C.default.Warning;case E.Info:return C.default.Info;case E.Hint:return C.default.Ignore}}E.toSeverity=y}(A||(e.MarkerSeverity=A={}));var m;(function(E){const b="";function L(p){return P(p,!0)}E.makeKey=L;function P(p,y){const k=[b];return p.source?k.push(p.source.replace("\xA6","\\\xA6")):k.push(b),p.code?typeof p.code=="string"?k.push(p.code.replace("\xA6","\\\xA6")):k.push(p.code.value.replace("\xA6","\\\xA6")):k.push(b),p.severity!==void 0&&p.severity!==null?k.push(A.toString(p.severity)):k.push(b),p.message&&y?k.push(p.message.replace("\xA6","\\\xA6")):k.push(b),p.startLineNumber!==void 0&&p.startLineNumber!==null?k.push(p.startLineNumber.toString()):k.push(b),p.startColumn!==void 0&&p.startColumn!==null?k.push(p.startColumn.toString()):k.push(b),p.endLineNumber!==void 0&&p.endLineNumber!==null?k.push(p.endLineNumber.toString()):k.push(b),p.endColumn!==void 0&&p.endColumn!==null?k.push(p.endColumn.toString()):k.push(b),k.push(b),k.join("\xA6")}E.makeKeyOptionalMessage=P})(m||(e.IMarkerData=m={})),e.$dt=(0,f.$Qh)("markerService")}),define(De[244],Ce([1,0,4,38,5]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6u=e.$5u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$4u=e.Severity=void 0,e.Severity=O.default,e.$4u=(0,f.$Qh)("notificationService");var R;(function(L){L[L.DEFAULT=0]="DEFAULT",L[L.SILENT=1]="SILENT",L[L.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var A;(function(L){L[L.WORKSPACE=0]="WORKSPACE",L[L.PROFILE=1]="PROFILE",L[L.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var m;(function(L){L[L.OFF=0]="OFF",L[L.SILENT=1]="SILENT",L[L.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new b,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.$5u=E;class b{infinite(){}done(){}total(P){}worked(P){}}e.$6u=b}),define(De[134],Ce([1,0,15,2,5]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tU=e.$sU=e.$rU=e.$qU=e.$pU=void 0,e.$pU=(0,f.$Qh)("openerService");function R(b,L){return O.URI.isUri(b)?(0,C.$3e)(b.scheme,L):(0,C.$4e)(b,L+":")}e.$qU=R;function A(b,...L){return L.some(P=>R(b,P))}e.$rU=A;function m(b,L){return b.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.$sU=m;function E(b){let L;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(b.fragment);return P&&(L={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},b=b.with({fragment:""})),{selection:L,uri:b}}e.$tU=E}),define(De[245],Ce([1,0,12,48]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let f;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.context<"u"){const R=C.$h.vscode.context.configuration();if(R)f=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(f=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(f,{nameShort:`${f.nameShort} Dev`,nameLong:`${f.nameLong} Dev`,dataFolderName:`${f.dataFolderName}-dev`,serverDataFolderName:f.serverDataFolderName?`${f.serverDataFolderName}-dev`:void 0}),!f.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(f,{version:R.version})}}else f={},Object.keys(f).length===0&&Object.assign(f,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=f}),define(De[135],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=void 0,e.$qj=(0,C.$Qh)("productService"),e.$rj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(C,O){e(C,O,$e)}};define(De[64],Ce([1,0,8,21,3,5]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.ProgressLocation=e.$7u=void 0,e.$7u=(0,R.$Qh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$8u=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$9u=m;class E{get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const y=this.d;this.d=()=>{y?.(),p()}}):Promise.resolve()}}e.$0u=E;let b=class extends f.$Sc{constructor(p,y){super(),this.a=new C.$dh,y.withProgress(p,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,f.$Qc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$$u=b,e.$$u=b=He([Be(1,e.$7u)],b);class L extends f.$Sc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new f.$Rc)}start(p){this.stop();const y=++this.a,k=new O.$Yd;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,f.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Qc)(()=>k.cancel())),this.b.add((0,f.$Qc)(()=>this.c?this.c.done():void 0)),{id:y,token:k.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$_u=L,e.$av=(0,R.$Qh)("editorProgressService")}),define(De[43],Ce([1,0,58,17]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=void 0;class f{constructor(){this.a=new Map}add(A,m){C.ok(O.$zf(A)),C.ok(O.$Bf(m)),C.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,m)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$kn=new f}),define(De[105],Ce([1,0,4,43]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0,e.$ln={JSONContribution:"base.contributions.json"};function f(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class R{constructor(){this.b=new C.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,b){this.a[f(E)]=b,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new R;O.$kn.add(e.$ln.JSONContribution,A)}),define(De[136],Ce([1,0,19,4,17,188,50,105,43]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ConfigurationScope=e.$pn=e.EditPresentationTypes=void 0;var b;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$pn={Configuration:"base.contributions.configuration"};var L;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn="vscode://schemas/settings/resourceLanguage",e.$xn="vscode://schemas/settings/configurationDefaults";const P=E.$kn.as(m.$ln.JSONContribution);class p{constructor(){this.h=new Set,this.i=new O.$Od,this.onDidSchemaChange=this.i.event,this.j=new O.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$wn,this.g),this.v()}registerConfiguration(t,i=!0){this.registerConfigurations([t],i)}registerConfigurations(t,i=!0){const s=new Set;this.n(t,i,s),P.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const i=new Set;this.o(t,i),P.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:t,remove:i}){const s=new Set;this.o(i,s),this.n(t,!1,s),P.registerSchema(e.$wn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const i=new Set;this.k(t,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(t,i){const s=[];for(const{overrides:n,source:r}of t)for(const u in n)if(i.add(u),e.$zn.test(u)){const I=this.a.get(u),S=I?.valuesSources??new Map;if(r)for(const D of Object.keys(n[u]))S.set(D,r);const $={...I?.value||{},...n[u]};this.a.set(u,{source:r,value:$,valuesSources:S});const g=(0,A.$ui)(u),w={type:"object",default:$,description:R.localize(1,null,g),$ref:e.$wn,defaultDefaultValue:$,source:f.$zf(r)?void 0:r,defaultValueSource:r};s.push(...v(u)),this.d[u]=w,this.b.properties[u]=w}else{this.a.set(u,{value:n[u],source:r});const I=this.d[u];I&&(this.w(u,I),this.r(u,I))}this.m(s)}deregisterDefaultConfigurations(t){const i=new Set;this.l(t,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(t,i){for(const{overrides:s,source:n}of t)for(const r in s){const u=this.a.get(r),I=f.$zf(n)?n:n?.id,S=f.$zf(u?.source)?u?.source:u?.source?.id;if(I===S)if(i.add(r),this.a.delete(r),e.$zn.test(r))delete this.d[r],delete this.b.properties[r];else{const $=this.d[r];$&&(this.w(r,$),this.r(r,$))}}this.u()}deltaConfiguration(t){let i=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),i=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),i=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const i of t)this.h.add(i);this.u()}n(t,i,s){t.forEach(n=>{this.p(n,i,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,i){const s=n=>{if(n.properties)for(const r in n.properties){i.add(r);const u=this.d[r];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>s(r))};for(const n of t){s(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,i=!0,s,n,r=3,u){r=f.$If(t.scope)?r:t.scope;const I=t.properties;if(I)for(const $ in I){const g=I[$];if(i&&c($,g)){delete I[$];continue}if(g.source=s,g.defaultDefaultValue=I[$].default,this.w($,g),e.$zn.test($)?g.scope=void 0:(g.scope=f.$If(g.scope)?r:g.scope,g.restricted=f.$If(g.restricted)?!!n?.includes($):g.restricted),I[$].hasOwnProperty("included")&&!I[$].included){this.f[$]=I[$],delete I[$];continue}else this.d[$]=I[$],I[$].policy?.name&&this.e.set(I[$].policy.name,$);!I[$].deprecationMessage&&I[$].markdownDeprecationMessage&&(I[$].deprecationMessage=I[$].markdownDeprecationMessage),u.add($)}const S=t.allOf;if(S)for(const $ of S)this.p($,i,s,n,r,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const i=s=>{const n=s.properties;if(n)for(const u in n)this.r(u,n[u]);s.allOf?.forEach(i)};i(t)}r(t,i){switch(e.$qn.properties[t]=i,i.scope){case 1:e.$rn.properties[t]=i;break;case 2:e.$sn.properties[t]=i;break;case 6:e.$tn.properties[t]=i;break;case 3:e.$un.properties[t]=i;break;case 4:e.$vn.properties[t]=i;break;case 5:e.$vn.properties[t]=i,this.g.properties[t]=i;break}}s(t,i){switch(delete e.$qn.properties[t],i.scope){case 1:delete e.$rn.properties[t];break;case 2:delete e.$sn.properties[t];break;case 6:delete e.$tn.properties[t];break;case 3:delete e.$un.properties[t];break;case 4:case 5:delete e.$vn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const i=`[${t}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$wn};this.w(i,s),e.$qn.properties[i]=s,e.$rn.properties[i]=s,e.$sn.properties[i]=s,e.$tn.properties[i]=s,e.$un.properties[i]=s,e.$vn.properties[i]=s}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$wn};e.$qn.patternProperties[e.$yn]=t,e.$rn.patternProperties[e.$yn]=t,e.$sn.patternProperties[e.$yn]=t,e.$tn.patternProperties[e.$yn]=t,e.$un.patternProperties[e.$yn]=t,e.$vn.patternProperties[e.$yn]=t,this.i.fire()}w(t,i){const s=this.a.get(t);let n=s?.value,r=s?.source;f.$Gf(n)&&(n=i.defaultDefaultValue,r=void 0),f.$Gf(n)&&(n=o(i.type)),i.default=n,i.defaultValueSource=r}}const y="\\[([^\\]]+)\\]",k=new RegExp(y,"g");e.$yn=`^(${y})+$`,e.$zn=new RegExp(e.$yn);function v(a){const t=[];if(e.$zn.test(a)){let i=k.exec(a);for(;i?.length;){const s=i[1].trim();s&&t.push(s),i=k.exec(a)}}return(0,C.$Mb)(t)}e.$An=v;function h(a){return a.reduce((t,i)=>`${t}[${i}]`,"")}e.$Bn=h;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Cn=o;const l=new p;E.$kn.add(e.$pn.Configuration,l);function c(a,t){return a.trim()?e.$zn.test(a)?R.localize(7,null,a):l.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&l.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,l.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$Dn=c;function d(){const a=[],t=l.getConfigurationProperties();for(const i of Object.keys(t))a.push([i,t[i].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$En=d}),define(De[246],Ce([1,0,19,4,157,3,28,24,17,2,50,136,43]),function($e,e,C,O,f,R,A,m,E,b,L,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function y(i){return Object.isFrozen(i)?i:m.$9m(i)}class k{constructor(s={},n=[],r=[],u){this.b=s,this.c=n,this.d=r,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof k)return n;const r=new v("");return r.parseRaw(n),r.configurationModel});this.f=s.reduce((n,r)=>r===n?r:n.merge(r),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,L.$si)(this.contents,s):this.contents}inspect(s,n){const r=this.rawConfiguration.getValue(s),u=n?this.rawConfiguration.getOverrideValue(s,n):void 0,I=n?this.rawConfiguration.override(n).getValue(s):r;return{value:r,override:u,merged:I}}getOverrideValue(s,n){const r=this.i(n);return r?s?(0,L.$si)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const r of this.overrides)r.identifiers.includes(s)&&n.push(...r.keys);return C.$Mb(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return C.$Mb(s)}override(s){let n=this.a.get(s);return n||(n=this.g(s),this.a.set(s,n)),n}merge(...s){const n=m.$8m(this.contents),r=m.$8m(this.overrides),u=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const S of s)if(I.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(n,S.contents);for(const $ of S.overrides){const[g]=r.filter(w=>C.$ub(w.identifiers,$.identifiers));g?(this.h(g.contents,$.contents),g.keys.push(...$.keys),g.keys=C.$Mb(g.keys)):r.push(m.$8m($))}for(const $ of S.keys)u.indexOf($)===-1&&u.push($)}return new k(n,u,r,I.every(S=>S instanceof k)?void 0:I)}g(s){const n=this.i(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const u of C.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let I=this.contents[u];const S=n[u];S&&(typeof I=="object"&&typeof S=="object"?(I=m.$8m(I),this.h(I,S)):I=S),r[u]=I}return new k(r,this.keys,this.overrides)}h(s,n){for(const r of Object.keys(n)){if(r in s&&E.$Bf(s[r])&&E.$Bf(n[r])){this.h(s[r],n[r]);continue}s[r]=m.$8m(n[r])}}i(s){let n=null,r=null;const u=I=>{I&&(r?this.h(r,I):r=m.$8m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===s?n=I.contents:I.identifiers.includes(s)&&u(I.contents);return u(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.j(s,n,!0)}setValue(s,n){this.j(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,L.$ri)(this.contents,s),P.$zn.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>C.$ub(r.identifiers,(0,P.$An)(s))),1))}j(s,n,r){(0,L.$qi)(this.contents,s,n,u=>console.error(u)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),P.$zn.test(s)&&this.overrides.push({identifiers:(0,P.$An)(s),keys:Object.keys(this.contents[s]),contents:(0,L.$pi)(this.contents[s],u=>console.error(u))})}}e.$Fn=k;class v{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!E.$If(s)){const r=this.g(s);this.parseRaw(r,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:r,keys:u,overrides:I,restricted:S,hasExcludedProperties:$}=this.h(s,n);this.b=new k(r,u,I,$?[s]:void 0),this.c=S||[]}g(s){let n={},r=null,u=[];const I=[],S=[];function $(w){Array.isArray(u)?u.push(w):r!==null&&(u[r]=w)}const g={onObjectBegin:()=>{const w={};$(w),I.push(u),u=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{u=I.pop()},onArrayBegin:()=>{const w=[];$(w),I.push(u),u=w,r=null},onArrayEnd:()=>{u=I.pop()},onLiteralValue:$,onError:(w,D,T)=>{S.push({error:w,offset:D,length:T})}};if(s)try{f.$5m(s,g),n=u[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return n}h(s,n){const r=p.$kn.as(P.$pn.Configuration).getConfigurationProperties(),u=this.i(s,r,!0,n);s=u.raw;const I=(0,L.$pi)(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),S=Object.keys(s),$=this.j(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:I,keys:S,overrides:$,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(s,n,r,u){let I=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:I};const S={},$=[];for(const g in s)if(P.$zn.test(g)&&r){const w=this.i(s[g],n,!1,u);S[g]=w.raw,I=I||w.hasExcludedProperties,$.push(...w.restricted)}else{const w=n[g],D=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&$.push(g),!u.exclude?.includes(g)&&(u.include?.includes(g)||(D===void 0||u.scopes===void 0||u.scopes.includes(D))&&!(u.skipRestricted&&w?.restricted))?S[g]=s[g]:I=!0}return{raw:S,restricted:$,hasExcludedProperties:I}}j(s,n){const r=[];for(const u of Object.keys(s))if(P.$zn.test(u)){const I={};for(const S in s[u])I[S]=s[u][S];r.push({identifiers:(0,P.$An)(u),keys:Object.keys(I),contents:(0,L.$pi)(I,n)})}return r}}e.$Gn=v;class h extends R.$Sc{constructor(s,n,r,u){super(),this.c=s,this.f=n,this.g=u,this.b=this.B(new O.$Od),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&r.isEqual(I.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Hn=h;class o{constructor(s,n,r,u,I,S,$,g,w,D,T,M,F){this.a=s,this.b=n,this.c=r,this.overrideIdentifiers=u,this.d=I,this.f=S,this.g=$,this.h=g,this.i=w,this.j=D,this.k=T,this.l=M,this.m=F}get value(){return y(this.c)}n(s,n,r){const u=s.inspect(n,r);return{get value(){return y(u.value)},get override(){return y(u.override)},get merged(){return y(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class l{constructor(s,n,r,u,I=new k,S=new k,$=new A.$Ac,g=new k,w=new A.$Ac){this.c=s,this.d=n,this.f=r,this.g=u,this.h=I,this.i=S,this.j=$,this.l=g,this.m=w,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,n,r){return this.q(s,n,r).getValue(s)}updateValue(s,n,r={}){let u;r.resource?(u=this.m.get(r.resource),u||(u=new k,this.m.set(r.resource,u))):u=this.l,n===void 0?u.removeValue(s):u.setValue(s,n),r.resource||(this.a=null)}inspect(s,n,r){const u=this.q(s,n,r),I=this.u(n.resource,r),S=n.resource?this.m.get(n.resource)||this.l:this.l,$=new Set;for(const g of u.overrides)for(const w of g.identifiers)u.getOverrideValue(s,w)!==void 0&&$.add(w);return new o(s,n,u.getValue(s),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,I||void 0,S)}keys(s){const n=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.j.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const r=[];if(!n){const{added:u,updated:I,removed:S}=a(this.c,s);n=[...u,...I,...S]}for(const u of n)for(const I of(0,P.$An)(u)){const S=this.c.getKeysForOverrideIdentifier(I),$=s.getKeysForOverrideIdentifier(I),g=[...$.filter(w=>S.indexOf(w)===-1),...S.filter(w=>$.indexOf(w)===-1),...S.filter(w=>!m.$_m(this.c.override(I).getValue(w),s.override(I).getValue(w)))];r.push([I,g])}return this.updateDefaultConfiguration(s),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:r,removed:u}=a(this.d,s),I=[...n,...r,...u];return I.length&&this.updatePolicyConfiguration(s),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:r,removed:u,overrides:I}=a(this.applicationConfiguration,s),S=[...n,...r,...u];return S.length&&this.updateApplicationConfiguration(s),{keys:S,overrides:I}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:r,removed:u,overrides:I}=a(this.localUserConfiguration,s),S=[...n,...r,...u];return S.length&&this.updateLocalUserConfiguration(s),{keys:S,overrides:I}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:r,removed:u,overrides:I}=a(this.remoteUserConfiguration,s),S=[...n,...r,...u];return S.length&&this.updateRemoteUserConfiguration(s),{keys:S,overrides:I}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:r,removed:u,overrides:I}=a(this.workspaceConfiguration,s),S=[...n,...r,...u];return S.length&&this.updateWorkspaceConfiguration(s),{keys:S,overrides:I}}compareAndUpdateFolderConfiguration(s,n){const r=this.p.get(s),{added:u,updated:I,removed:S,overrides:$}=a(r,n),g=[...u,...I,...S];return(g.length||!r)&&this.updateFolderConfiguration(s,n),{keys:g,overrides:$}}compareAndDeleteFolderConfiguration(s){const n=this.p.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:u,removed:I,overrides:S}=a(n,void 0);return{keys:[...r,...u,...I],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,n,r){let u=this.r(n,r);return n.overrideIdentifier&&(u=u.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(u=u.merge(this.d)),u}r({resource:s},n){let r=this.s();if(n&&s){const u=n.getFolder(s);u&&(r=this.t(u.uri)||r);const I=this.m.get(s);I&&(r=r.merge(I))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let n=this.b.get(s);if(!n){const r=this.s(),u=this.j.get(s);u?(n=r.merge(u),this.b.set(s,n)):n=r}return n}u(s,n){if(n&&s){const r=n.getFolder(s);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,n)=>{const{contents:r,overrides:u,keys:I}=this.j.get(n);return s.push([n,{contents:r,overrides:u,keys:I}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.i.keys.forEach(n=>s.add(n)),this.j.forEach(n=>n.keys.forEach(r=>s.add(r))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}w(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(u=>n.add(u))),[...n.values()]}static parse(s){const n=this.x(s.defaults),r=this.x(s.policy),u=this.x(s.application),I=this.x(s.user),S=this.x(s.workspace),$=s.folders.reduce((g,w)=>(g.set(b.URI.revive(w[0]),this.x(w[1])),g),new A.$Ac);return new l(n,r,u,I,new k,S,$,new k,new A.$Ac)}static x(s){return new k(s.contents,s.keys,s.overrides)}}e.$In=l;function c(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const s=new Set,n=new Map;for(const u of i)u.keys.forEach(I=>s.add(I)),u.overrides.forEach(([I,S])=>{const $=(0,A.$xc)(n,I,new Set);S.forEach(g=>$.add(g))});const r=[];return n.forEach((u,I)=>r.push([I,[...u.values()]])),{keys:[...s.values()],overrides:r}}e.$Jn=c;class d{constructor(s,n,r,u){this.change=s,this.f=n,this.g=r,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of s.keys)this.affectedKeys.add(I);for(const[,I]of s.overrides)for(const S of I)this.affectedKeys.add(S);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=l.parse(this.f.data)),this.i}affectsConfiguration(s,n){const r=this.a+s,u=this.d.indexOf(r);if(u<0)return!1;const I=u+r.length;if(I>=this.d.length)return!1;const S=this.d.charCodeAt(I);if(S!==this.b&&S!==this.c)return!1;if(n){const $=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,g=this.g.getValue(s,n,this.h);return!m.$_m($,g)}return!0}}e.$Kn=d;function a(i,s){const{added:n,removed:r,updated:u}=t(s?.rawConfiguration,i?.rawConfiguration),I=[],S=i?.getAllOverrideIdentifiers()||[],$=s?.getAllOverrideIdentifiers()||[];if(s){const g=$.filter(w=>!S.includes(w));for(const w of g)I.push([w,s.getKeysForOverrideIdentifier(w)])}if(i){const g=S.filter(w=>!$.includes(w));for(const w of g)I.push([w,i.getKeysForOverrideIdentifier(w)])}if(s&&i){for(const g of S)if($.includes(g)){const w=t({contents:i.getOverrideValue(void 0,g)||{},keys:i.getKeysForOverrideIdentifier(g)},{contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)});I.push([g,[...w.added,...w.removed,...w.updated]])}}return{added:n,removed:r,updated:u,overrides:I}}function t(i,s){const n=i?s?i.keys.filter(I=>s.keys.indexOf(I)===-1):[...i.keys]:[],r=s?i?s.keys.filter(I=>i.keys.indexOf(I)===-1):[...s.keys]:[],u=[];if(i&&s){for(const I of s.keys)if(i.keys.indexOf(I)!==-1){const S=(0,L.$si)(s.contents,I),$=(0,L.$si)(i.contents,I);m.$_m(S,$)||u.push(I)}}return{added:n,removed:r,updated:u}}}),define(De[247],Ce([1,0,22,4,3,82]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkb=e.$Pkb=e.$Okb=e.$Nkb=void 0;const A=(b,L,P)=>{const p=new Uint8Array(16);for(let v=0;v<16;v++)p[v]=Math.round(Math.random()*256);const y=(0,C.$we)(C.$ce.wrap(p));return[`GET ws://localhost${b}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$Nkb=A,e.$Okb=C.$ce.fromString(`\r
\r
`);async function m(b,L,P,p,y){b.write(C.$ce.fromString((0,e.$Nkb)(L,P,p)));const k=new f.$Rc;try{return await new Promise((v,h)=>{let o;k.add(b.onData(l=>{o?o=C.$ce.concat([o,l],o.byteLength+l.byteLength):o=l;const c=o.indexOf(e.$Okb);if(c===-1)return;v(b),b.pauseData();const d=o.slice(c+e.$Okb.byteLength);d.byteLength&&y.onData.fire(d)})),k.add(b.onClose(l=>h(l??new Error("socket closed")))),k.add(b.onEnd(()=>h(new Error("socket ended"))))})}catch(v){throw b.dispose(),v}finally{k.dispose()}}e.$Pkb=m;class E extends f.$Sc{constructor(L,P){super(),this.g=L,this.a=this.B(new O.$Rd),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new O.$Od),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(p=>this.a.fire(p))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(L,P){R.SocketDiagnostics.traceSocketEvent(this,this.g,L,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Qkb=E}),define(De[65],Ce([1,0,9,5]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.RemoteAuthorityResolverErrorCode=e.$Sk=e.$Rk=e.RemoteConnectionType=e.$Qk=void 0,e.$Qk=(0,O.$Qh)("remoteAuthorityResolverService");var f;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class R{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Rk=R;class A{constructor(P,p){this.host=P,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sk=A;var m;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class E extends C.$bb{static isNotAvailable(P){return P instanceof E&&P._code===m.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof E&&P._code===m.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof E&&P._code===m.NoResolverFound}static isInvalidAuthority(P){return P instanceof E&&P._code===m.InvalidAuthority}static isHandled(P){return P instanceof E&&P.isHandled}constructor(P,p=m.Unknown,y){super(P),this._message=P,this._code=p,this._detail=y,this.isHandled=p===m.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Tk=E;function b(L){const P=L.indexOf("+");return P===-1?L:L.substring(0,P)}e.$Uk=b}),define(De[66],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0;function O(b){return b.scheme===C.Schemas.vscodeRemote?b.authority:void 0}e.$Vk=O;function f(b){if(!b)return;const L=b.indexOf("+");return L<0?b:b.substr(0,L)}e.$Wk=f;function R(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$Xk=R;function A(b){const{host:L,port:P}=E(b);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:P}}e.$Yk=A;function m(b,L){let{host:P,port:p}=E(b);return typeof p>"u"&&(p=L),{host:P,port:p}}e.$Zk=m;function E(b){const L=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const P=b.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const p=b.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:b,port:void 0}}}),define(De[25],Ce([1,0,15,5,66]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.TargetPlatform=e.ExtensionType=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l="extensions.user.cache",e.$2l="extensions.builtin.cache",e.$3l="undefined_publisher",e.$4l=["ui","workspace","web"];function R(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$5l=R,e.$6l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(A||(e.ExtensionType=A={}));var m;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class E{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,o){if(typeof h>"u"||h===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof h=="string"||typeof o=="string"){const l=typeof h=="string"?h:h.value,c=typeof o=="string"?o:o.value;return C.$3e(l,c)}return h._lower===o._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.$7l=E;class b{get size(){return this.c.size}constructor(h){if(this.c=new Set,h)for(const o of h)this.add(o)}add(h){this.c.add(E.toKey(h))}delete(h){return this.c.delete(E.toKey(h))}has(h){return this.c.has(E.toKey(h))}}e.$8l=b;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(h){this.c.delete(E.toKey(h))}get(h){return this.c.get(E.toKey(h))}has(h){return this.c.has(E.toKey(h))}set(h,o){this.c.set(E.toKey(h),o)}values(){return this.c.values()}forEach(h){this.c.forEach(h)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$9l=L;function P(v){return p(v)}e.$0l=P;function p(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$$l=p;function y(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$_l=y;function k(v,h){if(h){const o=`onResolveRemoteAuthority:${(0,f.$Wk)(h)}`;return!!v.activationEvents?.includes(o)}return!1}e.$am=k,e.$bm=(0,O.$Qh)("IBuiltinExtensionsScannerService")}),define(De[137],Ce([1,0,9,25]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(A,m){this.a.set(A,m)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const m=Object.create(null);for(const E of A){const b=this.readActivationEvents(E);b.length>0&&(m[O.$7l.toKey(E.identifier)]=b)}return m}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const m=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return m;for(const E in A.contributes){const b=this.a.get(E);if(!b)continue;const L=A.contributes[E],P=Array.isArray(L)?L:[L];try{b(P,m)}catch(p){(0,C.$1)(p)}}return m}}e.$2E=f,e.$3E=new f}),define(De[248],Ce([1,0,8,22,21,9,4,3,54,35,31,82,65,66]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.PersistentConnectionEventType=e.$7k=e.$6k=e.$5k=e.ConnectionType=void 0;const k=30*1e3;var v;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function h(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(H){const B=new f.$Yd;return setTimeout(()=>B.cancel(),H),B.token}function l(H,B){if(H.isCancellationRequested||B.isCancellationRequested)return f.CancellationToken.Cancelled;const Y=new f.$Yd;return H.onCancellationRequested(()=>Y.cancel()),B.onCancellationRequested(()=>Y.cancel()),Y.token}class c{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new m.$Rc,this.promise=new Promise((Y,re)=>{this.f=Y,this.g=re}),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function d(H,B){const Y=new c(B);return Y.registerDisposable(H.onControlMessage(re=>{const X=JSON.parse(re.toString()),_=G(X);_?Y.reject(_):Y.resolve(X)})),Y.promise}function a(H,B,Y,re,X,_,x,pe){const ae=new c(pe),fe=b.$Kd.create(!1);return H.info(`Creating a socket (${x})...`),E.mark(`code/willCreateSocket/${_}`),B.connect(Y,re,X,x).then(ee=>{ae.didTimeout?(E.mark(`code/didCreateSocketError/${_}`),H.info(`Creating a socket (${x}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(E.mark(`code/didCreateSocketOK/${_}`),H.info(`Creating a socket (${x}) was successful after ${fe.elapsed()} ms.`),ae.resolve(ee))},ee=>{E.mark(`code/didCreateSocketError/${_}`),H.info(`Creating a socket (${x}) returned an error after ${fe.elapsed()} ms.`),H.error(ee),ae.reject(ee)}),ae.promise}function t(H,B){const Y=new c(B);return H.then(re=>{Y.didTimeout||Y.resolve(re)},re=>{Y.didTimeout||Y.reject(re)}),Y.promise}async function i(H,B,Y,re){const X=ce(H,B);H.logService.trace(`${X} 1/6. invoking socketFactory.connect().`);let _;try{_=await a(H.logService,H.remoteSocketFactoryService,H.connectTo,(0,y.$Xk)(H),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,h(B),`renderer-${h(B)}-${H.reconnectionToken}`,re)}catch(ee){throw H.logService.error(`${X} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ee),ee}H.logService.trace(`${X} 2/6. socketFactory.connect() was successful.`);let x,pe;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(_,null),x=H.reconnectionProtocol,pe=!1):(x=new P.$Eh({socket:_}),pe=!0),H.logService.trace(`${X} 3/6. sending AuthRequest control message.`);const ae=await t(H.signService.createNewMessage((0,L.$fg)()),re),fe={type:"auth",auth:H.connectionToken||"00000000000000000000",data:ae.data};x.sendControl(O.$ce.fromString(JSON.stringify(fe)));try{const ee=await d(x,l(re,o(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const U=new Error("Unexpected handshake message");throw U.code="VSCODE_CONNECTION_ERROR",U}if(H.logService.trace(`${X} 4/6. received SignRequest control message.`),!await t(H.signService.validate(ae,ee.signedData),re)){const U=new Error("Refused to connect to unsupported server");throw U.code="VSCODE_CONNECTION_ERROR",U}const be=await t(H.signService.sign(ee.data),re),Pe={type:"connectionType",commit:H.commit,signedData:be,desiredConnectionType:B};return Y&&(Pe.args=Y),H.logService.trace(`${X} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(O.$ce.fromString(JSON.stringify(Pe))),{protocol:x,ownsProtocol:pe}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(H.logService.error(`${X} the handshake timed out. Error:`),H.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${X} received error control message when negotiating connection. Error:`),H.logService.error(ee)),pe&&te(x),ee}}async function s(H,B,Y,re){const X=Date.now(),_=ce(H,B),{protocol:x,ownsProtocol:pe}=await i(H,B,Y,re),ae=new c(re);return ae.registerDisposable(x.onControlMessage(fe=>{const ee=JSON.parse(fe.toString()),de=G(ee);de?(H.logService.error(`${_} received error control message when negotiating connection. Error:`),H.logService.error(de),pe&&te(x),ae.reject(de)):(H.reconnectionProtocol?.endAcceptReconnection(),H.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${ye(X)}!`),ae.resolve({protocol:x,firstMessage:ee}))})),ae.promise}async function n(H,B){const{protocol:Y}=await s(H,1,void 0,B);return{protocol:Y}}async function r(H,B,Y){const{protocol:re,firstMessage:X}=await s(H,2,B,Y),_=X&&X.debugPort;return{protocol:re,debugPort:_}}async function u(H,B,Y){const re=Date.now(),X=ce(H,3),{protocol:_}=await i(H,3,B,Y);return H.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${ye(re)}!`),_}async function I(H,B,Y){const{connectTo:re,connectionToken:X}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,connectTo:re,connectionToken:X,reconnectionToken:B,reconnectionProtocol:Y,remoteSocketFactoryService:H.remoteSocketFactoryService,signService:H.signService,logService:H.logService}}async function S(H,B,Y){return g(H,async re=>{const{protocol:X}=await n(re,f.CancellationToken.None);return new K(H,B,Y,re.reconnectionToken,X)})}e.$5k=S;async function $(H,B){return g(H,async Y=>{const{protocol:re,debugPort:X}=await r(Y,B,f.CancellationToken.None);return new me(H,B,Y.reconnectionToken,re,X)})}e.$6k=$;async function g(H,B){for(let re=1;;re++)try{const X=(0,L.$fg)(),_=await I(H,X,null);return await B(_)}catch(X){if(re<5)H.logService.error(`[remote-connection][attempt ${re}] An error occurred in initial connection! Will retry... Error:`),H.logService.error(X);else throw H.logService.error(`[remote-connection][attempt ${re}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),H.logService.error(X),q.triggerPermanentFailure(0,0,p.$Tk.isHandled(X)),X}}async function w(H,B,Y){const re=await I(H,(0,L.$fg)(),null);return await u(re,{host:B,port:Y},f.CancellationToken.None)}e.$7k=w;function D(H){return(0,C.$Ig)(B=>new Promise((Y,re)=>{const X=setTimeout(Y,H*1e3);B.onCancellationRequested(()=>{clearTimeout(X),Y()})}))}var T;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class M{constructor(B,Y){this.reconnectionToken=B,this.millisSinceLastIncomingData=Y,this.type=0}}e.$8k=M;class F{constructor(B,Y,re,X){this.reconnectionToken=B,this.millisSinceLastIncomingData=Y,this.durationSeconds=re,this.c=X,this.type=1}skipWait(){this.c.cancel()}}e.$9k=F;class z{constructor(B,Y,re){this.reconnectionToken=B,this.millisSinceLastIncomingData=Y,this.attempt=re,this.type=2}}e.$0k=z;class j{constructor(B,Y,re){this.reconnectionToken=B,this.millisSinceLastIncomingData=Y,this.attempt=re,this.type=4}}e.$$k=j;class N{constructor(B,Y,re,X){this.reconnectionToken=B,this.millisSinceLastIncomingData=Y,this.attempt=re,this.handled=X,this.type=3}}e.$_k=N;class q extends m.$Sc{static triggerPermanentFailure(B,Y,re){this._permanentFailure=!0,this.f=B,this.g=Y,this.h=re,this.j.forEach(X=>X.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||q._permanentFailure}constructor(B,Y,re,X,_){super(),this.t=B,this.u=Y,this.reconnectionToken=re,this.protocol=X,this.w=_,this.m=this.B(new A.$Od),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new j(this.reconnectionToken,0,0)),this.B(X.onSocketClose(x=>{const pe=ie(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${pe} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${pe} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${pe} received socket close event.`),this.y()})),this.B(X.onSocketTimeout(x=>{const pe=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${pe} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),q.j.push(this),this.B((0,m.$Qc)(()=>{const x=q.j.indexOf(this);x>=0&&q.j.splice(x,1)})),this.n&&this.D(q.f,q.g,q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Y=[0,5,5,10,10,10,10,10,30];let re=-1;do{re++;const X=re<Y.length?Y[re]:Y[Y.length-1];try{if(X>0){const x=D(X);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X,x)),this.u.logService.info(`${B} waiting for ${X} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1)),this.u.logService.info(`${B} resolving connection...`);const _=await I(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${_.connectTo}...`),await this.G(_,o(k)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(re>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(p.$Tk.isTemporarilyNotAvailable(_)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((0,R.$4)(_)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if(_ instanceof p.$Tk){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,p.$Tk.isHandled(_));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}}while(!this.n&&!this.s)}C(B,Y,re){this.w?q.triggerPermanentFailure(B,Y,re):this.D(B,Y,re)}D(B,Y,re){this.m.fire(new N(this.reconnectionToken,B,Y,re)),te(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$al=q;class K extends q{constructor(B,Y,re,X,_){super(1,B,X,_,!0),this.client=this.B(new P.$Ch(_,{remoteAuthority:Y,clientId:re},B.ipcLogger))}async G(B,Y){await n(B,Y)}}e.$bl=K;class me extends q{constructor(B,Y,re,X,_){super(2,B,re,X,!1),this.H=Y,this.debugPort=_}async G(B,Y){await r(B,this.H,Y)}}e.$cl=me;function te(H){try{H.acceptDisconnect();const B=H.getSocket();H.dispose(),B.dispose()}catch(B){(0,R.$1)(B)}}function G(H){if(H&&H.type==="error"){const B=new Error(`Connection error: ${H.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function J(H,B){for(;H.length<B;)H+=" ";return H}function le(H,B){return`[remote-connection][${J(h(H),13)}][${B.substr(0,5)}\u2026]`}function ie(H,B,Y){return`${le(H,B)}[${Y?"reconnect":"initial"}]`}function ce(H,B){return`${ie(B,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.connectTo}]`}function ye(H){return`${Date.now()-H} ms`}}),define(De[249],Ce([1,0,3,5]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=void 0,e.$1k=(0,O.$Qh)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(A,m){return this.a[A]??=[],this.a[A].push(m),(0,C.$Qc)(()=>{const E=this.a[A]?.indexOf(m);typeof E=="number"&&E>=0&&this.a[A]?.splice(E,1)})}b(A){return(this.a[A.type]||[]).find(E=>E.supports(A))}connect(A,m,E,b){const L=this.b(A);if(!L)throw new Error(`No socket factory found for ${A}`);return L.connect(A,m,E,b)}}e.$2k=f}),define(De[250],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M3b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const R=await this.c();if(R){const A=String(C.a++);return this.b.set(A,R),{id:A,data:R.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,R){if(!f.id)return!0;const A=this.b.get(f.id);if(!A)return!1;this.b.delete(f.id);try{return A.validate(R)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$M3b=C}),define(De[106],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=void 0,e.$3k="signService",e.$4k=(0,C.$Qh)(e.$3k)}),define(De[138],Ce([1,0,250]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=void 0;class O extends C.$M3b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(A=>new A.signer().sign(R))}h(){return new Promise((R,A)=>$e(["vsda"],R,A))}}e.$G8b=O}),define(De[251],Ce([1,0,12,48,31]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=void 0;function R(E){if(C.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,b,L,P,p,y,k,v,h){const o=Object.create(null);o["common.machineId"]=y,o["common.sqmId"]=k,o.sessionID=(0,f.$fg)()+Date.now(),o.commitHash=P,o.version=p,o["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$i)(C.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=L,o["common.product"]=h||"desktop",v&&(o["common.msftInternal"]=v);let l=0;const c=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),C.$m&&(o["common.snap"]="true");const d=R(b);return d&&(o["common.platformDetail"]=d),o}e.$lo=A;function m(E){const b=O.env.USERDNSDOMAIN;if(!b)return!1;const L=b.toLowerCase();return E.some(P=>L===P)}e.$mo=m}),define(De[252],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0,e.$dl=(0,C.$Qh)("telemetryService"),e.$el=(0,C.$Qh)("customEndpointTelemetryService"),e.$fl="telemetry.currentSessionDate",e.$gl="telemetry.firstSessionDate",e.$hl="telemetry.lastSessionDate",e.$il="telemetry.machineId",e.$jl="telemetry.sqmId",e.$kl="telemetry",e.$ll="telemetry.telemetryLevel",e.$ml="telemetry.enableCrashReporter",e.$nl="telemetry.enableTelemetry";var O;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var f;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(De[85],Ce([1,0,24,17,4,50,66,251,252]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;class b{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$no=b;class L{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$oo=L,e.$po=new L;class P{async publicLog(r,u,I){}async publicLogError(r,u,I){}}e.$qo=P,e.$ro="telemetry",e.$so="extensionTelemetryLog",e.$to={log:()=>null,flush:()=>Promise.resolve(null)};function p(n,r){return f.Event.debounce(r.onDidChangeConfiguration,(I,S)=>{const $=I?new Set([...I.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:$}},1e3,!0)(I=>{I.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,R.$ni)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$uo=p;function y(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}e.$vo=y;function k(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$wo=k;function v(n){const r=n.getValue(E.$ll),u=n.getValue(E.$ml);if(n.getValue(E.$nl)===!1||u===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$xo=v;function h(n){const r={},u={},I={};c(n,I);for(let S in I){S=S.length>150?S.substr(S.length-149):S;const $=I[S];typeof $=="number"?u[S]=$:typeof $=="boolean"?u[S]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${$.length}`),r[S]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(r[S]=$)}return{properties:r,measurements:u}}e.$yo=h;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(n){if(!n)return"none";const r=(0,A.$Wk)(n);return o.has(r)?r:"other"}e.$zo=l;function c(n,r,u=0,I){if(n)for(const S of Object.getOwnPropertyNames(n)){const $=n[S],g=I?I+S:S;Array.isArray($)?r[g]=(0,C.$an)($):$ instanceof Date?r[g]=$.toISOString():(0,O.$Bf)($)?u<2?c($,r,u+1,g+"."):r[g]=(0,C.$an)($):r[g]=$}}function d(n,r){const u=n.msftInternalDomains||[],I=r.getValue("telemetry.internalTesting");return(0,m.$mo)(u)||I}e.$Ao=d;function a(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$Bo=a;function t(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let u=n;const I=[];for(const w of r)for(;;){const D=w.exec(n);if(!D)break;I.push([D.index,w.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(u="";;){const w=$.exec(n);if(!w)break;const D=I.some(([T,M])=>w.index<M&&T<$.lastIndex);!S.test(w[0])&&!D&&(u+=n.substring(g,w.index)+"<REDACTED: user-file-path>",g=$.lastIndex)}return g<n.length&&(u+=n.substr(g)),u}function i(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of r)if(u.regex.test(n))return`<REDACTED: ${u.label}>`;return n}function s(n,r){return(0,C.$0m)(n,u=>{if(u instanceof b||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let I=u.replaceAll("%20"," ");I=t(I,r);for(const S of r)I=I.replace(S,"");return I=i(I),I}})}e.$Co=s}),define(De[253],Ce([1,0,15,132,25,12,2,9,48,85]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=void 0;function L(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,C.$Xe)(s.id,n.id)===0}e.$Do=L;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(n){const r=n.manifest?n.manifest.version:n.version,u=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new p(n.identifier,r,u)}static parse(n){const r=P.exec(n);return r&&r[1]&&r[2]?new p({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,u="undefined"){this.version=r,this.targetPlatform=u,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof p?L(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$Eo=p;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(s){const n=y.exec(s);return n&&n[1]?[h(n[1]),n[2]]:[h(s),void 0]}e.$Fo=k;function v(s,n){return`${s}.${n}`}e.$Go=v;function h(s){return s.toLowerCase()}e.$Ho=h;function o(s,n){return h(v(s??f.$3l,n))}e.$Io=o;function l(s,n){const r=[],u=I=>{for(const S of r)if(S.some($=>L(n($),n(I))))return S;return null};for(const I of s){const S=u(I);S?S.push(I):r.push([I])}return r}e.$Jo=l;function c(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$Ko=c;function d(s){return{id:new b.$no(s.identifier.id),name:new b.$no(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Lo=d,e.$Mo=new f.$7l("pprice.better-merge");function a(s,n){const r=[],u=n.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const I=u.shift();if(I&&r.every(S=>!L(S.identifier,{id:I}))){const S=s.filter($=>L($.identifier,{id:I}));S.length===1&&(r.push(S[0]),u.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.$No=a;async function t(s,n){if(!R.$l)return!1;let r;try{r=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){n.debug("Error while getting the os-release file.",(0,m.$0)(I))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(s,n){const r=await t(s,n),u=(0,O.$0n)(r?"alpine":R.$u,E.$ec);return n.debug("ComputeTargetPlatform:",u),u}e.$Oo=i}),define(De[254],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=e.$qr=e.$pr=e.$or=void 0;function C(E){return[...E.entries()]}e.$or=C;function O(E){return E?[...E.entries()]:[]}e.$pr=O;function f(E){return new Map(E)}e.$qr=f;function R(E){return new Map(E??[])}e.$rr=R;function A(E){return Array.from(E.entries()).map(b=>[b[0],C(b[1].map),O(b[1].descriptionMap)])}e.$sr=A;function m(E){return new Map(E.map(b=>[b[0],{map:f(b[1]),descriptionMap:R(b[2])}]))}e.$tr=m}),define(De[255],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kb=void 0;class C{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,R,A=5){const m=R(E=>{const b=typeof E=="string"?E:E.data;let L=this.a.get(f);if(L){L.data.push(b);return}const P=setTimeout(()=>this.flushBuffer(f),A);L={data:[b],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(f),m.dispose()}},this.a.set(f,L)});return m}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const R=this.a.get(f);R&&(this.a.delete(f),this.b(f,R.data.join("")))}}e.$8kb=C}),define(De[256],Ce([1,0,8,79,59,4,17,2,199,105,43]),function($e,e,C,O,f,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.IconFontDefinition=e.IconContribution=e.$9v=void 0,e.$9v={IconContribution:"base.contributions.icons"};var P;(function(d){function a(t,i){let s=t.defaults;for(;f.ThemeIcon.isThemeIcon(s);){const n=k.getIcon(s.id);if(!n)return;s=n.defaults}return s}d.getDefinition=a})(P||(e.IconContribution=P={}));var p;(function(d){function a(i){return{weight:i.weight,style:i.style,src:i.src.map(s=>({format:s.format,location:s.location.toString()}))}}d.toJSONObject=a;function t(i){const s=n=>(0,A.$zf)(n)?n:void 0;if(i&&Array.isArray(i.src)&&i.src.every(n=>(0,A.$zf)(n.format)&&(0,A.$zf)(n.location)))return{weight:s(i.weight),style:s(i.style),src:i.src.map(n=>({format:n.format,location:m.URI.parse(n.location)}))}}d.fromJSONObject=t})(p||(e.IconFontDefinition=p={}));class y{constructor(){this.a=new R.$Od,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,i,s){const n=this.b[a];if(n){if(i&&!n.description){n.description=i,this.d.properties[a].markdownDescription=`${i} $(${a})`;const I=this.e.enum.indexOf(a);I!==-1&&(this.e.enumDescriptions[I]=i),this.a.fire()}return n}const r={id:a,description:i,defaults:t,deprecationMessage:s};this.b[a]=r;const u={$ref:"#/definitions/icons"};return s&&(u.deprecationMessage=s),i&&(u.markdownDescription=`${i}: $(${a})`),this.d.properties[a]=u,this.e.enum.push(a),this.e.enumDescriptions.push(i||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const i=this.f[a];return i||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(n,r)=>n.id.localeCompare(r.id),t=n=>{for(;f.ThemeIcon.isThemeIcon(n.defaults);)n=this.b[n.defaults.id];return`codicon codicon-${n?n.id:""}`},i=[];i.push("| preview     | identifier                        | default codicon ID                | description"),i.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(n=>this.b[n]);for(const n of s.filter(r=>!!r.description).sort(a))i.push(`|<i class="${t(n)}"></i>|${n.id}|${f.ThemeIcon.isThemeIcon(n.defaults)?n.defaults.id:n.id}|${n.description||""}|`);i.push("| preview     | identifier                        "),i.push("| ----------- | --------------------------------- |");for(const n of s.filter(r=>!f.ThemeIcon.isThemeIcon(r.defaults)).sort(a))i.push(`|<i class="${t(n)}"></i>|${n.id}|`);return i.join(`
`)}}const k=new y;L.$kn.add(e.$9v.IconContribution,k);function v(d,a,t,i){return k.registerIcon(d,a,t,i)}e.$0v=v;function h(){return k}e.$$v=h;function o(){const d=(0,O.$Tj)();for(const a in d){const t="\\"+d[a].toString(16);k.registerIcon(a,{fontCharacter:t})}}o(),e.$_v="vscode://schemas/icons";const l=L.$kn.as(b.$ln.JSONContribution);l.registerSchema(e.$_v,k.getIconSchema());const c=new C.$7g(()=>l.notifySchemaChanged(e.$_v),200);k.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$aw=v("widget-close",O.$Vj.close,(0,E.localize)(2,null)),e.$bw=v("goto-previous-location",O.$Vj.arrowUp,(0,E.localize)(3,null)),e.$cw=v("goto-next-location",O.$Vj.arrowDown,(0,E.localize)(4,null)),e.$dw=f.ThemeIcon.modify(O.$Vj.sync,"spin"),e.$ew=f.ThemeIcon.modify(O.$Vj.loading,"spin")}),define(De[86],Ce([1,0,4,50,5,14]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.ProvidedOnAutoForward=e.$dv=e.TunnelPrivacyId=e.TunnelProtocol=e.$cv=e.$bv=void 0,e.$bv=(0,f.$Qh)("tunnelService"),e.$cv=(0,f.$Qh)("sharedTunnelsService");var A;(function(h){h.Http="http",h.Https="https"})(A||(e.TunnelProtocol=A={}));var m;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(h){return!!h.forwardPort}e.$dv=E;var b;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function L(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(o)return{address:o[1],port:+o[2]}}e.$ev=L,e.$fv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.$fv.indexOf(h)>=0}e.$gv=P,e.$hv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(h){return e.$hv.indexOf(h)>=0}e.$iv=p;function y(h,o,l,c){if(l===1)return!1;if(l===2&&p(o)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(d?.length===4&&parseInt(d[1])>=18)return!1}return h<1024}e.$jv=y;class k{constructor(o,l,c){this.remoteAddress=o,this.localAddress=l,this.b=c,this.a=new C.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$kv=k;let v=class{constructor(o,l){this.j=o,this.k=l,this.a=new C.$Od,this.onTunnelOpened=this.a.event,this.b=new C.$Od,this.onTunnelClosed=this.b.event,this.c=new C.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],l=Array.from(this.e.values());for(const c of l){const d=Array.from(c.values());for(const a of d){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:l}of o.values())await l.then(c=>typeof c!="string"?c?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,l,c,d,a){this.p(o,l,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:l,localAddress:c,privacy:d,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,l){(p(o)||P(o))&&(o=e.$fv[0]);const c=this.r(o,l);if(c)return++c.refcount,c.value}openTunnel(o,l,c,d,a,t=!1,i,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${c} on local port ${a}.`);const n=this.f??o;if(!n)return;if(l||(l="localhost"),d||(d=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.s(n,l,c,d,a,t,i,s);return r?r.then(u=>{if(u){if(typeof u=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(l,c),u}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(l,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(u);return(u.tunnelRemoteHost!==l||u.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&u.privacy!==i&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const l=this.e.get(o.tunnelRemoteHost);if(l){const c=l.get(o.tunnelRemotePort);c&&(c.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,c))}}}}async o(o,l,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${l}.`);const d=c.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(l),d}}async closeTunnel(o,l){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${l} `);const c=this.e.get(o);if(c&&c.has(l)){const d=c.get(l);d.refcount=0,await this.o(o,l,d)}}p(o,l,c){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(l,{refcount:1,value:c})}async q(o,l){const c=this.e.get(o);if(c){const d=c.get(l),a=d?await d.value:void 0;(!a||typeof a=="string")&&c.delete(l),c.size===0&&this.e.delete(o)}}r(o,l){const c=[o];P(o)?(c.push(...e.$fv),c.push(...e.$hv)):p(o)&&c.push(...e.$hv);const d=c.map(a=>this.e.get(a));for(const a of d){const t=a?.get(l);if(t)return t}}canTunnel(o){return!!L(o)}t(o,l,c,d,a,t,i){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${c} on local port ${d}.`);const s=c;this.i.add(s);const n=d===void 0?c:d,r={elevationRequired:a?this.isPortPrivileged(n):!1},u={remoteAddress:{host:l,port:c},localAddressPort:d,privacy:t,public:t?t!==m.Private:void 0,protocol:i},I=o.forwardPort(u,r);return I?(this.p(l,c,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),I}};e.$lv=v,e.$lv=v=He([Be(0,R.$$i),Be(1,O.$ki)],v)}),define(De[257],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=void 0,e.$Jk=(0,C.$Qh)("IUriIdentityService")}),define(De[258],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$mv=void 0,e.$mv=(0,C.$Qh)("editSessionIdentityService");var O;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(De[259],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=void 0;function O(E){return E.scheme!==C.Schemas.file&&E.scheme!==C.Schemas.vscodeRemote}e.$YJ=O;function f(E){if(E.folders.length)return E.folders.every(b=>O(b.uri))?E.folders[0].uri:void 0;if(E.configuration&&O(E.configuration))return E.configuration}e.$ZJ=f;function R(E){return f(E)?.scheme}e.$1J=R;function A(E){return f(E)?.authority}e.$2J=A;function m(E){return f(E)!==void 0}e.$3J=m}),define(De[44],Ce([1,0,201,16,78,23,2,5,18]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.WorkbenchState=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0,e.$Zh=(0,m.$Qh)("contextService");function b(n){const r=n;return typeof r?.id=="string"&&A.URI.isUri(r.uri)}e.$1h=b;function L(n){return typeof n?.id=="string"&&!b(n)&&!p(n)}e.$2h=L,e.$3h={id:"ext-dev"},e.$4h={id:"empty-window"};function P(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,O.$nc)(n)}:r?e.$3h:e.$4h;const u=n;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}e.$5h=P;function p(n){const r=n;return typeof r?.id=="string"&&A.URI.isUri(r.configPath)}e.$6h=p;function y(n){const r=n;if(r?.uri)return{id:r.id,uri:A.URI.revive(r.uri)};const u=n;if(u?.configPath)return{id:u.id,configPath:A.URI.revive(u.configPath)};if(n?.id)return{id:n.id}}e.$7h=y;var k;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function v(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.$8h=v;function h(n){const r=n;return!!(r&&typeof r=="object"&&A.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.$9h=h;class o{constructor(r,u,I,S,$){this.h=r,this.j=I,this.k=S,this.l=$,this.c=f.$Wh.forUris(this.l,()=>!0),this.folders=u}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=f.$Wh.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$0h=o;class l{constructor(r,u){this.raw=u,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.$wg)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$$h=l;function c(n){return new l({uri:n,index:0,name:(0,R.$sg)(n)},{uri:n.toString()})}e.$_h=c,e.$ai="code-workspace",e.$bi=`.${e.$ai}`,e.$ci=[{name:(0,C.localize)(0,null),extensions:[e.$ai]}],e.$di="workspace.json";function d(n,r){return R.$ng.isEqualOrParent(n,r.untitledWorkspacesHome)}e.$ei=d;function a(n){let r;return A.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===E.Schemas.tmp}e.$fi=a,e.$gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$gi}e.$hi=t;function i(n,r){return!d(n,r)&&!a(n)}e.$ii=i;function s(n){return(typeof n=="string"?(0,O.$oc)(n):(0,R.$ug)(n))===e.$bi}e.$ji=s}),define(De[260],Ce([1,0,52,4,3,23,2,200,131,30,5,14,44,28,257,8,31,15,17]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.ProfileResourceType=void 0;var c;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function d(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&A.URI.isUri(r.location)&&A.URI.isUri(r.globalStorageHome)&&A.URI.isUri(r.settingsResource)&&A.URI.isUri(r.keybindingsResource)&&A.URI.isUri(r.tasksResource)&&A.URI.isUri(r.snippetsHome)&&A.URI.isUri(r.extensionsResource))}e.$Kk=d,e.$Lk=(0,L.$Qh)("IUserDataProfilesService");function a(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:A.URI.revive(n.location).with({scheme:r}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:r}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Mk=a;function t(n,r,u,I,S,$){return{id:n,name:r,location:u,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:$&&S?.useDefaultFlags?.globalState?$.globalStorageHome:(0,R.$wg)(u,"globalStorage"),settingsResource:$&&S?.useDefaultFlags?.settings?$.settingsResource:(0,R.$wg)(u,"settings.json"),keybindingsResource:$&&S?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,R.$wg)(u,"keybindings.json"),tasksResource:$&&S?.useDefaultFlags?.tasks?$.tasksResource:(0,R.$wg)(u,"tasks.json"),snippetsHome:$&&S?.useDefaultFlags?.snippets?$.snippetsHome:(0,R.$wg)(u,"snippets"),extensionsResource:$&&S?.useDefaultFlags?.extensions?$.extensionsResource:(0,R.$wg)(u,"extensions.json"),cacheHome:(0,R.$wg)(I,n),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$Nk=t;let i=class extends f.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(r,u,I,S){super(),this.t=r,this.u=u,this.w=I,this.y=S,this.f=!0,this.h=this.B(new O.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(r){this.f!==r&&(this.z=void 0,this.f=r)}isEnabled(){return this.f}get C(){if(!this.z){const r=this.D(),u=[r];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,l.$zf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}u.push(t((0,R.$tg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},r))}}catch($){this.y.error($)}const I=new y.$Ac,S=new Map;if(u.length)try{const $=this.Q();if($.workspaces)for(const[g,w]of Object.entries($.workspaces)){const D=A.URI.parse(g),T=u.find(M=>M.id===w);T&&I.set(D,T)}if($.emptyWindows)for(const[g,w]of Object.entries($.emptyWindows)){const D=u.find(T=>T.id===w);D&&S.set(g,D)}}catch($){this.y.error($)}this.z={profiles:u,workspaces:I,emptyWindows:S}}return this.z}D(){const r=t("__default__profile__",(0,m.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...r,extensionsResource:this.S()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const u="Temp",I=new RegExp(`${(0,o.$Ge)(u)}\\s(\\d+)`);let S=0;for(const g of this.profiles){const w=I.exec(g.name),D=w?parseInt(w[1]):0;S=D>S?D:S}const $=`${u} ${S+1}`;return this.createProfile((0,C.$Ei)((0,h.$fg)()).toString(16),$,{transient:!0},r)}async createNamedProfile(r,u,I){return this.createProfile((0,C.$Ei)((0,h.$fg)()).toString(16),r,u,I)}async createProfile(r,u,I,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(r,u,I);return S&&await this.setProfileForWorkspace(S,$),$}async F(r,u,I){if(!(0,l.$zf)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(u);return S||(S=(async()=>{try{const $=this.profiles.find(D=>D.name===u||D.id===r);if($)return $;const g=t(r,u,(0,R.$wg)(this.profilesHome,r),this.g,I,this.defaultProfile);await this.u.createFolder(g.location);const w=[];return this.j.fire({profile:g,join(D){w.push(D)}}),await v.Promises.settled(w),this.I([g],[],[]),g}finally{this.r.delete(u)}})(),this.r.set(u,S)),S}async updateProfile(r,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let I=this.profiles.find(S=>S.id===r.id);if(!I)throw new Error(`Profile '${r.name}' does not exist`);return I=t(I.id,u.name??I.name,I.location,this.g,{shortName:u.shortName??I.shortName,icon:u.icon===null?void 0:u.icon??I.icon,transient:u.transient??I.isTransient,useDefaultFlags:u.useDefaultFlags??I.useDefaultFlags},this.defaultProfile),this.I([],[],[I]),I}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(S=>S.id===r.id);if(!u)throw new Error(`Profile '${r.name}' does not exist`);const I=[];this.m.fire({profile:u,join(S){I.push(S)}});try{await Promise.allSettled(I)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(S){(0,b.$qk)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(r,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=this.profiles.find(S=>S.id===u.id);if(!I)throw new Error(`Profile '${u.name}' does not exist`);this.L(r,I)}unsetWorkspace(r,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(r,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const r=await this.u.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(u=>u.isDirectory&&this.profiles.every(I=>!this.w.extUri.isEqual(I.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(r.map(u=>this.removeProfile(u)))}getProfileForWorkspace(r){const u=this.G(r);return A.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(r){return(0,p.$1h)(r)?r.uri:(0,p.$6h)(r)?r.configPath:r.id}H(r){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,r.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,r.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,r.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,r.location)))}I(r,u,I){const S=[...this.profiles,...r],$=[];this.s.profiles=[];for(let g of S)g.isDefault||u.some(w=>g.id===w.id)||(g=I.find(w=>g.id===w.id)??g,g.isTransient?this.s.profiles.push(g):$.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags}));this.P($),this.z=void 0,this.J(r,u,I)}J(r,u,I){this.h.fire({added:r,removed:u,updated:I,all:this.profiles})}L(r,u,I){I=u?.isTransient?!0:I,I||this.L(r,void 0,!0);const S=this.G(r),$=I?this.s:this.C;A.URI.isUri(S)?($.workspaces.delete(S),u&&$.workspaces.set(S,u)):($.emptyWindows.delete(S),u&&$.emptyWindows.set(S,u)),I||this.M()}M(){const r={};for(const[I,S]of this.C.workspaces.entries())r[I.toString()]=S.id;const u={};for(const[I,S]of this.C.emptyWindows.entries())u[I.toString()]=S.id;this.R({workspaces:r,emptyWindows:u}),this.z=void 0}N(r){const u={},I=this.D();if(r.workspaces)for(const[$,g]of Object.entries(r.workspaces)){const w=A.URI.parse(g);u[$]=this.w.extUri.isEqual(w,I.location)?I.id:this.w.extUri.basename(w)}const S={};if(r.emptyWindows)for(const[$,g]of Object.entries(r.emptyWindows)){const w=A.URI.parse(g);S[$]=this.w.extUri.isEqual(w,I.location)?I.id:this.w.extUri.basename(w)}return{workspaces:u,emptyWindows:S}}O(){return[]}P(r){throw new Error("not implemented")}Q(){return{}}R(r){throw new Error("not implemented")}S(){}};e.$Ok=i,e.$Ok=i=He([Be(0,E.$Xh),Be(1,b.$_j),Be(2,k.$Jk),Be(3,P.$$i)],i);class s extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(r){this.a=r}Q(){return this.X}R(r){this.X=r}}e.$Pk=s}),define(De[261],Ce([1,0,8,4,3,54,17,184,5,260]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$0o=e.$9o=e.$8o=void 0,e.$8o="__$__isNewStorageMarker",e.$9o="__$__targetStorageMarker",e.$0o=(0,E.$Qh)("storageService");var L;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var P;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var p;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function y(l){const c=l.get(e.$9o);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.$$o=y;class k extends f.$Sc{static{this.a=60*1e3}constructor(c={flushInterval:k.a}){super(),this.m=c,this.b=this.B(new O.$Rd),this.c=this.B(new O.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new C.$7g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(c,d,a){return O.Event.filter(this.b.event,t=>t.scope===c&&(d===void 0||t.key===d),a)}n(){this.j.value=(0,C.$$g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(c,d){const{key:a,external:t}=d;if(a===e.$9o){switch(c){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:a,target:this.J(c)[a],external:t})}w(c){this.f.fire({reason:c})}get(c,d,a){return this.P(d)?.get(c,a)}getBoolean(c,d,a){return this.P(d)?.getBoolean(c,a)}getNumber(c,d,a){return this.P(d)?.getNumber(c,a)}getObject(c,d,a){return this.P(d)?.getObject(c,a)}storeAll(c,d){this.y(()=>{for(const a of c)this.store(a.key,a.value,a.scope,a.target,d)})}store(c,d,a,t,i=!1){if((0,A.$If)(d)){this.remove(c,a,i);return}this.y(()=>{this.z(c,a,t),this.P(a)?.set(c,d,i)})}remove(c,d,a=!1){this.y(()=>{this.z(c,d,void 0),this.P(d)?.delete(c,a)})}y(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,d){const a=[],t=this.J(c);for(const i of Object.keys(t))t[i]===d&&a.push(i);return a}z(c,d,a,t=!1){const i=this.J(d);typeof a=="number"?i[c]!==a&&(i[c]=a,this.P(d)?.set(e.$9o,JSON.stringify(i),t)):typeof i[c]=="number"&&(delete i[c],this.P(d)?.set(e.$9o,JSON.stringify(i),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(c){switch(c){case-1:return this.I;case 0:return this.G;default:return this.D}}L(c){const d=this.P(c);return d?y(d):Object.create(null)}isNew(c){return this.getBoolean(e.$8o,c)===!0}async flush(c=L.NONE){this.f.fire({reason:c});const d=this.P(-1),a=this.P(0),t=this.P(1);switch(c){case L.NONE:await C.Promises.settled([d?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await C.Promises.settled([d?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return o(c,d,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(c){return await this.flush(),this.P(c)?.optimize()}async switch(c,d){return this.w(L.NONE),(0,b.$Kk)(c)?this.R(c,d):this.S(c,d)}M(c,d){return!(c.id===d.id||v(d)&&v(c))}N(c,d,a){this.y(()=>{const t=new Set;for(const[i,s]of c)t.add(i),d.get(i)!==s&&this.u(a,{key:i,external:!0});for(const[i]of d.items)t.has(i)||this.u(a,{key:i,external:!0})})}}e.$_o=k;function v(l){return l.isDefault||!!l.useDefaultFlags?.globalState}e.$ap=v;class h extends k{constructor(){super(),this.U=this.B(new m.$6o(new m.$7o,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new m.$6o(new m.$7o,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new m.$6o(new m.$7o,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(c=>this.u(1,c))),this.B(this.W.onDidChangeStorage(c=>this.u(0,c))),this.B(this.U.onDidChangeStorage(c=>this.u(-1,c)))}P(c){switch(c){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(c){return!1}}e.$bp=h;async function o(l,c,d,a,t,i){const s=D=>{try{return JSON.parse(D)}catch{return D}},n=new Map,r=new Map;l.forEach((D,T)=>{n.set(T,D),r.set(T,s(D))});const u=new Map,I=new Map;c.forEach((D,T)=>{u.set(T,D),I.set(T,s(D))});const S=new Map,$=new Map;d.forEach((D,T)=>{S.set(T,D),$.set(T,s(D))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const g=[];if(n.forEach((D,T)=>{g.push({key:T,value:D})}),console.table(g),console.groupEnd(),console.log(r),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const D=[];u.forEach((T,M)=>{D.push({key:M,value:T})}),console.table(D),console.groupEnd(),console.log(I)}console.group(`Storage: Workspace (path: ${i})`);const w=[];S.forEach((D,T)=>{w.push({key:T,value:D})}),console.table(w),console.groupEnd(),console.log($)}e.$cp=o}),define(De[107],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;class C{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const R=this.c++;return this.b.set(R,f),this.e(),R}get(f,R){return this.b.has(f)?this.b.get(f)[R]:void 0}delete(f){this.b.delete(f),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$wcc=C}),define(De[55],Ce([1,0,18,23,5]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=e.$ycc=void 0;class R{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new O.$lg(m=>{const E=this.b.get(m.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(m,E){E===null?this.b.delete(m.scheme):this.b.set(m.scheme,E)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$ycc=R,e.$zcc=(0,f.$Qh)("IExtHostFileSystemInfo")}),define(De[27],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=void 0,e.$GM=(0,C.$Qh)("IExtHostInitDataService")}),define(De[262],Ce([1,0,207,14,242,27]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;let A=class extends f.$NN{constructor(E,b,L){const P=L.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",p=L.remote.isRemote?(0,C.localize)(0,null):E?(0,C.localize)(1,null):(0,C.localize)(2,null);super(b.createLogger(P,{name:p}))}};e.$Hec=A,e.$Hec=A=He([Be(1,O.$_i),Be(2,R.$GM)],A)}),define(De[263],Ce([1,0,8]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=void 0;class O{constructor(A,m,E){this.h=new Map,this.a=A,this.b=m,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(b=>(this.f=b,this)),this.g=this.c.onDidChangeStorage(b=>{b.shared===this.b&&b.key===this.a&&(this.f=b.value)}),this.i=new C.$7g(()=>{const b=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of b.values())L.complete()}catch(L){for(const P of b.values())P.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,m){let E=this.f[A];return typeof E>"u"&&(E=m),E}update(A,m){this.f[A]=m;const E=this.h.get(A);if(E!==void 0)return E.p;const b=new C.$dh;return this.h.set(A,b),this.i.isScheduled()||this.i.schedule(),b.p}dispose(){this.g.dispose()}}e.$2cc=O;class f extends O{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,m){super(A.identifier.value,!0,m),this.j=A}}e.$3cc=f}),define(De[264],Ce([1,0,4,2]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;class f{constructor(A){this.c=A,this.a=new C.$Od,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$Od,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,m,E,b){const P=this.c.getNotebookDocument(O.URI.revive(A)).acceptModelChanged(m.value,E,b);this.b.fire(P)}$acceptDirtyStateChanged(A,m){this.c.getNotebookDocument(O.URI.revive(A)).acceptDirty(m)}$acceptModelSaved(A){const m=this.c.getNotebookDocument(O.URI.revive(A));this.a.fire(m.apiNotebook)}}e.$oec=f}),define(De[20],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=e.$qM=void 0,e.$qM=(0,C.$Qh)("IExtHostRpcService");class O{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$rM=O}),define(De[265],Ce([1,0,25,4]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=void 0;class f{#e;constructor(A,m){this.b=new O.$Od,this.onDidChange=this.b.event,this.a=C.$7l.toKey(A.identifier),this.#e=m,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,m){return this.#e.store(this.a,A,m)}delete(A){return this.#e.delete(this.a,A)}}e.$bdc=f}),define(De[67],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=void 0,e.$Jcc=(0,C.$Qh)("IURITransformerService");class O{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Kcc=O}),define(De[266],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcb=e.$Lcb=void 0;class O{constructor(){this.buffers=[]}add(E){let b=this.buffers.indexOf(E);return b<0&&(b=this.buffers.length,this.buffers.push(E)),b}}function f(m,E){if(E.serializeBuffersForPostMessage){const b=new O,P=JSON.stringify(m,(y,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:b.add(k)};if(ArrayBuffer.isView(k)){const v=R(k);if(v)return{$$vscode_array_buffer_reference$$:!0,index:b.add(k.buffer),view:{type:v,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),p=b.buffers.map(y=>{const k=new Uint8Array(y);return C.$ce.wrap(k)});return{message:P,buffers:p}}else return{message:JSON.stringify(m),buffers:[]}}e.$Lcb=f;function R(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(m,E){const b=E.map(p=>{const y=new ArrayBuffer(p.byteLength);return new Uint8Array(y).set(p.buffer),y}),L=E.length?(p,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const k=y,{index:v}=k,h=b[v];if(k.view)switch(k.view.type){case 1:return new Int8Array(h,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return y}:void 0;return{message:JSON.parse(m,L),arrayBuffers:b}}e.$Mcb=A}),define(De[267],Ce([1,0,268,377,378,60,2,14,379]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;const b=!1;function L(c,d,a,t,i,s){const n=s.environment.useHostProxy,r=typeof n=="boolean"?n:!s.remote.isRemote,u={resolveProxy:$=>c.resolveProxy($),lookupProxyAuthorization:h.bind(void 0,t,i,d,{},s.remote.isRemote),getProxyURL:()=>d.getConfiguration("http").get("proxy"),getProxySupport:()=>d.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>p(d),getSystemCertificatesV2:()=>y(d),log:($,g,...w)=>{switch($){case E.LogLevel.Trace:t.trace(g,...w);break;case E.LogLevel.Debug:t.debug(g,...w);break;case E.LogLevel.Info:t.info(g,...w);break;case E.LogLevel.Warning:t.warn(g,...w);break;case E.LogLevel.Error:t.error(g,...w);break;case E.LogLevel.Critical:t.error(g,...w);break;case E.LogLevel.Off:break;default:D($,g,w);break}function D(T,M,...F){t.error("Unknown log level",T),t.error(M,...F)}},getLogLevel:()=>{const $=t.getLevel();switch($){case m.LogLevel.Trace:return E.LogLevel.Trace;case m.LogLevel.Debug:return E.LogLevel.Debug;case m.LogLevel.Info:return E.LogLevel.Info;case m.LogLevel.Warning:return E.LogLevel.Warning;case m.LogLevel.Error:return E.LogLevel.Error;case m.LogLevel.Off:return E.LogLevel.Off;default:return g($)}function g(w){return t.error("Unknown log level",w),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:r,addCertificates:[],env:process.env},I=(0,E.createProxyResolver)(u),S=P(u,I);return v(a,S)}e.$dfc=L;function P(c,d){return{http:Object.assign(C,(0,E.createHttpPatch)(c,C,d)),https:Object.assign(O,(0,E.createHttpPatch)(c,O,d)),net:Object.assign(R,(0,E.createNetPatch)(c,R)),tls:Object.assign(f,(0,E.createTlsPatch)(c,f))}}function p(c){const d=c.getConfiguration("http");return!d.get("experimental.systemCertificatesV2",b)&&!!d.get("systemCertificates")}function y(c){const d=c.getConfiguration("http");return!!d.get("experimental.systemCertificatesV2",b)&&!!d.get("systemCertificates")}const k=new Map;function v(c,d){return c.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,i=t._load;t._load=function(n,r,u){if(n==="net")return d.net;if(n==="tls")return d.tls;if(n!=="http"&&n!=="https")return i.apply(this,arguments);const I=a.findSubstr(A.URI.file(r.filename));let S=k.get(I);if(S||k.set(I,S={}),!S[n]){const $=d[n];S[n]={...$}}return S[n]}})}async function h(c,d,a,t,i,s,n,r){const u=t[s];n&&(t[s]=n),c.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${n}`,`proxyAuthenticateCache:${u}`);const I=n||u,S=Array.isArray(I)?I:typeof I=="string"?[I]:[];if(l(d,S,i),S.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!r.kerberosRequested)try{r.kerberosRequested=!0;const $=await new Promise((M,F)=>{$e(["kerberos"],M,F)}),g=new URL(s),w=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${g.hostname}`:`HTTP@${g.hostname}`);return c.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${w}`),"Negotiate "+await(await $.initializeClient(w)).step("")}catch($){c.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let o=!1;function l(c,d,a){o||!d.length||(o=!0,c.$publicLog2("proxyAuthenticationRequest",{authenticationType:d.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(De[269],Ce([1,0,128]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;function O(R){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:R,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function f(R){return new C.$Mm(O(R))}e.$Er=f}),define(De[139],Ce([1,0,217,17,2,3,5,43,30,18,41,176,38]),function($e,e,C,O,f,R,A,m,E,b,L,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lE=e.$kE=e.$jE=e.EditorsOrder=e.$iE=e.CloseDirection=e.$hE=e.$gE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.$$D=e.EditorInputCapabilities=e.$0D=e.SaveReason=e.Verbosity=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=void 0,e.$XD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$YD={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$ZD="workbench.editor.sidebysideEditor",e.$1D="workbench.editors.textDiffEditor",e.$2D="workbench.editors.binaryResourceDiffEditor";var y;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var k;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function v(ce){const ye=ce;return!!ye&&typeof ye.getSelection=="function"&&!!ye.onDidChangeSelection}e.$3D=v;function h(ce,ye,H){for(const B of H.visibleEditorPanes)if(B.group.id===ye&&ce.matches(B.input))return B.getViewState()}e.$4D=h;function o(ce){if(u(ce))return!1;const ye=ce;return f.URI.isUri(ye?.resource)}e.$5D=o;function l(ce){if(u(ce))return!1;const ye=ce;return ye?.original!==void 0&&ye.modified!==void 0}e.$6D=l;function c(ce){if(u(ce)||l(ce))return!1;const ye=ce;return ye?.primary!==void 0&&ye.secondary!==void 0}e.$7D=c;function d(ce){if(u(ce))return!1;const ye=ce;return ye?ye.resource===void 0||ye.resource.scheme===b.Schemas.untitled||ye.forceUntitled===!0:!1}e.$8D=d;function a(ce){if(u(ce))return!1;const ye=ce;return f.URI.isUri(ye?.base?.resource)&&f.URI.isUri(ye?.input1?.resource)&&f.URI.isUri(ye?.input2?.resource)&&f.URI.isUri(ye?.result?.resource)}e.$9D=a;var t;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var i;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class s{constructor(){this.a=new Map}registerSource(ye,H){let B=this.a.get(ye);return B||(B={source:ye,label:H},this.a.set(ye,B)),B.source}getSourceLabel(ye){return this.a.get(ye)?.label??ye}}e.$0D=new s;var n;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad",ce[ce.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(n||(e.EditorInputCapabilities=n={}));class r extends R.$Sc{}e.$$D=r;function u(ce){return ce instanceof r}e.$_D=u;function I(ce){const ye=ce;return f.URI.isUri(ye?.preferredResource)}function S(ce){const ye=ce;return u(ye?.primary)&&u(ye?.secondary)}e.$aE=S;function $(ce){const ye=ce;return u(ye?.modified)&&u(ye?.original)}e.$bE=$;function g(ce,ye,H,B,Y){return ie(B,[(0,P.$Ai)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const re={...H,limits:{size:Number.MAX_VALUE}};ce.openEditor(ye,re)}}),(0,P.$Ai)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>Y.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$cE=g;function w(ce){return u(ce?.editor)}e.$dE=w;function D(ce){const ye=ce;return w(ce)&&ye?.group!==void 0}e.$eE=D;function T(ce){const ye=ce;return typeof ye?.groupId=="number"&&u(ye.editor)}e.$fE=T;var M;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var F;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LABEL=2]="GROUP_LABEL",ce[ce.GROUP_LOCKED=3]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=4]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=5]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=6]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=8]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=10]="EDITOR_PIN",ce[ce.EDITOR_STICKY=11]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=12]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var z;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class j{getOriginalUri(ye,H){if(!ye)return;if(a(ye))return e.$hE.getOriginalUri(ye.result,H);if(H?.supportSideBySide){const{primary:Y,secondary:re}=this.a(ye);if(Y&&re){if(H?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(Y,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===z.ANY)return this.getOriginalUri(Y,{filterByScheme:H.filterByScheme})??this.getOriginalUri(re,{filterByScheme:H.filterByScheme});ye=H.supportSideBySide===z.PRIMARY?Y:re}}if(l(ye)||c(ye)||a(ye))return;const B=I(ye)?ye.preferredResource:ye.resource;return!B||!H||!H.filterByScheme?B:this.b(B,H.filterByScheme)}a(ye){return S(ye)||c(ye)?{primary:ye.primary,secondary:ye.secondary}:$(ye)||l(ye)?{primary:ye.modified,secondary:ye.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ye,H){if(!ye)return;if(a(ye))return e.$hE.getCanonicalUri(ye.result,H);if(H?.supportSideBySide){const{primary:Y,secondary:re}=this.a(ye);if(Y&&re){if(H?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(Y,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===z.ANY)return this.getCanonicalUri(Y,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:H.filterByScheme});ye=H.supportSideBySide===z.PRIMARY?Y:re}}if(l(ye)||c(ye)||a(ye))return;const B=ye.resource;return!B||!H||!H.filterByScheme?B:this.b(B,H.filterByScheme)}b(ye,H){if(Array.isArray(H)){if(H.some(B=>ye.scheme===B))return ye}else if(H===ye.scheme)return ye}}var N;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function q(ce,ye,H,B){if(!ce.isSticky(ye))return!1;switch(B.preventPinnedEditorClose){case"keyboardAndMouse":return H===N.MOUSE||H===N.KEYBOARD;case"mouse":return H===N.MOUSE;case"keyboard":return H===N.KEYBOARD}return!1}e.$gE=q,e.$hE=new j;var K;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(K||(e.CloseDirection=K={}));class me{constructor(){this.c=new Map,this.d=new Map}start(ye){const H=this.a=ye.get(A.$Ph);for(const[B,Y]of this.c)this.e(B,Y,H);this.c.clear()}e(ye,H,B){const Y=B.createInstance(H);this.d.set(ye,Y)}registerFileEditorFactory(ye){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ye}getFileEditorFactory(){return(0,O.$Kf)(this.b)}registerEditorSerializer(ye,H){if(this.c.has(ye)||this.d.has(ye))throw new Error(`A editor serializer with type ID '${ye}' was already registered.`);return this.a?this.e(ye,H,this.a):this.c.set(ye,H),(0,R.$Qc)(()=>{this.c.delete(ye),this.d.delete(ye)})}getEditorSerializer(ye){return this.d.get(typeof ye=="string"?ye:ye.typeId)}}m.$kn.add(e.$XD.EditorFactory,new me);async function te(ce,ye,H){return!ce||!ce.length?[]:await Promise.all(ce.map(async B=>{const Y=f.URI.revive(B.fileUri);if(!Y){H.info("Cannot resolve the path because it is not valid.",B);return}if(!await ye.canHandleResource(Y)){H.info("Cannot resolve the path because it cannot be handled",B);return}let X=B.exists,_=B.type;if(typeof X!="boolean"||typeof _!="number")try{_=(await ye.stat(Y)).isDirectory?E.FileType.Directory:E.FileType.Unknown,X=!0}catch(pe){H.error(pe),X=!1}if(!X&&B.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",B);return}if(_===E.FileType.Directory){H.info("Cannot resolve the path because it is a directory",B);return}const x={...B.options,pinned:!0};return X?{resource:Y,options:x}:{resource:Y,options:x,forceUntitled:!0}}))}e.$iE=te;var G;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(G||(e.EditorsOrder=G={}));function J(ce){const ye=ce;if(!ye)return!1;const H=ye;if(H.modified)return J(H.modified);const B=ye;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}e.$jE=J;function le(ce){return(0,L.$Ci)(ce)}e.$kE=le;function ie(ce,ye,H){const B=(0,L.$Di)(ce,ye);return B.forceMessage=H?.forceMessage,B.forceSeverity=H?.forceSeverity,B.allowDialog=H?.allowDialog,B}e.$lE=ie}),define(De[270],Ce([1,0,4,218,5,3,28,43,19,24,79,256]),function($e,e,C,O,f,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wE=e.$vE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$uE=e.$tE=e.ViewContentGroups=e.$sE=e.$rE=e.ViewContainerLocation=e.Extensions=e.$qE=e.$pE=e.$oE=void 0,e.$oE="views",e.$pE=(0,O.localize)(0,null),e.$qE=(0,P.$0v)("default-view-icon",L.$Vj.window,(0,O.localize)(1,null));var p;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var y;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$rE=[0,1,2];function k(i){switch(i){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$sE=k;class v extends R.$Sc{constructor(){super(...arguments),this.c=this.B(new C.$Od),this.onDidRegister=this.c.event,this.f=this.B(new C.$Od),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Rb)([...this.g.values()])}registerViewContainer(s,n,r){const u=this.get(s.id);if(u)return u;const I=s;return I.openCommandActionDescriptor=r?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$xc)(this.g,n,[]).push(I),r?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:n}),I}deregisterViewContainer(s){for(const n of this.g.keys()){const r=this.g.get(n),u=r?.indexOf(s);if(u!==-1){r?.splice(u,1),r.length===0&&this.g.delete(n),this.f.fire({viewContainer:s,viewContainerLocation:n});return}}}get(s){return this.all.filter(n=>n.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(n=>this.getViewContainers(n).filter(r=>r?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(n=>this.getViewContainerLocation(n)===s)}}m.$kn.add(p.ViewContainersRegistry,new v);var h;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(h||(e.ViewContentGroups=h={}));function o(i,s){const n=i.group??h.More,r=s.group??h.More;return n!==r?n.localeCompare(r):(i.order??5)-(s.order??5)}class l extends R.$Sc{constructor(){super(...arguments),this.c=this.B(new C.$Od),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$Od),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$Od),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$Od),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,n){this.registerViews2([{views:s,viewContainer:n}])}registerViews2(s){s.forEach(({views:n,viewContainer:r})=>this.r(n,r)),this.c.fire(s)}deregisterViews(s,n){const r=this.s(s,n);r.length&&this.f.fire({views:r,viewContainer:n})}moveViews(s,n){for(const r of this.m.keys())if(r!==n){const u=this.s(s,r);u.length&&(this.r(u,n),this.g.fire({views:u,from:r,to:n}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const n of this.j){const r=(this.m.get(n)||[]).filter(u=>u.id===s)[0];if(r)return r}return null}getViewContainer(s){for(const n of this.j)if((this.m.get(n)||[]).filter(u=>u.id===s)[0])return n;return null}registerViewWelcomeContent(s,n){return this.n.add(s,n),this.h.fire(s),(0,R.$Qc)(()=>{this.n.delete(s,n),this.h.fire(s)})}registerViewWelcomeContent2(s,n){const r=new Map;for(const[u,I]of n)this.n.add(s,I),r.set(u,(0,R.$Qc)(()=>{this.n.delete(s,I),this.h.fire(s)}));return this.h.fire(s),r}getViewWelcomeContent(s){const n=[];return this.n.forEach(s,r=>n.push(r)),n.sort(o)}r(s,n){let r=this.m.get(n);r||(r=[],this.m.set(n,r),this.j.push(n));for(const u of s){if(this.getView(u.id)!==null)throw new Error((0,O.localize)(2,null,u.id));r.push(u)}}s(s,n){const r=this.m.get(n);if(!r)return[];const u=[],I=[];for(const S of r)s.includes(S)?u.push(S):I.push(S);return u.length&&(I.length?this.m.set(n,I):(this.m.delete(n),this.j.splice(this.j.indexOf(n),1))),u}}m.$kn.add(p.ViewsRegistry,new l),e.$tE=(0,f.$Qh)("viewsService"),e.$uE=(0,f.$Qh)("viewDescriptorService");var c;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var d;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(d||(e.TreeItemCollapsibleState=d={}));class a{constructor(s,n){this.c=!1,this.d=!1,(0,b.$$m)(this,s),this.d=!!n,this.resolve=async r=>{if(n&&!this.c){const u=await n(r);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}r.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$vE=a;class t extends Error{constructor(s){super((0,O.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$wE=t}),define(De[271],Ce([1,0,2,32,5]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$XE=e.$WE=void 0;function R(b){return!!b&&typeof b=="object"&&"uri"in b&&b.uri instanceof C.URI&&"version"in b&&typeof b.version=="number"&&"ranges"in b&&Array.isArray(b.ranges)&&b.ranges.every(O.$xs.isIRange)}e.$WE=R;function A(b){return!!b&&typeof b=="object"&&"documents"in b&&Array.isArray(b.documents)&&b.documents.every(R)}e.$XE=A;var m;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var E;(function(b){b[b.Action=1]="Action",b[b.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$YE=(0,f.$Qh)("IChatService")}),define(De[140],Ce([1,0,4,8,219]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new C.$Od,this.n=new C.$Od,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,E,b,L){const P={command:m};if(E&&Object.keys(E).length>0&&(P.arguments=E),this.s("request",P),typeof L=="number"){const p=setTimeout(()=>{clearTimeout(p);const y=this.f.get(P.seq);if(y){this.f.delete(P.seq);const k={type:"response",seq:0,request_seq:P.seq,success:!1,command:m,message:(0,f.localize)(0,null,L,m)};y(k)}},L)}return b&&this.f.set(P.seq,b),P.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,E){return m.type!=="event"||E.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,O.$Vg)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const E=m,b=this.f.get(E.request_seq);b&&(this.f.delete(E.request_seq),b(E));break}}}}s(m,E){E.type=m,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((E,b)=>m.set(b,E)),await(0,O.$Vg)(500),m.forEach((E,b)=>{E({type:"response",seq:0,request_seq:b,success:!1,command:"canceled",message:"canceled"}),this.f.delete(b)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$fdb=R}),define(De[272],Ce([1,0,220,42,5]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$$G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$0G=e.MemoryRangeType=e.$9G=e.State=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=void 0,e.$7F="workbench.view.debug",e.$8F="workbench.debug.variablesView",e.$9F="workbench.debug.watchExpressionsView",e.$0F="workbench.debug.callStackView",e.$$F="workbench.debug.loadedScriptsView",e.$_F="workbench.debug.breakPointsView",e.$aG="workbench.debug.disassemblyView",e.$bG="workbench.panel.repl",e.$cG="workbench.panel.repl.view",e.$dG=new O.$8i("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$eG=new O.$8i("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$fG=new O.$8i("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$gG="debugUx",e.$hG=new O.$8i(e.$gG,"default",{type:"string",description:C.localize(3,null)}),e.$iG=new O.$8i("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$jG=new O.$8i("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$kG=new O.$8i("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$lG=new O.$8i("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$mG=new O.$8i("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$nG=new O.$8i("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$oG=new O.$8i("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$pG=new O.$8i("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$qG=new O.$8i("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$rG=new O.$8i("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$sG=new O.$8i("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$tG=new O.$8i("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$uG=new O.$8i("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$vG=new O.$8i("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$wG=new O.$8i("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$xG=new O.$8i("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$yG=new O.$8i("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$zG=new O.$8i("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$AG=new O.$8i("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.$BG=new O.$8i("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.$CG=new O.$8i("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.$DG=new O.$8i("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.$EG=new O.$8i("stepBackSupported",!1,{type:"boolean",description:C.localize(26,null)}),e.$FG=new O.$8i("restartFrameSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.$GG=new O.$8i("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(28,null)}),e.$HG=new O.$8i("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$IG=new O.$8i("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$JG=new O.$8i("breakpointsExist",!1,{type:"boolean",description:C.localize(31,null)}),e.$KG=new O.$8i("debuggersAvailable",!1,{type:"boolean",description:C.localize(32,null)}),e.$LG=new O.$8i("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(33,null)}),e.$MG=new O.$8i("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(34,null)}),e.$NG=new O.$8i("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(35,null)}),e.$OG=new O.$8i("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.$PG=new O.$8i("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.$QG=new O.$8i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$RG=new O.$8i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$SG=new O.$8i("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$TG=new O.$8i("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$UG=new O.$8i("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(42,null)}),e.$VG=new O.$8i("variableIsReadonly",!1,{type:"boolean",description:C.localize(43,null)}),e.$WG=new O.$8i("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(44,null)}),e.$XG=new O.$8i("multiSessionRepl",!1,{type:"boolean",description:C.localize(45,null)}),e.$YG=new O.$8i("multiSessionDebug",!1,{type:"boolean",description:C.localize(46,null)}),e.$ZG=new O.$8i("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(47,null)}),e.$1G=new O.$8i("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(48,null)}),e.$2G=new O.$8i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(49,null)}),e.$3G=new O.$8i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(50,null)});const R=p=>C.localize(51,null,p);e.$4G=R,e.$5G="editor.contrib.debug",e.$6G="editor.contrib.breakpoint",e.$7G="debug",e.$8G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(52,null)};var A;(function(p){p[p.Inactive=0]="Inactive",p[p.Initializing=1]="Initializing",p[p.Stopped=2]="Stopped",p[p.Running=3]="Running"})(A||(e.State=A={}));function m(p){switch(p){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$9G=m;var E;(function(p){p[p.Valid=0]="Valid",p[p.Unreadable=1]="Unreadable",p[p.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$0G="vscode-debug-memory";var b;(function(p){p[p.Initial=1]="Initial",p[p.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var L;(function(p){p.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerString=L={})),e.$$G=(0,f.$Qh)("debugService");var P;(function(p){p[p.CONDITION=0]="CONDITION",p[p.HIT_COUNT=1]="HIT_COUNT",p[p.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(De[273],Ce([1,0,15,2,16,24,18,32,21,19]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=void 0;const L=/{([^}]+)}/g;function P(S,$,g){return S.replace(L,function(w,D){return $&&D.length>0&&D[0]!=="_"?w:g&&g.hasOwnProperty(D)?g[D]:w})}e.$vF=P;function p(S){const $={};for(const g of Object.keys(S))g.startsWith("!")||($[g]=S[g]);return $}e.$wF=p;function y(S){return S.configuration.request==="attach"&&!k(S)&&(!S.parentSession||y(S.parentSession))}e.$xF=y;function k(S){let $=S.configuration.type;if($)return $==="vslsShare"&&($=S.configuration.adapterProxy.configuration.type),(0,C.$3e)($,"extensionhost")||(0,C.$3e)($,"pwa-extensionhost")?S:S.parentSession?k(S.parentSession):void 0}e.$yF=k;function v(S){return S.type&&(S.label||S.program||S.runtime)}e.$zF=v;function h(S,$,g){let w,D=0;const T=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let M=null;for(;M=T.exec(S);){const F=M.index+1,z=F+M[0].length;if(F<=$&&z>=g){w=M[0],D=F;break}}if(w){const F=/\w+/g;let z=null;for(;(z=F.exec(w))&&!(z.index+1+D+z[0].length>=g););z&&(w=w.substring(0,F.lastIndex))}return w?{start:D,end:D+w.length-1}:{start:0,end:0}}e.$AF=h;async function o(S,$,g,w){if(S.evaluatableExpressionProvider.has($)){const D=S.evaluatableExpressionProvider.ordered($),T=(0,b.$Hb)(await Promise.all(D.map(async M=>{try{return await M.provideEvaluatableExpression($,g,w??E.CancellationToken.None)}catch{return}})));if(T.length>0){let M=T[0].expression;const F=T[0].range;return M||(M=$.getLineContent(g.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:M}}}else{const D=$.getLineContent(g.lineNumber),{start:T,end:M}=h(D,g.column,g.column),F=D.substring(T-1,M);return{matchingExpression:F,range:new m.$xs(g.lineNumber,T,g.lineNumber,T+F.length)}}return null}e.$BF=o;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(S){return!!(S&&S.match(l))}e.$CF=c;function d(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(c(S.path))return O.URI.parse(S.path);if((0,f.$ic)(S.path))return O.URI.file(S.path)}return S.path}function a(S){if(typeof S.path=="object"){const $=O.URI.revive(S.path);if($)return $.scheme===A.Schemas.file?$.fsPath:$.toString()}return S.path}function t(S,$){const g=$?d:a,w=(0,R.$8m)(S);return s(w,(D,T)=>{D&&T&&(T.path=g(T))}),w}e.$DF=t;function i(S,$){const g=$?d:a,w=(0,R.$8m)(S);return s(w,(D,T)=>{!D&&T&&(T.path=g(T))}),w}e.$EF=i;function s(S,$){switch(S.type){case"event":{const g=S;switch(g.event){case"output":$(!1,g.body.source);break;case"loadedSource":$(!1,g.body.source);break;case"breakpoint":$(!1,g.body.breakpoint.source);break;default:break}break}case"request":{const g=S;switch(g.command){case"setBreakpoints":$(!0,g.arguments.source);break;case"breakpointLocations":$(!0,g.arguments.source);break;case"source":$(!0,g.arguments.source);break;case"gotoTargets":$(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(w=>$(!1,w));break;default:break}break}case"response":{const g=S;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(w=>$(!1,w.source));break;case"loadedSources":g.body.sources.forEach(w=>$(!1,w));break;case"scopes":g.body.scopes.forEach(w=>$(!1,w.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(w=>$(!1,w.source));break;case"setBreakpoints":g.body.breakpoints.forEach(w=>$(!1,w.source));break;case"disassemble":g.body?.instructions.forEach(D=>$(!1,D.location));break;default:break}break}}}function n(S){return S.filter($=>!$.presentation?.hidden).sort(($,g)=>$.presentation?g.presentation?$.presentation.group?g.presentation.group?$.presentation.group!==g.presentation.group?$.presentation.group.localeCompare(g.presentation.group):r($.presentation.order,g.presentation.order):-1:g.presentation.group?1:r($.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.$FF=n;function r(S,$){return typeof S!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:S-$}async function u(S,$){const g=S.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(g!=="none"&&(await $.saveAll(),g==="allEditorsInActiveGroup")){const w=$.activeEditorPane;w&&w.input.resource?.scheme===A.Schemas.untitled&&await $.save({editor:w.input,groupId:w.group.id})}await S.reloadConfiguration()}e.$GF=u;const I=(S,$)=>!S||!$?S===$:S.name===$.name&&S.path===$.path&&S.sourceReference===$.sourceReference;e.$HF=I}),define(De[274],Ce([1,0,49,60,24,16,12,15,29,221,140]),function($e,e,C,O,f,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=e.$Pec=e.$Oec=e.$Nec=void 0;class P extends L.$fdb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,l){this.p=l,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",c=>this.w(c))}sendMessage(o){if(this.p){const l=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(l,"utf8")}${P.a}${l}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const l=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,l.length>0)try{this.acceptMessage(JSON.parse(l))}catch(c){this.m.fire(new Error((c.message||c)+`
`+l))}continue}}else{const l=this.r.indexOf(P.a);if(l!==-1){const d=this.r.toString("utf8",0,l).split(P.b);for(const a of d){const t=a.split(P.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(l+P.a.length);continue}}break}}}e.$Nec=P;class p extends P{startSession(){return new Promise((o,l)=>{let c=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),c=!0}),this.x.on("close",()=>{c?this.m.fire(new Error("connection closed")):l(new Error("connection closed"))}),this.x.on("error",d=>{c?this.m.fire(d):l(d)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Oec=p;class y extends p{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Pec=y;class k extends p{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.path,o)}}e.$Qec=k;class v extends P{constructor(o,l){super(),this.y=o,this.z=l}async startSession(){const o=this.y.command,l=this.y.args,c=this.y.options||{};try{if(o)if(R.$ic(o)){if(!await E.Promises.exists(o))throw new Error(b.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(b.localize(1,null,this.z));let d=process.env;if(c.env&&Object.keys(c.env).length>0&&(d=f.$$m(f.$8m(process.env),c.env)),o==="node")if(Array.isArray(l)&&l.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:d,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(t.cwd=c.cwd);const i=C.fork(l[0],l.slice(1),t);if(!i.pid)throw new Error(b.localize(2,null,l[0]));this.x=i}else throw new Error(b.localize(3,null));else{const a={env:d};c.cwd&&(a.cwd=c.cwd),this.x=C.spawn(o,l,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(d){this.m.fire(d)}}async stopSession(){return this.x?(await this.u(),A.$j?new Promise((o,l)=>{const c=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(d,a,t){if(d)return l(d)});c.on("exit",o),c.on("error",l)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,l){if(!o)return;const c=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?c.runtime=R.$jc(l,o.runtime):c.runtime=o.runtime),o.runtimeArgs&&(c.runtimeArgs=o.runtimeArgs),o.program&&(R.$ic(o.program)?c.program=o.program:c.program=R.$jc(l,o.program)),o.args&&(c.args=o.args);const d=o;return d.win&&(c.win=v.A(d.win,l)),d.winx86&&(c.winx86=v.A(d.winx86,l)),d.windows&&(c.windows=v.A(d.windows,l)),d.osx&&(c.osx=v.A(d.osx,l)),d.linux&&(c.linux=v.A(d.linux,l)),c}static platformAdapterExecutable(o,l){let c=Object.create(null);l=l.toLowerCase();for(const n of o)if(n.contributes){const r=n.contributes.debuggers;r&&r.length>0&&r.filter(u=>typeof u.type=="string"&&m.$3e(u.type,l)).forEach(u=>{const I=v.A(u,n.extensionLocation.fsPath);c=f.$$m(c,I,n.isBuiltin)})}let d;A.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?d=c.winx86||c.win||c.windows:A.$j?d=c.win||c.windows:A.$k?d=c.osx:A.$l&&(d=c.linux),d=d||c;const a=d.program||c.program,t=d.args||c.args,i=d.runtime||c.runtime,s=d.runtimeArgs||c.runtimeArgs;if(i)return{type:"executable",command:i,args:(s||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$Rec=v}),define(De[275],Ce([1,0,49,33,12]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=void 0;function R(b,L){return new Promise((P,p)=>{let y="";const k=C.spawn(b,L);k.pid&&k.stdout.on("data",v=>{y+=v.toString()}),k.on("error",v=>{p(v)}),k.on("close",v=>{P(y)})})}async function A(b){if(b)if(f.$j){const L=await new Promise((P,p)=>{$e(["@vscode/windows-process-tree"],P,p)});return new Promise(P=>{L.getProcessTree(b,p=>{P(!!p&&p.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(b)]).then(L=>{const P=L.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.$Sec=A;var m;(function(b){b[b.cmd=0]="cmd",b[b.powershell=1]="powershell",b[b.bash=2]="bash"})(m||(m={}));function E(b,L,P,p,y){b=b.trim().toLowerCase();let k;b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0?k=1:b.indexOf("cmd.exe")>=0?k=0:b.indexOf("bash")>=0?k=2:f.$j?k=0:k=2;let v,h=" ";switch(k){case 1:if(v=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),p){const o=(0,O.$4f)(p);o&&(h+=`${o}:; `),h+=`cd ${v(p)}; `}if(y)for(const o in y){const l=y[o];l===null?h+=`Remove-Item env:${o}; `:h+=`\${env:${o}}='${l}'; `}if(L.length>0){const o=L.shift(),l=P?o:v(o);h+=l[0]==="'"?`& ${l} `:`${l} `;for(const c of L)h+=c==="<"||c===">"||P?c:v(c),h+=" "}break;case 0:if(v=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(l=>o.includes(l))||o.length===0?`"${o}"`:o),p){const o=(0,O.$4f)(p);o&&(h+=`${o}: && `),h+=`cd ${v(p)} && `}if(y){h+='cmd /C "';for(const o in y){let l=y[o];l===null?h+=`set "${o}=" && `:(l=l.replace(/[&^|<>]/g,c=>`^${c}`),h+=`set "${o}=${l}" && `)}}for(const o of L)h+=o==="<"||o===">"||P?o:v(o),h+=" ";y&&(h+='"');break;case 2:{v=l=>(l=l.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),l.length===0?'""':l);const o=l=>/[^\w@%\/+=,.:^-]/.test(l)?`'${l.replace(/'/g,"'\\''")}'`:l;if(p&&(h+=`cd ${v(p)} ; `),y){h+="/usr/bin/env";for(const l in y){const c=y[l];c===null?h+=` -u ${o(l)}`:h+=` ${o(`${l}=${c}`)}`}h+=" "}for(const l of L)h+=l==="<"||l===">"||P?l:v(l),h+=" ";break}}return h}e.$Tec=E}),define(De[108],Ce([1,0,22,36,51,97,18,16,12,42]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AI=e.$zI=e.$yI=e.$xI=e.CellStatusbarAlignment=e.$wI=e.$vI=e.$uI=e.NotebookEditorPriority=e.$tI=e.$sI=e.$rI=e.$qI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$pI=e.$oI=e.$nI=e.$mI=e.CellKind=e.$lI=e.$kI=e.$jI=void 0,e.$jI="workbench.editor.notebook",e.$kI="workbench.editor.notebookTextDiffEditor",e.$lI="workbench.editor.interactive";var L;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(L||(e.CellKind=L={})),e.$mI=["application/json","application/javascript","text/html","image/svg+xml",R.$Tr.latex,R.$Tr.markdown,"image/png","image/jpeg",R.$Tr.text],e.$nI=[R.$Tr.latex,R.$Tr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Tr.text],e.$oI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$pI="_notAvailable";var P;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(P||(e.NotebookRunState=P={}));var p;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var y;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var k;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(k||(e.NotebookRendererMatch=k={}));var v;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(v||(e.RendererMessagingSpec=v={}));var h;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(h||(e.NotebookCellsChangeType=h={}));var o;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var l;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(l||(e.CellEditType=l={}));var c;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const q=["W","X","Y","Z","a","b","c","d","e","f"],K=new RegExp(`^[${q.join("")}]+`),me=7;function te(ye,H){const B=H.toString(me),re=`${B.length<q.length?q[B.length-1]:"z"}${B}s${(0,C.$we)(C.$ce.fromString(ye.scheme),!0,!0)}`;return ye.with({scheme:N.scheme,fragment:re})}N.generate=te;function G(ye){if(ye.scheme!==N.scheme)return;const H=ye.fragment.indexOf("s");if(H<0)return;const B=parseInt(ye.fragment.substring(0,H).replace(K,""),me),Y=(0,C.$ve)(ye.fragment.substring(H+1)).toString();if(!isNaN(B))return{handle:B,notebook:ye.with({scheme:Y,fragment:null})}}N.parse=G;function J(ye,H){return ye.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${ye.scheme!==A.Schemas.file?ye.scheme:""}`})}N.generateCellOutputUri=J;function le(ye){if(ye.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ye.fragment);if(!H)return;const B=H[1]&&H[1]!==""?H[1]:void 0,Y=H[2];return{outputId:B,notebook:ye.with({scheme:Y||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=le;function ie(ye,H,B){return N.generate(ye,H).with({scheme:B})}N.generateCellPropertyUri=ie;function ce(ye,H){if(ye.scheme===H)return N.parse(ye.with({scheme:N.scheme}))}N.parseCellPropertyUri=ce})(c||(e.CellUri=c={}));const d=N=>E.$j?N.replace(/\//g,"\\"):N;class a{constructor(q=[],K=e.$mI){this.e=K,this.d=[...new Set(q)].map(me=>({pattern:me,matches:O.$xj(d(me))}))}sort(q){const K=new Map(f.Iterable.map(q,te=>[te,d(te)]));let me=[];for(const{matches:te}of this.d)for(const[G,J]of K)if(te(J)){me.push(G),K.delete(G);break}return K.size&&(me=me.concat([...K.keys()].sort((te,G)=>this.e.indexOf(te)-this.e.indexOf(G)))),me}prioritize(q,K){const me=this.f(q);if(me===-1){this.d.unshift({pattern:q,matches:O.$xj(d(q))});return}const te=new Set(K.map(J=>this.f(J,me)));te.delete(-1);const G=Array.from(te).sort();this.d.splice(me+1,0,...G.map(J=>this.d[J]));for(let J=G.length-1;J>=0;J--)this.d.splice(G[J],1)}toArray(){return this.d.map(q=>q.pattern)}f(q,K=this.d.length){const me=d(q);for(let te=0;te<K;te++)if(this.d[te].matches(me))return te;return-1}}e.$qI=a;function t(N,q,K,me=(te,G)=>te===G){const te=[];function G(ie,ce,ye){if(ce===0&&ye.length===0)return;const H=te[te.length-1];H&&H.start+H.deleteCount===ie?(H.deleteCount+=ce,H.toInsert.push(...ye)):te.push({start:ie,deleteCount:ce,toInsert:ye})}let J=0,le=0;for(;;){if(J===N.length){G(J,0,q.slice(le));break}if(le===q.length){G(J,N.length-J,[]);break}const ie=N[J],ce=q[le];if(me(ie,ce)){J+=1,le+=1;continue}K(ce)?(G(J,1,[]),J+=1):(G(J,0,[ce]),le+=1)}return te}e.$rI=t,e.$sI=new b.$8i("notebookEditorCursorAtBoundary","none"),e.$tI=new b.$8i("notebookEditorCursorAtLineBoundary","none");var i;(function(N){N.default="default",N.option="option"})(i||(e.NotebookEditorPriority=i={}));function s(N){const q=N;return!!((typeof q.include=="string"||O.$yj(q.include))&&(typeof q.exclude=="string"||O.$yj(q.exclude)))}e.$uI=s;function n(N,q,K){if(Array.isArray(N.viewType)&&N.viewType.indexOf(q)>=0||N.viewType===q)return!0;if(N.filenamePattern){const me=s(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,te=s(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(O.$wj(me,(0,m.$nc)(K.fsPath).toLowerCase()))return!(te&&O.$wj(te,(0,m.$nc)(K.fsPath).toLowerCase()))}return!1}e.$vI=n,e.$wI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var r;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(r||(e.CellStatusbarAlignment=r={}));class u{static{this.d="notebook/"}static create(q){return`${u.d}${q}`}static parse(q){if(q.startsWith(u.d))return q.substring(u.d.length)}}e.$xI=u;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$yI=I;const S=new TextDecoder;function $(N){const q=[];let K=!1;for(const J of N)(q.length===0||K)&&(q.push(J),K=!0);let me=D(q);const te=C.$ce.concat(q.map(J=>C.$ce.wrap(J))),G=j(te);return me=me||G.byteLength!==te.byteLength,{data:G,didCompression:me}}e.$zI=$,e.$AI=`${String.fromCharCode(27)}[A`;const g=e.$AI.split("").map(N=>N.charCodeAt(0)),w=10;function D(N){let q=!1;return N.forEach((K,me)=>{if(me===0||K.length<e.$AI.length)return;const te=N[me-1],G=K.subarray(0,e.$AI.length);if(G[0]===g[0]&&G[1]===g[1]&&G[2]===g[2]){const J=te.lastIndexOf(w);if(J===-1)return;q=!0,N[me-1]=te.subarray(0,J),N[me]=K.subarray(e.$AI.length)}}),q}function T(N){let q=N;do N=q,q=N.replace(/[^\n]\x08/gm,"");while(q.length<N.length);return N}function M(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const q=N.match(/^(.*)\r+/m)[1];let K=N.match(/\r+(.*)$/m)[1];K=K+q.slice(K.length,q.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,K)}return N}const F="\b".charCodeAt(0),z="\r".charCodeAt(0);function j(N){return!N.buffer.includes(F)&&!N.buffer.includes(z)?N:C.$ce.fromString(M(T(S.decode(N.buffer))))}}),define(De[7],Ce([1,0,19,9,80,28,97,15,17,2,31,25,30,65,108]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k){"use strict";var v,h,o,l,c,d,a,t,i,s,n,r,u,I,S,$,g,w;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$fM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.TestRunProfileKind=e.TestResultState=e.$YL=e.$XL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$WL=e.$VL=e.$UL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$TL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.ColorThemeKind=e.$NL=e.$ML=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$LL=e.DebugConsoleMode=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$FL=e.$EL=e.FileChangeType=e.$DL=e.$CL=e.$BL=e.$AL=e.InlineCompletionTriggerKind=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.ConfigurationTarget=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$dL=e.ViewBadge=e.ProgressLocation=e.$cL=e.$bL=e.TaskScope=e.ShellQuoting=e.$aL=e.$_K=e.$$K=e.TaskPanelKind=e.TaskRevealKind=e.$0K=e.TerminalLocation=e.$9K=e.$8K=e.$7K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$6K=e.$5K=e.$4K=e.$3K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$2K=e.StatusBarAlignment=e.ViewColumn=e.$1K=e.$ZK=e.$YK=e.$XK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$WK=e.$VK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.LanguageStatusSeverity=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.CodeActionTriggerKind=e.$JK=e.$IK=e.SymbolTag=e.SymbolKind=e.$HK=e.DocumentHighlightKind=e.$GK=e.$FK=e.$EK=e.$DK=e.DiagnosticSeverity=e.DiagnosticTag=e.$CK=e.$BK=e.FileEditType=e.$AK=e.$zK=e.$yK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(V){return Object.assign(V,{apply:function(...ve){if(ve.length===0)return Reflect.construct(V,[]);{const Re=ve.length===1?[]:ve[1];return Reflect.construct(V,Re,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(V,[]);{const[Re,...Je]=ve;return Reflect.construct(V,Je,Re.constructor)}}})}var T;(function(V){V[V.Top=0]="Top",V[V.Bottom=1]="Bottom"})(T||(e.TerminalOutputAnchor=T={}));var M;(function(V){V[V.TerminalCommand=0]="TerminalCommand",V[V.Opener=1]="Opener",V[V.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let F=v=class{static from(...W){let ve=W;return new v(function(){if(ve){for(const Re of ve)Re&&typeof Re.dispose=="function"&&Re.dispose();ve=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$rK=F,e.$rK=F=v=He([D],F);let z=h=class{static Min(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Je=W[Re];Je.isBefore(ve)&&(ve=Je)}return ve}static Max(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Je=W[Re];Je.isAfter(ve)&&(ve=Je)}return ve}static isPosition(W){if(!W)return!1;if(W instanceof h)return!0;const{line:ve,character:Re}=W;return typeof ve=="number"&&typeof Re=="number"}static of(W){if(W instanceof h)return W;if(this.isPosition(W))return new h(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ve){if(W<0)throw(0,O.$7)("line must be non-negative");if(ve<0)throw(0,O.$7)("character must be non-negative");this.c=W,this.e=ve}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ve=0){if(W===null||ve===null)throw(0,O.$7)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,ve=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&ve===0?this:new h(this.line+Re,this.character+ve)}with(W,ve=this.character){if(W===null||ve===null)throw(0,O.$7)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,ve=typeof W.character=="number"?W.character:this.character),Re===this.line&&ve===this.character?this:new h(Re,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$sK=z,e.$sK=z=h=He([D],z);let j=o=class{static isRange(W){return W instanceof o?!0:W?z.isPosition(W.start)&&z.isPosition(W.end):!1}static of(W){if(W instanceof o)return W;if(this.isRange(W))return new o(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ve,Re,Je){let et,ot;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Je=="number"?(et=new z(W,ve),ot=new z(Re,Je)):z.isPosition(W)&&z.isPosition(ve)&&(et=z.of(W),ot=z.of(ve)),!et||!ot)throw new Error("Invalid arguments");et.isBefore(ot)?(this.c=et,this.e=ot):(this.c=ot,this.e=et)}contains(W){return o.isRange(W)?this.contains(W.start)&&this.contains(W.end):z.isPosition(W)?!(z.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ve=z.Max(W.start,this.c),Re=z.Min(W.end,this.e);if(!ve.isAfter(Re))return new o(ve,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ve=z.Min(W.start,this.c),Re=z.Max(W.end,this.end);return new o(ve,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ve=this.end){if(W===null||ve===null)throw(0,O.$7)();let Re;return W?z.isPosition(W)?Re=W:(Re=W.start||this.start,ve=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&ve.isEqual(this.end)?this:new o(Re,ve)}toJSON(){return[this.start,this.end]}};e.$tK=j,e.$tK=j=o=He([D],j);let N=l=class extends j{static isSelection(W){return W instanceof l?!0:W?j.isRange(W)&&z.isPosition(W.anchor)&&z.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ve,Re,Je){let et,ot;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Je=="number"?(et=new z(W,ve),ot=new z(Re,Je)):z.isPosition(W)&&z.isPosition(ve)&&(et=z.of(W),ot=z.of(ve)),!et||!ot)throw new Error("Invalid arguments");super(et,ot),this.f=et,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$uK=N,e.$uK=N=l=He([D],N);const q=V=>{if(typeof V!="string"||V.length===0||!/^[0-9A-Za-z_\-]+$/.test(V))throw(0,O.$7)("connectionToken")};class K{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve,Re){if(typeof W!="string"||W.length===0)throw(0,O.$7)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,O.$7)("port");typeof Re<"u"&&q(Re),this.host=W,this.port=Math.round(ve),this.connectionToken=Re}}e.$vK=K;class me{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve){this.makeConnection=W,this.connectionToken=ve,typeof ve<"u"&&q(ve)}}e.$wK=me;class te extends Error{static NotAvailable(W,ve){return new te(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(W){return new te(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ve=y.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=ve,this._detail=Re,Object.setPrototypeOf(this,te.prototype)}}e.$xK=te;var G;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(G||(e.EndOfLine=G={}));var J;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let le=c=class{static isTextEdit(W){return W instanceof c?!0:W?j.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ve){return new c(W,ve)}static insert(W,ve){return c.replace(new j(W,W),ve)}static delete(W){return c.replace(W,"")}static setEndOfLine(W){const ve=new c(new j(new z(0,0),new z(0,0)),"");return ve.newEol=W,ve}get range(){return this.c}set range(W){if(W&&!j.isRange(W))throw(0,O.$7)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,O.$7)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,O.$7)("newEol");this.f=W}constructor(W,ve){this.c=W,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$yK=le,e.$yK=le=c=He([D],le);let ie=d=class{static isNotebookCellEdit(W){return W instanceof d?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ve){return new d(W,ve)}static insertCells(W,ve){return new d(new xt(W,W),ve)}static deleteCells(W){return new d(W,[])}static updateCellMetadata(W,ve){const Re=new d(new xt(W,W),[]);return Re.newCellMetadata=ve,Re}static updateNotebookMetadata(W){const ve=new d(new xt(0,0),[]);return ve.newNotebookMetadata=W,ve}constructor(W,ve){this.range=W,this.newCells=ve}};e.$zK=ie,e.$zK=ie=d=He([D],ie);class ce{static isSnippetTextEdit(W){return W instanceof ce?!0:W?j.isRange(W.range)&&B.isSnippetString(W.snippet):!1}static replace(W,ve){return new ce(W,ve)}static insert(W,ve){return ce.replace(new j(W,W),ve)}constructor(W,ve){this.range=W,this.snippet=ve}}e.$AK=ce;var ye;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace",V[V.Snippet=6]="Snippet"})(ye||(e.FileEditType=ye={}));let H=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ve,Re,Je){this.c.push({_type:1,from:W,to:ve,options:Re,metadata:Je})}createFile(W,ve,Re){this.c.push({_type:1,from:void 0,to:W,options:ve,metadata:Re})}deleteFile(W,ve,Re){this.c.push({_type:1,from:W,to:void 0,options:ve,metadata:Re})}e(W,ve,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(W,ve,Re,Je){const et=ve.start,ot=ve.end;(et!==ot||Re.length>0)&&this.c.push({_type:5,uri:W,index:et,count:ot-et,cells:Re,metadata:Je})}g(W,ve,Re,Je){this.c.push({_type:3,metadata:Je,uri:W,edit:{editType:3,index:ve,metadata:Re}})}replace(W,ve,Re,Je){this.c.push({_type:2,uri:W,edit:new le(ve,Re),metadata:Je})}insert(W,ve,Re,Je){this.replace(W,new j(ve,ve),Re,Je)}delete(W,ve,Re){this.replace(W,ve,"",Re)}has(W){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===W.toString())}set(W,ve){if(ve)for(const Re of ve){if(!Re)continue;let Je,et;Array.isArray(Re)?(Je=Re[0],et=Re[1]):Je=Re,ie.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(W,Je.range.start,Je.newCellMetadata,et):Je.newNotebookMetadata?this.e(W,Je.newNotebookMetadata,et):this.f(W,Je.range,Je.newCells,et):ce.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:W,range:Je.range,edit:Je.snippet,metadata:et}):this.c.push({_type:2,uri:W,edit:Je,metadata:et})}else{for(let Re=0;Re<this.c.length;Re++){const Je=this.c[Re];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,C.$Ib)(this.c)}}get(W){const ve=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&ve.push(Re.edit);return ve}entries(){const W=new R.$Ac;for(const ve of this.c)if(ve._type===2){let Re=W.get(ve.uri);Re||(Re=[ve.uri,[]],W.set(ve.uri,Re)),Re[1].push(ve.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$BK=H,e.$BK=H=He([D],H);let B=a=class{static isSnippetString(W){return W instanceof a?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=a.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ve=this.e++){if(typeof W=="function"){const Re=new a;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=a.c(W);return this.value+="${",this.value+=ve,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ve=this.e++){const Re=W.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,ve){if(typeof ve=="function"){const Re=new a;Re.e=this.e,ve(Re),this.e=Re.e,ve=Re.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$CK=B,e.$CK=B=a=He([D],B);var Y;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var re;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let X=t=class{static isLocation(W){return W instanceof t?!0:W?j.isRange(W.range)&&b.URI.isUri(W.uri):!1}constructor(W,ve){if(this.uri=W,ve)if(j.isRange(ve))this.range=j.of(ve);else if(z.isPosition(ve))this.range=new j(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$DK=X,e.$DK=X=t=He([D],X);let _=class{static is(W){return W?typeof W.message=="string"&&W.location&&j.isRange(W.location.range)&&b.URI.isUri(W.location.uri):!1}constructor(W,ve){this.location=W,this.message=ve}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.location.range.isEqual(ve.location.range)&&W.location.uri.toString()===ve.location.uri.toString()}};e.$EK=_,e.$EK=_=He([D],_);let x=class{constructor(W,ve,Re=re.Error){if(!j.isRange(W))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=W,this.message=ve,this.severity=Re}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.severity===ve.severity&&W.code===ve.code&&W.severity===ve.severity&&W.source===ve.source&&W.range.isEqual(ve.range)&&(0,C.$ub)(W.tags,ve.tags)&&(0,C.$ub)(W.relatedInformation,ve.relatedInformation,_.isEqual)}};e.$FK=x,e.$FK=x=He([D],x);let pe=class{constructor(W,ve){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ve}};e.$GK=pe,e.$GK=pe=He([D],pe);var ae;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(ae||(e.DocumentHighlightKind=ae={}));let fe=class{constructor(W,ve=ae.Text){this.range=W,this.kind=ve}toJSON(){return{range:this.range,kind:ae[this.kind]}}};e.$HK=fe,e.$HK=fe=He([D],fe);var ee;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var de;(function(V){V[V.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let be=i=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ve,Re,Je,et){this.name=W,this.kind=ve,this.containerName=et,typeof Re=="string"&&(this.containerName=Re),Je instanceof X?this.location=Je:Re instanceof j&&(this.location=new X(Je,Re)),i.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$IK=be,e.$IK=be=i=He([D],be);let Pe=s=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(s.validate)}constructor(W,ve,Re,Je,et){this.name=W,this.detail=ve,this.kind=Re,this.range=Je,this.selectionRange=et,this.children=[],s.validate(this)}};e.$JK=Pe,e.$JK=Pe=s=He([D],Pe);var U;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(U||(e.CodeActionTriggerKind=U={}));let Q=class{constructor(W,ve){this.title=W,this.kind=ve}};e.$KK=Q,e.$KK=Q=He([D],Q);let se=class{static{n=this}static{this.c="."}constructor(W){this.value=W}append(W){return new n(this.value?this.value+n.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+n.c)}};e.$LK=se,e.$LK=se=n=He([D],se),se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorMove=se.Refactor.append("move"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll"),se.Notebook=se.Empty.append("notebook");let oe=class{constructor(W,ve){if(this.range=W,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$MK=oe,e.$MK=oe=He([D],oe);class Z{constructor(W,ve,Re,Je,et,ot){this.kind=W,this.name=ve,this.detail=Re,this.uri=Je,this.range=et,this.selectionRange=ot}}e.$NK=Z;class ge{constructor(W,ve){this.fromRanges=ve,this.from=W}}e.$OK=ge;class Ee{constructor(W,ve){this.fromRanges=ve,this.to=W}}e.$PK=Ee;var ze;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(ze||(e.LanguageStatusSeverity=ze={}));let We=class{constructor(W,ve){this.range=W,this.command=ve}get isResolved(){return!!this.command}};e.$QK=We,e.$QK=We=He([D],We);let _e=r=class{#e;static isMarkdownString(W){return W instanceof r?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ve=!1){this.#e=new f.$4j(W,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ve){return this.#e.appendCodeblock(ve??"",W),this}};e.$RK=_e,e.$RK=_e=r=He([D],_e);let Ye=class{constructor(W,ve){this.label=W,this.documentation=ve}};e.$SK=Ye,e.$SK=Ye=He([D],Ye);let it=class{constructor(W,ve){this.label=W,this.documentation=ve,this.parameters=[]}};e.$TK=it,e.$TK=it=He([D],it);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$UK=tt,e.$UK=tt=He([D],tt);var Ae;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Te;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Te||(e.InlayHintKind=Te={}));let qe=class{constructor(W){this.value=W}};e.$VK=qe,e.$VK=qe=He([D],qe);let Le=class{constructor(W,ve,Re){this.position=W,this.label=ve,this.kind=Re}};e.$WK=Le,e.$WK=Le=He([D],Le);var Xe;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var he;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(he||(e.CompletionItemKind=he={}));var ue;(function(V){V[V.Deprecated=1]="Deprecated"})(ue||(e.CompletionItemTag=ue={}));let Ie=class{constructor(W,ve){this.label=W,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$XK=Ie,e.$XK=Ie=He([D],Ie);let Ke=class{constructor(W=[],ve=!1){this.items=W,this.isIncomplete=ve}};e.$YK=Ke,e.$YK=Ke=He([D],Ke);let Ue=class{constructor(W,ve,Re){this.insertText=W,this.range=ve,this.command=Re}};e.$ZK=Ue,e.$ZK=Ue=He([D],Ue);let Ze=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$1K=Ze,e.$1K=Ze=He([D],Ze);var nt;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ct;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ct||(e.StatusBarAlignment=ct={}));function bt(V,W){return`${P.$7l.toKey(V)}.${W}`}e.$2K=bt;var Et;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var Kt;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var pt;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var zt;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var Tt;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Tt||(e.DecorationRangeBehavior=Tt={})),function(V){function W(ve){switch(ve){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=W}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Gt;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(V){function W(ve){switch(ve){case V.Other:return"other";case V.Comment:return"comment";case V.String:return"string";case V.RegEx:return"regex"}return"other"}V.toString=W}(Gt||(e.SyntaxTokenType=Gt={}));let Ut=class{constructor(W,ve){if(ve&&!b.URI.isUri(ve))throw(0,O.$7)("target");if(!j.isRange(W)||W.isEmpty)throw(0,O.$7)("range");this.range=W,this.target=ve}};e.$3K=Ut,e.$3K=Ut=He([D],Ut);let Dt=class{constructor(W,ve,Re,Je){this.red=W,this.green=ve,this.blue=Re,this.alpha=Je}};e.$4K=Dt,e.$4K=Dt=He([D],Dt);let Ft=class{constructor(W,ve){if(ve&&!(ve instanceof Dt))throw(0,O.$7)("color");if(!j.isRange(W)||W.isEmpty)throw(0,O.$7)("range");this.range=W,this.color=ve}};e.$5K=Ft,e.$5K=Ft=He([D],Ft);let Bt=class{constructor(W){if(!W||typeof W!="string")throw(0,O.$7)("label");this.label=W}};e.$6K=Bt,e.$6K=Bt=He([D],Bt);var Qt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Qt||(e.ColorFormat=Qt={}));var Wt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var qt;(function(V){V[V.Unknown=0]="Unknown",V[V.Shutdown=1]="Shutdown",V[V.Process=2]="Process",V[V.User=3]="User",V[V.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class Nt{constructor(W,ve,Re){if(this.startIndex=W,this.length=ve,this.tooltip=Re,typeof W!="number"||W<0)throw(0,O.$7)("startIndex");if(typeof ve!="number"||ve<1)throw(0,O.$7)("length");if(Re!==void 0&&typeof Re!="string")throw(0,O.$7)("tooltip")}}e.$7K=Nt;class ut{constructor(W){this.uri=W}}e.$8K=ut;class ft{constructor(W){this.terminalCommand=W}}e.$9K=ft;var At;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class Vt{constructor(W){if(this.options=W,typeof W!="object")throw(0,O.$7)("options")}}e.$0K=Vt;var Rt;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var at;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(at||(e.TaskPanelKind=at={}));let vt=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from(W){switch(W){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor(W,ve){if(this.label=ve,typeof W!="string"||typeof ve!="string")throw(0,O.$7)("name");this.c=W}get id(){return this.c}};e.$$K=vt,e.$$K=vt=u=He([D],vt);function Ot(V){let W="";for(let ve=0;ve<V.length;ve++)W+=V[ve].replace(/,/g,",,")+",";return W}let Pt=class{constructor(W,ve,Re){if(typeof W!="string")throw(0,O.$7)("process");this.e=[],this.c=W,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Re):this.f=ve)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,O.$7)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)W.push(ve);return Ot(W)}};e.$_K=Pt,e.$_K=Pt=He([D],Pt);let Ge=class{constructor(W,ve,Re){if(this.f=[],Array.isArray(ve)){if(!W)throw(0,O.$7)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,O.$7)("command");this.e=W,this.f=ve,this.g=Re}else{if(typeof W!="string")throw(0,O.$7)("commandLine");this.c=W,this.g=ve}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,O.$7)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,O.$7)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)W.push(typeof ve=="string"?ve:ve.value);return Ot(W)}};e.$aL=Ge,e.$aL=Ge=He([D],Ge);var Jt;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Me;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(Me||(e.TaskScope=Me={}));class Oe{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.$fg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$bL=Oe;let Se=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ve,Re,Je,et,ot){this.j=!1,this.k=this.definition=W;let ht;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Re,this.execution=Je,ht=et,this.j=!0):ve===Me.Global||ve===Me.Workspace?(this.target=ve,this.m=this.name=Re,this.t=this.source=Je,this.execution=et,ht=ot):(this.target=ve,this.m=this.name=Re,this.t=this.source=Je,this.execution=et,ht=ot),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Pt?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof Ge?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof Oe?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,L.$fg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,O.$7)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,O.$7)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const ve=this.k.type;(I.g===ve||I.e===ve||I.f===ve||I.c===ve)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,O.$7)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$cL=Se,e.$cL=Se=I=He([D],Se);var ne;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(ne||(e.ProgressLocation=ne={}));var Fe;(function(V){function W(ve){const Re=ve;return(0,E.$Df)(Re.value)?Re.tooltip&&!(0,E.$zf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}V.isViewBadge=W})(Fe||(e.ViewBadge=Fe={}));let Ve=S=class{static isTreeItem(W,ve){const Re=W;if(Re.checkboxState!==void 0){const Je=(0,E.$Df)(Re.checkboxState)?Re.checkboxState:(0,E.$Bf)(Re.checkboxState)&&(0,E.$Df)(Re.checkboxState.state)?Re.checkboxState.state:void 0,et=!(0,E.$Df)(Re.checkboxState)&&(0,E.$Bf)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Qe.Checked&&Je!==Qe.Unchecked||et!==void 0&&!(0,E.$zf)(et))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof S)return!0;if(Re.label!==void 0&&!(0,E.$zf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,E.$zf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,E.$zf)(Re.iconPath)&&!b.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,E.$zf)(Re.iconPath.id))){const Je=Re.iconPath;if(!Je||!(0,E.$zf)(Je.light)&&!b.URI.isUri(Je.light)&&!(0,E.$zf)(Je.dark)&&!b.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,E.$zf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!b.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,E.$zf)(Re.tooltip)&&!(Re.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<xe.None&&Re.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,E.$zf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,ve=xe.None){this.collapsibleState=ve,b.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$dL=Ve,e.$dL=Ve=S=He([D],Ve);var xe;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var Qe;(function(V){V[V.Unchecked=0]="Unchecked",V[V.Checked=1]="Checked"})(Qe||(e.TreeItemCheckboxState=Qe={}));let rt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$eL=rt,e.$eL=rt=He([D],rt);class kt extends rt{}e.$fL=kt;class St extends kt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$gL=St;class mt{constructor(W,ve,Re,Je){this.name=W,this.uri=ve,this._itemId=Re,this.c=Je}data(){return this.c()}}e.$hL=mt;let dt=class{#e=new Map;constructor(W){for(const[ve,Re]of W??[]){const Je=this.#e.get(this.#t(ve));Je?Je.push(Re):this.#e.set(this.#t(ve),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ve){this.#e.set(this.#t(W),[ve])}forEach(W,ve){for(const[Re,Je]of this.#e)for(const et of Je)W.call(ve,et,Re,this)}*[Symbol.iterator](){for(const[W,ve]of this.#e)for(const Re of ve)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$iL=dt,e.$iL=dt=He([D],dt);let gt=class{constructor(W){this.insertText=W}};e.$jL=gt,e.$jL=gt=He([D],gt);let mi=class{constructor(W,ve){this.label=ve,this.insertText=W}};e.$kL=mi,e.$kL=mi=He([D],mi);let Ct=class{constructor(W,ve){this.id=W,this.color=ve}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$lL=Ct,e.$lL=Ct=He([D],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Di=class{constructor(W){this.id=W}};e.$mL=Di,e.$mL=Di=He([D],Di);var ui;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let $i=class{get base(){return this.c}set base(W){this.c=W,this.e=b.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ve){if(typeof W!="string"&&(!W||!b.URI.isUri(W)&&!b.URI.isUri(W.uri)))throw(0,O.$7)("base");if(typeof ve!="string")throw(0,O.$7)("pattern");typeof W=="string"?this.baseUri=b.URI.file(W):b.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$nL=$i,e.$nL=$i=He([D],$i);const It=new WeakMap;function gn(V,W){It.set(V,W)}e.$oL=gn;let ri=class{constructor(W,ve,Re,Je){this.enabled=typeof W=="boolean"?W:!0,typeof ve=="string"&&(this.condition=ve),typeof Re=="string"&&(this.hitCondition=Re),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=It.get(this)??(0,L.$fg)()),this.c}};e.$pL=ri,e.$pL=ri=He([D],ri);let yt=class extends ri{constructor(W,ve,Re,Je,et){if(super(ve,Re,Je,et),W===null)throw(0,O.$7)("location");this.location=W}};e.$qL=yt,e.$qL=yt=He([D],yt);let bi=class extends ri{constructor(W,ve,Re,Je,et){super(ve,Re,Je,et),this.functionName=W}};e.$rL=bi,e.$rL=bi=He([D],bi);let wi=class extends ri{constructor(W,ve,Re,Je,et,ot,ht){if(super(Je,et,ot,ht),!ve)throw(0,O.$7)("dataId");this.label=W,this.dataId=ve,this.canPersist=Re}};e.$sL=wi,e.$sL=wi=He([D],wi);let si=class{constructor(W,ve,Re){this.command=W,this.args=ve||[],this.options=Re}};e.$tL=si,e.$tL=si=He([D],si);let Ci=class{constructor(W,ve){this.port=W,this.host=ve}};e.$uL=Ci,e.$uL=Ci=He([D],Ci);let Ii=class{constructor(W){this.path=W}};e.$vL=Ii,e.$vL=Ii=He([D],Ii);let Lt=class{constructor(W){this.implementation=W}};e.$wL=Lt,e.$wL=Lt=He([D],Lt);let pi=class{constructor(W,ve,Re){this.session=W,this.threadId=ve,this.frameId=Re}};e.$xL=pi,e.$xL=pi=He([D],pi);let Pi=class{constructor(W,ve){this.session=W,this.threadId=ve}};e.$yL=Pi,e.$yL=Pi=He([D],Pi);let oi=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$zL=oi,e.$zL=oi=He([D],oi);var li;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(li||(e.InlineCompletionTriggerKind=li={}));let lt=class{constructor(W,ve){this.range=W,this.text=ve}};e.$AL=lt,e.$AL=lt=He([D],lt);let Ai=class{constructor(W,ve,Re=!0){this.range=W,this.variableName=ve,this.caseSensitiveLookup=Re}};e.$BL=Ai,e.$BL=Ai=He([D],Ai);let Zt=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$CL=Zt,e.$CL=Zt=He([D],Zt);let ii=class{constructor(W,ve){this.frameId=W,this.stoppedLocation=ve}};e.$DL=ii,e.$DL=ii=He([D],ii);var Ri;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Li=$=class extends Error{static FileExists(W){return new $(W,p.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(W){return new $(W,p.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(W){return new $(W,p.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(W){return new $(W,p.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(W){return new $(W,p.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(W){return new $(W,p.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(W,ve=p.FileSystemProviderErrorCode.Unknown,Re){super(b.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,p.$ok)(this,ve),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$EL=Li,e.$EL=Li=$=He([D],Li);let Mi=class{constructor(W,ve,Re){this.start=W,this.end=ve,this.kind=Re}};e.$FL=Mi,e.$FL=Mi=He([D],Mi);var Yi;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Fi;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Xi;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(Xi||(e.CommentMode=Xi={}));var Oi;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(Oi||(e.CommentState=Oi={}));var ai;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class mn{constructor(W,ve=[]){this.tokenTypes=W,this.tokenModifiers=ve}}e.$GL=mn;function Ti(V){return typeof V>"u"||(0,E.$Af)(V)}class hi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ve=0,Re=W.tokenTypes.length;ve<Re;ve++)this.j.set(W.tokenTypes[ve],ve);for(let ve=0,Re=W.tokenModifiers.length;ve<Re;ve++)this.k.set(W.tokenModifiers[ve],ve)}}push(W,ve,Re,Je,et){if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Je=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.n(W,ve,Re,Je,et);if(j.isRange(W)&&typeof ve=="string"&&Ti(Re))return this.m(W,ve,Re);throw(0,O.$7)()}m(W,ve,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Je=W.start.line,et=W.start.character,ot=W.end.character-W.start.character,ht=this.j.get(ve);let jt=0;if(Re)for(const Xt of Re){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);jt|=1<<ei>>>0}this.n(Je,et,ot,ht,jt)}n(W,ve,Re,Je,et){if(this.f&&(W<this.c||W===this.c&&ve<this.e)){this.f=!1;const jt=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<jt;ti++){let ni=this.g[5*ti],Qi=this.g[5*ti+1];ni===0?(ni=Xt,Qi+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Qi,Xt=ni,ei=Qi}}let ot=W,ht=ve;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ht,this.g[this.h++]=Re,this.g[this.h++]=Je,this.g[this.h++]=et,this.c=W,this.e=ve}static o(W){const ve=[],Re=W.length/5|0;for(let ht=0;ht<Re;ht++)ve[ht]=ht;ve.sort((ht,jt)=>{const Xt=W[5*ht],ei=W[5*jt];if(Xt===ei){const ti=W[5*ht+1],ni=W[5*jt+1];return ti-ni}return Xt-ei});const Je=new Uint32Array(W.length);let et=0,ot=0;for(let ht=0;ht<Re;ht++){const jt=5*ve[ht],Xt=W[jt+0],ei=W[jt+1],ti=W[jt+2],ni=W[jt+3],Qi=W[jt+4],In=Xt-et,Fn=In===0?ei-ot:ei,Ji=5*ht;Je[Ji+0]=In,Je[Ji+1]=Fn,Je[Ji+2]=ti,Je[Ji+3]=ni,Je[Ji+4]=Qi,et=Xt,ot=ei}return Je}build(W){return this.f?new Ni(new Uint32Array(this.g),W):new Ni(hi.o(this.g),W)}}e.$HL=hi;class Ni{constructor(W,ve){this.resultId=ve,this.data=W}}e.$IL=Ni;class $n{constructor(W,ve,Re){this.start=W,this.deleteCount=ve,this.data=Re}}e.$JL=$n;class di{constructor(W,ve){this.resultId=ve,this.edits=W}}e.$KL=di;var Zi;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let ji=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$LL=ji,e.$LL=ji=He([D],ji);var xi;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var fi;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var _i;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class bn{static validate(W){if(typeof W.badge=="string"){let ve=(0,m.$af)(W.badge,0);if(ve<W.badge.length&&(ve+=(0,m.$af)(W.badge,ve)),W.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ct.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ve,Re){this.badge=W,this.tooltip=ve,this.color=Re}}e.$ML=bn;let zi=class{constructor(W){this.kind=W}};e.$NL=zi,e.$NL=zi=He([D],zi);var gi;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(gi||(e.ColorThemeKind=gi={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ve){if(W<0)throw(0,O.$7)("start must be positive");if(ve<0)throw(0,O.$7)("end must be positive");W<=ve?(this.c=W,this.e=ve):(this.c=ve,this.e=W)}with(W){let ve=this.c,Re=this.e;return W.start!==void 0&&(ve=W.start),W.end!==void 0&&(Re=W.end),ve===this.c&&Re===this.e?this:new xt(ve,Re)}}e.$OL=xt;class vi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ve=>vi.isNotebookCellData(ve))}static isNotebookCellData(W){return!0}constructor(W,ve,Re,Je,et,ot,ht){this.kind=W,this.value=ve,this.languageId=Re,this.mime=Je,this.outputs=et??[],this.metadata=ot,this.executionSummary=ht,vi.validate(this)}}e.$PL=vi;class en{constructor(W){this.cells=W}}e.$QL=en;class Yt{static isNotebookCellOutputItem(W){return W instanceof Yt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ve={name:W.name,message:W.message,stack:W.stack};return Yt.json(ve,"application/vnd.code.notebook.error")}static stdout(W){return Yt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Yt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ve="application/octet-stream"){return new Yt(W,ve)}static#e=new TextEncoder;static text(W,ve=A.$Tr.text){const Re=Yt.#e.encode(String(W));return new Yt(Re,ve)}static json(W,ve="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Yt.text(Re,ve)}constructor(W,ve){this.data=W,this.mime=ve;const Re=(0,A.$Xr)(ve,!0);if(!Re)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$RL=Yt;class yi{static isNotebookCellOutput(W){return W instanceof yi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ve=!1){const Re=new Set,Je=new Set;for(let et=0;et<W.length;et++){const ot=W[et],ht=(0,A.$Xr)(ot.mime);if(!Re.has(ht)||(0,k.$yI)(ht)){Re.add(ht);continue}Je.add(et),ve&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Je.size===0?W:W.filter((et,ot)=>!Je.has(ot))}constructor(W,ve,Re){this.items=yi.ensureUniqueMimeTypes(W,!0),typeof ve=="string"?(this.id=ve,this.metadata=Re):(this.id=(0,L.$fg)(),this.metadata=ve??Re)}}e.$SL=yi;var tn;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var Ei;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class sn{constructor(W,ve){this.text=W,this.alignment=ve}}e.$TL=sn;var je;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(je||(e.NotebookControllerAffinity=je={}));var _t;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred",V[V.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class on{constructor(W,ve=[]){this.uri=W,this.provides=(0,C.$3b)(ve)}}e.$UL=on;class $t{constructor(W){this.label=W}}e.$VL=$t;let Ui=class{constructor(W,ve){this.label=W,this.timestamp=ve}};e.$WL=Ui,e.$WL=Ui=He([D],Ui);var an;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Bi;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var cn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class ki{constructor(W,ve){this.ranges=W,this.wordPattern=ve}}e.$XL=ki;class wn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$YL=wn;var un;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let Si=class{constructor(W=void 0,ve=void 0,Re=void 0,Je=!1){this.include=W,this.exclude=ve,this.profile=Re,this.continuous=Je}};e.$ZL=Si,e.$ZL=Si=He([D],Si);let Wi=g=class{static diff(W,ve,Re){const Je=new g(W);return Je.expectedOutput=ve,Je.actualOutput=Re,Je}constructor(W){this.message=W}};e.$1L=Wi,e.$1L=Wi=g=He([D],Wi);let qi=class{constructor(W){this.id=W}};e.$2L=qi,e.$2L=qi=He([D],qi);let ci=class{constructor(W,ve){this.covered=W,this.total=ve}};e.$3L=ci,e.$3L=ci=He([D],ci);let Vi=w=class{static fromDetails(W,ve){const Re=new ci(0,0),Je=new ci(0,0),et=new ci(0,0);for(const ht of ve)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const jt of ht.branches)Je.total+=1,Je.covered+=jt.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const ot=new w(W,Re,Je.total>0?Je:void 0,et.total>0?et:void 0);return ot.detailedCoverage=ve,ot}constructor(W,ve,Re,Je){this.uri=W,this.statementCoverage=ve,this.branchCoverage=Re,this.functionCoverage=Je}};e.$4L=Vi,e.$4L=Vi=w=He([D],Vi);let Ki=class{constructor(W,ve,Re=[]){this.executionCount=W,this.location=ve,this.branches=Re}};e.$5L=Ki,e.$5L=Ki=He([D],Ki);let Hi=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$6L=Hi,e.$6L=Hi=He([D],Hi);let Gi=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$7L=Gi,e.$7L=Gi=He([D],Gi);var hn;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(hn||(e.ExternalUriOpenerPriority=hn={}));var dn;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var fn;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class we{constructor(W,ve,Re,Je,et,ot){this.kind=W,this.name=ve,this.detail=Re,this.uri=Je,this.range=et,this.selectionRange=ot}}e.$8L=we;class ke{constructor(W){this.uri=W}}e.$9L=ke;class Ne{constructor(W,ve){this.original=W,this.modified=ve}}e.$0L=Ne;class st{constructor(W,ve,Re,Je){this.base=W,this.input1=ve,this.input2=Re,this.result=Je}}e.$$L=st;class wt{constructor(W,ve){this.uri=W,this.viewType=ve}}e.$_L=wt;class Mt{constructor(W){this.viewType=W}}e.$aM=Mt;class Pn{constructor(W,ve){this.uri=W,this.notebookType=ve}}e.$bM=Pn;class An{constructor(W,ve,Re){this.original=W,this.modified=ve,this.notebookType=Re}}e.$cM=An;class Rn{constructor(){}}e.$dM=Rn;class Ln{constructor(W,ve){this.uri=W,this.inputBoxUri=ve}}e.$eM=Ln;var pn;(function(V){V[V.Down=0]="Down",V[V.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(V){V[V.Action=1]="Action",V[V.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var yn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful",V[V.Undone=2]="Undone",V[V.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(V){V[V.System=0]="System",V[V.User=1]="User",V[V.Assistant=2]="Assistant",V[V.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var kn;(function(V){V[V.Short=1]="Short",V[V.Medium=2]="Medium",V[V.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Mn{constructor(W,ve){this.role=W,this.content=ve}}e.$fM=Mn;var Sn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful"})(Sn||(e.ChatAgentResultFeedbackKind=Sn={}));var Dn;(function(V){V[V.SymbolInformation=1]="SymbolInformation",V[V.CommandInformation=2]="CommandInformation",V[V.SearchInformation=3]="SearchInformation",V[V.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Cn;(function(V){V[V.Started=1]="Started",V[V.Recognizing=2]="Recognizing",V[V.Recognized=3]="Recognized",V[V.Stopped=4]="Stopped"})(Cn||(e.SpeechToTextStatus=Cn={}))}),define(De[141],Ce([1,0,58,18,15,171,124,7,19]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=void 0;const b=new Map;function L(k,v){v?b.set(k,v):b.delete(k)}e.$sM=L;function P(k){return b.get(k)}class p extends R.$Zu{constructor(v,h,o,l,c,d,a,t){super(h,o,l,c),this.c=v,this.m=d,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(v){return(0,E.$ub)(this.f,v)}get document(){if(!this.a){const v=this;this.a={get uri(){return v.d},get fileName(){return v.d.fsPath},get isUntitled(){return v.d.scheme===O.Schemas.untitled},get languageId(){return v.m},get version(){return v.h},get isClosed(){return v.b},get isDirty(){return v.q},save(){return v.r()},getText(h){return h?v.s(h):v.getText()},get eol(){return v.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return v.f.length},lineAt(h){return v.t(h)},offsetAt(h){return v.u(h)},positionAt(h){return v.v(h)},validateRange(h){return v.w(h)},validatePosition(h){return v.x(h)},getWordRangeAtPosition(h,o){return v.y(h,o)}}}return Object.freeze(this.a)}_acceptLanguageId(v){(0,C.ok)(!this.b),this.m=v}_acceptIsDirty(v){(0,C.ok)(!this.b),this.q=v}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(v){const h=this.w(v);if(h.isEmpty)return"";if(h.isSingleLine)return this.f[h.start.line].substring(h.start.character,h.end.character);const o=this.g,l=h.start.line,c=h.end.line,d=[];d.push(this.f[l].substring(h.start.character));for(let a=l+1;a<c;a++)d.push(this.f[a]);return d.push(this.f[c].substring(0,h.end.character)),d.join(o)}t(v){let h;if(v instanceof m.$sK?h=v.line:typeof v=="number"&&(h=v),typeof h!="number"||h<0||h>=this.f.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new y(h,this.f[h],h===this.f.length-1)}u(v){return v=this.x(v),this.l(),this.j.getPrefixSum(v.line-1)+v.character}v(v){v=Math.floor(v),v=Math.max(0,v),this.l();const h=this.j.getIndexOf(v),o=this.f[h.index].length;return new m.$sK(h.index,Math.min(h.remainder,o))}w(v){if(!(v instanceof m.$tK))throw new Error("Invalid argument");const h=this.x(v.start),o=this.x(v.end);return h===v.start&&o===v.end?v:new m.$tK(h.line,h.character,o.line,o.character)}x(v){if(!(v instanceof m.$sK))throw new Error("Invalid argument");if(this.f.length===0)return v.with(0,0);let{line:h,character:o}=v,l=!1;if(h<0)h=0,o=0,l=!0;else if(h>=this.f.length)h=this.f.length-1,o=this.f[h].length,l=!0;else{const c=this.f[h].length;o<0?(o=0,l=!0):o>c&&(o=c,l=!0)}return l?new m.$sK(h,o):v}y(v,h){const o=this.x(v);if(!h)h=P(this.m);else if((0,f.$Pe)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const l=(0,A.$_r)(o.character+1,(0,A.$0r)(h),this.f[o.line],0);if(l)return new m.$tK(o.line,l.startColumn-1,o.line,l.endColumn-1)}}e.$tM=p;class y{constructor(v,h,o){this.a=v,this.b=h,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$tK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$tK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$uM=y}),define(De[276],Ce([1,0,7,20,4]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;let R=class{constructor(m){this.a=new C.$NL(C.ColorThemeKind.Dark),this.b=new f.$Od}get activeColorTheme(){return this.a}$onColorThemeChange(m){let E;switch(m){case"light":E=C.ColorThemeKind.Light;break;case"hcDark":E=C.ColorThemeKind.HighContrast;break;case"hcLight":E=C.ColorThemeKind.HighContrastLight;break;default:E=C.ColorThemeKind.Dark}this.a=new C.$NL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$0dc=R,e.$0dc=R=He([Be(0,O.$qM)],R)}),define(De[277],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CI=e.CellExecutionUpdateType=void 0;var O;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$CI=(0,C.$Qh)("INotebookExecutionService")}),define(De[68],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iJ=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(R){R.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var O;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class f{static fromExtHostTestItem(A,m,E=A.parent){if(A._isRoot)return new f([m]);const b=[A.id];for(let L=E;L&&L.id!==m;L=L.parent)b.push(L.id);return b.push(m),new f(b.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const m=A.indexOf("\0");return m===-1?A:A.slice(0,m)}static fromString(A){return new f(A.split("\0"))}static join(A,m){return new f([...A.path,m])}static joinToString(A,m){return A.toString()+"\0"+m}static parentId(A){const m=A.lastIndexOf("\0");return m===-1?void 0:A.slice(0,m)}static localId(A){const m=A.lastIndexOf("\0");return m===-1?A:A.slice(m+1)}static isChild(A,m){return m.startsWith(A)&&m[A.length]==="\0"}static compare(A,m){return A===m?0:f.isChild(A,m)?2:f.isChild(m,A)?3:1}constructor(A,m=A.length){if(this.path=A,this.d=m,A.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new f(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new f(this.path,A)}compare(A){if(typeof A=="string")return f.compare(this.toString(),A);for(let m=0;m<A.d&&m<this.d;m++)if(A.path[m]!==this.path[m])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$iJ=f}),define(De[87],Ce([1,0,2,32,68]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$oJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$nJ=e.$mJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$lJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$kJ=e.$jJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var m;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$jJ=[2,4,8,16,32,64];const E=S=>"runId"in S;e.$kJ=E;var b;(function(S){S.serialize=$=>({range:$.range.toJSON(),uri:$.uri.toJSON()}),S.deserialize=$=>({range:O.$xs.lift($.range),uri:C.URI.revive($.uri)})})(b||(e.IRichLocation=b={}));var L;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(L||(e.TestMessageType=L={}));var P;(function(S){S.serialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&b.serialize($.location)}),S.deserialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&b.deserialize($.location)})})(P||(e.ITestErrorMessage=P={}));const p=(S,$)=>`${$?"s":"e"}${S}`;e.$lJ=p;var y;(function(S){S.serialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&b.serialize($.location)}),S.deserialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&b.deserialize($.location)})})(y||(e.ITestOutputMessage=y={}));var k;(function(S){S.serialize=$=>$.type===0?P.serialize($):y.serialize($),S.deserialize=$=>$.type===0?P.deserialize($):y.deserialize($)})(k||(e.ITestMessage=k={}));var v;(function(S){S.serializeWithoutMessages=$=>({state:$.state,duration:$.duration,messages:[]}),S.serialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(k.serialize)}),S.deserialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(k.deserialize)})})(v||(e.ITestTaskState=v={}));const h="\0",o=(S,$)=>S+h+$;e.$mJ=o;const l=S=>{const $=S.indexOf(h);return{ctrlId:S.slice(0,$),tagId:S.slice($+1)}};e.$nJ=l;var c;(function(S){S.serialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?.toJSON(),range:$.range?.toJSON()||null,description:$.description,error:$.error,sortText:$.sortText}),S.deserialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?C.URI.revive($.uri):void 0,range:$.range?O.$xs.lift($.range):null,description:$.description,error:$.error,sortText:$.sortText})})(c||(e.ITestItem=c={}));var d;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(d||(e.TestItemExpandState=d={}));var a;(function(S){S.serialize=$=>({expand:$.expand,item:c.serialize($.item)}),S.deserialize=$=>({controllerId:f.$iJ.root($.item.extId),expand:$.expand,item:c.deserialize($.item)})})(a||(e.InternalTestItem=a={}));var t;(function(S){S.serialize=$=>{let g;return $.item&&(g={},$.item.label!==void 0&&(g.label=$.item.label),$.item.tags!==void 0&&(g.tags=$.item.tags),$.item.busy!==void 0&&(g.busy=$.item.busy),$.item.uri!==void 0&&(g.uri=$.item.uri?.toJSON()),$.item.range!==void 0&&(g.range=$.item.range?.toJSON()),$.item.description!==void 0&&(g.description=$.item.description),$.item.error!==void 0&&(g.error=$.item.error),$.item.sortText!==void 0&&(g.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:g}},S.deserialize=$=>{let g;return $.item&&(g={},$.item.label!==void 0&&(g.label=$.item.label),$.item.tags!==void 0&&(g.tags=$.item.tags),$.item.busy!==void 0&&(g.busy=$.item.busy),$.item.range!==void 0&&(g.range=$.item.range?O.$xs.lift($.item.range):null),$.item.description!==void 0&&(g.description=$.item.description),$.item.error!==void 0&&(g.error=$.item.error),$.item.sortText!==void 0&&(g.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:g}}})(t||(e.ITestItemUpdate=t={}));const i=(S,$)=>{$.expand!==void 0&&(S.expand=$.expand),$.item!==void 0&&(S.item=S.item?Object.assign(S.item,$.item):$.item)};e.$oJ=i;var s;(function(S){S.serializeWithoutMessages=$=>({...a.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(v.serializeWithoutMessages)}),S.serialize=$=>({...a.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(v.serialize)}),S.deserialize=$=>({...a.deserialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(v.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var n;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(n||(e.DetailType=n={}));var r;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(r||(e.TestDiffOpType=r={}));var u;(function(S){S.deserialize=$=>$.op===0?{op:$.op,item:a.deserialize($.item)}:$.op===1?{op:$.op,item:t.deserialize($.item)}:$.op===2?{op:$.op,uri:C.URI.revive($.uri),docv:$.docv}:$,S.serialize=$=>$.op===0?{op:$.op,item:a.serialize($.item)}:$.op===1?{op:$.op,item:t.serialize($.item)}:$})(u||(e.TestsDiffOp=u={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply($){const g=this.o();for(const w of $)switch(w.op){case 0:this.j(a.deserialize(w.item),g);break;case 1:this.k(t.deserialize(w.item),g);break;case 3:this.l(w.itemId,g);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}g.complete?.()}j($,g){const w=f.$iJ.parentId($.item.extId)?.toString();let D;if(!w)D=this.p($),this.f.add(D),this.d.set($.item.extId,D);else if(this.d.has(w)){const T=this.d.get(w);T.children.add($.item.extId),D=this.p($,T),this.d.set($.item.extId,D)}else{console.error(`Test with unknown parent ID: ${JSON.stringify($)}`);return}return g.add?.(D),$.expand===2&&this.g++,D}k($,g){const w=this.d.get($.extId);if(w)return $.expand!==void 0&&(w.expand===2&&this.g--,$.expand===2&&this.g++),(0,e.$oJ)(w,$),g.update?.(w),w}l($,g){const w=this.d.get($);if(!w)return;const D=f.$iJ.parentId(w.item.extId)?.toString();D?this.d.get(D).children.delete(w.item.extId):this.f.delete(w);const T=[[$]];for(;T.length;)for(const M of T.pop()){const F=this.d.get(M);F&&(T.push(F.children),this.d.delete(M),g.remove?.(F,F!==w),F.expand===2&&this.g--)}}m($){}updatePendingRoots($){this.h+=$}o(){return{}}}e.$pJ=I}),define(De[109],Ce([1,0,8,4,3,58,87,68]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.TestItemEventOp=void 0;var E;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const b=(l,c)=>l===c,P=Object.entries({range:(l,c)=>l===c?!0:!l||!c?!1:l.equalsRange(c),busy:b,label:b,description:b,error:b,sortText:b,tags:(l,c)=>!(l.length!==c.length||l.some(d=>!c.includes(d)))}),p=(l,c)=>{let d;for(const[a,t]of P)t(l[a],c[a])||(d?d[a]=c[a]:d={[a]:c[a]});return d};class y extends f.$Sc{get root(){return this.s.root}constructor(c){super(),this.s=c,this.f=this.B(new C.$7g(()=>this.flushDiff(),200)),this.g=this.B(new O.$Od),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(c){this.h=c;for(const d of this.tree.values())this.I(d)}get resolveHandler(){return this.h}collectDiff(){const c=this.m;return this.m=[],c}pushDiff(c){switch(c.op){case 2:{for(const d of this.m)if(d.op===2&&d.uri===c.uri){d.docv=c.docv;return}break}case 1:{const d=this.m[this.m.length-1];if(d){if(d.op===1&&d.item.extId===c.item.extId){(0,A.$oJ)(d.item,c.item);return}if(d.op===0&&d.item.item.extId===c.item.extId){(0,A.$oJ)(d.item,c.item);return}}break}}this.m.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,d){const a=this.tree.get(c);if(a){if((a.expandLevels===void 0||d>a.expandLevels)&&(a.expandLevels=d),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,d-1):t.wait().then(()=>this.J(a,d-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,d-1)):this.J(a,d-1)}}dispose(){for(const c of this.tree.values())this.s.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(c,d){switch(d.op){case 3:this.N(m.$iJ.joinToString(c.fullId,d.id));break;case 0:this.y(d.item,c);break;case 5:for(const a of d.ops)this.u(c,a);break;case 1:this.z(d.new,d.old,c.fullId.toString());break;case 2:this.I(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:d.update}});break;case 6:this.w(c.actual.uri);break;default:(0,R.$4c)(d)}}w(c){c&&this.pushDiff({op:2,uri:c,docv:this.s.getDocumentVersion(c)})}y(c,d){const a=m.$iJ.fromExtHostTestItem(c,this.root.id,d?.actual),t=this.s.getApiFor(c);t.parent&&t.parent!==d?.actual&&this.s.getChildren(t.parent).delete(c.id);let i=this.tree.get(a.toString());if(!i){i={fullId:a,actual:c,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},c.tags.forEach(this.C,this),this.tree.set(i.fullId.toString(),i),this.F(c,d),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:i.expand,item:this.s.toITestItem(c)}}),this.H(c,i,d);return}if(i.actual===c){this.G(c,i,d);return}if(i.actual.uri?.toString()!==c.uri?.toString())return this.N(a.toString()),this.y(c,d);const s=this.s.getChildren(i.actual),n=i.actual,r=p(this.s.toITestItem(n),this.s.toITestItem(c));this.s.getApiFor(n).listener=void 0,i.actual=c,i.expand=0,r&&(r.hasOwnProperty("tags")&&(this.z(c.tags,n.tags,a.toString()),delete r.tags),this.u(i,{op:4,update:r})),this.H(c,i,d);for(const[u,I]of s)this.s.getChildren(c).get(I.id)||this.N(m.$iJ.joinToString(a,I.id));this.w(i.actual.uri)}z(c,d,a){const t=new Set(d.map(i=>i.id));for(const i of c)t.delete(i.id)||this.C(i);this.pushDiff({op:1,item:{extId:a,item:{tags:c.map(i=>(0,A.$mJ)(this.s.controllerId,i.id))}}}),t.forEach(this.D,this)}C(c){const d=this.j.get(c.id);d?d.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$mJ)(this.s.controllerId,c.id)}}))}D(c){const d=this.j.get(c);d&&!--d.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,A.$mJ)(this.s.controllerId,c)}))}F(c,d){this.s.getApiFor(c).parent=d&&d.actual!==this.root?d.actual:void 0}G(c,d,a){this.F(c,a);const t=this.s.getApiFor(c);t.parent=a?.actual,t.listener=i=>this.u(d,i),this.I(d)}H(c,d,a){this.G(c,d,a);for(const[t,i]of this.s.getChildren(c))this.y(i,d)}I(c){let d;this.h?c.resolveBarrier?d=c.resolveBarrier.isOpen()?3:2:d=c.actual.canResolveChildren?1:0:d=0,d!==c.expand&&(c.expand=d,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:d}}),d===1&&c.expandLevels!==void 0&&this.L(c))}J(c,d){if(d<0)return;const a=[];for(const[t,i]of this.s.getChildren(c.actual)){const s=this.expand(m.$iJ.joinToString(c.fullId,i.id),d);(0,C.$Hg)(s)&&a.push(s)}if(a.length)return Promise.all(a).then(()=>{})}L(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const i=new C.$Tg;return i.open(),i}c.expand=2,this.M(c);const d=c.resolveBarrier=new C.$Tg,a=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,i)};let t;try{t=this.h(c.actual===this.root?void 0:c.actual)}catch(i){a(i)}return(0,C.$Hg)(t)?t.catch(a).then(()=>{d.open(),this.I(c)}):(d.open(),this.I(c)),c.resolveBarrier}M(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}N(c){const d=this.tree.get(c);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const a=[d];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const i of t.actual.tags)this.D(i.id);this.tree.delete(t.fullId.toString());for(const[i,s]of this.s.getChildren(t.actual))a.push(this.tree.get(m.$iJ.joinToString(t.fullId,s.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.$gM=y;class k extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.$hM=k;class v extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$iM=v;class h extends Error{constructor(c,d,a){super(`TestItem with ID "${c}" is from controller "${d}" and cannot be added as a child of an item from controller "${a}".`)}}e.$jM=h;const o=(l,c,d)=>{let a=new Map;return{get size(){return a.size},forEach(t,i){for(const s of a.values())t.call(i,s,this)},[Symbol.iterator](){return a.entries()},replace(t){const i=new Map,s=new Set(a.keys()),n={op:5,ops:[]};for(const r of t){if(!(r instanceof d))throw new v(r.id);const u=c(r).controllerId;if(u!==l.controllerId)throw new h(r.id,u,l.controllerId);if(i.has(r.id))throw new k(r.id);i.set(r.id,r),s.delete(r.id),n.ops.push({op:0,item:r})}for(const r of s.keys())n.ops.push({op:3,id:r});l.listener?.(n),a=i},add(t){if(!(t instanceof d))throw new v(t.id);a.set(t.id,t),l.listener?.({op:0,item:t})},delete(t){a.delete(t)&&l.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$kM=o}),define(De[142],Ce([1,0,109]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=void 0;const O=new WeakMap,f=(A,m)=>{const E={controllerId:m};return O.set(A,E),E};e.$lM=f;const R=A=>{const m=O.get(A);if(!m)throw new C.$iM(A?.id||"<unknown>");return m};e.$mM=R}),define(De[110],Ce([1,0,18,2]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpb=e.$lpb=e.$kpb=e.$jpb=e.$ipb=void 0,e.$ipb="vscode-cdn.net",e.$jpb=`vscode-resource.${e.$ipb}`,e.$kpb=`'self' https://*.${e.$ipb}`;function f(m,E){return m.scheme===C.Schemas.http||m.scheme===C.Schemas.https?m:(E&&E.authority&&E.isRemote&&m.scheme===C.Schemas.file&&(m=O.URI.from({scheme:C.Schemas.vscodeRemote,authority:E.authority,path:m.path})),O.URI.from({scheme:C.Schemas.https,authority:`${m.scheme}+${R(m.authority)}.${e.$jpb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$lpb=f;function R(m){return m.replace(/./g,E=>{const b=E.charCodeAt(0);return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57?E:"-"+b.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(E,b)=>String.fromCharCode(parseInt(b,16)))}e.$mpb=A}),define(De[278],Ce([1,0,4,3,110]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class R{constructor(m,E,b){this.d=m,this.e=E,this.f=b,this.a=0,this.b=new O.$Rc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const L=E.getVisibleTextEditors();for(const P of this.c.values())L.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,E,b,L,P){let p;for(const c of this.e.getVisibleTextEditors(!0))if(c.value===m){p=c;break}if(!p)throw new Error("not a visible editor");const y=this,k=this.a++,v=new C.$Od,h=new C.$Od,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(c){return(0,f.$lpb)(c,y.f)}get cspSource(){return f.$kpb}set options(c){this.b=c,y.d.$setOptions(k,c)}get options(){return this.b}set html(c){this.a=c,y.d.$setHtml(k,c)}get html(){return this.a}get onDidReceiveMessage(){return v.event}postMessage(c){return y.d.$postMessage(k,c)}},l=new class{constructor(){this.editor=m,this.line=E,this.height=b,this.webview=o,this.onDidDispose=h.event}dispose(){y.c.has(k)&&(y.c.delete(k),y.d.$disposeEditorInset(k),h.fire(),h.dispose(),v.dispose())}};return this.d.$createEditorInset(k,p.id,p.value.document.uri,E+1,b,L||{},P.identifier,P.extensionLocation),this.c.set(k,{editor:m,inset:l,onDidReceiveMessage:v}),l}$onDidDispose(m){const E=this.c.get(m);E&&E.inset.dispose()}$onDidReceiveMessage(m,E){this.c.get(m)?.onDidReceiveMessage.fire(E)}}e.$Hdc=R}),define(De[279],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=e.VariableKind=e.$cN=void 0,e.$cN=(0,C.$Qh)("configurationResolverService");var O;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(O||(e.VariableKind=O={}));class f extends Error{constructor(A,m){super(m),this.variable=A}}e.$dN=f}),define(De[280],Ce([1,0,16,48,17,24,12,99,224,279,15]),function($e,e,C,O,f,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,k,v,h){this.h=new Map,this.a=y,this.b=k,this.g=v,h&&(this.c=h.then(o=>this.i(o)))}i(y){if(A.$j){const k=Object.create(null);return Object.keys(y).forEach(v=>{k[v.toLowerCase()]=y[v]}),k}return y}resolveWithEnvironment(y,k,v){return this.l({env:this.i(y),userHome:void 0},k?k.uri:void 0,v)}async resolveAsync(y,k){const v={env:await this.c,userHome:await this.g};return this.l(v,y?y.uri:void 0,k)}async j(y,k,v,h){const o=R.$8m(k);A.$j&&o.windows?Object.keys(o.windows).forEach(c=>o[c]=o.windows[c]):A.$k&&o.osx?Object.keys(o.osx).forEach(c=>o[c]=o.osx[c]):A.$l&&o.linux&&Object.keys(o.linux).forEach(c=>o[c]=o.linux[c]),delete o.windows,delete o.osx,delete o.linux;const l={env:await this.c,userHome:await this.g};return this.l(l,y?y.uri:void 0,o,v,h)}async resolveAnyAsync(y,k,v){return this.j(y,k,v)}async resolveAnyMap(y,k,v){const h=new Map;return{newConfig:await this.j(y,k,v,h),resolvedVariables:h}}resolveWithInteractionReplace(y,k,v,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,k,v,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,k){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,k)}async l(y,k,v,h,o){if(f.$zf(v))return this.m(y,k,v,h,o);if(Array.isArray(v))return Promise.all(v.map(l=>this.l(y,k,l,h,o)));if(f.$Bf(v)){const l=Object.create(null),c=await Promise.all(Object.keys(v).map(async d=>[await this.m(y,k,d,h,o),await this.l(y,k,v[d],h,o)]));for(const[d,a]of c)l[d]=a;return l}return v}m(y,k,v,h,o){return(0,L.$Ue)(v,P.VARIABLE_REGEXP,async(l,c)=>{if(c.includes(P.VARIABLE_LHS))return l;let d=await this.o(y,l,c,k,h);return o?.set(c,d),d!==l&&f.$zf(d)&&d.match(P.VARIABLE_REGEXP)&&(d=await this.m(y,k,d,h,o)),d})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,k,v,h,o){let l;const c=v.split(":");c.length>1&&(v=c[0],l=c[1]);const d=i=>{const s=this.a.getFilePath();if(s)return(0,m.$wv)(s);throw new b.$dN(i,(0,E.localize)(0,null,k))},a=i=>{const s=d(i);if(this.a.getWorkspaceFolderPathForFile){const n=this.a.getWorkspaceFolderPathForFile();if(n)return(0,m.$wv)(n)}throw new b.$dN(i,(0,E.localize)(1,null,k,C.$nc(s)))},t=i=>{if(l){const s=this.a.getFolderUri(l);if(s)return s;throw new b.$dN(i,(0,E.localize)(2,null,k,l))}if(h)return h;throw this.a.getWorkspaceFolderCount()>1?new b.$dN(i,(0,E.localize)(3,null,k)):new b.$dN(i,(0,E.localize)(4,null,k))};switch(v){case"env":if(l){if(y.env){const i=y.env[A.$j?l.toLowerCase():l];if(f.$zf(i))return i}return""}throw new b.$dN(b.VariableKind.Env,(0,E.localize)(5,null,k));case"config":if(l){const i=this.a.getConfigurationValue(h,l);if(f.$If(i))throw new b.$dN(b.VariableKind.Config,(0,E.localize)(6,null,k,l));if(f.$Bf(i))throw new b.$dN(b.VariableKind.Config,(0,E.localize)(7,null,k,l));return i}throw new b.$dN(b.VariableKind.Config,(0,E.localize)(8,null,k));case"command":return this.p(b.VariableKind.Command,k,l,o,"command");case"input":return this.p(b.VariableKind.Input,k,l,o,"input");case"extensionInstallFolder":if(l){const i=await this.a.getExtension(l);if(!i)throw new b.$dN(b.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,k,l));return this.n(i.extensionLocation)}throw new b.$dN(b.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,k));default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,m.$wv)(this.n(t(b.VariableKind.WorkspaceFolder)));case"cwd":return h||l?(0,m.$wv)(this.n(t(b.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$wv)(C.$nc(this.n(t(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new b.$dN(b.VariableKind.UserHome,(0,E.localize)(11,null,k))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new b.$dN(b.VariableKind.LineNumber,(0,E.localize)(12,null,k))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new b.$dN(b.VariableKind.SelectedText,(0,E.localize)(13,null,k))}case"file":return d(b.VariableKind.File);case"fileWorkspaceFolder":return a(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return h||l?C.$lc(this.n(t(b.VariableKind.RelativeFile)),d(b.VariableKind.RelativeFile)):d(b.VariableKind.RelativeFile);case"relativeFileDirname":{const i=C.$mc(d(b.VariableKind.RelativeFileDirname));if(h||l){const s=C.$lc(this.n(t(b.VariableKind.RelativeFileDirname)),i);return s.length===0?".":s}return i}case"fileDirname":return C.$mc(d(b.VariableKind.FileDirname));case"fileExtname":return C.$oc(d(b.VariableKind.FileExtname));case"fileBasename":return C.$nc(d(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=C.$nc(d(b.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-C.$oc(i).length)}case"fileDirnameBasename":return C.$nc(C.$mc(d(b.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||k}case"execInstallFolder":{const i=this.a.getAppRoot();return i||k}case"pathSeparator":return C.sep;default:try{const i=l?`${v}:${l}`:v;return this.p(b.VariableKind.Unknown,k,i,o,void 0)}catch{return k}}}}p(y,k,v,h,o){if(v&&h){const l=o===void 0?h[v]:h[o+":"+v];if(typeof l=="string")return l;throw new b.$dN(y,(0,E.localize)(14,null,k))}return k}}e.$rN=P}),define(De[143],Ce([1,0,5,139]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.OpenEditorContext=e.GroupsOrder=e.$sC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$rC=void 0,e.$rC=(0,C.$Qh)("editorGroupsService");var f;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var R;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var A;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var m;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EXPAND=1]="EXPAND",k[k.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var E;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function b(k){const v=k;return(0,O.$_D)(v?.editor)&&(0,O.$_D)(v?.replacement)}e.$sC=b;var L;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var P;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function p(k){const v=k;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.$tC=p;function y(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$uC=y}),define(De[281],Ce([1,0,5,143]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$xC=e.$wC=e.$vC=void 0,e.$vC=(0,C.$Qh)("editorService"),e.$wC=-1,e.$xC=-2;function f(R){const A=R;return typeof R=="number"||(0,O.$tC)(A)}e.$yC=f}),define(De[144],Ce([1,0,5,131]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=void 0,e.$MJ=(0,C.$Rh)(O.$Xh)}),define(De[145],Ce([1,0,25,4,16,3]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R4b=e.$Q4b=e.$P4b=e.$O4b=e.$N4b=e.$M4b=void 0;class A{constructor(o,l){this.versionId=o,this.removedDueToLooping=l}}e.$M4b=A;class m{static isHostExtension(o,l,c){if(l.getExtensionDescription(o))return!1;const d=c.getExtensionDescription(o);return d?!!((d.main||d.browser)&&d.api==="none"):!1}constructor(o,l){this.j=o,this.c=new O.$Od,this.onDidChange=this.c.event,this.d=0,this.e=l,this.k()}k(){this.e.sort(k),this.f=new C.$9l,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const l=this.j.readActivationEvents(o);if(Array.isArray(l))for(let c of l)c==="onUri"&&(c=`onUri:${C.$7l.toKey(o.identifier)}`),this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,l){this.e=v(this.e,l),this.e=this.e.concat(o);const c=m.l(this.e);return this.e=v(this.e,c.map(d=>d.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,c)}static l(o){const l=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,s){this.addNode(i),this.addNode(s),this.c.has(i)?this.c.get(i).push(s):this.c.set(i,[s])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,s){const n=l.getArcs(i);for(let r=0;r<n.length;r++)if(!s.has(n[r]))return!1;return!0}getNodes(){return this.e}},c=new C.$9l;for(const i of o)if(c.set(i.identifier,i),i.extensionDependencies)for(const s of i.extensionDependencies)l.addArc(C.$7l.toKey(i.identifier),C.$7l.toKey(s));const d=new Set;l.getNodes().filter(i=>l.getArcs(i).length===0).forEach(i=>d.add(i));const a=l.getNodes().filter(i=>!d.has(i));let t;do{t=!1;for(let i=0;i<a.length;i++){const s=a[i];l.hasOnlyGoodArcs(s,d)&&(a.splice(i,1),i--,d.add(s),t=!0)}}while(t);return a.map(i=>c.get(i))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const l=this.h.get(o);return l?l.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const l=this.f.get(o);return l||void 0}getExtensionDescriptionByUUID(o){for(const l of this.g)if(l.uuid===o)return l}getExtensionDescriptionByIdOrUUID(o,l){return this.getExtensionDescription(o)??(l?this.getExtensionDescriptionByUUID(l):void 0)}}e.$N4b=m;class E{constructor(o,l){this.versionId=o,this.extensions=l}}e.$O4b=E,e.$P4b={readActivationEvents:h=>h.activationEvents};class b{constructor(o){this.d=new p,this.c=new m(o,[])}async acquireLock(o){const l=await this.d.acquire(o);return new L(this,l)}deltaExtensions(o,l,c){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(l,c)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,l){return this.c.getExtensionDescriptionByIdOrUUID(o,l)}}e.$Q4b=b;class L extends R.$Sc{constructor(o,l){super(),this.f=o,this.c=!1,this.B(l)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$R4b=L;class P{constructor(o){this.name=o,this.promise=new Promise((l,c)=>{this.c=l})}resolve(o){this.c(o)}}class p{constructor(){this.c=[],this.d=!1}async acquire(o){const l=new P(o);return this.c.push(l),this.e(),l.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let l=!0;const c=setTimeout(()=>{l&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),d=()=>{l&&(clearTimeout(c),l=!1,this.d=!1,this.e())};o.resolve((0,R.$Qc)(d))}}var y;(function(h){h[h.Builtin=0]="Builtin",h[h.User=1]="User",h[h.Dev=2]="Dev"})(y||(y={}));function k(h,o){const l=h.isBuiltin?0:h.isUnderDevelopment?2:1,c=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(l!==c)return l-c;const d=f.$gc.basename(h.extensionLocation.path),a=f.$gc.basename(o.extensionLocation.path);return d<a?-1:d>a?1:0}function v(h,o){const l=new C.$8l(o);return h.filter(c=>!l.has(c.identifier))}}),define(De[282],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.ExtHostConnectionType=void 0;var C;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[O.ENV_KEY]=this.pipeName}}e.$ym=O;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[f.ENV_KEY]="1"}}e.$zm=f;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[R.ENV_KEY]="1"}}e.$Am=R;function A(L){delete L[O.ENV_KEY],delete L[f.ENV_KEY],delete L[R.ENV_KEY]}function m(L,P){A(P),L.serialize(P)}e.$Bm=m;function E(L){if(L[O.ENV_KEY])return b(L,new O(L[O.ENV_KEY]));if(L[f.ENV_KEY])return b(L,new f);if(L[R.ENV_KEY])return b(L,new R);throw new Error("No connection information defined in environment!")}e.$Cm=E;function b(L,P){return A(L),P}}),define(De[111],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$dm=e.$cm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(O||(e.UIKind=O={}));var f;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var R;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function A(b){const L=C.$ce.alloc(1);switch(b){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.$cm=A;function m(b,L){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.$dm=m;var E;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(De[88],Ce([1,0,5,4,14,27,111,66,85,24,2,3,211]),function($e,e,C,O,f,R,A,m,E,b,L,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=e.$IM=e.$HM=void 0;let y=class extends P.$Sc{constructor(o,l){super(),this.s=o,this.t=l,this.a=this.B(new O.$Od),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$Od),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=L.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=l.createLogger(this.m,{id:E.$so,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(l.onDidChangeLogLevel(c=>{(0,f.$aj)(c)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,l,c){const d=this.getTelemetryDetails(),a=new k(l,c,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,l,c){this.f=o,this.g=l,this.c=c??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const l=Object.create(null);switch(l["common.extname"]=`${o.publisher}.${o.name}`,l["common.extversion"]=o.version,l["common.vscodemachineid"]=this.s.telemetryInfo.machineId,l["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,l["common.vscodeversion"]=this.s.version,l["common.isnewappinstall"]=v(this.s.telemetryInfo.firstSessionDate),l["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:l["common.uikind"]="web";break;case A.UIKind.Desktop:l["common.uikind"]="desktop";break;default:l["common.uikind"]="unknown"}return l["common.remotename"]=(0,m.$Wk)((0,E.$zo)(this.s.remote.authority)),l}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const l=this.getTelemetryDetails();this.r.forEach((c,d)=>{const a=c.filter(t=>!t.isDisposed);a.length===0?this.r.delete(d):this.r.set(d,a)}),this.r.forEach(c=>{for(const d of c)d.updateTelemetryEnablements(l.isUsageEnabled,l.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,l){const d=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!d)return this.r.delete(o.value),!1;let a=!1;for(const t of d)t.ignoreUnhandledExtHostErrors||(t.logError(l),a=!0);return a}};e.$HM=y,e.$HM=y=He([Be(0,R.$GM),Be(1,f.$_i)],y);class k{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,l,c,d,a,t,i){this.g=c,this.h=d,this.i=a,this.j=t,this.a=new O.$Od,this.ignoreUnhandledExtHostErrors=l?.ignoreUnhandledErrors??!1,this.b=l?.ignoreBuiltInCommonProperties??!1,this.c=l?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}}updateTelemetryEnablements(o,l){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:l},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let l="properties"in o?o.properties??{}:o;return l=(0,E.$Co)(l,[]),this.c&&(l=(0,b.$$m)(l,this.c)),this.b||(l=(0,b.$$m)(l,this.j)),"properties"in o?o.properties=l:o=l,o}k(o,l){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,l=this.mixInCommonPropsAndCleanData(l||{}),this.i||this.f?.sendEventData(o,l),this.h.trace(o,l))}logUsage(o,l){this.d.isUsageEnabled&&this.k(o,l)}logError(o,l){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,l);else{const c={name:o.name,message:o.message,stack:o.stack,cause:o.cause},d=(0,E.$Co)(c,[]),a=new Error(d.message,{cause:d.cause});a.stack=d.stack,a.name=d.name,l=this.mixInCommonPropsAndCleanData(l||{}),this.i||this.f.sendErrorData(a,l),this.h.trace("exception",l)}}get apiTelemetryLogger(){if(!this.e){const o=this,l={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(l)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$IM=k;function v(h){const o=Date.now()-new Date(h).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$JM=v,e.$KM=(0,C.$Qh)("IExtHostTelemetry")}),define(De[26],Ce([1,0,4,2,253,137,25,5]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.ActivationKind=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.ExtensionHostStartup=e.$iF=e.$hF=e.$gF=e.$fF=void 0,e.$fF=Object.freeze({identifier:new A.$7l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$gF="extensions.webWorker",e.$hF=(0,m.$Qh)("extensionService");class E{constructor(a){this.dependency=a}}e.$iF=E;var b;(function(d){d[d.EagerAutoStart=1]="EagerAutoStart",d[d.EagerManualStart=2]="EagerManualStart",d[d.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class L{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,i){this.c=a,this.d=t.slice(0),this.e=i.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$3E.createActivationEventsMap(this.d)}}set(a,t,i){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const s=[],n=[],r=[],u=[],I=P(this.d),S=P(t),$=(M,F)=>M.extensionLocation.toString()===F.extensionLocation.toString()||M.isBuiltin===F.isBuiltin||M.isUserBuiltin===F.isUserBuiltin||M.isUnderDevelopment===F.isUnderDevelopment;for(const M of this.d){const F=S.get(M.identifier);if(!F){s.push(M.identifier),I.delete(M.identifier);continue}if(!$(M,F)){s.push(M.identifier),I.delete(M.identifier);continue}}for(const M of t){const F=I.get(M.identifier);if(!F){n.push(M);continue}if(!$(F,M)){s.push(F.identifier),I.delete(F.identifier);continue}}const g=new A.$8l(this.e),w=new A.$8l(i);for(const M of this.e)w.has(M)||r.push(M);for(const M of i)g.has(M)||u.push(M);const D=R.$3E.createActivationEventsMap(n),T={versionId:a,toRemove:s,toAdd:n,addActivationEvents:D,myToRemove:r,myToAdd:u};return this.delta(T),T}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:i,myToRemove:s,myToAdd:n}=a,r=new A.$8l(t),u=new A.$8l(s);for(let I=0;I<this.d.length;I++)r.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)u.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of i)this.d.push(I);for(const I of n)this.e.push(I);return a}containsExtension(a){for(const t of this.e)if(A.$7l.equals(t,a))return!0;return!1}}e.$jF=L;function P(d){const a=new A.$9l;for(const t of d)a.set(t.identifier,t);return a}function p(d,a){return d.enabledApiProposals?d.enabledApiProposals.includes(a):!1}e.$kF=p;function y(d,a){if(!p(d,a))throw new Error(`Extension '${d.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${d.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.$lF=y;class k{constructor(a,t,i,s){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=i,this.activationReason=s}}e.$mF=k;class v{constructor(a,t){this.description=a,this.value=t}}e.$nF=v;var h;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(h||(e.ActivationKind=h={}));function o(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,f.$Io)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation,targetPlatform:d.targetPlatform,validations:[],isValid:!0}}e.$oF=o;function l(d,a){return{identifier:new A.$7l((0,f.$Go)(d.manifest.publisher,d.manifest.name)),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!!a,extensionLocation:d.location,...d.manifest,uuid:d.identifier.uuid,targetPlatform:d.targetPlatform}}e.$pF=l;class c{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$qF=c}),define(De[283],Ce([1,0,9,145,25,26,14,8]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.$Xcc=e.$Wcc=e.$Vcc=e.$Ucc=e.$Tcc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(o,l,c,d){this.startup=o,this.codeLoadingTime=l,this.activateCallTime=c,this.activateResolvedTime=d}}e.$Tcc=E;class b{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,l){return o===-1||l===-1?-1:l-o}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ucc=b;class L{constructor(o,l,c,d,a,t){this.activationFailed=o,this.activationFailedError=l,this.activationTimes=c,this.module=d,this.exports=a,this.subscriptions=t}}e.$Vcc=L;class P extends L{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wcc=P;class p extends L{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xcc=p;class y extends L{constructor(o){super(!0,o,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(o,l,c,d){this.g=d,this.a=o,this.b=l,this.c=c,this.d=new f.$9l,this.f=Object.create(null)}dispose(){for(const[o,l]of this.d)l.dispose()}async waitForActivatingExtensions(){const o=[];for(const[l,c]of this.d)o.push(c.wait());await Promise.all(o)}isActivated(o){const l=this.d.get(o);return!!(l&&l.value)}getActivatedExtension(o){const l=this.d.get(o);if(!l||!l.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return l.value}async activateByEvent(o,l){if(this.f[o])return;const c=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(c.map(d=>({id:d.identifier,reason:{startup:l,extensionId:d.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,l){const c=this.a.getExtensionDescription(o);if(!c)throw new Error(`Extension '${o}' is not known`);return this.h([{id:c.identifier,reason:l}])}async h(o){const l=o.filter(c=>!this.isActivated(c.id)).map(c=>this.j(c));await Promise.all(l.map(c=>c.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const l=this.a.getExtensionDescription(o.id);if(!l){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new y(a));return this.c.onExtensionActivationError(o.id,a,new R.$iF(o.id.value)),t}const c=[],d=typeof l.extensionDependencies>"u"?[]:l.extensionDependencies;for(const a of d){if(this.m(a))continue;const t=this.d.get(a);if(t){c.push(t);continue}if(this.l(a)){c.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:o.reason}));continue}const i=this.a.getExtensionDescription(a);if(i){if(!i.main&&!i.browser)continue;c.push(this.j({id:i.identifier,reason:o.reason}));continue}const s=l.displayName||l.identifier.value,n=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${a}'`),r=this.k(o,l.displayName,[],new y(n));return this.c.onExtensionActivationError(l.identifier,n,new R.$iF(a)),r}return this.k(o,l.displayName,c,null)}k(o,l,c,d){const a=new v(o.id,l,o.reason,c,d,this.c,this.g);return this.d.set(o.id,a),a}l(o){return O.$N4b.isHostExtension(o,this.a,this.b)}m(o){const l=this.b.getExtensionDescription(o);return l?!l.main&&!l.browser:!1}};e.$Ycc=k,e.$Ycc=k=He([Be(3,A.$$i)],k);let v=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,l,c,d,a,t,i){this.c=o,this.d=l,this.f=c,this.g=d,this.h=a,this.j=t,this.k=i,this.a=new m.$Tg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const l=this.g[o];if(l.value&&!l.value.activationFailed){this.g.splice(o,1),o--;continue}if(l.value&&l.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${l.friendlyName}' failed to activate`);c.detail=l.value.activationFailedError,this.h=new y(c),this.j.onExtensionActivationError(this.c,c,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const l=new Error;if(o&&o.name&&(l.name=o.name),o&&o.message?l.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:l.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(l.stack=o.stack),this.h=new y(l),this.b&&C.$4(o))return;this.j.onExtensionActivationError(this.c,l,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};v=He([Be(6,A.$$i)],v)}),define(De[13],Ce([1,0,19,22,162,75,80,28,158,62,97,24,17,2,32,83,133,142,139,108,68,87,281,7,26]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d,a,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$pM=e.$oM=e.MarkdownString=e.$nM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Me){function Oe(ne){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:xe,positionColumn:Qe}=ne,rt=new i.$sK(Fe-1,Ve-1),kt=new i.$sK(xe-1,Qe-1);return new i.$uK(rt,kt)}Me.to=Oe;function Se(ne){const{anchor:Fe,active:Ve}=ne;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Me.from=Se})(n||(e.Selection=n={}));var r;(function(Me){function Oe(ne){if(!ne)return;const{start:Fe,end:Ve}=ne;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Me.from=Oe;function Se(ne){if(!ne)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:xe,endColumn:Qe}=ne;return new i.$tK(Fe-1,Ve-1,xe-1,Qe-1)}Me.to=Se})(r||(e.Range=r={}));var u;(function(Me){function Oe(Se){switch(Se){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}Me.to=Oe})(u||(e.TokenType=u={}));var I;(function(Me){function Oe(ne){return new i.$sK(ne.lineNumber-1,ne.column-1)}Me.to=Oe;function Se(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Me.from=Se})(I||(e.Position=I={}));var S;(function(Me){function Oe(Fe,Ve,xe){return(0,C.$Hb)((0,C.$3b)(Fe).map(Qe=>Se(Qe,Ve,xe)))}Me.from=Oe;function Se(Fe,Ve,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:xe?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ne(Fe.scheme,Ve),pattern:he.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:xe?.isBuiltin}}function ne(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(S||(e.DocumentSelector=S={}));var $;(function(Me){function Oe(ne){switch(ne){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}Me.from=Oe;function Se(ne){switch(ne){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}Me.to=Se})($||(e.DiagnosticTag=$={}));var g;(function(Me){function Oe(ne){let Fe;return ne.code&&((0,p.$zf)(ne.code)||(0,p.$Df)(ne.code)?Fe=String(ne.code):Fe={value:String(ne.code.value),target:ne.code.target}),{...r.from(ne.range),message:ne.message,source:ne.source,code:Fe,severity:D.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(w.from),tags:Array.isArray(ne.tags)?(0,C.$Hb)(ne.tags.map($.from)):void 0}}Me.from=Oe;function Se(ne){const Fe=new i.$FK(r.to(ne),ne.message,D.to(ne.severity));return Fe.source=ne.source,Fe.code=(0,p.$zf)(ne.code)?ne.code:ne.code?.value,Fe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(w.to),Fe.tags=ne.tags&&(0,C.$Hb)(ne.tags.map($.to)),Fe}Me.to=Se})(g||(e.Diagnostic=g={}));var w;(function(Me){function Oe(ne){return{...r.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Me.from=Oe;function Se(ne){return new i.$EK(new i.$DK(ne.resource,r.to(ne)),ne.message)}Me.to=Se})(w||(e.DiagnosticRelatedInformation=w={}));var D;(function(Me){function Oe(ne){switch(ne){case i.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}Me.from=Oe;function Se(ne){switch(ne){case h.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}Me.to=Se})(D||(e.DiagnosticSeverity=D={}));var T;(function(Me){function Oe(ne){return typeof ne=="number"&&ne>=i.ViewColumn.One?ne-1:ne===i.ViewColumn.Beside?t.$xC:t.$wC}Me.from=Oe;function Se(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Se})(T||(e.ViewColumn=T={}));function M(Me){return typeof Me.range<"u"}function F(Me){return Me.length===0?!0:!!M(Me[0])}e.$nM=F;var z;(function(Me){function Oe(Qe){return Qe.map(Me.from)}Me.fromMany=Oe;function Se(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ne(Qe){let rt;if(Se(Qe)){const{language:dt,value:gt}=Qe;rt={value:"```"+dt+`
`+gt+"\n```\n"}}else i.$RK.isMarkdownString(Qe)?rt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?rt={value:Qe}:rt={value:""};const kt=Object.create(null);rt.uris=kt;const St=dt=>{try{let gt=y.URI.parse(dt,!0);gt=gt.with({query:Fe(gt.query,kt)}),kt[dt]=gt}catch{}return""},mt=new E.marked.Renderer;return mt.link=St,mt.image=dt=>typeof dt=="string"?St(A.$$j(dt).href):"",(0,E.marked)(rt.value,{renderer:mt}),rt}Me.from=ne;function Fe(Qe,rt){if(!Qe)return Qe;let kt;try{kt=(0,b.$mh)(Qe)}catch{}if(!kt)return Qe;let St=!1;return kt=(0,P.$0m)(kt,mt=>{if(y.URI.isUri(mt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[dt]=mt,St=!0,dt}else return}),St?JSON.stringify(kt):Qe}function Ve(Qe){const rt=new i.$RK(Qe.value,Qe.supportThemeIcons);return rt.isTrusted=Qe.isTrusted,rt.supportHtml=Qe.supportHtml,rt.baseUri=Qe.baseUri?y.URI.from(Qe.baseUri):void 0,rt}Me.to=Ve;function xe(Qe){if(Qe)return typeof Qe=="string"?Qe:Me.from(Qe)}Me.fromStrict=xe})(z||(e.MarkdownString=z={}));function j(Me){return F(Me)?Me.map(Oe=>({range:r.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?z.fromMany(Oe.hoverMessage):Oe.hoverMessage?z.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Me.map(Oe=>({range:r.from(Oe)}))}e.$oM=j;function N(Me){return typeof Me>"u"?Me:typeof Me=="string"?y.URI.file(Me):Me}e.$pM=N;var q;(function(Me){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?N(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Me.from=Oe})(q||(e.ThemableDecorationAttachmentRenderOptions=q={}));var K;(function(Me){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?N(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?q.from(Se.before):void 0,after:Se.after?q.from(Se.after):void 0}}Me.from=Oe})(K||(e.ThemableDecorationRenderOptions=K={}));var me;(function(Me){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Oe})(me||(e.DecorationRangeBehavior=me={}));var te;(function(Me){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?me.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?K.from(Se.light):void 0,dark:Se.dark?K.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?N(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?q.from(Se.before):void 0,after:Se.after?q.from(Se.after):void 0}}Me.from=Oe})(te||(e.DecorationRenderOptions=te={}));var G;(function(Me){function Oe(ne){return{text:ne.newText,eol:ne.newEol&&Ae.from(ne.newEol),range:r.from(ne.range)}}Me.from=Oe;function Se(ne){const Fe=new i.$yK(r.to(ne.range),ne.text);return Fe.newEol=typeof ne.eol>"u"?void 0:Ae.to(ne.eol),Fe}Me.to=Se})(G||(e.TextEdit=G={}));var J;(function(Me){function Oe(ne,Fe){const Ve={edits:[]};if(ne instanceof i.$BK){const xe=new m.$Bc;for(const Qe of ne._allEntries())Qe._type===1&&y.URI.isUri(Qe.to)&&Qe.from===void 0&&xe.add(Qe.to);for(const Qe of ne._allEntries())if(Qe._type===1){let rt;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?rt={type:"base64",value:(0,O.$we)(O.$ce.wrap(Qe.options.contents))}:rt={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ve.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:rt},metadata:Qe.metadata})}else Qe._type===2?Ve.edits.push({resource:Qe.uri,textEdit:G.from(Qe.edit),versionId:xe.has(Qe.uri)?void 0:Fe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?Ve.edits.push({resource:Qe.uri,textEdit:{range:r.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:xe.has(Qe.uri)?void 0:Fe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?Ve.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Ve.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(bt.from)}})}return Ve}Me.from=Oe;function Se(ne){const Fe=new i.$BK,Ve=new m.$Ac;for(const xe of ne.edits)if(xe.textEdit){const Qe=xe,rt=y.URI.revive(Qe.resource),kt=r.to(Qe.textEdit.range),St=Qe.textEdit.text,mt=Qe.textEdit.insertAsSnippet;let dt;mt?dt=i.$AK.replace(kt,new i.$CK(St)):dt=i.$yK.replace(kt,St);const gt=Ve.get(rt);gt?gt.push(dt):Ve.set(rt,[dt])}else Fe.renameFile(y.URI.revive(xe.oldResource),y.URI.revive(xe.newResource),xe.options);for(const[xe,Qe]of Ve)Fe.set(xe,Qe);return Fe}Me.to=Se})(J||(e.WorkspaceEdit=J={}));var le;(function(Me){const Oe=Object.create(null);Oe[i.SymbolKind.File]=0,Oe[i.SymbolKind.Module]=1,Oe[i.SymbolKind.Namespace]=2,Oe[i.SymbolKind.Package]=3,Oe[i.SymbolKind.Class]=4,Oe[i.SymbolKind.Method]=5,Oe[i.SymbolKind.Property]=6,Oe[i.SymbolKind.Field]=7,Oe[i.SymbolKind.Constructor]=8,Oe[i.SymbolKind.Enum]=9,Oe[i.SymbolKind.Interface]=10,Oe[i.SymbolKind.Function]=11,Oe[i.SymbolKind.Variable]=12,Oe[i.SymbolKind.Constant]=13,Oe[i.SymbolKind.String]=14,Oe[i.SymbolKind.Number]=15,Oe[i.SymbolKind.Boolean]=16,Oe[i.SymbolKind.Array]=17,Oe[i.SymbolKind.Object]=18,Oe[i.SymbolKind.Key]=19,Oe[i.SymbolKind.Null]=20,Oe[i.SymbolKind.EnumMember]=21,Oe[i.SymbolKind.Struct]=22,Oe[i.SymbolKind.Event]=23,Oe[i.SymbolKind.Operator]=24,Oe[i.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Me.from=Se;function ne(Fe){for(const Ve in Oe)if(Oe[Ve]===Fe)return Number(Ve);return i.SymbolKind.Property}Me.to=ne})(le||(e.SymbolKind=le={}));var ie;(function(Me){function Oe(ne){switch(ne){case i.SymbolTag.Deprecated:return 1}}Me.from=Oe;function Se(ne){switch(ne){case 1:return i.SymbolTag.Deprecated}}Me.to=Se})(ie||(e.SymbolTag=ie={}));var ce;(function(Me){function Oe(ne){return{name:ne.name,kind:le.from(ne.kind),tags:ne.tags&&ne.tags.map(ie.from),containerName:ne.containerName,location:re.from(ne.location)}}Me.from=Oe;function Se(ne){const Fe=new i.$IK(ne.name,le.to(ne.kind),ne.containerName,re.to(ne.location));return Fe.tags=ne.tags&&ne.tags.map(ie.to),Fe}Me.to=Se})(ce||(e.WorkspaceSymbol=ce={}));var ye;(function(Me){function Oe(ne){const Fe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),kind:le.from(ne.kind),tags:ne.tags?.map(ie.from)??[]};return ne.children&&(Fe.children=ne.children.map(Oe)),Fe}Me.from=Oe;function Se(ne){const Fe=new i.$JK(ne.name,ne.detail,le.to(ne.kind),r.to(ne.range),r.to(ne.selectionRange));return(0,C.$Lb)(ne.tags)&&(Fe.tags=ne.tags.map(ie.to)),ne.children&&(Fe.children=ne.children.map(Se)),Fe}Me.to=Se})(ye||(e.DocumentSymbol=ye={}));var H;(function(Me){function Oe(ne){const Fe=new i.$NK(le.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),r.to(ne.range),r.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Oe;function Se(ne,Fe,Ve){if(Fe=Fe??ne._sessionId,Ve=Ve??ne._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:ne.name,detail:ne.detail,kind:le.from(ne.kind),uri:ne.uri,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),tags:ne.tags?.map(ie.from)}}Me.from=Se})(H||(e.CallHierarchyItem=H={}));var B;(function(Me){function Oe(Se){return new i.$OK(H.to(Se.from),Se.fromRanges.map(ne=>r.to(ne)))}Me.to=Oe})(B||(e.CallHierarchyIncomingCall=B={}));var Y;(function(Me){function Oe(Se){return new i.$PK(H.to(Se.to),Se.fromRanges.map(ne=>r.to(ne)))}Me.to=Oe})(Y||(e.CallHierarchyOutgoingCall=Y={}));var re;(function(Me){function Oe(ne){return{range:ne.range&&r.from(ne.range),uri:ne.uri}}Me.from=Oe;function Se(ne){return new i.$DK(y.URI.revive(ne.uri),r.to(ne.range))}Me.to=Se})(re||(e.location=re={}));var X;(function(Me){function Oe(ne){const Fe=ne,Ve=ne;return{originSelectionRange:Fe.originSelectionRange?r.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:r.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?r.from(Fe.targetSelectionRange):void 0}}Me.from=Oe;function Se(ne){return{targetUri:y.URI.revive(ne.uri),targetRange:r.to(ne.range),targetSelectionRange:ne.targetSelectionRange?r.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?r.to(ne.originSelectionRange):void 0}}Me.to=Se})(X||(e.DefinitionLink=X={}));var _;(function(Me){function Oe(ne){return{range:r.from(ne.range),contents:z.fromMany(ne.contents)}}Me.from=Oe;function Se(ne){return new i.$GK(ne.contents.map(z.to),r.to(ne.range))}Me.to=Se})(_||(e.Hover=_={}));var x;(function(Me){function Oe(ne){return{range:r.from(ne.range),expression:ne.expression}}Me.from=Oe;function Se(ne){return new i.$zL(r.to(ne.range),ne.expression)}Me.to=Se})(x||(e.EvaluatableExpression=x={}));var pe;(function(Me){function Oe(ne){if(ne instanceof i.$AL)return{type:"text",range:r.from(ne.range),text:ne.text};if(ne instanceof i.$BL)return{type:"variable",range:r.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof i.$CL)return{type:"expression",range:r.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Oe;function Se(ne){switch(ne.type){case"text":return{range:r.to(ne.range),text:ne.text};case"variable":return{range:r.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:r.to(ne.range),expression:ne.expression}}}Me.to=Se})(pe||(e.InlineValue=pe={}));var ae;(function(Me){function Oe(ne){return{frameId:ne.frameId,stoppedLocation:r.from(ne.stoppedLocation)}}Me.from=Oe;function Se(ne){return new i.$DL(ne.frameId,r.to(ne.stoppedLocation))}Me.to=Se})(ae||(e.InlineValueContext=ae={}));var fe;(function(Me){function Oe(ne){return{range:r.from(ne.range),kind:ne.kind}}Me.from=Oe;function Se(ne){return new i.$HK(r.to(ne.range),ne.kind)}Me.to=Se})(fe||(e.DocumentHighlight=fe={}));var ee;(function(Me){function Oe(Se){switch(Se){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}Me.to=Oe})(ee||(e.CompletionTriggerKind=ee={}));var de;(function(Me){function Oe(Se){return{triggerKind:ee.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Me.to=Oe})(de||(e.CompletionContext=de={}));var be;(function(Me){function Oe(ne){switch(ne){case i.CompletionItemTag.Deprecated:return 1}}Me.from=Oe;function Se(ne){switch(ne){case 1:return i.CompletionItemTag.Deprecated}}Me.to=Se})(be||(e.CompletionItemTag=be={}));var Pe;(function(Me){const Oe=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function Se(Ve){return Oe.get(Ve)??9}Me.from=Se;const ne=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Fe(Ve){return ne.get(Ve)??i.CompletionItemKind.Property}Me.to=Fe})(Pe||(e.CompletionItemKind=Pe={}));var U;(function(Me){function Oe(Se,ne){const Fe=new i.$XK(Se.label);return Fe.insertText=Se.insertText,Fe.kind=Pe.to(Se.kind),Fe.tags=Se.tags?.map(be.to),Fe.detail=Se.detail,Fe.documentation=A.$6j(Se.documentation)?z.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,k.$xs.isIRange(Se.range)?Fe.range=r.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:r.to(Se.range.insert),replacing:r.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new i.$CK(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof i.$tK?new i.$yK(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(Ve=>G.to(Ve))),Fe.command=ne&&Se.command?ne.fromInternal(Se.command):void 0,Fe}Me.to=Oe})(U||(e.CompletionItem=U={}));var Q;(function(Me){function Oe(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:z.fromStrict(ne.documentation)}}Me.from=Oe;function Se(ne){return{label:ne.label,documentation:A.$6j(ne.documentation)?z.to(ne.documentation):ne.documentation}}Me.to=Se})(Q||(e.ParameterInformation=Q={}));var se;(function(Me){function Oe(ne){return{label:ne.label,documentation:z.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(Q.from):[],activeParameter:ne.activeParameter}}Me.from=Oe;function Se(ne){return{label:ne.label,documentation:A.$6j(ne.documentation)?z.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(Q.to):[],activeParameter:ne.activeParameter}}Me.to=Se})(se||(e.SignatureInformation=se={}));var oe;(function(Me){function Oe(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(se.from):[]}}Me.from=Oe;function Se(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(se.to):[]}}Me.to=Se})(oe||(e.SignatureHelp=oe={}));var Z;(function(Me){function Oe(Se,ne){const Fe=new i.$WK(I.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(ge.to.bind(void 0,Se)),ne.kind&&Ee.to(ne.kind));return Fe.textEdits=ne.textEdits&&ne.textEdits.map(G.to),Fe.tooltip=A.$6j(ne.tooltip)?z.to(ne.tooltip):ne.tooltip,Fe.paddingLeft=ne.paddingLeft,Fe.paddingRight=ne.paddingRight,Fe}Me.to=Oe})(Z||(e.InlayHint=Z={}));var ge;(function(Me){function Oe(Se,ne){const Fe=new i.$VK(ne.label);return Fe.tooltip=A.$6j(ne.tooltip)?z.to(ne.tooltip):ne.tooltip,v.Command.is(ne.command)&&(Fe.command=Se.fromInternal(ne.command)),ne.location&&(Fe.location=re.to(ne.location)),Fe}Me.to=Oe})(ge||(e.InlayHintLabelPart=ge={}));var Ee;(function(Me){function Oe(ne){return ne}Me.from=Oe;function Se(ne){return ne}Me.to=Se})(Ee||(e.InlayHintKind=Ee={}));var ze;(function(Me){function Oe(ne){return{range:r.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Me.from=Oe;function Se(ne){let Fe;if(ne.url)try{Fe=typeof ne.url=="string"?y.URI.parse(ne.url,!0):y.URI.revive(ne.url)}catch{}return new i.$3K(r.to(ne.range),Fe)}Me.to=Se})(ze||(e.DocumentLink=ze={}));var We;(function(Me){function Oe(ne){const Fe=new i.$6K(ne.label);return ne.textEdit&&(Fe.textEdit=G.to(ne.textEdit)),ne.additionalTextEdits&&(Fe.additionalTextEdits=ne.additionalTextEdits.map(Ve=>G.to(Ve))),Fe}Me.to=Oe;function Se(ne){return{label:ne.label,textEdit:ne.textEdit?G.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Fe=>G.from(Fe)):void 0}}Me.from=Se})(We||(e.ColorPresentation=We={}));var _e;(function(Me){function Oe(ne){return new i.$4K(ne[0],ne[1],ne[2],ne[3])}Me.to=Oe;function Se(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Me.from=Se})(_e||(e.Color=_e={}));var Ye;(function(Me){function Oe(ne){return{range:r.from(ne.range)}}Me.from=Oe;function Se(ne){return new i.$MK(r.to(ne.range))}Me.to=Se})(Ye||(e.SelectionRange=Ye={}));var it;(function(Me){function Oe(Se){switch(Se){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}Me.to=Oe})(it||(e.TextDocumentSaveReason=it={}));var tt;(function(Me){function Oe(ne){switch(ne){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Oe;function Se(ne){switch(ne){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}Me.to=Se})(tt||(e.TextEditorLineNumbersStyle=tt={}));var Ae;(function(Me){function Oe(ne){if(ne===i.EndOfLine.CRLF)return 1;if(ne===i.EndOfLine.LF)return 0}Me.from=Oe;function Se(ne){if(ne===1)return i.EndOfLine.CRLF;if(ne===0)return i.EndOfLine.LF}Me.to=Se})(Ae||(e.EndOfLine=Ae={}));var Te;(function(Me){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Oe})(Te||(e.ProgressLocation=Te={}));var qe;(function(Me){function Oe(ne){const Fe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Fe.kind=Le.from(ne.kind)),Fe}Me.from=Oe;function Se(ne){const Fe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Fe.kind=Le.to(ne.kind)),Fe}Me.to=Se})(qe||(e.FoldingRange=qe={}));var Le;(function(Me){function Oe(ne){if(ne)switch(ne){case i.FoldingRangeKind.Comment:return v.$mt.Comment;case i.FoldingRangeKind.Imports:return v.$mt.Imports;case i.FoldingRangeKind.Region:return v.$mt.Region}}Me.from=Oe;function Se(ne){if(ne)switch(ne.value){case v.$mt.Comment.value:return i.FoldingRangeKind.Comment;case v.$mt.Imports.value:return i.FoldingRangeKind.Imports;case v.$mt.Region.value:return i.FoldingRangeKind.Region}}Me.to=Se})(Le||(e.FoldingRangeKind=Le={}));var Xe;(function(Me){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?r.from(Se.selection):void 0,override:typeof Se.override=="boolean"?l.$YD.id:void 0}}Me.from=Oe})(Xe||(e.TextEditorOpenOptions=Xe={}));var he;(function(Me){function Oe(Ve){return Ve instanceof i.$nL?Ve.toJSON():typeof Ve=="string"?Ve:Se(Ve)||ne(Ve)?new i.$nL(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Me.from=Oe;function Se(Ve){const xe=Ve;return xe?y.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ne(Ve){const xe=Ve;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new i.$nL(y.URI.revive(Ve.baseUri),Ve.pattern)}Me.to=Fe})(he||(e.GlobPattern=he={}));var ue;(function(Me){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const ne=Se;return{language:ne.language,scheme:ne.scheme,pattern:he.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Me.from=Oe})(ue||(e.LanguageSelector=ue={}));var Ie;(function(Me){function Oe(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&y.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(xe=>xe instanceof i.$tK)))}Me.is=Oe;function Se(ne){return{documents:ne.documents.map(Fe=>Fe.map(Ve=>({uri:y.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(xe=>r.from(xe))})))}}Me.from=Se})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Me){function Oe(ne){return{start:ne.start,end:ne.end}}Me.from=Oe;function Se(ne){return new i.$OL(ne.start,ne.end)}Me.to=Se})(Ke||(e.NotebookRange=Ke={}));var Ue;(function(Me){function Oe(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Me.to=Oe;function Se(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Me.from=Se})(Ue||(e.NotebookCellExecutionSummary=Ue={}));var Ze;(function(Me){function Oe(Se){if(Se===c.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(Se===c.NotebookCellExecutionState.Pending)return;if(Se===c.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Me.to=Oe})(Ze||(e.NotebookCellExecutionState=Ze={}));var nt;(function(Me){function Oe(ne){switch(ne){case i.NotebookCellKind.Markup:return c.CellKind.Markup;case i.NotebookCellKind.Code:default:return c.CellKind.Code}}Me.from=Oe;function Se(ne){switch(ne){case c.CellKind.Markup:return i.NotebookCellKind.Markup;case c.CellKind.Code:default:return i.NotebookCellKind.Code}}Me.to=Se})(nt||(e.NotebookCellKind=nt={}));var ct;(function(Me){function Oe(ne){const Fe={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ve of ne.cells)i.$PL.validate(Ve),Fe.cells.push(bt.from(Ve));return Fe}Me.from=Oe;function Se(ne){const Fe=new i.$QL(ne.cells.map(bt.to));return(0,p.$Mf)(ne.metadata)||(Fe.metadata=ne.metadata),Fe}Me.to=Se})(ct||(e.NotebookData=ct={}));var bt;(function(Me){function Oe(ne){return{cellKind:nt.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:Ue.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Kt.from):[]}}Me.from=Oe;function Se(ne){return new i.$PL(nt.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Kt.to):void 0,ne.metadata,ne.internalMetadata?Ue.to(ne.internalMetadata):void 0)}Me.to=Se})(bt||(e.NotebookCellData=bt={}));var Et;(function(Me){function Oe(ne){return{mime:ne.mime,valueBytes:O.$ce.wrap(ne.data)}}Me.from=Oe;function Se(ne){return new i.$RL(ne.valueBytes.buffer,ne.mime)}Me.to=Se})(Et||(e.NotebookCellOutputItem=Et={}));var Kt;(function(Me){function Oe(ne){return{outputId:ne.id,items:ne.items.map(Et.from),metadata:ne.metadata}}Me.from=Oe;function Se(ne){const Fe=ne.items.map(Et.to);return new i.$SL(Fe,ne.outputId,ne.metadata)}Me.to=Se})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Me){function Oe(Fe){return ne(Fe)?{include:he.from(Fe.include)??void 0,exclude:he.from(Fe.exclude)??void 0}:he.from(Fe)??void 0}Me.from=Oe;function Se(Fe){return ne(Fe)?{include:he.to(Fe.include),exclude:he.to(Fe.exclude)}:he.to(Fe)}Me.to=Se;function ne(Fe){const Ve=Fe;return Ve?!(0,p.$If)(Ve.include)&&!(0,p.$If)(Ve.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var pt;(function(Me){function Oe(Se,ne,Fe){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ve,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Me.from=Oe})(pt||(e.NotebookStatusBarItem=pt={}));var zt;(function(Me){function Oe(Se,ne,Fe){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ne.toInternal(Ve,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Me.from=Oe})(zt||(e.NotebookKernelSourceAction=zt={}));var Tt;(function(Me){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Me.from=Oe})(Tt||(e.NotebookDocumentContentOptions=Tt={}));var Gt;(function(Me){function Oe(ne){return{uri:ne.uri,provides:ne.provides}}Me.from=Oe;function Se(ne){return new i.$UL(y.URI.revive(ne.uri),ne.provides)}Me.to=Se})(Gt||(e.NotebookRendererScript=Gt={}));var Ut;(function(Me){function Oe(ne){return{message:z.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:r.from(ne.location.range),uri:ne.location.uri}}}Me.from=Oe;function Se(ne){const Fe=new i.$1L(typeof ne.message=="string"?ne.message:z.to(ne.message));return Fe.actualOutput=ne.actual,Fe.expectedOutput=ne.expected,Fe.contextValue=ne.contextValue,Fe.location=ne.location?re.to(ne.location):void 0,Fe}Me.to=Se})(Ut||(e.TestMessage=Ut={}));var Dt;(function(Me){Me.namespace=a.$mJ,Me.denamespace=a.$nJ})(Dt||(e.TestTag=Dt={}));var Ft;(function(Me){function Oe(ne){const Fe=(0,o.$mM)(ne).controllerId;return{extId:d.$iJ.fromExtHostTestItem(ne,Fe).toString(),label:ne.label,uri:y.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ve=>Dt.namespace(Fe,Ve.id)),range:k.$xs.lift(r.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&z.fromStrict(ne.error)||null}}Me.from=Oe;function Se(ne){return{parent:void 0,error:void 0,id:d.$iJ.fromString(ne.extId).localId,label:ne.label,uri:y.URI.revive(ne.uri),tags:(ne.tags||[]).map(Fe=>{const{tagId:Ve}=Dt.denamespace(Fe);return new i.$2L(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:r.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Me.toPlain=Se})(Ft||(e.TestItem=Ft={})),function(Me){function Oe(ne){return{id:ne.id}}Me.from=Oe;function Se(ne){return new i.$2L(ne.id)}Me.to=Se}(Dt||(e.TestTag=Dt={}));var Bt;(function(Me){const Oe=(ne,Fe)=>{const Ve=[];for(const[Qe,rt]of Fe)d.$iJ.compare(rt.item.extId,Qe)===2&&(Fe.delete(Qe),Ve.push(rt));const xe={...Ft.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(rt=>rt.type===0).map(Ut.to)})),children:Ve.map(Qe=>Oe(Qe,Fe))};for(const Qe of xe.children)Qe.parent=xe;return xe};function Se(ne){const Fe=[],Ve=new Map;for(const xe of ne.items){Ve.set(xe.item.extId,xe);const Qe=d.$iJ.root(xe.item.extId);ne.request.targets.some(rt=>rt.controllerId===Qe&&rt.testIds.includes(xe.item.extId))&&Fe.push(xe)}return{completedAt:ne.completedAt,results:Fe.map(xe=>Oe(xe,Ve))}}Me.to=Se})(Bt||(e.TestResults=Bt={}));var Qt;(function(Me){function Oe(Ve){return{covered:Ve.covered,total:Ve.covered}}function Se(Ve){return"line"in Ve?I.from(Ve):r.from(Ve)}function ne(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Se(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Se(xe.location)})):void 0}:{type:0,count:Ve.executionCount,location:Se(Ve.location)}}Me.fromDetailed=ne;function Fe(Ve){return{uri:Ve.uri,statement:Oe(Ve.statementCoverage),branch:Ve.branchCoverage&&Oe(Ve.branchCoverage),function:Ve.functionCoverage&&Oe(Ve.functionCoverage),details:Ve.detailedCoverage?.map(ne)}}Me.fromFile=Fe})(Qt||(e.TestCoverage=Qt={}));var Wt;(function(Me){function Oe(Se){switch(Se){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}Me.to=Oe})(Wt||(e.CodeActionTriggerKind=Wt={}));var qt;(function(Me){function Oe(ne){const Fe=new i.$8L(le.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),r.to(ne.range),r.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Oe;function Se(ne,Fe,Ve){if(Fe=Fe??ne._sessionId,Ve=Ve??ne._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:le.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),tags:ne.tags?.map(ie.from)}}Me.from=Se})(qt||(e.TypeHierarchyItem=qt={}));var Nt;(function(Me){function Oe(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Me.from=Oe})(Nt||(e.ViewBadge=Nt={}));var ut;(function(Me){function Oe(Ve,xe,Qe){const rt=xe.fileData;return rt?new i.$gL(new i.$hL(rt.name,y.URI.revive(rt.uri),rt.id,(0,R.$db)(()=>Qe(rt.id)))):Ve===L.$Tr.uriList&&xe.uriListData?new i.$fL(Fe(xe.uriListData)):new i.$fL(xe.asString)}Me.to=Oe;async function Se(Ve,xe){const Qe=await xe.asString();if(Ve===L.$Tr.uriList)return{asString:Qe,fileData:void 0,uriListData:ne(Qe)};const rt=xe.asFile();return{asString:Qe,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Me.from=Se;function ne(Ve){return f.$7s.split(Ve).map(xe=>{if(xe.startsWith("#"))return xe;try{return y.URI.parse(xe)}catch{}return xe})}function Fe(Ve){return f.$7s.create(Ve.map(xe=>typeof xe=="string"?xe:y.URI.revive(xe)))}})(ut||(e.DataTransferItem=ut={}));var ft;(function(Me){function Oe(ne,Fe){const Ve=ne.items.map(([xe,Qe])=>[xe,ut.to(xe,Qe,Fe)]);return new i.$iL(Ve)}Me.toDataTransfer=Oe;async function Se(ne){const Fe={items:[]},Ve=[];for(const[xe,Qe]of ne)Ve.push((async()=>{Fe.items.push([xe,await ut.from(xe,Qe)])})());return await Promise.all(Ve),Fe}Me.from=Se})(ft||(e.DataTransfer=ft={}));var At;(function(Me){function Oe(ne){return{message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.to=Oe;function Se(ne){return{kind:"reply",message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.from=Se})(At||(e.ChatReplyFollowup=At={}));var Vt;(function(Me){function Oe(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:At.from(Se)}Me.from=Oe})(Vt||(e.ChatFollowup=Vt={}));var Rt;(function(Me){function Oe(ne){const Fe=new i.$fM(at.to(ne.role),ne.content);return Fe.name=ne.name,Fe}Me.to=Oe;function Se(ne){return{role:at.from(ne.role),content:ne.content,name:ne.name}}Me.from=Se})(Rt||(e.ChatMessage=Rt={}));var at;(function(Me){function Oe(ne){switch(ne){case 0:return i.ChatMessageRole.System;case 1:return i.ChatMessageRole.User;case 2:return i.ChatMessageRole.Assistant;case 3:return i.ChatMessageRole.Function}}Me.to=Oe;function Se(ne){switch(ne){case i.ChatMessageRole.System:return 0;case i.ChatMessageRole.Assistant:return 2;case i.ChatMessageRole.Function:return 3;case i.ChatMessageRole.User:default:return 1}}Me.from=Se})(at||(e.ChatMessageRole=at={}));var vt;(function(Me){function Oe(Fe){const Ve={};for(const xe of Object.keys(Fe))Ve[xe]=Fe[xe].map(Me.to);return Ve}Me.objectTo=Oe;function Se(Fe){return{level:Ot.to(Fe.level),value:Fe.value,description:Fe.description}}Me.to=Se;function ne(Fe){return{level:Ot.from(Fe.level),value:Fe.value,description:Fe.description}}Me.from=ne})(vt||(e.ChatVariable=vt={}));var Ot;(function(Me){function Oe(ne){switch(ne){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}Me.to=Oe;function Se(ne){switch(ne){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}Me.from=Se})(Ot||(e.ChatVariableLevel=Ot={}));var Pt;(function(Me){function Oe(Se){switch(Se){case 1:return i.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return i.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return i.InteractiveEditorResponseFeedbackKind.Undone;case 3:return i.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Oe})(Pt||(e.InteractiveEditorResponseFeedbackKind=Pt={}));var Ge;(function(Me){function Oe(Se,ne){return"placeholder"in ne&&"resolvedContent"in ne?{placeholder:ne.placeholder}:"responseId"in ne?{requestId:ne.responseId}:"markdownContent"in ne?((0,s.$lF)(Se,"chatAgents2Additions"),{content:z.from(ne.markdownContent)}):"content"in ne?typeof ne.content=="string"?ne:((0,s.$lF)(Se,"chatAgents2Additions"),{content:z.from(ne.content)}):"documents"in ne?{documents:ne.documents.map(Fe=>({uri:Fe.uri,version:Fe.version,ranges:Fe.ranges.map(Ve=>r.from(Ve))}))}:"reference"in ne?{reference:"uri"in ne.reference?{uri:ne.reference.uri,range:r.from(ne.reference.range)}:ne.reference}:"inlineReference"in ne?{inlineReference:"uri"in ne.inlineReference?{uri:ne.inlineReference.uri,range:r.from(ne.inlineReference.range)}:ne.inlineReference,title:ne.title}:("agentName"in ne&&(0,s.$lF)(Se,"chatAgents2Additions"),ne)}Me.from=Oe})(Ge||(e.ChatResponseProgress=Ge={}));var Jt;(function(Me){function Oe(Se,ne,Fe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:ne.toInternal(Se,Fe)}Me.from=Oe})(Jt||(e.TerminalQuickFix=Jt={}))}),define(De[284],Ce([1,0,2,9,7,13,76]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class m{constructor(b,L,P,p={timeout:1500,errors:3}){this.c=b,this.d=L,this.f=P,this.g=p,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(b){return(L,P,p)=>{const k={dispose:this.a.push([L,P,b])};return Array.isArray(p)&&p.push(k),k}}async $participateInSave(b,L){const P=C.URI.revive(b);let p=!1;const y=setTimeout(()=>p=!0,this.g.timeout),k=[];try{for(const v of[...this.a]){if(p)break;const h=this.d.getDocument(P),o=await this.h(v,{document:h,reason:R.TextDocumentSaveReason.to(L)});k.push(o)}}finally{clearTimeout(y)}return k}h([b,L,P],p){const y=this.b.get(b);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(P,b,L,p).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const v=this.b.get(b);this.b.set(b,v?v+1:1),typeof v=="number"&&v>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(b,L,P,p){const y=[],k=Date.now(),{document:v,reason:h}=p,{version:o}=v,l=Object.freeze({document:v,reason:h,waitUntil(c){if(Object.isFrozen(y))throw(0,O.$8)("waitUntil can not be called async");y.push(Promise.resolve(c))}});try{L.apply(P,[l])}catch(c){return Promise.reject(c)}return Object.freeze(y),new Promise((c,d)=>{const a=setTimeout(()=>d(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(a),c(t)}).catch(t=>{clearTimeout(a),d(t)})}).then(c=>{const d={edits:[]};for(const a of c)if(Array.isArray(a)&&a.every(t=>t instanceof f.$yK))for(const{newText:t,newEol:i,range:s}of a)d.edits.push({resource:v.uri,versionId:void 0,textEdit:{range:s&&R.Range.from(s),text:t,eol:i&&R.EndOfLine.from(i)}});if(d.edits.length!==0)return o===v.version?this.f.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.$Scc=m}),define(De[285],Ce([1,0,18,2,13,7,108]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=void 0;class m{constructor(P,p,y,k){this.start=P,this.deletedCount=p,this.deletedItems=y,this.items=k}asApiEvent(){return{range:new R.$OL(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(P,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,p,y){this.notebook=P,this.h=p,this.j=y,this.handle=y.handle,this.uri=O.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(f.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return P.g},set mime(k){P.g=k},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(y)}return this.f}setOutputs(P){this.a=P.map(f.NotebookCellOutput.to)}setOutputItems(P,p,y){const k=y.map(f.NotebookCellOutputItem.to),v=this.a.find(h=>h.id===P);if(v&&(p||(v.items.length=0),v.items.push(...k),v.items.length>1&&v.items.every(h=>A.$yI(h.mime)))){const h=new Map,o=[];v.items.forEach(l=>{let c;h.has(l.mime)?c=h.get(l.mime):(c=[],h.set(l.mime,c),o.push(l.mime)),c.push(l.data)}),v.items.length=0,o.forEach(l=>{const c=A.$zI(h.get(l));v.items.push({mime:l,data:c.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$6dc=E;class b{static{this.a=0}constructor(P,p,y,k,v){this.k=P,this.l=p,this.m=y,this.uri=k,this.handle=b.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=v.viewType,this.f=Object.freeze(v.metadata??Object.create(null)),this.r([[0,0,v.cells]],!0,void 0),this.g=v.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,p={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===C.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(y){return y=P.n(y),P.b[y].apiCell},getCells(y){return(y?P.p(y):P.b).map(v=>v.apiCell)},save(){return P.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,p,y){this.g=P.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:y});const k={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},v=[];for(const o of P.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,k.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,k.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),v.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),v.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),v.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?v.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),v.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),v.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const h=new Map;for(let o=0;o<v.length;o++){const l=v[o],c=h.get(l.cell);if(c===void 0){const d=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});h.set(l.cell,d-1)}else k.cellChanges[c]={...k.cellChanges[c],...l}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let p=P.start|0,y=P.end|0;return p<0&&(p=0),y>this.b.length&&(y=this.b.length),P.with({start:p,end:y})}p(P){P=this.o(P);const p=[];for(let y=P.start;y<P.end;y++)p.push(this.b[y]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,p,y){if(this.j)return;const k=[],v=[],h=[];if(P.reverse().forEach(o=>{const c=o[2].map(t=>{const i=new E(this,this.l,t);return p||v.push(E.asModelAddData(this.apiNotebook,t)),i}),d=new m(o[0],o[1],[],c),a=this.b.splice(o[0],o[1],...c);for(const t of a)h.push(t.uri),d.deletedItems.push(t.apiCell);k.push(d)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:h}),y)for(const o of k)y.push(o.asApiEvent())}s(P,p,y,k){const v=this.b.splice(P,p);this.b.splice(y,0,...v);const h=[new m(P,p,v.map(o=>o.apiCell),[]),new m(y,0,[],v)];for(const o of h)k.push(o.asApiEvent())}t(P,p){this.b[P].setOutputs(p)}u(P,p,y,k){this.b[P].setOutputItems(p,y,k)}v(P,p){const y=this.b[P];y.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(y.uri,p)}w(P,p){const y=this.b[P];y.apiCell.mime=p}x(P,p){this.b[P].setMetadata(p)}y(P,p){this.b[P].setInternalMetadata(p)}getCellFromApiCell(P){return this.b.find(p=>p.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(p=>p.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$7dc=b}),define(De[286],Ce([1,0,4,2,13,7]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class A{constructor(E,b,L,P={timeout:1500,errors:3}){this.b=E,this.c=b,this.d=L,this.f=P,this.a=new C.$Qd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(b,L,P)=>{const p=function(k){b.call(L,k)};return p.extension=E,this.a.event(p,void 0,P)}}async $participateInSave(E,b,L){const P=O.URI.revive(E),p=this.c.getNotebookDocument(P);if(!p)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:f.TextDocumentSaveReason.to(b)},L,async(v,h)=>{const o=Date.now(),l=await await Promise.resolve(v);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier),!L.isCancellationRequested&&l&&(l instanceof R.$BK?y.push(l):this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(y.length===0)return!0;const k={edits:[]};for(const v of y){const{edits:h}=f.WorkspaceEdit.from(v);k.edits=k.edits.concat(h)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$uec=A}),define(De[146],Ce([1,0,9,13,7]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,E,b,L,P,p){this.id=m,this.f=E,this.notebookData=b,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=L,this.c=p}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(E){this.selections=[E]},get selections(){return m.a},set selections(E){if(!Array.isArray(E)||!E.every(f.$OL.isNotebookRange))throw(0,C.$7)("selections");m.a=E,m.g(E)},get visibleRanges(){return m.b},revealRange(E,b){m.f.$tryRevealRange(m.id,O.NotebookRange.from(E),b??f.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(O.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$8dc=R}),define(De[287],Ce([1,0,9,4,14,13]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;let A=class{constructor(E,b){this.c=E,this.d=b,this.a=new O.$Od({onListenerError:C.$2}),this.b=new O.$Od({onListenerError:C.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,b);const L=this.d.getEditorById(E);b.visibleRanges&&L._acceptVisibleRanges(b.visibleRanges.ranges.map(R.NotebookRange.to)),b.selections&&L._acceptSelections(b.selections.selections.map(R.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:L.apiEditor,visibleRanges:L.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:L.apiEditor,selections:L.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const b in E)this.d.getEditorById(b)._acceptViewColumn(R.ViewColumn.to(E[b]))}};e.$nec=A,e.$nec=A=He([Be(0,f.$$i)],A)}),define(De[288],Ce([1,0,13,64,209,21,57,9]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class E{constructor(p){this.b=0,this.c=new Map,this.a=p}async withProgress(p,y,k){const v=this.b++,{title:h,location:o,cancellable:l}=y,c={label:(0,f.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this.a.$startProgress(v,{location:C.ProgressLocation.from(o),title:h,source:c,cancellable:l},p.isUnderDevelopment?void 0:p.identifier.value).catch(m.$2),this.d(v,k,!!l)}d(p,y,k){let v;k&&(v=new R.$Yd,this.c.set(p,v));const h=l=>{this.a.$progressEnd(l),this.c.delete(l),v?.dispose()};let o;try{o=y(new L(this.a,p),k&&v?v.token:R.CancellationToken.None)}catch(l){throw h(p),l}return o.then(l=>h(p),l=>h(p)),o}$acceptProgressCanceled(p){const y=this.c.get(p);y&&(y.cancel(),this.c.delete(p))}}e.$rdc=E;function b(P,p){return P.message=p.message,typeof p.increment=="number"&&(typeof P.increment=="number"?P.increment+=p.increment:P.increment=p.increment),P}class L extends O.$9u{constructor(p,y){super(k=>this.throttledReport(k)),this.c=p,this.d=y}throttledReport(p){this.c.$progressReport(this.d,p)}}He([(0,A.$kh)(100,(P,p)=>b(P,p),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(De[147],Ce([1,0,32,142,68,109,87,13,2]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=e.$DM=e.$CM=void 0;const b=(c,d,a,t)=>{let i=d;return{enumerable:!0,configurable:!1,get(){return i},set(s){if(!a(i,s)){const n=i;i=s,c.listener?.(t(s,n))}}}},L=(c,d)=>c===d,P={range:(c,d)=>c===d?!0:!c||!d?!1:c.isEqual(d),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(c,d)=>!(c.length!==d.length||c.some(a=>!d.find(t=>a.id===t.id)))},p=c=>d=>({op:4,update:c(d)}),y=(c,d)=>({range:(()=>{let a;const t=p(i=>({range:C.$xs.lift(m.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return a},set(i){c.listener?.({op:6}),P.range(a,i)||(a=i,c.listener?.(t(i)))}}})(),label:b(c,d,P.label,p(a=>({label:a}))),description:b(c,void 0,P.description,p(a=>({description:a}))),sortText:b(c,void 0,P.sortText,p(a=>({sortText:a}))),canResolveChildren:b(c,!1,P.canResolveChildren,a=>({op:2,state:a})),busy:b(c,!1,P.busy,p(a=>({busy:a}))),error:b(c,void 0,P.error,p(a=>({error:m.MarkdownString.fromStrict(a)||null}))),tags:b(c,[],P.tags,(a,t)=>({op:1,new:a.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),k=c=>{const d=f.$iJ.fromString(c.extId),a=new h(d.controllerId,d.localId,c.label,E.URI.revive(c.uri)||void 0);return a.range=m.Range.to(c.range||void 0),a.description=c.description||void 0,a.sortText=c.sortText||void 0,a.tags=c.tags.map(t=>m.TestTag.to({id:(0,A.$nJ)(t).tagId})),a},v=c=>{let d;for(const a of c.tests){const t=k(a.item);(0,O.$mM)(t).parent=d,d=t}return d};e.$CM=v;class h{constructor(d,a,t,i){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const s=(0,O.$lM)(this,d);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof o?void 0:s.parent}},children:{value:(0,R.$kM)(s,O.$mM,h),enumerable:!0,writable:!1},...y(s,t)})}}e.$DM=h;class o extends h{constructor(d,a){super(d,d,a,void 0),this._isRoot=!0}}e.$EM=o;class l extends R.$gM{constructor(d,a,t){super({controllerId:d,getDocumentVersion:i=>i&&t.getDocument(i)?.version,getApiFor:O.$mM,getChildren:i=>i.children,root:new o(d,a),toITestItem:m.TestItem.from})}}e.$FM=l}),define(De[148],Ce([1,0,58,9,119,13,7]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=e.$yM=e.$xM=void 0;class m{static{this.c=new f.$vM("TextEditorDecorationType")}constructor(p,y,k){const v=m.c.nextId();p.$registerTextEditorDecorationType(y.identifier,v,R.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:v,dispose(){p.$removeTextEditorDecorationType(v)}})}}e.$xM=m;class E{constructor(p,y){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,y){this.k();let k=null;if(p instanceof A.$sK)k=new A.$tK(p,p);else if(p instanceof A.$tK)k=p;else throw new Error("Unrecognized location");this.l(k,y,!1)}insert(p,y){this.k(),this.l(new A.$tK(p,p),y,!0)}delete(p){this.k();let y=null;if(p instanceof A.$tK)y=p;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(p,y,k){const v=this.c.validateRange(p);this.g.push({range:v,text:y,forceMoveMarkers:k})}setEndOfLine(p){if(this.k(),p!==A.EndOfLine.LF&&p!==A.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=p}}class b{constructor(p,y,k,v){this.c=p,this.d=y,this._accept(k),this.e=v;const h=this;this.value={get tabSize(){return h.f},set tabSize(o){h.m(o)},get indentSize(){return h.g},set indentSize(o){h.o(o)},get insertSpaces(){return h.h},set insertSpaces(o){h.q(o)},get cursorStyle(){return h.j},set cursorStyle(o){h.s(o)},get lineNumbers(){return h.k},set lineNumbers(o){h.t(o)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.insertSpaces,this.j=p.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(p.lineNumbers)}l(p){if(p==="auto")return"auto";if(typeof p=="number"){const y=Math.floor(p);return y>0?y:null}if(typeof p=="string"){const y=parseInt(p,10);return isNaN(y)?null:y>0?y:null}return null}m(p){const y=this.l(p);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const y=Math.floor(p);return y>0?y:null}if(typeof p=="string"){const y=parseInt(p,10);return isNaN(y)?null:y>0?y:null}return null}o(p){const y=this.n(p);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(p){return p==="auto"?"auto":p==="false"?!1:!!p}q(p){const y=this.p(p);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(p){this.j!==p&&(this.j=p,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}t(p){this.k!==p&&(this.k=p,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(p)})))}assign(p){const y={};let k=!1;if(typeof p.tabSize<"u"){const v=this.l(p.tabSize);v==="auto"?(k=!0,y.tabSize=v):typeof v=="number"&&this.f!==v&&(this.f=v,k=!0,y.tabSize=v)}if(typeof p.indentSize<"u"){const v=this.n(p.indentSize);v==="tabSize"?(k=!0,y.indentSize=v):typeof v=="number"&&this.g!==v&&(this.g=v,k=!0,y.indentSize=v)}if(typeof p.insertSpaces<"u"){const v=this.p(p.insertSpaces);v==="auto"?(k=!0,y.insertSpaces=v):this.h!==v&&(this.h=v,k=!0,y.insertSpaces=v)}typeof p.cursorStyle<"u"&&this.j!==p.cursorStyle&&(this.j=p.cursorStyle,k=!0,y.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.k!==p.lineNumbers&&(this.k=p.lineNumbers,k=!0,y.lineNumbers=R.TextEditorLineNumbersStyle.from(p.lineNumbers)),k&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(p,y){y.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(k)})}}e.$yM=b;class L{constructor(p,y,k,v,h,o,l,c){this.id=p,this.j=y,this.k=k,this.g=!1,this.h=new Set,this.c=h,this.d=new b(this.j,this.id,o,k),this.e=l,this.f=c;const d=this;this.value=Object.freeze({get document(){return v.value},set document(a){throw new O.$9("document")},get selection(){return d.c&&d.c[0]},set selection(a){if(!(a instanceof A.$uK))throw(0,O.$7)("selection");d.c=[a],d.l()},get selections(){return d.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof A.$uK)))throw(0,O.$7)("selections");d.c=a,d.l()},get visibleRanges(){return d.e},set visibleRanges(a){throw new O.$9("visibleRanges")},get options(){return d.d.value},set options(a){d.g||d.d.assign(a)},get viewColumn(){return d.f},set viewColumn(a){throw new O.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(d.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new E(v.value,t);return a(i),d.m(i)},insertSnippet(a,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(d.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=d.c.map(n=>R.Range.from(n));else if(t instanceof A.$sK){const{lineNumber:n,column:r}=R.Position.from(t);s=[{startLineNumber:n,startColumn:r,endLineNumber:n,endColumn:r}]}else if(t instanceof A.$tK)s=[R.Range.from(t)];else{s=[];for(const n of t)if(n instanceof A.$tK)s.push(R.Range.from(n));else{const{lineNumber:r,column:u}=R.Position.from(n);s.push({startLineNumber:r,startColumn:u,endLineNumber:r,endColumn:u})}}return y.$tryInsertSnippet(p,v.value.version,a.value,s,i)},setDecorations(a,t){const i=t.length===0;i&&!d.h.has(a.key)||(i?d.h.delete(a.key):d.h.add(a.key),d.n(()=>{if(R.$nM(t))return y.$trySetDecorations(p,a.key,R.$oM(t));{const s=new Array(4*t.length);for(let n=0,r=t.length;n<r;n++){const u=t[n];s[4*n]=u.start.line+1,s[4*n+1]=u.start.character+1,s[4*n+2]=u.end.line+1,s[4*n+3]=u.end.character+1}return y.$trySetDecorationsFast(p,a.key,s)}}))},revealRange(a,t){d.n(()=>y.$tryRevealRange(p,R.Range.from(a),t||A.TextEditorRevealType.Default))},show(a){y.$tryShowEditor(p,R.ViewColumn.from(a))},hide(){y.$tryHideEditor(p)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,C.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,C.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,C.ok)(!this.g),this.f=p}_acceptSelections(p){(0,C.ok)(!this.g),this.c=p}async l(){const p=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const y=p.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const k=y.edits.map(h=>h.range);k.sort((h,o)=>h.end.line===o.end.line?h.end.character===o.end.character?h.start.line===o.start.line?h.start.character-o.start.character:h.start.line-o.start.line:h.end.character-o.end.character:h.end.line-o.end.line);for(let h=0,o=k.length-1;h<o;h++){const l=k[h].end;if(k[h+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=y.edits.map(h=>({range:R.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,v,{setEndOfLine:typeof y.setEndOfLine=="number"?R.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$zM=L}),define(De[289],Ce([1,0,213,23,2,4,3,270,8,7,17,19,13,80,21,173,26]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;function o(d,a){if((0,L.$zf)(d))return{label:d};if(d&&typeof d=="object"&&typeof d.label=="string"){let t;return Array.isArray(d.highlights)&&(t=d.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),t=t.length?t:void 0),{label:d.label,highlights:t}}}class l extends A.$Sc{constructor(a,t,i){super(),this.f=a,this.g=t,this.h=i,this.a=new Map,this.b=new v.$Y7;function s(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:n=>s(n)?this.r(n):Array.isArray(n)&&n.length>0?n.map(r=>s(r)?this.r(r):r):n})}registerTreeDataProvider(a,t,i){const s=this.createTreeView(a,{treeDataProvider:t},i);return{dispose:()=>s.dispose()}}createTreeView(a,t,i){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],n=t.dragAndDropController?.dragMimeTypes??[],r=!!t.dragAndDropController?.handleDrag,u=!!t.dragAndDropController?.handleDrop,I=this.m(a,t,i),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:n,hasHandleDrag:r,hasHandleDrop:u,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(a,S),g={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,h.$lF)(i,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,h.$lF)(i,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(w){(0,y.$6j)(w)&&(0,h.$lF)(i,"treeViewMarkdownMessage"),I.message=w},get title(){return I.title},set title(w){I.title=w},get description(){return I.description},set description(w){I.description=w},get badge(){return I.badge},set badge(w){w!==void 0&&b.ViewBadge.isViewBadge(w)?I.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(I.badge=void 0)},reveal:(w,D)=>I.reveal(w,D),dispose:async()=>{await $,this.a.delete(a),I.dispose()}};return this.B(g),g}$getChildren(a,t){const i=this.a.get(a);return i?i.getChildren(t):Promise.reject(new m.$wE(a))}async $handleDrop(a,t,i,s,n,r,u,I){const S=this.a.get(a);if(!S)return Promise.reject(new m.$wE(a));const $=p.DataTransfer.toDataTransfer(i,async g=>(await this.f.$resolveDropFileData(a,t,g)).buffer);return u===a&&I&&await this.j($,S,I,n,r),S.onDrop($,s,n)}async j(a,t,i,s,n){const r=this.b.removeDragOperationTransfer(n);if(r)(await r)?.forEach((u,I)=>{u&&a.set(I,u)});else if(n&&t.handleDrag){const u=t.handleDrag(i,a,s);this.b.addDragOperationTransfer(n,u),await u}return a}async $handleDrag(a,t,i,s){const n=this.a.get(a);if(!n)return Promise.reject(new m.$wE(a));const r=await this.j(new b.$iL,n,t,s,i);if(!(!r||s.isCancellationRequested))return p.DataTransfer.from(r)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new m.$wE(a);return t.hasResolve}$resolve(a,t,i){const s=this.a.get(a);if(!s)throw new m.$wE(a);return s.resolveTreeItem(t,i)}$setExpanded(a,t,i){const s=this.a.get(a);if(!s)throw new m.$wE(a);s.setExpanded(t,i)}$setSelectionAndFocus(a,t,i){const s=this.a.get(a);if(!s)throw new m.$wE(a);s.setSelectionAndFocus(t,i)}$setVisible(a,t){const i=this.a.get(a);if(!i){if(!t)return;throw new m.$wE(a)}i.setVisible(t)}$changeCheckboxState(a,t){const i=this.a.get(a);if(!i)throw new m.$wE(a);i.setCheckboxState(t)}m(a,t,i){const s=this.B(new c(a,t,this.f,this.g.converter,this.h,i));return this.a.set(a,s),s}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$ydc=l;class c extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,L.$If)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,i,s,n,r){if(super(),this.I=a,this.J=i,this.L=s,this.M=n,this.N=r,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$Od),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$Od),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$Od),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$Od),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$Od),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$Od),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$Od),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$Yd,r.contributes&&r.contributes.views)for(const $ in r.contributes.views)for(const g of r.contributes.views[$])g.id===a&&(this.P=g.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let u,I;const S=R.Event.debounce(this.F.event,($,g)=>($||($={message:!1,elements:[]}),g.element!==!1&&(u||(u=new Promise(w=>I=w),this.G=this.G.then(()=>u)),Array.isArray(g.element)?$.elements.push(...g.element):$.elements.push(g.element)),g.message&&($.message=!0),$),200,!0);this.B(S(({message:$,elements:g})=>{g.length&&(this.H=this.H.then(()=>{const w=I;return u=null,this.$(g).then(()=>w())})),$&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let i=this.X(a);return i||(i=await this.Y(t)),i?i.map(s=>s.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const i=(0,L.$If)(t.select)?!0:t.select,s=(0,L.$If)(t.focus)?!1:t.focus,n=(0,L.$If)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(r=>this.W(a,r[r.length-1]).then(u=>this.J.$reveal(this.I,{item:u.item,parentChain:r.map(I=>I.item)},{select:i,focus:s,expand:n})),r=>this.M.error(r)):this.J.$reveal(this.I,void 0,{select:i,focus:s,expand:n})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=p.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const i=this.getExtensionElement(a);i&&(t?this.u.fire(Object.freeze({element:i})):this.w.fire(Object.freeze({element:i})))}setSelectionAndFocus(a,t){const i=!(0,P.$ub)(this.s,a);this.s=a;const s=this.t!==t;this.t=t,i&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async i=>{const s=this.getExtensionElement(i.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:i.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);t.forEach(i=>{i.treeItem.checkboxState=i.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(i=>[i.extensionItem,i.newState])})}async handleDrag(a,t,i){const s=[];for(const n of a){const r=this.getExtensionElement(n);r&&s.push(r)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,i),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,i){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,E.$Ng)(()=>this.g?.handleDrop?this.g.handleDrop(s,a,i):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const i=this.j.get(a);if(i){const s=this.m.get(i);if(s){const n=await this.f.resolveTreeItem(s.extensionItem,i,t)??s.extensionItem;return this.hb(n),s.item.tooltip=this.eb(n.tooltip),s.item.command=this.fb(s.disposableStore,n.command),s.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(i=>this.W(t,i[i.length-1]).then(s=>(i.push(s),i))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Ng)(()=>this.f.getParent(a))}W(a,t){const i=this.m.get(a);return i?Promise.resolve(i):(0,E.$Ng)(()=>this.f.getTreeItem(a)).then(s=>this.kb(a,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const n=this.getExtensionElement(s);if(n){const r=this.m.get(n);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const i=this.getExtensionElement(a);t=i?this.m.get(i):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new k.$Yd(this.Z.token);try{const i=a?this.m.get(a):void 0,s=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const n=await Promise.all((0,P.$Hb)(s||[]).map(async r=>{const u=await this.f.getTreeItem(r);return u&&!t.token.isCancellationRequested?this.db(r,u,i):null}));return t.token.isCancellationRequested?void 0:(0,P.$Hb)(n)}finally{t.dispose()}}$(a){if(a.some(i=>!i))return this.Z.dispose(!0),this.Z=new k.$Yd,this.tb(),this.J.$refresh(this.I);{const i=this.ab(a);if(i.length)return this.bb(i)}return Promise.resolve(void 0)}ab(a){const t=new Set,i=a.map(n=>this.m.get(n));for(const n of i)if(n&&!t.has(n.item.handle)){let r=n;for(;r&&r.parent&&i.findIndex(u=>r&&r.parent&&u&&u.item.handle===r.parent.item.handle)===-1;){const u=this.j.get(r.parent.item.handle);r=u?this.m.get(u):void 0}r&&!r.parent&&t.add(n.item.handle)}const s=[];return t.forEach(n=>{const r=this.j.get(n);if(r){const u=this.m.get(r);u&&(!u.parent||!t.has(u.parent.item.handle))&&s.push(n)}}),s}bb(a){const t={};return Promise.all(a.map(i=>this.cb(i).then(s=>{s&&(t[i]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const i=this.m.get(t);if(i)return this.rb(t),(0,E.$Ng)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const n=this.ib(t,s,i.parent);return this.pb(t,n,i,i.parent),i.dispose(),n}return null})}return Promise.resolve(null)}db(a,t,i){const s=this.ib(a,t,i);if(t.id&&this.j.has(s.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(a,s),this.qb(s,i),s}eb(a){return b.$RK.isMarkdownString(a)?p.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,i,s;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,i=a.checkboxState.tooltip,s=a.checkboxState.accessibilityInformation),{isChecked:t===b.TreeItemCheckboxState.Checked,tooltip:i,accessibilityInformation:s}}hb(a){if(!b.$dL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,i){this.hb(t);const s=this.B(new A.$Rc),n=this.kb(a,t,i),r=this.lb(t);return{item:{handle:n,parentHandle:i?i.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:r,iconDark:this.mb(t)||r,themeIcon:this.jb(t),collapsibleState:(0,L.$If)(t.collapsibleState)?b.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:i,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(a){return a.iconPath instanceof b.$lL?a.iconPath:void 0}kb(a,{id:t,label:i,resourceUri:s},n,r){if(t)return`${c.b}/${t}`;const u=o(i,this.N),I=n?n.item.handle:c.a;let S=u?u.label:s?(0,O.$tg)(s):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const $=this.m.has(a)?this.m.get(a).item.handle:void 0,g=this.X(n)||[];let w,D=0;do{if(w=`${I}/${D}:${S}`,r||!this.j.has(w)||$===w)break;D++}while(D<=g.length);return w}lb(a){if(a.iconPath&&!(a.iconPath instanceof b.$lL))return typeof a.iconPath=="string"||f.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof b.$lL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return f.URI.isUri(a)?a:f.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,i,s){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==i.item.handle&&this.j.delete(i.item.handle),this.ob(a,t);const n=this.X(s)||[],r=n.filter(u=>u.item.handle===i.item.handle)[0];r&&n.splice(n.indexOf(r),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const i of t.children){const s=this.j.get(i.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const i of t.children){const s=this.j.get(i.item.handle);s&&this.sb(s)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(De[290],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[291],Ce([1,0,225,9,38,132,105,43,25,290,135,137]),function($e,e,C,O,f,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=void 0;const p=m.$kn.as(A.$ln.JSONContribution);class y{constructor(a,t,i){this.a=a,this.b=t,this.c=i}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(f.default.Error,a)}warn(a){this.d(f.default.Warning,a)}info(a){this.d(f.default.Info,a)}}e.$_E=y;class k{static a(a){const t=new E.$8l;for(let i=0,s=a.length;i<s;i++)t.add(a[i].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new k(t,[]);if(!t||!t.length)return new k([],a);const i=this.a(a),s=this.a(t),n=t.filter(u=>!i.has(u.description.identifier)),r=a.filter(u=>!s.has(u.description.identifier));return new k(n,r)}constructor(a,t){this.added=a,this.removed=t}}e.$aF=k;class v{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=k.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,O.$1)(a)}}}e.$bF=v;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$cF={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$6l},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"*",description:C.localize(42,null),body:"*"}]}},badges:{type:"array",description:C.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(44,null)},href:{type:"string",description:C.localize(45,null)},description:{type:"string",description:C.localize(46,null)}}}},markdown:{type:"string",description:C.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$2n}},extensionPack:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$2n}},extensionKind:{description:C.localize(51,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(52,null)},{body:["workspace"],description:C.localize(53,null)},{body:["ui","workspace"],description:C.localize(54,null)},{body:["workspace","ui"],description:C.localize(55,null)},{body:[],description:C.localize(56,null)}]},capabilities:{description:C.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(60,null),C.localize(61,null),C.localize(62,null)]},description:{type:"string",markdownDescription:C.localize(63,null)}}},untrustedWorkspaces:{description:C.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(66,null),C.localize(67,null),C.localize(68,null)]},restrictedConfigurations:{description:C.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(70,null)}}}}},sponsor:{description:C.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(73,null),type:"string"},"vscode:uninstall":{description:C.localize(74,null),type:"string"}}},icon:{type:"string",description:C.localize(75,null)},l10n:{type:"string",description:C.localize(76,null)},pricing:{type:"string",markdownDescription:C.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new v(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&P.$3E.register(a.extensionPoint,a.activationEventsGenerator),e.$cF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,p.registerSchema(o,e.$cF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$dF=l;const c={ExtensionsRegistry:"ExtensionsRegistry"};m.$kn.add(c.ExtensionsRegistry,new l),e.$eF=m.$kn.as(c.ExtensionsRegistry),p.registerSchema(o,e.$cF),p.registerSchema(L.$rj,{properties:{extensionEnabledApiProposals:{description:C.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}}]}}}})}),define(De[292],Ce([1,0,222,17,24,291,42,4]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var b;(function(p){function y(k,v,h){if(!k)return;const o=O.$zf(k.type)?k.type:void 0;if(!o||o.length===0){h.error(C.localize(3,null));return}const l=[];if(Array.isArray(k.required))for(const c of k.required)O.$zf(c)&&l.push(c);return{extensionId:v.value,taskType:o,required:l,properties:k.properties?f.$8m(k.properties):{},when:k.when?A.$Oi.deserialize(k.when):void 0}}p.from=y})(b||(b={}));const L=R.$eF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,y)=>{for(const k of p)k.type&&y.push(`onTaskType:${k.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:E}});class P{constructor(){this.d=new m.$Od,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,k)=>{L.setHandler((v,h)=>{this.c=void 0;try{for(const o of h.removed){const l=o.value;for(const c of l)this.a&&c.type&&this.a[c.type]&&delete this.a[c.type]}for(const o of h.added){const l=o.value;for(const c of l){const d=b.from(c,o.description.identifier,o.collector);d&&(this.a[d.taskType]=d)}}(h.removed.length>0||h.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const k of this.all()){const v={type:"object",additionalProperties:!1};k.required.length>0&&(v.required=k.required.slice(0)),k.properties!==void 0?v.properties=f.$8m(k.properties):v.properties=Object.create(null),v.properties.type={type:"string",enum:[k.taskType]},y.push(v)}this.c={oneOf:y}}return this.c}}e.$VF=new P}),define(De[293],Ce([1,0,223,17,23,24,42,292]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$6F=e.JsonSchemaVersion=e.ExecutionEngine=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$ZF=e.ShellQuoting=e.$YF=e.$XF=e.$WF=void 0,e.$WF="settings",e.$XF=new A.$8i("taskRunning",!1,C.localize(0,null)),e.$YF={value:C.localize(1,null),original:"Tasks"};var E;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$ZF="$customized",function(j){function N(q){if(!q)return j.Strong;switch(q.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=N}(E||(e.ShellQuoting=E={}));var b;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(b||(e.CommandOptions=b={}));var L;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(L||(e.RevealKind=L={})),function(j){function N(q){switch(q.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=N}(L||(e.RevealKind=L={}));var P;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(j){function N(q){switch(q.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=N}(P||(e.RevealProblemKind=P={}));var p;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(p||(e.PanelKind=p={})),function(j){function N(q){switch(q.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=N}(p||(e.PanelKind=p={}));var y;(function(j){j.defaults={echo:!0,reveal:L.Always,revealProblems:P.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var k;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(j){function N(K){switch(K.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=N;function q(K){switch(K){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=q}(k||(e.RuntimeType=k={}));var v;(function(j){function N(q){return O.$zf(q)?q:q.value}j.value=N})(v||(e.CommandString=v={}));var h;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function N(K){return K===j.Clean._id||K===j.Build._id||K===j.Rebuild._id||K===j.Test._id}j.is=N;function q(K){if(K!==void 0)return O.$zf(K)?N(K)?{_id:K,isDefault:!1}:void 0:K}j.from=q})(h||(e.TaskGroup=h={}));var o;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var l;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function N(q){switch(q){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=N})(l||(e.TaskSourceKind=l={}));var c;(function(j){j.parallel="parallel",j.sequence="sequence"})(c||(e.DependsOrder=c={}));var d;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(d||(e.RunOnOptions=d={}));var a;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:d.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(N,q,K,me,te,G){this._label="",this._id=N,q&&(this._label=q),K&&(this.type=K),this.runOptions=me,this.configurationProperties=te,this._source=G}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,q=!1){if(N===void 0)return!1;if(O.$zf(N))return N===this._label||N===this.configurationProperties.identifier||q&&N===this._id;const K=this.getDefinition(!0);return K!==void 0&&K._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$1F=t;class i extends t{constructor(N,q,K,me,te,G,J,le){super(N,K,void 0,J,le,q),this.command={},this._source=q,this.hasDefinedMatchers=G,te&&(this.command=te)}clone(){return new i(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let q;switch(this.command?this.command.runtime:void 0){case k.Shell:q="shell";break;case k.Process:q="process";break;case k.CustomExecution:q="customExecution";break;case void 0:q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:q,_key:this._id,id:this._id}}}static is(N){return N instanceof i}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===l.User?e.$WF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let q=this.configurationProperties.identifier;this._source.kind!==l.Workspace&&(q+=this._source.kind);const K={type:e.$ZF,folder:N,id:q};return JSON.stringify(K)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$tg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new i(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$2F=i;class s extends t{constructor(N,q,K,me,te,G,J){super(N,K,me,G,J,q),this._source=q,this.configures=te}static is(N){return N instanceof s}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$tg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===l.User?e.$WF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let q=this.configurationProperties.identifier;this._source.kind!==l.Workspace&&(q+=this._source.kind);const K={type:e.$ZF,folder:N,id:q};return JSON.stringify(K)}}e.$3F=s;class n extends t{constructor(N,q,K,me,te,G,J,le,ie){super(N,K,me,le,ie,q),this.defines=te,this.hasDefinedMatchers=J,this.command=G,this.icon=ie.icon,this.hide=ie.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof n}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new n(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$4F=n;class r extends t{constructor(N,q,K,me,te,G){super(N,K,me,te,G,q),this._source=q}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new r(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$5F=r;var u;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(u||(e.ExecutionEngine=u={})),function(j){j._default=j.Terminal}(u||(e.ExecutionEngine=u={}));var I;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class S{constructor(N){this.c=new Map;for(let q=0;q<N.length;q++)this.c.set(N[q].uri.toString(),q)}compare(N,q){const K=N.getWorkspaceFolder(),me=q.getWorkspaceFolder();if(K&&me){let te=this.c.get(K.uri.toString());te=te===void 0?0:te+1;let G=this.c.get(me.uri.toString());return G=G===void 0?0:G+1,te===G?N._label.localeCompare(q._label):te-G}else return!K&&me?-1:K&&!me?1:0}}e.$6F=S;var $;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})($||(e.TaskEventKind=$={}));var g;(function(j){j.SingleRun="singleRun",j.Background="background"})(g||(e.TaskRunType=g={}));var w;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var D;(function(j){function N(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function q(le,ie,ce){return{...N(le),kind:"start",terminalId:ie,resolvedVariables:ce}}j.start=q;function K(le,ie,ce){return{...N(le),kind:"processStarted",terminalId:ie,processId:ce}}j.processStarted=K;function me(le,ie,ce){return{...N(le),kind:"processEnded",terminalId:ie,exitCode:ce}}j.processEnded=me;function te(le,ie,ce){return{...N(le),kind:"terminated",exitReason:ce,terminalId:ie}}j.terminated=te;function G(le,ie,ce){return{...N(ie),kind:le,terminalId:ce}}j.general=G;function J(){return{kind:"changed"}}j.changed=J})(D||(e.TaskEvent=D={}));var T;(function(j){function N(K){const me=Object.keys(K).sort();let te="";for(const G of me){let J=K[G];J instanceof Object?J=N(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),te+=G+","+J+","}return te}function q(K){const te={_key:N(K),type:K.taskType};return Object.assign(te,K),te}j.create=q})(T||(e.KeyedTaskIdentifier=T={}));var M;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection"})(M||(e.TaskSettingId=M={}));var F;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var z;(function(j){function N(q,K){const me=m.$VF.get(q.type);if(me===void 0){const le=R.$8m(q);return delete le._key,T.create(le)}const te=Object.create(null);te.type=me.taskType;const G=new Set;me.required.forEach(le=>G.add(le));const J=me.properties;for(const le of Object.keys(J)){const ie=q[le];if(ie!=null)te[le]=ie;else if(G.has(le)){const ce=J[le];if(ce.default!==void 0)te[le]=R.$8m(ce.default);else switch(ce.type){case"boolean":te[le]=!1;break;case"number":case"integer":te[le]=0;break;case"string":te[le]="";break;default:K.error(C.localize(2,null,JSON.stringify(q,void 0,0),le));return}}}return T.create(te)}j.createTaskIdentifier=N})(z||(e.TaskDefinition=z={}))}),define(De[294],Ce([1,0,9]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T4b=e.$S4b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,m)=>{this.b=A,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,C.$1)(A))}then(A,m){return this.j().then(A,m)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$S4b=O;class f extends O{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$T4b=f}),define(De[69],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=void 0;class C{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++C.count}}e.$rv=C;const O=[];function f(m){const E=new C(m);return O[E.nid]=E,E}e.$sv=f;function R(m){return O[m].sid}e.$tv=R;class A{constructor(E){this.value=E}}e.$uv=A}),define(De[6],Ce([1,0,69]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=e.$pK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$oK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var f;(function(v){v[v.UnknownInput=0]="UnknownInput",v[v.TextInput=1]="TextInput",v[v.TextDiffInput=2]="TextDiffInput",v[v.TextMergeInput=3]="TextMergeInput",v[v.NotebookInput=4]="NotebookInput",v[v.NotebookDiffInput=5]="NotebookDiffInput",v[v.CustomEditorInput=6]="CustomEditorInput",v[v.WebviewEditorInput=7]="WebviewEditorInput",v[v.TerminalEditorInput=8]="TerminalEditorInput",v[v.InteractiveEditorInput=9]="InteractiveEditorInput"})(f||(e.TabInputKind=f={}));var R;(function(v){v[v.TAB_OPEN=0]="TAB_OPEN",v[v.TAB_CLOSE=1]="TAB_CLOSE",v[v.TAB_UPDATE=2]="TAB_UPDATE",v[v.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var A;(function(v){v[v.Editable=0]="Editable",v[v.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var m;(function(v){v[v.Int8Array=1]="Int8Array",v[v.Uint8Array=2]="Uint8Array",v[v.Uint8ClampedArray=3]="Uint8ClampedArray",v[v.Int16Array=4]="Int16Array",v[v.Uint16Array=5]="Uint16Array",v[v.Int32Array=6]="Int32Array",v[v.Uint32Array=7]="Uint32Array",v[v.Float32Array=8]="Float32Array",v[v.Float64Array=9]="Float64Array",v[v.BigInt64Array=10]="BigInt64Array",v[v.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var E;(function(v){v[v.Text=1]="Text",v[v.Error=2]="Error",v[v.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var b;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var L;(function(v){v[v.None=0]="None",v[v.Process=1]="Process",v[v.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class P{static{this.a=0}static mixin(h){return h._id=P.a++,h}}e.$oK=P;var p;(function(v){v.label="a",v.kind="b",v.detail="c",v.documentation="d",v.sortText="e",v.filterText="f",v.preselect="g",v.insertText="h",v.insertTextRules="i",v.range="j",v.commitCharacters="k",v.additionalTextEdits="l",v.kindModifier="m",v.commandIdent="n",v.commandId="o",v.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var y;(function(v){v.defaultRanges="a",v.completions="b",v.isIncomplete="c",v.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var k;(function(v){v[v.Workspace=0]="Workspace",v[v.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$pK={MainThreadAuthentication:(0,C.$sv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$sv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$sv)("MainThreadChatProvider"),MainThreadChatAgents:(0,C.$sv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,C.$sv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$sv)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$sv)("MainThreadClipboard"),MainThreadCommands:(0,C.$sv)("MainThreadCommands"),MainThreadComments:(0,C.$sv)("MainThreadComments"),MainThreadConfiguration:(0,C.$sv)("MainThreadConfiguration"),MainThreadConsole:(0,C.$sv)("MainThreadConsole"),MainThreadDebugService:(0,C.$sv)("MainThreadDebugService"),MainThreadDecorations:(0,C.$sv)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$sv)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$sv)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$sv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$sv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$sv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$sv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$sv)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$sv)("MainThreadErrors"),MainThreadTreeViews:(0,C.$sv)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$sv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$sv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$sv)("MainThreadLanguages"),MainThreadLogger:(0,C.$sv)("MainThreadLogger"),MainThreadMessageService:(0,C.$sv)("MainThreadMessageService"),MainThreadOutputService:(0,C.$sv)("MainThreadOutputService"),MainThreadProgress:(0,C.$sv)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$sv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$sv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$sv)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$sv)("MainThreadSecretState"),MainThreadStorage:(0,C.$sv)("MainThreadStorage"),MainThreadSpeech:(0,C.$sv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$sv)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$sv)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$sv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$sv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$sv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$sv)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$sv)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$sv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$sv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$sv)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$sv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$sv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$sv)("MainThreadExtensionService"),MainThreadSCM:(0,C.$sv)("MainThreadSCM"),MainThreadSearch:(0,C.$sv)("MainThreadSearch"),MainThreadShare:(0,C.$sv)("MainThreadShare"),MainThreadTask:(0,C.$sv)("MainThreadTask"),MainThreadWindow:(0,C.$sv)("MainThreadWindow"),MainThreadLabelService:(0,C.$sv)("MainThreadLabelService"),MainThreadNotebook:(0,C.$sv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$sv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$sv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$sv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$sv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$sv)("MainThreadInteractive"),MainThreadChat:(0,C.$sv)("MainThreadChat"),MainThreadInlineChat:(0,C.$sv)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$sv)("MainThreadTheming"),MainThreadTunnelService:(0,C.$sv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$sv)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$sv)("MainThreadTimeline"),MainThreadTesting:(0,C.$sv)("MainThreadTesting"),MainThreadLocalization:(0,C.$sv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$sv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$sv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$sv)("MainThreadIssueReporter")},e.$qK={ExtHostCommands:(0,C.$sv)("ExtHostCommands"),ExtHostConfiguration:(0,C.$sv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$sv)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$sv)("ExtHostDebugService"),ExtHostDecorations:(0,C.$sv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$sv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$sv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$sv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$sv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$sv)("ExtHostEditors"),ExtHostTreeViews:(0,C.$sv)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$sv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$sv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$sv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$sv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$sv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$sv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$sv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$sv)("ExtHostStatusBar"),ExtHostShare:(0,C.$sv)("ExtHostShare"),ExtHostExtensionService:(0,C.$sv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$sv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$sv)("ExtHostTerminalService"),ExtHostSCM:(0,C.$sv)("ExtHostSCM"),ExtHostSearch:(0,C.$sv)("ExtHostSearch"),ExtHostTask:(0,C.$sv)("ExtHostTask"),ExtHostWorkspace:(0,C.$sv)("ExtHostWorkspace"),ExtHostWindow:(0,C.$sv)("ExtHostWindow"),ExtHostWebviews:(0,C.$sv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$sv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$sv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$sv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$sv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$sv)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$sv)("ExtHostProgress"),ExtHostComments:(0,C.$sv)("ExtHostComments"),ExtHostSecretState:(0,C.$sv)("ExtHostSecretState"),ExtHostStorage:(0,C.$sv)("ExtHostStorage"),ExtHostUrls:(0,C.$sv)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$sv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$sv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$sv)("ExtHostOutputService"),ExtHosLabelService:(0,C.$sv)("ExtHostLabelService"),ExtHostNotebook:(0,C.$sv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$sv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$sv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$sv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$sv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$sv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$sv)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$sv)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$sv)("ExtHostChat"),ExtHostChatAgents:(0,C.$sv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,C.$sv)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$sv)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$sv)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$sv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,C.$sv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$sv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$sv)("ExtHostTheming"),ExtHostTunnelService:(0,C.$sv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$sv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$sv)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$sv)("ExtHostTimeline"),ExtHostTesting:(0,C.$sv)("ExtHostTesting"),ExtHostTelemetry:(0,C.$sv)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$sv)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$sv)("ExtHostIssueReporter")}}),define(De[295],Ce([1,0,6,7]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;class f{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$pK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,m,E){if(this.a.size===0)throw new Error("No related information providers registered");const b=this.a.get(A);if(!b)throw new Error("related information provider not found");return await b.provideRelatedInformation(m,E)??[]}getRelatedInformation(A,m,E){return this.c.$getAiRelatedInformation(m,E)}registerRelatedInformationProvider(A,m,E){const b=this.b;return this.b++,this.a.set(b,E),this.c.$registerAiRelatedInformationProvider(b,m),new O.$rK(()=>{this.c.$unregisterAiRelatedInformationProvider(b),this.a.delete(b)})}}e.$Aec=f}),define(De[89],Ce([1,0,5,14,6,20]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=e.$Dcc=e.$Ccc=void 0,e.$Ccc=(0,C.$Qh)("IExtHostApiDeprecationService");let A=class{constructor(E,b){this.c=b,this.a=new Set,this.b=E.getProxy(f.$pK.MainThreadTelemetry)}report(E,b,L){const P=this.d(E,b);this.a.has(P)||(this.a.add(P),b.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:b.identifier.value,apiId:E}))}d(E,b){return`${E}-${b.identifier.value}`}};e.$Dcc=A,e.$Dcc=A=He([Be(0,R.$qM),Be(1,O.$$i)],A),e.$Ecc=Object.freeze(new class{report(m,E,b){}})}),define(De[296],Ce([1,0,4,6,7,25]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class A{constructor(b){this.b=new Map,this.c=[],this.d=new C.$Od,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=b.getProxy(O.$pK.MainThreadAuthentication)}$setProviders(b){return this.c=b,Promise.resolve()}async getSession(b,L,P,p={}){const y=R.$7l.toKey(b.identifier),k=[...P].sort().join(" ");return await this.f.getOrCreate(`${y} ${L} ${k}`,async()=>{await this.a.$ensureProvider(L);const v=b.displayName||b.name;return this.a.$getSession(L,P,y,v,p)})}async getSessions(b,L,P){const p=R.$7l.toKey(b.identifier),y=[...P].sort().join(" ");return await this.g.getOrCreate(`${p} ${y}`,async()=>{await this.a.$ensureProvider(L);const k=b.displayName||b.name;return this.a.$getSessions(L,P,p,k)})}async removeSession(b,L){const P=this.b.get(b);return P?P.provider.removeSession(L):this.a.$removeSession(b,L)}registerAuthenticationProvider(b,L,P,p){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:L,provider:P,options:p??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===b)||this.c.push({id:b,label:L});const y=P.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(b,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(b,L,p?.supportsMultipleAccounts??!1),new f.$rK(()=>{y.dispose(),this.b.delete(b);const k=this.c.findIndex(v=>v.id===b);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,L,P){const p=this.b.get(b);if(p)return Promise.resolve(p.provider.createSession(L,P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,L){const P=this.b.get(b);if(P)return Promise.resolve(P.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,L){const P=this.b.get(b);if(P)return Promise.resolve(P.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,L){return this.d.fire({provider:{id:b,label:L}}),Promise.resolve()}}e.$$dc=A;class m{constructor(){this.a=new Map}getOrCreate(b,L){const P=this.a.get(b);if(P)return P;const p=L().finally(()=>this.a.delete(b));return this.a.set(b,p),p}}}),define(De[297],Ce([1,0,6,20,13]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;let R=class{constructor(m,E){this.a=m.getProxy(C.$pK.MainThreadBulkEdits),this.b={getTextDocumentVersion:b=>E.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,b){const L=f.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,b?.isRefactoring??!1)}};e.$eec=R,e.$eec=R=He([Be(0,O.$qM)],R)}),define(De[298],Ce([1,0,8,4,51,3,35,202,6,13]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;class L{static{this.a=0}constructor(y,k){this.extension=y,this.provider=k,this.handle=L.a++}}class P{static{this.a=0}constructor(y,k){this.h=k,this.b=new Map,this.d=new Map,this.e=new O.$Od,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$pK.MainThreadChat)}registerChatProvider(y,k,v){const h=new L(y,v);return this.b.set(h.handle,h),this.g.$registerChatProvider(h.handle,k),(0,R.$Qc)(()=>{this.g.$unregisterChatProvider(h.handle),this.b.delete(h.handle)})}transferChatSession(y,k){const v=f.Iterable.find(this.d.keys(),h=>this.d.get(h)===y)??0;typeof v=="number"&&this.g.$transferChatSession(v,k)}sendInteractiveRequestToProvider(y,k){this.g.$sendRequestToProvider(y,k)}async $prepareChat(y,k,v){const h=this.b.get(y);if(!h)return;const o=await h.provider.prepareSession(k,v);if(!o)return;const l=P.a++;return this.d.set(l,o),{id:l,requesterUsername:o.requester?.name,requesterAvatarIconUri:o.requester?.icon,responderUsername:o.responder?.name,responderAvatarIconUri:o.responder?.icon,inputPlaceholder:o.inputPlaceholder}}async $provideWelcomeMessage(y,k){const v=this.b.get(y);if(!v||!v.provider.provideWelcomeMessage)return;const h=await v.provider.provideWelcomeMessage(k);if(h)return h.map(o=>typeof o=="string"?o:Array.isArray(o)?o.map(l=>b.ChatReplyFollowup.from(l)):b.MarkdownString.from(o))}async $provideFollowups(y,k,v){const h=this.b.get(y);if(!h)return;const o=this.d.get(k);return!o||!h.provider.provideFollowups?void 0:(await h.provider.provideFollowups(o,v))?.map(c=>b.ChatFollowup.from(c))}async $provideSampleQuestions(y,k){const v=this.b.get(y);if(!v||!v.provider.provideSampleQuestions)return;const h=await v.provider.provideSampleQuestions(k);if(h)return h?.map(o=>b.ChatReplyFollowup.from(o))}$removeRequest(y,k,v){const h=this.b.get(y);if(!h)return;const o=this.d.get(k);o&&h.provider.removeRequest&&h.provider.removeRequest(o,v)}async $provideReply(y,k,v,h){const o=this.b.get(y);if(!o)return;const l=this.d.get(k);if(!l)return;const c={session:l,message:v.message,variables:{}};if(v.variables)for(const n of Object.keys(v.variables))c.variables[n]=v.variables[n].map(b.ChatVariable.to);const d=A.$Kd.create(!1);let a;const t={report:n=>{if(h.isCancellationRequested)return;typeof a>"u"&&(a=d.elapsed());const r=b.ChatResponseProgress.from(o.extension,n);if("placeholder"in n&&"resolvedContent"in n){const u=Promise.all([this.g.$acceptResponseProgress(y,k,r),n.resolvedContent]);(0,C.$Jg)(u,h).then(I=>{if(!I)return;const[S,$]=I;this.g.$acceptResponseProgress(y,k,$,S??void 0)})}else this.g.$acceptResponseProgress(y,k,r)}};let i;try{i=await o.provider.provideResponseWithProgress(c,t,h),i||(i={errorDetails:{message:(0,m.localize)(0,null)}})}catch(n){i={errorDetails:{message:(0,m.localize)(1,null,n.message),responseIsIncomplete:!0}},this.h.error(n)}try{if(l.saveState&&this.d.has(k)){const n=l.saveState();this.g.$acceptChatState(k,n)}}catch(n){this.h.warn(n)}const s={firstProgress:a??0,totalElapsed:d.elapsed()};return{errorDetails:i.errorDetails,timings:s}}async $provideSlashCommands(y,k,v){const h=this.b.get(y);if(!h)return;const o=this.d.get(k);return!o||!h.provider.provideSlashCommands?void 0:(await h.provider.provideSlashCommands(o,v))?.map(c=>({...c,kind:b.CompletionItemKind.from(c.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$sec=P}),define(De[299],Ce([1,0,8,3,64,6,13,7]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;class E{static{this.a=0}constructor(P,p,y){this.d=p,this.e=y,this.b=new Map,this.c=P.getProxy(R.$pK.MainThreadChatAgents)}registerAgent(P,p,y,k){const v=E.a++;return this.b.set(v,{extension:P,agent:y}),this.c.$registerAgent(v,p,k),(0,O.$Qc)(()=>{this.c.$unregisterAgent(v),this.b.delete(v)})}async $invokeAgent(P,p,y,k,v){const h=this.b.get(P);if(!h){this.e.warn(`[CHAT](${P}) CANNOT invoke agent because the agent is not registered`);return}let o=!1;function l(){if(o)throw new Error("Only valid while executing the command")}const c=new C.$dh;v.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),10*1e3),this.d.allowListExtensionWhile(h.extension,c.p);const d=h.agent({role:m.ChatMessageRole.User,content:y},{history:k.history.map(A.ChatMessage.to)},new f.$9u(a=>{l(),this.c.$handleProgressChunk(p,{content:b(a.message)?a.message:a.message.value})}),v);try{return await(0,C.$Jg)(Promise.resolve(d).then(a=>{if(a&&"followUp"in a)return{followUp:a?.followUp?.map(i=>A.ChatFollowup.from(i))}}),v)}finally{o=!0,c.complete()}}}e.$Cec=E;function b(L){return!!L&&typeof L=="object"&&"treeData"in L}}),define(De[300],Ce([1,0,8,21,41,4,35,17,2,203,64,6,13,7,271,26]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;class h{static{this.a=0}constructor(c,d,a){this.i=d,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=c.getProxy(P.$pK.MainThreadChatAgents2)}createChatAgent(c,d,a){const t=h.a++,i=new o(c,d,this.d,t,a);return this.b.set(t,i),this.d.$registerAgent(t,d,{}),i.apiAgent}async $invokeAgent(c,d,a,t,i,s){this.g.delete(d);const n=this.b.get(c);if(!n)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let r=!1;function u(){if(r)throw new Error("Only valid while executing the command")}const I=new C.$dh;s.onCancellationRequested(()=>I.complete()),setTimeout(()=>I.complete(),10*1e3),this.i.allowListExtensionWhile(n.extension.identifier,I.p);const S=t.command?await n.validateSlashCommand(t.command):void 0,$=A.$Kd.create(!1);let g;try{const w=n.invoke({prompt:t.message,variables:p.ChatVariable.objectTo(t.variables),slashCommand:S},{history:i.history.map(p.ChatMessage.to)},new L.$9u(D=>{u(),typeof g>"u"&&"content"in D&&(g=$.elapsed());const T=p.ChatResponseProgress.from(n.extension,D);if("placeholder"in D&&"resolvedContent"in D){const M=Promise.all([this.d.$handleProgressChunk(a,T),D.resolvedContent]);(0,C.$Jg)(M,s).then(F=>{if(!F)return;const[z,j]=F;this.d.$handleProgressChunk(a,j,z??void 0)})}else this.d.$handleProgressChunk(a,T)}),s);return await(0,C.$Jg)(Promise.resolve(w).then(D=>{if(D){this.g.set(d,D);let T=this.h.get(d);T||(T=new Map,this.h.set(d,T)),T.set(a,D);const M={firstProgress:g,totalElapsed:$.elapsed()};return{errorDetails:D.errorDetails,timings:M}}else this.g.delete(d)}),s)}catch(w){return this.j.error(w,n.extension),{errorDetails:{message:(0,b.localize)(0,null,(0,f.$Bi)(w)),responseIsIncomplete:!0}}}finally{r=!0,I.complete()}}$releaseSession(c){this.g.delete(c),this.h.delete(c)}async $provideSlashCommands(c,d){const a=this.b.get(c);return a?a.provideSlashCommand(d):[]}$provideFollowups(c,d,a){const t=this.b.get(c);if(!t)return Promise.resolve([]);const i=this.g.get(d);return i?t.provideFollowups(i,a):Promise.resolve([])}$acceptFeedback(c,d,a,t){const i=this.b.get(c);if(!i)return;const s=this.h.get(d)?.get(a);if(!s)return;let n;switch(t){case k.InteractiveSessionVoteDirection.Down:n=y.ChatAgentResultFeedbackKind.Unhelpful;break;case k.InteractiveSessionVoteDirection.Up:n=y.ChatAgentResultFeedbackKind.Helpful;break}i.acceptFeedback(Object.freeze({result:s,kind:n}))}$acceptAction(c,d,a,t){const i=this.b.get(c);if(!i)return;const s=this.h.get(d)?.get(a);s&&t.action.kind!=="vote"&&i.acceptAction(Object.freeze({action:t.action,result:s}))}}e.$Dec=h;class o{constructor(c,d,a,t,i){this.extension=c,this.n=d,this.o=a,this.q=t,this.r=i,this.l=new R.$Od,this.m=new R.$Od}acceptFeedback(c){this.l.fire(c)}acceptAction(c){this.m.fire(c)}async validateSlashCommand(c){this.b||(await this.provideSlashCommand(O.CancellationToken.None),(0,m.$Jf)(this.b));const d=this.b.find(a=>a.name===c);if(!d)throw new Error(`Unknown slashCommand: ${c}`);return d}async provideSlashCommand(c){if(!this.a)return[];const d=await this.a.provideSlashCommands(c);return d?(this.b=d,d.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate}))):[]}async provideFollowups(c,d){if(!this.d)return[];const a=await this.d.provideFollowups(c,d);return a?a.map(t=>p.ChatFollowup.from(t)):[]}get apiAgent(){let c=!1,d=!1;const a=()=>{c||d||(d=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof E.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof y.$lL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),d=!1}))},t=this;return{get name(){return t.n},get description(){return t.g??""},set description(i){t.g=i,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(i){t.h=i,a()},get iconPath(){return t.i},set iconPath(i){t.i=i,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(i){t.a=i,a()},get followupProvider(){return t.d},set followupProvider(i){t.d=i,a()},get isDefault(){return(0,v.$lF)(t.extension,"defaultChatAgent"),t.j},set isDefault(i){(0,v.$lF)(t.extension,"defaultChatAgent"),t.j=i,a()},get isSecondary(){return(0,v.$lF)(t.extension,"defaultChatAgent"),t.k},set isSecondary(i){(0,v.$lF)(t.extension,"defaultChatAgent"),t.k=i,a()},get onDidReceiveFeedback(){return t.l.event},onDidPerformAction:(0,v.$kF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){c=!0,t.a=void 0,t.d=void 0,t.l.dispose(),t.o.$unregisterAgent(t.q)}}}invoke(c,d,a,t){return this.r(c,d,a,t)}}}),define(De[301],Ce([1,0,21,3,6,13,64,25,8,4]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class L{constructor(k,v){this.stream=new E.$hh,this.stream=v??new E.$hh;const h=this;this.apiObj={option:k,response:h.stream.asyncIterable}}}class P{constructor(k,v){this.a=new b.$Od,this.b=new Map,this.c=new E.$hh,this.d=!1;const h=this;this.apiObject={result:k,response:h.c.asyncIterable,onDidStartResponseStream:h.a.event,cancel(){v.cancel()}},k.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(k){if(this.d)return;let v=this.b.get(k.index);v||(this.b.size===0?v=new L(k.index,this.c):v=new L(k.index),this.b.set(k.index,v),this.a.fire(v.apiObj)),v.stream.emitOne(k.part)}}class p{static{this.a=1}constructor(k,v){this.d=v,this.c=new Map,this.e=new Map,this.f=new m.$9l,this.b=k.getProxy(f.$pK.MainThreadChatProvider)}registerProvider(k,v,h,o){const l=p.a++;return this.c.set(l,{extension:k,provider:h}),this.b.$registerProvider(l,v,{extension:k,displayName:o.name??k.value}),(0,O.$Qc)(()=>{this.b.$unregisterProvider(l),this.c.delete(l)})}async $provideChatResponse(k,v,h,o,l){const c=this.c.get(k);if(!c)return;const d=new A.$9u(async a=>{if(l.isCancellationRequested){this.d.warn(`[CHAT](${c.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(v,{index:a.index,part:a.part})});return c.provider.provideChatResponse(h.map(R.ChatMessage.to),o,d,l)}allowListExtensionWhile(k,v){this.f.set(k,v),v.finally(()=>this.f.delete(k))}async requestChatResponseProvider(k,v){if(!this.f.has(k))throw new Error("Extension is NOT allowed to make chat requests");const h=this;return{get isRevoked(){return!h.f.has(k)},makeRequest(o,l,c){if(!h.f.has(k))throw new Error("Access to chat has been revoked");const d=new C.$Yd(c),a=Math.random()*1e6|0,t=h.b.$fetchResponse(k,v,a,o.map(R.ChatMessage.from),l??{},d.token),i=new P(t,d);return h.e.set(a,{res:i}),t.finally(()=>{h.e.delete(a)}),i.apiObject}}}async $handleResponseFragment(k,v){const h=this.e.get(k);h&&h.res.handleFragment(v)}}e.$xec=p}),define(De[302],Ce([1,0,3,6,9,13]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(O.$pK.MainThreadChatVariables)}async $resolveVariable(E,b,L){const P=this.b.get(E);if(P)try{const p=await P.resolver.resolve(P.data.name,{message:b},L);if(p)return p.map(R.ChatVariable.from)}catch(p){(0,f.$2)(p)}}registerVariableResolver(E,b,L,P){const p=A.a++;return this.b.set(p,{extension:E.identifier,data:{name:b,description:L},resolver:P}),this.c.$registerVariable(p,{name:b,description:L}),(0,C.$Qc)(()=>{this.b.delete(p),this.c.$unregisterVariable(p)})}}e.$zec=A}),define(De[303],Ce([1,0,6]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class O{constructor(R){const A=R.getProxy(C.$pK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(m){return A.$writeText(m)}})}}e.$Hcc=O}),define(De[34],Ce([1,0,17,7,13,24,6,19,14,62,32,61,2,3,5,20,147,22,69,41,35,85,88]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=void 0;let i=class{#e;#t;#i;constructor(S,$,g){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$pK.MainThreadCommands),this.d=$,this.#i=g,this.#t=S.getProxy(A.$pK.MainThreadTelemetry),this.converter=new s(this,w=>{const D=this.c.get(w);return D?.result===r.Void?D:void 0},$),this.f=[{processArgument(w){return(0,b.$nh)(w)}},{processArgument(w){return(0,R.$0m)(w,function(D){if(L.$xs.isIRange(D))return f.Range.to(D);if(P.$ws.isIPosition(D))return f.Position.to(D);if(L.$xs.isIRange(D.range)&&p.URI.isUri(D.uri))return f.location.to(D);if(D instanceof o.$ce)return D.buffer.buffer;if(!Array.isArray(D))return D})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const $=this.registerCommand(!1,S.id,async(...g)=>{const w=S.args.map((T,M)=>{if(!T.validate(g[M]))throw new Error(`Invalid argument '${T.name}' when running '${S.id}', received: ${typeof g[M]=="object"?JSON.stringify(g[M],null,"	"):g[M]} `);return T.convert(g[M])}),D=await this.executeCommand(S.internalId,...w);return S.result.convert(D,g,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new O.$rK(()=>{$.dispose(),this.c.delete(S.id)})}registerCommand(S,$,g,w,D,T){if(this.d.trace("ExtHostCommands#registerCommand",$),!$.trim().length)throw new Error("invalid id");if(this.b.has($))throw new Error(`command '${$}' already exists`);return this.b.set($,{callback:g,thisArg:w,metadata:D,extension:T}),S&&this.#e.$registerCommand($),new O.$rK(()=>{this.b.delete($)&&S&&this.#e.$unregisterCommand($)})}executeCommand(S,...$){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,$,!0)}async g(S,$,g){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,$,!1);{let w=!1;const D=(0,R.$0m)($,function(T){if(T instanceof O.$sK)return f.Position.from(T);if(T instanceof O.$tK)return f.Range.from(T);if(T instanceof O.$DK)return f.location.from(T);if(O.$OL.isNotebookRange(T))return f.NotebookRange.from(T);if(T instanceof ArrayBuffer)return w=!0,o.$ce.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return w=!0,o.$ce.wrap(T);if(T instanceof o.$ce)return w=!0,T;if(!Array.isArray(T))return T});try{const T=await this.#e.$executeCommand(S,w?new l.$uv(D):D,g);return(0,b.$nh)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this.g(S,$,!1);throw T}}}async h(S,$,g){const w=this.b.get(S);if(!w)throw new Error("Unknown command");const{callback:D,thisArg:T,metadata:M}=w;if(M?.args)for(let z=0;z<M.args.length;z++)try{(0,C.$Qf)($[z],M.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${M.args[z].name}' - ${M.args[z].description}`)}const F=d.$Kd.create();try{return await D.apply(T,$)}catch(z){if(S===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...$);j&&(S=j.command)}if(this.d.error(z,S,w.extension?.identifier),!g)throw z;if(w.extension?.identifier){const j=this.#i.onExtensionError(w.extension.identifier,z);this.d.trace("forwarded error to extension?",j,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.$Bi)(z)),this.id=S,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,S,F.elapsed())}}j(S,$,g){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new a.$no($),duration:g})}$executeContributedCommand(S,...$){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const g=this.b.get(S);return g?($=$.map(w=>this.f.reduce((D,T)=>T.processArgument(D,g.extension?.identifier),w)),this.h(S,$,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then($=>(S&&($=$.filter(g=>g[0]!=="_")),$))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[$,g]of this.b){const{metadata:w}=g;w&&(S[$]=w)}return Promise.resolve(S)}};e.$LM=i,e.$LM=i=He([Be(0,v.$qM),Be(1,E.$$i),Be(2,t.$KM)],i),e.$MM=(0,k.$Qh)("IExtHostCommands");class s{constructor(S,$,g){this.d=S,this.f=$,this.g=g,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,$){if(!S)return;const g={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return g;const w=this.f(S.command);if(w)g.id=w.internalId,g.arguments=w.args.map((D,T)=>D.convert(S.arguments&&S.arguments[T]));else if((0,m.$Lb)(S.arguments)){const D=`${S.command} /${++this.c}`;this.b.set(D,S),$.add((0,y.$Qc)(()=>{this.b.delete(D),this.g.trace("CommandsConverter#DISPOSE",D)})),g.$ident=D,g.id=this.delegatingCommandId,g.arguments=[D],this.g.trace("CommandsConverter#CREATE",S.command,D)}return g}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const $=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],$?$.command:"MISSING"),$?this.d.executeCommand($.command,...$.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$NM=s;class n{static{this.Uri=new n("uri","Uri of a text document",S=>p.URI.isUri(S),S=>S)}static{this.Position=new n("position","A position in a text document",S=>O.$sK.isPosition(S),f.Position.from)}static{this.Range=new n("range","A range in a text document",S=>O.$tK.isRange(S),f.Range.from)}static{this.Selection=new n("selection","A selection in a text document",S=>O.$uK.isSelection(S),f.Selection.from)}static{this.Number=new n("number","",S=>typeof S=="number",S=>S)}static{this.String=new n("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=n.Arr(n.String)}static Arr(S){return new n(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,$=>Array.isArray($)&&$.every(g=>S.validate(g)),$=>$.map(g=>S.convert(g)))}static{this.CallHierarchyItem=new n("item","A call hierarchy item",S=>S instanceof O.$NK,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new n("item","A type hierarchy item",S=>S instanceof O.$8L,f.TypeHierarchyItem.from)}static{this.TestItem=new n("testItem","A VS Code TestItem",S=>S instanceof h.$DM,f.TestItem.from)}constructor(S,$,g,w){this.name=S,this.description=$,this.validate=g,this.convert=w}optional(){return new n(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,$){return new n(S??this.name,$??this.description,this.validate,this.convert)}}e.$OM=n;class r{static{this.Void=new r("no result",S=>S)}constructor(S,$){this.description=S,this.convert=$}}e.$PM=r;class u{constructor(S,$,g,w,D){this.id=S,this.internalId=$,this.description=g,this.args=w,this.result=D}}e.$QM=u}),define(De[304],Ce([1,0,19,18,2,83,129,42,134,34,13,7]),function($e,e,C,O,f,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;const p=[new b.$QM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$OM.Uri,b.$OM.Position],new b.$PM("A promise that resolves to an array of DocumentHighlight-instances.",k(L.DocumentHighlight.to))),new b.$QM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$OM.Uri],new b.$PM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,o)=>{if((0,C.$Kb)(h))return;class l extends P.$IK{static to(d){const a=new l(d.name,L.SymbolKind.to(d.kind),d.containerName||"",new P.$DK(o[0],L.Range.to(d.range)));return a.detail=d.detail,a.range=a.location.range,a.selectionRange=L.Range.to(d.selectionRange),a.children=d.children?d.children.map(l.to):[],a}}return h.map(l.to)})),new b.$QM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$OM.Uri,new b.$OM("options","Formatting options",h=>!0,h=>h)],new b.$PM("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new b.$QM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$OM.Uri,b.$OM.Range,new b.$OM("options","Formatting options",h=>!0,h=>h)],new b.$PM("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new b.$QM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$OM.Uri,b.$OM.Position,new b.$OM("ch","Trigger character",h=>typeof h=="string",h=>h),new b.$OM("options","Formatting options",h=>!0,h=>h)],new b.$PM("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new b.$QM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$OM.Uri,b.$OM.Position],new b.$PM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$QM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$OM.Uri,b.$OM.Position],new b.$PM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$QM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$OM.Uri,b.$OM.Position],new b.$PM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$QM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$OM.Uri,b.$OM.Position],new b.$PM("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$QM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$OM.Uri,b.$OM.Position],new b.$PM("A promise that resolves to an array of Location-instances.",k(L.location.to))),new b.$QM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$OM.Uri,b.$OM.Position],new b.$PM("A promise that resolves to an array of Hover-instances.",k(L.Hover.to))),new b.$QM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$OM.Uri,new b.$OM("position","A position in a text document",h=>Array.isArray(h)&&h.every(o=>P.$sK.isPosition(o)),h=>h.map(L.Position.from))],new b.$PM("A promise that resolves to an array of ranges.",h=>h.map(o=>{let l;for(const c of o.reverse())l=new P.$MK(L.Range.to(c),l);return l}))),new b.$QM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$OM.String.with("query","Search string")],new b.$PM("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(L.WorkspaceSymbol.to))),new b.$QM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$OM.Uri,b.$OM.Position],new b.$PM("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(L.CallHierarchyItem.to))),new b.$QM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$OM.CallHierarchyItem],new b.$PM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(L.CallHierarchyIncomingCall.to))),new b.$QM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$OM.CallHierarchyItem],new b.$PM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(L.CallHierarchyOutgoingCall.to))),new b.$QM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$OM.Uri,b.$OM.Position],new b.$PM("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:L.Range.to(h.range),placeholder:h.text}})),new b.$QM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$OM.Uri,b.$OM.Position,b.$OM.String.with("newName","The new symbol name")],new b.$PM("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return L.WorkspaceEdit.to(h)}})),new b.$QM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$OM.Uri,b.$OM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$PM("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(L.DocumentLink.to))),new b.$QM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$OM.Uri],new b.$PM("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new P.$GL(h.tokenTypes,h.tokenModifiers)})),new b.$QM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$OM.Uri],new b.$PM("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const o=(0,A.$90)(h);if(o.type==="full")return new P.$IL(o.data,void 0)})),new b.$QM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$OM.Uri,b.$OM.Range.optional()],new b.$PM("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new P.$GL(h.tokenTypes,h.tokenModifiers)})),new b.$QM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$OM.Uri,b.$OM.Range],new b.$PM("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const o=(0,A.$90)(h);if(o.type==="full")return new P.$IL(o.data,void 0)})),new b.$QM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$OM.Uri,b.$OM.Position,b.$OM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$OM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$PM("A promise that resolves to a CompletionList-instance.",(h,o,l)=>{if(!h)return new P.$YK([]);const c=h.suggestions.map(d=>L.CompletionItem.to(d,l));return new P.$YK(c,h.incomplete)})),new b.$QM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$OM.Uri,b.$OM.Position,b.$OM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$PM("A promise that resolves to SignatureHelp.",h=>{if(h)return L.SignatureHelp.to(h)})),new b.$QM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$OM.Uri,b.$OM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$PM("A promise that resolves to an array of CodeLens-instances.",(h,o,l)=>k(c=>new P.$QK(L.Range.to(c.range),c.command&&l.fromInternal(c.command)))(h))),new b.$QM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$OM.Uri,new b.$OM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>P.$tK.isRange(h),h=>P.$uK.isSelection(h)?L.Selection.from(h):L.Range.from(h)),b.$OM.String.with("kind","Code action kind to return code actions for").optional(),b.$OM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$PM("A promise that resolves to an array of Command-instances.",(h,o,l)=>k(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(c.command)}else{const d=new P.$KK(c.title,c.kind?new P.$LK(c.kind):void 0);return c.edit&&(d.edit=L.WorkspaceEdit.to(c.edit)),c.command&&(d.command=l.fromInternal(c.command)),d.isPreferred=c.isPreferred,d}})(h))),new b.$QM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$OM.Uri],new b.$PM("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(o=>new P.$5K(L.Range.to(o.range),L.Color.to(o.color))):[])),new b.$QM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$OM("color","The color to show and insert",h=>h instanceof P.$4K,L.Color.from),new b.$OM("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:L.Range.from(h.range)}))],new b.$PM("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(L.ColorPresentation.to):[])),new b.$QM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$OM.Uri,b.$OM.Range],new b.$PM("A promise that resolves to an array of Inlay objects",(h,o,l)=>h.map(L.InlayHint.to.bind(void 0,l)))),new b.$QM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$OM.Uri],new b.$PM("A promise that resolves to an array of FoldingRange objects",(h,o)=>{if(h)return h.map(L.FoldingRange.to)})),new b.$QM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$PM("A promise that resolves to an array of NotebookContentProvider static info objects.",k(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(o=>L.NotebookExclusiveDocumentPattern.to(o))})))),new b.$QM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$OM.Uri,b.$OM.Range,new b.$OM("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof P.$tK,h=>L.InlineValueContext.from(h))],new b.$PM("A promise that resolves to an array of InlineValue objects",h=>h.map(L.InlineValue.to))),new b.$QM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$OM("uriOrString","Uri-instance or string (only http/https)",h=>f.URI.isUri(h)||typeof h=="string"&&(0,E.$rU)(h,O.Schemas.http,O.Schemas.https),h=>h),new b.$OM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[L.ViewColumn.from(h),void 0]:[L.ViewColumn.from(h.viewColumn),L.TextEditorOpenOptions.from(h)])).optional(),b.$OM.String.with("label","").optional()],b.$PM.Void),new b.$QM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$OM.Uri.with("resource","Resource to open"),b.$OM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$OM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[L.ViewColumn.from(h),void 0]:[L.ViewColumn.from(h.viewColumn),L.TextEditorOpenOptions.from(h)])).optional()],b.$PM.Void),new b.$QM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$OM.Uri.with("left","Left-hand side resource of the diff editor"),b.$OM.Uri.with("right","Right-hand side resource of the diff editor"),b.$OM.String.with("title","Human readable title for the diff editor").optional(),new b.$OM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[L.ViewColumn.from(h.viewColumn),L.TextEditorOpenOptions.from(h)]).optional()],b.$PM.Void),new b.$QM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$OM.Uri,b.$OM.Position],new b.$PM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(L.TypeHierarchyItem.to))),new b.$QM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$OM.TypeHierarchyItem],new b.$PM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(L.TypeHierarchyItem.to))),new b.$QM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$OM.TypeHierarchyItem],new b.$PM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(L.TypeHierarchyItem.to))),new b.$QM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$OM.TestItem],b.$PM.Void),new b.$QM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$OM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$PM.Void),new b.$QM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$OM.String.with("name","The context key name"),new b.$OM("value","The context key value",()=>!0,h=>h)],b.$PM.Void),new b.$QM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$OM.Uri,b.$OM.StringArray,new b.$OM("MappedEditsContext","Mapped Edits Context",h=>L.MappedEditsContext.is(h),h=>L.MappedEditsContext.from(h))],new b.$PM("A promise that resolves to a workspace edit or null",h=>h?L.WorkspaceEdit.to(h):null))];class y{static register(o){p.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$Pi)}}e.$Gcc=y;function k(h){return o=>{if(Array.isArray(o))return o.map(h)}}function v(h){if(!Array.isArray(h))return;const o=[];for(const l of h)R.$it(l)?o.push(L.DefinitionLink.to(l)):o.push(L.location.to(l));return o}}),define(De[305],Ce([1,0,8,57,4,3,2,83,25,13,7,6,26]),function($e,e,C,O,f,R,A,m,E,b,L,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;function y(k,v,h){const o=k.getProxy(P.$pK.MainThreadComments);class l{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$9l,v.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const I=this.b.get(u.handle);return I?I.value:u}else if(u&&u.$mid===7){const I=this.b.get(u.commentControlHandle);if(!I)return u;const S=I.getCommentThread(u.commentThreadHandle);return S?S.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const I=this.b.get(u.thread.commentControlHandle);if(!I)return u;const S=I.getCommentThread(u.thread.commentThreadHandle);return S?u.$mid===8?S.value:{thread:S.value,text:u.text}:u}else if(u&&u.$mid===10){const I=this.b.get(u.thread.commentControlHandle);if(!I)return u;const S=I.getCommentThread(u.thread.commentThreadHandle);if(!S)return u;const $=u.commentUniqueId,g=S.getCommentByUniqueId($);return g||u}else if(u&&u.$mid===11){const I=this.b.get(u.thread.commentControlHandle);if(!I)return u;const S=I.getCommentThread(u.thread.commentThreadHandle);if(!S)return u;const $=u.text,g=u.commentUniqueId,w=S.getCommentByUniqueId(g);return w?(typeof w.body=="string"?w.body=$:w.body=new L.$RK($),w):u}return u}})}createCommentController(u,I,S){const $=l.a++,g=new d(u,$,I,S);this.b.set(g.handle,g);const w=this.c.get(u.identifier)||[];return w.push(g),this.c.set(u.identifier,w),g.value}async $createCommentThreadTemplate(u,I,S){const $=this.b.get(u);$&&$.$createCommentThreadTemplate(I,S)}async $updateCommentThreadTemplate(u,I,S){const $=this.b.get(u);$&&$.$updateCommentThreadTemplate(I,S)}$deleteCommentThread(u,I){this.b.get(u)?.$deleteCommentThread(I)}$provideCommentingRanges(u,I,S){const $=this.b.get(u);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const g=h.getDocument(A.URI.revive(I));return(0,C.$Ng)(async()=>{const w=await $.commentingRangeProvider.provideCommentingRanges(g,S);let D;return Array.isArray(w)?D={ranges:w,fileComments:!1}:w?D={ranges:w.ranges||[],fileComments:w.fileComments||!1}:D=w??void 0,D}).then(w=>{let D;return w&&(D={ranges:w.ranges.map(T=>b.Range.from(T)),fileComments:w.fileComments}),D})}$toggleReaction(u,I,S,$,g){const w=this.b.get(u);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,C.$Ng)(()=>{const D=w.getCommentThread(I);if(D){const T=D.getCommentByUniqueId($.uniqueIdInThread);if(w!==void 0&&T&&w.reactionHandler)return w.reactionHandler(T,i(g))}return Promise.resolve(void 0)})}}class c{static{this.a=0}set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,I,S,$,g,w,D,T){this.m=I,this.n=S,this.o=$,this.p=g,this.q=w,this.extensionDescription=D,this.r=T,this.handle=c.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$Od,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Tc,this.l.value=new R.$Rc,this.n===void 0&&(this.n=`${u}.${this.handle}`),o.$createCommentThread(I,this.handle,this.n,this.o,b.Range.from(this.p),D.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{o.$deleteCommentThread(I,this.handle)}});const M=this;this.value={get uri(){return M.uri},get range(){return M.range},set range(F){M.range=F},get comments(){return M.comments},set comments(F){M.comments=F},get collapsibleState(){return M.collapsibleState},set collapsibleState(F){M.collapsibleState=F},get canReply(){return M.canReply},set canReply(F){M.canReply=F},get contextValue(){return M.contextValue},set contextValue(F){M.contextValue=F},get label(){return M.label},set label(F){M.label=F},get state(){return M.state},set state(F){M.state=F},dispose:()=>{M.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Rc);const u=S=>Object.prototype.hasOwnProperty.call(this.b,S),I={};u("range")&&(I.range=b.Range.from(this.p)),u("label")&&(I.label=this.label),u("contextValue")&&(I.contextValue=this.contextValue??null),u("comments")&&(I.comments=this.q.map(S=>a(this,S,this.k,this.extensionDescription))),u("collapsibleState")&&(I.collapseState=s(this.g)),u("canReply")&&(I.canReply=this.canReply),u("state")&&(I.state=n(this.h)),u("isTemplate")&&(I.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(u){for(const I of this.k){const S=I[0],$=I[1];if(u===$)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}He([(0,O.$jh)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class d{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,I,S,$){this.f=u,this.g=I,this.h=S,this.i=$,this.a=new Map,o.$registerCommentController(this.handle,S,$,this.f.identifier.value);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(w){g.options=w},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(w){g.commentingRangeProvider=w},get reactionHandler(){return g.reactionHandler},set reactionHandler(w){g.reactionHandler=w},createCommentThread(w,D,T){return g.createCommentThread(w,D,T).value},dispose:()=>{g.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(u,I,S){I===void 0&&(0,p.$lF)(this.f,"fileComments");const $=new c(this.id,this.handle,void 0,u,I,S,this.f,!1);return this.a.set($.handle,$),$}$createCommentThreadTemplate(u,I){const S=new c(this.id,this.handle,void 0,A.URI.revive(u),b.Range.to(I),[],this.f,!0);return S.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(u,I){const S=this.a.get(u);S&&(S.range=b.Range.to(I))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function a(r,u,I,S){let $=I.get(u);return $||($=++r.commentHandle,I.set(u,$)),u.state!==void 0&&(0,p.$lF)(S,"commentsDraftState"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:$,body:typeof u.body=="string"?u.body:b.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(g=>t(g)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function t(r){return{label:r.label,iconPath:r.iconPath?b.$pM(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?A.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case L.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function n(r){if(r!==void 0)switch(r){case L.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new l}e.$Icc=y}),define(De[306],Ce([1,0,24,6,27,20]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;let A=class{constructor(L,P){this.a=L.getProxy(O.$pK.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,P){const p=this,y=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){p.e(L,P,y,arguments)}})}e(L,P,p,y){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:E(y,this.b)}),this.c&&this.f(L,p,y)}};e.$Gec=A,e.$Gec=A=He([Be(0,R.$qM),Be(1,f.$GM)],A);const m=1e5;function E(b,L){const P=[];if(b.length)for(let p=0;p<b.length;p++){let y=b[p];if(typeof y>"u")y="undefined";else if(y instanceof Error){const k=y;k.stack?y=k.stack:y=k.toString()}P.push(y)}if(L){const p=new Error().stack;p&&P.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,C.$an)(P);return p.length>m?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(De[149],Ce([1,0,2,6,7,5,20,14,19,15,16,26]),function($e,e,C,O,f,R,A,m,E,b,L,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=e.$Jdc=void 0;let y=class{static{p=this}static{this.c=0}static{this.d=250}constructor(v,h){this.h=h,this.f=new Map,this.g=v.getProxy(O.$pK.MainThreadDecorations)}registerFileDecorationProvider(v,h){const o=p.c++;this.f.set(o,{provider:v,extensionDescription:h}),this.g.$registerDecorationProvider(o,h.identifier.value);const l=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(o,null);return}const d=(0,E.$3b)(c);if(d.length<=p.d){this.g.$onDidChange(o,d);return}this.h.warn("[Decorations] CAPPING events from decorations provider",h.identifier.value,d.length);const a=d.map(s=>({uri:s,rank:(0,b.$He)(s.path,"/")})),t=(0,E.$zb)(a,(s,n)=>s.rank-n.rank||(0,b.$Ve)(s.uri.path,n.uri.path)),i=[];e:for(const s of t){let n;for(const r of s){const u=(0,L.$mc)(r.uri.path);if(n!==u&&(n=u,i.push(r.uri)>=p.d))break e}}this.g.$onDidChange(o,i)});return new f.$rK(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(v,h,o){if(!this.f.has(v))return Object.create(null);const l=Object.create(null),{provider:c,extensionDescription:d}=this.f.get(v);return await Promise.all(h.map(async a=>{try{const{uri:t,id:i}=a,s=await Promise.resolve(c.provideFileDecoration(C.URI.revive(t),o));if(!s)return;try{f.$ML.validate(s),s.badge&&typeof s.badge!="string"&&(0,P.$lF)(d,"codiconDecoration"),l[i]=[s.propagate,s.tooltip,s.badge,s.color]}catch(n){this.h.warn(`INVALID decoration from extension '${d.identifier.value}': ${n}`)}}catch(t){this.h.error(t)}})),l}};e.$Jdc=y,e.$Jdc=y=p=He([Be(0,A.$qM),Be(1,m.$$i)],y),e.$Kdc=(0,R.$Qh)("IExtHostDecorations")}),define(De[307],Ce([1,0,204,133,2,6,7,13,4,14,28,55]),function($e,e,C,O,f,R,A,m,E,b,L,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=e.$Acc=void 0;class y{#e;#t;#i;constructor(h,o,l,c,d,a,t,i){this.d=h,this.e=o,this.f=l,this.g=c,this.h=d,this.c=!1,this.f=Math.max(c,l),this.#i=new L.$Ac(s=>a.getComparisonKey(s)),this.#e=t,this.#t=i}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(h,o){if(!h){this.clear();return}this.j();let l=[];if(f.URI.isUri(h)){if(!o){this.delete(h);return}this.#i.set(h,o.slice()),l=[h]}else if(Array.isArray(h)){l=[];let a;h=[...h].sort(y.k);for(const t of h){const[i,s]=t;if((!a||i.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=i,l.push(i),this.#i.set(i,[])),s)this.#i.get(i)?.push(...s);else{const n=this.#i.get(i);n&&(n.length=0)}}}if(this.#t.fire(l),!this.#e)return;const c=[];let d=0;for(const a of l){let t=[];const i=this.#i.get(a);if(i)if(i.length>this.g){t=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const r of i)if(r.severity===s[n]&&t.push({...m.Diagnostic.from(r),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,C.localize)(0,null,i.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=i.map(s=>({...m.Diagnostic.from(s),modelVersionId:this.h(a)}));if(c.push([a,t]),d+=t.length,d>this.f)break}this.#e.$changeMany(this.e,c)}delete(h){this.j(),this.#t.fire([h]),this.#i.delete(h),this.#e?.$changeMany(this.e,[[h,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(h,o){this.j();for(const[l,c]of this)h.call(o,l,c,this)}*[Symbol.iterator](){this.j();for(const h of this.#i.keys())yield[h,this.get(h)]}get(h){this.j();const o=this.#i.get(h);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(h){return this.j(),Array.isArray(this.#i.get(h))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(h,o){return h[0].toString()<o[0].toString()?-1:h[0].toString()>o[0].toString()?1:0}}e.$Acc=y;let k=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(h){const o=new L.$Ac;for(const l of h)o.set(l,l);return{uris:Object.freeze(Array.from(o.values()))}}constructor(h,o,l,c){this.j=o,this.k=l,this.l=c,this.g=new Map,this.h=new E.$Sd({merge:d=>d.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,p._mapper),this.f=h.getProxy(R.$pK.MainThreadDiagnostics)}createDiagnosticCollection(h,o){const{g:l,f:c,h:d,j:a,k:t,l:i}=this,s=new class{$changeMany(u,I){c.$changeMany(u,I),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",h.value,u,I.length===0?"CLEARING":I)}$clear(u){c.$clear(u),a.trace("[DiagnosticCollection] remove all (extension, owner)",h.value,u)}dispose(){c.dispose()}};let n;if(!o)o="_generated_diagnostic_collection_name_#"+p.c++,n=o;else if(!l.has(o))n=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do n=o+p.c++;while(l.has(n))}return new class extends y{constructor(){super(o,n,p.e,p.d,u=>i.getDocument(u)?.version,t.extUri,s,d),l.set(n,this)}dispose(){super.dispose(),l.delete(n)}}}getDiagnostics(h){if(h)return this.m(h);{const o=new Map,l=[];for(const c of this.g.values())c.forEach((d,a)=>{let t=o.get(d.toString());typeof t>"u"&&(t=l.length,o.set(d.toString(),t),l.push([d,[]])),l[t][1]=l[t][1].concat(...a)});return l}}m(h){let o=[];for(const l of this.g.values())l.has(h)&&(o=o.concat(l.get(h)));return o}$acceptMarkersChange(h){if(!this.n){const o="_generated_mirror",l=new y(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this.k.extUri,void 0,this.h);this.g.set(o,l),this.n=l}for(const[o,l]of h)this.n.set(f.URI.revive(o),l.map(m.Diagnostic.to))}};e.$Bcc=k,e.$Bcc=k=p=He([Be(1,b.$$i),Be(2,P.$zcc)],k)}),define(De[308],Ce([1,0,2,6,26]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;class R{constructor(m){this.a=m.getProxy(O.$pK.MainThreadDialogs)}showOpenDialog(m,E){return E?.allowUIResources&&(0,f.$lF)(m,"showLocal"),this.a.$showOpenDialog(E).then(b=>b?b.map(L=>C.URI.revive(L)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(E=>E?C.URI.revive(E):void 0)}}e.$Qcc=R}),define(De[309],Ce([1,0,9,2,7,6,18,21,15]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;class b{static{this.a=0}constructor(P,p,y){this.d=p,this.e=y,this.b=new Map,this.c=P.getProxy(R.$pK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,p){if(Object.keys(A.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const y=b.a++;this.b.set(y,p),this.c.$registerTextContentProvider(y,P);let k;return typeof p.onDidChange=="function"&&(k=p.onDidChange(v=>{if(v.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this.d.getDocument(v)&&this.$provideTextDocumentContent(y,v).then(h=>{if(!h&&typeof h!="string")return;const o=this.d.getDocument(v);if(!o)return;const l=(0,E.$Qe)(h);if(!o.equalLines(l))return this.c.$onVirtualDocumentChange(v,h)},C.$1)})),new f.$rK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(P,p){const y=this.b.get(P);return y?Promise.resolve(y.provideTextDocumentContent(O.URI.revive(p),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$Rcc=b}),define(De[310],Ce([1,0,4,3,2,6,141,13,17,24,7,9]),function($e,e,C,O,f,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;class p{constructor(k,v){this.a=new C.$Od({onListenerError:P.$2}),this.b=new C.$Od({onListenerError:P.$2}),this.c=new C.$Od({onListenerError:P.$2}),this.d=new C.$Od({onListenerError:P.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Rc,this.h=new Map,this.f=k.getProxy(R.$pK.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(h=>{for(const o of h)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const o of h)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const v=this.g.getDocument(k);if(v)return v}getDocument(k){const v=this.getDocumentData(k);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return v.document}ensureDocumentData(k){const v=this.g.getDocument(k);if(v)return Promise.resolve(v);let h=this.h.get(k.toString());return h||(h=this.f.$tryOpenDocument(k).then(o=>{this.h.delete(k.toString());const l=f.URI.revive(o);return(0,E.$Kf)(this.g.getDocument(l))},o=>(this.h.delete(k.toString()),Promise.reject(o))),this.h.set(k.toString(),h)),h}createDocumentData(k){return this.f.$tryCreateDocument(k).then(v=>f.URI.revive(v))}$acceptModelLanguageChanged(k,v){const h=f.URI.revive(k),o=this.g.getDocument(h);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(v),this.a.fire(o.document)}$acceptModelSaved(k){const v=f.URI.revive(k),h=this.g.getDocument(v);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(k,v){const h=f.URI.revive(k),o=this.g.getDocument(h);if(!o)throw new Error("unknown document");o._acceptIsDirty(v),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,v,h){const o=f.URI.revive(k),l=this.g.getDocument(o);if(!l)throw new Error("unknown document");l._acceptIsDirty(h),l.onEvents(v);let c;v.isUndoing?c=L.TextDocumentChangeReason.Undo:v.isRedoing&&(c=L.TextDocumentChangeReason.Redo),this.c.fire((0,b.$9m)({document:l.document,contentChanges:v.changes.map(d=>({range:m.Range.to(d.range),rangeOffset:d.rangeOffset,rangeLength:d.rangeLength,text:d.text})),reason:c}))}setWordDefinitionFor(k,v){(0,A.$sM)(k,v)}}e.$xcc=p}),define(De[70],Ce([1,0,58,4,3,2,5,6,141,20,148,13,14,28,18,51,47]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=void 0;class o{constructor(d){this.value=d,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let l=class{constructor(d,a){this.h=d,this.i=a,this.a=null,this.b=new Map,this.c=new y.$Ac,this.d=new O.$Od,this.e=new O.$Od,this.f=new O.$Od,this.g=new O.$Od,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const a=[],t=[],i=[];if(d.removedDocuments)for(const s of d.removedDocuments){const n=R.URI.revive(s),r=this.c.get(n);r?.unref()&&(this.c.delete(n),a.push(r.value))}if(d.addedDocuments)for(const s of d.addedDocuments){const n=R.URI.revive(s.uri);let r=this.c.get(n);if(r&&n.scheme!==k.Schemas.vscodeNotebookCell&&n.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);r||(r=new o(new E.$tM(this.h.getProxy(m.$pK.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(n,r),t.push(r.value)),r.ref()}if(d.removedEditors)for(const s of d.removedEditors){const n=this.b.get(s);this.b.delete(s),n&&i.push(n)}if(d.addedEditors)for(const s of d.addedEditors){const n=R.URI.revive(s.documentUri);C.ok(this.c.has(n),`document '${n}' does not exist`),C.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const r=this.c.get(n).value,u=new L.$zM(s.id,this.h.getProxy(m.$pK.MainThreadTextEditors),this.i,new h.$V(()=>r.document),s.selections.map(P.Selection.to),s.options,s.visibleRanges.map(I=>P.Range.to(I)),typeof s.editorPosition=="number"?P.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,u)}d.newActiveEditor!==void 0&&(C.ok(d.newActiveEditor===null||this.b.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this.a=d.newActiveEditor),(0,f.$Nc)(a),(0,f.$Nc)(i),d.removedDocuments&&this.e.fire(a),d.addedDocuments&&this.d.fire(t),(d.removedEditors||d.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),d.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(d){return this.c.get(d)?.value}allDocuments(){return v.Iterable.map(this.c.values(),d=>d.value)}getEditor(d){return this.b.get(d)}activeEditor(d){if(!this.a)return;const a=this.b.get(this.a);return d?a:a?.value}allEditors(){return[...this.b.values()]}};e.$AM=l,e.$AM=l=He([Be(0,b.$qM),Be(1,p.$$i)],l),e.$BM=(0,A.$Qh)("IExtHostDocumentsAndEditors")}),define(De[71],Ce([1,0,13,6,2,4,5,7,20,17,74]),function($e,e,C,O,f,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=e.$Odc=void 0,e.$Odc=(0,A.$Qh)("IExtHostEditorTabs");class P{constructor(h,o,l){this.e=l,this.d=o,this.acceptDtoUpdate(h)}get apiObject(){if(!this.a){const h=this,o={get isActive(){return h.b.id===h.e()},get label(){return h.b.label},get input(){return h.c},get isDirty(){return h.b.isDirty},get isPinned(){return h.b.isPinned},get isPreview(){return h.b.isPreview},get group(){return h.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(h){this.b=h,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new m.$9L(f.URI.revive(this.b.input.uri));case 2:return new m.$0L(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified));case 3:return new m.$$L(f.URI.revive(this.b.input.base),f.URI.revive(this.b.input.input1),f.URI.revive(this.b.input.input2),f.URI.revive(this.b.input.result));case 6:return new m.$_L(f.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new m.$aM(this.b.input.viewType);case 4:return new m.$bM(f.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new m.$cM(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new m.$dM;case 9:return new m.$eM(f.URI.revive(this.b.input.uri),f.URI.revive(this.b.input.inputBoxUri));default:return}}}class p{constructor(h,o){this.c=[],this.d="",this.b=h,this.e=o;for(const l of h.tabs)l.isActive&&(this.d=l.id),this.c.push(new P(l,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const h=this,o={get isActive(){return h.b.groupId===h.e()},get viewColumn(){return C.ViewColumn.to(h.b.viewColumn)},get activeTab(){return h.c.find(l=>l.tabId===h.d)?.apiObject},get tabs(){return Object.freeze(h.c.map(l=>l.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(h){this.b=h}acceptTabOperation(h){if(h.kind===0){const l=new P(h.tabDto,this,()=>this.activeTabId());return this.c.splice(h.index,0,l),h.tabDto.isActive&&(this.d=l.tabId),l}else if(h.kind===1){const l=this.c.splice(h.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return l.tabId===this.d&&(this.d=""),l}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this.c.splice(h.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this.c.splice(h.index,0,l),l}const o=this.c.find(l=>l.tabId===h.tabDto.id);if(!o)throw new Error("INVALID tab");return h.tabDto.isActive?this.d=h.tabDto.id:this.d===h.tabDto.id&&!h.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(h.tabDto),o}activeTabId(){return this.d}}let y=class{constructor(h){this.b=new R.$Od,this.c=new R.$Od,this.e=[],this.a=h.getProxy(O.$pK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const h=this,o={onDidChangeTabGroups:h.c.event,onDidChangeTabs:h.b.event,get all(){return Object.freeze(h.e.map(l=>l.apiObject))},get activeTabGroup(){const l=h.d;return(0,b.$Kf)(h.e.find(d=>d.groupId===l)?.apiObject)},close:async(l,c)=>{const d=Array.isArray(l)?l:[l];return d.length?k(d[0])?this.j(d,c):this.i(d,c):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(h){const o=new Set(this.e.map(s=>s.groupId)),l=new Set(h.map(s=>s.groupId)),c=(0,L.$K)(o,l),d=this.e.filter(s=>c.removed.includes(s.groupId)).map(s=>s.apiObject),a=[],t=[];this.e=h.map(s=>{const n=new p(s,()=>this.d);return c.added.includes(n.groupId)?a.push(n.apiObject):t.push(n.apiObject),n});const i=(0,b.$Kf)(h.find(s=>s.isActive===!0)?.groupId);i!==void 0&&this.d!==i&&(this.d=i),this.c.fire(Object.freeze({opened:a,closed:d,changed:t}))}$acceptTabGroupUpdate(h){const o=this.e.find(l=>l.groupId===h.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(h),h.isActive&&(this.d=h.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const o=this.e.find(c=>c.groupId===h.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const l=o.acceptTabOperation(h);switch(h.kind){case 0:this.b.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}g(h){for(const o of this.e)for(const l of o.tabs)if(l.apiObject===h)return l}h(h){return this.e.find(o=>o.apiObject===h)}async i(h,o){const l=[];for(const c of h){const d=this.g(c);if(!d)throw new Error("Tab close: Invalid tab not found!");l.push(d.tabId)}return this.a.$closeTab(l,o)}async j(h,o){const l=[];for(const c of h){const d=this.h(c);if(!d)throw new Error("Group close: Invalid group not found!");l.push(d.groupId)}return this.a.$closeGroup(l,o)}};e.$Pdc=y,e.$Pdc=y=He([Be(0,E.$qM)],y);function k(v){return v.tabs!==void 0}}),define(De[311],Ce([1,0,6,7]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class f{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$pK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,m,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const b=this.a.get(A);if(!b)throw new Error("Embedding vector provider not found");const L=await b.provideEmbeddingVector(m,E);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(A,m,E){const b=this.b;return this.b++,this.a.set(b,E),this.c.$registerAiEmbeddingVectorProvider(m,b),new O.$rK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(b),this.a.delete(b)})}}e.$Bec=f}),define(De[312],Ce([1,0,2,6,3,7,13,169,15,22,26,80]),function($e,e,C,O,f,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class p{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const h=this.a.indexOf(v);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),h=[];let o,l,c=14,d=14;for(const a of v){let t=o?(0,E.$5e)(o,a):0;for(t===0?l=1:l=d;t<a.length;t++)t+1===a.length?(c=d,d=9):d+=1,h.push([l,a.toUpperCase().charCodeAt(t),d]),h.push([l,a.toLowerCase().charCodeAt(t),d]),l=d;o=a,d=c}h.push([9,58,10]),h.push([10,47,12]),this.b=new m.$_Y(h)}}provideDocumentLinks(v){this.c();const h=[],o=m.$aZ.computeLinks({getLineContent(l){return v.lineAt(l-1).text},getLineCount(){return v.lineCount}},this.b);for(const l of o){const c=A.DocumentLink.to(l);c.target&&h.push(c)}return h}}class y{constructor(v,h){this.i=h,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(O.$pK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,h,o,l={}){if(y.j(o),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const c=this.h++;this.b.add(h),this.d.add(h),this.c.set(c,o);let d=2;l.isCaseSensitive&&(d+=1024),l.isReadonly&&(d+=2048),typeof o.copy=="function"&&(d+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,L.$lF)(v,"fsChunks"),d+=4);let a;l.isReadonly&&(0,P.$6j)(l.isReadonly)&&((0,L.$lF)(v,"readonlyMessage"),a={value:l.isReadonly.value,isTrusted:l.isReadonly.isTrusted,supportThemeIcons:l.isReadonly.supportThemeIcons,supportHtml:l.isReadonly.supportHtml,baseUri:l.isReadonly.baseUri,uris:l.isReadonly.uris}),this.a.$registerFileSystemProvider(c,h,d,a).catch(i=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${h}`),console.error(i)});const t=o.onDidChangeFile(i=>{const s=[];for(const n of i){const{uri:r,type:u}=n;if(r.scheme!==h)continue;let I;switch(u){case R.FileChangeType.Changed:I=0;break;case R.FileChangeType.Created:I=1;break;case R.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:r,type:I})}this.a.$onFileSystemChange(c,s)});return(0,f.$Qc)(()=>{t.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(c),this.a.$unregisterProvider(c)})}static j(v){if(!v)throw new Error("MISSING provider");if(typeof v.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof v.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof v.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof v.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof v.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof v.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof v.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof v.rename!="function")throw new Error("Provider does NOT implement rename")}static k(v){const{type:h,ctime:o,mtime:l,size:c,permissions:d}=v;return{type:h,ctime:o,mtime:l,size:c,permissions:d}}$stat(v,h){return Promise.resolve(this.l(v).stat(C.URI.revive(h))).then(o=>y.k(o))}$readdir(v,h){return Promise.resolve(this.l(v).readDirectory(C.URI.revive(h)))}$readFile(v,h){return Promise.resolve(this.l(v).readFile(C.URI.revive(h))).then(o=>b.$ce.wrap(o))}$writeFile(v,h,o,l){return Promise.resolve(this.l(v).writeFile(C.URI.revive(h),o.buffer,l))}$delete(v,h,o){return Promise.resolve(this.l(v).delete(C.URI.revive(h),o))}$rename(v,h,o,l){return Promise.resolve(this.l(v).rename(C.URI.revive(h),C.URI.revive(o),l))}$copy(v,h,o,l){const c=this.l(v);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(C.URI.revive(h),C.URI.revive(o),l))}$mkdir(v,h){return Promise.resolve(this.l(v).createDirectory(C.URI.revive(h)))}$watch(v,h,o,l){const c=this.l(v).watch(C.URI.revive(o),l);this.f.set(h,c)}$unwatch(v,h){const o=this.f.get(h);o&&(o.dispose(),this.f.delete(h))}$open(v,h,o){const l=this.l(v);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(C.URI.revive(h),o))}$close(v,h){const o=this.l(v);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(h))}$read(v,h,o,l){const c=this.l(v);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const d=b.$ce.alloc(l);return Promise.resolve(c.read(h,o,d.buffer,0,l)).then(a=>d.slice(0,a))}$write(v,h,o,l){const c=this.l(v);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(h,o,l.buffer,0,l.byteLength))}l(v){const h=this.c.get(v);if(!h){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return h}}e.$ldc=y}),define(De[72],Ce([1,0,6,30,7,22,5,20,55,3,8,23,18]),function($e,e,C,O,f,R,A,m,E,b,L,P,p){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=void 0;let k=y=class{constructor(h,o){this.b=new Map,this.c=new L.$4g,this.a=h.getProxy(C.$pK.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(c){try{let d;const a=l.b.get(c.scheme);return a?(await l.a.$ensureActivation(c.scheme),d=await a.impl.stat(c)):d=await l.a.$stat(c),{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions===O.FilePermission.Readonly?1:void 0}}catch(d){y.e(d)}},async readDirectory(c){try{const d=l.b.get(c.scheme);return d?(await l.a.$ensureActivation(c.scheme),(await d.impl.readDirectory(c)).slice()):await l.a.$readdir(c)}catch(d){return y.e(d)}},async createDirectory(c){try{const d=l.b.get(c.scheme);return d&&!d.isReadonly?(await l.a.$ensureActivation(c.scheme),await l.d(d.impl,d.extUri,c)):await l.a.$mkdir(c)}catch(d){return y.e(d)}},async readFile(c){try{const d=l.b.get(c.scheme);return d?(await l.a.$ensureActivation(c.scheme),(await d.impl.readFile(c)).slice()):(await l.a.$readFile(c)).buffer}catch(d){return y.e(d)}},async writeFile(c,d){try{const a=l.b.get(c.scheme);return a&&!a.isReadonly?(await l.a.$ensureActivation(c.scheme),await l.d(a.impl,a.extUri,a.extUri.dirname(c)),await l.c.queueFor(c).queue(()=>Promise.resolve(a.impl.writeFile(c,d,{create:!0,overwrite:!0})))):await l.a.$writeFile(c,R.$ce.wrap(d))}catch(a){return y.e(a)}},async delete(c,d){try{const a=l.b.get(c.scheme);return a&&!a.isReadonly?(await l.a.$ensureActivation(c.scheme),await a.impl.delete(c,{recursive:!1,...d})):await l.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...d})}catch(a){return y.e(a)}},async rename(c,d,a){try{return await l.a.$rename(c,d,{overwrite:!1,...a})}catch(t){return y.e(t)}},async copy(c,d,a){try{return await l.a.$copy(c,d,{overwrite:!1,...a})}catch(t){return y.e(t)}},isWritableFileSystem(c){const d=o.getCapabilities(c);if(typeof d=="number")return!(d&2048)}})}async d(h,o,l){const c=[];for(;!o.isEqual(l,o.dirname(l));)try{if(!((await h.stat(l)).type&O.FileType.Directory))throw f.$EL.FileExists(`Unable to create folder '${l.scheme===p.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(d){if(O.$pk(d)!==O.FileSystemProviderErrorCode.FileNotFound)throw d;c.push(o.basename(l)),l=o.dirname(l)}for(let d=c.length-1;d>=0;d--){l=o.joinPath(l,c[d]);try{await h.createDirectory(l)}catch(a){if(O.$pk(a)!==O.FileSystemProviderErrorCode.FileExists)throw a}}}static e(h){if(h instanceof f.$EL)throw h;if(h instanceof O.$lk)switch(h.code){case O.FileSystemProviderErrorCode.FileExists:throw f.$EL.FileExists(h.message);case O.FileSystemProviderErrorCode.FileNotFound:throw f.$EL.FileNotFound(h.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw f.$EL.FileNotADirectory(h.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw f.$EL.FileIsADirectory(h.message);case O.FileSystemProviderErrorCode.NoPermissions:throw f.$EL.NoPermissions(h.message);case O.FileSystemProviderErrorCode.Unavailable:throw f.$EL.Unavailable(h.message);default:throw new f.$EL(h.message,h.name)}if(!(h instanceof Error))throw new f.$EL(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw f.$EL.Unavailable(h.message);switch(h.name){case O.FileSystemProviderErrorCode.FileExists:throw f.$EL.FileExists(h.message);case O.FileSystemProviderErrorCode.FileNotFound:throw f.$EL.FileNotFound(h.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw f.$EL.FileNotADirectory(h.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw f.$EL.FileIsADirectory(h.message);case O.FileSystemProviderErrorCode.NoPermissions:throw f.$EL.NoPermissions(h.message);case O.FileSystemProviderErrorCode.Unavailable:throw f.$EL.Unavailable(h.message);default:throw new f.$EL(h.message,h.name)}}addFileSystemProvider(h,o,l){return this.b.set(h,{impl:o,extUri:l?.isCaseSensitive?P.$mg:P.$og,isReadonly:!!l?.isReadonly}),(0,b.$Qc)(()=>this.b.delete(h))}getFileSystemProviderExtUri(h){return this.b.get(h)?.extUri??P.$mg}};e.$4cc=k,e.$4cc=k=y=He([Be(0,m.$qM),Be(1,E.$zcc)],k),e.$5cc=(0,A.$Qh)("IExtHostConsumerFileSystem")}),define(De[313],Ce([1,0,4,36,2,6,13,7,47]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;class b{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,k,v,h,o,l){this.a=Math.random(),this.b=new C.$Od,this.c=new C.$Od,this.d=new C.$Od,this.h=0,l?.ignoreCreateEvents&&(this.h+=1),l?.ignoreChangeEvents&&(this.h+=2),l?.ignoreDeleteEvents&&(this.h+=4);const c=(0,O.$xj)(o),d=typeof o=="string",a=l?.correlate,t=h(i=>{if(!(typeof i.session=="number"&&i.session!==this.a)&&!(a&&typeof i.session>"u")){if(!l?.ignoreCreateEvents)for(const s of i.created){const n=f.URI.revive(s);c(n.fsPath)&&(!d||k.getWorkspaceFolder(n))&&this.b.fire(n)}if(!l?.ignoreChangeEvents)for(const s of i.changed){const n=f.URI.revive(s);c(n.fsPath)&&(!d||k.getWorkspaceFolder(n))&&this.c.fire(n)}if(!l?.ignoreDeleteEvents)for(const s of i.deleted){const n=f.URI.revive(s);c(n.fsPath)&&(!d||k.getWorkspaceFolder(n))&&this.d.fire(n)}}});this.g=m.$rK.from(this.i(y,v,o,l,l?.correlate),this.b,this.c,this.d,t)}i(y,k,v,h,o){const l=m.$rK.from();if(typeof v=="string")return l;const c=y.getProxy(R.$pK.MainThreadFileSystemEventService);let d=!1;return(v.pattern.includes(O.$tj)||v.pattern.includes(O.$uj))&&(d=!0),c.$watch(k.identifier.value,this.a,v.baseUri,{recursive:d,excludes:h?.excludes??[]},!!o),m.$rK.from({dispose:()=>c.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class L{constructor(y){this.a=y,this.session=this.a.session,this.b=new E.$V(()=>this.a.created.map(f.URI.revive)),this.c=new E.$V(()=>this.a.changed.map(f.URI.revive)),this.d=new E.$V(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(y,k,v){this.j=y,this.k=k,this.l=v,this.a=new C.$Od,this.b=new C.$Od,this.c=new C.$Od,this.d=new C.$Od,this.g=new C.$Qd,this.h=new C.$Qd,this.i=new C.$Qd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,k,v,h){return new b(this.j,y,k,this.a.event,A.GlobPattern.from(v),h)}$onFileEvent(y){this.a.fire(new L(y))}$onDidRunFileOperation(y,k){switch(y){case 2:this.b.fire(Object.freeze({files:k.map(v=>({oldUri:f.URI.revive(v.source),newUri:f.URI.revive(v.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(v=>f.URI.revive(v.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(v=>f.URI.revive(v.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,k){return(v,h,o)=>{const l=function(d){v.call(h,d)};return l.extension=y,k.event(l,void 0,o)}}async $onWillRunFileOperation(y,k,v,h){switch(y){case 2:return await this.n(this.g,{files:k.map(o=>({oldUri:f.URI.revive(o.source),newUri:f.URI.revive(o.target)}))},v,h);case 1:return await this.n(this.i,{files:k.map(o=>f.URI.revive(o.target))},v,h);case 0:case 3:return await this.n(this.h,{files:k.map(o=>f.URI.revive(o.target))},v,h)}}async n(y,k,v,h){const o=new Set,l=[];if(await y.fireAsync(k,h,async(d,a)=>{const t=Date.now(),i=await Promise.resolve(d);i instanceof m.$BK&&(l.push([a.extension,i]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>v&&this.k.warn("SLOW file-participant",a.extension.identifier)}),h.isCancellationRequested||l.length===0)return;const c={edits:[]};for(const[,d]of l){const{edits:a}=A.WorkspaceEdit.from(d,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(a)}return{edit:c,extensionNames:Array.from(o)}}}e.$mdc=P}),define(De[314],Ce([1,0,3,2,6,13,7,34,8]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;class b{static{this.a=0}constructor(y,k){this.extension=y,this.provider=k,this.handle=b.a++}}class L{constructor(y){this.session=y,this.responses=[]}}class P{static{this.a=0}constructor(y,k,v,h){this.f=v,this.g=h,this.b=new Map,this.d=new Map,this.e=y.getProxy(f.$pK.MainThreadInlineChat),k.registerApiCommand(new m.$QM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$OM("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?R.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?R.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?R.Position.from(o.position):void 0}})],m.$PM.Void))}registerProvider(y,k,v){const h=new b(y,k);return this.b.set(h.handle,h),this.e.$registerInteractiveEditorProvider(h.handle,v.label,y.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function"),(0,C.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(h.handle),this.b.delete(h.handle)})}async $prepareSession(y,k,v,h){const o=this.b.get(y);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const l=this.f.getDocument(O.URI.revive(k)),c=R.Selection.to(v),d=await o.provider.prepareInteractiveEditorSession({document:l,selection:c},h);if(!d)return;if(d.wholeRange&&!d.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=P.a++;return this.d.set(a,new L(d)),{id:a,placeholder:d.placeholder,input:d.input,slashCommands:d.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:R.Range.from(d.wholeRange),message:d.message}}async $provideResponse(y,k,v,h){const o=this.b.get(y);if(!o)return;const l=this.d.get(k.id);if(!l)return;const c={prompt:v.prompt,selection:R.Selection.to(v.selection),wholeRange:R.Range.to(v.wholeRange),attempt:v.attempt,live:v.live};let d=!1;const a={report:async u=>{if(!v.live&&u.edits?.length)throw new Error("Progress reporting is only supported for live sessions");d||h.isCancellationRequested||await this.e.$handleProgressChunk(v.requestId,{message:u.message,edits:u.edits?.map(R.TextEdit.from),editsShouldBeInstant:u.editsShouldBeInstant,slashCommand:u.slashCommand?.command,markdownFragment:A.$RK.isMarkdownString(u.content)?u.content.value:u.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(l.session,c,a,h));let i;try{i=await(0,E.$Jg)(t,h)}finally{d=!0}if(!i)return;const s=l.responses.push(i)-1,n={wholeRange:R.Range.from(i.wholeRange),placeholder:i.placeholder};if(P.h(i))return{...n,id:s,type:"message",message:R.MarkdownString.from(i.contents)};const{edits:r}=i;return r instanceof A.$BK?{...n,id:s,type:"bulkEdit",edits:R.WorkspaceEdit.from(r)}:{...n,id:s,type:"editorEdit",edits:r.map(R.TextEdit.from)}}$handleFeedback(y,k,v,h){const o=this.b.get(y),l=this.d.get(k),c=l?.responses[v];if(o&&c){const d=R.InteractiveEditorResponseFeedbackKind.to(h);o.provider.handleInteractiveEditorResponseFeedback?.(l.session,c,d)}}$releaseSession(y,k){}static h(y){return typeof y=="object"&&typeof y.contents=="object"}}e.$tec=P}),define(De[315],Ce([1,0,2,34]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;class f{constructor(A,m,E,b,L){this.a=m,this.b=E,this.c=b;const P=new O.$QM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$OM("showOptions","Show Options",p=>!0,p=>p),new O.$OM("resource","Interactive resource Uri",p=>!0,p=>p),new O.$OM("controllerId","Notebook controller Id",p=>!0,p=>p),new O.$OM("title","Interactive editor title",p=>!0,p=>p)],new O.$PM("Notebook and input URI",p=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const y=this.a.getEditorById(p.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri),notebookEditor:y.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(A,m,E,b){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$pec=f}),define(De[316],Ce([1,0,6,7]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;class f{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(C.$pK.MainThreadIssueReporter)}async $getIssueReporterUri(A,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const b=await E.handleIssueUrlRequest();if(!b)throw new Error("Issue request handler returned no result");return b}async $getIssueReporterData(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(A);if(!E)throw new Error("Issue data provider not found");const b=await E.provideIssueData(m);if(!b)throw new Error("Issue data provider returned no result");return b}async $getIssueReporterTemplate(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(A);if(!E)throw new Error("Issue data provider not found");const b=await E.provideIssueTemplate(m);if(!b)throw new Error("Issue template provider returned no result");return b}registerIssueUriRequestHandler(A,m){const E=A.identifier.value;return this.a.set(E,m),this.c.$registerIssueUriRequestHandler(E),new O.$rK(()=>{this.c.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}registerIssueDataProvider(A,m){const E=A.identifier.value;return this.b.set(E,m),this.c.$registerIssueDataProvider(E),new O.$rK(()=>{this.c.$unregisterIssueDataProvider(E),this.b.delete(E)})}}e.$vec=f}),define(De[317],Ce([1,0,3,6]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class f{constructor(A){this.b=0,this.a=A.getProxy(O.$pK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,A),(0,C.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Idc=f}),define(De[318],Ce([1,0,2,24,13,7,83,6,15,32,19,17,165,21,25,3,129,119,107,35,9,8,26,206]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d,a,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;class s{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentSymbols(U,Q){const se=this.d.getDocument(U),oe=await this.e.provideDocumentSymbols(se,Q);if(!(0,L.$Kb)(oe))return oe[0]instanceof R.$JK?oe.map(f.DocumentSymbol.from):s.f(oe)}static f(U){U=U.slice(0).sort((oe,Z)=>{let ge=oe.location.range.start.compareTo(Z.location.range.start);return ge===0&&(ge=Z.location.range.end.compareTo(oe.location.range.end)),ge});const Q=[],se=[];for(const oe of U){const Z={name:oe.name||"!!MISSING: name!!",kind:f.SymbolKind.from(oe.kind),tags:oe.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:f.Range.from(oe.location.range),selectionRange:f.Range.from(oe.location.range),children:[]};for(;;){if(se.length===0){se.push(Z),Q.push(Z);break}const ge=se[se.length-1];if(b.$xs.containsRange(ge.range,Z.range)&&!b.$xs.equalsRange(ge.range,Z.range)){ge.children?.push(Z),se.push(Z);break}se.pop()}}return Q}}class n{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(U,Q,se){this.g=U,this.h=Q,this.j=se,this.e=new l.$wcc("CodeLens"),this.f=new Map}async provideCodeLenses(U,Q){const se=this.g.getDocument(U),oe=await this.j.provideCodeLenses(se,Q);if(!oe||Q.isCancellationRequested)return;const Z=this.e.add(oe),ge=new v.$Rc;this.f.set(Z,ge);const Ee={cacheId:Z,lenses:[]};for(let ze=0;ze<oe.length;ze++)Ee.lenses.push({cacheId:[Z,ze],range:f.Range.from(oe[ze].range),command:this.h.toInternal(oe[ze].command,ge)});return Ee}async resolveCodeLens(U,Q){const se=U.cacheId&&this.e.get(...U.cacheId);if(!se)return;let oe;if(typeof this.j.resolveCodeLens!="function"||se.isResolved?oe=se:oe=await this.j.resolveCodeLens(se,Q),oe||(oe=se),Q.isCancellationRequested)return;const Z=U.cacheId&&this.f.get(U.cacheId[0]);if(Z)return U.command=this.h.toInternal(oe.command??n.d,Z),U}releaseCodeLenses(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}}function r(Pe){return Array.isArray(Pe)?Pe.map(f.DefinitionLink.from):Pe?[f.DefinitionLink.from(Pe)]:[]}class u{constructor(U,Q){this.d=U,this.e=Q}async provideDefinition(U,Q,se){const oe=this.d.getDocument(U),Z=f.Position.to(Q),ge=await this.e.provideDefinition(oe,Z,se);return r(ge)}}class I{constructor(U,Q){this.d=U,this.e=Q}async provideDeclaration(U,Q,se){const oe=this.d.getDocument(U),Z=f.Position.to(Q),ge=await this.e.provideDeclaration(oe,Z,se);return r(ge)}}class S{constructor(U,Q){this.d=U,this.e=Q}async provideImplementation(U,Q,se){const oe=this.d.getDocument(U),Z=f.Position.to(Q),ge=await this.e.provideImplementation(oe,Z,se);return r(ge)}}class ${constructor(U,Q){this.d=U,this.e=Q}async provideTypeDefinition(U,Q,se){const oe=this.d.getDocument(U),Z=f.Position.to(Q),ge=await this.e.provideTypeDefinition(oe,Z,se);return r(ge)}}class g{constructor(U,Q){this.d=U,this.e=Q}async provideHover(U,Q,se){const oe=this.d.getDocument(U),Z=f.Position.to(Q),ge=await this.e.provideHover(oe,Z,se);if(!(!ge||(0,L.$Kb)(ge.contents)))return ge.range||(ge.range=oe.getWordRangeAtPosition(Z)),ge.range||(ge.range=new R.$tK(Z,Z)),f.Hover.from(ge)}}class w{constructor(U,Q){this.d=U,this.e=Q}async provideEvaluatableExpression(U,Q,se){const oe=this.d.getDocument(U),Z=f.Position.to(Q),ge=await this.e.provideEvaluatableExpression(oe,Z,se);if(ge)return f.EvaluatableExpression.from(ge)}}class D{constructor(U,Q){this.d=U,this.e=Q}async provideInlineValues(U,Q,se,oe){const Z=this.d.getDocument(U),ge=await this.e.provideInlineValues(Z,f.Range.to(Q),f.InlineValueContext.to(se),oe);if(Array.isArray(ge))return ge.map(Ee=>f.InlineValue.from(Ee))}}class T{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentHighlights(U,Q,se){const oe=this.d.getDocument(U),Z=f.Position.to(Q),ge=await this.e.provideDocumentHighlights(oe,Z,se);if(Array.isArray(ge))return ge.map(f.DocumentHighlight.from)}}class M{constructor(U,Q){this.d=U,this.e=Q}async provideLinkedEditingRanges(U,Q,se){const oe=this.d.getDocument(U),Z=f.Position.to(Q),ge=await this.e.provideLinkedEditingRanges(oe,Z,se);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,L.$Hb)(ge.ranges.map(f.Range.from)),wordPattern:ge.wordPattern}}}class F{constructor(U,Q){this.d=U,this.e=Q}async provideReferences(U,Q,se,oe){const Z=this.d.getDocument(U),ge=f.Position.to(Q),Ee=await this.e.provideReferences(Z,ge,se,oe);if(Array.isArray(Ee))return Ee.map(f.location.from)}}class z{static{this.d=1e3}constructor(U,Q,se,oe,Z,ge,Ee){this.g=U,this.h=Q,this.j=se,this.k=oe,this.l=Z,this.m=ge,this.n=Ee,this.e=new l.$wcc("CodeAction"),this.f=new Map}async provideCodeActions(U,Q,se,oe){const Z=this.g.getDocument(U),ge=p.$zs.isISelection(Q)?f.Selection.to(Q):f.Range.to(Q),Ee=[];for(const tt of this.j.getDiagnostics(U))if(ge.intersection(tt.range)&&Ee.push(tt)>z.d)break;const ze={diagnostics:Ee,only:se.only?new R.$LK(se.only):void 0,triggerKind:f.CodeActionTriggerKind.to(se.trigger)},We=await this.k.provideCodeActions(Z,ge,ze,oe);if(!(0,L.$Lb)(We)||oe.isCancellationRequested)return;const _e=this.e.add(We),Ye=new v.$Rc;this.f.set(_e,Ye);const it=[];for(let tt=0;tt<We.length;tt++){const Ae=We[tt];Ae&&(z.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ye)})):(ze.only&&(Ae.kind?ze.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,tt],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(f.Diagnostic.from),edit:Ae.edit&&f.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$kF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(U,Q){const[se,oe]=U,Z=this.e.get(se,oe);if(!Z||z.o(Z))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(Z,Q)??Z;let Ee;ge.edit&&(Ee=f.WorkspaceEdit.from(ge.edit,void 0));let ze;if(ge.command){const We=this.f.get(se);We&&(ze=this.h.toInternal(ge.command,We))}return{edit:Ee,command:ze}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class j{static toInternalProviderId(U,Q){return U+"."+Q}constructor(U,Q,se,oe,Z){this.d=U,this.e=Q,this.f=se,this.g=oe,this.h=Z}async prepareDocumentPaste(U,Q,se,oe){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(U),ge=Q.map(We=>f.Range.to(We)),Ee=f.DataTransfer.toDataTransfer(se,()=>{throw new d.$$});if(await this.f.prepareDocumentPaste(Z,ge,Ee,oe),oe.isCancellationRequested)return;const ze=Array.from(Ee).filter(([,We])=>!(We instanceof R.$fL));return f.DataTransfer.from(ze)}async providePasteEdits(U,Q,se,oe,Z){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(Q),Ee=se.map(_e=>f.Range.to(_e)),ze=f.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolvePasteFileData(this.g,U,_e)).buffer),We=await this.f.provideDocumentPasteEdits(ge,Ee,ze,Z);if(We)return{label:We.label??(0,i.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:j.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class N{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentFormattingEdits(U,Q,se){const oe=this.d.getDocument(U),Z=await this.e.provideDocumentFormattingEdits(oe,Q,se);if(Array.isArray(Z))return Z.map(f.TextEdit.from)}}class q{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentRangeFormattingEdits(U,Q,se,oe){const Z=this.d.getDocument(U),ge=f.Range.to(Q),Ee=await this.e.provideDocumentRangeFormattingEdits(Z,ge,se,oe);if(Array.isArray(Ee))return Ee.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,Q,se,oe){(0,P.$Jf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(U),ge=Q.map(f.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Z,ge,se,oe);if(Array.isArray(Ee))return Ee.map(f.TextEdit.from)}}class K{constructor(U,Q){this.d=U,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,Q,se,oe,Z){const ge=this.d.getDocument(U),Ee=f.Position.to(Q),ze=await this.e.provideOnTypeFormattingEdits(ge,Ee,se,oe,Z);if(Array.isArray(ze))return ze.map(f.TextEdit.from)}}class me{constructor(U,Q){this.e=U,this.f=Q,this.d=new l.$wcc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,Q){const se=await this.e.provideWorkspaceSymbols(U,Q);if(!(0,L.$Lb)(se))return{symbols:[]};const oe=this.d.add(se),Z={cacheId:oe,symbols:[]};for(let ge=0;ge<se.length;ge++){const Ee=se[ge];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Z.symbols.push({...f.WorkspaceSymbol.from(Ee),cacheId:[oe,ge]})}return Z}async resolveWorkspaceSymbol(U,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const se=this.d.get(...U.cacheId);if(se){const oe=await this.e.resolveWorkspaceSymbol(se,Q);return oe&&(0,O.$$m)(U,f.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class te{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,Q,se){this.d=U,this.e=Q,this.f=se}async provideRenameEdits(U,Q,se,oe){const Z=this.d.getDocument(U),ge=f.Position.to(Q);try{const Ee=await this.e.provideRenameEdits(Z,ge,se,oe);return Ee?f.WorkspaceEdit.from(Ee):void 0}catch(Ee){const ze=te.g(Ee);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(U,Q,se){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(U),Z=f.Position.to(Q);try{const ge=await this.e.prepareRename(oe,Z,se);let Ee,ze;if(R.$tK.isRange(ge)?(Ee=ge,ze=oe.getText(ge)):(0,P.$Bf)(ge)&&(Ee=ge.range,ze=ge.placeholder),!Ee||!ze)return;if(Ee.start.line>Z.line||Ee.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(Ee),text:ze}}catch(ge){const Ee=te.g(ge);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(ge)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class G{constructor(U,Q){this.resultId=U,this.tokens=Q}}class J{constructor(U,Q){this.f=U,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,Q,se){const oe=this.f.getDocument(U),Z=Q!==0?this.d.get(Q):null;let ge=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,Z.resultId,se):await this.g.provideDocumentSemanticTokens(oe,se);return Z&&this.d.delete(Q),ge?(ge=J.h(ge),this.o(J.n(Z,ge),ge)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return J.j(U)?J.k(U)?U:new R.$IL(new Uint32Array(U.data),U.resultId):J.l(U)?J.m(U)?U:new R.$KL(U.edits.map(Q=>new R.$JL(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const Q of U.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(U,Q){if(!J.j(Q)||!U||!U.tokens)return Q;const se=U.tokens,oe=se.length,Z=Q.data,ge=Z.length;let Ee=0;const ze=Math.min(oe,ge);for(;Ee<ze&&se[Ee]===Z[Ee];)Ee++;if(Ee===oe&&Ee===ge)return new R.$KL([],Q.resultId);let We=0;const _e=ze-Ee;for(;We<_e&&se[oe-We-1]===Z[ge-We-1];)We++;return new R.$KL([{start:Ee,deleteCount:oe-Ee-We,data:Z.subarray(Ee,ge-We)}],Q.resultId)}o(U,Q){if(J.j(U)){const se=this.e++;return this.d.set(se,new G(U.resultId,U.data)),(0,h.$80)({id:se,type:"full",data:U.data})}if(J.l(U)){const se=this.e++;return J.j(Q)?this.d.set(se,new G(Q.resultId,Q.data)):this.d.set(se,new G(U.resultId)),(0,h.$80)({id:se,type:"delta",deltas:(U.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class le{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentRangeSemanticTokens(U,Q,se){const oe=this.d.getDocument(U),Z=await this.e.provideDocumentRangeSemanticTokens(oe,f.Range.to(Q),se);return Z?this.f(Z):null}f(U){return(0,h.$80)({id:0,type:"full",data:U.data})}}class ie{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,Q,se,oe,Z){this.f=U,this.g=Q,this.h=se,this.j=oe,this.k=Z,this.d=new l.$wcc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,Q,se,oe){const Z=this.f.getDocument(U),ge=f.Position.to(Q),Ee=Z.getWordRangeAtPosition(ge)||new R.$tK(ge,ge),ze=Ee.with({end:ge}),We=new c.$Kd,_e=await this.h.provideCompletionItems(Z,ge,oe,f.CompletionContext.to(se));if(!_e||oe.isCancellationRequested)return;const Ye=Array.isArray(_e)?new R.$YK(_e):_e,it=ie.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),tt=new v.$Rc;this.e.set(it,tt);const Ae=[],Te={x:it,b:Ae,a:{replace:f.Range.from(Ee),insert:f.Range.from(ze)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Ye.items.length;qe++){const Le=Ye.items[qe],Xe=this.l(Le,[it,qe],ze,Ee);Ae.push(Xe)}return Te}async resolveCompletionItem(U,Q){if(typeof this.h.resolveCompletionItem!="function")return;const se=this.d.get(...U);if(!se)return;const oe=this.l(se,U),Z=await this.h.resolveCompletionItem(se,Q);if(!Z)return;const ge=this.l(Z,U);return(oe.h!==ge.h||oe.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==ge.n||oe.o!==ge.o||!(0,O.$_m)(oe.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,Q,se,oe){const Z=this.e.get(Q[0]);if(!Z)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(U.command,Z),Ee={x:Q,a:U.label,b:U.kind!==void 0?f.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(f.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:f.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(f.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=U.textEdit.newText):typeof U.insertText=="string"?Ee.h=U.insertText:U.insertText instanceof R.$CK&&(Ee.h=U.insertText.value,Ee.i|=4);let ze;return U.textEdit?ze=U.textEdit.range:U.range&&(ze=U.range),R.$tK.isRange(ze)?Ee.j=f.Range.from(ze):ze&&(!se?.isEqual(ze.inserting)||!oe?.isEqual(ze.replacing))&&(Ee.j={insert:f.Range.from(ze.inserting),replace:f.Range.from(ze.replacing)}),Ee}}class ce{async provideInlineCompletions(U,Q,se,oe){}disposeCompletions(U){}handleDidShowCompletionItem(U,Q,se){}handlePartialAccept(U,Q,se){}}class ye extends ce{constructor(U,Q,se,oe){super(),this.f=U,this.g=Q,this.h=se,this.j=oe,this.d=new H,this.e=(0,t.$kF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$kF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,Q,se,oe){const Z=this.g.getDocument(U),ge=f.Position.to(Q),Ee=await this.h.provideInlineCompletionItems(Z,ge,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:f.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[se.triggerKind]},oe);if(!Ee||oe.isCancellationRequested)return;const ze=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:ze}),items:ze.map((tt,Ae)=>{let Te;tt.command&&(Ye||(Ye=new v.$Rc),Te=this.j.toInternal(tt.command,Ye));const qe=tt.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:tt.filterText,range:tt.range?f.Range.from(tt.range):void 0,command:Te,idx:Ae,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:We.map(tt=>(Ye||(Ye=new v.$Rc),this.j.toInternal(tt,Ye))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,Q,se){const oe=this.d.get(U)?.items[Q];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,se)}handlePartialAccept(U,Q,se){const oe=this.d.get(U)?.items[Q];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,se)}}class H{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const Q=this.e++;return this.d.set(Q,U),Q}disposeReferenceId(U){const Q=this.d.get(U);return this.d.delete(U),Q}get(U){return this.d.get(U)}}class B{constructor(U,Q){this.e=U,this.f=Q,this.d=new l.$wcc("SignatureHelp")}async provideSignatureHelp(U,Q,se,oe){const Z=this.e.getDocument(U),ge=f.Position.to(Q),Ee=this.g(se),ze=await this.f.provideSignatureHelp(Z,ge,oe,Ee);if(ze){const We=this.d.add([ze]);return{...f.SignatureHelp.from(ze),id:We}}}g(U){let Q;if(U.activeSignatureHelp){const se=f.SignatureHelp.to(U.activeSignatureHelp),oe=this.d.get(U.activeSignatureHelp.id,0);oe?(Q=oe,Q.activeSignature=se.activeSignature,Q.activeParameter=se.activeParameter):Q=se}return{...U,activeSignatureHelp:Q}}releaseSignatureHelp(U){this.d.delete(U)}}class Y{constructor(U,Q,se,oe,Z){this.f=U,this.g=Q,this.h=se,this.j=oe,this.k=Z,this.d=new l.$wcc("InlayHints"),this.e=new Map}async provideInlayHints(U,Q,se){const oe=this.f.getDocument(U),Z=f.Range.to(Q),ge=await this.h.provideInlayHints(oe,Z,se);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Q}`);return}if(se.isCancellationRequested)return;const Ee=this.d.add(ge);this.e.set(Ee,new v.$Rc);const ze={hints:[],cacheId:Ee};for(let We=0;We<ge.length;We++)this.l(ge[We],Z)&&ze.hints.push(this.m(ge[We],[Ee,We]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for ${Q}`),ze}async resolveInlayHint(U,Q){if(typeof this.h.resolveInlayHint!="function")return;const se=this.d.get(...U);if(!se)return;const oe=await this.h.resolveInlayHint(se,Q);if(oe&&this.l(oe))return this.m(oe,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,Q){return U.label.length===0||Array.isArray(U.label)&&U.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(Q&&!Q.contains(U.position))}m(U,Q){const se=this.e.get(Q[0]);if(!se)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:Q,tooltip:f.MarkdownString.fromStrict(U.tooltip),position:f.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(f.TextEdit.from),kind:U.kind&&f.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};return typeof U.label=="string"?oe.label=U.label:oe.label=U.label.map(Z=>{const ge={label:Z.value};return ge.tooltip=f.MarkdownString.fromStrict(Z.tooltip),R.$DK.isLocation(Z.location)&&(ge.location=f.location.from(Z.location)),Z.command&&(ge.command=this.g.toInternal(Z.command,se)),ge}),oe}}class re{constructor(U,Q){this.e=U,this.f=Q,this.d=new l.$wcc("DocumentLink")}async provideLinks(U,Q){const se=this.e.getDocument(U),oe=await this.f.provideDocumentLinks(se,Q);if(!(!Array.isArray(oe)||oe.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(re.g).map(f.DocumentLink.from)};{const Z=this.d.add(oe),ge={links:[],cacheId:Z};for(let Ee=0;Ee<oe.length;Ee++){if(!re.g(oe[Ee]))continue;const ze=f.DocumentLink.from(oe[Ee]);ze.cacheId=[Z,Ee],ge.links.push(ze)}return ge}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,Q){if(typeof this.f.resolveDocumentLink!="function")return;const se=this.d.get(...U);if(!se)return;const oe=await this.f.resolveDocumentLink(se,Q);if(!(!oe||!re.g(oe)))return f.DocumentLink.from(oe)}releaseLinks(U){this.d.delete(U)}}class X{constructor(U,Q){this.d=U,this.e=Q}async provideColors(U,Q){const se=this.d.getDocument(U),oe=await this.e.provideDocumentColors(se,Q);return Array.isArray(oe)?oe.map(ge=>({color:f.Color.from(ge.color),range:f.Range.from(ge.range)})):[]}async provideColorPresentations(U,Q,se){const oe=this.d.getDocument(U),Z=f.Range.to(Q.range),ge=f.Color.to(Q.color),Ee=await this.e.provideColorPresentations(ge,{document:oe,range:Z},se);if(Array.isArray(Ee))return Ee.map(f.ColorPresentation.from)}}class _{constructor(U,Q){this.d=U,this.e=Q}async provideFoldingRanges(U,Q,se){const oe=this.d.getDocument(U),Z=await this.e.provideFoldingRanges(oe,Q,se);if(Array.isArray(Z))return Z.map(f.FoldingRange.from)}}class x{constructor(U,Q,se){this.d=U,this.e=Q,this.f=se}async provideSelectionRanges(U,Q,se){const oe=this.d.getDocument(U),Z=Q.map(f.Position.to),ge=await this.e.provideSelectionRanges(oe,Z,se);if(!(0,L.$Lb)(ge))return[];if(ge.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let ze=0;ze<Z.length;ze++){const We=[];Ee.push(We);let _e=Z[ze],Ye=ge[ze];for(;;){if(!Ye.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(f.SelectionRange.from(Ye)),!Ye.parent)break;_e=Ye.range,Ye=Ye.parent}}return Ee}}class pe{constructor(U,Q){this.f=U,this.g=Q,this.d=new o.$vM(""),this.e=new Map}async prepareSession(U,Q,se){const oe=this.f.getDocument(U),Z=f.Position.to(Q),ge=await this.g.prepareCallHierarchy(oe,Z,se);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ee,ze)):[this.h(Ee,ge)]}async provideCallsTo(U,Q,se){const oe=this.j(U,Q);if(!oe)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(oe,se);if(Z)return Z.map(ge=>({from:this.h(U,ge.from),fromRanges:ge.fromRanges.map(Ee=>f.Range.from(Ee))}))}async provideCallsFrom(U,Q,se){const oe=this.j(U,Q);if(!oe)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(oe,se);if(Z)return Z.map(ge=>({to:this.h(U,ge.to),fromRanges:ge.fromRanges.map(Ee=>f.Range.from(Ee))}))}releaseSession(U){this.e.delete(U)}h(U,Q){const se=this.e.get(U),oe=f.CallHierarchyItem.from(Q,U,se.size.toString(36));return se.set(oe._itemId,Q),oe}j(U,Q){return this.e.get(U)?.get(Q)}}class ae{constructor(U,Q){this.f=U,this.g=Q,this.d=new o.$vM(""),this.e=new Map}async prepareSession(U,Q,se){const oe=this.f.getDocument(U),Z=f.Position.to(Q),ge=await this.g.prepareTypeHierarchy(oe,Z,se);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ee,ze)):[this.h(Ee,ge)]}async provideSupertypes(U,Q,se){const oe=this.j(U,Q);if(!oe)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(oe,se);if(Z)return Z.map(ge=>this.h(U,ge))}async provideSubtypes(U,Q,se){const oe=this.j(U,Q);if(!oe)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(oe,se);if(Z)return Z.map(ge=>this.h(U,ge))}releaseSession(U){this.e.delete(U)}h(U,Q){const se=this.e.get(U),oe=f.TypeHierarchyItem.from(Q,U,se.size.toString(36));return se.set(oe._itemId,Q),oe}j(U,Q){return this.e.get(U)?.get(Q)}}class fe{static toInternalProviderId(U,Q){return U+"."+Q}constructor(U,Q,se,oe,Z){this.d=U,this.e=Q,this.f=se,this.g=oe,this.h=Z}async provideDocumentOnDropEdits(U,Q,se,oe,Z){const ge=this.e.getDocument(Q),Ee=f.Position.to(se),ze=f.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,U,_e)).buffer),We=await this.f.provideDocumentDropEdits(ge,Ee,ze,Z);if(We)return{label:We.label??(0,i.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:fe.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor(U,Q){this.d=U,this.e=Q}async provideMappedEdits(U,Q,se,oe){const Z=C.URI.revive(U),ge=this.d.getDocument(Z),Ee=se.documents.map(_e=>_e.map(Ye=>({uri:C.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(it=>f.Range.to(it))}))),ze={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,Q,ze,oe);return We?f.WorkspaceEdit.from(We):null}}class de{constructor(U,Q){this.adapter=U,this.extension=Q}}class be{static{this.d=0}constructor(U,Q,se,oe,Z,ge,Ee,ze){this.g=Q,this.h=se,this.j=oe,this.k=Z,this.l=ge,this.m=Ee,this.n=ze,this.f=new Map,this.e=U.getProxy(m.$pK.MainThreadLanguageFeatures)}o(U,Q){return f.DocumentSelector.from(U,this.g,Q)}p(U){return new R.$rK(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return be.d++}async s(U,Q,se,oe,Z,ge=!1){const Ee=this.f.get(U);if(!Ee||!(Ee.adapter instanceof Q))return oe;const ze=Date.now();ge||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const We=se(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(_e=>{(0,d.$4)(_e)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ee.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),y.CancellationToken.isCancellationToken(Z)?(0,a.$Kg)(We,Z):We}t(U,Q){const se=this.q();return this.f.set(se,new de(U,Q)),se}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,Q,se,oe){const Z=this.t(new s(this.h,se),U),ge=oe&&oe.label||be.u(U);return this.e.$registerDocumentSymbolProvider(Z,this.o(Q,U),ge),this.p(Z)}$provideDocumentSymbols(U,Q,se){return this.s(U,s,oe=>oe.provideDocumentSymbols(C.URI.revive(Q),se),void 0,se)}registerCodeLensProvider(U,Q,se){const oe=this.q(),Z=typeof se.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new de(new n(this.h,this.j.converter,se),U)),this.e.$registerCodeLensSupport(oe,this.o(Q,U),Z);let ge=this.p(oe);if(Z!==void 0){const Ee=se.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(Z));ge=R.$rK.from(ge,Ee)}return ge}$provideCodeLenses(U,Q,se){return this.s(U,n,oe=>oe.provideCodeLenses(C.URI.revive(Q),se),void 0,se)}$resolveCodeLens(U,Q,se){return this.s(U,n,oe=>oe.resolveCodeLens(Q,se),void 0,void 0)}$releaseCodeLenses(U,Q){this.s(U,n,se=>Promise.resolve(se.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(U,Q,se){const oe=this.t(new u(this.h,se),U);return this.e.$registerDefinitionSupport(oe,this.o(Q,U)),this.p(oe)}$provideDefinition(U,Q,se,oe){return this.s(U,u,Z=>Z.provideDefinition(C.URI.revive(Q),se,oe),[],oe)}registerDeclarationProvider(U,Q,se){const oe=this.t(new I(this.h,se),U);return this.e.$registerDeclarationSupport(oe,this.o(Q,U)),this.p(oe)}$provideDeclaration(U,Q,se,oe){return this.s(U,I,Z=>Z.provideDeclaration(C.URI.revive(Q),se,oe),[],oe)}registerImplementationProvider(U,Q,se){const oe=this.t(new S(this.h,se),U);return this.e.$registerImplementationSupport(oe,this.o(Q,U)),this.p(oe)}$provideImplementation(U,Q,se,oe){return this.s(U,S,Z=>Z.provideImplementation(C.URI.revive(Q),se,oe),[],oe)}registerTypeDefinitionProvider(U,Q,se){const oe=this.t(new $(this.h,se),U);return this.e.$registerTypeDefinitionSupport(oe,this.o(Q,U)),this.p(oe)}$provideTypeDefinition(U,Q,se,oe){return this.s(U,$,Z=>Z.provideTypeDefinition(C.URI.revive(Q),se,oe),[],oe)}registerHoverProvider(U,Q,se,oe){const Z=this.t(new g(this.h,se),U);return this.e.$registerHoverProvider(Z,this.o(Q,U)),this.p(Z)}$provideHover(U,Q,se,oe){return this.s(U,g,Z=>Z.provideHover(C.URI.revive(Q),se,oe),void 0,oe)}registerEvaluatableExpressionProvider(U,Q,se,oe){const Z=this.t(new w(this.h,se),U);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(Q,U)),this.p(Z)}$provideEvaluatableExpression(U,Q,se,oe){return this.s(U,w,Z=>Z.provideEvaluatableExpression(C.URI.revive(Q),se,oe),void 0,oe)}registerInlineValuesProvider(U,Q,se,oe){const Z=typeof se.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new D(this.h,se),U);this.e.$registerInlineValuesProvider(ge,this.o(Q,U),Z);let Ee=this.p(ge);if(Z!==void 0){const ze=se.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Z));Ee=R.$rK.from(Ee,ze)}return Ee}$provideInlineValues(U,Q,se,oe,Z){return this.s(U,D,ge=>ge.provideInlineValues(C.URI.revive(Q),se,oe,Z),void 0,Z)}registerDocumentHighlightProvider(U,Q,se){const oe=this.t(new T(this.h,se),U);return this.e.$registerDocumentHighlightProvider(oe,this.o(Q,U)),this.p(oe)}$provideDocumentHighlights(U,Q,se,oe){return this.s(U,T,Z=>Z.provideDocumentHighlights(C.URI.revive(Q),se,oe),void 0,oe)}registerLinkedEditingRangeProvider(U,Q,se){const oe=this.t(new M(this.h,se),U);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(Q,U)),this.p(oe)}$provideLinkedEditingRanges(U,Q,se,oe){return this.s(U,M,async Z=>{const ge=await Z.provideLinkedEditingRanges(C.URI.revive(Q),se,oe);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?be.w(ge.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(U,Q,se){const oe=this.t(new F(this.h,se),U);return this.e.$registerReferenceSupport(oe,this.o(Q,U)),this.p(oe)}$provideReferences(U,Q,se,oe,Z){return this.s(U,F,ge=>ge.provideReferences(C.URI.revive(Q),se,oe,Z),void 0,Z)}registerCodeActionProvider(U,Q,se,oe){const Z=new v.$Rc,ge=this.t(new z(this.h,this.j.converter,this.k,se,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(ge,this.o(Q,U),{providedKinds:oe?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:oe?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Z)}))},be.u(U),!!se.resolveCodeAction),Z.add(this.p(ge)),Z}$provideCodeActions(U,Q,se,oe,Z){return this.s(U,z,ge=>ge.provideCodeActions(C.URI.revive(Q),se,oe,Z),void 0,Z)}$resolveCodeAction(U,Q,se){return this.s(U,z,oe=>oe.resolveCodeAction(Q,se),{},void 0)}$releaseCodeActions(U,Q){this.s(U,z,se=>Promise.resolve(se.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(U,Q,se){const oe=this.t(new N(this.h,se),U);return this.e.$registerDocumentFormattingSupport(oe,this.o(Q,U),U.identifier,U.displayName||U.name),this.p(oe)}$provideDocumentFormattingEdits(U,Q,se,oe){return this.s(U,N,Z=>Z.provideDocumentFormattingEdits(C.URI.revive(Q),se,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(U,Q,se){const oe=typeof se.provideDocumentRangesFormattingEdits=="function",Z=this.t(new q(this.h,se),U);return this.e.$registerRangeFormattingSupport(Z,this.o(Q,U),U.identifier,U.displayName||U.name,oe),this.p(Z)}$provideDocumentRangeFormattingEdits(U,Q,se,oe,Z){return this.s(U,q,ge=>ge.provideDocumentRangeFormattingEdits(C.URI.revive(Q),se,oe,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(U,Q,se,oe,Z){return this.s(U,q,ge=>ge.provideDocumentRangesFormattingEdits(C.URI.revive(Q),se,oe,Z),void 0,Z)}registerOnTypeFormattingEditProvider(U,Q,se,oe){const Z=this.t(new K(this.h,se),U);return this.e.$registerOnTypeFormattingSupport(Z,this.o(Q,U),oe,U.identifier),this.p(Z)}$provideOnTypeFormattingEdits(U,Q,se,oe,Z,ge){return this.s(U,K,Ee=>Ee.provideOnTypeFormattingEdits(C.URI.revive(Q),se,oe,Z,ge),void 0,ge)}registerWorkspaceSymbolProvider(U,Q){const se=this.t(new me(Q,this.l),U);return this.e.$registerNavigateTypeSupport(se,typeof Q.resolveWorkspaceSymbol=="function"),this.p(se)}$provideWorkspaceSymbols(U,Q,se){return this.s(U,me,oe=>oe.provideWorkspaceSymbols(Q,se),{symbols:[]},se)}$resolveWorkspaceSymbol(U,Q,se){return this.s(U,me,oe=>oe.resolveWorkspaceSymbol(Q,se),void 0,void 0)}$releaseWorkspaceSymbols(U,Q){this.s(U,me,se=>se.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(U,Q,se){const oe=this.t(new te(this.h,se,this.l),U);return this.e.$registerRenameSupport(oe,this.o(Q,U),te.supportsResolving(se)),this.p(oe)}$provideRenameEdits(U,Q,se,oe,Z){return this.s(U,te,ge=>ge.provideRenameEdits(C.URI.revive(Q),se,oe,Z),void 0,Z)}$resolveRenameLocation(U,Q,se,oe){return this.s(U,te,Z=>Z.resolveRenameLocation(C.URI.revive(Q),se,oe),void 0,oe)}registerDocumentSemanticTokensProvider(U,Q,se,oe){const Z=this.t(new J(this.h,se),U),ge=typeof se.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(Q,U),oe,ge);let Ee=this.p(Z);if(ge){const ze=se.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));Ee=R.$rK.from(Ee,ze)}return Ee}$provideDocumentSemanticTokens(U,Q,se,oe){return this.s(U,J,Z=>Z.provideDocumentSemanticTokens(C.URI.revive(Q),se,oe),null,oe)}$releaseDocumentSemanticTokens(U,Q){this.s(U,J,se=>se.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,Q,se,oe){const Z=this.t(new le(this.h,se),U);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(Q,U),oe),this.p(Z)}$provideDocumentRangeSemanticTokens(U,Q,se,oe){return this.s(U,le,Z=>Z.provideDocumentRangeSemanticTokens(C.URI.revive(Q),se,oe),null,oe)}registerCompletionItemProvider(U,Q,se,oe){const Z=this.t(new ie(this.h,this.j.converter,se,this.m,U),U);return this.e.$registerCompletionsProvider(Z,this.o(Q,U),oe,ie.supportsResolving(se),U.identifier),this.p(Z)}$provideCompletionItems(U,Q,se,oe,Z){return this.s(U,ie,ge=>ge.provideCompletionItems(C.URI.revive(Q),se,oe,Z),void 0,Z)}$resolveCompletionItem(U,Q,se){return this.s(U,ie,oe=>oe.resolveCompletionItem(Q,se),void 0,se)}$releaseCompletionItems(U,Q){this.s(U,ie,se=>se.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(U,Q,se,oe){const Z=new ye(U,this.h,se,this.j.converter),ge=this.t(Z,U);return this.e.$registerInlineCompletionsSupport(ge,this.o(Q,U),Z.supportsHandleEvents,k.$7l.toKey(U.identifier.value),oe?.yieldTo?.map(Ee=>k.$7l.toKey(Ee))||[]),this.p(ge)}$provideInlineCompletions(U,Q,se,oe,Z){return this.s(U,ce,ge=>ge.provideInlineCompletions(C.URI.revive(Q),se,oe,Z),void 0,Z)}$handleInlineCompletionDidShow(U,Q,se,oe){this.s(U,ce,async Z=>{Z.handleDidShowCompletionItem(Q,se,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,Q,se,oe){this.s(U,ce,async Z=>{Z.handlePartialAccept(Q,se,oe)},void 0,void 0)}$freeInlineCompletionsList(U,Q){this.s(U,ce,async se=>{se.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(U,Q,se,oe){const Z=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ge=this.t(new B(this.h,se),U);return this.e.$registerSignatureHelpProvider(ge,this.o(Q,U),Z),this.p(ge)}$provideSignatureHelp(U,Q,se,oe,Z){return this.s(U,B,ge=>ge.provideSignatureHelp(C.URI.revive(Q),se,oe,Z),void 0,Z)}$releaseSignatureHelp(U,Q){this.s(U,B,se=>se.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(U,Q,se){const oe=typeof se.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new Y(this.h,this.j.converter,se,this.l,U),U);this.e.$registerInlayHintsProvider(Z,this.o(Q,U),typeof se.resolveInlayHint=="function",oe,be.u(U));let ge=this.p(Z);if(oe!==void 0){const Ee=se.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(oe));ge=R.$rK.from(ge,Ee)}return ge}$provideInlayHints(U,Q,se,oe){return this.s(U,Y,Z=>Z.provideInlayHints(C.URI.revive(Q),se,oe),void 0,oe)}$resolveInlayHint(U,Q,se){return this.s(U,Y,oe=>oe.resolveInlayHint(Q,se),void 0,se)}$releaseInlayHints(U,Q){this.s(U,Y,se=>se.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(U,Q,se){const oe=this.t(new re(this.h,se),U);return this.e.$registerDocumentLinkProvider(oe,this.o(Q,U),typeof se.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(U,Q,se){return this.s(U,re,oe=>oe.provideLinks(C.URI.revive(Q),se),void 0,se,Q.scheme==="output")}$resolveDocumentLink(U,Q,se){return this.s(U,re,oe=>oe.resolveLink(Q,se),void 0,void 0,!0)}$releaseDocumentLinks(U,Q){this.s(U,re,se=>se.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(U,Q,se){const oe=this.t(new X(this.h,se),U);return this.e.$registerDocumentColorProvider(oe,this.o(Q,U)),this.p(oe)}$provideDocumentColors(U,Q,se){return this.s(U,X,oe=>oe.provideColors(C.URI.revive(Q),se),[],se)}$provideColorPresentations(U,Q,se,oe){return this.s(U,X,Z=>Z.provideColorPresentations(C.URI.revive(Q),se,oe),void 0,oe)}registerFoldingRangeProvider(U,Q,se){const oe=this.q(),Z=typeof se.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new de(new _(this.h,se),U)),this.e.$registerFoldingRangeProvider(oe,this.o(Q,U),U.identifier,Z);let ge=this.p(oe);if(Z!==void 0){const Ee=se.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));ge=R.$rK.from(ge,Ee)}return ge}$provideFoldingRanges(U,Q,se,oe){return this.s(U,_,Z=>Z.provideFoldingRanges(C.URI.revive(Q),se,oe),void 0,oe)}registerSelectionRangeProvider(U,Q,se){const oe=this.t(new x(this.h,se,this.l),U);return this.e.$registerSelectionRangeProvider(oe,this.o(Q,U)),this.p(oe)}$provideSelectionRanges(U,Q,se,oe){return this.s(U,x,Z=>Z.provideSelectionRanges(C.URI.revive(Q),se,oe),[],oe)}registerCallHierarchyProvider(U,Q,se){const oe=this.t(new pe(this.h,se),U);return this.e.$registerCallHierarchyProvider(oe,this.o(Q,U)),this.p(oe)}$prepareCallHierarchy(U,Q,se,oe){return this.s(U,pe,Z=>Promise.resolve(Z.prepareSession(C.URI.revive(Q),se,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(U,Q,se,oe){return this.s(U,pe,Z=>Z.provideCallsTo(Q,se,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(U,Q,se,oe){return this.s(U,pe,Z=>Z.provideCallsFrom(Q,se,oe),void 0,oe)}$releaseCallHierarchy(U,Q){this.s(U,pe,se=>Promise.resolve(se.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(U,Q,se){const oe=this.t(new ae(this.h,se),U);return this.e.$registerTypeHierarchyProvider(oe,this.o(Q,U)),this.p(oe)}$prepareTypeHierarchy(U,Q,se,oe){return this.s(U,ae,Z=>Promise.resolve(Z.prepareSession(C.URI.revive(Q),se,oe)),void 0,oe)}$provideTypeHierarchySupertypes(U,Q,se,oe){return this.s(U,ae,Z=>Z.provideSupertypes(Q,se,oe),void 0,oe)}$provideTypeHierarchySubtypes(U,Q,se,oe){return this.s(U,ae,Z=>Z.provideSubtypes(Q,se,oe),void 0,oe)}$releaseTypeHierarchy(U,Q){this.s(U,ae,se=>Promise.resolve(se.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(U,Q,se,oe){const Z=this.q();this.f.set(Z,new de(new fe(this.e,this.h,se,Z,U),U));const ge=(0,t.$kF)(U,"dropMetadata")&&oe?fe.toInternalProviderId(U.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(Q,U),ge,(0,t.$kF)(U,"dropMetadata")?oe:void 0),this.p(Z)}$provideDocumentOnDropEdits(U,Q,se,oe,Z,ge){return this.s(U,fe,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(Q,C.URI.revive(se),oe,Z,ge)),void 0,void 0)}registerMappedEditsProvider(U,Q,se){const oe=this.t(new ee(this.h,se),U);return this.e.$registerMappedEditsProvider(oe,this.o(Q,U)),this.p(oe)}$provideMappedEdits(U,Q,se,oe,Z){return this.s(U,ee,ge=>Promise.resolve(ge.provideMappedEdits(Q,se,oe,Z)),null,Z)}registerDocumentPasteEditProvider(U,Q,se,oe){const Z=this.q();this.f.set(Z,new de(new j(this.e,this.h,se,Z,U),U));const ge=j.toInternalProviderId(U.identifier.value,oe.id);return this.e.$registerPasteEditProvider(Z,this.o(Q,U),ge,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(U,Q,se,oe,Z){return this.s(U,j,ge=>ge.prepareDocumentPaste(C.URI.revive(Q),se,oe,Z),void 0,Z)}$providePasteEdits(U,Q,se,oe,Z,ge){return this.s(U,j,Ee=>Ee.providePasteEdits(Q,C.URI.revive(se),oe,Z,ge),void 0,ge)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:be.w(U.decreaseIndentPattern),increaseIndentPattern:be.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?be.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?be.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:be.w(U.beforeText),afterText:U.afterText?be.w(U.afterText):void 0,previousLineText:U.previousLineText?be.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(be.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(Q=>R.SyntaxTokenType.toString(Q)):void 0}}static D(U){return U.map(be.C)}setLanguageConfiguration(U,Q,se){const{wordPattern:oe}=se;if(oe&&(0,E.$Pe)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(Q,oe):this.h.setWordDefinitionFor(Q,void 0),se.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),se.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const Z=this.q(),ge={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?be.w(se.wordPattern):void 0,indentationRules:se.indentationRules?be.y(se.indentationRules):void 0,onEnterRules:se.onEnterRules?be.B(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?be.D(se.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Z,Q,ge),this.p(Z)}$setWordDefinitions(U){for(const Q of U)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$Fcc=be}),define(De[319],Ce([1,0,6,13,7,38,8,3,26]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;class b{constructor(P,p,y,k){this.c=p,this.d=y,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(C.$pK.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,p){await this.a.$changeLanguage(P,p);const y=this.c.getDocumentData(P);if(!y)throw new Error(`document '${P.toString()}' NOT found`);return y.document}async tokenAtPosition(P,p){const y=P.version,k=O.Position.from(p),v=await this.a.$tokensAtPosition(P.uri,k),h={type:f.StandardTokenType.Other,range:P.getWordRangeAtPosition(p)??new f.$tK(p.line,p.character,p.line,p.character)};if(!v)return h;const o={range:O.Range.to(v.range),type:O.TokenType.to(v.type)};return!o.range.contains(p)||y!==P.version?h:o}createLanguageStatusItem(P,p,y){const k=this.f++,v=this.a,h=this.g,o=`${P.identifier.value}/${p}`;if(h.has(o))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);h.add(o);const l={selector:y,id:p,name:P.displayName??P.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const d=new m.$Rc,a=()=>{if(c?.dispose(),!h.has(o)){console.warn(`LanguageStatusItem (${p}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Wg)(()=>{d.clear(),this.a.$setLanguageStatus(k,{id:o,name:l.name??P.displayName??P.name,source:P.displayName??P.name,selector:O.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===f.LanguageStatusSeverity.Error?R.default.Error:l.severity===f.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:l.command&&this.d.toInternal(l.command,d),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},t={dispose(){d.dispose(),c?.dispose(),v.$removeLanguageStatus(k),h.delete(o)},get id(){return l.id},get name(){return l.name},set name(i){l.name=i,a()},get selector(){return l.selector},set selector(i){l.selector=i,a()},get text(){return l.text},set text(i){l.text=i,a()},set text2(i){(0,E.$lF)(P,"languageStatusText"),l.text=i,a()},get text2(){return(0,E.$lF)(P,"languageStatusText"),l.text},get detail(){return l.detail},set detail(i){l.detail=i,a()},get severity(){return l.severity},set severity(i){l.severity=i,a()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(i){l.accessibilityInformation=i,a()},get command(){return l.command},set command(i){l.command=i,a()},get busy(){return l.busy},set busy(i){l.busy=i,a()}};return a(),t}}e.$ndc=b}),define(De[112],Ce([1,0,12,15,2,5,14,6,27,20]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=e.$cdc=void 0;let L=class{constructor(p,y,k){this.f=k,this.d=new Map,this.a=y.getProxy(m.$pK.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===C.$g}getMessage(p,y){const{message:k,args:v,comment:h}=y;if(this.c)return(0,O.$Ee)(k,v??{});let o=k;h&&h.length>0&&(o+=`/${Array.isArray(h)?h.join(""):h}`);const l=this.d.get(p)?.contents[o];return l||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$Ee)(l??k,v??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let y;const k=await this.g(p);if(!k){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const v=await this.a.$fetchBundleContents(k),h=JSON.parse(v);y=p.isBuiltin?h.contents?.bundle:h}catch(v){this.f.error(`Failed to load translations for ${p.identifier.value} from ${k}: ${v.message}`);return}y&&this.d.set(p.identifier.value,{contents:y,uri:k})}async g(p){if(p.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return f.URI.revive(y)}return p.l10n?f.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$cdc=L,e.$cdc=L=He([Be(0,E.$GM),Be(1,b.$qM),Be(2,A.$$i)],L),e.$ddc=(0,R.$Qh)("IExtHostLocalizationService")}),define(De[150],Ce([1,0,14,6,27,20,2,62]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;let E=class extends C.$jj{constructor(P,p){super(p.logLevel,p.logsLocation,p.loggers.map(y=>(0,m.$nh)(y))),this.r=P.getProxy(O.$pK.MainThreadLogger)}$setLogLevel(P,p){p?this.setLogLevel(A.URI.revive(p),P):this.setLogLevel(P)}setVisibility(P,p){super.setVisibility(P,p),this.r.$setVisibility(P,p)}s(P,p,y){return new b(this.r,P,p,y)}};e.$Fec=E,e.$Fec=E=He([Be(0,R.$qM),Be(1,f.$GM)],E);class b extends C.$ej{constructor(P,p,y,k){super(k?.logLevel==="always"),this.r=P,this.s=p,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(p,k).then(()=>{this.u(this.n),this.m=!0})}g(P,p){const y=[[P,p]];this.m?this.u(y):this.n.push(...y)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(De[113],Ce([1,0,6,5,3,20,22]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=void 0,e.$edc=(0,O.$Qh)("IExtHostManagedSockets");let m=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(C.$pK.MainThreadManagedSockets)}setFactory(P,p){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(P,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const p=++this.b,y=await this.c.makeConnection(),k=new f.$Rc;return this.d.set(p,new b(p,y,k)),k.add((0,f.$Qc)(()=>this.d.delete(p))),k.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),k.dispose()})),k.add(y.onDidClose(v=>{this.a.$onDidManagedSocketClose(p,v?.stack??v?.message),k.dispose()})),k.add(y.onDidReceiveMessage(v=>this.a.$onDidManagedSocketHaveData(p,A.$ce.wrap(v)))),p}$remoteSocketWrite(P,p){this.d.get(P)?.actual.send(p.buffer)}$remoteSocketEnd(P){const p=this.d.get(P);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$fdc=m,e.$fdc=m=He([Be(0,R.$qM)],m);class E{constructor(P,p){this.socketFactoryId=P,this.makeConnection=p}}class b extends f.$Sc{constructor(P,p,y){super(),this.socketId=P,this.actual=p,this.B(y)}}}),define(De[320],Ce([1,0,6,14,26]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;function R(m){return m&&m.title}let A=class{constructor(E,b){this.b=b,this.a=E.getProxy(C.$pK.MainThreadMessageService)}showMessage(E,b,L,P,p){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let k;typeof P=="string"||R(P)?k=[P,...p]:(y.modal=P?.modal,y.useCustom=P?.useCustom,y.detail=P?.detail,k=p),y.useCustom&&(0,f.$lF)(E,"resolvers");const v=[];for(let h=0;h<k.length;h++){const o=k[h];if(typeof o=="string")v.push({title:o,handle:h,isCloseAffordance:!1});else if(typeof o=="object"){const{title:l,isCloseAffordance:c}=o;v.push({title:l,isCloseAffordance:!!c,handle:h})}else this.b.warn("Invalid message item:",o)}return this.a.$showMessage(b,L,y,v).then(h=>{if(typeof h=="number")return k[h]})}};e.$odc=A,e.$odc=A=He([Be(1,O.$$i)],A)}),define(De[321],Ce([1,0,208,22,4,3,28,15,17,2,30,107,6,34,13,7,69,285,146,9,24,18]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,n,r,u,I){this.q=r,this.r=u,this.s=I,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new f.$Od({onListenerError:c.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$Od({onListenerError:c.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$Od({onListenerError:c.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$Od({onListenerError:c.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$wcc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=s.getProxy(p.$pK.MainThreadNotebook),this.c=s.getProxy(p.$pK.MainThreadNotebookDocuments),this.d=s.getProxy(p.$pK.MainThreadNotebookEditors),this.i=n.converter,n.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const $=S.notebookEditor?.notebookUri,g=S.cell.handle,D=this.g.get($)?.getCell(g);if(D)return D.apiCell}if(S&&S.$mid===14){const $=S.uri,g=this.g.get($);if(g)return g.apiNotebook}return S}}),t.A(n)}getEditorById(s){const n=this.h.get(s);if(!n)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return n}getIdByEditor(s){for(const[n,r]of this.h)if(r.apiEditor===s)return n}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,n){const r=this.g.get(s);if(!r&&!n)throw new Error(`NO notebook document for '${s}'`);return r}static t(s,n){if(!n)return;const r=n.filenamePattern.map(u=>k.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(n.filenamePattern&&!r){console.warn(`Notebook content provider view options file name pattern is invalid ${n.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:n.displayName,filenamePattern:r,exclusive:n.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,n,r){const u=t.a++,I=typeof r.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(u,r),this.b.$registerNotebookCellStatusBarItemProvider(u,I,n);let S;return I!==void 0&&(S=r.onDidChangeCellStatusBarItems($=>this.b.$emitCellStatusBarEvent(I))),new v.$rK(()=>{this.f.delete(u),this.b.$unregisterNotebookCellStatusBarItemProvider(u,I),S?.dispose()})}async createNotebookDocument(s){const n=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&k.NotebookData.from(s.content)});return b.URI.revive(n)}async openNotebookDocument(s){const n=this.g.get(s);if(n)return n.apiNotebook;const r=await this.c.$tryOpenNotebook(s),u=this.g.get(b.URI.revive(r));return(0,E.$Kf)(u?.apiNotebook)}async showNotebookDocument(s,n){b.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let r;typeof n=="object"?r={position:k.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus,selections:n.selections&&n.selections.map(k.NotebookRange.from),pinned:typeof n.preview=="boolean"?!n.preview:void 0}:r={preserveFocus:!1};const u=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,r),I=u&&this.h.get(u)?.apiEditor;if(I)return I;throw u?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,n,r,u){const I=this.f.get(s),S=b.URI.revive(n),$=this.g.get(S);if(!$||!I)return;const g=$.getCellFromIndex(r);if(!g)return;const w=await I.provideCellStatusBarItems(g.apiCell,u);if(!w)return;const D=new R.$Rc,T=this.p.add([D]),F=(Array.isArray(w)?w:[w]).map(z=>k.NotebookStatusBarItem.from(z,this.i,D));return{cacheId:T,items:F}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,n,r,u,I){if((0,m.$Ce)(n))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:n,serializer:r,options:u}),this.b.$registerNotebookSerializer(S,{id:s.identifier,location:s.extensionLocation},n,k.NotebookDocumentContentOptions.from(u),t.t(s,I)),(0,R.$Qc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(s,n,r){const u=this.w.get(s);if(!u)throw new Error("NO serializer found");const I=await u.serializer.deserializeNotebook(n.buffer,r);return new h.$uv(k.NotebookData.from(I))}async $notebookToData(s,n,r){const u=this.w.get(s);if(!u)throw new Error("NO serializer found");const I=await u.serializer.serializeNotebook(k.NotebookData.to(n.value),r);return O.$ce.wrap(I)}async $saveNotebook(s,n,r,u,I){const S=b.URI.revive(n),$=this.w.get(s);if(!$)throw new Error("NO serializer found");const g=this.g.get(S);if(!g)throw new Error("Document NOT found");if(g.versionId!==r)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new L.$uk((0,C.localize)(0,null,this.y(S)),6);await this.x(S,u);const w={metadata:(0,d.$dn)(g.apiNotebook.metadata,z=>!($.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of g.apiNotebook.getCells()){const j=new v.$PL(z.kind,z.document.getText(),z.document.languageId,z.mime,$.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);j.metadata=(0,d.$dn)(z.metadata,N=>!($.options?.transientCellMetadata??{})[N]),w.cells.push(j)}const D=await $.serializer.serializeNotebook(w,I);await this.s.value.writeFile(S,D);const T=this.s.getFileSystemProviderExtUri(S.scheme),M=await this.s.value.stat(S);return{name:T.basename(S),isFile:(M.type&L.FileType.File)!==0,isDirectory:(M.type&L.FileType.Directory)!==0,isSymbolicLink:(M.type&L.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&L.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((M.permissions??0)&L.FilePermission.Locked),etag:L.$Fk({mtime:M.mtime,size:M.size}),children:void 0}}async x(s,n){const r=await this.s.value.stat(s);if(typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==L.$Ek&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==L.$Fk({mtime:n.mtime,size:r.size}))throw new L.$uk((0,C.localize)(1,null),3,n)}y(s){return s.scheme===a.Schemas.file?s.fsPath:s.toString()}z(s,n,r){if(this.h.has(n))throw new Error(`editor with id ALREADY EXSIST: ${n}`);const u=new l.$8dc(n,this.d,s,r.visibleRanges.map(k.NotebookRange.to),r.selections.map(k.NotebookRange.to),typeof r.viewColumn=="number"?k.ViewColumn.to(r.viewColumn):void 0);this.h.set(n,u)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const r of s.value.removedDocuments){const u=b.URI.revive(r),I=this.g.get(u);I&&(I.dispose(),this.g.delete(u),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(I.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===u.toString()&&this.h.delete(S.id)}if(s.value.addedDocuments){const r=[];for(const u of s.value.addedDocuments){const I=b.URI.revive(u.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const S=new o.$7dc(this.c,this.q,this.r,I,u);r.push(...u.cells.map($=>o.$6dc.asModelAddData(S.apiNotebook,$))),this.g.get(I)?.dispose(),this.g.set(I,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:r}),this.m.fire(S.apiNotebook)}}if(s.value.addedEditors)for(const r of s.value.addedEditors){if(this.h.has(r.id))return;const u=b.URI.revive(r.documentUri),I=this.g.get(u);I&&this.z(I,r.id,r)}const n=[];if(s.value.removedEditors)for(const r of s.value.removedEditors){const u=this.h.get(r);u&&(this.h.delete(r),this.k?.id===u.id&&(this.k=void 0),n.push(u))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(u=>this.h.get(u)).filter(u=>!!u);const r=new Set;this.l.forEach(u=>r.add(u.id));for(const u of this.h.values()){const I=r.has(u.id);u._acceptVisibility(I)}this.l=[...this.h.values()].map(u=>u).filter(u=>u.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(s){const n=y.$OM.String.with("notebookType","A notebook type"),r=new y.$QM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[n,new y.$OM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>O.$ce.wrap(I))],new y.$PM("Notebook Data",I=>k.NotebookData.to(I.value))),u=new y.$QM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[n,new y.$OM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new h.$uv(k.NotebookData.from(I)))],new y.$PM("Bytes",I=>I.buffer));s.registerApiCommand(r),s.registerApiCommand(u)}}e.$9dc=t}),define(De[322],Ce([1,0,19,8,21,4,3,28,2,25,14,6,34,13,7,110,277,26,69]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0;let c=class{constructor(u,I,S,$,g){this.l=I,this.m=S,this.n=$,this.o=g,this.b=new m.$Ac,this.c=new m.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new R.$Od,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=u.getProxy(P.$pK.MainThreadNotebookKernels);const w=new p.$QM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$OM("options","Select kernel options",D=>!0,D=>{if(D&&"notebookEditor"in D&&"id"in D){const T=this.m.getIdByEditor(D.notebookEditor);return{id:D.id,extension:D.extension,notebookEditorId:T}}else if(D&&"notebookEditor"in D){const T=this.m.getIdByEditor(D.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${D.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return D})],p.$PM.Void);this.n.registerApiCommand(w)}createNotebookController(u,I,S,$,g,w){for(const le of this.i.values())if(le.controller.id===I&&b.$7l.equals(u.identifier,le.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const D=this.j++,T=this;this.o.trace(`NotebookController[${D}], CREATED by ${u.identifier.value}, ${I}`);const M=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${u.identifier}'`);let F=!1;const z=new R.$Od,j=new R.$Od,N={id:n(u.identifier,I),notebookType:S,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:$||u.identifier.value,preloads:w?w.map(y.NotebookRendererScript.from):[]};let q=g??M,K;this.a.$addKernel(D,N).catch(le=>{console.log(le),F=!0});let me=0;const te=()=>{if(F)return;const le=++me;Promise.resolve().then(()=>{le===me&&this.a.$updateKernel(D,N)})},G=new m.$Ac,J={get id(){return I},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return N.label},set label(le){N.label=le??u.displayName??u.name,te()},get detail(){return N.detail??""},set detail(le){N.detail=le,te()},get description(){return N.description??""},set description(le){N.description=le,te()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(le){N.supportedLanguages=le,te()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(le){N.supportsExecutionOrder=le,te()},get rendererScripts(){return N.preloads?N.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(le){q=le??M},get interruptHandler(){return K},set interruptHandler(le){K=le,N.supportsInterrupt=!!le,te()},createNotebookCellExecution(le){if(F)throw new Error("notebook controller is DISPOSED");if(!G.has(le.notebook.uri))throw T.o.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(G.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.notebook.uri.toString()}`);return T._createNotebookCellExecution(le,n(u.identifier,this.id))},createNotebookExecution(le){if((0,o.$lF)(u,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!G.has(le.uri))throw T.o.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(G.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.uri.toString()}`);return T._createNotebookExecution(le,n(u.identifier,this.id))},dispose:()=>{F||(this.o.trace(`NotebookController[${D}], DISPOSED`),F=!0,this.i.delete(D),z.dispose(),j.dispose(),this.a.$removeKernel(D))},updateNotebookAffinity(le,ie){ie===k.NotebookControllerAffinity2.Hidden&&(0,o.$lF)(u,"notebookControllerAffinityHidden"),T.a.$updateNotebookPriority(D,le.uri,ie)},onDidReceiveMessage:j.event,postMessage(le,ie){return(0,o.$lF)(u,"notebookMessaging"),T.a.$postMessage(D,ie&&T.m.getIdByEditor(ie),le)},asWebviewUri(le){return(0,o.$lF)(u,"notebookMessaging"),(0,v.$lpb)(le,T.l.remote)}};return this.i.set(D,{extensionId:u.identifier,controller:J,onDidReceiveMessage:j,onDidChangeSelection:z,associatedNotebooks:G}),J}getIdByController(u){for(const[I,S]of this.i)if(S.controller===u)return n(S.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,I){const S=this.f++,$=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${u.identifier.value}`),this.a.$addKernelDetectionTask(S,I);const g={dispose:()=>{this.e.delete(S),$.a.$removeKernelDetectionTask(S)}};return this.e.set(S,g),g}registerKernelSourceActionProvider(u,I,S){const $=this.h++,g=typeof S.onDidChangeNotebookKernelSourceActions=="function"?$:void 0,w=this;this.g.set($,S),this.o.trace(`NotebookKernelSourceActionProvider[${$}], CREATED by ${u.identifier.value}`),this.a.$addKernelSourceActionProvider($,$,I);let D;return g!==void 0&&(D=S.onDidChangeNotebookKernelSourceActions(T=>this.a.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this.g.delete($),w.a.$removeKernelSourceActionProvider($,$),D?.dispose()}}}async $provideKernelSourceActions(u,I){const S=this.g.get(u);if(S){const $=new A.$Rc;return(await S.provideNotebookKernelSourceActions(I)??[]).map(w=>y.NotebookKernelSourceAction.from(w,this.n.converter,$))}return[]}$acceptNotebookAssociation(u,I,S){const $=this.i.get(u);if($){const g=this.m.getNotebookDocument(E.URI.revive(I));S?$.associatedNotebooks.set(g.uri,!0):$.associatedNotebooks.delete(g.uri),this.o.trace(`NotebookController[${u}] ASSOCIATE notebook`,g.uri.toString(),S),$.onDidChangeSelection.fire({selected:S,notebook:g.apiNotebook})}}async $executeCells(u,I,S){const $=this.i.get(u);if(!$)return;const g=this.m.getNotebookDocument(E.URI.revive(I)),w=[];for(const D of S){const T=g.getCell(D);T&&w.push(T.apiCell)}try{this.o.trace(`NotebookController[${u}] EXECUTE cells`,g.uri.toString(),w.length),await $.controller.executeHandler.call($.controller,w,g.apiNotebook,$.controller)}catch(D){this.o.error(`NotebookController[${u}] execute cells FAILED`,D),console.error(D)}}async $cancelCells(u,I,S){const $=this.i.get(u);if(!$)return;const g=this.m.getNotebookDocument(E.URI.revive(I));if($.controller.interruptHandler)await $.controller.interruptHandler.call($.controller,g.apiNotebook);else for(const w of S){const D=g.getCell(w);D&&this.b.get(D.uri)?.cancel()}if($.controller.interruptHandler){const w=this.c.get(g.uri);S.length&&Array.isArray(w)&&w.length&&w.forEach(D=>D.dispose())}}$acceptKernelMessageFromRenderer(u,I,S){const $=this.i.get(u);if(!$)return;const g=this.m.getEditorById(I);$.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:S}))}$cellExecutionChanged(u,I,S){const g=this.m.getNotebookDocument(E.URI.revive(u)).getCell(I);if(g){const w=S?y.NotebookCellExecutionState.to(S):k.NotebookCellExecutionState.Idle;w!==void 0&&this.k.fire({cell:g.apiCell,state:w})}}_createNotebookCellExecution(u,I){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const $=this.m.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!$)throw new Error("invalid cell");if(this.b.has($.uri))throw new Error(`duplicate execution for ${$.uri}`);const g=new a(I,$,this.a);this.b.set($.uri,g);const w=g.onDidChangeState(()=>{g.state===d.Resolved&&(g.dispose(),w.dispose(),this.b.delete($.uri))});return g.asApiObject()}_createNotebookExecution(u,I){const S=this.m.getNotebookDocument(u.uri),$=u.getCells().find(D=>{const T=S.getCellFromApiCell(D);return T&&this.b.has(T.uri)});if($)throw new Error(`duplicate cell execution for ${$.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const g=new i(I,S,this.a),w=g.onDidChangeState(()=>{g.state===t.Resolved&&(g.dispose(),w.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[g,w]),g.asApiObject()}};e.$kec=c,e.$kec=c=He([Be(4,L.$$i)],c);var d;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(d||(d={}));class a extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(u,I,S){super(),this.m=I,this.n=S,this.b=a.a++,this.c=new R.$Od,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new f.$Yd),this.h=new s(10,$=>this.s($)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,u,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(u){await this.h.addItem(u)}async s(u){const I=Array.isArray(u)?u:[u];return this.n.$updateExecution(this.b,new l.$uv(I))}t(){if(this.f===d.Init)throw new Error("Must call start before modifying cell output");if(this.f===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(u){let I=this.m;if(u&&(I=this.m.notebook.getCellFromApiCell(u)),!I)throw new Error("INVALID cell");return I.handle}y(u){return u.map(I=>{const S=k.$SL.ensureUniqueMimeTypes(I.items,!0);return S===I.items?y.NotebookCellOutput.from(I):y.NotebookCellOutput.from({items:S,id:I.id,metadata:I.metadata})})}async z(u,I,S){const $=this.w(I),g=this.y((0,C.$3b)(u));return this.r({editType:h.CellExecutionUpdateType.Output,cellHandle:$,append:S,outputs:g})}async C(u,I,S){return u=k.$SL.ensureUniqueMimeTypes((0,C.$3b)(u),!0),this.r({editType:h.CellExecutionUpdateType.OutputItems,items:u.map(y.NotebookCellOutputItem.from),outputId:I.id,append:S})}asApiObject(){const u=this;return Object.freeze({get token(){return u.g.token},get cell(){return u.m.apiCell},get executionOrder(){return u.j},set executionOrder(S){u.j=S,u.s([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:u.j}])},start(S){if(u.f===d.Resolved||u.f===d.Started)throw new Error("Cannot call start again");u.f=d.Started,u.c.fire(),u.s({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,$){if(u.f===d.Resolved)throw new Error("Cannot call resolve twice");u.f=d.Resolved,u.c.fire(),u.h.flush(),u.n.$completeExecution(u.b,new l.$uv({runEndTime:$,lastRunSuccess:S}))},clearOutput(S){return u.t(),u.z([],S,!1)},appendOutput(S,$){return u.t(),u.z(S,$,!0)},replaceOutput(S,$){return u.t(),u.z(S,$,!1)},appendOutputItems(S,$){return u.t(),u.C(S,$,!0)},replaceOutputItems(S,$){return u.t(),u.C(S,$,!1)}})}}var t;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(t||(t={}));class i extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(u,I,S){super(),this.h=I,this.j=S,this.b=i.a++,this.c=new R.$Od,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new f.$Yd),this.j.$createNotebookExecution(this.b,u,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor(u,I){this.e=u,this.f=I,this.a=[],this.b=Date.now()}addItem(u){return this.a.push(u),this.c||(this.c=new O.$dh,this.b=Date.now(),(0,O.$Vg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const u=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>u.complete())}}function n(r,u){return`${r.value}/${u}`}e.$lec=n}),define(De[323],Ce([1,0,4,6,146]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;class R{constructor(m,E){this.c=E,this.a=new Map,this.b=m.getProxy(O.$pK.MainThreadNotebookRenderers)}$postRendererMessage(m,E,b){const L=this.c.getEditorById(m);this.a.get(E)?.fire({editor:L.apiEditor,message:b})}createRendererMessaging(m,E){if(!m.contributes?.notebookRenderer?.some(L=>L.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(L,P,p)=>this.d(E).event(L,P,p),postMessage:(L,P)=>{f.$8dc.apiEditorsToExtHost.has(L)&&([L,P]=[P,L]);const p=P&&f.$8dc.apiEditorsToExtHost.get(P);return this.b.$postMessage(p?.id,E,L)}}}d(m){let E=this.a.get(m);return E||(E=new C.$Od({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(m)}}),this.a.set(m,E),E)}}e.$mec=R}),define(De[324],Ce([1,0,3,17,2,26,6]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;class m{constructor(b){this.b=new Map,this.a=b.getProxy(A.$pK.MainThreadProfileContentHandlers)}registrProfileContentHandler(b,L,P){if((0,R.$lF)(b,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,P),this.a.$registerProfileContentHandler(L,P.name,P.description,b.identifier.value),(0,C.$Qc)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(b,L,P,p){const y=this.b.get(b);if(!y)throw new Error(`Unknown handler with id: ${b}`);return y.saveProfile(L,P,p)}async $readProfile(b,L,P){const p=this.b.get(b);if(!p)throw new Error(`Unknown handler with id: ${b}`);return p.readProfile((0,O.$zf)(L)?L:f.URI.revive(L),P)}}e.$qec=m}),define(De[325],Ce([1,0,2,6,8,13]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;class A{static{this.a=0}constructor(E,b){this.d=b,this.c=new Map,this.b=E.getProxy(O.$pK.MainThreadQuickDiff)}$provideOriginalResource(E,b,L){const P=C.URI.revive(b),p=this.c.get(E);return p?(0,f.$Ng)(()=>p.provideOriginalResource(P,L)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,b,L,P){const p=A.a++;return this.c.set(p,b),this.b.$registerQuickDiffProvider(p,R.DocumentSelector.from(E,this.d),L,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$rec=A}),define(De[326],Ce([1,0,21,4,3,6,2,7,9,19,38,59,26,13]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;function k(v,h,o){const l=v.getProxy(R.$pK.MainThreadQuickOpen);class c{constructor(I,S){this.e=new Map,this.f=0,this.a=I,this.b=S}showQuickPick(I,S,$,g=C.CancellationToken.None){this.c=void 0;const w=Promise.resolve(S),D=++this.f,T=l.$show(D,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},g),M={},F=T.then(()=>M);return Promise.race([F,w]).then(z=>{if(z===M)return;const j=(0,p.$kF)(I,"quickPickItemTooltip");return w.then(N=>{const q=[];for(let K=0;K<N.length;K++){const me=N[K];if(typeof me=="string")q.push({label:me,handle:K});else if(me.kind===m.QuickPickItemKind.Separator)q.push({type:"separator",label:me.label});else{me.tooltip&&!j&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const te=me.iconPath?s(me.iconPath):void 0;q.push({label:me.label,iconPath:te?.iconPath,iconClass:te?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:j?y.MarkdownString.fromStrict(me.tooltip):void 0,handle:K})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=K=>{$.onDidSelectItem(N[K])}),l.$setItems(D,q),T.then(K=>{if(typeof K=="number")return N[K];if(Array.isArray(K))return K.map(me=>N[me])})})}).then(void 0,z=>{if(!(0,E.$4)(z))return l.$setError(D,z),Promise.reject(z)})}$onItemSelected(I){this.c?.(I)}showInput(I,S=C.CancellationToken.None){return this.d=I?.validateInput,l.$input(I,typeof this.d=="function",S).then(void 0,$=>{if(!(0,E.$4)($))return Promise.reject($)})}async $validateInput(I){if(!this.d)return;const S=await this.d(I);if(!S||typeof S=="string")return S;let $;switch(S.severity){case m.InputBoxValidationSeverity.Info:$=L.default.Info;break;case m.InputBoxValidationSeverity.Warning:$=L.default.Warning;break;case m.InputBoxValidationSeverity.Error:$=L.default.Error;break;default:$=S.message?L.default.Error:L.default.Ignore;break}return{content:S.message,severity:$}}async showWorkspaceFolderPick(I,S=C.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!$)return;const g=await this.a.getWorkspaceFolders2();if(g)return g.find(w=>w.uri.toString()===$.uri.toString())}createQuickPick(I){const S=new n(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(I){const S=new r(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(I,S){this.e.get(I)?._fireDidChangeValue(S)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,S){const $=this.e.get(I);$ instanceof n&&$._fireDidChangeActive(S)}$onDidChangeSelection(I,S){const $=this.e.get(I);$ instanceof n&&$._fireDidChangeSelection(S)}$onDidTriggerButton(I,S){this.e.get(I)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(I,S,$){const g=this.e.get(I);g instanceof n&&g._fireDidTriggerItemButton(S,$)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class d{static{this.a=1}constructor(I,S){this.x=I,this.y=S,this._id=n.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$Od,this.q=new O.$Od,this.r=new O.$Od,this.s=new O.$Od,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((S,$)=>{const g=S===m.$LL.Back?-1:$;this.o.set(g,S)}),this.z({buttons:I.map((S,$)=>({...s(S.iconPath),tooltip:S.tooltip,handle:S===m.$LL.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const S=this.o.get(I);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),l.$dispose(this._id))}z(I){if(!this.v){for(const S of Object.keys(I)){const $=I[S];this.u[S]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){l.$createOrUpdate(this.u),this.u={id:this._id}}}function a(u){if(u instanceof m.$lL)return{id:u.id};const I=i(u),S=t(u);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof S=="string"?A.URI.file(S):S}}function t(u){return typeof u=="object"&&"light"in u?u.light:u}function i(u){return typeof u=="object"&&"dark"in u?u.dark:u}function s(u){const I=a(u);let S,$;return"id"in I?$=P.ThemeIcon.asClassName(I):S=I,{iconPath:S,iconClass:$}}class n extends d{constructor(I,S){super(I.identifier,S),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$Od,this.L=[],this.M=new O.$Od,this.N=new O.$Od,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((g,w)=>{this.C.set(w,g),this.D.set(g,w)});const S=(0,p.$kF)(this.O,"quickPickItemTooltip"),$=[];for(let g=0;g<I.length;g++){const w=I[g];if(w.kind===m.QuickPickItemKind.Separator)$.push({type:"separator",label:w.label});else{w.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const D=w.iconPath?s(w.iconPath):void 0;$.push({handle:g,label:w.label,iconPath:D?.iconPath,iconClass:D?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:S?y.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((T,M)=>({...s(T.iconPath),tooltip:T.tooltip,handle:M}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(I){const S=(0,b.$Hb)(I.map($=>this.C.get($)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(I){const S=(0,b.$Hb)(I.map($=>this.C.get($)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(I,S){const $=this.C.get(I);if(!$||!$.buttons||!$.buttons.length)return;const g=$.buttons[S];g&&this.N.fire({button:g,item:$})}}class r extends d{constructor(I,S){super(I.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:L.default.Error}):this.z({validationMessage:I.message,severity:I.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new c(h,o)}e.$sdc=k}),define(De[327],Ce([1,0,2,4,57,3,8,6,19,126,14,25,59,13,26,18]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=e.$tdc=void 0;function o(w){if(w)return typeof w.iconPath=="string"?C.URI.file(w.iconPath):C.URI.isUri(w.iconPath)||p.ThemeIcon.isThemeIcon(w.iconPath)?w.iconPath:void 0}function l(w){if(w?.icon){if(C.URI.isUri(w.icon))return w.icon;if(p.ThemeIcon.isThemeIcon(w.icon))return w.icon;{const D=w.icon;return{light:D.light,dark:D.dark}}}else return}function c(w){if(w.icon){if(C.URI.isUri(w.icon))return w.icon;if(p.ThemeIcon.isThemeIcon(w.icon))return w.icon;{const D=w.icon;return{light:D.light,dark:D.dark}}}else return}function d(w,D){if(!w.iconPath&&!D.iconPath)return 0;if(w.iconPath){if(!D.iconPath)return 1}else return-1;const T=typeof w.iconPath=="string"?w.iconPath:C.URI.isUri(w.iconPath)?w.iconPath.fsPath:w.iconPath.id,M=typeof D.iconPath=="string"?D.iconPath:C.URI.isUri(D.iconPath)?D.iconPath.fsPath:D.iconPath.id;return(0,b.$vq)(T,M)}function a(w,D){let T=0;if(w.strikeThrough!==D.strikeThrough)return w.strikeThrough?1:-1;if(w.faded!==D.faded)return w.faded?1:-1;if(w.tooltip!==D.tooltip)return(w.tooltip||"").localeCompare(D.tooltip||"");if(T=d(w,D),T!==0)return T;if(w.light&&D.light)T=d(w.light,D.light);else{if(w.light)return 1;if(D.light)return-1}if(T!==0)return T;if(w.dark&&D.dark)T=d(w.dark,D.dark);else{if(w.dark)return 1;if(D.dark)return-1}return T}function t(w,D){if(w.command!==D.command)return w.command<D.command?-1:1;if(w.title!==D.title)return w.title<D.title?-1:1;if(w.tooltip!==D.tooltip){if(w.tooltip!==void 0&&D.tooltip!==void 0)return w.tooltip<D.tooltip?-1:1;if(w.tooltip!==void 0)return 1;if(D.tooltip!==void 0)return-1}if(w.arguments===D.arguments)return 0;if(w.arguments)if(D.arguments){if(w.arguments.length!==D.arguments.length)return w.arguments.length-D.arguments.length}else return 1;else return-1;for(let T=0;T<w.arguments.length;T++){const M=w.arguments[T],F=D.arguments[T];if(M!==F)return M<F?-1:1}return 0}function i(w,D){let T=(0,b.$vq)(w.resourceUri.fsPath,D.resourceUri.fsPath,!0);if(T!==0)return T;if(w.command&&D.command)T=t(w.command,D.command);else{if(w.command)return 1;if(D.command)return-1}if(T!==0)return T;if(w.decorations&&D.decorations)T=a(w.decorations,D.decorations);else{if(w.decorations)return 1;if(D.decorations)return-1}return T}function s(w,D){for(let T=0;T<w.length;T++)if(w[T]!==D[T])return!1;return!0}function n(w,D){return w.command===D.command&&w.title===D.title&&w.tooltip===D.tooltip&&(w.arguments&&D.arguments?s(w.arguments,D.arguments):w.arguments===D.arguments)}function r(w,D){return(0,E.$ub)(w,D,n)}function u(w,D){return w===D?!0:!w||!D?!1:w.id===D.id&&w.label===D.label&&w.upstream?.id===D.upstream?.id&&w.upstream?.label===D.upstream?.label}class I{#e;#t;get value(){return this.d}set value(D){D=D??"",this.#e.$setInputBoxValue(this.o,D),this.q(D)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(D){this.#e.$setInputBoxPlaceholder(this.o,D),this.f=D}get validateInput(){return(0,k.$lF)(this.m,"scmValidation"),this.g}set validateInput(D){if((0,k.$lF)(this.m,"scmValidation"),D&&typeof D!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=D,this.#e.$setValidationProviderIsEnabled(this.o,!!D)}get enabled(){return this.h}set enabled(D){D=!!D,this.h!==D&&(this.h=D,this.#e.$setInputBoxEnablement(this.o,D))}get visible(){return this.j}set visible(D){D=!!D,this.j!==D&&(this.j=D,this.#e.$setInputBoxVisibility(this.o,D))}get actionButton(){return(0,k.$lF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(D){(0,k.$lF)(this.m,"scmInputBoxActionButton"),this.l.value=new R.$Rc,this.k=D;const T=D!==void 0?{command:this.n.converter.toInternal(D.command,this.l.value),icon:l(D),enabled:D.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,T??null)}get document(){return(0,k.$lF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(D,T,M,F,z,j){this.m=D,this.n=T,this.o=z,this.p=j,this.d="",this.e=new O.$Od,this.f="",this.h=!0,this.j=!0,this.l=new R.$Tc,this.#t=M,this.#e=F}showValidationMessage(D,T){(0,k.$lF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,D,T)}$onInputBoxValueChange(D){this.q(D)}q(D){this.d=D,this.e.fire(D)}}e.$tdc=I;class S{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(D){this.v=D,this.q.$updateGroupLabel(this.t,this.handle,D)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(D){this.p=D,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(D){this.f=[...D],this.k.fire()}constructor(D,T,M,F,z){this.q=D,this.s=T,this.t=M,this.u=F,this.v=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$Od,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$Od,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=S.d++}getResourceState(D){return this.g.get(D)}$executeResourceCommand(D,T){const M=this.h.get(D);return M?(0,A.$Ng)(()=>this.s.executeCommand(M.command,...M.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const D=[...this.f].sort(i),M=(0,E.$Db)(this.o,D,i).map(j=>{const N=j.toInsert.map(q=>{const K=this.e++;this.g.set(K,q);const me=q.resourceUri;let te;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const re=new R.$Rc;te=this.s.converter.toInternal(q.command,re),this.j.set(K,re)}else this.h.set(K,q.command);const G=o(q.decorations),J=q.decorations&&o(q.decorations.light)||G,le=q.decorations&&o(q.decorations.dark)||G,ie=[J,le],ce=q.decorations&&q.decorations.tooltip||"",ye=q.decorations&&!!q.decorations.strikeThrough,H=q.decorations&&!!q.decorations.faded,B=q.contextValue||"";return{rawResource:[K,me,ie,ce,ye,H,B,te],handle:K}});return{start:j.start,deleteCount:j.deleteCount,toInsert:N}}),F=M.map(({start:j,deleteCount:N,toInsert:q})=>[j,N,q.map(K=>K.rawResource)]),z=M.reverse();for(const{start:j,deleteCount:N,toInsert:q}of z){const K=q.map(te=>te.handle),me=this.n.splice(j,N,...K);for(const te of me)this.g.delete(te),this.h.delete(te),this.j.get(te)?.dispose(),this.j.delete(te)}return this.o=D,F}dispose(){this.l=!0,this.m.fire()}}class ${static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(D){this.g!==D&&(this.g=D,this.#e.$updateSourceControl(this.x,{count:D}))}get quickDiffProvider(){return this.h}set quickDiffProvider(D){this.h=D;let T;(0,k.$kF)(this.y,"quickDiffProvider")&&(T=D?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!D,quickDiffLabel:T})}get historyProvider(){return(0,k.$lF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(D){(0,k.$lF)(this.y,"scmHistoryProvider"),this.j=D,this.k.value=new R.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!D}),D&&(this.k.value.add(D.onDidChangeCurrentHistoryItemGroup(()=>{u(this.l,D?.currentHistoryItemGroup)||(this.l=D?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(D.onDidChangeActionButton(()=>{(0,k.$lF)(this.y,"scmActionButton"),this.m.value=new R.$Rc;const T=D.actionButton!==void 0?{command:this.z.converter.toInternal(D.actionButton.command,this.m.value),description:D.actionButton.description,enabled:D.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,T??null)})))}get commitTemplate(){return this.n}set commitTemplate(D){D!==this.n&&(this.n=D,this.#e.$updateSourceControl(this.x,{commitTemplate:D}))}get acceptInputCommand(){return this.p}set acceptInputCommand(D){this.o.value=new R.$Rc,this.p=D;const T=this.z.converter.toInternal(D,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:T})}get actionButton(){return(0,k.$lF)(this.y,"scmActionButton"),this.s}set actionButton(D){(0,k.$lF)(this.y,"scmActionButton"),this.q.value=new R.$Rc,this.s=D;const T=D!==void 0?{command:this.z.converter.toInternal(D.command,this.q.value),secondaryCommands:D.secondaryCommands?.map(M=>M.map(F=>this.z.converter.toInternal(F,this.q.value))),description:D.description,enabled:D.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:T??null})}get statusBarCommands(){return this.u}set statusBarCommands(D){if(this.u&&D&&r(this.u,D))return;this.t.value=new R.$Rc,this.u=D;const T=(D||[]).map(M=>this.z.converter.toInternal(M,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:T})}get selected(){return this.v}constructor(D,T,M,F,z,j,N){this.y=D,this.z=F,this.A=z,this.B=j,this.C=N,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Tc,this.m=new R.$Tc,this.n=void 0,this.o=new R.$Tc,this.p=void 0,this.q=new R.$Tc,this.t=new R.$Tc,this.u=void 0,this.v=!1,this.w=new O.$Od,this.onDidChangeSelection=this.w.event,this.x=$.d++,this.D=new Map,this.E=new Set,this.#e=M;const q=C.URI.from({scheme:v.Schemas.vscodeSourceControl,path:`${z}/scm${this.x}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this.f=new I(D,F,T,this.#e,this.x,q),this.#e.$registerSourceControl(this.x,z,j,N,q)}createResourceGroup(D,T){const M=new S(this.#e,this.z,this.x,D,T),F=O.Event.once(M.onDidDispose)(()=>this.D.delete(M));return this.D.set(M,F),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const D=[],T=[];for(const[M,F]of this.D){F.dispose();const z=M.onDidUpdateResourceStates(()=>{this.E.add(M),this.eventuallyUpdateResourceStates()});O.Event.once(M.onDidDispose)(()=>{this.E.delete(M),z.dispose(),this.e.delete(M.handle),this.#e.$unregisterGroup(this.x,M.handle)}),D.push([M.handle,M.id,M.label,M.features]);const j=M._takeResourceStateSnapshot();j.length>0&&T.push([M.handle,j]),this.e.set(M.handle,M)}this.#e.$registerGroups(this.x,D,T),this.D.clear()}eventuallyUpdateResourceStates(){const D=[];this.E.forEach(T=>{const M=T._takeResourceStateSnapshot();M.length!==0&&D.push([T.handle,M])}),D.length>0&&this.#e.$spliceResourceStates(this.x,D),this.E.clear()}getResourceGroup(D){return this.e.get(D)}setSelectionState(D){this.v=D,this.w.fire(D)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(D=>D.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,f.$jh)(100)],$.prototype,"eventuallyAddResourceGroups",null),He([(0,f.$jh)(100)],$.prototype,"eventuallyUpdateResourceStates",null);let g=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(D,T,M,F){this.l=T,this.m=M,this.n=F,this.g=new Map,this.h=new P.$9l,this.j=new O.$Od,this.e=D.getProxy(m.$pK.MainThreadSCM),this.f=D.getProxy(m.$pK.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const j=this.g.get(z.sourceControlHandle);if(!j)return z;const N=j.getResourceGroup(z.groupHandle);return N?N.getResourceState(z.handle):z}else if(z&&z.$mid===4){const j=this.g.get(z.sourceControlHandle);return j?j.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const j=this.g.get(z.handle);return j||z}return z}})}createSourceControl(D,T,M,F){this.n.trace("ExtHostSCM#createSourceControl",D.identifier.value,T,M,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:D.identifier.value});const z=h.d++,j=new $(D,this.m,this.e,this.l,T,M,F);this.g.set(z,j);const N=this.h.get(D.identifier)||[];return N.push(j),this.h.set(D.identifier,N),j}getLastInputBox(D){this.n.trace("ExtHostSCM#getLastInputBox",D.identifier.value);const T=this.h.get(D.identifier),M=T&&T[T.length-1];return M&&M.inputBox}$provideOriginalResource(D,T,M){const F=C.URI.revive(T);this.n.trace("ExtHostSCM#$provideOriginalResource",D,F.toString());const z=this.g.get(D);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Ng)(()=>z.quickDiffProvider.provideOriginalResource(F,M)).then(j=>j||null)}$onInputBoxValueChange(D,T){this.n.trace("ExtHostSCM#$onInputBoxValueChange",D);const M=this.g.get(D);return M&&M.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(D,T,M,F){this.n.trace("ExtHostSCM#$executeResourceCommand",D,T,M);const z=this.g.get(D);if(!z)return Promise.resolve(void 0);const j=z.getResourceGroup(T);return j?j.$executeResourceCommand(M,F):Promise.resolve(void 0)}$validateInput(D,T,M){this.n.trace("ExtHostSCM#$validateInput",D);const F=this.g.get(D);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Ng)(()=>F.inputBox.validateInput(T,M)).then(z=>{if(!z)return Promise.resolve(void 0);const j=y.MarkdownString.fromStrict(z.message);return j?Promise.resolve([j,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(D){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",D),D!==void 0&&this.g.get(D)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=D,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(D,T,M){return await this.g.get(D)?.historyProvider?.resolveHistoryItemGroupBase(T,M)??void 0}async $resolveHistoryItemGroupCommonAncestor(D,T,M,F){return await this.g.get(D)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(T,M,F)??void 0}async $provideHistoryItems(D,T,M,F){return(await this.g.get(D)?.historyProvider?.provideHistoryItems(T,M,F))?.map(N=>({id:N.id,parentIds:N.parentIds,label:N.label,description:N.description,icon:c(N),timestamp:N.timestamp}))??void 0}async $provideHistoryItemChanges(D,T,M){return await this.g.get(D)?.historyProvider?.provideHistoryItemChanges(T,M)??void 0}};e.$udc=g,e.$udc=g=h=He([Be(3,L.$$i)],g)}),define(De[114],Ce([1,0,6,4,5]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0;class R{constructor(m){this.b=new O.$Od,this.onDidChangePassword=this.b.event,this.a=m.getProxy(C.$pK.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,E){return this.a.$getPassword(m,E)}store(m,E,b){return this.a.$setPassword(m,E,b)}delete(m,E){return this.a.$deletePassword(m,E)}}e.$_cc=R,e.$adc=(0,f.$Qh)("IExtHostSecretState")}),define(De[328],Ce([1,0,6,13,2]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;class R{static{this.a=0}constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(C.$pK.MainThreadShare)}async $provideShare(m,E,b){return await this.c.get(m)?.provideShare({selection:O.Range.to(E.selection),resourceUri:f.URI.revive(E.resourceUri)},b)??void 0}registerShareProvider(m,E){const b=R.a++;return this.c.set(b,E),this.b.$registerShareProvider(b,O.DocumentSelector.from(m,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(b),this.c.delete(b)}}}}e.$wec=R}),define(De[329],Ce([1,0,21,3,6]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class R{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(f.$pK.MainThreadSpeech)}async $createSpeechToTextSession(m,E){const b=this.c.get(m);if(!b)return;const L=new O.$Rc,P=new C.$Yd;this.d.set(E,P);const p=L.add(b.provideSpeechToTextSession(P.token));L.add(p.onDidChange(y=>{P.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,y)})),L.add(P.token.onCancellationRequested(()=>L.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,E,b){const L=R.a++;return this.c.set(L,b),this.b.$registerProvider(L,E,{extension:m,displayName:m.value}),(0,O.$Qc)(()=>{this.b.$unregisterProvider(L),this.c.delete(L)})}}e.$yec=R}),define(De[330],Ce([1,0,7,6,210,3,13,17]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$mL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$mL("statusBarItem.warningForeground")]])}#e;#t;constructor(p,y,k,v,h,o=C.StatusBarAlignment.Left,l){if(this.i=!1,this.k="",this.q=new R.$Rc,this.#e=p,this.#t=y,h&&v){this.c=(0,C.$2K)(v.identifier,h);const c=k.get(this.c);c&&(o=c.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,l=c.priority,this.j=!0,this.name=c.name,this.text=c.text,this.tooltip=c.tooltip,this.command=c.command,this.accessibilityInformation=c.accessibilityInformation)}else this.c=String(E.a++);this.e=v,this.f=h,this.g=o,this.h=this.u(l)}u(p){if((0,m.$Df)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!E.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new R.$Rc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let y;this.m?y=this.m:y=(0,f.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=E.b.get(this.o.id));const v=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,y,this.k,v,this.r?.internal,k,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$vdc=E;class b{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const y={message:p};return this.b.unshift(y),this.c(),new C.$rK(()=>{const k=this.b.indexOf(y);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class L{constructor(p,y){this.e=new Map,this.a=p.getProxy(O.$pK.MainThreadStatusBar),this.b=y,this.c=new b(this)}$acceptStaticEntries(p){for(const y of p)this.e.set(y.entryId,y)}createStatusBarEntry(p,y,k,v){return new E(this.a,this.b,this.e,p,y,k,v)}setStatusBarMessage(p,y){const k=this.c.setMessage(p);let v;return typeof y=="number"?v=setTimeout(()=>k.dispose(),y):typeof y<"u"&&y.then(()=>k.dispose(),()=>k.dispose()),new C.$rK(()=>{k.dispose(),clearTimeout(v)})}}e.$wdc=L}),define(De[115],Ce([1,0,6,4,5]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=void 0;class R{constructor(m,E){this.c=E,this.b=new O.$Od,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(C.$pK.MainThreadStorage)}registerExtensionStorageKeysToSync(m,E){this.a.$registerExtensionStorageKeysToSync(m,E)}async initializeExtensionStorage(m,E,b){const L=await this.a.$initializeExtensionStorage(m,E);let P;return L&&(P=this.d(m,E,L)),P||b}setValue(m,E,b){return this.a.$setValue(m,E,b)}$acceptValue(m,E,b){const L=this.d(m,E,b);L&&this.b.fire({shared:m,key:E,value:L})}d(m,E,b){try{return JSON.parse(b)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${m}): ${L}`)}}}e.$Zcc=R,e.$1cc=(0,f.$Qh)("IExtHostStorage")}),define(De[90],Ce([1,0,5,27,14,72,2]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=void 0,e.$6cc=(0,C.$Qh)("IExtensionStoragePaths");let m=class{constructor(b,L,P){this.d=L,this.f=P,this.a=b.workspace??void 0,this.b=b.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(b){return A.URI.joinPath(this.b.workspaceStorageHome,b)}async h(){if(!this.a)return Promise.resolve(void 0);const b=this.a.id,L=await this.g(b);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(A.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(b){if(this.c)return A.URI.joinPath(this.c,b.identifier.value)}globalValue(b){return A.URI.joinPath(this.b.globalStorageHome,b.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$7cc=m,e.$7cc=m=He([Be(0,O.$GM),Be(1,f.$$i),Be(2,R.$5cc)],m)}),define(De[45],Ce([1,0,4,6,5,2,20,3,7,212,9,254,21,31,255,59,8,13,34]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=e.$9cc=e.$8cc=void 0,e.$8cc=(0,f.$Qh)("IExtHostTerminalService");class c{constructor($,g,w,D){this.l=$,this._id=g,this.m=w,this.n=D,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(M=>this.f=M);const T=this;this.value={get name(){return T.n||""},get processId(){return T.b},get creationOptions(){return T.m},get exitStatus(){return T.h},get state(){return T.j},get selection(){return T.k},sendText(M,F=!0){T.q(),T.l.$sendText(T._id,M,F)},show(M){T.q(),T.l.$show(T._id,M)},hide(){T.q(),T.l.$hide(T._id)},dispose(){T.a||(T.a=!0,T.l.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create($,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??void 0,env:$.env??void 0,icon:r($.iconPath)??void 0,color:v.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,isFeatureTerminal:g?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:g?.useShellEnvironment??void 0,location:g?.location||this.o($.location,g?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,g,w,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:w,color:v.ThemeColor.isThemeColor(D)?D.id:void 0,location:this.o($,g),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,g){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in $?{viewColumn:o.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,g){this.h=Object.freeze({code:$,reason:g})}setDimensions($,g){return $===this.d&&g===this.g||$===0||g===0?!1:(this.d=$,this.g=g,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(g=>{g!==$&&(this.b=Promise.resolve($))})}}e.$9cc=c;class d{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new C.$Od,this.onProcessData=this.a.event,this.b=new C.$Od,this.d=new C.$Od,this.onDidChangeProperty=this.d.event,this.f=new C.$Od,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${g}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,g){this.g.setDimensions?.({columns:$,rows:g})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(g=>this.a.fire(g)),this.g.onDidClose?.((g=void 0)=>{this.f.fire(g===void 0?void 0:g)}),this.g.onDidOverrideDimensions?.(g=>{g&&this.d.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this.g.onDidChangeName?.(g=>{this.d.fire({type:"title",value:g})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends m.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,g,w){super(),this.Q=g,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$Od,this.onDidCloseTerminal=this.H.event,this.I=new C.$Od,this.onDidOpenTerminal=this.I.event,this.J=new C.$Od,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$Od,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$Od,this.onDidChangeTerminalState=this.M.event,this.N=new C.$Od,this.onDidChangeShell=this.N.event,this.O=new C.$Od({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$Od({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(O.$pK.MainThreadTerminalService),this.y=new k.$8kb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:D=>{const T=M=>{const F=M;return this.W(F.instanceId)?.value};switch(D?.$mid){case 15:return T(D);default:{if(Array.isArray(D))for(let M=0;M<D.length&&D[M].$mid===15;M++)D[M]=T(D[M]);return D}}}}),this.B({dispose:()=>{for(const[D,T]of this.g)T.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,g){const w=new c(this.a,(0,y.$fg)(),$,$.name),D=new d($.pty);return w.createExtensionTerminal($.location,this.R($,g).resolvedExtHostIdentifier,r($.iconPath),u($.color)).then(T=>{const M=this.S(T,D);this.h[T]=M}),this.f.push(w),w.value}R($,g){if(g=g||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const w=$.location.parentTerminal;if(w){const D=this.f.find(T=>T.value===w);D&&(g.resolvedExtHostIdentifier=D._id)}}else $.location&&typeof $.location!="object"?g.location=$.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal($,g){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const D=new d(g),T=this.S($,D);this.h[$]=T}async $acceptActiveTerminalChanged($){const g=this.b;if($===null){this.b=void 0,g!==this.b&&this.J.fire(this.b);return}const w=this.W($);w&&(this.b=w,g!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,g){const w=this.W($);w&&this.O.fire({terminal:w.value,data:g})}async $acceptTerminalDimensions($,g,w){const D=this.W($);D&&D.setDimensions(g,w)&&this.L.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptDidExecuteCommand($,g){const w=this.W($);w&&this.P.fire({terminal:w.value,...g})}async $acceptTerminalMaximumDimensions($,g,w){this.g.get($)?.resize(g,w)}async $acceptTerminalTitleChange($,g){const w=this.W($);w&&(w.name=g)}async $acceptTerminalClosed($,g,w){const D=this.Y(this.f,$);if(D!==null){const T=this.f.splice(D,1)[0];T.setExitStatus(g,w),this.H.fire(T.value)}}$acceptTerminalOpened($,g,w,D){if(g){const F=this.Y(this.f,g);if(F!==null){this.f[F]._id=$,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const T={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:R.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},M=new c(this.a,$,T,w);this.f.push(M),this.I.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId($,g){this.W($)?._setProcessId(g)}async $startExtensionTerminal($,g){const w=this.W($);if(!w)return{message:(0,b.localize)(0,null,$)};w.isOpen||await new Promise(T=>{const M=this.onDidOpenTerminal(async F=>{F===w.value&&(M.dispose(),T())})});const D=this.g.get($);D?D.startSendingEvents(g):this.j[$]={initialDimensions:g}}S($,g){const w=new m.$Rc;w.add(g.onProcessReady(T=>this.a.$sendProcessReady($,T.pid,T.cwd,T.windowsPty))),w.add(g.onDidChangeProperty(T=>this.a.$sendProcessProperty($,T))),this.y.startBuffering($,g.onProcessData),w.add(g.onProcessExit(T=>this.U($,T))),this.g.set($,g);const D=this.j[$];return D&&g instanceof d&&(g.startSendingEvents(D.initialDimensions),delete this.j[$]),w}$acceptProcessAckDataEvent($,g){this.g.get($)?.acknowledgeDataEvent(g)}$acceptProcessInput($,g){this.g.get($)?.input(g)}$acceptTerminalInteraction($){const g=this.W($);g?.setInteractedWith()&&this.M.fire(g.value)}$acceptTerminalSelection($,g){this.W($)?.setSelection(g)}$acceptProcessResize($,g,w){try{this.g.get($)?.resize(g,w)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown($,g){this.g.get($)?.shutdown(g)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(g=>this.a.$sendProcessProperty($,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(g=>this.a.$sendProcessProperty($,{type:"cwd",value:g}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new E.$rK(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,g,w){if(this.C.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this.C.set(g,w),this.a.$registerProfileProvider(g,$.identifier.value),new E.$rK(()=>{this.C.delete(g),this.a.$unregisterProfileProvider(g)})}registerTerminalQuickFixProvider($,g,w){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,w),this.a.$registerQuickFixProvider($,g),new E.$rK(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,g){const w=new p.$Yd().token;if(w.isCancellationRequested)return;const D=this.D.get($);if(!D)return;const T=await D.provideTerminalQuickFixes(g,w);if(T===null||Array.isArray(T)&&T.length===0)return;const M=new m.$Rc;if(this.w.value=M,!Array.isArray(T))return T?o.TerminalQuickFix.from(T,this.Q.converter,M):void 0;const F=[];for(const z of T){const j=o.TerminalQuickFix.from(z,this.Q.converter,M);j&&F.push(j)}return F}async $createContributedProfileTerminal($,g){const w=new p.$Yd().token;let D=await this.C.get($)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(D&&!("options"in D)&&(D={options:D}),!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,g);return}this.createTerminalFromOptions(D.options,g)}}async $provideLinks($,g){const w=this.W($);if(!w)return[];this.F.delete($),this.G.get($)?.dispose(!0);const T=new p.$Yd;this.G.set($,T);const M=[],F={terminal:w.value,line:g},z=[];for(const q of this.z)z.push(h.Promises.withAsyncBody(async K=>{T.token.onCancellationRequested(()=>K({provider:q,links:[]}));const me=await q.provideTerminalLinks(F,T.token)||[];T.token.isCancellationRequested||K({provider:q,links:me})}));const j=await Promise.all(z);if(T.token.isCancellationRequested)return[];const N=new Map;for(const q of j)q&&q.links.length>0&&M.push(...q.links.map(K=>{const me={id:a++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return N.set(me.id,{provider:q.provider,link:K}),me}));return this.F.set($,N),M}$activateLink($,g){const w=this.F.get($)?.get(g);w&&w.provider.handleTerminalLink(w.link)}U($,g){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const w=this.h[$];w&&(w.dispose(),delete this.h[$]),this.a.$sendProcessExit($,g)}W($){return this.X(this.f,$)}X($,g){const w=this.Y($,g);return w!==null?$[w]:null}Y($,g){const w=$.findIndex(D=>D._id===g);return w===-1?null:w}getEnvironmentVariableCollection($){let g=this.n.get($.identifier.value);return g||(g=new i,this.$($.identifier.value,g)),g.getScopedEnvironmentVariableCollection(void 0)}Z($,g){const w=(0,P.$or)(g.map),D=(0,P.$pr)(g.descriptionMap);this.a.$setEnvironmentVariableCollection($,g.persistent,w.length===0?void 0:w,D)}$initEnvironmentVariableCollections($){$.forEach(g=>{const w=g[0],D=new i(g[1]);this.$(w,D)})}$acceptDefaultProfile($,g){const w=this.s;this.s=$,this.u=g,w?.path!==$.path&&this.N.fire($.path)}$($,g){this.n.set($,g),g.onDidChangeCollection(()=>{this.Z($,g)})}};e.$0cc=t,e.$0cc=t=He([Be(1,l.$MM),Be(2,A.$qM)],t);class i{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$Od,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const g=this.h($);let w=this.a.get(g);return w||(w=new s(this,$),this.a.set(g,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace($,g,w,D){this.f($,{value:g,type:E.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:D})}append($,g,w,D){this.f($,{value:g,type:E.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:D})}prepend($,g,w,D){this.f($,{value:g,type:E.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:D})}f($,g){if(g.options&&g.options.applyAtProcessCreation===!1&&!g.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g($,g.scope),D=this.map.get(w),T=g.options?{applyAtProcessCreation:g.options.applyAtProcessCreation??!1,applyAtShellIntegration:g.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!D||D.value!==g.value||D.type!==g.type||D.options?.applyAtProcessCreation!==T.applyAtProcessCreation||D.options?.applyAtShellIntegration!==T.applyAtShellIntegration||D.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index){const M=this.g($,g.scope),F={variable:$,...g,options:T};this.map.set(M,F),this.d.fire()}}get($,g){const w=this.g($,g),D=this.map.get(w);return D?I(D):void 0}g($,g){const w=this.h(g);return w.length?`${$}:::${w}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const g=new Map;for(const[w,D]of this.map)this.h(D.scope)===this.h($)&&g.set(D.variable,I(D));return g}delete($,g){const w=this.g($,g);this.map.delete(w),this.d.fire()}clear($){if($?.workspaceFolder){for(const[g,w]of this.map)w.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(g);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,g){const w=this.h(g),D=this.descriptionMap.get(w);if(!D||D.description!==$){let T;typeof $=="string"?T=$:T=$?.value.split(`

`)[0];const M={description:T,scope:g};this.descriptionMap.set(w,M),this.d.fire()}}getDescription($){const g=this.h($);return this.descriptionMap.get(g)?.description}k($){const g=this.h($);this.descriptionMap.delete(g)}}class s{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,g){this.b=$,this.d=g,this.a=new C.$Od}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,g,w){this.b.replace($,g,w,this.d)}append($,g,w){this.b.append($,g,w,this.d)}prepend($,g,w){this.b.prepend($,g,w,this.d)}get($){return this.b.get($,this.d)}forEach($,g){this.b.getVariableMap(this.d).forEach((w,D)=>$.call(g,D,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let n=class extends t{constructor($,g){super(!1,$,g)}createTerminal($,g,w){throw new L.$_}createTerminalFromOptions($,g){throw new L.$_}};e.$$cc=n,e.$$cc=n=He([Be(0,l.$MM),Be(1,A.$qM)],n);function r(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function u(S){return v.ThemeColor.isThemeColor(S)?S:void 0}function I(S){const $={...S};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(De[331],Ce([1,0,118,8,22,21,4,75,52,3,24,17,31,6,20,147,13,7,68,109,87]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=e.$hec=e.$gec=e.$fec=void 0;let a=class{constructor(M,F,z){this.j=z,this.c=new A.$Od,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=M.getProxy(y.$pK.MainThreadTesting),this.h=new g(this.f),this.g=new n(this.f),F.registerArgumentProcessor({processArgument:j=>{switch(j?.$mid){case 16:{const N=j,q=N.tests[N.tests.length-1].item.extId;return this.d.get(l.$iJ.root(q))?.collection.tree.get(q)?.actual??(0,v.$CM)(j)}case 18:{const{extId:N,message:q}=j;return{test:this.d.get(l.$iJ.root(N))?.collection.tree.get(N)?.actual,message:h.TestMessage.to(q)}}default:return j}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const j=await F.executeCommand("_testing.getExplorerSelection"),N=q=>{const K=this.d.get(l.$iJ.root(q));if(K)return l.$iJ.isRoot(q)?K.controller:K.collection.tree.get(q)?.actual};return{include:j?.include.map(N).filter(P.$Hf)||[],exclude:j?.exclude.map(N).filter(P.$Hf)||[]}})}createTestController(M,F,z,j){if(this.d.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const N=new b.$Rc,q=N.add(new v.$FM(F,z,this.j));q.root.label=z;const K=new Map,me=this.f,te={items:q.root.children,get label(){return z},set label(J){z=J,q.root.label=J,me.$updateController(F,{label:z})},get refreshHandler(){return j},set refreshHandler(J){j=J,me.$updateController(F,{canRefresh:!!J})},get id(){return F},createRunProfile:(J,le,ie,ce,ye,H)=>{let B=(0,E.$Ei)(J);for(;K.has(B);)B++;return new w(this.f,K,F,B,J,le,ie,ce,ye,H)},createTestItem(J,le,ie){return new v.$DM(F,J,le,ie)},createTestRun:(J,le,ie=!0)=>this.g.createTestRun(M,F,q,J,le,ie),invalidateTestResults:J=>{if(J===void 0)this.f.$markTestRetired(void 0);else{const le=J instanceof Array?J:[J];this.f.$markTestRetired(le.map(ie=>l.$iJ.fromExtHostTestItem(ie,F).toString()))}},set resolveHandler(J){q.resolveHandler=J},get resolveHandler(){return q.resolveHandler},dispose:()=>{N.dispose()}};me.$registerTestController(F,z,!!j),N.add((0,b.$Qc)(()=>me.$unregisterTestController(F)));const G={controller:te,collection:q,profiles:K,extension:M};return this.d.set(F,G),N.add((0,b.$Qc)(()=>this.d.delete(F))),N.add(q.onDidGenerateDiff(J=>me.$publishDiff(F,J.map(d.TestsDiffOp.serialize)))),te}createTestObserver(){return this.h.checkout()}async runTests(M,F=R.CancellationToken.None){const z=r(M);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(z.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(N=>l.$iJ.fromExtHostTestItem(N,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:D[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:M.exclude?.map(N=>N.id)},F)}$syncTests(){for(const{collection:M}of this.d.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,F,z){return(0,C.$rb)(this.g.trackers,N=>N.id===M?N.getCoverage(F):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(M,F,z,j){return(0,C.$rb)(this.g.trackers,q=>q.id===M?q.getCoverage(F):void 0)?.resolveFileCoverage(z,j)??Promise.resolve([])}$configureRunProfile(M,F){this.d.get(M)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(M,F){await this.d.get(M)?.controller.refreshHandler?.(F)}$publishTestResults(M){this.results=Object.freeze(M.map(F=>(0,L.$9m)(h.TestResults.to(F))).concat(this.results).sort((F,z)=>z.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(M,F){const z=this.d.get(l.$iJ.fromString(M).controllerId)?.collection;z&&(await z.expand(M,F<0?1/0:F),z.flushDiff())}$acceptDiff(M){this.h.applyDiff(M.map(d.TestsDiffOp.deserialize))}async $runControllerTests(M,F){return Promise.all(M.map(z=>this.k(z,!1,F)))}async $startContinuousRun(M,F){const z=new R.$Yd(F),j=await Promise.all(M.map(N=>this.k(N,!0,z.token)));return!F.isCancellationRequested&&!j.some(N=>N.error)&&await new Promise(N=>F.onCancellationRequested(N)),z.dispose(!0),j}async k(M,F,z){const j=this.d.get(M.controllerId);if(!j)return{};const{collection:N,profiles:q,extension:K}=j,me=q.get(M.profileId);if(!me)return{};const te=M.testIds.map(ie=>N.tree.get(ie)).filter(P.$Hf),G=M.excludeExtIds.map(ie=>j.collection.tree.get(ie)).filter(P.$Hf).filter(ie=>te.some(ce=>ce.fullId.compare(ie.fullId)===2));if(!te.length)return{};const J=new o.$ZL(te.some(ie=>ie.actual instanceof v.$EM)?void 0:te.map(ie=>ie.actual),G.map(ie=>ie.actual),me,F),le=(0,d.$kJ)(M)&&this.g.prepareForMainThreadTestRun(J,u.fromInternal(M,j.collection),K,z);try{return await me.runHandler(J,z),{}}catch(ie){return{error:String(ie)}}finally{le&&(le.hasRunningTasks&&!z.isCancellationRequested&&await A.Event.toPromise(le.onEnd),le.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.g.cancelAllRuns():this.g.cancelRunById(M)}};e.$fec=a,e.$fec=a=He([Be(0,k.$qM)],a);const t=1e4;var i;(function(T){T[T.Running=0]="Running",T[T.Cancelling=1]="Cancelling",T[T.Ended=2]="Ended"})(i||(i={}));class s extends b.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(M,F,z){super(),this.m=M,this.s=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Od),this.onEnd=this.j.event,this.h=this.B(new R.$Yd(z));const j=this.B(new O.$7g(()=>this.u(),t));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const F=this.m.id,z=this.m.controllerId,j=(0,p.$fg)(),N=new I(this.s,F,j),q=G=>(J,...le)=>{if(me){console.warn(`Setting the state of test "${J.id}" is a no-op after the run ends.`);return}this.m.isIncluded(J)&&(this.y(J),G(J,...le))},K=(G,J)=>{const le=J instanceof Array?J.map(h.TestMessage.from):[h.TestMessage.from(J)];if(G.uri&&G.range){const ie={range:h.Range.from(G.range),uri:G.uri};for(const ce of le)ce.location=ce.location||ie}this.s.$appendTestMessagesInRun(F,j,l.$iJ.fromExtHostTestItem(G,z).toString(),le)};let me=!1;const te={isPersisted:this.m.isPersisted,token:this.h.token,name:M,get coverageProvider(){return N.coverageProvider},set coverageProvider(G){N.coverageProvider=G},enqueued:q(G=>{this.s.$updateTestStateInRun(F,j,l.$iJ.fromExtHostTestItem(G,z).toString(),1)}),skipped:q(G=>{this.s.$updateTestStateInRun(F,j,l.$iJ.fromExtHostTestItem(G,z).toString(),5)}),started:q(G=>{this.s.$updateTestStateInRun(F,j,l.$iJ.fromExtHostTestItem(G,z).toString(),2)}),errored:q((G,J,le)=>{K(G,J),this.s.$updateTestStateInRun(F,j,l.$iJ.fromExtHostTestItem(G,z).toString(),6,le)}),failed:q((G,J,le)=>{K(G,J),this.s.$updateTestStateInRun(F,j,l.$iJ.fromExtHostTestItem(G,z).toString(),4,le)}),passed:q((G,J)=>{this.s.$updateTestStateInRun(F,j,l.$iJ.fromExtHostTestItem(G,this.m.controllerId).toString(),3,J)}),appendOutput:(G,J,le)=>{me||(le&&(this.m.isIncluded(le)?this.y(le):le=void 0),this.s.$appendOutputToRun(F,j,f.$ce.fromString(G),J&&h.location.from(J),le&&l.$iJ.fromExtHostTestItem(le,z).toString()))},end:()=>{me||(me=!0,this.s.$finishedTestRunTask(F,j),this.f.delete(j),this.f.size||this.w())}};return this.f.set(j,{run:te,coverage:N}),this.s.$startedTestRunTask(F,{id:j,name:M,running:!0}),te}u(){for(const{run:M}of this.f.values())M.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(M){if(!(M instanceof v.$DM))throw new c.$iM(M.id);if(this.g.has(l.$iJ.fromExtHostTestItem(M,this.m.controllerId).toString()))return;const F=[],z=this.m.colllection.root;for(;;){const j=h.TestItem.from(M);if(F.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),M===z))break;M=M.parent||z}this.s.$addTestsToRun(this.m.controllerId,this.m.id,F)}dispose(){this.w(),super.dispose()}}class n{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,F,z,j){return this.f(M,F,z,j)}cancelRunById(M){for(const F of this.c.values())if(F.id===M){F.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,F,z,j,N,q){const K=this.c.get(j);if(K)return K.createRun(N);const me=u.fromPublic(F,z,j,q),te=r(j);this.d.$startedExtensionTestRun({controllerId:F,continuous:!!j.continuous,profile:te&&{group:D[te.kind],id:te.profileId},exclude:j.exclude?.map(J=>l.$iJ.fromExtHostTestItem(J,z.root.id).toString())??[],id:me.id,include:j.include?.map(J=>l.$iJ.fromExtHostTestItem(J,z.root.id).toString())??[z.root.id],persist:q});const G=this.f(j,me,M);return A.Event.once(G.onEnd)(()=>{this.d.$finishedExtensionTestRun(me.id),G.dispose()}),G.createRun(N)}f(M,F,z,j){const N=new s(F,this.d,j);return this.c.set(M,N),A.Event.once(N.onEnd)(()=>this.c.delete(M)),N}}e.$gec=n;const r=T=>{if(T.profile){if(!(T.profile instanceof w))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class u{static fromPublic(M,F,z,j){return new u(M,(0,p.$fg)(),z.include?.map(N=>l.$iJ.fromExtHostTestItem(N,M).toString())??[M],z.exclude?.map(N=>l.$iJ.fromExtHostTestItem(N,M).toString())??[],j,F)}static fromInternal(M,F){return new u(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,F)}constructor(M,F,z,j,N,q){this.controllerId=M,this.id=F,this.isPersisted=N,this.colllection=q,this.c=z.map(K=>K+"\0"),this.d=j.map(K=>K+"\0")}isIncluded(M){const F=l.$iJ.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const z of this.d)if(F===z||F.startsWith(z))return!1;for(const z of this.c)if(F===z||F.startsWith(z))return!0;return!1}}e.$hec=u;class I{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,F,z){this.f=M,this.g=F,this.h=z}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(h.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(M,F){const z=await this.d;let j=z?.[M];return!this.c||!z||!j?[]:(j.detailedCoverage||(j=z[M]=await this.c.resolveFileCoverage?.(j,F)??j),j.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class S{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,h.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const F=l.$iJ.parentId(M.item.extId);if(F&&this.g.has(F.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:F,f:z}=this;return{get added(){return[...M].map(j=>j.revived)},get updated(){return[...F].map(j=>j.revived)},get removed(){return[...z].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class $ extends d.$pJ{constructor(){super(...arguments),this.q=new A.$Od,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,F){return{...M,revived:h.TestItem.toPlain(M.item),depth:F?F.depth+1:0,children:new Set}}o(){return new S(this.q)}}class g{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(F=>F.revived)},dispose:(0,m.$db)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new $;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class w{#e;#t;get label(){return this.d}set label(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?h.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,F,z,j,N,q,K,me=!1,te=void 0,G=!1){this.controllerId=z,this.profileId=j,this.d=N,this.kind=q,this.runHandler=K,this.f=me,this._tag=te,this.g=G,this.#e=M,this.#t=F,F.set(j,this);const J=D[q];if(typeof J!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);this.#e.$publishTestRunProfile({profileId:j,controllerId:z,tag:te?h.TestTag.namespace(this.controllerId,te.id):null,label:N,group:J,isDefault:me,hasConfigurationHandler:!1,supportsContinuousRun:G})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$iec=w;const D={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(De[332],Ce([1,0,19,9,4,6,148,13,7]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class b{constructor(P,p){this.i=p,this.a=new f.$Od({onListenerError:O.$2}),this.b=new f.$Od({onListenerError:O.$2}),this.c=new f.$Od({onListenerError:O.$2}),this.d=new f.$Od({onListenerError:O.$2}),this.f=new f.$Od({onListenerError:O.$2}),this.g=new f.$Od({onListenerError:O.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=P.getProxy(R.$pK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(P){const p=this.i.allEditors();return P?p:p.map(y=>y.value)}async showTextDocument(P,p,y){let k;typeof p=="number"?k={position:m.ViewColumn.from(p),preserveFocus:y}:typeof p=="object"?k={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selection:typeof p.selection=="object"?m.Range.from(p.selection):void 0,pinned:typeof p.preview=="boolean"?!p.preview:void 0}:k={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(P.uri,k),h=v&&this.i.getEditor(v);if(h)return h.value;throw v?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,p){return new A.$xM(this.h,P,p).value}$acceptEditorPropertiesChanged(P,p){const y=this.i.getEditor(P);if(!y)throw new Error("unknown text editor");if(p.options&&y._acceptOptions(p.options),p.selections){const k=p.selections.selections.map(m.Selection.to);y._acceptSelections(k)}if(p.visibleRanges){const k=C.$Hb(p.visibleRanges.map(m.Range.to));y._acceptVisibleRanges(k)}if(p.options&&this.b.fire({textEditor:y.value,options:{...p.options,lineNumbers:m.TextEditorLineNumbersStyle.to(p.options.lineNumbers)}}),p.selections){const k=E.TextEditorSelectionChangeKind.fromValue(p.selections.source),v=p.selections.selections.map(m.Selection.to);this.a.fire({textEditor:y.value,selections:v,kind:k})}if(p.visibleRanges){const k=C.$Hb(p.visibleRanges.map(m.Range.to));this.c.fire({textEditor:y.value,visibleRanges:k})}}$acceptEditorPositionData(P){for(const p in P){const y=this.i.getEditor(p);if(!y)throw new Error("Unknown text editor");const k=m.ViewColumn.to(P[p]);y.value.viewColumn!==k&&(y._acceptViewColumn(k),this.d.fire({textEditor:y.value,viewColumn:k}))}}getDiffInformation(P){return Promise.resolve(this.h.$getDiffInformation(P))}}e.$xdc=b}),define(De[333],Ce([1,0,2,5,6,3,7,13,25,17]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=void 0,e.$_dc=(0,O.$Qh)("IExtHostTimeline");class L{constructor(y,k){this.b=new Map,this.c=new Map,this.a=y.getProxy(f.$pK.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(v,h)=>{if(v&&v.$mid===12)if(this.b.get(v.source)&&E.$7l.equals(h,this.b.get(v.source)?.extension)){const o=v.uri===void 0?void 0:C.URI.revive(v.uri);return this.c.get(v.source)?.get(P(o))?.get(v.handle)}else return;return v}})}async $getTimeline(y,k,v,h){return this.b.get(y)?.provider.provideTimeline(C.URI.revive(k),v,h)}registerTimelineProvider(y,k,v,h){const o=new R.$Rc,l=this.d(k.id,h,o).bind(this);let c;k.onDidChange&&(c=k.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:k.id}),this));const d=this.c;return this.f({...k,scheme:y,onDidChange:void 0,async provideTimeline(a,t,i){t?.resetCache&&(o.clear(),d.get(k.id)?.clear());const s=await k.provideTimeline(a,t,i);if(s==null)return;const n=l(a,t);return{...s,source:k.id,items:s.items.map(n)}},dispose(){for(const a of d.values())a.get(k.id)?.clear();c?.dispose(),o.dispose()}},v)}d(y,k,v){return(h,o)=>{let l;if(o?.cacheResults){let c=this.c.get(y);c===void 0&&(c=new Map,this.c.set(y,c));const d=P(h);l=c.get(d),l===void 0&&(l=new Map,c.set(d,l))}return c=>{const{iconPath:d,...a}=c,t=`${y}|${c.id??c.timestamp}`;l?.set(t,c);let i,s,n;c.iconPath&&(d instanceof A.$lL?n={id:d.id,color:d.color}:C.URI.isUri(d)?(i=d,s=d):{light:i,dark:s}=d);let r;return A.$RK.isMarkdownString(a.tooltip)?r=m.MarkdownString.from(a.tooltip):(0,b.$zf)(a.tooltip)?r=a.tooltip:A.$RK.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=m.MarkdownString.from(a.detail)):(0,b.$zf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=a.detail),{...a,id:a.id??void 0,handle:t,source:y,command:c.command?k.toInternal(c.command,v):void 0,icon:i,iconDark:s,themeIcon:n,tooltip:r,accessibilityInformation:c.accessibilityInformation}}}}f(y,k){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:k}),(0,R.$Qc)(()=>{for(const h of this.c.values())h.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$aec=L;function P(p){return p?.toString()}}),define(De[73],Ce([1,0,21,4,3,214,5,14,86,6,27,20,7]),function($e,e,C,O,f,R,A,m,E,b,L,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$owb=e.$nwb=e.TunnelDtoConverter=void 0;class y extends E.$kv{}var k;(function(h){function o(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:c.protocol}}h.fromApiTunnel=o;function l(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==E.TunnelPrivacyId.ConstantPrivate&&c.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}h.fromServiceTunnel=l})(k||(e.TunnelDtoConverter=k={})),e.$nwb=(0,A.$Qh)("IExtHostTunnelService");let v=class extends f.$Sc{constructor(o,l,c){super(),this.s=c,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$Od,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(b.$pK.MainThreadTunnelService)}async openTunnel(o,l){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const c=await this.a.$openTunnel(l,o.displayName);if(c){const d=new y(c.remoteAddress,c.localAddress,()=>this.a.$closeTunnel(c.remoteAddress));return this.B(d),d}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,l){const c=this.u();return this.r.set(c,{selector:o,provider:l}),this.a.$registerPortsAttributesProvider(o,c),new p.$rK(()=>{this.r.delete(c),this.a.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(o,l,c,d,a){const t=[];for(const s of o){const n=this.r.get(s);if(!n)return[];t.push(...await Promise.all(l.map(async r=>{let u;try{u=await n.provider.providePortAttributes({port:r,pid:c,commandLine:d},a)}catch{u=await n.provider.providePortAttributes(r,c,d,a)}return{providedAttributes:u,port:r}})))}const i=t.filter(s=>!!s.providedAttributes);return i.length>0?i.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,l){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(d,a)=>await o.provideTunnel(d,a,new C.$Yd().token)??void 0;const c=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(c),Promise.resolve((0,f.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,l){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const c=o.tunnelFactory??(l?this.w(l):void 0);if(c){this.b=c;let d=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:d}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,f.$Qc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,l){if(this.g.has(o.host)){const c=this.g.get(o.host);c.has(o.port)&&(l&&c.get(o.port).disposeListener.dispose(),await c.get(o.port).tunnel.dispose(),c.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,l){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this.b(o,l);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const d=await c;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),d===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const a=this.B(d.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(d.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:d,disposeListener:a}),k.fromApiTunnel(d)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(o){const l=await Promise.all(o.map(d=>this.f(d.host,d.port,d.detail??""))),c=o.filter((d,a)=>l[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(d=>d.port).join(", ")} to ${c.map(d=>d.port).join(", ")}`),c}};e.$owb=v,e.$owb=v=He([Be(0,P.$qM),Be(1,L.$GM),Be(2,m.$$i)],v)}),define(De[334],Ce([1,0,3,18,2,6]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class A{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(R.$pK.MainThreadUriOpeners)}registerExternalUriOpener(E,b,L,P){if(this.c.has(b))throw new Error(`Opener with id '${b}' already registered`);const p=P.schemes.find(y=>!A.a.has(y));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(b,L),this.b.$registerUriOpener(b,P.schemes,E,P.label),(0,C.$Qc)(()=>{this.c.delete(b),this.b.$unregisterUriOpener(b)})}async $canOpenUri(E,b,L){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener with id: ${E}`);const p=f.URI.revive(b);return P.canOpenExternalUri(p,L)}async $openUri(E,b,L){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener id: '${E}'`);return P.openExternalUri(f.URI.revive(b.resolvedUri),{sourceUri:f.URI.revive(b.sourceUri)},L)}}e.$jec=A}),define(De[335],Ce([1,0,6,2,3,9,25]),function($e,e,C,O,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class m{static{this.a=0}constructor(b){this.c=new A.$8l,this.d=new Map,this.b=b.getProxy(C.$pK.MainThreadUrls)}registerUriHandler(b,L){const P=b.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const p=m.a++;return this.c.add(P),this.d.set(p,L),this.b.$registerUriHandler(p,P,b.displayName||b.name),(0,f.$Qc)(()=>{this.c.delete(P),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(b,L){const P=this.d.get(b);if(!P)return Promise.resolve(void 0);try{P.handleUri(O.URI.revive(L))}catch(p){(0,R.$1)(p)}return Promise.resolve(void 0)}async createAppUri(b){return O.URI.revive(await this.b.$createAppUri(b))}}e.$zdc=m}),define(De[91],Ce([1,0,4,3,18,24,2,229,266,110,6]),function($e,e,C,O,f,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=e.$Ddc=e.$Cdc=e.$Bdc=e.$Adc=void 0;class P{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(d,a,t,i,s,n,r){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new C.$Od,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$Od,this._onDidDispose=this.#h.event,this.#e=d,this.#t=a,this.#r=t,this.#l=i,this.#u=s,this.#n=n,this.#c=p(n),this.#d=y(n),this.#i=r}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return this.#a=!0,(0,b.$lpb)(d,this.#l)}get cspSource(){const d=this.#n.extensionLocation;if(d.scheme===f.Schemas.https||d.scheme===f.Schemas.http){let a=d.toString();return a.endsWith("/")||(a+="/"),a+" "+b.$kpb}return b.$kpb}get html(){return this.a(),this.#s}set html(d){this.a(),this.#s!==d&&(this.#s=d,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(d)))}get options(){return this.a(),this.#r}set options(d){this.a(),R.$_m(this.#r,d)||this.#t.$setOptions(this.#e,h(this.#n,this.#u,d)),this.#r=d}async postMessage(d){if(this.#o)return!1;const a=(0,E.$Lcb)(d,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(d){if(!this.#d)return d;const a=this.#n.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return d.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,s,n,r,u,I)=>{const S=A.URI.from({scheme:r||"file",path:decodeURIComponent(u)}),$=(0,b.$lpb)(S,{isRemote:a,authority:t}).toString();return`${s}${$}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,s,n,r,u,I)=>{const S=A.URI.from({scheme:r||"file",path:decodeURIComponent(u)}),$=(0,b.$lpb)(S,{isRemote:a,authority:t}).toString();return`${s}${$}${I}`})}}e.$Adc=P;function p(c){try{const d=(0,m.$Ro)((0,m.$Qo)(c.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.$Bdc=p;function y(c){try{const d=(0,m.$Ro)((0,m.$Qo)(c.engines.vscode));return d?d.majorBase<1||d.majorBase===1&&d.minorBase<60:!1}catch{return!1}}class k extends O.$Sc{constructor(d,a,t,i,s){super(),this.c=a,this.f=t,this.g=i,this.h=s,this.b=new Map,this.a=d.getProxy(L.$pK.MainThreadWebviews)}dispose(){super.dispose();for(const d of this.b.values())d.dispose();this.b.clear()}$onMessage(d,a,t){const i=this.j(d);if(i){const{message:s}=(0,E.$Mcb)(a,t.value);i._onMessageEmitter.fire(s)}}$onMissingCsp(d,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,a,t){const i=new P(d,this.a,o(a),this.c,this.f,t,this.h);this.b.set(d,i);const s=i._onDidDispose(()=>{s.dispose(),this.deleteWebview(d)});return i}deleteWebview(d){this.b.delete(d)}j(d){return this.b.get(d)}}e.$Cdc=k;function v(c){return{id:c.identifier,location:c.extensionLocation}}e.$Ddc=v;function h(c,d,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||l(c,d)}}e.$Edc=h;function o(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(d=>A.URI.from(d))}}function l(c,d){return[...(d?.getWorkspaceFolders()||[]).map(a=>a.uri),c.extensionLocation]}}),define(De[336],Ce([1,0,21,52,3,18,23,2,13,91,107,6,7]),function($e,e,C,O,f,R,A,m,E,b,L,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class y{constructor(i,s){this.document=i,this.b=s,this.a=1,this.c=new L.$wcc("custom documents")}addEdit(i){return this.c.add([i])}async undo(i,s){await this.f(i).undo(),s||this.disposeBackup()}async redo(i,s){await this.f(i).redo(),s||this.disposeBackup()}disposeEdits(i){for(const s of i)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const i=a(this.document.uri)+this.a++;return(0,A.$wg)(this.b,i)}updateBackup(i){this.d?.delete(),this.d=i}disposeBackup(){this.d?.delete(),this.d=void 0}f(i){const s=this.c.get(i,0);if(!s)throw new Error("No edit found");return s}}class k{constructor(){this.a=new Map}get(i,s){return this.a.get(this.b(i,s))}add(i,s,n){const r=this.b(i,s.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${i} resource:${s.uri}`);const u=new y(s,n);return this.a.set(r,u),u}delete(i,s){const n=this.b(i,s.uri);this.a.delete(n)}b(i,s){return`${i}@@@${s}`}}var v;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(v||(v={}));class h{constructor(){this.a=new Map}addTextProvider(i,s,n){return this.b(0,i,s,n)}addCustomProvider(i,s,n){return this.b(1,i,s,n)}get(i){return this.a.get(i)}b(i,s,n,r){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:i,extension:n,provider:r}),new p.$rK(()=>this.a.delete(s))}}class o{constructor(i,s,n,r,u){this.d=s,this.f=n,this.g=r,this.h=u,this.b=new h,this.c=new k,this.a=i.getProxy(P.$pK.MainThreadCustomEditors)}registerCustomEditorProvider(i,s,n,r){const u=new f.$Rc;return c(n)?(u.add(this.b.addTextProvider(s,i,n)),this.a.$registerTextEditorProvider((0,b.$Ddc)(i),s,r.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,b.$Bdc)(i))):(u.add(this.b.addCustomProvider(s,i,n)),l(n)&&u.add(n.onDidChangeCustomDocument(I=>{const S=this.i(s,I.document.uri);if(d(I)){const $=S.addEdit(I);this.a.$onDidEdit(I.document.uri,s,$,I.label)}else this.a.$onContentChange(I.document.uri,s)})),this.a.$registerCustomEditorProvider((0,b.$Ddc)(i),s,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,b.$Bdc)(i))),p.$rK.from(u,new p.$rK(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(i,s,n,r,u){const I=this.b.get(s);if(!I)throw new Error(`No provider found for '${s}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${s}'`);const S=m.URI.revive(i),$=await I.provider.openCustomDocument(S,{backupId:n,untitledDocumentData:r?.buffer},u);let g;return l(I.provider)&&this.f&&(g=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(s,$,g),{editable:l(I.provider)}}async $disposeCustomDocument(i,s){const n=this.b.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${s}'`);const r=m.URI.revive(i),{document:u}=this.i(s,r);this.c.delete(s,u),u.dispose()}async $resolveCustomEditor(i,s,n,r,u,I){const S=this.b.get(n);if(!S)throw new Error(`No provider found for '${n}'`);const $=E.ViewColumn.to(u),g=this.g.createNewWebview(s,r.contentOptions,S.extension),w=this.h.createNewWebviewPanel(s,n,r.title,$,r.options,g,r.active),D=m.URI.revive(i);switch(S.type){case 1:{const{document:T}=this.i(n,D);return S.provider.resolveCustomEditor(T,w,I)}case 0:{const T=this.d.getDocument(D);return S.provider.resolveCustomTextEditor(T,w,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,s,n){this.i(s,i).disposeEdits(n)}async $onMoveCustomEditor(i,s,n){const r=this.b.get(n);if(!r)throw new Error(`No provider found for '${n}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const u=this.h.getWebviewPanel(i);if(!u)throw new Error("No webview found");const I=m.URI.revive(s),S=this.d.getDocument(I);await r.provider.moveCustomTextEditor(S,u,C.CancellationToken.None)}async $undo(i,s,n,r){return this.i(s,i).undo(n,r)}async $redo(i,s,n,r){return this.i(s,i).redo(n,r)}async $revert(i,s,n){const r=this.i(s,i);await this.j(s).revertCustomDocument(r.document,n),r.disposeBackup()}async $onSave(i,s,n){const r=this.i(s,i);await this.j(s).saveCustomDocument(r.document,n),r.disposeBackup()}async $onSaveAs(i,s,n,r){const u=this.i(s,i);return this.j(s).saveCustomDocumentAs(u.document,m.URI.revive(n),r)}async $backup(i,s,n){const r=this.i(s,i),I=await this.j(s).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},n);return r.updateBackup(I),I.id}i(i,s){const n=this.c.get(i,m.URI.revive(s));if(!n)throw new Error("No custom document found");return n}j(i){const n=this.b.get(i)?.provider;if(!n||!l(n))throw new Error("Custom document is not editable");return n}}e.$dec=o;function l(t){return!!t.onDidChangeCustomDocument}function c(t){return typeof t.resolveCustomTextEditor=="function"}function d(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const i=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,O.$Ei)(i)+""}}),define(De[337],Ce([1,0,4,3,2,31,13,91,6,7]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class L extends O.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(k,v,h,o){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new C.$Od),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$Od),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=v,this.#l=h,this.#i=o.viewType,this.#u=o.panelOptions,this.#r=o.viewColumn,this.#n=o.title,this.#a=o.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(k){this.c(),this.#n!==k&&(this.#n=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#s}set iconPath(k){this.c(),this.#s!==k&&(this.#s=k,this.#t.$setIconPath(this.#e,f.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(k){this.#c||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#a=k.active,this.#o=k.visible,this.#r=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,v){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:A.ViewColumn.from(k),preserveFocus:!!v})}c(){if(this.#c)throw new Error("Webview is disposed")}}class P extends O.$Sc{static c(){return(0,R.$fg)()}constructor(k,v,h){super(),this.j=v,this.m=h,this.g=new Map,this.h=new Map,this.f=k.getProxy(E.$pK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,v,h,o,l={}){const c=typeof o=="object"?o.viewColumn:o,d={viewColumn:A.ViewColumn.from(c),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,m.$Bdc)(k),t=P.c();this.f.$createWebviewPanel((0,m.$Ddc)(k),t,v,{title:h,panelOptions:p(l),webviewOptions:(0,m.$Edc)(k,this.m,l),serializeBuffersForPostMessage:a},d);const i=this.j.createNewWebview(t,l,k);return this.createNewWebviewPanel(t,v,h,c,l,i,!0)}$onDidChangeWebviewPanelViewStates(k){const v=Object.keys(k);v.sort((h,o)=>{const l=k[h],c=k[o];return l.active?1:c.active?-1:+l.visible-+c.visible});for(const h of v){const o=this.getWebviewPanel(h);if(!o)continue;const l=k[h];o._updateViewState({active:l.active,visible:l.visible,viewColumn:A.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,v,h){if(this.h.has(v))throw new Error(`Serializer for '${v}' already registered`);return this.h.set(v,{serializer:h,extension:k}),this.f.$registerSerializer(v,{serializeBuffersForPostMessage:(0,m.$Bdc)(k)}),new b.$rK(()=>{this.h.delete(v),this.f.$unregisterSerializer(v)})}async $deserializeWebviewPanel(k,v,h,o){const l=this.h.get(v);if(!l)throw new Error(`No serializer found for '${v}'`);const{serializer:c,extension:d}=l,a=this.j.createNewWebview(k,h.webviewOptions,d),t=this.createNewWebviewPanel(k,v,h.title,o,h.panelOptions,a,h.active);await c.deserializeWebviewPanel(t,h.state)}createNewWebviewPanel(k,v,h,o,l,c,d){const a=new L(k,this.f,c,{viewType:v,title:h,viewColumn:o,panelOptions:l,active:d});return this.g.set(k,a),a}getWebviewPanel(k){return this.g.get(k)}}e.$cec=P;function p(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(De[338],Ce([1,0,4,3,91,13,6,7]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class E extends O.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(P,p,y,k,v,h){super(),this.#u=!1,this.#a=this.B(new C.$Od),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new C.$Od),this.onDidDispose=this.#c.event,this.#i=y,this.#s=k,this.#e=P,this.#t=p,this.#l=v,this.#n=h}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(P){this.a(),this.#s!==P&&(this.#s=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#r}set description(P){this.a(),this.#r!==P&&(this.#r=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(P){P===this.#n||this.#u||(this.#n=P,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(P){this.a(),!(P?.value===this.#o?.value&&P?.tooltip===this.#o?.tooltip)&&(this.#o=R.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#u)throw new Error("Webview is disposed")}}class b{constructor(P,p){this.d=p,this.b=new Map,this.c=new Map,this.a=P.getProxy(A.$pK.MainThreadWebviewViews)}registerWebviewViewProvider(P,p,y,k){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:y,extension:P}),this.a.$registerWebviewViewProvider((0,f.$Ddc)(P),p,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$Bdc)(P)}),new m.$rK(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(P,p,y,k,v){const h=this.b.get(p);if(!h)throw new Error(`No view provider found for '${p}'`);const{provider:o,extension:l}=h,c=this.d.createNewWebview(P,{},l),d=new E(P,this.a,p,y,c,!0);this.c.set(P,d),await o.resolveWebviewView(d,{state:k},v)}async $onDidChangeWebviewViewVisibility(P,p){this.e(P)._setVisible(p)}async $disposeWebviewView(P){const p=this.e(P);this.c.delete(P),p.dispose(),this.d.deleteWebview(P)}e(P){const p=this.c.get(P);if(!p)throw new Error("No webview found");return p}}e.$bec=b}),define(De[151],Ce([1,0,4,6,2,18,15,5,20,26]),function($e,e,C,O,f,R,A,m,E,b){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=e.$Fdc=void 0;let P=class{static{L=this}static{this.a={focused:!0,active:!0}}getState(y){const k=this.d;return{get focused(){return k.focused},get active(){return(0,b.$lF)(y,"windowActivity"),k.active}}}constructor(y){this.c=new C.$Od,this.onDidChangeWindowState=this.c.event,this.d=L.a,this.b=y.getProxy(O.$pK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:v})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,k){k!==this.d[y]&&(this.d={...this.d,[y]:k},this.c.fire(this.d))}openUri(y,k){let v;if(typeof y=="string"){v=y;try{y=f.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,A.$Ce)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,v,k)}async asExternalUri(y,k){if((0,A.$Ce)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(y,k);return f.URI.from(v)}};e.$Fdc=P,e.$Fdc=P=L=He([Be(0,E.$qM)],P),e.$Gdc=(0,m.$Qh)("IExtHostWindow")}),define(De[339],Ce([1,0,306,27,20]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;const R=1024*1024;let A=class extends C.$Gec{constructor(E,b){super(E,b),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,b,L){const P=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),b.apply(console,L),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,b){const L=process[E],P=L.write;let p="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(y,k,v)=>{if(!this.g){p+=y.toString(k);const h=p.length>R?p.length:p.lastIndexOf(`
`);h!==-1&&(console[b](p.slice(0,h)),p=p.slice(h+1))}P.call(L,y,k,v)}})}};e.$ffc=A,e.$ffc=A=He([Be(0,f.$qM),Be(1,O.$GM)],A)}),define(De[340],Ce([1,0,72,18,14,241,30,12]),function($e,e,C,O,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;let E=class{constructor(P,p){P.addFileSystemProvider(O.Schemas.file,new b(p),{isCaseSensitive:m.$l})}};e.$gfc=E,e.$gfc=E=He([Be(0,C.$5cc),Be(1,f.$$i)],E);class b{constructor(P){this.b=P,this.a=new R.$eq(this.b)}async stat(P){const p=await this.a.stat(P);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,p,y){return this.a.writeFile(P,p,{...y,unlock:!1,atomic:!1})}delete(P,p){return this.a.delete(P,{...p,useTrash:!1,atomic:!1})}rename(P,p,y){return this.a.rename(P,p,y)}copy(P,p,y){return this.a.copy(P,p,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,p){throw new Error("Method not implemented.")}}}),define(De[341],Ce([1,0,16,63,31,34,3,6,2,20]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;let L=class extends A.$Sc{constructor(p,y){super();const k=p.getProxy(m.$pK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async v=>{const h=E.URI.file((0,C.$jc)((0,O.tmpdir)(),(0,f.$fg)()));return await k.$download(v,h),h})}};e.$efc=L,e.$efc=L=He([Be(0,b.$qM),Be(1,R.$MM)],L)}),define(De[342],Ce([1,0,150,18,243,31]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class A extends C.$Fec{s(E,b,L){return E.scheme===O.Schemas.file?new f.$CN(L?.name||(0,R.$fg)(),E.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,b):super.s(E,b,L)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$rfc=A}),define(De[343],Ce([1,0,53,16,2,90,3,18,8,29]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class L extends R.$7cc{constructor(){super(...arguments),this.i=null}async g(t){const i=await super.g(t);if(i.scheme!==m.Schemas.file)return i;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${i.fsPath}.`),i;const s=i.fsPath;let n=0;do{let r;n===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${n}`:`${s}-${n}`,await P(r);const u=O.$jc(r,"vscode.lock"),I=await v(this.d,u,!1);if(I)return this.i=I,process.on("exit",()=>{I.dispose()}),f.URI.file(r);n++}while(n<10);return i}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$qfc=L;async function P(a){try{await b.Promises.stat(a);return}catch{}try{await b.Promises.mkdir(a,{recursive:!0})}catch{}}const p=1e3,y=10*60*1e3;class k extends A.$Sc{constructor(t,i){super(),this.b=t,this.c=i,this.a=this.B(new E.$6g),this.a.cancelAndSet(async()=>{const s=await h(t,i);(!s||s.pid!==process.pid)&&(t.info(`Lock '${i}': The lock was lost unexpectedly.`),this.a.cancel());try{await b.Promises.utimes(i,new Date,new Date)}catch(n){t.error(n),t.info(`Lock '${i}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const i={pid:process.pid,willReleaseAt:Date.now()+t};await b.Promises.writeFile(this.c,JSON.stringify(i),{flag:"w"})}catch(i){this.b.error(i)}}}async function v(a,t,i){try{const n={pid:process.pid,willReleaseAt:0};await b.Promises.writeFile(t,JSON.stringify(n),{flag:"wx"})}catch(n){a.error(n)}const s=await h(a,t);return!s||s.pid!==process.pid?i?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),c(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new k(a,t))}async function h(a,t){let i;try{i=await b.Promises.readFile(t)}catch(s){return a.error(s),null}try{return JSON.parse(String(i))}catch(s){return a.error(s),null}}async function o(a,t){let i;try{i=await b.Promises.stat(t)}catch(s){return a.error(s),0}return i.mtime.getTime()}function l(a){try{return process.kill(a,0),!0}catch{return!1}}async function c(a,t){const i=await h(a,t);if(!i)return a.info(`Lock '${t}': Could not read pid of lock holder.`),d(a,t);if(i.willReleaseAt){let I=i.willReleaseAt-Date.now();if(I<5e3){for(I>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${I} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);I>0;){if(await(0,E.$Vg)(Math.min(100,I)),await o(a,t)===0)return d(a,t);I=i.willReleaseAt-Date.now()}return d(a,t)}}if(!l(i.pid))return a.info(`Lock '${t}': The pid ${i.pid} appears to be gone.`),d(a,t);const s=await o(a,t),n=Date.now()-s;if(n<=y)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Vg)(2e3);const r=await o(a,t),u=Date.now()-r;return u<=y?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),d(a,t))}async function d(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await b.Promises.unlink(t)}catch{}return v(a,t,!0)}}),define(De[344],Ce([1,0,31,20,45,34]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;let A=class extends f.$0cc{constructor(E,b){super(!0,E,b)}createTerminal(E,b,L){return this.createTerminalFromOptions({name:E,shellPath:b,shellArgs:L})}createTerminalFromOptions(E,b){const L=new f.$9cc(this.a,(0,C.$fg)(),E,E.name);return this.f.push(L),L.create(E,this.R(E,b)),L.value}};e.$Lec=A,e.$Lec=A=He([Be(0,R.$MM),Be(1,O.$qM)],A)}),define(De[345],Ce([1,0,8,22,21,9,4,3,128,294,69]),function($e,e,C,O,f,R,A,m,E,b,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$W4b=e.ResponsiveState=e.RequestInitiator=e.$V4b=e.$U4b=void 0;function p(w,D){try{return JSON.stringify(w,D)}catch{return"null"}}const y="$$ref$$",k={[y]:-1};class v{constructor(D,T){this.jsonString=D,this.referencedBuffers=T}}function h(w,D=null,T=!1){const M=[];return{jsonString:(T?p:JSON.stringify)(w,(z,j)=>{if(typeof j>"u")return k;if(typeof j=="object"){if(j instanceof O.$ce){const N=M.push(j)-1;return{[y]:N}}if(D)return D(z,j)}return j}),referencedBuffers:M}}e.$U4b=h;function o(w,D,T){return JSON.parse(w,(M,F)=>{if(F){const z=F[y];if(typeof z=="number")return D[z];if(T&&F.$mid===1)return T.transformIncoming(F)}return F})}e.$V4b=o;function l(w,D){return JSON.stringify(w,D)}function c(w){return w?(D,T)=>T&&T.$mid===1?w.transformOutgoing(T):T:null}var d;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(d||(e.RequestInitiator=d={}));var a;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},i=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class n extends m.$Sc{static{P=i}static{this.a=3*1e3}constructor(D,T=null,M=null){super(),this[P]=!0,this.b=this.B(new A.$Od),this.onDidChangeResponsiveState=this.b.event,this.c=D,this.f=T,this.g=M,this.h=c(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,z=L.$rv.count;F<z;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$7g(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(D=>{const T=this.w[D];delete this.w[D],T.resolveErr(R.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(D){this.z===0&&(this.C=Date.now()+n.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(D){this.C=Date.now()+n.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(D){this.y!==D&&(this.y=D,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(D){return this.g?(0,E.$Pm)(D,this.g):D}getProxy(D){const{nid:T,sid:M}=D;return this.s[T]||(this.s[T]=this.J(T,M)),this.s[T]}J(D,T){const M={get:(F,z)=>(typeof z=="string"&&!F[z]&&z.charCodeAt(0)===36&&(F[z]=(...j)=>this.U(D,z,j)),z===s?T:F[z])};return new Proxy(Object.create(null),M)}set(D,T){return this.m[D.nid]=T,T}assertRegistered(D){for(let T=0,M=D.length;T<M;T++){const F=D[T];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(D){if(this.j)return;const T=D.byteLength,M=u.read(D,0),F=M.readUInt8(),z=M.readUInt32();switch(F){case 1:case 2:{let{rpcId:j,method:N,args:q}=S.deserializeRequestJSONArgs(M);this.g&&(q=(0,E.$Pm)(q,this.g)),this.M(T,z,j,N,q,F===2);break}case 3:case 4:{let{rpcId:j,method:N,args:q}=S.deserializeRequestMixedArgs(M);this.g&&(q=(0,E.$Pm)(q,this.g)),this.M(T,z,j,N,q,F===4);break}case 5:{this.f?.logIncoming(T,z,0,"ack"),this.G(z);break}case 6:{this.N(T,z);break}case 7:{this.O(T,z,void 0);break}case 9:{let j=S.deserializeReplyOKJSON(M);this.g&&(j=(0,E.$Pm)(j,this.g)),this.O(T,z,j);break}case 10:{const j=S.deserializeReplyOKJSONWithBuffers(M,this.g);this.O(T,z,j);break}case 8:{const j=S.deserializeReplyOKVSBuffer(M);this.O(T,z,j);break}case 11:{let j=S.deserializeReplyErrError(M);this.g&&(j=(0,E.$Pm)(j,this.g)),this.P(T,z,j);break}case 12:{this.P(T,z,void 0);break}default:console.error("received unexpected message"),console.error(D)}}M(D,T,M,F,z,j){this.f?.logIncoming(D,T,1,`receiveRequest ${(0,L.$tv)(M)}.${F}(`,z);const N=String(T);let q,K;if(j){const te=new f.$Yd;z.push(te.token),q=this.Q(M,F,z),K=()=>te.cancel()}else q=this.Q(M,F,z),K=t;this.u[N]=K;const me=S.serializeAcknowledged(T);this.f?.logOutgoing(me.byteLength,T,1,"ack"),this.c.send(me),q.then(te=>{delete this.u[N];const G=S.serializeReplyOK(T,te,this.h);this.f?.logOutgoing(G.byteLength,T,1,"reply:",te),this.c.send(G)},te=>{delete this.u[N];const G=S.serializeReplyErr(T,te);this.f?.logOutgoing(G.byteLength,T,1,"replyErr:",te),this.c.send(G)})}N(D,T){this.f?.logIncoming(D,T,1,"receiveCancel");const M=String(T);this.u[M]?.()}O(D,T,M){this.f?.logIncoming(D,T,0,"receiveReply:",M);const F=String(T);if(!this.w.hasOwnProperty(F))return;const z=this.w[F];delete this.w[F],z.resolveOk(M)}P(D,T,M){this.f?.logIncoming(D,T,0,"receiveReplyErr:",M);const F=String(T);if(!this.w.hasOwnProperty(F))return;const z=this.w[F];delete this.w[F];let j;M&&(M.$isError?(j=new Error,j.name=M.name,j.message=M.message,j.stack=M.stack):j=M),z.resolveErr(j)}Q(D,T,M){try{return Promise.resolve(this.S(D,T,M))}catch(F){return Promise.reject(F)}}S(D,T,M){const F=this.m[D];if(!F)throw new Error("Unknown actor "+(0,L.$tv)(D));const z=F[T];if(typeof z!="function")throw new Error("Unknown method "+T+" on actor "+(0,L.$tv)(D));return z.apply(F,M)}U(D,T,M){if(this.j)return new b.$T4b;let F=null;if(M.length>0&&f.CancellationToken.isCancellationToken(M[M.length-1])&&(F=M.pop()),F&&F.isCancellationRequested)return Promise.reject(R.$6());const z=S.serializeRequestArguments(M,this.h),j=++this.t,N=String(j),q=new b.$S4b,K=new m.$Rc;F&&K.add(F.onCancellationRequested(()=>{const te=S.serializeCancel(j);this.f?.logOutgoing(te.byteLength,j,0,"cancel"),this.c.send(S.serializeCancel(j))})),this.w[N]=new r(q,K),this.F(j);const me=S.serializeRequest(j,D,T,z,!!F);return this.f?.logOutgoing(me.byteLength,j,0,`request: ${(0,L.$tv)(D)}.${T}(`,M),this.c.send(me),q}}e.$W4b=n;class r{constructor(D,T){this.a=D,this.b=T}resolveOk(D){this.a.resolveOk(D),this.b.dispose()}resolveErr(D){this.a.resolveErr(D),this.b.dispose()}}class u{static alloc(D,T,M){const F=new u(O.$ce.alloc(M+1+4),0);return F.writeUInt8(D),F.writeUInt32(T),F}static read(D,T){return new u(D,T)}get buffer(){return this.a}constructor(D,T){this.a=D,this.b=T}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(D){this.a.writeUInt8(D,this.b),this.b+=1}readUInt8(){const D=this.a.readUInt8(this.b);return this.b+=1,D}writeUInt32(D){this.a.writeUInt32BE(D,this.b),this.b+=4}readUInt32(){const D=this.a.readUInt32BE(this.b);return this.b+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this.a.writeUInt8(D.byteLength,this.b),this.b+=1,this.a.set(D,this.b),this.b+=D.byteLength}readShortString(){const D=this.a.readUInt8(this.b);this.b+=1;const M=this.a.slice(this.b,this.b+D).toString();return this.b+=D,M}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readLongString(){const D=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+D).toString();return this.b+=D,M}writeBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readVSBuffer(){const D=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+D);return this.b+=D,T}static sizeMixedArray(D){let T=0;T+=1;for(let M=0,F=D.length;M<F;M++){const z=D[M];switch(T+=1,z.type){case 1:T+=this.sizeLongString(z.value);break;case 2:T+=this.sizeVSBuffer(z.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(z.value);for(let j=0;j<z.buffers.length;++j)T+=this.sizeVSBuffer(z.buffers[j]);break;case 4:break}}return T}writeMixedArray(D){this.a.writeUInt8(D.length,this.b),this.b+=1;for(let T=0,M=D.length;T<M;T++){const F=D[T];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let z=0;z<F.buffers.length;++z)this.writeBuffer(F.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this.a.readUInt8(this.b);this.b+=1;const T=new Array(D);for(let M=0;M<D;M++)switch(this.readUInt8()){case 1:T[M]=this.readLongString();break;case 2:T[M]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),j=this.readLongString(),N=[];for(let q=0;q<z;++q)N.push(this.readVSBuffer());T[M]=new L.$uv(o(j,N,null));break}case 4:T[M]=void 0;break}return T}}var I;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(I||(I={}));class S{static a(D){for(let T=0,M=D.length;T<M;T++)if(D[T]instanceof O.$ce||D[T]instanceof L.$uv||typeof D[T]>"u")return!0;return!1}static serializeRequestArguments(D,T){if(this.a(D)){const M=[];for(let F=0,z=D.length;F<z;F++){const j=D[F];if(j instanceof O.$ce)M[F]={type:2,value:j};else if(typeof j>"u")M[F]={type:4};else if(j instanceof L.$uv){const{jsonString:N,referencedBuffers:q}=h(j.value,T);M[F]={type:3,value:O.$ce.fromString(N),buffers:q}}else M[F]={type:1,value:O.$ce.fromString(l(j,T))}}return{type:1,args:M}}return{type:0,args:l(D,T)}}static serializeRequest(D,T,M,F,z){switch(F.type){case 0:return this.b(D,T,M,F.args,z);case 1:return this.c(D,T,M,F.args,z)}}static b(D,T,M,F,z){const j=O.$ce.fromString(M),N=O.$ce.fromString(F);let q=0;q+=u.sizeUInt8(),q+=u.sizeShortString(j),q+=u.sizeLongString(N);const K=u.alloc(z?2:1,D,q);return K.writeUInt8(T),K.writeShortString(j),K.writeLongString(N),K.buffer}static deserializeRequestJSONArgs(D){const T=D.readUInt8(),M=D.readShortString(),F=D.readLongString();return{rpcId:T,method:M,args:JSON.parse(F)}}static c(D,T,M,F,z){const j=O.$ce.fromString(M);let N=0;N+=u.sizeUInt8(),N+=u.sizeShortString(j),N+=u.sizeMixedArray(F);const q=u.alloc(z?4:3,D,N);return q.writeUInt8(T),q.writeShortString(j),q.writeMixedArray(F),q.buffer}static deserializeRequestMixedArgs(D){const T=D.readUInt8(),M=D.readShortString(),F=D.readMixedArray(),z=new Array(F.length);for(let j=0,N=F.length;j<N;j++){const q=F[j];typeof q=="string"?z[j]=JSON.parse(q):z[j]=q}return{rpcId:T,method:M,args:z}}static serializeAcknowledged(D){return u.alloc(5,D,0).buffer}static serializeCancel(D){return u.alloc(6,D,0).buffer}static serializeReplyOK(D,T,M){if(typeof T>"u")return this.d(D);if(T instanceof O.$ce)return this.e(D,T);if(T instanceof L.$uv){const{jsonString:F,referencedBuffers:z}=h(T.value,M,!0);return this.g(D,F,z)}else return this.f(D,p(T,M))}static d(D){return u.alloc(7,D,0).buffer}static e(D,T){let M=0;M+=u.sizeVSBuffer(T);const F=u.alloc(8,D,M);return F.writeVSBuffer(T),F.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static f(D,T){const M=O.$ce.fromString(T);let F=0;F+=u.sizeLongString(M);const z=u.alloc(9,D,F);return z.writeLongString(M),z.buffer}static g(D,T,M){const F=O.$ce.fromString(T);let z=0;z+=u.sizeUInt32,z+=u.sizeLongString(F);for(const N of M)z+=u.sizeVSBuffer(N);const j=u.alloc(10,D,z);j.writeUInt32(M.length),j.writeLongString(F);for(const N of M)j.writeBuffer(N);return j.buffer}static deserializeReplyOKJSON(D){const T=D.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(D,T){const M=D.readUInt32(),F=D.readLongString(),z=[];for(let j=0;j<M;++j)z.push(D.readVSBuffer());return new L.$uv(o(F,z,T))}static serializeReplyErr(D,T){const M=T?p(R.$3(T),null):void 0;if(typeof M!="string")return this.h(D);const F=O.$ce.fromString(M);let z=0;z+=u.sizeLongString(F);const j=u.alloc(11,D,z);return j.writeLongString(F),j.buffer}static deserializeReplyErrError(D){const T=D.readLongString();return JSON.parse(T)}static h(D){return u.alloc(12,D,0).buffer}}var $;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var g;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(g||(g={}))}),define(De[346],Ce([1,0,4,43,42,5]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=e.OutputChannelUpdateMode=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=void 0,e.$AJ="text/x-code-output",e.$BJ="output",e.$CJ="Log",e.$DJ="text/x-code-log-output",e.$EJ="log",e.$FJ="workbench.panel.output",e.$GJ=new f.$8i("inOutput",!1),e.$HJ=new f.$8i("activeLogOutput",!1),e.$IJ=new f.$8i("outputView.scrollLock",!1),e.$JJ=(0,R.$Qh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$KJ={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new C.$Od,this.onDidRegisterChannel=this.b.event,this.c=new C.$Od,this.onDidRemoveChannel=this.c.event}registerChannel(b){this.a.has(b.id)||(this.a.set(b.id,b),this.b.fire(b.id))}getChannels(){const b=[];return this.a.forEach(L=>b.push(L)),b}getChannel(b){return this.a.get(b)}removeChannel(b){this.a.delete(b),this.c.fire(b)}}O.$kn.add(e.$KJ.OutputChannels,new m),e.$LJ=new f.$8i("activeOutputChannel","")}),define(De[152],Ce([1,0,6,5,20,25,14,346,72,27,55,178,22,17,30,4,3]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=void 0;class o extends A.$ej{get disposed(){return this.n}constructor(a,t,i,s,n){super(),this.id=a,this.name=t,this.r=i,this.s=s,this.extension=n,this.m=0,this.n=!1,this.visible=!1,this.setLevel(i.getLevel()),this.B(i.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=p.$ce.fromString(t).byteLength,(0,A.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class l extends o{appendLine(a){this.append(a)}}let c=class{constructor(a,t,i,s,n,r){this.i=t,this.j=i,this.k=s,this.l=n,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(C.$pK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$fm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,i]of this.g)i.visible=t===this.h}createOutputChannel(a,t,i){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,n=(0,y.$zf)(t)?t:void 0;if((0,y.$zf)(n)&&!n.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const u=this.i.environment.extensionLogLevel?.find(([S])=>R.$7l.equals(i.identifier,S))?.[1];u&&(r=(0,A.$oj)(u));const I=s?this.o(a,r,i):this.n(a,n,i);return I.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),s?this.r(a,r??this.m.getLevel(),I):this.q(a,I)}async n(a,t,i){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,n=this.k.extUri.joinPath(s,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(n,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),u=await this.a.$register(a,n,t,i.identifier.value);return new o(u,a,r,this.a,i)}async o(a,t,i){const s=await this.p(i),n=a.replace(/[\\/:\*\?"<>\|]/g,""),r=this.k.extUri.joinPath(s,`${n}.log`),u=`${i.identifier.value}.${n}`,I=this.l.createLogger(r,{id:u,name:a,logLevel:t,extensionId:i.identifier.value});return new l(u,a,I,this.a,i)}p(a){let t=this.d.get(a.identifier.value);if(!t){const i=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(i)}catch(s){if((0,k.$pk)(s)!==k.FileSystemProviderErrorCode.FileExists)throw s}return i})())}return t}q(a,t){let i=!1;const s=()=>{if(i)throw new Error("Channel has been closed")};return{get name(){return a},append(n){s(),t.then(r=>r.append(n))},appendLine(n){s(),t.then(r=>r.appendLine(n))},clear(){s(),t.then(n=>n.clear())},replace(n){s(),t.then(r=>r.replace(n))},show(n,r){s(),t.then(u=>u.show(n,r))},hide(){s(),t.then(n=>n.hide())},dispose(){i=!0,t.then(n=>n.dispose())}}}r(a,t,i){const s=new h.$Rc,n=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},r=s.add(new v.$Od);function u(I){t=I,r.fire(I)}return i.then(I=>{s.add(I),I.logLevel!==t&&u(I.logLevel),s.add(I.onDidChangeLogLevel(S=>u(S)))}),{...this.q(a,i),get logLevel(){return t},onDidChangeLogLevel:r.event,trace(I,...S){n(),i.then($=>$.trace(I,...S))},debug(I,...S){n(),i.then($=>$.debug(I,...S))},info(I,...S){n(),i.then($=>$.info(I,...S))},warn(I,...S){n(),i.then($=>$.warn(I,...S))},error(I,...S){n(),i.then($=>$.error(I,...S))},dispose(){s.dispose()}}}};e.$pdc=c,e.$pdc=c=He([Be(0,f.$qM),Be(1,b.$GM),Be(2,E.$5cc),Be(3,L.$zcc),Be(4,A.$_i),Be(5,A.$$i)],c),e.$qdc=(0,O.$Qh)("IExtHostOutputService")}),define(De[347],Ce([1,0,5,8]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0,e.$um=(0,C.$Qh)("remoteAgentService"),e.$vm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let R=1/0;for(let m=0;m<this.maxSampleCount;m++){const E=await f.getRoundTripTime();if(E===void 0)return;R=Math.min(R,E/2),await(0,O.$Vg)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(R):A=this.initial.reduce((m,E)=>m+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:R,average:this.average.reduce((m,E)=>m+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[348],Ce([1,0,33,18,16,12,23,2,5,259,44,144,347]),function($e,e,C,O,f,R,A,m,E,b,L,P,p){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.$4J=void 0,e.$4J=(0,E.$Qh)("pathService");let k=y=class{constructor(h,o,l,c){this.d=h,this.e=o,this.f=l,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const d=await this.e.getEnvironment();return this.c=d?.userHome??h})()}hasValidBasename(h,o,l){return typeof o=="string"||typeof o>"u"?this.a.then(c=>this.h(h,c,o)):this.h(h,o,l)}h(h,o,l){return h.scheme===O.Schemas.file||h.scheme===O.Schemas.vscodeRemote?(0,C.$Wf)(l??(0,A.$tg)(h),o===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(h,o){if(h.remoteAuthority)return O.Schemas.vscodeRemote;const l=(0,b.$1J)(o.getWorkspace());if(l)return l;const c=o.getWorkspace().folders[0];if(c)return c.uri.scheme;const d=o.getWorkspace().configuration;return d?d.scheme:O.Schemas.file}userHome(h){return h?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(h=>h===1?f.$fc:f.$gc)}async fileURI(h){let o="";if(await this.a===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const c=h.indexOf("/",2);c===-1?(o=h.substring(2),h="/"):(o=h.substring(2,c),h=h.substring(c)||"/")}return m.URI.from({scheme:O.Schemas.file,authority:o,path:h,query:"",fragment:""})}};e.$5J=k,e.$5J=k=y=He([Be(1,p.$um),Be(2,P.$MJ),Be(3,L.$Zh)],k)}),define(De[349],Ce([1,0,226,19,57,4,52,3,2,50,231,14,65,261,86,44,144,26,21,17,24,42]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$WJ=e.$VJ=e.OnPortForward=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.TunnelSource=e.TunnelCloseReason=e.$PJ=e.$OJ=e.$NJ=void 0;const t=10*1e3,i="remote.tunnels.toRestore";e.$NJ="onTunnel",e.$OJ=new a.$8i("forwardedPortsViewEnabled",!1,C.localize(0,null));function s(T){const M=T.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(M)return{host:M[1]?.substring(0,M[1].length-1)||"localhost",port:Number(M[2])}}e.$PJ=s;var n;(function(T){T.Other="Other",T.User="User",T.AutoForwardEnd="AutoForwardEnd"})(n||(e.TunnelCloseReason=n={}));var r;(function(T){T[T.User=0]="User",T[T.Auto=1]="Auto",T[T.Extension=2]="Extension"})(r||(e.TunnelSource=r={})),e.$QJ={source:r.User,description:C.localize(1,null)},e.$RJ={source:r.Auto,description:C.localize(2,null)};function u(T,M,F){const z=T.get(S(M,F));if(z)return z;if((0,k.$gv)(M))for(const j of k.$fv){const N=S(j,F);if(T.has(N))return T.get(N)}else if((0,k.$iv)(M))for(const j of k.$hv){const N=S(j,F);if(T.has(N))return T.get(N)}}e.$SJ=u;function I(T,M,F){const z=u(T,M,F);if(z)return z;const j=(0,k.$iv)(M)?"localhost":(0,k.$gv)(M)?"0.0.0.0":void 0;if(j)return u(T,j,F)}e.$TJ=I;function S(T,M){return T+":"+M}e.$UJ=S;var $;(function(T){T.Notify="notify",T.OpenBrowser="openBrowser",T.OpenBrowserOnce="openBrowserOnce",T.OpenPreview="openPreview",T.Silent="silent",T.Ignore="ignore"})($||(e.OnPortForward=$={}));function g(T){return T&&"host"in T&&typeof T.host=="string"&&"port"in T&&typeof T.port=="number"&&(!("detail"in T)||typeof T.detail=="string")&&(!("pid"in T)||typeof T.pid=="string")}e.$VJ=g;class w extends m.$Sc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(M){super(),this.r=M,this.j=[],this.n=new R.$Od,this.onDidChangeAttributes=this.n.event,this.B(M.onDidChangeConfiguration(F=>{(F.affectsConfiguration(w.c)||F.affectsConfiguration(w.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(M,F,z){let j=this.w(M,F,z,this.j,0);const N={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const q=this.j[j];q.key===M?(N.onAutoForward=q.onAutoForward??N.onAutoForward,N.elevateIfNeeded=q.elevateIfNeeded!==void 0?q.elevateIfNeeded:N.elevateIfNeeded,N.label=q.label??N.label,N.requireLocalPort=q.requireLocalPort,N.protocol=q.protocol):(N.onAutoForward=N.onAutoForward??q.onAutoForward,N.elevateIfNeeded=N.elevateIfNeeded!==void 0?N.elevateIfNeeded:q.elevateIfNeeded,N.label=N.label??q.label,N.requireLocalPort=N.requireLocalPort!==void 0?N.requireLocalPort:void 0,N.protocol=N.protocol??q.protocol),j=this.w(M,F,z,this.j,j+1)}return N.onAutoForward!==void 0||N.elevateIfNeeded!==void 0||N.label!==void 0||N.requireLocalPort!==void 0||N.protocol!==void 0?N:this.C()}t(M){return M.start!==void 0&&M.end!==void 0}u(M){return M.host!==void 0&&M.port!==void 0&&(0,c.$zf)(M.host)&&(0,c.$Df)(M.port)}w(M,F,z,j,N){if(N>=j.length)return-1;const q=!(0,k.$gv)(F)&&!(0,k.$iv)(F),me=j.slice(N).findIndex(te=>(0,c.$Df)(te.key)?q?!1:te.key===M:this.t(te.key)?q?!1:M>=te.key.start&&M<=te.key.end:this.u(te.key)?M===te.key.port&&F===te.key.host:z?te.key.test(z):!1);return me>=0?me+N:-1}y(){const M=this.r.getValue(w.c);if(!M||!(0,c.$Bf)(M))return[];const F=[];for(const j in M){if(j===void 0)continue;const N=M[j];let q;if(Number(j))q=Number(j);else if((0,c.$zf)(j))if(w.g.test(j)){const K=j.match(w.g);q={start:Number(K[1]),end:Number(K[2])}}else if(w.h.test(j)){const K=j.match(w.h);q={host:K[1],port:Number(K[2])}}else{let K;try{K=RegExp(j)}catch{}K&&(q=K)}q&&F.push({key:q,elevateIfNeeded:N.elevateIfNeeded,onAutoForward:N.onAutoForward,label:N.label,requireLocalPort:N.requireLocalPort,protocol:N.protocol})}const z=this.r.getValue(w.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(F)}z(M){function F(z,j){return(0,c.$Df)(z.key)?z.key:j.t(z.key)?z.key.start:j.u(z.key)?z.key.port:Number.MAX_VALUE}return M.sort((z,j)=>F(z,this)-F(j,this))}C(){return this.m}static providedActionToAction(M){switch(M){case k.ProvidedOnAutoForward.Notify:return $.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return $.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return $.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return $.OpenPreview;case k.ProvidedOnAutoForward.Silent:return $.Silent;case k.ProvidedOnAutoForward.Ignore:return $.Ignore;default:return}}async addAttributes(M,F,z){const N=this.r.inspect(w.c).userRemoteValue;let q;!N||!(0,c.$Bf)(N)?q={}:q=(0,d.$8m)(N),q[`${M}`]||(q[`${M}`]={});for(const K in F)q[`${M}`][K]=F[K];return this.r.updateValue(w.c,q,z)}}e.$WJ=w;let D=class extends m.$Sc{constructor(M,F,z,j,N,q,K,me,te,G){super(),this.H=M,this.I=F,this.J=z,this.L=j,this.M=N,this.N=q,this.O=K,this.P=me,this.Q=te,this.R=G,this.c=new Map,this.g=new R.$Od,this.onForwardPort=this.g.event,this.h=new R.$Od,this.onClosePort=this.h.event,this.j=new R.$Od,this.onPortName=this.j.event,this.n=new R.$Od,this.onCandidatesChanged=this.n.event,this.t=new R.$Od,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$Od,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new w(z),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async J=>{const le=await this.getAttributes(J.map(ie=>({port:ie.tunnelRemotePort,host:ie.tunnelRemoteHost})));for(const ie of J)if(ie.localAddress){const ce=S(ie.tunnelRemoteHost,ie.tunnelRemotePort),ye=I(this.m??new Map,ie.tunnelRemoteHost,ie.tunnelRemotePort);this.forwarded.set(ce,{remotePort:ie.tunnelRemotePort,remoteHost:ie.tunnelRemoteHost,localAddress:ie.localAddress,protocol:le?.get(ie.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ie.localAddress,le?.get(ie.tunnelRemotePort)),localPort:ie.tunnelLocalPort,runningProcess:ye?.detail,hasRunningProcess:!!ye,pid:ye?.pid,privacy:ie.privacy,source:e.$QJ}),this.f.set(ce,ie)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async J=>{const le=S(J.tunnelRemoteHost,J.tunnelRemotePort);if(!I(this.forwarded,J.tunnelRemoteHost,J.tunnelRemotePort)&&!I(this.detected,J.tunnelRemoteHost,J.tunnelRemotePort)&&!I(this.c,J.tunnelRemoteHost,J.tunnelRemotePort)&&J.localAddress){const ie=I(this.m??new Map,J.tunnelRemoteHost,J.tunnelRemotePort),ce=(await this.getAttributes([{port:J.tunnelRemotePort,host:J.tunnelRemoteHost}]))?.get(J.tunnelRemotePort);this.forwarded.set(le,{remoteHost:J.tunnelRemoteHost,remotePort:J.tunnelRemotePort,localAddress:J.localAddress,protocol:ce?.protocol??k.TunnelProtocol.Http,localUri:await this.X(J.localAddress,ce),localPort:J.tunnelLocalPort,closeable:!0,runningProcess:ie?.detail,hasRunningProcess:!!ie,pid:ie?.pid,privacy:J.privacy,source:e.$QJ})}await this.$(),this.f.set(le,J),this.g.fire(this.forwarded.get(le))})),this.B(this.H.onTunnelClosed(J=>this.W(J,n.Other))),this.U()}S(){return this.Q.extensions.find(M=>M.activationEvents?.includes(e.$NJ))?(this.R.createKey(e.$OJ.key,!0),!0):!1}U(){if(this.S())return;const M=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&M.dispose()}))}async W(M,F){const z=S(M.host,M.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.$(),this.h.fire(M))}X(M,F){if(M.startsWith("http"))return E.URI.parse(M);const z=F?.protocol??"http";return E.URI.parse(`${z}://${M}`)}async Y(){const M=this.N.getWorkspace(),F=M.configuration?(0,A.$Ei)(M.configuration.path):M.folders.length>0?(0,A.$Ei)(M.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${i}.${this.L.remoteAuthority}.${F}`}async Z(){const M=this.I.get(i,1);if(M)return this.I.remove(i,1),await this.$(),M;const F=await this.Y();if(F)return this.I.get(F,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const M=await this.s;if(M&&M!==this.y){const F=JSON.parse(M)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(z=>z.remotePort).join(", ")}`);for(const z of F){const j=I(this.detected,z.remoteHost,z.remotePort);z.source.source!==r.Extension&&!j||z.source.source===r.Extension&&j?await this.cb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,privacy:z.privacy,elevateIfNeeded:!0,source:z.source}):z.source.source===r.Extension&&!j&&this.D.set(S(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const M=await this.Y();this.w=this.B(new m.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async F=>{F.key===M&&(this.s=Promise.resolve(this.I.get(M,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const M=JSON.stringify(Array.from(this.forwarded.values()));if(M!==this.y){this.y=M;const F=await this.Y();F&&this.I.store(F,this.y,0,0)}}}async bb(M,F,z){if(!M.tunnelLocalPort||!z?.requireLocalPort||M.tunnelLocalPort===F)return;const j=new Date;if(this.ab.getTime()+t>j.getTime())return;this.ab=j;const N=C.localize(3,null,F,M.tunnelRemotePort,M.tunnelLocalPort);return this.P.info(N)}async forward(M,F){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.cb(M,F)}async cb(M,F){await this.Q.activateByEvent(e.$NJ);const z=I(this.forwarded,M.remote.host,M.remote.port);F=F??(F!==null?(await this.getAttributes([M.remote]))?.get(M.remote.port):void 0);const j=M.local!==void 0?M.local:M.remote.port;let N;if(z)return this.eb(z,M,F);{const q=this.L.remoteAuthority,K=q?{getAddress:async()=>(await this.M.resolveAuthority(q)).authority}:void 0,me=S(M.remote.host,M.remote.port);this.c.set(me,!0),M=this.db(me,M);const te=await this.H.openTunnel(K,M.remote.host,M.remote.port,void 0,j,M.elevateIfNeeded?M.elevateIfNeeded:F?.elevateIfNeeded,M.privacy,F?.protocol);if(typeof te=="string")N=te;else if(te&&te.localAddress){const G=I(this.m??new Map,M.remote.host,M.remote.port),J=te.protocol?te.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:F?.protocol??k.TunnelProtocol.Http,le={remoteHost:te.tunnelRemoteHost,remotePort:te.tunnelRemotePort,localPort:te.tunnelLocalPort,name:F?.label??M.name,closeable:!0,localAddress:te.localAddress,protocol:J,localUri:await this.X(te.localAddress,F),runningProcess:G?.detail,hasRunningProcess:!!G,pid:G?.pid,source:M.source??e.$QJ,privacy:te.privacy};return this.forwarded.set(me,le),this.f.set(me,te),this.c.delete(me),await this.$(),await this.bb(te,j,F),this.g.fire(le),te}this.c.delete(me)}return N}db(M,F){const z=this.D.has(M)?this.D:this.F.has(M)?this.F:void 0;if(z){const j=z.get(M);z.delete(M),j&&(F.name=j.name??F.name,F.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??F.local,F.privacy=j.privacy??F.privacy)}return F}async eb(M,F,z){const j=z?.label??F.name;let N;(function(K){K[K.None=0]="None",K[K.Fire=1]="Fire",K[K.Reopen=2]="Reopen"})(N||(N={}));let q=N.None;switch(j!==M.name&&(M.name=j,q=N.Fire),(z?.protocol||M.protocol!==k.TunnelProtocol.Http)&&z?.protocol!==M.protocol&&(F.source=M.source,q=N.Reopen),F.privacy&&M.privacy!==F.privacy&&(q=N.Reopen),q){case N.Fire:{this.g.fire();break}case N.Reopen:await this.close(M.remoteHost,M.remotePort,n.User),await this.cb(F,z)}return I(this.f,F.remote.host,F.remote.port)}async name(M,F,z){const j=I(this.forwarded,M,F),N=S(M,F);if(j){j.name=z,await this.$(),this.j.fire({host:M,port:F});return}else this.detected.has(N)&&(this.detected.get(N).name=z,this.j.fire({host:M,port:F}))}async close(M,F,z){const j=S(M,F),N=this.forwarded.get(j);return z===n.AutoForwardEnd&&N&&N.source.source===r.Auto&&this.F.set(j,{local:N.localPort,name:N.name,privacy:N.privacy}),await this.H.closeTunnel(M,F),this.W({host:M,port:F},z)}address(M,F){const z=S(M,F);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(M){if(M)for(const F of M){const z=I(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),j=typeof F.localAddress=="string"?F.localAddress:S(F.localAddress.host,F.localAddress.port);this.detected.set(S(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:j,protocol:k.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:r.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,j,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(M){this.r=M}async setCandidates(M){let F=M;this.r&&(F=await this.r(M));const z=this.fb(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(j=>j.port).join(", ")}`),this.n.fire(z)}fb(M){const F=this.m??new Map,z=new Map;return this.m=z,M.forEach(j=>{const N=S(j.host,j.port);z.set(N,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),F.has(N)&&F.delete(N);const q=I(this.forwarded,j.host,j.port);q&&(q.runningProcess=j.detail,q.hasRunningProcess=!0,q.pid=j.pid)}),F.forEach((j,N)=>{const q=s(N);if(!q)return;const K=I(this.forwarded,q.host,q.port);K&&(K.runningProcess=void 0,K.hasRunningProcess=!1,K.pid=void 0);const me=I(this.detected,q.host,q.port);me&&(me.runningProcess=void 0,me.hasRunningProcess=!1,me.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const M=Array.from(this.forwarded.values()),F=await this.getAttributes(M.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(F)for(const z of M){const j=F.get(z.remotePort);(j?.protocol||z.protocol!==k.TunnelProtocol.Http)&&j?.protocol!==z.protocol&&await this.cb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},j),j&&j.label&&j.label!==z.name&&await this.name(z.remoteHost,z.remotePort,j.label)}}async getAttributes(M,F=!0){const z=new Map,j=new Map;M.forEach(te=>{const G=I(this.m??new Map,k.$fv[0],te.port)??te;if(G){z.set(te.port,G);const J=g(G)?G.pid:void 0;j.has(J)||j.set(J,[]),j.get(J)?.push(te.port)}});const N=new Map;if(M.forEach(te=>{const G=this.configPortsAttributes.getAttributes(te.port,te.host,z.get(te.port)?.detail);G&&N.set(te.port,G)}),this.G.length===0||!F)return N.size>0?N:void 0;const q=await Promise.all((0,O.$Rb)(this.G.map(te=>Array.from(j.entries()).map(G=>{const J=G[1],le=z.get(J[0]);return te.providePortAttributes(J,le?.pid,le?.detail,new l.$Yd().token)})))),K=new Map;if(q.forEach(te=>te.forEach(G=>{G&&K.set(G.port,G)})),!N&&!K)return;const me=new Map;return M.forEach(te=>{const G=N.get(te.port),J=K.get(te.port);me.set(te.port,{elevateIfNeeded:G?.elevateIfNeeded,label:G?.label,onAutoForward:G?.onAutoForward??w.providedActionToAction(J?.autoForwardAction),requireLocalPort:G?.requireLocalPort,protocol:G?.protocol})}),me}addAttributesProvider(M){this.G.push(M)}};e.$XJ=D,He([(0,f.$jh)(1e3)],D.prototype,"$",null),e.$XJ=D=He([Be(0,k.$bv),Be(1,y.$0o),Be(2,b.$ki),Be(3,h.$MJ),Be(4,p.$Qk),Be(5,v.$Zh),Be(6,P.$$i),Be(7,L.$Fv),Be(8,o.$hF),Be(9,a.$9i)],D)}),define(De[92],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$KI=e.$JI=void 0;class C{constructor(A,m){this.line=A,this.character=m}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,m){return new C(0,0)}with(A){return new C(0,0)}}e.$JI=C;class O{constructor(A,m,E,b){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(A,m),this.end=new C(E,b)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new O(0,0,0,0)}with(A){return new O(0,0,0,0)}}e.$KI=O;var f;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(De[37],Ce([1,0,19,36,24,33,15,5,16,9,92,8]),function($e,e,C,O,f,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.SearchErrorCode=e.$ZI=e.$YI=e.SearchSortOrder=e.ViewMode=e.$XI=e.$WI=e.$VI=e.$UI=e.SearchCompletionExitCode=e.$TI=e.$SI=e.$RI=e.QueryType=e.SearchProviderType=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$LI="workbench.view.search",e.$MI="workbench.panel.search",e.$NI="workbench.view.search",e.$OI="search-result",e.$PI="search.exclude";const p="\u27EA ",y=" characters skipped \u27EB",k=(p.length+y.length+5)*2;e.$QI=(0,m.$Qh)("searchService");var v;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(v||(e.SearchProviderType=v={}));var h;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(h||(e.QueryType=h={}));function o(J){return!!J.preview}e.$RI=o;function l(J){return!!J.resource}e.$SI=l;function c(J){return!!J.message}e.$TI=c;var d;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(d||(e.SearchCompletionExitCode=d={}));class a{constructor(le){this.resource=le,this.results=[]}}e.$UI=a;class t{constructor(le,ie,ce,ye){this.ranges=ie,this.webviewIndex=ye;const H=Array.isArray(ie)?ie:[ie];if(ce&&ce.matchLines===1&&i(H)){le=(0,A.$sf)(le,ce.matchLines);let B="",Y=0,re=0;const X=Math.floor(ce.charsPerLine/5),_=[];for(const x of H){const pe=Math.max(x.startColumn-X,0),ae=x.startColumn+ce.charsPerLine;if(pe>re+X+k){const fe=p+(pe-re)+y;B+=fe+le.slice(pe,ae),Y+=pe-(re+fe.length)}else B+=le.slice(re,ae);_.push(new n(0,x.startColumn-Y,x.endColumn-Y)),re=ae}this.preview={text:B,matches:Array.isArray(this.ranges)?_:_[0]}}else{const B=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:le,matches:(0,C.$2b)(ie,Y=>new s(Y.startLineNumber-B,Y.startColumn,Y.endLineNumber-B,Y.endColumn))}}}}e.$VI=t;function i(J){const le=J[0].startLineNumber;for(const ie of J)if(ie.startLineNumber!==le||ie.endLineNumber!==le)return!1;return!0}class s{constructor(le,ie,ce,ye){this.startLineNumber=le,this.startColumn=ie,this.endLineNumber=ce,this.endColumn=ye}}e.$WI=s;class n extends s{constructor(le,ie,ce){super(le,ie,le,ce)}}e.$XI=n;var r;(function(J){J.List="list",J.Tree="tree"})(r||(e.ViewMode=r={}));var u;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(u||(e.SearchSortOrder=u={}));function I(J,le=!0){const ie=J&&J.files&&J.files.exclude,ce=le&&J&&J.search&&J.search.exclude;if(!ie&&!ce)return;if(!ie||!ce)return ie||ce;let ye=Object.create(null);return ye=f.$$m(ye,f.$8m(ie)),ye=f.$$m(ye,f.$8m(ce),!0),ye}e.$YI=I;function S(J,le){return J.excludePattern&&O.$wj(J.excludePattern,le)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&O.$wj(J.includePattern,le)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ie=>{const ce=ie.folder.fsPath;if(R.$Yf(le,ce)){const ye=E.$lc(ce,le);return!ie.includePattern||!!O.$wj(ie.includePattern,ye)}else return!1}):!1:!0}e.$ZI=S;var $;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class g extends Error{constructor(le,ie){super(le),this.code=ie}}e.$1I=g;function w(J){const le=J.message;if((0,b.$4)(J))return new g(le,$.canceled);try{const ie=JSON.parse(le);return new g(ie.message,ie.code)}catch{return new g(le,$.other)}}e.$2I=w;function D(J){const le={message:J.message,code:J.code};return new Error(JSON.stringify(le))}e.$3I=D;function T(J){return J.type==="error"?!0:J.type==="success"}e.$4I=T;function M(J){return J.type==="success"}e.$5I=M;function F(J){return!!J.path}e.$6I=F;function z(J,le){const ie=J.searchPath?J.searchPath:J.relativePath;return(0,A.$pf)(ie,le)}e.$7I=z;class j{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$8I=j;function N(J,le){const ie={...J||{},...le||{}};return Object.keys(ie).filter(ce=>{const ye=ie[ce];return typeof ye=="boolean"&&ye})}e.$9I=N;class q{constructor(le,ie){this.c=null,this.a={...le.excludePattern||{},...ie.excludePattern||{}},this.b=O.$xj(this.a);let ce=le.includePattern;ie.includePattern&&(ce?ce={...ce,...ie.includePattern}:ce=ie.includePattern),ce&&(this.c=O.$xj(ce))}matchesExcludesSync(le,ie,ce){return!!(this.b&&this.b(le,ie,ce))}includedInQuerySync(le,ie,ce){return!(this.b&&this.b(le,ie,ce)||this.c&&!this.c(le,ie,ce))}includedInQuery(le,ie,ce){const ye=this.b(le,ie,ce),H=()=>this.c?!!this.c(le,ie,ce):!0;return(0,P.$Hg)(ye)?ye.then(B=>B?!1:H()):H()}hasSiblingExcludeClauses(){return K(this.a)}}e.$0I=q;function K(J){for(const le in J)if(typeof J[le]!="boolean")return!0;return!1}function me(J){if(!J)return;let le;return ie=>(le||(le=(J()||Promise.resolve([])).then(ce=>ce?G(ce):{})),le.then(ce=>!!ce[ie]))}e.$$I=me;function te(J){if(!J)return;let le;return ie=>{if(!le){const ce=J();le=ce?G(ce):{}}return!!le[ie]}}e.$_I=te;function G(J){const le={};for(const ie of J)le[ie]=!0;return le}}),define(De[39],Ce([1,0,19,8,21,4,3,78,18,120,23,15,2,215,5,14,244,44,55,27,20,13,7,67,37,6]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d,a,t,i,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=e.$Lcc=void 0;function r(T,M,F){return new L.$lg(z=>$(z,F)).isEqual(T,M)}function u(T,M,F){return r(T.uri,M.uri,F)?0:(0,P.$Ve)(T.uri.toString(),M.uri.toString())}function I(T,M,F){return T.index!==M.index?T.index<M.index?-1:1:r(T.uri,M.uri,F)?(0,P.$Ve)(T.name,M.name):(0,P.$Ve)(T.uri.toString(),M.uri.toString())}function S(T,M,F,z){const j=T.slice(0).sort((q,K)=>F(q,K,z)),N=M.slice(0).sort((q,K)=>F(q,K,z));return(0,C.$Eb)(j,N,(q,K)=>F(q,K,z))}function $(T,M){const F=M.getCapabilities(T.scheme);return!(F&&F&1024)}class g extends o.$0h{static toExtHostWorkspace(M,F,z,j){if(!M)return{workspace:null,added:[],removed:[]};const{id:N,name:q,folders:K,configuration:me,transient:te,isUntitled:G}=M,J=[],le=F;F?K.forEach((H,B)=>{const Y=p.URI.revive(H.uri),re=g.o(z||F,Y,j);re?(re.name=H.name,re.index=H.index,J.push(re)):J.push({uri:Y,name:H.name,index:B})}):J.push(...K.map(({uri:H,name:B,index:Y})=>({uri:p.URI.revive(H),name:B,index:Y}))),J.sort((H,B)=>H.index<B.index?-1:1);const ie=new g(N,q,J,!!te,me?p.URI.revive(me):null,!!G,H=>$(H,j)),{added:ce,removed:ye}=S(le?le.workspaceFolders:[],ie.workspaceFolders,u,j);return{workspace:ie,added:ce,removed:ye}}static o(M,F,z){for(let j=0;j<M.folders.length;j++){const N=M.workspaceFolders[j];if(r(N.uri,F,z))return N}}constructor(M,F,z,j,N,q,K){super(M,z.map(me=>new o.$$h(me)),j,N,K),this.t=F,this.u=q,this.q=[],this.s=m.$Wh.forUris(K),z.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,F){return F&&this.s.get(M)&&(M=(0,L.$vg)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let w=class{constructor(M,F,z,j,N){this.c=new R.$Od,this.onDidChangeWorkspace=this.c.event,this.g=new R.$Od,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$Qd,this.B=new Map,this.h=j,this.s=z,this.t=N,this.j=new b.$Rl,this.k=new O.$Tg,this.o=M.getProxy(n.$pK.MainThreadWorkspace),this.q=M.getProxy(n.$pK.MainThreadMessageService);const q=F.workspace;this.l=q?new g(q.id,q.name,[],!!q.transient,q.configuration?p.URI.revive(q.configuration):null,!!q.isUntitled,K=>$(K,z)):void 0}$initializeWorkspace(M,F){this.v=F,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:E.Schemas.untitled,path:(0,L.$tg)((0,L.$vg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,F,z,...j){const N=[];if(Array.isArray(j)&&j.forEach(G=>{p.URI.isUri(G.uri)&&!N.some(J=>r(J.uri,G.uri,this.s))&&N.push({uri:G.uri,name:G.name||(0,L.$sg)(G.uri)})}),this.n||[F,z].some(G=>typeof G!="number"||G<0)||z===0&&N.length===0)return!1;const q=this.x?this.x.workspaceFolders:[];if(F+z>q.length)return!1;const K=q.slice(0);K.splice(F,z,...N.map(G=>({uri:G.uri,name:G.name||(0,L.$sg)(G.uri),index:void 0})));for(let G=0;G<K.length;G++){const J=K[G];if(K.some((le,ie)=>ie!==G&&r(J.uri,le.uri,this.s)))return!1}K.forEach((G,J)=>G.index=J);const{added:me,removed:te}=S(q,K,I,this.s);if(me.length===0&&te.length===0)return!1;if(this.o){const G=M.displayName||M.name;this.o.$updateWorkspaceFolders(G,F,z,N).then(void 0,J=>{this.n=void 0;const le={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(h.Severity.Error,(0,y.localize)(0,null,G,J.toString()),le,[])})}return this.y(K),!0}getWorkspaceFolder(M,F){if(this.x)return this.x.getWorkspaceFolder(M,F)}async getWorkspaceFolder2(M,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,F)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,F){let z,j="";if(typeof M=="string"?(z=p.URI.file(M),j=M):typeof M<"u"&&(z=M,j=M.fsPath),!z)return j;const N=this.getWorkspaceFolder(z,!0);if(!N)return j;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let q=(0,L.$yg)(N.uri,z);return F&&N.name&&(q=`${N.name}/${q}`),q}y(M){this.x&&(this.n=g.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:F,added:z,removed:j}=g.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:z,removed:j}))}findFiles(M,F,z,j,N=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let q;if(F===null?q=!1:F&&(typeof F=="string"?q=F:q=F.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:me}=D(a.GlobPattern.from(M));return this.o.$startFileSearch(K??null,me??null,q??null,z??null,N).then(te=>Array.isArray(te)?te.map(G=>p.URI.revive(G)):[])}async findTextInFiles(M,F,z,j,N=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const q=this.j.getNext(),K=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:me,folder:te}=D(a.GlobPattern.from(F.include)),G=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,J={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:K,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:me,excludePattern:G},le=!1;if(this.u[q]=ie=>{if(le)return;const ce=p.URI.revive(ie.resource);ie.results.forEach(ye=>{(0,s.$RI)(ye)?z({uri:ce,preview:{text:ye.preview.text,matches:(0,C.$2b)(ye.preview.matches,H=>new t.$tK(H.startLineNumber,H.startColumn,H.endLineNumber,H.endColumn))},ranges:(0,C.$2b)(ye.ranges,H=>new t.$tK(H.startLineNumber,H.startColumn,H.endLineNumber,H.endColumn))}):z({uri:ce,text:ye.text,lineNumber:ye.lineNumber})})},N.isCancellationRequested)return{};try{const ie=await this.o.$startTextSearch(M,te??null,J,q,N);return delete this.u[q],ie||{}}catch(ie){throw delete this.u[q],ie}}$handleTextSearchResult(M,F){this.u[F]?.(M)}async save(M){const F=await this.o.$save(M,{saveAs:!1});return p.URI.revive(F)}async saveAs(M){const F=await this.o.$save(M,{saveAs:!0});return p.URI.revive(F)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,F){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,F);const z=this.t.transformOutgoingScheme(M),j=this.z++;return this.o.$registerEditSessionIdentityProvider(j,z),(0,A.$Qc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(M,F){this.h.info("Getting edit session identifier for workspaceFolder",M);const z=await this.resolveWorkspaceFolder(p.URI.revive(M));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const j=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!j),!j)return;const N=await j.provideEditSessionIdentity(z,F);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(M,F,z,j){this.h.info("Getting edit session identifier for workspaceFolder",M);const N=await this.resolveWorkspaceFolder(p.URI.revive(M));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const q=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!q),!q)return;const K=await q.provideEditSessionIdentityMatch?.(F,z,j);if(this.h.info("Provider returned edit session identifier match result: ",K),!!K)return K}getOnWillCreateEditSessionIdentityEvent(M){return(F,z,j)=>{const N=function(K){F.call(z,K)};return N.extension=M,this.A.event(N,void 0,j)}}async $onWillCreateEditSessionIdentity(M,F,z){const j=await this.resolveWorkspaceFolder(p.URI.revive(M));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:j},F,async(N,q)=>{const K=Date.now();await Promise.resolve(N),Date.now()-K>z&&this.h.warn("SLOW edit session create-participant",q.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(M,F){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,F);const z=this.t.transformOutgoingScheme(M),j=this.z++;return this.o.$registerCanonicalUriProvider(j,z),(0,A.$Qc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(M,F,z){const j=this.B.get(M.scheme);if(!j)return;const N=await j.provideCanonicalUri?.(p.URI.revive(M),F,z);if(N)return N}async $provideCanonicalUri(M,F,z){return this.provideCanonicalUri(p.URI.revive(M),{targetScheme:F},z)}};e.$Lcc=w,e.$Lcc=w=He([Be(0,d.$qM),Be(1,c.$GM),Be(2,l.$zcc),Be(3,v.$$i),Be(4,i.$Jcc)],w),e.$Mcc=(0,k.$Qh)("IExtHostWorkspace");function D(T){let M,F;return T&&(typeof T=="string"?M=T:(M=T.pattern,F=p.URI.revive(T.baseUri))),{includePattern:M,folder:F}}}),define(De[40],Ce([1,0,24,4,39,6,7,246,136,17,8,5,20,14,2]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=e.$Ncc=void 0;function v(i,s){if(s){const n=s.split(".");let r=i;for(let u=0;r&&u<n.length;u++)r=r[n[u]];return r}}function h(i){return i instanceof k.URI}function o(i){return i&&i.uri instanceof k.URI&&i.languageId&&typeof i.languageId=="string"}function l(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function c(i){return i&&i.uri instanceof k.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function d(i){if(h(i))return{resource:i};if(o(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(l(i))return{overrideIdentifier:i.languageId};if(c(i))return{resource:i.uri};if(i===null)return{resource:null}}let a=class{constructor(s,n,r){this.a=s.getProxy(R.$pK.MainThreadConfiguration),this.c=n,this.b=r,this.d=new L.$Tg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,n))}};e.$Ncc=a,e.$Ncc=a=He([Be(0,p.$qM),Be(1,f.$Mcc),Be(2,y.$$i)],a);class t{constructor(s,n,r,u){this.a=new O.$Od,this.b=s,this.f=u,this.c=n,this.e=m.$In.parse(r),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,n){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$In.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(n,r))}getConfiguration(s,n,r){const u=d(n)||{},I=this.g(s?v(this.e.getValue(void 0,u,this.c.workspace),s):this.e.getValue(void 0,u,this.c.workspace));s&&this.h(s,u,r?.identifier);function S(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(g){return typeof v(I,g)<"u"},get:(g,w)=>{this.h(s?`${s}.${g}`:g,u,r?.identifier);let D=v(I,g);if(typeof D>"u")D=w;else{let T;const M=(F,z)=>{if((0,b.$Bf)(F)){let j;const N=()=>{T=T||(0,C.$8m)(I),j=j||v(T,z)};return new Proxy(F,{get:(q,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return N(),()=>j;if(T)return j=j||v(T,z),j[K];const me=q[K];return typeof K=="string"?M(me,`${z}.${K}`):me},set:(q,K,me)=>(N(),j&&(j[K]=me),!0),deleteProperty:(q,K)=>(N(),j&&delete j[K],!0),defineProperty:(q,K,me)=>(N(),j&&Object.defineProperty(j,K,me),!0)})}return Array.isArray(F)?(0,C.$8m)(F):F};D=M(D,g)}return D},update:(g,w,D,T)=>{g=s?`${s}.${g}`:g;const M=S(D);return w!==void 0?this.b.$updateConfigurationOption(M,g,w,u,T):this.b.$removeConfigurationOption(M,g,u,T)},inspect:g=>{g=s?`${s}.${g}`:g;const w=this.e.inspect(g,u,this.c.workspace);if(w)return{key:g,defaultValue:(0,C.$8m)(w.policy?.value??w.default?.value),globalValue:(0,C.$8m)(w.user?.value??w.application?.value),workspaceValue:(0,C.$8m)(w.workspace?.value),workspaceFolderValue:(0,C.$8m)(w.workspaceFolder?.value),defaultLanguageValue:(0,C.$8m)(w.default?.override),globalLanguageValue:(0,C.$8m)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,C.$8m)(w.workspace?.override),workspaceFolderLanguageValue:(0,C.$8m)(w.workspaceFolder?.override),languageIds:(0,C.$8m)(w.overrideIdentifiers)}}};return typeof I=="object"&&(0,C.$$m)($,I,!1),Object.freeze($)}g(s){const n=r=>(0,b.$Bf)(r)?new Proxy(r,{get:(u,I)=>n(u[I]),set:(u,I,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(u,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(u,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return n(s)}h(s,n,r){const u=E.$zn.test(s)?4:this.d.get(s),I=r?`[${r.value}] `:"";if(u===4){typeof n?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){n?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,n){const r=new m.$Kn(s,n,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,I)=>r.affectsConfiguration(u,d(I))})}k(s){return s.reduce((n,r)=>(n.set(r[0],r[1]),n),new Map)}}e.$Occ=t,e.$Pcc=(0,P.$Qh)("IExtHostConfiguration")}),define(De[93],Ce([1,0,2,8,4,6,7,39,70,40,21,45,20,27,5,18,12,14,89,293,9]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=e.$Ldc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(M){function F(j){if(j!=null)return j}M.from=F;function z(j){if(j!=null)return j}M.to=z})(a||(a={}));var t;(function(M){function F(j){if(j!=null)return j}M.from=F;function z(j){if(j!=null)return j}M.to=z})(t||(t={}));var i;(function(M){function F(j){if(j!=null)return j}M.from=F;function z(j){if(j!=null)return j}M.to=z})(i||(i={}));var s;(function(M){function F(N){if(N){const q=N;return q&&!!q.process}else return!1}M.is=F;function z(N){if(N==null)return;const q={process:N.process,args:N.args};return N.options&&(q.options=i.from(N.options)),q}M.from=z;function j(N){if(N!=null)return new A.$_K(N.process,N.args,N.options)}M.to=j})(s||(s={}));var n;(function(M){function F(j){if(j!=null)return j}M.from=F;function z(j){if(j!=null)return j}M.to=z})(n||(n={}));var r;(function(M){function F(N){if(N){const q=N;return q&&(!!q.commandLine||!!q.command)}else return!1}M.is=F;function z(N){if(N==null)return;const q={};return N.commandLine!==void 0?q.commandLine=N.commandLine:(q.command=N.command,q.args=N.args),N.options&&(q.options=n.from(N.options)),q}M.from=z;function j(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$aL(N.commandLine,N.options):new A.$aL(N.command,N.args?N.args:[],N.options)}M.to=j})(r||(r={}));var u;(function(M){function F(N){if(N){const q=N;return q&&q.customExecution==="customExecution"}else return!1}M.is=F;function z(N){return{customExecution:"customExecution"}}M.from=z;function j(N,q){return q.get(N)}M.to=j})(u||(e.CustomExecutionDTO=u={}));var I;(function(M){function F(z,j){let N;return z.scope!==void 0&&typeof z.scope!="number"?N=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===A.TaskScope.Workspace&&j&&j.workspaceFile?N=j.workspaceFile:N=c.$WF),{id:z._id,workspaceFolder:N}}M.from=F})(I||(e.TaskHandleDTO=I={}));var S;(function(M){function F(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}M.from=F})(S||(S={}));var $;(function(M){function F(N,q){if(N==null)return[];const K=[];for(const me of N){const te=z(me,q);te&&K.push(te)}return K}M.fromMany=F;function z(N,q){if(N==null)return;let K;N.execution instanceof A.$_K?K=s.from(N.execution):N.execution instanceof A.$aL?K=r.from(N.execution):N.execution&&N.execution instanceof A.$bL&&(K=u.from(N.execution));const me=a.from(N.definition);let te;return N.scope?typeof N.scope=="number"?te=N.scope:te=N.scope.uri:te=A.TaskScope.Workspace,!me||!te?void 0:{_id:N._id,definition:me,name:N.name,source:{extensionId:q.identifier.value,label:N.source,scope:te},execution:K,isBackground:N.isBackground,group:S.from(N.group),presentationOptions:t.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}M.from=z;async function j(N,q,K){if(N==null)return;let me;s.is(N.execution)?me=s.to(N.execution):r.is(N.execution)?me=r.to(N.execution):u.is(N.execution)&&(me=u.to(N._id,K));const te=a.to(N.definition);let G;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?G=N.source.scope:G=await q.resolveWorkspaceFolder(C.URI.revive(N.source.scope)):G=A.TaskScope.Workspace),!te||!G)return;const J=new A.$cL(te,G,N.name,N.source.label,me,N.problemMatchers);return N.isBackground!==void 0&&(J.isBackground=N.isBackground),N.group!==void 0&&(J.group=A.$$K.from(N.group._id),J.group&&N.group.isDefault&&(J.group=new A.$$K(J.group.id,J.group.label),N.group.isDefault===!0&&(J.group.isDefault=N.group.isDefault))),N.presentationOptions&&(J.presentationOptions=t.to(N.presentationOptions)),N._id&&(J._id=N._id),N.detail&&(J.detail=N.detail),J}M.to=j})($||(e.TaskDTO=$={}));var g;(function(M){function F(j){return j}M.from=F;function z(j){if(j)return Object.assign(Object.create(null),j)}M.to=z})(g||(g={}));class w{#e;constructor(F,z,j){this._id=z,this.a=j,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let D=class{constructor(F,z,j,N,q,K,me,te){this.q=new f.$Od,this.r=new f.$Od,this.s=new f.$Od,this.t=new f.$Od,this.a=F.getProxy(R.$pK.MainThreadTask),this.b=j,this.c=N,this.d=q,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=te,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,z,j){if(!j)return new A.$rK(()=>{});const N=this.w();return this.j.set(N,{type:z,provider:j,extension:F}),this.a.$registerTaskProvider(N,z),new A.$rK(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(F,z){this.a.$registerTaskSystem(F,z)}fetchTasks(F){return this.a.$fetchTasks(g.from(F)).then(async z=>{const j=[];for(const N of z){const q=await $.to(N,this.b,this.m);q&&j.push(q)}return j})}get taskExecutions(){const F=[];return this.k.forEach(z=>F.push(z)),F}terminateTask(F){if(!(F instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,z,j){const N=this.m.get(F.id);N&&(this.o.set(F.id,N),this.e.attachPtyToTerminal(z,await N.callback(j))),this.p=F.id,this.q.fire({execution:await this.y(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){const z=await this.y(F);this.l.delete(F.id),this.k.delete(F.id),this.A(F),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const z=await this.y(F.id);this.s.fire({execution:z,processId:F.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(F){const z=await this.y(F.id);this.t.fire({execution:z,exitCode:F.exitCode})}$provideTasks(F,z){const j=this.j.get(F);if(!j)return Promise.reject(new Error("no handler found"));const N=[],q=(0,O.$Ng)(()=>j.provider.provideTasks(L.CancellationToken.None)).then(K=>this.u(z,N,j,K));return new Promise(K=>{q.then(me=>{Promise.all(N).then(()=>{K(me)})})})}async $resolveTask(F,z){const j=this.j.get(F);if(!j)return Promise.reject(new Error("no handler found"));if(z.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${j.type}].`);const N=await $.to(z,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const q=await j.provider.resolveTask(N,L.CancellationToken.None);if(!q)return;this.z(q,j);const K=$.from(q,j.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(K.execution)&&await this.x(K,q,!0),await this.v(K)}w(){return this.h++}async x(F,z,j){const N=await this.a.$createTaskId(F);!j&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,z.execution)),this.m.set(N,z.execution)}async y(F,z){if(typeof F=="string"){const q=this.l.get(F);if(!q)throw new d.$bb("Unexpected: The specified task is missing an execution");return q}const j=this.l.get(F.id);if(j)return j;const N=new Promise((q,K)=>{function me(te,G,J){J?q(new w(te,G.id,J)):K("Unexpected: Task does not exist.")}z?me(this,F,z):$.to(F.task,this.b,this.m).then(te=>me(this,F,te))});return this.l.set(F.id,N),N.then(q=>(this.k.set(F.id,q),q),q=>Promise.reject(q))}z(F,z){F._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const j=this.n.values();let N=j.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=j.next()}};e.$Ldc=D,e.$Ldc=D=He([Be(0,p.$qM),Be(1,y.$GM),Be(2,m.$Mcc),Be(3,E.$BM),Be(4,b.$Pcc),Be(5,P.$8cc),Be(6,o.$$i),Be(7,l.$Ccc)],D);let T=class extends D{constructor(F,z,j,N,q,K,me,te){super(F,z,j,N,q,K,me,te),this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:h.$i(0)})}async executeTask(F,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const j=$.from(z,F);if(j===void 0)throw new Error("Task is not valid");if(u.is(j.execution))await this.x(j,z,!1);else throw new d.$_;const N=await this.y(await this.a.$getTaskExecution(j),z);return this.a.$executeTask(j).catch(q=>{throw new Error(q)}),N}u(F,z,j,N){const q=[];if(N)for(const K of N){this.z(K,j),(!K.definition||!F[K.definition.type])&&this.f.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const me=$.from(K,j.extension);me&&u.is(me.execution)?(q.push(me),z.push(this.x(me,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:j.extension}}async v(F){if(u.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,z,j){}};e.$Mdc=T,e.$Mdc=T=He([Be(0,p.$qM),Be(1,y.$GM),Be(2,m.$Mcc),Be(3,E.$BM),Be(4,b.$Pcc),Be(5,P.$8cc),Be(6,o.$$i),Be(7,l.$Ccc)],T),e.$Ndc=(0,k.$Qh)("IExtHostTask")}),define(De[350],Ce([1,0,16,21,41,36,23,35,37]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;class b{constructor(p,y,k){this.k=p,this.l=y,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&R.$xj(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&R.$xj(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const y=this.k.folderQueries||[];return new Promise((k,v)=>{const h=o=>{this.f++,p(o)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const l=o.toString(),c=C.$nc(l);this.j&&this.j(l,c)||this.v(h,{base:o,basename:c})}),Promise.all(y.map(o=>this.p(o,h))).then(o=>{k({limitHit:this.e,stats:o[0]||void 0})},o=>{v(new Error((0,f.$Bi)(o)))})})}async p(p,y){const k=new O.$Yd,v=this.q(p),h=this.r(),o=new E.$0I(this.k,p),l=!o.hasSiblingExcludeClauses();let c;try{this.h.add(k),c=m.$Kd.create();const d=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},v,k.token),a=c.elapsed(),t=m.$Kd.create();return this.g&&!this.e||(d&&d.forEach(i=>{const s=C.$gc.relative(p.folder.path,i.path);if(l){const n=C.$nc(i.path);this.v(y,{base:p.folder,relativePath:s,basename:n});return}this.s(h,p.folder,s,y)}),this.g&&!this.e)?null:(this.u(h,o,y),{providerTime:a,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(p){const y=(0,E.$9I)(this.k.includePattern,p.includePattern),k=(0,E.$9I)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:k,includes:y,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},y,k,v){if(k===this.a){const o=C.$nc(this.a);this.v(v,{base:y,relativePath:this.a,basename:o})}function h(o){const l=C.$nc(o),c=C.$mc(o);let d=p[c];d||(d=p[c]=[],h(c)),d.push({base:y,relativePath:o,basename:l})}h(k)}u({rootEntries:p,pathToEntries:y},k,v){const h=this,o=this.a;function l(c){const d=(0,E.$_I)(()=>c.map(a=>a.basename));for(let a=0,t=c.length;a<t;a++){const i=c[a],{relativePath:s,basename:n}=i;if(k.matchesExcludesSync(s,n,o!==n?d:void 0))continue;const r=y[s];if(r)l(r);else{if(s===o)continue;h.v(v,i)}if(h.e)break}}l(p)}v(p,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(y))}}class L{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,y,k,v){const h=this.c(p.cacheKey),o=new b(p,y,h&&h.token);let l=0;const c=d=>{l+=d.length,k(d.map(a=>this.d(a)))};return this.e(o,L.a,c,v).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:l,detailStats:d.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new O.$Yd),this.b.get(p)}d(p){return p.relativePath?{resource:A.$wg(p.base,p.relativePath)}:{resource:p.base}}e(p,y,k,v){const h=v.onCancellationRequested(()=>{p.cancel()}),o=c=>{c&&(l.push(c),y>0&&l.length>=y&&(k(l),l=[]))};let l=[];return p.search(o).then(c=>(l.length&&k(l),h.dispose(),c),c=>(l.length&&k(l),h.dispose(),Promise.reject(c)))}}e.$Xdc=L}),define(De[351],Ce([1,0,19,74,36,99,28,18,16,23,15,17,2,172,227,50,14,44,143,348,37]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7J=e.$6J=void 0;let a=class{constructor(g,w,D,T,M){this.a=g,this.b=w,this.c=D,this.d=T,this.e=M}text(g,w,D={}){g=this.f(g,D);const T=this.a.getValue(),M=w&&w.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(w?.map(o.$_h),D),type:2,contentPattern:g,previewOptions:D.previewOptions,maxFileSize:D.maxFileSize,usePCRE2:T.search.usePCRE2||M||!1,beforeContext:D.beforeContext,afterContext:D.afterContext,userDisabledExcludesAndIgnoreFiles:D.disregardExcludeSettings&&D.disregardIgnoreFiles}}f(g,w){const D=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const T={...g,wordSeparators:D.editor.wordSeparators};return this.j(g,w)&&(T.isCaseSensitive=!0),this.k(g)&&(T.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),T}file(g,w={}){return{...this.h(g,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(g,w){return g?(g=Array.isArray(g)?g.map(r):r(g),w?this.parseSearchPaths(g):{pattern:i(...Array.isArray(g)?g:[g])}):{}}h(g=[],w={}){const D=this.g(w.includePattern,w.expandPatterns),T=this.g(w.excludePattern,w.expandPatterns),M=g.length>1,F=(D.searchPaths&&D.searchPaths.length?D.searchPaths.map(N=>this.q(N,w,T)):g.map(N=>this.r(N,w,T,M))).filter(N=>!!N),z={_reason:w._reason,folderQueries:F,usingSearchPaths:!!(D.searchPaths&&D.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:T.pattern,includePattern:D.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const N=C.$Hb(C.$Rb(this.c.groups.map(me=>me.editors.map(te=>te.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const q=N.filter(me=>(0,d.$ZI)(z,me.fsPath)),K=this.i(q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...z,...K}}const j=w.extraFileResources&&w.extraFileResources.filter(N=>(0,d.$ZI)(z,N.fsPath));return z.extraFileResources=j&&j.length?j:void 0,z}i(g){const w=[],D=new A.$Ac,T={};let M=!1;return g.forEach(F=>{if(F.scheme===m.Schemas.walkThrough)return;if((0,b.$Ag)(F)){const j=this.b.getWorkspaceFolder(F)?.uri??F.with({path:E.$mc(F.fsPath)});let N=D.get(j);N||(M=!0,N={folder:j,includePattern:{}},w.push(N),D.set(j,N));const q=E.$lc(j.fsPath,F.fsPath);(0,P.$Kf)(N.includePattern)[q.replace(/\\/g,"/")]=!0}else F.fsPath&&(M=!0,T[F.fsPath]=!0)}),{folderQueries:w,includePattern:T,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}j(g,w){if(w.isSmartCase){if(g.isRegExp){if(L.$qf(g.pattern,!0))return!0}else if(L.$qf(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,y.$zB)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const w=K=>E.$ic(K)||/^\.\.?([\/\\]|$)/.test(K),T=(Array.isArray(g)?g:s(g)).map(K=>{const me=this.e.resolvedUserHome;return me?(0,R.$yv)(K,me.scheme===m.Schemas.file?me.fsPath:me.path):K}),M=O.$J(T,K=>w(K)?"searchPaths":"exprSegments"),F=(M.exprSegments||[]).map(K=>L.$Le(K,"/")).map(K=>L.$Le(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),n(K))),z={},j=this.m(M.searchPaths||[]);j&&j.length&&(z.searchPaths=j);const N=C.$Rb(F),q=i(...N);return q&&(z.pattern=q),z}l(g,w){return w.disregardExcludeSettings?void 0:(0,d.$YI)(g,!w.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const w=g.flatMap(T=>{let{pathPortion:M,globPortion:F}=t(T);return F&&(F=u(F)),this.n(M).flatMap(j=>this.o(j,F))}),D=new Map;return w.forEach(T=>{const M=T.searchPath.toString(),F=D.get(M);F?T.pattern&&(F.pattern=F.pattern||{},F.pattern[T.pattern]=!0):D.set(M,{searchPath:T.searchPath,pattern:T.pattern?i(T.pattern):void 0})}),Array.from(D.values())}n(g){if(E.$ic(g)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==m.Schemas.file?[{searchPath:w[0].uri.with({path:g})}]:[{searchPath:p.URI.file(E.$hc(g))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(g=r(g),g.startsWith("../")||g===".."){const T=E.$gc.resolve(w.path,g);return[{searchPath:w.with({path:T})}]}const D=u(g);return[{searchPath:w,pattern:D}]}else{if(g==="./"||g===".\\")return[];{const w=g.replace(/^\.[\/\\]/,""),T=this.b.getWorkspace().folders.map(M=>{const F=w.match(new RegExp(`^${L.$Ge(M.name)}(?:/(.*)|$)`));return F?{match:F,folder:M}:null}).filter(P.$Hf);if(T.length)return T.map(M=>{const F=M.match[1];return{searchPath:M.folder.uri,pattern:F&&u(F)}});{const M=g.match(/\.[\/\\](.+)[\/\\]?/),F=M?M[1]:g,z=k.localize(0,null,F);throw new Error(z)}}}}o(g,w){const D=g.pattern&&w?`${g.pattern}/${w}`:g.pattern||w,T=[{searchPath:g.searchPath,pattern:D}];return D&&!D.endsWith("**")&&T.push({searchPath:g.searchPath,pattern:D+"/**"}),T}q(g,w,D){const T=this.r((0,o.$_h)(g.searchPath),w,D,!1);return T?{...T,includePattern:g.pattern}:null}r(g,w,D,T){let M;const F=p.URI.isUri(g)?g:g.uri;if(D.searchPaths){const K=D.searchPaths.filter(me=>(0,b.$pg)(me.searchPath,F))[0];if(K&&!K.pattern)return null;K&&(M=K.pattern)}const z=this.a.getValue({resource:F}),N={...this.l(z,w)||{},...M||{}},q=p.URI.isUri(g)?(0,b.$tg)(g):g.name;return{folder:F,folderName:T?q:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!z.search.followSymlinks}}};e.$6J=a,e.$6J=a=He([Be(0,v.$ki),Be(1,o.$Zh),Be(2,l.$rC),Be(3,h.$$i),Be(4,c.$4J)],a);function t($){const g=$.match(/[\*\{\}\(\)\[\]\?]/);if(g){const w=g.index,D=$.substr(0,w).match(/[/|\\][^/\\]*$/);if(D){let T=$.substr(0,D.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:$.substr((D.index||0)+1)}}}return{pathPortion:$}}function i(...$){return $.length?$.reduce((g,w)=>(g[w]=!0,g),Object.create(null)):void 0}function s($){return f.$vj($,",").map(g=>g.trim()).filter(g=>!!g.length)}function n($){return[`**/${$}/**`,`**/${$}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function r($){return $.replace(/\\/g,"/")}function u($){return r($).replace(/^\.\//,"").replace(/\/+$/g,"")}function I($){return $.replace(/([?*[\]])/g,"[$1]")}function S($,g){$=C.$Mb($,T=>T.toString());const w=[],D=g.getWorkspace();return $&&$.forEach(T=>{let M;if(g.getWorkbenchState()===2)M=(0,b.$yg)(D.folders[0].uri,T),M&&M!=="."&&(M="./"+M);else{const F=g.getWorkspaceFolder(T);if(F){const z=F.name;if(D.folders.filter(N=>N.name===z).length===1){const N=(0,b.$yg)(F.uri,T);N===""?M=`./${F.name}`:M=`./${F.name}/${N}`}else M=T.fsPath}}M&&w.push(I(M))}),w}e.$7J=S}),define(De[352],Ce([1,0,23,2,21,9,5,351,37,44]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olb=e.$Nlb=void 0;const L=7e3;function P(v,h){const o=h.activationEvents;if(!o)return Promise.resolve(void 0);const l=[],c=[];for(const n of o)if(/^workspaceContains:/.test(n)){const r=n.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||v.forceUsingSearch?c.push(r):l.push(r)}if(l.length===0&&c.length===0)return Promise.resolve(void 0);let d;const a=new Promise((n,r)=>{d=n}),t=n=>d({activationEvent:n}),i=Promise.all(l.map(n=>p(v,n,t))).then(()=>{}),s=y(v,h.identifier,c,t);return Promise.all([i,s]).then(()=>{d(void 0)}),a}e.$Nlb=P;async function p(v,h,o){for(const l of v.folders)if(await v.exists(C.$wg(O.URI.revive(l),h))){o(`workspaceContains:${h}`);return}}async function y(v,h,o,l){if(o.length===0)return Promise.resolve(void 0);const c=new f.$Yd,d=v.checkExists(v.folders,o,c.token),a=setTimeout(async()=>{c.cancel(),v.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},L);let t=!1;try{t=await d}catch(i){R.$4(i)||R.$1(i)}c.dispose(),clearTimeout(a),t&&l(`workspaceContains:${o.join(",")}`)}function k(v,h,o,l){const c=v.get(A.$Ph),d=v.get(E.$QI),t=c.createInstance(m.$6J).file(h.map(i=>(0,b.$_h)(O.URI.revive(i))),{_reason:"checkExists",includePattern:o,exists:!0});return d.fileSearch(t,l).then(i=>!!i.limitHit,i=>R.$4(i)?!1:Promise.reject(i))}e.$Olb=k}),define(De[46],Ce([1,0,205,16,54,23,8,3,78,2,14,6,40,283,115,39,26,145,9,25,22,263,7,65,5,27,90,20,104,73,45,4,352,114,265,18,112,35,12,113]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d,a,t,i,s,n,r,u,I,S,$,g,w,D,T,M,F,z,j,N){"use strict";var q;Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=e.$jdc=e.$idc=e.$hdc=e.$gdc=void 0,e.$gdc=(0,s.$Qh)("IHostUtils");let K=q=class extends m.$Sc{constructor(H,B,Y,re,X,_,x,pe,ae,fe,ee,de){super(),this.X=de,this.a=this.B(new g.$Od),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=Y,this.f=x,this.j=re,this.m=X,this.s=_,this.t=ae,this.u=fe,this.w=ee,this.y=this.g.getProxy(P.$pK.MainThreadWorkspace),this.z=this.g.getProxy(P.$pK.MainThreadTelemetry),this.C=this.g.getProxy(P.$pK.MainThreadExtensionService),this.D=new A.$Tg,this.F=new A.$Tg,this.G=new A.$Tg,this.H=new A.$Tg,this.I=new ce(this.f.extensions.activationEvents),this.L=new o.$N4b(this.I,this.f.extensions.allExtensions);const be=new c.$8l(this.f.extensions.myExtensions);this.J=new o.$N4b(this.I,le(this.L,be)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${G(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${G(this.J)}`)),this.M=new k.$Zcc(this.g,this.s),this.N=new D.$_cc(this.g),this.O=pe,this.h=H.createChild(new I.$Oh([k.$1cc,this.M],[D.$adc,this.N])),this.P=this.B(new y.$Ycc(this.J,this.L,{onExtensionActivationError:(Pe,U,Q)=>{this.C.$onExtensionActivationError(Pe,l.$3(U),Q)},actualActivateExtension:async(Pe,U)=>{if(o.$N4b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,U),new y.$Xcc;const Q=this.J.getExtensionDescription(Pe);return this.db(Q,U)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(H){l.$1(H)}}async Y(){this.O.onWillDeactivateAll();let H=[];try{H=this.J.getAllExtensionDescriptions().map(X=>X.identifier).filter(X=>this.isActivated(X)).map(X=>this.cb(X))}catch{}await Promise.all(H)}terminate(H,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${H}`),this.s.flush(),this.u.dispose(),this.P.dispose(),l.setUnexpectedErrorHandler(re=>{this.s.error(re)}),this.g.dispose();const Y=this.Y();Promise.race([(0,A.$Vg)(5e3),Y]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(H){return this.G.isOpen()?this.P.isActivated(H):!1}async getExtension(H){const B=await this.C.$getExtension(H);return B&&{...B,identifier:new c.$7l(B.identifier.value),extensionLocation:b.URI.revive(B.extensionLocation)}}Z(H,B){return this.P.activateByEvent(H,B)}$(H,B){return this.P.activateById(H,B)}activateByIdWithErrors(H,B){return this.$(H,B).then(()=>{const Y=this.P.getActivatedExtension(H);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(H=>this.J)}getExtensionExports(H){if(this.G.isOpen())return this.P.getActivatedExtension(H).exports;try{return this.P.getActivatedExtension(H).exports}catch{return null}}async ab(H){if(H.scheme===M.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(H.fsPath);return b.URI.file(B)}return H}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(H=>new ie(H))),this.Q}async bb(H){const B=E.$Wh.forUris(Y=>R.$ng.ignorePathCasing(Y));return await Promise.all(H.map(async Y=>{if(this.ub(Y)){const re=await this.ab(Y.extensionLocation);B.set(re,Y)}})),B}cb(H){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(H))return B;const Y=this.P.getActivatedExtension(H);if(!Y)return B;try{typeof Y.module.deactivate=="function"&&(B=Promise.resolve(Y.module.deactivate()).then(void 0,re=>(this.s.error(re),Promise.resolve(void 0))))}catch(re){this.s.error(`An error occurred when deactivating the extension '${H.value}':`),this.s.error(re)}try{(0,m.$Nc)(Y.subscriptions)}catch(re){this.s.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.s.error(re)}return B}async db(H,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(H.identifier):await this.C.$onWillActivateExtension(H.identifier),this.fb(H,B).then(Y=>{const re=Y.activationTimes;return this.C.$onDidActivateExtension(H.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,B),this.eb(H,B,"success",re),Y},Y=>{throw this.eb(H,B,"failure"),Y})}eb(H,B,Y,re){const X=te(H,B);this.z.$publicLog2("extensionActivationTimes",{...X,...re||{},outcome:Y})}fb(H,B){const Y=te(H,B);this.z.$publicLog2("activatePlugin",Y);const re=this.ub(H);if(!re)return Promise.resolve(new y.$Wcc(y.$Tcc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${H.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const X=new y.$Ucc(B.startup);return Promise.all([this.vb(H,(0,R.$wg)(H.extensionLocation,re),X),this.gb(H)]).then(_=>(f.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),q.hb(this.s,H.identifier,_[0],_[1],X))).then(_=>(f.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),_))}gb(H){const B=new a.$3cc(H,this.M),Y=new a.$2cc(H.identifier.value,!1,this.M),re=new T.$bdc(H,this.N),X=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,_=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([B.whenReady,Y.whenReady,this.O.whenReady]).then(()=>{const x=this;let pe,ae;const fe=(0,h.$kF)(H,"ipc")?this.f.messagePorts?.get(c.$7l.toKey(H.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:Y,secrets:re,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(ee){return O.$jc(H.extensionLocation.fsPath,ee)},get storagePath(){return x.O.workspaceValue(H)?.fsPath},get globalStoragePath(){return x.O.globalValue(H).fsPath},get logPath(){return O.$jc(x.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return b.URI.joinPath(x.f.logsLocation,H.identifier.value)},get storageUri(){return x.O.workspaceValue(H)},get globalStorageUri(){return x.O.globalValue(H)},get extensionMode(){return X},get extension(){return pe===void 0&&(pe=new J(x,H.identifier,H,_,!1)),pe},get extensionRuntime(){return(0,h.$lF)(H,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!ae){if(!fe)return;const ee=g.Event.buffer(g.Event.fromDOMEventEmitter(fe,"message",de=>de.data));fe.start(),ae={onDidReceiveMessage:ee,postMessage:fe.postMessage.bind(fe)}}return ae}})})}static hb(H,B,Y,re,X){return Y=Y||{activate:void 0,deactivate:void 0},this.ib(H,B,Y,re,X).then(_=>new y.$Vcc(!1,null,X.build(),Y,_,re.subscriptions))}static ib(H,B,Y,re,X){if(typeof Y.activate=="function")try{X.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${B.value}`);const _=typeof global=="object"?global:self,x=Y.activate.apply(_,[re]);return X.activateCallStop(),X.activateResolveStart(),Promise.resolve(x).then(pe=>(X.activateResolveStop(),pe))}catch(_){return Promise.reject(_)}else return Promise.resolve(Y)}jb(H,B){this.$(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:B}).then(void 0,Y=>{this.s.error(Y)})}kb(H,B=0){const re=Date.now();(0,j.$B)(()=>{for(let X=B;X<H.length;X+=1){const _=H[X];for(const x of _.activationEvents??[])if(x==="onStartupFinished")if(Date.now()-re>50){this.kb(H,X);break}else this.jb(_,x)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(H=>{const B=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Y=this.J.getAllExtensionDescriptions();if(B)this.kb(Y);else for(const re of Y)if(re.activationEvents)for(const X of re.activationEvents)X==="onStartupFinished"&&this.jb(re,X)})}mb(){const H=this.Z("*",!0).then(void 0,_=>{this.s.error(_)});this.B(this.j.onDidChangeWorkspace(_=>this.nb(_.added)));const B=this.j.workspace?this.j.workspace.folders:[],Y=this.nb(B),re=this.pb(),X=Promise.all([re,H,Y]).then(()=>{});return Promise.race([X,(0,A.$Vg)(1e4)]).then(()=>{this.lb()}),X}nb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(H,B))).then(()=>{})}async ob(H,B){if(this.isActivated(B.identifier))return;const Y=!this.f.remote.isRemote&&!!this.f.remote.authority,re={logService:this.s,folders:H.map(_=>_.uri),forceUsingSearch:Y||!this.c.fsExists,exists:_=>this.c.fsExists(_.fsPath),checkExists:(_,x,pe)=>this.y.$checkExists(_,x,pe)},X=await(0,w.$Nlb)(re,B);if(X)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:X.activationEvent}).then(void 0,_=>this.s.error(_))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(H){throw console.error(H),H}}async qb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:B}=this.f.environment;if(!H||!B)throw new Error(C.localize(0,null));const Y=await this.vb(null,B,new y.$Ucc(!1));if(!Y||typeof Y.run!="function")throw new Error(C.localize(1,null,B.toString()));return new Promise((re,X)=>{const _=(ae,fe)=>{ae?(j.$t&&this.s.error("Test runner called back with error",ae),X(ae)):(j.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),re(typeof fe=="number"&&fe>0?1:0))},x=(0,R.$kg)(B),pe=Y.run(x,_);pe&&pe.then&&pe.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),re(0)}).catch(ae=>{j.$t&&this.s.error("Test runner finished with error",ae),X(ae instanceof Error&&ae.stack?ae.stack:String(ae))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Vg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,B){return this.R[H]=B,(0,m.$Qc)(()=>{delete this.R[H]})}async getRemoteExecServer(H){const{resolver:B}=await this.sb(H);return B?.resolveExecServer?.(H,{resolveAttempt:0})}async sb(H){const B=H.indexOf("+");if(B===-1)throw new t.$xK("Not an authority that can be resolved!",i.RemoteAuthorityResolverErrorCode.InvalidAuthority);const Y=H.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this.R[Y]}}async $resolveAuthority(H,B){const Y=z.$Kd.create(!1),re=()=>`[resolveAuthority(${(0,i.$Uk)(H)},${B})][${Y.elapsed()}ms] `,X=oe=>this.s.info(`${re()}${oe}`),_=oe=>this.s.warn(`${re()}${oe}`),x=(oe,Z=void 0)=>this.s.error(`${re()}${oe}`,Z),pe=oe=>{if(oe instanceof t.$xK)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe},ae=async oe=>{X(`activating resolver for ${oe}...`);const{resolver:Z,authorityPrefix:ge}=await this.sb(oe);if(!Z)throw x(`no resolver for ${ge}`),new t.$xK(`No remote extension installed to resolve ${ge}.`,i.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Z,authorityPrefix:ge,remoteAuthority:oe}},fe=H.split(/@|%40/g).reverse();X(`activating remote resolvers ${fe.join(" -> ")}`);let ee;try{ee=await Promise.all(fe.map(ae)).catch(async oe=>{if(!(oe instanceof t.$xK)||oe._code!==i.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw oe;return _(`resolving nested authorities failed: ${oe.message}`),[await ae(H)]})}catch(oe){return pe(oe)}const de=new A.$6g;de.cancelAndSet(()=>X("waiting..."),1e3);let be,Pe;for(const[oe,{authorityPrefix:Z,resolver:ge,remoteAuthority:Ee}]of ee.entries())try{if(oe===ee.length-1)X("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${Z}`),be=await ge.resolve(Ee,{resolveAttempt:B,execServer:Pe}),f.mark(`code/extHost/didResolveAuthorityOK/${Z}`),X("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$wK.isManagedResolvedAuthority(be)?be:void 0));else{if(X(`invoking resolveExecServer() for ${Ee}`),f.mark(`code/extHost/willResolveExecServer/${Z}`),Pe=await ge.resolveExecServer?.(Ee,{resolveAttempt:B,execServer:Pe}),!Pe)throw new t.$xK(`Exec server was not available for ${Ee}`,i.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${Z}`)}}catch(ze){return f.mark(`code/extHost/didResolveAuthorityError/${Z}`),x("returned an error",ze),de.dispose(),pe(ze)}de.dispose();const U={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},Q={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};X(`returned ${t.$wK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let se;if(t.$wK.isManagedResolvedAuthority(be)){const oe=B;this.X.setFactory(oe,be.makeConnection),se={authority:H,connectTo:new i.$Rk(oe),connectionToken:be.connectionToken}}else se={authority:H,connectTo:new i.$Sk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:se,options:Q,tunnelInformation:U}}}async $getCanonicalURI(H,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,i.$Uk)(H)})`);const{resolver:Y}=await this.sb(H);if(!Y)return null;const re=b.URI.revive(B);if(typeof Y.getCanonicalURI>"u")return re;const X=await(0,A.$Ng)(()=>Y.getCanonicalURI(re));return X||re}$startExtensionHost(H){H.toAdd.forEach(re=>re.extensionLocation=b.URI.revive(re.extensionLocation));const{globalRegistry:B,myExtensions:Y}=me(this.I,this.L,this.J,H);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(Y),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${G(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${G(this.J)}`)),this.rb()}$activateByEvent(H,B){return B===1?this.D.wait().then(Y=>this.Z(H,!1)):this.G.wait().then(Y=>this.Z(H,!1))}async $activate(H,B){return await this.G.wait(),this.J.getExtensionDescription(H)?(await this.$(H,B),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(_=>_.extensionLocation=b.URI.revive(_.extensionLocation));const{globalRegistry:B,myExtensions:Y}=me(this.I,this.L,this.J,H),re=await this.bb(Y);return(await this.getExtensionPathIndex()).setSearchTree(re),this.L.set(B.getAllExtensionDescriptions()),this.J.set(Y),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${G(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${G(this.J)}`)),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const B=d.$ce.alloc(H),Y=Math.random()%256;for(let re=0;re<H;re++)B.writeUInt8(Y,re);return B}async $updateRemoteConnectionData(H){this.W=H,this.a.fire()}};e.$hdc=K,e.$hdc=K=q=He([Be(0,s.$Ph),Be(1,e.$gdc),Be(2,u.$qM),Be(3,v.$Mcc),Be(4,p.$Pcc),Be(5,L.$$i),Be(6,n.$GM),Be(7,r.$6cc),Be(8,S.$nwb),Be(9,$.$8cc),Be(10,F.$ddc),Be(11,N.$edc)],K);function me(ye,H,B,Y){ye.addActivationEvents(Y.addActivationEvents);const re=new o.$N4b(ye,H.getAllExtensionDescriptions());re.deltaExtensions(Y.toAdd,Y.toRemove);const X=new c.$8l(B.getAllExtensionDescriptions().map(x=>x.identifier));for(const x of Y.myToRemove)X.delete(x);for(const x of Y.myToAdd)X.add(x);const _=le(re,X);return{globalRegistry:re,myExtensions:_}}function te(ye,H){return{id:ye.identifier.value,name:ye.name,extensionVersion:ye.version,publisherDisplayName:ye.publisher,activationEvents:ye.activationEvents?ye.activationEvents.join(","):null,isBuiltin:ye.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}function G(ye){return ye.getAllExtensionDescriptions().map(H=>H.identifier.value).join(",")}e.$idc=(0,s.$Qh)("IExtHostExtensionService");class J{#e;#t;#i;constructor(H,B,Y,re,X){this.#e=H,this.#t=B,this.#i=Y.identifier,this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=O.$hc((0,R.$kg)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=re,this.isFromDifferentExtensionHost=X}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$jdc=J;function le(ye,H){return ye.getAllExtensionDescriptions().filter(B=>H.has(B.identifier))}class ie{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$kdc=ie;class ce{constructor(H){this.a=new c.$9l,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)}addActivationEvents(H){for(const B of Object.keys(H))this.a.set(B,H[B])}}}),define(De[353],Ce([1,0,54,2,6,40,26,25,20,27,5,46,14,15]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;let v=class{constructor(d,a,t,i,s,n,r){this.c=d,this.d=a,this.e=t,this.f=i,this.g=s,this.h=n,this.i=r,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const d=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new o(this.c,a,this.d,d,this.i)),this.register(this.e.createInstance(h)),this.h.remote.isRemote&&this.register(this.e.createInstance(l,a,this.h.environment.appUriScheme))}register(d){if("nodeModuleName"in d)if(Array.isArray(d.nodeModuleName))for(const a of d.nodeModuleName)this.a.set(a,d);else this.a.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this.b.push(a=>d.alternativeModuleName(a))}};e.$Iec=v,e.$Iec=v=He([Be(2,L.$Ph),Be(3,R.$Pcc),Be(4,P.$idc),Be(5,b.$GM),Be(6,p.$$i)],v);let h=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(d){if(d.environment.appRoot&&k.a.size){const a=(0,y.$Ge)(this.c(d.environment.appRoot.fsPath)),t="[a-z0-9_.-]",i=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${s}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(d){if(!this.b)return;const a=this.b.exec(this.c(d));if(!a)return;const[,t,i,s]=a,n=k.a.get(i);if(n!==void 0)return console.warn(`${i} as been renamed to ${n}, please update your imports`),t+n+s}c(d){return d.replace(/\\/g,"/")}};h=k=He([Be(0,b.$GM)],h);class o{constructor(d,a,t,i,s){this.c=d,this.d=a,this.e=t,this.f=i,this.g=s,this.nodeModuleName="vscode",this.a=new m.$9l}load(d,a){const t=this.d.findSubstr(a);if(t){let i=this.a.get(t.identifier);return i||(i=this.c(t,this.e,this.f),this.a.set(t.identifier,i)),i}if(!this.b){let i="";this.d.forEach((s,n)=>i+=`	${n} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${i}`),this.b=this.c(A.$fF,this.e,this.f)}return this.b}}let l=class{constructor(d,a,t){this.e=d,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$pK.MainThreadTelemetry);const i=t.getProxy(f.$pK.MainThreadWindow);this.c=(s,n)=>{const r=O.URI.parse(s);return n?this.g(s,n):r.scheme==="http"||r.scheme==="https"?i.$openUri(r,s,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this.f?i.$openUri(r,s,{}):this.g(s,n)}}load(d,a,t){const i=this.e.findSubstr(a);return i&&(this.a=i.identifier.value,this.h()),this.b=t(d),this.c}g(d,a){return this.i(),this.b(d,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};l=He([Be(2,E.$qM)],l)}),define(De[56],Ce([1,0,47,3,16,48,5,70,71,46,7,39,280,40]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=e.$Qdc=void 0,e.$Qdc=(0,A.$Qh)("IExtHostVariableResolverProvider");class k extends p.$rN{constructor(o,l,c,d,a,t,i){function s(){if(c){const n=c.activeEditor();if(n)return n.document.uri;const r=d.tabGroups.all.find(u=>u.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof L.$0L||r.input instanceof L.$cM)return r.input.modified;if(r.input instanceof L.$9L||r.input instanceof L.$bM||r.input instanceof L.$_L)return r.input.uri}}}super({getFolderUri:n=>{const r=t.folders.filter(u=>u.name===n);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,r)=>a.getConfiguration(void 0,n).get(r),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=s();if(n)return f.$hc(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const n=s();if(n){const r=l.getWorkspaceFolder(n);if(r)return f.$hc(r.uri.fsPath)}}},getSelectedText:()=>{if(c){const n=c.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(c){const n=c.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>o.getExtension(n)},void 0,i?Promise.resolve(i):void 0,Promise.resolve(R.env))}}let v=class extends O.$Sc{constructor(o,l,c,d,a){super(),this.b=o,this.c=l,this.g=c,this.h=d,this.j=a,this.a=new C.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async n=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$Rdc=v,e.$Rdc=v=He([Be(0,b.$idc),Be(1,P.$Mcc),Be(2,m.$BM),Be(3,y.$Pcc),Be(4,E.$Odc)],v)}),define(De[94],Ce([1,0,8,4,2,5,6,71,46,20,7,39,140,273,40,56]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=e.$Vdc=e.$Udc=e.$Tdc=e.$Sdc=void 0,e.$Sdc=(0,R.$Qh)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(i,s,n,r,u,I){this.E=s,this.F=n,this.G=r,this.H=u,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new O.$Od,this.n=new O.$Od,this.o=new O.$Od,this.u=new O.$Od,this.k=i.getProxy(A.$pK.MainThreadDebugService),this.y=new O.$Od,this.A=new O.$Od,this.v=new l(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange($=>{this.J(S)}),this.J(S)})}asDebugSourceUri(i,s){const n=i;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let r=`debug:${encodeURIComponent(n.path||"")}`,u="?";return s&&(r+=`${u}session=${encodeURIComponent(s.id)}`,u="&"),r+=`${u}ref=${n.sourceReference}`,f.URI.parse(r)}else{if(n.path)return f.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(i){const s=[];for(const n of i.getAllExtensionDescriptions())if(n.contributes){const r=n.contributes.debuggers;if(r&&r.length>0)for(const u of r)(0,y.$zF)(u)&&s.push(u.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const i=[];return this.w.forEach(s=>i.push(s)),i}addBreakpoints(i){const s=i.filter(u=>{const I=u.id;return this.w.has(I)?!1:(this.w.set(I,u),!0)});this.U(s,[],[]);const n=[],r=new Map;for(const u of s)if(u instanceof L.$qL){let I=r.get(u.location.uri.toString());I||(I={type:"sourceMulti",uri:u.location.uri,lines:[]},r.set(u.location.uri.toString(),I),n.push(I)),I.lines.push({id:u.id,enabled:u.enabled,condition:u.condition,hitCondition:u.hitCondition,logMessage:u.logMessage,line:u.location.range.start.line,character:u.location.range.start.character})}else u instanceof L.$rL&&n.push({type:"function",id:u.id,enabled:u.enabled,hitCondition:u.hitCondition,logMessage:u.logMessage,condition:u.condition,functionName:u.functionName});return this.k.$registerBreakpoints(n)}removeBreakpoints(i){const s=i.filter(I=>this.w.delete(I.id));this.U([],s,[]);const n=s.filter(I=>I instanceof L.$qL).map(I=>I.id),r=s.filter(I=>I instanceof L.$rL).map(I=>I.id),u=s.filter(I=>I instanceof L.$sL).map(I=>I.id);return this.k.$unregisterBreakpoints(n,r,u)}startDebugging(i,s,n){return this.k.$startDebugging(i?i.uri:void 0,s,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===L.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,suppressSaveBeforeStart:n.suppressSaveBeforeStart,suppressDebugStatusbar:n.suppressDebugStatusbar??n.debugUI?.simple,suppressDebugToolbar:n.suppressDebugToolbar??n.debugUI?.simple,suppressDebugView:n.suppressDebugView??n.debugUI?.simple})}stopDebugging(i){return this.k.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,s,n){if(!s)return new L.$rK(()=>{});const r=this.d++;return this.f.push({type:i,handle:r,provider:s}),this.k.$registerDebugConfigurationProvider(i,n,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,r),new L.$rK(()=>{this.f=this.f.filter(u=>u.provider!==s),this.k.$unregisterDebugConfigurationProvider(r)})}registerDebugAdapterDescriptorFactory(i,s,n){if(!n)return new L.$rK(()=>{});if(!this.Q(i,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const r=this.g++;return this.h.push({type:s,handle:r,factory:n}),this.k.$registerDebugAdapterDescriptorFactory(s,r),new L.$rK(()=>{this.h=this.h.filter(u=>u.factory!==n),this.k.$unregisterDebugAdapterDescriptorFactory(r)})}registerDebugAdapterTrackerFactory(i,s){if(!s)return new L.$rK(()=>{});const n=this.i++;return this.j.push({type:i,handle:n,factory:s}),new L.$rK(()=>{this.j=this.j.filter(r=>r.factory!==s)})}async $runInTerminal(i,s){return Promise.resolve(void 0)}async $substituteVariables(i,s){let n;const r=await this.W(i);return r&&(n={uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(n,s)}K(i,s){if(i.type==="implementation")return new d(i.implementation)}L(){}async $startDASession(i,s){const n=this,r=await this.V(s);return this.S(this.N(r.type),r).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}' (extension might have failed to activate)`);const I=this.M(u),S=this.K(I,r);if(!S)throw new Error(`Couldn't create a debug adapter for type '${r.type}'.`);const $=S;return this.B.set(i,$),this.R(r).then(g=>(g&&this.C.set(i,g),$.onMessage(async w=>{if(w.type==="request"&&w.command==="handshake"){const D=w,T={type:"response",seq:0,command:D.command,request_seq:D.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const M=await this.D.sign(D.arguments.value);T.body={signature:M},$.sendResponse(T)}else throw new Error("no signer")}catch(M){T.success=!1,T.message=M.message,$.sendResponse(T)}}else g&&g.onDidSendMessage&&g.onDidSendMessage(w),w=(0,y.$EF)(w,!0),n.k.$acceptDAMessage(i,w)}),$.onError(w=>{g&&g.onError&&g.onError(w),this.k.$acceptDAError(i,w.name,w.message,w.stack)}),$.onExit(w=>{g&&g.onExit&&g.onExit(w??void 0,void 0),this.k.$acceptDAExit(i,w??void 0,void 0)}),g&&g.onWillStartSession&&g.onWillStartSession(),$.startSession()))})}$sendDAMessage(i,s){s=(0,y.$DF)(s,!1);const n=this.C.get(i);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(s),this.B.get(i)?.sendMessage(s)}$stopDASession(i){const s=this.C.get(i);this.C.delete(i),s&&s.onWillStopSession&&s.onWillStopSession();const n=this.B.get(i);return this.B.delete(i),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const s=[],n=[],r=[];if(i.added)for(const u of i.added){const I=u.id;if(I&&!this.w.has(I)){let S;if(u.type==="function")S=new L.$rL(u.functionName,u.enabled,u.condition,u.hitCondition,u.logMessage);else if(u.type==="data")S=new L.$sL(u.label,u.dataId,u.canPersist,u.enabled,u.hitCondition,u.condition,u.logMessage);else{const $=f.URI.revive(u.uri);S=new L.$qL(new L.$DK($,new L.$sK(u.line,u.character)),u.enabled,u.condition,u.hitCondition,u.logMessage)}(0,L.$oL)(S,I),this.w.set(I,S),s.push(S)}}if(i.removed)for(const u of i.removed){const I=this.w.get(u);I&&(this.w.delete(u),n.push(I))}if(i.changed){for(const u of i.changed)if(u.id){const I=this.w.get(u.id);if(I){if(I instanceof L.$rL&&u.type==="function"){const S=I;S.enabled=u.enabled,S.condition=u.condition,S.hitCondition=u.hitCondition,S.logMessage=u.logMessage,S.functionName=u.functionName}else if(I instanceof L.$qL&&u.type==="source"){const S=I;S.enabled=u.enabled,S.condition=u.condition,S.hitCondition=u.hitCondition,S.logMessage=u.logMessage,S.location=new L.$DK(f.URI.revive(u.uri),new L.$sK(u.line,u.character))}r.push(I)}}}this.U(s,n,r)}async $acceptStackFrameFocus(i){let s;const n=i.sessionId?await this.V(i.sessionId):void 0;if(!n)throw new Error("no DebugSession found for debug focus context");i.kind==="thread"?s=new L.$yL(n,i.threadId):s=new L.$xL(n,i.threadId,i.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(i,s,n){return(0,C.$Ng)(async()=>{const r=this.P(i);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const u=await this.W(s);return r.provideDebugConfigurations(u,n)}).then(r=>{if(!r)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return r})}$resolveDebugConfiguration(i,s,n,r){return(0,C.$Ng)(async()=>{const u=this.P(i);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(s);return u.resolveDebugConfiguration(I,n,r)})}$resolveDebugConfigurationWithSubstitutedVariables(i,s,n,r){return(0,C.$Ng)(async()=>{const u=this.P(i);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(s);return u.resolveDebugConfigurationWithSubstitutedVariables(I,n,r)})}async $provideDebugAdapter(i,s){const n=this.O(i);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const r=await this.V(s);return this.S(n,r).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}'`);return this.M(u)})}async $acceptDebugSessionStarted(i){const s=await this.V(i);this.m.fire(s)}async $acceptDebugSessionTerminated(i){const s=await this.V(i);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(i){this.q=i?await this.V(i):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(i,s){(await this.V(i))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(i,s){const r={session:await this.V(i),event:s.event,body:s.body};this.u.fire(r)}M(i){if(i instanceof L.$tL)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof L.$uL)return{type:"server",port:i.port,host:i.host};if(i instanceof L.$vL)return{type:"pipeServer",path:i.path};if(i instanceof L.$wL)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}N(i){const s=this.h.filter(n=>n.type===i);if(s.length>0)return s[0].factory}O(i){const s=this.h.filter(n=>n.handle===i);if(s.length>0)return s[0].factory}P(i){const s=this.f.filter(n=>n.handle===i);if(s.length>0)return s[0].provider}Q(i,s){if(i.contributes){const n=i.contributes.debuggers;if(n&&n.length>0){for(const r of n)if(r.label&&r.type&&r.type===s)return!0}}return!1}R(i){const n=i.configuration.type,r=this.j.filter(u=>u.type===n||u.type==="*").map(u=>(0,C.$Ng)(()=>u.factory.createDebugAdapterTracker(i)).then(I=>I,I=>null));return Promise.race([Promise.all(r).then(u=>{const I=u.filter(S=>!!S);if(I.length>0)return new c(I)}),new Promise(u=>setTimeout(()=>u(void 0),1e3))]).catch(u=>{})}async S(i,s){const n=s.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new L.$uL(n));if(i){const u=await this.F.getExtensionRegistry();return(0,C.$Ng)(()=>i.createDebugAdapterDescriptor(s,this.T(s,u))).then(I=>{if(I)return I})}const r=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,r))}T(i,s){}U(i,s,n){(i.length>0||s.length>0||n.length>0)&&this.y.fire(Object.freeze({added:i,removed:s,changed:n}))}async V(i){if(i)if(typeof i=="string"){const s=this.l.get(i);if(s)return s}else{let s=this.l.get(i.id);if(!s){const n=await this.W(i.folderUri),r=i.parent?this.l.get(i.parent):void 0;s=new o(this.k,i.id,i.type,i.name,n,i.configuration,r),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(i){if(i){const s=f.URI.revive(i);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$Tdc=h,e.$Tdc=h=He([Be(0,b.$qM),Be(1,P.$Mcc),Be(2,E.$idc),Be(3,k.$Pcc),Be(4,m.$Odc),Be(5,v.$Qdc)],h);class o{constructor(i,s,n,r,u,I,S){this.d=i,this.f=s,this.g=n,this.h=r,this.i=u,this.j=I,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(i){this.h=i,this.d.$setDebugSessionName(this.f,i)}get parentSession(){return this.k}_acceptNameChanged(i){this.h=i}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(i,s){return this.d.$customDebugAdapterRequest(this.f,i,s)}getDebugProtocolBreakpoint(i){return this.d.$getDebugProtocolBreakpoint(this.f,i.id)}}e.$Udc=o;class l{constructor(i){this.value=Object.freeze({append(s){i.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$Vdc=l;class c{constructor(i){this.d=i}onWillStartSession(){this.d.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(i):void 0)}onWillStopSession(){this.d.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.d.forEach(s=>s.onError?s.onError(i):void 0)}onExit(i,s){this.d.forEach(n=>n.onExit?n.onExit(i,s):void 0)}}class d extends p.$fdb{constructor(i){super(),this.h=i,i.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.h.handleMessage(i)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends h{constructor(i,s,n,r,u,I){super(i,s,n,r,u,I)}};e.$Wdc=a,e.$Wdc=a=He([Be(0,b.$qM),Be(1,P.$Mcc),Be(2,E.$idc),Be(3,k.$Pcc),Be(4,m.$Odc),Be(5,v.$Qdc)],a)}),define(De[354],Ce([1,0,9,54,2,6,345,14,103,104,27,239,20,67,46,88]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=void 0;class h{static async installEarlyHandler(c){Error.stackTraceLimit=100;const d=c.get(m.$$i),t=c.get(p.$qM).getProxy(R.$pK.MainThreadErrors);C.setUnexpectedErrorHandler(i=>{d.error(i);const s=C.$3(i);t.$onUnexpectedError(s)})}static async installFullHandler(c){const d=c.get(m.$$i),a=c.get(p.$qM),t=c.get(k.$idc),i=c.get(v.$KM),s=a.getProxy(R.$pK.MainThreadExtensionService),n=a.getProxy(R.$pK.MainThreadErrors),r=await t.getExtensionPathIndex(),u=new WeakMap;function I(g,w){if(u.has(g))return u.get(g).stack;let D="",T,M;for(const z of w)D+=`
	at ${z.toString()}`,M=z.getFileName(),!T&&M&&(T=r.findSubstr(f.URI.file(M)));const F=`${g.name||"Error"}: ${g.message||""}${D}`;return u.set(g,{extensionIdentifier:T?.identifier,stack:F}),F}const S=Symbol("prepareStackTrace wrapped");let $=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(g){if(g===I||!g||g[S]){$=g||I;return}$=function(w,D){return I(w,D),g.call(Error,w,D)},Object.assign($,{[S]:!0})}}),C.setUnexpectedErrorHandler(g=>{d.error(g);const w=C.$3(g),D=u.get(g);if(!D?.extensionIdentifier){n.$onUnexpectedError(w);return}s.$onExtensionRuntimeError(D.extensionIdentifier,w);const T=i.onExtensionError(D.extensionIdentifier,g);d.trace("forwarded error to extension?",T,D)})}}e.$Jec=h;class o{constructor(c,d,a,t,i){this.a=a,this.b=new A.$W4b(c,null,t),d=o.e(d,this.b);const s=new b.$Oh(...(0,E.$Br)());s.set(L.$GM,{_serviceBrand:void 0,...d,messagePorts:i}),s.set(p.$qM,new p.$rM(this.b)),s.set(y.$Jcc,new y.$Kcc(t)),s.set(k.$gdc,a);const n=new P.$hq(s,!0);n.invokeFunction(h.installEarlyHandler),this.d=n.invokeFunction(r=>r.get(m.$$i)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",d),this.c=n.invokeFunction(r=>r.get(k.$idc)),this.c.initialize(),n.invokeFunction(h.installFullHandler)}async asBrowserUri(c){const d=this.b.getProxy(R.$pK.MainThreadExtensionService);return f.URI.revive(await d.$asBrowserUri(c))}terminate(c){this.c.terminate(c)}static e(c,d){c.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(d.transformIncomingURIs(t.extensionLocation))}),c.environment.appRoot=f.URI.revive(d.transformIncomingURIs(c.environment.appRoot));const a=c.environment.extensionDevelopmentLocationURI;return a&&(c.environment.extensionDevelopmentLocationURI=a.map(t=>f.URI.revive(d.transformIncomingURIs(t)))),c.environment.extensionTestsLocationURI=f.URI.revive(d.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=f.URI.revive(d.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=f.URI.revive(d.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=f.URI.revive(d.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=f.URI.revive(d.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=f.URI.revive(d.transformIncomingURIs(c.logsLocation)),c.workspace=d.transformIncomingURIs(c.workspace),c}}e.$Kec=o}),define(De[355],Ce([1,0,8,12,216,233,138,94,71,46,20,45,7,56,39,274,275,40]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=void 0;let l=class extends m.$Tdc{constructor(i,s,n,r,u,I,S){super(i,s,n,r,I,S),this.Z=u,this.X=new a}K(i,s){switch(i.type){case"server":return new v.$Pec(i);case"pipeServer":return new v.$Qec(i);case"executable":return new v.$Rec(i,s.type)}return super.K(i,s)}T(i,s){const n=v.$Rec.platformAdapterExecutable(s.getAllExtensionDescriptions(),i.type);if(n)return new p.$tL(n.command,n.args,n.options)}L(){return new A.$G8b}async $runInTerminal(i,s){if(i.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const n=await this.G.getConfigProvider(),r=this.Z.getDefaultShell(!0),u=this.Z.getDefaultShellArgs(!0),I=i.title||f.localize(0,null),S=JSON.stringify({shell:r,shellArgs:u});let $=await this.X.checkout(S,I),g,w=!1;if($)g=i.cwd;else{const F={shellPath:r,shellArgs:u,cwd:i.cwd,name:I,iconPath:new p.$lL("debug")};w=!0,$=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert($,S)}$.show(!0);const D=await $.processId;w?await new Promise(F=>setTimeout(F,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?$.sendText("cls"):r.indexOf("bash")>=0?$.sendText("clear"):O.$j?$.sendText("cls"):$.sendText("clear"));const T=(0,h.$Tec)(r,i.args,!!i.argsCanBeInterpretedByShell,g,i.env);$.sendText(T);const M=this.onDidTerminateDebugSession(F=>{F.id===s&&(this.X.free($),M.dispose())});return D}else if(i.kind==="external")return d(i,await this.G.getConfigProvider());return super.$runInTerminal(i,s)}};e.$Uec=l,e.$Uec=l=He([Be(0,L.$qM),Be(1,k.$Mcc),Be(2,b.$idc),Be(3,o.$Pcc),Be(4,P.$8cc),Be(5,E.$Odc),Be(6,y.$Qdc)],l);let c;function d(t,i){if(!c)if(O.$j)c=new R.$s7b;else if(O.$k)c=new R.$t7b;else if(O.$l)c=new R.$u7b;else throw new Error("external terminals not supported on this platform");const s=i.getConfiguration("terminal");return c.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(i,s){const r=[...this.b.entries()].map(([u,I])=>(0,C.$Ig)(async S=>{if(u.name!==s||I.lastUsedAt!==-1&&await(0,h.$Sec)(await u.processId))return null;const $=Date.now();return I.lastUsedAt+a.a>$||S.isCancellationRequested||I.config!==i?null:(I.lastUsedAt=$,u)}));return await(0,C.$Zg)(r,u=>!!u)}insert(i,s){this.b.set(i,{lastUsedAt:Date.now(),config:s})}free(i){const s=this.b.get(i);s&&(s.lastUsedAt=-1)}onTerminalClosed(i){this.b.delete(i)}}}),define(De[356],Ce([1,0,16,2,101,39,70,40,44,45,20,27,93,18,14,89,23,63,56]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;let c=class extends p.$Ldc{constructor(a,t,i,s,n,r,u,I,S){super(a,t,i,s,n,r,u,I),this.B=i,this.C=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const i=t;if(!t.execution&&i._id===void 0)throw new Error("Tasks to execute must include an execution");if(i._id!==void 0){const s=p.TaskHandleDTO.from(i,this.B),n=await this.a.$getTaskExecution(s);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.y(n,t);return this.a.$executeTask(s).catch(()=>{}),r}else{const s=p.TaskDTO.from(t,a);if(s===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(s.execution)&&await this.x(s,t,!1);const n=await this.y(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),n}}u(a,t,i,s){const n=[];if(s)for(const r of s){this.z(r,i),(!r.definition||!a[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const u=p.TaskDTO.from(r,i.extension);u&&(n.push(u),p.CustomExecutionDTO.is(u.execution)&&t.push(this.x(u,r,!0)))}return{tasks:n,extension:i.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const i=O.URI.file((0,o.homedir)());t=new E.$$h({uri:i,name:h.$tg(i),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const i=O.URI.revive(a),s={process:void 0,variables:Object.create(null)},n=await this.b.resolveWorkspaceFolder(i),r=await this.b.getWorkspaceFolders2()??[],u=await this.C.getResolver(),I=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(r);for(const S of t.variables)s.variables[S]=await u.resolveAsync(I,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(C.$tc);for(let $=0;$<S.length;$++)S[$]=await u.resolveAsync(I,S[$])}s.process=await f.win32.findExecutable(await u.resolveAsync(I,t.process.name),t.process.cwd!==void 0?await u.resolveAsync(I,t.process.cwd):void 0,S)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,i){return f.win32.findExecutable(a,t,i)}};e.$Mec=c,e.$Mec=c=He([Be(0,L.$qM),Be(1,P.$GM),Be(2,R.$Mcc),Be(3,A.$BM),Be(4,m.$Pcc),Be(5,b.$8cc),Be(6,k.$$i),Be(7,v.$Ccc),Be(8,l.$Qdc)],c)}),define(De[357],Ce([1,0,63,56]),function($e,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class f extends O.$Rdc{m(){return(0,C.homedir)()}}e.$sfc=f}),define(De[153],Ce([1,0,19,8,21,41,18,16,23,2,37]),function($e,e,C,O,f,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=e.$1dc=e.$Zdc=e.$Ydc=void 0;class P{constructor(l,c,d,a){this.d=l,this.e=c,this.f=d,this.g=a,this.a=null,this.b=!1,this.c=0}search(l,c){const d=this.d.folderQueries||[],a=new f.$Yd(c);return new Promise((t,i)=>{this.a=new y(l);let s=!1;const n=(r,u)=>{if(!s&&!this.b){const I=this.h(r);v(r)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,s=!0,a.cancel(),r=this.j(r,this.d.maxResults-this.c));const S=this.h(r);this.c+=S,(S>0||!v(r))&&this.a.add(r,u)}};Promise.all(d.map((r,u)=>this.k(r,I=>n(I,u),a.token))).then(r=>{a.dispose(),this.a.flush();const u=r.some(I=>!!I&&!!I.limitHit);t({limitHit:this.b||u,messages:(0,C.$Rb)(r.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},r=>{a.dispose();const u=(0,R.$Bi)(r);i(new Error(u))})})}h(l){return v(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}j(l,c){const d=Array.isArray(l.ranges)?l.ranges:[l.ranges],a=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:d.slice(0,c),preview:{matches:a.slice(0,c),text:l.preview.text},uri:l.uri}}async k(l,c,d){const a=new L.$0I(this.d,l),t=[],i={report:r=>{if(!this.l(r))return;const u=l.folder.scheme===A.Schemas.file?(0,L.$$I)(()=>this.f.readdir(E.$vg(r.uri))):void 0,I=E.$yg(l.folder,r.uri);if(I){const S=a.includedInQuery(I,m.$nc(I),u);(0,O.$Hg)(S)?t.push(S.then($=>{$&&c(r)})):S&&c(r)}}},s=this.n(l),n=await this.e.provideTextSearchResults(p(this.d.contentPattern),s,i,d);return t.length&&await Promise.all(t),n}l(l){if(v(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(l){const c=(0,L.$9I)(this.d.includePattern,l.includePattern),d=(0,L.$9I)(this.d.excludePattern,l.excludePattern),a={folder:b.URI.from(l.folder),excludes:d,includes:c,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.f.toCanonicalName(l.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$Ydc=P;function p(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class y{constructor(l){this.e=l,this.b=-1,this.d=null,this.a=new h(512,c=>this.g(c))}add(l,c){this.d&&(this.b!==c||!E.$pg(this.c,l.uri))&&(this.f(),this.d=null),this.d||(this.b=c,this.d={resource:l.uri,results:[]}),this.d.results.push(k(l))}f(){const l=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,l)}flush(){this.f(),this.a.flush()}g(l){this.e(l)}}e.$Zdc=y;function k(o){return v(o)?{preview:{matches:(0,C.$2b)(o.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:o.preview.text},ranges:(0,C.$2b)(o.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function v(o){return!!o.preview}e.$1dc=v;class h{static{this.a=4e3}static{this.b=50}constructor(l,c){this.g=l,this.h=c,this.c=0,this.d=[],this.e=0}addItem(l,c){l&&this.j(l,c)}addItems(l,c){l&&this.k(l,c)}j(l,c){this.d.push(l),this.e+=c,this.l()}k(l,c){this.d=this.d.concat(l),this.e+=c,this.l()}l(){this.c<h.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},h.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$2dc=h}),define(De[95],Ce([1,0,3,6,5,350,20,67,14,2,153]),function($e,e,C,O,f,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=e.$4dc=e.$3dc=void 0,e.$3dc=(0,f.$Qh)("IExtHostSearch");let P=class{constructor(v,h,o){this.k=v,this.l=h,this.n=o,this.c=this.k.getProxy(O.$pK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$Xdc}o(v){return this.l.transformOutgoingScheme(v)}registerTextSearchProvider(v,h){if(this.g.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this.g.add(v);const o=this.d++;return this.e.set(o,h),this.c.$registerTextSearchProvider(o,this.o(v)),(0,C.$Qc)(()=>{this.g.delete(v),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(v,h){if(this.i.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this.i.add(v);const o=this.d++;return this.h.set(o,h),this.c.$registerFileSearchProvider(o,this.o(v)),(0,C.$Qc)(()=>{this.i.delete(v),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(v,h,o,l){const c=p(o),d=this.h.get(v);if(d)return this.j.fileSearch(c,d,a=>{this.c.$handleFileMatch(v,h,a.map(t=>t.resource))},l);throw new Error("unknown provider: "+v)}$clearCache(v){return this.j.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,h,o,l){const c=this.e.get(v);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const d=p(o);return this.q(d,c).search(t=>this.c.$handleTextMatch(v,h,t),l)}$enableExtensionHostSearch(){}q(v,h){return new L.$Ydc(v,h,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$4dc=P,e.$4dc=P=He([Be(0,A.$qM),Be(1,m.$Jcc),Be(2,E.$$i)],P);function p(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(y),extraFileResources:k.extraFileResources&&k.extraFileResources.map(v=>b.URI.revive(v))}}e.$5dc=p;function y(k){return{...k,folder:b.URI.revive(k.folder)}}}),define(De[358],Ce([1,0,21,9,4,38,2,130,125,168,185,30,6,111,304,303,34,305,40,307,308,309,284,310,70,46,312,313,318,319,320,152,288,326,327,330,115,45,332,289,13,7,85,335,91,151,39,25,278,317,66,149,93,94,95,14,67,20,27,321,276,73,89,296,333,90,72,338,336,337,297,55,331,334,114,71,88,322,92,323,18,134,287,264,315,3,26,272,112,258,324,325,298,314,286,316,113,328,301,329,302,295,311,299,300]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d,a,t,i,s,n,r,u,I,S,$,g,w,D,T,M,F,z,j,N,q,K,me,te,G,J,le,ie,ce,ye,H,B,Y,re,X,_,x,pe,ae,fe,ee,de,be,Pe,U,Q,se,oe,Z,ge,Ee,ze,We,_e,Ye,it,tt,Ae,Te,qe,Le,Xe,he,ue,Ie,Ke,Ue,Ze,nt,ct,bt,Et,Kt,Ht,pt,zt,Tt,Gt,Ut,Dt,Ft,Bt,Qt,Wt,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;function Nt(ut){const ft=ut.get(ae.$GM),At=ut.get(ze.$zcc),Vt=ut.get(se.$5cc),Rt=ut.get(n.$idc),at=ut.get(le.$Mcc),vt=ut.get(tt.$KM),Ot=ut.get(l.$Pcc),Pt=ut.get(x.$Jcc),Ge=ut.get(pe.$qM),Jt=ut.get(F.$1cc),Me=ut.get(Q.$6cc),Oe=ut.get(_.$_i),Se=ut.get(_.$$i),ne=ut.get(de.$nwb),Fe=ut.get(be.$Ccc),Ve=ut.get(J.$Gdc),xe=ut.get(Ye.$adc),Qe=ut.get(it.$Odc),rt=ut.get(Tt.$edc);Ge.set(p.$qK.ExtHostFileSystemInfo,At),Ge.set(p.$qK.ExtHostLogLevelServiceShape,Oe),Ge.set(p.$qK.ExtHostWorkspace,at),Ge.set(p.$qK.ExtHostConfiguration,Ot),Ge.set(p.$qK.ExtHostExtensionService,Rt),Ge.set(p.$qK.ExtHostStorage,Jt),Ge.set(p.$qK.ExtHostTunnelService,ne),Ge.set(p.$qK.ExtHostWindow,Ve),Ge.set(p.$qK.ExtHostSecretState,xe),Ge.set(p.$qK.ExtHostTelemetry,vt),Ge.set(p.$qK.ExtHostEditorTabs,Qe),Ge.set(p.$qK.ExtHostManagedSockets,rt);const kt=Ge.set(p.$qK.ExtHostDecorations,ut.get(B.$Kdc)),St=Ge.set(p.$qK.ExtHostDocumentsAndEditors,ut.get(s.$BM)),mt=Ge.set(p.$qK.ExtHostCommands,ut.get(h.$MM)),dt=Ge.set(p.$qK.ExtHostTerminalService,ut.get(z.$8cc)),gt=Ge.set(p.$qK.ExtHostDebugService,ut.get(re.$Sdc)),mi=Ge.set(p.$qK.ExtHostSearch,ut.get(X.$3dc)),Ct=Ge.set(p.$qK.ExtHostTask,ut.get(Y.$Ndc)),Di=Ge.set(p.$qK.ExtHostOutputService,ut.get(g.$qdc)),ui=Ge.set(p.$qK.ExtHostLocalization,ut.get(nt.$ddc)),$i=Ge.set(p.$qK.ExtHostUrls,new te.$zdc(Ge)),It=Ge.set(p.$qK.ExtHostDocuments,new i.$xcc(Ge,St)),gn=Ge.set(p.$qK.ExtHostDocumentContentProviders,new a.$Rcc(Ge,St,Se)),ri=Ge.set(p.$qK.ExtHostDocumentSaveParticipant,new t.$Scc(Se,It,Ge.getProxy(p.$pK.MainThreadBulkEdits))),yt=Ge.set(p.$qK.ExtHostNotebook,new fe.$9dc(Ge,mt,St,It,Vt)),bi=Ge.set(p.$qK.ExtHostNotebookDocuments,new ue.$oec(yt)),wi=Ge.set(p.$qK.ExtHostNotebookEditors,new he.$nec(Se,yt)),si=Ge.set(p.$qK.ExtHostNotebookKernels,new Ae.$kec(Ge,ft,yt,mt,Se)),Ci=Ge.set(p.$qK.ExtHostNotebookRenderers,new qe.$mec(Ge,yt)),Ii=Ge.set(p.$qK.ExtHostNotebookDocumentSaveParticipant,new pt.$uec(Se,yt,Ge.getProxy(p.$pK.MainThreadBulkEdits))),Lt=Ge.set(p.$qK.ExtHostEditors,new j.$xdc(Ge,St)),pi=Ge.set(p.$qK.ExtHostTreeViews,new N.$ydc(Ge.getProxy(p.$pK.MainThreadTreeViews),mt,Se)),Pi=Ge.set(p.$qK.ExtHostEditorInsets,new ce.$Hdc(Ge.getProxy(p.$pK.MainThreadEditorInsets),Lt,ft.remote)),oi=Ge.set(p.$qK.ExtHostDiagnostics,new c.$Bcc(Ge,Se,At,St)),li=Ge.set(p.$qK.ExtHostLanguages,new S.$ndc(Ge,It,mt.converter,Pt)),lt=Ge.set(p.$qK.ExtHostLanguageFeatures,new I.$Fcc(Ge,Pt,It,mt,oi,Se,Fe,vt)),Ai=Ge.set(p.$qK.ExtHostFileSystem,new r.$ldc(Ge,lt)),Zt=Ge.set(p.$qK.ExtHostFileSystemEventService,new u.$mdc(Ge,Se,St)),ii=Ge.set(p.$qK.ExtHostQuickOpen,(0,D.$sdc)(Ge,at,mt)),Ri=Ge.set(p.$qK.ExtHostSCM,new T.$udc(Ge,mt,It,Se)),Li=Ge.set(p.$qK.ExtHostQuickDiff,new Et.$rec(Ge,Pt)),Mi=Ge.set(p.$qK.ExtHostShare,new Gt.$wec(Ge,Pt)),Yi=Ge.set(p.$qK.ExtHostComments,(0,o.$Icc)(Ge,mt,It)),Fi=Ge.set(p.$qK.ExtHostProgress,new w.$rdc(Ge.getProxy(p.$pK.MainThreadProgress))),Xi=Ge.set(p.$qK.ExtHosLabelService,new ye.$Idc(Ge)),Oi=Ge.set(p.$qK.ExtHostTheming,new ee.$0dc(Ge)),ai=Ge.set(p.$qK.ExtHostAuthentication,new Pe.$$dc(Ge)),mn=Ge.set(p.$qK.ExtHostTimeline,new U.$aec(Ge,mt)),Ti=Ge.set(p.$qK.ExtHostWebviews,new G.$Cdc(Ge,ft.remote,at,Se,Fe)),hi=Ge.set(p.$qK.ExtHostWebviewPanels,new ge.$cec(Ge,Ti,at)),Ni=Ge.set(p.$qK.ExtHostCustomEditors,new Z.$dec(Ge,It,Me,Ti,hi)),$n=Ge.set(p.$qK.ExtHostWebviewViews,new oe.$bec(Ge,Ti)),di=Ge.set(p.$qK.ExtHostTesting,new We.$fec(Ge,mt,St)),Zi=Ge.set(p.$qK.ExtHostUriOpeners,new _e.$jec(Ge)),ji=Ge.set(p.$qK.ExtHostProfileContentHandlers,new bt.$qec(Ge));Ge.set(p.$qK.ExtHostInteractive,new Ie.$pec(Ge,yt,St,mt,Se));const xi=Ge.set(p.$qK.ExtHostInlineChat,new Ht.$tec(Ge,mt,It,Se)),fi=Ge.set(p.$qK.ExtHostChatProvider,new Ut.$xec(Ge,Se)),_i=Ge.set(p.$qK.ExtHostChatAgents,new Wt.$Cec(Ge,fi,Se)),bn=Ge.set(p.$qK.ExtHostChatAgents2,new qt.$Dec(Ge,fi,Se)),zi=Ge.set(p.$qK.ExtHostChatVariables,new Ft.$zec(Ge)),gi=Ge.set(p.$qK.ExtHostChat,new Kt.$sec(Ge,Se)),xt=Ge.set(p.$qK.ExtHostAiRelatedInformation,new Bt.$Aec(Ge)),vi=Ge.set(p.$qK.ExtHostAiEmbeddingVector,new Qt.$Bec(Ge)),en=Ge.set(p.$qK.ExtHostIssueReporter,new zt.$vec(Ge)),Yt=Ge.set(p.$qK.ExtHostStatusBar,new M.$wdc(Ge,mt.converter)),yi=Ge.set(p.$qK.ExtHostSpeech,new Dt.$yec(Ge)),tn=Object.values(p.$qK);Ge.assertRegistered(tn);const nn=new Ee.$eec(Ge,St),rn=new v.$Hcc(Ge),Ei=new $.$odc(Ge,Se),sn=new d.$Qcc(Ge);return k.$Gcc.register(mt),function(je,_t,on){const $t=function(){let we=!je.isUnderDevelopment;function ke(){we||(Se.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")ke();else{const wt=st;typeof wt.scheme>"u"&&ke(),typeof wt.exclusive=="boolean"&&(0,Ue.$lF)(je,"documentFiltersExclusive")}return st}}(),Ui={getSession(we,ke,Ne){return ai.getSession(je,we,ke,Ne)},getSessions(we,ke){return(0,Ue.$lF)(je,"authGetSessions"),ai.getSessions(je,we,ke)},async hasSession(we,ke){return(0,Ue.$lF)(je,"authSession"),!!await ai.getSession(je,we,ke,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(we,ke,Ne,st){return ai.registerAuthenticationProvider(we,ke,Ne,st)}},an={registerCommand(we,ke,Ne){return mt.registerCommand(!0,we,ke,Ne,void 0,je)},registerTextEditorCommand(we,ke,Ne){return mt.registerCommand(!0,we,(...st)=>{const wt=Lt.getActiveTextEditor();if(!wt){Se.warn("Cannot execute "+we+" because there is no active text editor.");return}return wt.edit(Mt=>{ke.apply(Ne,[wt,Mt,...st])}).then(Mt=>{Mt||Se.warn("Edits from command "+we+" were not applied.")},Mt=>{Se.warn("An error occurred while running command "+we,Mt)})},void 0,void 0,je)},registerDiffInformationCommand:(we,ke,Ne)=>((0,Ue.$lF)(je,"diffCommand"),mt.registerCommand(!0,we,async(...st)=>{const wt=St.activeEditor(!0);if(!wt){Se.warn("Cannot execute "+we+" because there is no active text editor.");return}const Mt=await Lt.getDiffInformation(wt.id);ke.apply(Ne,[Mt,...st])},void 0,void 0,je)),executeCommand(we,...ke){return mt.executeCommand(we,...ke)},getCommands(we=!1){return mt.getCommands(we)}},Bi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return dt.onDidChangeShell},get isTelemetryEnabled(){return vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return vt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ue.$lF)(je,"telemetry"),vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ue.$lF)(je,"telemetry"),vt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.$JM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,ke){return tt.$IM.validateSender(we),vt.instantiateLogger(je,we,ke)},openExternal(we,ke){return Ve.openUri(we,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===ft.environment.appUriScheme)return $i.createAppUri(we);try{return await Ve.asExternalUri(we,{allowTunneling:!!ft.remote.authority})}catch(ke){if((0,Xe.$qU)(we,Le.Schemas.http)||(0,Xe.$qU)(we,Le.Schemas.https))return we;throw ke}},get remoteName(){return(0,H.$Wk)(ft.remote.authority)},get remoteAuthority(){return(0,Ue.$lF)(je,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Se.getLevel()},get onDidChangeLogLevel(){return Se.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,Ue.$lF)(je,"handleIssueUri"),en.registerIssueUriRequestHandler(je,we)},registerIssueDataProvider(we){return(0,Ue.$lF)(je,"handleIssueUri"),en.registerIssueDataProvider(je,we)},get appQuality(){return(0,Ue.$lF)(je,"resolvers"),ft.quality},get appCommit(){return(0,Ue.$lF)(je,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Bi);const cn={createTestController(we,ke,Ne){return di.createTestController(je,we,ke,Ne)},createTestObserver(){return(0,Ue.$lF)(je,"testObserver"),di.createTestObserver()},runTests(we){return(0,Ue.$lF)(je,"testObserver"),di.runTests(we)},get onDidChangeTestResults(){return(0,Ue.$lF)(je,"testObserver"),di.onResultsChanged},get testResults(){return(0,Ue.$lF)(je,"testObserver"),di.results}},ki=ft.remote.isRemote?K.ExtensionKind.Workspace:K.ExtensionKind.UI,wn={getExtension(we,ke){(0,Ue.$kF)(je,"extensionsAny")||(ke=!1);const Ne=_t.mine.getExtensionDescription(we);if(Ne)return new n.$jdc(Rt,je.identifier,Ne,ki,!1);if(ke){const st=_t.all.getExtensionDescription(we);if(st)return new n.$jdc(Rt,je.identifier,st,ki,!0)}},get all(){const we=[];for(const ke of _t.mine.getAllExtensionDescriptions())we.push(new n.$jdc(Rt,je.identifier,ke,ki,!1));return we},get allAcrossExtensionHosts(){(0,Ue.$lF)(je,"extensionsAny");const we=new ie.$8l(_t.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),ke=[];for(const Ne of _t.all.getAllExtensionDescriptions()){const st=!we.has(Ne.identifier);ke.push(new n.$jdc(Rt,je.identifier,Ne,ki,st))}return ke},get onDidChange(){return(0,Ue.$kF)(je,"extensionsAny")?f.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},un={createDiagnosticCollection(we){return oi.createDiagnosticCollection(je.identifier,we)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:we=>oi.getDiagnostics(we),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(we,ke){return li.changeLanguage(we.uri,ke)},match(we,ke){const Ne=It.getDocumentData(ke.uri)?.notebook;return(0,L.$xE)(q.LanguageSelector.from(we),ke.uri,ke.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(we,ke,Ne){return lt.registerCodeActionProvider(je,$t(we),ke,Ne)},registerDocumentPasteEditProvider(we,ke,Ne){return(0,Ue.$lF)(je,"documentPaste"),lt.registerDocumentPasteEditProvider(je,$t(we),ke,Ne)},registerCodeLensProvider(we,ke){return lt.registerCodeLensProvider(je,$t(we),ke)},registerDefinitionProvider(we,ke){return lt.registerDefinitionProvider(je,$t(we),ke)},registerDeclarationProvider(we,ke){return lt.registerDeclarationProvider(je,$t(we),ke)},registerImplementationProvider(we,ke){return lt.registerImplementationProvider(je,$t(we),ke)},registerTypeDefinitionProvider(we,ke){return lt.registerTypeDefinitionProvider(je,$t(we),ke)},registerHoverProvider(we,ke){return lt.registerHoverProvider(je,$t(we),ke,je.identifier)},registerEvaluatableExpressionProvider(we,ke){return lt.registerEvaluatableExpressionProvider(je,$t(we),ke,je.identifier)},registerInlineValuesProvider(we,ke){return lt.registerInlineValuesProvider(je,$t(we),ke,je.identifier)},registerDocumentHighlightProvider(we,ke){return lt.registerDocumentHighlightProvider(je,$t(we),ke)},registerLinkedEditingRangeProvider(we,ke){return lt.registerLinkedEditingRangeProvider(je,$t(we),ke)},registerReferenceProvider(we,ke){return lt.registerReferenceProvider(je,$t(we),ke)},registerRenameProvider(we,ke){return lt.registerRenameProvider(je,$t(we),ke)},registerDocumentSymbolProvider(we,ke,Ne){return lt.registerDocumentSymbolProvider(je,$t(we),ke,Ne)},registerWorkspaceSymbolProvider(we){return lt.registerWorkspaceSymbolProvider(je,we)},registerDocumentFormattingEditProvider(we,ke){return lt.registerDocumentFormattingEditProvider(je,$t(we),ke)},registerDocumentRangeFormattingEditProvider(we,ke){return lt.registerDocumentRangeFormattingEditProvider(je,$t(we),ke)},registerOnTypeFormattingEditProvider(we,ke,Ne,...st){return lt.registerOnTypeFormattingEditProvider(je,$t(we),ke,[Ne].concat(st))},registerDocumentSemanticTokensProvider(we,ke,Ne){return lt.registerDocumentSemanticTokensProvider(je,$t(we),ke,Ne)},registerDocumentRangeSemanticTokensProvider(we,ke,Ne){return lt.registerDocumentRangeSemanticTokensProvider(je,$t(we),ke,Ne)},registerSignatureHelpProvider(we,ke,Ne,...st){return typeof Ne=="object"?lt.registerSignatureHelpProvider(je,$t(we),ke,Ne):lt.registerSignatureHelpProvider(je,$t(we),ke,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(we,ke,...Ne){return lt.registerCompletionItemProvider(je,$t(we),ke,Ne)},registerInlineCompletionItemProvider(we,ke,Ne){return ke.handleDidShowCompletionItem&&(0,Ue.$lF)(je,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,Ue.$lF)(je,"inlineCompletionsAdditions"),Ne&&(0,Ue.$lF)(je,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(je,$t(we),ke,Ne)},registerDocumentLinkProvider(we,ke){return lt.registerDocumentLinkProvider(je,$t(we),ke)},registerColorProvider(we,ke){return lt.registerColorProvider(je,$t(we),ke)},registerFoldingRangeProvider(we,ke){return lt.registerFoldingRangeProvider(je,$t(we),ke)},registerSelectionRangeProvider(we,ke){return lt.registerSelectionRangeProvider(je,we,ke)},registerCallHierarchyProvider(we,ke){return lt.registerCallHierarchyProvider(je,we,ke)},registerTypeHierarchyProvider(we,ke){return lt.registerTypeHierarchyProvider(je,we,ke)},setLanguageConfiguration:(we,ke)=>lt.setLanguageConfiguration(je,we,ke),getTokenInformationAtPosition(we,ke){return(0,Ue.$lF)(je,"tokenInformation"),li.tokenAtPosition(we,ke)},registerInlayHintsProvider(we,ke){return lt.registerInlayHintsProvider(je,we,ke)},createLanguageStatusItem(we,ke){return li.createLanguageStatusItem(je,we,ke)},registerDocumentDropEditProvider(we,ke,Ne){return lt.registerDocumentOnDropEditProvider(je,we,ke,(0,Ue.$kF)(je,"dropMetadata")?Ne:void 0)}},ln={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(we,ke,Ne){const st=await(A.URI.isUri(we)?Promise.resolve(Si.openTextDocument(we)):Promise.resolve(we));return Lt.showTextDocument(st,ke,Ne)},createTextEditorDecorationType(we){return Lt.createTextEditorDecorationType(je,we)},onDidChangeActiveTextEditor(we,ke,Ne){return Lt.onDidChangeActiveTextEditor(we,ke,Ne)},onDidChangeVisibleTextEditors(we,ke,Ne){return Lt.onDidChangeVisibleTextEditors(we,ke,Ne)},onDidChangeTextEditorSelection(we,ke,Ne){return Lt.onDidChangeTextEditorSelection(we,ke,Ne)},onDidChangeTextEditorOptions(we,ke,Ne){return Lt.onDidChangeTextEditorOptions(we,ke,Ne)},onDidChangeTextEditorVisibleRanges(we,ke,Ne){return Lt.onDidChangeTextEditorVisibleRanges(we,ke,Ne)},onDidChangeTextEditorViewColumn(we,ke,Ne){return Lt.onDidChangeTextEditorViewColumn(we,ke,Ne)},onDidCloseTerminal(we,ke,Ne){return dt.onDidCloseTerminal(we,ke,Ne)},onDidOpenTerminal(we,ke,Ne){return dt.onDidOpenTerminal(we,ke,Ne)},onDidChangeActiveTerminal(we,ke,Ne){return dt.onDidChangeActiveTerminal(we,ke,Ne)},onDidChangeTerminalDimensions(we,ke,Ne){return(0,Ue.$lF)(je,"terminalDimensions"),dt.onDidChangeTerminalDimensions(we,ke,Ne)},onDidChangeTerminalState(we,ke,Ne){return dt.onDidChangeTerminalState(we,ke,Ne)},onDidWriteTerminalData(we,ke,Ne){return(0,Ue.$lF)(je,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(we,ke,Ne)},onDidExecuteTerminalCommand(we,ke,Ne){return(0,Ue.$lF)(je,"terminalExecuteCommandEvent"),dt.onDidExecuteTerminalCommand(we,ke,Ne)},get state(){return Ve.getState(je)},onDidChangeWindowState(we,ke,Ne){return Ve.onDidChangeWindowState(we,ke,Ne)},showInformationMessage(we,...ke){return Ei.showMessage(je,R.default.Info,we,ke[0],ke.slice(1))},showWarningMessage(we,...ke){return Ei.showMessage(je,R.default.Warning,we,ke[0],ke.slice(1))},showErrorMessage(we,...ke){return Ei.showMessage(je,R.default.Error,we,ke[0],ke.slice(1))},showQuickPick(we,ke,Ne){return ii.showQuickPick(je,we,ke,Ne)},showWorkspaceFolderPick(we){return ii.showWorkspaceFolderPick(we)},showInputBox(we,ke){return ii.showInput(we,ke)},showOpenDialog(we){return sn.showOpenDialog(je,we)},showSaveDialog(we){return sn.showSaveDialog(we)},createStatusBarItem(we,ke,Ne){let st,wt,Mt;return typeof we=="string"?(st=we,wt=ke,Mt=Ne):(wt=we,Mt=ke),Yt.createStatusBarEntry(je,st,wt,Mt)},setStatusBarMessage(we,ke){return Yt.setStatusBarMessage(we,ke)},withScmProgress(we){return Fe.report("window.withScmProgress",je,"Use 'withProgress' instead."),Fi.withProgress(je,{location:K.ProgressLocation.SourceControl},(ke,Ne)=>we({report(st){}}))},withProgress(we,ke){return Fi.withProgress(je,we,ke)},createOutputChannel(we,ke){return Di.createOutputChannel(we,ke,je)},createWebviewPanel(we,ke,Ne,st){return hi.createWebviewPanel(je,we,ke,Ne,st)},createWebviewTextEditorInset(we,ke,Ne,st){return(0,Ue.$lF)(je,"editorInsets"),Pi.createWebviewEditorInset(we,ke,Ne,st,je)},createTerminal(we,ke,Ne){return typeof we=="object"?"pty"in we?dt.createExtensionTerminal(we):dt.createTerminalFromOptions(we):dt.createTerminal(we,ke,Ne)},registerTerminalLinkProvider(we){return dt.registerLinkProvider(we)},registerTerminalProfileProvider(we,ke){return dt.registerProfileProvider(je,we,ke)},registerTerminalQuickFixProvider(we,ke){return(0,Ue.$lF)(je,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(we,je.identifier.value,ke)},registerTreeDataProvider(we,ke){return pi.registerTreeDataProvider(we,ke,je)},createTreeView(we,ke){return pi.createTreeView(we,ke,je)},registerWebviewPanelSerializer:(we,ke)=>hi.registerWebviewPanelSerializer(je,we,ke),registerCustomEditorProvider:(we,ke,Ne={})=>Ni.registerCustomEditorProvider(je,we,ke,Ne),registerFileDecorationProvider(we){return kt.registerFileDecorationProvider(we,je)},registerUriHandler(we){return $i.registerUriHandler(je,we)},createQuickPick(){return ii.createQuickPick(je)},createInputBox(){return ii.createInputBox(je)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(we,ke,Ne){return Oi.onDidChangeActiveColorTheme(we,ke,Ne)},registerWebviewViewProvider(we,ke,Ne){return $n.registerWebviewViewProvider(je,we,ke,Ne?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,ke,Ne){return yt.onDidChangeActiveNotebookEditor(we,ke,Ne)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,ke,Ne){return wi.onDidChangeNotebookEditorSelection(we,ke,Ne)},onDidChangeNotebookEditorVisibleRanges(we,ke,Ne){return wi.onDidChangeNotebookEditorVisibleRanges(we,ke,Ne)},showNotebookDocument(we,ke){return yt.showNotebookDocument(we,ke)},registerExternalUriOpener(we,ke,Ne){return(0,Ue.$lF)(je,"externalUriOpener"),Zi.registerExternalUriOpener(je.identifier,we,ke,Ne)},registerProfileContentHandler(we,ke){return(0,Ue.$lF)(je,"profileContentHandlers"),ji.registrProfileContentHandler(je,we,ke)},registerQuickDiffProvider(we,ke,Ne,st){return(0,Ue.$lF)(je,"quickDiffProvider"),Li.registerQuickDiffProvider($t(we),ke,Ne,st)},get tabGroups(){return Qe.tabGroups},registerShareProvider(we,ke){return(0,Ue.$lF)(je,"shareProvider"),Mi.registerShareProvider($t(we),ke)}},Si={get rootPath(){return Fe.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(we){throw new O.$9("rootPath")},getWorkspaceFolder(we){return at.getWorkspaceFolder(we)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(we){throw new O.$9("name")},get workspaceFile(){return at.workspaceFile},set workspaceFile(we){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(we,ke,...Ne)=>at.updateWorkspaceFolders(je,we,ke||0,...Ne),onDidChangeWorkspaceFolders:function(we,ke,Ne){return at.onDidChangeWorkspace(we,ke,Ne)},asRelativePath:(we,ke)=>at.getRelativePath(we,ke),findFiles:(we,ke,Ne,st)=>at.findFiles(we,ke,Ne,je.identifier,st),findTextInFiles:(we,ke,Ne,st)=>{(0,Ue.$lF)(je,"findTextInFiles");let wt,Mt;return typeof ke=="object"?(wt=ke,Mt=Ne):(wt={},Mt=ke,st=Ne),at.findTextInFiles(we,wt||{},Mt,je.identifier,st)},save:we=>((0,Ue.$lF)(je,"saveEditor"),at.save(we)),saveAs:we=>((0,Ue.$lF)(je,"saveEditor"),at.saveAs(we)),saveAll:we=>at.saveAll(we),applyEdit(we,ke){return nn.applyWorkspaceEdit(we,je,ke)},createFileSystemWatcher:(we,ke,Ne,st)=>{let wt;return typeof ke=="boolean"?wt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!st,correlate:!1}:ke&&((0,Ue.$lF)(je,"createFileSystemWatcher"),wt={...ke,correlate:!0}),Zt.createFileSystemWatcher(at,je,we,wt)},get textDocuments(){return It.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new O.$9("textDocuments")},openTextDocument(we){let ke;const Ne=we;if(typeof we=="string")ke=Promise.resolve(A.URI.file(we));else if(A.URI.isUri(we))ke=Promise.resolve(we);else if(!Ne||typeof Ne=="object")ke=It.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>It.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(we,ke,Ne)=>It.onDidAddDocument(we,ke,Ne),onDidCloseTextDocument:(we,ke,Ne)=>It.onDidRemoveDocument(we,ke,Ne),onDidChangeTextDocument:(we,ke,Ne)=>It.onDidChangeDocument(we,ke,Ne),onDidSaveTextDocument:(we,ke,Ne)=>It.onDidSaveDocument(we,ke,Ne),onWillSaveTextDocument:(we,ke,Ne)=>ri.getOnWillSaveTextDocumentEvent(je)(we,ke,Ne),get notebookDocuments(){return yt.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,ke){let Ne;if(A.URI.isUri(we))Ne=we,await yt.openNotebookDocument(we);else if(typeof we=="string")Ne=A.URI.revive(await yt.createNotebookDocument({viewType:we,content:ke}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(we,ke,Ne){return bi.onDidSaveNotebookDocument(we,ke,Ne)},onDidChangeNotebookDocument(we,ke,Ne){return bi.onDidChangeNotebookDocument(we,ke,Ne)},onWillSaveNotebookDocument(we,ke,Ne){return Ii.getOnWillSaveNotebookDocumentEvent(je)(we,ke,Ne)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(we,ke,Ne,st){return yt.registerNotebookSerializer(je,we,ke,Ne,(0,Ue.$kF)(je,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(we,ke,Ne)=>on.onDidChangeConfiguration(we,ke,Ne),getConfiguration(we,ke){return ke=arguments.length===1?void 0:ke,on.getConfiguration(we,ke,je)},registerTextDocumentContentProvider(we,ke){return gn.registerTextDocumentContentProvider(we,ke)},registerTaskProvider:(we,ke)=>(Fe.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(je,we,ke)),registerFileSystemProvider(we,ke,Ne){return(0,Ke.$Pc)(Ai.registerFileSystemProvider(je,we,ke,Ne),Vt.addFileSystemProvider(we,ke,Ne))},get fs(){return Vt.value},registerFileSearchProvider:(we,ke)=>((0,Ue.$lF)(je,"fileSearchProvider"),mi.registerFileSearchProvider(we,ke)),registerTextSearchProvider:(we,ke)=>((0,Ue.$lF)(je,"textSearchProvider"),mi.registerTextSearchProvider(we,ke)),registerRemoteAuthorityResolver:(we,ke)=>((0,Ue.$lF)(je,"resolvers"),Rt.registerRemoteAuthorityResolver(we,ke)),registerResourceLabelFormatter:we=>((0,Ue.$lF)(je,"resolvers"),Xi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,Ue.$lF)(je,"resolvers"),Rt.getRemoteExecServer(we)),onDidCreateFiles:(we,ke,Ne)=>Zt.onDidCreateFile(we,ke,Ne),onDidDeleteFiles:(we,ke,Ne)=>Zt.onDidDeleteFile(we,ke,Ne),onDidRenameFiles:(we,ke,Ne)=>Zt.onDidRenameFile(we,ke,Ne),onWillCreateFiles:(we,ke,Ne)=>Zt.getOnWillCreateFileEvent(je)(we,ke,Ne),onWillDeleteFiles:(we,ke,Ne)=>Zt.getOnWillDeleteFileEvent(je)(we,ke,Ne),onWillRenameFiles:(we,ke,Ne)=>Zt.getOnWillRenameFileEvent(je)(we,ke,Ne),openTunnel:we=>((0,Ue.$lF)(je,"tunnels"),ne.openTunnel(je,we).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,Ue.$lF)(je,"tunnels"),ne.getTunnels()},onDidChangeTunnels:(we,ke,Ne)=>((0,Ue.$lF)(je,"tunnels"),ne.onDidChangeTunnels(we,ke,Ne)),registerPortAttributesProvider:(we,ke)=>((0,Ue.$lF)(je,"portsAttributes"),ne.registerPortsAttributesProvider(we,ke)),registerTunnelProvider:(we,ke)=>((0,Ue.$lF)(je,"tunnelFactory"),ne.registerTunnelProvider(we,ke)),registerTimelineProvider:(we,ke)=>((0,Ue.$lF)(je,"timeline"),mn.registerTimelineProvider(we,ke,je.identifier,mt.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:we=>((0,Ue.$lF)(je,"workspaceTrust"),at.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,ke,Ne)=>at.onDidGrantWorkspaceTrust(we,ke,Ne),registerEditSessionIdentityProvider:(we,ke)=>((0,Ue.$lF)(je,"editSessionIdentityProvider"),at.registerEditSessionIdentityProvider(we,ke)),onWillCreateEditSessionIdentity:(we,ke,Ne)=>((0,Ue.$lF)(je,"editSessionIdentityProvider"),at.getOnWillCreateEditSessionIdentityEvent(je)(we,ke,Ne)),registerCanonicalUriProvider:(we,ke)=>((0,Ue.$lF)(je,"canonicalUriProvider"),at.registerCanonicalUriProvider(we,ke)),getCanonicalUri:(we,ke,Ne)=>((0,Ue.$lF)(je,"canonicalUriProvider"),at.provideCanonicalUri(we,ke,Ne))},Wi={get inputBox(){return Fe.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(je)},createSourceControl(we,ke,Ne){return Ri.createSourceControl(je,we,ke,Ne)}},qi={createCommentController(we,ke){return Yi.createCommentController(je,we,ke)}},ci={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(we,ke,Ne){return gt.onDidStartDebugSession(we,ke,Ne)},onDidTerminateDebugSession(we,ke,Ne){return gt.onDidTerminateDebugSession(we,ke,Ne)},onDidChangeActiveDebugSession(we,ke,Ne){return gt.onDidChangeActiveDebugSession(we,ke,Ne)},onDidReceiveDebugSessionCustomEvent(we,ke,Ne){return gt.onDidReceiveDebugSessionCustomEvent(we,ke,Ne)},onDidChangeBreakpoints(we,ke,Ne){return gt.onDidChangeBreakpoints(we,ke,Ne)},onDidChangeStackFrameFocus(we,ke,Ne){return(0,Ue.$lF)(je,"debugFocus"),gt.onDidChangeStackFrameFocus(we,ke,Ne)},registerDebugConfigurationProvider(we,ke,Ne){return gt.registerDebugConfigurationProvider(we,ke,Ne||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,ke){return gt.registerDebugAdapterDescriptorFactory(je,we,ke)},registerDebugAdapterTrackerFactory(we,ke){return gt.registerDebugAdapterTrackerFactory(we,ke)},startDebugging(we,ke,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?gt.startDebugging(we,ke,{parentSession:Ne}):gt.startDebugging(we,ke,Ne||{})},stopDebugging(we){return gt.stopDebugging(we)},addBreakpoints(we){return gt.addBreakpoints(we)},removeBreakpoints(we){return gt.removeBreakpoints(we)},asDebugSourceUri(we,ke){return gt.asDebugSourceUri(we,ke)}},Vi={registerTaskProvider:(we,ke)=>Ct.registerTaskProvider(je,we,ke),fetchTasks:we=>Ct.fetchTasks(we),executeTask:we=>Ct.executeTask(je,we),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(we,ke,Ne)=>Ct.onDidStartTask(we,ke,Ne),onDidEndTask:(we,ke,Ne)=>Ct.onDidEndTask(we,ke,Ne),onDidStartTaskProcess:(we,ke,Ne)=>Ct.onDidStartTaskProcess(we,ke,Ne),onDidEndTaskProcess:(we,ke,Ne)=>Ct.onDidEndTaskProcess(we,ke,Ne)},Ki={createNotebookController(we,ke,Ne,st,wt){return si.createNotebookController(je,we,ke,Ne,st,(0,Ue.$kF)(je,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(we,ke)=>yt.registerNotebookCellStatusBarItemProvider(je,we,ke),createRendererMessaging(we){return Ci.createRendererMessaging(je,we)},createNotebookControllerDetectionTask(we){return(0,Ue.$lF)(je,"notebookKernelSource"),si.createNotebookControllerDetectionTask(je,we)},registerKernelSourceActionProvider(we,ke){return(0,Ue.$lF)(je,"notebookKernelSource"),si.registerKernelSourceActionProvider(je,we,ke)},onDidChangeNotebookCellExecutionState(we,ke,Ne){return(0,Ue.$lF)(je,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(we,ke,Ne)}},Hi={t(...we){if(typeof we[0]=="string"){const ke=we.shift(),Ne=!we||typeof we[0]!="object"?we:we[0];return ui.getMessage(je.identifier.value,{message:ke,args:Ne})}return ui.getMessage(je.identifier.value,we[0])},get bundle(){return ui.getBundle(je.identifier.value)},get uri(){return ui.getBundleUri(je.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(we,ke){return(0,Ue.$lF)(je,"interactive"),xi.registerProvider(je,we,ke={label:ke?.label??je.displayName??je.name})},registerInteractiveSessionProvider(we,ke){return(0,Ue.$lF)(je,"interactive"),gi.registerChatProvider(je,we,ke)},sendInteractiveRequestToProvider(we,ke){return(0,Ue.$lF)(je,"interactive"),gi.sendInteractiveRequestToProvider(we,ke)},get onDidPerformUserAction(){return(0,Ue.$lF)(je,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(we,ke){return(0,Ue.$lF)(je,"interactive"),gi.transferChatSession(we,ke)}},hn={getRelatedInformation(we,ke){return(0,Ue.$lF)(je,"aiRelatedInformation"),xt.getRelatedInformation(je,we,ke)},registerRelatedInformationProvider(we,ke){return(0,Ue.$lF)(je,"aiRelatedInformation"),xt.registerRelatedInformationProvider(je,we,ke)},registerEmbeddingVectorProvider(we,ke){return(0,Ue.$lF)(je,"aiRelatedInformation"),vi.registerEmbeddingVectorProvider(je,we,ke)}},dn={registerChatResponseProvider(we,ke,Ne){return(0,Ue.$lF)(je,"chatProvider"),fi.registerProvider(je.identifier,we,ke,Ne)},requestChatAccess(we){return(0,Ue.$lF)(je,"chatRequestAccess"),fi.requestChatResponseProvider(je.identifier,we)},registerVariable(we,ke,Ne){return(0,Ue.$lF)(je,"chatVariables"),zi.registerVariableResolver(je,we,ke,Ne)},registerMappedEditsProvider(we,ke){return(0,Ue.$lF)(je,"mappedEditsProvider"),lt.registerMappedEditsProvider(je,we,ke)},createChatAgent(we,ke){return(0,Ue.$lF)(je,"chatAgents2"),bn.createChatAgent(je,we,ke)},registerAgent(we,ke,Ne){return(0,Ue.$lF)(je,"chatAgents"),_i.registerAgent(je.identifier,we,ke,Ne)}},fn={registerSpeechProvider(we,ke){return(0,Ue.$lF)(je,"speech"),yi.registerProvider(je.identifier,we,ke)}};return{version:ft.version,ai:hn,authentication:Ui,commands:an,comments:qi,chat:dn,debug:ci,env:Bi,extensions:wn,interactive:Gi,l10n:Hi,languages:un,notebooks:Ki,scm:Wi,speech:fn,tasks:Vi,tests:cn,window:ln,workspace:Si,Breakpoint:K.$pL,TerminalOutputAnchor:K.TerminalOutputAnchor,ChatAgentResultFeedbackKind:K.ChatAgentResultFeedbackKind,ChatMessage:K.$fM,ChatMessageRole:K.ChatMessageRole,ChatVariableLevel:K.ChatVariableLevel,CallHierarchyIncomingCall:K.$OK,CallHierarchyItem:K.$NK,CallHierarchyOutgoingCall:K.$PK,CancellationError:O.$5,CancellationTokenSource:C.$Yd,CandidatePortSource:p.CandidatePortSource,CodeAction:K.$KK,CodeActionKind:K.$LK,CodeActionTriggerKind:K.CodeActionTriggerKind,CodeLens:K.$QK,Color:K.$4K,ColorInformation:K.$5K,ColorPresentation:K.$6K,ColorThemeKind:K.ColorThemeKind,CommentMode:K.CommentMode,CommentState:K.CommentState,CommentThreadCollapsibleState:K.CommentThreadCollapsibleState,CommentThreadState:K.CommentThreadState,CompletionItem:K.$XK,CompletionItemKind:K.CompletionItemKind,CompletionItemTag:K.CompletionItemTag,CompletionList:K.$YK,CompletionTriggerKind:K.CompletionTriggerKind,ConfigurationTarget:K.ConfigurationTarget,CustomExecution:K.$bL,DebugAdapterExecutable:K.$tL,DebugAdapterInlineImplementation:K.$wL,DebugAdapterNamedPipeServer:K.$vL,DebugAdapterServer:K.$uL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:K.DebugConsoleMode,DecorationRangeBehavior:K.DecorationRangeBehavior,Diagnostic:K.$FK,DiagnosticRelatedInformation:K.$EK,DiagnosticSeverity:K.DiagnosticSeverity,DiagnosticTag:K.DiagnosticTag,Disposable:K.$rK,DocumentHighlight:K.$HK,DocumentHighlightKind:K.DocumentHighlightKind,DocumentLink:K.$3K,DocumentSymbol:K.$JK,EndOfLine:K.EndOfLine,EnvironmentVariableMutatorType:K.EnvironmentVariableMutatorType,EvaluatableExpression:K.$zL,InlineValueText:K.$AL,InlineValueVariableLookup:K.$BL,InlineValueEvaluatableExpression:K.$CL,InlineCompletionTriggerKind:K.InlineCompletionTriggerKind,EventEmitter:f.$Od,ExtensionKind:K.ExtensionKind,ExtensionMode:K.ExtensionMode,ExternalUriOpenerPriority:K.ExternalUriOpenerPriority,FileChangeType:K.FileChangeType,FileDecoration:K.$ML,FileDecoration2:K.$ML,FileSystemError:K.$EL,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:K.$FL,FoldingRangeKind:K.FoldingRangeKind,FunctionBreakpoint:K.$rL,InlineCompletionItem:K.$ZK,InlineCompletionList:K.$1K,Hover:K.$GK,IndentAction:b.IndentAction,Location:K.$DK,MarkdownString:K.$RK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:K.$SK,PortAutoForwardAction:K.PortAutoForwardAction,Position:K.$sK,ProcessExecution:K.$_K,ProgressLocation:K.ProgressLocation,QuickInputButtons:K.$LL,Range:K.$tK,RelativePattern:K.$nL,Selection:K.$uK,SelectionRange:K.$MK,SemanticTokens:K.$IL,SemanticTokensBuilder:K.$HL,SemanticTokensEdit:K.$JL,SemanticTokensEdits:K.$KL,SemanticTokensLegend:K.$GL,ShellExecution:K.$aL,ShellQuoting:K.ShellQuoting,SignatureHelp:K.$UK,SignatureHelpTriggerKind:K.SignatureHelpTriggerKind,SignatureInformation:K.$TK,SnippetString:K.$CK,SourceBreakpoint:K.$qL,StandardTokenType:K.StandardTokenType,StatusBarAlignment:K.StatusBarAlignment,SymbolInformation:K.$IK,SymbolKind:K.SymbolKind,SymbolTag:K.SymbolTag,Task:K.$cL,TaskGroup:K.$$K,TaskPanelKind:K.TaskPanelKind,TaskRevealKind:K.TaskRevealKind,TaskScope:K.TaskScope,TerminalLink:K.$7K,TerminalQuickFixExecuteTerminalCommand:K.$9K,TerminalQuickFixOpener:K.$8K,TerminalLocation:K.TerminalLocation,TerminalProfile:K.$0K,TerminalExitReason:K.TerminalExitReason,TextDocumentSaveReason:K.TextDocumentSaveReason,TextEdit:K.$yK,SnippetTextEdit:K.$AK,TextEditorCursorStyle:m.TextEditorCursorStyle,TextEditorLineNumbersStyle:K.TextEditorLineNumbersStyle,TextEditorRevealType:K.TextEditorRevealType,TextEditorSelectionChangeKind:K.TextEditorSelectionChangeKind,SyntaxTokenType:K.SyntaxTokenType,TextDocumentChangeReason:K.TextDocumentChangeReason,ThemeColor:K.$mL,ThemeIcon:K.$lL,TreeItem:K.$dL,TreeItemCheckboxState:K.TreeItemCheckboxState,TreeItemCollapsibleState:K.TreeItemCollapsibleState,TypeHierarchyItem:K.$8L,UIKind:y.UIKind,Uri:A.URI,ViewColumn:K.ViewColumn,WorkspaceEdit:K.$BK,DocumentDropEdit:K.$jL,DocumentPasteEdit:K.$kL,InlayHint:K.$WK,InlayHintLabelPart:K.$VK,InlayHintKind:K.InlayHintKind,RemoteAuthorityResolverError:K.$xK,ResolvedAuthority:K.$vK,ManagedResolvedAuthority:K.$wK,SourceControlInputBoxValidationType:K.SourceControlInputBoxValidationType,ExtensionRuntime:K.ExtensionRuntime,TimelineItem:K.$WL,NotebookRange:K.$OL,NotebookCellKind:K.NotebookCellKind,NotebookCellExecutionState:K.NotebookCellExecutionState,NotebookCellData:K.$PL,NotebookData:K.$QL,NotebookRendererScript:K.$UL,NotebookCellStatusBarAlignment:K.NotebookCellStatusBarAlignment,NotebookEditorRevealType:K.NotebookEditorRevealType,NotebookCellOutput:K.$SL,NotebookCellOutputItem:K.$RL,NotebookCellStatusBarItem:K.$TL,NotebookControllerAffinity:K.NotebookControllerAffinity,NotebookControllerAffinity2:K.NotebookControllerAffinity2,NotebookEdit:K.$zK,NotebookKernelSourceAction:K.$VL,PortAttributes:K.$YL,LinkedEditingRanges:K.$XL,TestResultState:K.TestResultState,TestRunRequest:K.$ZL,TestMessage:K.$1L,TestMessage2:K.$1L,TestTag:K.$2L,TestRunProfileKind:K.TestRunProfileKind,TextSearchCompleteMessageType:Te.TextSearchCompleteMessageType,DataTransfer:K.$iL,DataTransferItem:K.$eL,CoveredCount:K.$3L,FileCoverage:K.$4L,StatementCoverage:K.$5L,BranchCoverage:K.$6L,FunctionCoverage:K.$7L,WorkspaceTrustState:K.WorkspaceTrustState,LanguageStatusSeverity:K.LanguageStatusSeverity,QuickPickItemKind:K.QuickPickItemKind,InputBoxValidationSeverity:K.InputBoxValidationSeverity,TabInputText:K.$9L,TabInputTextDiff:K.$0L,TabInputTextMerge:K.$$L,TabInputCustom:K.$_L,TabInputNotebook:K.$bM,TabInputNotebookDiff:K.$cM,TabInputWebview:K.$aM,TabInputTerminal:K.$dM,TabInputInteractiveWindow:K.$eM,TelemetryTrustedValue:me.$no,LogLevel:_.LogLevel,EditSessionIdentityMatch:ct.EditSessionIdentityMatch,InteractiveSessionVoteDirection:K.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:K.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:K.InteractiveEditorResponseFeedbackKind,StackFrameFocus:K.$xL,ThreadFocus:K.$yL,RelatedInformationType:K.RelatedInformationType,SpeechToTextStatus:K.SpeechToTextStatus}}}e.$Eec=Nt}),define(De[359],Ce([1,0,103,152,39,149,40,34,70,45,93,94,95,115,73,89,151,72,55,114,88,71,150,14,56,112,113]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d,a,t,i,s,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Ar)(n.$ddc,n.$cdc,1),(0,C.$Ar)(i.$_i,t.$Fec,1),(0,C.$Ar)(v.$Ccc,v.$Dcc,1),(0,C.$Ar)(m.$MM,m.$LM,0),(0,C.$Ar)(A.$Pcc,A.$Ncc,0),(0,C.$Ar)(o.$5cc,o.$4cc,0),(0,C.$Ar)(P.$Sdc,P.$Wdc,0),(0,C.$Ar)(R.$Kdc,R.$Jdc,0),(0,C.$Ar)(E.$BM,E.$AM,0),(0,C.$Ar)(r.$edc,r.$fdc,0),(0,C.$Ar)(l.$zcc,l.$ycc,0),(0,C.$Ar)(O.$qdc,O.$pdc,1),(0,C.$Ar)(p.$3dc,p.$4dc,0),(0,C.$Ar)(y.$1cc,y.$Zcc,0),(0,C.$Ar)(L.$Ndc,L.$Mdc,0),(0,C.$Ar)(b.$8cc,b.$$cc,0),(0,C.$Ar)(k.$nwb,k.$owb,0),(0,C.$Ar)(h.$Gdc,h.$Fdc,0),(0,C.$Ar)(f.$Mcc,f.$Lcc,0),(0,C.$Ar)(c.$adc,c.$_cc,0),(0,C.$Ar)(d.$KM,d.$HM,0),(0,C.$Ar)(a.$Odc,a.$Pdc,0),(0,C.$Ar)(s.$Qdc,s.$Rdc,0)}),define(De[116],Ce([1,0,19,14,37,92]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=e.$Wec=e.$Vec=void 0;function A(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.$Vec=A;function m(P,p,y,k){const v=(0,C.$2b)(y,E),h=new f.$VI(p,v,k),o=h.preview.matches;return{ranges:(0,C.$2b)(v,b),uri:P,preview:{text:h.preview.text,matches:(0,C.$2b)(o,b)}}}e.$Wec=m;function E(P){return new f.$WI(P.start.line,P.start.character,P.end.line,P.end.character)}function b(P){return new R.$KI(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let L=class{constructor(p,y){this.a=p,this.b=y}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$Xec=L,e.$Xec=L=He([Be(1,O.$$i)],L)}),define(De[360],Ce([1,0,49,16,77,33,12,15,116,361]),function($e,e,C,O,f,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=e.$Zec=e.$Yec=void 0;const L=b.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(c,d,a,t){const i=p(c,d,a,t),s=d.folder.fsPath;return{cmd:C.spawn(L,i.args,{cwd:s}),rgDiskPath:L,siblingClauses:i.siblingClauses,rgArgs:i,cwd:s}}e.$Yec=P;function p(c,d,a,t){const i=["--files","--hidden","--case-sensitive","--no-require-git"];k([d],a,!1).forEach(n=>{const r=(0,E.$Vec)(n);if(i.push("-g",r),A.$k){const u=(0,f.$ql)(r);u!==r&&i.push("-g",u)}});const s=y([d],t,void 0,!1);return s.globArgs.forEach(n=>{const r=`!${(0,E.$Vec)(n)}`;if(i.push("-g",r),A.$k){const u=(0,f.$ql)(r);u!==r&&i.push("-g",u)}}),d.disregardIgnoreFiles!==!1?i.push("--no-ignore"):d.disregardParentIgnoreFiles!==!1&&i.push("--no-ignore-parent"),d.ignoreSymlinks||i.push("--follow"),c.exists&&i.push("--quiet"),i.push("--no-config"),d.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:s.siblingClauses}}function y(c,d,a,t=!0){const i=[];let s={};return c.forEach(n=>{const r=Object.assign({},n.excludePattern||{},d||{}),u=v(r,t?n.folder.fsPath:void 0,a);i.push(...u.globArgs),u.siblingClauses&&(s=Object.assign(s,u.siblingClauses))}),{globArgs:i,siblingClauses:s}}function k(c,d,a=!0){const t=[];return c.forEach(i=>{const s=Object.assign({},d||{},i.includePattern||{}),n=v(s,a?i.folder.fsPath:void 0);t.push(...n.globArgs)}),t}function v(c,d,a){const t=[],i={};return Object.keys(c).forEach(s=>{if(a&&a.has(s)||!s)return;const n=c[s];s=o(d?h(d,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),t.push(l(s))):n&&n.when&&(i[s]=n)}),{globArgs:t,siblingClauses:i}}function h(c,d){return O.$ic(d)?d:O.$jc(c,d)}e.$Zec=h;function o(c){return c=m.$Le(c,"\\"),m.$Le(c,"/")}function l(c){return R.$Uf(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.$1ec=l}),define(De[362],Ce([1,0,49,53,16,363,19,41,36,77,33,12,35,15,17,29,37,360,127]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=void 0;const c=new Set;process.on("exit",()=>{c.forEach(s=>s())});class d{constructor(n){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=n,this.b=n.filePattern||"",this.d=n.includePattern&&E.$xj(n.includePattern),this.f=n.maxResults||null,this.g=!!n.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,l.$Cq)(this.b).normalizedLowercase),this.u=n.excludePattern&&E.$xj(n.excludePattern),this.t=new Map,n.folderQueries.forEach(r=>{const u=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),I=r.folder.fsPath;n.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==I).forEach(S=>{(0,L.$Yf)(S,I)&&(u[f.$lc(I,S)]=!0)}),this.t.set(I,new t(u,I))})}cancel(){this.l=!0,c.forEach(n=>n())}walk(n,r,u,I,S){if(this.m=p.$Kd.create(!1),this.l)return S(null,this.j);r.forEach($=>{const g=f.$nc($.fsPath);this.u&&this.u($.fsPath,g)||this.J(u,{relativePath:$.fsPath,searchPath:void 0})}),this.r=p.$Kd.create(!1),this.w(n,($,g)=>{this.x(this.y,this,$,u,I,w=>{if(w){const D=(0,m.$Bi)(w);console.error(D),this.q.push(D),g(w,void 0)}else g(null,void 0)})},($,g)=>{this.m.stop();const w=$?A.$Hb($)[0]:null;S(w,this.j)})}w(n,r,u){const I=new Array(n.length),S=new Array(n.length);let $=!1,g=0;if(n.length===0)return u(null,[]);n.forEach((w,D)=>{r(w,(T,M)=>{if(T?($=!0,I[D]=null,S[D]=T):(I[D]=M,S[D]=null),++g===n.length)return u($?S:null,I)})})}x(n,r,...u){try{n.apply(r,u)}catch(I){u[u.length-1](I)}}y(n,r,u,I){const S=n.folder.fsPath,$=P.$k,g=()=>F&&F.kill();c.add(g);let w=q=>{c.delete(g),w=()=>{},I(q)},D="";const T=this.D(),M=(0,o.$Yec)(this.a,n,this.a.includePattern,this.t.get(n.folder.fsPath).expression),F=M.cmd,z=!Object.keys(M.siblingClauses).length,j=M.rgArgs.args.map(q=>q.match(/^-/)?q:`'${q}'`).join(" ");let N=`${M.rgDiskPath} ${j}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(N+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),u({message:N}),this.s=0,this.z(F,"utf8",u,(q,K,me)=>{if(q){w(q);return}if(this.j){w();return}const G=(D+($?b.$pl(K||""):K)).split(`
`);if(me){const J=G.length;G[J-1]=G[J-1].trim(),G[J-1]||G.pop()}else D=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=G.length,z){for(const J of G)if(this.J(r,{base:S,relativePath:J,searchPath:this.N(n,J)}),this.j){g();break}(me||this.j)&&w();return}this.G(n,T,S,G,r),me&&(this.H(T,S,r),w())})}spawnFindCmd(n){const r=this.t.get(n.folder.fsPath),u=r.getBasenameTerms(),I=r.getPathTerms(),S=["-L","."];if(u.length||I.length){S.push("-not","(","(");for(const $ of u)S.push("-name",$),S.push("-o");for(const $ of I)S.push("-path",$),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),C.spawn("find",S,{cwd:n.folder.fsPath})}readStdout(n,r,u){let I="";this.z(n,r,()=>{},(S,$,g)=>{if(S){u(S);return}I+=$,g&&u(null,I)})}z(n,r,u,I){let S=(w,D,T)=>{(w||T)&&(S=()=>{},this.r?.stop()),I(w,D,T)},$=!1;n.stdout?(this.A(n.stdout,r,S),n.stdout.once("data",()=>$=!0)):u({message:"stdout is null"});let g;n.stderr?g=this.B(n.stderr):u({message:"stderr is null"}),n.on("error",w=>{S(w)}),n.on("close",w=>{let D;!$&&(D=this.C(g,r))&&i(D)?S(new Error(`command failed with error code ${w}: ${this.C(g,r)}`)):(this.g&&w===0&&(this.j=!0),S(null,"",!0))})}A(n,r,u){const I=new R.StringDecoder(r);return n.on("data",S=>{u(null,I.write(S))}),I}B(n){const r=[];return n.on("data",u=>{r.push(u)}),r}C(n,r){const u=new R.StringDecoder(r);return n.map(I=>u.write(I)).join("")}D(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}G(n,{pathToEntries:r},u,I,S){I.indexOf(this.b)!==-1&&this.J(S,{base:u,relativePath:this.b,searchPath:this.N(n,this.b)});const $=g=>{const w=f.$nc(g),D=f.$mc(g);let T=r[D];T||(T=r[D]=[],$(D)),T.push({base:u,relativePath:g,basename:w,searchPath:this.N(n,g)})};I.forEach($)}H({rootEntries:n,pathToEntries:r},u,I){const S=this,$=this.t.get(u),g=this.b;function w(D){S.o++;const T=(0,h.$_I)(()=>D.map(M=>M.basename));for(let M=0,F=D.length;M<F;M++){const z=D[M],{relativePath:j,basename:N}=z;if($.test(j,N,g!==N?T:void 0))continue;const q=r[j];if(q)w(q);else{if(S.p++,j===g)continue;S.J(I,z)}if(S.j)break}}w(n)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(n,r,u,I,S){const $=n.folder,g=(0,h.$_I)(()=>u);this.w(u,(w,D)=>{if(this.l||this.j)return D(null);const T=r?[r,w].join(f.sep):w;if(this.t.get(n.folder.fsPath).test(T,w,this.a.filePattern!==w?g:void 0))return D(null);const M=[$.fsPath,T].join(f.sep);O.lstat(M,(F,z)=>{if(F||this.l||this.j)return D(null);this.L(M,z,(j,N)=>j||this.l||this.j?D(null):N.isDirectory()?(this.o++,this.M(M,z,(q,K)=>q||this.l||this.j||(K=K||"",this.v[K])?D(null):(this.v[K]=!0,v.Promises.readdir(M).then(me=>{if(this.l||this.j)return D(null);this.I(n,T,me,I,te=>D(te||null))},me=>{D(null)})))):(this.p++,T===this.b||this.h&&k.$Df(N.size)&&N.size>this.h||this.J(I,{base:$.fsPath,relativePath:T,searchPath:this.N(n,T)}),D(null,void 0)))})},w=>{const D=w&&A.$Hb(w);return S(D&&D.length>0?D[0]:void 0)})}J(n,r){this.K(r)&&(!this.d||this.d(r.relativePath,f.$nc(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||n(r))}K(n){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,h.$7I)(n,this.c)}return!0}L(n,r,u){return r.isSymbolicLink()?O.stat(n,u):u(null,r)}M(n,r,u){return r.isSymbolicLink()?O.realpath(n,(I,S)=>I?u(I):u(null,S)):u(null,n)}N(n,r){return n.folderName?f.$jc(n.folderName,r):r}}e.$2ec=d;class a{constructor(n){this.a=n.folderQueries,this.b=n.extraFileResources||[],this.c=new d(n)}search(n,r,u){this.c.walk(this.a,this.b,n,r,(I,S)=>{u(I,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$3ec=a;class t{constructor(n,r){this.expression=n,this.c=r,this.d(n)}d(n){let r,u;Object.keys(n).filter(I=>n[I]).forEach(I=>{f.$ic(I)?(r=r||E.$sj(),r[I]=n[I]):(u=u||E.$sj(),u[I]=n[I])}),this.a=r&&E.$xj(r,{trimForExclusions:!0}),this.b=u&&E.$xj(u,{trimForExclusions:!0})}test(n,r,u){return this.b&&this.b(n,r,u)||this.a&&this.a(f.$jc(this.c,n),r,u)}getBasenameTerms(){const n=[];return this.a&&n.push(...E.$zj(this.a)),this.b&&n.push(...E.$zj(this.b)),n}getPathTerms(){const n=[];return this.a&&n.push(...E.$Aj(this.a)),this.b&&n.push(...E.$Aj(this.b)),n}}function i(s){const n=s.trim().split(`
`),r=n[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return y.$rf(n[n.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}}),define(De[364],Ce([1,0,96,22,182,21]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QC=e.$PC=e.$OC=e.$NC=e.$MC=e.$LC=e.$KC=e.$JC=e.$IC=e.DecodeStreamErrorKind=e.$HC=e.$GC=e.$FC=e.$EC=e.$DC=e.$CC=e.$BC=e.$AC=void 0,e.$AC="utf8",e.$BC="utf8bom",e.$CC="utf16be",e.$DC="utf16le";function A(r){return[e.$AC,e.$BC,e.$CC,e.$DC].some(u=>u===r)}e.$EC=A,e.$FC=[254,255],e.$GC=[255,254],e.$HC=[239,187,191];const m=512,E=512,b=512*8,L=512*128;var P;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class p extends Error{constructor(u,I){super(u),this.decodeStreamErrorKind=I}}e.$IC=p;class y{static async create(u){let I;if(u!==e.$AC)I=(await(0,f.$zC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(u));else{const S=new TextDecoder;I={write($){return S.decode($,{stream:!0})},end(){return S.decode()}}}return new y(I)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function k(r,u){const I=u.minBytesRequiredForDetection??u.guessEncoding?b:E;return new Promise((S,$)=>{const g=(0,C.$3d)(z=>z.join("")),w=[];let D=0,T;const M=new R.$Yd,F=async()=>{try{const z=await n({buffer:O.$ce.concat(w),bytesRead:D},u.guessEncoding);if(z.seemsBinary&&u.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);z.encoding=await u.overwriteEncoding(z.encoding),T=await y.create(z.encoding);const j=T.write(O.$ce.concat(w).buffer);g.write(j),w.length=0,D=0,S({stream:g,detected:z})}catch(z){M.cancel(),g.destroy(),$(z)}};(0,C.$7d)(r,{onData:async z=>{T?g.write(T.write(z.buffer)):(w.push(z),D+=z.byteLength,D>=I&&(r.pause(),await F(),setTimeout(()=>r.resume())))},onError:z=>g.error(z),onEnd:async()=>{T||await F(),g.end(T?.end())}},M.token)})}e.$JC=k;async function v(r,u,I){const $=(await(0,f.$zC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(u),I);let g=!1,w=!1;return{read(){if(w)return null;const D=r.read();if(typeof D!="string"){if(w=!0,!g&&I?.addBOM)switch(u){case e.$AC:case e.$BC:return O.$ce.wrap(Uint8Array.from(e.$HC));case e.$CC:return O.$ce.wrap(Uint8Array.from(e.$FC));case e.$DC:return O.$ce.wrap(Uint8Array.from(e.$GC))}const T=$.end();return T&&T.length>0?(g=!0,O.$ce.wrap(T)):null}return g=!0,O.$ce.wrap($.write(D))}}}e.$KC=v;async function h(r){return(await(0,f.$zC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(r))}e.$LC=h;function o(r){return r===e.$BC||r===null?e.$AC:r}e.$MC=o;function l(r,u){if(!r||u<e.$FC.length)return null;const I=r.readUInt8(0),S=r.readUInt8(1);if(I===e.$FC[0]&&S===e.$FC[1])return e.$CC;if(I===e.$GC[0]&&S===e.$GC[1])return e.$DC;if(u<e.$HC.length)return null;const $=r.readUInt8(2);return I===e.$HC[0]&&S===e.$HC[1]&&$===e.$HC[2]?e.$BC:null}e.$NC=l;const c=["ascii","utf-16","utf-32"];async function d(r){const u=await(0,f.$zC)("jschardet","dist/jschardet.min.js"),I=r.slice(0,L),S=i(I.buffer),$=u.detect(S);if(!$||!$.encoding)return null;const g=$.encoding.toLowerCase();return 0<=c.indexOf(g)?null:t($.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(r){const u=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[u]||u}function i(r){let u="";for(let I=0;I<r.length;I++)u+=String.fromCharCode(r[I]);return u}function s(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=r.match(/windows(\d+)/);return u?"windows-"+u[1]:r}}}e.$OC=s;function n({buffer:r,bytesRead:u},I){let S=l(r,u),$=!1;if(S!==e.$CC&&S!==e.$DC&&r){let g=!0,w=!0,D=!1;for(let T=0;T<u&&T<m;T++){const M=T%2===1,F=r.readUInt8(T)===0;if(F&&(D=!0),g&&(M&&!F||!M&&F)&&(g=!1),w&&(M&&F||!M&&!F)&&(w=!1),F&&!g&&!w)break}D&&(g?S=e.$DC:w?S=e.$CC:$=!0)}return I&&!$&&!S&&r?d(r.slice(0,u)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:$,encoding:S}}e.$PC=n,e.$QC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ce([1,0,364,29,153]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class R extends f.$Ydc{constructor(m,E,b=O,L="searchProcess"){super(m,E,{readdir:P=>b.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,C.$OC)(P)},L)}}e.$$ec=R}),define(De[155],Ce([1,0,49,380,363,19,74,36,16,15,2,37,92,381,361,116]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=e.$9ec=e.$8ec=e.$7ec=e.$6ec=e.$5ec=e.$4ec=void 0;const h=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(w){this.a=w}provideTextSearchResults(w,D,T,M){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...D,folder:D.folder.toString()})}`),new Promise((F,z)=>{M.onCancellationRequested(()=>J());const j=i(w,D),N=D.folder.fsPath,q=j.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");this.a.appendLine(`${h} ${q}
 - cwd: ${N}`);let K=C.spawn(h,j,{cwd:N});K.on("error",H=>{console.error(H),this.a.appendLine("Error: "+(H&&H.message)),z((0,P.$3I)(new P.$1I(H&&H.message,P.SearchErrorCode.rgProcessError)))});let me=!1;const te=new d(D.maxResults,N,D.previewOptions);te.on("result",H=>{me=!0,ie="",T.report(H)});let G=!1;const J=()=>{G=!0,K?.kill(),te?.cancel()};let le=!1;te.on("hitLimit",()=>{le=!0,J()});let ie="";K.stdout.on("data",H=>{te.handleData(H),me||(ie+=H)});let ce=!1;K.stdout.once("data",()=>ce=!0);let ye="";K.stderr.on("data",H=>{const B=H.toString();this.a.appendLine(B),ye.length+B.length<1e6&&(ye+=B)}),K.on("close",()=>{if(this.a.appendLine(ce?"Got data from stdout":"No data from stdout"),this.a.appendLine(me?"Got result from parser":"No result from parser"),ie&&this.a.appendLine(`Got data without result: ${ie}`),this.a.appendLine(""),G)F({limitHit:le});else{te.flush(),K=null;let H;ye&&!ce&&(H=l(ye))?z((0,P.$3I)(new P.$1I(H.message,H.code))):F({limitHit:le})}})})}}e.$4ec=o;function l(g){const w=g.split(`
`),D=w[0].trim();if(w.some(M=>M.startsWith("regex parse error")))return new P.$1I(c(w),P.SearchErrorCode.regexParseError);const T=D.match(/grep config error: unknown encoding: (.*)/);if(T)return new P.$1I(`Unknown encoding: ${T[1]}`,P.SearchErrorCode.unknownEncoding);if(D.startsWith("error parsing glob"))return new P.$1I(D.charAt(0).toUpperCase()+D.substr(1),P.SearchErrorCode.globParseError);if(D.startsWith("the literal"))return new P.$1I(D.charAt(0).toUpperCase()+D.substr(1),P.SearchErrorCode.invalidLiteral);if(D.startsWith("PCRE2: error compiling pattern"))return new P.$1I(D,P.SearchErrorCode.regexParseError)}function c(g){const w=["Regex parse error"],D=g.filter(T=>T.startsWith("PCRE2:"));if(D.length>=1){const T=D[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const M=T.split(":")[1];w.push(":"+M)}}return w.join("")}class d extends O.EventEmitter{constructor(w,D,T){super(),this.g=w,this.h=D,this.j=T,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,D){return super.on(w,D),this}handleData(w){if(this.b)return;const D=typeof w=="string"?w:this.d.write(w);this.k(D)}k(w){let D=w.indexOf(`
`);const T=this.a+w;if(D>=0)D+=this.a.length;else{this.a=T;return}let M=0;for(;D>=0;)this.m(T.substring(M,D).trim()),M=D+1,D=T.indexOf(`
`,M);this.a=T.substring(M)}m(w){if(this.b||!w)return;let D;try{D=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(D.type==="match"){const T=a(D.data.path),M=L.URI.file(E.$jc(this.h,T)),F=this.n(D.data,M);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(D.type==="context"){const T=a(D.data.path),M=L.URI.file(E.$jc(this.h,T));this.o(D.data,M).forEach(z=>this.p(z))}}n(w,D){const T=w.line_number-1,M=a(w.lines),F=Buffer.from(M);let z=0,j=0,N=T;w.submatches.length===0&&w.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const q=(0,R.$Hb)(w.submatches.map((K,me)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const te=a(K.match),G=F.slice(z,K.start).toString(),J=t(G),le=J.numLines>0?J.lastLineLength:J.lastLineLength+j,ie=t(te),ce=J.numLines+N,ye=ie.numLines+ce,H=ie.numLines>0?ie.lastLineLength:ie.lastLineLength+le;return z=K.end,j=H,N=ye,new p.$KI(ce,le,ye,H)}));return(0,v.$Wec)(D,M,q,this.j)}o(w,D){const T=a(w.lines),M=w.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((F,z)=>({text:F,uri:D,lineNumber:M+z}))}p(w){this.emit("result",w)}}e.$5ec=d;function a(g){return g.bytes?Buffer.from(g.bytes,"base64").toString():g.text}function t(g){const w=/\n/g;let D=0,T=-1,M;for(;M=w.exec(g);)D++,T=M.index;const F=T>=0?g.length-T-1:g.length;return{numLines:D,lastLineLength:F}}function i(g,w){const D=["--hidden","--no-require-git"];D.push(g.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:M}=(0,A.$J)(w.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const z=new Set;M.forEach(j=>{z.add(j)}),D.push("-g","!*"),z.forEach(j=>{s(j).map(v.$Vec).forEach(N=>{D.push("-g",N)})})}T&&T.length&&T.forEach(z=>{D.push("-g",z)}),w.excludes.map(v.$Vec).forEach(z=>D.push("-g",`!${z}`)),w.maxFileSize&&D.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||D.push("--no-ignore-parent"):D.push("--no-ignore"),w.followSymlinks&&D.push("--follow"),w.encoding&&w.encoding!=="utf8"&&D.push("--encoding",w.encoding),g.pattern==="--"&&(g.isRegExp=!0,g.pattern="\\-\\-"),g.isMultiline&&!g.isRegExp&&(g.pattern=(0,b.$Ge)(g.pattern),g.isRegExp=!0),w.usePCRE2&&D.push("--pcre2"),D.push("--crlf"),g.isRegExp&&(g.pattern=n(g.pattern),D.push("--engine","auto"));let F;if(g.isWordMatch){const j=(0,b.$Oe)(g.pattern,!!g.isRegExp,{wholeWord:g.isWordMatch}).source.replace(/\\\//g,"/");D.push("--regexp",j)}else if(g.isRegExp){let z=u(g.pattern);z=I(z),D.push("--regexp",z)}else F=g.pattern,D.push("--fixed-strings");return D.push("--no-config"),w.useGlobalIgnoreFiles||D.push("--no-ignore-global"),D.push("--json"),g.isMultiline&&D.push("--multiline"),w.beforeContext&&D.push("--before-context",w.beforeContext+""),w.afterContext&&D.push("--after-context",w.afterContext+""),D.push("--"),F&&D.push(F),D.push("."),D}e.$6ec=i;function s(g){return $(g).flatMap(D=>{const T=(0,m.$vj)(D,"/");return T.map((M,F)=>T.slice(0,F+1).join("/"))})}function n(g){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;g.match(w);)g=g.replace(w,"$1\\x{$2}");const D=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;g.match(D);)g=g.replace(D,"$1\\x{$2}");return g}e.$7ec=n;const r=g=>g.type==="Assertion"&&g.kind==="lookbehind";function u(g){let w;try{w=new y.RegExpParser().parsePattern(g)}catch{return g}let D="",T=0;const M=(j,N,q)=>{D+=g.slice(T,j)+q,T=N},F=[];return new y.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const N=F[0];if(!N)M(j.start,j.end,"\\r?\\n");else if(!F.some(r))if(N.type==="CharacterClass")if(N.negate){const q=g.slice(N.start+2,j.start)+g.slice(j.end,N.end-1);N.parent?.type==="Quantifier"?M(N.start,N.end,q?`[^${q}]`:"."):M(N.start,N.end,"(?!\\r?\\n"+(q?`|[${q}]`:"")+")")}else{const q=g.slice(N.start+1,j.start)+g.slice(j.end,N.end-1);M(N.start,N.end,q===""?"\\r?\\n":`(?:[${q}]|\\r?\\n)`)}else N.type==="Quantifier"&&M(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){F.unshift(j)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(j){F.unshift(j)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(j){F.unshift(j)},onCharacterClassLeave(){F.shift()},onAssertionEnter(j){r(j)&&F.push(j)},onAssertionLeave(j){F[0]===j&&F.shift()}}).visit(w),D+=g.slice(T),D}e.$8ec=u;function I(g){return g.replace(/\n/g,"\\r?\\n")}e.$9ec=I;function S(g){let w=!1,D=!1,T="",M="";for(let F=0;F<g.length;F++){const z=g[F];switch(z){case"\\":D?(w?M+="\\"+z:T+="\\"+z,D=!1):D=!0;break;case"{":if(D)w?M+=z:T+=z,D=!1;else{if(w)return{strInBraces:T+"{"+M+"{"+g.substring(F+1)};w=!0}break;case"}":if(D)w?M+=z:T+=z,D=!1;else{if(w)return{fixedStart:T,strInBraces:M,fixedEnd:g.substring(F+1)};T+=z}break;default:w?M+=(D?"\\":"")+z:T+=(D?"\\":"")+z,D=!1;break}}return{strInBraces:T+(w?"{"+M:"")}}function $(g){const{fixedStart:w,strInBraces:D,fixedEnd:T}=S(g);if(w===void 0||T===void 0)return[D];let M=(0,m.$vj)(D,",");M.length||(M=[""]);const F=$(T);return M.flatMap(z=>{const j=w+z;return F.map(N=>j+N)})}e.$0ec=$}),define(De[365],Ce([1,0,21,155,64,18]),function($e,e,C,O,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class A{constructor(b){this.b=b,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(b,L,P,p){const y=new O.$4ec(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const k={...L,folder:L.folder.with({scheme:R.Schemas.file})},v=new f.$9u(h=>P.report({...h,uri:h.uri.with({scheme:L.folder.scheme})}));return this.c(p,h=>y.provideTextSearchResults(b,k,v,h))}else return this.c(p,k=>y.provideTextSearchResults(b,L,P,k))}async c(b,L){const P=m(b);this.a.add(P);const p=await L(P.token);return this.a.delete(P),p}d(){this.a.forEach(b=>b.cancel())}}e.$bfc=A;function m(E){const b=new C.$Yd;return E.onCancellationRequested(()=>b.cancel()),b}}),define(De[366],Ce([1,0,29,155,154]),function($e,e,C,O,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class R{constructor(E){this.a=E}search(E,b,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(y){L({message:y})}},p=new f.$$ec(this.a,new O.$4ec(P),C);return new Promise((y,k)=>p.search(v=>{b(v.map(A))},E).then(v=>y({limitHit:v.limitHit,type:"success",stats:v.stats}),k))}}e.$_ec=R;function A(m){return{path:m.resource&&m.resource.fsPath,results:m.results,numMatches:(m.results||[]).reduce((E,b)=>{if(b.ranges){const L=b;return E+(Array.isArray(L.ranges)?L.ranges.length:1)}else return E+1},0)}}}),define(De[367],Ce([1,0,19,8,9,4,127,16,35,2,30,37,362,366]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class k{static{this.a=512}constructor(d="searchProcess"){this.d=d,this.b=Object.create(null)}fileSearch(d){let a;const t=o(d),i=new R.$Od({onDidAddFirstListener:()=>{a=(0,O.$Ig)(s=>this.doFileSearchWithEngine(p.$3ec,t,n=>i.fire(n),s)),a.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return i.event}textSearch(d){let a;const t=o(d),i=new R.$Od({onDidAddFirstListener:()=>{a=(0,O.$Ig)(s=>this.f(t,n=>i.fire(n),s)),a.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return i.event}f(d,a,t){return d.maxFileSize=this.g().maxFileSize,new y.$_ec(d).search(t,a,a)}g(){return{maxFileSize:16*L.$Hk.GB}}doFileSearch(d,a,t){return this.doFileSearchWithEngine(p.$3ec,d,a,t)}doFileSearchWithEngine(d,a,t,i,s=k.a){let n=0;const r=I=>{Array.isArray(I)?(n+=I.length,t(I.map(S=>this.h(S)))):I.relativePath?(n++,t(this.h(I))):t(I)};if(a.sortByScore){let I=this.l(a,r,i);if(!I){const S=a.maxResults?Object.assign({},a,{maxResults:null}):a,$=new d(S);I=this.j($,a,t,r,i)}return new Promise((S,$)=>{I.then(([g,w])=>{const D=w.map(T=>this.h(T));this.o(D,t,s),S(g)},$)})}const u=new d(a);return this.r(u,r,s,i).then(I=>({limitHit:I.limitHit,type:"success",stats:{detailStats:I.stats,type:this.d,fromCache:!1,resultCount:n,sortingTime:void 0}}))}h(d){return{path:d.base?(0,m.$jc)(d.base,d.relativePath):d.relativePath}}j(d,a,t,i,s){const n=new R.$Od;let r=(0,O.$Ig)(I=>{let S=[];const $=g=>{Array.isArray(g)?S=g:(i(g),n.fire(g))};return this.r(d,$,-1,I).then(g=>[g,S])}),u;if(a.cacheKey){u=this.k(a.cacheKey);const I={promise:r,event:n.event,resolved:!1};u.resultsToSearchCache[a.filePattern||""]=I,r.then(()=>{I.resolved=!0},S=>{delete u.resultsToSearchCache[a.filePattern||""]}),r=this.s(r)}return r.then(([I,S])=>{const $=u?u.scorerCache:Object.create(null),g=(typeof a.maxResults!="number"||a.maxResults>0)&&E.$Kd.create(!1);return this.n(a,S,$,s).then(w=>{const D=g?g.elapsed():-1;return[{type:"success",stats:{detailStats:I.stats,sortingTime:D,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:w.length},messages:I.messages,limitHit:I.limitHit||typeof a.maxResults=="number"&&S.length>a.maxResults},w]})})}k(d){const a=this.b[d];return a||(this.b[d]=new v)}l(d,a,t){const i=d.cacheKey&&this.b[d.cacheKey];if(!i)return;const s=this.q(i,d.filePattern||"",a,t);if(s)return s.then(([n,r,u])=>{const I=E.$Kd.create(!1);return this.n(d,r,i.scorerCache,t).then(S=>{const $=I.elapsed(),g={fromCache:!0,detailStats:u,type:this.d,resultCount:r.length,sortingTime:$};return[{type:"success",limitHit:n.limitHit||typeof d.maxResults=="number"&&r.length>d.maxResults,stats:g},S]})})}n(d,a,t,i){const s=(0,A.$Cq)(d.filePattern||""),n=(u,I)=>(0,A.$Bq)(u,I,s,!0,h,t),r=typeof d.maxResults=="number"?d.maxResults:Number.MAX_VALUE;return C.$Gb(a,n,r,1e4,i)}o(d,a,t){if(t&&t>0)for(let i=0;i<d.length;i+=t)a(d.slice(i,i+t));else a(d)}q(d,a,t,i){const s=E.$Kd.create(!1),n=a.indexOf(m.sep)>=0;let r;for(const $ in d.resultsToSearchCache)if(a.startsWith($)){if(n&&$.indexOf(m.sep)<0&&$!=="")continue;const g=d.resultsToSearchCache[$];r={promise:this.s(g.promise),event:g.event,resolved:g.resolved};break}if(!r)return null;const u=s.elapsed(),I=E.$Kd.create(!1),S=r.event(t);return i&&i.onCancellationRequested(()=>{S.dispose()}),r.promise.then(([$,g])=>{if(i&&i.isCancellationRequested)throw(0,f.$6)();const w=[],D=(0,A.$Cq)(a).normalizedLowercase;for(const T of g)(0,P.$7I)(T,D)&&w.push(T);return[$,w,{cacheWasResolved:r.resolved,cacheLookupTime:u,cacheFilterTime:I.elapsed(),cacheEntryCount:g.length}]})}r(d,a,t,i){return new Promise((s,n)=>{let r=[];i?.onCancellationRequested(()=>d.cancel()),d.search(u=>{u&&(t?(r.push(u),t>0&&r.length>=t&&(a(r),r=[])):a(u))},u=>{a(u)},(u,I)=>{r.length&&a(r),u?n(u):s(I)})})}clearCache(d){return delete this.b[d],Promise.resolve(void 0)}s(d){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return d.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return d.finally(a)}}}}e.$afc=k;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const h=new class{getItemLabel(c){return(0,m.$nc)(c.relativePath)}getItemDescription(c){return(0,m.$mc)(c.relativePath)}getItemPath(c){return c.relativePath}};function o(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(l),extraFileResources:c.extraFileResources&&c.extraFileResources.map(d=>b.URI.revive(d))}}function l(c){return{...c,folder:b.URI.revive(c.folder)}}}),define(De[368],Ce([1,0,3,18,2,29,14,27,20,95,67,37,367,365,116,154]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;let h=class extends b.$4dc{constructor(l,c,d,a){super(l,d,a),this.s=R,this.t=-1,this.v=null,this.w=!1,this.x=new C.$Rc;const t=new k.$Xec("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new y.$bfc(t))),c.remote.isRemote&&c.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const l=new k.$Xec("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.file,new y.$bfc(l))),this.x.add(this.z(O.Schemas.file,new p.$afc("fileSearchProvider")))}z(l,c){const d=this.d++;return this.v=c,this.t=d,this.c.$registerFileSearchProvider(d,this.o(l)),(0,C.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(d)})}$provideFileSearchResults(l,c,d,a){const t=(0,b.$5dc)(d);return l===this.t?this.A(l,c,t,a):super.$provideFileSearchResults(l,c,d,a)}A(l,c,d,a){const t=i=>{if((0,P.$6I)(i)&&(i=[i]),Array.isArray(i)){this.c.$handleFileMatch(l,c,i.map(s=>f.URI.file(s.path)));return}i.message&&this.n.debug("ExtHostSearch",i.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(d,t,a)}$clearCache(l){return this.v?.clearCache(l),super.$clearCache(l)}q(l,c){return new v.$$ec(l,c,void 0,"textSearchProvider")}};e.$cfc=h,e.$cfc=h=He([Be(0,E.$qM),Be(1,m.$GM),Be(2,L.$Jcc),Be(3,A.$$i)],h)}),define(De[117],Ce([1,0,382,60,63,383,22,9,4,3,16,12,31,81,82]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;class v{traceSocketEvent(g,w){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,g,w)}constructor(g,w=""){this.f=!0,this.debugLabel=w,this.socket=g,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,m.$1)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(g){const w=D=>{this.traceSocketEvent("read",D),g(A.$ce.wrap(D))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(g){const w=D=>{g({type:0,hadError:D,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(g){const w=()=>{g()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(g){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",g),this.socket.write(g.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,m.$1)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,m.$1)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((g,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),g();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),g()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$Fh=v;var h;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(h||(h={}));var o;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(o||(o={}));class l extends b.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(g,w){this.socket.traceSocketEvent(g,w)}constructor(g,w,D,T){super(),this.f=this.B(new E.$Od),this.g=this.B(new E.$Od),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=g,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:D?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new c(this,w,D,T,this.f,(M,F)=>this.m(M,F))),this.B(this.a.onError(M=>{console.error(M),(0,m.$1)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new k.$Ah,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this.f.event(g)}onClose(g){return this.g.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){let w=0;for(;w<g.byteLength;)this.a.writeMessage(g.slice(w,Math.min(w+262144,g.byteLength)),{compressed:!0,opcode:2}),w+=262144}m(g,{compressed:w,opcode:D}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",g);let T=2;g.byteLength<126?T+=0:g.byteLength<2**16?T+=2:T+=8;const M=A.$ce.alloc(T),F=w?64:0,z=D&15;if(M.writeUInt8(128|F|z,0),g.byteLength<126)M.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){M.writeUInt8(126,1);let j=1;M.writeUInt8(g.byteLength>>>8&255,++j),M.writeUInt8(g.byteLength>>>0&255,++j)}else{M.writeUInt8(127,1);let j=1;M.writeUInt8(0,++j),M.writeUInt8(0,++j),M.writeUInt8(0,++j),M.writeUInt8(0,++j),M.writeUInt8(g.byteLength>>>24&255,++j),M.writeUInt8(g.byteLength>>>16&255,++j),M.writeUInt8(g.byteLength>>>8&255,++j),M.writeUInt8(g.byteLength>>>0&255,++j)}this.socket.write(A.$ce.concat([M,g]))}end(){this.h=!0,this.socket.end()}n(g){if(g.byteLength!==0){for(this.b.acceptChunk(g);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const w=this.b.peek(this.j.readLen),D=w.readUInt8(0),T=(D&128)>>>7,M=(D&64)>>>6,F=D&15,z=w.readUInt8(1),j=(z&128)>>>7,N=z&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(N===126?2:0)+(N===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const w=this.b.read(this.j.readLen),D=w.readUInt8(1),T=(D&128)>>>7;let M=D&127,F=1;M===126?M=w.readUInt8(++F)*2**8+w.readUInt8(++F):M===127&&(M=w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*2**24+w.readUInt8(++F)*2**16+w.readUInt8(++F)*2**8+w.readUInt8(++F));let z=0;T&&(z=w.readUInt8(++F)*2**24+w.readUInt8(++F)*2**16+w.readUInt8(++F)*2**8+w.readUInt8(++F)),this.j.state=3,this.j.readLen=M,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const w=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),t(w,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(w,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(w,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Gh=l;class c extends b.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ce.alloc(0)}constructor(g,w,D,T,M,F){super(),this.n=g,this.r=M,this.s=F,this.a=this.B(new E.$Od),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Od),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Od),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,w?(this.b=this.B(new d(this.n,T,D,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(g,w){this.g.push({data:g,options:w}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:g,options:w}=this.g.shift();if(this.f&&w.compressed){const D=await this.w(this.f,g);this.s(D,w)}else this.s(g,{...w,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(g,w){return new Promise((D,T)=>{g.write(w),g.flush(M=>D(M))})}acceptFrame(g,w,D){this.h.push({data:g,isCompressed:w,isLastFrameOfMessage:D}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const g=this.h.shift();if(this.b&&g.isCompressed){const w=await this.C(this.b,g.data,g.isLastFrameOfMessage);this.r.fire(w)}else this.r.fire(g.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(g,w,D){return new Promise((T,M)=>{g.write(w),D&&g.write(A.$ce.fromByteArray([0,0,255,255])),g.flush(F=>T(F))})}}class d extends b.$Sc{get recordedInflateBytes(){return this.j?A.$ce.concat(this.f):A.$ce.alloc(0)}constructor(g,w,D,T){super(),this.h=g,this.j=w,this.a=this.B(new E.$Od),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(T),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(A.$ce.wrap(M))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(g){this.j&&this.f.push(g.clone()),this.h.traceSocketEvent("zlibInflateWrite",g),this.b.write(g.buffer)}flush(g){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const w=A.$ce.concat(this.g);this.g.length=0,g(w)})}}class a extends b.$Sc{constructor(g,w){super(),this.g=g,this.a=this.B(new E.$Od),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(A.$ce.wrap(D))})}write(g){this.g.traceSocketEvent("zlibDeflateWrite",g.buffer),this.b.write(g.buffer)}flush(g){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let w=A.$ce.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),g(w)})}}function t($,g){if(g===0)return;const w=$.byteLength>>>2;for(let j=0;j<w;j++){const N=$.readUInt32BE(j*4);$.writeUInt32BE(N^g,j*4)}const D=w*4,T=$.byteLength-D,M=g>>>24&255,F=g>>>16&255,z=g>>>8&255;T>=1&&$.writeUInt8($.readUInt8(D)^M,D),T>=2&&$.writeUInt8($.readUInt8(D+1)^F,D+1),T>=3&&$.writeUInt8($.readUInt8(D+2)^z,D+2)}e.$Hh=process.env.XDG_RUNTIME_DIR;const i={[2]:107,[1]:103};function s(){const $=(0,p.$fg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const g=process.platform!=="darwin"&&e.$Hh?e.$Hh:(0,f.tmpdir)(),w=(0,L.$jc)(g,`vscode-ipc-${$}.sock`);return r(w),w}e.$Ih=s;function n($,g,w){const D=(0,C.createHash)("md5").update($).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${w}-${g}-sock`;const T=w.substr(0,4),M=g.substr(0,6),F=D.substr(0,8);let z;return process.platform!=="darwin"&&e.$Hh&&!process.env.VSCODE_PORTABLE?z=(0,L.$jc)(e.$Hh,`vscode-${F}-${T}-${M}.sock`):z=(0,L.$jc)($,`${T}-${M}.sock`),r(z),z}e.$Jh=n;function r($){const g=i[P.$u];typeof g=="number"&&$.length>=g&&console.warn(`WARNING: IPC handle "${$}" is longer than ${g} chars, try a shorter --user-data-dir`)}class u extends y.$uh{static b(g){const w=E.Event.fromNodeEventEmitter(g,"connection");return E.Event.map(w,D=>({protocol:new k.$Bh(new v(D,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(D,"close"))}))}constructor(g){super(u.b(g)),this.d=g}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Kh=u;function I($){return new Promise((g,w)=>{const D=(0,O.createServer)();D.on("error",w),D.listen($,()=>{D.removeListener("error",w),g(new u(D))})})}e.$Lh=I;function S($,g){return new Promise((w,D)=>{const T=(0,O.createConnection)($,()=>{T.removeListener("error",D),w(k.$Ch.fromSocket(new v(T,`ipc-client${g}`),g))});T.once("error",D)})}e.$Mh=S}),define(De[369],Ce([1,0,60,63,163,117,8,3,12,50,14,135,248,249,106,86,22]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=e.$D8b=e.$C8b=e.$B8b=void 0;async function o(t,i,s,n,r){let u;for(let I=3;I&&(u?.dispose(),u=await new l(t,i,s,n,r).waitForReady(),!(r&&f.$ig[r]||!f.$ig[u.tunnelLocalPort]));I--);return u}class l extends m.$Sc{constructor(i,s,n,r,u){super(),this.m=s,this.n=u,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=C.createServer(),this.c=new A.$Tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=I=>this.r(I),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=r,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,s=(0,v.$iv)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,f.$jg)(i,2,1e3,s),r=null;return this.b.listen(n,this.m),await this.c.wait(),r=this.b.address(),r||(n=0,this.b.listen(n,this.m),await this.c.wait(),r=this.b.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async r(i){i.pause();const s=(0,v.$gv)(this.tunnelRemoteHost)||(0,v.$iv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,p.$7k)(this.a,s,this.tunnelRemotePort),r=n.getSocket(),u=n.readEntireBuffer();n.dispose(),u.byteLength>0&&i.write(u.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),r.end()}),i.on("close",()=>r.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),r instanceof R.$Fh?r.socket.destroy():r.end()}),r instanceof R.$Fh?this.t(i,r):this.s(i,r),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),r.end()})}s(i,s){s.onClose(()=>i.destroy()),s.onEnd(()=>i.end()),s.onData(n=>i.write(n.buffer)),i.on("data",n=>s.write(h.$ce.wrap(n))),i.resume()}t(i,s){const n=s.socket;n.on("end",()=>i.end()),n.on("close",()=>i.end()),n.on("error",()=>{i.destroy()}),n.pipe(i),i.pipe(n)}}e.$B8b=l;let c=class extends v.$lv{constructor(i,s,n,r,u){super(s,u),this.u=i,this.v=n,this.w=r}isPortPrivileged(i){return(0,v.$jv)(i,this.l,E.OS,O.release())}s(i,s,n,r,u,I,S,$){const g=this.r(s,n);if(g)return++g.refcount,g.value;if((0,v.$dv)(i))return this.t(i,s,n,u,I,S,$);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${u}.`);const w={commit:this.w.commit,quality:this.w.quality,addressProvider:i,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},D=o(w,r,s,n,u);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(s,n,D),D}}};e.$C8b=c,e.$C8b=c=He([Be(0,y.$1k),Be(1,L.$$i),Be(2,k.$4k),Be(3,P.$qj),Be(4,b.$ki)],c);let d=class extends c{constructor(i,s,n,r,u){super(i,s,n,r,u)}};e.$D8b=d,e.$D8b=d=He([Be(0,y.$1k),Be(1,L.$$i),Be(2,k.$4k),Be(3,P.$qj),Be(4,b.$ki)],d);let a=class extends m.$Sc{constructor(i,s,n,r,u){super(),this.b=i,this.c=s,this.f=n,this.g=r,this.h=u,this.a=new Map}async openTunnel(i,s,n,r,u,I,S,$,g){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${r} on local port ${I}.`),!this.a.has(i)){const w=new d(this.b,this.c,this.g,this.f,this.h);this.B(w),this.a.set(i,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(s,n,r,u,I,S,$,g)}};e.$E8b=a,e.$E8b=a=He([Be(0,y.$1k),Be(1,L.$$i),Be(2,P.$qj),Be(3,k.$4k),Be(4,b.$ki)],a)}),define(De[370],Ce([1,0,117,268,53,34,2,14,44]),function($e,e,C,O,f,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=void 0;class b{constructor(p,y,k){this.b=p,this.c=y,this.f=k,this.a=O.createServer((v,h)=>this.h(v,h)),this.g().catch(v=>(y.error(v),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,y){const k=(h,o)=>{y.writeHead(h,{"content-type":"application/json"}),y.end(JSON.stringify(o||null),l=>l&&this.c.error(l))},v=[];p.setEncoding("utf8"),p.on("data",h=>v.push(h)),p.on("end",async()=>{try{const h=JSON.parse(v.join(""));let o;switch(h.type){case"open":o=await this.i(h);break;case"openExternal":o=await this.j(h);break;case"status":o=await this.l(h);break;case"extensionManagement":o=await this.k(h);break;default:k(404,`Unknown message type: ${h.type}`);break}k(200,o)}catch(h){const o=h instanceof Error?h.message:JSON.stringify(h);k(500,o),this.c.error("Error while processing pipe request",h)}})}async i(p){const{fileURIs:y,folderURIs:k,forceNewWindow:v,diffMode:h,mergeMode:o,addMode:l,forceReuseWindow:c,gotoLineMode:d,waitMarkerFilePath:a,remoteAuthority:t}=p,i=[];if(Array.isArray(k))for(const u of k)try{i.push({folderUri:A.URI.parse(u)})}catch{}if(Array.isArray(y))for(const u of y)try{(0,E.$ji)(u)?i.push({workspaceUri:A.URI.parse(u)}):i.push({fileUri:A.URI.parse(u)})}catch{}const s=a?A.URI.file(a):void 0,r={forceNewWindow:v,diffMode:h,mergeMode:o,addMode:l,gotoLineMode:d,forceReuseWindow:c,preferNewWindow:!c&&!s&&!l,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",i,r)}async j(p){for(const y of p.uris){const k=A.URI.parse(y),v=k.scheme==="file"?k:y;await this.b.executeCommand("_remoteCLI.openExternal",v)}}async k(p){const y=v=>v?.map(h=>/\.vsix$/i.test(h)?A.URI.parse(h):h),k={list:p.list,install:y(p.install),uninstall:y(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$RM=b;let L=class extends b{constructor(p,y){super(p,y,(0,C.$Ih)())}};e.$SM=L,e.$SM=L=He([Be(0,R.$MM),Be(1,m.$$i)],L)}),define(De[371],Ce([1,0,54,358,353,267,46,341,2,18,7,370,100,339,340]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class v extends f.$Iec{j(){const l=this,c=globalThis._VSCODE_NODE_MODULES.module,d=c._load;c._load=function(s,n,r){return s=t(s),l.a.has(s)?l.a.get(s).load(s,E.URI.file((0,p.$_p)(n.filename)),u=>d.apply(this,[u,n,r])):d.apply(this,arguments)};const a=c._resolveLookupPaths;c._resolveLookupPaths=(i,s)=>a.call(this,t(i),s);const t=i=>{for(const s of l.b){const n=s(i);if(n){i=n;break}}return i}}}class h extends A.$hdc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$ffc);const l=this.h.invokeFunction(O.$Eec);if(this.h.createInstance(m.$efc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(P.$SM);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(k.$gfc),await this.h.createInstance(v,l,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const d=await this.m.getConfigProvider();await(0,R.$dfc)(this.j,d,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(l){return l.main}async vb(l,c,d){if(c.scheme!==b.Schemas.file)throw new Error(`Cannot load URI: '${c}', must be of file-scheme`);let a=null;d.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${c.toString(!0)}`),this.s.flush();const t=l?.identifier.value;l&&await this.w.initializeLocalizedMessages(l);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),a=$e.__$__nodeRequire(c.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}return a}async $setRemoteEnvironment(l){if(this.f.remote.isRemote)for(const c in l){const d=l[c];d===null?delete process.env[c]:process.env[c]=d}}}e.$hfc=h}),define(De[372],Ce([1,0,49,22,4,3,120,12,23,2,29,14,247,65,106,86,369,27,20,73,349]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=e.$ofc=e.$nfc=e.$mfc=e.$lfc=e.$kfc=e.$jfc=e.$ifc=void 0;function a(g){const w=g.trim().split(`
`),D=[];return w.forEach(M=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(M);F&&F.length>=3&&D.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),D.reduce((M,F)=>(M[F.socket]=F,M),{})}e.$ifc=a;function t(...g){const w=[].concat(...g.map(s));return[...new Map(w.filter(D=>D.st==="0A").map(D=>{const T=D.local_address.split(":");return{socket:parseInt(D.inode,10),ip:i(T[0]),port:parseInt(T[1],16)}}).map(D=>[D.ip+":"+D.port,D])).values()]}e.$jfc=t;function i(g){let w="";if(g.length===8)for(let D=g.length-2;D>=0;D-=2)w+=parseInt(g.substr(D,2),16),D!==0&&(w+=".");else for(let D=0;D<g.length;D+=8){const T=g.substring(D,D+8);let M="";for(let F=8;F>=2;F-=2)M+=T.substring(F-2,F),(F===6||F===2)&&(M=parseInt(M,16).toString(16),w+=`${M}`,M="",D+F!==g.length-6&&(w+=":"))}return w}e.$kfc=i;function s(g){const w=g.trim().split(`
`),D=w.shift().trim().split(/\s+/).filter(M=>M!=="rx_queue"&&M!=="tm->when");return w.map(M=>M.trim().split(/\s+/).reduce((F,z,j)=>(F[D[j]||j]=z,F),{}))}e.$lfc=s;function n(g){return!!g.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||g.indexOf("out/server-main.js")!==-1||g.indexOf("_productName=VSCode")!==-1}function r(g){const w=g.trim().split(`
`),D=[];return w.forEach(T=>{const M=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(T);M&&M.length>=4&&D.push({pid:parseInt(M[1],10),ppid:parseInt(M[2]),cmd:M[3]})}),D}e.$mfc=r;async function u(g,w,D){const T=D.reduce((F,z)=>(F[z.pid]=z,F),{}),M=[];return g.forEach(({socket:F,ip:z,port:j})=>{const N=w[F]?w[F].pid:void 0,q=N?T[N]?.cmd:void 0;N&&q&&!n(q)&&M.push({host:z,port:j,detail:q,pid:N})}),M}e.$nfc=u;function I(g,w,D){const T=new Map,M=r(w);for(const F of g){const z=D.get(F.port);if(z){T.set(F.port,z);continue}const j=M.find(N=>N.cmd.includes(`${F.port}`));if(j){let N=j,q;do q=M.find(K=>K.ppid===N.pid),q&&(N=q);while(q);T.set(F.port,{host:F.ip,port:F.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else T.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return T}e.$ofc=I;let S=class extends c.$owb{constructor(w,D,T,M){super(w,D,T),this.D=D,this.F=M,this.y=void 0,this.z=new Map,this.C=!1,m.$l&&D.remote.isRemote&&D.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(w){if(w&&this.C)return;this.C=w;let D;this.y&&(D=this.y,await this.a.$onFoundNewCandidates(this.y));const T=new A.$Sl;let M=0;for(;this.C;){const F=new Date().getTime(),z=(await this.I()).filter(q=>(0,v.$gv)(q.host)||(0,v.$iv)(q.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(q=>q.port).join(", ")}`);const j=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),M++>3&&T.update(j),(!D||JSON.stringify(D)!==JSON.stringify(z))&&(D=z,await this.a.$onFoundNewCandidates(D));const N=this.G(T.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${N} ms.`),await new Promise(q=>setTimeout(()=>q(),N))}}G(w){return Math.max(w*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(w=>w.port).join(", ")}`)}async I(){let w="",D="";try{w=await L.Promises.readFile("/proc/net/tcp","utf8"),D=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const T=t(w,D),M=await new Promise(te=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(G,J,le)=>{te(J)})}),F=a(M),z=await L.Promises.readdir("/proc"),j=[];for(const te of z)try{const G=Number(te),J=E.$wg(b.URI.file("/proc"),te);if((await L.Promises.stat(J.fsPath)).isDirectory()&&!isNaN(G)){const ie=await L.Promises.readlink(E.$wg(J,"cwd").fsPath),ce=await L.Promises.readFile(E.$wg(J,"cmdline").fsPath,"utf8");j.push({pid:G,cwd:ie,cmd:ce})}}catch{}const N=[],q=T.filter(te=>{const G=F[te.socket];return G||N.push(te),G}),K=u(q,F,j);let me;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const te=await new Promise(G=>{(0,C.exec)("ps -F -A -l | grep root",(J,le,ie)=>{G(le)})});this.z=I(N,te,this.z),me=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${me.map(G=>G.port).join(", ")}`)}return K.then(te=>me?te.concat(me):te)}w(w){return async D=>{const T=new h.$B8b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,z,j,N){const q=await w.makeConnection();return $.connect(q,z,j,N)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Rk(0),connectionToken:w.connectionToken})}},signService:this.F},"localhost",D.remoteAddress.host||"localhost",D.remoteAddress.port,D.localAddressPort);await T.waitForReady();const M=new f.$Od;return{localAddress:(0,d.$PJ)(T.localAddress)??T.localAddress,remoteAddress:{port:T.tunnelRemotePort,host:T.tunnelRemoteHost},onDidDispose:M.event,dispose:()=>{T.dispose(),M.fire(),M.dispose()}}}}};e.$pfc=S,e.$pfc=S=He([Be(0,l.$qM),Be(1,o.$GM),Be(2,P.$$i),Be(3,k.$4k)],S);class $ extends p.$Qkb{static connect(w,D,T,M){const F=new R.$Rc,z={onClose:F.add(new f.$Od),onData:F.add(new f.$Od),onEnd:F.add(new f.$Od)};F.add(w.onDidReceiveMessage(N=>z.onData.fire(O.$ce.wrap(N)))),F.add(w.onDidEnd(()=>z.onEnd.fire())),F.add(w.onDidClose(N=>z.onClose.fire({type:0,error:N,hadError:!!N})));const j=new $(w,M,z);return j.B(F),(0,p.$Pkb)(j,D,T,M,z)}constructor(w,D,T){super(D,T),this.n=w}write(w){this.n.send(w.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(De[373],Ce([1,0,103,344,356,355,368,371,372,94,46,95,93,45,73,90,343,342,14,357,56,262,102,106,138]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o,l,c,d,a,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Ar)(L.$idc,m.$hfc,0),(0,C.$Ar)(l.$_i,o.$rfc,1),(0,C.$Ar)(l.$$i,new t.$Nh(a.$Hec,[!1],!0)),(0,C.$Ar)(i.$4k,s.$G8b,1),(0,C.$Ar)(v.$6cc,h.$qfc,0),(0,C.$Ar)(b.$Sdc,R.$Uec,0),(0,C.$Ar)(P.$3dc,A.$cfc,0),(0,C.$Ar)(p.$Ndc,f.$Mec,0),(0,C.$Ar)(y.$8cc,O.$Lec,0),(0,C.$Ar)(k.$nwb,E.$pfc,0),(0,C.$Ar)(d.$Qdc,c.$sfc,0)}),define(De[384],Ce([1,0,60,385,54,9,82,117,245,111,354,22,29,100,8,130,269,282,359,373]),function($e,e,C,O,f,R,A,m,E,b,L,P,p,y,k,v,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const l=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=globalThis._VSCODE_NODE_MODULES.module,u=r._load;r._load=function(I){if(I==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return u.apply(this,arguments)}})();const c=process.exit.bind(process);function d(r){process.exit=function(u){if(r)c(u);else{const I=new Error("An extension called process.exit() and this was prevented.");console.warn(I.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(r){c()};function t(){const r=(0,o.$Cm)(process.env);if(r.type===3)return new Promise((u,I)=>{const S=$=>{const g=$[0],w=new A.$Dh;g.on("message",D=>w.fire(P.$ce.wrap(D.data))),g.on("close",()=>{a("renderer closed the MessagePort")}),g.start(),u({onMessage:w.event,send:D=>g.postMessage(D.buffer)})};process.parentPort.on("message",$=>S($.ports))});if(r.type===2)return new Promise((u,I)=>{let S=null;const $=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),g=108e5,w=3e5,D=new k.$8g(()=>a("renderer disconnected for too long (1)"),g),T=new k.$8g(()=>a("renderer disconnected for too long (2)"),w);process.on("message",(F,z)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const j=P.$ce.wrap(Buffer.from(F.initialDataChunk,"base64"));let N;if(F.skipWebSocketFrames)N=new m.$Fh(z,"extHost-socket");else{const q=P.$ce.wrap(Buffer.from(F.inflateBytes,"base64"));N=new m.$Gh(new m.$Fh(z,"extHost-socket"),F.permessageDeflate,q,!1)}S?(D.cancel(),T.cancel(),S.beginAcceptReconnection(N,j),S.endAcceptReconnection(),S.sendResume()):(clearTimeout($),S=new A.$Eh({socket:N,initialChunk:j}),S.sendResume(),S.onDidDispose(()=>a("renderer disconnected")),u(S),S.onSocketClose(()=>{D.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;D.isScheduled()&&T.schedule()}});const M={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(M)});{const u=r.pipeName;return new Promise((I,S)=>{const $=C.createConnection(u,()=>{$.removeListener("error",S);const g=new A.$Eh({socket:new m.$Fh($,"extHost-renderer")});g.sendResume(),I(g)});$.once("error",S),$.on("close",()=>{a("renderer closed the socket")})})}}async function i(){const r=await t();return new class{constructor(){this.a=new A.$Dh,this.onMessage=this.a.event,this.b=!1,r.onMessage(u=>{(0,b.$dm)(u,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(u)})}send(u){this.b||r.send(u)}async drain(){if(r.drain)return r.drain()}}}function s(r){return new Promise(u=>{const I=r.onMessage(S=>{I.dispose();const $=JSON.parse(S.toString()),g=$.commit,w=E.default.commit;if(g&&w&&g!==w&&c(55),$.parentPid){let D=0;setInterval(function(){try{process.kill($.parentPid,0),D=0}catch(M){M&&M.code==="EPERM"?(D++,D>=3&&a(`parent process ${$.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):a(`parent process ${$.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let T;try{T=globalThis._VSCODE_NODE_MODULES["native-watchdog"],T.start($.parentPid)}catch(M){(0,R.$1)(M)}}r.send((0,b.$cm)(0)),u({protocol:r,initData:$})});r.send((0,b.$cm)(1))})}async function n(){const r=[];process.on("unhandledRejection",(D,T)=>{r.push(T),setTimeout(()=>{const M=r.indexOf(T);M>=0&&T.catch(F=>{r.splice(M,1),(0,R.$4)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),D&&(0,R.$1)(D))})},1e3)}),process.on("rejectionHandled",D=>{const T=r.indexOf(D);T>=0&&r.splice(T,1)}),process.on("uncaughtException",function(D){(0,R.$Z)(D)||(0,R.$1)(D)}),f.mark("code/extHost/willConnectToRenderer");const u=await i();f.mark("code/extHost/didConnectToRenderer");const I=await s(u);f.mark("code/extHost/didWaitForInitData");const{initData:S}=I;d(!!S.environment.extensionTestsLocationURI),S.environment.useHostProxy=l.useHostProxy!==void 0?l.useHostProxy!=="false":void 0,S.environment.skipWorkspaceStorageLock=(0,v.boolean)(l.skipWorkspaceStorageLock,!1);const $=new class{constructor(){this.pid=process.pid}exit(T){c(T)}fsExists(T){return p.Promises.exists(T)}fsRealpath(T){return(0,y.$$p)(T)}};let g=null;S.remote.authority&&l.transformURIs&&(g=(0,h.$Er)(S.remote.authority));const w=new L.$Kec(I.protocol,S,$,g);a=D=>w.terminate(D)}n().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/35419fc016b8d3d5dbc59aa11a0be957b0897309/core/vs/workbench/api/node/extensionHostProcess.js.map
